                MUNIPACK


is a general astronomical image processing software.
It is contains a set of utilities for image reductions,
coloring, etc. of the a lot of the CCD images.


HOMEPAGE

     https://munipack.physics.muni.cz/


DOWNLOAD

     https://integral.physics.muni.cz/ftp/munipack/


SOURCE REPOSITORY

     https://munipack.physics.muni.cz/hg/munipack/


DOCS

   The docpage/ directory contains doc in HTML.


Filip Hroch
hroch@physics.muni.cz
Masaryk University, Brno
March 2022

wxMathPlot is a framework for mathematical graph plotting in wxWindows.

For more information go to
https://sourceforge.net/projects/wxmathplot/
http://wxmathplot.sourceforge.net/

0.1.2 Release notes
-------------------
Scrollers back again. Ability to build as DLL in Windows. Introduced colour theme, plus minor fixes.

0.1.1 Release notes
-------------------
Minor bugfixes, introduced show/hide for single layer and added library packaging.

0.1.0 Release notes
-------------------

Library has been deeply revised: the coordinate system has been changed for code simplification. Added a lot of new functionalities:
1. Printing
2. Saving screenshots as images
3. Legend
4. Mouse coordinates display
5. A number of new layer types
6. Optional axis draw margins (to avoid that plots can hide axis labels)
...and a lot of bugfixing! See Changelog for more details.


0.03 Release notes
------------------

Some useful functionalities has been added.
The axes now can be set to be drawn on 5 different configurations for each one. In addition to the central mode prevoiusly avalilable, you can draw them to the the borders of the window, or close to the border but with an offset to let labels within. The axes are now always visible when you resize the window. This style is more similar to technical softwares, and more useful, I think.
Mouse operations are now available for zooming, panning and scrolling the window. You can also activate double buffering of the mpWindow to avoid flickering.
Three new classes are available, mpText, mpProfile and mpFXYVector. See Changelog for more details.

A special acknowledgement goes to the contributors Jose Luis Blanco and Val Greene who provided a significant part of the new functionalities. 

0.02 Release notes
------------------

While the project has been idle for about 4 years, this release simply fixes
some thing to adapt to new versions of wxWidgets. The use of deprecated
classes or method has been corrected. Only a simple method for layer
counting has been added.

wxMathPlot now works on Linux (tested for Mepis 6.5 and Debian Etch using
wxGTK-2.6), and Windows (built under XP using Visual Studio Express 2005).
If you experience to test it under other platforms, please write me at:
cdron77(at)sourceforge.net



Installing
----------

wxMathPlot uses cmake build environment
It requires wxWidgets >= 2.6 to be installed.

Under POSIX systems, to build and install wxMathPlot run:

cmake -i .
make
make install

Running cmake with -i option causes to get an interactive shell which asks some question on how to build the library.

Default install directory for headers is:
/usr/local/include

and the lib to
/usr/local/lib

Samples
-------

A subdirectory 'samples' contains sample applications using wxMathLib.
They re built together with the library, if the relative option is selected by CMake.


David Schalig, email sf(at)schalig.org

Coloring utilities are intended for color processing.
-----------------------------------------------------


* coloring

coloring utility creates a color FITS file. At least two single-color
frames are stacked to an output file. The operation is practically
only simple copy of data and adding of the color flag. For example, the
color FITS can be created from two single-color exposures in two Landolt 
filters.


* ctrafo

ctrafo transforms a color FITS to a different colorspace. The operation
recompute its data according a transformation matrix. Typical
usage is transformation of observation in astronomical filters
to computer graphics colorspaces.



Usage
-----

The utilities can be controlled by commands on standard input. There are
no command line parameters. This property gives flexible and portable
interface for various environments (cgi script, GUI,..).

Control commands has the form:

KEY = value

where KEY (uppercase) is a control key and value is supplemented
value. Values are of types: integer, real and string. The strings
must be enclosed in apostrophes (to be readable by Fortran input
edition in free format). Examples:

# key   value
NBAND = 3            # integer
XXX   = 3.0          # real, none used
COLORSPACE='XYZ'     # character, apostrophes are mandatory


The parameters for stacked frames are placed at end of file (!)
immediately following of NBAND key. The color-bands must be arranged
from short to longer wave-lengths (as BVR are)! The value of NBAND 
must corresponds to number of the records. Parameters gets form:

# 'filename'                       black weight
'/home/f/foto/colorCCD/m27_B.fits' 3700  0.6        # blue is first
'/home/f/foto/colorCCD/m27_V.fits' 8700  1
'/home/f/foto/colorCCD/m27_R.fits' 19700 1          # red is last

The first string determines the file to be used. Numbers at end of 
every line sets black and weight of every band. Both must be determined
empirically. It is recommended for black to use level 1-sigma under 
median for typical night sky images. The weight is proportional
to recorded flux, so choose weight by the reciprocal relative ratio
of exposure times.

There are tree types of the records:

 1. for conversion to XYZ colorspace (example above)

 2. for general manipulation:

# 'filename'                       extension
'/home/f/foto/colorCCD/m27_B.fits' 'B'
'/home/f/foto/colorCCD/m27_V.fits' 'V'
'/home/f/foto/colorCCD/m27_R.fits' 'R'


 3. for transformation (black, weight has the same meaning)

# index   black weight
  1       3700  0.6
  2       8700  1
  3      19700  1

  

All FITS filenames can use of common FITS conventions,
so it is possible to select extensions, subframes etc.
The exclamation mark '!' indicates potentional file overwrite.

The characted # starts comments.




Examples of usage
-----------------


Usage:
* save the text between --- lines to a file (m27-in)
* apply by executing of the command:

   $ coloring < m27-in

* that's all



Convert Landolt BVR to XYZ:

----------------------------------
OUTPUT='!x.fits'
INPUTSPACE='Landolt BVR'
COLORSPACE='XYZ'
NBAND = 3
'/home/f/foto/colorCCD/m27_B.fits' 3700 0.6
'/home/f/foto/colorCCD/m27_V.fits' 8700 1
'/home/f/foto/colorCCD/m27_R.fits' 19700 1
-------------------------------------------


Create a color FITS:

----------------------------------------
OUTPUT='!x.fits'
INPUTSPACE='Landolt BVR'
NBAND = 3
'/home/f/foto/colorCCD/m27_B.fits' 'B'
'/home/f/foto/colorCCD/m27_V.fits' 'V'
'/home/f/foto/colorCCD/m27_R.fits' 'R'
----------------------------------------


Convert a color FITS to XYZ:

-----------------------------------------
OUTPUT='!xt.fits'
INPUT='x.fits'
COLORSPACE='XYZ'
NBAND = 3
1 3700 0.6
2 8700 1
3 19700 1
----------------------------------------



All possible colorspaces can be listed by command:

$ echo 'INFO = colorspaces' | ctrafo





List of keys

See top of mcoloring.cpp and mctrafo.cpp.




List of colosrpaces

The known colorspaces are in ctable.dat (format is described
in mcoloring.cpp). The file is a text file so it is possible
to add any required transformations.

Note to a watermark
-------------------

* The watermark has been painted by me in Gimp. The artwork is kept as artpicture.xcf.

* One is converted (by Gimp) to artpicture.xpm.

* Program artpicture.c++ converts the XPM to Fortran source:

  $ g++ artpicture.c++

  (warnings about conversions from/to char * can be safety ignored)

* Fortran source itself is created as

  $ ./a.out > artpicture.f95


* marker.f95 reads directly the source file.



Light Curves
------------

Light curves are approximated by Fourier polynomials.

* delta-Cep, data included (reference in lcapprox.f08)

* Algol (data included)

* Fourier coefficients are eastimated and saved to lcparams:

  $ gfortran -I../lib -Wall -g -p -fcheck=all -fimplicit-none -fbacktrace lcapprox.f08 \
           -L../lib -lminpacks -lminpack
  $./a.out > lcparams.f95

FITSUTILS

Purpose of all that utilities is general manipulation with FITSes.




munitits 

 * inspired by sng (convertor PNG to plain text and vice versa)
   Extremly useful for any unpredictable manipulations by standard tool
   with fits. For headers, images and tables.


munihead

 * general work with fits header's keywords (in fashion of exiftool)
   Usefull for list, read, modify, write header's records.



muniarit

 * a simple FITS arithmetics (+-*/ functions?)


munistat

 * a general statistic function's (mean, median, ..)

Binary distribution
-------------------

Goals:

  * offer simple installation for peoples without computer skills
  * be multiplatform
  * be independent on local libraries (version and configuration diversity)


Because:
  
  * users are not computer specialist but astronomers
  * there is many of unix flavours (espetially linux distributions) 
  * there is great diversity in presence and configuration of required 
    libraries in many linux distributions
  * It is very difficult to maintain distribution packages for 
    Debian (stable, testing, unstable,..), Ubuntu (8.x,9.x,10.x..),
    Fedora..., Mandriva, ...., *BSD, ...



How to create a binary self-installation package
-----------------------------------------------

See:

   http://integral.physics.muni.cz/debbuilder.html
   http://integral.physics.muni.cz/rpmbuilder.html

!
!  aperture photometry tester
!
!  Copyright © 2019-20 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program testaphot

  use fitsaphot
  use daofotometr

  implicit none

  integer :: naper, i
  real :: r0, e, f, g, g2
  real, dimension(:), allocatable :: raper, apsum
  character(len=666) :: arg

  call get_command_argument(1,arg)
  read(arg,*) r0
  call get_command_argument(2,arg)
  read(arg,*) e

  call rfits('art.fits',naper,raper,apsum)

  do i = 1, naper
     f = 1 - exp(-raper(i)**2/2/r0**2)
     g = apsum(i) / apsum(naper)
     g2 = g2d(raper(i),r0,e)
     write(*,'(6f10.3)') raper(i),g,f,g-f,g2,g2-f
!          grow(raper(i)/r0)*grow(raper(i)/r0/sqrt(1-e**2))
  end do

  deallocate(raper,apsum)

contains

  real function grow(r)

    real, intent(in) :: r

    grow = (1 + erf(r/sqrt(2.0))) / 2

  end function grow

  real function g2d(raper,r0,e)

    real, intent(in) :: raper,r0,e

    integer, parameter :: ndim = 2500
    !    real, dimension(-ndim:ndim,-ndim,ndim) :: g
    integer :: n,i,j
    real :: s,c,g,r2

    n = 0
    s = 0
    c = 100
    do i = -ndim, ndim
       do j = -ndim, ndim
          r2 = (i**2 + j**2) / c**2
!          if( .true. ) then
          if( r2 <= raper**2 ) then
             g = exp(-r2/r0**2/2)
             s = s + g
             n = n + 1
          end if
       end do
    end do
!    write(*,*) s,n,s / n / c,s/250591.047
    g2d = s / n / c
    g2d = s/250591.047
    g2d = s / (c*ndim)

  end function g2d



  subroutine rfits(filename,naper,raper,apsum)

    use titsio

    character(len=*), intent(in) :: filename
    integer, intent(out) :: naper
    real, dimension(:), allocatable, intent(out) :: raper, apsum

    character(len=80) :: key
    real, dimension(:), allocatable :: col
    integer :: status,nrows,irow,i
    type(fitsfiles) :: fits
    logical :: anyf

    irow = 1

    status = 0
    call fits_open_table(fits,filename,FITS_READONLY,status)
    call fits_get_num_rows(fits,nrows,status)
    allocate(col(nrows))

    call fits_read_key(fits,'NAPER',naper,status)
    allocate(raper(naper),apsum(naper))
    do i = 1, naper
       write(key,'(a,i0)') 'APER',i
       call fits_read_key(fits,key,raper(i),status)
    end do

    do i = 1, naper
       call fits_read_col(fits,3+2*i,1,0.0,col,anyf,status)
       apsum(i) = col(irow)
    end do
    deallocate(col)
    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

  end subroutine rfits

end program testaphot

c     **********
c
c     this program checks the constants of machine precision and
c     smallest and largest machine representable numbers specified in
c     function dpmpar, against the corresponding hardware-determined
c     machine constants obtained by dmchar, a subroutine due to
c     w. j. cody.
c
c     data statements in dpmpar corresponding to the machine used must
c     be activated by removing c in column 1.
c
c     the printed output consists of the machine constants obtained by
c     dmchar and comparisons of the dpmpar constants with their
c     dmchar counterparts. descriptions of the machine constants are
c     given in the prologue comments of dmchar.
c
c     subprograms called
c
c       minpack-supplied ... dmchar,dpmpar
c
c     argonne national laboratory. minpack project. march 1980.
c     burton s. garbow, kenneth e. hillstrom, jorge j. more
c
c     **********
      integer ibeta,iexp,irnd,it,machep,maxexp,minexp,negep,ngrd,
     *        nwrite
      double precision dwarf,eps,epsmch,epsneg,giant,xmax,xmin
      double precision rerr(3)
      double precision dpmpar
c
c     logical output unit is assumed to be number 6.
c
      data nwrite /6/
c
c     determine the machine constants dynamically from dmchar.
c
      call dmchar(ibeta,it,irnd,ngrd,machep,negep,iexp,minexp,maxexp,
     *            eps,epsneg,xmin,xmax)
c
c     compare the dpmpar constants with their dmchar counterparts and
c     store the relative differences in rerr.
c
      epsmch = dpmpar(1)
      dwarf = dpmpar(2)
      giant = dpmpar(3)
      rerr(1) = (epsmch - eps)/epsmch
      rerr(2) = (dwarf - xmin)/dwarf
      rerr(3) = (xmax - giant)/giant
c
c     write the dmchar constants.
c
      write (nwrite,10)
     *      ibeta,it,irnd,ngrd,machep,negep,iexp,minexp,maxexp,eps,
     *      epsneg,xmin,xmax
c
c     write the dpmpar constants and the relative differences.
c
      write (nwrite,20) epsmch,rerr(1),dwarf,rerr(2),giant,rerr(3)
      stop
   10 format (17h1dmchar constants /// 8h ibeta =, i6 // 8h it    =,
     *        i6 // 8h irnd  =, i6 // 8h ngrd  =, i6 // 9h machep =,
     *        i6 // 8h negep =, i6 // 7h iexp =, i6 // 9h minexp =,
     *        i6 // 9h maxexp =, i6 // 6h eps =, d15.7 // 9h epsneg =,
     *        d15.7 // 7h xmin =, d15.7 // 7h xmax =, d15.7)
   20 format ( /// 42h dpmpar constants and relative differences ///
     *         9h epsmch =, d15.7 / 10h rerr(1) =, d15.7 //
     *         8h dwarf =, d15.7 / 10h rerr(2) =, d15.7 // 8h giant =,
     *         d15.7 / 10h rerr(3) =, d15.7)
c
c     last card of driver.
c
      end

!
!  fitsfind
!
!  Copyright © 2013 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module fitsfind

  use fitsio

  implicit none

  integer, parameter, private :: rp = selected_real_kind(15)

contains


subroutine ffind(filename,maxsky,verbose,plog,fkeys,fwhm,readns_init, &
     satur_init,lothresh,threshold,shrplo,shrphi,rndlo,rndhi)

  use mdaofind

  integer, parameter :: DIM = 2

  character(len=*),intent(in) :: filename
  logical, intent(in) :: verbose,plog
  character(len=*),dimension(:),intent(in) :: fkeys
  real,intent(in) :: fwhm,readns_init,satur_init, &
       lothresh,threshold,shrplo,shrphi,rndlo,rndhi
  integer,intent(in) :: maxsky
  integer :: status, naxis, bitpix, hdutype
  integer, parameter :: group = 1, extver = 0, frow = 1, felem = 1
  real, parameter :: nullval = 0.0
  integer, dimension(DIM) :: naxes
  logical :: anyf
  real, dimension(:,:), allocatable :: data
  real, dimension(:), allocatable :: xcens,ycens,hstar,rounds,sharps
  character(len=FLEN_CARD) :: buf
  real :: lobad, hibad, aduthresh,saturation,readns,skymod, skyerr, skysig
  character(len=FLEN_VALUE), dimension(5) :: ttype, tform, tunit

  buf = ''
  status = 0
  call ftiopn(15,filename,1,status)
  call ftgipr(15,DIM,bitpix,naxis,naxes,status)
  if( status /= 0 .or. naxis /= 2 ) goto 666

  if( readns_init > 0.0 ) then
     readns = readns_init
     call ftukye(15,fkeys(2),readns_init,-7,'[ADU] read noise',status)
  else
     call ftgkye(15,fkeys(2),readns,buf,status)
     if( status == KEYWORD_NOT_FOUND ) then
        readns = 0.0
        status = 0
     end if
  end if

  if( satur_init > 0.0 ) then
     saturation = satur_init
     call ftukye(15,fkeys(1),satur_init,5,'[counts] full well capacity',status)
  else
     call ftgkye(15,fkeys(1),saturation,buf,status)
     if( status == KEYWORD_NOT_FOUND ) then
        saturation = -1.0
        status = 0
     end if
  end if
  if( status /= 0 ) goto 666

  if( saturation > 0.0 ) then
     hibad = saturation
  else
     hibad = huge(data)
  end if

  allocate(data(naxes(1),naxes(2)))
  call ftg2de(15,group,nullval,size(data,1),naxes(1),naxes(2), &
       data,anyf,status)

  if( status /= 0 ) then
     call ftrprt('STDERR',status)
     deallocate(data)
     return
  end if

  if( status == 0 ) then

     call daofind(data,maxsky,verbose,plog,hibad,fwhm,lothresh,threshold, &
          shrplo,shrphi,rndlo,rndhi,readns,1.0,xcens,ycens,hstar,rounds,sharps, &
          lobad, aduthresh, skymod, skyerr, skysig)

     ! sort arrays by height above lower threshold
     call sorter(xcens,ycens,hstar)

  end if

! results fills new FITS extension

  ! look for the extension
  call ftmnhd(15,BINARY_TBL,FINDEXTNAME,extver,status)
  if( status == BAD_HDU_NUM ) then
     status = 0
  else if( status == 0 ) then
     ! already presented ? remove it !
     call ftdhdu(15,hdutype,status)
  end if
  if( status /= 0 ) goto 666

  ttype(1) = FITS_COL_X
  ttype(2) = FITS_COL_Y
  ttype(3) = FITS_COL_SHARP
  ttype(4) = FITS_COL_ROUND
  ttype(5) = FITS_COL_PEAKRATIO
  tform = '1D'
  tunit = ''

  call ftibin(15,0,size(ttype),ttype,tform,tunit,FINDEXTNAME,0,status)

  call ftukye(15,FITS_KEY_FWHM,fwhm,-2,'[pix] standard FWHM of objects',status)
  call ftukye(15,FITS_KEY_THRESHOLD,threshold,-2,'threshold in sigmas above background',status)
  call ftukye(15,FITS_KEY_LOWBAD,lobad,-3,'[ADU] low good datum',status)
  call ftukye(15,FITS_KEY_HIGHBAD,hibad,-3,'[ADU] high good datum',status)
  call ftukye(15,FITS_KEY_RNDLO,rndlo,-3,'low round',status)
  call ftukye(15,FITS_KEY_RNDHI,rndhi,-3,'high round',status)
  call ftukye(15,FITS_KEY_SHRPLO,shrplo,-3,'low sharp',status)
  call ftukye(15,FITS_KEY_SHRPHI,shrphi,-3,'high sharp',status)

  call ftpcom(15,'Star detection parameters:',status)

  write(buf,*) 'Saturation (ADU)=',saturation,' (see primary HDU)'
  call ftpcom(15,buf,status)

  write(buf,*) 'Read noise (ADU)=',readns,' (see primary HDU)'
  call ftpcom(15,buf,status)

  write(buf,*) 'Lower threshold (sigma)=',lothresh
  call ftpcom(15,buf,status)

  write(buf,*) 'Levels range (ADU) =',lobad, '..',hibad
  call ftpcom(15,buf,status)

  write(buf,*) 'Round range =',rndlo, '..',rndhi
  call ftpcom(15,buf,status)

  write(buf,*) 'Sharp range =',shrplo, '..',shrphi
  call ftpcom(15,buf,status)

  write(buf,*) 'Approximate sky value =',skymod,'+-',skyerr
  call ftpcom(15,buf,status)

  write(buf,*) 'Estimated sky sigma =',skysig
  call ftpcom(15,buf,status)

  write(buf,*) 'Pixels used for sky determination =',maxsky
  call ftpcom(15,buf,status)

  call ftpcle(15,1,frow,felem,size(xcens),xcens,status)
  call ftpcle(15,2,frow,felem,size(ycens),ycens,status)
  call ftpcle(15,3,frow,felem,size(sharps),sharps,status)
  call ftpcle(15,4,frow,felem,size(rounds),rounds,status)
  call ftpcle(15,5,frow,felem,size(hstar),hstar,status)

666 continue

  call ftclos(15,status)
  if( status /= 0 ) call ftrprt('STDERR',status)

  if( allocated(data) ) deallocate(data)
  if( allocated(xcens) ) deallocate(xcens,ycens,hstar,rounds,sharps)


contains

  subroutine sorter(xcens,ycens,hstar)

    use quicksort

    real, dimension(:),intent(inout) :: xcens,ycens,hstar

    real(rp), dimension(:), allocatable :: xs,ys,hs
    integer, dimension(:), allocatable :: id
    integer :: i,n,idx

    allocate(xs(size(xcens)),ys(size(ycens)),hs(size(hstar)),id(size(hstar)))
    forall( i = 1:size(hstar) )
       id(i) = i
       hs(i) = hstar(i)
    end forall
    call qsort(hs,id)
    ! sorted from low to high

    xs = xcens
    ys = ycens
    n = size(id) + 1
    do i = 1, size(id)
       idx = id(n - i)
       xcens(i) = real(xs(idx))
       ycens(i) = real(ys(idx))
    end do

    ! reverse sort
    forall( i = 1:size(hstar) )
       hstar(i) = real(hs(n - i))
    end forall
    deallocate(id,xs,ys,hs)

  end subroutine sorter


end subroutine ffind


end module fitsfind

! perm - creates all possible permutations
!
! $ gfortran -Wall -g -p -fbounds-check -fimplicit-none  -I../lib match.f95  perm.f95
!
! Copyright © 2012-4 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program perm

  implicit none

  integer, dimension(:), allocatable :: id
  integer :: n,nmatch,nperm

  nperm = 0

  nmatch = 3
  allocate(id(nmatch))

  n = 0
  call tperm

  write(*,*) 'nperm=',nperm

contains

  
  recursive subroutine tperm

    use matcher

    integer :: i


    if( n == size(id) ) then

       nperm = nperm + 1
       write(*,*) id

    else

       do i = 1, size(id)

          if( .not. locate(i,id(1:n)) ) then

             n = n + 1
             id(n) = i
             call tperm
             n = n  - 1
          end if
          
       end do
    end if
    
  end subroutine tperm


function locate(d,id)

  logical :: locate
  integer, intent(in) :: d
  integer, dimension(:), intent(in) :: id
  integer :: i

  locate = .false.
  do i = 1, size(id)
     if( id(i) == d ) then
        locate = .true.
        return
     end if
  end do
 
end function locate


end program perm

! gfortran -Wall -g -p -no-pie -fcheck=all -fimplicit-none -fbacktrace minpacks.f95 testminpacks.f08 -lminpack -lm

program testminpacks

  use minpacks
  use iso_fortran_env

  implicit none


  real(REAL64), dimension(3,3) :: a, a1, u
  real(REAL64), dimension(3) :: b,x
  integer :: i,j

  do i = 1, 3
     do j = 1,3
        a(i, j) = real(1.0,REAL64) / real(i + 3*j - 1,REAL64)
     enddo
  enddo

  write(*,*) 'Original matrix:'
  do i = 1,3
     write(*,*) a(i,:)
  enddo

  call qrinv(a,a1)

  write(*,*)
  write(*,*) 'Inverted matrix:'
  do i = 1,3
     write(*,*) a1(i,:)
  enddo

  write(*,*)
  write(*,*) 'Unit matrix:'
  u = matmul(a,a1)
  do i = 1,3
     write(*,*) u(i,:)
  enddo

  write(*,*)
  write(*,*) 'Solution of equations:'

  b = [ 1,0,0 ]
  call qrsolve(a,b,x)
  write(*,*) x

  b = [ 0,1,0 ]
  call qrsolve(a,b,x)
  write(*,*) x

  b = [ 0,0,1 ]
  call qrsolve(a,b,x)
  write(*,*) x

end program testminpacks

!
! Common for read/write photometry-related FITSes
!
!
! Copyright © 2013,2015-6,2018-20 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module phio

  use titsio
  use astrotrafo

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl

contains


  subroutine wcsget(fits,t,status)

    type(fitsfiles), intent(in) :: fits
    integer, intent(in out) :: status
    type(AstroTrafoProj), intent(out) :: t

    integer, parameter :: DIM = 2
    integer, dimension(DIM) :: naxes
    character(len=FLEN_VALUE),dimension(2) :: ctype
    real(dbl), dimension(2,2) :: cd
    real(dbl), dimension(2) :: crval,crpix,crder

    ! read image dimensions
    call fits_get_img_size(fits,DIM,naxes,status)

    ! read astrometric calibration
    call fits_read_key(fits,'CTYPE1',ctype(1),status)
    call fits_read_key(fits,'CTYPE2',ctype(2),status)
    call fits_read_key(fits,'CRVAL1',crval(1),status)
    call fits_read_key(fits,'CRVAL2',crval(2),status)
    call fits_read_key(fits,'CRPIX1',crpix(1),status)
    call fits_read_key(fits,'CRPIX2',crpix(2),status)
    call fits_read_key(fits,'CD1_1',cd(1,1),status)
    call fits_read_key(fits,'CD1_2',cd(1,2),status)
    call fits_read_key(fits,'CD2_1',cd(2,1),status)
    call fits_read_key(fits,'CD2_2',cd(2,2),status)
    if( status /= 0 ) return

    ! optional keywords
    call fits_read_key(fits,'CRDER1',crder(1),status)
    call fits_read_key(fits,'CRDER2',crder(2),status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       status = 0
       crder = 0
    end if

    if( status /= 0 ) return

    ! interpret the calibration
    call trafo_fromwcs(t,ctype,crval,crpix,cd,crder)

  end subroutine wcsget

  subroutine trafo_fromwcs(t,ctype,crval,crpix,cd,crder)

    type(AstroTrafoProj), intent(out) :: t
    character(len=*), dimension(:), intent(in) :: ctype
    real(dbl), dimension(:),intent(in) :: crval,crpix,crder
    real(dbl), dimension(:,:),intent(in) :: cd
    character(len=FLEN_VALUE) :: type
    real(dbl) :: c,s,sc,rot,refl,err
    real(dbl), dimension(2,2) :: mi,m

    if( size(ctype) /= 2 ) stop 'Bad dimensions of CTYPE (no 2).'

    if( index(ctype(1),"-TAN") > 0 ) then
       type = 'GNOMONIC'
    else
       type = ' '
    end if

    ! un-flip spherical to rectangular coordinates
    mi(1,:) = [ -1.0_dbl, 0.0_dbl ]
    mi(2,:) = [  0.0_dbl, 1.0_dbl ]
    m = matmul(mi,cd)

    ! the reflection (flip, mirror) is determined from
    ! diagonal elements with (non-)corresponding signs
    refl = sign(1.0_dbl,m(1,1)*m(2,2))

    ! transform-out reflex
    mi(1,:) = [    refl, 0.0_dbl ]
    mi(2,:) = [ 0.0_dbl, 1.0_dbl ]
    m = matmul(m,mi)

    c = (m(1,1) + m(2,2)) / 2.0_dbl
    s = (m(2,1) - m(1,2)) / 2.0_dbl
    sc = 1.0_dbl / sqrt(c**2 + s**2)   ! in pix per deg
    rot = rad*(atan2(-m(1,2),m(1,1)) + atan2(m(2,1),m(2,2)))/2.0_dbl

    if( sum(abs(crder)) > size(crder)*epsilon(1.0_dbl) ) then
       err = sqrt(sum(crder**2)/size(crder))
    else
       err = 1.0/sc
    end if

    call trafo_init(t,type,crval(1),crval(2),crpix(1),crpix(2), &
         scale=1/sc,rot=rot,refl=refl,err=err)

  end subroutine trafo_fromwcs


  function fits_jd(dateobs,status) result(jd)

    use trajd

    real(dbl) :: jd
    character(len=*), intent(in) :: dateobs
    integer ::year, month, day, hour, minute
    real(dbl) :: second, d
    integer :: status

    jd = 0
    if( status /= 0 ) return

    if( dateobs /= '' ) then

       ! decode date-time string
       call fits_str2date(dateobs,year,month,day,hour,minute,second,status)
       if( status == 0 ) then

          ! Evaluate Julian date
          d = day + (hour + (minute + second/60.0_dbl) / 60.0_dbl) / 24.0_dbl
          jd = datjd(real(year,dbl),real(month,dbl),d)
       end if

    end if

  end function fits_jd


end module phio

!
! astrofits - write WCS to FITS image & read star table
!
!
! Copyright © 2011-3, 2015-7, 2020 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module astrofits

  use titsio
  use astrotrafo
  use trajd
  use iso_fortran_env

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

contains

  subroutine readtable(filename, label_alpha, label_delta, label_pmalpha, &
       label_pmdelta, label_mag, key_epoch, alpha, delta, pmalpha, pmdelta, &
       refflux, rframe, catid, epoch,status)

    character(len=*), intent(in) :: filename, label_alpha, label_delta, &
         label_pmalpha, label_pmdelta, label_mag, key_epoch
    real(dbl), allocatable, dimension(:), intent(out) :: alpha, delta, &
         pmalpha, pmdelta, refflux
    character(len=*), intent(out) :: rframe, catid
    real(dbl), intent(out) :: epoch
    integer, intent(out) :: status

    real(dbl), parameter :: nullcoo = 1e33, clim = 0.1*nullcoo
    real(dbl), parameter :: nullmag = 99.999
    real(dbl), parameter :: mag25 = 25
    integer, parameter :: ncols = 5
    integer, dimension(ncols) :: col, statuses
    real(dbl), allocatable, dimension(:) :: ra,dec,pmra,pmdec,mag
    integer :: nrows,i,l,nr,n,frow,srows,stat
    logical :: anyf
    character(len=FLEN_VALUE), dimension(ncols) :: label,colname
    character(len=80) :: errmsg
    type(fitsfiles) :: fits

    label(1) = label_alpha
    label(2) = label_delta
    label(3) = label_pmalpha
    label(4) = label_pmdelta
    label(5) = label_mag

    status = 0

    ! open, and move, to a table extension
    call fits_open_table(fits,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read a table in the file `',trim(filename),"'."
       return
    end if

    call fits_get_num_rows(fits,nrows,status)
    if( status /= 0 ) goto 666
    if( .not. (nrows > 0) )then
       write(error_unit,*) 'Error: encountered empty table in the file `', &
            trim(filename),"'."
       goto 666
    end if

    ! define reference frame and identification of catalogue
    rframe = ''
    catid = ''
    call fits_read_key(fits,'EXTNAME',catid,status)
    call fits_read_key(fits,key_epoch,epoch,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       status = 0
       epoch = yearjd(2000.0_dbl)   ! 2451545.0
    else
       epoch = yearjd(epoch)
    end if

    ! find columns by labels
    statuses = 0
    do i = 1, ncols
       colname(i) = ''
       if( label(i) /= '' ) then
          call fits_get_colname(fits,.false.,label(i),colname(i),col(i),statuses(i))
       else
          statuses(i) = -1
       end if
    end do
    if( any(statuses(1:2) /= 0) ) then
       write(error_unit,*) &
            'Error: Right Ascension and Declination columns are mandatory.'
       status = maxval(statuses(1:2))
       goto 666
    end if

    allocate(ra(nrows),dec(nrows),pmra(nrows),pmdec(nrows),mag(nrows),&
         stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,'(2a)') 'Error:', trim(errmsg)
       goto 666
    end if

    pmra = 0.0_dbl
    pmdec = 0.0_dbl
    mag = mag25

    call fits_get_rowsize(fits,srows,status)

    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       ! coordinates
       call fits_read_col(fits,col(1),frow,nullcoo,ra(i:l),anyf,status)
       call fits_read_col(fits,col(2),frow,nullcoo,dec(i:l),anyf,status)

       ! proper motion
       if( all(statuses(3:4) == 0) ) then
          call fits_read_col(fits,col(3),frow,nullcoo,pmra(i:l),anyf,status)
          call fits_read_col(fits,col(4),frow,nullcoo,pmdec(i:l),anyf,status)
       end if

       ! magnitudes
       if( statuses(5) == 0 ) then
          call fits_read_col(fits,col(5),frow,nullmag,mag(i:l),anyf,status)
       end if

       if( status /= 0 ) goto 666
    end do

    pmra = pmra / 3.6e6_dbl  ! supposing mas/year
    pmdec = pmdec / 3.6e6_dbl


    nr = min(count(abs(ra) < clim), count(abs(dec) < clim), count(mag < 99))
    allocate(alpha(nr),delta(nr),pmalpha(nr),pmdelta(nr),refflux(nr), &
         stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,'(2a)') 'Error:', trim(errmsg)
       goto 666
    end if

    n = 0
    do i = 1, nrows
       if( abs(ra(i)) < clim .and. abs(dec(i)) < clim .and. mag(i) < 99 ) then
          n = n + 1
          alpha(n) = ra(i)
          delta(n) = dec(i)
          pmalpha(n) = pmra(i)
          pmdelta(n) = pmdec(i)
          refflux(n) = 10.0**((mag25 - mag(i))/2.5)
       end if
    end do
    deallocate(ra,dec,pmra,pmdec,mag)

    call fits_close_file(fits,status)
    return

666 continue

    if( allocated(ra) ) deallocate(ra,dec,pmra,pmdec,mag)
    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

  end subroutine readtable


  subroutine readfile(filename, key_dateobs, width, height, xcoo, ycoo, flux, &
       crpix, jd, crval, sc, pa, refl, status)

    use phio

    character(len=*), intent(in) :: filename, key_dateobs
    real(dbl), intent(out) :: width, height
    real(dbl), allocatable, dimension(:), intent(out) :: xcoo, ycoo, flux
    real(dbl), dimension(:), intent(out) :: crpix, crval
    real(dbl), intent(out) :: jd, sc, pa, refl
    integer,intent(out) :: status

    integer :: naxis, bitpix, nrows, n, ns, i, l, srows, frow
    integer, dimension(2) :: naxes
    logical :: anyf
    integer, parameter :: extver = 0
    real(dbl), allocatable, dimension(:) :: x,y,cts
    real(dbl), parameter :: nullval = 0.0_dbl
    character(len=FLEN_CARD) :: colname1, colname2, dateobs, aplabel
    integer :: col1, col2
    type(AstroTrafoProj) :: t
    type(fitsfiles) :: fits

    status = 0
    call fits_open_image(fits,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read an image in the file `',trim(filename),"'."
       return
    end if

    call fits_get_img_param(fits,bitpix,naxis,naxes,status)
    if( status /= 0 .or. naxis /= 2 ) then
       if( naxis /= 2 ) then
            write(error_unit,*) trim(filename), &
                 ": Sorry, just two dimensional images are implemented yet."
            status = -1
         end if
       goto 666
    end if
    width = naxes(1)
    height = naxes(2)
    crpix = naxes/2.0_dbl

    call fits_read_key(fits,key_dateobs,dateobs,status)
    if( status == 0 ) then
       jd = fits_jd(dateobs,status)
    else if( status == FITS_KEYWORD_NOT_FOUND ) then
       status = 0
       jd = 2451544.5_dbl
       write(error_unit,*) "Warning: the keyword `",trim(key_dateobs), &
            "' not found in `",trim(filename),"'. Set to J2000.0."
    end if
    if( status /= 0 ) goto 666

    ! get calibration
    call wcsget(fits,t,status)
    if( status == 0 ) then
       sc = t%scale
       pa = t%rot
       refl = t%refl
       crval = [ t%acen, t%dcen ]
       crpix = [ t%xcen, t%ycen ]
    else
       status = 0
       crval = -999.999
    end if

    ! FIND extension
    call fits_movnam_hdu(fits,FITS_BINARY_TBL,FINDEXTNAME,extver,status)
    if( status == FITS_BAD_HDU_NUM ) then
       write(error_unit,*) trim(FINDEXTNAME)// &
            ': extension not found. Coordinates of objects are not available.'
       goto 666
    end if
    call fits_get_num_rows(fits,nrows,status)
    if( status /= 0 ) goto 666

    allocate(x(nrows),y(nrows))

    ! the column labels are specific for MUNIPACK extension only
    colname1 = ''
    colname2 = ''
    call fits_get_colname(fits,.false.,FITS_COL_X,colname1,col1,status)
    call fits_get_colname(fits,.false.,FITS_COL_Y,colname2,col2,status)

    call fits_get_rowsize(fits,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_read_col(fits,col1,frow,nullval,x(i:l),anyf,status)
       call fits_read_col(fits,col2,frow,nullval,y(i:l),anyf,status)

       if( status /= 0 ) goto 666
    end do

    ! photometry extension
    call fits_movnam_hdu(fits,FITS_BINARY_TBL,APEREXTNAME,extver,status)
    if( status == FITS_BAD_HDU_NUM ) then
       status = 0
       ! aperture photometry is not available, no problem,
       ! we are continuing still and all ...?
       ns = size(x)
       allocate(xcoo(ns),ycoo(ns),flux(ns))
       xcoo = x
       ycoo = y
       flux = 1.0
    else if( status == 0 ) then
       ! aperture photometry is available, we can use photometry informations
       ! to improve reliability
       aplabel = trim(FITS_COL_APCOUNT)//"1"
       call fits_get_colname(fits,.false.,aplabel,colname1,col1,status)
       allocate(cts(nrows))
       frow = 1
       call fits_read_col(fits,col1,frow,nullval,cts,anyf,status)

       ! we're selecting stars with valid photometry only
       ns = count(cts > 0.0)
       allocate(xcoo(ns),ycoo(ns),flux(ns))
       ns = 0
       do n = 1,nrows
          if( cts(n) > 0.0 .and. ns < size(xcoo) ) then
             ns = ns + 1
             xcoo(ns) = x(n)
             ycoo(ns) = y(n)
             flux(ns) = cts(n)
          end if
       end do
       deallocate(cts)

    end if
    if( status /= 0 ) goto 666

    call fits_close_file(fits,status)

    deallocate(x,y)
    return

666 continue

    if( allocated(x) ) deallocate(x,y)
    if( allocated(cts) ) deallocate(cts)

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

  end subroutine readfile


  subroutine reffile(filename,key_dateobs,alpha,delta,rflux,jd,status)

    character(len=*), intent(in) :: filename, key_dateobs
    real(dbl), allocatable, dimension(:), intent(out) :: alpha, delta, rflux
    real(dbl), intent(out) :: jd
    integer, intent(out) :: status

    real(dbl) :: w, h, sc, rot, refl
    real(dbl), allocatable, dimension(:) :: x,y
    real(dbl), dimension(2) :: crpix,crval
    type(AstroTrafoProj) :: t


    call readfile(filename,key_dateobs,w,h,x,y,rflux,crpix,jd,crval,&
         sc,rot,refl,status)

    if( status == 0 .and. crval(1) > -666.0 .and. allocated(x) ) then

       allocate(alpha(size(x)),delta(size(x)))

       call trafo_init(t,"GNOMONIC",crval(1),crval(2),crpix(1),crpix(2),&
            scale=sc,rot=rot,refl=refl)
       call invtrafo(t,x,y,alpha,delta)

       deallocate(x,y)
    end if

  end subroutine reffile



!-----------------------------------------------------------------------------

  subroutine wcsupdate(fits,type,crval,sc,pa,dpa,fcrpix,crpixels,refl,rms,&
       com,status)

    use astrotrafo

    integer, parameter :: ndim = 2
    real(dbl), parameter :: rad = 57.295779513082322865_dbl

    type(fitsfiles) :: fits
    character(len=*), intent(in) :: type
    real(dbl), dimension(:), intent(in) :: crpixels,crval
    real(dbl), intent(in) :: sc,pa,dpa,rms,refl
    logical, intent(in) :: fcrpix
    character(len=*), dimension(:), intent(in) :: com
    integer, intent(in out) :: status

    integer :: naxis, bitpix
    integer, dimension(ndim) :: naxes
    real(dbl), dimension(ndim) :: crpix
    character(len=6), dimension(2), parameter :: keys = [ 'CTYPE1', 'CTYPE2' ]
    real(dbl) :: a,b,da,db,s,err
    real(dbl), dimension(2,2) :: mat,rmat
    type(AstroTrafoProj) :: tra
    character(len=5) :: un
    integer :: i

    if( type == " " ) then
       s = 1.0_dbl
       un = '[pix]'
    else
       s = -1.0_dbl
       un = '[deg]'
    end if

    a = cos(pa/rad)
    da = (dpa/rad)*sin(pa/rad)
    b = sin(pa/rad)
    db = (dpa/rad)*cos(pa/rad)
    err = rms/sqrt(2.0)

    ! clear possible previous calibration
    call wcsremove(fits,status)

    if( fcrpix ) then
       crpix = crpixels
    else
       call fits_get_img_param(fits,bitpix,naxis,naxes,status)
       if( status /= 0 ) return
       crpix = naxes/2.0_dbl
    end if

    call fits_update_key(fits,FITS_KEY_CREATOR,FITS_VALUE_CREATOR,FITS_COM_CREATOR,status)

    if( type == "GNOMONIC" )then
       call fits_update_key(fits,'CTYPE1', &
            'RA---TAN','the coordinate type for the first axis',status)
       call fits_update_key(fits,'CTYPE2', &
            'DEC--TAN','the coordinate type for the second axis',status)
    else if( type == " " ) then
       call fits_write_errmark
       do i = 1,size(keys)
          call fits_delete_key(fits,keys(i),status)
          if( status == FITS_KEYWORD_NOT_FOUND ) status = 0
       end do
       call fits_clear_errmark
    end if

    call fits_update_key(fits,'CRVAL1',crval(1),16, &
         un//' first axis value at reference pixel',status)
    call fits_update_key(fits,'CRVAL2',crval(2),16, &
         un//' second axis value at reference pixel',status)
    call fits_update_key(fits,'CRDER1',err,1, &
         un//' random error in first axis',status)
    call fits_update_key(fits,'CRDER2',err,1, &
         un//' random error in second axis',status)

    if( type == " " ) then
       call fits_update_key(fits,'CUNIT1','pix','units of first axis',status)
       call fits_update_key(fits,'CUNIT2','pix','units of second axis',status)
    else
       call fits_update_key(fits,'CUNIT1','deg','units of first axis',status)
       call fits_update_key(fits,'CUNIT2','deg','units of second axis',status)
    end if

    call trafo_init(tra,scale=sc,rot=pa,refl=refl)

    ! flip x-axis due to conversion rectangular -> spherical coordinates
    rmat(1,:) = [ -1.0_dbl,0.0_dbl ]
    rmat(2,:) = [ 0.0_dbl,1.0_dbl ]
    mat = matmul(rmat,tra%mat)

    call fits_update_key(fits,'CRPIX1',crpix(1),16, &
         'x-coordinate of reference pixel',status)
    call fits_update_key(fits,'CRPIX2',crpix(2),16, &
         'y-coordinate of reference pixel',status)
    call fits_update_key(fits,'CD1_1',mat(1,1),16, &
         'partial of first axis coordinate w.r.t. x',status)
    call fits_update_key(fits,'CD1_2',mat(1,2),16, &
         'partial of first axis coordinate w.r.t. y',status)
    call fits_update_key(fits,'CD2_1',mat(2,1),16, &
         'partial of second axis coordinate w.r.t. x',status)
    call fits_update_key(fits,'CD2_2',mat(2,2),16, &
         'partial of second axis coordinate w.r.t. y',status)

    call fits_write_comment(fits,BEGIN_ASTROMETRY,status)
    do i = 1, size(com)
       call fits_write_comment(fits,com(i),status)
    end do

    ! no fitting
    if( size(com) < 1 ) &
         call fits_write_comment(fits,"Astrometry calibration provided by user.",status)

    call fits_write_comment(fits,MUNIPACK_VERSION,status)
    call fits_write_comment(fits,END_ASTROMETRY,status)

  end subroutine wcsupdate


!-----------------------------------------------------------------------------


  subroutine wcsremove(fits,status)

    type(fitsfiles) :: fits
    integer, intent(in out) :: status
    integer :: i, nbegin, nend
    character(len=FLEN_CARD) :: card
    character(len=6), dimension(14) :: keys = [ &
         'CTYPE1', 'CTYPE2','CRVAL1','CRVAL2','CRDER1','CRDER2', &
         'CRPIX1','CRPIX2','CUNIT1','CUNIT2','CD1_1 ','CD1_2 ', &
         'CD2_1 ','CD2_2 ' ]

    call fits_write_errmark
    do i = 1, size(keys)
       call fits_delete_key(fits,keys(i),status)
       if( status == FITS_KEYWORD_NOT_FOUND ) status = 0
    end do
    call fits_clear_errmark

    i = 0
    nbegin = 0
    nend = 0
    card = ''
    do
       i = i + 1
       call fits_read_record(fits,i,card,status)
       if( status /= 0) exit
       if( card(9:) == BEGIN_ASTROMETRY ) nbegin = i
       if( card(9:) == END_ASTROMETRY ) nend = i
    end do
    if( status == 203 ) status = 0

    if( nbegin > 0 ) then
       do i = nbegin, nend
          ! looks strangle, but it's correct --
          ! records in header are moved up imediately following delete
          call fits_delete_record(fits,nbegin,status)
       end do
    end if

  end subroutine wcsremove

end module astrofits

!
! Procedures for handling of a dynamical (linked) list
!
!
!  Copyright © 2011,2014,2016-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

Module LibList

  use fitsio

  implicit none

  type ImageType
     integer :: i
     real :: mean,stderr,stdsig,exptime,temp,saturate
     real,  pointer :: image(:,:), noise(:,:)
     character(len=FLEN_VALUE) :: dateobs, filter
     character(len=FLEN_FILENAME) :: filename
     type( ImageType ), pointer :: next
  end type ImageType

contains !---------------------------------------------------------------

  subroutine InitList(list)

    ! Initialize a new list

    type(Imagetype), pointer :: list

    nullify(list)
    Allocate(list)
    nullify(list%next)
    list%i = 0

  end subroutine InitList

  Subroutine DestroyList(list)

    type(Imagetype), pointer :: list,c,d

    c => list%next
    do while (associated(c))
       d => c
       c => c%next
       if( associated(d%image) ) deallocate(d%image)
       if( associated(d%noise) ) deallocate(d%noise)
       deallocate(d)
    end do
    deallocate(list)
    nullify(list)

  end Subroutine DestroyList

  !-------------------------------------------------------------------------

  Subroutine AddItem (current,image,filename,noise,mean,stderr,stdsig,&
       dateobs,exptime,filter,temp,satur)

    type(Imagetype), pointer :: current
    real, dimension(:,:), optional, pointer :: image, noise
    real, optional, intent(in) :: mean, stderr, stdsig, exptime, temp, satur
    character(len=*), optional, intent(in) :: filename,dateobs, filter
    integer :: i

    i = current%i + 1
    Allocate( current%next )
    nullify( current%next%next )
    current => current%next
    current%i = i
    if( present(image) ) then
       current%image => image
    else
       nullify(current%image)
    end if
    if( present(noise) ) then
       current%noise => noise
    else
       nullify(current%noise)
    end if
    if( present(filename) ) current%filename = filename
    if( present(mean) ) current%mean = mean
    if( present(stderr) ) current%stderr = stderr
    if( present(stdsig) ) current%stdsig = stdsig
    if( present(dateobs) ) current%dateobs = dateobs
    if( present(filter) ) current%filter = filter
    if( present(exptime) ) current%exptime = exptime
    if( present(temp) ) current%temp = temp
    if( present(satur) ) current%saturate = satur

  end subroutine AddItem

  ! -----------------------------------------------------------------------

  subroutine GetItem(current,image,noise,filename,mean,stderr,stdsig, &
       dateobs,exptime,filter,temp, satur)

    type(Imagetype) :: current
    real, dimension(:,:), optional, pointer :: image, noise
    real, optional, intent(out) :: mean,stderr,stdsig,exptime,temp,satur
    character(len=*), optional, intent(out) :: filename,dateobs,filter

    if( present(image) ) image => current%image
    if( present(noise) ) noise => current%noise
    if( present(filename) ) filename = current%filename
    if( present(mean) ) mean = current%mean
    if( present(stderr) ) stderr = current%stderr
    if( present(stdsig) ) stdsig = current%stdsig
    if( present(dateobs) ) dateobs = current%dateobs
    if( present(exptime) ) exptime = current%exptime
    if( present(filter) ) filter = current%filter
    if( present(temp) ) temp = current%temp
    if( present(satur) ) satur = current%saturate

  end subroutine GetItem

  ! ------------------------------------------------------------------------


  Subroutine GetImage(first, n, image, noise)

    type(Imagetype), pointer :: first, current
    integer, intent(in) :: n
    real, dimension(:,:), pointer :: image
    real, dimension(:,:), pointer, optional :: noise

    current => first
    do while ( associated( current ))
       if( current%i == n ) then
          image => current%image
          if( present(noise) ) noise => current%noise
          return
       endif
       current => current%next
    enddo

  end subroutine GetImage

  !----------------------------------------------------------------------

  Subroutine PutImage( first, n, image, noise)

    type(Imagetype), pointer :: first, current
    integer, intent(in) :: n
    real, dimension(:,:), pointer :: image
    real, dimension(:,:), pointer, optional :: noise

    current => first
    do while ( associated( current ))
       if( current%i == n ) then
          current%image => image
          if( present(noise) ) then
             current%noise = noise
          else
             nullify(current%noise)
          end if
          return
       endif
       current => current%next
    enddo

  end subroutine PutImage

  ! ---------------------------------------------------------------------

  function GetNext(current)

    type(Imagetype), pointer :: current, GetNext

    GetNext => current%next

  end function GetNext


  ! ----------------------------------------------------------------------

  function GetNo(current)

    type(Imagetype) :: current
    integer :: getno

    getno = current%i

  end function GetNo

  ! -----------------------------------------------------------------------

  subroutine GetSky(current, mean, stderr)

    type(Imagetype) :: current
    real, intent(out) :: mean, stderr

    mean = current%mean
    stderr = current%stderr

  end subroutine GetSky

  ! ---------------------------------------------------------------------

  Subroutine GetPar ( first, n, mean, stderr)

    type(Imagetype),pointer :: first, current
    integer, intent(in) :: n
    real, intent(out) :: mean, stderr

    current => first
    do while ( associated( current ))
       if( current%i == n ) then
          mean = current%mean
          stderr = current%stderr
          return
       endif
       current => current%next
    enddo

  end subroutine GetPar

  ! ------------------------------------------------------------------------

  Subroutine PutPar (first, n, mean, stderr)

    type(Imagetype),pointer :: first, current
    integer, intent(in) :: n
    real, intent(in) :: mean, stderr

    current => first
    do while ( associated( current ))
       if( current%i == n ) then
          current%mean = mean
          current%stderr = stderr
          return
       endif
       current => current%next
    enddo

  end subroutine PutPar

  subroutine SetItem(current,array,filename,mean,stderr,stdsig, &
       dateobs,exptime,filter,temp,satur)

    type(Imagetype) :: current
    real, dimension(:,:), optional, pointer :: array
    real, optional, intent(in) :: mean,stderr,stdsig,exptime,temp,satur
    character(len=*), optional, intent(in) :: filename,dateobs,filter

    if( present(array) )    current%image => array
    if( present(filename) ) current%filename  = filename
    if( present(mean) )     current%mean = mean
    if( present(stderr) )   current%stderr= stderr
    if( present(stdsig) )   current%stdsig= stdsig
    if( present(dateobs) )  current%dateobs = dateobs
    if( present(exptime) )  current%exptime = exptime
    if( present(filter) )   current%filter = filter
    if( present(temp) )     current%temp = temp
    if( present(satur) )    current%saturate = satur

  end subroutine SetItem

end module LibList

!
! gfortran -Wall testrfun.f95 -L. -lrstat -lm
!

program testrfun

  use rfun

  implicit none

  integer, parameter :: rp = selected_real_kind(15)

  integer :: i
  real(rp) :: x

  do i = -100,100
     x = i/10.0
!     write(*,*) x,huber(x),dhuber(x),hampel(x),dhampel(x),andrews(x),dandrews(x), &
!          tukey(x),dtukey(x)
     write(*,*) x,dhuber(x),(huber(x+0.1)-huber(x-0.1))/0.2, &
          dhampel(x),(hampel(x+0.1)-hampel(x-0.1))/0.2,&
          dandrews(x),(andrews(x+0.1)-andrews(x-0.1))/0.2,&
          dtukey(x),(tukey(x+0.1)-tukey(x-0.1))/0.2
  end do

end program testrfun

!
!  Light curve parameters by FITS files
!
!
!  Copyright © 2017-20 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!


module lcio

  use iso_fortran_env

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

contains

  subroutine lcimport(tablename,time,flux,dflux)

    use titsio

    character(len=*), intent(in) :: tablename
    real(dbl), dimension(:), allocatable, intent(out) :: time,flux,dflux

    real(dbl), parameter :: nullval = 0.0_dbl

    integer :: nrows, srows, status, i, l, frow
    real(dbl), dimension(:), allocatable :: mag, dmag
    character(len=FLEN_CARD) :: qname
    logical :: anyf, mags, check
    type(fitsfiles) :: fits

    status = 0

    ! open and move to a table extension
    call fits_open_table(fits,tablename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read a table in the file `',trim(tablename),"'."
       stop 'LCIO'
    end if

    call fits_get_num_rows(fits,nrows,status)
    if( status /= 0 ) goto 666
    if( nrows == 0 ) stop 'lcio: There is no timeseries.'

    ! read options, name of second column is used to identify the quantity
    call fits_read_key(fits,'TTYPE2',qname,status)
    mags = index(qname,'MAG') > 0

    allocate(time(nrows),flux(nrows),dflux(nrows))
    if( mags ) then
       allocate(mag(nrows),dmag(nrows))
    end if

    call fits_get_rowsize(fits,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_read_col(fits,1,frow,nullval,time(i:l),anyf,status)

       if( mags ) then
          call fits_read_col(fits,2,frow,nullval,mag(i:l),anyf,status)
          call fits_read_col(fits,3,frow,nullval,dmag(i:l),anyf,status)
       else
          call fits_read_col(fits,2,frow,nullval,flux(i:l),anyf,status)
          call fits_read_col(fits,3,frow,nullval,dflux(i:l),anyf,status)
       end if

       if( status /= 0 ) goto 666
    end do

    if( mags ) then
       flux = 10**(-0.4*mag)
       dflux = (dmag/mag)*flux
       deallocate(mag,dmag)
    end if

    check = .false.
    do i = 2, size(time)
       if( time(i) < time(i-1) ) check = .true.
    end do
    if( check ) write(error_unit,*) "Warning: Time sequence is no increasing."

    call fits_close_file(fits,status)
    return

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    if( allocated(time) ) deallocate(time,flux,dflux)
    if( allocated(mag) ) deallocate(mag,dmag)

    stop 'LCIO'

  end subroutine lcimport


  subroutine lcfourio(tablename,c)

    use fitsio

    character(len=*), intent(in) :: tablename
    complex(dbl), dimension(:), allocatable, intent(out) :: c

    real(dbl), parameter :: nullval = 0.0_dbl

    integer :: nrows, srows, status, frow, i, l
    real(dbl), dimension(:), allocatable :: a,b
    logical :: anyf
    type(fitsfiles) :: fits

    status = 0

    ! open and move to a table extension
    call fits_open_table(fits,tablename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read a table in the file `',trim(tablename),"'."
       stop 'FOURIO'
    end if

    call fits_get_num_rows(fits,nrows,status)
    if( status /= 0 ) goto 666

    if( nrows == 0 ) stop 'lcio: There are no Fourier coefficients.'

    allocate(a(nrows),b(nrows),c(0:nrows-1))

    call fits_get_rowsize(fits,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_read_col(fits,1,frow,nullval,a(i:l),anyf,status)
       call fits_read_col(fits,2,frow,nullval,b(i:l),anyf,status)
       if( status /= 0 ) goto 666
    end do

    c = cmplx(a,b,dbl)
    deallocate(a,b)

    call fits_close_file(fits,status)
    return

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    if( allocated(a) ) deallocate(a,b,c)

    stop 'FOURIO'


  end subroutine lcfourio

end module lcio

!
!  transformation of an instrumental to standard photometry system
!
!  Copyright © 2013-5, 2017 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!
! Additional work:
!
!  * implement Pending function in analytical derivations, derfcn
!  * solve problem of error estimation
!  * provide calibration informations (star identifications,...)
!  * try Augmented Lagrangian method
!  * try non-triagonal matrix
!  * generalize on non-square transformation matrix
!

module fotran

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter :: ci0 = 10**(-0.4*0.5)
  real(dbl), dimension(:,:), allocatable, private :: cts,dcts
  real(dbl), dimension(:,:), allocatable, private :: pht,dpht
  real(dbl), dimension(:), allocatable, private :: mad
  real(dbl), private :: lambda
  integer, private :: ncts, npht, ndat
  logical, private :: verbose

  private :: res,relerr,robfcn,medtri,derfcn,grouping

contains

  subroutine stdtra(pairs,xpht,xdpht,xcts,xdcts,tra,etra,verb)

    use oakleaf
    use robustplane

    integer, dimension(:,:), intent(in) :: pairs
    real(dbl), dimension(:,:), intent(in) :: xpht,xcts,xdpht,xdcts
    real(dbl), dimension(:,:), intent(out) :: tra,etra
    logical, intent(in) :: verb

    real(dbl),dimension(2) :: p,dp
    real(dbl),dimension(3) :: q,dq
    real(dbl),dimension(:), allocatable :: r,dr,u,du,v,dv
    real(dbl) :: sig
    integer :: i,j,k,l,n,m,ntriplets,ntwins,npairs,lref,info
    integer, dimension(size(pairs,1),2) :: twins
    integer, dimension(size(pairs,1),3) :: triplets
    integer, dimension(2) :: refpair

    npht = size(xpht,2)
    ncts = size(xcts,2)
    verbose = verb

    if( size(xpht,1) /= size(xcts,1) ) stop 'Dimensions pht /= cts.'
    if( size(xdpht,1) /= size(xpht,1) ) stop 'Dimensions pht /= dpht.'
    if( size(xdcts,1) /= size(xcts,1) ) stop 'Dimensions cts /= dcts.'

    ndat = size(xpht,1)
    npairs = size(pairs,1)

    if( .not. (ndat > 0) ) stop 'Data missing.'

    allocate(r(ndat),dr(ndat),pht(ndat,npht),dpht(ndat,npht), &
         cts(ndat,npht),dcts(ndat,npht),u(ndat),du(ndat),v(ndat),dv(ndat))
    pht = xpht
    dpht = xdpht
    cts = xcts
    dcts = xdcts

    if( verbose ) then
       write(*,*) 'Pairs indexes:'
       do k = 1,size(pairs,1)
          write(*,*) pairs(k,1),pairs(k,2)
       end do
    end if

    tra = 0.0_dbl
    etra = 0.0_dbl

    call grouping(pairs,ntriplets,triplets,ntwins,twins,lref,refpair)

    ! precise estimation from triplets
    do n = 1,ntriplets
       i = triplets(n,1)
       l = triplets(n,2)
       j = triplets(n,3)
       call ratio(cts(:,l),pht(:,l),dcts(:,l),dpht(:,l),r,dr)
       call ratio(pht(:,i),pht(:,l),dpht(:,i),dpht(:,l),u,du)
       call ratio(pht(:,j),pht(:,l),dpht(:,j),dpht(:,l),v,dv)
       u = u - ci0
       v = v - ci0
       q = (/ 1.0, 0.0, 0.0 /)
       dq = (/ 0.1, 0.01,0.01 /)
       call rplane(u,du,v,dv,r,dr,q,dq,sig,info)
       if( info == 0 ) then
          tra(l,l) = q(1) - ci0*(q(2) + q(3))
          tra(l,l-1) = q(2)
          tra(l,l+1) = q(3)
          etra(l,l-1:l+1) = dq
          if( verbose ) then
             write(*,*) 'triplet:',triplets(n,:)
             do k = 1,ndat
                write(*,'(5f10.5)') u(k),v(k),r(k),r(k) - (q(1) + q(2)*u(k) + q(3)*v(k))
             end do
             write(*,'(a,5f10.5)') 't-solution:',q
             write(*,'(a,6f10.5)') 't-errors:',dq,sig
          end if
       else
          stop 'No convergence occurred on a plane.'
       end if
    end do

    ! reference filter, if it is not already in some triplet
    if( .not. all( refpair == 0) ) then
       l = lref
       i = refpair(1)
       j = refpair(2)

       call ratio(pht(:,i),pht(:,j),dpht(:,i),dpht(:,j),u,du)
       call ratio(cts(:,l),pht(:,l),dcts(:,l),dpht(:,l),r,dr)
       u = u - ci0
       call rline(u,r,p(1),p(2),dp(1),dp(2),du,dr,sig)
       if( verbose ) then
          write(*,*) "Reference: ",i,j
          do k = 1,ndat
             write(*,'(5f10.5,1x,1pg0.3)') u(k),r(k),du(k),dr(k), &
                  r(k) - (p(1) + p(2)*u(k)),pht(k,l)
          end do
          write(*,'(a,5f10.5)') 'a-solution:',p,dp,sig
       end if
       tra(l,l) = p(1) - p(2)*ci0
       tra(l,i) = p(2)
       etra(l,l) = dp(1)
       etra(l,i) = dp(2)
    end if

    ! colour indexes
    l = pairs(1,1)
    do n = 1, ntwins
       i = twins(n,1)
       j = twins(n,2)

       call ratio(pht(:,i),pht(:,j),dpht(:,i),dpht(:,j),u,du)
       call ratio(cts(:,i),cts(:,j),dcts(:,i),dcts(:,j),r,dr)

       ! correction while previous line is a triplet
       m = 0
       do k = 1, ntriplets
          if( triplets(k,1) == i .and. triplets(k,2) == j ) then
             m = triplets(k,3)
             call ratio(pht(:,m),pht(:,j),dpht(:,m),dpht(:,j),v,dv)
          else if( triplets(k,2) == j .and. triplets(k,3) == i ) then
             m = triplets(k,1)
             call ratio(pht(:,m),pht(:,j),dpht(:,m),dpht(:,j),v,dv)
          end if
       end do

       u = u - ci0
       if( m == 0 ) then
          r = r * (1 + tra(j,i)/tra(j,j) * u + tra(j,i)/tra(j,j) * ci0)
       else
          r = r * (1 + tra(j,i)/tra(j,j) * u + tra(j,m)/tra(j,j) * (v - ci0) + &
               ci0*(tra(j,i) + tra(j,m))/tra(j,j))
       end if
       call rline(u,r,p(1),p(2),dp(1),dp(2),du,dr,sig)
       tra(i,i) = p(2) * tra(j,j)
       tra(i,j) = p(1) * tra(j,j) - tra(i,i)* ci0
       etra(i,i) = dp(2)
       etra(i,j) = dp(1)

       if( verbose ) then
          write(*,*) "Colour index: ",i,j
          call ratio(cts(:,i),cts(:,j),dcts(:,i),dcts(:,j),r,dr)
          do k = 1,ndat
             write(*,'(5f10.5,3(1x,1pg0.5))') u(k),r(k),du(k),dr(k), &
                  r(k) - tra(i,i)/tra(j,j)*(u(k) + tra(i,j)/tra(i,i) + ci0) / &
                  (1 + tra(j,i)/tra(j,j)*u(k) + tra(j,i)/tra(j,j)*ci0),pht(k,i),pht(k,j)
          end do
          write(*,'(a,5f10.5)') 'c-solution:',p,dp,sig
       end if

    end do

   deallocate(r,dr,pht,dpht,cts,dcts,u,du,v,dv)

  end subroutine stdtra


  subroutine fotra(t,pairs,cts,dcts,pht,dpht)

    integer, dimension(:,:), intent(in) :: pairs
    real(dbl), dimension(:,:), intent(in) :: t
    real(dbl), dimension(:), intent(in) :: cts,dcts
    real(dbl), dimension(:), intent(out) :: pht,dpht

    integer, dimension(size(pairs,1),2) :: twins
    integer, dimension(size(pairs,1),3) :: triplets
    integer, dimension(2) :: refpair
    real(dbl) :: ph,c
    integer:: i,j,k,l,n,m,ntriplets,ntwins,lref

    call grouping(pairs,ntriplets,triplets,ntwins,twins,lref,refpair)

    do n = 1,ntriplets
       i = triplets(n,1)
       l = triplets(n,2)
       j = triplets(n,3)
       if( cts(i) > 0 .and. cts(l) > 0 .and. cts(j) > 0 ) then
          ph = t(l,l) + ci0*(t(l,i) + t(l,j)) + &
               t(l,i)*(cts(i)/cts(l) - ci0) + t(l,j)*(cts(j)/cts(l) - ci0)
          pht(l) = ph * cts(l)
       else
          pht(l) = -1
       end if
       if( pht(l) > 0 .and. dcts(l) > 0 .and. cts(l) > 0 ) then
          dpht(l) = pht(l) * (dcts(l) / cts(l))
       else
          dpht(l) = -1
       end if
    end do

    ! reference
    if( .not. all( refpair == 0) ) then
       l = lref
       i = refpair(1)
       j = refpair(2)
       if( cts(i) > 0 .and. cts(j) > 0 ) then
          ph = t(l,l) + t(l,i) * ci0 + t(l,i)*(cts(i)/cts(j) - ci0)
          pht(l) = ph * cts(l)
          dpht(l) = pht(l) * (dcts(l) / cts(l))
       else
          pht(l) = -1
          dpht(l) = -1
       end if
    end if

    do n = 1,ntwins
       i = twins(n,1)
       j = twins(n,2)

       m = 0
       do k = 1, ntriplets
          if( triplets(k,1) == i .and. triplets(k,2) == j ) then
             m = triplets(k,3)
          else if( triplets(k,2) == j .and. triplets(k,3) == i ) then
             m = triplets(k,1)
          end if
       end do

       if( cts(i) > 0 .and. cts(j) > 0 .and. pht(j) > 0 ) then
          c = cts(i)/cts(j) - ci0
          if( m == 0 ) then
             ph = t(i,i) / t(j,j) * (c + t(i,j)/t(i,i) + ci0) / &
                  (1 + t(j,i)/t(j,j)*ci0 + t(j,i)/t(j,j)*c)
          else
             ph = t(i,i) / t(j,j) * (c + t(i,j)/t(i,i) + ci0) / &
                  (1 + t(j,i)/t(j,j) * c + t(j,m)/t(j,j) * (cts(m)/cts(j) - ci0) + &
                  ci0*(t(j,i) + t(j,m))/t(j,j))
          end if
          pht(i) = ph * pht(j)
          dpht(i) = pht(i) * (dcts(j) / cts(j))
       else
          pht(i) = -1
          dpht(i) = -1
       end if
    end do

!    return

!!$    n = size(ctph0)
!!$    allocate(tra(n,n),ctph(n))
!!$    call traex(pairs,tra0,ctph0,tra)
!!$    ctph = 1.0_dbl
!!$
!!$    npht = size(cts)
!!$    allocate(ctc(npht-1))
!!$    do i = 2,npht
!!$       k = pairs(i,1)
!!$       l = pairs(i,2)
!!$       if( cts(l) > epsilon(cts) .and. cts(k) > epsilon(cts) ) then
!!$          ctc(i-1) = (ctph(k)* cts(k)) / (ctph(l) * cts(l))
!!$       else
!!$          ctc(i-1) = 0
!!$       end if
!!$    end do
!!$
!!$    k = pairs(1,1)
!!$    l = pairs(1,2)
!!$    if( cts(k) > epsilon(cts) ) then
!!$       pht(k) = ctph(k) * cts(k) * (tra(1,1) + tra(1,2)*ctc(1))
!!$       dpht(k) = (dcts(k)/cts(k))* pht(k)
!!$    else
!!$       pht = -1
!!$       dpht = -1
!!$       goto 666
!!$    end if
!!$    down = .true.
!!$    do i = 2,npht
!!$       k = pairs(i,1)
!!$       l = pairs(i,2)
!!$       if( k == pairs(1,1) ) down = .false.
!!$       if( down ) then
!!$          if( pht(l) > epsilon(pht) .and. cts(l) > epsilon(cts) ) then
!!$!             write(*,*) pht(l),tra(i,1),tra(i,2),ctc(i-1)
!!$             pht(k)  = pht(l) * (tra(i,1) + tra(i,2)*ctc(i-1))
!!$             dpht(k) = (dcts(l) / cts(l)) * pht(k)
!!$          else
!!$             pht(k) = -1
!!$             dpht(k) = -1
!!$          end if
!!$       else
!!$          if( pht(k) > epsilon(pht) .and. cts(k) > epsilon(cts) .and. &
!!$               abs(tra(i,1) + tra(i,2)*ctc(i-1)) > epsilon(ctc) ) then
!!$             pht(l)  = pht(k) / (tra(i,1) + tra(i,2)*ctc(i-1))
!!$             dpht(l) = (dcts(k) / cts(k)) * pht(l)
!!$          else
!!$             pht(l) = -1
!!$             dpht(l) = -1
!!$          end if
!!$       end if
!!$    end do
!!$
!!$    where( pht < 0 )
!!$       pht = -1
!!$       dpht = -1
!!$    end where
!!$
!!$666 continue
!!$    deallocate(ctc,ctph,tra)

  end subroutine fotra




  subroutine ratio(x,y,dx,dy,r,dr)

    real(dbl), dimension(:), intent(in) :: x,y,dx,dy
    real(dbl), dimension(:), intent(out) :: r,dr

    where( abs(x) > epsilon(dx) .and. abs(y) > epsilon(dy))
       r = x / y
       dr = abs(r)*sqrt((dx/x)**2 + (dy/y)**2)
    elsewhere
       r = 0
       dr = huge(dr)
    end where

  end subroutine ratio


  subroutine grouping(pairs,ntriplets,triplets,ntwins,twins,lref,refpair)

    integer, dimension(:,:), intent(in) :: pairs
    integer, dimension(:,:), intent(out) :: triplets, twins
    integer, dimension(:), intent(out) :: refpair
    integer, intent(out) :: ntriplets, ntwins, lref

    integer :: i,j,n,npairs
    logical :: found, reference

    npairs = size(pairs,1)

    ! form triplets
    ntriplets = 0
    triplets = 0
    do i = 2, npairs
       triplets(ntriplets+1,1:2) = pairs(i,:)
       do j = 2, npairs
          if( triplets(ntriplets+1,2) == pairs(j,1) ) then
             ntriplets = ntriplets + 1
             triplets(ntriplets,3) = pairs(j,2)
          end if
       end do
    end do

    ! form twins
    ntwins = 0
    twins = 0
    do i = 2, npairs
       ntwins = ntwins + 1
       twins(ntwins,:) = pairs(i,:)
       found = .false.
       do j = 2, npairs
          if( pairs(j,1) == twins(ntwins,2) ) found = .true.
       end do
       if( found ) ntwins = ntwins - 1
    end do
    do i = 2, npairs
       ntwins = ntwins + 1
       twins(ntwins,:) = pairs(i,:)
       found = .false.
       do j = 2, npairs
          if( pairs(j,2) == twins(ntwins,1) ) found = .true.
       end do
       do j = 1, ntwins-1
          if( all(twins(j,:) == twins(ntwins,:)) ) found = .true.
       end do
       if( found ) ntwins = ntwins - 1
    end do

    ! reference filter, if it is not already in some triplet
    reference = .true.
    do i = 1,ntriplets
       if( any(pairs(1,1) == triplets(i,:)) ) reference = .false.
    end do
    ! reference = ntriplets > 0

    refpair = 0
    lref = pairs(1,1)
    if( reference ) then
       do n = 2, npairs
          if( pairs(n,1) < lref ) then
             i = pairs(n,1)
             j = pairs(n,2)
          else if( pairs(n,2) > lref ) then
             i = pairs(n,2)
             j = pairs(n,1)
          end if
          if( j == lref  )then
             refpair = (/i,j/)
          end if
          if( i == lref .and. all(refpair == 0) ) then
             refpair = (/i,j/)
          end if
       end do

    end if

    do n = 1, ntwins
       if( twins(n,1) < lref ) then
          i = twins(n,1)
          j = twins(n,2)
       else if( twins(n,2) > lref ) then
          i = twins(n,2)
          j = twins(n,1)
       end if
       twins(n,:) = (/i,j/)
    end do

  end subroutine grouping


  subroutine tratri(xpht,xdpht,xcts,xdcts,tratab,verb)

    use NelderMead
    use minpack
    use minpacks
    use oakleaf

    integer :: npar
    real(dbl), dimension(:,:), target, intent(in) :: xpht,xcts,xdpht,xdcts
    real(dbl), dimension(:,:), allocatable, intent(out) :: tratab
    logical, intent(in) :: verb

    real(dbl),dimension(:), allocatable :: p,p0,dp
    real(dbl),dimension(:,:), allocatable :: t,dt,r,relp,fjac,cov
    real(dbl) :: s0,reqmin,sum1,sum2,w,med, rms
    integer :: icount, numres, ifault, info, nprint, it, i, j, n
    character(len=80) :: tfmt,rfmt,resfmt,trfmt


    ! BIG WARNING!
!    pht => xpht
!    cts => xcts
!    dpht => xdpht
!    dcts => xdcts
    npht = size(pht,2)
    ncts = size(cts,2)
    verbose = verb

    if( size(pht,1) /= size(cts,1) ) stop 'Dimensions pht /= cts.'
    if( size(dpht,1) /= size(pht,1) ) stop 'Dimensions pht /= dpht.'
    if( size(dcts,1) /= size(cts,1) ) stop 'Dimensions cts /= dcts.'

    ndat = size(pht,1)

    if( .not. (ndat > 0) ) stop 'Data missing.'

    if( verbose ) then
       write(*,*) "=> Initial data:"
       write(tfmt,'(a,i0,a,i0,a)') '(i5,',npht,'g12.5,',npht,'g12.5)'
       do j = 1,size(pht,1)
          write(*,tfmt) j,pht(j,:),cts(j,:)
       end do
    end if

    write(tfmt,'(a,i0,a)') '(',npht,'f15.6)'
    write(rfmt,'(a,i0,a,i0,a,i0,a)') '(',2*(npht-1),'g12.5,',npht,'f9.5,',npht,'f10.5)'
!    write(*,*) trim(rfmt)

    npar = npht*ncts
    allocate(t(ncts,npht),dt(ncts,npht),r(ndat,ncts),relp(ndat,ncts))

    r = pht / cts

    if( verbose ) then
       write(*,*) "=> Ratios:"
       write(trfmt,'(a,i0,a)') '(i5,',npht,'g12.5)'
       do j = 1,size(pht,1)
          write(*,trfmt) j,r(j,:)
       end do
    end if

    t = 0
    dt = epsilon(dt)
    dt = 0
    do i = 1,ncts
       call qmean(r(:,i),t(i,i),dt(i,i))
       dt(i,i) = dt(i,i) / sqrt(real(ndat))
    end do

    if( verbose ) then
       write(*,*) "=> Initial estimation of diagonal:"
       do i = 1,ncts
          write(*,'(i5,1x,g0.5,a,g0.5)') i,t(i,i)," +- ",dt(i,i)
       end do
    end if

!    do i = 1,ncts
!       do j = 1,npht
!          if( i /= j ) t(i,j) = -(dt(i,i)/t(i,i) + dt(j,j)/t(j,j))*(t(i,i) + t(j,j))/4
!       end do
!    end do


    ! bootstrap for robust method
    allocate(p(npar),p0(npar),dp(npar))
    p = pack(t,.true.)

    if( verbose ) then
       write(*,*) "=> Estimation minimizing of absolute deviations: ndat=",ndat
       write(*,*) " # status      mean deviation    lambda   evaluations"
    end if

    lambda = sum(abs(p))/npar
    reqmin = epsilon(reqmin)
    s0 = huge(s0)
    do it = 1,1!00

       n = 0
       do i = 1,ncts
          do j = 1,npht
             n = n + 1
             dp(n) = max(dt(i,i),dt(j,j),epsilon(1.0))*(-1.0)**(i+j)
          end do
       end do

       p0 = p
       call nelmin(medtri,npar,p0,p,rms,reqmin,dp,1,1000000,icount,numres,ifault)
       t = reshape(p,(/ncts,npht/))

       if( verbose ) then
          write(*,'(i3,i5,g15.5,g10.3,i10)') it,ifault,rms,lambda,icount
          write(*,tfmt) (t(i,:),i=1,ncts)
       end if

       if( abs(rms - s0) < 0.001 ) exit

       lambda = 10*lambda
       s0 = rms

    enddo

    allocate(mad(ncts))

    call res(t,r)
    r = abs(r)
    do j = 1,size(r,2)
       call qmean(r(:,i),mad(j))
       mad(j) = mad(j) / sqrt(real(ndat))
    end do

    if( verbose ) then
       write(*,*) "=> Estimation of scale:"
       write(*,tfmt) mad
    end if

    if( verbose ) then
       write(*,*) "   Residuals       .... relative precision  "
       write(resfmt,'(a,i0,a,i0,a)') '(i5,',npht,'g13.5,',npht,'f10.5)'
       call relerr(t,relp)
       do i = 1,size(r,1)
          write(*,resfmt) i,r(i,:),relp(i,:)
       end do
    end if

    allocate(fjac(npar,npar),cov(npar,npar))

    if( verbose ) then
       nprint = 1
    else
       nprint = 0
    end if

    lambda = sum(abs(p))
    do j = 1,7
       call lmdif2(robfcn,p,epsilon(p),nprint,info)
       lambda = 10*lambda
    end do
    call lmder2(derfcn,p,epsilon(p),nprint,info)

    t = reshape(p,(/ncts,npht/))

    ! residual sum
    ! compute jac !!!
    call qrinv(fjac,cov)

    call res(t,r)
    do j = 1,ncts

       sum1 = 0
       sum2 = 0
       do i = 1, ndat
          w = r(i,j)/mad(j)
          sum1 = sum1 + huber(w)**2
          sum2 = sum2 + dhuber(w)
       end do
       s0 = mad(j)**2*sum1/sum2**2*ndat**2
       rms = sqrt(s0 / (ndat - npar))

       n = 0
       do i = 1, npht
          n = n + 1
          dt(j,i) = sqrt(s0*cov(n,n)/(ndat - npar))
       end do

    enddo

    if( verbose ) then
       write(*,*) "   Residuals       .... relative precision  "
       write(resfmt,'(a,i0,a,i0,a)') '(i5,',npht,'g13.5,',npht,'f10.5)'
       call relerr(t,relp)
       do i = 1,size(r,1)
          write(*,resfmt) i,r(i,:),relp(i,:)
       end do
    end if

    if( verbose ) then
       write(*,*) "=> Robust estimation:"
       write(*,*) ' info=',info
       write(*,*) " Laplace's multiplicator=",lambda
       write(*,*) " Jacobian in minimum:"
       write(*,*) " RMS=",rms

       write(*,*) " Matrix of Transformations:"
       write(*,tfmt) (t(i,:),i=1,ncts)

       write(*,*) " Errors of Matrix of Transformation:"
       write(*,tfmt) (dt(i,:),i=1,ncts)

       if( size(pht,2) > 1 ) then
          write(*,*) " Band ratios (catalogue, instrumental)  Ratios  Relative precision:"
          call relerr(t,relp)
          do i = 1,ndat
             write(*,rfmt) (pht(i,j-1)/pht(i,j),j=2,size(pht,2)), &
                  (cts(i,j-1)/cts(i,j),j=2,size(pht,2)),pht(i,:)/cts(i,:),relp(i,:)
          end do

          do i = 1,ndat
             write(*,*) (pht(i,j-1)/pht(i,j),j=2,size(pht,2)), &
                  (cts(i,j-1)/cts(i,j),j=2,size(pht,2)),&
                  pht(i,:),cts(i,:),cts(i,:)/pht(i,:)
          end do
       end if

    end if

    allocate(tratab(ncts,npht))
    tratab = t

    deallocate(t,dt,p,p0,dp,r,relp,mad,fjac,cov)

  end subroutine tratri

  subroutine res(t,r)

    real(dbl), dimension(:,:), intent(in) :: t
    real(dbl), dimension(:,:), intent(out) :: r
    real(dbl) :: x,d
    integer :: i,n

    do n = 1, ndat
       do i = 1,npht
          x = sum(t(i,:)*cts(n,:))
          d = sqrt(dpht(n,i)**2 + sum(t(i,:)**2 * dcts(n,:)**2))
          r(n,i) = (pht(n,i) - x)/d
       end do
    end do

  end subroutine res

  subroutine relerr(t,r)

    real(dbl), dimension(:,:), intent(in) :: t
    real(dbl), dimension(:,:), intent(out) :: r
    real(dbl) :: x
    integer :: i,n

    do n = 1, ndat
       do i = 1,npht
          x = sum(t(i,:)*cts(n,:))
          r(n,i) = (pht(n,i) - x)/((pht(n,i) + x)/2)
       end do
    end do

  end subroutine relerr

  subroutine robfcn(m,np,p,fvec,iflag)

    use oakleaf

    integer, intent(in) :: m,np
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(:,:), allocatable :: t,r,fv
    real(dbl) :: rp,ss,x,d
    integer :: npar,n,i,j

!    if( iflag == 0 .and. verbose ) write(*,*) '#robfcn:',real(p)

    npar = ncts*npht
    allocate(t(ncts,npht),fv(ncts,npht),r(ndat,ncts))
    fv = 0.0_dbl
    t = reshape(p,(/ncts,npht/))

    call res(t,r)

    do n = 1, ndat

       do i = 1,npht
          x = sum(t(i,:)*cts(n,:))
          d = sqrt(sum(t(i,:)**2 * dcts(n,:)**2) + dpht(n,i)**2)
          rp = huber(r(n,i)/mad(i))
          fv(i,:) = fv(i,:) - rp*(cts(n,i)/(d*mad(i)))
       end do
    end do

    ss = 0.0_dbl
    do j = 1,ncts
       do i = 1,npht
          if( abs(i-j) > 1 ) then
             fv(i,j) = fv(i,j) + lambda*t(i,j)**2
          end if
       end do
    end do

    fvec = pack(fv,.true.)

    deallocate(t,fv,r)

  end subroutine robfcn


  subroutine derfcn(m,np,p,fvec,fjac,ldfjac,iflag)

    use oakleaf

    integer, intent(in) :: m,np,ldfjac
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
    real(dbl), dimension(:,:), allocatable :: t,r,fv
    real(dbl) :: rp,x,d,u
    integer :: npar,n,i,j

    npar = ncts*npht
    allocate(t(ncts,npht),r(ndat,ncts))
    t = reshape(p,(/ncts,npht/))
    call res(t,r)

    if( iflag == 1 ) then

       allocate(fv(ncts,npht))
       fv = 0

       do n = 1, ndat

          do i = 1,npht
             x = sum(t(i,:)*cts(n,:))
             d = sqrt(sum(t(i,:)**2 * dcts(n,:)**2) + dpht(n,i)**2)
             rp = huber(r(n,i)/mad(i))
             fv(i,:) = fv(i,:) - rp*(cts(n,i)/(d*mad(i)))
          end do
       end do

       fvec = pack(fv,.true.)
       deallocate(fv)

    else if( iflag == 2 ) then

       fjac = 0
       do n = 1, ndat

          do i = 1,ncts
             x = sum(t(i,:)*cts(n,:))
             d = sqrt(sum(t(i,:)**2 * dcts(n,:)**2) + dpht(n,i)**2)
             rp = dhuber(r(n,i)/mad(i))
             u = rp/(d*mad(i))**2
             do j = 1,npht
                fjac(i,j) = fjac(i,j) + u*cts(n,i)*cts(n,j)
             end do
          end do
       end do


    end if

    deallocate(t,r)

  end subroutine derfcn


  function medtri(p) result(s)

    real(dbl), dimension(:), intent(in) :: p
    real(dbl), dimension(:,:), allocatable :: t,r
    real(dbl) :: s,ss
    integer :: i,j

    allocate(r(ndat,ncts),t(ncts,npht))
    t = reshape(p,(/ncts,npht/))

    call res(t,r)
    s = sum(abs(r))/size(r)

    ss = 0
    do i = 1,ncts
       do j = 1,npht
          if( abs(i-j) > 1 ) then
             ss = ss + abs(t(i,j))
          end if
       end do
    end do

    s = s + lambda *ss

    deallocate(r,t)

  end function medtri


  subroutine trainv(pairs,tra,tra1)

    use minpacks

    integer, dimension(:,:), intent(in) :: pairs
    real(dbl), dimension(:,:), intent(in) :: tra
    real(dbl), dimension(:,:), intent(out) :: tra1
    real(dbl), dimension(size(tra,1),size(tra,1)) :: a,b
    real(dbl) :: det
    integer :: n

!    write(*,*) tra(1,:)
!    write(*,*) tra(2,:)


    call traconv(pairs,tra,a)

!    write(*,*) a(1,:)
!    write(*,*) a(2,:)

    do n = 1,size(tra,1)
       write(*,'(10f10.5)') a(n,:)
    end do

    n = size(a,1)
    if( n == 1 ) then
       b(1,1) = 1.0_dbl / a(1,1)
    else if( n == -2 ) then

       det = a(1,1)*a(2,2) - a(1,2)*a(2,1)
       b(1,:) = (/  a(2,2),-a(1,2) /) / det
       b(2,:) = (/ -a(2,1), a(1,1) /) / det

    else

       call qrinv(a,b)

    end if

    do n = 1,size(tra,1)
       write(*,'(10f10.5)') b(n,:)
    end do


!    write(*,*) b(1,:)
!    write(*,*) b(2,:)

    call traiconv(pairs,b,tra1)

!    write(*,*) tra1(1,:)
!    write(*,*) tra1(2,:)

    do n = 1,size(tra1,1)
       write(*,'(10f10.5)') tra1(n,1:2)
    end do

!    stop

  end subroutine trainv

  subroutine traconv(pairs,tra,a)

    integer, dimension(:,:), intent(in) :: pairs
    real(dbl), dimension(:,:), intent(in) :: tra
    real(dbl), dimension(:,:), intent(out) :: a
    integer :: n,i,k,l
    logical :: down

    n = size(tra,1)
    if( n == 1 ) then
       a(1,1) = tra(1,1)
    else if ( n == -2 ) then
       a(1,1) = tra(1,1)
       a(1,2) = tra(1,2)
       a(2,1) = tra(2,1)*a(1,2)
       a(2,2) = a(1,1)*tra(2,2) + tra(2,1)*a(1,2)
    else
       a = 0.0_dbl
       k = pairs(1,1)
       l = pairs(2,1)
       a(k,k) = tra(1,1)
       a(k,l) = tra(1,2)
       down = .true.
       do i = 2, n
          k = pairs(i,1)
          l = pairs(i,2)
          if( k == pairs(1,1) ) down = .false.
!          write(*,*) k,l,down
          if( down ) then
             a(k,l) = tra(i,1)*a(l,l)
             a(k,k) = a(l,l)*tra(i,2) + a(k,l)*a(l,k)/a(l,l)
          else
             a(k,l) = tra(i,1)*a(k,k)
             a(l,l) = a(k,k)*tra(i,2) + a(k,l)*a(l,k)/a(k,k)
!             a(k,i-1) = tra(i,1)*a(i-1,i-1)
!             a(k,i) = a(i-1,i-1)*tra(i,2) + tra(i,1)*a(i-1,i)
          end if
       end do
    end if

  end subroutine traconv

  subroutine traiconv(pairs,b,tra)

    integer, dimension(:,:), intent(in) :: pairs
    real(dbl), dimension(:,:), intent(in) :: b
    real(dbl), dimension(:,:), intent(out) :: tra
    integer :: n,i,k,l
    logical :: down

    n = size(b,1)
    if( n == 1 ) then
       tra(1,1) = b(1,1)
    else if( n == -2 ) then
       tra(1,1) = b(1,1)
       tra(1,2) = b(1,2)
       tra(2,1) = b(2,1)*tra(1,1)
       tra(2,2) = b(2,2)/tra(1,1) - b(2,1)*tra(1,2)/tra(1,1)**2
    else
       tra = 0.0_dbl
!       tra(1,1:2) = b(1,1:2)
       k = pairs(1,1)
       l = pairs(2,1)
       tra(1,1) = b(k,k)
       tra(1,2) = b(k,l)
       down = .true.
       do i = 2,n
          k = pairs(i,1)
          l = pairs(i,2)
          if( k == pairs(1,1) ) down = .false.
          if( down ) then
             tra(i,1) = b(k,l)/b(l,l)
             tra(i,2) = b(k,k)/b(l,l) - b(k,l)*b(l,k)/b(l,l)**2
          else
             tra(i,1) = b(k,l) / b(k,k)
             tra(i,2) = b(l,l) / b(k,k) - b(k,l)*b(l,k)/b(k,k)**2
          end if
       end do
    end if

  end subroutine traiconv

  subroutine traex(pairs,tratab,t,tra)

    integer, dimension(:,:), intent(in) :: pairs
    real(dbl), dimension(:,:), intent(in) :: tratab
    real(dbl), dimension(:), intent(in) :: t
    real(dbl), dimension(:,:), intent(out) :: tra
    real(dbl), dimension(size(tra,1),size(tra,1)) :: tra1,tra2
    integer :: i

    tra2 = 0.0_dbl
    forall(i=1:size(t))
       tra2(i,i) = t(pairs(i,1))
    end forall
    call traconv(pairs,tratab,tra1)

!    write(*,*) tra1(1,1:2)
!    write(*,*) tra1(2,1:2)

    tra1 = matmul(tra1,tra2)
!    write(*,*) tra1(1,1:2)
!    write(*,*) tra1(2,1:2)
    call traiconv(pairs,tra1,tra)

  end subroutine traex


end module fotran

!
!  artificial frames
!
!  Copyright © 2016-9, 2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!
!  * The variable star part, implemented as a class, would by more classy.
!  * Checking proper combination of parameters during computations (to prevent
!    frames below horizon with atmosphere, negative values of radii, etc.)?
!  * Add galaxies (profiles as NFW, Hubble, King, spirals) or globular clusters
!    with Plummer? Fractals for nebulae?
!

program artificial

  use titsio
  use trajd
  use generator
  use lcurves
  use lcio
  use iso_fortran_env

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  real(dbl), parameter :: j2000 = 2451544.5_dbl

  character(len=4*FLEN_FILENAME) :: record,key,val,fmt
  character(len=FLEN_FILENAME) :: cat = '', galcat = '', phsystable = '', &
       phsystem = 'Johnson', file = 'artificial.fits', psffile = '', &
       filemask = 'artificial_???.fits'
  logical :: verbose = .false., plog = .false.
  integer, dimension(2) :: naxes = [ 666, 666 ]
  real(dbl), dimension(2) :: crpix = [ 333, 333 ]
  integer :: bitpix = -32
  integer :: nfiles = 0
  integer :: eq,n,i,l1,l2
  real(dbl) :: skymag = 21               ! mag per 1 sq. arcsec
  real(dbl), dimension(2) :: skygrad = [ 0,0 ]  ! mag per 1 sq. arcsec per pix
  integer :: maglim = 13
  real(dbl) :: exptime = 1, area = 1     ! 1 sec per 1 sq.meter, equiv. r=0.56m
  real(dbl) :: hwhm = 1                  ! in pixels
  real(dbl) :: eccentricity = 0          ! 0 (circle) .. 1 (line)
  real(dbl) :: inclination = 0           ! inclination of major semiaxis, degs
  real(dbl) :: airy = 0.1                ! Airy disk radius in pix for r=0.56m
  real(dbl) :: beta = 2                  ! Moffat exponent
  real(dbl) :: scale = 1.0 / 3600.0      ! 1 arcsex = 1 pix
  real(dbl) :: fov = 666. / 3600.0       ! field of view, used for scale setup
  real(dbl) :: angle = 0
  real(dbl) :: qefficiency = 1
  logical   :: noise = .true.            ! data has added noise componets
  real(dbl) :: extink = 0.1              ! extinction coefficient
  real(dbl) :: longitude = 0             ! geographic longitude
  real(dbl) :: latitude = 0              ! geographic latitude
  real(dbl) :: timestep = 60             ! time step in seconds
  real(dbl) :: jd = j2000                ! 2000-01-01T00:00:00
  real(dbl) :: year = 2000, month = 1, day = 1, hour = 0, minute = 0, sec = 0, r, d
  real(dbl), dimension(2) :: crval = 0
  real(dbl) :: lcmag = 15                ! lc magnitude
  real(dbl) :: ccmag = 15                ! current magnitude
  real(dbl) :: lcamp = 1                 ! lc amplitude
  real(dbl) :: lcjd0 = j2000             ! lc reference time
  real(dbl) :: lcper = 1                 ! lc period
  real(dbl), dimension(2) :: lcoo = 0    ! lc coordinates
  character(len=FLEN_VALUE) :: filter = 'V'
  character(len=FLEN_VALUE), dimension(5) :: labels = [ '','','','','' ]
  character(len=FLEN_VALUE) :: profile = 'SEEING'
  character(len=FLEN_VALUE) :: spread = 'AUTO'
  character(len=FLEN_VALUE) :: lcmodel = '', lctable = '', lcfourier = ''
  complex(dbl), dimension(:), allocatable :: fcoeff ! lc Fourier coefficients
  real(dbl), dimension(:), allocatable :: xcoo,ycoo,flux
  ! 'FFT' for FFT convolution, 'RANDOM' for random offset, 'AUTO' for 'RANDOM'
  ! of short exposures and 'TEST' for direct convolution
  type(SplineSerieType) :: lcspline
  logical :: atmosphere = .false.
  logical :: lcmode = .false.
  logical :: datetime_init = .false.
  logical :: lccoo_init = .false.

  do
     read(*,'(a)',end=20) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Malformed input record.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'PIPELOG' ) then

        read(val,*) plog

     else if( key == 'PSFFILE' ) then

        read(val,*) psffile

     else if( key == 'PROFILE' ) then

        read(val,*) profile

     else if( key == 'SPREAD' ) then

        read(val,*) spread

     else if( key == 'NAXES' ) then

        read(val,*) naxes

     else if( key == 'BITPIX' ) then

        read(val,*) bitpix

     else if( key == 'SKYMAG' ) then

        read(val,*) skymag

     else if( key == 'SKYGRADX' ) then

        read(val,*) skygrad(1)

     else if( key == 'SKYGRADY' ) then

        read(val,*) skygrad(2)

     else if( key == 'MAGLIM' ) then

        read(val,*) maglim

     else if( key == 'HWHM' ) then

        read(val,*) hwhm

     else if( key == 'ECCENTRICITY' ) then

        read(val,*) eccentricity
        if( .not. abs(eccentricity) < 1 ) stop 'Error: eccentricity >= 1.'

     else if( key == 'INCLINATION' ) then

        read(val,*) inclination

     else if( key == 'AIRY' ) then

        read(val,*) airy

     else if( key == 'BETA' ) then

        read(val,*) beta

     else if( key == 'FILTER' ) then

        read(val,*) filter

     else if( key == 'EXPTIME' ) then

        read(val,*) exptime

     else if( key == 'AREA' ) then

        read(val,*) area

     else if( key == 'QEFF' ) then

        read(val,*) qefficiency

     else if( key == 'EXTINK' ) then

        read(val,*) extink

     else if( key == 'FOV' ) then

        read(val,*) fov
        scale = fov / naxes(2)

     else if( key == 'DIAMETER' ) then

        read(val,*) d
        r = d / 2
        area = 3.14*r**2
        airy = 7e-2/r

     else if( key == 'ANGLE' ) then

        read(val,*) angle

     else if( key == 'SCALE' ) then

        read(val,*) scale

     else if( key == 'CRVAL' ) then

        read(val,*) crval

     else if( key == 'CAT' ) then

        read(val,*) cat

     else if( key == 'GALCAT' ) then

        read(val,*) galcat

     else if( key == 'COL_RA' ) then

        read(val,*) labels(1)

     else if( key == 'COL_DEC' ) then

        read(val,*) labels(3)

     else if( key == 'COL_PMRA' ) then

        read(val,*) labels(2)

     else if( key == 'COL_PMDEC' ) then

        read(val,*) labels(4)

     else if( key == 'COL_MAG' ) then

        read(val,*) labels(5)

     else if( key == 'PHSYSTABLE' ) then

        read(val,*) phsystable

     else if( key == 'PHOTSYS' ) then

        read(val,*) phsystem

     else if( key == 'GEOGRAPHIC' ) then

        read(val,*) longitude, latitude

     else if( key == 'TIMESTEP' ) then

        read(val,*) timestep

     else if( key == 'DATE' ) then

        read(val,*) year,month,day
        datetime_init = .true.

     else if( key == 'TIME' ) then

        read(val,*) hour,minute,sec
        datetime_init = .true.

     else if( key == 'ATMOSPHERE' ) then

        read(val,*) atmosphere

     else if( key == 'LCMODEL' ) then

        read(val,*) lcmodel

     else if( key == 'LCTABLE' ) then

        read(val,*) lctable

     else if( key == 'LCFOURIER' ) then

        read(val,*) lcfourier

     else if( key == 'LCMAG' ) then

        read(val,*) lcmag

     else if( key == 'LCAMP' ) then

        read(val,*) lcamp

     else if( key == 'LCJD0' ) then

        read(val,*) lcjd0

     else if( key == 'LCPER' ) then

        read(val,*) lcper

     else if( key == 'LCCOO' ) then

        read(val,*) lcoo
        lccoo_init = .true.

     else if( key == 'NOISE' ) then

        read(val,*) noise

     else if( key == 'NFILES' ) then

        read(val,*) nfiles

     else if( key == 'OUTPUT' ) then

        read(val,*) filemask

     end if

  end do

20 continue

  crpix = naxes / 2

  if( spread == 'AUTO' ) then
     if( exptime < 3 ) then
        spread = 'RANDOM'
     else
        spread = 'FFT'
     end if
  end if

  ! whatever LC is generated
  if( lcmodel /= '' .or. lctable /= '' .or. lcfourier /= '' ) lcmode = .true.

  if( lcmode ) then
     if( .not. lccoo_init ) lcoo = crval

     if( lctable /= '' ) then
        call lctable_init(lctable,lcspline)
     end if
     if( lcfourier /= '' ) then
        call lcfourio(lcfourier,fcoeff)
     end if

  end if

  ! stars
  if( cat /= '' ) then
     call catstars(cat,labels,scale,angle,crval,crpix,phsystable,phsystem, &
          filter,xcoo,ycoo,flux)
  else
     call genstars(maglim,naxes,xcoo,ycoo,flux)
  end if

  if( verbose ) then
     write(error_unit,*)
     write(error_unit,*) "LIST OF PARAMETERS"
     write(error_unit,*)
     if( psffile == '' ) then
        write(error_unit,*) "Point spread function (PSF): ",trim(profile)
        write(error_unit,*) "Seeing spread method: ",trim(spread)
        write(error_unit,'(a,f0.2)') " HWHM = ",hwhm
        write(error_unit,'(a,f0.3)') " Eccentricity = ",eccentricity
        write(error_unit,'(a,f0.1)') " Inclination = ",inclination
        if( profile == 'MOFFAT' ) then
           write(error_unit,'(a,f0.2)') " Moffat exponent (beta) = ",beta
        else if( profile == 'SEEING' ) then
           write(error_unit,'(a,f0.2)') " Airy disk radius (airy) = ",airy
        end if
     else
        write(error_unit,*) 'PSF by file: ',trim(psffile)
     end if
     write(error_unit,'(a,f0.2)') " Quantum efficiency = ",qefficiency
     write(error_unit,*) "Photometry system: ",trim(phsystem)
     write(error_unit,*) "Filter: ",trim(filter)
     write(error_unit,*) "Atmosphere modelling: ",atmosphere
     if( atmosphere ) then
        write(error_unit,'(a,f0.2)') " Extinction coefficient = ",extink
     end if
     write(error_unit,'(a,f0.1,a)') " Sky magnitude = ",skymag," mag/arcsec2"
     write(error_unit,'(a,2(g0.2,2x),a)') &
          " Sky gradient = ",skygrad," mag/arcsec2/pix"
     write(error_unit,'(a,f0.2,a)') " Area = ",area," [m2]"
     write(error_unit,'(a,f0.1,a)') " Exposure time = ",exptime," [s]"
     write(error_unit,'(a,f0.1,a)') " Time span = ",timestep," [s]"
     write(error_unit,'(a,i4.4,2("-",i2.2))') " Exposure start date: ", &
          nint(year),nint(month),nint(day)
     write(error_unit,'(a,2(i2.2,":"),f0.3)') " Exposure start time: ", &
          nint(hour),nint(minute),sec
     write(error_unit,'(a,i0," x ",i0)') " Width and height of image(s): ",naxes
     write(error_unit,'(a,2f7.2,a)') " Equatorial coordinates: ",crval," [deg]"
     write(error_unit,'(a,f0.1,a,g0.2,a)') ' Scale: ',1/scale," [pix/deg],  ", &
          scale*3600," [arcsec/pix]"
     write(error_unit,'(a,f0.1,a)') ' Field rotation = ',angle," [deg]"
     write(error_unit,'(a,f0.2,a)') ' Field of view = ',fov," [deg]"
     if( cat == '' ) then
        write(error_unit,*) "Star coordinates and fluxes: random generated"
        write(error_unit,'(a,i0)') " Magnitude limit = ",maglim
     else
        write(error_unit,*) "Star coordinates and fluxes: by `",trim(cat),"'"
     end if
     write(error_unit,'(a,2f7.2,a)') " Observatory coordinates: ", &
          longitude, latitude," [deg]"
     write(error_unit,*) "Light curve modelling: ",lcmode
     if( lcmode ) then
        if( lcmodel /= '' ) then
           write(error_unit,*) "Light curve model: ",trim(lcmodel)
        else if( lctable /= '' ) then
           write(error_unit,*) "Light curve in table: `",trim(lctable),"'"
        else if( lcfourier /= '' ) then
           write(error_unit,*) "Light curve by Fourier coefficients in: `", &
                trim(lcfourier),"':"
           do i = 0,size(fcoeff)-1
              write(error_unit,'(a,i0,a,2(3x,f0.5),a)') "   c(",i,") = ",&
                   fcoeff(i),"i"
           end do
        end if
        write(error_unit,'(a,f0.1)') " Light curve mean magnitude = ",lcmag
        write(error_unit,'(a,f0.1)') " Light curve amplitude = ",lcamp
        write(error_unit,'(a,f0.6)') " Light curve JD0 = ",lcjd0
        write(error_unit,'(a,f0.6,a)') " Light curve period = ",lcper, &
             " [day(s)]"
        write(error_unit,'(a,2f7.2,a)') " Coordinates of the object: ",lcoo, &
             " [deg]"
     end if
     write(error_unit,*)
     write(error_unit,*) "Filename, JD(begin), airmass, seeing radius:"
  end if


  ! determine '?' in filemask
  n = 0
  do i = 1,len(filemask)
     if( filemask(i:i) == '?' ) n = n + 1
  end do
  if( nfiles > 1 .and. n == 0 ) n = int(log10(real(nfiles)) + 1)
  if( nfiles == 0 .and. n == 0 ) file = filemask
  write(fmt,'(a,i0,a)') '(a,i0.',n,',a)'

  if( datetime_init ) &
       jd = datjd(year,month,day + (hour+(minute+sec/60.0_dbl)/60.0_dbl)/24.0_dbl)
  timestep = timestep / 86400.0_dbl


  if( nfiles == 0 ) then

     call artfits(file,jd)

  else

     l1 = index(filemask,'?')

     if( l1 > 0 ) then
        l1 = l1 - 1
        l2 = index(filemask,'?',back=.true.) + 1

        do i = 1,nfiles
           write(file,fmt) filemask(1:l1),i,filemask(l2:len_trim(filemask))
           call artfits(file,jd)
           jd = jd + timestep
        end do
     else
        ! single filename
        call artfits(filemask,jd)
     end if

  end if

  if( allocated(fcoeff) ) deallocate(fcoeff)
  if( allocated(xcoo) ) deallocate(xcoo,ycoo,flux)

  stop 0

contains

  subroutine artfits(filename,jd)

    use generator
    use marker
    use spray
    use astrosphere
    use lcurves
    use artgalaxy

    real(dbl), parameter :: rad = 57.295779513082322865_dbl

    character(len=*), intent(in) :: filename
    real(dbl), intent(in) :: jd

    integer :: status
    character(len=FLEN_COMMENT) :: com
    character(len=FLEN_VALUE) :: datetime
    real(dbl), dimension(:,:), allocatable :: sky
    real(dbl) :: c,s,x,qe,see,extin,hwhms,jd2, ms, lcflux, phi, mag, back
    real(dbl), dimension(2) :: bgrad
    integer :: year, month, day, hour, minute, sec, m
    real(dbl), dimension(:), allocatable :: xstar,ystar,fluxes,xvar, yvar, fvar
    type(SprayType) :: psf
    type(fitsfiles) :: fits

    ! background at zenit
    back = magiconv(phsystable,phsystem,filter,[skymag])
    back = back * exptime * area * qefficiency * (scale*3600)**2
    bgrad = 1.086 * skygrad * back

    if( atmosphere ) then

       ! compute airmass
       x = xairmass(jd,longitude,latitude,crval(1),crval(2))
       if( x < 0 ) then
          call jdatetime(jd,year,month,day,hour,minute,sec,ms)
          write(error_unit,'(a,i4.4,2(a,i2.2),a,2(i2.2,a),i2.2,a,i0.3,a)') &
               "Airmass undefined (below horizon) for date  ", &
               year,"-",month,"-",day,"  and time ",hour,":",minute,":",sec,".", &
               nint(ms)," UT"
          return
       end if

       ! simulate seeing and extinction
       extin = exp(-extink*(x-1))          ! relative extinction against X=1
       qe = extin * qefficiency

       ! http://www.astro.auth.gr/~seeing-gr/seeing_gr_files/theory/node17.html
       ! Fries parameter for spread
       see = x**0.6
       hwhms = hwhm*see

       ! sky increases by airmass
       back  = back * extin
       bgrad = 1.086 * skygrad * back

       if( verbose ) write(error_unit,'(a,f15.5,f8.3,2f6.2)') &
            trim(filename),jd,x,extin,see
    else
       hwhms = hwhm
       qe = qefficiency

       if( verbose ) &
            write(error_unit,'(a,f15.5)') trim(filename),jd
    endif

    if( lcmode ) then
       ! variables

       phi = phase(jd,lcjd0,lcper)

       lcflux = 1

       if( lcmodel == 'WAVE' ) then
          lcflux = wave(phi)
       else if( lcmodel == 'CEPHEID' ) then
          lcflux = delta_cep(phi)
       else if( lcmodel == 'ALGOL' ) then
          lcflux = beta_per(phi)
       else if( lcmodel /= '' ) then
          stop "Unrecognised light curve model. Try `Cepheid', `Algol', `wave'."
       end if

       if( lcfourier /= '' ) then
          lcflux = fourfun(fcoeff,phi)
       end if

       if( lctable /= '' ) then
          lcflux = lcspline%Spline(phi)
       end if

       if( lcflux > 0 ) then
          mag = lcmag - (2.5_dbl*lcamp*log10(lcflux))
       else
          write(error_unit,*) 'Negative flux detected. Assumed near zero.'
          mag = 99.999
       end if

       allocate(xvar(1),yvar(1),fvar(1))
       call rain([lcoo(1)],[lcoo(2)],[mag],scale,angle,crval,crpix, &
            phsystable,phsystem,filter,xvar,yvar,fvar)

       ccmag = magconv(phsystable,phsystem,filter,fvar)
    else
       allocate(xvar(0),yvar(0),fvar(0))
    end if

    ! Frame generator
    allocate(sky(naxes(1),naxes(2)))
    sky = 0

    call background(back,bgrad,noise,sky)

    if( galcat /= '' ) &
         call galaxy(galcat,crval,crpix,scale,angle,exptime,area,qe, &
         phsystable,phsystem,filter,sky)

    ! merge both lists: variables and ordinary stars
    m = size(xvar)
    n = m + size(xcoo)
    allocate(xstar(n),ystar(n),fluxes(n))
    xstar(1:m) = xvar;  xstar(m+1:) = xcoo
    ystar(1:m) = yvar;  ystar(m+1:) = ycoo
    fluxes(1:m) = fvar; fluxes(m+1:) = flux

    ! update fluxes
    fluxes = fluxes * exptime * area * qe

    ! simulate profile
    if( psffile == '' ) then
       call psf%Init(profile,spread,hwhms,eccentricity,inclination,airy,beta)
    else
       call psf%Load(psffile)
    end if

    ! create the artificial sky
    call spreadstars(psf,xstar,ystar,fluxes,noise,sky)

    ! watermark
    call watermark(sky,5*sqrt(back))

    ! save the generated artificial sky to FITS file
    status = 0
    if( fits_file_exist(filename) ) call fits_file_delete(filename)
    call fits_create_file(fits,filename,status)
    if( status /= 0 ) then
       write(error_unit,*) "Error: `",trim(filename),"' failed to create."
       goto 666
    end if

    ! convert JD to date
    call jdatetime(jd,year,month,day,hour,minute,sec,ms)
    jd2 = jd + exptime / 2.0_dbl / 86400.0_dbl

    ! the artifical frame
    call fits_insert_img(fits,bitpix,size(naxes),naxes,status)
    write(datetime, &
         "(i4.4,'-',i2.2,'-',i2.2,'T',i2.2,':',i2.2,':',i2.2,'.',i3.3)") &
         year, month, day, hour, minute, sec, nint(ms)
    call fits_write_key(fits,FITS_KEY_DATEOBS,datetime,'date and time in UT',&
         status)
    call fits_write_key(fits,FITS_KEY_FILTER,filter,'filter',status)
    call fits_write_key(fits,FITS_KEY_JD,jd2,-16, &
         '[day] Julian date at half of exposure',status)
    call fits_write_key(fits,FITS_KEY_EXPTIME,exptime,-3,'[s] exposure time', &
         status)
    call fits_write_key(fits,FITS_KEY_AREA,area,-2,'[m2] detection area',status)
    call fits_write_key(fits,FITS_KEY_HWHM,hwhms,-3, &
         '[pix] half with at half maximum',status)
    call fits_write_key(fits,FITS_KEY_ECCENTRICITY,eccentricity,-3, &
         'eccentricity of ellipsis (0=circle)',status)
    call fits_write_key(fits,FITS_KEY_INCLINATION,inclination,-1, &
         '[deg] inclination of major semiaxis',status)
    if( atmosphere ) &
         call fits_write_key(fits,FITS_KEY_AIRMASS,x,-4,'airmass',status)
    call fits_write_key(fits,'PSF',profile,'PSF',status)
    if( profile == 'MOFFAT' ) then
       call fits_write_key(fits,'MOFFATB',beta,-3,'Moffat exponent',status)
    else if ( profile == 'SEEING' ) then
       call fits_write_key(fits,'AIRYDISK',airy,-3,'[pix] Airy disk radius', &
            status)
       call fits_write_key(fits,'SPREAD',spread,'seeing spread method ',status)
    end if
    call fits_write_key(fits,'CTYPE1','RA---TAN', &
         'the coordinate type for the first axis',status)
    call fits_write_key(fits,'CTYPE2','DEC--TAN', &
         'the coordinate type for the second axis',status)
    call fits_write_key(fits,'CRPIX1',real(naxes(1)/2),-6,'[pix]',status)
    call fits_write_key(fits,'CRPIX2',real(naxes(2)/2),-6,'[pix]',status)
    call fits_write_key(fits,'CRVAL1',crval(1),-17,'[deg]',status)
    call fits_write_key(fits,'CRVAL2',crval(2),-17,'[deg]',status)
    s = sin(angle/rad)
    c = cos(angle/rad)
    call fits_write_key(fits,'CD1_1',-c*scale,13,'',status)
    call fits_write_key(fits,'CD1_2',s*scale,13,'',status)
    call fits_write_key(fits,'CD2_1',s*scale,13,'',status)
    call fits_write_key(fits,'CD2_2',c*scale,13,'',status)
    call fits_write_key(fits,FITS_KEY_LONGITUDE,longitude,-5, &
         '[deg] geographic longitude (-east)',status)
    call fits_write_key(fits,FITS_KEY_LATITUDE,latitude,-5, &
         '[deg] geographic latitude (+north)',status)
    call fits_write_comment(fits,'Artificial sky by Munipack.',status)
    call fits_write_comment(fits,'Parameters:',status)
    write(com,'(a,es10.3,1x,2(g0.2,1x))') &
         'Background: level, gradient = ',back,bgrad
    call fits_write_comment(fits,com,status)
    write(com,'(a,l2)') 'Noise: ',noise
    call fits_write_comment(fits,com,status)
    write(com,'(2a)') 'PSF = ',trim(profile)
    call fits_write_comment(fits,com,status)
    if( profile == 'SEEING' ) then
       write(com,'(2a)') 'Seeing spread method = ',trim(spread)
       call fits_write_comment(fits,com,status)
    end if
    if( cat == '' ) then
       write(com,'(a,i0)') 'Magnitude limit  = ',maglim
       call fits_write_comment(fits,com,status)
    end if
    write(com,'(a,g0.3)') 'Quantum efficiency  = ', qe
    call fits_write_comment(fits,com,status)
    if( atmosphere ) then
       write(com,'(a,g0.3)') 'Extinction coefficient  = ', extink
       call fits_write_comment(fits,com,status)
       write(com,'(a,g0.3)') 'Seeing factor  = ', see
       call fits_write_comment(fits,com,status)
    end if
    if( lcmode ) then
       write(com,'(2a)') 'Light curve model = ',trim(lcmodel)
       call fits_write_comment(fits,com,status)
       if( lcfourier /= '' ) then
          write(com,'(2a)') 'Fourier coefficients table = ', trim(lcfourier)
          call fits_write_comment(fits,com,status)
       end if
       if( lctable /= '' ) then
          write(com,'(2a)') 'Spline interpolation table = ', trim(lctable)
          call fits_write_comment(fits,com,status)
       end if
       write(com,'(a,f0.3)') "Light curve current magnitude = ",ccmag
       call fits_write_comment(fits,com,status)
       write(com,'(a,2(f0.3,1x))') &
            "Light curve mean magnitude, amplitude = ",lcmag,lcamp
       call fits_write_comment(fits,com,status)
       write(com,'(a,2(f0.6,1x),a)') &
            "Light curve elements (JD0, period) = ",lcjd0,lcper," [day(s)]"
       call fits_write_comment(fits,com,status)
       write(com,'(a,2(f0.5,1x),a)') &
            "Light curve object coordinates = ",lcoo," [deg]"
       call fits_write_comment(fits,com,status)
    end if
    call fits_write_comment(fits,MUNIPACK_VERSION,status)
    call fits_write_image(fits,0,real(sky),status)

    ! PSF extension
    call fits_insert_img(fits,-32,2,[size(psf%psf,1),size(psf%psf,2)],status)
    call fits_update_key(fits,'EXTNAME','PSF','',status)
    call fits_update_key(fits,'ZOOM',psf%zoom,'zoom',status)
    call fits_write_image(fits,0,real(psf%psf),status)

    ! Star table extension
    block
      character(len=FLEN_VALUE), dimension(3) :: ttype, tform, tunit
      integer :: nrows, srows, i, l, frow

      nrows = size(xstar)
      ttype(1) = FITS_COL_X
      ttype(2) = FITS_COL_Y
      ttype(3) = FITS_COL_COUNT
      tform  = '1E'
      tunit = ''
      call fits_insert_btbl(fits,nrows,ttype,tform,tunit,'CATALOGUE',status)

      call fits_get_rowsize(fits,srows,status)
      do i = 1, nrows, srows
         frow = i
         l = min(i+srows,nrows)

         call fits_write_col(fits,1,frow,xstar(i:l),status)
         call fits_write_col(fits,2,frow,ystar(i:l),status)
         call fits_write_col(fits,3,frow,fluxes(i:l),status)
      end do
    end block

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    ! cleanup
    if( allocated(xvar) ) deallocate(xvar,yvar,fvar)
    deallocate(xstar,ystar,fluxes)
    deallocate(sky)

  end subroutine artfits


  subroutine lctable_init(tablename, lcspline)

    use lcio

    character(len=*), intent(in) :: tablename
    class(SplineSerieType), intent(out) :: lcspline

    real(dbl), dimension(:), allocatable :: time, flux, dflux
    real(dbl), parameter :: sopt = -1

    call lcimport(tablename,time,flux,dflux)

    call lcspline%Init(time,flux,dflux,sopt)
    deallocate(time,flux,dflux)

  end subroutine lctable_init

  function magconv(phsystable,phsystem,filter,ph)

    use phsysfits
    use photoconv

    real(dbl) :: magconv
    character(len=*), intent(in) :: filter, phsystable, phsystem
    real(dbl), dimension(:), intent(in) :: ph
    type(type_phsys) :: phsys
    real(dbl), dimension(size(ph)) :: mag,dmag,dph

    call phselect(phsystable,phsystem,phsys)
    dph = -1
    call phsysphmag1(phsys,filter,ph,dph,mag,dmag)
    magconv = mag(1)

  end function magconv

  function magiconv(phsystable,phsystem,filter,mag)

    use phsysfits
    use photoconv

    real(dbl) :: magiconv
    character(len=*), intent(in) :: filter, phsystable, phsystem
    real(dbl), dimension(:), intent(in) :: mag
    type(type_phsys) :: phsys
    real(dbl), dimension(size(mag)) :: ph,dph,dmag

    call phselect(phsystable,phsystem,phsys)
    dmag = 9.999
    call phsysmagph1(phsys,filter,mag,dmag,ph,dph)
    magiconv = ph(1)

  end function magiconv

end program artificial

!
!  Common array manipulations
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!  
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!  
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module muniarrays

  integer, parameter, private :: dbl = selected_real_kind(15)

  interface reallocate
     module procedure reallocate_i,reallocate_s,reallocate_d,reallocate_c
  end interface reallocate

contains

subroutine reallocate_i(x,n)

  implicit none
  integer, dimension(:),allocatable,intent(in out) :: x
  integer :: n
  integer, dimension(:),allocatable :: y
  
  allocate(y(n))

  if( n < size(x) )then
     y = x(1:n)
  else if( n > size(x) )then
     y(1:size(x)) = x
  else
     y = x
  end if

  deallocate(x)
  allocate(x(n))
  x(1:size(y)) = y
  deallocate(y)

end subroutine reallocate_i

subroutine reallocate_s(x,n)

  implicit none
  real, dimension(:),allocatable,intent(inout) :: x
  integer :: n
  real, dimension(:),allocatable :: y
  
  allocate(y(n))

  if( n < size(x) )then
     y = x(1:n)
  else if( n > size(x) )then
     y(1:size(x)) = x
  else
     y = x
  end if

  deallocate(x)
  allocate(x(n))
  x(1:size(y)) = y
  deallocate(y)

end subroutine reallocate_s

subroutine reallocate_d(x,n)

  implicit none
  real(dbl), dimension(:),allocatable,intent(inout) :: x
  integer :: n
  real(dbl), dimension(:),allocatable :: y
  
  allocate(y(n))

  if( n < size(x) )then
     y = x(1:n)
  else if( n > size(x) )then
     y(1:size(x)) = x
  else
     y = x
  end if

  deallocate(x)
  allocate(x(n))
  x(1:size(y)) = y
  deallocate(y)

end subroutine reallocate_d

subroutine reallocate_c(x,n)

  implicit none
  character(len=*), dimension(:),allocatable,intent(inout) :: x
  integer :: n
  character(len=len(x)), dimension(:),allocatable :: y
  
  allocate(y(n))

  if( n < size(x) )then
     y = x(1:n)
  else if( n > size(x) )then
     y(1:size(x)) = x
  else
     y = x
  end if

  deallocate(x)
  allocate(x(n))
  x(1:size(y)) = y
  deallocate(y)

end subroutine reallocate_c

end module muniarrays

!
!  grow-curve photometry
!
!  Copyright © 2016-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


program gphot

  use titsio
  use iso_fortran_env

  implicit none

  character(len=4*FLEN_FILENAME) :: record,key,val
  character(len=FLEN_FILENAME) :: filename,output
  logical :: verbose = .false., plog = .false.
  integer :: eq
  real :: threshold = 0.1
  logical :: ex, exitus = .true.

  do
     read(*,'(a)',end=20) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Malformed input record.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'PIPELOG' ) then

        read(val,*) plog

     else if( key == 'THRESHOLD' ) then

        read(val,*) threshold

     else if( key == 'FILE' ) then

        read(val,*) filename, output

        call growfits(filename,output,ex)
        exitus = exitus .and. ex

     end if

  end do

20 continue

  if( exitus ) then
     stop 0
  else
     stop 'An error during growth-curve photometry occurred.'
  end if

contains

  subroutine growfits(filename,output,exitus)

    use grow_curve
    use grow_report
    use fitsgphot

    character(len=*),intent(in) :: filename,output
    logical, intent(out) :: exitus

    integer, parameter :: rp = selected_real_kind(15)

    integer :: status,nrows,naper
    real, dimension(:), allocatable :: xcens,ycens,sky,skyerr,skycorr,skyerrcorr
    real, dimension(:,:), allocatable :: apcts,apcts_err
    real(rp), dimension(:), allocatable :: gcount,gcount_err
    integer, dimension(:), allocatable :: growflag
    real(rp), dimension(:), allocatable :: curve, curve_err, prof
    real, dimension(:), allocatable :: raper
    real :: hwhm, rflux90, ghwhm, sep
    type(grow_reporter) :: reporter
    logical :: report_init

    report_init = .false.
    status = 0

    call fits_gphot_read(filename,hwhm,sep,raper,xcens,ycens, &
         sky,skyerr,skycorr,skyerrcorr,apcts,apcts_err,status)
    if( status /= 0 ) goto 666

    naper = size(raper)
    nrows = size(xcens)
    allocate(gcount(nrows),gcount_err(nrows), growflag(nrows), &
         curve(naper), curve_err(naper), prof(naper) )

    if( verbose ) then
       report_init = .true.
       call grow_report_init(reporter,naper,nrows,raper)
    end if

    ! angular separation of stars intended as base for growth-curve
    ! construction, the stars can share only the ring of sky
    !  sep = ring(2)

    ! growth-curve photometry
    call growphot(xcens,ycens,apcts,apcts_err,sky,skyerr,raper,hwhm,sep,&
         threshold, &
         gcount,gcount_err,skycorr,skyerrcorr,curve,curve_err,growflag, &
         prof,rflux90,ghwhm,verbose,reporter)

    ! update sky
    sky = sky - skycorr
    where( skyerr > 0 .and. skyerrcorr > 0 )
       skyerr = sqrt(skyerr**2 + skyerrcorr**2) / 1.414
!    elsewhere
!       skyerr = 0
    end where

    call fits_find_save(filename,output,ghwhm,rflux90, &
       raper, xcens, ycens, sky,skyerr, gcount,gcount_err, growflag, &
       curve, curve_err, prof, status)


!    if( verbose ) call grow_report_dump(15,reporter,status)

666 continue

    if( allocated(apcts) ) deallocate(raper,xcens,ycens,sky,skyerr,skycorr, &
         skyerrcorr,apcts,apcts_err)

    if( allocated(gcount) ) deallocate(gcount,gcount_err,growflag, &
         curve,curve_err,prof)

    if( verbose .and. report_init ) call grow_report_terminate(reporter)

    exitus = status == 0

  end subroutine growfits


end program gphot

!
!  Fourier transformation, very simple implementation for images
!
!
!  Copyright © 2016 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!
!
! https://en.wikipedia.org/wiki/Discrete_Fourier_transform
!

module ftransform

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: pi = 3.1415926535897931_dbl
  real(dbl), parameter, private :: pi2 = 2*pi

contains

  subroutine ftra(x,z,m,w)

    ! for forward w = 1
    ! for backward w = -1

    complex(dbl), dimension(:,:), intent(in) :: x
    complex(dbl), dimension(:,:), intent(out) :: z
    integer, intent(in) :: m,w

    complex(dbl), dimension(:,:), allocatable :: y
    integer :: i,j

    allocate(y(size(x,1),size(x,2)))

    do i = 1,size(x,1)
       y(i,:) = x(i,:)
       call fft(y(i,:),m,w)
    end do

    do j = 1,size(x,2)
       z(:,j) = y(:,j)
       call fft(z(:,j),m,w)
    end do

    deallocate(y)

  end subroutine ftra



  subroutine fft(a,m,d)

    ! This subroutine computes Fast Fourier transformation
    ! of the input/output array a with dimension a(2**m).
    ! d setup any of forward (d=1) and backward (d=-1) transformation.

    ! The code has been adopted from book in Czech (P.Prikryl: Numericke
    ! methody matematicke analyzy, SNTL, Prague 1985) without a reference.
    ! Numerical recipes introduces very similar procedure (in C++)
    ! with only reference to autor N.M. Brenner. See also:
    !    https://en.wikipedia.org/wiki/Fast_Fourier_transform

    complex(dbl), dimension(:), intent(in out) :: a
    integer, intent(in) :: m,d

    complex(dbl) :: u,w,t
    integer :: n,i,j,k,l,le,le1,ip
    real(dbl) :: ang

    n = 2**m
    j = 1
    do i = 1,n-1
       if( i < j )then
          t = a(j)
          a(j) = a(i)
          a(i) = t
        endif
        k = n/2
        do while( k < j )
           j = j-k
           k = k/2
        end do
        j = j+k
     enddo

     do l = 1,m
        le = 2**l
        le1 = le/2
        u = cmplx(1.0_dbl,0.0_dbl,dbl)
        ang = -d*pi/le1
        w = cmplx(cos(ang),-sin(ang),dbl)
        do j = 1,le1
          do i = j,n,le
             ip = i+le1
             t = a(ip)*u
             a(ip) = a(i)-t
             a(i) = a(i)+t
          enddo
          u = u*w
        enddo
      enddo
    end subroutine fft


end module ftransform

!
! Interpolation routines suitable for kombine
!
! Copyright © 2018 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
! All interpolation methods are implemented according to wiki pages:
!
!  https://en.wikipedia.org/wiki/Bicubic_interpolation
!  https://en.wikipedia.org/wiki/Bilinear_interpolation
!

module interpol

  implicit none


contains

  real function bilinear(x,y,f)

    ! https://en.wikipedia.org/wiki/Bilinear_interpolation

    real, intent(in) :: x,y
    real, dimension(:,:), intent(in) :: f
    real, dimension(2) :: dx, dy
    real, dimension(2,2) :: M

    dx = [1 - x, x]
    dy = [1 - y, y]
    M(1,:) = [ f(1,1), f(1,2) ]
    M(2,:) = [ f(2,1), f(2,2) ]

    dy = matmul(M,dy)
    bilinear = sum(dx*dy)

  end function bilinear


  real function bicubic(x,y,f,fx,fy,fxy)

    ! https://en.wikipedia.org/wiki/Bicubic_interpolation

    real, intent(in) :: x,y
    real, dimension(0:,0:), intent(in) :: f,fx,fy,fxy

    real, dimension(4,4) :: A,M,D
    real, dimension(4,4) :: B
    real, dimension(4) :: dx, dy

    ! interpolation matrix
    M(1,:) = [ 1, 0, 0, 0 ]
    M(2,:) = [ 0, 0, 1, 0 ]
    M(3,:) = [-3, 3,-2,-1 ]
    M(4,:) = [ 2,-2, 1, 1 ]

    ! functions and derivations matrix
    D(1,:) = [  f(0,0),  f(0,1),  fy(0,0),  fy(0,1) ]
    D(2,:) = [  f(1,0),  f(1,1),  fy(1,0),  fy(1,1) ]
    D(3,:) = [ fx(0,0), fx(0,1), fxy(0,0), fxy(0,1) ]
    D(4,:) = [ fx(1,0), fx(1,1), fxy(1,0), fxy(1,1) ]

    B = matmul(D,M)
    A = matmul(transpose(M),B)

    B = matmul(D,transpose(M))
    A = matmul(M,B)


    dx = [ 1.0, x, x**2, x**3 ]
    dy = [ 1.0, y, y**2, y**3 ]

    dy = matmul(A,dy)
    bicubic = sum(dx*dy)

  end function bicubic

  subroutine diff(f,f1,u,v)

    ! calculate first order differences along x,y-directions

    real, dimension(:,:), intent(in) :: f
    real, dimension(:,:), intent(out) :: f1
    integer, intent(in) :: u,v

    real, parameter :: h = 1 ! step
    integer :: i,j

    f1 = 0
    do i = 2, size(f,1) - 1
       do j = 2, size(f,2) - 1
          f1(i,j) = (f(i+u,j+v) - f(i-u,j-v)) / (2*h)
       end do
    end do

  end subroutine diff

  subroutine diff2(f,f2)

    ! second order mixed differences. both xy-directions

    real, dimension(:,:), intent(in) :: f
    real, dimension(:,:), intent(out) :: f2

    real, parameter :: h = 1
    integer :: i,j

    f2 = 0
    do i = 2, size(f,1) - 1
       do j = 2, size(f,2) - 1
          f2(i,j) = (f(i+1,j+1) + f(i-1,j-1) - 2*f(i,j)) / h**2
       end do
    end do


  end subroutine diff2


  real function bi3conv(x,y,f)

    real, intent(in) :: x,y
    real, dimension(-1:,-1:), intent(in) :: f

    ! bi-cubic interpolation by convolution
    ! https://en.wikipedia.org/wiki/Bicubic_interpolation
    ! Section: Bicubic convolution algorithm

    real, dimension(-1:2) :: b
    integer :: i

    do i = -1,2
       b(i) = bi3conv_p(x,f(-1:2,i))
    end do

    bi3conv = bi3conv_p(y,b)

  end function bi3conv

  real function bi3conv_p(x,f)

    real, intent(in) :: x
    real, dimension(-1:),intent(in) :: f

    ! bi-cubic interpolation by convolution
    ! https://en.wikipedia.org/wiki/Bicubic_interpolation
    ! Section: Bicubic convolution algorithm

    real, dimension(4,4) :: M
    real, dimension(4) :: dx, d

    ! interpolation matrix
    M(1,:) = [ 0, 2, 0, 0 ]
    M(2,:) = [-1, 0, 1, 0 ]
    M(3,:) = [ 2,-5, 4,-1 ]
    M(4,:) = [-1, 3,-3, 1 ]

    dx = [ 1.0, x, x**2, x**3 ]

    d = matmul(M,f(-1:2))

    bi3conv_p = 0.5 * sum(dx*d)

  end function bi3conv_p

end module interpol

!
! This module is a adopted version of algorithm described below.
!
! Download:    http://people.sc.fsu.edu/~burkardt/f_src/asa047/asa047.html
!
! Thx to J. Burkardt http://people.sc.fsu.edu/~burkardt/index.html
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!


Module NelderMead

  implicit none


contains

  ! a simple wrapper to the original subroutine

  subroutine nelmin1(fn,xmin,step,ynewlo,ifault,reqmin0,konvge0,kcount0,icount0,numres0)

    interface
       function fn(t)
         real(kind=8) :: fn
         real(kind=8), dimension(:), intent(in) :: t
       end function fn
    end interface

    real(kind=8), dimension(:), intent(in out) :: xmin
    real(kind=8), dimension(:), intent(in) :: step
    real(kind=8), intent(out) :: ynewlo
    integer, intent(out) :: ifault
    real(kind=8), optional, intent(in) :: reqmin0
    integer, optional, intent(in) :: konvge0, kcount0
    integer, optional, intent(out) :: icount0,numres0

    real(kind=8), dimension(size(xmin)) :: start
    integer :: n,konvge,kcount,icount,numres
    real(kind=8) :: reqmin

    n = size(xmin)
    start = xmin

    if( present(reqmin0) ) then
       reqmin = reqmin0
    else
       reqmin = epsilon(ynewlo)
    end if

    if( present(konvge0) ) then
       konvge = konvge0
    else
       konvge = 1
    end if

    if( present(kcount0) ) then
       kcount = kcount0
    else
       kcount = 1000*n
    end if

    call nelmin(fn,n,start,xmin,ynewlo,reqmin,step,konvge,kcount,icount,numres,ifault)

    if( present(icount0) ) icount0 = icount
    if( present(numres0) ) numres0 = numres

  end subroutine nelmin1


  subroutine nelmin ( fn, n, start, xmin, ynewlo, reqmin, step, konvge, kcount, &
  icount, numres, ifault )

!*****************************************************************************80
!
!! NELMIN minimizes a function using the Nelder-Mead algorithm.
!
!  Discussion:
!
!    This routine seeks the minimum value of a user-specified function.
!
!    Simplex function minimisation procedure due to Nelder and Mead (1965),
!    as implemented by O'Neill(1971, Appl.Statist. 20, 338-45), with
!    subsequent comments by Chambers+Ertel(1974, 23, 250-1), Benyon(1976,
!    25, 97) and Hill(1978, 27, 380-2)
!
!    The function to be minimized must be defined by a function of
!    the form
!
!      function fn ( x, f )
!      real ( kind = 8 ) fn
!      real ( kind = 8 ) x(*)
!
!    and the name of this subroutine must be declared EXTERNAL in the
!    calling routine and passed as the argument FN.
!
!    This routine does not include a termination test using the
!    fitting of a quadratic surface.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    27 February 2008
!
!  Author:
!
!    Original FORTRAN77 version by R ONeill.
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    John Nelder, Roger Mead,
!    A simplex method for function minimization,
!    Computer Journal,
!    Volume 7, 1965, pages 308-313.
!
!    R ONeill,
!    Algorithm AS 47:
!    Function Minimization Using a Simplex Procedure,
!    Applied Statistics,
!    Volume 20, Number 3, 1971, pages 338-345.
!
!  Parameters:
!
!    Input, external FN, the name of the function which evaluates
!    the function to be minimized.
!
!    Input, integer ( kind = 4 ) N, the number of variables.
!    0 < N is required.
!
!    Input/output, real ( kind = 8 ) START(N).  On input, a starting point
!    for the iteration.  On output, this data may have been overwritten.
!
!    Output, real ( kind = 8 ) XMIN(N), the coordinates of the point which
!    is estimated to minimize the function.
!
!    Output, real ( kind = 8 ) YNEWLO, the minimum value of the function.
!
!    Input, real ( kind = 8 ) REQMIN, the terminating limit for the variance
!    of the function values.  0 < REQMIN is required.
!
!    Input, real ( kind = 8 ) STEP(N), determines the size and shape of the
!    initial simplex.  The relative magnitudes of its elements should reflect
!    the units of the variables.
!
!    Input, integer ( kind = 4 ) KONVGE, the convergence check is carried out
!    every KONVGE iterations. 0 < KONVGE is required.
!
!    Input, integer ( kind = 4 ) KCOUNT, the maximum number of function
!    evaluations.
!
!    Output, integer ( kind = 4 ) ICOUNT, the number of function evaluations
!    used.
!
!    Output, integer ( kind = 4 ) NUMRES, the number of restarts.
!
!    Output, integer ( kind = 4 ) IFAULT, error indicator.
!    0, no errors detected.
!    1, REQMIN, N, or KONVGE has an illegal value.
!    2, iteration terminated because KCOUNT was exceeded without convergence.
!
  implicit none

  integer ( kind = 4 ) n

  real ( kind = 8 ), parameter :: ccoeff = 0.5D+00
  real ( kind = 8 ) del
  real ( kind = 8 ), parameter :: ecoeff = 2.0D+00
  real ( kind = 8 ), parameter :: eps = 0.001D+00
!  real ( kind = 8 ), external :: fn
  integer ( kind = 4 ) i
  integer ( kind = 4 ) icount
  integer ( kind = 4 ) ifault
  integer ( kind = 4 ) ihi
  integer ( kind = 4 ) ilo
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jcount
  integer ( kind = 4 ) kcount
  integer ( kind = 4 ) konvge
  integer ( kind = 4 ) l
  integer ( kind = 4 ) numres
  real ( kind = 8 ) p(n,n+1)
  real ( kind = 8 ) p2star(n)
  real ( kind = 8 ) pbar(n)
  real ( kind = 8 ) pstar(n)
  real ( kind = 8 ), parameter :: rcoeff = 1.0D+00
  real ( kind = 8 ) reqmin
  real ( kind = 8 ) rq
  real ( kind = 8 ) start(n)
  real ( kind = 8 ) step(n)
  real ( kind = 8 ) x
  real ( kind = 8 ) xmin(n)
  real ( kind = 8 ) y(n+1)
  real ( kind = 8 ) y2star
  real ( kind = 8 ) ylo
  real ( kind = 8 ) ynewlo
  real ( kind = 8 ) ystar
  real ( kind = 8 ) z

  interface
     function fn(t)
       real(kind=8) :: fn
       real(kind=8), dimension(:), intent(in) :: t
     end function fn
  end interface


!
!  Check the input parameters.
!
  if ( reqmin <= 0.0D+00 ) then
    ifault = 1
    return
  end if

  if ( n < 1 ) then
    ifault = 1
    return
  end if

  if ( konvge < 1 ) then
    ifault = 1
    return
  end if
!
!  Initialization.
!
  icount = 0
  numres = 0
  jcount = konvge
  del = 1.0D+00
  rq = reqmin * real ( n, kind = 8 )
!
!  Initial or restarted loop.
!
  do

    p(1:n,n+1) = start(1:n)
    y(n+1) = fn ( start )
    icount = icount + 1
!
!  Define the initial simplex.
!
    do j = 1, n
      x = start(j)
      start(j) = start(j) + step(j) * del
      p(1:n,j) = start(1:n)
      y(j) = fn ( start )
      icount = icount + 1
      start(j) = x
    end do
!
!  Find highest and lowest Y values.  YNEWLO = Y(IHI) indicates
!  the vertex of the simplex to be replaced.
!
    ilo = minloc ( y(1:n+1), 1 )
    ylo = y(ilo)
!
!  Inner loop.
!
    do while ( icount < kcount )
!
!  YNEWLO is, of course, the HIGHEST value???
!
      ihi = maxloc ( y(1:n+1), 1 )
      ynewlo = y(ihi)
!
!  Calculate PBAR, the centroid of the simplex vertices
!  excepting the vertex with Y value YNEWLO.
!
      do i = 1, n
        pbar(i) = ( sum ( p(i,1:n+1) ) - p(i,ihi) ) / real ( n, kind = 8 )
      end do
!
!  Reflection through the centroid.
!
      pstar(1:n) = pbar(1:n) + rcoeff * ( pbar(1:n) - p(1:n,ihi) )
      ystar = fn ( pstar )
      icount = icount + 1
!
!  Successful reflection, so extension.
!
      if ( ystar < ylo ) then

        p2star(1:n) = pbar(1:n) + ecoeff * ( pstar(1:n) - pbar(1:n) )
        y2star = fn ( p2star )
        icount = icount + 1
!
!  Retain extension or contraction.
!
        if ( ystar < y2star ) then
          p(1:n,ihi) = pstar(1:n)
          y(ihi) = ystar
        else
          p(1:n,ihi) = p2star(1:n)
          y(ihi) = y2star
        end if
!
!  No extension.
!
      else

        l = 0
        do i = 1, n + 1
          if ( ystar < y(i) ) then
            l = l + 1
          end if
        end do

        if ( 1 < l ) then

          p(1:n,ihi) = pstar(1:n)
          y(ihi) = ystar
!
!  Contraction on the Y(IHI) side of the centroid.
!
        else if ( l == 0 ) then

          p2star(1:n) = pbar(1:n) + ccoeff * ( p(1:n,ihi) - pbar(1:n) )
          y2star = fn ( p2star )
          icount = icount + 1
!
!  Contract the whole simplex.
!
          if ( y(ihi) < y2star ) then

            do j = 1, n + 1
              p(1:n,j) = ( p(1:n,j) + p(1:n,ilo) ) * 0.5D+00
              xmin(1:n) = p(1:n,j)
              y(j) = fn ( xmin )
              icount = icount + 1
            end do

            ilo = minloc ( y(1:n+1), 1 )
            ylo = y(ilo)

            cycle
!
!  Retain contraction.
!
          else
            p(1:n,ihi) = p2star(1:n)
            y(ihi) = y2star
          end if
!
!  Contraction on the reflection side of the centroid.
!
        else if ( l == 1 ) then

          p2star(1:n) = pbar(1:n) + ccoeff * ( pstar(1:n) - pbar(1:n) )
          y2star = fn ( p2star )
          icount = icount + 1
!
!  Retain reflection?
!
          if ( y2star <= ystar ) then
            p(1:n,ihi) = p2star(1:n)
            y(ihi) = y2star
          else
            p(1:n,ihi) = pstar(1:n)
            y(ihi) = ystar
          end if

        end if

      end if
!
!  Check if YLO improved.
!
      if ( y(ihi) < ylo ) then
        ylo = y(ihi)
        ilo = ihi
      end if

      jcount = jcount - 1

      if ( 0 < jcount ) then
        cycle
      end if
!
!  Check to see if minimum reached.
!
      if ( icount <= kcount ) then

        jcount = konvge

        x = sum ( y(1:n+1) ) / real ( n + 1, kind = 8 )
        z = sum ( ( y(1:n+1) - x )**2 )

        if ( z <= rq ) then
          exit
        end if

      end if

    end do
!
!  Factorial tests to check that YNEWLO is a local minimum.
!
    xmin(1:n) = p(1:n,ilo)
    ynewlo = y(ilo)

    if ( kcount < icount ) then
      ifault = 2
      exit
    end if

    ifault = 0

    do i = 1, n
      del = step(i) * eps
      xmin(i) = xmin(i) + del
      z = fn ( xmin )
      icount = icount + 1
      if ( z < ynewlo ) then
        ifault = 2
        exit
      end if
      xmin(i) = xmin(i) - del - del
      z = fn ( xmin )
      icount = icount + 1
      if ( z < ynewlo ) then
        ifault = 2
        exit
      end if
      xmin(i) = xmin(i) + del
    end do

    if ( ifault == 0 ) then
      exit
    end if
!
!  Restart the procedure.
!
    start(1:n) = xmin(1:n)
    del = eps
    numres = numres + 1

  end do

  return
end subroutine nelmin


subroutine timestamp ( )

!*****************************************************************************80
!
!! TIMESTAMP prints the current YMDHMS date as a time stamp.
!
!  Example:
!
!    31 May 2001   9:45:54.872 AM
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    18 May 2013
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    None
!
  implicit none

  character ( len = 8 ) ampm
  integer ( kind = 4 ) d
  integer ( kind = 4 ) h
  integer ( kind = 4 ) m
  integer ( kind = 4 ) mm
  character ( len = 9 ), parameter, dimension(12) :: month = (/ &
    'January  ', 'February ', 'March    ', 'April    ', &
    'May      ', 'June     ', 'July     ', 'August   ', &
    'September', 'October  ', 'November ', 'December ' /)
  integer ( kind = 4 ) n
  integer ( kind = 4 ) s
  integer ( kind = 4 ) values(8)
  integer ( kind = 4 ) y

  call date_and_time ( values = values )

  y = values(1)
  m = values(2)
  d = values(3)
  h = values(5)
  n = values(6)
  s = values(7)
  mm = values(8)

  if ( h < 12 ) then
    ampm = 'AM'
  else if ( h == 12 ) then
    if ( n == 0 .and. s == 0 ) then
      ampm = 'Noon'
    else
      ampm = 'PM'
    end if
  else
    h = h - 12
    if ( h < 12 ) then
      ampm = 'PM'
    else if ( h == 12 ) then
      if ( n == 0 .and. s == 0 ) then
        ampm = 'Midnight'
      else
        ampm = 'AM'
      end if
    end if
  end if

  write ( *, '(i2,1x,a,1x,i4,2x,i2,a1,i2.2,a1,i2.2,a1,i3.3,1x,a)' ) &
    d, trim ( month(m) ), y, h, ':', n, ':', s, '.', mm, trim ( ampm )

  return

end subroutine timestamp

end Module NelderMead

!
! astromatch - matching engine
!
!
! Copyright © 2011-5, 2017 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module astromatcher

  use iso_fortran_env

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

  ! maximal number of loop over frame stars
  integer, parameter, private :: maxloop = 3

  character(len=80), private :: ptype
  real(dbl), dimension(:), pointer, private :: astar,dstar,xstar,ystar
  logical, private :: verbose, plog
  real(dbl), private :: xcen,ycen,acen,dcen

contains

  subroutine astromatch(minmatch,maxmatch,type,a,d,pma,pmd,rflux, &
       xx,yy,flux,ac,dc,xc,yc,id1,id2,sig1,sig2,fsig,fluxtest, &
       epoch,jd,fullmatch,luckymatch,verb,pl,status)

    use astrotrafo
    use matcher

    integer, intent(in) :: minmatch, maxmatch, luckymatch
    logical, intent(in) :: fullmatch,verb, pl, fluxtest
    character(len=*), intent(in) :: type
    real(dbl), intent(in) :: ac,dc,xc,yc,sig1,sig2,fsig,epoch,jd
    real(dbl), dimension(:), intent(in), target :: a, d, pma, pmd, xx, yy, &
         flux, rflux
    integer, dimension(:), allocatable, intent(out) :: id1,id2
    logical, intent(out) :: status

    real(dbl), dimension(:), allocatable :: u,v,x,y
    type(AstroTrafoProj) :: t
    real(dbl) :: dt
    integer :: n1,n2,l,n,k,m

    status = .false.

    verbose = verb
    plog = pl
    ptype = type
    astar => a
    dstar => d
    xstar => xx
    ystar => yy
    acen = ac
    dcen = dc
    xcen = xc
    ycen = yc

    if(verbose) write(error_unit,*) "=== Matching ==="

    n1 = size(a)
    n2 = size(xx)
    allocate(x(n2),y(n2),u(n1),v(n1))

    x = xx - xc
    y = yy - yc

    dt = (jd - epoch)/365.25_dbl

    call trafo_init(t,type,ac,dc)
    call proj(t,a+dt*pma,d+dt*pmd,u,v)

    if( verbose ) then
       write(error_unit,'(2(a,i0),a)') " Matching of ",size(u), &
            " reference stars against to ",size(x)," frame stars:"
       write(error_unit,*) &
            "#: {seq1} -> {seq2} | scale,r: sq.(angle, scale, flux) < Xi2(0.95)"
    end if

    k = 1
    do m = 1, min(size(x)/maxmatch + 1, maxloop)
       n2 = min(maxmatch,size(x)-k) - 1
       l = 1
       do n = 1, size(u)/maxmatch + 1
          n1 = min(maxmatch,size(u)-l) - 1
          if(verbose) write(error_unit,'(2(2(a,i0),a))') &
               " Reference stars in range ",l," -- ",l+n1,".", &
               " Frame stars in range ",k," -- ",k+n2,"."
          call match(u(l:l+n1),v(l:l+n1),rflux(l:l+n1), &
               x(k:k+n2),y(k:k+n2),flux(k:k+n2), &
               minmatch,maxmatch,sig1,sig2,fsig,fluxtest,id1,id2,&
               fullmatch,luckymatch,matchprint,progress2,status)
          if( status ) then
             id1 = l + id1 - 1
             id2 = k + id2 - 1
             goto 99
          end if
          l = l + maxmatch
       end do
       k = k + maxmatch
    end do
99  continue

    deallocate(u,v,x,y)


  end subroutine astromatch


  subroutine matchprint(id1,id2,c,t,a,d,f,q)

    use matcher

    integer, dimension(:), intent(in) :: id1,id2
    real(dbl), intent(in) :: c,t,a,d,f,q
    real(dbl), dimension(size(id1)) :: u,v
    integer :: i,n
    real(dbl) :: d3
    character(len=80) :: fmt

    if( size(id1) /= size(id2) ) stop 'Astromatch size(id1) /= size(id2)'

    n = size(id2)

    if( verbose ) then

       write(fmt,"(a,i0,a,i0,a)") "(i0,a,",n,"(1x,i0),a,",n, &
            "(1x,i0),a,f0.1,2x,g0.2,a,3(2x,g0.3),a,f0.1)"
       write(error_unit,fmt) n,":",id1,' -> ',id2,' | ',c,t,': ',a,d,f,' < ',q

    end if

    return

    if( plog ) then

       write(fmt,"(a,i0,a)") "(a,i0,",2*n,"(1x,f0.3),f6.3,f8.5)"
       write(*,fmt) "=M> ",n,(xstar(id2(i)),ystar(id2(i)),i=1,n),a,d

       do i = 3,n
          call triangle(xstar(i-2),ystar(i-2),xstar(i-1), &
               ystar(i-1),xstar(i),ystar(i),d3,u(i),v(i))
       end do

       write(fmt,"(a,i0,a)") "(a,i0,",2*(n-2),"(1x,f0.3))"
       write(*,fmt) "=MUV> ",n-2,(u(i),v(i),i=3,n)
    end if

  end subroutine matchprint


  subroutine progress2(ns,ntot,xamin,xdmin,xfmin,id1,id2)

    use matcher
    use absfit
    use estimator

    integer, intent(in) :: ns,ntot
    integer, dimension(:), intent(in), optional :: id1,id2
    real(dbl), intent(in), optional :: xamin,xdmin,xfmin
    character(len=80) :: fmt,fm
    real(dbl), dimension(:), allocatable :: u,v
    integer :: n,m,i,i1,i2,i3
    real(dbl) :: ac,dc,sc,dsc,rot,drot,rms,amin,dmin,fmin,d3,refl, &
         xoff,yoff,dxoff,dyoff
    real(dbl), dimension(:), allocatable :: alpha,delta,x,y

    if( .not. plog ) return

    if( present(id2) ) then

       n = size(id2)

       allocate(u(n),v(n))

       ! FIT
       allocate(alpha(n),delta(n),x(n),y(n))
       do i = 1,n
          i1 = id1(i)
          i2 = id2(i)
          alpha(i) = astar(i1)
          delta(i) = dstar(i1)
          x(i) = xstar(i2)
          y(i) = ystar(i2)
       end do

       ac = acen
       dc = dcen
       call inestim(ptype,alpha,delta,xcen,ycen,x,y,ac,dc,sc,dsc,rot,drot, &
            refl,xoff,yoff,dxoff,dyoff,verbose)
       call absmin(ptype,alpha,delta,xcen,ycen,x,y,ac,dc,sc,dsc,rot,drot,refl,&
            0.0_dbl,0.0_dbl,0.0_dbl,0.0_dbl,rms,.false.)
       deallocate(alpha,delta,x,y)

       write(*,'(a,en15.3,en25.15,en25.15,4en25.15)') &
            "=MFIT> ",rms,sc,rot,ac,dc,xcen,ycen

       if( xdmin < 0.1*huge(xdmin) ) then
          amin = xamin
          dmin = xdmin
          fmin = xfmin
       else
          dmin = -1.0
          amin = -1.0
          fmin = -1.0
       end if

       do i = 3,n
          i1 = id2(i)
          i2 = id2(i - 1)
          i3 = id2(i - 2)
          call triangle(xstar(i3),ystar(i3),xstar(i2),ystar(i2), &
               xstar(i1),ystar(i1),d3,u(i),v(i))
       end do

       write(fmt,"(a,i0,a,i0,a)") "(a,3(1x,g0.7),1x,i0,",2*n,"(1x,f0.3),1x,i0,"
       m = n - 2
       write(fm,'(i0,a)') 2*(n-2),"(1x,f0.3))"

       fmt = trim(fmt)//fm
       write(*,fmt) "=MPROGRES2> ",amin,dmin,fmin,n, &
            (xstar(id2(i)),ystar(id2(i)),i=1,n),m,(u(i),v(i),i=3,n)
       deallocate(u,v)

    else
       write(*,'(a,2(1x,i0))') "=MPROGRESO> ",ns,ntot
    end if


  end subroutine progress2

  subroutine uvhist(x,y)

    use matcher

    integer, parameter :: nhist = 100

    real(dbl), dimension(:), intent(in) :: x,y
    integer, allocatable, dimension(:,:) :: hist
    real(dbl) :: u, v, d3
    integer :: i,j,k,m,n,c
    character(len=80) :: fmt

    allocate(hist(nhist,nhist))
    hist = 0

    ! the number of triangles is limited to enable an acceptable user response
    c = max(size(x)/137,1)

    do i = 1, size(x) - 2,c
       do j = i+1, size(x) - 1,c
          do k = j+1, size(x),c
             call triangle(x(i),y(i),x(j),y(j),x(k),y(k),d3,u,v)
             m = nint(nhist*u)
             n = nint(nhist*v)
             if( 1 <= m .and. m <= nhist .and. 1 <= n .and. n <= nhist ) &
                  hist(m,n) = hist(m,n) + 1
          end do
       end do
    end do

    write(fmt,'(a,i0,a)') "(a,1x,i0,1x,",nhist**2,"(1x,i0))"
    write(*,fmt) "=MTRI> ",nhist,hist

    deallocate(hist)

  end subroutine uvhist

end module astromatcher

!
!  time series of photometric quantities (light curves) extracted
!              from calibrated images
!
!  Copyright © 2012-4, 2018-20 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


program timeseries

  use savelcfits
  use fitscat
  use fitsts
  use titsio
  use iso_fortran_env

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)

  character(len=FLEN_FILENAME) :: output = 'timeserie.fits'
  character(len=FLEN_FILENAME) :: cat = ''
  character(len=FLEN_VALUE) :: timetype = 'JD' ! time type: JD,MJD,HJD,PHASE
  character(len=FLEN_VALUE) :: timestamp = 'MID' ! stamp: BEGIN, MID, END
  character(len=FLEN_VALUE) :: cootype = 'EQT'   ! coordinates EQT, RECT
  character(len=FLEN_FILENAME), dimension(:), allocatable :: files
  character(len=FLEN_KEYWORD), dimension(:), allocatable :: keys
  character(len=FLEN_VALUE), dimension(:), allocatable :: cols, coocols
  real(dbl), dimension(:), allocatable :: xcoo, ycoo
  character(len=FLEN_KEYWORD), dimension(5) :: fitskeys
  character(len=FLEN_VALUE) :: extname = PHOTOEXTNAME ! default data extension
  logical :: stdout = .false.    ! results to std.out.
  logical :: printname = .false. ! print filenames
  logical :: printtime = .true.  ! print time-like
  logical :: printhorizon = .false.  ! print horizonal coordinates
  logical :: printairmass = .false.  ! print air-mass
  logical :: verbose = .false.   ! be verbose
  real(dbl) :: tolerance = -1    ! cross-match tolerance
  real(dbl) :: lc_epoch = 0      ! reference time for phase
  real(dbl) :: lc_period = 1     ! period
  logical :: lc_set = .false.    ! light curve paramaters defined?
  logical :: status = .false.    ! output file state
  integer :: nvalid = 0          ! count of valid fitses
  logical :: cmatch = .true.     ! full star match for alls?
  logical :: keys_found = .true. ! full star match for alls?
  integer :: n,eq,ncoo,nfiles,ncols,ncoocols,nkeys,stat
  character(len=4*FLEN_FILENAME) :: record,key,val
  character(len=80) :: msg

  type(TSFits), dimension(:), allocatable :: fitses
  type(CatFits), allocatable :: cfits

  nfiles = 0
  ncoo = 0
  ncols = 0
  nkeys = 0
  allocate(cols(0),keys(0),xcoo(0),ycoo(0))

  ! default coordinates column labels
  ncoocols = 2
  allocate(coocols(2))
  coocols = [ FITS_COL_RA, FITS_COL_DEC ]

  ! mandatory keys
  fitskeys = [ FITS_KEY_DATEOBS, FITS_KEY_TIMEOBS, FITS_KEY_EXPTIME, &
       FITS_KEY_LONGITUDE, FITS_KEY_LATITUDE ]

  do
     read(*,'(a)',iostat=stat,iomsg=msg) record
     if( stat == IOSTAT_END ) exit
     if( stat > 0 ) then
        write(error_unit,*) trim(msg)
        error stop 'An input error.'
     end if

     eq = index(record,'=')
     if( eq == 0 ) error stop 'Malformed input record.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'OUTPUT' ) then

        read(val,*) output

     else if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'EXTNAME' ) then

        read(val,*) extname

     else if( key == 'NCOOCOL' ) then

        read(val,*) ncoocols
        deallocate(coocols)
        allocate(coocols(ncoocols))

     else if( key == 'COOCOL' ) then

        read(val,*) coocols

     else if( key == 'NCOL' ) then

        read(val,*) ncols
        deallocate(cols)
        allocate(cols(ncols))

     else if( key == 'COL' ) then

        read(val,*) cols

     else if( key == 'NKEY' ) then

        read(val,*) nkeys
        deallocate(keys)
        allocate(keys(nkeys))

     else if( key == 'KEY' ) then

        read(val,*) keys

     else if( key == 'COOTYPE' ) then

        read(val,*) cootype

     else if( key == 'TIMETYPE' ) then

        read(val,*) timetype

     else if( key == 'TIMESTAMP' ) then

        read(val,*) timestamp

     else if( key == 'NCOO' ) then

        read(val,*) ncoo

        deallocate(xcoo,ycoo)
        allocate(xcoo(ncoo),ycoo(ncoo))
        ncoo = 0

     else if( key == 'COO' ) then

        ncoo =  ncoo + 1
        read(val,*) xcoo(ncoo), ycoo(ncoo)

     else if( key == 'TOL' ) then

        read(val,*) tolerance

     else if( key == 'LC_EPOCH' ) then

        read(val,*) lc_epoch
        lc_set = .true.

     else if( key == 'LC_PERIOD' ) then

        read(val,*) lc_period
        lc_set = .true.

     else if( key == 'FITS_KEY_DATEOBS' ) then

        read(val,*) fitskeys(1)

     else if( key == 'FITS_KEY_TIMEOBS' ) then

        read(val,*) fitskeys(2)

     else if( key == 'FITS_KEY_EXPTIME'  ) then

        read(val,*) fitskeys(3)

     else if( key == 'FITS_KEY_LONGITUDE'  ) then

        read(val,*) fitskeys(4)

     else if( key == 'FITS_KEY_LATITUDE'  ) then

        read(val,*) fitskeys(5)

     else if( key == 'STDOUT' ) then

        read(val,*) stdout

     else if( key == 'PRINTNAME' ) then

        read(val,*) printname

     else if( key == 'PRINTTIME' ) then

        read(val,*) printtime

     else if( key == 'PRINTHORIZON' ) then

        read(val,*) printhorizon

     else if( key == 'PRINTAIRMASS' ) then

        read(val,*) printairmass

     else if( key == 'CATALOGUE' ) then

        read(val,*) cat

     else if( key == 'NFILES' ) then

        read(val,*) nfiles

        allocate(files(nfiles))
        nfiles = 0

     else if( key == 'FILE' ) then

        nfiles = nfiles + 1
        read(val,*) files(nfiles)

     end if

  end do

  if( nfiles == 0 ) stop 'No files on input.'

  if( .not. lc_set .and. timetype == 'PHASE' .and. verbose) &
       write(error_unit,*) &
       'Warning: Timetype PHASE invoked but light curve elements was not given.'

  ! read coordinates
  allocate(cfits)
  if( ncoo == 0 .and. cat /= '' ) then
     call cfits%Catalogue(cat)
     if( .not. cfits%status ) stop 'Failed to read a catalogue.'
  else if( ncoo > 0 .and. cat == '' )then
     call cfits%Coords(xcoo,ycoo)
  else !left it with defaults
     call cfits%ZeroInit()
  end if

  ! processsing
  allocate(fitses(nfiles))
  nvalid = 0
  do n = 1, nfiles
     call fitses(n)%Load(files(n),extname,fitskeys,keys,coocols,cootype, &
          cols,tolerance,cfits,verbose)
     if( fitses(n)%status ) then
        nvalid = nvalid + 1
        cmatch = fitses(n)%cmatch .and. cmatch
        keys_found = fitses(n)%key_found .and. keys_found
        if ( stdout ) then
           call fitses(n)%report(timetype,timestamp,lc_epoch,lc_period, &
                printname,printtime,printhorizon,printairmass)
        end if
     end if
  end do

  if( nvalid == 0 ) stop 'Error: There is no valid FITS file.'

  if( .not. cmatch .and. .not. verbose) write(error_unit,*) &
       "Warning: One or more stars not found. Use --verbose for details."

  if( .not. keys_found .and. .not. verbose ) write(error_unit,*) &
       "Warning: One or more keywords not found. Use --verbose for details."

  ! save data
  call savelc(output,fitses,timetype,timestamp,cfits,cols, &
       lc_epoch,lc_period,printname,printtime,printhorizon,printairmass,status)

  deallocate(fitses,cfits,files,keys,cols,coocols,xcoo,ycoo)

  if( status ) then
     stop 0
  else
     stop 'An error occurred during timeseries session.'
  end if

end program timeseries

!
! gfortran -Wall -g -p -no-pie -fcheck=all cfitsio.f08 fitsio.f08 \
!	 -o artpsf artpsf.f08 -lcfitsio -lm

!  Copyright © 2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program artpsf

  use fitsio
  use iso_fortran_env

  implicit none
  integer, parameter :: width = 16
  integer, parameter :: height = width
  integer, parameter :: i0 = width / 2
  integer, parameter :: j0 = height / 2
  integer :: status, nelements, i, j
  real, dimension(width,height) :: psf
  type(fitsfiles) :: fits
  real(REAL64) :: s
  real, parameter :: sigma = 1

  ! generate gaussian
  do i = 1, width
     do j = 1, height
        psf(i,j) = exp(-((i - i0)**2 + (j - j0)**2)/sigma**2)
     end do
  end do

  ! normalisation
  s = sum(psf)
  psf = real(psf / s)

  status = 0
  nelements = width*height
  call fits_create_file(fits,'!artpsf.fits',status)
  call fits_insert_img(fits,-32,2,[width,height],status)
  call fits_write_key(fits,'ZOOM',4,'',status)
  call fits_write_img(fits,1,1,nelements,pack(psf,.true.),status)
  call fits_close_file(fits,status)
  call fits_report_error(error_unit,status)

end program artpsf

!
! tester - astrometry
!
!
! $ gfortran -Wall -g -p -fbounds-check -fimplicit-none projections.f95 atrafo.f95 \
!            lsfit.f95 tester.f95 -L../lib -lminpack -lm
!
! Copyright © 2011-2 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program tester

  use astrotrafo
  use lsfit
  use absfit
  use robfit
  use robustmean

  implicit none

  character(len=*), parameter :: type = 'GNOMONIC'
  integer, parameter :: ns = 9999
  integer, parameter :: dbl = selected_real_kind(15)
  real(dbl), dimension(ns) :: x,y,a,d,a2,d2,x0,y0,dx,dy
  real(dbl), parameter :: a0 = 330.0, d0 = 3.0, r = 0.6
  real(dbl), parameter :: scale0 = 1.e3, pa0 = 0.0
  real(dbl), parameter :: w = 1000, h = 800
  real, parameter :: ge = (1.0/3600.0)*scale0

  real(dbl) :: q,acen,dacen,dcen,ddcen,sc,dsc,pa,dpa,rms,s0,sres,mad,u,v
  integer :: i
  type(TypeProjection) :: t



!  do i = 1,100
!     write(*,*) i/100.0,invdist(i/100.0),0.5*erf(x/sqrt(2.0))+0.5
!  end do
!  stop

  do i = 1,ns
     x(i) = gnoise(0.0,1.0)
!     write(*,*) x(i)
  end do

  call histogram(x,'ds')
  
  call rmean(x,u,v)
  write(*,'(3f10.3)') sqrt(sum(x**2)/ns),sum(abs(x))/ns,v*sqrt(real(ns))
  stop


  do i = 1, ns
     call random_number(q)
     a(i) = a0 + r*(q - 0.5) 
     call random_number(q)
     d(i) = d0 + r*(q - 0.5)
  end do

  t%type = type
  t%acen = a0
  t%dcen = d0
  t%xcen = w/2.0
  t%ycen = h/2.0
  t%scale = scale0
  t%pa = pa0

  call trafo(t,a,d,x0,y0)

  do i = 1, ns
     x(i) = x0(i) + gnoise(0.0,ge)
     y(i) = y0(i) + gnoise(0.0,ge)
!     write(*,*) gnoise(0.14),gnoise(0.14)
!     write(*,'(a,e25.15)') '>', (1.0-ee)*gnoise(0.0,ge)+ee*gnoise(0.0,ge*3.0)
  end do

!  stop

  do i = 1,ns
     write(*,'(2f10.5,2f20.3,2f10.5)') a(i),d(i),x(i),y(i)
  end do

  acen = a0+0.1
  dcen = d0-0.1
  sc = 1.0
  pa = 0
  call lsmin(type,a,d,w/2.0,h/2.0,w,h,x,y,acen,dacen,dcen,ddcen,sc,dsc,pa,dpa,rms,s0,.true.)
!  call absmin(type,a,d,w/2.0,h/2.0,w,h,x,y,acen,dcen,sc,pa,rms,s0,.true.)
  mad = rms
!  call robmin(type,a,d,w/2.0,h/2.0,w,h,x,y,mad,acen,dacen,dcen,ddcen,sc,dsc,pa,dpa,rms,s0,.true.)

  write(*,99) acen,dacen,dacen/acen
  write(*,99) dcen,ddcen,ddcen/dcen
  write(*,99) sc,dsc,dsc/sc
  write(*,99) pa,dpa,dpa/pa
  write(*,*) rms,rms*3600
  write(*,*) s0,s0*3600
99 format(f20.10,'+-',f20.10,'  ',1es20.5)

  ! residuals
  t%acen = acen
  t%dcen = dcen
  t%scale = sc
  t%pa = pa
  sres = 0.0
  call invtrafo(t,x,y,a2,d2)
  do i = 1,ns
     write(*,'(2f10.5,2f10.5,2f8.3)') a(i),d(i),a2(i),d2(i), &
          3600*(a(i)-a2(i))/cos(dcen/57.3),3600*(d(i)-d2(i))
     sres = sres + ((a(i) - a2(i))/cos(dcen/57.3))**2 + (d(i) - d2(i))**2
     dx(i) = 3600*(a(i)-a2(i))/cos(dcen/57.3)
     dy(i) = 3600*(d(i)-d2(i))
  end do

  write(*,*) sqrt(sres/ns/2.0)*3600.0

  call histogram(dx,'histx')
  call histpgram(dy,'histy')


contains

   function gnoise(t,s)

    real :: gnoise
    real :: x,t,s
    real :: e,ee = 0.1

    call random_number(e)
    call random_number(x)
    if( e < ee ) then
       gnoise = 3.0*s*invdist(x)
    else
       gnoise = s*invdist(x)
    end if
!    gnoise = 0.5*erf(x/sqrt(2.0)/s)+0.5
    

  end function gnoise


  function invdist(xx)

    real :: invdist,xx

    ! rational approximation of an inverse to a cumulative function
    ! of Gaussian distribution  with precision better than 0.00045
    ! J.Andel: Statistical methods, Matfyz Press, Prague 1991
    
    real :: w,f,x
    logical :: interval

    x = xx
    if( x < 0.0 ) then
       invdist = 0.0
    elseif( x > 1.0 )then
       invdist = 1.0
    else
       interval = x < 0.5
       if( .not. interval ) x = 1.0 - x + epsilon(1.0)
       w = sqrt(-2.0*log(x));
       f = -w + (2.515517 + w*(0.802853 + w*0.010328))/ &
            (1.0 + w*(1.432788 + w*(0.189269 + w*0.001308)));
       if( interval ) then
          invdist = f
       else
          invdist = -f
       endif
    endif
    
  end function invdist

  
  subroutine histogram(x,name)

    character(len=*) :: name
    real(dbl), dimension(:) :: x

    integer, parameter :: nhist = 99
    integer, dimension(nhist) :: hist
    real(dbl), dimension(nhist) :: bins
    real(dbl), parameter :: h = 0.2
    integer :: i,j
    real(dbl) :: ss

    do i = 1, nhist
       bins(i) = h*(i - nhist/2)
!       write(*,*) i,bins(i)
    end do

  
    hist = 0
    do i = 1,size(x)
       do j = 2,nhist
          if( bins(j-1) < x(i) .and. x(i) <= bins(j)) hist(j) = hist(j) + 1
       end do
    end do

    open(1,file=name)
    ss = sum(hist)*h
    do i = 1,nhist
       write(1,*) bins(i)-h/2.0,hist(i)/ss
    end do
    close(1)

  end subroutine histogram


end program tester

!
!  robust ratio
!
!  Copyright © 2012 - 2017 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

module robratio

  ! This module provides subroutines for estimation of a mean ratio
  !
  !     t =  pht / cts
  !
  ! including estimation of its scatter.
  !
  ! rcal should be called as:
  !
  !  call rcal(pht,dpht,cts,dcts,t,dt,verbose,reliable,poisson)
  !
  ! on input:
  !   pht - array of reference (from a catalogue) number of photons
  !   dpht - array of statistical errors of pht
  !   cts - array of observed number of photons
  !   dcts - array of statistical errors of cts
  !   verbose - print additional info
  !
  ! on output are estimated:
  !   t - robust ratio
  !   dt - its standard error
  !   reliable - indicates reliability of results (optional)
  !   poisson - indicates Poisson (.true.) or Normal (.false.)
  !             distribution used for determine of results (optional)
  !
  ! The given results  means that a true value T of the sample pht/cts can be,
  ! with 70% probability, found in interval
  !
  !         t - dt  <  T  <  t + dt
  !
  ! The estimate is performed as maximum of entropy of Poisson density
  ! for values of pht smaller than 'plimit' (666) or by robust estimate
  ! of parameters of Normal distribution. Both the estimates are robust.
  ! Poisson mean is estimated on minimum of free energy:
  ! https://en.wikipedia.org/wiki/Helmholtz_free_energy

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

  ! verbose, updated by calling rcal()
  logical, private :: verbose = .false.

  ! which method of estimate of the ratio will be used?
  integer, parameter, private :: method = 2

  ! debuging
  logical, parameter, private :: debug = .false.

  ! Hessians are computed by analytic or numerical way
  logical, parameter, private :: analytic = .true.

  integer, parameter, private :: maxit = precision(0.0_dbl)
  ! Number of iterations is limited by numerical precision.
  ! We belives, as optimists, that one order is reached by each iteration.
  ! But, the pesimist, inside us, says that the convergence can be slower.

  ! Tolerances in numerical precision of iterations
  real(dbl), parameter, private :: tol = 10*epsilon(1.0_dbl)

  ! Limit for use of Poisson statistics (Normal otherwise)
  integer, parameter, private :: plimit = 666

  ! Parameter for regularisation
  real(dbl), private :: reg

  ! working arrays
  real(dbl), dimension(:), allocatable, private :: cts,dcts,pht,dpht,res, &
       dcts2,dpht2
  real(dbl), private :: xctph, sigma, rmin, rmax

  private :: fundif, funder, loglikely, residuals, residuals2, difjac, &
       jacobian_analytic, rnewton, snoise, snoise1, rcal2, rcal1, rcal0, &
       pnoisemin, entropy, rinit, ratiomin, zmean, zfun, pmean, negfree, &
       rmean_graph, poisson_graph, snoise_graph, graph, nscale

  ! implemened both single and double precision
  interface rcal
     module procedure rcal_double, rcal_single
  end interface rcal

contains

  subroutine rcal_double(xpht,xdpht,xcts,xdcts,ctph,dctph,verb,xreliable, &
       xpoisson)

    use rfun
    use weightedmean
    use medians

    real(dbl), dimension(:), target, intent(in) :: xpht,xdpht,xcts,xdcts
    real(dbl), intent(in out) :: ctph,dctph
    logical, optional, intent(in) :: verb
    logical, optional, intent(out) :: xreliable, xpoisson

    integer :: ndat,n,i,nplus,nstep
    real(dbl) :: d,c,r,w,sig,t0,s0,regold,sigold
    logical :: reliable, poisson, convergent

    if( present(verb) ) verbose = verb

    reliable = .false.
    poisson = .false.

    ndat = size(xpht)

    if( ndat < 1 ) then                ! no data
       ctph = 1
       dctph = 0
       return
    endif

    if( ndat == 1 ) then               ! single point only
       ctph = xpht(1) / xcts(1)
       dctph = 1
       return
    endif

    ! data check
    if( .not. (all(xpht > 0) .and. all(xcts > 0) .and. all(xdpht > 0) .and. &
         all(xdcts > 0) ) ) &
         stop 'robratio.f08: rcal got invalid data (negative or zero counts).'
    if( size(cts) /= size(pht) ) stop 'robratio.f08: size(cts) /= size(pht)'
    if( size(dcts) /= size(dpht) ) stop 'robratio.f08: size(dcts) /= size(dpht)'
    if( size(cts) /= size(dcts) ) stop 'robratio.f08: size(cts) /= size(dcts)'
    if( size(pht) /= size(dpht) ) stop 'robratio.f08: size(pht) /= size(dpht)'

    allocate(pht(ndat),cts(ndat),dpht(ndat),dcts(ndat),res(ndat),&
         dpht2(ndat),dcts2(ndat))
    pht = xpht
    cts = xcts
    dpht = xdpht
    dcts = xdcts
!    dpht = sqrt(pht)
!    dcts = sqrt(cts)
    dpht2 = dpht**2
    dcts2 = dcts**2

    ! determine range for ratio
    rmin = minval(pht/cts)
    rmax = maxval(pht/cts)

    ! no regularisation
    reg = 0

    i = max(int(log10(real(ndat))) - 1,0)
    nstep = 10**i
    if( verbose .and. nstep > 1 ) write(*,'(a,i0,a)') &
         'Warning: printing only every ',nstep,'th datapoint.'

    ! initial estimate of ctph and spread, by absolute values
    call rinit(ctph,sig)
    call residuals(ctph,res)

    if( verbose ) then
       write(*,*) 'Data table: pht(i),dpht(i),cts(i),dcts(i), ratio, residuals'
       do i = 1,ndat,nstep
          r = pht(i) / cts(i)
          write(*,'(i3,1p,2(g15.5,g10.3),0pf11.3,f10.3)') &
               i,pht(i),dpht(i),cts(i),dcts(i),r,res(i)
       end do
       write(*,'(a50,1pg15.5,1x,0pg8.2)') &
            "Initial ctph, sig by min. of absolute deviations:",ctph,sig
    end if

    ! singular data
    if( abs(sig) < tol ) then
       if( verbose ) write(*,*) &
            '(!) Skipping robust estimation -- singular data.'
       dctph = 0
       reliable = .true.
       goto 666
    end if


    ! update sig by entropy
!    sig = snoise(ctph,sig)


    ! Solvers
    select case(method)

    case(0)
       ! maximum likelihood
       call rcal0(ctph,dctph,sig)

    case(1)
       ! Scale by entropy, ratio by maximum likelihood
       call rcal1(ctph,dctph,sig)

    case(2)
       ! Poisson (for low counts), Normal otherwise with var() ~= 1

!       call rcal3(ctph,dctph,sig,reliable,poisson)

       t0 = ctph
       s0 = sig

       sigold = -1
       do i = 0,666,10
          reg = i
          call rcal2(ctph,sig,reliable,poisson)
!          write(*,*) reg,ctph,sig
          if( sig < 1 ) exit
          sigold = sig
          regold = reg
       end do
       ! solve reg. parameter by linear interpolation to the condition sig=1
       if( sigold > 0 .and. abs(sig - sigold) > epsilon(sig) ) then
          reg = regold + (1 - sigold)*(reg - regold)/(sig - sigold)
          call rcal2(ctph,sig,reliable,poisson)
       end if

       if( verbose ) &
            write(*,'(a50,1pg15.3)') 'Regularisation parameter:',reg

       if( reliable ) then

          t0 = ctph
          s0 = sig

          call rnewton(ctph,dctph,sig,convergent)

          reliable = convergent .and. (rmin <= ctph .and. ctph <= rmax)

          if( verbose ) write(*,'(a50,1pg15.5,1x,0pg8.2,l3)') &
               'Robust mean by Newton with std.err.:',ctph,dctph,convergent
       end if

       if( .not. reliable ) then
          ctph = t0
          sig = s0
          dctph = sig * ctph * median(sqrt(ctph**2*dcts2 + dpht2)) / &
               (0.6745 * median((cts*ctph + pht)/2))
!          dctph = median(sig*sqrt(t**2*dcts**2 + dpht**2)) / 0.6745
       end if

    case default
       ! No default is here, initial estimates will be used
       continue

    end select

666 continue

    ! residual sum
    if( verbose ) then
       call residuals(ctph,res)
       write(*,*) '# photons, computed counts, rel.err, expected rel.err, res., huber, dhuber:'
       do i = 1,ndat,nstep
          c = ctph*cts(i)
          d = (pht(i) - c)/((pht(i) + c)/2)
          w = sqrt((dpht(i)/ctph)**2 + dcts(i)**2)/((cts(i) + pht(i)/ctph)/2.0)
          if( sig > 0 ) then
             r = res(i) / sig
          else
             r = 0
          end if
          write(*,'(i3,1p2g13.4,0p2f10.5,3f8.3)') &
               i,pht(i),c,d,w,r,huber(r),dhuber(r)
       enddo
       n = count(abs(res) < sig)
       nplus = count(res > 0)
       write(*,'(a,g0.5,a,1pg0.1,a,5x,a,g0.3)') &
            'ctph = ',ctph,' +- ',dctph,',','sig = ',sig
       write(*,'(a,i0,a,i0,a,f0.1,a)') &
            'Points within 1-sigma error interval: ', &
            n,'/',ndat,' (',100.*real(n)/real(ndat),'%)'
       write(*,'(a,i0,"/",f0.1,",   ",i0,"+-",f0.1)') &
            'Sign test (total/expected, +):  ',&
            ndat,ndat/2.0,nplus,sqrt(nplus*0.25)
       ! Test whatever the errors corresponds to values to prove
       ! Poisson's origin. It is quantity like
       ! https://en.wikipedia.org/wiki/Index_of_dispersion
       write(*,'(a,2(1x,g0.3,1x,a,:","))') 'Mean Poissonity (best=1): ',&
            sqrt(sum(dpht**2/pht)/ndat),'(reference)', &
            sqrt(sum(dcts**2/cts)/ndat),'(data)'
    end if

    deallocate(res,pht,cts,dpht,dcts,dpht2,dcts2)

    if( present(xreliable) ) xreliable = reliable
    if( present(xpoisson) ) xpoisson = poisson

  end subroutine rcal_double

  subroutine rcal_single(xpht,xdpht,xcts,xdcts,ctph,dctph,xverb,xreliable,&
       xpoisson)

    real, dimension(:), target, intent(in) :: xpht,xdpht,xcts,xdcts
    real, intent(in out) :: ctph,dctph
    logical, optional, intent(in) :: xverb
    logical, optional, intent(out) :: xreliable, xpoisson

    logical :: verb,reliable,poisson
    real(dbl) :: t,dt
    real(dbl), dimension(:), allocatable :: pht,dpht,cts,dcts
    integer :: n

    if( present(xverb) ) then
       verb = xverb
    else
       verb = .false.
    end if

    if( size(xcts) /= size(xpht) ) &
         stop 'robratio.f08, single: size(cts) /= size(pht)'
    if( size(xdcts) /= size(xdpht) ) &
         stop 'robratio.f08, single: size(dcts) /= size(dpht)'
    if( size(xcts) /= size(xdcts) ) &
         stop 'robratio.f08, single: size(cts) /= size(dcts)'
    if( size(xpht) /= size(xdpht) ) &
         stop 'robratio.f08, single: size(pht) /= size(dpht)'

    n = size(xpht)
    allocate(pht(n),dpht(n),cts(n),dcts(n))
    pht = xpht
    dpht = xdpht
    cts = xcts
    dcts = xdcts

    call rcal_double(pht,dpht,cts,dcts,t,dt,verb,reliable,poisson)
    ctph = real(t)
    dctph = real(dt)

    if( present(xreliable) ) xreliable = reliable
    if( present(xpoisson) ) xpoisson = poisson

    deallocate(pht,dpht,cts,dcts)

  end subroutine rcal_single



  subroutine residuals(t,r)

    real(dbl), intent(in) :: t
    real(dbl), dimension(:), intent(out) :: r
    real(dbl) :: t2

    t2 = t**2

!    r = (pht - t*cts) / sqrt(t**2*dcts**2 + dpht**2)
!    r = (pht - t*cts) / sqrt(t2*dcts2 + dpht2 +  (pht+t*cts)/2*  reg**2)
    r = (pht - t*cts) / sqrt(t2*dcts2 + dpht2 +  pht*  reg**2)
!    r = (pht - t*cts) / (dcts*sqrt(t) + dpht)

!    write(*,*) pht(1),cts(1),dcts2(1),dpht2(1),r(1),t,&
!         (pht(1)-t*cts(1))/sqrt(t2*dcts2(1)+dpht2(1)),t2,r(1)

  end subroutine residuals

  subroutine residuals2(t,r,ds)

    real(dbl), intent(in) :: t
    real(dbl), dimension(:), intent(out) :: r,ds
    real(dbl) :: t2

    t2 = t**2
    !    r = (pht - t*cts) / sqrt(t**2*dcts**2 + dpht**2)
!    ds = sqrt(t2*dcts2 + dpht2 + (pht+t*cts)/2* reg**2)
    ds = sqrt(t2*dcts2 + dpht2 + pht* reg**2)
    r =  (pht - t*cts) / ds
!    ds = dcts*sqrt(t) + dpht
!    r = (pht - t*cts) / ds

  end subroutine residuals2


  ! --------------------------------------------------------

  subroutine rcal2(ctph,sig,reliable,poisson)

    use rfun

    real(dbl), intent(in out) :: ctph, sig
    logical, intent(out) :: reliable,poisson

    integer :: n
    real(dbl) :: t,dt,s,s0,t0
    logical :: reli, treli, sreli

    n = size(pht)
    t = ctph
    s = sig

    if( maxval(pht) < plimit ) then
       poisson = .true.

       call pmean(ctph)
       dt = sig

       reliable = .true.
    else

       t0 = t
       s0 = s
       reliable = .false.

       call zmean(t,s,treli)
       call nscale(t,s,sreli)
       reli = treli .and. sreli
!       s = snoise(t,s)

       if( verbose ) write(*,'(a50,1pg15.5,1x,0pg8.2,1x,2l1)') &
            'Robust mean estimation, sig by entropy:',t,s,treli,sreli

       reliable = reli .and. (rmin <= t .and. t <= rmax)

       if( reliable ) then
          ctph = t
          sig = s
       else
          ctph = t0
          sig = s0
       end if

    end if

    if( debug ) then
       call snoise_graph(ctph,sig)
       call rmean_graph(ctph-3*sig,ctph+5*sig,sig)
       call poisson_graph
    end if

  end subroutine rcal2

!!$  subroutine rcal3(ctph,dctph,sig,reliable,poisson)
!!$
!!$    use rfun
!!$    use medians
!!$    use fmm
!!$
!!$    real(dbl), intent(in out) :: ctph, sig
!!$    real(dbl), intent(out) :: dctph
!!$    logical, intent(out) :: reliable,poisson
!!$    real(dbl), parameter :: tol = 1e-2
!!$    real(dbl), parameter :: regmin = 0
!!$    real(dbl), parameter :: regmax = 1e3
!!$
!!$    sigma = sig
!!$    xctph = ctph
!!$!    sig = fmin(regmin,regmax,sigfun,tol)
!!$    sig = zeroin(regmin,regmax,sigfun,tol)
!!$
!!$    ctph = xctph
!!$    call rcal2(ctph,dctph,sig,reliable,poisson)
!!$
!!$  end subroutine rcal3
!!$
!!$  function sigfun(r)
!!$
!!$    real(dbl) :: sigfun
!!$    real(dbl), intent(in) :: r
!!$    real(dbl) :: ctph,dctph, s
!!$    logical :: reliable,poisson
!!$
!!$    reg = r
!!$!    s = sig
!!$    call rcal2(xctph,dctph,sigma,reliable,poisson)
!!$    xctph = ctph
!!$    sigfun = sigma - 1
!!$
!!$  end function sigfun

  subroutine rcal1(ctph,dctph,sig)

    real(dbl), intent(in out) :: ctph, sig
    real(dbl), intent(out) :: dctph

    integer :: iter
    real(dbl) :: t,dt,s,t1
    logical :: convergent

    t = ctph
    s = sig
    t1 = huge(t)

    do iter = 1,maxit

       ! precision of mean improved with the updated scale
       call rnewton(t,dt,s,convergent)

       convergent = abs(t - t1) < tol .and. convergent
       if( convergent ) exit

       s = snoise(t,s)
       t1 = t
    end do

    if( convergent ) then
       ctph = t
       dctph = dt
       sig = s
    else
       dctph = -1
    end if

    if( .not. convergent .and. verbose ) &
         write(*,*) &
         "Warning: Likelihood and entropy iterations shows no convergence!"

    if( debug ) call snoise_graph(ctph,sig)

  end subroutine rcal1


  subroutine rnewton(t,dt,s,convergent)

    use rfun

    real(dbl), intent(in out) :: t
    real(dbl), intent(out) :: dt
    real(dbl), intent(in) :: s
    logical, intent(out) :: convergent

    integer :: n,iter
    real(dbl) :: xtol,d,f,df,f2
    real(dbl), dimension(:), allocatable :: r,psi,dpsi,ds,rs,ds2

    convergent = .false.

    if( .not. (s > 0) ) return

    n = size(pht)
    allocate(r(n),psi(n),dpsi(n),ds(n),rs(n),ds2(n))

    ! tolerance limit will depends on number of elements in sums
    ! because every element can include its rounding error...
    ! ... proportional to absolute value ...
    xtol = n*tol*abs(t)

    do iter = 1, maxit

       ! solution of f(t) = 0, where f(t) = sum(psi((n-t*c)/(s*ds))
       call residuals2(t,r,ds)
       rs = r / s
       ds2 = ds**2
       call tukeys(rs,psi)
       call dtukeys(rs,dpsi)

       f = t*sum((psi*r-1.0_dbl)*(dcts/ds)**2) + sum(psi*cts/ds)
       df = sum(dpsi*(cts/ds + r*t*dcts2/ds2)**2) &
            -sum(psi*(pht - 3*t*cts)*(dcts/ds)**2/ds) &
            +sum(psi*3*r*t**2*(dcts/ds)**4) &
            +sum((dcts/ds)**2) - 2*t**2*sum((dcts2/ds2)**2)

       if( abs(df) < epsilon(df) ) exit

       ! corrector for mean
       d = s * f / df

       ! update location
       t = t + d

       if( debug ) write(*,'(a,i2,1pg20.10,1p3g12.3)') &
            "mean, incr., f, f': ",iter,t,d,f,df

       convergent = abs(d) < xtol

       ! exit of iterations: the absolute errot must be at least |d| < tol
       if( convergent ) exit

    enddo

    f2 = sum(psi**2)  ! mean of psi**2
    df = df * s**2
!    write(*,*) f2,d,df
    if( convergent .and. df > 0 .and. f2 > 0 ) then
       dt = s*sqrt(f2/df**2*n/(n-1)) ! df is an element of Jacobian
    end if

    deallocate(r,psi,dpsi,ds,rs,ds2)

  end subroutine rnewton

  subroutine nscale(t,s,reli)

    use entropyscale

    real(dbl), intent(in) :: t
    real(dbl), intent(in out) :: s
    logical, intent(out) :: reli
    real(dbl), dimension(:), allocatable :: r
    integer :: n

    n = size(pht)
    allocate(r(n))
    call residuals(t,r)
    call escale(r,s,reli)
    deallocate(r)

  end subroutine nscale

  function snoise(t,s)

    use fmm

    real(dbl), intent(in) :: t,s
    real(dbl) :: snoise

    real(dbl), dimension(:), allocatable :: r
    real(dbl) :: stol,smin,smax
    integer :: n

    stol = 1e-3
    smin = max(s / 10, epsilon(s))
    smax = min(s * 10, (rmax - rmin)/2)

    n = size(pht)
    allocate(r(n))
    call residuals(t,r)
    smin = minval(abs(r))
    smax = maxval(abs(r))
    deallocate(r)
    xctph = t
    snoise = fmin(smin,smax,pnoisemin,stol)

  end function snoise

  function pnoisemin(s)

    real(dbl), intent(in) :: s
    real(dbl) :: pnoisemin

    pnoisemin = - entropy(xctph,s)

  end function pnoisemin

  function entropy(t,s)

    use rfun

    real(dbl), parameter :: expmax = log(huge(1.0_dbl)/2.1)

    real(dbl), intent(in) :: t,s
    real(dbl) :: entropy
    real(dbl), dimension(:), allocatable :: r,rho
    integer :: n

    n = size(pht)
    allocate(r(n),rho(n))

    call residuals(t,r)
    call ihubers(r/s,rho)
    entropy = sum(rho*exp(-2*rho),rho < expmax)
    deallocate(r,rho)

  end function entropy



  subroutine snoise1(t,sig)

    ! Estimate of maximum entropy by Newton's method
    ! While, I'd pin one's hopes on the method, it does not stands
    ! many common data (convergence is occurred only for ideal data). Perhaps,
    ! there are __numerical problems__ in evaluations of exponential functions.
    ! Or, it is bad idea to do derivate of its derivative.

    use rfun

    real(dbl), intent(in) :: t
    real(dbl), intent(in out) :: sig

    integer :: n,iter
    real(dbl) :: s,sum1,sum2,fs,dfs,d
    real(dbl), dimension(:), allocatable :: r,f,df,rho,erho
    logical :: convergent

    n = size(pht)
    allocate(r(n),rho(n),df(n),f(n),erho(n))

    s = sig
    convergent = .false.

    do iter = 1, maxit

       if( .not. (s > 0) ) exit

       call residuals(t,r)
       call ihubers(r/s,rho)
       call hubers(r/s,f)
       call dhubers(r/s,df)

!       rho = (r/s)**2/2
!       f = r/s
!       df = 1

       erho = exp(-2*rho)
       sum1 = sum(f*r*(1-2*rho)*erho)
       sum2 = sum(((1-2*rho)*(2*f**2-df) + 2*f**2)*r**2*erho)

       fs = -sum1 / s**2
       dfs = 2*sum1 / s**3 - sum2 / s**4

       ! Note. If we have good initial estimate, than sum1 (=fs) is near to zero
       ! and sum1 / sum2 * s**2 is numerically equivalent, but little bit
       ! faster, than fs/dfs. Their numerical difference is negligible.

       if( .not. (abs(dfs) > 0) ) exit

       ! Newton's step for scale
       d = fs / dfs
       s = s - d

       if( debug ) write(*,'(a,i3,4g15.5)') "scale,f,f',incr.",iter,s,d,fs,dfs

       ! exit immediately when required precision is reached
       convergent = abs(d) < 10*epsilon(sig)
       if( convergent ) exit

    end do

    deallocate(r,f,df,rho,erho)

    if( convergent ) sig = s

    if( debug ) call snoise_graph(t,s)

  end subroutine snoise1



  ! --------------------------------------------------------

  subroutine rcal0(ctph,dctph,sig)

    use rfun
    use minpacks
    use neldermead

    real(dbl), intent(in out) :: ctph,sig
    real(dbl), intent(out) :: dctph

    integer :: ndat,i,info,nprint,icount,numres,ifault,nwins
    real(dbl) :: c,s,log0,wsig,sum2,sum3,reqmin
    real(dbl),dimension(:), allocatable :: p,dp
    real(dbl),dimension(2,2) :: jac, hess
    real(dbl),dimension(2) :: u,u0,du

    if( verbose ) then
       nprint = 1
    else
       nprint = 0
    end if

    ndat = size(pht)

    ! winsorisation at x-sigma
    if( verbose ) write(*,'(a,f3.1,a)') 'Winsorisation at ',winscut, &
         " for pht, ctph*cts, dpht, residual in sigma, replacement: "
    nwins = 0
    call residuals(ctph,res)
    do i = 1,ndat
       if( abs(res(i)) > winscut ) then
          nwins = nwins + 1
          wsig = - sign(winscut,res(i))
          c = max(pht(i) + wsig*sqrt(dpht(i)**2+ctph**2*dcts(i)**2),0.0)
          if( verbose ) &
               write(*,'(i3,1p2g15.5,g12.2,1pg11.3,g15.5)') &
               i,pht(i),ctph*cts(i),dpht(i),res(i),c
          cts(i) = c / ctph
       end if
    end do

    ! locate proper solution
    ! Approximate location of -log(L), the function has one global minimum
    du(1) = 0.1*ctph
    du(2) = 0.1*sig
    u = (/ctph, sig/)
    u0 = u
    reqmin = epsilon(reqmin)
    call nelmin(loglikely,size(u),u0,u,log0,reqmin,du,1,10000,icount,numres,ifault)
    if( verbose ) write(*,'(a,2i6,3g15.5)') 'Log-likelihood solution: ',ifault,icount,u

    if( ifault /= 0 ) then
       if( verbose ) write(*,*) "Finished prematurely without likelihood convergence."
       goto 666
    endif


    s = u(2)
    ctph = u(1)
    dctph = s/sqrt(real(ndat))

    if( verbose ) write(*,'(a,2g10.5,i6)') &
         'ctph, s (winsorising and robust applied): ',ctph,s,nwins

    ! solution of psi( (pht(i) - ctph*cts(i)) / s*sqrt(..)
    if( verbose ) write(*,'(4(6x,a2,7x))') 't','s','f1','f2'
    if( analytic ) then
       call lmder2(funder,u,epsilon(u),nprint,info)
    else
       call lmdif2(fundif,u,epsilon(u),nprint,info)
    end if

    if( verbose ) then
       write(*,*) 'Analytic jacobian: ',analytic
       write(*,*) 'Minpack info:',info
    end if

    if( info /= 5 ) then

       ctph = u(1)
       s = u(2)
       sig = huber_sigcorr*sig

       call jacobian_analytic(u,jac)
       call qrinv(jac,hess)

       if( verbose ) then
          write(*,*) 'jac:',real(jac(1,:))
          write(*,*) 'jac:',real(jac(2,:))
          write(*,*) 'hess:',real(hess(1,:))
          write(*,*) 'hess:',real(hess(2,:))
       end if

       ! estimate errors
       if( hess(1,1) > 0 .and. ndat > 1 ) then
          allocate(p(ndat),dp(ndat))
          call residuals(ctph,res)
          call hubers(res/s,p)
          call dhubers(res/s,dp)
          sum2 = sum(dp)
          sum3 = sum(p**2)
          if( sum2 > 0 .and. sum3 > 0 ) then
             dctph = s*sig*ndat*sqrt(sum3/sum2/(ndat-1.0)*hess(1,1))
          end if
          deallocate(p,dp)
       else
          dctph = -1
       end if

    else

       if( verbose ) write(*,*) "Finished prematurely without convergence in gradient."

    end if

666 continue

  end subroutine rcal0



  subroutine fundif(m,np,p,fvec,iflag)

    use rfun

    integer, intent(in) :: m,np
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(:), allocatable :: r,f,ds
    real(dbl), dimension(2,2) :: jac
    real(dbl), dimension(2) :: fv
    integer :: n
    real(dbl) :: t,s

    if( iflag == 0 ) then

       write(*,'(4g15.5)') p,fvec

       if( debug ) then
          n = 2
          call funder(2,2,p,fv,jac,2,n)
          write(*,*) ' jac:',jac(1,:)
          write(*,*) ' jac:',jac(2,:)

       end if
       return

    end if

    n = size(pht)
    allocate(r(n),f(n),ds(n))
    t = p(1)
    s = p(2)

!    ds = sqrt(t**2*dcts**2 + dpht**2)
    ds = sqrt(t**2*dcts2 + dpht2)
    r = (pht - t*cts)/ds
    r = r / s

    call hubers(r,f)
!    f = r

    fv(1) = sum(f*(cts*dpht2 + pht*t*dcts2)/ds**3) - s*t*sum(dcts2/ds**2)
!    fv(1) = sum(f*(cts*dpht**2 + pht*t*dcts**2)/ds**3) - s*t*sum(dcts**2/ds**2)
    fv(2) = sum(f*r) - n

    fvec = fv / s

    deallocate(r,f,ds)

  end subroutine fundif


  subroutine funder(m,np,p,fvec,fjac,ldfjac,iflag)

    use rfun

    integer, intent(in) :: m,np,ldfjac
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
    real(dbl), dimension(:), allocatable :: r,f,df,ds,ds2,cs,dd,d1s,d2s
    real(dbl), dimension(2,2) :: dfjac
    integer :: n
    real(dbl) :: t,s

    if( iflag == 0 ) then
       write(*,'(4g15.5)') p,fvec

       if( debug ) then
          write(*,*) ' jac:',fjac(1,:)
          write(*,*) ' jac:',fjac(2,:)

          call difjac(p(1),p(2),dfjac)
          write(*,*) 'djac:',dfjac(1,:)
          write(*,*) 'djac:',dfjac(2,:)

       end if

       return
    end if

    n = size(pht)
    allocate(r(n),f(n),ds(n),cs(n),ds2(n),df(n),dd(n),d1s(n),d2s(n))
    t = p(1)
    s = p(2)

!    ds2 = t**2*dcts**2 + dpht**2
    ds2 = t**2*dcts2 + dpht2
    ds = sqrt(ds2)
    r = (pht - t*cts)/(s*ds)

    call hubers(r,f)
!    f = r

    dd = pht - t*cts
    d1s = t*dcts**2/ds
    d2s = dcts**2*(ds - t*d1s)/ds2
    cs = cts*ds + dd*d1s

    if( iflag == 1 ) then

       fvec(1) = sum(f*cs/s/ds2) - sum(d1s/ds)
       fvec(2) = sum(f*dd/s**2/ds) - n/s

    else if( iflag == 2 ) then

       call dhubers(r,df)
!       df = 1

       fjac(1,1) = sum(df*(cs/s/ds2)**2) - &
            sum(f*(dd*(d2s*ds-2*d1s**2)-2*cts*ds*d1s)/s/ds**3) + &
            sum((d2s*ds - d1s**2)/ds**2)
       fjac(1,2) = sum(df*cs*dd/s**3/ds**3) + sum(f*cs/s**2/ds2)
       fjac(2,2) = sum(df*(dd/s**2/ds)**2) + sum(f*2*dd/s**3/ds) - n/s**2

       fjac(2,1) = fjac(1,2)
       fjac = - fjac

    end if

    deallocate(r,f,ds,cs,ds2,df,dd,d1s,d2s)

  end subroutine funder


  subroutine difjac(t,s,jac)

    real(dbl), intent(in) :: t,s
    real(dbl), dimension(:,:), intent(out) :: jac
    real(dbl), parameter :: d = 1e-4
    real(dbl), dimension(2) :: fv1,fv2
    integer :: iflag

    iflag = 1

    call fundif(2,2,(/t+d,s/),fv1,iflag)
    call fundif(2,2,(/t-d,s/),fv2,iflag)
    jac(1,:) = (fv1 - fv2)/(2*d)

    call fundif(2,2,(/t,s+d/),fv1,iflag)
    call fundif(2,2,(/t,s-d/),fv2,iflag)
    jac(2,:) = (fv1 - fv2)/(2*d)

  end subroutine difjac



  function loglikely(p)

    use rfun

    real(dbl), dimension(:), intent(in) :: p
    real(dbl) :: loglikely
    real(dbl), dimension(:), allocatable :: r,f,ds
    integer :: n
    real(dbl) :: t,s

    n = size(pht)
    t = p(1)
    s = p(2)

    if( s < epsilon(s) ) then
       loglikely = huge(loglikely)
       return
    end if

    allocate(r(n),f(n),ds(n))
!    ds = s * sqrt(t**2*dcts**2 + dpht**2)
    ds = s * sqrt(t**2*dcts2 + dpht2)
    r = (pht - t*cts)/ds

    call ihubers(r,f)
!    f = r**2/2
    loglikely = sum(f) + sum(log(ds))

    deallocate(r,f,ds)

  end function loglikely

  subroutine jacobian_analytic(p,fjac)

    use rfun

    real(dbl), dimension(:),intent(in) :: p
    real(dbl), dimension(:,:), intent(out) :: fjac
    real(dbl), dimension(:), allocatable :: r,rs,f,df,ds,ds2
    integer :: n
    real(dbl) :: t,s

    n = size(pht)
    allocate(r(n),rs(n),f(n),ds(n),ds2(n),df(n))
    t = p(1)
    s = p(2)

!    ds2 = t**2*dcts**2 + dpht**2
    ds2 = t**2*dcts2 + dpht2
    ds = sqrt(ds2)
    r = pht - t*cts
    rs = r /(s*ds)

    call hubers(rs,f)
    !    f = r
    call dhubers(rs,df)
    !       df = 1

    ! this is a very simple approximation only

    fjac(1,1) = sum(df) ! sum(df*cts**2)
    fjac(1,2) = 0 !sum(df*r*cts)/s + sum(f*cts*ds)
    fjac(2,1) = fjac(1,2)
    fjac(2,2) = n !sum(df*r**2/s**2) + n

    deallocate(r,rs,f,ds,ds2,df)

  end subroutine jacobian_analytic

  subroutine rinit(t,s)

    ! This is a the first estimation of ratio parameter.
    ! I'm in doubts to use Newton's method or fmin by Brent's
    ! method (Golden sections search on star and interpolation
    ! by parabola near minimum). Brent's method looks to be
    ! extraordinary robust... especially when absolute value
    ! is processed.

    use fmm
    use medians
    use qmeans

    real(dbl), intent(out) :: t,s
    integer :: n
    real(dbl) :: d,ds
!    real(dbl) :: rtol

!    rtol = 1e-5*max(1.0,rmax)
    !    t = fmin(rmin,rmax,ratiomin,rtol)


    n = size(pht)

    if( n > 30 ) then
       t = qmedian(pht/cts)
       ds = qmedian(sqrt(t**2*dcts2 + dpht2))
       s = qmedian(abs(pht - t*cts)) / (0.6745*ds)
    else if( n > 13 ) then
       t = median(pht/cts)
       ds = median(sqrt(t**2*dcts2 + dpht2))
       s = median(abs(pht - t*cts)) / (0.6745*ds)
    else if( n > 2 ) then
       call qmean(pht/cts,t,d)
       call qmean(sqrt(t**2*dcts2 + dpht2),ds,d)
       call qmean(abs(pht - t*cts),s,d)
       s = s / (0.6745*ds)
    else if( n > 0 ) then
       t = sum(pht/cts) / n
       ds = sum(sqrt(t**2*dcts2 + dpht2)) / n
       s = sum(abs(pht - t*cts)) / (n * ds)
    else
       t = 0
       s = 0
    end if



!    write(*,*) t,s,n

!    allocate(ds(n))
!    call residuals2(t,res,ds)
!    s = qmedian(abs(res)) / 0.6745
!    d = qmedian(ds)
!    deallocate(ds)

    ! Just for fun. All of estimates below gives the same result on standard data:
!     write (*,*) sqrt(sum(res**2)/n),median(abs(res))/0.6745,sum(abs(res))/n/0.8

  end subroutine rinit

  function ratiomin(t)

!    use medians

    real(dbl), intent(in) :: t
    real(dbl) :: ratiomin
    integer :: n

    n = size(pht)
    call residuals(t,res)
    ratiomin = sum(abs(res)) / (0.8*n)

    ! This function computes sum of absolute deviations. To have values
    ! of order of an unit, we're normalise the sum by data size. The
    ! factor 0.8 converts of its Laplace's dispersion to one corresponding
    ! to Normal distributions. It is important for estimate of dispersion.

  end function ratiomin


  subroutine zmean(t,s,reli)

    use fmm
    use medians

    ! This is a robust estimation of the ratio.

    real(dbl), intent(in out) :: t
    real(dbl), intent(in) :: s
    logical, intent(out) :: reli
    real(dbl) :: htol,d,tmin,tmax

!    htol = 1e-7*max(1.0,rmax)
    sigma = s

    d = 3.3 * qmedian(abs(pht/cts - t)) / 0.6745
    htol = 1e-5*d

    if( size(pht) > 13 ) then
       tmin = max(t - d,rmin)
       tmax = min(t + d,rmax)
    else
       tmin = rmin
       tmax = rmax
    end if
!    write(*,*) tmin,tmax,d,s,qmedian(sqrt(dpht**2 + t**2*dcts**2))
    t = zeroin(tmin,tmax,zfun,htol)

    d = 2*htol
    reli = rmin + d < t .and. t < rmax - d

    ! the realiable result is inside interval rmin .. rmax
    ! and not too close to the interval endpoints

  end subroutine zmean


  function zfun(t)

    use rfun

    real(dbl), intent(in) :: t
    real(dbl) :: zfun
    real(dbl), dimension(:), allocatable :: phi,ds
    integer :: n

    n = size(pht)
    allocate(phi(n),ds(n))
    call residuals2(t,res,ds)
    call tukeys(res/sigma,phi)

    zfun = (t*sum((phi*res - 1.0_dbl)*(dcts/ds)**2) + sum(phi*cts/ds))/sigma

    deallocate(phi,ds)

  end function zfun


  subroutine pmean(t)

    use fmm
!    use qmeans

    real(dbl), intent(out) :: t
!    real(dbl) :: tmin, tmax, d
!    real(dbl) :: d

!    call qmean(pht / cts,t,d)

!    tmin = rmin
!    tmax = rmax
    t = fmin(rmin,rmax,negfree,tol)

  end subroutine pmean


  function negfree(t)

    ! negative free energy

    real(dbl), intent(in) :: t
    real(dbl) :: negfree
    real(dbl), dimension(:), allocatable :: f

    allocate(f(size(pht)))

    ! The density for Poisson distribution is computed by the way:
    ! https://en.wikipedia.org/wiki/Poisson_distribution#Definition

    f = pht*log(t*cts) - t*cts - log_gamma(pht + 1)
    f = exp(f)
    negfree = - sum(f)
    deallocate(f)

  end function negfree


  ! --------------------------------------------------------

  subroutine poisson_graph

    integer, parameter :: nmax = 1000
    integer :: n
    real(dbl) :: t,dt
    real(dbl), dimension(:), allocatable :: f

    allocate(f(size(pht)))

    dt = (rmax - rmin) / nmax

    open(1,file='/tmp/f')
    do n = 1,nmax,2
       t = rmin + dt*n
       f = pht*log(t*cts) - t*cts - log_gamma(pht+1)
       write(1,*) t,sum(exp(f)),sum(f*exp(f))
    end do
    close(1)

    deallocate(f)

  end subroutine poisson_graph

  subroutine snoise_graph(t,sig)

    real(dbl), intent(in) :: t, sig

    integer :: i
    real(dbl) :: s

    open(1,file='/tmp/e')
    do i = 2,int(1000*sig),10
       s = i / 100.0
       write(1,*) s,entropy(t,s)
    end do
    close(1)

  end subroutine snoise_graph


  subroutine rmean_graph(t1,t2,s)

    use rfun

    real(dbl), intent(in) :: t1,t2,s
    real(dbl) :: t,dt
    real(dbl), dimension(:), allocatable :: r,rho
    integer :: i,n

    n = size(pht)
    allocate(r(n),rho(n))

    dt = (t2 - t1) / 1000

    open(1,file='/tmp/r')
    do i = 1,1000,10
       t = t1 + dt*i

       call residuals(t,r)
!       call ihubers(r/s,rho)
       call itukeys(r/s,rho)

       write(1,*) t,loglikely((/t,s/)),sum(rho),zfun(t)
    end do
    close(1)

    deallocate(r,rho)

  end subroutine rmean_graph


  ! an interface for plotting of functions in minimum (not used for calibration)
  subroutine graph(xpht,xdpht,xcts,xdcts,ctph,sig,type,fvec)

    real(dbl), dimension(:), target, intent(in) :: xpht,xdpht,xcts,xdcts
    real(dbl), intent(in) :: ctph,sig
    character(len=*), intent(in) :: type
    real(dbl), dimension(:) :: fvec
    integer :: iflag, ndat

    ndat = size(xpht)
    allocate(pht(ndat),cts(ndat),dpht(ndat),dcts(ndat))
    pht = xpht
    cts = xcts
    dpht = xdpht
    dcts = xdcts

    if( type == "grad" ) then
       iflag = 1
       call fundif(2,2,(/ctph,sig/),fvec,iflag)
    else if( type == "like" ) then
       fvec(1) = loglikely((/ctph,sig/))
    else
       fvec = 0
    end if

    deallocate(pht,cts,dpht,dcts)

  end subroutine graph


end module robratio

!
! lsfit - least square fit
!
!
! Copyright © 2011-3, 2015-6, 2018 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module lsfit

  implicit none

  logical, private :: debug = .false.
  logical, private :: analytic = .true.
  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl
  real(dbl), dimension(:), allocatable, private :: x,y,u,v
  integer, private :: ndat
  real(dbl), private :: s0, refl, xcen, ycen

  private :: lsminfun,funder,hessian_min

contains

  subroutine lsmin(type,a,d,xc,yc,rf,xx,yy,acen,dacen,dcen,ddcen,sc,dsc,pa,dpa,&
       rms,verbose)

    use astrotrafo
    use minpack
    use minpacks

    ! parameters
    character(len=*),intent(in) :: type
    real(dbl),dimension(:),intent(in) :: a,d,xx,yy
    real(dbl),intent(in) :: xc,yc,rf
    real(dbl),intent(in out) :: acen,dcen,sc,pa
    real(dbl),intent(out) :: dacen,ddcen,dsc,dpa,rms
    logical, intent(in) :: verbose

    real(dbl), parameter :: eps = 1e2*epsilon(eps)

    ! fitting parameters
    integer, parameter :: npar = 4
    real(dbl),dimension(npar) :: p,dp
    real(dbl),dimension(npar,npar) :: fjac,cov

    integer :: i,iter,info,nprint
    type(AstroTrafoProj) :: t,ti

    debug = verbose
    refl = rf
    xcen = xc
    ycen = yc

    if( size(a) < npar ) stop 'N=4 is absolute minimum of provided data.'
    if( size(a) /= size(d) .or. size(a) /= size(xx) .or. size(xx) /= size(yy) )&
         stop 'Lsmin bad dimensions.'

    ! normalization
    ndat = size(a)
    allocate(x(ndat),y(ndat),u(ndat),v(ndat))
    x = xx
    y = yy

    ! setup projection
    call trafo_init(t,type,acen,dcen)
    call proj(t,a,d,u,v)

    ! fitting parameters
    p = [ 0.0_dbl, 0.0_dbl, 1.0_dbl, -pa/rad ]
    p(3) = 1.0_dbl / sc
    p(4) = pa / rad

    if( debug) write(*,*) "#   info   rms  x0    y0    scale   phi   acen   dcen"
    do iter = 1, 10
       nprint = 0 ! or 1

       ! transformation
       if( analytic ) then
          call lmder2(funder,p,eps,nprint,info)
       else
          call lmdif2(lsminfun,p,eps,nprint,info)
       end if
       if( info == 0 ) stop 'lsfit: Improper fit parameters.'

       rms = sqrt(s0 / (ndat - npar))

       ! correction of center of projection
       call trafo_init(ti,type,acen,dcen,xcen=p(1),ycen=p(2),scale=p(3), &
            rot=rad*p(4),refl=refl)
       call invtrafo(ti,0.0_dbl,0.0_dbl,acen,dcen)

       if( debug ) write(*,'(i2,1x,i1,es9.2,2es10.2,es11.3,3f11.5)') &
            iter,info,rms,p(1:2),p(3),pa,acen,dcen

       ! finish when parameters are appropriate small
       ! and iterations couldn't make further progress
       if( iter > 1 .and. all(abs(p(1:2)) < eps)  ) exit

       ! new projection by using of fitted parameters
       call trafo_init(t,type,acen,dcen)
       call proj(t,a,d,u,v)
       p(1:2) = 0.0_dbl

    end do

    sc = 1.0_dbl/p(3)
    pa = rad*p(4)

    ! statistical uncertainities of parameters
    call hessian_min(p,fjac)
    call qrinv(fjac,cov)
    if( debug ) then
       write(*,*) 'Hessian matrix:'
       write(*,'(4g15.3)') (fjac(i,:),i=1,npar)
       write(*,*) 'Covariance matrix:'
       write(*,'(4g15.3)') (cov(i,:),i=1,npar)
    end if
    forall( i = 1:npar ) dp(i) = sqrt(s0*cov(i,i)/(ndat - npar))

    ! output parameters with deviations
    dsc = sc*(dp(3)/p(3))
    dacen = dp(1) / cos(dcen / rad)
    ddcen = dp(2)
    dpa = rad*dp(4)

    if( debug ) then
       write(*,*) "Final solution:"
       write(*,'(a,4g15.5)') '#lsfit solution:',p
       write(*,'(a,4en15.2)') '#lsfit uncerts.: ',dp
       write(*,*) '#lsfit scale [pix/deg]: ',sc,'+-',dsc
       write(*,*) '#lsfit s0: ',s0
    end if

    deallocate(x,y,u,v)

  end subroutine lsmin



  subroutine funder(m,np,p,fvec,fjac,ldfjac,iflag)

    use astrotrafo

    integer, intent(in) :: m,np,ldfjac
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
    real(dbl), dimension(:), allocatable :: du,dv,uu,vv
    real(dbl), dimension(m) :: fc
    real(dbl) :: u1,v1,r,su,sv,s2
    type(AstroTrafoProj) :: t
    integer :: i,j

    if( iflag == 0 ) then
       write(*,'(4g15.5)') p
       return
    end if

    call trafo_init(t,xcen=xcen,ycen=ycen, &
         ucen=p(1),vcen=p(2),scale=p(3),rot=rad*p(4),refl=refl)

    allocate(du(ndat),dv(ndat),uu(ndat),vv(ndat))

    do i = 1, ndat
       call invaffine(t,x(i),y(i),u1,v1,uu(i),vv(i))

       ! u,v - projected coordinates of reference stars
       ! x,y - coordinates of stars on CCD
       ! uu,vv - rotation and scale of x,y coordinates
       ! du,dv - differences

       du(i) = u(i) - u1
       dv(i) = v(i) - v1

!       write(*,'(9f12.5)') u(i),v(i),x(i),y(i),3600*du,3600*dv
    end do

    r = p(3)
    fc(1) = sum(du)
    fc(2) = sum(dv)
    fc(3) = sum(du*uu + dv*vv)
    fc(4) = sum(dv*uu - du*vv)

    if( iflag == 1 ) then

       fvec(1:3) = fc(1:3)
       fvec(4) = fc(4)*r
       fvec = 2*fvec

    else if( iflag == 2 ) then

       su = sum(uu)
       sv = sum(vv)
       s2 = sum(uu**2 + vv**2)

       fjac = 0.0_dbl
       fjac(1,1) = ndat
       fjac(1,3) = su
       fjac(1,4) = -sv*r
       fjac(2,2) = ndat
       fjac(2,3) = sv
       fjac(2,4) = su*r
       fjac(3,3) = s2
       fjac(3,4) = fc(4)
       fjac(4,4) = r**2*s2 - fc(3)*r

       do i = 1,size(p)
          do j = 1,i-1
             fjac(i,j) = fjac(j,i)
          end do
       end do
       fjac = 2*fjac

    end if

    s0 = sum(du**2 + dv**2)

    deallocate(du,dv,uu,vv)

  end subroutine funder

  subroutine hessian_min(p,hess)

    real(dbl), dimension(:), intent(in) :: p
    real(dbl), dimension(:,:), intent(out) :: hess
    real(dbl), dimension(size(p)) :: fvec
    integer :: iflag,m

    iflag = 2
    m = size(p)
    call funder(m,m,p,fvec,hess,m,iflag)

  end subroutine hessian_min

  subroutine lsminfun(m,np,p,fvec,iflag)

    use astrotrafo

    integer, intent(in) :: m,np
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl) :: sx,sy,sc,sf,rx,ry,xx,yy,uu,vv
    type(AstroTrafoProj) :: t
    integer :: i

    if( iflag == 0 .and. debug ) write(*,'(a,4en15.3)') '#lsfit t:',p(1:np)

    call trafo_init(t,xcen=xcen,ycen=ycen, &
         ucen=p(1),vcen=p(2),scale=p(3),rot=rad*p(4),refl=refl)

    sx = 0.0_dbl; sy = 0.0_dbl; sc = 0.0_dbl; sf = 0.0_dbl; s0 = 0.0_dbl;
    do i = 1, ndat
       call invaffine(t,x(i),y(i),uu,vv,xx,yy)
       rx = u(i) - uu
       ry = v(i) - vv

       sx = sx + rx
       sy = sy + ry
       sc = sc + (rx*xx + ry*yy)
       sf = sf + (rx*yy - ry*xx)

       s0 = s0 + rx**2 + ry**2
!       write(*,'(9f10.5)') u(i),v(i),x(i),y(i),rx,ry
    end do
    fvec = [ -sx,-sy,-sc,sf*p(3) ]

!    if( iflag == 0 .and. debug ) write(*,'(a,6es10.2)') '#lsfit: fvec:',fvec(1:np),sum(fvec**2),s0

  end subroutine lsminfun


end module lsfit

!
!  FITS I/O for photometric calibration
!
!  Copyright © 2014-5, 2018 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

module fits_fotran

  use titsio

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

  private :: idcol

contains

  subroutine traload(nametable,photosys_ref,photosys_instr, &
       tr,trerr,tr1,tr1err,status)

    character(len=*), intent(in) :: nametable
    character(len=*), intent(out) :: photosys_ref,photosys_instr
    real(dbl), dimension(:,:), allocatable, intent(out) :: tr,trerr,tr1,tr1err
    integer, intent(out) :: status

    character(len=FLEN_KEYWORD) :: key
    character(len=FLEN_VALUE) :: extname
    integer :: ncols,nrows,i
    integer, parameter :: frow = 1, extver = 0
    real(dbl), parameter :: nullval = 0.0_dbl
    logical :: anyf
    type(fitsfiles) :: fits

    status = 0

    ! open and move to first table extension
    call fits_open_file(fits,nametable,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read a table in the file `',trim(nametable),"'."
       return
    end if

    if( status /= 0 ) goto 666

    ! check reference frame and identification of this table
    call fits_make_keyn(FITS_KEY_PHOTSYS,1,key,status)
    call fits_read_key(fits,key,photosys_instr,status)
    call fits_make_keyn(FITS_KEY_PHOTSYS,2,key,status)
    call fits_read_key(fits,key,photosys_ref,status)

    extname = trim(FTHDUNAME) // '_FORWARD'
    call fits_movnam_hdu(fits,FITS_ANY_HDU, extname, extver,status)
    if( status /= 0 ) goto 666

    call fits_get_num_rows(fits,nrows,status)
    call fits_get_num_cols(fits,ncols,status)

    allocate(tr(nrows,ncols))
    do i = 1, ncols
       call fits_read_col(fits,i,frow,nullval,tr(:,i),anyf,status)
    end do

    extname = trim(FTHDUNAME) // '_BACKWARD'
    call fits_movnam_hdu(fits,FITS_ANY_HDU, extname, extver,status)
    if( status /= 0 ) goto 666
    call fits_get_num_rows(fits,nrows,status)
    call fits_get_num_cols(fits,ncols,status)
    allocate(tr1(nrows,ncols))
    do i = 1, ncols
       call fits_read_col(fits,i,frow,nullval,tr1(:,i),anyf,status)
    end do

    allocate(trerr(nrows,ncols),tr1err(nrows,ncols))
    trerr = -1
    tr1err = -1

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    if( status /= 0 ) then
       if( allocated(tr) ) deallocate(tr)
       if( allocated(tr1) ) deallocate(tr1)
       if( allocated(trerr) ) deallocate(trerr)
       if( allocated(tr1err) ) deallocate(tr1err)
    end if

  end subroutine traload


  subroutine trawrite(output,photosys_ref,photosys_instr,filters_ref, &
       filters_instr,ra,dec,ci0,ph,dph,cts,dcts, &
       tr,trerr,tr1,tr1err,filenames,airmass,ctph,extin)

    character(len=*), intent(in) :: output, photosys_ref, photosys_instr
    character(len=*), dimension(:), intent(in) :: filters_ref, filters_instr
    character(len=*), dimension(:), intent(in), optional :: filenames
    real(dbl), dimension(:), intent(in) :: ra,dec
    real(dbl), dimension(:), intent(in), optional :: airmass,ctph,extin
    real(dbl), intent(in) :: ci0
    real(dbl), dimension(:,:), intent(in) :: tr,trerr,tr1,tr1err, &
         ph,dph,cts,dcts

    integer, parameter :: frow = 1
    character(len=FLEN_VALUE), dimension(:), allocatable :: ttype, tform,tunit
    character(len=FLEN_VALUE) :: extname
    character(len=FLEN_KEYWORD) :: key
    character(len=FLEN_CARD) :: buf,a
    real(dbl) :: x
    integer :: n,nrows,ncols, nbands,status
    type(fitsfiles) :: fits

    status = 0
    if( fits_file_exist(output) ) call fits_file_delete(output)
    call fits_create_file(fits,output,status)
    call fits_insert_image(fits,8,0,[0],status)
    call fits_write_comment(fits,'Photometry system conversion table.',status)
    call fits_write_key(fits,FITS_KEY_CREATOR,FITS_VALUE_CREATOR,FITS_COM_CREATOR,status)
    call fits_write_comment(fits,MUNIPACK_VERSION,status)
    call fits_write_comment(fits,'Description: http://munipack.physics.muni.cz/dataform_phfotran.html',status)

    call fits_make_keyn(FITS_KEY_PHOTSYS,1,key,status)
    call fits_write_key(fits,key,photosys_instr,'instrumental photometry system',status)

    call fits_make_keyn(FITS_KEY_PHOTSYS,2,key,status)
    call fits_write_key(fits,key,photosys_ref,'reference photometry system (standard)',status)

    if( present(airmass) ) then
       x = sum(airmass)/size(airmass)
       call fits_write_key(fits,FITS_KEY_AIRMASS,x,-6,'average air-mass',status)
    end if

    ! mean colour index
    call fits_write_key(fits,'REFCI',ci0,-6,'reference colour index',status)

    if( present(filenames) ) then
       call fits_write_comment(fits,'Photometry transformation has been derived by processing..',status)
       call fits_write_comment(fits,' filename, filter, airmass, ctph, extinction:',status)
       do n = 1,size(filenames)
          if( size(airmass) > 0 ) then
             write(buf,'(f8.5)') airmass(n)
          else
             buf = "-"
          end if
          if( size(ctph) > 0 ) then
             write(a,'(1p,g0.5)') ctph(n)
          else
             a = "-"
          end if
          buf = trim(buf) // " " // trim(a)
          if( size(extin) > 0 ) then
             write(a,'(1p,g0.5)') extin(n)
          else
             a = "-"
          end if
          buf = trim(buf) // " " // trim(a)
          call fits_write_comment(fits,"'"//trim(filenames(n))//"' '"//  &
               trim(filters_instr(n))//"' "//trim(buf),status)
       end do
       call fits_write_comment(fits,'All elements are normalized for both unit area and time.',status)
    end if


    ! extension - FOTRAN
    nrows = size(tr,1)
    ncols = size(tr,2)
    allocate(ttype(ncols),tform(ncols),tunit(ncols))
    tform = '1D'
    tunit = '' !'an instrumental filter'
    ttype = filters_ref

    extname = trim(FTHDUNAME) // '_FORWARD'
    call fits_insert_btbl(fits,nrows,ttype,tform,tunit,extname,status)
    call fits_write_comment(fits,'Forward matrix (photon rate to counts rate).',status)
    do n = 1, ncols
       call fits_write_col(fits,n,frow,tr(:,n),status)
    end do

    extname = trim(FTHDUNAME) // '_BACKWARD'
    call fits_insert_btbl(fits,nrows,ttype,tform,tunit,extname,status)
    call fits_write_comment(fits,'Backward matrix (counts rate to photon rate).',status)
    do n = 1, ncols
       call fits_write_col(fits,n,frow,tr1(:,n),status)
    end do

    extname = trim(FTHDUNAME) // '_FORWARD_ERR'
    call fits_insert_btbl(fits,nrows,ttype,tform,tunit,extname,status)
    do n = 1, ncols
       call fits_write_col(fits,n,frow,trerr(:,n),status)
    end do

    extname = trim(FTHDUNAME) // '_BACKWARD_ERR'
    call fits_insert_btbl(fits,nrows,ttype,tform,tunit,extname,status)
    do n = 1, ncols
       call fits_write_col(fits,n,frow,tr1err(:,n),status)
    end do

    deallocate(ttype,tform,tunit)


    ! data info extension
    nrows = size(ra)
    nbands = size(ph,2)
    ncols = (2*2)*nbands + 2
    allocate(ttype(ncols),tform(ncols),tunit(ncols))
    tform = '1D'
    tunit(1:2) = 'deg'
    tunit(3:2+2*nbands) = 'ph/s/m2'
    tunit(3+2*nbands:2+4*nbands) = 'W/m2'
    tunit(3+4*nbands:) = 'cts/s/m2'
    ttype(1) = FITS_COL_RA
    ttype(2) = FITS_COL_DEC
    ttype(3:2+1*nbands) = 'PH_'//filters_ref
    ttype(3+1*nbands:2+2*nbands) = 'ePH_'//filters_ref
    ttype(3+2*nbands:2+3*nbands) = 'CTS_'//filters_instr
    ttype(3+3*nbands:) = 'eCTS_'//filters_instr

    call fits_insert_btbl(fits,nrows,ttype,tform,tunit,trim(FTHDUNAME)//'data',status)
    call fits_write_col(fits,1,frow,ra,status)
    call fits_write_col(fits,2,frow,dec,status)
    do n = 1,nbands
       call fits_write_col(fits,2+n,frow,ph(:,n),status)
    end do
    do n = 1,nbands
       call fits_write_col(fits,2+nbands+n,frow,dph(:,n),status)
    end do
    do n = 1,nbands
       call fits_write_col(fits,2+2*nbands+n,frow,cts(:,n),status)
    end do
    do n = 1,nbands
       call fits_write_col(fits,2+3*nbands+n,frow,dcts(:,n),status)
    end do

    deallocate(ttype,tform,tunit)

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

  end subroutine trawrite

  subroutine tradata(nametable,ra,dec,ph,dph,cts,dcts)

    character(len=*), intent(in) :: nametable
    real(dbl), dimension(:), allocatable, intent(out) :: ra,dec
    real(dbl), dimension(:,:), allocatable, intent(out) :: ph,dph,cts,dcts

    integer :: ncols,nrows,i,n,rcol,dcol,status
    integer, parameter :: frow = 1, felem = 1, extver = 0
    real(dbl), parameter :: nullval = 0.0_dbl
    integer, dimension(:), allocatable :: col_cts, col_ph, col_dcts, col_dph
    logical :: anyf
    type(fitsfiles) :: fits

    status = 0

    ! open and move to first table extension
    call fits_open_table(fits,nametable,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read a table in the file `',trim(nametable),"'."
       return
    end if

    call fits_movnam_hdu(fits,FITS_BINARY_TBL,trim(FTHDUNAME)//'data', extver,status)
    call fits_get_num_rows(fits,nrows,status)
    call fits_get_num_cols(fits,ncols,status)
    if( status /= 0 ) goto 666

    call fits_get_colnum(fits,.true.,FITS_COL_RA,rcol,status)
    call fits_get_colnum(fits,.true.,FITS_COL_DEC,dcol,status)
    if( status /= 0 ) goto 666

    allocate(col_cts(ncols),col_ph(ncols),col_dph(ncols),col_dcts(ncols))

    call idcol(fits,'CTS_*',col_cts,n,status)
    call idcol(fits,'eCTS_*',col_dcts,n,status)
    call idcol(fits,'PH_*',col_ph,n,status)
    call idcol(fits,'ePH_*',col_dph,n,status)

    if( size(col_ph) /= size(col_cts) .or. n == 0 ) &
         stop 'CTS or PH columns badly identified.'

    allocate(cts(nrows,n),ph(nrows,n),dcts(nrows,n),dph(nrows,n),ra(nrows),dec(nrows))
    call fits_read_col(fits,rcol,frow,nullval,ra,anyf,status)
    call fits_read_col(fits,dcol,frow,nullval,dec,anyf,status)
    do i = 1,n
       call fits_read_col(fits,col_cts(i),frow,nullval,cts(:,i),anyf,status)
    end do
    do i = 1,n
       call fits_read_col(fits,col_dcts(i),frow,nullval,dcts(:,i),anyf,status)
    end do
    do i = 1,n
       call fits_read_col(fits,col_ph(i),frow,nullval,ph(:,i),anyf,status)
    end do
    do i = 1,n
       call fits_read_col(fits,col_dph(i),frow,nullval,dph(:,i),anyf,status)
    end do
    deallocate(col_cts,col_ph)

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

  end subroutine tradata

  subroutine idcol(fits,temp,cols,n,status)

    type(fitsfiles), intent(in) :: fits
    character(len=*), intent(in) :: temp
    integer, dimension(:), intent(out) :: cols
    integer, intent(out) :: n,status
    integer :: l

    n = 0
    do
       call fits_get_colnum(fits,.true.,temp,l,status)
       if( status == FITS_MULTIPLE_MATCH ) then
          n = n + 1
          cols(n) = l
       else
          exit
       end if
    end do
    status = 0

  end subroutine idcol

end module fits_fotran

!
!  Fortran 95+ module interface to selected routines from the book
!
!       "Computer Methods for Mathematical Computations",
!           by Forsythe, Malcolm, and Moler (1977)
!
!  known as FMM (http://www.netlib.org/fmm/index.html).
!
!
!  Copyright © 2015-6 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

module fmm

    implicit none

    interface

       subroutine spline (n, x, y, b, c, d)

         integer, parameter :: dbl = selected_real_kind(15)
         integer, intent(in) ::n
         real(dbl), dimension(n), intent(in) :: x,y
         real(dbl), dimension(n), intent(out) :: b,c,d

       end subroutine spline

       double precision function seval(n, u, x, y, b, c, d)

         integer, parameter :: dbl = selected_real_kind(15)
         integer, intent(in) :: n
         real(dbl), intent(in) :: u
         real(dbl), dimension(n), intent(in) :: x,y,b,c,d

       end function seval


       double precision function fmin(ax,bx,f,tol)

         double precision, intent(in) :: ax,bx,tol

         interface
            function f(x)
              double precision :: f
              double precision, intent(in) :: x
            end function f
         end interface

       end function fmin

       double precision function zeroin(ax,bx,f,tol)

         double precision, intent(in) :: ax,bx,tol

         interface
            function f(x)
              double precision :: f
              double precision, intent(in) :: x
            end function f
         end interface

       end function zeroin

    end interface

end module fmm

!
! ctables manipulations
!
! Copyright © 2018 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module ctables

  use iso_fortran_env

  implicit none

contains

  subroutine ctable_load(ctable,cspace,outspace,cmatrix,verbose)

    character(len=*), intent(in) :: ctable,cspace,outspace
    real, dimension(:,:), allocatable, intent(out) :: cmatrix
    logical, intent(in) :: verbose

    character(len=80) :: label1, label2, msg
    integer :: n,stat,ndim,mdim

    open(1,file=ctable,status='old',iostat=stat,iomsg=msg)
    if( stat > 0 ) then
       write(error_unit,*) "Error: ",trim(msg)
       stop 'A color table file not found.'
    end if

    do
       read(1,*,end=90,err=666,iomsg=msg) label1, label2, ndim, mdim
       allocate(cmatrix(ndim,mdim))
       do n = 1, ndim
          read(1,*,end=90,err=666,iomsg=msg) cmatrix(n,:)
       end do
       if( label1 == cspace .and. outspace == label2 ) exit
       deallocate(cmatrix)
    end do
90  close(1)

    if( .not. allocated(cmatrix) ) stop 'Required an unknown colour space.'

    if( verbose ) then
       write(error_unit,*) 'Info for colour transformation matrix: ', &
            trim(label1),' -> ',trim(label2)
       do n = 1, ndim
          write(error_unit,'(a,5f10.4)') ' Info: ',cmatrix(n,:)
       end do
    end if

    return

666 continue
    write(error_unit,*) "Error: ",trim(msg)
    stop 'A color table file read error.'

  end subroutine ctable_load

  subroutine ctable_list(ctable)

    character(len=*), intent(in) :: ctable

    character(len=80) :: msg,cspace,outspace
    integer :: stat,ndim,mdim
    real, dimension(:,:),allocatable :: cmatrix

    open(1,file=ctable,status='old',iostat=stat,iomsg=msg)
    if( stat > 0 ) then
       write(error_unit,*) "Error: ",trim(msg)
       stop 'A color table file not found.'
    end if

    write(*,*) 'Available colour spaces:'
    write(*,'(a20,1x,a,1x,a)') 'Input','>','Output'

    do
       read(1,*,end=90,err=666,iomsg=msg) cspace,outspace, ndim, mdim
       write(*,'(a20,3x,a)') trim(cspace), trim(outspace)
       allocate(cmatrix(ndim,mdim))
       read(1,*,end=90,err=666,iomsg=msg) cmatrix
       deallocate(cmatrix)
    end do
90  close(1)
    return

666 continue
    write(error_unit,*) "Error: ",trim(msg)
    stop 'A color table file read error.'

  end subroutine ctable_list


end module ctables

!
!  FITSIO definitions for Munipack
!
!  Copyright © 2020-2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.



module titsio

  use fitsio_mmviii
  use iso_fortran_env

  implicit none

  ! version identification like:
  ! character(len=*), parameter, private :: VERSION = "0"
  include 'fversion.inc'

  character(len=*), parameter :: MUNIPACK_VERSION = &
       "Munipack "//VERSION//", (C)1997-2022 F. Hroch <hroch@physics.muni.cz>"

  character(len=*), parameter :: FITS_VALUE_CREATOR = &
       "Munipack "//VERSION
  character(len=*), parameter :: FITS_COM_CREATOR = &
       "https://munipack.physics.muni.cz"

  character(len=*), parameter :: FINDEXTNAME = 'FIND'
  character(len=*), parameter :: APEREXTNAME = 'APERPHOT'
  character(len=*), parameter :: GROWEXTNAME = 'GROWPHOT'
  character(len=*), parameter :: GROWCURVEXTNAME = 'GROWCURVE'
  character(len=*), parameter :: GROWFUNCEXTNAME = 'GROWFUNC'
  character(len=*), parameter :: GROWDATEXTNAME = 'GROWDATA'
  character(len=*), parameter :: PSFEXTNAME  = 'PSFPHOT'
  character(len=*), parameter :: PHOTOEXTNAME= 'PHOTOMETRY'
  character(len=*), parameter :: MEXTNAMETS =  'TIMESERIES'
  character(len=*), parameter :: MEXTNAMETSC = 'CATALOGUE'
  character(len=*), parameter :: FHDUNAME =    'PHOTOSYS'
  character(len=*), parameter :: FTHDUNAME =   'FOTRAN'
  character(len=*), parameter :: EXT_STDERR =  'STDERR'
  character(len=*), parameter :: EXT_PHRES =   'PHRES'

  character(len=*), parameter :: BEGIN_ASTROMETRY = &
       '=== Astrometric Solution by Munipack ==='
  character(len=*), parameter :: END_ASTROMETRY = &
       '=== End of Astrometric Solution by Munipack ==='
  character(len=*), parameter :: BEGIN_PHOTOCAL = &
       '=== Photometric Calibration by Munipack ==='
  character(len=*), parameter :: END_PHOTOCAL = &
       '=== End of Photometric Calibration by Munipack ==='

  character(len=*), parameter :: FITS_KEY_NAPER = 'NAPER'
  character(len=*), parameter :: FITS_KEY_APER = 'APER'
  character(len=*), parameter :: FITS_KEY_SAPER = 'SAPER'
  character(len=*), parameter :: FITS_KEY_ANNULUS = 'ANNULUS'
  character(len=*), parameter :: FITS_KEY_FWHM = 'FWHM'
  character(len=*), parameter :: FITS_KEY_HWHM = 'HWHM'
  character(len=*), parameter :: FITS_KEY_ECCENTRICITY = 'ECCENTR'
  character(len=*), parameter :: FITS_KEY_INCLINATION = 'INCL'
  character(len=*), parameter :: FITS_KEY_RF90 = 'RADFLX90'
  character(len=*), parameter :: FITS_KEY_EXTINK0 = 'EXTIN_K0'
  character(len=*), parameter :: FITS_KEY_EXTINR = 'EXTIN_R'
  character(len=*), parameter :: FITS_KEY_EXTINREF = 'EXTINREF'
  character(len=*), parameter :: FITS_KEY_THRESHOLD = 'THRESH'
  character(len=*), parameter :: FITS_KEY_LOWBAD = 'LOWBAD'
  character(len=*), parameter :: FITS_KEY_HIGHBAD = 'HIGHBAD'
  character(len=*), parameter :: FITS_KEY_RNDLO = 'RNDLO'
  character(len=*), parameter :: FITS_KEY_RNDHI = 'RNDHI'
  character(len=*), parameter :: FITS_KEY_SHRPLO = 'SHRPLO'
  character(len=*), parameter :: FITS_KEY_SHRPHI = 'SHRPHI'
  character(len=*), parameter :: FITS_KEY_PHOTPLAM = 'PHOTPLAM'
  character(len=*), parameter :: FITS_KEY_PHOTZPT = 'PHOTZPT'
  character(len=*), parameter :: FITS_KEY_PHOTFLAM = 'PHOTFLAM'
  character(len=*), parameter :: FITS_KEY_PHOTBW = 'PHOTBW'
  character(len=*), parameter :: FITS_KEY_CTPH = 'CTPH'
  character(len=*), parameter :: FITS_KEY_CTPHERR = 'CTPHERR'
  character(len=*), parameter :: FITS_KEY_CSPACE = 'CSPACE'
  character(len=*), parameter :: FITS_KEY_REFRAME = 'REFRAME'
  character(len=*), parameter :: FITS_KEY_SATURATE = 'SATURATE'
  character(len=*), parameter :: FITS_KEY_GAIN = 'GAIN'
  character(len=*), parameter :: FITS_KEY_READNS = 'READNS'
  character(len=*), parameter :: FITS_KEY_AREA = 'AREA'
  character(len=*), parameter :: FITS_KEY_EXPTIME = 'EXPTIME'
  character(len=*), parameter :: FITS_KEY_PHOTSYS = 'PHOTSYS'
  character(len=*), parameter :: FITS_KEY_FILTER = 'FILTER'
  character(len=*), parameter :: FITS_KEY_FILTREF = 'FILTREF'
  character(len=*), parameter :: FITS_KEY_OBJECT = 'OBJECT'
  character(len=*), parameter :: FITS_KEY_OBSERVER = 'OBSERVER'
  character(len=*), parameter :: FITS_KEY_ORIGIN = 'ORIGIN'
  character(len=*), parameter :: FITS_KEY_AUTHOR = 'AUTHOR'
  character(len=*), parameter :: FITS_KEY_INSTRUME = 'INSTRUME'
  character(len=*), parameter :: FITS_KEY_TELESCOP = 'TELESCOP'
  character(len=*), parameter :: FITS_KEY_BIBREF = 'BIBREF'
  character(len=*), parameter :: FITS_KEY_LONGITUDE = 'LONGITUD'
  character(len=*), parameter :: FITS_KEY_LATITUDE =  'LATITUDE'
  character(len=*), parameter :: FITS_KEY_EPOCH = 'EPOCH'
  character(len=*), parameter :: FITS_KEY_CREATOR = 'CREATOR'
  character(len=*), parameter :: FITS_KEY_ORIGHDU = 'ORIGHDU'
  character(len=*), parameter :: FITS_KEY_BUNIT = 'BUNIT'
  character(len=*), parameter :: FITS_KEY_SKYMAG = 'SKYMAG'
  character(len=*), parameter :: FITS_KEY_SKYMEAN = 'SKYMEAN'
  character(len=*), parameter :: FITS_KEY_SKYSIG = 'SKYSIG'
  character(len=*), parameter :: FITS_KEY_SKYSTD = 'SKYSTD'
  character(len=*), parameter :: FITS_KEY_IMAGETYP = 'IMAGETYP'
  character(len=*), parameter :: FITS_KEY_DATEOBS = 'DATE-OBS'
  character(len=*), parameter :: FITS_KEY_TIMEOBS = 'TIME-OBS'
  character(len=*), parameter :: FITS_KEY_TEMPERATURE = 'TEMPERAT'
  character(len=*), parameter :: FITS_KEY_AIRMASS = 'AIRMASS'
  character(len=*), parameter :: FITS_KEY_JD = 'JD'
  character(len=*), parameter :: FITS_KEY_HJD = 'HJD'
  character(len=*), parameter :: FITS_KEY_FILENAME = 'FILENAME'
  character(len=*), parameter :: FITS_KEY_PHOTOTYP = 'PHOTOTYP'

  ! definitions of column labels, common
  character(len=*), parameter :: FITS_COL_FILENAME = 'FILENAME'
  character(len=*), parameter :: FITS_COL_TIME = 'TIME'
  character(len=*), parameter :: FITS_COL_X = 'X'
  character(len=*), parameter :: FITS_COL_Y = 'Y'
  character(len=*), parameter :: FITS_COL_RA = 'RAJ2000'
  character(len=*), parameter :: FITS_COL_DEC = 'DEJ2000'
  character(len=*), parameter :: FITS_COL_PMRA = 'pmRA'
  character(len=*), parameter :: FITS_COL_PMDEC = 'pmDE'
  character(len=*), parameter :: FITS_COL_SKY = 'SKY'
  character(len=*), parameter :: FITS_COL_SKYERR = 'SKYERR'
  character(len=*), parameter :: FITS_COL_AZIMUTH = 'AZIMUTH'
  character(len=*), parameter :: FITS_COL_ZENITD = 'ZENITD'
  character(len=*), parameter :: FITS_COL_AIRMASS = 'AIRMASS'
  character(len=*), parameter :: FITS_COL_R = 'R'
  character(len=*), parameter :: FITS_COL_GROW = 'GROWCURVE'
  character(len=*), parameter :: FITS_COL_GROWERR = 'GROWCURVEERR'
  character(len=*), parameter :: FITS_COL_RPROF = 'RADIALPROFILE'
  character(len=*), parameter :: FITS_COL_RESGROW = 'RESGROW'
  character(len=*), parameter :: FITS_COL_GROWFLAG = 'GROWFLAG'

  ! definitions of column labels, find
  character(len=*), parameter :: FITS_COL_PEAKRATIO = 'PEAKRATIO'
  character(len=*), parameter :: FITS_COL_SHARP = 'SHARP'
  character(len=*), parameter :: FITS_COL_ROUND = 'ROUND'

  ! definitions of column labels, general photometry
  character(len=*), parameter :: FITS_COL_COUNT =     'COUNT'
  character(len=*), parameter :: FITS_COL_COUNTERR =  'COUNTERR'
  character(len=*), parameter :: FITS_COL_PHOTON =    'PHOTON'
  character(len=*), parameter :: FITS_COL_PHOTONERR = 'PHOTONERR'
  character(len=*), parameter :: FITS_COL_PHOTRATE =    'PHOTRATE'
  character(len=*), parameter :: FITS_COL_PHOTRATEERR = 'PHOTRATEERR'

  ! definitions of column labels, aperture photometry
  character(len=*), parameter :: FITS_COL_APCOUNT =    'APCOUNT'
  character(len=*), parameter :: FITS_COL_APCOUNTERR = 'APCOUNTERR'

  ! definitions of column labels, growth-curve photometry
  character(len=*), parameter :: FITS_COL_GCOUNT =    'GCOUNT'
  character(len=*), parameter :: FITS_COL_GCOUNTERR = 'GCOUNTERR'

  ! definitions of column labels, L-photometry
  character(len=*), parameter :: FITS_COL_LBCOUNT =    'LBCOUNT'
  character(len=*), parameter :: FITS_COL_LBCOUNTERR = 'LBCOUNTERR'

  ! definitions of column labels, PSF photometry
  character(len=*), parameter :: FITS_COL_PSFCOUNT =   'PSFCOUNT'
  character(len=*), parameter :: FITS_COL_PSFCOUNTERR ='PSFCOUNTERR'
  character(len=*), parameter :: FITS_COL_PSFPEAK =    'PSFPEAK'
  character(len=*), parameter :: FITS_COL_PSFPEAKERR = 'PSFPEAKERR'

  ! definitions of column labels, output photometry quantities
  character(len=*), parameter :: FITS_COL_PHOTNU =     'PHOTNU'
  character(len=*), parameter :: FITS_COL_PHOTNUERR =  'PHOTNUERR'
  character(len=*), parameter :: FITS_COL_PHOTLAM =    'PHOTLAM'
  character(len=*), parameter :: FITS_COL_PHOTLAMERR = 'PHOTLAMERR'
  character(len=*), parameter :: FITS_COL_FLUX =       'FLUX'
  character(len=*), parameter :: FITS_COL_FLUXERR =    'FLUXERR'
  character(len=*), parameter :: FITS_COL_FNU =        'FNU'
  character(len=*), parameter :: FITS_COL_FNUERR =     'FNUERR'
  character(len=*), parameter :: FITS_COL_FLAM =       'FLAM'
  character(len=*), parameter :: FITS_COL_FLAMERR=     'FLAMERR'
  character(len=*), parameter :: FITS_COL_MAG =        'MAG'
  character(len=*), parameter :: FITS_COL_MAGERR =     'MAGERR'
  character(len=*), parameter :: FITS_COL_ABMAG =      'ABMAG'
  character(len=*), parameter :: FITS_COL_ABMAGERR =   'ABMAGERR'
  character(len=*), parameter :: FITS_COL_STMAG =      'STMAG'
  character(len=*), parameter :: FITS_COL_STMAGERR =   'STMAGERR'
  character(len=*), parameter :: FITS_COL_RATE =       'RATE'
  character(len=*), parameter :: FITS_COL_RATEERR =    'RATEERR'

  character(len=*), parameter :: FITS_COL_FILTER =     'FILTER'

  character(len=*), parameter :: FITS_COL_LAMEFF =     'LAM_EFF'
  character(len=*), parameter :: FITS_COL_LAMFWHM =    'LAM_FWHM'
  character(len=*), parameter :: FITS_COL_NUEFF =      'NU_EFF'
  character(len=*), parameter :: FITS_COL_NUFWHM =     'NU_FWHM'
  character(len=*), parameter :: FITS_COL_FNUREF =     'FNU_REF'
  character(len=*), parameter :: FITS_COL_FLAMREF =    'FLAM_REF'


contains

  subroutine fits_get_dateobs(fitsfile,keys,dateobs,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), dimension(:), intent(in) :: keys
    character(len=*), intent(out) :: dateobs
    integer, intent(in out) :: status

    character(len=FLEN_VALUE) :: date, time
    character(len=FLEN_COMMENT) :: com
    integer :: status1,status2

    dateobs = ''
    if( status /= 0 ) return

    status1 = 0
    status2 = 0

    com = ''
    date = ''
    time = ''
    call fits_read_key(fitsfile,keys(1),date,com,status1)
    call fits_read_key(fitsfile,keys(2),time,com,status2)

    if( status1 == 0 .and. status2 == 0 ) then
       ! full date is in dateobs, full time is in timeobs
       ! this time specification is obsolete now (since 2000)
       dateobs = trim(date) // "T" // trim(time)
       status = 0
    else if ( status1 == 0 ) then
       ! both date and time are in one record, the standard way
       dateobs = date
       status = 0
    else
       status = status1
    end if

  end subroutine fits_get_dateobs

  subroutine fits_read_wcs(fitsfile,ctype,crval,crpix,cd,crder,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), dimension(:), intent(out) :: ctype
    real(selected_real_kind(15)), dimension(:), intent(out) :: crval,crpix,crder
    real(selected_real_kind(15)), dimension(:,:), intent(out) :: cd
    integer, intent(in out) :: status

    character(len=FLEN_CARD) :: buf
    character(len=FLEN_KEYWORD) :: keyword, key
    integer :: n,m

    buf = ''
    keyword = ''
    key = ''
    ctype = ''

    ! read astrometric calibration
    do n = 1, size(ctype)
       call fits_make_keyn('CTYPE',n,keyword,status)
       call fits_read_key(fitsfile,keyword,ctype(n),buf,status)
    end do
    do n = 1, size(crval)
       call fits_make_keyn('CRVAL',n,keyword,status)
       call fits_read_key(fitsfile,keyword,crval(n),buf,status)
    end do
    do n = 1, size(crpix)
       call fits_make_keyn('CRPIX',n,keyword,status)
       call fits_read_key(fitsfile,keyword,crpix(n),buf,status)
    end do
    do n = 1, size(cd,1)
       call fits_make_keyn('CD',n,keyword,status)
       do m = 1, size(cd,2)
          call fits_make_keyn(trim(keyword)//"_",m,key,status)
          call fits_read_key(fitsfile,key,cd(n,m),buf,status)
       end do
    end do

    if( status /= 0 ) return

    ! optional keywords
    call fits_write_errmark
    do n = 1, size(crder)
       call fits_make_keyn('CRDER',n,keyword,status)
       call fits_read_key(fitsfile,keyword,crder(n),buf,status)
    end do
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       call fits_clear_errmark
       status = 0
       crder = 0
    end if

  end subroutine fits_read_wcs

  subroutine fits_update_wcs(fitsfile,ctype,crval,crpix,cd,crder,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), dimension(:), intent(in) :: ctype
    real(selected_real_kind(15)), dimension(:), intent(in) :: crval,crpix
    real(selected_real_kind(15)), dimension(:,:), intent(in) :: cd
    real(selected_real_kind(15)), dimension(:), intent(in) :: crder
    integer, intent(in out) :: status

    integer, parameter :: digits = 15
    character(len=FLEN_KEYWORD) :: keyword, key
    integer :: n,m

    keyword = ''
    key = ''

    ! read astrometric calibration
    do n = 1, size(ctype)
       call fits_make_keyn('CTYPE',n,keyword,status)
       call fits_update_key(fitsfile,keyword,ctype(n), &
            'coordinate projection type',status)
    end do
    do n = 1, size(crval)
       call fits_make_keyn('CRVAL',n,keyword,status)
       call fits_update_key(fitsfile,keyword,crval(n),digits, &
            '[deg] spherical coordinates of center of projection',status)
    end do
    do n = 1, size(crpix)
       call fits_make_keyn('CRPIX',n,keyword,status)
       call fits_update_key(fitsfile,keyword,crpix(n),-6, &
            '[pix] reference pixel in focal plane',status)
    end do
    do n = 1, size(cd,1)
       call fits_make_keyn('CD',n,keyword,status)
       do m = 1, size(cd,2)
          call fits_make_keyn(trim(keyword)//"_",m,key,status)
          call fits_update_key(fitsfile,key,cd(n,m),digits, &
               '[deg/pix] scaled rotation matrix',status)
       end do
    end do

    ! optional
    if( all(crder > 0) ) then
       do n = 1, size(crder)
          call fits_make_keyn('CRDER',n,keyword,status)
          call fits_update_key(fitsfile,keyword,crder(n),1, &
               '[deg] standard errors',status)
       end do
    end if

    do n = 1, size(ctype)
       call fits_make_keyn('CUNIT',n,keyword,status)
       call fits_update_key(fitsfile,keyword,'deg','units of the CRVALx axis',status)
    end do

  end subroutine fits_update_wcs


end module titsio

!
!  Merging of photometric catalogues
!
!  Copyright © 2013-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

module jamming


  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl

contains


  subroutine cooid(refra,refdec,ra,dec,tol,idx)

    real(dbl), dimension(:), intent(in) :: ra, dec, refra, refdec
    real(dbl), intent(in) :: tol
    integer, dimension(:), intent(out) :: idx
    integer :: i,j,jmin
    real(dbl) :: r,rmin

    idx = 0

    do i = 1,size(ra)
       rmin = tol
       jmin = 0
       do j = 1,size(refra)
          r = spmetr(refra(j),refdec(j),ra(i),dec(i))
          if( r < rmin )then
             rmin = r
             jmin = j
          end if
       end do

       if( jmin > 0 ) then
          idx(jmin) = i
       end if

    end do

  end subroutine cooid

  function spmetr(a1,d1,a2,d2)

    ! angular distance in degrees

    real(dbl), parameter :: rad = 57.295779513082322865_dbl
    real(dbl) :: spmetr
    real(dbl), intent(in) :: a1,d1,a2,d2
    real(dbl) :: cosr

    cosr = sin(d1/rad)*sin(d2/rad) + cos(d1/rad)*cos(d2/rad)*cos((a1 - a2)/rad)
    spmetr = rad*acos(min(cosr,1.0_dbl))
!    spmetr = sqrt((d1 - d2)**2 + cos((a1+a2)/2/rad)**2*(a1 - a2)**2)

  end function spmetr


  subroutine jamcat(tol, refra, refdec, mag, dmag, ra,dec,dn,ddn, cts, dcts )

    real(dbl), dimension(:), intent(in) :: tol
    real(dbl), dimension(:), intent(in out) :: refra, refdec
    real(dbl), dimension(:,:), intent(in out) :: mag, dmag
    real(dbl), dimension(:,:), intent(in) :: dn,ddn, ra, dec
    real(dbl), dimension(:,:), allocatable, intent(out) :: cts,dcts

    real(dbl), dimension(:,:), allocatable :: xcts,xdcts
    integer, dimension(:), allocatable :: id
    integer :: ncat,ncols,j,n,l


    ncat = size(mag,1)
    ncols = size(dn,2)

    allocate(id(ncat))
    allocate(xcts(ncat,ncols),xdcts(ncat,ncols))
    xcts = -1
    xdcts = 0

    do n = 1, ncols

       call cooid(refra,refdec,ra(:,n),dec(:,n),tol(n),id)

       do l = 1,ncat
          if( id(l) > 0 ) then
             j = id(l)
!             write(*,*) dn(j,n),mag(l,n)
             if(  dn(j,n) > 0 .and. mag(l,n) < 99 ) then
                xcts(l,n) = dn(j,n)
                xdcts(l,n) = ddn(j,n)
             end if
          end if
       end do

    end do


    ! select valid records
    ncat = 0
    do j = 1,size(mag,1)
       if( all(xcts(j,:) > 0) ) then
!          if(  all(sqrt(xcts(j,:))/xcts(j,:) < 0.005) ) then
             ncat = ncat + 1
             refra(ncat) = refra(j)
             refdec(ncat) = refdec(j)
             mag(ncat,:) = mag(j,:)
             dmag(ncat,:) = dmag(j,:)
             xcts(ncat,:) = xcts(j,:)
             xdcts(ncat,:) = xdcts(j,:)
!          end if
       end if
    end do

    deallocate(id)

    allocate(cts(ncat,ncols),dcts(ncat,ncols))
    cts(1:ncat,:) = xcts(1:ncat,:)
    dcts(1:ncat,:) = xdcts(1:ncat,:)
    deallocate(xcts,xdcts)


  end subroutine jamcat


  subroutine jamcatx(cat,phsystable,keys,col_ra,col_dec,col_mag,col_magerr,utol, &
       area, init_area, filters, filename, catid, filter, ra, dec, airmass,ph,dph, &
       cts,dcts, photosys_ref, photosys_instr, pairs)

    use phsysfits
    use photoconv
    use mfits

    character(len=*), intent(in) :: cat,phsystable,col_ra,col_dec,photosys_ref
    character(len=*), intent(out) :: photosys_instr
    character(len=*), dimension(:), intent(in) :: keys,col_mag,col_magerr,filters,filename
    real(dbl), intent(in) :: utol, area
    logical, intent(in) :: init_area
    real(dbl), dimension(:), allocatable, intent(out) :: ra, dec, airmass
    real(dbl), dimension(:,:), allocatable, intent(out) :: ph,dph,cts,dcts
    character(len=FLEN_VALUE), dimension(:), allocatable, intent(out) :: filter
    character(len=FLEN_VALUE), intent(out) :: catid
    integer, dimension(:,:), allocatable, intent(out) :: pairs

    real(dbl), allocatable, dimension(:) :: refra,refdec,xra,xdec,adu,dadu,exptime,areas
    real(dbl), allocatable, dimension(:,:) :: mag,dmag, xcts,xdcts
    real(dbl) :: ftol,tol,w, aper
    integer, dimension(:), allocatable :: id
    type(type_phsys), dimension(:), allocatable :: phsyscal
    type(type_phsys) :: phsys
    integer :: status,nfiles,ncat,ncols,j,n,l

    ! setup to prove
    real(dbl), parameter :: waterline = 5
    real(dbl), parameter :: maxerr = 0.1


    call readcat(cat,(/col_ra,col_dec/),col_mag,col_magerr, &
         refra,refdec,mag,dmag,catid,status)
    if( status /= 0 ) stop 'Failed to read a catalogue.'

    ncat = size(mag,1)
    ncols = size(mag,2)
    nfiles = size(filename)

    if( ncols /= nfiles ) stop 'Count of color bands and files differs.'

    allocate(xcts(ncat,nfiles),xdcts(ncat,nfiles))
    xcts = -1
    xdcts = 0
    allocate(exptime(nfiles),areas(nfiles),filter(nfiles),airmass(nfiles))

    do n = 1, nfiles
       call readframe(filename(n),keys,waterline,maxerr,xra,xdec,adu,dadu,&
            ftol,exptime(n),areas(n),photosys_instr,filter(n), &
            init_area,0,aper,status,airmass(n))
       ! SAPER=0 is set at any case, only apperture corrected data are used !

       if( status /= 0 ) then
          write(*,*) "Failed to read `",trim(filename(n)),"'."
          stop 666
       end if

       if( utol > 0 ) then
          tol = utol
       else
          tol = ftol
       end if

       if( init_area ) areas = area

       if( filter(n) /= filters(n) ) write(*,*) "Warning: Different filters (?): `",&
            trim(filters(n)),"'(catalogue), `",trim(filter(n)),"'(frame)."

       allocate(id(ncat))
       call cooid(refra,refdec,xra,xdec,tol,id)

       do l = 1,ncat
          if( id(l) > 0 ) then
             j = id(l)
             if( adu(j) > 0 ) then
                xcts(l,n) = adu(j)
                xdcts(l,n) = dadu(j)
             end if
          end if
       end do

       deallocate(id,xra,xdec,adu,dadu)
    end do

    ! select just valid records
    ncat = 0
    do j = 1,size(mag,1)
       if( all(xcts(j,:) > epsilon(xcts)) .and. all(mag(j,:) < 99) ) then
          ncat = ncat + 1
          refra(ncat) = refra(j)
          refdec(ncat) = refdec(j)
          mag(ncat,:) = mag(j,:)
          dmag(ncat,:) = dmag(j,:)
          xcts(ncat,:) = xcts(j,:)
          xdcts(ncat,:) = xdcts(j,:)
       end if
    end do

    allocate(ph(ncat,ncols),dph(ncat,ncols),cts(ncat,nfiles),dcts(ncat,nfiles),&
         ra(ncat),dec(ncat))

    ra = refra(1:ncat)
    dec = refdec(1:ncat)

    call phselect(phsystable,photosys_ref,phsys)
    call phsyspairs(phsys,filters,pairs)
    call phsysmagph(phsys,filters,pairs,mag(1:ncat,:),dmag(1:ncat,:),ph,dph)
!    call phsysmagflux(phsys,filters,pairs,mag(1:ncat,:),dmag(1:ncat,:),flux,dflux)

!    write(*,'(1p,5g15.6)') ph(1,:)
!    write(*,'(1p,5g15.5)') flux(1,:)

!    do j = 1,ncat
!       write(*,'(5f10.3)') mag(j,:)
!       write(*,'(i5,10g10.3)') i,flux(j,:),dflux(j,:)
!    end do

!    call phsysphmag(phsys,filters,pairs,ph,dph,mag(1:ncat,:),dmag(1:ncat,:))
!    call phsysphmag(phsys,filters,pairs,ph,dph,flux,dmag(1:ncat,:))
!    do j = 1,ncat
!       write(*,'(10f10.3)') mag(j,:),flux(j,:),mag(j,:)-flux(j,:)
!    end do



!!$!    mag(1,:) = 0
!!$    call phsysmagflux(phsys,filters,mag(1:ncat,:),dmag(1:ncat,:),flux,dflux)
!!$    write(*,'(5f10.3)') mag(1,:)
!!$    write(*,'(5e10.3)') flux(1,:)
!!$    do j = 1,ncat
!!$!       flux(j,1) = flux(j,2)*10**(-0.4*(mag(j,1)-mag(j,2)))
!!$ !      flux(j,2) = flux(j,3)*10**(-0.4*(mag(j,2)-mag(j,3)))
!!$ !      flux(j,1) = flux(j,2)*10**(-0.4*(mag(j,1)-mag(j,2)))
!!$ !      flux(j,4) = flux(j,3)*10**(0.4*(mag(j,3)-mag(j,4)))
!!$ !      flux(j,5) = flux(j,4)*10**(0.4*(mag(j,4)-mag(j,5)))
!!$    end do
!!$!    write(*,'(5e10.3)') flux(1,:)
!!$    k = pairs(1,1)
!!$    do n = 2,size(pairs,1)
!!$       i = pairs(n,1)
!!$       j = pairs(n,2)
!!$       if( pairs(n,1) < k ) then
!!$!          i = pairs(n,1)
!!$!          j = pairs(n,2)
!!$          flux(:,i) = flux(:,j)*10**(-0.4*(mag(1:ncat,i)-mag(1:ncat,j)))
!!$       else if( pairs(n,2) > k ) then
!!$!          i = pairs(n,1)
!!$!          j = pairs(n,2)
!!$          flux(:,j) = flux(:,i)*10**(0.4*(mag(1:ncat,i)-mag(1:ncat,j)))
!!$       end if
!!$       write(*,*) i,j,mag(1,i)-mag(1,j)
!!$!       do l = 1,ncat
!!$!          flux(l,i) = flux(l,j)*10**(-0.4*(mag(l,i)-mag(l,j)))
!!$!       end do
!!$    end do
!!$
!!$    write(*,'(5e10.3)') flux(1,:)
!!$    write(*,'(5a10)') filters
!!$
!!$    write(*,'(5e10.3)') ph(1,:)
!!$    !       ph(j,2) = ph(j,2)*(1+0.5*(75*0.7)**2/(553.0*(553.0-444.0))*(1.96*flux(j,1)/flux(j,2)-1))
!!$    !    write(*,*) flux(j,1)/flux(j,2),0.5*(75*0.7)**2/(553.0*(553.0-444.0))*(1.96*flux(j,1)/flux(j,2)-1)
!!$    k = pairs(1,1)
!!$    do n = 2, size(pairs,1)
!!$       i = pairs(n,1)
!!$       j = pairs(n,2)
!!$       if( pairs(n,1) < k ) then
!!$          i = pairs(n,1)
!!$          j = pairs(n,2)
!!$          w = phsys%lam_eff(j) / phsys%lam_eff(i)
!!$          ph(:,i) = ph(:,j)*(flux(:,i)/flux(:,j))*w
!!$       else if( pairs(n,2) > k ) then
!!$          i = pairs(n,1)
!!$          j = pairs(n,2)
!!$          w = phsys%lam_eff(i) / phsys%lam_eff(j)
!!$          ph(:,j) = ph(:,i)*(flux(:,j)/flux(:,i))*w
!!$       end if
!!$       write(*,*) i,j,w
!!$       do l = 1,ncat
!!$!          ph(l,i) = ph(l,j)*(flux(l,i)/flux(l,j))*w!*1.25
!!$       end do
!!$    end do
!!$!    write(*,*) phsys%lam_eff(2)/phsys%lam_eff(1)
!!$!    ph(1,1) = ph(1,2)*(flux(1,1)/flux(1,2))*1.26
!!$!    ph(1,4) = ph(1,3)*(flux(1,4)/flux(1,3))*0.80
!!$!    ph(1,5) = ph(1,4)*(flux(1,5)/flux(1,4))*0.80
!!$    write(*,'(5e10.3)') ph(1,:)

!!$    do l = 1,ncat
!!$       do n = 1,size(ph,2)
!!$          write(*,'(1pg10.3)',advance="no") &
!!$               !               mag(l,n)-mag(l,n+1) - 2.5*log10(flux(l,n+1)/flux(l,n))
!!$               flux(l,n)
!!$       end do
!!$       write(*,*)
!!$    end do
!!$
!!$    do l = 1,ncat
!!$       do n = 1,size(ph,2)
!!$          write(*,'(1pg10.3)',advance="no") &
!!$               !               mag(l,n)-mag(l,n+1) - 2.5*log10(ph(l,n+1)/ph(l,n))
!!$               ph(l,n)
!!$       end do
!!$       write(*,*)
!!$    end do

!    stop

    do n = 1,nfiles
       w = exptime(n) * areas(n)
       cts(:,n) = xcts(1:ncat,n) / w
       dcts(:,n) = xdcts(1:ncat,n) / sqrt(w)
    end do

    deallocate(mag,dmag,xcts,xdcts,exptime,areas)
    call deallocate_phsyscal_multiple(phsyscal)

  end subroutine jamcatx


  subroutine jamframes(tol, ndat, ra, dec, id )

    use phsysfits
    use photoconv
    use mfits

    real(dbl), dimension(:), intent(in) :: tol
    integer, dimension(:), intent(in) :: ndat
    real(dbl), dimension(:,:), intent(in) :: ra, dec
    integer, dimension(:,:), intent(out) :: id
    integer :: n

    id = 0

    forall(n=1:ndat(1))
       id(n,1) = n
    end forall

    do n = 2, size(ra,2)
       call cooid(ra(1:ndat(1),1),dec(1:ndat(1),1), &
            ra(1:ndat(n),n),dec(1:ndat(n),n),tol(n),id(:,n))
    end do

  end subroutine jamframes

  subroutine jamref(tol, refra, refdec, refph, drefph, ra,dec, cts, dcts)

    real(dbl), dimension(:), intent(in) :: tol
    real(dbl), dimension(:), intent(in out) :: refra, refdec
    real(dbl), dimension(:,:), allocatable, intent(in out) :: ra,dec, &
         refph, drefph, cts, dcts
!    real(dbl), dimension(:,:), intent(in) :: dn,ddn, ra, dec
!    real(dbl), dimension(:,:), allocatable, intent(out) :: cts,dcts

    real(dbl), dimension(:,:), allocatable :: xcts,xdcts
    integer, dimension(:), allocatable :: id
    integer :: nref,ncols,j,n,l


!    ncat = size(mag,1)
!    ncols = size(dn,2)

    nref= size(refra)
    ncols = size(refph,2)

    allocate(id(nref))
    allocate(xcts(nref,ncols),xdcts(nref,ncols))
    xcts = -1
    xdcts = 0

    do n = 1, ncols

       call cooid(refra,refdec,ra(:,n),dec(:,n),tol(n),id)

       do l = 1,nref
          if( id(l) > 0 ) then
             j = id(l)
             if( cts(j,n) > 0 .and. refph(l,n) > 0 ) then
                xcts(l,n) = cts(j,n)
                xdcts(l,n) = dcts(j,n)
             end if
          end if
       end do

    end do


    ! select just valid records
    nref = 0
    do j = 1,size(refph,1)
       if( all(xcts(j,:) > 0) .and. all(refph(j,:) > 0) ) then
!          if(  all(sqrt(xcts(j,:))/xcts(j,:) < 0.01) ) then
             nref = nref + 1
             refra(nref) = refra(j)
             refdec(nref) = refdec(j)
             refph(nref,:) = refph(j,:)
             drefph(nref,:) = drefph(j,:)
             xcts(nref,:) = xcts(j,:)
             xdcts(nref,:) = xdcts(j,:)
!          end if
       end if
    end do

    deallocate(id)

    deallocate(cts,dcts)
    allocate(cts(nref,ncols),dcts(nref,ncols))
    cts = xcts(1:nref,:)
    dcts = xdcts(1:nref,:)
    deallocate(xcts,xdcts)


  end subroutine jamref

end module jamming

!
!  grow-curve photometry
!
!  Copyright © 2016-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


program gphot

  use fitsio
  use iso_fortran_env

  implicit none

  character(len=4*FLEN_FILENAME) :: record,key,val
  character(len=FLEN_FILENAME) :: outname, file,backup, output = ''
  logical :: verbose = .false., plog = .false.
  integer :: eq,status
  real :: threshold = 0.1

  do
     read(*,'(a)',end=20) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Improper input.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'PIPELOG' ) then

        read(val,*) plog

     else if( key == 'THRESHOLD' ) then

        read(val,*) threshold

     else if( key == 'FILE' ) then

        read(val,*) file, backup, output

        status = 0
        call fitsback(file,backup,output,.false.,outname,status)
        call growfits(outname,threshold,verbose)

     end if

  end do

20 continue

  stop 0

contains

  subroutine growfits(filename,threshold,verbose)

    use grow_curve
    use grow_report

    character(len=*),intent(in) :: filename
    real, intent(in) :: threshold
    logical, intent(in) :: verbose

    integer, parameter :: rp = selected_real_kind(15)

    integer :: status,blocksize,nrows,xcol,ycol,ecol,scol,hdutype,i,n,naper
    integer, parameter :: group = 1, extver = 0, frow = 1, felem = 1, nbegin = 4
    real, parameter :: nullval = 0.0
    logical :: anyf
    real, dimension(:), allocatable :: xcens,ycens,sky,skyerr,skycorr,skyerrcorr
    real, dimension(:,:), allocatable :: apcts,apcts_err
    real(rp), dimension(:), allocatable :: gcount,gcount_err
    integer, dimension(:), allocatable :: growflag
    real(rp), dimension(:), allocatable :: curve, curve_err, prof
    real, dimension(:), allocatable :: raper
    character(len=FLEN_VALUE), dimension(:), allocatable :: ttype, tform, tunit
    real :: hwhm, rflux90, ghwhm, sep
    character(len=FLEN_COMMENT) :: com
    character(len=FLEN_VALUE) :: key, label
    type(grow_reporter) :: reporter
    logical :: report_init

    report_init = .false.

    status = 0
    call ftopen(15,filename,1,blocksize,status)
    if( status /= 0 ) then
       write(error_unit,*) "Error: `",trim(filename),"' failed to open (for writing)."
       goto 666
    end if

    call ftmnhd(15,BINARY_TBL,APEREXTNAME,extver,status)
    if( status == BAD_HDU_NUM ) then
       write(error_unit,*) "Error: ",trim(APEREXTNAME)// &
            " extension not found. Has been aperture photometry by " // &
            "`munipack aphot "//trim(filename)//"' performed?"
       goto 666
    end if

    call ftgnrw(15,nrows,status)
    call ftgkyj(15,FITS_KEY_NAPER,naper,com,status)
    call ftgkye(15,FITS_KEY_HWHM,hwhm,com,status)
    call ftgkye(15,trim(FITS_KEY_ANNULUS)//'2',sep,com,status)

    allocate(xcens(nrows),ycens(nrows),sky(nrows),skyerr(nrows), &
         skycorr(nrows),skyerrcorr(nrows),apcts(nrows,naper),apcts_err(nrows,naper), &
         gcount(nrows),gcount_err(nrows),growflag(nrows), &
         curve(naper), curve_err(naper), prof(naper), raper(naper))

    do i = 1, naper
       call ftkeyn(FITS_KEY_APER,i,key,status)
       call ftgkye(15,key,raper(i),com,status)
    end do

    call ftgcno(15,.true.,FITS_COL_X,xcol,status)
    call ftgcno(15,.true.,FITS_COL_Y,ycol,status)
    call ftgcno(15,.true.,FITS_COL_SKY,scol,status)
    call ftgcno(15,.true.,FITS_COL_SKYERR,ecol,status)
    call ftgcve(15,xcol,frow,felem,nrows,nullval,xcens,anyf,status)
    call ftgcve(15,ycol,frow,felem,nrows,nullval,ycens,anyf,status)
    call ftgcve(15,scol,frow,felem,nrows,nullval,sky,anyf,status)
    call ftgcve(15,ecol,frow,felem,nrows,nullval,skyerr,anyf,status)

    do i = 1, naper
       write(label,'(a,i0)') FITS_COL_APCOUNT,i
       call ftgcno(15,.true.,label,n,status)
       call ftgcve(15,n,frow,felem,nrows,nullval,apcts(:,i),anyf,status)
       write(label,'(a,i0)') FITS_COL_APCOUNTERR,i
       call ftgcno(15,.true.,label,n,status)
       call ftgcve(15,n,frow,felem,nrows,nullval,apcts_err(:,i),anyf,status)
    end do

    ! all the commands must be finished without eny error for
    ! correct head, any error indicates internal inconsistency
    if( status /= 0 ) goto 666

    if( verbose ) then
       report_init = .true.
       call grow_report_init(reporter,naper,nrows,raper)
    end if

    ! angular separation of stars intended as base for growth-curve construction,
    ! the stars can share only the ring of sky
    !  sep = ring(2)

    ! growth-curve photometry
    call growphot(xcens,ycens,apcts,apcts_err,sky,skyerr,raper,hwhm,sep,threshold, &
         gcount,gcount_err,skycorr,skyerrcorr,curve,curve_err,growflag, &
         prof,rflux90,ghwhm,verbose,reporter)

    ! update sky
    sky = sky - skycorr
    where( skyerr > 0 .and. skyerrcorr > 0 )
       skyerr = sqrt(skyerr**2 + skyerrcorr**2) / 1.414
!    elsewhere
!       skyerr = 0
    end where

    ! grow photometry table
    call ftmnhd(15,BINARY_TBL,GROWEXTNAME,extver,status)
    if( status == BAD_HDU_NUM ) then
       status = 0
    else
       ! already presented ? remove it !
       call ftdhdu(15,hdutype,status)
       if( status /= 0 ) goto 666
    end if

    n = 7
    allocate(ttype(n), tform(n), tunit(n))

    tform = '1D'
    tform(7) = '1B'
    tunit = ''
    ttype(1) = FITS_COL_X
    ttype(2) = FITS_COL_Y
    ttype(3) = FITS_COL_SKY
    ttype(4) = FITS_COL_SKYERR
    ttype(5) = FITS_COL_GCOUNT
    ttype(6) = FITS_COL_GCOUNTERR
    ttype(7) = FITS_COL_GROWFLAG

    call ftibin(15,0,size(ttype),ttype,tform,tunit,GROWEXTNAME,0,status)
    call ftpkye(15,FITS_KEY_HWHM,ghwhm,-4,'[pix] half width at half of maximum',status)
    call ftpkye(15,FITS_KEY_RF90,rflux90,-4,'[pix] radius contains 90% of flux',status)
    write(com,'(a,i0)') 'Count of stars used for curve construction: ',count(growflag == 1)
    call ftpcom(15,com,status)
    call ftpcom(15,'GROWFLAG: 0 - star, not used,',status)
    call ftpcom(15,'          1 - star, used for growth curve construction,',status)
    call ftpcom(15,'          2 - non-stellar object',status)
    call ftpcle(15,1,frow,felem,size(xcens),xcens,status)
    call ftpcle(15,2,frow,felem,size(ycens),ycens,status)
    call ftpcle(15,3,frow,felem,size(sky),sky,status)
    call ftpcle(15,4,frow,felem,size(skyerr),skyerr,status)
    call ftpcld(15,5,frow,felem,size(gcount),gcount,status)
    call ftpcld(15,6,frow,felem,size(gcount_err),gcount_err,status)
    call ftpclj(15,7,frow,felem,size(growflag),growflag,status)
    deallocate(ttype,tform,tunit)

    ! store growth-curve
    call ftmnhd(15,BINARY_TBL,GROWCURVEXTNAME,extver,status)
    if( status == BAD_HDU_NUM ) then
       status = 0
    else
       ! already presented ? remove it !
       call ftdhdu(15,hdutype,status)
       if( status /= 0 ) goto 666
    end if

    n = 4
    allocate(ttype(n), tform(n), tunit(n))

    tform = '1D'
    tunit = ''
    ttype(1) = FITS_COL_R
    ttype(2) = FITS_COL_GROW
    ttype(3) = FITS_COL_GROWERR
    ttype(4) = FITS_COL_RPROF

    call ftibin(15,0,size(ttype),ttype,tform,tunit,GROWCURVEXTNAME,0,status)
    call ftpcle(15,1,frow,felem,size(raper),raper,status)
    call ftpcld(15,2,frow,felem,size(curve),curve,status)
    call ftpcld(15,3,frow,felem,size(curve),curve_err,status)
    call ftpcld(15,4,frow,felem,size(prof),prof,status)
    deallocate(ttype,tform,tunit)

    if( verbose ) call grow_report_dump(15,reporter,status)

666 continue

    if( allocated(apcts) ) deallocate(xcens,ycens,sky,skyerr,skycorr,skyerrcorr, &
         apcts,apcts_err,gcount,gcount_err,growflag,curve,curve_err,prof,raper)

    call ftclos(15,status)
    call ftrprt('STDERR',status)

    if( verbose .and. report_init ) call grow_report_terminate(reporter)

  end subroutine growfits


end program gphot

!
!  selectsort - a simple sorting algorithm
!
!  by  Wirth,N: Algorithm + Data Structure = Programs, Prentice-Hall, 1975
!
!  Copyright © 2012 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!  
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!  
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module selectsort

  implicit none

  ! precision of real numbers
  integer, parameter, private :: rp = selected_real_kind(15)

contains

  subroutine ssort(a)

    real(rp), dimension(:), intent(in out) :: a
    real(rp) :: x
    integer :: n,i,j,k

    n = size(a)
    do i = 1, n - 1
       k = i
       x = a(i)
       do j = i + 1, n
          if( a(j) < x ) then
             k = j
             x = a(j)
          end if
       end do
       a(k) = a(i)
       a(i) = x
    end do

  end subroutine ssort

end module selectsort

!
! coloring
!
!
! Copyright © 2010-2 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program mcoloring

  use coloring_book

  implicit none

  integer, parameter :: slen = 32768
  character(len=slen) :: record,radek,line,cname,backup,cspace
  character(len=slen),dimension(:),allocatable :: fnames
  character(len=10),dimension(3) :: key
  integer :: n,i,j,istat,nband = 0

  cname = 'color.fits'
  cspace = ''
  key(1) = 'INFO'           ! <argument> print some information
  key(2) = 'OUTPUT'         ! name of output file (default 'color.fits')
  key(3) = 'COLORSPACE'     ! data stored in the colorspace(default 'XYZ')

  ! NBAND key sets number of input bands (3 only?)
  ! line without key a file with single band is specified, sorted 
  ! by increased wavelength (eg. BVR)

  ! read input data
  n = 0
  do
     read(*,'(a)',end=99,iostat=istat) record
     if( istat /= 0 ) then
        write(*,*) 'Unexpected data on input.'
        stop 34
     end if

     j = index(record,'#')
     if( j == 0 ) then
        radek = record
     else
        radek = record(1:j-1)
     end if

     do i = 1, size(key)
        j = index(radek,trim(key(i)))
        if( j > 0 ) line = radek(index(radek,'=')+1:)

        if( j > 0 .and. key(i) == 'INFO' ) then
           write(*,*) 'info [parameters]'
           stop 0
        end if

        if( j > 0 .and. key(i) == 'OUTPUT' ) then
           read(line,*,iostat=istat) cname,backup
           if( istat /= 0 .or. cname == '') then
              write(*,*) 'An error during reading of the output file name.'
              stop 34
           end if
        end if

        if( j > 0 .and. key(i) == 'COLORSPACE' ) then
           read(line,*,iostat=istat) cspace
           if( istat /= 0 .or. cspace == '' ) then
              write(*,*) 'An error during reading of the input colorspace.'
              stop 34
           end if
        end if

     end do

     if( j == 0 ) then

        if( index(radek,'NBAND') > 0 ) then

           read(radek(index(radek,'=')+1:),*,iostat=istat) nband
           if( istat /= 0 .or. nband <= 0 ) then
              write(*,*) 'NBAND parameter read failed.'
              stop 34
           end if
           if( allocated(fnames) ) then
              write(*,*) 'NBAND multiply specified ?'
              stop 35
           end if
           allocate(fnames(nband))

        else if( nband > 0 .and. n < nband .and. radek /= ' ') then

           n = n + 1
           read(radek,*,iostat=istat) fnames(n)
           if( istat /= 0 ) then
              write(*,*) 'Failed to parse of an input record.'
              stop 34
           end if

        end if

     end if

  end do
99 continue

  if( n /= nband ) then
     write(*,*) 'A full set of FITS files not specified.'
     if( allocated(fnames) ) deallocate(fnames)
     stop 33
  end if

  if( cspace == '' ) then
     write(*,*) 'Input colorspace not specified.'
     if( allocated(fnames) ) deallocate(fnames)
     stop 33
  end if

  call coloring(cspace,fnames,cname,backup)

  stop 0

end program mcoloring

!
! coloring - the engine
!
!
! Copyright © 2010-3 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module coloring_book

  implicit none


contains

  subroutine coloring(cspace,fnames,cname,backup)

    use fitsio

    implicit none

    ! the container for headers
    type MetaFits
       integer :: bitpix
       integer, dimension(2) :: naxes
       character(len=80),dimension(:),allocatable :: head
    end type MetaFits

    character(len=*),dimension(:),intent(in) :: fnames
    character(len=*),intent(in) :: cname,backup,cspace

    ! the parameter fnames contains list of filenames in order BVR

    integer, parameter :: naxis = 2
    real, parameter :: minvalue = -huge(1.0)
    integer :: bitpix = 8

    integer :: nbands, width, height, nhead
    integer :: i,n,istat, mstat,bpix, pcount,gcount
    integer, dimension(naxis) :: naxes
    integer, dimension(naxis+1) :: naxes3d
    logical :: simple,extend,anyf
    real,dimension(:,:,:),allocatable :: cube
    real,dimension(:,:), allocatable :: ccd
    type(MetaFits), dimension(:), allocatable :: mfits

    nbands = size(fnames)

    width = 0
    height = 0

    allocate(mfits(nbands))

    ! load images
    do i = 1,nbands

       istat = 0
       call ftnopn(25,fnames(i),0,istat)
       if( istat /= 0 ) goto 666
       call ftghpr(25,naxis,simple,bpix,n,naxes,pcount,gcount,extend,istat)

       if( n /= naxis ) then
          write(*,*) 'Only two dimensional images are supported.'
          stop 31
       end if

       mfits(i)%bitpix = bpix
       mfits(i)%naxes = naxes

       if( abs(bpix) > abs(bitpix) ) bitpix = bpix

       call ftghps(25,nhead,n,istat)
       allocate(mfits(i)%head(nhead),stat=mstat)
       if( mstat /= 0 ) then
          write(*,*) 'Not enough memory for your head.'
          stop 31
       end if
       do n = 1, nhead
          call ftgrec(25,n,mfits(i)%head(n),istat)
       enddo

       if( i == 1 ) then
          width = naxes(1)
          height = naxes(2)
          allocate(cube(width,height,nbands),stat=mstat)
          !if( mstat /= 0 ) stop 'Not enough memory.'
          if( mstat == 0 ) &
               allocate(ccd(width,height),stat=mstat)
          if( mstat /= 0 ) then
             write(*,*) 'Not enough memory..'
             stop 66
          end if
       else if( .not.(naxes(1) == width .and. naxes(2) == height) ) then
          write(*,*) 'Dimensions of images does not corresponds mutually.'
          stop 31
       end if

       call ftg2de(25,1,minvalue,width,width,height,ccd,anyf,istat)
       cube(:,:,i) = ccd

       call ftclos(25,istat)

       if( istat /= 0 ) goto 666

    end do

    deallocate(ccd)


    ! write out FITS color
    call fitsbackup(cname,backup,istat)
    call ftinit(26,cname,1,istat)

    naxes3d = (/ width, height, nbands /)
    call ftiimg(26,bitpix,3,naxes3d,istat)

    call ftukys(26,FITS_KEY_CSPACE,cspace,'the color space of stored data',istat)

    call ftpcom(26,'Headers of originals:',istat)
    do i = 1,nbands
       call ftpcom(26,'BEGIN '//trim(fnames(i)),istat)
       do n = 1, size(mfits(i)%head)
          call ftpcom(26,mfits(i)%head(n),istat)
       enddo
       call ftpcom(26,'END '//trim(fnames(i)),istat)
    end do

    call ftukys(26,'CREATOR','Munipack','Created by coloring utility of Munipack',istat)

    call ftp3de(26,1,width,height,width,height,nbands,cube,istat)

    if( istat == 412 ) istat = 0 ! numerical overflow during implicit datatype conversion

    call ftclos(26,istat)


666 continue

    do i = 1,nbands
       if( allocated(mfits(i)%head) )deallocate(mfits(i)%head)
    end do
    if( allocated(mfits) ) deallocate(mfits)
    if( allocated(cube) ) deallocate(cube)
    if( allocated(ccd) ) deallocate(ccd)

    call ftrprt('STDERR',istat)

  end subroutine coloring

end module coloring_book

!
!  Quantile mean
!
!  Copyright © 2016-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!
!
! * qmean - estimate on base of quantiles (constructs CDF), usefull for initials
!           or as a general (slow) estimator of mean

module qmeans

  implicit none

  ! print debug informations ?
  logical, parameter, private :: debug = .false.

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)

  ! 50% quantil of N(0,1)
  real(dbl), parameter, private :: q50 = 0.6745

  private :: pulky

contains

  subroutine qmean(x,t,s)

    ! this function computes mean by using of quantiles

    real(dbl), dimension(:), intent(in) :: x
    real(dbl), intent(out) :: t,s
    real(dbl), dimension(:), allocatable :: xcdf,ycdf
    real(dbl), dimension(3), parameter :: xq = (/0.25_dbl, 0.5_dbl, 0.75_dbl/)
    real(dbl), dimension(size(xq)) :: q
    integer :: i,n

    n = size(x)
    allocate(xcdf(n),ycdf(n))

    ! cummulative distribution function of data
    call cdf(x,xcdf,ycdf)

    ! quantiles
    do i = 1, size(q)
       call quantile(xq(i),xcdf,ycdf,q(i))
    end do

    ! mean is for q = 1/2, it is fully equivalent to median
    t = q(2)

    ! standard deviation is estimated from quantile deviation
    s = (q(3) - q(1))/(2*q50)

    if( debug ) write(*,*) 'q1/4,q1/2,q3/4:',q

!    open(1,file='quantile')
!    do i = 1,n
!       call quantile(ycdf(i),xcdf,ycdf,q(1))
       !       write(1,*) ycdf(i),q(1)
!       write(1,*) xcdf(i),ycdf(i)
!    end do
!    close(1)

    deallocate(xcdf,ycdf)

  end subroutine qmean



  subroutine cdf(x,u,v)

    ! cumulative distribution function constructed from data

    use quicksort

    real(dbl),dimension(:),intent(in) :: x
    real(dbl),dimension(:),intent(out) :: u,v
    integer :: i,n
    real(dbl) :: h

    n = size(x)
    h = 1.0_dbl / (n + 1.0_dbl)

    u = x
    call qsort(u)
    forall( i = 1:n ) v(i) = i*h

!    open(1,file='cdf')
!    do i = 1,n
!       write(1,*) u(i),v(i)
!    end do
!    close(1)

  end subroutine cdf


  function pulky(x,q) result(k)

    ! performs bi-section on pre-sorted array x, more than two values are required
    ! returns index k of the element of x for which x(k) <= q .and. q <= x(k+1)

    integer :: k
    real(dbl), intent(in) :: q
    real(dbl), dimension(:),intent(in) :: x
    integer :: n,i,ka,kb,maxit

    n = size(x)
    maxit = int(log(real(n)) / 0.69315 + 1)  ! ~ log2(n) + 1
    ka = 1
    kb = n - 1
    do i = 1, maxit
       k = (ka + kb) / 2
       if( x(k) <= q .and. q <= x(k+1) ) return
       if( x(ka) <= q .and. q < x(k) ) then
          kb = k
       else if( x(k) <= q .and. q < x(kb+1) ) then
          ka = k
       else if ( debug ) then
          write(*,*) 'Pulky warning:',ka,k,kb,q,x
       end if
    end do

    ! this point is reached only when no convergence is occured
    k = -1

  end function pulky


  subroutine quantile(q,x,y,t)

    ! estimates q-quantile, this is inverse of CDF from data

    real(dbl), intent(in) :: q
    real(dbl), dimension(:),intent(in) :: x,y
    real(dbl), intent(out) :: t
    integer :: i,n,low,high

    n = size(x)

    if( n == 0 ) then
       t = 0
       return
    else if( n == 1 ) then
       t = x(1)
       return
    end if

    if( q <= y(1) ) then
       t = x(1)
    else if( q >= y(n) ) then
       t = x(n)
    else

       ! we are looking for proper interval of q in y
       low = pulky(y,q)
       high = low + 1

       ! check reliability of binary search, or try (slow) linear search
       if( low < 0 ) then
          if( debug ) write(*,*) 'Warning: Binary search failed. q:',q
          low = 1
          high = n
          do i = 1,n-1
             if( y(i) <= q .and. q <= y(i+1) ) then
                low = i
                high = i+1
                exit
             end if
          end do
       end if

       ! the result is linearly interpolated
       t = (x(high) - x(low))/(y(high) - y(low))*(q - y(low)) + x(low)
    end if
!    write(*,*) high,low,x(high),x(low),y(high),y(low)

  end subroutine quantile



end module qmeans

!
!  Colour extinction
!
!  Copyright © 2015, 2017-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module colorex

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

  ! sqrt(pi/2) - obsolete
  real(dbl), parameter, private :: sqrtpi2 = 1.2533141373155001_dbl
  ! sqrt(2*pi)
  real(dbl), parameter, private :: sqrt2pi = 2.50662721600161359133_dbl

  ! sqrt(2)
  real(dbl), parameter, private :: sqrt2 = 1.41421356237309504878_dbl

  ! Constants for Gauss-Hermite Integration of second order
  real(dbl), parameter, private :: &
       h1 = 0.886226925453_dbl, &
       a1 = 0.707106781187_dbl

  private :: extin, attenuation

contains

  subroutine correx(leff,dlam,airmass,k0,r,lref,flux)

    real(dbl), dimension(:), intent(in) :: leff,dlam,airmass
    real(dbl), dimension(:), intent(in out) :: flux
    real(dbl), intent(in) :: k0,r,lref

    real(dbl), dimension(size(leff)) :: flam
    real(dbl) :: a0,ax,f1,f2,dx
    integer :: i,n

    n = size(leff)

!    write(*,'(a,5f15.3)') "in:",flux

    ! sanity check for undefined fluxes, correction is omitted
    if( any(flux < 0) ) return

    ! compute flux density from fluxes (replace by flam2flux from photoconv module?)
!    flam = flux / (1e9 * sqrtpi2 * dlam)
    flam = flux / (sqrtpi2 * dlam)

!    write(*,'(a,5f15.3)') 'flam:',flam
!    write(*,'(a,5f15.3)') 'ctph:',ctph

    ! estimate effective extinction
!    call extin(leff,ctph,airmass,lref,k0,r)

!    write(*,*) 'e',k0,r

!    do i = 1,n
!       flam(i) = flam(i) / attenuation(k0,r,leff(i),airmass(i))
!    end do

    ! approximation of derivations near edges
    call attenuation(k0,r,lref,leff(1),airmass(1),a0,ax)
!    a0 = attenuation(k0,r,leff(1),airmass(1))
!    ax = attenuation1(k0,r,leff(1),airmass(1))
!    flux(1) = 2.0_dbl*(flam(1)*a0/a0 + &
!         0*2*1e9*(flam(2) - flam(1))/(leff(2) - leff(1))*(dlam(1)*a1)**2*ax)
!    write(*,*) 'l',flam(1)*a0, 1e9*(flam(2) - flam(1))/(leff(2) - leff(1))*(dlam(1)*a1)**2*ax
!    write(*,*) (flam(2) - flam(1))/(leff(2) - leff(1))*(sqrt2pi*dlam(1)*a1)**2*(ax/a0)/flam(1)*1e9
!    write(*,*) (flam(2) - flam(1))/flam(1), dlam(1)/(leff(2) - leff(1)),ax/a0

!    write(*,*) (flam(2) - flam(1))/flam(1)* dlam(1)/(leff(2) - leff(1)) * ax/a0, &
!         (flam(2) - flam(1))/flam(1)* dlam(1)/(leff(2) - leff(1)) * ax/a0 * 2* dlam(1)*a1**2*1e9
!    write(*,*) flam(1)*a0,2*1e9*(flam(2) - flam(1))/(leff(2) - leff(1))*(dlam(1)*a1)**2*ax
!    flux(1) = flux(1)*(1 + &
!         2*1e9*(flam(2) - flam(1))/(leff(2) - leff(1))*(dlam(1)*a1)**2*ax/a0/flam(1))
    dx = sqrt2*dlam(1)*a1
    f1 = (flam(2) - flam(1))/(leff(2) - leff(1))
!    flux(1) = flux(1)*(1 - 1e9*f1*ax/a0*dx**2/flam(1))
    flux(1) = flux(1)*(1 - f1*ax/a0*dx**2/flam(1))

!    a0 = attenuation(k0,r,leff(n),airmass(n))
!    ax = attenuation1(k0,r,leff(n),airmass(n))
!    flux(n) = 2.0_dbl*(flam(n)*a0/a0 - &
!         0*2*1e9*(flam(n) - flam(n-1))/(leff(n) - leff(n-1))*(dlam(n)*a1)**2*ax)

!    write(*,*) flam(n)*a0,2*1e9*(flam(n) - flam(n-1))/(leff(n) - leff(n-1))*(dlam(n)*a1)**2*ax
    do i = 2,n-1
       dx = sqrt2*dlam(i)*a1
       call attenuation(k0,r,lref,leff(i),airmass(i),a0,ax)
!       a0 = attenuation(k0,r,leff(i),airmass(i))
!       ax = attenuation1(k0,r,leff(i),airmass(i))
       f1 = (flam(i-1) - flam(i))/(leff(i-1) - leff(i))
       f2 = (flam(i+1) - flam(i))/(leff(i+1) - leff(i))
!       flux(i) = flux(i)*(1 + &
       !            2*1e9*(f2-f1)/2*(dlam(i)*a1)**2*(ax/a0)/flam(i))
!       flux(i) = flux(i)*(1 - ((f2-f1)*0 + 1e9*(f1+f2)*ax/a0*dx)* dx/2/flam(i))
       flux(i) = flux(i)*(1 - (f1+f2)/2*ax/a0*dx**2/flam(i))
!       write(*,*) (f2-f1)* dx/2/flam(i),(f1+f2)*1e9*ax/a0*dx* dx/2/flam(i),((f2-f1) + (f1+f2)*1e9*ax/a0*dx)* dx/2/flam(i)

    end do
!    stop
!    a0 = attenuation(k0,r,leff(n),airmass(n))
!    ax = attenuation1(k0,r,leff(n),airmass(n))
    call attenuation(k0,r,lref,leff(n),airmass(n),a0,ax)
    dx = sqrt2*dlam(n)*a1
    f1 = (flam(n) - flam(n-1))/(leff(n) - leff(n-1))
    flux(n) = flux(n)*(1 - f1*dx**2*ax/a0/flam(n))
!    flux(n) = flux(n)*(1 - 1e9*f1*dx**2*ax/a0/flam(n))


    ! approximation at internal points
!    do i = 2,n-1
!       dx = sqrt2*dlam(i)*a1
!       f1 = flam(i) + (flam(i+1) - flam(i))/(leff(i+1) - leff(i))*dx
!       f2 = flam(i) - (flam(i) - flam(i-1))/(leff(i) - leff(i-1))*dx
!       flux(i) = f1*attenuation(k0,r,leff(i)+dx,airmass(i)) + &
!            f2*attenuation(k0,r,leff(i)-dx,airmass(i))
!       flux(i) = sqrt2*dlam(i)*h1*flux(i) * 1e9
!    end do

!    flux = sqrt2*dlam*h1*flux * 1e9

!    flux = 2*h1*flux

!    write(*,*) flux
!    write(*,'(a,5f15.3)') "out:",flux
!    write(*,*) airmass
!    write(*,*) (2.5*log10(flux(i-1)/flux(i)),i=2,n)

  end subroutine correx

!!$  function attenuation(k0,r,lam,x)
!!$
!!$    real(dbl) :: attenuation
!!$    real(dbl), intent(in) :: k0,r,lam,x
!!$    real(dbl) :: k
!!$
!!$    k = (1e9*lam / k0)**(-r)
!!$    attenuation = exp(-k*x)
!!$
!!$  end function attenuation
!!$
!!$  function attenuation1(k0,r,lam,x)
!!$
!!$    real(dbl) :: attenuation1
!!$    real(dbl), intent(in) :: k0,r,lam,x
!!$    real(dbl) :: k,k1
!!$
!!$    k = (1e9*lam / k0)**(-r)
!!$    k1 = -r*(1e9*lam / k0)**(-r-1) / k0
!!$    attenuation1 = -k1*x*exp(-k*x)
!!$
!!$  end function attenuation1

  subroutine attenuation(k0,r,lref,lam,x,a0,a1)

    real(dbl), intent(in) :: k0,r,lam,x,lref
    real(dbl), intent(out) :: a0,a1
    real(dbl) :: k,k1

    k = k0*(lam /lref)**(-r)
    k1 = -r*k/lam
    a0 = exp(-k*x)
    a1 = -k1*x*a0

  end subroutine attenuation

  subroutine extin(leff,a,x,lref,k0,r)

    use oakleaf

    real(dbl), dimension(:), intent(in) :: leff,a,x
    real(dbl), intent(in) :: lref
    real(dbl), intent(out) :: k0,r

    real(dbl), dimension(size(leff)) :: k,t,s,dt,ds
    real(dbl) :: sig,dk,dr,amin,a0

    amin = minval(a)
    if( amin < 1 ) then
       a0 = 1.11/amin
    else
       a0 = 1
    end if
    k = log(a0*a) / x   ! (-) sign is removed because ctph is reciprocal to a

    t = log(k)
    s = log(leff/lref)
!    dt = log(0.1*k)
!    ds = log(0.01*1e9*leff)
    dt = 1e-2
    ds = 5e-2

!    write(*,*) a0
!    write(*,*) k
!    write(*,*) s
!    write(*,*) t
!    write(*,*) ds
!    write(*,*) dt

    call rline(s,t,k0,r,dk,dr,ds,dt,sig)

!    write(*,*) sig,k0,r
!    write(*,*) 'r=',r
    r = -r

    ! check range, from Mie r=1 to Rayleigh r=4 scaterrings,
    ! this is fall-back way when some points are uncorrect,
    ! r is very sensitive to bad points and I determined
    ! a mean value r=3 for La Silla which means scattering
    ! on fluctations rather than on the dust
    if( .not. (1 < r .and. r < 4) ) then
!    if( .true. ) then
       r = 3
       t = log(k) + r*log(leff/lref)
!       write(*,*) t
       !write(*,*) k
       call rmean(t,k0,dk,sig)
!       write(*,*) sig,k0
    end if

    k0 = exp(k0)

  end subroutine extin

  subroutine scaterr(leff,a,x,k0,r,lref)

    real(dbl), dimension(:), intent(in) :: leff,a,x
    real(dbl), intent(out) :: k0,r,lref

    ! reference effective wavelenght
    lref = leff(max(size(leff)/2+1,1))

    call extin(leff,a,x,lref,k0,r)

  end subroutine scaterr

end module colorex

!
!  fmin
!
!  This procedure is adopted version of fmin procedure
!  by FMM library developed by Forsythe, Malcolm, and Moler
!  (http://www.netlib.org/fmm/index.html) for Fortran 95.
!  Some changes to code are introduced by FH:
!   * epsilon by standard function
!   * check for non-convergence
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.



double precision function fmin(ax,bx,f,tol)

  implicit none

  double precision, intent(in) :: ax,bx,tol

  interface
     function f(x)
       double precision :: f
       double precision, intent(in) :: x
     end function f
  end interface

!
!      an approximation  x  to the point where  f  attains a minimum  on
!  the interval  (ax,bx)  is determined.
!
!
!  input..
!
!  ax    left endpoint of initial interval
!  bx    right endpoint of initial interval
!  f     function subprogram which evaluates  f(x)  for any  x
!        in the interval  (ax,bx)
!  tol   desired length of the interval of uncertainty of the final
!        result ( .ge. 0.0d0)
!
!
!  output..
!
!  fmin  abcissa approximating the point where  f  attains a minimum
!
!
!      the method used is a combination of  golden  section  search  and
!  successive parabolic interpolation.  convergence is never much slower
!  than  that  for  a  fibonacci search.  if  f  has a continuous second
!  derivative which is positive at the minimum (which is not  at  ax  or
!  bx),  then  convergence  is  superlinear, and usually of the order of
!  about  1.324....
!      the function  f  is never evaluated at two points closer together
!  than  eps*abs(fmin) + (tol/3), where eps is  approximately the square
!  root  of  the  relative  machine  precision.   if   f   is a unimodal
!  function and the computed values of   f   are  always  unimodal  when
!  separated by at least  eps*abs(x) + (tol/3), then  fmin  approximates
!  the abcissa of the global minimum of  f  on the interval  ax,bx  with
!  an error less than  3*eps*abs(fmin) + tol.  if   f   is not unimodal,
!  then fmin may approximate a local, but perhaps non-global, minimum to
!  the same accuracy.
!      this function subprogram is a slightly modified  version  of  the
!  algol  60 procedure  localmin  given in richard brent, algorithms for
!  minimization without derivatives, prentice - hall, inc. (1973).
!
!
  double precision, parameter :: eps = epsilon(fmin)
  double precision  a,b,c,d,e,xm,p,q,r,tol1,tol2,u,v,w
  double precision  fu,fv,fw,fx,x
  double precision  dabs,dsqrt,dsign

!  FH: to prevent infinity loop, Fibonacci search is O(log(n))
!  see https://en.wikipedia.org/wiki/Fibonacci_search_technique
!  3x (?), precision(fmin) = 16, ... yes, we are realist....
  integer :: ieval, maxeval

  maxeval = max(int(3*log((bx - ax) / tol)), precision(fmin))
  ieval = 0
!
!  c is the squared inverse of the golden ratio
!
  c = 0.5d0*(3. - dsqrt(5.0d0))
!
!  eps is approximately the square root of the relative machine
!  precision.
!
!  FH: the loop is replaced by an internal function (to be faster)
!      eps = 1.0d00
!   10 eps = eps/2.0d00
!      tol1 = 1.0d0 + eps
!      if (tol1 .gt. 1.0d00) go to 10
!  eps = epsilon(1.0d0)
!  eps = dsqrt(eps)
!
!  initialization
!
  a = ax
  b = bx
  v = a + c*(b - a)
  w = v
  x = v
  e = 0.0d0
  d = e
  fx = f(x)
  fv = fx
  fw = fx
!
!  main loop starts here
!
20 xm = 0.5d0*(a + b)
  tol1 = eps*dabs(x) + tol/3.0d0
  tol2 = 2.0d0*tol1
!
! FH: number of evaluations
!
  ieval = ieval + 1
!
!  check stopping criterion
!
  if (dabs(x - xm) .le. (tol2 - 0.5d0*(b - a))) go to 90
!
!  FH: maximum number of evaluations reached
  if( ieval > maxeval ) goto 90
!
! is golden-section necessary
!
  if (dabs(e) .le. tol1) go to 40
!
!  fit parabola
!
  r = (x - w)*(fx - fv)
  q = (x - v)*(fx - fw)
  p = (x - v)*q - (x - w)*r
  q = 2.0d00*(q - r)
  if (q .gt. 0.0d0) p = -p
  q =  dabs(q)
  r = e
  e = d
!
!  is parabola acceptable
!
  if (dabs(p) .ge. dabs(0.5d0*q*r)) go to 40
  if (p .le. q*(a - x)) go to 40
  if (p .ge. q*(b - x)) go to 40
!
!  a parabolic interpolation step
!
  d = p/q
  u = x + d
!
!  f must not be evaluated too close to ax or bx
!
  if ((u - a) .lt. tol2) d = dsign(tol1, xm - x)
  if ((b - u) .lt. tol2) d = dsign(tol1, xm - x)
  go to 50
!
!  a golden-section step
!
40 if (x .ge. xm) e = a - x
  if (x .lt. xm) e = b - x
  d = c*e
!
!  f must not be evaluated too close to x
!
50 if (dabs(d) .ge. tol1) u = x + d
  if (dabs(d) .lt. tol1) u = x + dsign(tol1, d)
  fu = f(u)
!
!  update  a, b, v, w, and x
!
  if (fu .gt. fx) go to 60
  if (u .ge. x) a = x
  if (u .lt. x) b = x
  v = w
  fv = fw
  w = x
  fw = fx
  x = u
  fx = fu
  go to 20
60 if (u .lt. x) a = u
  if (u .ge. x) b = u
  if (fu .le. fw) go to 70
  if (w .eq. x) go to 70
  if (fu .le. fv) go to 80
  if (v .eq. x) go to 80
  if (v .eq. w) go to 80
  go to 20
70 v = w
  fv = fw
  w = u
  fw = fu
  go to 20
80 v = u
  fv = fu
  go to 20
!
!  end of main loop
!
90 fmin = x
  return
end function fmin

!
!  QUICKSORT - recursive version of the QuickSort algorithm
!
!  by  Wirth,N: Algorithm + Data Structure = Programs, Prentice-Hall, 1975
!
!  Copyright © 1997-2011, 2017-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module quicksort

  ! precision of real numbers
  integer, parameter, private :: rp = selected_real_kind(15)

  private :: trid, tridi

contains

  subroutine qsort(a,idx)

    real(rp), dimension(:), intent(in out) :: a
    integer, dimension(:), optional, intent (in out) :: idx
    integer :: n

    n = size(a)
    if( n < 2 ) return

    if( present(idx) ) then
       if( n /= size(idx) ) stop 'qsort: n /= size(idx)'
       call tridi(1,n,a,idx)
    else
       call trid(1,n,a)
    end if

  end subroutine qsort


  recursive subroutine trid(l,r,a)

    integer,intent(in) :: l,r
    real(rp), dimension(:),intent(in out) :: a

    integer :: i,j
    real(rp) :: x,w     ! internal buffers

    i = l
    j = r
    x = a((l+r)/2)

    do
       do while ( a(i) < x )
          i = i + 1
       end do

       do while ( x < a(j) )
          j = j - 1
       end do

       if( i <= j )then
          w = a(i); a(i) = a(j); a(j) = w
          i = i + 1; j = j - 1
       endif

       if( i > j ) exit
    end do

    if( l < j ) call trid(l,j,a)
    if( i < r ) call trid(i,r,a)

  end subroutine trid

!--------------------------------------------------------------------------

  recursive subroutine tridi(l,r,a,idx)

    integer,intent(in) :: l, r
    integer, dimension(:), intent(in out) :: idx
    real(rp), dimension(:), intent(in out) :: a

    integer :: i,j,m
    real(rp) :: x,w     ! internal buffers

    i = l
    j = r
    x = a((l+r)/2)

    do
       do while ( a(i) < x )
          i = i + 1
       end do

       do while ( x < a(j) )
          j = j - 1
       end do

       if( i <= j )then
          w = a(i); a(i) = a(j); a(j) = w
          m = idx(i); idx(i) = idx(j); idx(j) = m
          i = i + 1; j = j - 1
       endif

       if( i > j ) exit
    end do

    if( l < j ) call tridi(l,j,a,idx)
    if( i < r ) call tridi(i,r,a,idx)

  end subroutine tridi


end module quicksort

!
!  timeserie, light curve
!
!  Copyright © 2011-4 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

module tmseries

  use fitsio
  use iso_fortran_env

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl

  integer, private :: nfile
  real(dbl), dimension(:), allocatable, private :: timelike,gexposure, &
       gxcoo,gycoo,gvxcoo,gvycoo
  real(dbl), dimension(:,:), allocatable, private :: dat
  character(len=FLEN_FILENAME),dimension(:), allocatable, private :: gfiles
  character(len=FLEN_KEYWORD),dimension(:), allocatable, private :: gfitskeys
  character(len=FLEN_VALUE),dimension(:), allocatable, private :: gfitsval
  character(len=80), private :: timetype, timestamp, gfilter, gphsystem, cootype
  character(len=FLEN_VALUE) :: extname
  character(len=FLEN_VALUE), dimension(:), allocatable, private :: coocols,cols
  real(dbl), private :: gtol,min0,per,jd0,timeerr,timeres
  logical, private :: gdiffmag,verbose,gstdout,allstars, &
       gfiltermatch, gphsystemmatch, gstarsmatch

contains

  subroutine tmseries_init(xtimetype,xtimestamp,xtimeerr,xtimeres,xcootype,nfiles, &
       fitskeys,xextname,xcoocols,xcols,tol,xmin0,xper,xepoch,diffmag,verb,stdout,alls)

    character(len=*), intent(in) :: xtimetype, xtimestamp, xextname, xcootype
    integer, intent(in) :: nfiles
    character(len=*), dimension(:), intent(in) :: fitskeys, xcoocols,xcols
    real(dbl), intent(in) :: tol,xmin0,xper,xepoch,xtimeerr,xtimeres
    logical, intent(in) :: diffmag,verb,stdout,alls

    timetype = xtimetype
    timestamp = xtimestamp
    timeerr = xtimeerr
    timeres = xtimeres
    cootype = xcootype
    if( allocated(gfitskeys) ) stop 'tmseries_init: gfitskeys already allocated.'
    allocate(gfitskeys(size(fitskeys)),gfitsval(size(fitskeys)))
    gfitskeys = fitskeys
    allocate(gfiles(nfiles),gexposure(nfiles),timelike(nfiles))

    allocate(coocols(size(xcoocols)),cols(size(xcols)))
    coocols = xcoocols
    cols = xcols


    nfile = 0
    gtol = tol
    min0 = xmin0
    per = xper
    gdiffmag = diffmag
    verbose = verb
    gstdout = stdout
    allstars = alls
    gfilter = ''
    gphsystem = ''
    gfiltermatch = .true.
    gphsystemmatch = .true.
    gstarsmatch = .true.
    jd0 = xepoch
    extname = xextname


  end subroutine tmseries_init

! ------

  subroutine tmseries_coo(xcoo,ycoo,vxcoo,vycoo)

    real(dbl), dimension(:), intent(in) :: xcoo,ycoo,vxcoo,vycoo
    integer :: n

    n = size(xcoo)
    if( allocated(gxcoo) ) stop 'tmseries_coo: gxcoo already allocated.'
    allocate(gxcoo(n),gycoo(n),gvxcoo(n),gvycoo(n))
    gxcoo = xcoo
    gycoo = ycoo
    gvxcoo = vxcoo
    gvycoo = vycoo

    if( allocated(dat) ) stop 'tmseries_coo: dat-es already allocated.'
    allocate(dat(size(timelike),n*size(cols)))

  end subroutine tmseries_coo

! ------

  subroutine tmseries_addcoo(t,tol,x,y)

    use astrotrafo
    use muniarrays

    type(AstroTrafoProj),intent(in) :: t
    real(dbl), intent(in) :: tol
    real(dbl), dimension(:), intent(in) :: x,y
    real(dbl), dimension(:), allocatable :: a,d,u,v
    integer, dimension(:), allocatable :: idx
    integer :: nidx,i,j,n,nsize
    real(dbl) :: r
    logical :: found

    if( .not. allocated(gxcoo) ) then

       n = size(x)
       allocate(gxcoo(n),gycoo(n),gvxcoo(n),gvycoo(n))
       gxcoo = 0.0
       gycoo = 0.0
       call invtrafo(t,x,y,gxcoo,gycoo)
       gvxcoo = 0.0_dbl
       gvycoo = 0.0_dbl

       if( allocated(dat) ) stop 'tmseries_coo: dat-es already allocated.'

       nsize = size(timelike)
       allocate(dat(nsize,n*size(cols)))

    else

       allocate(u(size(gxcoo)),v(size(gycoo)))
       allocate(a(size(x)),d(size(y)),idx(size(x)))

       if( cootype == 'DEG' ) then
          call proj(t,gxcoo,gycoo,u,v)
          call invtrafo(t,x,y,a,d)
       else if( cootype == 'RECT' ) then
          u = gxcoo
          v = gycoo
          a = x
          d = y
       end if

       nidx = 0

       do i = 1, size(x)

          found = .false.
          do j = 1,size(u)
             r = sqrt((u(j) - x(i))**2 + (v(j) - y(i))**2)
             if( r < tol ) found = .true.
          end do

          if( .not. found ) then
             nidx = nidx + 1
             idx(nidx) = i
          end if

       end do

       if( nidx > 0 ) then

          nsize = size(gxcoo)
          n = nsize + nidx
          call reallocate(gxcoo,n)
          call reallocate(gycoo,n)
          call reallocate(gvxcoo,n)
          call reallocate(gvycoo,n)
          call reallocate2d(dat,size(timelike),size(cols)*n)

          n = nsize+1
          dat(:,n:) = 0.0_dbl

          do i = 1, nidx
             n = nsize + i
             gxcoo(n) = a(idx(i))
             gycoo(n) = d(idx(i))
             gvxcoo(n) = 0.0_dbl
             gvycoo(n) = 0.0_dbl
          end do

       end if

       deallocate(a,d,u,v,idx)

    end if


  end subroutine tmseries_addcoo

! -----

  subroutine tmseries_add(filename)

    use fitsio
    use trajd
    use astrosphere
    use astrotrafo
    use photoconv
    use mtable

    character(len=*), intent(in) :: filename

    character(len=FLEN_VALUE) :: filter,photsys
    integer :: i,j,ij,n, status, nidx
    integer, dimension(:,:), allocatable :: idxs
    real(dbl) :: year,month,day,hour,min,sec,amass,exptime,jd,r,rmin,dt,tol,etime,tm
    character(len=FLEN_KEYWORD), dimension(0) :: headkeys
    character(len=FLEN_VALUE), dimension(0) :: headval
    real(dbl),dimension(:,:), allocatable :: coo,data,cts
    real(dbl), dimension(:), allocatable :: a,d,u,v
    real, dimension(:), allocatable :: undef
    type(AstroTrafoProj) :: t

    if( nfile == size(timelike) ) goto 666

    if( verbose ) write(error_unit,*) trim(filename),":"

    call table(filename, extname, gfitskeys, headkeys, coocols, cols, &
         verbose,cootype,gfitsval,headval,photsys,filter,year,month,day,&
         hour,min,sec,amass,exptime,t,coo,data,status)

    if( status /= 0 ) then
       write(error_unit,*) "Failed to read `",trim(filename),"'."
       goto 666
    end if
    if( size(coo) == 0 ) goto 666

    allocate(undef(size(cols)))
    call undefs(cols,undef)

    if( filter /= gfilter .and. gfilter /= '' ) then
       gfiltermatch = .false.
       if( verbose ) write(error_unit,*) "Filters `", &
            trim(filter),"' and `",trim(gfilter),"' doesn't match."
    end if

    if( photsys /= gphsystem .and. gphsystem /= '' ) then
       gphsystemmatch = .false.
       if( verbose ) &
            write(error_unit,*) "Photometric systems `",trim(photsys),"' and `", &
            trim(gphsystem),"' doesn't match."
    end if

    if( cootype == 'DEG' ) then
       if( gtol > 0.0 ) then
          tol = gtol
       else
          ! one looks strange, but 1pix is prefered over dtol=0.0
          tol = 5.0*max(t%err,1.0/t%scale)
       end if
!       tol = t%scale*tol
!           write(*,*) tol,t%err,1.0/t%scale,t%scale
    else if( cootype == 'RECT' ) then
       if( gtol > 0.0 ) then
          tol = gtol
       else
          tol = 1.0
       end if
    end if

    if( allstars ) call tmseries_addcoo(t,tol,coo(:,1),coo(:,2))

    nfile = nfile + 1
    gfiles(nfile) = filename
    gexposure(nfile) = exptime
    gfilter = filter
    gphsystem = photsys


    ! Evaluate Julian date at time-stamp of exposure
    jd = datjd(year,month,day + (hour + (min + sec/60.0_dbl)/60.0_dbl)/24.0_dbl)

    etime = exptime/86400.0_dbl
    if( timestamp == 'MID' ) then
       jd = jd + etime/2.0_dbl
    else if ( timestamp == 'END' ) then
       jd = jd + etime
    end if

    ! time (-like) determination

    if( timetype == 'JD' ) then
       tm = jd
    else if( timetype == 'MJD' ) then
       tm = mjd(jd)
    else if( timetype == 'HJD' ) then
       tm = hjd(jd,helcor(longsun(jd,year),t%acen,t%dcen))
    else if( timetype == 'PHASE' ) then
       tm = phase(jd,min0,per)
    else if( timetype == 'AIRMASS' ) then
       tm = amass
    else
       tm = 0.0
    end if

    timelike(nfile) = tm


    ! look for coordinates
    n = size(gxcoo)
    allocate(a(n),d(n),u(n),v(n))

    ! WARNING! the current epoch coords are computed here only,
    !          may be also computed in tmserie_addcoo ??
    dt = (jd - jd0)!/365.25_dbl

    if( cootype == 'DEG' ) then

       do j = 1, n
          d(j) = gycoo(j) + gvycoo(j)*dt
          a(j) = gxcoo(j) + gvxcoo(j)*dt ! * cos(d(j)/rad) !!!! ?????
          ! write(*,*) a(j),d(j),dt,gvycoo(j)
       end do
       call trafo(t,a,d,u,v)

    else if( cootype == 'RECT' ) then

       u = gxcoo + gvxcoo*dt
       v = gycoo + gvycoo*dt

    end if

    nidx = 0
    allocate(idxs(size(gxcoo),2),cts(size(data,1),size(data,2)))
    cts = 0.0_dbl
    do j = 1, n

       rmin = tol
       ij = 0

       if( coocols(1) == FITS_COL_X .and. coocols(2) == FITS_COL_Y ) then

          do i = 1, size(coo,1)
             ! locate stars on base of euclidean metric
             r = sqrt((coo(i,1) - u(j))**2 + (coo(i,2) - v(j))**2)
             if( r < rmin) then
                rmin = r
                ij = i
             end if
          end do

       else

          do i = 1, size(coo,1)
             ! locate stars in spherical coordinates
             r = sqrt(((coo(i,1) - a(j))*cos(d(j)/rad))**2 + (coo(i,2) - d(j))**2)
             if( r < rmin) then
                rmin = r
                ij = i
             end if
          end do


       end if

       if( ij > 0 .and. nidx < size(cts,1) ) then
          nidx = nidx + 1
          idxs(nidx,:) = (/ij,j/)
          cts(nidx,:) = data(ij,:)
       else
          nidx = nidx + 1
          idxs(nidx,:) = (/0,j/)
          cts(nidx,:) = undef
          if( .not. allstars ) then
             gstarsmatch = .false.
             if( verbose ) &
                  write(error_unit,'(a,2(f0.5,1x),"(",2(f0.1,1x),"[pix])",a,g0.2)') &
                  'Object at ',a(j),d(j),u(j),v(j),' not found. tol=',rmin
          end if
       end if
    end do

    deallocate(a,d,u,v)

    call tmappend(nfile,nidx,idxs,cts(1:nidx,:))
    if( gstdout ) call xwrite(tm,headval,cols,cts(1:nidx,:))

666 continue

    if( allocated(coo) ) deallocate(coo)
    if( allocated(data) ) deallocate(data)
    if( allocated(idxs) ) deallocate(idxs,cts)
    if( allocated(undef) ) deallocate(undef)

  end subroutine tmseries_add

! ----------------

  subroutine tmappend(nfile,nidx,idxs,cts)

    ! transposes: stacks columns to rows, one by one

    integer, intent(in) :: nfile, nidx
    integer, dimension(:,:), intent(in) :: idxs
    real(dbl), dimension(:,:), intent(in) :: cts
    integer :: i,j,n

    n = size(cts,2)
    dat(nfile,:) = 0.0_dbl
    do i = 1, nidx
       j = n*(idxs(i,2) - 1) + 1
       dat(nfile,j:j+n-1) = cts(i,:)
    end do

  end subroutine tmappend

! ----------------

  subroutine xwrite(tm,vals,cols,cts)

    real(dbl), intent(in) :: tm
    character(len=*), dimension(:), intent(in) :: vals,cols
    real(dbl), dimension(:,:), intent(in) :: cts

    character(len=666) :: fmt = ""
    integer :: i,n,m

    n = size(cts,1)
    m = size(cols)

    write(*,'(f0.10)',advance="no") tm
    if( size(vals) > 0 ) then
       write(fmt,'(a,i0,a)') '(',size(vals),'(a),1x'
       write(*,fmt,advance="no") (trim(vals(i)),i=1,size(vals))
    end if
    if( n > 0 ) then
       write(fmt,'(a,i0,a)') '(1x,',n,'('
       do i = 1,m
          if( index(cols(i),'MAG') > 0 ) then
             fmt = trim(fmt) // 'f0.5'
          else
             fmt = trim(fmt) // 'g0'
          end if
          if( i < n ) then
             fmt = trim(fmt) // ',1x,'
          else
             fmt = trim(fmt) // ',1x'
          end if
       end do
       fmt = trim(fmt) // '))'
       write(*,fmt,advance="no") (cts(i,:),i=1,n)
    end if
    write(*,*)

  end subroutine xwrite

! ----------------

  subroutine different(mag,dmag,dag,ddag)

    real(dbl), parameter :: magnan = 99.99999_dbl
    real(dbl), parameter :: dmagnan = 9.99999_dbl
    real(dbl), dimension(:), intent(in) :: mag,dmag
    real(dbl), dimension(:), intent(out) :: dag,ddag
    integer :: i,j

    dag = magnan
    ddag = dmagnan

    do i = 1, size(mag)-1
       j = i + 1
       if( mag(j) < magnan .and. mag(1) < magnan ) then
          dag(i) = mag(j) - mag(1)
          ddag(i) = sqrt(dmag(j)**2 + dmag(1)**2)
       else
          dag(i) = magnan
          ddag(i) = dmagnan
       end if
    end do

  end subroutine different

! ----------------


  subroutine tmseries_finish(output,backup)

    character(len=*), intent(in) :: output,backup
    character(len=80), dimension(:), allocatable :: xcols, fmtcols
    character(len=80) :: units
    integer :: i, j, n, ncols

    if( output /= '' .and. nfile > 0 ) then

       n = size(gxcoo)
       ncols = size(cols)
       allocate(xcols(n*ncols),fmtcols(ncols))

       do i = 1,ncols
          fmtcols(i) = '("'//trim(cols(i))//'_",i0)'
          units = ''
       end do

       do i = 1,n
          do j = 1,ncols
             write(xcols(ncols*(i-1)+j),fmtcols(j)) i
          end do
       end do
       deallocate(fmtcols)

       call savelc(output,backup,xcols,units,gfitskeys,gfitsval,jd0,&
            gexposure,timelike,gfilter,gphsystem,gxcoo,gycoo,dat)

       deallocate(xcols)
    end if

    if( allocated(timelike) ) deallocate(gfiles,gexposure,timelike)
    if( allocated(dat) ) deallocate(dat)
    if( allocated(gxcoo) ) deallocate(gxcoo,gycoo,gvxcoo,gvycoo)
    if( allocated(gfitskeys) ) deallocate(gfitskeys,gfitsval)
    if( allocated(cols) ) deallocate(cols)
    if( allocated(coocols) ) deallocate(coocols)

    if( .not. gfiltermatch ) write(error_unit,*) "Warning: Filters doesn't match!"
    if( .not. gphsystemmatch ) write(error_unit,*) &
         "Warning: Photometric systems doesn't match!"
!    if( .not. gstarsmatch .and. verbose ) &
    if( .not. gstarsmatch ) write(error_unit,*) &
         "Warning: One or more stars not found. Try --verbose for details."

  end subroutine tmseries_finish


  subroutine savelc(file,backup,xcols,units,fitskeys,fitsval,epoch,&
       exposure,timelike,filter,phsystem,xcoo,ycoo,dat)

    use fitsio

    integer, parameter :: ntime = 2
    integer, parameter :: frow = 1, felem = 1

    character(len=*), intent(in) :: file,backup,filter,phsystem,units
    character(len=*), dimension(:), intent(in) :: fitskeys,fitsval,xcols
    real(dbl), dimension(:), intent(in) :: exposure,timelike,xcoo,ycoo
    real(dbl), dimension(:,:), intent(in) :: dat
    real(dbl), intent(in) :: epoch

    character(len=FLEN_VALUE), dimension(:), allocatable :: ttype, tform, tunit
    integer :: i,n,nrows,ntypes
    integer :: status, blocksize

    ntypes = ntime + size(xcols)
    allocate(ttype(ntypes),tform(ntypes),tunit(ntypes))
    tform = '1D'

    ttype(1) = FITS_COL_TIME;   tunit(1) = 'day'   ! jd
    ttype(2) = fitskeys(3);     tunit(2) = 's'     ! exptime
    ttype(ntime+1:) = xcols(:)
    tunit(ntime+1:) = units

    status = 0
    blocksize = 0
    nrows = nfile
    call fitsbackup(file,backup,status)
    call ftinit(15,file,blocksize,status)
    call ftiimg(15,8,0,(/0/),status)
    call ftpkys(15,'HDUNAME',MEXTNAMETS,'time series table',status)
    call ftpkys(15,FITS_KEY_CREATOR,FITS_VALUE_CREATOR,FITS_COM_CREATOR,status)
    call ftpcom(15,MUNIPACK_VERSION,status)
    call ftpcom(15,'Description: http://munipack.physics.muni.cz/dataform_tmserie.html',status)

    ! LC extension
    call ftibin(15,nrows,ntypes,ttype,tform,tunit,MEXTNAMETS,0,status)
    call ftpkys(15,fitskeys(6),fitsval(6),'observed object',status)
    call ftpkys(15,fitskeys(7),fitsval(7),'observer who acquired the data',status)
    call ftpkys(15,fitskeys(8),fitsval(8),'author of the data',status)
    call ftpkys(15,fitskeys(9),fitsval(9),'name of instrument',status)
    call ftpkys(15,fitskeys(10),fitsval(10),'name of telescope',status)
    call ftpkys(15,fitskeys(11),fitsval(11),'organization responsible for the data',status)
    call ftpkys(15,fitskeys(12),fitsval(12),'bibliographic reference',status)
    call ftpcom(15,'Aperture photometry has been used.',status)

    ! time info: http://dotastro.org/simpletimeseries/
    call ftpkys(15,'TIMETYPE',timetype,'JD,MJD,HJD,phase,airmass',status)
    call ftpkys(15,'TIMESYS','UTC','',status)
    call ftpkys(15,'TIMEREF','GEOCENTER','',status)
    call ftpkys(15,'TIMESTMP','MIDPOINT','time stamp = MIDPOINT,BEGIN,END',status)
    if( timeerr > 0.0_dbl ) &
         call ftpkyd(15,'TIMEERR',timeerr,2,'[s] uncertainty in the time measurement',status)
    if( timeres > 0.0_dbl ) &
         call ftpkyd(15,'TIMERES',timeres,2,'[s] resolution in the time measurement',status)
    call ftpkys(15,fitskeys(4),filter,'spectral band',status)
    call ftpkys(15,fitskeys(15),phsystem,'Photometric system',status)

    call ftpcom(15,'File names for each frame (ordered):',status)
    do i = 1, nfile
       call ftpcom(15,gfiles(i),status)
    end do

    call ftpcld(15,1,frow,felem,nrows,timelike,status)
    call ftpcld(15,2,frow,felem,nrows,exposure,status)

    do n = 1,size(xcols)
       call ftpcld(15,ntime+n,frow,felem,nrows,dat(:,n),status)
    end do
    deallocate(ttype,tform,tunit)

    ! OBJECT extension
    nrows = size(xcoo)
    ntypes = 2
    allocate(ttype(ntypes),tform(ntypes),tunit(ntypes))
    tform = '1D'
    tunit = 'deg'
    ttype(1) = FITS_COL_RA
    ttype(2) = FITS_COL_DEC

    call ftibin(15,nrows,ntypes,ttype,tform,tunit,MEXTNAMETSC,0,status)
    call ftpkys(15,"REFRAME",'ICRS','reference celestial coordinate system',status)
    call ftpkyd(15,"EPOCH",epoch,15,'reference epoch for proper motion',status)
    call ftpcld(15,1,frow,felem,nrows,xcoo,status)
    call ftpcld(15,2,frow,felem,nrows,ycoo,status)

    deallocate(ttype,tform,tunit)

    call ftclos(15,status)
    call ftrprt('STDERR',status)


  end subroutine savelc


  subroutine undefs(cols,data)

    character(len=*), dimension(:), intent(in) :: cols
    real, dimension(:), intent(out) :: data
    integer :: i

    do i = 1,size(cols)
       if( index(cols(i),'MAGERR') > 0 ) then
          data(i) = 9.99999
       else if( index(cols(i),'MAG') > 0 ) then
          data(i) = 99.99999
       else
          data(i) = -1
       end if
    end do


  end subroutine undefs

  subroutine reallocate2d(x,n,m)

    implicit none
    real(dbl), dimension(:,:),allocatable,intent(inout) :: x
    integer, intent(in) :: n,m
    real(dbl), dimension(:,:),allocatable :: y

    allocate(y(n,m))

    if( n < size(x,1) .and. m < size(x,2) )then
       y = x(1:n,1:m)
    else if( n >= size(x,1) .and. m >= size(x,2) )then
       y(1:size(x,1),1:size(x,2)) = x
    else
       y = x
    end if

    deallocate(x)
    allocate(x(n,m))
    x(1:size(y,1),1:size(y,2)) = y
    deallocate(y)

  end subroutine reallocate2d

end module tmseries

!
!  fitspphot
!
!  Copyright © 2013 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module fitspphot

  use titsio
  use iso_fortran_env

  implicit none

  integer, parameter, private :: rp = selected_real_kind(15)

contains

subroutine fpphot(filename,verbose,plog,fkeys)

  use psfengine

  integer, parameter :: DIM = 2

  character(len=*),intent(in) :: filename
  logical, intent(in) :: verbose, plog
  character(len=*),dimension(:),intent(in) :: fkeys

  integer :: status,naxis,bitpix,nrows,xcol,ycol,scol,ccol,hdutype,i,j,n
  integer, parameter :: group = 1, extver = 0, frow = 1, nbegin = 4
  real(rp), parameter :: nullval = 0.0_rp
  integer, dimension(DIM) :: naxes
  logical :: anyf
  real(rp), dimension(:,:), allocatable :: data, rframe
  real(rp), dimension(:), allocatable :: xcens,ycens,sky,sky_err,asky,acts,cts,cts_err,q
  logical, dimension(:), allocatable :: id
  character(len=FLEN_VALUE), dimension(:), allocatable :: ttype, tform, tunit
  real(rp) :: lobad, hibad, phpadu, fwhm, ring
  type(fitsfiles) :: fits

  status = 0
  call fits_open_image(fits,filename,FITS_READWRITE,status)
  if( status /= 0 ) then
     write(error_unit,*) &
          'Error: failed to open an image in the file `',trim(filename),"'."
     return
  end if

  call fits_get_img_param(fits,bitpix,naxis,naxes,status)
  if( status /= 0 ) goto 666

  call fits_read_key(fits,fkeys(1),phpadu,status)
  if( status == FITS_KEYWORD_NOT_FOUND ) then
     write(error_unit,*) trim(filename),": Gain identified by `",trim(fkeys(1)),"' keyword not found."
     goto 666
  end if

  allocate(data(naxes(1),naxes(2)))
  call fits_read_image(fits,group,nullval,data,anyf,status)

  if( status /= 0 ) then
     write(error_unit,*) trim(filename),": Failed to read data."
     goto 666
  end if

  call fits_movnam_hdu(fits,FITS_BINARY_TBL,FINDEXTNAME,extver,status)
  if( status == FITS_BAD_HDU_NUM ) then
     write(error_unit,*) trim(filename),": ", &
          trim(FINDEXTNAME)//' extension not found. Has been stars detected already?'
     goto 666
  end if

  call fits_read_key(fits,FITS_KEY_LOWBAD,lobad,status)
  call fits_read_key(fits,FITS_KEY_HIGHBAD,hibad,status)
  call fits_read_key(fits,FITS_KEY_FWHM,fwhm,status)

  if( status /= 0 ) then
     write(error_unit,*) trim(filename),": Required keywords ",trim(FITS_KEY_LOWBAD),&
          ",",trim(FITS_KEY_HIGHBAD)," or ",trim(FITS_KEY_FWHM)," not found."
     goto 666
  end if

  call fits_movnam_hdu(fits,FITS_BINARY_TBL,APEREXTNAME,extver,status)
  if( status == FITS_BAD_HDU_NUM ) then
     write(error_unit,*) trim(filename),": ",trim(APEREXTNAME) // &
          ' extension not found. An aperture photometry is missing.'
     goto 666
  end if

  call fits_get_num_rows(fits,nrows,status)

  call fits_read_key(fits,trim(FITS_KEY_ANNULUS)//'1',ring,status)
  if( status /= 0 ) then
     write(error_unit,*) trim(filename),": Required keywords ",trim(FITS_KEY_ANNULUS),&
          " not found."
     goto 666
  end if
  ring = 10*fwhm

  allocate(xcens(nrows),ycens(nrows),asky(nrows),acts(nrows))

  call fits_get_colnum(fits,.true.,FITS_COL_X,xcol,status)
  call fits_get_colnum(fits,.true.,FITS_COL_Y,ycol,status)
  call fits_get_colnum(fits,.true.,FITS_COL_SKY,scol,status)
  call fits_get_colnum(fits,.true.,trim(FITS_COL_APCOUNT)//'1',ccol,status)

  call fits_read_col(fits,xcol,frow,nullval,xcens,anyf,status)
  call fits_read_col(fits,ycol,frow,nullval,ycens,anyf,status)
  call fits_read_col(fits,scol,frow,nullval,asky,anyf,status)
  call fits_read_col(fits,ccol,frow,nullval,acts,anyf,status)
  if( status /= 0 ) goto 666

  allocate(cts(nrows),cts_err(nrows),sky(nrows),sky_err(nrows), &
       rframe(size(data,1),size(data,2)))

  call psfmodel(xcens,ycens,asky,acts,data,ring,lobad,hibad,phpadu, &
       verbose,plog,cts,cts_err,sky,sky_err,rframe,status)

  if( status /= 0 ) goto 666

  ! store results to next extension
  call fits_movnam_hdu(fits,FITS_BINARY_TBL,PSFEXTNAME,extver,status)
  if( status == FITS_BAD_HDU_NUM ) then
     status = 0
  else
     ! already presented ? remove it !
     call fits_delete_hdu(fits,hdutype,status)
     if( status /= 0 ) goto 666
  end if

  n = 6
  allocate(ttype(n), tform(n), tunit(n))

  tform = '1D'
  tunit = ''
  ttype(1) = FITS_COL_X
  ttype(2) = FITS_COL_Y
  ttype(3) = FITS_COL_SKY
  ttype(4) = FITS_COL_SKYERR
  ttype(5) = FITS_COL_PSFCOUNT
  ttype(6) = FITS_COL_PSFCOUNTERR

  ! PSF photometry
  call fits_insert_btbl(fits,0,ttype,tform,tunit,PSFEXTNAME,status)
  call fits_update_key(fits,FITS_KEY_FWHM,fwhm,-5,'[pix] standard FWHM of objects',status)

  call fits_write_col(fits,1,frow,xcens,status)
  call fits_write_col(fits,2,frow,ycens,status)
  call fits_write_col(fits,3,frow,sky,status)
  call fits_write_col(fits,4,frow,sky_err,status)
  call fits_write_col(fits,5,frow,cts,status)
  call fits_write_col(fits,6,frow,cts_err,status)
  deallocate(ttype,tform,tunit)

  ! photometry table
  call fits_movnam_hdu(fits,FITS_BINARY_TBL,PHOTOEXTNAME,extver,status)
  if( status == FITS_BAD_HDU_NUM ) then
     status = 0
  else
     ! already presented ? remove it !
     call fits_delete_hdu(fits,hdutype,status)
     if( status /= 0 ) goto 666
  end if

  allocate(ttype(6), tform(6), tunit(6))

  tform = '1D'
  tunit = ''
  ttype(1) = FITS_COL_X
  ttype(2) = FITS_COL_Y
  ttype(3) = FITS_COL_SKY
  ttype(4) = FITS_COL_SKYERR
  ttype(5) = FITS_COL_COUNT
  ttype(6) = FITS_COL_COUNTERR
  call fits_insert_btbl(fits,0,ttype,tform,tunit,PHOTOEXTNAME,status)
  call fits_update_key(fits,FITS_KEY_ORIGHDU,APEREXTNAME,'copied from',status)
  call fits_update_key(fits,FITS_KEY_FWHM,fwhm,-5,'[pix] standard FWHM of objects',status)

  ! select valid records only
  allocate(id(size(xcens)))
  id = .false.
  n = 0
  do i = 1, size(xcens)
     if( cts(i) >= 0 ) then
        n = n + 1
        id(i) = .true.
     end if
  end do

  allocate(q(n))

  q = pack(xcens,id)
  call fits_write_col(fits,1,frow,q,status)

  q = pack(ycens,id)
  call fits_write_col(fits,2,frow,q,status)

  q = pack(sky,id)
  call fits_write_col(fits,3,frow,q,status)

  q = pack(sky_err,id)
  call fits_write_col(fits,4,frow,q,status)

  q = pack(cts,id)
  call fits_write_col(fits,5,frow,q,status)

  q = pack(cts_err,id)
  call fits_write_col(fits,6,frow,q,status)

  call fits_close_file(fits,status)

  ! save residuals
  call fits_create_file(fits,'!r.fits',status)
  call fits_insert_img(fits,-32,naxis,naxes,status)
  call fits_write_image(fits,group,rframe,status)
  call fits_close_file(fits,status)
  call fits_report_error(error_unit,status)

  deallocate(id,q)

  deallocate(ttype,tform,tunit)

666 continue

  if( allocated(data) ) deallocate(data)
  if( allocated(xcens) ) deallocate(xcens,ycens,asky,acts)
  if( allocated(cts) ) deallocate(cts,cts_err,sky,sky_err)

  call fits_close_file(fits,status)
  call fits_report_error(error_unit,status)

end subroutine fpphot

end module fitspphot

!
!  Spherical astronomy module
!
!  Copyright © 1996 - 2013, 2015-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.



module astrosphere


  implicit none

  integer, parameter, private :: db = selected_real_kind(15)
  real(db), parameter, private :: rad =  57.29577951308232286464772_db

contains

  function gmst(jd)

    real(db) :: gmst
    real(db), intent(in) :: jd


!  Greenwich sidereal time in hours
!
!  jd is a full Julian date
!
!  The precision is better than 1 second.
!  According to Astronomical Almanac 2000.


    real(db) :: tu,t

    tu = (jd - 2451545.0_db)/36525.0_db
    t = 24110.54841_db + tu*(8640184.812866_db + tu*(0.093104_db-6.2e-6_db*tu))
    gmst = mod(t/3600.0_db + 24.0_db*(jd - aint(jd)) + 12.0_db,24.0_db)

  end function gmst


  function lmst(jd,longitude)

    real(db) :: lmst
    real(db), intent(in) :: jd, longitude


!  local sidereal time in hours
!
!  jd is a full Julian date
!  lambda is a longitude in degrees: -west ... +east
!
!  The precision is better than 1 second.
!  According to Astronomical Almanac 2000.

    lmst = mod(gmst(jd) + longitude/15.0_db,24.0_db)

  end function lmst



  function hangle(lmst,ra)

!   hour angle in degrees

    real(db) :: hangle
    real(db), intent(in) :: lmst, ra

    hangle = mod(lmst - ra,360.0_db)

  end function hangle


  subroutine eq2hor(ha, dec, latitude, az, elev)

    real(db), intent(in) :: ha,dec,latitude
    real(db), intent(out) :: az, elev


!
! equatorial to horizontal coordinates
!
!  all arguments in degrees
!

    real(db) :: sinh, cosh, sind, cosd, sinl, cosl, x,y,z,r

    sinh = sin(ha/RAD)
    cosh = cos(ha/RAD)
    sind = sin(dec/RAD)
    cosd = cos(dec/RAD)
    sinl = sin(latitude/RAD)
    cosl = cos(latitude/RAD)

    x = -cosh*cosd*sinl + sind*cosl
    y = -sinh*cosd
    z = cosh*cosd*cosl + sind*sinl

    r = sqrt(x**2 + y**2)
    if( abs(r) > epsilon(r) )then
       az = RAD*atan2(y,x)
    else
       az = 0.0_db
    end if
    if( az < 0_db ) az = az + 360.0_db
    elev = RAD*atan2(z,r)

  end subroutine eq2hor


  subroutine hor2eq(az, elev, latitude, ha,dec)

    real(db), intent(in) :: az,elev,latitude
    real(db), intent(out) :: ha, dec

!
!  horizontal to equatorial coordinates
!
!  all arguments in degrees
!

    real(db) :: sina, cosa, sine, cose, sinl, cosl, x, y, z, r

    sina = sin(az/RAD)
    cosa = cos(az/RAD)
    sine = sin(elev/RAD)
    cose = cos(elev/RAD)
    sinl = sin(latitude/RAD)
    cosl = cos(latitude/RAD)

    x = -cosa*cose*sinl + sine*cosl
    y = -sina*cose
    z = cosa*cose*cosl + sine*sinl

    r = sqrt(x**2 + y**2)
    if( abs(r) > epsilon(r) )then
       ha = RAD*atan2(y,x)
    else
       ha = 0.0_db
    endif
    dec = RAD*atan2(z,r)

  end subroutine hor2eq


  function refract(z)

    real(db) :: refract
    real(db), intent(in) :: z

!
!     compute refraction angle in degrees
!
!    Smart: Textbook on spherical astronomy
!
!    constants for pressure 760mmHg, 10deg C with
!    suffucient accuracy for z < 75 deg
!

    real(db) :: tanz

    tanz = tan(z/RAD)
    refract = (58.16_db*tanz - 0.067_db*tanz*tanz*tanz)/3600.0_db

  end function refract


  function airmass(z)

    real(db) :: airmass
    real(db), intent(in) :: z

    !
    !     compute airmass,
    !
    !      young&irvine: aj,72,945,(1967)
    !
    ! the airmass is limited on the given range of zenit distances

    real(db) :: secz

    if( 0 <= z .and. z < 86.5 ) then
       secz = 1.0_db/cos(z/RAD)
       airmass = secz*(1.0_db - 1.2e-3_db*(secz**2 - 1.0_db))
    else
       airmass = -1
    end if

  end function airmass

  function xairmass(jd,long,lat,ra,dec)

    real(db) :: xairmass
    real(db), intent(in) :: jd,long,lat,ra,dec
    real(db) :: t,h,ha,a

    t = lmst(jd,long)
    ha = hangle(15.0_db*t,ra)
    call eq2hor(ha,dec,lat,a,h)
    xairmass = airmass(90.0_db - h)

  end function xairmass


!  function longsun(jd,y)
  function longsun(d)

!    use trajd

!    real(db), intent(in) :: jd,y
    real(db), intent(in) :: d   ! days since 1. january
    real(db) :: longsun

   !  approx (!!!!) of length of the Sun
    longsun = mod(279.465 + 0.985647*d,360.0_db)
!    longsun = 279.465 + 0.985647*(jd - datjd(y,1.0_db,1.0_db))

  end function longsun


  function helcor(alpha,delta,ls)

    real(db), intent(in) ::  alpha,delta,ls
    real(db) ::  helcor

    ! heliocentric correction in days, angles in degrees

    helcor = 0.9174077_db*sin(alpha/rad)*cos(delta/rad) + &
         0.3979486_db*sin(delta/rad)
    helcor = helcor*sin(ls/rad) + cos(ls/rad)*cos(alpha/rad)*cos(delta/rad)
    helcor = -0.0057755_db*helcor

  end function helcor

  function phase(jd,min0,per)

    real(db), intent(in) ::  jd,min0,per
    real(db) ::  phase

    phase = mod(jd - min0,per) / per

    ! Phase is negative for jd < min0.

  end function phase

  subroutine propercoo(jd0,jd,a,d,pma,pmd,alpha,delta)

    real(db), intent(in) :: jd0,jd
    real(db), intent(in) :: a,d,pma,pmd
    real(db), intent(out) :: alpha,delta
    real(db) :: dt

    dt = (jd - jd0)/365.25_db
    alpha = a + dt*pma
    delta = d + dt*pmd

  end subroutine propercoo


end module astrosphere

!
!  zeroin
!
!  This procedure is adopted version of zeroin procedure
!  by FMM library developed by Forsythe, Malcolm, and Moler
!  (http://www.netlib.org/fmm/index.html) for Fortran 95.
!  Some changes to code are introduced by FH:
!   * epsilon by standard function
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


double precision function zeroin(ax,bx,f,tol)

  implicit none

  double precision, intent(in) :: ax,bx,tol

  interface
     function f(x)
       double precision :: f
       double precision, intent(in) :: x
     end function f
  end interface

!
!      a zero of the function  f(x)  is computed in the interval ax,bx .
!
!  input..
!
!  ax     left endpoint of initial interval
!  bx     right endpoint of initial interval
!  f      function subprogram which evaluates f(x) for any x in
!         the interval  ax,bx
!  tol    desired length of the interval of uncertainty of the
!         final result ( .ge. 0.0d0)
!
!
!  output..
!
!  zeroin abcissa approximating a zero of  f  in the interval ax,bx
!
!
!      it is assumed  that   f(ax)   and   f(bx)   have  opposite  signs
!  without  a  check.  zeroin  returns a zero  x  in the given interval
!  ax,bx  to within a tolerance  4*macheps*abs(x) + tol, where macheps
!  is the relative machine precision.
!      this function subprogram is a slightly  modified  translation  of
!  the algol 60 procedure  zero  given in  richard brent, algorithms for
!  minimization without derivatives, prentice - hall, inc. (1973).
!
  !
  double precision :: eps = epsilon(zeroin)
  double precision  a,b,c,d,e,fa,fb,fc,tol1,xm,p,q,r,s
  double precision  dabs,dsign
!
!  compute eps, the relative machine precision
!
!  FH: the loop is replaced by an internal function (to be faster)
!      eps = 1.0d0
!   10 eps = eps/2.0d0
!      tol1 = 1.0d0 + eps
!      if (tol1 .gt. 1.0d0) go to 10
!
! initialization
!
  a = ax
  b = bx
  fa = f(a)
  fb = f(b)
!
! begin step
!
20 c = a
  fc = fa
  d = b - a
  e = d
30 if (dabs(fc) .ge. dabs(fb)) go to 40
  a = b
  b = c
  c = a
  fa = fb
  fb = fc
  fc = fa
!
! convergence test
!
40 tol1 = 2.0d0*eps*dabs(b) + 0.5d0*tol
  xm = .5*(c - b)
  if (dabs(xm) .le. tol1) go to 90
  if (fb .eq. 0.0d0) go to 90
!
! is bisection necessary
!
  if (dabs(e) .lt. tol1) go to 70
  if (dabs(fa) .le. dabs(fb)) go to 70
!
! is quadratic interpolation possible
!
  if (a .ne. c) go to 50
!
! linear interpolation
!
  s = fb/fa
  p = 2.0d0*xm*s
  q = 1.0d0 - s
  go to 60
!
! inverse quadratic interpolation
!
50 q = fa/fc
  r = fb/fc
  s = fb/fa
  p = s*(2.0d0*xm*q*(q - r) - (b - a)*(r - 1.0d0))
  q = (q - 1.0d0)*(r - 1.0d0)*(s - 1.0d0)
!
! adjust signs
!
60 if (p .gt. 0.0d0) q = -q
  p = dabs(p)
!
! is interpolation acceptable
!
  if ((2.0d0*p) .ge. (3.0d0*xm*q - dabs(tol1*q))) go to 70
  if (p .ge. dabs(0.5d0*e*q)) go to 70
  e = d
  d = p/q
  go to 80
!
! bisection
!
70 d = xm
  e = d
!
! complete step
!
80 a = b
  fa = fb
  if (dabs(d) .gt. tol1) b = b + d
  if (dabs(d) .le. tol1) b = b + dsign(tol1, xm)
  fb = f(b)
  if ((fb*(fc/dabs(fc))) .gt. 0.0d0) go to 20
  go to 30
!
! done
!
90 zeroin = b
  return

end function zeroin

!
!  listing of derived quantities extracted from calibrated images
!
!  Copyright © 2011-2, 2016 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!  
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!  
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


program list

  use mlist

  implicit none
  
  integer, parameter :: dbl = selected_real_kind(15)
  integer, parameter :: clen = 32768
  character(len=clen) :: mode,filename,ifile,line,record,output,backup
!  character(len=9) :: dateobs = 'DATE-OBS',timeobs = 'TIME-OBS', exptime = 'EXPTIME', &
!       filter = 'FILTER'
!  character(len=80) :: object,observer,author,instrument,telescope,origin,reference
  character(len=80) :: column = 'apcount1', key, cootype = ''
!  character(len=10), dimension(35) :: columns
  ! the len is determined by TFORM, the dimension same as in muniphot/ifits
  real(dbl), dimension(:), allocatable :: xcoo, ycoo, vxcoo, vycoo
  character(len=80), dimension(:), allocatable :: fitskeys,headkeys, cols
!  integer, dimension(:), allocatable :: idx
  real(dbl) :: tol = -1.0, aperture = 2.0, &
       zeromag = 25.0_dbl, flux0=1e-26,  x, y, vx, vy, jd0, equinox, &
       long, lat = -99.9, alpha = -1.0, delta, min0, per = -1.0
       
!       zeromag = 25.0_dbl, min0, per = -1.0, x, y, vx, vy, jd0, equinox
  logical :: calibr = .false., mags = .false., fluxes = .false., fileprint = .false.
  !full = .false., &
!       positions = .false., header = .false., 
  logical :: verbose = .false., diffmag = .false.
!  integer :: i,eq,cc,istat,quiet=0,ncoo,nidx,nkeys !,ncolumns
  integer :: eq,cc,istat,ncoo,nkeys,ncols,nfile,naperture !nidx,,ncolumns

  mode = 'lc'
  equinox = 2000.0_dbl
!  ncolumns = 0
!  ncols = 0
  ncoo = 0
!  nidx = 0
  nkeys = 0
!  ncols = 0
!  allocate(cols(0))
  ncols = 2
  allocate(cols(2))
  cols(1) = 'apcount'
  cols(2) = 'apcount_err'

  allocate(headkeys(0))
!  allocate(xcoo(0),ycoo(0),vxcoo(0),vycoo(0))
  allocate(fitskeys(17))
  fitskeys(1) = FITS_KEY_DATEOBS
  fitskeys(2) = FITS_KEY_TIME
  fitskeys(3) = FITS_KEY_EXPTIME
  fitskeys(4) = FITS_KEY_FILTER
  fitskeys(5) = 'EQUINOX'
  fitskeys(6) = 'OBJECT'
  fitskeys(7) = 'OBSERVER'
  fitskeys(8) = 'AUTHOR'
  fitskeys(9) = 'INSTRUME'
  fitskeys(10) = 'TELESCOP'
  fitskeys(11) = 'ORIGIN'
  fitskeys(12) = 'BIBREF'
  fitskeys(13) = 'AREA'
  fitskeys(14) = 'CTFLUX'
  fitskeys(15) = 'CTFLUXER'
  fitskeys(16) = 'CTAPER'
  fitskeys(17) = 'ZEROFLUX'


  do
     read(*,'(a)',end=99,iostat=istat) record
     if( istat /= 0 ) then
        write(*,*) 'Unexpected string on input.'
        stop 21
     end if

     cc = index(record,'#')
     if( cc == 0 ) then
        line = record
     else
        line = record(1:cc-1)
     end if

     eq = index(line,'=')

     if( index(line,'OUTPUT') > 0 .and. eq > 0) then
        
        read(line(eq+1:),*,iostat=istat) output,backup
        if( istat /= 0 ) then
           write(*,*) 'OUTPUT parameter read failed.'
           stop 21
        end if

     else if( index(line,'VERBOSE') > 0 .and. eq > 0) then

        read(line(eq+1:),*,iostat=istat) verbose
        if( istat /= 0 ) then
           write(*,*) 'VERBOSE parameter read failed.'
           stop 21
        end if

     else if( index(line,'MODE') > 0 .and. eq > 0) then
        
        read(line(eq+1:),*,iostat=istat) mode
        if( istat /= 0 ) then
           write(*,*) 'MODE parameter read failed.'
           stop 21
        end if

     else if( index(line,'COOTYPE') > 0 .and. eq > 0) then
        
        read(line(eq+1:),*) cootype

     else if( index(line,'NKEYWORDS') > 0 .and. eq > 0) then

        read(line(eq+1:),*) nkeys
        deallocate(headkeys)
        allocate(headkeys(nkeys))
        nkeys = 0

     else if( index(line,'KEYWORDS') > 0 .and. eq > 0) then

        read(line(eq+1:),*,iostat=istat) key
        if( istat /= 0 ) then
           write(*,*) 'KEYWORD parameter read failed.'
           stop 21
        end if

!        if( nkeys == size(hkeys) ) then
!           call reallocate(hkeys,size(hkeys)+memstep)
!        end if

        if( allocated(headkeys) .and. nkeys < size(headkeys) ) then
           nkeys =  nkeys + 1
           headkeys(nkeys) = key
        end if

     else if( index(line,'NCOLUMNS') > 0 .and. eq > 0) then

        read(line(eq+1:),*) ncols
        deallocate(cols)
        allocate(cols(ncols))
        ncols = 0

     else if( index(line,'COLUMNS') > 0 .and. eq > 0) then

        read(line(eq+1:),*,iostat=istat) column
        if( istat /= 0 ) then
           write(*,*) 'COLUMN parameter read failed.'
           stop 21
        end if
        
        if( allocated(cols) .and. ncols < size(cols) ) then
           ncols = ncols + 1
           cols(ncols) = column
        end if

!!$     else if( index(line,'NINDEX') > 0 .and. eq > 0) then
!!$
!!$        read(line(eq+1:),*) nidx
!!$        allocate(idx(nidx))
!!$        nidx = 0
!!$
!!$     else if( index(line,'INDEX') > 0 .and. eq > 0 )  then
!!$
!!$        read(line(eq+1:),*,iostat=istat) i
!!$        if( istat /= 0 ) then
!!$           write(*,*) 'INDEX parameter read failed.'
!!$           stop 21
!!$        end if
!!$
!!$        if( allocated(idx) .and. nidx < size(idx) ) then
!!$           nidx =  nidx + 1
!!$           idx(nidx) = i
!!$!           call reallocate(idx,size(idx)+memstep)
!!$        end if

     else if( (index(line,'NCARTESIAN') > 0 &
          .or. index(line,'NSPHERICAL') > 0) .and. eq > 0) then


!        write(*,*) trim(line),allocated(xcoo),ncoo,size(xcoo)
        read(line(eq+1:),*) ncoo
!        deallocate(xcoo,ycoo,vxcoo,vycoo)
        allocate(xcoo(ncoo),ycoo(ncoo),vxcoo(ncoo),vycoo(ncoo))
        ncoo = 0
        vxcoo = 0.0_dbl
        vycoo = 0.0_dbl
!        write(*,*) trim(line),allocated(xcoo),ncoo,size(xcoo)

     else if( (index(line,'CARTESIAN') > 0 &
          .or. index(line,'SPHERICAL') > 0) .and. eq > 0) then

!        write(*,*) trim(line),allocated(xcoo),ncoo,size(xcoo)

        read(line(eq+1:),*,iostat=istat) x,y,vx,vy
        if( istat /= 0 ) then
           write(*,*) 'Coordinates parameter read failed.'
           stop 21
        end if

!        if( ncoo == size(xcoo) ) then
!           call reallocate(xcoo,size(xcoo)+memstep)
!           call reallocate(ycoo,size(ycoo)+memstep)
!           call reallocate(vxcoo,size(vxcoo)+memstep)
!           call reallocate(vycoo,size(vycoo)+memstep)
!        end if
        
        if( allocated(xcoo) .and. ncoo < size(xcoo) ) then

!           write(*,*) ncoo,size(xcoo),x,y
           ncoo =  ncoo + 1
           xcoo(ncoo) = x
           ycoo(ncoo) = y
           vxcoo(ncoo) = vx
           vycoo(ncoo) = vy

           if( index(line,'CARTESIAN') > 0 ) cootype = 'pixels'
        end if

     else if( index(line,'TOL') > 0 .and. eq > 0) then

        read(line(eq+1:),*,iostat=istat) tol
        if( istat /= 0 ) then
           write(*,*) 'TOL parameter read failed.'
           stop 21
        end if

     else if( index(line,'JD0') > 0 .and. eq > 0) then

        read(line(eq+1:),*,iostat=istat) jd0
        if( istat /= 0 ) then
           write(*,*) 'JD0 parameter read failed.'
           stop 21
        end if

!     else if( index(line,'MRECT') > 0 .and. eq > 0) then
!
!        read(line(eq+1:),*,iostat=istat) x,y
!        if( istat /= 0 ) then
!           write(*,*) 'MRECT parameter read failed.'
!           stop 21
!        end if
!
!        if( ncoo == size(xcoo) ) then
!           call reallocate(xcoo,size(xcoo)+memstep)
!           call reallocate(ycoo,size(ycoo)+memstep)
!        end if
!
!        mcoo =  mcoo + 1
!        mcoo(mcoo) = x;
!        mcoo(mcoo) = y;
!

!     else if( index(line,'HEADER') > 0 .and. eq > 0) then

!        header = .true.

!     else if( index(line,'MAG') > 0 .and. eq > 0) then

!        mag = .true.

!     else if( index(line,'RELATIVE') > 0 .and. eq > 0) then

!        read(line(eq+1:),*,iostat=istat) relative
!        if( istat /= 0 ) then
!           write(*,*) 'RELATIVE parameter read failed.'
!           stop 21
!        end if

!     else if( index(line,'FULL_LISTING') > 0 .and. eq > 0) then

!        full = .true.
!        relative = .false.

!     else if( index(line,'POSITION_LISTING') > 0 .and. eq > 0) then

!        positions = .true.
!        relative = .false.

!     else if( index(line,'DEBUG') > 0 .and. eq > 0) then

!        read(line(eq+1:),*,iostat=istat) quiet
!        if( istat /= 0 ) then
!           write(*,*) 'DEBUG parameter read failed.'
!           stop 21
!        end if

     else if( index(line,'MAGNITUDES') > 0 .and. eq > 0) then

        read(line(eq+1:),*) mags

     else if( index(line,'FLUXES') > 0 .and. eq > 0) then

        read(line(eq+1:),*) fluxes

     else if( index(line,'CALIBRATED') > 0 .and. eq > 0) then

        read(line(eq+1:),*) calibr

     else if( index(line,'DIFFMAG') > 0 .and. eq > 0) then

        read(line(eq+1:),*) diffmag

     else if( index(line,'ZEROMAG') > 0 .and. eq > 0) then

        read(line(eq+1:),*) zeromag

     else if( index(line,'PHOTFLUX') > 0 .and. eq > 0) then

        read(line(eq+1:),*) flux0

     else if( index(line,'APERTURE') > 0 .and. eq > 0) then

        read(line(eq+1:),*) aperture

     else if( line(:eq-1) == 'NAPERTURE' ) then

        read(line(eq+1:),*) naperture

!!$     else if( index(line,'LATITUDE') > 0 .and. eq > 0) then
!!$
!!$        read(line(eq+1:),*,iostat=istat) lat
!!$        if( istat /= 0 ) then
!!$           write(*,*) 'GEOGRAPHICAL parameter read failed.'
!!$           stop 21
!!$        end if
!!$
!!$     else if( index(line,'LONGITUDE') > 0 .and. eq > 0) then
!!$
!!$        read(line(eq+1:),*,iostat=istat) long
!!$        if( istat /= 0 ) then
!!$           write(*,*) 'GEOGRAPHICAL parameter read failed.'
!!$           stop 21
!!$        end if
!!$
!!$     else if( index(line,'ALPHA') > 0 .and. eq > 0) then
!!$
!!$        read(line(eq+1:),*,iostat=istat) alpha
!!$        if( istat /= 0 ) then
!!$           write(*,*) 'EQUATORIAL parameter read failed.'
!!$           stop 21
!!$        end if
!!$
!!$     else if( index(line,'DELTA') > 0 .and. eq > 0) then
!!$
!!$        read(line(eq+1:),*,iostat=istat) delta
!!$        if( istat /= 0 ) then
!!$           write(*,*) 'EQUATORIAL parameter read failed.'
!!$           stop 21
!!$        end if

!!$     else if( index(line,'EPOCH') > 0 .and. eq > 0) then
!!$
!!$        read(line(eq+1:),*,iostat=istat) min0
!!$        if( istat /= 0 ) then
!!$           write(*,*) 'LC_ELEMENTS parameter read failed.'
!!$           stop 21
!!$        end if

!!$     else if( index(line,'PERIOD') > 0 .and. eq > 0) then
!!$
!!$        read(line(eq+1:),*,iostat=istat) per
!!$        if( istat /= 0 ) then
!!$           write(*,*) 'LC_ELEMENTS parameter read failed.'
!!$           stop 21
!!$        end if

     else if( index(line,'DATE-OBS') > 0 .and. eq > 0 ) then
        read(line(eq+1:),*) fitskeys(1)!dateobs

     else if( index(line,'TIME-OBS') > 0 .and. eq > 0 ) then
        read(line(eq+1:),*) fitskeys(2)!timeobs

     else if( index(line,'EXPTIME') > 0 .and. eq > 0 ) then
        read(line(eq+1:),*) fitskeys(3)!exptime

     else if( index(line,'FILTER') > 0 .and. eq > 0 ) then
        read(line(eq+1:),*) fitskeys(4)!filter

!     else if( index(line,'EXTNAME') > 0 .and. eq > 0 ) then
!        read(line(eq+1:),*) extname

     else if( index(line,'PRINT_FILENAME') > 0 .and. eq > 0) then

        read(line(eq+1:),*) fileprint

     else if( index(line,'NFILES') > 0 .and. eq > 0) then

        read(line(eq+1:),*) nfile

        if( mode == 'cat' .and. nfile /= 1 ) &
             stop 'Passing many files uncompatible to catalogue list. Single file expected.'
!        if( size(headkeys) /= nkeys ) stop "Count of set and passed fits keys does not match."
!        if( size(xcoo) /= ncoo ) stop "Count of set and passed coordinates does not match."

        if( mags .or. fluxes ) then
           if( allocated(cols)) deallocate(cols)
           ncols = 2
           allocate(cols(2))
           cols(1) = 'apcount'
           cols(2) = 'apcount_err'
        end if

        call munilist_init(mode,nfile,fitskeys,headkeys,cols,aperture,naperture, &
             tol,zeromag,flux0,jd0,equinox,mags,fluxes,calibr,diffmag,verbose,fileprint)

        if( allocated(xcoo) ) call munilist_coo(cootype,xcoo,ycoo,vxcoo,vycoo)

     else if( index(line,'FILE') > 0 .and. eq > 0) then

        read(line(eq+1:),*,iostat=istat) filename
        if( istat /=0 ) then
           write(*,*) 'Invalid filename format.'
           stop 21
        end if

!        if( .not. allocated(headkeys) ) allocate(headkeys(0))
!        if( .not. allocated(cols) ) allocate(cols(0))
!        if( .not. allocated(idx) ) allocate(idx(0))
!        if( .not. allocated(xcoo) ) allocate(xcoo(0),ycoo(0),vxcoo(0),vycoo(0))


        call munilist_add(filename)
!!$        call munilist(mode,filename,output,aperture,&!idx(:nidx), &
!!$!        call munilist(mode,filename,output,column,idx(:nidx), &
!!$!        call munilist(mode,filename,output,idx(:nidx), &
!!$             xcoo(:ncoo),ycoo(:ncoo),vxcoo(:ncoo),vycoo(:ncoo),tol, &
!!$             zeromag,jd0,&
!!$        !min0,per,long,lat,alpha,delta,jd0,
!!$             mags,fluxes,instrmag, &!full,positions, &
!!$        !     header,
!!$        verbose,fileprint,cootype,keys(1:nkeys),cols,(/dateobs,timeobs,exptime,filter/),&
!!$        object,observer,author,instrument,telescope,origin,reference,equinox)

     end if

  end do
99 continue

  call munilist_finish(output,backup)

!  if( allocated(idx)  ) deallocate(idx)
  deallocate(fitskeys)
  if( allocated(headkeys) ) deallocate(headkeys)
  if( allocated(cols) ) deallocate(cols)
  if( allocated(xcoo) ) deallocate(xcoo,ycoo,vxcoo,vycoo)

  stop 0

end program list

!
!  Make a report of growth-curves processing
!
!  Copyright © 2016 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

module grow_report

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

  type grow_reporter

     integer :: naper, nstars

     real(dbl), dimension(:,:), allocatable :: grow, grow_err, resgrow
     real(dbl), dimension(:), allocatable :: radius, curve, prof, rapers

  end type grow_reporter


contains


  subroutine grow_report_dump(fits,r,status)

    use titsio

    type(fitsfiles) :: fits
    type(grow_reporter), intent(in) :: r
    integer, intent(in out) :: status

    integer, parameter :: group = 1, extver = 0, frow = 1
    integer :: hdutype,n,i
    character(len=FLEN_VALUE), dimension(:), allocatable :: ttype, tform, tunit
    character(len=FLEN_VALUE) :: key

    if( status /= 0 ) return

    ! HDU for growth-curve (function)
    call fits_movnam_hdu(fits,FITS_ANY_HDU,GROWFUNCEXTNAME,extver,status)
    if( status == FITS_BAD_HDU_NUM ) then
       status = 0
    else
       ! already presented ? remove it !
       call fits_delete_hdu(fits,hdutype,status)
       if( status /= 0 ) goto 666
    end if

    n = 3
    allocate(ttype(n), tform(n), tunit(n))

    tform = '1E'
    tunit = ''
    ttype(1) = FITS_COL_R
    ttype(2) = FITS_COL_GROW
    ttype(3) = FITS_COL_RPROF

    call fits_insert_btbl(fits,0,ttype,tform,tunit,GROWFUNCEXTNAME,status)

    call fits_write_col(fits,1,frow,r%radius,status)
    call fits_write_col(fits,2,frow,r%curve,status)
    call fits_write_col(fits,3,frow,r%prof,status)
    deallocate(ttype,tform,tunit)
    if( status /= 0 ) goto 666

    ! HDU for growth-data (empirical grow + residuals) of individual stars
    call fits_movnam_hdu(fits,FITS_ANY_HDU,GROWDATEXTNAME,extver,status)
    if( status == FITS_BAD_HDU_NUM ) then
       status = 0
    else
       ! already presented ? remove it !
       call fits_delete_hdu(fits,hdutype,status)
       if( status /= 0 ) goto 666
    end if

    n = 3 * r%naper
    allocate(ttype(n), tform(n), tunit(n))
    tform = '1E'
    tunit = ''

    do i = 1, r%naper
       write(ttype(i          ),'(a,i0)') trim(FITS_COL_GROW),i
       write(ttype(i+  r%naper),'(a,i0)') trim(FITS_COL_GROWERR),i
       write(ttype(i+2*r%naper),'(a,i0)') trim(FITS_COL_RESGROW),i
    end do

    call fits_insert_btbl(fits,0,ttype,tform,tunit,GROWDATEXTNAME,status)
    call fits_write_key(fits,FITS_KEY_NAPER,r%naper,'Count of apertures',status)
    do i = 1, r%naper
       call fits_make_keyn(FITS_KEY_APER,i,key,status)
       call fits_write_key(fits,key,r%rapers(i),-5,'[pix] aperture radius',status)
    end do
    do i = 1,r%naper
       call fits_write_col(fits,i,frow,r%grow(:,i),status)
    end do
    do i = 1,r%naper
       call fits_write_col(fits,i+r%naper,frow,r%grow_err(:,i),status)
    end do
    do i = 1,r%naper
       call fits_write_col(fits,i+2*r%naper,frow,r%resgrow(:,i),status)
    end do
    deallocate(ttype,tform,tunit)

666 continue

  end subroutine grow_report_dump

  subroutine grow_report_init(r,naper,nstars,rapers)

    integer, parameter :: nr = 10
    type(grow_reporter), intent(out) :: r
    integer, intent(in) :: naper,nstars
    real, dimension(:), intent(in) :: rapers

    integer :: nc,n
    real :: rmax

    rmax = rapers(naper)
    n = nstars*naper
    nc = nint(nr*rmax) + 1

    allocate(r%radius(nc),r%curve(nc),r%prof(nc),r%grow(nstars,naper),&
         r%grow_err(nstars,naper),r%resgrow(nstars,naper),r%rapers(naper))

    do n = 1,nc
       r%radius(n) = real(n-1) / real(nr)
    end do
    r%naper = naper
    r%nstars = nstars
    r%rapers = rapers

  end subroutine grow_report_init

  subroutine grow_report_terminate(r)

    type(grow_reporter), intent(in out) :: r

    deallocate(r%radius,r%curve,r%prof,r%grow,r%grow_err,r%resgrow,r%rapers)

  end subroutine grow_report_terminate

end module grow_report

!
!  transformation of an instrumental to standard photometry system
!
!  Copyright © 2013-6 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


program phfotran

  use titsio
  use mfits
  use phsysfits

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  character(len=FLEN_KEYWORD), dimension(8) :: keys
  character(len=4*FLEN_FILENAME) :: record, key, val, output
  logical :: verbose = .false., plog = .false., list = .false.
  character(len=FLEN_FILENAME), dimension(:), allocatable :: filenames
  character(len=FLEN_VALUE), dimension(:), allocatable :: col_mag, col_magerr, filters
  character(len=FLEN_FILENAME) :: phsystable = 'photosystems.fits', cat = ''
  character(len=FLEN_VALUE) :: col_ra = FITS_COL_RA, col_dec = FITS_COL_DEC, &
       photsys_instr = '', photsys_ref = ''
  real(dbl) :: utol = -1.0/3600.0
  real(dbl), dimension(:), allocatable :: ctph, extin
  logical :: init_area = .false.
  real(dbl) :: area
  integer :: nfile,n,eq,nmag,nmagerr,nfilters,nctph,nextin

  output = '!phfotran.fits'
  area = 1

  keys(1) = FITS_KEY_EXPTIME
  keys(2) = FITS_KEY_AREA
  keys(3) = FITS_KEY_DATEOBS
  keys(4) = FITS_KEY_PHOTSYS
  keys(5) = FITS_KEY_FILTER
  keys(6) = FITS_KEY_LONGITUDE
  keys(7) = FITS_KEY_LATITUDE
  keys(8) = FITS_KEY_TIMEOBS

  allocate(filenames(0))
  nfile = 0
  allocate(col_mag(0), col_magerr(0), filters(0), ctph(0),extin(0))
  nfilters = 0
  nmag = 0
  nmagerr = 0
  nctph = 0
  nextin = 0

  do
     read(*,'(a)',end=20) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Improper control data on input.'

     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'PIPELOG' ) then

        read(val,*) plog

     else if( key == 'FITS_KEY_EXPTIME' ) then

        read(val,*) keys(1)

     else if( key == 'FITS_KEY_AREA' ) then

        read(val,*) keys(2)

     else if( key == 'FITS_KEY_DATEOBS' ) then

        read(val,*) keys(3)

     else if( key == 'FITS_KEY_PHOTOSYS' ) then ! remove

        read(val,*) keys(4)

     else if( key == 'FITS_KEY_FILTER' ) then

        read(val,*) keys(5)

     else if( key == 'FITS_KEY_LONGITUDE' ) then

        read(val,*) keys(6)

     else if( key == 'FITS_KEY_LATITUDE' ) then

        read(val,*) keys(7)

     else if( key == 'FITS_KEY_TIMEOBS' ) then

        read(val,*) keys(8)

     else if( key == 'COL_RA' ) then

        read(val,*) col_ra

     else if( key == 'COL_DEC' ) then

        read(val,*) col_dec

     else if( key == 'COL_NMAG' ) then

        read(val,*) nmag

        deallocate(col_mag)
        allocate(col_mag(nmag))

     else if( key == 'COL_MAG' ) then

        ! a set of columns of filters
        read(val,*) col_mag

     else if( key == 'COL_NMAGERR' ) then

        read(val,*) nmagerr

        deallocate(col_magerr)
        allocate(col_magerr(nmagerr))

     else if( key == 'COL_MAGERR' ) then

        read(val,*) col_magerr

     else if( key == 'NFILTERS' ) then

        read(val,*) nfilters

        deallocate(filters)
        allocate(filters(nfilters))

     else if( key == 'FILTERS' ) then

        ! a set of filters
        read(val,*) filters

     else if( key == 'NCTPH' ) then

        read(val,*) nctph

        deallocate(ctph)
        allocate(ctph(nctph))

     else if( key == 'CTPH' ) then

        ! efficiency
        read(val,*) ctph

     else if( key == 'NEXTIN' ) then

        read(val,*) nextin

        deallocate(extin)
        allocate(extin(nextin))

     else if( key == 'EXTIN' ) then

        read(val,*) extin

     else if( key == 'PHOTSYS_INSTR' ) then

        read(val,*) photsys_instr

     else if( key == 'PHOTSYS_REF' ) then

        read(val,*) photsys_ref

     else if( key == 'PHSYSTABLE' ) then

        read(val,*) phsystable

     else if( key == 'LIST' ) then

        read(val,*) list

     else if( key == 'TOL' ) then

        read(val,*) utol

     else if( key == 'AREA' ) then

        read(val,*) area
        init_area = .true.

     else if( key == 'CAT' ) then

        read(val,*) cat

     else if( key == 'OUTPUT' ) then

        read(val,*) output

     else if( key == 'NFILE' ) then

        read(val,*) nfile
        deallocate(filenames)
        allocate(filenames(nfile))
        n = 0

     else if( key == 'FILE' ) then

        n = n + 1
        if( n > size(filenames) ) stop 'Too many files.'

        read(val,*) filenames(n)

     end if

  end do
20 continue

  if( photsys_instr == '' .or. photsys_ref == '' ) &
       stop 'Reference or instrumental photometry system undefined.'

  if( list ) then
     call listphsys(phsystable)
  else if ( nfile == 1 .and. cat == '' ) then
     call table
  else
     call frames
  end if

  deallocate(filenames,col_mag,col_magerr,filters,ctph,extin)

  stop 0

contains


  ! transformation
  subroutine frames

    use fits_fotran
    use fotran
    use jamming

    character(len=FLEN_VALUE) :: catid, photsys_frames
    character(len=FLEN_VALUE), dimension(:), allocatable :: filter
    real(dbl), allocatable, dimension(:) :: ra, dec, airmass
    real(dbl), allocatable, dimension(:,:) :: tr,tr1,trerr,tr1err, ph,dph,cts,dcts
    integer, dimension(:,:), allocatable :: pairs
    real(dbl) :: e
    integer :: k,nph

    if( size(filters) == 0 ) stop 'Filters undefined. Use -f option.'
    if( size(filenames) < 2 ) stop 'One frame only? No more frames - no more love.'
    if( nextin > 0 .and. nextin /= size(filenames) ) &
         stop 'Number of extinction elements does not match number of files.'
    if( nctph > 0 .and. nctph /= size(filenames) ) &
         stop 'Number of ctph elements does not match number of files.'
    if( size(filters) /= size(filenames) ) &
         stop 'Number of filters elements does not match number of files.'

    if( size(filters) > 0 .and. size(col_mag) == 0 ) then
       deallocate(col_mag)
       allocate(col_mag(size(filters)))
       col_mag = filters
    end if

    call jamcatx(cat,phsystable,keys,col_ra,col_dec,col_mag,col_magerr,&
       utol, area, init_area, filters, filenames, catid, filter, ra, dec, airmass, &
       ph,dph, cts,dcts, photsys_ref, photsys_frames, pairs)

    if( size(ra) < 2 ) &
         stop 'Determination of parameters of line requires more than two points.'

    if( photsys_frames /= '' ) photsys_instr = photsys_frames

    nph = nfilters
    allocate(tr(nph,nph),trerr(nph,nph),tr1(nph,nph),tr1err(nph,nph))

    do k = 1,nctph
       cts(:,k) = cts(:,k)*ctph(k)
       dcts(:,k) = dcts(:,k)*ctph(k)
    end do

    if( nextin > 0 .and. verbose ) write(*,*) 'Extinction: filter, airmass, attenuation:'
    do k = 1,nextin
       e = exp(extin(k)*airmass(k))
       cts(:,k) = e*cts(:,k)
       dcts(:,k) = e*dcts(:,k)
       if( verbose ) write(*,'(1x,a,2f7.3)') trim(filters(k)),airmass(k),e
    end do

    ! testing
!    tr(1,:) = (/0.25,-0.03 /)
!    tr(2,:) = (/-0.02,0.5 /)

!    tr(1,:) = (/11.0,0.1,0.0,0.0,0.0 /)
!    tr(2,:) = (/-0.1,3.0,0.1,0.0,0.0 /)
!    tr(3,:) = (/ 0.0,0.2,1.0,-0.1,0.0 /)
!    tr(4,:) = (/ 0.0,0.0,-0.2,2.0,0.2 /)
!    tr(5,:) = (/ 0.0,0.0,0.0,-0.1,3.0 /)

!    do k = 1,size(ph,1)
!       cts(k,:) = matmul(tr,ph(k,:))
!       dcts(k,:) = matmul(tr,dph(k,:))
!    end do

    call trafo(pairs,ph,dph,cts,dcts,tr,trerr,tr1,tr1err,verbose)

    call trawrite(output,photsys_ref,photsys_instr,filters,filters, &
         ra,dec,ci0,ph,dph,cts,dcts,tr,trerr,tr1,tr1err,filenames,airmass,ctph,extin)

    deallocate(ra,dec,airmass,cts,dcts,ph,dph,filter,tr,trerr,tr1,tr1err)

  end subroutine frames


  ! transformation
  subroutine table

    use fits_fotran
    use fotran
    use phsysfits

    real(dbl), allocatable, dimension(:) :: ra, dec
    real(dbl), allocatable, dimension(:,:) :: tr,tr1,trerr,tr1err, ph,dph,cts,dcts
    integer, dimension(:,:), allocatable :: pairs
    type(type_phsys) :: phsys
    integer :: n

    call phselect(phsystable,photsys_ref,phsys)
    call phsyspairs(phsys,filters,pairs)

    call tradata(filenames(1),ra,dec,ph,dph,cts,dcts)

    n = size(ph,2)
    allocate(tr(n,n),trerr(n,n),tr1(n,n),tr1err(n,n))

    call trafo(pairs,ph,dph,cts,dcts,tr,trerr,tr1,tr1err,verbose)

    call trawrite(output,photsys_ref,photsys_instr,filters,filters, &
         ra,dec,ci0,ph,dph,cts,dcts,tr,trerr,tr1,tr1err)

    deallocate(ra,dec,cts,dcts,ph,dph,tr,trerr,tr1,tr1err)

  end subroutine table


  subroutine trafo(pairs,ph,dph,cts,dcts,tr,trerr,tr1,tr1err,verbose)

    use fotran

    integer, dimension(:,:), intent(in) :: pairs
    real(dbl), dimension(:,:), intent(in) :: ph,dph,cts,dcts
    real(dbl), dimension(:,:), intent(out) :: tr,trerr,tr1,tr1err
    logical, intent(in) :: verbose

    real(dbl), dimension(:), allocatable :: ct,dct
    integer :: k,l,nph

    nph = size(ph,2)
    allocate(ct(nph),dct(nph))

    call stdtra(pairs,ph,dph,cts,dcts,tr,trerr,verbose)
    if( verbose ) then
       write(*,*) 'Forward matrix (ph-rate to cts-rate):'
       do k = 1,size(tr,1)
          write(*,'(5f12.4)') tr(k,:)
       end do
    end if


    if( verbose ) then
       write(*,*) 'Relative residuals in filters:'
       write(*,'(tr5,5a10)') filters
       do l = 1,size(ph,1)
          call fotra(tr,pairs,ph(l,:),dph(l,:),ct,dct)
          write(*,'(5f10.5)') (ct - cts(l,:))/ct
       end do
    end if

    call stdtra(pairs,cts,dcts,ph,dph,tr1,tr1err,verbose)
    if( verbose ) then
       write(*,*) 'Backward matrix (cts-rate to ph-rate):'
       do k = 1,size(tr1,1)
          write(*,'(5f12.4)') tr1(k,:)
       end do
    end if

    if( verbose ) then
       write(*,*) 'Relative residuals in filters:'
       write(*,'(tr5,5a10)') filters
       do l = 1,size(ph,1)
          call fotra(tr1,pairs,cts(l,:),dcts(l,:),ct,dct)
          write(*,'(5f10.5)') (ph(l,:) - ct)/ph(l,:)
       end do
    end if

    deallocate(ct,dct)

  end subroutine trafo

end program phfotran

!
!  photoconv - photometry conversions
!
!  Copyright © 2013 - 15, 2017-2021 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module photoconv

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

  ! http://en.wikipedia.org/wiki/Planck_constant
  real(dbl), parameter, private :: planck = 6.62606957e-34_dbl    ! [J.s] in SI

  ! http://en.wikipedia.org/wiki/Speed_of_light
  real(dbl), parameter, private :: c = 299792458.0_dbl            ! [m/s] in SI

  ! reciprocal flux for star of magnitude 25
  real(dbl), parameter, private :: flux25 = 1e10

  ! spectral flux density for star of magnitude 0 in V (545nm) band for AB system
  real(dbl), parameter, private :: ABspflux = 3.631e-23 ! [W/m2/Hz]

  ! spectral flux density for star of magnitude 0 in V (545nm) band for ST system
  real(dbl), parameter, private :: STspflux = 3.6335e-10 ! [W/m2/nm]

  ! gauss-hermite coefficients
  real(dbl), parameter, private :: h0 = 1.1816359006_dbl, &
       h12 = 0.295408975151_dbl, &
       a = 1.22474487139_dbl, &
       a1 = 0.707106781187_dbl
  ! h*c (planck * light speed in [J]
  real(dbl), parameter, private :: hc = 1.98644568e-25

  ! electron-Volt
  real(dbl), parameter, private :: evolt = 1.602176634e-19

  ! sqrt(pi)
  real(dbl), parameter, private :: sqrtpi = 1.772453850905515882_dbl

  ! sqrt(pi/2)
  real(dbl), parameter, private :: sqrtpi2 = 1.2533141373155001_dbl


  ! known quantities
  character(len=8), dimension(12), parameter :: quantities = [ &
       'COUNT   ', &
       'RATE    ', &
       'PHOTON  ', &
       'PHOTRATE', &
       'PHOTNU  ', &
       'PHOTLAM ', &
       'FLUX    ', &
       'FNU     ', &
       'FLAM    ', &
       'MAG     ', &
       'ABMAG   ', &
       'STMAG   ' ]

  ! units
  character(len=14), dimension(12), parameter :: units = [ &
       'count         ', &
       'count/s/m2    ', &
       'photon        ', &
       'photon/s/m2   ', &
       'photon/s/m2/Hz', &
       'photon/s/m2/nm', &
       'eV/s/m2       ', &
       'W/m2/Hz       ', &
       'W/m2/nm       ', &
       'mag           ', &
       'abmag         ', &
       'stmag         ']


contains

  subroutine quantity(key,unit)

    ! simulates searching in map stucture: ("key","unit")

    character(len=*), intent(in) :: key
    character(len=*), intent(out) :: unit
    integer :: i

    unit = ''
    do i = 1,size(quantities)
       if( key == quantities(i) ) then
          unit = units(i)
          return
       end if
    end do

  end subroutine quantity

  subroutine squantity(key,unit)

    ! quantity for surface photometry

    character(len=*), intent(in) :: key
    character(len=*), intent(out) :: unit

    call quantity(key,unit)
    unit = trim(unit)//'/arcsec2'

  end subroutine squantity

  subroutine ctrate(gain,area,exptime,arcscale,cts,dcts,rate,drate)

    real(dbl), intent(in) :: gain,area,exptime,arcscale
    real(dbl), dimension(:), intent(in) :: cts,dcts
    real(dbl), dimension(:), intent(out) :: rate,drate
    real(dbl) :: f

    f = gain/(area*exptime*arcscale**2)

    where( cts >= 0.0_dbl)
       rate = f * cts
       drate = f * dcts
    elsewhere
       rate = -1.0_dbl
       drate = -1.0_dbl
    end where

  end subroutine ctrate

  subroutine phrate(area,exptime,arcscale,ph,dph,rate,drate)

    ! photons (in CCD array) to photon rates

    real(dbl), intent(in) :: area,exptime,arcscale
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: rate,drate
    real(dbl) :: f

    f = area * exptime * arcscale**2

    where( ph >= 0.0_dbl)
       rate = ph / f
       drate = dph / f
    elsewhere
       rate = -1.0_dbl
       drate = -1.0_dbl
    end where

  end subroutine phrate

  subroutine ct2ph(gain,area,exptime,arcscale,ctph,dctph,cts,dcts,ph,dph)

    ! convert counts rate to photon rate [ph/s/m2]

    real(dbl), intent(in) :: gain,area,exptime,arcscale,ctph,dctph
    real(dbl), dimension(:), intent(in) :: cts,dcts
    real(dbl), dimension(:), intent(out) :: ph,dph
    real(dbl) :: f

    f = gain/(area*exptime)/arcscale**2/ctph

    where( cts >= 0.0_dbl)
       ph = f * cts
       dph = f * dcts
       !dph = sqrt(f**2*dctph**2 + f**2*dcts**2)
    elsewhere
       ph = -1.0_dbl
       dph = -1.0_dbl
    end where

  end subroutine ct2ph

  subroutine ph2photlam(lfwhm,ph,dph,phlam,dphlam)

    ! photon rate per unit of wavelegth [ph/s/m2/nm]

    real(dbl), intent(in) :: lfwhm
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: phlam,dphlam
    real(dbl) :: f

    f = lfwhm / 1e-9_dbl

    where( ph >= 0.0_dbl )
       phlam = f * ph
       dphlam = f * dph
    elsewhere
       phlam = -1.0_dbl
       dphlam = -1.0_dbl
    end where

  end subroutine ph2photlam

  subroutine ph2photnu(ffwhm,ph,dph,phnu,dphnu)

    ! photon rate per unit of frequency [ph/s/m2/Hz]

    real(dbl), intent(in) :: ffwhm
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: phnu,dphnu
    real(dbl) :: f

    f = 1.0 / ffwhm

    where( ph >= 0.0_dbl )
       phnu = f * ph
       dphnu = f * dph
    elsewhere
       phnu = -1.0_dbl
       dphnu = -1.0_dbl
    end where

  end subroutine ph2photnu


  subroutine ph2flux(feff,ph,dph,flux,dflux)

    ! (light intensity, energy) flux integrated over frequency band [W/m2],
    ! in convenient electron-Volts

    real(dbl), intent(in) :: feff
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: flux,dflux
    real(dbl) :: f

    f = planck * feff / evolt

    where( ph >= 0.0_dbl )
       flux = f * ph
       dflux = f * dph
    elsewhere
       flux = -1.0_dbl
       dflux = -1.0_dbl
    end where

  end subroutine ph2flux

    subroutine ph2flux0(leff,ph,dph,flux,dflux)

    ! (light intensity, energy) flux integrated over frequency band [W/m2]

    real(dbl), intent(in) :: leff
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: flux,dflux
    real(dbl) :: f

    f = planck * c / leff

    where( ph >= 0.0_dbl )
       flux = f * ph
       dflux = f * dph
    elsewhere
       flux = -1.0_dbl
       dflux = -1.0_dbl
    end where

  end subroutine ph2flux0

  subroutine cts2flux0(leff,cts,dcts,flux,dflux)
    ! replaced by ph2flux0

    ! (light intensity, energy) flux integrated over frequency band [W/m2]

    real(dbl), intent(in) :: leff
    real(dbl), dimension(:), intent(in) :: cts,dcts
    real(dbl), dimension(:), intent(out) :: flux,dflux
    real(dbl) :: f

    f = planck * c / leff

    where( cts >= 0.0_dbl )
       flux = f * cts
       dflux = f * dcts
    elsewhere
       flux = -1.0_dbl
       dflux = -1.0_dbl
    end where

  end subroutine cts2flux0

  subroutine ph2fllux(leff,ph,dph,flux,dflux)

    ! (light intensity, energy) flux integrated over wavelength band [W/m2]

    real(dbl), intent(in) :: leff
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: flux,dflux
    real(dbl) :: f

    f = planck * c / leff

    where( ph >= 0.0_dbl )
       flux = f * ph
       dflux = f * dph
    elsewhere
       flux = -1.0_dbl
       dflux = -1.0_dbl
    end where

  end subroutine ph2fllux


  subroutine ph2fnu(feff,ffwhm,ph,dph,flux,dflux)

    ! spectral flux density per frequency [W/m2/Hz]

    real(dbl), intent(in) :: feff, ffwhm
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: flux,dflux
    real(dbl) :: f

    f = planck * (feff / ffwhm)

    where( ph >= 0.0_dbl )
       flux = f * ph
       dflux = f * dph
    elsewhere
       flux = -1.0_dbl
       dflux = -1.0_dbl
    end where

  end subroutine ph2fnu

  subroutine ph2flam0(leff,lfwhm,ph,dph,flux,dflux)

    ! spectral flux density per wavelength [W/m2/nm]

    real(dbl), intent(in) :: leff, lfwhm
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: flux,dflux
    real(dbl) :: f

    f =  (planck / 1e-9) * (leff / lfwhm)

    where( ph >= 0.0_dbl )
       flux = f * ph
       dflux = f * dph
    elsewhere
       flux = -1.0_dbl
       dflux = -1.0_dbl
    end where

  end subroutine ph2flam0

  subroutine mag2flux0(lwidth,zeroflam,mag,dmag,flux,dflux)

    ! magnitudes to flux in the passband [W/m2]

    real(dbl), dimension(:), intent(in) :: lwidth,zeroflam
    real(dbl), dimension(:), intent(in) :: mag,dmag
    real(dbl), dimension(:), intent(out) :: flux,dflux

    where( mag < 99 )
       flux = sqrtpi2 * 1e9 * zeroflam * lwidth * 10.0_dbl**(-0.4_dbl * mag) ! [nm->m]
    elsewhere
       flux = -1
    end where

    where( dmag < 9 )
       dflux = flux * dmag / 1.0857
    elsewhere
       dflux = 0
    end where

  end subroutine mag2flux0

  subroutine mag2ph(leff,lwidth,zeroflam,mag,dmag,ph,dph)

    ! magnitudes to photon flux in a passband [ph/s/m2]
    ! 3-th order aproximation

    real(dbl), dimension(:), intent(in) :: leff,lwidth,zeroflam
    real(dbl), dimension(:), intent(in) :: mag,dmag
    real(dbl), dimension(:), intent(out) :: ph,dph

!    real(dbl), dimension(size(mag)) :: flux,flam,e,mag0,n0,w,lw
    real(dbl), dimension(size(mag)) :: flux,flam,w,lw

    integer :: i

!    e = (/0.65,0.81,0.88,0.92,0.96/)
!    mag0 = 0
!    mag0 = (/-0.23611,-20.533,-21.226,-20.984,-0.35776/)
!    mag0 = (/-0.23611,-0.693,0.04,-20.984,-0.35776/)
!    mag0 = (/-0.23611,-0.77305+0.04,0.04,-0.24246+0.04,-0.35776/)
!    n0 = (/4.34413517E+09,1.34928722E+10,8.57578752E+09,1.31331963E+10,9.31594240E+09/)
    w = (/0.572981,0.683449,0.76545,0.645865,0.634657/)

!    flux = zeroflux * 10.0_dbl**(-0.4_dbl * (mag - mag0))

!    flux = w * flux
!    flux = e *flux
!    call flux2flam(leff,lwidth/2,flux,flam)
!    write(*,'(a,5es13.5)') 'flux:',flux
!    write(*,'(a,5es13.5)') 'flam',flam
!    call flam2plux(1e9*leff,1e9*lwidth/2,flam,ph)
!    write(*,'(a,5es13.5)') 'ph',ph

!    stop
!    ph = n0 * 10.0_dbl**(-0.4_dbl * (mag - mag0))

!    dph = dmag*ph/1.0857

    !
!    flux = e * zeroflux * 10.0_dbl**(-0.4_dbl * (mag - mag0))

!    write(*,*) real(zeroflam)
!    write(*,*) real(lwidth)
!    write(*,*) real(mag)

    flux = zeroflam * 10.0_dbl**(-0.4_dbl * mag) ! [nm -> m]
    flam = zeroflam * 10.0_dbl**(-0.4_dbl * mag) / lwidth ! [nm -> m]
!    flux = 1e9 * e * zeroflam * lwidth * 10.0_dbl**(-0.4_dbl * mag) ! [nm -> m]
 !    flux = 10.0_dbl**(-0.4_dbl * (mag - mag0))
!    flux = flux * w
!    ph = flux*leff

    if( size(mag) == 1 ) then

       ph = flux*leff

    else

       lw = lwidth / 2
       ph(1) = flux(1)*leff(1)*(1 + a1**2/2*lw(1)**2/leff(1)/(leff(2)-leff(1)) &
            *( flux(2)/flux(1) * lw(1)/lw(2) - 1))
!       write(*,*) ph(1)
!       ph(1) = flam(1)*leff(1)*(1 + a1**2/2*lw(1)**2/leff(1)/(leff(2)-leff(1)) &
!            *( flam(2)/flam(1) - 1))
!       write(*,*) ph(1)

!       write(*,*) flam(1),flam(2),flam(2)/flam(1)
!       write(*,*) flux(1),flux(2),lw(1),lw(2),flux(2)/flux(1) * lw(2)/lw(1)
!       stop

       do i = 2,size(mag)
!       ph(i) = 0.886227*flux(i)*leff(i)*(1 + &
!       ph(i) = flux(i)*leff(i)*(1 - &
!            0.707107**2/2*lw(i)**2/leff(i)/(leff(i+1)-leff(i)) + &
!            0.707107**2/2*lw(i)*lw(i+1)/leff(i)/(leff(i+1)-leff(i)) * flux(i+1)/flux(i))
          ph(i) = flux(i)*leff(i)*(1 + a1**2/2*lw(i)**2/leff(i)/(leff(i)-leff(i-1)) &
               *( flux(i-1)/flux(i) * lw(i)/lw(i-1) - 1))
!          ph(i) = flam(i)*leff(i)*(1 + a1**2/2*lw(i)**2/leff(i)/(leff(i)-leff(i-1)) &
!               *( flam(i-1)/flam(i) - 1))
!       write(*,*) 0.707107**2/2*lw(i)**2/leff(i)/(leff(i+1)-leff(i)), &
!            0.707107**2/2*lw(i)*lw(i+1)/leff(i)/(leff(i+1)-leff(i)) * flux(i+1)/flux(i)
!       write(*,*) flux(i)*leff(i)/hc,ph(i)/hc,real((flux(i)*leff(i)-ph(i))/ph(i))
       end do
!    do i = 1,size(mag)
!       ph(i) = flux(i)*leff(i)
!    end do

    end if

    ph = ph / hc
    dph = dmag*ph/1.0857

!    write(*,'(a,5es13.5)') 'ph',ph


  end subroutine mag2ph

  subroutine mag2ph3(leff,lwidth,flamref,mag,dmag,ph,dph)

    ! magnitudes to photon flux in a passband [ph/s/m2]
    ! 3-th order aproximation

    real(dbl), dimension(:), intent(in) :: leff,lwidth,flamref
    real(dbl), dimension(:), intent(in) :: mag,dmag
    real(dbl), dimension(:), intent(out) :: ph,dph

!    real(dbl), dimension(size(mag)) :: flux,flam,e,mag0,n0,w,lw
    real(dbl), dimension(size(mag)) :: flux,flam,w

!    integer :: i

!    e = (/0.65,0.81,0.88,0.92,0.96/)
!    mag0 = 0
!    mag0 = (/-0.23611,-20.533,-21.226,-20.984,-0.35776/)
!    mag0 = (/-0.23611,-0.693,0.04,-20.984,-0.35776/)
!    mag0 = (/-0.23611,-0.77305+0.04,0.04,-0.24246+0.04,-0.35776/)
!    n0 = (/4.34413517E+09,1.34928722E+10,8.57578752E+09,1.31331963E+10,9.31594240E+09/)
    w = (/0.572981,0.683449,0.76545,0.645865,0.634657/)

    flux = flamref * 1e9 * 10.0_dbl**(-0.4_dbl * (mag - 0.04))

    flux(3) = 1e9 * flamref(3) * 10.0_dbl**(-0.4_dbl * mag(3)) * sqrtpi * lwidth(3)/2 * w(3)
    flux(2) = flux(3)*10**(-0.4*(mag(2)-mag(3)))*1.9644 !*  (w(3)/w(2))
    flux(1) = flux(2)*10**(-0.4*(mag(1)-mag(2)))*0.39476
    flux(4) = flux(3)*10**(-0.4*(mag(3)-mag(4)))/0.79986
    flux(5) = flux(4)*10**(-0.4*(mag(4)-mag(5)))/1.8034

!    write(*,'(a,5es13.5)') 'flux:',flux

!    flux = flamref * 1e9 * 10.0_dbl**(-0.4_dbl * mag) * sqrtpi * lwidth/2 / w
!    flux = flux / (w/w(3))
!    flux = flamref * 1e9 * 10.0_dbl**(-0.4_dbl * mag) * sqrtpi * lwidth/2 / w

!    flux = w * flux
!    flux = e *flux
    call flux2flam(leff,lwidth/2,flux,flam)
    flam = 1e-9*flam
    write(*,'(a,5es13.5)') 'flux:',flux
    write(*,'(a,5es13.5)') 'flam',flam
!    call flam2plux(1e9*leff,1e9*lwidth/2,flam,ph)


!    flam = 1e9 * flamref * 10.0_dbl**(-0.4_dbl * mag)
!    write(*,'(a,5es13.5)') 'flam',1e9 * flamref * 10.0_dbl**(-0.4_dbl * mag) / (lwidth/2) / sqrtpi

!    flam(3) = 1e9 * flamref(3) * 10.0_dbl**(-0.4_dbl * mag(3))
!    flam(2) = flam(3)*10**(-0.4*(mag(2)-mag(3)))
!    write(*,'(a,5es13.5)') 'flam',flam

    flam = 1e9*flam
!    flam = flux / lwidth
    call flam2plux(leff,lwidth/2,flam,ph)
    write(*,'(a,5es13.5)') 'ph',ph

    dph = ph * dmag / 1.086

  end subroutine mag2ph3


  subroutine ph2mag3(leff,lwidth,zeroflux,ph,dph,mag,dmag)

    ! converts photon flux to magnitudes in a passband [ph/s/m2]
    ! 3-th order aproximation

    real(dbl), dimension(:), intent(in) :: leff,lwidth,zeroflux
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: mag,dmag

!    real(dbl), dimension(size(mag)) :: flux,flam,e,mag0,n0,w,lw
    real(dbl), dimension(size(mag)) :: flux,flam,w

!    integer :: i

!    e = (/0.65,0.81,0.88,0.92,0.96/)
!    mag0 = 0
!    mag0 = (/-0.23611,-20.533,-21.226,-20.984,-0.35776/)
!    mag0 = (/-0.23611,-0.693,0.04,-20.984,-0.35776/)
!    mag0 = (/-0.23611,-0.77305+0.04,0.04,-0.24246+0.04,-0.35776/)
!    n0 = (/4.34413517E+09,1.34928722E+10,8.57578752E+09,1.31331963E+10,9.31594240E+09/)
    w = (/0.572981,0.683449,0.76545,0.645865,0.634657/)

!    write(*,*)
!    flux = zeroflux * 10.0_dbl**(-0.4_dbl * mag)

!    flux = w * flux
!    flux = e *flux
    call ph2flam(leff,lwidth/2,ph,flam)
!    write(*,'(a,5es13.5)') 'ph:',ph
!    write(*,'(a,5es13.5)') 'flam',flam
    call flam2flux(leff,lwidth/2,flam,flux)
!    write(*,'(a,5es13.5)') 'flux',flux
    mag = -2.5*log10(flux/zeroflux)
    dmag = (dph/ph) * mag * 1.086 !?

  end subroutine ph2mag3

!!$  subroutine mag2pht(leff,lwidth,zeroflux,exptime,area,mag,dmag,ph,dph)
!!$
!!$    ! magnitudes to photon flux in a passband on area and time [ph]
!!$
!!$    real(dbl), dimension(:), intent(in) :: leff,lwidth,zeroflux,exptime,area
!!$    real(dbl), dimension(:), intent(in) :: mag,dmag
!!$    real(dbl), dimension(:), intent(out) :: ph,dph
!!$    real(dbl), dimension(size(mag)) :: c
!!$
!!$    call mag2ph(leff,lwidth,zeroflux,mag,dmag,ph,dph)
!!$
!!$    c = exptime * area
!!$    ph = c * ph
!!$    dph = c *dph
!!$
!!$  end subroutine mag2pht

  subroutine flux2flam(leff,lw,flux,flam)

    ! flam deconvolution from flux

    real(dbl), dimension(:), intent(in) :: leff,lw,flux
    real(dbl), dimension(:), intent(out) :: flam

    real(dbl), dimension(size(flux)) :: w
    real(dbl), dimension(size(flux)-2) :: b,d,s,p,x
    real(dbl) :: hh
    integer :: i,j,n,m,iter

    n = size(flux)
    m = n - 2

    w = 1
    w = (/0.572981,0.683449,0.76545,0.645865,0.634657/)

    ! initial estimate of flux density (used 1 and n-th points)
    flam = w*flux/lw/sqrtpi

    do iter = 1,2

       b = w(2:n-1) * flux(2:n-1)
       p(1) = 0.0_dbl
       s(m) = 0.0_dbl

       do i = 2,n-1
          j = i - 1
          d(j) = (h0+2*h12*(1+(lw(i)*a)**2/(leff(i)-leff(i-1))/(leff(i)-leff(i+1))))*lw(i)
          hh = 2*h12*lw(i)**3*a**2/(leff(i+1)-leff(i-1))
          if( j > 1 ) p(j) = hh/(leff(i) - leff(i-1))
          if( j < m ) s(j) = hh/(leff(i+1) - leff(i))
          if( j == 1 ) b(j) = b(j) - hh*flam(i-1)/(leff(i) - leff(i-1))
          if( j == m ) b(j) = b(j) - hh*flam(i+1)/(leff(i+1) - leff(i))
       end do

       x = b
       call tridig(d,p,s,x)
       flam(2:n-1) = x

       ! more accurate estimate of points on edges
       hh = h12*lw(1)**3*a**2/(leff(3)-leff(1))
       p(1) = hh*(flam(3) - flam(2))/(leff(3) - leff(2))
       s(1) = hh*flam(2)/(leff(2) - leff(1))
       flam(1) = (w(1)*flux(1) - p(1) + s(1))/((h0 + 2*h12)*lw(1)+hh/(leff(2) - leff(1)))

       hh = h12*lw(n)**3*a**2/(leff(n-2)-leff(n))
       p(1) = hh*(flam(n-2) - flam(n-1))/(leff(n-2) - leff(n-1))
       s(1) = hh*flam(n-1)/(leff(n-1) - leff(n))
       flam(n) = (w(n)*flux(n) - p(1) + s(1))/((h0 + 2*h12)*lw(n)+hh/(leff(n-1)-leff(n)))

    end do


!!$    ! initial estimate of flux density (used 1 and n-th points)
!!$    w = 1
!!$    w = (/0.572981,0.683449,0.76545,0.645865,0.634657/)
!!$!    flam = w*flux/lw/sqrtpi*1e-9
!!$    write(*,*) flux
!!$    flam = w * flux / lw /sqrtpi * 1e-9
!!$    write(*,*) real(flam)
!!$
!!$!    ph = zeroflux * leff * 10.0_dbl**(-0.4_dbl*mag) / hc
!!$
!!$    do iter = 1,2
!!$
!!$       b = w(2:n-1) * flux(2:n-1)
!!$       p(1) = 0.0_dbl
!!$       s(m) = 0.0_dbl
!!$
!!$       do i = 2,n-1
!!$          j = i - 1
!!$          d(j) = (h0+2*h12*(1-(lw(i)*a)**2/(leff(i)-leff(i-1))/(leff(i+1)-leff(i))))*lw(i)
!!$          hh = 2*h12*lw(i)**3*a**2/(leff(i+1)-leff(i-1))
!!$          if( j > 1 ) p(j) = hh/(leff(i) - leff(i-1))
!!$          if( j < m ) s(j) = hh/(leff(i+1) - leff(i))
!!$          if( j == 1 ) b(j) = b(j) - hh*flam(i-1)/(leff(i) - leff(i-1))
!!$          if( j == m ) b(j) = b(j) - hh*flam(i+1)/(leff(i+1) - leff(i))
!!$       end do
!!$
!!$       x = b
!!$       call tridig(d,p,s,x)
!!$       flam(2:n-1) = x
!!$
!!$       ! more accurate estimate of points on edges
!!$       hh = h12*lw(1)**3*a**2/(leff(3)-leff(1))
!!$       p(1) = hh*(flam(3) - flam(2))/(leff(3) - leff(2))
!!$       s(1) = hh*flam(2)/(leff(2) - leff(1))
!!$       flam(1) = (w(1)*flux(1) - p(1) + s(1))/((h0 + 2*h12)*lw(1)+hh/(leff(2) - leff(1)))
!!$
!!$       hh = h12*lw(n)**3*a**2/(leff(n-2)-leff(n))
!!$       p(1) = hh*(flam(n-2) - flam(n-1))/(leff(n-2) - leff(n-1))
!!$       s(1) = hh*flam(n-1)/(leff(n-1) - leff(n))
!!$       flam(n) = (w(n)*flux(n) - p(1) + s(1))/((h0 + 2*h12)*lw(n)+hh/(leff(n-1)-leff(n)))
!!$
!!$!       write(*,*) real(flam)
!!$
!!$    end do
!!$
!!$!    flam = w*flux/lw/sqrtpi
!!$!    flam = 1d-9 * flam ! conversion [W/m3] -> [W/m2/nm]
!!$
!!$    write(*,*) real(flam)

!    stop

!!$
!!$
!!$    w = (/0.572981,0.683449,0.76545,0.645865,0.634657/)
!!$
!!$    ! initial estimate of flux density (used 1 and n-th points)
!!$    flam = w*flux/lw/sqrtpi
!!$
!!$    do iter = 1,2
!!$
!!$       b = w(2:n-1) * flux(2:n-1)
!!$       p(1) = 0
!!$       s(m) = 0
!!$
!!$       do i = 2,n-1
!!$          j = i - 1
!!$          d(j) = (h0+2*h12*(1+(lw(i)*a)**2/(leff(i)-leff(i-1))/(leff(i)-leff(i+1))))*lw(i)
!!$          hh = 2*h12*lw(i)**3*a**2/(leff(i+1)-leff(i-1))
!!$          if( j > 1 ) p(j) = hh/(leff(i) - leff(i-1))
!!$          if( j < m ) s(j) = hh/(leff(i+1) - leff(i))
!!$          if( j == 1 ) b(j) = b(j) - hh*flam(i-1)/(leff(i) - leff(i-1))
!!$          if( j == m ) b(j) = b(j) - hh*flam(i+1)/(leff(i+1) - leff(i))
!!$       end do
!!$
!!$       x = b
!!$       call tridig(d,p,s,x)
!!$       flam(2:n-1) = x
!!$
!!$       ! more accurate estimate of points on edges
!!$       hh = h12*lw(1)**3*a**2/(leff(3)-leff(1))
!!$       p(1) = hh*(flam(3) - flam(2))/(leff(3) - leff(2))
!!$       s(1) = hh*flam(2)/(leff(2) - leff(1))
!!$       flam(1) = (w(1)*flux(1) - p(1) + s(1))/((h0 + 2*h12)*lw(1)+hh/(leff(2) - leff(1)))
!!$
!!$       hh = h12*lw(n)**3*a**2/(leff(n-2)-leff(n))
!!$       p(1) = hh*(flam(n-2) - flam(n-1))/(leff(n-2) - leff(n-1))
!!$       s(1) = hh*flam(n-1)/(leff(n-1) - leff(n))
!!$       flam(n) = (w(n)*flux(n) - p(1) + s(1))/((h0 + 2*h12)*lw(n)+hh/(leff(n-1)-leff(n)))
!!$
!!$    end do


  end subroutine flux2flam

  subroutine flam2flux(leff,lw,flam,flux)

    ! flam deconvolution from flux

    real(dbl), dimension(:), intent(in) :: leff,lw,flam
    real(dbl), dimension(:), intent(out) :: flux

    real(dbl), dimension(size(flam)) :: w
    real(dbl) :: hh,ww,dd,u1,u2,df,df1,t
    integer :: i,n

    w = (/0.572981,0.683449,0.76545,0.645865,0.634657/)
    w = 1

    n = size(flux)

    do i = 2,n-1
       ww = h0 + 2*h12*(1 + (lw(i)*a)**2/(leff(i)-leff(i-1))/(leff(i)-leff(i+1)))
       dd = 2*h12*lw(i)**3*a**2
       u1 = dd/(leff(i-1)-leff(i))/(leff(i-1)-leff(i+1))
       u2 = dd/(leff(i+1)-leff(i))/(leff(i+1)-leff(i-1))
       flux(i) = ww*lw(i)*flam(i) + u1*flam(i-1) + u2*flam(i+1)
    end do

    hh = h0 + 2*h12
    i = 1
    t = (lw(i)*a)**2
    df = (flam(i+1) - flam(i)) / (leff(i+1) - leff(i))
    df1 = (flam(i+2) - flam(i+1)) / (leff(i+2) - leff(i+1))
    flux(i) = hh*flam(i)*lw(i) - h12*t*lw(i)/(leff(i+2) - leff(i))*(df - df1)

    i = n
    t = (lw(i)*a)**2
    df = (flam(i-1) - flam(i)) / (leff(i-1) - leff(i))
    df1 = (flam(i-2) - flam(i-1)) / (leff(i-2) - leff(i-1))
    flux(i) = hh*flam(i)*lw(i) - h12*t*lw(i)/(leff(i-2) - leff(i))*(df - df1)

    flux = flux / w

!!$    do i = 2,n-1
!!$       ww = h0 + 2*h12*(1 + (lw(i)*a)**2/(leff(i)-leff(i-1))/(leff(i)-leff(i+1)))
!!$       dd = 2*h12*lw(i)**3*a**2
!!$       u1 = dd/(leff(i-1)-leff(i))/(leff(i-1)-leff(i+1))
!!$       u2 = dd/(leff(i+1)-leff(i))/(leff(i+1)-leff(i-1))
!!$       flux(i) = ww*lw(i)*flam(i) + u1*flam(i-1) + u2*flam(i+1)
!!$    end do
!!$
!!$    hh = h0 + 2*h12
!!$    i = 1
!!$    t = (lw(i)*a)**2
!!$    df = (flam(i+1) - flam(i)) / (leff(i+1) - leff(i))
!!$    df1 = (flam(i+2) - flam(i+1)) / (leff(i+2) - leff(i+1))
!!$    flux(i) = hh*flam(i)*lw(i) + h12*t*lw(i)/(leff(i+2) - leff(i))*(df - df1)
!!$
!!$    i = n
!!$    t = (lw(i)*a)**2
!!$    df = (flam(i-1) - flam(i)) / (leff(i-1) - leff(i))
!!$    df1 = (flam(i-2) - flam(i-1)) / (leff(i-2) - leff(i-1))
!!$    flux(i) = hh*flam(i)*lw(i) + h12*t*lw(i)/(leff(i-2) - leff(i))*(df - df1)
!!$
!!$    flux = flux / w


  end subroutine flam2flux

  subroutine ph2flam(leff,lw,ph,flam)

    ! flam deconvolution from photons

    real(dbl), dimension(:), intent(in) :: leff,lw,ph
    real(dbl), dimension(:), intent(out) :: flam

    real(dbl), dimension(size(ph)) :: w,wplux
    real(dbl), dimension(size(ph)-2) :: b,d,s,p,x
    real(dbl) :: hh,ww,dd,u,df1,t,t2,uu,u0,u1,u2
    integer :: i,j,n,m,iter

    w = (/0.572981,0.683449,0.76545,0.645865,0.634657/)

    w = 1
    n = size(ph)
    m = n - 2


    wplux = w * ph

    ! initial estimate of flux density (used 1-th and n-th points)
    flam = hc*wplux/lw/sqrtpi/leff

!    write(*,*) real(flam)

    do iter = 1,2

       b = wplux(2:n-1)
       p(1) = 0
       s(m) = 0

       do i = 2,n-1

          j = i - 1

          t2 = (lw(i)*a)**2
          u1 = 2*t2*(2*leff(i) - leff(i+1))/(leff(i-1)-leff(i))/(leff(i-1)-leff(i+1))
          u2 = 2*t2*(2*leff(i) - leff(i-1))/(leff(i+1)-leff(i-1))/(leff(i+1)-leff(i))
          uu = leff(i)**2 + leff(i+1)*leff(i-1) - leff(i)*(leff(i+1)+leff(i-1)) + t2
          u0 = 2*leff(i)*uu - 2*t2*(2*leff(i)-(leff(i+1)+leff(i-1)))
          u0 = u0 / (leff(i)-leff(i-1))/(leff(i)-leff(i+1))

!          write(*,*) u0,u1,u2

          uu = lw(i) / hc
          d(j) = uu * (h0*leff(i) + h12*u0)
          if( j > 1 ) p(j) = h12 * u1 * uu
          if( j < m ) s(j) = h12 * u2 * uu
          if( j == 1 ) b(j) = b(j) - flam(i-1)*u1* uu * h12
          if( j == m ) b(j) = b(j) - flam(i+1)*u2* uu * h12

!          write(*,*) d(j),p(j),s(j)

       end do

!       write(*,*) real(d)
!       write(*,*) real(p)
!       write(*,*) real(s)
!       write(*,*) real(b)

       x = b
       call tridig(d,p,s,x)
       flam(2:n-1) = x

!       write(*,*) real(flam)

       hh = h0 + 2*h12
       i = 1
       t = (a*lw(i))**2
       df1 = (flam(i+2) - flam(i+1)) / (leff(i+2) - leff(i+1))
       u = 1 - leff(i)/(leff(i+2) - leff(i))
       ww = hh*leff(i) - h12*t*u/(leff(i+1) - leff(i))
       dd = h12*t*u/(leff(i+1) - leff(i))*flam(i+1) + &
            h12*t*leff(i)/(leff(i+2) - leff(i))*df1
       flam(i) = (wplux(i)*hc/lw(i) - dd)/ww

       i = n
       t = (a*lw(i))**2
       df1 = (flam(i-2) - flam(i-1)) / (leff(i-2) - leff(i-1))
       u = 1 - leff(i)/(leff(i-2) - leff(i))
       ww = hh*leff(i) - h12*t*u/(leff(i-1) - leff(i))
       dd = h12*t*u/(leff(i-1) - leff(i))*flam(i-1) + &
            h12*t*leff(i)/(leff(i-2) - leff(i))*df1
       flam(i) = (wplux(i)*hc/lw(i) - dd)/ww

!       write(*,*) real(flam)

!       stop

    end do



!!$    ! initial estimate of flux density, flam (used 1-th and n-th points)
!!$    flam = hc*ph/lw/sqrtpi/leff * w
!!$!    flam(2:n-1) = hc*plux(2:n-1)/lw(2:n-1)/sqrtpi/leff(2:n-1) * w(2:n-1)
!!$!    flam(1) = 1.61426515E-12
!!$!    flam(n) = 7.64483623E-14
!!$
!!$    write(*,*) real(leff)
!!$    write(*,*) real(lw)
!!$    write(*,*) real(flam)
!!$
!!$    do iter = 1,2
!!$
!!$       b = w(2:n-1) * ph(2:n-1) !?
!!$!       b = ph(2:n-1)
!!$       p(1) = 0
!!$       s(m) = 0
!!$
!!$       do i = 2,n-1
!!$
!!$          j = i - 1
!!$          t = lw(i)*a
!!$          u = (leff(i) - leff(i-1))*(leff(i+1) - leff(i))
!!$          write(*,*) u,leff(i) - leff(i-1),leff(i+1) - leff(i)
!!$          d(j) = h0*leff(i) + 2*h12*leff(i)*(1-t**2/u) &
!!$               + 2*h12*t*(leff(i+1) + leff(i-1) - 2*leff(i))/u
!!$          d(j) = d(j)*lw(i) / hc
!!$
!!$          write(*,*) h0*leff(i),h12*leff(i)*(1-t**2/u),2*h12*t*(leff(i+1) + leff(i-1) - 2*leff(i))/u,u
!!$
!!$          hh = 2*h12*lw(i)**3*a**2/(leff(i+1)-leff(i-1))
!!$          u1 = hh*(2*leff(i)-leff(i+1))/(leff(i) - leff(i-1))
!!$          u2 = hh*(2*leff(i)-leff(i-1))/(leff(i+1) - leff(i))
!!$          if( j > 1 ) p(j) = u1 / hc
!!$          if( j < m ) s(j) = u2 / hc
!!$          if( j == 1 ) b(j) = b(j) - flam(i-1)*u1 / hc / w(i-1)
!!$          if( j == m ) b(j) = b(j) - flam(i+1)*u2 / hc / w(i+1)
!!$
!!$          write(*,*) d(j),p(j),s(j)
!!$
!!$       end do
!!$
!!$!       write(*,*) real(d)
!!$!       write(*,*) real(p)
!!$!       write(*,*) real(s)
!!$!       write(*,*) real(b)
!!$
!!$       x = b
!!$       call tridig(d,p,s,x)
!!$       flam(2:n-1) = x
!!$
!!$       write(*,*) real(flam)
!!$
!!$       hh = h0 + 2*h12
!!$       i = 1
!!$       t = (a*lw(i))**2
!!$       df1 = (flam(i+2) - flam(i+1)) / (leff(i+2) - leff(i+1))
!!$       u = 1 - leff(i)/(leff(i+2) - leff(i))
!!$       ww = hh*leff(i) - h12*t*u/(leff(i+1) - leff(i))
!!$       dd = h12*t*u/(leff(i+1) - leff(i))*flam(i+1) + &
!!$            h12*t*leff(i)/(leff(i+2) - leff(i))*df1
!!$       flam(i) = (ph(i)*hc/lw(i) - dd)/ww
!!$
!!$       i = n
!!$       t = (a*lw(i))**2
!!$       df1 = (flam(i-2) - flam(i-1)) / (leff(i-2) - leff(i-1))
!!$       u = 1 - leff(i)/(leff(i-2) - leff(i))
!!$       ww = hh*leff(i) - h12*t*u/(leff(i-1) - leff(i))
!!$       dd = h12*t*u/(leff(i-1) - leff(i))*flam(i-1) + &
!!$            h12*t*leff(i)/(leff(i-2) - leff(i))*df1
!!$       flam(i) = (ph(i)*hc/lw(i) - dd)/ww
!!$
!!$       write(*,*) real(flam)
!!$
!!$!       stop
!!$
!!$    end do

  end subroutine ph2flam


  subroutine flam2plux(leff,lw,flam,plux3)

    ! photon flux from flam

    real(dbl), dimension(:), intent(in) :: leff,lw,flam
    real(dbl), dimension(:), intent(out) :: plux3

    real(dbl), dimension(size(flam)) :: w

    real(dbl) :: hh,df,df1,t,t2,uu,u0,u1,u2
    integer :: i,n

    w = 1
    w = (/0.572981,0.683449,0.76545,0.645865,0.634657/)
    n = size(flam)

    do i = 2,n-1

       t2 = (lw(i)*a)**2
       u1 = 2*t2*(2*leff(i) - leff(i+1))/(leff(i-1)-leff(i))/(leff(i-1)-leff(i+1))
       u2 = 2*t2*(2*leff(i) - leff(i-1))/(leff(i+1)-leff(i-1))/(leff(i+1)-leff(i))
       uu = leff(i)**2 + leff(i+1)*leff(i-1) - leff(i)*(leff(i+1)+leff(i-1)) + t2
       u0 = 2*leff(i)*uu - 2*t2*(2*leff(i)-(leff(i+1)+leff(i-1)))
       u0 = u0 / (leff(i)-leff(i-1))/(leff(i)-leff(i+1))

       plux3(i) = lw(i)*((h0*leff(i) + h12*u0)*flam(i)+h12*(u1*flam(i-1)+u2*flam(i+1)))

    end do

    i = 1
    hh = h0 + 2*h12
    t = (a*lw(i))**2
    df = (flam(i+1) - flam(i)) / (leff(i+1) - leff(i))
    df1 = (flam(i+2) - flam(i)) / (leff(i+2) - leff(i+1))
    plux3(i) = lw(i)*(hh*leff(i)*flam(i) + h12*df*t + &
         h12*t*leff(i)/(leff(i+2) - leff(i))*(df1 - df))

    i = n
    t = (a*lw(i))**2
    df = (flam(i-1) - flam(i)) / (leff(i-1) - leff(i))
    df1 = (flam(i-2) - flam(i)) / (leff(i-2) - leff(i-1))
    plux3(i) = lw(i)*(hh*leff(i)*flam(i) + h12*df*t + &
         h12*t*leff(i)/(leff(i-2) - leff(i))*(df1 - df))

    plux3 = plux3 / hc / w


!!$
!!$    do i = 2,n-1
!!$       plux3(i) = (h0*leff(i) &
!!$            + 2*h12*(1-(lw(i)*a)**2/(leff(i) - leff(i-1))/(leff(i+1) - leff(i)))*leff(i) &
!!$            + 2*h12*lw(i)*(leff(i+1) + leff(i-1) - 2*leff(i))/(leff(i) - leff(i-1))/(leff(i+1) - leff(i)) )*flam(i)*lw(i) + &
!!$            2*h12*lw(i)**3*a**2/(leff(i+1)-leff(i-1))* &
!!$            (flam(i-1)*(2*leff(i) - leff(i+1))/(leff(i) - leff(i-1)) + flam(i+1)*(2*leff(i) - leff(i-1))/(leff(i+1) - leff(i)))
!!$    end do
!!$
!!$    dd = lw(1)*a
!!$    df = (flam(2) - flam(1)) / (leff(2) - leff(1))
!!$    df1 = (flam(3) - flam(2)) / (leff(3) - leff(2))
!!$    hh = h12*lw(1)**3*a**2/(leff(3)-leff(1))
!!$    plux3(1) = lw(1)*(h0*flam(1)*leff(1) + &
!!$         h12*(leff(1)*(2*flam(1) + (df1 - df)*dd**2/(leff(3)-leff(1))) +&
!!$         2*df*dd**2))
!!$
!!$    dd = lw(n)*a
!!$    df = (flam(n-1) - flam(n)) / (leff(n-1) - leff(n))
!!$    df1 = (flam(n-2) - flam(n-1)) / (leff(n-2) - leff(n-1))
!!$    hh = h12*lw(n)**3*a**2/(leff(n-2)-leff(n))
!!$    plux3(n) = lw(n)*(h0*flam(n)*leff(n) + &
!!$         h12*(leff(n)*(2*flam(n) + (df1 - df)*dd**2/(leff(n-2)-leff(n))) +&
!!$         2*df*dd**2))
!!$
!!$    plux3 = plux3 / hc / w * 1d-18 ! due flam [W/m2/nm]
!!$


!!$    do i = 2,n-1
!!$
!!$       plux3(i) = (h0*leff(i) &
!!$            + 2*h12*(1-(lw(i)*a)**2/(leff(i) - leff(i-1))/(leff(i+1) - leff(i)))*leff(i) &
!!$            + 2*h12*lw(i)*a*(leff(i+1) + leff(i-1) - 2*leff(i))/(leff(i) - leff(i-1))/(leff(i+1) - leff(i)) )*flam(i)*lw(i) + &
!!$            2*h12*lw(i)**3*a**2/(leff(i+1)-leff(i-1))* &
!!$            (flam(i-1)*(2*leff(i) - leff(i+1))/(leff(i) - leff(i-1)) + flam(i+1)*(2*leff(i) - leff(i-1))/(leff(i+1) - leff(i)))
!!$    end do
!!$
!!$    i = 1
!!$    hh = h0 + 2*h12
!!$    t = (a*lw(i))**2
!!$    df = (flam(i+1) - flam(i)) / (leff(i+1) - leff(i))
!!$    df1 = (flam(i+2) - flam(i)) / (leff(i+2) - leff(i+1))
!!$    plux3(i) = lw(i)*(hh*leff(i)*flam(i) + h12*df*t + &
!!$         h12*t*leff(i)/(leff(i+2) - leff(i))*(df1 - df))
!!$
!!$    i = n
!!$    t = (a*lw(i))**2
!!$    df = (flam(i-1) - flam(i)) / (leff(i-1) - leff(i))
!!$    df1 = (flam(i-2) - flam(2)) / (leff(i-2) - leff(i-1))
!!$    plux3(i) = lw(i)*(hh*leff(i)*flam(i) + h12*df*t + &
!!$         h12*t*leff(i)/(leff(i-2) - leff(i))*(df1 - df))
!!$    plux3 = plux3 / hc / w
!!$

  end subroutine flam2plux


  subroutine mag2ph0(leff,lfwhm,flamref,mag,dmag,ph,dph)

    ! magnitudes to photon flux in a passband [ph/s/m2]
    ! 0-th order Gauss-Hermite integration

    real(dbl), intent(in) :: leff,lfwhm,flamref
    real(dbl), dimension(:), intent(in) :: mag,dmag
    real(dbl), dimension(:), intent(out) :: ph,dph
    real(dbl) :: ph0

    ph0 = 1e9 * sqrtpi2 * flamref * lfwhm *  leff / hc

    where( mag < 99 )
       ph = ph0 * 10.0_dbl**(-0.4_dbl*mag)
    elsewhere
       ph = -1
    end where

    where( dmag < 9 .and. ph > 0 )
       dph = ph * dmag / 1.0857
!    elsewhere( dmag >= 9 .and. mag < 99 )
!       dph = sqrt(ph)
    elsewhere
       dph = -1
    end where

  end subroutine mag2ph0

  subroutine ph2mag0(leff,lfwhm,flamref,ph,dph,mag,dmag)

    ! photons [ph/s/m2] to flux [W/m2] (and to magnitudes)

    real(dbl), intent(in) :: flamref,leff,lfwhm
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: mag,dmag
    real(dbl) :: ph0

    ph0 = 1e9 * sqrtpi2 * flamref * lfwhm * leff / hc

    where( ph > 0.0_dbl )
       mag = -2.5_dbl*log10(ph / ph0)
    elsewhere
       mag = 99.99999_dbl
    end where

    where( dph > 0 .and. ph > 0.0_dbl )
       dmag = 1.086_dbl*dph/ph
    elsewhere
       dmag = 9.99999_dbl
    end where

  end subroutine ph2mag0

  subroutine flux2mag0(lfwhm,flamref,flux,dflux,mag,dmag)

    ! flux [W/m2] to magnitudes

    real(dbl), intent(in) :: flamref,lfwhm
    real(dbl), dimension(:), intent(in) :: flux,dflux
    real(dbl), dimension(:), intent(out) :: mag,dmag
    real(dbl) :: f0

    f0 = sqrtpi2 * lfwhm * flamref * 1e9

    where( flux > 0.0_dbl )
       mag = -2.5_dbl*log10(flux / f0)
       dmag = 1.086_dbl*dflux/flux
    elsewhere
       mag = 99.99999_dbl
       dmag = 9.99999_dbl
    end where

  end subroutine

!!$  subroutine mag2pht0(leff,lwidth,zeroflux,exptime,area,mag,dmag,ph,dph)
!!$
!!$    ! magnitudes to photon flux in a passband on area and time [ph]
!!$
!!$    real(dbl), dimension(:), intent(in) :: leff,lwidth,zeroflux,exptime,area
!!$    real(dbl), dimension(:), intent(in) :: mag,dmag
!!$    real(dbl), dimension(:), intent(out) :: ph,dph
!!$    real(dbl), dimension(size(mag)) :: c
!!$
!!$    call mag2ph(leff,lwidth,zeroflux,mag,dmag,ph,dph)
!!$
!!$    c = exptime * area
!!$    ph = c * ph
!!$    dph = c *dph
!!$
!!$  end subroutine mag2pht0


  subroutine ph2mag(leff,lfwhm,flamref,ph,dph,mag,dmag)

    ! photons [ph/s/m2] to flux [W/m2] (and to magnitudes)

    real(dbl), dimension(:), intent(in) :: flamref,leff,lfwhm
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: mag,dmag

    real(dbl), dimension(size(mag)) :: flux,lw
    real(dbl) :: u,v,det
    integer :: i

    if( size(ph) == 1 ) then

       flux = hc / leff * ph
       mag = -2.5_dbl * log10(flux / flamref)

    else

       lw = lfwhm / 2

       u = a**2/2/(leff(2) - leff(1))
       det = 1 - u*(lw(2)**2/leff(2) + lw(1)**2/leff(1))
       det = 1
       v = 1 + u*lw(2)**2/leff(2)*(1-(leff(1)/leff(2))**3*(ph(2)/ph(1)))
       flux(1) = ph(1)*v/leff(1)/det

       do i = 2,size(ph)

          u = a**2/2/(leff(i) - leff(i-1))
          det = 1 - u*(lw(i)**2/leff(i) + lw(i-1)**2/leff(i-1))
          det = 1
          v = 1 + u*lw(i)**2/leff(i)*(1-(leff(i-1)/leff(i))**3*(ph(i-1)/ph(1)))
          flux(i) = ph(i)*v/leff(i)/det

       end do

       flux = hc * flux
       mag = -2.5_dbl * log10(flux / flamref)
       dmag = 1.086 * (dph/ph) * mag

    end if

  end subroutine ph2mag

  subroutine mag2rate(mag,dmag,r,dr)

    ! relative rates from magnitudes

    real(dbl), dimension(:), intent(in) :: mag,dmag
    real(dbl), dimension(:), intent(out) :: r,dr

    r = flux25*10.0_dbl**(-0.4_dbl*mag)
    dr = dmag*r/1.0857

  end subroutine mag2rate

  subroutine x2mag(f0,flux,dflux,mag,dmag)

    ! (relative) flux (or anythink) to magnitudes

    real(dbl), intent(in) :: f0
    real(dbl), dimension(:), intent(in) :: flux,dflux
    real(dbl), dimension(:), intent(out) :: mag,dmag

    where( flux > 0.0_dbl .and. f0 > 0.0_dbl )
       mag = -2.5_dbl*log10(flux/f0)
       dmag = 1.0857*dflux/flux
    elsewhere
       mag = 99.99999_dbl
       dmag = 9.99999_dbl
    end where

  end subroutine x2mag

  subroutine fnu2abmag(fnu,dfnu,mag,dmag)

    ! fnu to AB-magnitudes

    real(dbl), dimension(:), intent(in) :: fnu,dfnu
    real(dbl), dimension(:), intent(out) :: mag,dmag

    where( fnu > 0.0_dbl )
       mag = -2.5_dbl*log10(fnu/ABspflux)
       dmag = 1.0857*dfnu/fnu
    elsewhere
       mag = 99.99999_dbl
       dmag = 9.99999_dbl
    end where

  end subroutine fnu2abmag

  subroutine flam2stmag(flam,dflam,mag,dmag)

    ! flam to ST-magnitudes

    real(dbl), dimension(:), intent(in) :: flam,dflam
    real(dbl), dimension(:), intent(out) :: mag,dmag

    where( flam > 0.0_dbl )
       mag = -2.5_dbl*log10(flam/STspflux)
       dmag = 1.0857*dflam/flam
    elsewhere
       mag = 99.99999_dbl
       dmag = 9.99999_dbl
    end where

  end subroutine flam2stmag

  subroutine ph2abmag(feff,ffwhm,ph,dph,mag,dmag)

    ! photons to AB-magnitudes

    real(dbl), intent(in) :: feff, ffwhm
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: mag,dmag
    real(dbl) :: f

    f = planck * (feff / ffwhm) / ABspflux

    where( ph > 0.0_dbl )
       mag = -2.5_dbl*log10(f*ph)
       dmag = 1.0857*dph/ph
    elsewhere
       mag = 99.99999_dbl
       dmag = 9.99999_dbl
    end where

  end subroutine ph2abmag

  subroutine ph2stmag(leff,lfwhm,ph,dph,mag,dmag)

    ! photons to ST-magnitudes

    real(dbl), intent(in) :: leff, lfwhm
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: mag,dmag
    real(dbl) :: f

    f =  (planck / 1e-9) * (leff / lfwhm) / STspflux

    where( ph > 0.0_dbl )
       mag = -2.5_dbl*log10(f*ph)
       dmag = 1.0857*dph/ph
    elsewhere
       mag = 99.99999_dbl
       dmag = 9.99999_dbl
    end where

  end subroutine ph2stmag

  subroutine hstparam(lam_eff,lam_fwhm,photflam,photzpt,photplam,photbw)

    real(dbl), intent(in) :: lam_eff, lam_fwhm
    real(dbl), intent(out) :: photflam,photzpt,photplam,photbw

    ! unit erg/.. <-> J/.. conversion
    photflam = 1e6 * STspflux * (planck*c) / lam_eff**2
    ! the aperture correction 0.1 has been ommited
    photzpt = -21.0
    photplam = lam_eff / 1e-10
    photbw = lam_fwhm / 1e-10

  end subroutine hstparam


  ! solution of tri-diagonal system of linear equations
  subroutine tridig(d,p,s,b)

    real(dbl), dimension(:), intent(in out) :: d,p,s,b
    real(dbl) :: r
    integer :: i,k,n

    n = size(d)

    do i = 2,n
       r = p(i) / d(i-1)
       d(i) = d(i) - r* s(i-1)
       b(i) = b(i) - r* b(i-1)
    end do

    b(n) = b(n) / d(n)
    do i = 1,n-1
       k = n - i
       b(k) = (b(k) -s(k)*b(k+1)) / d(k)
    end do

  end subroutine tridig

end module photoconv

      subroutine covar(n,r,ldr,ipvt,tol,wa)
      integer n,ldr
      integer ipvt(n)
      double precision tol
      double precision r(ldr,n),wa(n)
c     **********
c
c     subroutine covar
c
c     given an m by n matrix a, the problem is to determine
c     the covariance matrix corresponding to a, defined as
c
c                    t
c           inverse(a *a) .
c
c     this subroutine completes the solution of the problem
c     if it is provided with the necessary information from the
c     qr factorization, with column pivoting, of a. that is, if
c     a*p = q*r, where p is a permutation matrix, q has orthogonal
c     columns, and r is an upper triangular matrix with diagonal
c     elements of nonincreasing magnitude, then covar expects
c     the full upper triangle of r and the permutation matrix p.
c     the covariance matrix is then computed as
c
c                      t     t
c           p*inverse(r *r)*p  .
c
c     if a is nearly rank deficient, it may be desirable to compute
c     the covariance matrix corresponding to the linearly independent
c     columns of a. to define the numerical rank of a, covar uses
c     the tolerance tol. if l is the largest integer such that
c
c           abs(r(l,l)) .gt. tol*abs(r(1,1)) ,
c
c     then covar computes the covariance matrix corresponding to
c     the first l columns of r. for k greater than l, column
c     and row ipvt(k) of the covariance matrix are set to zero.
c
c     the subroutine statement is
c
c       subroutine covar(n,r,ldr,ipvt,tol,wa)
c
c     where
c
c       n is a positive integer input variable set to the order of r.
c
c       r is an n by n array. on input the full upper triangle must
c         contain the full upper triangle of the matrix r. on output
c         r contains the square symmetric covariance matrix.
c
c       ldr is a positive integer input variable not less than n
c         which specifies the leading dimension of the array r.
c
c       ipvt is an integer input array of length n which defines the
c         permutation matrix p such that a*p = q*r. column j of p
c         is column ipvt(j) of the identity matrix.
c
c       tol is a nonnegative input variable used to define the
c         numerical rank of a in the manner described above.
c
c       wa is a work array of length n.
c
c     subprograms called
c
c       fortran-supplied ... dabs
c
c     argonne national laboratory. minpack project. august 1980.
c     burton s. garbow, kenneth e. hillstrom, jorge j. more
c
c     **********
      integer i,ii,j,jj,k,km1,l
      logical sing
      double precision one,temp,tolr,zero
      data one,zero /1.0d0,0.0d0/
c
c     form the inverse of r in the full upper triangle of r.
c
      tolr = tol*dabs(r(1,1))
      l = 0
      do 40 k = 1, n
         if (dabs(r(k,k)) .le. tolr) go to 50
         r(k,k) = one/r(k,k)
         km1 = k - 1
         if (km1 .lt. 1) go to 30
         do 20 j = 1, km1
            temp = r(k,k)*r(j,k)
            r(j,k) = zero
            do 10 i = 1, j
               r(i,k) = r(i,k) - temp*r(i,j)
   10          continue
   20       continue
   30    continue
         l = k
   40    continue
   50 continue
c
c     form the full upper triangle of the inverse of (r transpose)*r
c     in the full upper triangle of r.
c
      if (l .lt. 1) go to 110
      do 100 k = 1, l
         km1 = k - 1
         if (km1 .lt. 1) go to 80
         do 70 j = 1, km1
            temp = r(j,k)
            do 60 i = 1, j
               r(i,j) = r(i,j) + temp*r(i,k)
   60          continue
   70       continue
   80    continue
         temp = r(k,k)
         do 90 i = 1, k
            r(i,k) = temp*r(i,k)
   90       continue
  100    continue
  110 continue
c
c     form the full lower triangle of the covariance matrix
c     in the strict lower triangle of r and in wa.
c
      do 130 j = 1, n
         jj = ipvt(j)
         sing = j .gt. l
         do 120 i = 1, j
            if (sing) r(i,j) = zero
            ii = ipvt(i)
            if (ii .gt. jj) r(ii,jj) = r(i,j)
            if (ii .lt. jj) r(jj,ii) = r(i,j)
  120       continue
         wa(jj) = r(j,j)
  130    continue
c
c     symmetrize the covariance matrix in r.
c
      do 150 j = 1, n
         do 140 i = 1, j
            r(i,j) = r(j,i)
  140       continue
         r(j,j) = wa(j)
  150    continue
      return
c
c     last card of subroutine covar.
c
      end

!
!  FITS I/O for photometric calibration
!
!  Copyright © 2012-6, 2020-2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

module mfits

  use iso_fortran_env
  use titsio

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl
  real(dbl), parameter, private :: pi = 3.14159265359_dbl
  logical, private :: verbose = .true.


contains


  subroutine readcat(cat,labels,label_mag,label_magerr, &
       alpha,delta,mag,magerr,catid,status)

    character(len=*), intent(in) :: cat
    character(len=*), dimension(:), intent(in) :: labels,label_mag,label_magerr
    real(dbl), dimension(:), allocatable, intent(out) :: alpha,delta
    real(dbl), dimension(:,:), allocatable, intent(out) :: mag,magerr
    character(len=*), intent(out) :: catid
    integer, intent(out) :: status

    real(dbl), parameter :: nullcoo = -999
    real(dbl), parameter :: nullmag = 99.99999
    real(dbl), parameter :: dullmag = 9.99999

    integer :: nrows, srows, ncols, i, k, l, frow
    integer, dimension(size(labels)) :: cols
    integer, dimension(size(label_mag)) :: col_mag
    integer, dimension(size(label_magerr)) :: col_magerr
    type(fitsfiles) :: fits
    logical :: anyf


    status = 0

    ! open and move to a table extension
    call fits_open_table(fits,cat,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read a table in the file `',trim(cat),"'."
       return
    end if

    call fits_get_num_rows(fits,nrows,status)
    if( status /= 0 ) goto 666
    if( .not. (nrows > 0) ) then
       write(error_unit,*) 'Error: an empty table in the file `',trim(cat),"'."
       goto 666
    end if

    ! define reference frame and identification of catalogue
    call fits_read_key(fits,'EXTNAME',catid,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       catid = ''
       status = 0
    end if

    ! find columns by labels
    do i = 1, size(labels)
       call fits_get_colnum(fits,.true.,labels(i),cols(i),status)
    end do
    do i = 1, size(label_mag)
       call fits_get_colnum(fits,.true.,label_mag(i),col_mag(i),status)
    end do
    do i = 1, size(label_magerr)
       call fits_get_colnum(fits,.true.,label_magerr(i),col_magerr(i),status)
    end do
    if( status /= 0 ) goto 666

    ncols = size(label_mag)
    allocate(alpha(nrows),delta(nrows),mag(nrows,ncols),magerr(nrows,ncols))

    magerr = 9.99999

    call fits_get_rowsize(fits,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_read_col(fits,cols(1),frow,nullcoo,alpha(i:l),anyf,status)
       call fits_read_col(fits,cols(2),frow,nullcoo,delta(i:l),anyf,status)

       do k = 1, size(col_mag)
          call fits_read_col(fits,col_mag(k),frow,nullmag,mag(i:l,k),anyf,status)
       end do
       do k = 1, size(col_magerr)
          call fits_read_col(fits,col_magerr(k),frow,dullmag,magerr(i:l,k),anyf,status)
       end do
       if( status /= 0 ) goto 666
    end do


    call fits_close_file(fits,status)
    return

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    if( allocated(mag) ) deallocate(mag,magerr,alpha,delta)

  end subroutine readcat


  subroutine readframe(filename,keys,threshold,maxerr,alpha,delta,cts,dcts, &
       ftol,exptime,area,photosys,filter,init_area,saper,aper,status,&
       amass)

    use astrotrafo
    use astrosphere
    use trajd
    use phio

    character(len=*), intent(in) :: filename
    character(len=*), dimension(:), intent(in) :: keys
    real(dbl), intent(in) :: threshold, maxerr
    real(dbl), dimension(:), allocatable, intent(out) :: alpha,delta,cts,dcts
    real(dbl), intent(out) :: ftol,exptime, area
    character(len=*), intent(out) :: photosys,filter
    logical, intent(in) :: init_area
    integer, intent(in) :: saper
    real(dbl), intent(out) :: aper
    integer, intent(out) :: status
    real(dbl), optional, intent(out) :: amass

    integer, parameter :: DIM = 2
    integer, dimension(DIM) :: naxes
    integer :: naxis, nrows, srows, naper, maper, s1, s2, s4, s5, i, j, l, nid, frow
    real(dbl) :: jd, longitude, latitude, spot
    character(len=FLEN_CARD) :: key, keycts, keyerr
    real(dbl), dimension(:), allocatable :: x,y,sky,ct,dct
    integer, dimension(:), allocatable :: id
    integer, dimension(5) :: colnum
    character(len=FLEN_VALUE) :: dateobs
    real(dbl) :: nullval
    real :: hwhm
    logical :: anyf
    logical :: undef_airmass, have_grow, have_ap
    type(AstroTrafoProj) :: tproj
    type(fitsfiles) :: fits


    ! input FITS file
    status = 0
    call fits_open_image(fits,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read an image in the file `',trim(filename),"'."
       return
    end if

    call fits_get_img_dim(fits,naxis,status)
    call fits_get_img_size(fits,DIM,naxes,status)
    if( status /= 0 ) goto 666

    ! read astrometric calibration
    call wcsget(fits,tproj,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       write(error_unit,*) 'Astrometry keywords not found in header.'
       goto 666
    end if
    ftol = 5.0*tproj%err

    ! Citizen date
    call fits_get_dateobs(fits,[keys(3),keys(8)],dateobs,status)
    if( status == 0 ) then
       jd = fits_jd(dateobs,status)
    else
       write(error_unit,*) "Warning: Failed to get date or time."
       goto 666
    end if

    ! Geographic coordinates
    call fits_read_key(fits,keys(6),longitude,status)
    call fits_read_key(fits,keys(7),latitude,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       write(error_unit,*) &
            "Warning: Geographical longitude or latitude identified by FITS keywords `",&
            trim(keys(6)),"',`",trim(keys(7)),"' not found. Airmass is undefined."
       status = 0
       undef_airmass = .true.
    else
       undef_airmass = .false.
    end if

    s1 = 0
    call fits_read_key(fits,keys(1),exptime,s1)
    if( s1 == FITS_KEYWORD_NOT_FOUND ) then
       write(error_unit,*) "Warning: Exposure time identified by FITS keyword `",&
            trim(keys(1)),"' not found. Set to default 1 sec."
       exptime = 1
       s1 = 0
    end if

    s2 = 0
    if( .not. init_area ) then
       call fits_read_key(fits,keys(2),area,s2)
       if( s2 == FITS_KEYWORD_NOT_FOUND ) then
          write(error_unit,*) "Warning: Area identified by FITS keyword `", &
               trim(keys(2)),"' not found. Set to default 1 sq. meter."
          area = 1
          s2 = 0
       end if
    end if

!    s3 = 0
!    if( present(airmass) ) then
!       call ftgkyd(20,keys(3),airmass,com,s3)
!       if( s3 == KEYWORD_NOT_FOUND ) then
!          write(error_unit,*) "Warning: Airmass identified by FITS keyword `", &
!               trim(keys(3)),"' not found. Default is 0 (extra-atmospheric)."
!          airmass = 0
!          s3 = 0
!       end if
!    end if

    s4 = 0
    call fits_read_key(fits,keys(4),photosys,s4)
    if( s4 == FITS_KEYWORD_NOT_FOUND ) then
!       write(error_unit,*) "Photometry system by FITS keyword `", &
!            trim(keys(4)),"' not found, leaving it empty."
       photosys = ''
       s4 = 0
    end if

    s5 = 0
    call fits_read_key(fits,keys(5),filter,s5)
    if( s5 == FITS_KEYWORD_NOT_FOUND ) then
       write(error_unit,*) "Filter identified by FITS keyword `", &
            trim(keys(5)),"' not found. Set to default `' (empty)."
       filter = ''
       s5 = 0
    end if

    status = s1 + s2 + s4 + s5
    if( status /= 0 ) goto 666

    ! Julian date at midpoint of exposure
    jd = jd + exptime / 2.0_dbl / 86400.0_dbl

    if( present(amass) ) then
       if( .not. undef_airmass ) then
          ! airmass at the time
          amass = xairmass(jd,longitude,latitude,tproj%acen,tproj%dcen)
       else
          amass = -1
       end if
    end if

    ! detect all possible photometry tables
!    phexts(1) = APEREXTNAME
!    phexts(2) = GROWEXTNAME
!    have_phext = .false.
!    do i = 1,size(phexts)
!       call ftmnhd(20,BINARY_TBL,phexts(i),0,status)
!       if( status == 0 ) have_phext(i) = .true.
!       if( status == BAD_HDU_NUM ) status = 0
!       if( status /= 0 ) goto 666
!    end do



    ! try to select grow-curve photometry table
    call fits_movnam_hdu(fits,FITS_BINARY_TBL,GROWEXTNAME,0,status)
    have_grow = .not. (status == FITS_BAD_HDU_NUM)

    ! try to select the aperture photometry extension
    if( .not. have_grow ) then
       status = 0
       call fits_movnam_hdu(fits,FITS_BINARY_TBL,APEREXTNAME,0,status)
       have_ap = .not. (status == FITS_BAD_HDU_NUM)
    else
       have_ap = .true.
    end if

    if( .not. (have_grow .or. have_ap) )then
       write(error_unit,*) &
            "Error: Failed to find an aperture or a growth photometry extension: ", &
            trim(filename)
       goto 666
    end if

    ! key for HWHM is presented in all photometry extensions
    ! (methods for their estimates are different)
    call fits_read_key(fits,FITS_KEY_HWHM,hwhm,status)
    ftol = hwhm * tproj%scale

    keycts = ''
    keyerr = ''

    if( have_grow .and. saper == 0 ) then
       keycts = FITS_COL_GCOUNT
       keyerr = FITS_COL_GCOUNTERR
       call fits_read_key(fits,FITS_KEY_RF90,aper,status)
    end if

    if( (.not. have_grow .and. have_ap) .or. (have_ap .and. saper > 0) ) then

       call fits_movnam_hdu(fits,FITS_BINARY_TBL,APEREXTNAME,0,status)

       if( saper > 0 ) then
          maper = saper
          call fits_make_keyn(FITS_KEY_APER,maper,key,status)
          call fits_read_key(fits,key,aper,status)
       else
          call fits_read_key(fits,FITS_KEY_NAPER,naper,status)
          do i = 1, naper
             call fits_make_keyn(FITS_KEY_APER,i,key,status)
             call fits_read_key(fits,key,aper,status)
             if( aper > 2*hwhm ) then
                maper = i
                exit
             end if
          end do
       end if

       write(keycts,'(a,i0)') FITS_COL_APCOUNT,maper
       write(keyerr,'(a,i0)') FITS_COL_APCOUNTERR,maper

    end if

    call fits_get_num_rows(fits,nrows,status)
    if( status /= 0 ) goto 666

    allocate(x(nrows),y(nrows),sky(nrows),ct(nrows),dct(nrows))

    ! table
    call fits_get_colnum(fits,.true.,FITS_COL_X,colnum(1),status)
    call fits_get_colnum(fits,.true.,FITS_COL_Y,colnum(2),status)
    call fits_get_colnum(fits,.true.,FITS_COL_SKY,colnum(3),status)
    call fits_get_colnum(fits,.true.,keycts,colnum(4),status)
    call fits_get_colnum(fits,.true.,keyerr,colnum(5),status)

    call fits_get_rowsize(fits,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_read_col(fits,colnum(1),frow,nullval,x(i:l),anyf,status)
       call fits_read_col(fits,colnum(2),frow,nullval,y(i:l),anyf,status)
       call fits_read_col(fits,colnum(3),frow,nullval,sky(i:l),anyf,status)
       call fits_read_col(fits,colnum(4),frow,nullval,ct(i:l),anyf,status)
       call fits_read_col(fits,colnum(5),frow,nullval,dct(i:l),anyf,status)
       if( status /= 0 ) goto 666
    end do

    ! select stars acceptable for photometry
    spot = pi*aper**2
    allocate(id(nrows))
    nid = 0
    do i = 1, nrows
!       write(*,'(3f20.3)') ct(i)/(sky(i) * spot)
       if(  ct(i) > 0 .and. dct(i) > 0 .and. sky(i) > 0 .and. &
            ct(i) / (sky(i) * spot) > threshold .and. &
            dct(i) / ct(i) < maxerr ) then
          nid = nid + 1
          id(nid) = i
       end if
    end do

    allocate(alpha(nid),delta(nid),cts(nid),dcts(nid))
    do i = 1, nid
       j = id(i)
       x(i) = x(j)
       y(i) = y(j)
       cts(i) = ct(j)
       dcts(i) = dct(j)
    end do
    call invtrafo(tproj,x(1:nid),y(1:nid),alpha,delta)
    deallocate(x,y,ct,dct,sky)

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

  end subroutine readframe

  subroutine checkframe(filename,keys,filter,nrows,status)

    character(len=*), intent(in) :: filename
    character(len=*), dimension(:), intent(in) :: keys
    character(len=*), intent(out) :: filter
    integer, intent(out) :: nrows
    integer, intent(in out) :: status

    type(fitsfiles) :: fits

    call fits_open_image(fits,filename,FITS_READONLY,status)
    if( status /= 0 ) return

    call fits_read_key(fits,keys(5),filter,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       write(error_unit,*) "Filter identified by FITS keyword `", &
            trim(keys(5)),"' not found. Default is `' (empty)."
       filter = ''
       status = 0
    end if

    call fits_movnam_hdu(fits,FITS_BINARY_TBL,APEREXTNAME,0,status)
    if( status == FITS_BAD_HDU_NUM ) then
       if( verbose ) write(error_unit,*) "Failed to find a photometry extension: ",&
            trim(filename)
       goto 666
    end if

    call fits_get_num_rows(fits,nrows,status)

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

  end subroutine checkframe


  subroutine readframes(filenames,keys,filters_ref,photosys,threshold, &
       maxerr,ra,dec,cts,dcts,utol,exptime,area,filter,tol,init_area, &
       saper,aper,status)

    character(len=*), dimension(:), intent(in) :: filenames,keys,filters_ref
    character(len=*), intent(out) :: photosys
    real(dbl), intent(in) :: threshold, maxerr
    real(dbl), dimension(:,:), allocatable, intent(out) :: ra,dec,cts,dcts
    real(dbl), dimension(:), allocatable, intent(out) :: exptime,area,tol
    character(len=FLEN_VALUE), dimension(:), allocatable, intent(out) :: filter
    real(dbl), intent(in) :: utol
    integer, intent(in) :: saper
    logical, intent(in) :: init_area
    real(dbl), dimension(:), allocatable, intent(out) :: aper
    integer, intent(out) :: status

    real(dbl) :: ftol
    integer :: n, nd, nfiles!, i, j
    real(dbl), dimension(:), allocatable :: qra,qdec,dn,ddn
!    integer, allocatable, dimension(:) :: ndat, order
    integer, allocatable, dimension(:) :: order
    character(len=FLEN_VALUE) :: phsys

    nfiles = size(filenames)

    call file_order(filenames,keys,filters_ref,order,nd)

!!$    allocate(filter(nfiles),ndat(nfiles),order(nfiles))
!!$
!!$    ! before loading of the (big) data, we are discovering their sizes and filters
!!$    status = 0
!!$    do n = 1, nfiles
!!$       call checkframe(filenames(n),keys,filter(n),ndat(n),status)
!!$       if( status /= 0 ) then
!!$          write(error_unit,*) "File: `",trim(filenames(n)),"'"
!!$          stop 'Failed to read a frame.'
!!$       end if
!!$    end do
!!$
!!$    ! array allocation dimension
!!$    nd = maxval(ndat)
!!$
!!$    ! and using the info to arrange order by filters
!!$    n = 0
!!$    do i = 1,size(filters_ref)
!!$       do j = 1,size(filter)
!!$          if( filters_ref(i) == filter(j) ) then
!!$             n = n + 1
!!$             order(n) = j
!!$          end if
!!$       end do
!!$    end do
!!$    if( n /= nfiles ) &
!!$         stop 'Filters of frames does not unique corresponds to ones of standard set.'

    ! now, we are prepared to read the data
    allocate(exptime(nfiles),area(nfiles),tol(nfiles),filter(nfiles), &
         cts(nd,nfiles),dcts(nd,nfiles),ra(nd,nfiles),dec(nd,nfiles), &
         aper(nfiles))

    cts = -1.0_dbl
    dcts = -1.0_dbl
    ra = 0.0_dbl
    dec = 0.0_dbl
    aper = -1.0_dbl

    status = 0
    do n = 1, nfiles

       call readframe(filenames(order(n)),keys,threshold,maxerr, &
            qra,qdec,dn,ddn,ftol,exptime(n),area(n),phsys,filter(n),&
            init_area,saper,aper(n),status)

       if( status /= 0 ) then
          write(error_unit,*) "File: `",trim(filenames(n)),"'"
          stop 'Failed to read a frame.'
       end if

       if( utol > epsilon(utol) ) then
          tol(n) = utol
       else
          tol(n) = ftol
       end if

       if( n == 1 ) then
          photosys = phsys
       else
          if( phsys /= photosys ) write(error_unit,*) &
               "Uncompatible photometry systems: `",trim(phsys),"' and `", &
               trim(photosys),"'."
       end if

       nd = size(dn)

       cts(1:nd,n) = dn
       dcts(1:nd,n) = ddn
       ra(1:nd,n) = qra
       dec(1:nd,n) = qdec

       deallocate(qra,qdec,dn,ddn)

    end do
    deallocate(order)

  end subroutine readframes

  subroutine readref(ref,keys,maxerr,threshold, &
       refra,refdec,refph,drefph,filter,exptime, area, aper, status)

    !
    ! WARNING: Only one band is supported !
    !
    use astrotrafo
    use phio

    real(dbl), parameter :: rad = 57.295779513082322865_dbl
    real(dbl), parameter :: pi = 3.14159

    character(len=*), intent(in) :: ref
    character(len=*), dimension(:), intent(in) :: keys
    real(dbl), intent(in) :: maxerr,threshold
    real(dbl), dimension(:), allocatable, intent(out) :: refra,refdec
    real(dbl), dimension(:,:), allocatable, intent(out) :: refph,drefph
    character(len=*), intent(out) :: filter
    real(dbl), intent(out) :: exptime, area, aper
    integer, intent(in out) :: status

    real(dbl), dimension(:), allocatable :: ra,dec,ph,dph,sky
    integer, dimension(:), allocatable :: id
    character(len=FLEN_CARD) :: key
    character(len=FLEN_VALUE) :: phkind
    real(dbl), parameter :: nullval = 0.0_dbl
    real(dbl) :: sep, r, cosd2, scale, spot
    logical :: anyf, found
    integer :: nrows,srows,nid,rcol,dcol,scol,pcol,ecol,frow,i,j,l
    type(AstroTrafoProj) :: tastr
    type(fitsfiles) :: fits

    if( status /= 0 ) return

    ! open first image extension
    call fits_open_image(fits,ref,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read an image in the file `',trim(ref),"'."
       return
    end if

    call fits_read_key(fits,keys(5),filter,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) &
         stop 'A filter keyword not found in reference frame.'

    ! WCS
    call wcsget(fits,tastr,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) &
         stop 'Error: Astrometry keywords not found in header.'
    scale = tastr%scale

    call fits_read_key(fits,keys(1),exptime,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       write(error_unit,*) &
            "Warning: Exposure time identified by FITS keyword `", &
            trim(keys(1)),"' not found (default to 1 sec)."
       exptime = 1
       status = 0
    end if

    call fits_read_key(fits,keys(2),area,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       !       write(error_unit,*)
       !"Warning: Area identified by FITS keyword `",trim(keys(2)), &
!            "' not found (default to 1 [m2])."
       area = 1
       status = 0
    end if

    ! move to photometry table
    call fits_movnam_hdu(fits,FITS_BINARY_TBL,PHOTOEXTNAME,0,status)
    if( status == FITS_BAD_HDU_NUM ) &
         stop 'Failed to find a photometry extension in reference frame.'

    call fits_get_num_rows(fits,nrows,status)

    call fits_make_keyn(FITS_KEY_ANNULUS,1,key,status)
    call fits_read_key(fits,key,sep,status)

    call fits_read_key(fits,FITS_KEY_PHOTOTYP,phkind,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) &
         stop 'PHOTOTYP not found in reference frame.'

    if( phkind == 'APHOT' ) then
       !    sep = 2*sep
       call fits_read_key(fits,FITS_KEY_APER,aper,status)
       aper = aper / scale
    else if( phkind == 'GPHOT' ) then
       call fits_read_key(fits,FITS_KEY_RF90,aper,status)
       aper = aper / scale
    end if

    call fits_get_colnum(fits,.true.,FITS_COL_RA,rcol,status)
    call fits_get_colnum(fits,.true.,FITS_COL_DEC,dcol,status)
    call fits_get_colnum(fits,.true.,FITS_COL_SKY,scol,status)
    call fits_get_colnum(fits,.true.,FITS_COL_PHOTON,pcol,status)
    call fits_get_colnum(fits,.true.,FITS_COL_PHOTONERR,ecol,status)
    if( status /= 0 ) goto 666

    allocate(ra(nrows),dec(nrows),ph(nrows),dph(nrows),sky(nrows),id(nrows))

    call fits_get_rowsize(fits,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_read_col(fits,rcol,frow,nullval,ra(i:l),anyf,status)
       call fits_read_col(fits,dcol,frow,nullval,dec(i:l),anyf,status)
       call fits_read_col(fits,scol,frow,nullval,sky(i:l),anyf,status)
       call fits_read_col(fits,pcol,frow,nullval,ph(i:l),anyf,status)
       call fits_read_col(fits,ecol,frow,nullval,dph(i:l),anyf,status)
       if( status /= 0 ) goto 666
    end do

    call fits_close_file(fits,status)

    ! selection of suitable calibration stars
    spot = pi*aper**2    ! sky is per square pixel

    ! selection of isolated stars
    nid = 0
    do i = 1, nrows
       found = .false.
       cosd2 = cos(dec(i) / rad)**2
       do j = 1, nrows
          if( i /= j ) then
             r = sqrt((ra(i) - ra(j))**2*cosd2 + (dec(i) - dec(j))**2)
             if( r < sep ) then
                found = .true.
                goto 90
             end if
          end if
       end do
90     continue

       ! accept only those isolated stars with valid measurements  ...
!       if( .not. found .and. ph(i) > 0 .and. dph(i) > 0 .and. &
!          ! ... and only bright ones above the limit given by sky
!            ph(i) / (spot*sky(i)) > threshold .and. &
!          ! ... with the maximum error
!            dph(i) / ph(i) < maxerr ) then

       if( .not. found .and. ph(i) > 0 .and. dph(i) > 0 )then

          nid = nid + 1
          id(nid) = i

       end if

    end do

    if( nid == 0 ) then
       write(error_unit,*) &
            'Error: There are no suitable and accurate stars',&
            ' on the frame. Try decrease threshold by -th or increase',&
            ' the magnitude error by -e.'
       stop 'No calibration stars available.'
    end if

    allocate(refra(nid),refdec(nid),refph(nid,1),drefph(nid,1))
    do i = 1, nid
       j = id(i)
       refra(i) = ra(j)
       refdec(i) = dec(j)
       refph(i,1) = ph(j)
       drefph(i,1) = dph(j)
    end do

    return

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    if( allocated(ra) ) deallocate(ra,dec,ph,dph,sky,id)

  end subroutine readref

  subroutine file_order(filenames,keys,filters_ref,order,maxdat)

    character(len=*), dimension(:), intent(in) :: filenames,keys,filters_ref
    integer, dimension(:), allocatable, intent(out) :: order
    integer, intent(out), optional :: maxdat
    character(len=FLEN_VALUE), dimension(:), allocatable :: filter
    integer, dimension(:), allocatable :: ndat
    integer :: i,j,n,status,nfiles,nfilters

    nfilters = size(filters_ref)
    nfiles = size(filenames)
    allocate(filter(nfiles),ndat(nfiles),order(nfiles))

    ! prior to loading of the (big) data,
    ! we are discovering their sizes and filters
    status = 0
    do n = 1, nfiles
       call checkframe(filenames(n),keys,filter(n),ndat(n),status)
       if( status /= 0 ) then
          write(error_unit,*) "File: `",trim(filenames(n)),"'"
          stop 'Failed to read a frame.'
       end if
    end do

    ! and using the info to arrange order by the filters
    n = 0
    do i = 1,nfilters
       do j = 1,size(filter)
          if( filters_ref(i) == filter(j) ) then
             n = n + 1
             order(n) = j
          end if
       end do
    end do

    if( n /= nfiles ) then
       write(error_unit,*)
       write(error_unit,*) 'Summary of filter survey '
       write(error_unit,*) 'Reference filters: ', &
            (trim(filters_ref(i)),i=1,nfilters)
       write(error_unit,*) 'List of files and filters:'
       do i = 1, nfiles
          write(error_unit,*) trim(filenames(i)),': `',trim(filter(i)),"'"
       end do
       stop 'Filters of frames does not corresponds to the standard filter set.'
    end if

    if( present(maxdat) ) then
       ! array allocation dimension
       maxdat = maxval(ndat)
    end if

    deallocate(filter,ndat)

  end subroutine file_order

end module mfits

!
!  Spreaded profiles
!
!
!  Copyright © 2016-2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!


module spray

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  integer, parameter, private :: defzoom = 2**4
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl
  real(dbl), parameter, private :: sqrt2 = sqrt(2.0)

  type SprayType
     integer :: zoom = defzoom
     integer :: nbox
     real(dbl), dimension(:,:), allocatable :: psf
   contains
     procedure :: Init, Pixelize, Load
     procedure :: gauss, moffat, seeing, cseeing, fseeing
  end type SprayType

  private :: gauss, moffat, seeing, cseeing, fseeing, fill_gaussian, fill_bessel

contains

  subroutine Init(this,profile,spread,hwhm,eccentricity,inclination, &
       airy,beta)

    class(SprayType) :: this
    character(len=*), intent(in) :: profile, spread
    real(dbl), intent(in) :: hwhm, airy, beta, eccentricity,inclination

    if( profile == 'GAUSS' ) then

       call this%gauss(hwhm,eccentricity,inclination)

    else if( profile == 'MOFFAT' ) then

       call this%moffat(hwhm,beta,eccentricity,inclination)

    else ! if( profile == 'SEEING' ) then

       if( spread == 'RANDOM' ) then

          call this%seeing(hwhm,airy,eccentricity,inclination)

       else if( spread == 'TEST' ) then

          call this%cseeing(hwhm,airy,eccentricity,inclination)

       else ! if (spread == 'FFT' ) then

          call this%fseeing(hwhm,airy,eccentricity,inclination)

       end if
    end if

    ! normalisation
    this%psf = this%psf * this%zoom**2 / sum(this%psf)

  end subroutine Init


  subroutine seeing(this,hwhm,airy,e,incl)

    ! The seeing is simulated by summing of Airy profiles with random
    ! offsets. The distribution of offsets is Gaussian N(0,hwhm).
    ! This method is very illustrative; it simulates the real process
    ! of an image generation. On the other side, it is slow for many
    ! iterations. It gives an asymmetric and randomly noised images.

    use noise

    integer, parameter :: maxiter = 5000

    class(SprayType) :: this
    real(dbl), intent(in) :: hwhm, airy, e,incl

    real(dbl), dimension(:,:), allocatable :: bessel
    integer :: n,m,i,j,iter,l1,l2,k1,k2
    real(dbl) :: x,y,u,v,a,b,c,s,sig

    this%nbox = nint(13*max(hwhm,1.0)*max(airy,5.0))
    n = this%nbox*this%zoom
    m = n / 2
    allocate(this%psf(-n:n,-n:n),bessel(-m:m,-m:m))

    ! fill-up by Bessel
    call fill_bessel(m,this%zoom*airy,bessel)

    ! spread the profile by random shifts with N(0,s)
    sig = hwhm*this%zoom
    a = sqrt2*sig
    b = a*sqrt(1 - e**2)
    c = cos(incl/rad)
    s = sin(incl/rad)

    this%psf = 0
    do iter = 1, maxiter
       u = gnoise(0.0_dbl,a)
       v = gnoise(0.0_dbl,b)
       x = u*c + v*s
       y =-u*s + v*c
       i = nint(x)
       j = nint(y)

       k1 = i - m
       k2 = i + m
       l1 = j - m
       l2 = j + m
       this%psf(k1:k2,l1:l2) = this%psf(k1:k2,l1:l2) + bessel
    end do

    deallocate(bessel)

  end subroutine seeing


  subroutine cseeing(this,hwhm,airy, e,incl)

    ! The seeing is simulated by convolution of Airy disk function and
    ! gaussian giving spread. The convolution is computed by direct
    ! sum, so by very slow way.

    class(SprayType) :: this
    real(dbl), intent(in) :: hwhm, airy, e,incl

    real(dbl), dimension(:,:), allocatable :: bessel, kernel
    integer :: n,m,i,j,k,l
    real(dbl) :: s

    this%nbox = nint(13*max(hwhm,1.0)*max(airy,5.0))
    n = this%nbox*this%zoom
    m = n / 2
    allocate(this%psf(-n:n,-n:n),bessel(-m:m,-m:m),kernel(-n:n,-n:n))

    ! fill-up the Bessel intensity
    call fill_bessel(m,this%zoom*airy,bessel)

    ! fill kernel
    call fill_gaussian(m,this%zoom*hwhm,e,incl,kernel)

    ! spread profile by direct convolution
    this%psf = 0
    do i = -m,m
       do j = -m,m
          s = 0
          do l = -m,m
             do k = -m,m
                s = s + bessel(k,l)*kernel(i-l,j-k)
             end do
          end do
          this%psf(i,j) = s
       end do
    end do

    deallocate(bessel,kernel)

  end subroutine cseeing

  subroutine fseeing(this,hwhm,airy,e,incl)

    ! The seeing is simulated by convolution of Airy disk function and
    ! gaussian giving spread. The convolution is computed by using
    ! os Fourier transformation. It is most fast and precise method.

    use ftransform

    class(SprayType) :: this
    real(dbl), intent(in) :: hwhm, airy,e,incl

    complex(dbl), dimension(:,:), allocatable :: bessel, kernel, qpsf, &
         zbessel, zkernel, zpsf
    real(dbl), dimension(:,:), allocatable :: rkernel, rbessel
    integer :: n,m,n2

    n = nint(13*max(hwhm,1.0)*max(airy,5.0))
    m = int(log(real(n*this%zoom))/log(2.0) + 1)  ! power o 2 for FFT
    n = 2**m
    this%nbox = n / this%zoom
    n = this%nbox * this%zoom
    n2 = n / 2

    ! fill-up Bessel
    allocate(bessel(n,n),rbessel(-n2:n2,-n2:n2))
    call fill_bessel(n2,this%zoom*airy,rbessel)
    bessel = rbessel(-n2+1:n2,-n2+1:n2)
    deallocate(rbessel)

    ! fill-up Gaussian spread
    allocate(kernel(n,n),rkernel(-n2:n2,-n2:n2))
    call fill_gaussian(n2,this%zoom*hwhm,e,incl,rkernel)
    ! conversion Complex to Real numbers
    kernel = rkernel(-n2+1:n2,-n2+1:n2)
    deallocate(rkernel)

    ! forward FFT
    allocate(zbessel(n,n),zkernel(n,n))
    call ftra(bessel,zbessel,m,1)
    call ftra(kernel,zkernel,m,1)
    deallocate(bessel,kernel)

    ! the convolution
    allocate(zpsf(n,n),qpsf(n,n))
    zpsf = zbessel * zkernel

    ! back FFT
    call ftra(zpsf,qpsf,m,-1)
    deallocate(zbessel,zkernel,zpsf)

    ! fill PSF by re-arranged quarters
    allocate(this%psf(-n2+1:n2-1,-n2+1:n2-1))
    this%psf = 0
    this%psf(    0:n2-1,    0:n2-1) = real(qpsf(1:n2,1:n2))
    this%psf(-n2+1:-1,      0:n2-1) = real(qpsf(n2+1:n-1,1:n2))
    this%psf(    0:n2-1,-n2+1:-1)   = real(qpsf(1:n2,n2+1:n-1))
    this%psf(-n2+1:-1,  -n2+1:-1)   = real(qpsf(n2+1:n-1,n2+1:n-1))

    deallocate(qpsf)

  end subroutine fseeing

  subroutine fill_bessel(m,sig,bessel)

    integer, intent(in) :: m
    real(dbl), intent(in) :: sig
    real(dbl), dimension(-m:,-m:), intent(out) :: bessel

    real(dbl) :: x,y,r
    integer :: i,j

    ! fill-up the top-right quarter of Airy disk
    do i = 0,m
       x = i / sig
       do j = 0,m
          y = j / sig
          ! https://en.wikipedia.org/wiki/Airy_disk
          if( i == 0 .and. j == 0 ) then
             bessel(i,j) = 1
          else
             r = sqrt(x**2 + y**2)
             bessel(i,j) = (bessel_j1(r)/r)**2
          end if
       end do
    end do

    ! fill-up rest of the kernel
    forall( i = -m:0, j = 0:m ) bessel(i,j) = bessel(-i,j)
    forall( i = -m:m, j = -m:-1 ) bessel(i,j) = bessel(i,-j)

  end subroutine fill_bessel


  subroutine fill_gaussian(m,sig,e,incl,kernel)

    integer, intent(in) :: m
    real(dbl), intent(in) :: sig, e, incl
    real(dbl), dimension(-m:,-m:), intent(out) :: kernel

    real(dbl) :: x,y,a,b,c,s
    integer :: i,j

    a = sqrt2*sig
    b = a*sqrt(1 - e**2)
    c = cos(incl/rad)
    s = sin(incl/rad)

    do i = -m, m
       do j = -m, m
          x = ( i*c + j*s) / a
          y = (-i*s + j*c) / b
          kernel(i,j) = exp(-(x**2 + y**2))
       end do
    end do

  end subroutine fill_gaussian

  subroutine gauss(this,hwhm,e,incl)

    class(SprayType) :: this
    real(dbl), intent(in) :: hwhm, e, incl
    integer :: n

    this%nbox = nint(7*max(hwhm,1.0))
    n = this%zoom * this%nbox
    allocate(this%psf(-n:n,-n:n))

    call fill_gaussian(n,this%zoom*hwhm,e,incl,this%psf)

  end subroutine gauss


  subroutine moffat(this, hwhm, beta, e,incl)

    class(SprayType) :: this
    real(dbl), intent(in) :: hwhm, beta, e, incl
    real(dbl) :: a, b, c, s, x, y
    integer :: i,j,n

    this%nbox = nint(30*max(hwhm,1.0))
    n = this%zoom * this%nbox

    allocate(this%psf(-n:n,-n:n))

    a = this%zoom * hwhm
    b = a*sqrt(1 - e**2)
    c = cos(incl/rad)
    s = sin(incl/rad)

    do i = -n, n
       do j = -n, n
          x = ( i*c + j*s) / a
          y = (-i*s + j*c) / b
          this%psf(i,j) = (1 + (x**2 + y**2))**(-beta)
       end do
    end do

  end subroutine moffat


  subroutine Pixelize(this,dx,dy,xpsf,n)

    class(SprayType) :: this
    real(dbl), intent(in) :: dx, dy
    real(dbl), dimension(-n:n,-n:n), intent(out) :: xpsf
    integer, intent(in) :: n
    ! The default lower dimension in subroutine is 1 (allocatable array?),
    ! we pass the dimensions which we needs.

    integer :: x,y,k,l,i,j,k1,k2,l1,l2,m,m2,nmax,kk,ll

    nmax = ubound(this%psf,1)
    x = nint(this%zoom*dx)
    y = nint(this%zoom*dy)
    m = this%zoom
    m2 = m / 2

    xpsf = 0
    do i = -n,n
       k = i*m + x
       k1 = max(k - m2,-nmax)
       k2 = min(k + m2, nmax)
       kk = k2 - k1 + 1
       do j = -n,n
          l = j*m + y
          l1 = max(l - m2,-nmax)
          l2 = min(l + m2, nmax)
          ll = l2 - l1 + 1
          if( kk > 0 .and. ll > 0 ) then
             xpsf(i,j) = sum(this%psf(k1:k2,l1:l2)) / (kk*ll)
          end if
       end do
    end do

  end subroutine Pixelize

  subroutine Load(this,filename)

    use titsio
    use iso_fortran_env

    class(SprayType) :: this
    character(len=*), intent(in) :: filename
    type(fitsfiles) :: fits
    integer :: naxis,status,n,n1,zoom
    integer, dimension(2) :: naxes
    character(len=FLEN_COMMENT) :: comment
    logical :: anynull

    status = 0
    call fits_open_file(fits,filename,FITS_READONLY,status)
    if( status == 0 ) then
       call fits_get_img_dim(fits,naxis,status)
       if( naxis /= 2 ) stop 'spray.Load(): PSF should by 2D image array.'
       call fits_get_image_size(fits,naxes,status)
       if( naxes(1) /= naxes(2) ) stop 'spray.Load(): PSF should be a square.'
       call fits_read_key(fits,'ZOOM',zoom,comment,status)
       if( status /= 0 .or. zoom < 1 ) stop 'spray.Load(): zoom undefined.'

       n = naxes(1) / 2
       n1 = naxes(1) - (n + 1)
       allocate(this%psf(-n:n1,-n:n1))
       this%nbox = n
       this%zoom = zoom

       call fits_read_image(fits,1,0.0_dbl,this%psf,anynull,status)
       call fits_close_file(fits,status)
    end if
    call fits_report_error(error_unit,status)
    if( status /= 0 ) stop 'spray.Load() failed to read a FITS file with PSF.'

  end subroutine Load


end module spray

!
!  photometric calibration
!
!  Copyright © 2012-15, 2017-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module calibre

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

  type photores

     integer :: ndat
     real(dbl) :: ctph,dctph
     real(dbl), dimension(:), allocatable :: ra,dec,pht,cts,res

  end type photores


contains

  subroutine photores_init(phres,ndat)

    type(photores), intent(out) :: phres
    integer, intent(in) :: ndat

    allocate(phres%ra(ndat),phres%dec(ndat),phres%pht(ndat),phres%cts(ndat), &
         phres%res(ndat))
    phres%ndat = ndat
    phres%ctph = 0
    phres%dctph = 0

  end subroutine photores_init

  subroutine photores_destroy(phres)

    type(photores), intent(in out) :: phres

    deallocate(phres%ra,phres%dec,phres%pht,phres%cts,phres%res)
    phres%ndat = 0

  end subroutine photores_destroy


  subroutine caliber(pairs,filters,tr,tr1,pht,dpht,cts,dcts,ctph,dctph,phres,verbose)

    use fotran
    use oakleaf

    integer, dimension(:,:), intent(in) :: pairs
    character(len=*), dimension(:), intent(in) :: filters
    real(dbl), dimension(:,:), intent(in) :: tr,tr1
    real(dbl), dimension(:,:), intent(in) :: pht,dpht,cts,dcts
    real(dbl), dimension(:), intent(in out) :: ctph,dctph
    type(photores), dimension(:), intent(in out) :: phres
    logical, intent(in) :: verbose

    real(dbl),dimension(:,:),allocatable :: ct, dct
    real(dbl),dimension(:,:),allocatable :: relerr
    integer :: i,n,ndat,npht

    ndat = size(pht,1)
    npht = size(pht,2)
    allocate(ct(ndat,npht),dct(ndat,npht),relerr(ndat,npht))

    do i = 1, ndat
       call fotra(tr,pairs,pht(i,:),dpht(i,:),ct(i,:),dct(i,:))
    end do

    do n = 1, npht
       if( verbose ) write(*,*) 'Filter: ',trim(filters(n))
       call fmean(ct(:,n),dct(:,n),cts(:,n),dcts(:,n),ctph(n),dctph(n), &
            verbose=verbose)
    end do

    do i = 1, ndat
       call fotra(tr1,pairs,cts(i,:)*ctph,dcts(i,:),ct(i,:),dct(i,:))
    end do

    do n = 1, npht
       relerr(:,n) = (pht(:,n) - ct(:,n))/pht(:,n)
    end do

    phres(:)%ctph = ctph
    phres(:)%dctph = dctph

    do i = 1,npht
       phres(i)%pht = pht(:,i)
       phres(i)%cts = ct(:,i)
       phres(i)%res = relerr(:,i)
    end do

    deallocate(ct,dct)

  end subroutine caliber


  subroutine calibr(pht,dpht,cts,dcts,ctph,dctph,phres,verbose)

    use oakleaf

    real(dbl), dimension(:,:), intent(in) :: pht,dpht,cts,dcts
    real(dbl), dimension(:), intent(out) :: ctph,dctph
    type(photores), dimension(:), intent(in out) :: phres
    logical, intent(in) :: verbose

    real(dbl),dimension(:),allocatable :: ct, dct,ph,dph
    real(dbl),dimension(:,:),allocatable :: relerr
    integer :: i,n,ndat,ncol

    if( size(pht,1) /= size(cts,1) ) stop 'Non-conformal data.'

    ndat = size(pht,1)
    ncol = size(pht,2)
    allocate(ct(ndat),dct(ndat),ph(ndat),dph(ndat),relerr(ndat,ncol))

    do n = 1, size(cts,2)

       ct(:) = cts(:,n)
       dct(:) = dcts(:,n)

       ph(:) = pht(:,n)
       dph(:) = dpht(:,n)

       where( ph > 0 .and. dph < epsilon(dph) )
          dph = sqrt(ph)
       end where

       where( ct > 0 .and. dct < epsilon(dct) )
          dct = sqrt(ct)
       end where

!       call phrate(ct,ph,ctph(n),dctph(n),verbose=verbose)
!       call phrate(ph,ct,ctph(n),dctph(n),verbose=verbose)
!       write(*,*) 'phrate result=',ctph(n),dctph(n)
       call fmean(ph,dph,ct,dct,ctph(n),dctph(n),verbose=verbose)
!       call fmean(ct,dct,ph,dph,ctph(n),dctph(n),verbose=verbose)
       relerr(:,n) = (ph - ctph(n)*ct) / ((ph + ctph(n)*ct) / 2)
!       relerr(:,n) = (ct - ctph(n)*ph) / ct !((ct + ctph(n)*ph) / 2)

    end do

    phres(:)%ctph = ctph
    phres(:)%dctph = dctph

    do i = 1, size(ctph)
       phres(i)%pht = pht(:,i)
       phres(i)%cts = cts(:,i)
       phres(i)%res = relerr(:,i)
    end do

    deallocate(ct,dct,ph,dph)

  end subroutine calibr


end module calibre

!
! astrofit - fitting engine
!
!
! Copyright © 2011-3, 2015-8 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module astrofitting

  use iso_fortran_env

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl
  logical, private :: debug = .true., verbose = .false., plog = .false.

contains

  subroutine astrofit(fit,type,a,d,pma,pmd,x,y,sig,xsig,epoch,jd,xc,yc, &
       acen,dacen,dcen,ddcen,sc,dsc,refl,rms,rot,drot,ares,dres, &
       id1_init,id2_init,id1_final,id2_final,rmscheck,verb,pl,reliable)

    use absfit
    use robfit
    use lsfit
    use astrotrafo
    use astrosphere
    use matcher
    use estimator
    use nearmatch

    character(len=*), intent(in) :: fit,type
    logical, intent(in) :: verb, pl, rmscheck
    logical, intent(out) :: reliable
    real(dbl), dimension(:), intent(in) :: a, d, pma, pmd, x, y
    real(dbl), intent(in) :: xc,yc,sig,xsig,epoch,jd
    real(dbl), intent(out) :: acen,dcen,dacen,ddcen,sc,dsc,rms,rot,drot,refl
    real(dbl), dimension(:), allocatable, intent(out) :: ares, dres
    integer, dimension(:), intent(in) :: id1_init,id2_init
    integer, dimension(:), allocatable, intent(out) :: id1_final,id2_final
    real(dbl), dimension(:), allocatable :: alpha,delta,xstar,ystar,u,v,xx,yy
    integer, dimension(:), allocatable :: id1, id2
    type(AstroTrafoProj) :: t

    real(dbl) :: dlim,mad,xoff,dxoff,yoff,dyoff
    logical :: status
    integer :: i,j,n

    verbose = verb
    debug = verb
    plog = pl
    reliable = .false.

    ! check dimensions
    if( size(a) /= size(d) ) &
         stop 'Astrofit: alpha and delta sizes does not corresponds.'
    if( size(x) /= size(y) ) &
         stop 'Astrofit: xstar and ystar sizes does not corresponds.'

    ! check stars > 1 ???
    if( .not. (size(id1_init) > 1) ) then
       rms = huge(rms)
       return
    end if

    allocate(id1(size(id1_init)),id2(size(id2_init)))
    id1 = id1_init
    id2 = id2_init

    mad = -1

    ! rearrange matched objects and compute apparent coordinates
!    dt = (jd - epoch)/365.25_dbl
    n = size(id1)
    allocate(alpha(n),delta(n),xstar(n),ystar(n))
    do i = 1, n
       j = id1(i)
       call propercoo(jd,epoch,a(j),d(j),pma(j),pmd(j),alpha(i),delta(i))
!       if( debug ) write(*,*) j,alpha(i),delta(i)
    end do
    do i = 1, n
       j = id2(i)
       xstar(i) = x(j)
       ystar(i) = y(j)
!       if( debug ) write(*,*) j,xstar(i),ystar(i)
    end do

    ! an intial estimate of scale, rotation and reflection
    call inestim(type,alpha,delta,xc,yc,xstar,ystar,acen,dcen,sc,dsc, &
         rot,drot,refl,xoff,dxoff,yoff,dyoff,verbose)

    ! initial robust estimation
    call absmin(type,alpha,delta,xc,yc,xstar,ystar,acen,dcen,sc,dsc, &
         rot,drot,refl,xoff,dxoff,yoff,dyoff,mad,verbose)
    if( plog ) &
         write(*,'(a,en12.3,en13.3,f8.1,2f14.5)') "=AFIT> ",mad,sc,rot,acen,dcen

    ! estimator of MAD
    mad = 1.41*max(mad,epsilon(1.0))
    ! Important note: a numerical precision of MAD should not be higher than
    ! precision of coordinates stored in FITS files - single real precision!

    if( debug ) write(error_unit,'(2(a,g0.3),a)') '# astrofit stdsig by mad=',&
         mad/0.6745,' deg  ',3600.0*mad/0.6745,' arcsec'

!    do i = 1,n
!       write(*,*) real(xstar(i)),real(ystar(i))
!    end do
!    stop

    ! select such much stars as possible for final fit
!    goto 222
    deallocate(alpha,delta,xstar,ystar)
    deallocate(id1,id2)

    ! In fact, the limit xsig is limit of clipping of data.
    dlim = xsig*max(sig/sc,mad)
!    write(*,*) dlim,1.0/sc,mad
    call listmatch(type,a,d,pma,pmd,x,y,epoch,jd,acen,dcen,xc,yc,sc,&
         rot,refl,dlim,id1,id2,status)
    n = size(id1)
    if( n < 1 .or. size(id1) /= size(id2) ) stop 'n < 1'
    allocate(alpha(n),delta(n),xstar(n),ystar(n))
    do i = 1,n
       j = id1(i)
       call propercoo(jd,epoch,a(j),d(j),pma(j),pmd(j),alpha(i),delta(i))
       xstar(i) = x(id2(i))
       ystar(i) = y(id2(i))
!       write(*,*) real(xstar(i)),real(ystar(i))
    end do
!222 continue

    if( debug ) &
         write(error_unit,'(a,i0)') '# astrofit stars to fit: ',n

    if( n > 5 ) then

       if( fit == 'SQUARES' ) then
          call lsmin(type,alpha,delta,xc,yc,refl,xstar,ystar, &
               acen,dacen,dcen,ddcen,sc,dsc,rot,drot,rms,verbose)
          reliable = .true.

          if(plog) write(*,'(a,en12.3,en13.3,f8.1,2f14.5)') &
               "=LSFIT> ",rms,sc,rot,acen,dcen

       else ! if( fit == 'ROBUST' ) then

!          write(*,*) xc,yc,w,h,mad,acen,dcen,sc,pa

          call robmin(type,alpha,delta,xc,yc,refl,xstar,ystar,mad,&
               acen,dacen,dcen,ddcen,sc,dsc,rot,drot,rms,verbose,reliable)

          if(plog) write(*,'(a,en12.3,en13.3,f8.1,2f14.5)') &
               "=RFIT> ",rms,sc,rot,acen,dcen

       end if

    else if( n > 1 ) then

!       call lfit(type,alpha,delta,xstar,ystar, &
!            xc,yc,acen,dacen,dcen,ddcen,sc,dsc,rms,pa,dpa)
       call absmin(type,alpha,delta,xc,yc,xstar,ystar,acen,dcen,sc,dsc, &
            rot,drot,refl,0.0_dbl,0.0_dbl,0.0_dbl,0.0_dbl,rms,verbose)
       rms = mad
       reliable = .true.

       if(plog) write(*,'(a,en12.3,en13.3,f8.1,2f14.5)') &
            "=AFIT> ",rms,sc,rot,acen,dcen

    else

       write(error_unit,*) "Astrofit: At least, two stars are required."
       rms = huge(rms)
       reliable = .false.
       return

    end if

    if( (rmscheck .and. rms*sc < xsig*sig ) .or. .not. rmscheck ) then

       ! residuals
       allocate(ares(n),dres(n),u(n),v(n),xx(n),yy(n))
       call trafo_init(t,type,acen,dcen)
       call proj(t,alpha,delta,u,v)
       call trafo_init(t,xcen=xc,ycen=yc,scale=1/sc,rot=rot,refl=refl)
       call invaffine(t,xstar,ystar,xx,yy)
       ares = u - xx
       dres = v - yy
       deallocate(u,v,xx,yy)

       allocate(id1_final(n),id2_final(n))
       id1_final = id1
       id2_final = id2

    else
       allocate(id1_final(0),id2_final(0))
       if(debug) then
          write(error_unit,*) 'rms*scale < xsig*sig: ',rms*sc,xsig*sig
          write(error_unit,*)
          write(error_unit,*) 'Most common occurrences:'
          write(error_unit,*) &
               '  * crowded field mesh: increase --minmatch 6 (or more)'
          write(error_unit,*) &
               '  * wide-field deformation: increase --sig or --sigcat'
       end if
    end if

    deallocate(alpha,delta,xstar,ystar)
    deallocate(id1,id2)

  end subroutine astrofit


! it would be better to derive uradius by using fwhm-like qunatity?


!!$  ! low-precision estimator of uncertainties for a few data points
!!$  subroutine lfit(type,alpha, delta, xstar, ystar, xcen, ycen, &
!!$       acen,dacen,dcen,ddcen,sc,dsc,s0,rms,pa,dpa)
!!$
!!$    !!!!!!    NO   TESTING   DONE  YET    !!!!
!!$
!!$    use astrotrafo
!!$
!!$    character(len=*), intent(in) :: type
!!$    real(dbl),dimension(:), intent(in) :: alpha, delta, xstar, ystar
!!$    real(dbl),intent(in) :: xcen,ycen
!!$    real(dbl),intent(out) :: acen,dcen,dacen,ddcen,sc,dsc,s0,rms,pa,dpa
!!$    real(dbl),dimension(:), allocatable :: u, v,x,y
!!$!    type(TypeProjection) :: t
!!$    type(AstroTrafoProj) :: t
!!$    integer :: n,i
!!$    real(dbl) :: tol,ds,rx,ry,c,s
!!$
!!$    tol = sqrt(epsilon(tol))
!!$
!!$!    t%type = type
!!$!    t%xcen = 0.0_dbl
!!$!    t%ycen = 0.0_dbl
!!$!    t%scale = sc
!!$!    t%pa = pa
!!$!    t%acen = acen
!!$!    t%dcen = dcen
!!$!    write(*,*) t%type,t%acen,t%dcen,t%xcen,t%ycen,t%scale,t%pa
!!$
!!$
!!$    n = size(alpha)
!!$    allocate(u(n),v(n),x(n),y(n))
!!$    x = xstar - xcen
!!$    y = ystar - ycen
!!$
!!$    call trafo_init(t,type,acen,dcen)
!!$    call trafo(t,alpha,delta,u,v)
!!$
!!$    call trafo_init(t,scale=sc,rot=pa,refl=refl)
!!$    call affine(
!!$    ! residual sum
!!$
!!$!    s0 = sum((xstar - u)**2 + (ystar - v)**2)
!!$    s0 = 0.0
!!$    c = sc*cos(pa/rad)
!!$    s = sc*sin(pa/rad)
!!$    do i = 1,n
!!$       rx = u(i) - (c*x(i) - s*y(i))
!!$       ry = v(i) - (s*x(i) + c*y(i))
!!$!       write(*,*) u(i),v(i),x(i),y(i),rx,ry
!!$       s0 = s0 + rx**2 + ry**2
!!$    end do
!!$    deallocate(u,v,x,y)
!!$
!!$    ds = -1
!!$    sc = t%scale
!!$    dsc = ds
!!$    rms = sqrt(s0/(n - 2))
!!$    dpa = 0
!!$    dacen = 0
!!$    ddcen = 0
!!$
!!$!    if( debug ) write(*,*) '# solution:',p
!!$!    if( debug ) write(*,*) '# uncerts.: ',dp
!!$    if( debug ) write(*,*) '# scale,dsc=',sc,dsc
!!$    if( debug ) write(*,*) '# s0=',s0
!!$
!!$  end subroutine lfit




end module astrofitting

!
!  Interpolation visual test
!
!  Copyright © 2018 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

! FCFLAGS="-Wall -g -p -no-pie -fcheck=all -fimplicit-none -fbacktrace"
! gfortran $FCFLAGS -I ../lib testinterpol.f08 -L../lib -lfitsio -lcfitsio -lm


program testinterpol

  use interpol
  use titsio

  ! test different types of interpolation
  ! images like:
  ! https://matplotlib.org/gallery/images_contours_and_fields/interpolation_methods.html

  integer, parameter :: ncount = 70
  integer, parameter :: zoom = 10
  real, parameter :: room = zoom
  integer, parameter :: nsize = zoom*ncount
  real, dimension(0:ncount+1,0:ncount+1) :: q,fx,fy,fxy
  real, dimension(nsize,nsize) :: w
  type(fitsfiles) :: fits

  integer :: n,m,i,j,i1,i2,j1,j2,status
  real :: x,y
!  integer :: n
!  integer, dimension(:),allocatable :: mm

!  call random_seed(size=n)
!  allocate(mm(n))
!  call random_seed(get=mm)
!  write(*,*) n
!  write(*,*) mm
!  mm = 666
!  call random_seed(put=mm)


  do n = 1, ncount
     do m = 1, ncount
        call random_number(x)
        q(n,m) = x
     end do
  end do
  ! padding by mean
  q(0,:) = 0
  q(:,0) = 0
  q(ncount+1,:) = 0
  q(:,ncount+1) = 0

  do i = 1, ncount
     i1 = (i-1)*zoom + 1
     i2 = i*zoom
     do j = 1, ncount
        j1 = (j-1)*zoom + 1
        j2 = j*zoom
        w(i1:i2,j1:j2) = q(i,j)
     end do
  end do

  status = 0
  call fits_create_file(fits,'none.fits',status)
  call fits_insert_img(fits,-32,2,[nsize,nsize],status)
  call fits_write_image(fits,w,status)
  call fits_close_file(fits,status)

  ! nearest neighbourhood
  w = 1
  do i = 1, nsize
     do j = 1, nsize
        x = i / room + 0.5
        y = j / room + 0.5
        n = nint(x)
        m = nint(y)
        w(i,j) = q(n,m)
     end do
  end do

  status = 0
  call fits_create_file(fits,'nearest.fits',status)
  call fits_insert_img(fits,-32,2,[nsize,nsize],status)
  call fits_write_image(fits,w,status)
  call fits_close_file(fits,status)

  ! bi-linear interpolation
  w = 1
  do i = 1, nsize
     do j = 1, nsize
        x = i / room + 0.5
        y = j / room + 0.5
        i1 = int(x)
        i2 = i1 + 1
        j1 = int(y)
        j2 = j1 + 1
        w(i,j) = bilinear(x-i1,y-j1,q(i1:i2,j1:j2))
     end do
  end do

  call fits_create_file(fits,'bilinear.fits',status)
  call fits_insert_img(fits,-32,2,[nsize,nsize],status)
  call fits_write_2d(fits,w,status)
  call fits_close_file(fits,status)

  ! bi-cubic interpolation
  w = 1

  ! prepare first and second order difference
  call diff(q,fx,1,0)
  call diff(q,fy,0,1)
  call diff2(q,fxy)

  do i = 1, nsize
     do j = 1, nsize
        x = i / room + 0.5
        y = j / room + 0.5
        i1 = int(x)
        i2 = i1 + 1
        j1 = int(y)
        j2 = j1 + 1
        w(i,j) = bicubic(x-i1,y-j1,q(i1:i2,j1:j2),fx(i1:i2,j1:j2), &
             fy(i1:i2,j1:j2),fxy(i1:i2,j1:j2))
     end do
  end do

  call fits_create_file(fits,'bicubic.fits',status)
  call fits_insert_img(fits,-32,2,[nsize,nsize],status)
  call fits_write_2d(fits,w,status)
  call fits_close_file(fits,status)


  ! bi-cubic convolution interpolation
  w = 1
  do i = 1, nsize
     do j = 1, nsize
        x = i / room + 0.5
        y = j / room + 0.5
        i1 = int(x)
        i2 = i1 + 3
        j1 = int(y)
        j2 = j1 + 3
        if( 1 < i1 .and. i2 <= ncount .and. 1 < j1 .and. j2 <= ncount ) &
             w(i,j) = bi3conv(x-i1,y-j1,q(i1:i2,j1:j2))
     end do
  end do

  call fits_create_file(fits,'bi3conv.fits',status)
  call fits_insert_img(fits,-32,2,[nsize,nsize],status)
  call fits_write_2d(fits,w,status)
  call fits_close_file(fits,status)


end program testinterpol

!
!  FITS I/O for photometry calibration
!
!  Copyright © 2014-2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

module sfits

  use titsio
  use iso_fortran_env

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl

  type qFITS
     character(len=FLEN_FILENAME) :: filename
     real, dimension(:,:), allocatable :: frame
     integer :: naxis, nrows
     integer, dimension(2) :: naxes
     real(dbl), dimension(:),allocatable :: ra,dec,cts,dcts,sky,dsky,&
          ph,dph,phsky,dphsky,mag,dmag
     real(dbl) :: exptime,coo_err,aper,area,scale,rsky,rskyerr,skymag,&
          radf90, airmass, jd, hjd, longitude, latitude
     real(dbl), dimension(2) :: annuls
     character(len=FLEN_VALUE) :: filter, phtype
     logical :: geodefined = .false.
     logical :: status
  end type qFITS

  private :: readfits, qfits_init, qfits_deallocate, qfits_setph

contains



  subroutine writecal(filenames,outputs,keys,advanced,phsystable, &
    filters,catid,photsys,area,init_area,saper,tra,ctph,dctph,quantities,phres)

    use phsysfits
    use oakleaf
    use jamming
    use calibre
    use fotran
    use mfits
    use colorex

    real, parameter :: pi = 3.14159

    character(len=*), dimension(:), intent(in) :: filenames,outputs,keys, &
         quantities, filters
    character(len=*), intent(in) :: photsys, catid, phsystable
    real(dbl), dimension(:,:), intent(in) :: tra
    real(dbl), dimension(:), intent(in) :: ctph,dctph
    type(photores), dimension(:), intent(in), optional :: phres
    real(dbl), intent(in) :: area
    integer, intent(in) :: saper
    logical, intent(in) :: init_area, advanced

    real(dbl), parameter :: nullval = 0
    integer, parameter :: dim2 = 2
    integer, dimension(:), allocatable :: ndat
    integer, dimension(:,:), allocatable :: idx,pairs
    type(qFITS), dimension(:), allocatable :: fitses
    type(type_phsys) :: phsyscal
    real(dbl), dimension(:), allocatable :: atol
    real(dbl), dimension(:,:), allocatable :: ras,decs,ct,dct,sky,dsky,ph,dph, &
         phsky,dphsky,mag,dmag,phr,dphr
    real, dimension(:,:,:), allocatable :: cube,tcube
    real(dbl), dimension(size(ctph)) :: xctph,sqarcsec,airmass,aring,nsky
    real(dbl), dimension(1,size(ctph)) :: skymag,dskymag,skyrate,dskyrate
    integer, allocatable, dimension(:) :: order
    integer :: i,j,k,n,status,nrows_max, width, height, nq, ncat, nfiles, nrows, npht
    real(dbl) :: rsky,rskyerr,k0,r,lref

    nfiles = size(filenames)
    nq = size(quantities)
    npht = size(tra,1)

    status = 0
    allocate(fitses(nfiles))

    ! init photometry parameters
    call phselect(phsystable,photsys,phsyscal)
    call phsyspairs(phsyscal,filters,pairs)
    call file_order(filenames,keys,phsyscal%filter,order)

    nrows_max = 0
    ! read frames
    do n = 1, nfiles
       call qfits_init(fitses(n))
       call readfits(filenames(order(n)),keys,saper,fitses(n),status)
       if( status /= 0 ) stop 'FITS read failed.'
       if( fitses(n)%nrows > nrows_max ) nrows_max = fitses(n)%nrows
       if( init_area ) fitses(n)%area = area
       airmass(n) = fitses(n)%airmass
    end do

    ! convert frames from counts to photons
    if( nfiles == 1 ) then
       fitses(1)%frame = real(ctph(1)*fitses(1)%frame)
    else
       ! uncorrect handling for multiple frames with small mutual offsets !
       ! this code supposes all the fames with no mutual offset and the same dimensions
       width = fitses(1)%naxes(1)
       height = fitses(1)%naxes(2)
       allocate(cube(width,height,nfiles),tcube(width,height,nfiles))
       do n = 1,nfiles
          cube(:,:,n) = fitses(n)%frame
       end do

       do i = 1,width
          do j = 1,height
             !             call tra_frame(tra,pairs,ctph,cube(i,j,:),tcube(i,j,:))
             forall(n=1:npht)
                tcube(i,j,n) = real(ctph(n)*cube(i,j,n)*tra(n,n))
             end forall
          end do
       end do

       do n = 1,nfiles
          fitses(n)%frame = tcube(:,:,n)
       end do

       deallocate(cube,tcube)
    end if


    ! match both frames to be able to determine of colour indexes
    if( nfiles > 1 ) then

       allocate(ras(nrows_max,nfiles),decs(nrows_max,nfiles),atol(nfiles), &
            ndat(nfiles),idx(nrows_max,nfiles))
       idx = 0
       ras = 0
       decs = 0
       do n = 1,nfiles
          nrows = fitses(n)%nrows
          ndat(n) = nrows
          ras(1:nrows,n) = fitses(n)%ra
          decs(1:nrows,n) = fitses(n)%dec
       end do

       atol = 5.0*fitses%coo_err

       call jamframes(atol, ndat, ras, decs, idx)

       deallocate(ras,decs,atol,ndat)

    else ! nfiles == 1
       allocate(idx(nrows_max,nfiles))
       forall(i=1:size(idx,1))
          idx(i,1) = i
       end forall
    end if

    ncat = 0
    do i = 1,size(idx,1)
       if( all(idx(i,:) > 0) ) ncat = ncat + 1
    end do

    allocate(ct(ncat,nfiles),dct(ncat,nfiles),sky(ncat,nfiles), &
         dsky(ncat,nfiles),ras(ncat,nfiles),decs(ncat,nfiles))


    ncat = 0
    do i = 1,size(idx,1)
       if( all(idx(i,:) > 0) )then
          ncat = ncat  + 1
          do j = 1,nfiles
             k = idx(i,j)
             ras(ncat,j) = fitses(j)%ra(k)
             decs(ncat,j) = fitses(j)%dec(k)
             ct(ncat,j) = fitses(j)%cts(k)
             dct(ncat,j) = fitses(j)%dcts(k)
             sky(ncat,j) = fitses(j)%sky(k)
             dsky(ncat,j) = fitses(j)%dsky(k)
          end do
       end if
    end do
    deallocate(idx)

    do n = 1,nfiles
       deallocate(fitses(n)%ra,fitses(n)%dec)
       allocate(fitses(n)%ra(ncat),fitses(n)%dec(ncat))
       fitses(n)%ra = ras(:,n)
       fitses(n)%dec= decs(:,n)
    end do
    deallocate(ras,decs)


    allocate(ph(ncat,nfiles),dph(ncat,nfiles),phsky(ncat,nfiles), &
         dphsky(ncat,nfiles))
    ph = -1
    dph = -1
    phsky = -1
    dphsky = -1

    do n = 1,size(fitses)
       xctph(n) = fitses(n)%area * fitses(n)%exptime
       !xctph(n) = 1
       sqarcsec(n) = (3600 * fitses(n)%scale)**2
       ! unused:
       aring(n) = pi*(fitses(n)%annuls(2)**2 - fitses(n)%annuls(1)**2) /  &
            fitses(n)%scale**2
       nsky(n) = pi*fitses(n)%aper**2/fitses(n)%scale**2
    end do

!    write(*,*) aring
!    write(*,*) nsky

    allocate(mag(ncat,nfiles),dmag(ncat,nfiles),phr(ncat,nfiles), &
         dphr(ncat,nfiles))

    if( nfiles > 1 ) then
       ! estimate effective extinction
       call scaterr(phsyscal%lam_eff,ctph,airmass,k0,r,lref)
    else
       r = -1
    end if

    do i = 1,ncat
       if( nfiles == 1 )then
!          write(*,*) sqrt(ctph(1)),sqarcsec(1), dsky(i,1)
          where( sky(i,:) > 0 .and. dsky(i,:) > 0 )
             phsky(i,:) = ctph(1) * sky(i,:) !* sqarcsec(1)
             dphsky(i,:) = phsky(i,:) * (dsky(i,:)/sky(i,:))
!             dphsky(i,:) = sqrt(ctph(1)) * dsky(i,:) !* sqarcsec(1)
          elsewhere
             phsky(i,:) = -1
             dphsky(i,:) = -1
          end where

          where( ct(i,:) > 0 .and. dct(i,:) > 0 )
             ph(i,:) = ctph(1)*ct(i,:)
             dph(i,:) = sqrt(ctph(1)) * dct(i,:)  ! pure Poisson
             dph(i,:) = sqrt(ctph(1)**2*dct(i,:)**2 + ct(i,:)**2*dctph(1)**2)

             ! "gain" update
!             dph(i,:) = dph(i,:) / sqrt(ctph(1))

!             dph(i,:) = sqrt(dct(i,:)**2 + ct(i,:)**2*dctph(1)**2 + ctph(1)**2*dph(i,:)**2)


             ! Errors are estimated under Poisson statistics
             ! assumption, it can be underestimated for faint stars.

             ! fully optimal estimate: independent scaling Po and N parts
!             dph(i,:) = max(dct(i,:)**2 - ct(i,:),0.0)
!             dph(i,:) = sqrt(ph(i,:) + dph(i,:)*ctph(1)**2)


!             dph(i,:) = sqrt(ct(i,:)**2 * dctph(1)**2 + &
!                  ctph(1)**2 * dct(i,:)**2)
!             dph(i,:) = ph(i,:)*(dct(i,:)/ct(i,:))
             !dph(i,:) = sqrt(ph(i,:) + dphsky(i,:)**2*nsky(1)**2 + &
             !     dphsky(i,:)**2*pi*nsky(1)**2)
          elsewhere
             ph(i,:) = -1
             dph(i,:) = -1
          end where

!          write(*,*) sqrt(abs(ph(i,:))),sqrt(dphsky(i,:)**2*nsky(1)**2), &
          !               sqrt(dphsky(i,:)**2*pi*nsky(1)**2)
       else
          ct(i,:) = ctph * ct(i,:) / xctph
          dct(i,:) = ctph * dct(i,:) / xctph !! needs correction !!!
          sky(i,:) = ctph * sky(i,:) / xctph
          dsky(i,:) = ctph * dsky(i,:) / xctph
          call fotra(tra,pairs,ct(i,:),dct(i,:),phr(i,:),dphr(i,:))
          call fotra(tra,pairs,sky(i,:),dsky(i,:),phsky(i,:),dphsky(i,:))
          call correx(phsyscal%lam_eff,phsyscal%lam_fwhm/2,airmass,k0,r,lref,phr(i,:))
          where( phr(i,:) > 0 )
             ph(i,:) = phr(i,:) * xctph
             dph(i,:) = dphr(i,:) * xctph !! correct !!!
          elsewhere
             ph(i,:) = - 1
             dph(i,:) = -1
          end where
          where( phsky(i,:) > 0 )
             phsky(i,:) = phsky(i,:) * xctph
             dphsky(i,:) = dphsky(i,:) * xctph !! correct needs!!!
          elsewhere
             phsky(i,:) = -1
             dphsky(i,:) = -1
          end where
       end if

    end do
!    write(*,*) ct(4,1),ph(4,1)


!    write(*,*) ctph,dctph
!    write(*,*) ct
!    write(*,*) dct
!    write(*,*) ph
!    write(*,*) dph


    do i = 1, nfiles
       call rmean(phsky(:,i),rsky,rskyerr)
       skyrate(1,i) = (rsky / xctph(i)) / sqarcsec(i)
       dskyrate(1,i)= (rskyerr / (xctph(i)) / sqarcsec(i))
!       write(*,*) rsky,skyrate(1,i),xctph(i),sqarcsec(i)
    end do

    if( nfiles == 1 ) then
       call phsysphmag1(phsyscal,filters(1),ph(:,1)/xctph(1), &
            dph(:,1)/xctph(1),mag(:,1),dmag(:,1))
!            dph(:,1)/sqrt(xctph(1)),mag(:,1),dmag(:,1))
       call phsysphmag1(phsyscal,filters(1),skyrate(1,:),dskyrate(1,:), &
            skymag(1,:),dskymag(1,:))
!       write(*,*) trim(filenames(1)),xctph(1),ph(4,1),mag(4,1)
    else
       call phsysphmag(phsyscal,filters,pairs,phr,dphr,mag,dmag)
       call phsysphmag(phsyscal,filters,pairs,skyrate,dskyrate,skymag,dskymag)
    end if

!    write(*,*) xctph
!    write(*,*) mag
!    write(*,*) dmag

    do n = 1,size(fitses)
       call qfits_setph(fitses(n),ph(:,n),dph(:,n),phsky(:,n),dphsky(:,n))

       fitses(n)%mag = mag(:,n)
       fitses(n)%dmag = dmag(:,n)
       fitses(n)%rsky = skyrate(1,n)
       fitses(n)%rskyerr = dskyrate(1,n)
       fitses(n)%skymag = skymag(1,n)

    end do

    do n = 1,size(fitses)
       i = order(n)
       if( present(phres) ) then
          call savefits(filenames(i),outputs(i),fitses(n),advanced, &
               photsys,phsyscal,area,init_area,catid,quantities, &
               ctph(n),dctph(n),status,k0,r,lref,phres(n))
       else
          call savefits(filenames(i),outputs(i),fitses(n),advanced, &
               photsys,phsyscal,area,init_area,catid,quantities, &
               ctph(n),dctph(n),status,k0,r,lref)
       end if
       call qfits_deallocate(fitses(n))
    end do

    call deallocate_phsyscal(phsyscal)
    deallocate(ct,dct,sky,dsky,ph,dph,mag,dmag,phr,dphr, &
         phsky,dphsky,pairs,order)

  end subroutine writecal

  subroutine readfits(filename,keys,saper,fits,status)

    ! this is candidate for merge with the analogical subroutine in mfits.f95

    use astrotrafo
    use astrosphere
    use trajd
    use phio

    character(len=*), intent(in) :: filename
    character(len=*), dimension(:), intent(in) :: keys
    integer, intent(in) :: saper
    type(qFITS), intent(in out) :: fits
    integer, intent(in out) :: status

    real, parameter :: nullval = -huge(1.0)
    real(REAL64), parameter :: dullval = -huge(real(0.0,REAL64))
    integer, parameter :: group = 1, extver = 0
    integer :: frow
    real(dbl), dimension(:), allocatable :: xcen, ycen
    type(AstroTrafoProj) :: tastr
    logical :: anyf
    character(len=FLEN_CARD) :: key, dateobs
    integer :: w,h,i,l,ccol,dcol,xcol,ycol,scol,ecol,nrows,maper, naper, srows
    real(dbl) :: ls, jd0
    real :: hwhm, aper
    logical :: have_grow
    type(fitsfiles) :: fitsfile

    fits%filename = filename

    call fits_open_image(fitsfile,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read an image in the file `',trim(filename),"'."
       return
    end if

    call fits_get_img_size(fitsfile,2,fits%naxes,status)
    if( status /= 0 ) goto 666

    ! WCS
    call wcsget(fitsfile,tastr,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       write(error_unit,*) 'Error: Astrometry keywords not found in header.'
       goto 666
    end if
    fits%scale = tastr%scale

    ! Citizen date
    call fits_get_dateobs(fitsfile,(/keys(3),keys(8)/),dateobs,status)
    if( status == 0 ) then
       fits%jd = fits_jd(dateobs,status)

       block
         real(REAL64), parameter :: one = real(1.0,REAL64)
         integer :: year, month, day, hour, minute
         real(dbl) :: second
         call fits_str2date(dateobs,year,month,day,hour,minute,second,status)

         ! Julian date of 1. january
         jd0 = datjd(real(year,REAL64),one,one)

       end block

    else
       write(error_unit,*) "Warning: Failed to get date or time."
       fits%jd = 0
       jd0 = 0
       status = 0
    end if

    call fits_read_key(fitsfile,keys(1),fits%exptime,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       write(error_unit,*) "Warning: Exposure time identified by FITS keyword `", &
            trim(keys(1)),"' not found (default to 1 sec)."
       fits%exptime = 1
       status = 0
    end if

    call fits_read_key(fitsfile,keys(2),fits%area,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
!       write(error_unit,*) "Warning: Area identified by FITS keyword `",trim(keys(2)), &
!            "' not found (default to 1 [m2])."
       fits%area = 1
       status = 0
    end if

!    call ftgkyd(25,keys(3),fits%airmass,buf,status)
!    if( status == KEYWORD_NOT_FOUND ) then
!       fits%airmass = 1
!       status = 0
!    end if

    call fits_read_key(fitsfile,keys(5),fits%filter,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       write(error_unit,*) "Warning: Filter identified by FITS keyword `",trim(keys(5)), &
            "' not found (default to empty `')."
       fits%filter = ''
       status = 0
    end if

    call fits_read_key(fitsfile,keys(6),fits%longitude,status)
    call fits_read_key(fitsfile,keys(7),fits%latitude,status)
    fits%geodefined = status == 0
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       write(error_unit,*) &
            "Warning: Geographical longitude or latitude identified by FITS keywords `",&
            trim(keys(6)),"',`",trim(keys(7)),"' not found. Airmass is undefined."
       status = 0
    end if

    ! Julian date at midpoint of exposure
    fits%jd = fits%jd + fits%exptime / 2.0_dbl / 86400.0_dbl

    ! Heliocentric JD
    ls = longsun(fits%jd - jd0)
    fits%hjd = fits%jd + helcor(tastr%acen,tastr%dcen,ls)

    ! airmass at the time
    if( fits%geodefined ) &
         fits%airmass = xairmass(fits%jd,fits%longitude,fits%latitude, &
         tastr%acen,tastr%dcen)

    ! frame
    w = fits%naxes(1)
    h = fits%naxes(2)
    allocate(fits%frame(w,h))
    call fits_read_image(fitsfile,group,nullval,fits%frame,anyf,status)

    ! move to aperture photometry extension
    call fits_movnam_hdu(fitsfile,FITS_BINARY_TBL,APEREXTNAME,0,status)
    if( status == FITS_BAD_HDU_NUM ) then
       write(error_unit,*) &
            "Failed to find an aperture photometry extension in ",trim(filename)
       goto 666
    end if

    ! sky annulus
    do i = 1, 2
       call fits_make_keyn(FITS_KEY_ANNULUS,i,key,status)
       call fits_read_key(fitsfile,key,fits%annuls(i),status)
    end do
    fits%annuls = fits%annuls * tastr%scale

    ! aperture
    if( saper == 0 ) then
       call fits_read_key(fitsfile,FITS_KEY_HWHM,hwhm,status)
       call fits_read_key(fitsfile,FITS_KEY_NAPER,naper,status)
       do i = 1, naper
          call fits_make_keyn(FITS_KEY_APER,i,key,status)
          call fits_read_key(fitsfile,key,aper,status)
          if( aper > 2*hwhm ) then
             maper = i
             exit
          end if
       end do
    else
       maper = saper
    end if
    call fits_make_keyn(FITS_KEY_APER,maper,key,status)
    call fits_read_key(fitsfile,key,fits%aper,status)
    fits%aper = fits%aper * tastr%scale

    ! move to growth-curve photometry extension
    call fits_movnam_hdu(fitsfile,FITS_BINARY_TBL,GROWEXTNAME,0,status)
    have_grow = .not. (status == FITS_BAD_HDU_NUM)
    if( status == FITS_BAD_HDU_NUM ) then
       ! no problem, we're continuing with aperture extension
       status = 0
    end if

    if( .not. have_grow .or. saper > 0 ) then
       call fits_movnam_hdu(fitsfile,FITS_BINARY_TBL,APEREXTNAME,0,status)
       write(key,'(a,i0)') FITS_COL_APCOUNT,maper
       call fits_get_colnum(fitsfile,.true.,key,ccol,status)
       write(key,'(a,i0)') FITS_COL_APCOUNTERR,maper
       call fits_get_colnum(fitsfile,.true.,key,dcol,status)
       fits%radf90 = -1
       fits%phtype = 'APHOT'
    else
       call fits_read_key(fitsfile,FITS_KEY_RF90,fits%radf90,status)
       fits%radf90 = fits%scale * fits%radf90
       fits%aper = -1
       call fits_get_colnum(fitsfile,.true.,FITS_COL_GCOUNT,ccol,status)
       call fits_get_colnum(fitsfile,.true.,FITS_COL_GCOUNTERR,dcol,status)
       fits%phtype = 'GPHOT'
    end if

    call fits_get_colnum(fitsfile,.true.,FITS_COL_X,xcol,status)
    call fits_get_colnum(fitsfile,.true.,FITS_COL_Y,ycol,status)
    call fits_get_colnum(fitsfile,.true.,FITS_COL_SKY,scol,status)
    call fits_get_colnum(fitsfile,.true.,FITS_COL_SKYERR,ecol,status)
    if( status /= 0 ) goto 666

    call fits_get_num_rows(fitsfile,nrows,status)
    allocate(xcen(nrows),ycen(nrows))
    allocate(fits%sky(nrows),fits%dsky(nrows), &
         fits%cts(nrows),fits%dcts(nrows))

    call fits_get_rowsize(fitsfile,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_read_col(fitsfile,xcol,frow,dullval,xcen(i:l),anyf,status)
       call fits_read_col(fitsfile,ycol,frow,dullval,ycen(i:l),anyf,status)
       call fits_read_col(fitsfile,scol,frow,dullval,fits%sky(i:l),anyf,status)
       call fits_read_col(fitsfile,ecol,frow,dullval,fits%dsky(i:l),anyf,status)
       call fits_read_col(fitsfile,ccol,frow,dullval,fits%cts(i:l),anyf,status)
       call fits_read_col(fitsfile,dcol,frow,dullval,fits%dcts(i:l),anyf,status)
       if( status /= 0 ) goto 666
    end do

    call fits_close_file(fitsfile,status)

    !  coordinates conversions
    allocate(fits%ra(nrows),fits%dec(nrows))
    call invtrafo(tastr,xcen,ycen,fits%ra,fits%dec)

    fits%nrows = nrows
    fits%coo_err = tastr%err

    deallocate(xcen,ycen)
    return

666 continue

    call fits_close_file(fitsfile,status)
    call fits_report_error(error_unit,status)

  end subroutine readfits


  subroutine savefits(filename,output,fits,advanced,photsys,phsyscal,&
       area,init_area,catid, qlabels,ctph, dctph, status, k0, r, lref, phres)

    use phsysfits
    use photoconv
    use calibre

    character(len=*), intent(in) :: filename,output,photsys,catid
    character(len=*), dimension(:), intent(in) :: qlabels
    type(qFITS), intent(in) :: fits
    type(type_phsys), intent(in) :: phsyscal
    real(dbl), intent(in) :: area, ctph, dctph, k0, r, lref
    logical, intent(in) :: init_area, advanced
    type(photores), intent(in), optional :: phres
    integer, intent(in out) :: status

    integer, parameter :: group = 1, extver = 0
    character(len=*), parameter :: bunit = units(3)
    character(len=FLEN_VALUE), dimension(:), allocatable :: ttype, tform,tunit
    character(len=FLEN_CARD), dimension(2) :: com
    real(dbl), dimension(:,:), allocatable :: q,dq
    character(len=FLEN_CARD) :: key, buf
    real(dbl) :: photflam,photzpt,photplam,photbw
    integer :: n, m, i, l, width, height, hdutype, nq, nrows, ncols, chdu, nhdu, &
         srows, frow
    type(fitsfiles) :: fitsfile, fitscal

    width = fits%naxes(1)
    height = fits%naxes(2)
    nq = size(qlabels)

    call fits_open_image(fitsfile,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read an image in the file `',trim(filename),"'."
       return
    end if

    call fits_create_scratch(fitscal,status)
    call fits_copy_header(fitsfile,fitscal,status)
    call fits_update_key(fitscal,'BITPIX',-32,'',status)
    !call fits_delete_key(fitscal,'BSCALE,status)
    !call fits_delete_key(fitscal,'BZERO,status)

    if( status /= 0 ) goto 666

    call fits_get_hdu_num(fitsfile,chdu)

    call fits_update_key(fitscal,FITS_KEY_PHOTSYS,photsys,'photometry filter system',status)
    call fits_update_key(fitscal,FITS_KEY_BUNIT,bunit,'Physical units of array values',status)

    if( init_area ) then
       call fits_update_key(fitscal,FITS_KEY_AREA,area,-5, &
            '[m2] Area of input aperture',status)
    end if

    if( photsys /= '' ) then
       ! compatibility with HST calibration
       call phstkeys(phsyscal,fits%filter,photflam,photzpt,photplam,photbw)

       call fits_update_key(fitscal,FITS_KEY_PHOTFLAM,photflam,5, &
            '[erg/s/cm2/A] flux for 1 photon/s/cm2',status)
       call fits_update_key(fitscal,FITS_KEY_PHOTZPT,photzpt,-6, &
            'mag zero-point for fluxes in [erg/s/cm2/A]',status)
       call fits_update_key(fitscal,FITS_KEY_PHOTPLAM,photplam,-6, &
            '[A] effective wavelength',status)
       call fits_update_key(fitscal,FITS_KEY_PHOTBW,photbw,-6,'[A] passband FWHM',status)
    end if

    call fits_write_image(fitscal,group,fits%frame,status)
    if( status == FITS_NUMERICAL_OVERFLOW ) then
       call fits_report_error(error_unit,status)
       status = 0
    end if

    if( advanced ) then
       ! copy all others extensions
       call fits_get_num_hdus(fitsfile,nhdu,status)
       do n = 1,nhdu
          if( n /= chdu ) then
             call fits_movabs_hdu(fitsfile,n,hdutype,status)
             call fits_copy_hdu(fitsfile,fitscal,0,status)
             if( status /= 0 ) goto 666
          end if
       end do
    end if
    call fits_close_file(fitsfile,status)
    call fits_report_error(error_unit,status)

    ! prepare HDU with photometry
    ncols = 6 + 2*nq
    allocate(ttype(ncols),tform(ncols),tunit(ncols))

    tform = '1D'
    tunit(1:2) = 'deg'
    tunit(3:) = bunit

    ttype(1:6) = [ character(len=FLEN_VALUE) :: FITS_COL_RA, FITS_COL_DEC, &
         FITS_COL_SKY, FITS_COL_SKYERR, FITS_COL_PHOTON, FITS_COL_PHOTONERR ]

    do n = 1, nq
       i = 2*n + 5
       ttype(i) = qlabels(n)
       ttype(i+1) = trim(qlabels(n))//'ERR'
       call quantity(qlabels(n),tunit(i))
       tunit(i+1) = tunit(i)
    end do

    call fits_insert_btbl(fitscal,ncols,ttype,tform,tunit,PHOTOEXTNAME,status)
    call fits_update_key(fitscal,FITS_KEY_JD,fits%jd,-18, &
         'Julian date at midpoint of exposure',status)
    call fits_update_key(fitscal,FITS_KEY_HJD,fits%hjd,-12,'Heliocentric JD',status)

    if( fits%geodefined ) then
       call fits_update_key(fitscal,FITS_KEY_AIRMASS,fits%airmass,-5,&
            'The airmass of centre at JD',status)
    else
       call fits_update_key(fitscal,FITS_KEY_AIRMASS,fits%airmass,-1,&
            'Consider the airmass as UNDEFINED',status)
    end if
    call fits_update_key(fitscal,FITS_KEY_PHOTOTYP,fits%phtype,'photometry method',status)
    call fits_update_key(fitscal,FITS_KEY_CTPH,ctph,13,'counts per photons, calibration',status)
    call fits_update_key(fitscal,FITS_KEY_CTPHERR,dctph,1,'std. error of CTPH ',status)

    if( fits%aper > 0 ) &
         call fits_update_key(fitscal,FITS_KEY_APER,fits%aper,3, &
         '[deg] calibration aperture radius',status)
    if( fits%radf90 > 0 ) &
         call fits_update_key(fitscal,FITS_KEY_RF90,fits%radf90,3, &
         '[deg] radius contains 90% of flux',status)

    com(1) = '[deg] inner sky annulus radius'
    com(2) = '[deg] outer sky annulus radius'
    do i = 1, 2
       call fits_make_keyn(FITS_KEY_ANNULUS,i,key,status)
       call fits_update_key(fitscal,key,fits%annuls(i),3,com(i),status)
    end do
    call fits_update_key(fitscal,FITS_KEY_PHOTSYS,photsys,'photometry filter system',status)
    call fits_update_key(fitscal,FITS_KEY_FILTER,fits%filter,'filter in the system',status)
    if( status /= 0 ) goto 666

    if( r > 1 ) then
       call fits_write_comment(fitscal,'Extinction model k = k0*(lam/lref)**-r with parameters:',status)
       call fits_write_key(fitscal,FITS_KEY_EXTINK0,k0,-3,'mean extinction k0',status)
       call fits_write_key(fitscal,FITS_KEY_EXTINR,r,-3,'extinction power r',status)
       call fits_write_key(fitscal,FITS_KEY_EXTINREF,lref,-3,'[m] extinction reference wavelenght lref',status)
    end if

    call fits_update_key(fitscal,FITS_KEY_SKYMAG,fits%skymag,-5, &
         '[mag/arcsec2] the averadge sky in magnitudes',status)
    call fits_update_key(fitscal,FITS_KEY_SKYMEAN,fits%rsky,-5, &
         '[ph/s/m2/arcsec2] averadge sky of star anullii',status)
    call fits_update_key(fitscal,FITS_KEY_SKYSTD,fits%rskyerr,-2, &
         '[ph/s/m2/arcsec2] statistical error of the mean sky',status)

    call fits_update_key(fitscal,FITS_KEY_CREATOR,FITS_VALUE_CREATOR,FITS_COM_CREATOR,status)
    if( status /= 0 ) goto 666

    call fits_write_comment(fitscal,BEGIN_PHOTOCAL,status)

    if( catid /= '' ) then
       call fits_write_comment(fitscal,"Reference photometric sequence: "//trim(catid),status)
    end if
    write(buf,'(a,g0.5,a,es8.1)') "Counts per photons = ",ctph," +- ",dctph
    call fits_write_comment(fitscal,buf,status)

    if( present(phres) ) then

       write(buf,'(a,i0)') "Objects used = ",phres%ndat
       call fits_write_comment(fitscal,buf,status)
       call fits_write_comment(fitscal,'   Catalogue RA,DEC [deg]    Photons/s/m2    Counts/s/m2       rel.dev.',status)
       do i = 1, phres%ndat
          write(buf,'(2f13.8,2en15.3,f14.4)') &
               phres%ra(i),phres%dec(i),phres%pht(i),phres%cts(i),phres%res(i)
          call fits_write_comment(fitscal,buf,status)
       end do
    end if

    call fits_write_comment(fitscal,MUNIPACK_VERSION,status)
    call fits_write_comment(fitscal,'Description: http://munipack.physics.muni.cz/dataform_photometry.html',status)
    call fits_write_comment(fitscal,END_PHOTOCAL,status)

    nrows = size(fits%ra)

    allocate(q(nrows,nq),dq(nrows,nq))
    do n = 1, nq
       call phsysconv(qlabels(n),fits%filter,phsyscal,fits%area,fits%exptime,&
            1.0_dbl,fits%ph,fits%dph,q(:,n),dq(:,n))
    end do

    call fits_get_rowsize(fitscal,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)
       call fits_write_col(fitscal,1,frow,fits%ra(i:l),status)
       call fits_write_col(fitscal,2,frow,fits%dec(i:l),status)
       call fits_write_col(fitscal,3,frow,fits%phsky(i:l),status)
       call fits_write_col(fitscal,4,frow,fits%dphsky(i:l),status)
       call fits_write_col(fitscal,5,frow,fits%ph(i:l),status)
       call fits_write_col(fitscal,6,frow,fits%dph(i:l),status)
       do n = 1,nq
          m = 2*n + 5
          call fits_write_col(fitscal,m,frow,q(i:l,n),status)
          call fits_write_col(fitscal,m+1,frow,dq(i:l,n),status)
       end do
    end do

    deallocate(ttype,tform,tunit,q,dq)

    ! add residuals to a next extension
    if( advanced .and. present(phres) ) then

       ncols = 5
       allocate(ttype(ncols),tform(ncols),tunit(ncols))

       tform = '1D'
       tunit(1:2) = 'deg'
       tunit(3:) = ''

       ttype(1:5) = [ character(len=FLEN_VALUE) :: FITS_COL_RA, FITS_COL_DEC, &
            FITS_COL_PHOTON, FITS_COL_COUNT, 'RESIDUALS' ]

       call fits_insert_btbl(fitscal,0,ttype,tform,tunit,EXT_PHRES,status)
       call fits_update_key(fitscal,FITS_KEY_CTPH,ctph,13,'counts per photons, calibration',status)
       call fits_update_key(fitscal,FITS_KEY_CTPHERR,dctph,1,'std. error of CTPH ',status)

       call fits_write_comment(fitscal,'This table contains relative residuals of photometry',status)
       call fits_write_comment(fitscal,'calibration in '//trim(PHOTOEXTNAME)//' extension.',status)
       write(buf,'(a,g0.5,a,es8.1)') "Counts per photons = ",ctph," +- ",dctph
       call fits_write_comment(fitscal,buf,status)

       call fits_get_rowsize(fitscal,srows,status)
       do i = 1, nrows, srows
          frow = i
          l = min(i+srows,nrows)

          call fits_write_col(fitscal,1,frow,phres%ra(i:l),status)
          call fits_write_col(fitscal,2,frow,phres%dec(i:l),status)
          call fits_write_col(fitscal,3,frow,phres%pht(i:l),status)
          call fits_write_col(fitscal,4,frow,phres%cts(i:l),status)
          call fits_write_col(fitscal,5,frow,phres%res(i:l),status)
       end do

       deallocate(ttype,tform,tunit)

    end if

    if( status == 0 ) then
       if( fits_file_exist(output) ) call fits_file_delete(output)
       call fits_file_duplicate(fitscal,output,status)
    end if

666 continue

    call fits_delete_file(fitscal,status)
    call fits_report_error(error_unit,status)

  end subroutine savefits


  subroutine tra_frame(tra,pairs,ctph,xcts,xpht)

    use fotran

    integer, dimension(:,:), intent(in) :: pairs
    real(dbl), dimension(:,:), intent(in) :: tra
    real(dbl), dimension(:), intent(in) :: ctph
    real, dimension(:), intent(in) :: xcts
    real, dimension(:), intent(out) :: xpht

    real(dbl), dimension(:), allocatable :: cts,dcts,pht,dpht
    integer :: n

    n = size(xcts)
    allocate(cts(n),dcts(n),pht(n),dpht(n))
    cts = xcts * ctph
    dcts = 0
    dpht = 0
    call fotra(tra,pairs,cts,dcts,pht,dpht)
    xpht = real(pht)
    deallocate(cts,dcts,pht,dpht)

  end subroutine tra_frame


  subroutine qfits_init(fits)

    type(qFITS), intent(out) :: fits
    fits%status = .false.
    fits%filename = ''
    fits%nrows = 0
    fits%naxis = 0
    fits%naxes = 0
    fits%aper = -1
    fits%area = 1
    fits%exptime = 1
    fits%coo_err = -1
    fits%scale = 0
    fits%annuls = 0
    fits%filter = ''
    fits%rsky = 0
    fits%rskyerr = 0
    fits%skymag = 99.999
    fits%radf90 = -1
    fits%airmass = 1
    fits%jd = 0.0
    fits%latitude = 0.0
    fits%longitude = 0.0

  end subroutine qfits_init

  subroutine qfits_deallocate(fits)

    type(qFITS), intent(in out) :: fits

    if( allocated(fits%frame) ) deallocate(fits%frame)
    if( allocated(fits%ra) ) deallocate(fits%ra)
    if( allocated(fits%dec) ) deallocate(fits%dec)
    if( allocated(fits%cts) ) deallocate(fits%cts)
    if( allocated(fits%dcts) ) deallocate(fits%dcts)
    if( allocated(fits%sky) ) deallocate(fits%sky)
    if( allocated(fits%dsky) ) deallocate(fits%dsky)
    if( allocated(fits%ph) ) deallocate(fits%ph)
    if( allocated(fits%dph) ) deallocate(fits%dph)
    if( allocated(fits%phsky) ) deallocate(fits%phsky)
    if( allocated(fits%dphsky) ) deallocate(fits%dphsky)

    if( allocated(fits%dmag) ) deallocate(fits%dmag)
    if( allocated(fits%mag) ) deallocate(fits%mag)

  end subroutine qfits_deallocate

  subroutine qfits_setph(fits,ph,dph,phsky,dphsky)

    type(qFITS), intent(in out) :: fits
    real(dbl), dimension(:), intent(in) :: ph,dph,phsky,dphsky
    integer :: ncat

    ncat = size(ph)
    allocate(fits%ph(ncat),fits%dph(ncat),fits%phsky(ncat),fits%dphsky(ncat))
    allocate(fits%mag(ncat),fits%dmag(ncat))
    fits%ph = ph
    fits%dph = dph
    fits%phsky = phsky
    fits%dphsky = dphsky

  end subroutine qfits_setph

end module sfits

!
!  time series of photometric quantities (light curves) extracted from calibrated images
!
!  Copyright © 2012-4 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


program timeseries

  use tmseries
  use fitsio

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  character(len=FLEN_FILENAME) :: filename,output,backup,cat
  character(len=4*FLEN_FILENAME) :: line,key,val, timetype = 'JD', timestamp = 'MID', &
       cootype = 'DEG'
  real(dbl), dimension(:), allocatable :: xcoo, ycoo, vxcoo, vycoo
  character(len=FLEN_KEYWORD), dimension(:), allocatable :: fitskeys
  character(len=FLEN_VALUE), dimension(:), allocatable :: cols,coocols
  character(len=FLEN_FILENAME), dimension(:), allocatable :: files
  real(dbl) :: tol = -1.0, x, y, min0 = 0.0, per = 1.0, epoch = 0.0,timeerr = -1, timeres = -1
  logical :: stdout = .false.
  logical :: verbose = .false., diffmag = .false.
  integer :: i,eq,ncoo,nfiles,ncols,ncoocols,status

  nfiles = 0
  ncoo = 0
  ncols = 0
  ncoocols = 0

  extname = PHOTOEXTNAME
  allocate(cols(0),coocols(0))

  allocate(fitskeys(15))
  fitskeys(1) = FITS_KEY_DATEOBS
  fitskeys(2) = 'TIME-OBS'
  fitskeys(3) = FITS_KEY_EXPTIME
  fitskeys(4) = FITS_KEY_FILTER
  fitskeys(5) = 'EQUINOX'
  fitskeys(6) = FITS_KEY_OBJECT
  fitskeys(7) = FITS_KEY_OBSERVER
  fitskeys(8) = FITS_KEY_AUTHOR
  fitskeys(9) = FITS_KEY_INSTRUME
  fitskeys(10) = FITS_KEY_TELESCOP
  fitskeys(11) = FITS_KEY_ORIGIN
  fitskeys(12) = FITS_KEY_BIBREF
  fitskeys(13) = FITS_KEY_LATITUDE
  fitskeys(14) = FITS_KEY_LONGITUDE
  fitskeys(15) = FITS_KEY_PHOTSYS

  do
     read(*,'(a)',end=99) line

     eq = index(line,'=')
     if( eq == 0 ) stop 'Improper input.'

     key = line(:eq-1)
     val = line(eq+1:)

     if( key == 'OUTPUT' ) then

        read(val,*) output,backup

     else if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'EXTNAME' ) then

        read(val,*) extname

     else if( key == 'NCOOCOL' ) then

        read(val,*) ncoocols
        deallocate(coocols)
        allocate(coocols(ncoocols))

     else if( key == 'COOCOL' ) then

        read(val,*) coocols


     else if( key == 'NCOL' ) then

        read(val,*) ncols
        deallocate(cols)
        allocate(cols(ncols))

     else if( key == 'COL' ) then

        read(val,*) cols


     else if( key == 'COOTYPE' ) then

        read(val,*) cootype

     else if( key == 'TIMETYPE' ) then

        read(val,*) timetype

     else if( key == 'TIMESTAMP' ) then

        read(val,*) timestamp

     else if( key == 'TIMEERR' ) then

        read(val,*) timeerr

     else if( key == 'TIMERES' ) then

        read(val,*) timeres

     else if( key == 'NCOO' ) then

        read(val,*) ncoo

        allocate(xcoo(ncoo),ycoo(ncoo),vxcoo(ncoo),vycoo(ncoo))
        ncoo = 0
        vxcoo = 0.0_dbl
        vycoo = 0.0_dbl

     else if( key == 'COO' ) then

        read(val,*) x,y

        if( allocated(xcoo) .and. ncoo < size(xcoo) ) then

           ncoo =  ncoo + 1
           xcoo(ncoo) = x
           ycoo(ncoo) = y

        end if

     else if( key == 'TOL' ) then

        read(val,*) tol

     else if( key == 'DIFFMAG' ) then

        read(val,*) diffmag

     else if( key == 'EPOCH0' ) then

        read(val,*) min0

     else if( key == 'PERIOD' ) then

        read(val,*) per

     else if( key == 'FITS_KEY_DATEOBS' ) then
        read(val,*) fitskeys(1)

     else if( key == 'FITS_KEY_TIMEOBS' ) then ! candidate to remove?

        read(val,*) fitskeys(2)

     else if( key == 'FITS_KEY_EXPTIME'  ) then
        read(val,*) fitskeys(3)

     else if( key == 'FITS_KEY_FILTER' ) then
        read(val,*) fitskeys(4)

     else if( key == 'STDOUT' ) then

        read(val,*) stdout

     else if( key == 'CATALOGUE' ) then

        read(val,*) cat
        call readcat(cat,epoch,xcoo,ycoo,vxcoo,vycoo,status)
        if( status /= 0 ) stop 'Failed to read a catalogue.'
        ncoo = size(xcoo)

     else if( key == 'NFILES' ) then

        read(val,*) nfiles

        allocate(files(nfiles))
        nfiles = 0

     else if( key == 'FILE' ) then

        read(val,*) filename

        if( allocated(files) .and. nfiles < size(files) ) then
           nfiles = nfiles + 1
           files(nfiles) = filename
        end if

     end if

  end do
99 continue

  if( nfiles == 0 ) stop 'No files on input.'

  if( (size(cols) == 0 .or. size(coocols) == 0) .and. extname == PHOTOEXTNAME ) &
       call colinit(files(1))

  call tmseries_init(timetype,timestamp,timeerr,timeres,cootype,nfiles,fitskeys, &
       extname,coocols,cols, tol,min0,per,epoch,diffmag, &
       verbose,stdout,ncoo==0)

  if( allocated(xcoo) ) call tmseries_coo(xcoo,ycoo,vxcoo,vycoo)

  do i = 1,nfiles
     call tmseries_add(files(i))
  end do

  call tmseries_finish(output,backup)

  deallocate(fitskeys)
  if( allocated(files) ) deallocate(files)
  if( allocated(xcoo) ) deallocate(xcoo,ycoo,vxcoo,vycoo)
  deallocate(cols,coocols)

  stop 0

contains

  subroutine readcat(cat,epoch,ra,dec,pmra,pmdec,status)

    use fitsio

    character(len=*), intent(in) :: cat
    real(dbl), intent(out) :: epoch
    real(dbl), dimension(:), allocatable, intent(out) :: ra,dec,pmra,pmdec
    integer, intent(out) :: status

    integer, parameter :: frow = 1, felem = 1
    real(dbl), parameter :: nullval = 0.0_dbl
    real(dbl), parameter :: xpm = 365.25_dbl * 3600.0_dbl

    integer :: nrows, ncols, i
    integer, parameter :: nlabels = 4
    integer, dimension(nlabels) :: col
    character(len=FLEN_VALUE), dimension(nlabels) :: labels
    character(len=FLEN_CARD) :: runits,dunits,buf
    logical :: anyf

    labels(1) = FITS_COL_RA
    labels(2) = FITS_COL_DEC
    labels(3) = FITS_COL_PMRA
    labels(4) = FITS_COL_PMDEC

    status = 0

    call fttopn(15,cat,0,status)
    call ftgkyd(15,FITS_KEY_EPOCH,epoch,buf,status)
    if( status == KEYWORD_NOT_FOUND ) then
       status = 0
       epoch = 2451545.0_dbl
    end if

    call ftgncl(15,ncols,status)
    call ftgnrw(15,nrows,status)
    if( ncols /= size(labels) ) stop 'ncols /= size(labels)'

    ! find columns by labels
    do i = 1, size(labels)
       call ftgcno(15,.true.,labels(i),col(i),status)
    end do
    if( status /= 0 ) goto 666

    ! get units of PM_*
    call ftgkys(15,'TUNIT3',runits,buf,status)
    call ftgkys(15,'TUNIT4',dunits,buf,status)

    allocate(ra(nrows),dec(nrows),pmra(nrows),pmdec(nrows))

    call ftgcvd(15,col(1),frow,felem,nrows,nullval,ra,anyf,status)
    call ftgcvd(15,col(2),frow,felem,nrows,nullval,dec,anyf,status)
    call ftgcvd(15,col(3),frow,felem,nrows,nullval,pmra,anyf,status)
    call ftgcvd(15,col(4),frow,felem,nrows,nullval,pmdec,anyf,status)

    if( status /= 0 ) goto 666

    if( runits == 'arcsec/year' )  pmra = pmra  / xpm
    if( dunits == 'arcsec/year' ) pmdec = pmdec / xpm

    call ftclos(15,status)
    if( status /= 0 ) goto 666

    return

666 continue

    deallocate(ra,dec,pmra,pmdec)

    call ftclos(15,status)
    call ftrprt('STDERR',status)

  end subroutine readcat



  subroutine colinit(filename)

    character(len=*), intent(in) :: filename

    integer, parameter :: extver = 0
    integer :: status, blocksize, ncols, n
    character(len=FLEN_VALUE) :: ttype,key
    character(len=FLEN_COMMENT) :: com

    ! input FITS file
    status = 0
    call ftopen(20,filename,0,blocksize,status)

    ! looking for photometry extension
    call ftmnhd(20,BINARY_TBL,PHOTOEXTNAME,extver,status)
    call ftgncl(20,ncols,status)
    if( status /= 0 .or. ncols < 3 ) goto 666

    if( size(coocols) == 0 ) then
       deallocate(coocols)
       allocate(coocols(2))
       do n = 1,2
          call ftkeyn('TTYPE',n,key,status)
          call ftgkys(20,key,ttype,com,status)
          if( status /= 0 ) goto 666
          coocols(n) = ttype
       end do
    end if

    if( size(cols) == 0 ) then
       deallocate(cols)
       allocate(cols(ncols-2))
       do n = 3,ncols
          call ftkeyn('TTYPE',n,key,status)
          call ftgkys(20,key,ttype,com,status)
          if( status /= 0 ) goto 666
          cols(n-2) = ttype
       end do
    end if

666 continue
    call ftclos(20,status)
    call ftrprt('STDERR',status)

    if( status == BAD_HDU_NUM ) stop 'Photometry extension not found.'

  end subroutine Colinit


end program timeseries

!
!  stat -  a library of basic statistical estimates
!
!  Copyright © 2011, 2017 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

module means

  implicit none

  ! precision of real numbers
  integer, parameter, private :: rp = selected_real_kind(15)

  interface mean
     module procedure mean_double, mean_single
  end interface mean

contains

  subroutine mean_double(x,t,dt)

    real(rp), dimension(:), intent(in) :: x
    real(rp), intent(out) :: t,dt
    integer :: n

    n = size(x)
    if( n <= 0 ) then
       t = 0.0_rp
       dt = 0.0_rp
    else if( n == 1 ) then
       t = x(1)
       dt = 0.0_rp
    else
       t = sum(x)/n
       dt = sqrt(sum((x - t)**2)/(n - 1))
    endif

  end subroutine mean_double

  subroutine mean_single(x,t,dt)

    real, dimension(:), intent(in) :: x
    real, intent(out) :: t,dt
    integer :: n

    n = size(x)
    if( n <= 0 ) then
       t = 0.0
       dt = 0.0
    else if( n == 1 ) then
       t = x(1)
       dt = 0.0
    else
       t = sum(x)/n
       dt = sqrt(sum((x - t)**2)/(n - 1))
    endif

  end subroutine mean_single

end module means

!
!  munilist
!
!  Copyright © 2012-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module mtable


  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl

contains

  subroutine table(filename,extname,fitskeys,headkeys,coonames,colnames,verbose,&
       cootype, &
       fitsval,headval,photsys,filter,year,month,day,hour,min,sec,airmass,exptime, &
       tproj,coo,data,status)

    use fitsio
    use astrotrafo
    use phio
    use iso_fortran_env

    logical, intent(in) :: verbose
    character(len=*), intent(in) :: filename, extname, cootype
    character(len=*), intent(out) :: filter, photsys
    character(len=*), dimension(:), intent(in) :: fitskeys, headkeys, coonames,colnames
    character(len=*), dimension(:), intent(inout) :: fitsval,headval
    real(dbl), intent(out) :: year,month,day,hour,min,sec,airmass,exptime
    real(dbl), dimension(:,:), allocatable, intent(out) :: coo,data
    type(AstroTrafoProj),intent(out) :: tproj
    integer, intent(out) :: status

    integer, parameter :: DIM = 2
    integer, dimension(DIM) :: naxes
    real(dbl), dimension(:), allocatable :: tmp
    integer :: naxis,pcount,gcount,bitpix,nrows,colnum,frow,felem, &
         ndata,i,y1,m1,d1,h1,min1,ctaper,ncols
    logical :: simple,extend,anyf
    real(dbl) :: nullval
    character(len=80) :: line, buf,colname,card, key

    line = ''; buf = ''; colname = ''; card = ''; key = ''

    frow = 1
    felem = 1
    nullval = 0.0_dbl
    ctaper = 0

    ! input FITS file
    status = 0
    call ftdopn(20,filename,0,status)

    call ftghpr(20,DIM,simple,bitpix,naxis,naxes,pcount,gcount,extend,status)
    if( status /= 0 ) then
       if( verbose ) write(error_unit,*) "Failed to open: ",trim(filename)
       goto 666
    endif

    ! read date and time
    call datetime(20,fitskeys(1:2),y1,m1,d1,h1,min1,sec,status)
    if( status == 0 ) then
       year = y1; month = m1; day = d1; hour = h1; min = min1
    else
!      if( verbose ) write(error_unit,*) "Warning: Failed to get date or time."
       goto 666
    end if

    ! read date, time, exposure, filter
    call ftgkyd(20,fitskeys(3),exptime,buf,status)
    if( status == KEYWORD_NOT_FOUND ) then
       exptime = 1.0
!       if( verbose ) write(*,*) 'Exposure time not found. Assumed =0.'
       status = 0
    endif

    ! read date, time, exposure, filter
    call ftgkys(20,fitskeys(4),filter,buf,status)
    if( status == KEYWORD_NOT_FOUND ) then
       filter = ''
!       if( verbose )  write(*,*) 'Filter not found.'
       status = 0
    endif

    call ftgkys(20,fitskeys(15),photsys,buf,status)
    if( status == KEYWORD_NOT_FOUND ) then
       photsys = ''
       status = 0
    endif

    ! required header quantities
    do i = 1, size(fitskeys)

       call ftgkys(20,fitskeys(i),line,buf,status)
       if( status == 0 ) then
          fitsval(i) = line
       else
          fitsval(i) = ''
          status = 0
       end if
    end do

    do i = 1, size(headkeys)

       call ftgkys(20,headkeys(i),line,buf,status)
       if( status == 0 ) then
          headval(i) = line
       else
          headval(i) = ''
          status = 0
       end if

    end do

    if( cootype == 'DEG' ) then
       call wcsget(20,tproj,status)
    else if( cootype == 'RECT' ) then
       tproj%type = ''
    end if

    ! select data extension
    call ftmnhd(20,BINARY_TBL,extname,0,status)
    if( status == BAD_HDU_NUM ) then
       if( verbose ) write(error_unit,*)  &
            "Failed to find a photometry extension: ",trim(filename)
       goto 666
    end if

    call ftgkyd(20,'AIRMASS',airmass,buf,status)

    ! possible keys in table HDU
    do i = 1, size(headkeys)

       call ftgkys(20,headkeys(i),line,buf,status)
       if( status == 0 ) then
          headval(i) = line
       else
          status = 0
       end if

    end do

    call ftgnrw(20,nrows,status)
    if( status /= 0 ) goto 666

    ! table
    ncols = size(coonames)
    allocate(coo(nrows,ncols))
    allocate(tmp(nrows))

    do i = 1, ncols
       call ftgcno(20,.true.,coonames(i),colnum,status)
       call ftgcvd(20,colnum,frow,felem,nrows,nullval,tmp,anyf,status)
       coo(:,i) = tmp
    end do

    ndata = size(colnames)
    allocate(data(nrows,ndata))
    do i = 1, ndata
       call ftgcno(20,.true.,colnames(i),colnum,status)
       call ftgcvd(20,colnum,frow,felem,nrows,nullval,tmp,anyf,status)
       if( status == 0 ) data(:,i) = tmp
    end do
    deallocate(tmp)

666 continue

    call ftclos(20,status)
    call ftrprt('STDERR',status)

  end subroutine table

end module mtable

! gfortran -Wall --check=all  -I../lib rratio.f95 testcal.f95 -L. -L../lib -L../minpack -lrstat -lsort -llmin -lminpacks -lminpack -lm


program testcal

  use robratio
  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  integer, parameter :: nmax = 15
  real(dbl), dimension(nmax) :: ph,dph,ct,dct
  real(dbl) :: r,dr,x,y,z,dx,dy
  integer :: i,k

!    write(*,*) 'sss'

!  x = inverf(-1.5_dbl)
!  x = inverf(-0.7_dbl)
!  x = inverf(0.0_dbl)
!  x = inverf(0.3_dbl)
!  x = inverf(1.5_dbl)
!stop 'sss'

  goto 33
  do i = 1,nmax
     ph(i) = pnoise(200.0_dbl)
     dph(i) = sqrt(ph(i))
     ct(i) = pnoise(100.0_dbl)
     dct(i) = sqrt(ct(i))
  end do

  call rcal(ph,dph,ct,dct,r,dr,.true.)


  do i = 1,nmax
     ph(i) = gdis(20000.0_dbl,141.42_dbl)
     dph(i) = sqrt(ph(i))
     ct(i) = gdis(10000.0_dbl,100.0_dbl)
     dct(i) = sqrt(ct(i))
  end do
  call rcal(ph,dph,ct,dct,r,dr,.true.)
33 continue

  do i = 1,nmax
     r = 1000 + 20*i
     !ph(i) = gdis(2*r,sqrt(2*r))
     ph(i) = pnoise(1*r)
     dph(i) = sqrt(ph(i))
!     ct(i) = gdis(r,sqrt(r))
     ct(i) = pnoise(r)
     dct(i) = sqrt(ct(i))
  end do
  call rcal(ph,dph,ct,dct,r,dr,.true.)

!  write(*,*) 'Non-robust:',sqrt(sum((ph - ct)**2) / nmax)

  stop

  open(1,file='/tmp/xdist')
  do k = 1,10000,10
     r = k
     do i = 1,nmax
        ph(i) = pnoise(r)
     end do
     x = sum(ph) / nmax
     dx = sqrt(sum((ph-x)**2)/nmax)
     do i = 1,nmax
        ph(i) = gdis(r,sqrt(r))
     end do
     y = sum(ph) / nmax
     dy = sqrt(sum((ph-y)**2)/nmax)
     write(1,*) k,x,dx,y,dy
  end do
  close(1)


  open(1,file='/tmp/err')
  do i = -5000,5000,10
     r = i / 1e3
     x = erf(r)
     write(1,*) r,x,ierf(x)-r,inverf(x)-r
  end do
  close(1)

  ! comparison rratios, Anscombe and magnitudes
  ! https://en.wikipedia.org/wiki/Anscombe_transform
  open(1,file='/tmp/ans')
  do k = 1,8
     r = 100 + 10**k
     do i = 1,nmax
        ph(i) = pnoise(r)
     end do
     x = sum(ph/sqrt(ph))/nmax
     y = sum(log10(ph))/nmax
     z = sum(2*sqrt(ph+3.0/8.0))/nmax
     write(*,*) r,x**2/r,10**y/r, &
          ((z/2)**2 - 1.0/8.0 + 0.306186218/z - 1.375/z**2 + 0.765465545/z**3 )/r, &
          (sum(ph)/nmax)/r
  end do
  close(1)

contains

  function pnoise(lam)

    real(dbl), intent(in) :: lam
    real(dbl) :: pnoise

    if( lam  < 500 ) then
       pnoise = pnoise_knuth(lam)
    else
       pnoise = gdis(lam,sqrt(lam))
    end if

  end function pnoise


  function pnoise_junhao(lam) result(k)

    ! Junhao, based on Knuth:
    !    http://en.wikipedia.org/wiki/Poisson_distribution

    real(dbl), intent(in) :: lam
    real(dbl), parameter :: e = exp(1.0_dbl)
    real(dbl), parameter :: lx = 500
    real(dbl), parameter :: elx = exp(lx)
    real(dbl) :: l,p,u
    integer :: k

    l = lam
    k = 0
    p = 1
    do
       k = k + 1
       call random_number(u)
       p = p*u
       if( p < e .and. l > 0 ) then
          if( l > lx ) then
             p = p * elx
             l = l - lx
          else
             p = p * exp(l)
             l = -1
          end if
       end if
       if( .not. (p > 1) ) exit
    enddo
    k = k - 1

  end function pnoise_junhao

  function pnoise_knuth(lam) result(k)

    ! Knuth's algorithm by http://en.wikipedia.org/wiki/Poisson_distribution

    real(dbl), intent(in) :: lam
    real(dbl) :: L,p,u
    integer :: k

    L = exp(-lam)
    k = 0
    p = 1
    do
       k = k + 1
       call random_number(u)
       p = p*u
       if( .not. (p > L) ) exit
    enddo
    k = k - 1

  end function pnoise_knuth

  function gdis(mean, sig)

    ! generate random data with gauss distribution

    real(dbl), intent(in) :: mean, sig
    real(dbl) :: gdis, x

    call random_number(x)
!    gdis = mean + 1.618*sqrt(2.0)*sig*ierf(2*x-1) ! Numerical Recipes (6.14.3)
    gdis = mean + sqrt(2.0)*sig*inverf(2*x-1)

  end function gdis

  function ierf(x)

    ! http://en.wikipedia.org/wiki/Error_function

    real(dbl), intent(in) :: x
    real(dbl) :: ierf, u, v, a, y, w

    a = 0.140012288686666
    u = log(1 - x**2)
    v = 2/3.14159265358979/a
    y = v + u/2

    w = sqrt(y**2 - u/a)
    ierf = sign(1.0d0,x)*sqrt(w - v)

  end function ierf


  ! by Numerical Recipes
  function inverf(p)

    real(dbl), intent(in) :: p
    real(dbl) :: inverf, pp,x,t,err
    integer :: j

    if( abs(p) < 1 ) then
       pp = 1 - abs(p)
       t = sqrt(-2.0_dbl*log(pp/2))
       x = - 0.70711*((2.30753+t*0.27061)/(1 + t*(0.99229+t*0.04481)) - t)
       do j = 1,2
          err = 1 - erf(x) - pp
          x = x + err/(1.128379167099551257 * exp(-x**2) - x*err)
       end do
       inverf = -sign(x,-p)

    else
       inverf = sign(huge(p),p)
    end if

  end function inverf


end program testcal

!
!  Tolerant FITSio subroutine
!
!  Copyright © 2012-4,16 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

module xfitsio

  use fitsio
  use iso_fortran_env

  implicit none

  type xFITS
     character(len=FLEN_FILENAME) :: filename
     real,dimension(:,:),allocatable :: image, stderr
     integer :: naxis, bitpix, nhead, chdu, nhdu
     integer, dimension(2) :: naxes
     character(len=FLEN_CARD), dimension(:), allocatable :: head
     logical :: status
  end type xFITS


contains

  subroutine xfits_init(fits)

    type(xFITS), intent(out) :: fits
    fits%status = .false.
    fits%filename = ''
    fits%naxis = 0
    fits%bitpix = 0
    fits%naxes = 0
    fits%nhead = 0
    fits%nhdu = 0
    fits%chdu = 0

  end subroutine xfits_init

  subroutine xfits_read(file,fits)

    character(len=*), intent(in) :: file
    type(xFITS), intent(out) :: fits

    integer :: istat,n,nh,nhead,extver
    real :: minvalue
    character(len=FLEN_CARD) :: buf
    character(len=FLEN_CARD), dimension(:), allocatable :: head
    logical :: anyf

    minvalue = -huge(minvalue)
    extver = 0

    istat = 0
    call xfits_deallocate(fits)
    call xfits_init(fits)

    fits%filename = file
    call ftdopn(20,file,0,istat)
    call ftgidt(20,fits%bitpix,istat)
    call ftgidm(20,fits%naxis,istat)
    call ftthdu(20,fits%nhdu,istat)
    if( istat /= 0 ) goto 666

    call ftghdn(20,fits%chdu)

    if( fits%naxis /= size(fits%naxes) ) then !stop 'naxis /= 2'
       write(error_unit,*) trim(file),": Assertion failed: naxis /= 2"
       goto 666
    end if

    call ftgisz(20,fits%naxis,fits%naxes,istat)

    if( istat /= 0 ) goto 666

    call ftghps(20,nhead,n,istat)
    if( istat /= 0 ) goto 666
    allocate(head(nhead))
    nh = 0
    do n = 1, nhead
       buf = ''
       call ftgrec(20,n,buf,istat)
       if( istat /= 0 ) goto 666
       if( ftgkcl(buf) > TYP_CMPRS_KEY ) then
          nh = nh + 1
          head(nh) = buf
       end if
    end do
    fits%nhead = nh
    allocate(fits%head(nh))
    fits%head = head(1:nh)
    deallocate(head)

    allocate(fits%image(fits%naxes(1),fits%naxes(2)), &
         fits%stderr(fits%naxes(1),fits%naxes(2)))
    call ftg2de(20,1,minvalue,fits%naxes(1),fits%naxes(1),fits%naxes(2),fits%image,&
         anyf,istat)

    call ftmnhd(20,IMAGE_HDU,EXT_STDERR,extver,istat)
    if( istat == 0 ) then
       call ftg2de(20,1,minvalue,fits%naxes(1),fits%naxes(1),fits%naxes(2),fits%stderr,&
            anyf,istat)
    else
       ! if the information about standard deviation is not available,
       ! we are continuing with epsilons
       fits%stderr = epsilon(fits%stderr)
       istat = 0
    end if

    call ftclos(20,istat)
    if( istat /= 0 ) goto 666

    fits%status = .true.
    return

666 continue

    call xfits_deallocate(fits)
    call ftclos(20,istat)
    call ftrprt('STDERR',istat)
    fits%status = .false.

  end subroutine xfits_read

  subroutine xfits_deallocate(fits)

    type(xFITS), intent(in out) :: fits

    if( allocated(fits%image) ) deallocate(fits%image)
    if( allocated(fits%stderr) ) deallocate(fits%stderr)
    if( allocated(fits%head) ) deallocate(fits%head)

  end subroutine xfits_deallocate

  subroutine xfits_kyd(fits,key,n,status)

    type(xFITS), intent(in) :: fits
    character(len=*), intent(in) :: key
    integer, intent(out) :: n
    integer, intent(in out) :: status
    integer :: i,keylength
    character(len=FLEN_CARD) :: keyname,value,comment

    if( status /= 0 ) return

    do i = 1,size(fits%head)
       keyname = ''
       call ftgknm(fits%head(i),keyname, keylength, status)
       if( status /= 0 ) exit

       if( key == keyname ) then
          value = ''
          comment = ''
          call ftpsvc(fits%head(i),value,comment,status)
          if( status /= 0 ) exit
          read(value,*,iostat=status) n
          return
       end if
    end do
    status = 1

  end subroutine xfits_kyd

  subroutine xfits_kye(fits,key,x,status)

    type(xFITS), intent(in) :: fits
    character(len=*), intent(in) :: key
    real, intent(out) :: x
    integer, intent(in out) :: status
    integer :: i,keylength
    character(len=FLEN_CARD) :: keyname,value,comment

    if( status /= 0 ) return

    do i = 1,size(fits%head)
       keyname = ''
       call ftgknm(fits%head(i),keyname, keylength, status)
       if( status /= 0 ) exit

       if( key == keyname ) then
          value = ''
          comment = ''
          call ftpsvc(fits%head(i),value,comment,status)
          if( status /= 0 ) exit
          read(value,*,iostat=status) x
          return
       end if
    end do
    status = 1

  end subroutine xfits_kye

  subroutine xfits_kys(fits,key,a,status)

    type(xFITS), intent(in) :: fits
    character(len=*), intent(in) :: key
    character(len=*), intent(out) :: a
    integer, intent(in out) :: status
    integer :: i,keylength
    character(len=FLEN_CARD) :: keyname,value,comment

    if( status /= 0 ) return

    do i = 1,size(fits%head)
       keyname = ''
       call ftgknm(fits%head(i),keyname, keylength, status)
       if( status /= 0 ) exit

       if( key == keyname ) then
          value = ''
          comment = ''
          call ftpsvc(fits%head(i),value,comment,status)
          if( status /= 0 ) exit
          read(value,*,iostat=status) a
          return
       end if
    end do
    status = 1

  end subroutine xfits_kys


end module xfitsio

!
!  Phcorr - photometric corrections
!  Copyright (C) 2012-4, 2016-7  Filip Hroch, Masaryk University, Brno, CZ
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

program phcorr

  use robustmean
  use weightedmean
  use fitsio
  use xfitsio
  use iso_fortran_env

  implicit none

  ! No. of image dimensions
  integer, parameter :: DIM = 2

  character(len=*), parameter :: phid = 'PHCORR'

  ! This utility assumes that output image has in intensity
  ! within range minvalue < x < maxvalue.
  ! The minvalue always is 0 for measured intensities (?)
  ! The maxvalue is determined as (2**bitpix - 1).
  ! The specific characteristic of dark images may require some modification
  ! for real-type intensity of image.
  !real, parameter :: minvalue = 0.0

  character(len=FLEN_FILENAME) :: sciname,flatname='',biasname='',darkname='', &
       maskname='', outname,buf,backup,newname

  character(len=4*FLEN_FILENAME) :: key,val,record,flattext,darktext,biastext

  character(len=FLEN_KEYWORD) :: DATE_OBS=FITS_KEY_DATEOBS, &
       TEMPERAT=FITS_KEY_TEMPERATURE, EXPTIME=FITS_KEY_EXPTIME, &
       FILTER=FITS_KEY_FILTER,KEY_GAIN=FITS_KEY_GAIN, &
       KEY_SATURATE=FITS_KEY_SATURATE,flatfilter,filt,tmask

  integer :: i,j,eq,istat,blocksize,hdutype
  real :: xerr, t, temp, xmask
  real, dimension(:,:), allocatable :: FLAT, BIAS, DARK, MASK, OUT, &
       DFLAT, DBIAS, DDARK, DOUT
  logical :: verbose = .false.
  logical :: force_apply = .false.
  logical :: normalise = .false.
  logical :: phalready
  logical :: bitpix_user = .false.
  logical :: gain_set = .false.
  logical :: gain_apply = .true.
  logical :: saturate_set = .false.
  real :: saturate
  real :: tol_exptime = 1e-6
  real :: tol_temperat = 1.0
  real :: xdark = -1.0
  real :: etime = -1.0
  real :: darktemp, darketime = -1.0
  real :: flatmean = 1.0
  real :: gain = 1
  integer :: bitpix = -32

  type(xFITS) :: fits, biasfits, darkfits, flatfits, maskfits

  i = 0
  buf = ''

  call xfits_init(biasfits)
  call xfits_init(darkfits)
  call xfits_init(flatfits)
  call xfits_init(maskfits)

  do
     read(*,'(a)',end=20) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Improper input.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then
        read(val,*) verbose
     endif

     if( key == 'BITPIX' ) then
        read(val,*) bitpix
        bitpix_user = .true.
     endif

     if( key == 'FITS_KEY_DATEOBS' ) then
        read(val,*) DATE_OBS
     endif

     if( key == 'FITS_KEY_FILTER' ) then
        read(val,*) FILTER
     endif

     if( key == 'FITS_KEY_TEMPERATURE' ) then
        read(val,*) TEMPERAT
     endif

     if( key == 'FITS_KEY_EXPTIME' ) then
        read(val,*) EXPTIME
     endif

     if( key == 'FITS_KEY_SATURATE' ) then
        read(val,*) KEY_SATURATE
     endif

     if( key == 'FITS_KEY_GAIN' ) then
        read(val,*) KEY_GAIN
     endif

     if( key == 'GAIN' ) then
        read(val,*) gain
        gain_set = .true.
     endif

     if( key == 'GAIN_APPLY' ) then
        read(val,*) gain_apply
     endif

     if( key == 'TOL_TEMPERATURE' ) then
        read(val,*) tol_temperat
     endif

     if( key == 'TOL_EXPOSURE' ) then
        read(val,*) tol_exptime
     endif

     if( key == 'FORCEAPPLY' ) then
        read(val,*) force_apply
     endif

     if( key == 'NORMALISE' ) then
        read(val,*) normalise
     endif

     if( key == 'FLAT' ) then

        read(val,*) flatname
        if( verbose ) write(error_unit,*) "FLAT=",trim(flatname)
        call xfits_read(flatname,flatfits)
        if( .not. flatfits%status ) stop 'Failed to load flat-field frame.'

        istat = 0
        call xfits_kys(flatfits,FILTER,flatfilter,istat)
        if( istat /= 0 ) then
           istat = 0
           flatfilter = ''
           if( verbose ) &
                write(error_unit,*) &
                "Warning: a photometric filter of flat-field unknown."
        end if


        if( normalise .or. flatfits%bitpix > 0 ) then

           ! average of flat
           call rwmean(pack(flatfits%image, flatfits%stderr > 0),&
                       pack(flatfits%stderr,flatfits%stderr > 0),flatmean,xerr)

           if( verbose ) &
                write(error_unit,*) 'Flat-frame statistics: mean=', &
                flatmean,'+-',xerr

           if( flatmean < epsilon(flatmean) ) &
                stop 'Mean of flat is not positive.'

        end if

     end if

     if( key == 'BIAS' ) then

        read(val,*) biasname
        if( verbose ) write(error_unit,*) "BIAS=",trim(biasname)
        call xfits_read(biasname,biasfits)
        if( .not. biasfits%status ) stop 'Failed to load bias frame.'

     end if

     if( key == 'DARK' ) then

        read(val,*) darkname
        if( verbose ) write(error_unit,*) "DARK=",trim(darkname)
        call xfits_read(darkname,darkfits)
        if( .not. darkfits%status ) stop 'Failed to load dark frame.'

        istat = 0
        call xfits_kye(darkfits,EXPTIME,darketime,istat)
        if( istat /= 0 ) then
           istat = 0
           darketime = -1
           if( verbose ) &
                write(error_unit,*) "An exposure time for dark frame unknown."
        end if

        call xfits_kye(darkfits,TEMPERAT,darktemp,istat)
        if( istat /= 0 ) then
           istat = 0
           darktemp = -999
           if( verbose ) &
                write(error_unit,*) "A temperature for dark frame unknown."
        end if

     end if

     if( key == 'XDARK' ) then
        read(val,*) xdark
     end if

     if( key == 'MASK' ) then

        read(val,*) maskname
        if( verbose ) write(error_unit,*) "MASK=",trim(maskname)
        call xfits_read(maskname,maskfits)
        if( .not. maskfits%status ) stop 'Failed to load mask frame.'

     end if

     if( key == 'XMASK' ) then
        read(val,*) tmask
     end if

     if( key == 'FILE' ) then

        read(val,*) sciname,backup,newname
        if( verbose ) write(error_unit,'(a)',advance="no") ' ('//trim(sciname)

        call xfits_init(fits)
        call xfits_read(sciname,fits)
        if( .not. fits%status ) then
           write(error_unit,*) &
                "Warning: Failed to read `",trim(sciname),"'. Skippy."
           call xfits_deallocate(fits)
           goto 665
        end if

        istat = 0

        call xfits_kye(fits,TEMPERAT,temp,istat)
        if( istat /= 0 ) then
           istat = 0
           temp = -999
        end if

        call xfits_kye(fits,EXPTIME,etime,istat)
        if( istat /= 0 ) then
           istat = 0
           etime = -1
        end if

        call xfits_kys(fits,FILTER,filt,istat)
        if( istat /= 0 ) then
           istat = 0
           filt = ''
        end if

        if( .not. gain_set .and. gain_apply ) then
           call xfits_kye(fits,KEY_GAIN,gain,istat)
           gain_set = istat == 0
           if( istat /= 0 ) then
              write(error_unit,*) &
                "Warning: Gain keyword not found in FITS header Skipping: `", &
                trim(sciname),"'"
              goto 665
           end if
        end if
        if( .not. (gain > 0) ) then
           write(error_unit,*) &
                "Warning: assumed gain > 0 ... Skipping: `",trim(sciname),"'"
           goto 665
        end if

        call xfits_kye(fits,KEY_SATURATE,saturate,istat)
        saturate_set = istat == 0
        if( istat /= 0 ) istat = 0

        ! check of already corrected images
        phalready = .false.
        do j = 1, fits%nhead
           if( index(fits%head(j),phid) > 0 ) phalready = .true.
        enddo

        if( phalready .and. .not. force_apply ) then
           write(error_unit,*) &
                "Warning: Photometric corrections already applied.", &
                " Skipping: `",trim(sciname),"'"
           goto 665
        end if

        allocate(FLAT(fits%naxes(1),fits%naxes(2)),DFLAT(fits%naxes(1),fits%naxes(2)))
        FLAT = 1.0
        DFLAT = epsilon(DFLAT)

        allocate(BIAS(fits%naxes(1),fits%naxes(2)),DBIAS(fits%naxes(1),fits%naxes(2)))
        BIAS = 0.0
        DBIAS = epsilon(DBIAS)

        allocate(DARK(fits%naxes(1),fits%naxes(2)),DDARK(fits%naxes(1),fits%naxes(2)))
        DARK = 0.0
        DDARK = epsilon(DDARK)

        if( flatfits%status ) then
           if( .not. all(flatfits%naxes == fits%naxes) )then
              write(error_unit,*) &
                   "Warning: Flat-field size does not match corrected frame.",&
                   "Skipped."
              goto 665
           end if

           if( verbose .and. flatfilter /= '' .and. filt /= '' )then
              if( flatfilter /= filt ) &
                   write(error_unit,*) "Warning: filters does not match."
           end if

           FLAT =  flatfits%image / flatmean
           DFLAT = flatfits%stderr / flatmean

        endif

        if( biasfits%status ) then
           if( .not. all(biasfits%naxes == fits%naxes) )then
              write(error_unit,*) &
                   "Warning: Frame and bias sizes does not match. Skipping."
              goto 665
           end if
           BIAS = biasfits%image
           DBIAS = biasfits%stderr

        endif

        if( maskfits%status ) then
           if( .not. all(maskfits%naxes == fits%naxes) )then
              write(error_unit,*) &
                   "Warning: Frame and mask sizes does not match. Skipping."
              goto 665
           end if
        endif

        if( darkfits%status ) then
           if( .not. all(darkfits%naxes == fits%naxes) )then
              write(error_unit,*) &
                   "Warning: Frame and dark sizes does not match. Skipping."
              goto 665
           end if

           if( verbose .and. darktemp > -273.0 .and. temp > -273.0 )then
              if( abs(temp - darktemp) > tol_temperat ) &
                   write(error_unit,*) &
                   "Warning: Temperature diference over limit."
           end if

           if( xdark > 0.0 ) then
              t = xdark
           else if( darketime > 0 .and. etime > 0 ) then
              t = etime / darketime
           else
              t = 1
           end if

           DARK = darkfits%image
           DDARK = darkfits%stderr

        endif

        if( gain_apply .and. .not. gain_set ) then
           write(error_unit,*) &
                "Warning: Gain unset (use --gain or --gain-ignore). Skipping."
              goto 665
        end if

        if( verbose ) then

           flattext = ''
           biastext = ''
           darktext = ''

           if( flatname /= '' ) write(flattext,'(3a,1pg0.6,a)') &
                '/ (',trim(flatname),'/',flatmean,')'

           if( biasname /= '' ) &
                biastext = " - "//trim(biasname)

           if( darkname /= '' ) &
                write(darktext,'(a,f0.3,2a)') ' - ',t,'*',trim(darkname)

           write(error_unit,'(a)',advance="no") &
                trim(darktext)//trim(biastext)//') '//trim(flattext)//' ='
        end if

        allocate(OUT(fits%naxes(1),fits%naxes(2)), &
                DOUT(fits%naxes(1),fits%naxes(2)))

        ! the corrections, we are sure that FLAT > 0
        where( FLAT > 0 )
           OUT = gain*(fits%image - (t*DARK + BIAS)) / FLAT
        elsewhere
           OUT = gain*(fits%image - (t*DARK + BIAS))
        end where
        where( FLAT > 0 .and. OUT > 0 )
           DOUT = sqrt(OUT + gain**2*(t**2*DDARK**2 + DBIAS**2))
           DOUT = abs(OUT)*sqrt(DOUT**2/OUT**2 + DFLAT**2/FLAT**2)
        elsewhere
           ! defective pixels (?)
           OUT = 0
           DOUT = 1
        end where
        ! YES, this small piece of code is the full correction!!!
        ! All everything is just a practise in reading and writing
        ! of FITS files.

        ! convert saturation to electrons
        if( gain_apply .and. gain_set .and. saturate_set ) &
             saturate = gain*saturate

        ! masking
        if( maskfits%status ) then

           allocate(MASK(fits%naxes(1),fits%naxes(2)))
           MASK = maskfits%image

           if( tmask == "MEAN" ) then
              ! median of the image
              call rmean(pack(OUT,OUT>0),xmask,xerr)
              if( verbose ) &
                   write(error_unit,*) 'Mask frame statistics: mean=',&
                   xmask,'+-',xerr
           else ! if( tmask == "ZERO" ) then
              xmask = 0
              xerr = 0
           end if

           where( MASK < epsilon(MASK) )
              OUT = xmask
              DOUT = xerr
           end where

           deallocate(MASK)
        end if

        ! cut-off negative counts
        where( OUT < 0 )
           OUT = 0
        end where

        ! default bitpix
        if( .not. bitpix_user ) bitpix = -32

        ! write out corrected image
        i = 0
        call fitsback(sciname,backup,newname,.true.,outname,i)
        if( backup /= '' ) then
           call ftopen(25,backup,0,blocksize,i)
        else
           call ftopen(25,sciname,0,blocksize,i)
        end if
        call ftinit(26,outname,1,i)

        if( fits%nhdu > 1 ) then

           ! copy all extensions
           call ftcpfl(25,26,1,1,1,i)

           ! point to right
           call ftmahd(25,fits%chdu,hdutype,i)
           call ftmahd(26,fits%chdu,hdutype,i)

           ! remove old one
           call ftdhdu(26,hdutype,i)

        end if

        ! create new one
        call ftiimg(26,bitpix,fits%naxis,fits%naxes,i)
        ! copy user-level header records
        do j = 1, fits%nhead
           if( fits%head(j) /= '' ) call ftprec(26,fits%head(j),i)
        enddo

        call ftclos(25,i)
        if( i /= 0 ) goto 665

        if( bitpix > 0 ) then
           call ftukyj(26,'BSCALE',1,'',i)
           if( bitpix < 32) then
              call ftukyj(26,'BZERO',2**(bitpix-1),'',i)
           else
              call ftukyj(26,'BZERO',1,'',i)
              ! Important: the 2**(32-1) is undefined when
              ! we are using 32-bit integers (perhaps including
              ! any other processing). We are setting to fallback values.
           end if
        else
           call ftdkey(26,'BSCALE',i)
           if( i == KEYWORD_NOT_FOUND ) i = 0
           call ftdkey(26,'BZERO',i)
           if( i == KEYWORD_NOT_FOUND ) i = 0
        end if

        if( gain_apply ) then
           call ftukye(26,KEY_GAIN,gain,5,'[e-/ADU] amplifier gain used for conversion',i)
           call ftukys(26,FITS_KEY_BUNIT,'COUNTS','count of captured electrons',i)
           write(buf,'(g0.3)') gain
           if( saturate_set ) then
              call ftukye(26,KEY_SATURATE,saturate,-5,'[counts] saturation level',i)
              buf = trim(buf) // " (updated saturation)"
           end if
           call ftphis(26,phid//" gain: "//trim(buf),i)
        else
           call ftukys(26,FITS_KEY_BUNIT,'ADU','values directly provided by camera',i)
        end if

        if( flatname /= '' ) then
           write(buf,'(1pg0.6)') flatmean
           call ftphis(26,phid//" flat-field: '"//trim(flatname)//"' / "//trim(buf),i)
        end if

        if( darkname /= '' ) then
           write(buf,'(f0.5)') t
           call ftphis(26,phid//" dark: '"//trim(darkname)//"' * "//trim(buf),i)
        end if

        if( biasname /= '' ) then
           call ftphis(26,phid//" bias: '"//trim(biasname)//"'",i)
        end if

        if( maskname /= '' ) then
           call ftphis(26,phid//" mask: '"//trim(maskname)//"'",i)
        end if

        call ftukys(26,FITS_KEY_CREATOR,FITS_VALUE_CREATOR,FITS_COM_CREATOR,i)
        call ftpcom(26,MUNIPACK_VERSION,i)

        ! corrected data
        call ftp2de(26,1,fits%naxes(1),fits%naxes(1),fits%naxes(2),OUT,i)

        ! stderr
        call ftiimg(26,bitpix,fits%naxis,fits%naxes,istat)
        call ftukys(26,'EXTNAME',EXT_STDERR,'',istat)
        call ftpcom(26,'The estimation of standard error.',istat)
        call ftp2de(26,1,fits%naxes(1),fits%naxes(1),fits%naxes(2),DOUT,istat)

        call ftclos(26,i)

        if( verbose ) write(error_unit,*) trim(outname)

665     continue

        if( allocated(FLAT) ) deallocate(FLAT,DFLAT)
        if( allocated(BIAS) ) deallocate(BIAS,DBIAS)
        if( allocated(DARK) ) deallocate(DARK,DDARK)

        if( allocated(OUT) ) deallocate(OUT,DOUT)

        call xfits_deallocate(fits)

     end if

  end do
20 continue

  call xfits_deallocate(maskfits)
  call xfits_deallocate(biasfits)
  call xfits_deallocate(darkfits)
  call xfits_deallocate(flatfits)

  if( allocated(OUT) ) deallocate(OUT,DOUT)

  if( i == 0 ) then
     stop 0
  else
     call ftrprt('STDERR',i)
  end if

end program phcorr

!
! the colouring book -- the engine
!
!
! Copyright © 2010-3, 2018-20 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module colouring_book

  use iso_fortran_env

  implicit none
  private

  ! Planck's constant * speed of light [in electron-Volts]
  real, parameter :: hcevolt = 1.2398e-06 ! = h c / 1eV

  ! D65 white point for XYZ values
  ! https://en.wikipedia.org/wiki/Illuminant_D65
  real, dimension(3), parameter :: white_point = [ 1.07304, 1.0, 0.948115 ]

  integer, parameter, public :: &
       WHITE_SPOT = 5, &         ! use a spot to calibrate white
       WHITE_STAR = 4, &         ! use a star to calibrate white
       WHITE_CTPH = 3, &         ! use quantum efficiency, aka CTPH
       WHITE_CAL = 2, &          ! use calibrated frames
       WHITE_WEIGHTS = 1         ! use weights by user to calibrate white

  public :: colour

contains

  subroutine colour(cspace,outspace,bands,bitpix,cmatrix,x,y,r, &
       white,estimbacks,weights,ctphs,backgrounds,output,verbose,status)

    use fitscolour
    use phio
    use oakleaf
    use titsio

    character(len=*), intent(in) :: cspace, outspace, output
    type(ColourFits) , dimension(:), intent(in) :: bands
    integer, intent(in) :: bitpix, white
    real, dimension(:,:), intent(in) :: cmatrix
    real, intent(in) :: x, y, r
    real, dimension(:), allocatable, intent(in) :: weights, ctphs, backgrounds
    logical, intent(in) :: estimbacks, verbose
    integer, intent(out) :: status

    integer :: nbands, width, height
    integer :: i,j,k,stat

    character(len=FLEN_CARD) :: com
    character(len=80) :: msg, squnit
    integer, dimension(3) :: naxes
    real, dimension(:,:,:), allocatable :: cube
    real, dimension(size(bands)) :: e, w, f, sq, backs
    logical :: astrometry
    type(fitsfiles) :: fits

    status = 1
    nbands = size(bands)

    width = bands(1)%naxes(1)
    height = bands(1)%naxes(2)

    astrometry = all(bands(:)%astrometry)
    e = hcevolt / bands(:)%leff           ! effective photon energy in eV
    if( astrometry ) then
       sq = (3600*bands(:)%scale)**2     ! scale arcsec2 per pixels
    else
       sq = 1
    end if

    ! backgrounds
    if( allocated(backgrounds) ) then
       backs = backgrounds
    else if( estimbacks ) then
       do k = 1, size(bands)
          backs(k) = bands(k)%sky()
          if( verbose ) write(error_unit,*) "Info: background for `", &
               trim(bands(k)%filename),"' estimated on: ",backs(k)
       end do
    else ! backgrounds are set to zero
       backs = 0
    end if

    if( white == WHITE_SPOT ) then
       ! determine weights by averadging of white area
       do k = 1, nbands
          f(k) = bands(k)%apmean(x,y,r,backs(k))
          if( verbose ) then
             write (error_unit,*) 'Info: white spot mean in ',&
                  trim(bands(k)%filter),' is: ',f(k)
          end if
       end do
       if( .not. all(f > 0) ) &
            stop 'Error: white spot mean determination failed.'

       call weights_setup(f,e,cmatrix,w)
       w = w / w(2)

    else if ( white == WHITE_STAR ) then
       ! determine weights by equalising of flux of a white star

       do k = 1, nbands
          f(k) = bands(k)%apsum(x,y,r,backs(k))
          if( verbose ) then
             write (error_unit,*) 'Info: white star in ',&
                  trim(bands(k)%filter),' has total counts in aperture: ',f(k)
          end if
       end do
       if( .not. all(f > 0) ) &
            stop 'Error: white star determination failed.'

!       write(*,*) f / f(2)

       call weights_setup(f,e,cmatrix,w)
       w = w / w(2)

    else if( white == WHITE_WEIGHTS ) then
       ! by user

       w = weights

    else if( white == WHITE_CTPH .or. white == WHITE_CAL ) then
       ! passed CTPH or photon rates are already calibrated

       ! NEEDS REVISION !!!!

!       write(*,*) bands(:)%fref / bands(2)%fref
!       write(*,*) bands(:)%exptime / bands(2)%exptime
!       write(*,*) bands(:)%ctph / bands(2)%ctph
!       write(*,*) bands(:)%ctph * bands(:)%fref / (bands(2)%ctph*bands(2)%fref)
!       write(*,*) e / e(2)

!       f = 1 * (bands(:)%exptime * bands(:)%area)
!       f = bands(2)%fref / bands(:)%fref
!       f = bands(:)%exptime  / bands(2)%exptime
       f = (bands(:)%ctph * bands(:)%fref) / (bands(2)%fref * bands(2)%ctph)
!       f = bands(:)%fref !/ bands(:)%exptime
!       f = e * (bands(:)%exptime * bands(:)%area) !/ (bands(2)%exptime*bands(2)%area)
!       e = 1
       !       f = f / f(2)
!       f = 1 / [ 3.166, 1.0, 2.0]
!       f = [ 0.28, 1.0, 0.89 ]
!       write(*,*) f
       call weights_setup(f,e,cmatrix,w)
!       w = w * (bands(:)%exptime * bands(:)%area)
!       if( white == WHITE_CTPH ) w = w * ctphs
!       e = hcevolt / bands(:)%leff
!       w = w * (bands(:)%exptime * bands(:)%area)
       w = w / w(2)
    else
       ! guesstimate, no data for adjusting available

       f = 1
       call weights_setup(f,e,cmatrix,w)
       w = w / w(2)
       write(error_unit,*) "Warning: weights undefined -- colours artificial."

    end if

    if( verbose ) then
       write(error_unit,'(a)') &
            ' Info: filter, energy[eV], background[cts], weight, exptime[s]:'
       do k = 1, nbands
          write(error_unit,'(2a,3x,f7.2,3x,en12.3,f12.2,f10.3)') " Info: ", &
               trim(bands(k)%filter),e(k),backs(k),w(k),bands(k)%exptime
       end do
    end if


    if( .not. any(w > 0) ) &
         stop 'Error: all channel weights and thinking must be positive.'

    ! memory
    allocate(cube(width,height,nbands),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) "Error: ",trim(msg)
       error stop 'Failed to allocate colour cube.'
    end if

    ! scale inputs, convert to fluxes
    do k = 1, nbands
       cube(:,:,k) = w(k) * (bands(k)%image - backs(k)) * e(k) / sq(k)
    end do

    ! the rotation in the colour space, the transformation
    forall( i = 1:width, j = 1:height )
        cube(i,j,:) = matmul(cmatrix,cube(i,j,:))
    end forall

    ! cut to the appropriate range
    block
      real :: cmax

      if( bitpix > 0 ) then
         cmax = 2.0**bitpix - 1
         cube = max(0.0,min(cmax,cube))
      end if
    end block

    ! write out Colour FITS
    status = 0
    if( fits_file_exist(output) ) call fits_file_delete(output)
    call fits_create_file(fits,output,status)
    if( status /= 0 ) then
       write(error_unit,*) 'Error: failed to create the file `',trim(output),"'."
       return
    end if

    naxes = [ width, height, nbands ]
    call fits_insert_img(fits,bitpix,3,naxes,status)

    ! by V filter
    do k = 1, nbands
       if( bands(k)%filter == 'V' ) then

          if( bands(k)%object /= '' ) &
               call fits_update_key(fits,FITS_KEY_OBJECT,bands(k)%object, &
               'object by V filter',status)

          call fits_update_key(fits,FITS_KEY_DATEOBS,bands(k)%dateobs, &
               'date by V filter',status)

          call fits_update_key(fits,FITS_KEY_EXPTIME,bands(k)%exptime,-3,&
               '[s] original exposure by V filter',status)

          call fits_update_key(fits,FITS_KEY_AREA,bands(k)%area,-3, &
               '[m2] original area',status)

          if( bands(k)%astrometry ) &
             call fits_update_wcs(fits,bands(k)%ctype,bands(k)%crval,&
                  bands(k)%crpix,bands(k)%cd,real([-1,-1],REAL64),status)
          exit
       end if
    end do

    call fits_update_key(fits,FITS_KEY_CSPACE,outspace, &
         'the colour space of stored data',status)
    call fits_write_comment(fits, &
         "Original colour-space: '"//trim(cspace)//"'",status)
    call fits_write_comment(fits,'Original file, weight, background:',status)
    do k = 1, nbands
       write(com,'(a,2x,g0.3,1x,g0.5)') trim(bands(k)%filename),w(k),backs(k)
       call fits_write_comment(fits,com,status)
    end do

    if( white == WHITE_CAL .or. white == WHITE_CTPH ) then
       if( astrometry ) then
          squnit = 'arcsec2'
       else
          squnit = 'pixel2'
       end if
       call fits_update_key(fits,FITS_KEY_BUNIT,'eV/s/m2/'//squnit, &
            'image data represents intensity (energy)',status)
    end if

    call fits_write_comment(fits,MUNIPACK_VERSION,status)
    call fits_update_key(fits,'CREATOR','Munipack', &
         'Created by colouring utility of Munipack',status)
    call fits_write_cube(fits,0,cube,status)
    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    deallocate(cube)

  end subroutine colour

  subroutine weights_setup(f,e,cmatrix,w)

    use minpacks

    real, dimension(:), intent(in) :: f,e
    real, dimension(:,:), intent(in) :: cmatrix
    real, dimension(:), intent(out) :: w

    real(REAL64), dimension(size(f)) :: x

    call qrsolve(real(cmatrix,REAL64),real(white_point,REAL64),x)
    w = real(x / (f*e))

  end subroutine weights_setup

end module colouring_book

!
!  fitsfind
!
!  Copyright © 2013, 2018-22 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module fitsfind

  use titsio
  use iso_fortran_env

  implicit none

contains

  subroutine fits_find_read(filename,fkeys,data,readns,saturation,status)

    character(len=*), intent(in) :: filename
    character(len=*), dimension(:), intent(in) :: fkeys
    real, intent(out) :: readns,saturation
    real, dimension(:,:), allocatable, intent(out) :: data
    integer, intent(in out) :: status

    integer, parameter :: DIM = 2
    integer :: naxis, bitpix
    integer, dimension(DIM) :: naxes
    logical :: satkey, anyf
    type(fitsfiles) :: fits

    if( status /= 0 ) return

    call fits_open_image(fits,filename,FITS_READONLY,status)
        if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read an image in the file `',trim(filename),"'."
       return
    end if

    call fits_get_img_dim(fits,naxis,status)
    if( naxis /= DIM .and. status == 0 ) then
       write(error_unit,*) 'Error in FIND: Only 2D frames are supported.'
       goto 666
    end if
    call fits_get_img_size(fits,DIM,naxes,status)
    if( status /= 0 ) goto 666

    call fits_read_key(fits,fkeys(1),saturation,status)
    satkey = status == 0
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       status = 0
       call fits_get_img_type(fits,bitpix,status)
       if( status /= 0 ) goto 666
    end if

    call fits_read_key(fits,fkeys(2),readns,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       readns = 0
       status = 0
    end if

    if( status /= 0 ) goto 666

    allocate(data(naxes(1),naxes(2)))
    call fits_read_image(fits,0,0.0,data,anyf,status)
    if( status /= 0 ) goto 666

    if( .not. satkey ) then
       if( bitpix > 0 ) then
          saturation = 2.0**bitpix - 1
       else
          saturation = 0.99*maxval(data)
       end if
    end if

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    if( status /= 0 ) then
       if( allocated(data) ) deallocate(data)
    end if

  end subroutine fits_find_read



  subroutine fits_find_save(filename,output,fkeys,nstar, &
       fwhm,threshold,shrplo,shrphi,rndlo,rndhi, readns, &
       lothresh,  lobad, hibad, hmin, skymod, skyerr, skysig, maxsky, status)

    use oakleaf

    ! results fills new FITS extension

    character(len=*), intent(in) :: filename, output
    character(len=*), dimension(:), intent(in) :: fkeys

    real, intent(in) :: fwhm, threshold, &
         shrplo,shrphi,rndlo,rndhi, lothresh, readns, lobad, hibad, hmin, &
         skymod, skyerr, skysig
    integer, intent(in) :: maxsky, nstar
    integer, intent(in out) :: status

    integer, parameter :: extver = 0
    character(len=FLEN_CARD) :: buf
    character(len=FLEN_VALUE), dimension(5) :: ttype, tform, tunit
    real, dimension(:), allocatable :: xcen,ycen,hstar,round,sharp,ecc,incl
    real :: ecc_mean, incl_mean
    integer :: n, hdutype, frow, nrows, srows, i, l
    type(fitsfiles) :: fits

    if( status /= 0 ) return

    if( output == '' ) then
       call fits_open_file(fits,filename,FITS_READWRITE,status)
       if( status /= 0 ) then
          write(error_unit,*) 'Error: failed to open the file `', &
               trim(filename),"' for a table update."
          return
       end if
    else
       call fits_precopy_file(fits,filename,output,FITS_READWRITE,.true.,status)
       if( status /= 0 ) then
          write(error_unit,*) &
               'Error: failed to create the file `',trim(output),"'."
          return
       end if
    end if

    ! look for an older extension
    call fits_movnam_hdu(fits,FITS_BINARY_TBL,FINDEXTNAME,extver,status)
    if( status == FITS_BAD_HDU_NUM ) then
       status = 0
    else if( status == 0 ) then
       ! already presented ? remove it !
       call fits_delete_hdu(fits,hdutype,status)
    end if
    if( status /= 0 ) goto 666

    ttype(1) = FITS_COL_X
    ttype(2) = FITS_COL_Y
    ttype(3) = FITS_COL_PEAKRATIO
    ttype(4) = FITS_COL_SHARP
    ttype(5) = FITS_COL_ROUND
    tform = '1E'
    tunit = ''

    call fits_insert_btbl(fits,nstar,ttype,tform,tunit,FINDEXTNAME,status)
    call fits_update_key(fits,fkeys(1),hibad,5,'[cts] saturation',status)
    call fits_update_key(fits,fkeys(2),readns,-7,'[ADU] read noise',status)
    call fits_update_key(fits,FITS_KEY_FWHM,fwhm,-2, &
         '[pix] standard FWHM of objects',status)
    call fits_update_key(fits,FITS_KEY_THRESHOLD,threshold,-2, &
         'threshold in sigmas above background',status)
    call fits_update_key(fits,FITS_KEY_LOWBAD,lobad,-3, &
         '[cts] low good datum',status)
    call fits_update_key(fits,FITS_KEY_HIGHBAD,hibad,-3, &
         '[cts] high good datum',status)
    call fits_update_key(fits,FITS_KEY_RNDLO,rndlo,-3,'low round',status)
    call fits_update_key(fits,FITS_KEY_RNDHI,rndhi,-3,'high round',status)
    call fits_update_key(fits,FITS_KEY_SHRPLO,shrplo,-3,'low sharp',status)
    call fits_update_key(fits,FITS_KEY_SHRPHI,shrphi,-3,'high sharp',status)

    call fits_write_comment(fits,'Star detection parameters:',status)

    write(buf,*) 'Saturation (counts)=',hibad
    call fits_write_comment(fits,buf,status)

    write(buf,*) 'Read noise (ADU)=',readns
    call fits_write_comment(fits,buf,status)

    write(buf,*) 'Lower threshold (sigma)=',lothresh
    call fits_write_comment(fits,buf,status)

    write(buf,*) 'Levels range (counts) =',lobad, '..',hibad
    call fits_write_comment(fits,buf,status)

    write(buf,*) 'Hmin (counts) =',hmin
    call fits_write_comment(fits,buf,status)

    write(buf,*) 'Round range =',rndlo, '..',rndhi
    call fits_write_comment(fits,buf,status)

    write(buf,*) 'Sharp range =',shrplo, '..',shrphi
    call fits_write_comment(fits,buf,status)

    write(buf,*) 'Approximate sky value =',skymod,'+-',skyerr
    call fits_write_comment(fits,buf,status)

    write(buf,*) 'Estimated sky sigma =',skysig
    call fits_write_comment(fits,buf,status)

    write(buf,*) 'Pixels used for sky determination =',maxsky
    call fits_write_comment(fits,buf,status)

    allocate(xcen(nstar),ycen(nstar),sharp(nstar),round(nstar),hstar(nstar),&
         ecc(nstar),incl(nstar))
    do n = 1, nstar
       read(3) xcen(n),ycen(n),hstar(n),sharp(n),round(n),ecc(n),incl(n)
    end do

    ! sort arrays by height above lower threshold
    call sorter(xcen,ycen,hstar,sharp,round)

    ! mean eccentricity and inclination
    call rmean(ecc,ecc_mean)
    call rmean(incl,incl_mean)
    call fits_update_key(fits,FITS_KEY_ECCENTRICITY,ecc_mean,-2, &
         ' mean eccentricity',status)
    call fits_update_key(fits,FITS_KEY_INCLINATION,nint(incl_mean), &
         ' mean inclination',status)

    nrows = nstar
    call fits_get_rowsize(fits,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_write_col(fits,1,frow,xcen(i:l),status)
       call fits_write_col(fits,2,frow,ycen(i:l),status)
       call fits_write_col(fits,3,frow,hstar(i:l),status)
       call fits_write_col(fits,4,frow,sharp(i:l),status)
       call fits_write_col(fits,5,frow,round(i:l),status)
    end do

    deallocate(xcen,ycen,hstar,round,sharp,ecc,incl)

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

  end subroutine fits_find_save


  subroutine sorter(xcen,ycen,hstar,sharp,round)

    use quicksort

    real, dimension(:),intent(in out) :: xcen,ycen,hstar,sharp,round

    integer, parameter :: rp = selected_real_kind(15)
    real(rp), dimension(:), allocatable :: htmp
    real, dimension(:), allocatable :: tmp
    integer, dimension(:), allocatable :: id, idx
    integer :: i,n,m

    n = size(xcen)
    allocate(tmp(n),htmp(n),id(n),idx(n))
    id = [ (i, i = 1,n) ]
    htmp = hstar

    call qsort(htmp,id)
    ! hstar sorted into low to high order

    ! reverse sort
    m = n + 1
    forall( i = 1:n ) hstar(i) = real(htmp(m - i))
    forall( i = 1:n ) idx(i) = id(m - i)

    tmp = xcen
    xcen = tmp(idx)

    tmp = ycen
    ycen = tmp(idx)

    tmp = sharp
    sharp = tmp(idx)

    tmp = round
    round = tmp(idx)

    deallocate(tmp,htmp,id,idx)

  end subroutine sorter


end module fitsfind

!
!  fitsaphot
!
!  Copyright © 2013-6, 2018-2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

! Parameters by:
! http://stsdas.stsci.edu/cgi-bin/gethelp.cgi?psfmeasure.hlp


module fitsaphot

  use titsio
  use iso_fortran_env

  implicit none

contains

  subroutine fits_aphot_image(filename,fkeys,data,stderr,saturate,status)

    integer, parameter :: naxis = 2

    character(len=*),intent(in) :: filename
    character(len=*), dimension(:), intent(in) :: fkeys
    real, dimension(:,:), allocatable, intent(out) :: data,stderr
    real, intent(out) :: saturate
    integer, intent(in out) :: status

    type(fitsfiles) :: fits
    integer, parameter :: extver = 0
    integer, dimension(naxis) :: naxes
    integer :: bitpix
    logical :: anyf

    if( status /= 0 ) return

    call fits_open_image(fits,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read an image in the file `',trim(filename),"'."
       return
    end if

    call fits_get_img_size(fits,naxis,naxes,status)
    if( status /= 0 ) goto 666

    call fits_read_key(fits,fkeys(1),saturate,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       status = 0
       call fits_get_img_type(fits,bitpix,status)
       if( status /= 0 ) goto  666
       if( bitpix > 0 ) then
          saturate = 2.0**bitpix - 1
       else
          saturate = huge(saturate)
       end if
    end if

    allocate(data(naxes(1),naxes(2)),stderr(naxes(1),naxes(2)))
    call fits_read_image(fits,0,0.0,data,anyf,status)

    call fits_movnam_hdu(fits,FITS_IMAGE_HDU,EXT_STDERR,extver,status)
    if( status == 0 ) then
       call fits_read_image(fits,0,0.0,stderr,anyf,status)
    else if ( status == FITS_BAD_HDU_NUM ) then
       ! if the information about standard errors is not available,
       ! we are continuing with the Poisson component only
       where( data > 0 )
          stderr = sqrt(data)
       elsewhere
          stderr = -1
       end where
       status = 0
    end if

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    if( status /= 0 ) then
       if( allocated(data) ) deallocate(data,stderr)
    end if

  end subroutine fits_aphot_image


  subroutine fits_aphot_read(filename,data,stderr,xcens,ycens, &
       lobad,hibad,fwhm,ecc,incl,status)

    integer, parameter :: DIM = 2

    character(len=*),intent(in) :: filename
    real, dimension(:,:), allocatable, intent(out) :: data,stderr
    real, dimension(:), allocatable, intent(out) :: xcens,ycens
    real, intent(out) :: lobad,hibad,fwhm,ecc,incl
    integer, intent(in out) :: status

    type(fitsfiles) :: fits
    integer, parameter :: extver = 0
    integer, dimension(DIM) :: naxes
    integer :: naxis,nrows,srows,frow,i,l,xcol,ycol
    logical :: anyf

    if( status /= 0 ) return

    call fits_open_image(fits,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read an image in the file `',trim(filename),"'."
       return
    end if

    call fits_get_img_dim(fits,naxis,status)
    if( naxis /= 2 .and. status == 0 ) then
       write(error_unit,*) 'Error in aphot: Only 2D frames are supported.'
       goto 666
    end if
    call fits_get_img_size(fits,DIM,naxes,status)
    if( status /= 0 ) goto 666

    allocate(data(naxes(1),naxes(2)),stderr(naxes(1),naxes(2)))
    call fits_read_image(fits,0,0.0,data,anyf,status)

    call fits_movnam_hdu(fits,FITS_IMAGE_HDU,EXT_STDERR,extver,status)
    if( status == 0 ) then
       call fits_read_image(fits,0,0.0,stderr,anyf,status)
    else if ( status == FITS_BAD_HDU_NUM ) then
       ! if the information about standard errors is not available,
       ! we continues with Poisson component only
       where( data > 0 )
          stderr = sqrt(data)
       elsewhere
          stderr = -1
       end where
       status = 0
    end if

    if( status /= 0 ) then
       write(error_unit,*) trim(filename),": Failed to read data."
       goto 666
    end if

    call fits_movnam_hdu(fits,FITS_BINARY_TBL,FINDEXTNAME,extver,status)
    if( status == FITS_BAD_HDU_NUM ) then
       write(error_unit,*) "Error: ",trim(FINDEXTNAME)//" extension not found."
       write(error_unit,*) "       Has been stars detected by `munipack find " &
            //trim(filename)//"' ?"
       goto 666
    end if

    call fits_get_num_rows(fits,nrows,status)

    call fits_read_key(fits,FITS_KEY_LOWBAD,lobad,status)
    call fits_read_key(fits,FITS_KEY_HIGHBAD,hibad,status)
    call fits_read_key(fits,FITS_KEY_FWHM,fwhm,status)
    call fits_read_key(fits,FITS_KEY_ECCENTRICITY,ecc,status)
    call fits_read_key(fits,FITS_KEY_INCLINATION,incl,status)
    if( status /= 0 ) then
       write(error_unit,*) trim(filename),": Required keywords ", &
            trim(FITS_KEY_LOWBAD),", ",trim(FITS_KEY_HIGHBAD),", ", &
            trim(FITS_KEY_FWHM),", ",trim(FITS_KEY_ECCENTRICITY),", or ",&
            trim(FITS_KEY_INCLINATION)," not found."
       goto 666
    end if

    call fits_get_colnum(fits,.true.,FITS_COL_X,xcol,status)
    call fits_get_colnum(fits,.true.,FITS_COL_Y,ycol,status)

    allocate(xcens(nrows),ycens(nrows))

    call fits_get_rowsize(fits,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_read_col(fits,xcol,frow,0.0,xcens(i:l),anyf,status)
       call fits_read_col(fits,ycol,frow,0.0,ycens(i:l),anyf,status)
    end do

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    if( status /= 0 ) then
       if( allocated(data) ) deallocate(data,stderr)
       if( allocated(xcens) ) deallocate(xcens,ycens)
    end if

  end subroutine fits_aphot_read

  subroutine fits_aphot_save(filename, output, hwhm, ecc, incl, raper, ring,  &
       xcens, ycens, apcts,apcts_err,sky,sky_err, status)

    character(len=*), intent(in) :: filename, output
    real, intent(in) :: hwhm, ecc, incl
    real, dimension(:), intent(in) :: raper, ring, xcens, ycens, sky,sky_err
    real, dimension(:,:), intent(in) :: apcts,apcts_err
    integer, intent(in out) :: status

    type(fitsfiles) :: fits
    integer, parameter :: extver = 0, nbegin = 4
    character(len=FLEN_VALUE), dimension(:), allocatable :: ttype, tform, tunit
    character(len=FLEN_VALUE) :: key
    integer :: hdutype,i,j,k,l,n,nrows,srows,frow


    if( status /= 0 ) return

    if( output == '' ) then
       call fits_open_file(fits,filename,FITS_READWRITE,status)
       if( status /= 0 ) then
          write(error_unit,*) &
            'Error: failed to open the file `',trim(filename),"' for a table update."
          return
       end if
    else
       call fits_precopy_file(fits,filename,output,FITS_READWRITE,.true.,status)
       if( status /= 0 ) then
          write(error_unit,*) &
            'Error: failed to create the file `',trim(output),"'."
          return
       end if
    end if

    ! store results to the aperture photometry extension
    call fits_movnam_hdu(fits,FITS_BINARY_TBL,APEREXTNAME,extver,status)
    if( status == FITS_BAD_HDU_NUM ) then
       status = 0
    else
       ! already presented ? remove it !
       call fits_delete_hdu(fits,hdutype,status)
    end if
    if( status /= 0 ) goto 666

    n = nbegin + 2*size(raper)
    allocate(ttype(n), tform(n), tunit(n))

    tform = '1D'
    tunit = ''
    ttype(1) = FITS_COL_X
    ttype(2) = FITS_COL_Y
    ttype(3) = FITS_COL_SKY
    ttype(4) = FITS_COL_SKYERR

    do i = 1, size(raper)
       j = nbegin - 1 + 2*i
       write(ttype(j),'(a,i0)') trim(FITS_COL_APCOUNT),i
       write(ttype(j+1),'(a,i0)') trim(FITS_COL_APCOUNTERR),i
    end do

    ! aperture photometry table
    nrows = size(xcens)
    call fits_insert_btbl(fits,nrows,ttype,tform,tunit,APEREXTNAME,status)

    call fits_write_key(fits,FITS_KEY_HWHM,hwhm,-4, &
         '[pix] half width at half of maximum',status)
    call fits_update_key(fits,FITS_KEY_ECCENTRICITY,ecc,-2, &
         ' eccentricity',status)
    call fits_update_key(fits,FITS_KEY_INCLINATION,nint(incl), &
         ' inclination',status)
    call fits_write_key(fits,FITS_KEY_NAPER,size(raper), &
         'Count of apertures',status)
    do i = 1, size(raper)
       call fits_make_keyn(FITS_KEY_APER,i,key,status)
       call fits_write_key(fits,key,raper(i),-5,'[pix] aperture radius',status)
    end do

    call fits_write_key(fits,trim(FITS_KEY_ANNULUS)//'1',ring(1),-5, &
         '[pix] inner sky annulus radius',status)
    call fits_write_key(fits,trim(FITS_KEY_ANNULUS)//'2',ring(2),-5, &
         '[pix] outer sky annulus radius',status)

    call fits_get_rowsize(fits,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_write_col(fits,1,frow,xcens(i:l),status)
       call fits_write_col(fits,2,frow,ycens(i:l),status)
       call fits_write_col(fits,3,frow,sky(i:l),status)
       call fits_write_col(fits,4,frow,sky_err(i:l),status)

       do k = 1,size(apcts,2)
          j = nbegin-1+2*k
          call fits_write_col(fits,j,frow,apcts(i:l,k),status)
          call fits_write_col(fits,j+1,frow,apcts_err(i:l,k),status)
       end do
    end do
    deallocate(ttype,tform,tunit)

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

  end subroutine fits_aphot_save

  subroutine estim_hwhm(data,xcens,ycens,sky,fwhm,lobad,hibad,hwhm)

    use oakleaf

    real, dimension(:,:), intent(in) :: data
    real, dimension(:), intent(in) :: xcens,ycens,sky
    real, intent(in) :: fwhm,lobad,hibad
    real, intent(out) :: hwhm

    real, dimension(:), allocatable :: xhwhm
    real :: sx,sy,w,sw,w0
    integer :: nx,ny,i,j,l,m,n,i0,j0

    allocate(xhwhm(size(xcens)))

    nx = size(data,1)
    ny = size(data,2)

    n = 0
    m = nint(1.5*fwhm)
    m = nint(fwhm / 2) * 3
    ! neighborhood is 3*hwhm of expected which prefers important
    ! parts of profile

    do l = 1, size(xcens)

       sx = 0
       sy = 0
       sw = 0
       i0 = nint(xcens(l))
       j0 = nint(ycens(l))
       w0 = data(i0,j0) - sky(l)
       if( w0 > 0 .and. sky(l) > 0 ) then
          do i = i0-m,i0+m
             do j = j0-m,j0+m
                if( 0 < i .and. i <= nx .and. 0 < j .and. j <= ny ) then
                   w = data(i,j) - sky(l)
                   if( lobad < data(i,j).and.data(i,j) < hibad .and. w > 0) then
                      sx = sx + w*(i - xcens(l))**2
                      sy = sy + w*(j - ycens(l))**2
                      sw = sw + w
                   end if
                end if
             end do
          end do
          if( sw > 0 .and. sqrt(w0) / w0 < 0.01) then
             ! estimation of hwhm is sensitive on noise in data (w),
             ! we're selecting only bright stars
             n = n + 1
             xhwhm(n) = (sqrt(sx/sw) + sqrt(sy/sw)) / 2
          end if
       end if
    end do

    if( n > 1 ) then
       call rmean(xhwhm(1:n),hwhm,w)
    else
       hwhm = -1
    end if

    deallocate(xhwhm)

  end subroutine estim_hwhm

end module fitsaphot

      subroutine dmchar(ibeta,it,irnd,ngrd,machep,negep,iexp,minexp,
     1                   maxexp,eps,epsneg,xmin,xmax)
c
      integer i,ibeta,iexp,irnd,it,iz,j,k,machep,maxexp,minexp,
     1        mx,negep,ngrd
      double precision a,b,beta,betain,betam1,eps,epsneg,one,xmax,
     1                 xmin,y,z,zero
c
c     this subroutine is intended to determine the characteristics
c     of the floating-point arithmetic system that are specified
c     below.  the first three are determined according to an
c     algorithm due to m. malcolm, cacm 15 (1972), pp. 949-951,
c     incorporating some, but not all, of the improvements
c     suggested by m. gentleman and s. marovich, cacm 17 (1974),
c     pp. 276-277.
c
c
c       ibeta   - the radix of the floating-point representation
c       it      - the number of base ibeta digits in the floating-point
c                 significand
c       irnd    - 0 if floating-point addition chops,
c                 1 if floating-point addition rounds
c       ngrd    - the number of guard digits for multiplication.  it is
c                 0 if  irnd=1, or if  irnd=0  and only  it  base  ibeta
c                   digits participate in the post normalization shift
c                   of the floating-point significand in multiplication
c                 1 if  irnd=0  and more than  it  base  ibeta  digits
c                   participate in the post normalization shift of the
c                   floating-point significand in multiplication
c       machep  - the largest negative integer such that
c                 1.0+float(ibeta)**machep .ne. 1.0, except that
c                 machep is bounded below by  -(it+3)
c       negeps  - the largest negative integer such that
c                 1.0-float(ibeta)**negeps .ne. 1.0, except that
c                 negeps is bounded below by  -(it+3)
c       iexp    - the number of bits (decimal places if ibeta = 10)
c                 reserved for the representation of the exponent
c                 (including the bias or sign) of a floating-point
c                 number
c       minexp  - the largest in magnitude negative integer such that
c                 float(ibeta)**minexp is a positive floating-point
c                 number
c       maxexp  - the largest positive integer exponent for a finite
c                 floating-point number
c       eps     - the smallest positive floating-point number such
c                 that  1.0+eps .ne. 1.0. in particular, if either
c                 ibeta = 2  or  irnd = 0, eps = float(ibeta)**machep.
c                 otherwise,  eps = (float(ibeta)**machep)/2
c       epsneg  - a small positive floating-point number such that
c                 1.0-epsneg .ne. 1.0. in particular, if ibeta = 2
c                 or  irnd = 0, epsneg = float(ibeta)**negeps.
c                 otherwise,  epsneg = (ibeta**negeps)/2.  because
c                 negeps is bounded below by -(it+3), epsneg may not
c                 be the smallest number which can alter 1.0 by
c                 subtraction.
c       xmin    - the smallest non-vanishing floating-point power of the
c                 radix.  in particular,  xmin = float(ibeta)**minexp
c       xmax    - the largest finite floating-point number.  in
c                 particular   xmax = (1.0-epsneg)*float(ibeta)**maxexp
c                 note - on some machines  xmax  will be only the
c                 second, or perhaps third, largest number, being
c                 too small by 1 or 2 units in the last digit of
c                 the significand.
c
c     latest revision - october 22, 1979
c
c     author - w. j. cody
c              argonne national laboratory
c
c-----------------------------------------------------------------
      one = dble(float(1))
      zero = 0.0d0
c-----------------------------------------------------------------
c     determine ibeta,beta ala malcolm
c-----------------------------------------------------------------
      a = one
   10 a = a + a
         if (((a+one)-a)-one .eq. zero) go to 10
      b = one
   20 b = b + b
         if ((a+b)-a .eq. zero) go to 20
      ibeta = int(sngl((a + b) - a))
      beta = dble(float(ibeta))
c-----------------------------------------------------------------
c     determine it, irnd
c-----------------------------------------------------------------
      it = 0
      b = one
  100 it = it + 1
         b = b * beta
         if (((b+one)-b)-one .eq. zero) go to 100
      irnd = 0
      betam1 = beta - one
      if ((a+betam1)-a .ne. zero) irnd = 1
c-----------------------------------------------------------------
c     determine negep, epsneg
c-----------------------------------------------------------------
      negep = it + 3
      betain = one / beta
      a = one
c
      do 200 i = 1, negep
         a = a * betain
  200 continue
c
      b = a
  210 if ((one-a)-one .ne. zero) go to 220
         a = a * beta
         negep = negep - 1
      go to 210
  220 negep = -negep
      epsneg = a
      if ((ibeta .eq. 2) .or. (irnd .eq. 0)) go to 300
      a = (a*(one+a)) / (one+one)
      if ((one-a)-one .ne. zero) epsneg = a
c-----------------------------------------------------------------
c     determine machep, eps
c-----------------------------------------------------------------
  300 machep = -it - 3
      a = b
  310 if((one+a)-one .ne. zero) go to 320
         a = a * beta
         machep = machep + 1
      go to 310
  320 eps = a
      if ((ibeta .eq. 2) .or. (irnd .eq. 0)) go to 350
      a = (a*(one+a)) / (one+one)
      if ((one+a)-one .ne. zero) eps = a
c-----------------------------------------------------------------
c     determine ngrd
c-----------------------------------------------------------------
  350 ngrd = 0
      if ((irnd .eq. 0) .and. ((one+eps)*one-one) .ne. zero) ngrd = 1
c-----------------------------------------------------------------
c     determine iexp, minexp, xmin
c
c     loop to determine largest i and k = 2**i such that
c         (1/beta) ** (2**(i))
c     does not underflow
c     exit from loop is signaled by an underflow.
c-----------------------------------------------------------------
      i = 0
      k = 1
      z = betain
  400 y = z
         z = y * y
c-----------------------------------------------------------------
c        check for underflow here
c-----------------------------------------------------------------
         a = z * one
         if ((a+a .eq. zero) .or. (dabs(z) .ge. y)) go to 410
         i = i + 1
         k = k + k
      go to 400
  410 if (ibeta .eq. 10) go to 420
      iexp = i + 1
      mx = k + k
      go to 450
c-----------------------------------------------------------------
c     for decimal machines only
c-----------------------------------------------------------------
  420 iexp = 2
      iz = ibeta
  430 if (k .lt. iz) go to 440
         iz = iz * ibeta
         iexp = iexp + 1
      go to 430
  440 mx = iz + iz - 1
c-----------------------------------------------------------------
c     loop to determine minexp, xmin
c     exit from loop is signaled by an underflow.
c-----------------------------------------------------------------
  450 xmin = y
         y = y * betain
c-----------------------------------------------------------------
c        check for underflow here
c-----------------------------------------------------------------
         a = y * one
         if (((a+a) .eq. zero) .or. (dabs(y) .ge. xmin)) go to 460
         k = k + 1
      go to 450
  460 minexp = -k
c-----------------------------------------------------------------
c     determine maxexp, xmax
c-----------------------------------------------------------------
      if ((mx .gt. k+k-3) .or. (ibeta .eq. 10)) go to 500
      mx = mx + mx
      iexp = iexp + 1
  500 maxexp = mx + minexp
c-----------------------------------------------------------------
c     adjust for machines with implicit leading
c     bit in binary significand and machines with
c     radix point at extreme right of significand
c-----------------------------------------------------------------
      i = maxexp + minexp
      if ((ibeta .eq. 2) .and. (i .eq. 0)) maxexp = maxexp - 1
      if (i .gt. 20) maxexp = maxexp - 1
      if (a .ne. y) maxexp = maxexp - 2
      xmax = one - epsneg
      if (xmax*one .ne. xmax) xmax = one - beta * epsneg
      xmax = xmax / (beta * beta * beta * xmin)
      i = maxexp + minexp + 3
      if (i .le. 0) go to 520
c
      do 510 j = 1, i
          if (ibeta .eq. 2) xmax = xmax + xmax
          if (ibeta .ne. 2) xmax = xmax * beta
  510 continue
c
  520 return
c     ---------- last card of dmchar ----------
      end

!
!  FITS subroutines for pre-corrections
!
!  Copyright © 2018-2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

module fitscorr

  use titsio
  use iso_fortran_env

  implicit none

  type :: CorrFits
     character(len=FLEN_FILENAME) :: filename
     character(len=FLEN_VALUE) :: dateobs='', imagetyp='', filter=''
     real, dimension(:,:), allocatable :: image, imgerr
     integer :: naxis, bitpix
     integer, dimension(2) :: naxes
     real :: exptime = 0
     real :: saturate = huge(1.0)*(1.0-10*epsilon(1.0))
     real :: temper = -666
     real :: gain = 1
     logical :: saturate_set = .false.
     logical :: gain_set = .false.
     logical :: exptime_set = .false.
     logical :: status = .false.
     real :: mean, stderr, sig ! flat only
   contains
     procedure :: Load, get_saturate
  end type CorrFits

contains

  subroutine Load(fits,filename,keys)

    class(CorrFits) :: fits
    character(len=*), intent(in) :: filename
    character(len=*), dimension(:), intent(in), optional :: keys

    integer, parameter :: extver = 0, group = 1
    real, parameter :: null = 0.0
    integer :: status, stat
    logical :: anyf
    character(len=80) :: msg
    type(fitsfiles) :: fitsfile

    status = 0
    fits%filename = filename
    call fits_open_image(fitsfile,filename,FITS_READONLY,status)
    if( status /= 0  ) then
       write(error_unit,*) 'Error: failed to read the file `',trim(filename),"'."
       fits%status = .false.
       return
    end if

    call fits_get_img_type(fitsfile,fits%bitpix,status)
    call fits_get_img_dim(fitsfile,fits%naxis,status)
    if( status /= 0 ) goto 666

    if( fits%naxis /= 2 ) then
       write(error_unit,*) trim(filename),": Assertion failed: naxis /= 2"
       goto 666
    end if

    call fits_get_img_size(fitsfile,2,fits%naxes,status)

    if( present(keys) ) then

       ! dateobs
       call fits_write_errmark
       call fits_read_key(fitsfile,keys(1),fits%dateobs,status)
       if( status == FITS_KEYWORD_NOT_FOUND ) then
          call fits_clear_errmark
          status = 0
          fits%dateobs = ''
       end if

       ! exposure time
       call fits_write_errmark
       call fits_read_key(fitsfile,keys(2),fits%exptime,status)
       if( status == 0 ) then
          fits%exptime_set = .true.
       else if( status == FITS_KEYWORD_NOT_FOUND ) then
          call fits_clear_errmark
          status = 0
          fits%exptime = -1
       end if

       ! filter
       call fits_write_errmark
       call fits_read_key(fitsfile,keys(3),fits%filter,status)
       if( status == FITS_KEYWORD_NOT_FOUND ) then
          call fits_clear_errmark
          status = 0
          fits%filter = ''
       end if

       call fits_write_errmark
       call fits_read_key(fitsfile,keys(4),fits%saturate,status)
       if( status == 0 ) then
          fits%saturate_set = .true.
       else if( status == FITS_KEYWORD_NOT_FOUND ) then
          call fits_clear_errmark
          status = 0
       end if

       ! device temperature
       call fits_write_errmark
       call fits_read_key(fitsfile,keys(5),fits%temper,status)
       if( status == FITS_KEYWORD_NOT_FOUND ) then
          call fits_clear_errmark
          status = 0
          fits%temper = -666
       end if

       ! gain
       call fits_write_errmark
       call fits_read_key(fitsfile,keys(6),fits%gain,status)
       if( status == 0 ) then
          fits%gain_set = .true.
       else if( status == FITS_KEYWORD_NOT_FOUND ) then
          call fits_clear_errmark
          status = 0
          fits%gain = 1
       end if

       ! imagetyp
       call fits_write_errmark
       call fits_read_key(fitsfile,FITS_KEY_IMAGETYP,fits%imagetyp,status)
       if( status == FITS_KEYWORD_NOT_FOUND ) then
          call fits_clear_errmark
          status = 0
          fits%imagetyp = ''
       end if

    end if ! keys
    if( status /= 0 ) goto 666

    ! data
    allocate(fits%image(fits%naxes(1),fits%naxes(2)), &
         fits%imgerr(fits%naxes(1),fits%naxes(2)),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) trim(msg)
       error stop 'Failed to allocate images.'
    end if

    call fits_read_image(fitsfile,group,null,fits%image,anyf,status)
    if( status /= 0 ) goto 666

    ! errors
    call fits_write_errmark
    call fits_movnam_hdu(fitsfile,FITS_IMAGE_HDU,EXT_STDERR,extver,status)
    if( status == 0 ) then
       call fits_read_image(fitsfile,group,null,fits%imgerr,anyf,status)
       if( status /= 0 ) goto 666
    else if( status == FITS_BAD_HDU_NUM ) then
       ! if the information about standard deviation is not available,
       ! we are continuing with zeros
       fits%imgerr = 0
       status = 0
       call fits_clear_errmark
    end if

    ! initial saturation setup
    if( .not. fits%saturate_set ) then
       if( status == 0 .and. fits%bitpix > 0 ) then
          fits%saturate = 2.0**fits%bitpix - 1
       else
          fits%saturate = huge(fits%image) * (1.0 - 10*epsilon(fits%image))
       end if
    end if

666 continue

    if( status /= 0 ) then
       if( allocated(fits%image) ) deallocate(fits%image)
       if( allocated(fits%imgerr) ) deallocate(fits%imgerr)
    end if

    call fits_close_file(fitsfile,status)
    call fits_report_error(error_unit,status)

    fits%status = status == 0

  end subroutine Load


  real function get_saturate(this,gain)

    class(CorrFits) :: this
    real, intent(in) :: gain

    associate( saturate => this%saturate )

      get_saturate = saturate

      if( gain > 1 ) then

         if( saturate < huge(saturate) / (1.001*gain) ) &
              get_saturate = gain * saturate

      else if( gain < 1 ) then

         if( saturate < huge(saturate) * (1.001*gain) ) &
              get_saturate = gain * saturate

      end if

    end associate

  end function get_saturate

end module fitscorr

!
!  photometric calibration
!
!  Copyright © 2012-7, 2019-20 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!  Problems:
!    * calibration frame is not referenced when a frame is referenced
!      to a frame (done)
!    * standard deviation has bad value (done)
!
!  Adds:
!    * Re-design of command line parameters: better defaults to --col-*,
!      rename all mags to be VO-compatible (Vmag,e_Vmag). User must specify
!      only filter/photometry system (or nothing when filter/phsystem is
!      presented in FITS header).
!

program phcal

  use titsio
  use phsysfits
  use mfits
  use iso_fortran_env

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)

  character(len=4*FLEN_FILENAME) :: line, key, val
  character(len=FLEN_FILENAME), dimension(:), allocatable :: filename, &
       output
  character(len=FLEN_FILENAME) :: ref = '', cat = '', tratable = '', &
       phsystable = 'photosystems.fits'
  character(len=FLEN_VALUE), dimension(:), allocatable :: qlabels
  character(len=FLEN_VALUE) :: col_ra = FITS_COL_RA, col_dec = FITS_COL_DEC, &
       photsys_ref = '', photsys_instr = ''
  character(len=FLEN_VALUE), dimension(:), allocatable :: col_mag, col_magerr, &
       filters
  logical :: verbose = .false., plog = .false., list = .false.
  logical :: init_area = .false. , init_photsys = .false.
  logical :: cal_manual = .false.
  logical :: advanced = .false.
  real(dbl) :: utol = -1.0/3600.0
  real(dbl) :: area
  real(dbl) :: threshold = 0.1
  real(dbl) :: maxerr = 0.1
  real(dbl) :: apcorr = 1.0_dbl
  real(dbl), dimension(:), allocatable :: ctph_manual,dctph_manual
  integer :: eq,nfile,n,nmag,nmagerr,nfilters,nctph,saper
  character(len=FLEN_KEYWORD), dimension(8) :: keys
  integer :: nqlabels

  keys = [ character(len=FLEN_KEYWORD) :: FITS_KEY_EXPTIME, FITS_KEY_AREA, &
       FITS_KEY_DATEOBS, FITS_KEY_PHOTSYS, FITS_KEY_FILTER, &
       FITS_KEY_LONGITUDE, FITS_KEY_LATITUDE, FITS_KEY_TIMEOBS ]

!  nqlabels = 7
!  qlabels = (/'PHOTRATE','FLUX    ','FNU     ','FLAM    ','MAG     ', &
!       'ABMAG   ','STMAG   '/)

  nqlabels = 2
  allocate(qlabels(nqlabels))
  qlabels = [ character(len=FLEN_VALUE) :: 'FLUX', 'MAG' ]

  allocate(col_mag(0), col_magerr(0), filters(0))
  allocate(ctph_manual(0), dctph_manual(0))
  allocate(filename(0), output(0))
  nfilters = 0
  nmag = 0
  nmagerr = 0
  nfile = 0
  area = 1
  saper = 0

  do
     read(*,'(a)',end=20) line

     eq = index(line,'=')
     if( eq == 0 ) stop 'Malformed input record.'

     key = line(:eq-1)
     val = line(eq+1:)

     if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'PIPELOG' ) then

        read(val,*) plog

     else if( key == 'ADVANCED' ) then

        read(val,*) advanced

     else if( key == 'FITS_KEY_EXPTIME' ) then

        read(val,*) keys(1)

     else if( key == 'FITS_KEY_AREA' ) then

        read(val,*) keys(2)

     else if( key == 'FITS_KEY_DATEOBS' ) then

        read(val,*) keys(3)

     else if( key == 'FITS_KEY_PHOTOSYS' ) then ! remove?

        read(val,*) keys(4)

     else if( key == 'FITS_KEY_FILTER' ) then

        read(val,*) keys(5)

     else if( key == 'FITS_KEY_LONGITUDE' ) then

        read(val,*) keys(6)

     else if( key == 'FITS_KEY_LATITUDE' ) then

        read(val,*) keys(7)

     else if( key == 'FITS_KEY_TIMEOBS' ) then

        read(val,*) keys(8)

     else if( key == 'NFILTERS' ) then

        read(val,*) nfilters

        deallocate(filters)
        allocate(filters(nfilters))
        filters = ''

     else if( key == 'FILTERS' ) then

        ! a set of filters
        read(val,*) filters

     else if( key == 'COL_RA' ) then

        read(val,*) col_ra

     else if( key == 'COL_DEC' ) then

        read(val,*) col_dec

     else if( key == 'COL_NMAG' ) then

        read(val,*) nmag

        deallocate(col_mag)
        allocate(col_mag(nmag))
        col_mag = ''

     else if( key == 'COL_MAG' ) then

        ! a set columns
        read(val,*) col_mag

     else if( key == 'COL_NMAGERR' ) then

        read(val,*) nmagerr

        deallocate(col_magerr)
        allocate(col_magerr(nmagerr))
        col_magerr= ''

     else if( key == 'COL_MAGERR' ) then

        read(val,*) col_magerr

     else if( key == 'TOL' ) then

        read(val,*) utol

     else if( key == 'SAPER' ) then

        read(val,*) saper

     else if( key == 'AREA' ) then

        read(val,*) area
        init_area = .true.

     else if( key == 'THRESHOLD' ) then

        read(val,*) threshold

     else if( key == 'MAXERR' ) then

        read(val,*) maxerr

     else if( key == 'APCORR' ) then

        read(val,*) apcorr

     else if( key == 'NQUANTITIES' ) then

        read(val,*) nqlabels

        deallocate(qlabels)
        allocate(qlabels(nqlabels))
        qlabels = ''

     else if( key == 'QUANTITIES' ) then

        read(val,*) qlabels

     else if( key == 'PHOTSYS_REF' ) then

        read(val,*) photsys_ref

     else if( key == 'PHOTSYS_INSTR' ) then

        read(val,*) photsys_instr
        init_photsys = .true.

     else if( key == 'PHSYSTABLE' ) then

        read(val,*) phsystable

     else if( key == 'TRATABLE' ) then

        read(val,*) tratable

     else if( key == 'LIST' ) then

        read(val,*) list

     else if( key == 'NCTPH' ) then

        read(val,*) nctph
        deallocate(ctph_manual,dctph_manual)
        allocate(ctph_manual(nctph),dctph_manual(nctph))
        ctph_manual = 1
        dctph_manual= 0

     else if( key == 'CTPH' ) then

        ! manual calibration
        read(val,*) ctph_manual
        dctph_manual = 0
        cal_manual = .true.

     else if( key == 'CAT' ) then

        ! calibration agains to the catalogue
        read(val,*) cat

     else if( key == 'REF' ) then

        ! calibration agains to the already calibrated frame
        read(val,*) ref

     else if( key == 'NFILES' ) then

        read(val,*) nfile

        deallocate(filename,output)
        allocate(filename(nfile),output(nfile))
        filename = ''
        output = ''
        n = 0

     else if( key == 'FILE' ) then

        n = n + 1
        if( n > size(filename) ) stop 'Too many files.'

        read(line(eq+1:),*) filename(n), output(n)

     end if

  end do

20 continue


  if( list ) then

     call listphsys(phsystable)

  else

     if( size(filename) == 0 ) stop 'No frames to process.'

     if( .not. (area > 0) ) &
          stop 'Error: The specified area is negative or zero, very funny!'

     if( cat /= '' ) then
        call calibrate   ! catcal ?
     else if( ref /= '' ) then
        call framecal
     else if( cal_manual ) then
        call mancal
     else
        stop 'Calibration type unknown.'
     end if

  end if

  deallocate(filename,output,col_mag,col_magerr,filters,ctph_manual, &
       dctph_manual)

  stop 0


contains

  ! calibration
  subroutine calibrate

    use phsysfits
    use calibre
    use minpacks
    use photoconv
    use jamming
    use sfits
    use fits_fotran

    character(len=FLEN_VALUE) :: catid,photosys_instr,photsys1,photsys2
    character(len=FLEN_VALUE), dimension(:), allocatable :: filter_frames
    real(dbl), allocatable, dimension(:) :: refra, refdec, ctph,dctph, &
         exptime, areas, tol, aper
    real(dbl), allocatable, dimension(:,:) :: tr,tr1,trerr,tr1err,refph,drefph,&
         cts,dcts,dn,ddn,ra,dec,mag,dmag
    real(dbl) :: q, d
    type(type_phsys) :: phsyscal
    type(photores), dimension(:), allocatable :: phres
    integer, dimension(:,:), allocatable :: pairs
    integer :: status,nfiles,ncat,i

    if( photsys_ref == '' ) &
         stop 'No identificator for reference photometry system.'

    if( nmag == 0 ) &
         stop 'Magnitude column(s) are not specified.'

    if( nmagerr > 0 .and. nmag /= nmagerr ) &
         stop 'Magnitude error column(s) does not match magnitudes itself.'

    if( nmagerr == 0 ) write(error_unit,*) &
         'Warning: Magnitude error column(s) are missing (consider include).'

    nfiles = size(filename)

    call readcat(cat,(/col_ra,col_dec/),col_mag,col_magerr, &
         refra,refdec,mag,dmag,catid,status)
    ! filters as results of readcat (?!)
    if( status /= 0 ) stop 'Failed to read a catalogue.'
    if( .not. allocated(mag) ) stop 'An empty catalogue.'

    ! reference system
    call phselect(phsystable,photsys_ref,phsyscal)
    call phsyspairs(phsyscal,filters,pairs)

    call readframes(filename,keys,phsyscal%filter,photosys_instr,threshold,&
         maxerr,ra,dec,dn,ddn,utol,exptime,areas,filter_frames,tol,init_area,&
         saper,aper,status)
    if( status /= 0 ) stop 'Failed to read frames.'
    if( size(filter_frames) /= size(filters) ) &
         stop 'Filters and frames dimensions differs.'
    if( init_area ) areas = area

    if( verbose ) then
       write(*,*) 'Filename, filter, exptime [s], area [m2]:'
       do i = 1,size(filename)
          write(*,'(2(a,3x),2(f0.3,1x))') trim(filename(i)), &
               trim(filter_frames(i)),exptime(i), areas(i)
       end do
    end if

!    write(*,*) size(mag)
!    write(*,*) size(cts,1)
    call jamcat(tol, refra, refdec, mag, dmag, ra,dec,dn,ddn,cts,dcts)

    ncat = size(cts,1)
    if( ncat == 0 ) stop 'Catalogue to frame joint stars not found.'
    allocate(refph(ncat,size(mag,2)),drefph(ncat,size(mag,2)))

    if( photsys_ref /= '' ) then
       call phsysmagph(phsyscal,filters,pairs,mag(1:ncat,:),dmag(1:ncat,:), &
            refph,drefph)

       do n = 1,nfiles
          q = exptime(n)*areas(n)
          refph = q*refph
       end do

    else
       ! undefined photosystem, relative rates
       call relmagph(mag(1:ncat,:),dmag(1:ncat,:),refph,drefph)
    end if

!    do i = 1, ncat
!       write(*,*) mag(i,1),dmag(i,1),1.086*drefph(i,1)/refph(i,1),refph(i,1)
!    end do

    if( tratable/= '' ) then
       call traload(tratable,photsys2,photsys1,tr,trerr,tr1,tr1err,status)
       if( status /= 0 ) &
            stop 'Instrumental to standard conversion table not found.'
       if( photsys2 /= photsys_ref ) &
            stop 'Reference photometry system does not match the conversion table.'
       if( photsys1 /= photsys_instr ) &
            stop 'Instrumental photometry system does not match the conversion table.'
       if( size(tr,1) /= size(filters) ) &
            stop "Amount of filters doesn't correspons to transformation table."
    else
       allocate(tr(size(refph,2),size(refph,2)),tr1(size(refph,2),size(refph,2)), &
            trerr(size(refph,2),size(refph,2)),tr1err(size(refph,2),size(refph,2)))
       tr = 0.0_dbl
       forall(n=1:size(refph,2))
          tr(n,n) = 1.0_dbl
       end forall
       tr1 = tr
    end if

    if( verbose ) then
       write(*,*) 'Photons to counts transformation:'
       do i = 1,size(filters)
          write(*,'(1x,a,6f8.3)') trim(filters(i)),tr(i,:)
       end do
       write(*,*) 'Counts to photons transformation:'
       do i = 1,size(filters)
          write(*,'(1x,a,6f8.3)') trim(filters(i)),tr1(i,:)
       end do
!       write(*,*) 'Photon and count rates are in [*/s/m2].'
    end if

!    do i = 1, ncat
!       write(*,*) real(refph(i,1)),real(cts(i,1))
!    end do

!    do i = 1, size(cts,1)
!       write(*,*) dcts(i,1), cts(i,1), dcts(i,1)**2-cts(i,1)
!    end do


    ! The reference photon flux is computed by magnitudes,
    ! or by flux normalised per both second and square meter.
    ! Statistical errors of flux can not be easy scaled
    ! on arbitraty exposure time or telescope diameter,
    ! if ones are mix of Poisson and Normal distributions
    ! of deviations.
    !
    ! On the other side, our photons, carefully selected
    ! for bright stars, has nearly Poisson's rates and
    ! errors can be properly scaled.

    do n = 1,0*nfiles
       q = exptime(n)*areas(n)
       dcts(1:ncat,n) = max(dcts(1:ncat,n)**2 - cts(1:ncat,n),0.0)
       dcts(1:ncat,n) = sqrt(cts(1:ncat,n) / q + dcts(1:ncat,n) / q**2)
       cts(1:ncat,n) = cts(1:ncat,n) / q
       dcts(1:ncat,n) = dcts(1:ncat,n) / sqrt(q)
    end do


!    block
!      real :: s
!      s = 0
!      open(1,file='n')
!      do n = 1, size(dn,1)
!         if( dn(n,1) > 0 ) then
!            s = s + sqrt(dn(n,1))/dn(n,1)
!            write(1,*) n, sqrt(dn(n,1))/sqrt(dn(1,1)),s/(sqrt(dn(1,1))/dn(1,1))
!         end if
!      end do
!      close(1)
!    end block

    do i = 1, size(cts,1)

 !      write(*,*) (dcts(i,1)**2 - cts(i,1))/cts(i,1), (drefph(i,1)**2 - refph(i,1))/refph(i,1)/30
    end do

!    if( index(cat,'cone') > 0 ) then
!       do i = 1, size(cts,1)
!          !       dcts(i,1) = sqrt(cts(i,1))
!          drefph(i,1) = sqrt(refph(i,1) + drefph(i,1) / 10)
!       end do
!    end if

    allocate(phres(nfiles),ctph(nfiles),dctph(nfiles))
    do n = 1, nfiles
       call photores_init(phres(n),ncat)
       phres(n)%ra = refra(1:ncat)
       phres(n)%dec = refdec(1:ncat)
    enddo

    if( nfiles == 1 ) then
       call calibr(refph,drefph,cts(1:ncat,:),dcts(1:ncat,:),ctph,dctph, &
            phres,verbose)
    else
       call caliber(pairs,filters,tr,tr1,refph,drefph, &
            cts(1:ncat,:),dcts(1:ncat,:),ctph,dctph,phres,verbose)
    end if

    ! apperture correction
    ctph = apcorr * ctph
    dctph = apcorr * dctph

    if( verbose ) then
       if( nfiles > 1 ) then
          write(*,*) 'Relative residuals:'
          write(*,'(5x,tr5,5a10)') filters
          do i = 1, ncat
             write(*,'(i5,5f10.4)') i,(phres(n)%res(i),n=1,size(phres))
          end do
       end if
       write(*,*) 'Final solutions:'
       do i = 1,size(ctph)
          write(*,'(3a,g15.5,a,1pg8.1)') 'ctph(',trim(filters(i)),') =', &
               ctph(i),'+-',dctph(i)
       end do
    end if

    ! per second and square meter
    q = exptime(1)*areas(1)
    d = dctph(1) / ctph(1)
!    ctph = q / ctph
!    dctph = ctph * d

    call writecal(filename,output,keys,advanced,phsystable,filters, &
         catid,photsys_ref,area,init_area,saper,tr1,ctph,dctph,qlabels,phres)

    do i = 1,size(phres)
       call photores_destroy(phres(i))
    end do
    deallocate(phres)

    if( allocated(pairs) ) deallocate(pairs)
    call deallocate_phsyscal(phsyscal)

    deallocate(refra,refdec,refph,drefph,filter_frames,exptime,areas,aper, &
         tol,tr,tr1,trerr,tr1err,cts,dcts,dn,ddn,ra,dec,mag,dmag,ctph,dctph)

  end subroutine calibrate

  subroutine relmagph(mag,dmag,ph,dph)

    use photoconv

    real(dbl), dimension(:,:), intent(in) :: mag,dmag
    real(dbl), dimension(:,:), intent(out) :: ph,dph

    do n = 1, size(mag,2)
       call mag2rate(mag(:,n),dmag(:,n),ph(:,n),dph(:,n))
!       dph(:,n) = sqrt(ph(:,n))
    end do


  end subroutine relmagph


  subroutine framecal

    ! framecal suppose calibration in single filter only

    use jamming
    use calibre
    use sfits

    character(len=FLEN_VALUE) :: catid,photosys_frames
    character(len=FLEN_VALUE), dimension(:), allocatable :: filter_ref, &
         filters_fram
    real(dbl), allocatable, dimension(:) :: refra, refdec, ctph,dctph, &
         exptime, areas, tol, aper
    real(dbl), allocatable, dimension(:,:) :: refph,drefph, &
         cts,dcts,ra,dec
    real(dbl), dimension(1,1), parameter :: tratab = real(1.0,dbl)
    type(photores), dimension(:), allocatable :: phres
    type(type_phsys) :: phsyscal
    integer :: status,nfiles,ncat,i,n
    real(dbl) :: reftime, refarea, refaper, q

    nfiles = size(filename)
    status = 0

    nfilters = 1
    allocate(filters_fram(1),filter_ref(1))

    ! reference system
    call phselect(phsystable,photsys_ref,phsyscal)

    call readref(ref,keys,maxerr,threshold,refra,refdec,refph,drefph, &
         filter_ref(1),reftime,refarea,refaper,status)
    if( status /= 0 ) stop 'Failed to read a reference frame.'
    catid = trim(ref)

    call readframes(filename,keys,phsyscal%filter,photosys_frames,threshold,&
         maxerr,ra,dec,cts,dcts,utol,exptime,areas,filters_fram,tol,init_area,&
         saper,aper,status)
    if( status /= 0 ) stop 'Failed to read frames.'
    if( init_area ) areas = area
    if( any(abs(refaper - aper) > 0.1) ) &
         write(error_unit,*) 'Warning: synthetic apertures looks different.'

    ! Rates of the reference frame are rescaled on calibrated frames;
    ! the reference frames are supposed as the best frame, or the frame
    ! with its exposure longer than the exposure of calibrated ones.
    q = (reftime * refarea) / (exptime(1)*areas(1))
    !    write(*,*) q,sqrt(q)
!    q = reftime * refarea
!    q = exptime(1) * areas(1)
    !    q = 1
    refph = refph / q
!    drefph = drefph / sqrt(q) ! pure Poisson
    drefph = drefph / q    ! Normal-like

!    drefph = max(drefph**2 - refph,0.0)
!    drefph = sqrt(refph / q + drefph/q**2)
!    refph = refph / q

!    do i = 1, size(refph,1)
!       write(*,*) sqrt(refph(i,1)),drefph(i,1)
!    end do

    if( verbose ) then
       write(*,*) 'Filename, filter, exptime [s], area [m2]:'
       write(*,'(2(a,3x),2(f0.3,1x),a)') trim(ref), &
               trim(filter_ref(1)),reftime,refarea,'   (reference)'
       do i = 1,size(filename)
          write(*,'(2(a,3x),2(f0.3,1x))') trim(filename(i)), &
               trim(filters_fram(i)),exptime(i),areas(i)
       end do
    end if


!!$    block
!!$      real(dbl), allocatable, dimension(:) :: refra0, refdec0
!!$      real(dbl), allocatable, dimension(:,:) :: refph0,drefph0, &
!!$           cts0,dcts0,ra0,dec0
!!$      integer :: m
!!$
!!$      allocate(ctph(1),dctph(1),phres(1))
!!$      allocate(refra0,source=refra)
!!$      allocate(refdec0,source=refdec)
!!$      allocate(refph0,source=refph)
!!$      allocate(drefph0,source=drefph)
!!$      allocate(cts0,source=cts)
!!$      allocate(dcts0,source=dcts)
!!$      allocate(ra0,source=ra)
!!$      allocate(dec0,source=dec)
!!$
!!$      open(1,file='n')
!!$
!!$      do n = 1, size(refra0)
!!$
!!$         deallocate(refra,refdec,refph,drefph)
!!$         allocate(refra(n),refdec(n),refph(n,1),drefph(n,1))
!!$
!!$         refra = refra0(:n)
!!$         refdec = refdec0(:n)
!!$         refph(:,1) = refph0(:n,1)
!!$         drefph(:,1) = drefph0(:n,1)
!!$         ra = ra0
!!$         dec = dec0
!!$         cts = cts0
!!$         dcts = dcts0
!!$         call jamref(tol, refra, refdec, refph, drefph, ra,dec,cts,dcts)
!!$         m = size(cts,1)
!!$         call calibr(refph(1:m,:),drefph(1:m,:),cts(1:m,:),dcts(1:m,:),&
!!$              ctph,dctph,phres,verbose)
!!$         write(1,*) n,ctph,dctph,(cts(1,1)/ctph(1)-refph(1,1))/refph(1,1)
!!$
!!$      end do
!!$      close(1)
!!$    end block
!!$
!!$


    call jamref(tol, refra, refdec, refph, drefph, ra,dec,cts,dcts)

    ncat = size(cts,1)
    if( ncat == 0 ) stop 'Frame to frame joint stars not found.'

!    do n = 1,nfiles
!       q = (exptime(n) * areas(n)) / (reftime * refarea)
!       q = 1
!       cts(1:ncat,n) = cts(1:ncat,n) / q
!       dcts(1:ncat,n) = dcts(1:ncat,n) / sqrt(q)
!    end do

    allocate(phres(nfiles),ctph(nfiles),dctph(nfiles))
    do n = 1, nfiles
       call photores_init(phres(n),ncat)
       phres(n)%ra = refra(1:ncat)
       phres(n)%dec = refdec(1:ncat)
    enddo

!    write(*,*) refph(1:ncat,:)
!    write(*,*) cts(1:ncat,:)

    call calibr(refph(1:ncat,:),drefph(1:ncat,:),cts(1:ncat,:),dcts(1:ncat,:),&
         ctph,dctph,phres,verbose)

    ! pull back of original rates
!    q = reftime * refarea
!    q = (reftime * refarea) / (exptime(1)*areas(1))
!    ctph = q * ctph
!    dctph = q * dctph

    ! apperture correction
    ctph = apcorr * ctph
    dctph = apcorr * dctph

    ! update rates
    q = (reftime * refarea) / (exptime(1)*areas(1))
    !    q = exptime(1)*areas(1)
    q = 1
    do i = 1, size(ctph)
       phres(i)%pht = phres(i)%pht / q
       phres(i)%cts = phres(i)%cts / q
!       phres(i)%pht = phres(i)%pht / (reftime * refarea)
!       phres(i)%cts = phres(i)%cts / (exptime(1)*areas(1))
    end do

    ! per second and square meter
!    q = (reftime * refarea) / (exptime(1)*areas(1))
    !q = exptime(1)*areas(1)
!    d = dctph(1) / ctph(1)
!    ctph = q * ctph
!    dctph = d * ctph

    call writecal(filename,output,keys,advanced,phsystable, &
         filters_fram,catid,photsys_ref,area,init_area,saper,tratab, &
         ctph,dctph,qlabels,phres)

    deallocate(refra,refdec,refph,drefph,filter_ref,filters_fram,exptime, &
         areas,tol,cts,dcts,ra,dec,ctph,dctph)

    do i = 1,size(phres)
       call photores_destroy(phres(i))
    end do

    deallocate(phres)
    call deallocate_phsyscal(phsyscal)

  end subroutine framecal

  ! manual calibration
  subroutine mancal

    use sfits
    use fits_fotran

    character(len=FLEN_VALUE) :: catid,photsys1,photsys2
    real(dbl), allocatable, dimension(:,:) :: tr,tr1,trerr,tr1err
    integer :: n,status

    if( tratable/= '' ) then
       call traload(tratable,photsys2,photsys1,tr,trerr,tr1,tr1err,status)
       if( status /= 0 ) &
            stop 'Instrumental to standard conversion table not found.'
       if( size(tr,1) /= size(filters) ) &
            stop "Dimensions of transformation table and filters doesn't corresponds."
       if( photsys2 /= photsys_ref ) &
            stop 'Reference photometry system does not match the conversion table.'
       if( photsys1 /= photsys_instr ) &
            stop 'Instrumental photometry system does not match the conversion table.'

    else

       allocate(tr(size(filename),size(filename)),tr1(size(filename),size(filename)), &
            trerr(0,0),tr1err(0,0))
       tr = 0.0_dbl
       forall(n=1:size(tr,1))
          tr(n,n) = 1.0_dbl
       end forall
    end if

    catid = ''

    call writecal(filename,output,keys,advanced,phsystable,filters, &
         catid,photsys_ref,area,init_area,saper,tr1,apcorr*ctph_manual, &
         apcorr*dctph_manual,qlabels)

    deallocate(tr,tr1,trerr,tr1err)

  end subroutine mancal

end program phcal

!
!  Flat     Average of a set of flat-fields.
!  Copyright (C) 1997 - 2020  Filip Hroch, Masaryk University, Brno, CZ
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program flatmaker

  use fitscorr
  use oakleaf
  use titsio
  use iso_fortran_env

  implicit none

  ! debuging
  logical, parameter :: debug = .false.

  ! verbosity
  logical :: verbose = .false.

  ! Default Output image name:
  character(len=FLEN_FILENAME) :: flatname = 'flat.fits'
  character(len=FLEN_FILENAME) :: biasname = ''
  character(len=FLEN_FILENAME) :: darkname = ''
  character(len=FLEN_FILENAME) :: maskname = ''

  ! lower and upper limits
  real :: saturate =  -1
  real :: threshold = epsilon(threshold)
  logical :: saturate_set = .false.
  logical :: threshold_set = .false.

  integer :: eq, stat, naxis
  integer, dimension(2) :: naxes
  integer :: nflat = 0     ! counter of flats
  integer :: bitpix = -32
  integer :: maxiter = 7
  integer :: status = 0
  character(len=8) :: approximation = 'STANDARD'

  real :: flat_mean = 1, flat_err = 0
  real :: gain_mean = 1, gain_err = 0

  real :: time = 1
  real :: xdark = -1.0
  real :: gain = 1
  logical :: gain_set = .false.

  ! mean flat with statistical error
  real, dimension(:,:), allocatable :: flat, flaterr
  logical, dimension(:,:), allocatable :: bitmask

  character(len=80) :: msg
  character(len=4*FLEN_FILENAME) :: record, key, val
  character(len=FLEN_VALUE) :: dateobs, filter, imagetyp

  character(len=FLEN_FILENAME), dimension(:), allocatable :: flatnames
  character(len=FLEN_KEYWORD), dimension(6) :: keys = [ &
       FITS_KEY_DATEOBS, &
       FITS_KEY_EXPTIME, &
       FITS_KEY_FILTER, &
       FITS_KEY_SATURATE, &
       FITS_KEY_TEMPERATURE, &
       FITS_KEY_GAIN ]

  ! FITS wrappers
  type(CorrFits), allocatable :: darkfits, biasfits, maskfits
  type(CorrFits), dimension(:), allocatable :: flats

  ! Section: Input  ---------------------------------------
  do
     read(*,'(a)',iostat=stat,iomsg=msg) record
     if( stat == IOSTAT_END ) exit
     if( stat > 0 ) then
        write(error_unit,*) trim(msg)
        error stop 'Input error.'
     end if

     eq = index(record,'=')
     if( eq == 0 ) error stop 'Malformed input record.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then
        read(val,*) verbose
     endif

     if( key == 'OUTPUT' ) then
        read(val,*) flatname
     endif

     if( key == 'BITPIX' ) then
        read(val,*) bitpix
     endif

     if( key == 'SATURATE' ) then
        read(val,*) saturate
        if( .not. (saturate > 0) ) stop 'Saturation > 0 is required.'
        saturate_set = .true.
     endif

     if( key == 'THRESHOLD' ) then
        read(val,*) threshold
        if( .not. (threshold > 0) ) stop 'Threshold > 0 is required.'
        threshold_set = .true.
     endif

     if( key == 'GAIN' ) then
        read(val,*) gain
        gain_set = .true.
     endif

     if( key == 'APPROXIMATION' ) then
        read(val,*) approximation
        if( approximation == 'BASIC' ) then
           maxiter = 0
        else !if( approximation == 'STANDARD' ) then
           maxiter = 3
        end if
     endif

     if( key == 'FITS_KEY_DATEOBS' ) then
        read(val,*) keys(1)
     endif

     if( key == 'FITS_KEY_EXPTIME' ) then
        read(val,*) keys(2)
     endif

     if( key == 'FITS_KEY_FILTER' ) then
        read(val,*) keys(3)
     endif

     if( key == 'FITS_KEY_SATURATE' ) then
        read(val,*) keys(4)
     endif

     if( key == 'FITS_KEY_TEMPERATURE' ) then
        read(val,*) keys(5)
     endif

     if( key == 'FITS_KEY_GAIN' ) then
        read(val,*) keys(6)
     endif

     if( key == 'BIAS' ) then
        read(val,*) biasname
     end if

     if( key == 'XDARK' ) then
        read(val,*) xdark
     end if

     if( key == 'DARK' ) then
        read(val,*) darkname
     end if

     if( key == 'MASK' ) then
        read(val,*) maskname
     end if

     if( key == 'NFILES' ) then

        read(val,*) nflat
        allocate(flatnames(nflat),stat=stat,errmsg=msg)
        if( stat /= 0 ) then
           write(error_unit,*) trim(msg)
           error stop 'Insufficient memory.'
        end if
        nflat = 0

     end if

     if( key == 'FILE' ) then

        nflat = nflat + 1
        if( nflat > size(flatnames) ) stop 'NFILES unspecified?'
        read(val,*) flatnames(nflat)

     end if

  enddo

  if( nflat == 0 ) stop 'No input image(s).'
  if( nflat /= size(flatnames) ) error stop 'n /= size(flatnames)'

  ! Section: FITS files input ---------------------------------------
  block

    integer :: n
    character :: gflag
    logical :: filter_match = .true.
    logical :: filter_empty = .false.
    logical :: gain_default = .false.

    ! bias
    if( biasname /= '' ) then
       if( verbose ) write(error_unit,'(a)',advance="no") &
            "Bias frame: "//trim(biasname)//","

       allocate(biasfits)
       call biasfits%Load(biasname,keys)
       if( .not. biasfits%status ) stop 'Failed to load bias frame.'

       if( verbose ) write(error_unit,'(a,1pg0.3,a,0pf0.1)') &
            ' exp.time[s] = ',biasfits%exptime, &
            ', T[degC] = ',biasfits%temper
    end if

    ! dark
    if( darkname /= '' ) then
       if( verbose ) write(error_unit,'(a)',advance="no") &
            "Dark frame: "//trim(darkname)//", "

       allocate(darkfits)
       call darkfits%Load(darkname,keys)
       if( .not. darkfits%status ) stop 'Failed to load dark frame.'

       if( verbose ) write(error_unit,'(a,1pg0.3,a,0pf0.1)') &
            ' exp.time[s] = ',darkfits%exptime, &
            ', T[degC] = ',darkfits%temper
    end if

    ! mask
    if( maskname /= '' ) then
       if( verbose ) write(error_unit,*) "Mask frame: ",trim(maskname)

       allocate(maskfits)
       call maskfits%Load(maskname)
       if( .not. maskfits%status ) stop 'Failed to load the mask frame.'
    end if

    if( verbose ) write(error_unit,*) &
         "Filename, filter, exptime[s], gain[ct/adu], saturation[ct], T[degC]:"

    ! flats
    allocate(flats(nflat),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) trim(msg)
       error stop 'Insufficient memory.'
    end if

    do n = 1, size(flatnames)

       if( verbose ) write(error_unit,'(a)',advance="no") &
            trim(flatnames(n))//":"

       call flats(n)%Load(flatnames(n),keys)
       if( .not. flats(n)%status ) stop 'Flat-field frame read failed.'

       if( n == 1 .and. allocated(biasfits) ) then
          if( .not. all(biasfits%naxes == flats(n)%naxes) ) then
             stop "Dimensions of bias and the frame does not corresponds."
          end if
       end if

       if( n == 1 .and. allocated(darkfits) ) then
          if( .not. all(darkfits%naxes == flats(n)%naxes) ) then
             stop "Dimensions of dark and the frame does not corresponds."
          end if
       end if

       if( n == 1 .and. allocated(maskfits) ) then
          if( .not. all(maskfits%naxes == flats(n)%naxes) ) then
             stop "Dimensions of bitmask and the frame does not corresponds."
          end if
       end if

       if( n > 1 ) then
          if( .not. all(flats(n-1)%naxes == flats(n)%naxes) ) then
             stop "Dimensions of images mutually does not corresponds."
          end if
       endif

       ! setup saturation
       if( saturate_set ) flats(n)%saturate = saturate

       ! set gain by the provided value
       if( gain_set ) then
          flats(n)%gain = gain
          flats(n)%gain_set = .true.
       end if

       if( verbose ) then
          if( flats(n)%gain_set .or. gain_set ) then
             gflag = ' '
          else
             gflag = '!'
             gain_default = .true.
          end if

          write(error_unit,'(2x,a,2x,1pg0.3,2x,0pf0.3,a,2x,1p,g0.2,2x,0pf0.1)')&
               trim(flats(n)%filter),flats(n)%exptime,flats(n)%gain,gflag, &
               flats(n)%saturate,flats(n)%temper

          ! detect filter mismatch
          if( flats(n)%filter /= flats(1)%filter ) filter_match = .false.
          if( flats(n)%filter == '' ) filter_empty = .true.

       end if
    end do

    if( .not. filter_match ) write(error_unit,*) &
         "Warning: incompatible filters detected (try --verbose)."

    if( filter_empty ) write(error_unit,*) &
         "Warning: empty filter value is encountered (try --verbose). "

    if( verbose .and. gain_default ) &
       write(error_unit,*) "Gain default setup is indicated by '!' flag."

  end block

  ! setup common parameters
  naxis = flats(1)%naxis
  naxes = flats(1)%naxes
  dateobs = flats(1)%dateobs
  imagetyp = flats(1)%imagetyp
  filter = flats(1)%filter

  allocate(flat(naxes(1),naxes(2)),flaterr(naxes(1),naxes(2)), &
       bitmask(naxes(1),naxes(2)),stat=stat,errmsg=msg)
  if( stat /= 0 ) then
     write(error_unit,*) trim(msg)
     error stop 'Insufficient memory.'
  end if

  if( allocated(maskfits) ) then
     bitmask = maskfits%image > 0.5
     deallocate(maskfits)
  else
     bitmask = .true.
  end if

  if( verbose ) then
     write(error_unit,*)
     write(error_unit,*) 'Flat-field frames:',nflat
     write(error_unit,*) 'Flat frame dimensions:',naxes(1),'x',naxes(2)
     write(error_unit,*) 'Filter: ',trim(filter)
     write(error_unit,*) 'Accuracy of approximation: ',trim(approximation)
  end if

  ! Section: flat-field preparation --------------------------------
  ! All flats are corrected for gain, bias, darks.
  block

    real, dimension(:,:), allocatable :: bias, ebias, dark, edark
    logical, dimension(:,:), allocatable :: mask
    real :: exptime
    logical :: exptime_set
    integer :: n,m

    n = naxes(1)
    m = naxes(2)
    allocate(bias(n,m),ebias(n,m),dark(n,m),edark(n,m),mask(n,m), &
         stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) trim(msg)
       error stop 'Insufficient memory.'
    end if

    if( allocated(biasfits) ) then
       bias = biasfits%image
       ebias = biasfits%imgerr
       deallocate(biasfits)
    else
       bias = 0
       ebias = 0
    end if
    if( allocated(darkfits) ) then
       dark = darkfits%image
       edark = darkfits%imgerr
       exptime = darkfits%exptime
       exptime_set = darkfits%exptime_set .and. darkfits%exptime > 0
       deallocate(darkfits)
    else
       dark = 0
       edark = 0
       exptime_set = .false.
    end if

    if( verbose ) write(error_unit,*) &
         'Pre-corrections by gain, bias, or dark of raw flats ...'

    do n = 1, size(flats)

       ! dark frame multiplicator
       if( xdark > 0 )then
          time = xdark
       else if( flats(n)%exptime_set .and. exptime_set ) then
          time = flats(n)%exptime / exptime
       else
          time = 1
       end if

       ! Preparatory correct input flats (updates images in FitsCorr).
       ! Standard deviation is set with assumption of Poisson distribution
       ! of data. It requires large light fluxes, around half of a full range.
       associate (image => flats(n)%image, imgerr => flats(n)%imgerr, &
            saturate => flats(n)%saturate, gain => flats(n)%gain )

         mask = threshold < image .and. image < saturate .and. bitmask
         where( mask )
            image = gain*(image - (bias + time*dark))
            mask = image > epsilon(image)
         elsewhere
            ! Important. Pixels out of the mask has set negative values
            ! during all computations below, use of individual masks
            ! for every frame takes a lot of memory.
            image = -1
         end where
         where( mask )
            imgerr = sqrt(image + gain**2*(ebias**2 + time**2*edark**2))
         elsewhere
            imgerr = -1
         end where
         ! IMPORTANT
         ! imgerr means standard deviation: stdsig
         ! similarity stderr and imgerr, or meaning in dark.f08,
         ! is pure coincidental (and memory saving)

         ! determine of mean level of our current frame
         call rmean(pack(image,mask),pack(imgerr,mask), &
              flats(n)%mean,flats(n)%stderr,flats(n)%sig)

       end associate
    end do

    deallocate(mask,bias,ebias,dark,edark)
  end block


  ! Section: Initial flat-field estimate as mean of scaled flats  ------
  !          by averadge levels.
  block

    real, dimension(:), allocatable :: x,w,q
    integer :: i,j,n,m
    real :: thresh

    n = naxes(1)
    m = naxes(2)
    allocate(x(nflat),w(nflat),q(nflat))
    do m = 1, nflat
       if( flats(m)%mean > 0 ) q(m) = sqrt(flats(m)%mean)
    end do

    ! Initial mean flat
    if( verbose ) write(error_unit,'(a)') &
         'Calculating the initial flat-field frame (iter. #0) ...'
    do j = 1,naxes(2)
       do i = 1,naxes(1)

          ! this is initial estimate only
          ! lighter frames has higher influence due Poisson statistics
          n = 0
          do m = 1, nflat
             associate( image => flats(m)%image, imgerr => flats(m)%imgerr, &
                  mean => flats(m)%mean, &
                  saturate => flats(m)%saturate, gain => flats(m)%gain )

               thresh = gain*threshold
               if( thresh < image(i,j) .and. image(i,j) < saturate .and. &
                    bitmask(i,j) .and. mean > 0 ) then
                  n = n + 1
                  x(n) = image(i,j) / mean
                  w(n) = imgerr(i,j) / q(m)
               end if
             end associate
          end do

          if( n > 1 ) then
             call rmean(x(1:n),w(1:n),flat(i,j),flaterr(i,j))
          else
             flat(i,j) = 1
             flaterr(i,j) = 0
          end if

       enddo
    enddo

    deallocate(x,w,q)
  end block

  ! Section: debug prints, write out the first estimate -----------
  if( debug ) then

     block
       real, allocatable, dimension(:,:) :: res
       integer :: i,j

       allocate(res(naxes(1),naxes(2)),stat=stat,errmsg=msg)
       if( stat /= 0 ) then
          write(error_unit,*) trim(msg)
          error stop 'Insufficient memory.'
       end if

       where( bitmask .and. flaterr > 0 )
          res = (flat - 1) / (flaterr * sqrt(real(nflat)))
       end where

       open(1,file='/tmp/flatdebug_zero.dat')
       do i = 1,size(flat,1),2
          do j = 1,size(flat,2),2
             if( bitmask(i,j) .and. flaterr(i,j) > 0 .and. &
                  abs(res(i,j)) < 25 ) then
                write(1,*) flat(i,j)-1,res(i,j), flat(i,j)
             end if
          end do
       end do
       close(1)
       deallocate(res)
     end block
  end if

  ! Section: estimate the flat-field with scaling by individual -----
  !          ratios against previously estimated flat-field.
  block

    logical, dimension(:,:), allocatable :: mask
    real, dimension(:,:), allocatable  :: res
    real, dimension(:), allocatable :: u,ue,v,ve,gains
    integer :: i,j,m,n,iter
    logical :: terminate, reliable
    real :: t, dt, d, sig, avg, thresh

    allocate(res(naxes(1),naxes(2)),u(nflat),ue(nflat),v(nflat),ve(nflat), &
         gains(nflat),mask(naxes(1),naxes(2)),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) trim(msg)
       error stop 'Insufficient memory.'
    end if

    terminate = .false.
    do iter = 1, maxiter

       ! Now, we're improving accuracy of approximation. The number of
       ! iterations is controled by `terminate' variable which tests
       ! convergence of subsequent estimates of the created flat.

       if( terminate ) exit

       if( verbose ) then
          write(error_unit,'(a)') &
               'Scaling individual frames by the new flat ...'
          write(error_unit,'(a)') &
               "Filename, mean level[ct], std.err., std.dev., gain, reliable:"
       end if

       ! Update mean levels for individual frames
       do n = 1, nflat

          associate( image => flats(n)%image, imgerr => flats(n)%imgerr, &
               mean => flats(n)%mean, stderr => flats(n)%stderr, &
               stdsig => flats(n)%sig, &
               saturate => flats(n)%saturate, gain => flats(n)%gain )

            thresh = flats(n)%gain * threshold
            mask = thresh < image .and. image < saturate .and. imgerr > 0 &
                 .and. flat > 0 .and. flaterr > 0 .and. bitmask
            call fmean(pack(image,mask),pack(imgerr,mask),pack(flat,mask), &
                 pack(flaterr,mask),t,dt,sig,reliable=reliable)
!            call fmean(pack(flat,mask),pack(flaterr,mask), &
!                 pack(image,mask),pack(imgerr,mask),t,dt,sig,reliable=reliable)
            ! We assumes Poisson distribution of flat pixels, their dispersion
            ! is bound to the mean value. Data with strong fluence of
            ! non-Poisson noise component should be avoided already.

            ! update only when our estimate is realiable
            if( reliable ) then
               mean = t
               stderr = dt
               stdsig = sig
            end if

            if( verbose ) then

               gains(n) = t / sig**2
               write(error_unit, &
                    '(2a,2x,1pg0.5,2x,1pg0.3,1x,1pg0.5,2x,0pf0.3,2x,l1)') &
                    trim(flatnames(n)),": ",t,dt,sig,gains(n),reliable

            end if

          end associate

       enddo ! over all frames

       ! update flat
       if( verbose ) write(error_unit,'(a,i0,a)') &
            'Calculating accurate flat-field frame (iter. #',iter,') ...'
       res = -1
       do j = 1,naxes(2)
          do i = 1,naxes(1)

             n = 0
             do m = 1, nflat
                associate( image => flats(m)%image, imgerr => flats(m)%imgerr, &
                     mean => flats(m)%mean, sig => flats(m)%sig, &
                     saturate => flats(m)%saturate, gain => flats(m)%gain )

                  thresh = gain*threshold
                  if( thresh < image(i,j) .and. image(i,j) < saturate .and. &
                       imgerr(i,j) > 0 .and. bitmask(i,j) .and. &
                       mean > 0 .and. sig > 0 ) then
                     n = n + 1
                     u(n) = image(i,j)
                     ue(n) = imgerr(i,j)
                     v(n) = mean
                     ve(n) = sig
                  end if
                end associate
             enddo

             if( n > 0 ) then

                avg = flat(i,j)

                if( debug .and. i == naxes(1)/2 .and. j == naxes(2)/2 ) &
!                     call fmean(v(1:n),ve(1:n),u(1:n),ue(1:n), &
!                     flat(i,j),flaterr(i,j),reliable=reliable,verbose=.true.)
                     call fmean(u(1:n),ue(1:n),v(1:n),ve(1:n), &
                     flat(i,j),flaterr(i,j),reliable=reliable,verbose=.true.)

                call fmean(u(1:n),ue(1:n),v(1:n),ve(1:n), &
                     flat(i,j),flaterr(i,j))
!                call fmean(v(1:n),ve(1:n),u(1:n),ue(1:n), &
!                     flat(i,j),flaterr(i,j))

                ! Non reliable pixels are silently ignored. Some data
                ! has strongly non-gaussian distribution: the case of
                ! bad columns and pixels, an overscan data and etc.
                ! if( .not. reliable .and. verbose ) write(*,*) i,j

                ! the absolute difference between the result of previous
                ! computation and the current one controls termination
                if( reliable ) res(i,j) = abs(avg - flat(i,j))

             else
                flat(i,j) = 1
                flaterr(i,j) = 0
             end if

          enddo
       enddo

       ! condition for terminate: the mean difference of running flats
       ! between two latest subsequent iterations is smaller
       ! the mean std.err. limit
       d = qmedian(pack(res,res>0))
       flat_err = qmedian(pack(flaterr,flaterr>0))
       terminate = d < flat_err
       if( verbose ) &
            write(error_unit,'(a,3x,1p,2(g0.1,2x),l1)') &
            'Mean residual and std.dev., terminate:',d,flat_err,terminate

    end do ! iter

    ! final mean over the whole area
    call rmean(pack(flat,bitmask),flat_mean)

    if( verbose ) &
       call rmean(gains,gain_mean,gain_err)

    if( maxiter == 0 ) flat_err = qmedian(pack(flaterr,flaterr>0))

    deallocate(mask,res,u,ue,v,ve,gains)
  end block

  ! Section: diagnostics  ----------------------------------------
  block

    character(len=FLEN_FILENAME) :: buf
    logical, dimension(:,:), allocatable :: mask
    real, dimension(:,:), allocatable  :: res,des
    real :: thresh
    integer :: i,j,n

    allocate(mask(naxes(1),naxes(2)),res(naxes(1),naxes(2)), &
         des(naxes(1),naxes(2)),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) trim(msg)
       error stop 'Insufficient memory.'
    end if

    if( debug ) then
       ! (**)
       ! Diagnostics. The second column of the files
       ! are residuals intended for Normality testing.
       !
       ! https://stackoverflow.com/questions/2471884/
       ! or:
       ! gnuplot> binwidth=0.05
       ! gnuplot> bin(x,width)=width*floor(x/width)
       ! gnuplot> plot '/tmp/flatdebug_666.fits.dat' \
       !          using (bin($2,binwidth)):(1.0) smooth freq with boxes

       do n = 1, nflat

          associate( image => flats(n)%image, imgerr => flats(n)%imgerr, &
               mean => flats(n)%mean, saturate => flats(n)%saturate, &
               gain => flats(n)%gain  )

            thresh = gain*threshold
            mask = thresh < image .and. image < saturate .and. &
                 flat > 0 .and. flaterr > 0 .and. bitmask
            where( mask )
               des = sqrt(imgerr**2 + mean**2*flaterr**2)
               res = (image - mean*flat) / des
            end where

            write(buf,'(a,i0,a)') '/tmp/flatdebug_',n,'.dat'
            open(1,file=buf)
            write(1,'(2a)') '# ',trim(flatnames(n))
            do i = 1,size(image,1),2
               do j = 1,size(image,2),2
                  if( mask(i,j) .and. abs(res(i,j)) < 5 ) then
                     write(1,*) image(i,j)-mean, res(i,j), flat(i,j)
                  end if
               end do
            end do
            close(1)
          end associate

        end do
     end if ! debug
     deallocate(mask,res,des)
   end block

   ! Section: save in integers implies to scale the flat ------------------
   block

     integer :: waterline
     real :: maxflat

     ! Representation of flat by integers can't be recommended in any case,
     ! but it can be useful for a compatibility
     if( bitpix > 0 ) then

        ! scaled to waterline
        waterline = nint(10.0**(int(log10(2.0**(bitpix-1)))))
        ! waterline updates mean levels on 1e2,1e4 and 1e9
        flat_mean = waterline * flat_mean
        flat = waterline * flat
        flaterr = waterline * flaterr
        maxflat = 2.0**bitpix - 1

        ! range cut-off
        flat = max(0.0,min(flat,maxflat))
        flaterr = max(0.0,min(flaterr,maxflat))
        if( verbose ) write(error_unit,*) &
             'Warning: Numerical accurate degraded by conversion to integers.'
     end if
   end block

  if( verbose ) then
     write(error_unit,'(2a)') ' Output image: ',trim(flatname)
     write(error_unit,'(a,3x,1pg0.7)') ' Final mean:',flat_mean
     write(error_unit,'(a,3x,1pg0.1)') &
          ' Expected photometry standard error per pixel:',flat_err
     write(error_unit,'(a,2(2x,f0.3),a,f0.3,a)') &
          ' Estimated relative gain, std.err:',gain_mean,gain_err, &
          ' (original gain was ',gain,').'
  end if

  ! Section: FITS save ----------------------------------------------
  block

    integer, parameter :: group = 1
    character(len=*), parameter :: afid = 'FLAT'
    character(len=FLEN_CARD) :: buf
    integer :: n
    type(fitsfiles) :: fits

    call fits_create_scratch(fits,status)
    call fits_insert_img(fits,bitpix,naxis,naxes,status)
    if( dateobs /= '' ) &
         call fits_write_key(fits,keys(1),dateobs, &
         'UTC of the first on input',status)
    if( filter /= '' ) &
         call fits_write_key(fits,keys(3),filter,'filter',status)
    if( imagetyp /= '' ) &
         call fits_write_key(fits,FITS_KEY_IMAGETYP,imagetyp, &
         'Image type',status)
    if( verbose ) then
       call fits_write_key(fits,'GAIN_AVG',gain_mean,6, &
            '[ct/ADU] estimated gain',status)
       call fits_write_key(fits,'GAIN_STD',gain_err,2, &
            '[ct/ADU] std.dev of estimated gain',status)
    end if

    if( nflat > 0 ) then
       write(buf,'(a,i0,a)') 'Result of flat-fielding of ',nflat,' frames(s):'
       call fits_write_comment(fits,buf,status)
       do n = 1, nflat
          call fits_write_comment(fits,"'"//trim(flatnames(n))//"'",status)
       enddo
    endif

    if( gain_set ) then
       write(buf,'(f0.3)') gain
       call fits_write_history(fits,afid//" gain: "//trim(buf),status)
    end if

    if( darkname /= '' ) then
       write(buf,'(a,g0.5)') afid//" dark: '"//trim(darkname)//"' *",time
       call fits_write_history(fits,buf,status)
    end if

    if( biasname /= '' ) then
       buf = afid//" bias: '"//trim(biasname)//"'"
       call fits_write_history(fits,buf,status)
    end if

    if( maskname /= '' ) then
       buf = afid//" bitmask: '"//trim(maskname)//"'"
       call fits_write_history(fits,buf,status)
    end if

    if( threshold_set ) then
       write(buf,*) afid//" threshold: ", threshold, " (no gain applied)"
       call fits_write_history(fits,buf(2:),status)
    end if

    if( saturate_set ) then
       write(buf,*) afid//" saturation: ",saturate," (no gain applied)"
       call fits_write_history(fits,buf(2:),status)
    end if

    write(buf,*) afid//" mean level: ",flat_mean
    call fits_write_history(fits,buf(2:),status)

    call fits_update_key(fits,FITS_KEY_CREATOR,FITS_VALUE_CREATOR, &
         FITS_COM_CREATOR,status)
    call fits_write_comment(fits,MUNIPACK_VERSION,status)

    ! flat-field data
    call fits_write_image(fits,group,flat,status)

    ! standard error of mean
    call fits_insert_img(fits,bitpix,naxis,naxes,status)
    call fits_update_key(fits,'EXTNAME',EXT_STDERR,'',status)
    call fits_write_comment(fits,&
         'The estimation of standard error of mean of pixels of flat-field.',&
         status)

    call fits_write_image(fits,group,flaterr,status)

    if( status == 0 ) then
       if( fits_file_exist(flatname) ) call fits_file_delete(flatname)
       call fits_file_duplicate(fits,flatname,status)
    end if
    call fits_delete_file(fits,status)

    call fits_report_error(error_unit,status)

  end block

  deallocate(flats,flatnames,flat,flaterr,bitmask)

  if( status == 0 ) then
     stop 0
  else
     stop 'An error occurred during flat-field determination.'
  end if

end program flatmaker

!
! Matching on base of looking for nearest stars
!
!
! Copyright © 2017 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module nearmatch

  use iso_fortran_env

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

contains

  subroutine listmatch(type,alpha,delta,pmalpha,pmdelta,xx,yy,epoch,jd, &
       acen,dcen,xc,yc,scale,pa,refl,tol,i1,i2,status)

    use astrotrafo

    character(len=*), intent(in) :: type
    real(dbl), dimension(:), intent(in) :: alpha,delta,pmalpha,pmdelta,xx,yy
    real(dbl), intent(in) :: acen,dcen,xc,yc,scale,pa,refl,tol,epoch,jd
    integer, dimension(:), allocatable, intent(out) :: i1,i2
    logical, intent(out) :: status
    real(dbl), dimension(:), allocatable :: x,y,u,v
    integer, dimension(:), allocatable :: id1,id2
    type(AstroTrafoProj) :: t
    real(dbl) :: smin,smin0,s,dt
    integer :: nsize,msize,n,i,j,idx
    logical :: found

    status = .false.

    if( size(alpha) /= size(delta) .or. size(xx) /= size(yy) .or. &
        size(alpha) /= size(pmalpha) .or. size(pmalpha) /= size(pmdelta) ) stop 666

    allocate(x(size(xx)),y(size(yy)))
    x = xx
    y = yy

    ! apparent coordinates
    dt = (jd - epoch)/365.25_dbl

    ! select maximum amount of stars by list
    nsize = size(alpha)
    msize = size(x)
    allocate(u(nsize),v(nsize),id1(nsize),id2(nsize))

    call trafo_init(t,type,acen,dcen)
    call proj(t,alpha+dt*pmalpha,delta+dt*pmdelta,u,v)
    call trafo_init(t,xcen=xc,ycen=yc,scale=1/scale,rot=pa,refl=refl)
    call invaffine(t,xx,yy,x,y)

    smin0 = tol

    n = 0
    do i = 1, nsize
       smin = smin0
!       write(*,'(i5,5f15.5)') i,u(i),v(i),alpha(i),delta(i),smin
!       write(*,*) alpha(i),delta(i),smin
       idx = 0
       do j = 1, msize
!          write(*,*) x(j),y(j),smin
          s = sqrt((u(i) - x(j))**2 + (v(i) - y(j))**2)
          if( s < smin ) then
             ! the nearest and brighest star (on flux-sorted list)
             smin = s
             idx = j
          end if
       end do
       if( idx > 0 ) then

          ! check whatever the star is already presented,
          ! it will be ignored, because brighter ones are prefered
          ! (and we are supposing flux-sorted lists).
          found = .false.
          do j = 1, n
             if( idx == id2(j) ) then
                found = .true.
                goto 99
             end if
          end do
99        continue

          if( .not. found ) then
             n = n + 1
             id1(n) = i
             id2(n) = idx
          end if


!          if( debug ) write(*,'(f10.3,2i5,2f15.2)') smin,i,idx,u(i)-x(idx),v(i)-y(idx)

          if( n == size(id1) ) goto 20
       end if
    end do
20 continue

    allocate(i1(n),i2(n))
    i1 = id1(1:n)
    i2 = id2(1:n)

    deallocate(id1,id2,u,v,x,y)

    status = n > 0

  end subroutine listmatch


end module nearmatch

!
!  munilist
!
!  Copyright © 2011-3 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!  
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!  
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module mlist

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl

  integer, private :: nfile,gncoo,gnaperture
  integer, dimension(:), allocatable, private :: gyear,gmonth,gday,ghour,gminute
  real(dbl), dimension(:), allocatable, private :: gra,gdec,gsec,gexposure,gjulday, &
       garea,gzeroflux,gctflux,gdctflux
  real(dbl), dimension(:), allocatable, private :: gxcoo,gycoo,gvxcoo,gvycoo
  real(dbl), dimension(:,:), allocatable, private :: gdata
  character(len=80),dimension(:), allocatable, private :: gfitskeys,gfitsval,gheadkeys,&
       gheadval,gfilters,gcols
  character(len=80), private :: gmode, gcootype, gdateobs, gfilter
  real(dbl), private :: gaperture,gtol,gzeromag,gflux0,gepoch,gequinox,gexptime
  logical, private :: gmags,gfluxes,gcalibr,gdiffmag,verbose,gfileprint

contains

  subroutine munilist_init(mode,nfiles,fitskeys,headkeys,cols,aperture,naperture,&
       tol,zeromag,flux0,epoch,equinox,mags,fluxes,calibr,diffmag,verb,fileprint)

    character(len=*), intent(in) :: mode
    integer, intent(in) :: nfiles, naperture
    character(len=*), dimension(:), intent(in) :: fitskeys, headkeys, cols
    real(dbl), intent(in) :: aperture,tol,zeromag,flux0,epoch,equinox
    logical, intent(in) :: mags,fluxes,calibr,diffmag,verb,fileprint
    integer :: ncols
    
    gmode = mode
    ncols = size(cols)
    if( ncols == 0 ) stop 'munilist_init: undefined cols (try --mag, --flux or --col)'
    if( allocated(gfitskeys) ) stop 'munilist_init: gfitskeys already allocated.'
    allocate(gfitskeys(size(fitskeys)),gfitsval(size(fitskeys)),gheadkeys(size(headkeys)),&
         gheadval(size(headkeys)),gcols(size(cols)))
    gfitskeys = fitskeys
    gheadkeys = headkeys
    gcols = cols
    allocate(gyear(nfiles),gmonth(nfiles),gday(nfiles),ghour(nfiles),gminute(nfiles), &
         gsec(nfiles),gfilters(nfiles),gexposure(nfiles),gjulday(nfiles),&
         gra(nfiles),gdec(nfiles),garea(nfiles),gzeroflux(nfiles),gctflux(nfiles),&
         gdctflux(nfiles))
    nfile = 0
    gtol = tol
    gaperture = aperture
    gnaperture = naperture
    gzeromag = zeromag
    gflux0 = flux0
    gepoch = epoch
    gequinox = equinox
    gmags = mags
    gfluxes = fluxes
    gcalibr = calibr
    gdiffmag = diffmag
    verbose = verb
    gfileprint = fileprint
!    write(*,*) nfiles,ncols

  end subroutine munilist_init

! ------

  subroutine munilist_coo(cootype,xcoo,ycoo,vxcoo,vycoo)
    
    character(len=*), intent(in) :: cootype
    real(dbl), dimension(:), intent(in) :: xcoo,ycoo,vxcoo,vycoo
    integer :: n

    n = size(xcoo)
    if( allocated(gxcoo) ) stop 'munilist_coo: gxcoo already allocated.'
    allocate(gxcoo(n),gycoo(n),gvxcoo(n),gvycoo(n))
    gxcoo = xcoo
    gycoo = ycoo
    gvxcoo = vxcoo
    gvycoo = vycoo
    gcootype = cootype

    if( allocated(gdata) ) stop 'munilist_coo: gdate already allocated.'
    
    gncoo = n
    allocate(gdata(size(gyear),n*size(gcols)))


  end subroutine munilist_coo

! ------

  subroutine munilist_add(filename)

    use fitsio
    use trajd
    use astrosphere

!    use traco
    use astrotrafo
    use mtable

    character(len=*), intent(in) :: filename

    character(len=80) :: ctype,filter,phsystem
    character(len=666) :: fmt = ""
    integer :: i,j,ij,n, ndata, status
    real(dbl) :: year,month,day,hour,min,sec,exptime,area,jd,r,rmin,dt,tol,dtol, &
         scale,angle,ctflux,dctflux,zeromag,zeroflux,gain,feff,fwidth,feff,ffwhm,leff,lfwhm,
    real(dbl),dimension(:), allocatable :: x,y
    real(dbl),dimension(:,:), allocatable :: data,xdata
    real(dbl), dimension(:), allocatable :: a,d,u,v,mag,dmag,flux,dflux
    real(dbl), dimension(2) :: crval, crpix
    type(TypeProjection) :: t


    call table(filename, gfitskeys, gheadkeys, gcols, gaperture, gnaperture, verbose,gfitsval,&
         gheadval,year,month,day,hour,min,sec,exptime,area,gain,filter,phsystem,gcootype,ctype,crpix,crval, &
         scale,angle,dtol,fnuref,flamref,leff,lfwhm,feff,ffwhm,ctflux,dctflux,x,y,data,status)

    gdateobs = gfitsval(1)
    if( status /= 0 ) then
       if( allocated(x) ) deallocate(x)
       if( allocated(y) ) deallocate(y)
       if( allocated(data) ) deallocate(data)
       return
    end if

    if( gmode == 'lc' .and. .not. allocated(gxcoo) ) then

       n = size(x)
       allocate(gxcoo(n),gycoo(n),gvxcoo(n),gvycoo(n))
       t%type = ctype
       t%acen = crval(1)
       t%dcen = crval(2)
       t%xcen = crpix(1)
       t%ycen = crpix(2)
       t%scale = scale
       t%pa = angle
       call invtrafo(t,x,y,gxcoo,gycoo)
       gvxcoo = 0.0_dbl
       gvycoo = 0.0_dbl
       gcootype = 'equatorial'

       if( allocated(gdata) ) stop 'munilist_coo: gdate already allocated.'
    
       gncoo = n
       allocate(gdata(size(gyear),n*size(gcols)))
    end if

    ! Evaluate Julian date at half of exposure 
    jd = datjd(year,month,day + (hour + (min + sec/60.0)/60.0)/24.0)
    jd = jd + exptime/2.0/86400.0
    
    ! look for coordinates
    if( allocated(gxcoo) ) then

       n = size(gxcoo)
       allocate(a(n),d(n),u(n),v(n))
       do j = 1, n
          dt = jd - gepoch!jd0
          a(j) = gxcoo(j) + gvxcoo(j)*dt
          d(j) = gycoo(j) + gvycoo(j)*dt
       end do

       t%type = ctype    
       t%acen = crval(1)
       t%dcen = crval(2)
       t%xcen = crpix(1)
       t%ycen = crpix(2)
       t%scale = scale
       t%pa = angle
    
       call trafo(t,a,d,u,v)
       !    write(*,*) a,d,u,v

       if( gtol > 0.0 ) then
          tol = gtol
       else
          ! one looks strange, but 1pix is prefered over dtol=0.0
          tol = 10.0*max(dtol,1.0/scale)
       end if
       tol = scale*tol
       
       ! locate stars on base of euclidean metric
       ndata = size(gcols)
       allocate(xdata(n,ndata))
       !    tol = max(,xtol)
       !    write(*,*) tol,scale
       do j = 1, n

          rmin = huge(rmin)
          ij = 0

          do i = 1, size(x)
             r = sqrt((x(i) - u(j))**2 + (y(i) - v(j))**2)
             !          write(*,'(5f10.3)') x(i),u(j),y(i),v(j),r
             if( r < tol .and. r < rmin) then
                rmin = r
                ij = i
             end if
          end do
          
          if( ij > 0 ) then
             xdata(j,:) = data(ij,:)
          else
             xdata(j,:) = 0.0
             if( verbose ) write(*,'(a,2(f0.5,1x),"(",2(f0.1,1x),"[pix]) ",a,g0.5)') &
                  'Object at ',a(j),d(j),u(j),v(j),' not found: r=',r
          end if
       end do

       deallocate(u,v)

    else

       n = size(x)
       ndata = size(gcols)
       allocate(a(n),d(n),xdata(n,ndata))
       xdata = data

       t%type = ctype
       t%acen = crval(1)
       t%dcen = crval(2)
       t%xcen = crpix(1)
       t%ycen = crpix(2)
       t%scale = scale
       t%pa = angle
       call invtrafo(t,x,y,a,d)
       

    end if

    ! update globals
    nfile = nfile + 1
    gra(nfile) = a(1)
    gdec(nfile) = d(1)
    gyear(nfile) = year
    gmonth(nfile) = month
    gday(nfile) = day
    ghour(nfile) = hour
    gminute(nfile) = min
    gsec(nfile) = sec
    gexposure(nfile) = exptime
    garea(nfile) = area
    gzeroflux(nfile) = zeroflux
    gctflux(nfile) = ctflux
    gdctflux(nfile) = dctflux
    gfilters(nfile) = filter
    gjulday(nfile) = jd


    if( gmode == 'lc' ) then
       ! save LC

       if( gmags .or. gfluxes ) then

          r = exptime*area

          allocate(flux(n),dflux(n))
          where( xdata(:,1) > 0.0_dbl )
             flux = xdata(:,1)/r
             dflux = xdata(:,2)/r
          elsewhere
             flux = xdata(:,1)
             dflux = xdata(:,2)
          end where
          if( gcalibr ) then
             where( flux > 0.0_dbl )
                flux = ctflux*flux 
                dflux = dctflux*dflux 
             end where
          end if

          if( gmags ) then
             
             allocate(mag(n),dmag(n))
             if( gcalibr ) then
                zeromag = 2.5_dbl*log10(zeroflux)
             else
                zeromag = gzeromag
             end if
             call magnitudes(zeromag,flux,dflux,mag,dmag)
             
             !       if( gmags ) then
             
             !          allocate(mag(n),dmag(n))
             !          call magnitudes(gzeromag,xdata(:,1),xdata(:,2),mag,dmag)
             write(fmt,'(a,i0,a)') "(1x,f0.10,1x,3a,1x,",2*n,"(1x,f0.5))"

             if( gdiffmag ) then

                do i = 2,n
                   if( mag(i) < 99.0 .and. mag(1) < 99.0 ) then
                      mag(i) = mag(i) - mag(1)
                      dmag(i) = sqrt(dmag(i)**2+dmag(1)**2)
                   else
                      mag(i) = 99.99999_dbl
                      dmag(i) = 9.99999_dbl
                   end if
                end do
                
                write(*,fmt) jd,"'",trim(filter),"'",(mag(i),dmag(i),i=2,n)
                gdata(nfile,:) = (/(mag(i),dmag(i),i=2,n)/)
                
             else
                
                !          if( .not. gcalibr ) then
             
                write(*,fmt) jd,"'",trim(filter),"'",(mag(i),dmag(i),i=1,n)
                gdata(nfile,:) = (/(mag(i),dmag(i),i=1,n)/)
                
                !          else
                
                !             do i = 2,n
                !                mag(i) = mag(i) - mag(1)
                !                dmag(i) = sqrt(dmag(i)**2+dmag(1)**2)
                !             end do
                
                !             write(*,fmt) jd,"'",trim(filter),"'",(mag(i),dmag(i),i=2,n)
                !             gdata(nfile,:) = (/(mag(i),dmag(i),i=2,n)/)
             
             end if
!          end if
             deallocate(mag,dmag)

          else if( gfluxes ) then

             !          allocate(flux(n),dflux(n))
             !          r = exptime*area
             !          flux = xdata(:,1)/r
             !          dflux = xdata(:,2)/r
             write(fmt,'(a,i0,a)') "(1x,f0.10,1x,3a,1x,",2*n,"(1x,f0.5))"
             write(*,fmt) jd,"'",trim(filter),"'",(flux(i),dflux(i),i=1,n)
             gdata(nfile,:) = (/(flux(i),dflux(i),i=1,n)/)
          end if
          deallocate(flux,dflux)
          
       else 

          if( gfileprint ) write(*,'(3a)',advance="no") "'",trim(filename),"'"

          write(*,'(1x,i4.4,tr1,4(i2.2,tr1),f6.3,tr1,f6.1,tr1,3a)',advance="no") &
               int(year),int(month),int(day),int(hour),int(min),sec,exptime,"'",trim(filter),"'"

          if( size(gheadval) > 0 ) &
               write(*,'(1000a)',advance="no") (" '"//trim(gheadval(i))//"'",i=1,size(gheadval))
       
          write(*,"(tr2,f20.10)",advance="no" ) jd

          if( gcootype == 'horizontal' ) then

!          if( alpha >= 0.0 .and. abs(lat) <= 90.0 )then
!             ha = hangle(lmst(jd,long)*15.0_dbl,alpha)
!             call eq2hor(ha,delta,lat,azimut,elev)
!             airm = airmass(90.0_dbl-elev)
!             write(*,'(2f10.5,f10.5)',advance="no") azimut,elev,airm
!          end if

          else if( gcootype == 'pixels' ) then

!             write(*,'(2000f10.3)',advance="no") (gxcoo(i),gycoo(i),i=1,n)
             !          write(*,'(2000f10.3)',advance="no") (u(i),v(i),i=1,n)
          
          else if( gcootype == 'equatorial' ) then

             call invtrafo(t,gxcoo,gycoo,a,d)
             !          call invtrafo(t,u,v,a,d)
             write(*,'(2000f12.5)',advance="no") (a(i),d(i),i=1,n)
             
          end if

          write(*,*) ((xdata(i,j),j=1,ndata),i = 1,n)

          ! save LC
          n = size(x)
          ndata = size(gcols)
!          do i = 1,n
!             gdata(nfile,1+(i-1)*ndata:1+i*ndata) = xdata(i,:)
!          end do
          gdata(nfile,:) = pack(xdata,.true.)!,(/1,n*ndata/))
          
       end if



    else if( gmode == 'cat' ) then

       ! save star field
       if( allocated(gdata) ) deallocate(gdata)
       allocate(gdata(size(xdata,1),size(xdata,2)))
       
       if( gmags .or. gfluxes ) then

          r = exptime*area
             
          allocate(flux(n),dflux(n))
          where( xdata(:,1) > 0.0_dbl )
             flux = xdata(:,1)/r
             dflux = xdata(:,2)/r
          elsewhere
             flux = xdata(:,1)
             dflux = xdata(:,2)
          end where
          if( gcalibr ) then
             where( flux > 0.0_dbl )
                flux = ctflux*flux 
                dflux = dctflux*dflux 
             end where
          end if

          if( gmags ) then

             allocate(mag(n),dmag(n))
             if( gcalibr ) then
                zeromag = 2.5_dbl*log10(zeroflux)
             else
                zeromag = gzeromag
             end if
             call magnitudes(zeromag,flux,dflux,mag,dmag)
!             call magnitudes(zeromag,xdata(:,1),xdata(:,2),mag,dmag)
             do i = 1, n
                write(*,"(2(f0.7,1x),2(f0.5,1x))") a(i),d(i),mag(i),dmag(i)
                gdata(i,:) = (/mag(i),dmag(i)/)
             end do
             deallocate(mag,dmag)

          else if( gfluxes ) then
             do i = 1, n
                write(*,"(2(f0.7,1x),2(en17.7,1x))") a(i),d(i),flux(i),dflux(i)
                gdata(i,:) = (/flux(i),dflux(i)/)
             end do
          end if

          deallocate(flux,dflux)

       else
          do i = 1,n
             write(*,*) a(i),d(i),(xdata(i,j),j=1,ndata)
             gdata(i,:) = (/(xdata(i,j),j=1,ndata)/)
          end do
       end if

       deallocate(gra,gdec)
       allocate(gra(size(a)),gdec(size(d)))
       gra = a
       gdec = d

    end if

    deallocate(x,y,xdata,data)

end subroutine munilist_add


! ----------------

  subroutine magnitudes(zeromag,flux,dflux,mag,dmag)

    real(dbl), intent(in) :: zeromag
    real(dbl), dimension(:), intent(in) :: flux,dflux
    real(dbl), dimension(:), intent(out) :: mag,dmag

    where( flux > 0.0 )
       mag = zeromag - 2.5_dbl*log10(flux)
       dmag = 1.086_dbl*dflux/flux
    elsewhere
       mag = 99.99999_dbl
       dmag = 9.99999_dbl
    end where

  end subroutine magnitudes

! ----------------



  subroutine munilist_finish(output,backup)

    use savetables

    character(len=*), intent(in) :: output,backup
    character(len=80), dimension(:), allocatable :: cols, fmtcols
    character(len=80) :: dateobs
    integer :: status, i, j, n

    if( output /= '' .and. nfile > 0 ) then

       if( gmode == 'lc' ) then

          if( gmags .or. gfluxes ) then

             if( gcalibr .and. gmags ) then
                n = gncoo - 1
             else
                n = gncoo
             end if
             allocate(cols(2*n),fmtcols(2))
             if( gmags ) then
                fmtcols(1) = '("MAG_",i0)'
                fmtcols(2) = '("MAGERR_",i0)'
             else if( gfluxes ) then
                fmtcols(1) = '("FLUX_",i0)'
                fmtcols(2) = '("FLUXERR_",i0)'
             end if
             do i = 1,n
                do j = 1,2
                   write(cols(2*(i-1)+j),fmtcols(j)) i
                end do
             end do
             deallocate(fmtcols)

          else
             
             n = size(gcols)
             allocate(cols(n*gncoo),fmtcols(n))
             do j = 1,n
                fmtcols(j) = '("'//trim(gcols(j))//'_",i0)'
             end do
             do i = 1,gncoo
                do j = 1,n
                   write(cols(n*(i-1)+j),fmtcols(j)) i
                end do
             end do             
             deallocate(fmtcols)
             
          end if

          call savelc(output,backup,'MUNIPACK_LC',cols,gfitskeys,gfitsval,&
               gaperture,gequinox,&
!               gaperture,gequinox,gyear,gmonth,gday,ghour,gminute,gsec,&
               gexposure,gjulday,gfilters,gxcoo,gycoo,gdata(:,1:size(cols)))
          
       else if( gmode == 'cat' ) then
 
          allocate(cols(size(gcols)))
          cols = gcols

          status = 0
          call fttm2s(int(gyear(1)),int(gmonth(1)),int(gday(1)),int(ghour(1)),&
               int(gminute(1)),gsec(1),3,dateobs,status)
          call savecat(output,backup,'MUNIPACK_CAT',cols,gfitskeys,gfitsval,&
          dateobs,gfilters(1),gexposure(1),gaperture,gequinox,gra,gdec,gdata)
          
       end if

       if( allocated(cols) ) deallocate(cols)

    end if

    if( allocated(gyear) ) deallocate(gyear,gmonth,gday,ghour,gminute,gsec,gfilters,&
         gexposure,gra,gdec,gjulday)
    if( allocated(gdata) ) deallocate(gdata)
    if( allocated(gxcoo) ) deallocate(gxcoo,gycoo,gvxcoo,gvycoo)
    if( allocated(gfitskeys) ) deallocate(gfitskeys,gfitsval,gheadval,gcols)

    if(nfile==0) stop 'No apropriate files on input. Perhaps astrometry or photometry unavailable?'

  end subroutine munilist_finish

end module mlist



!!!  subroutine munilist(mode,filename,output,aperture,xcoo,ycoo,vxcoo,vycoo,xtol, &
!!!!  subroutine munilist(mode,filename,output,idx,xcoo,ycoo,vxcoo,vycoo,xtol, &
!!!       zeromag, &
!!!!    min0,per,long,lat,alpha,delta,
!!!       jd0,mags,fluxes,instrmag,&
!!!!       full,positions,header, &
!!!       verbose,fileprint,cootype,headkeys,selcols,fitskeys, object,observer,author,instrument,telescope, &
!!!               origin,reference,equinox)
!!!
!!!!    use cfitsio  ! consider fitsio
!!!    use fitsio
!!!    use trajd
!!!    use traco
!!!    use astrotrafo
!!!    use mtable
!!!    use savetables
!!!
!!!!!$    interface
!!!!!$       subroutine storelc(ra,de,eqx,y,m,d,h,min,s,e,jd,fl,dd)
!!!!!$         integer, intent(in) :: y,m,d,h,min
!!!!!$         integer, parameter :: dbl = selected_real_kind(15)
!!!!!$         real(dbl), intent(in) :: ra,de,eqx,s,e,jd
!!!!!$         real(dbl), dimension(:), intent(in) :: dd
!!!!!$         character(len=*),intent(in) :: fl
!!!!!$       end subroutine storelc
!!!!!$    end interface
!!!
!!!    character(len=*), intent(in) :: mode, filename, output, cootype
!!!    character(len=*), dimension(:), intent(in) :: fitskeys, headkeys, selcols
!!!    character(len=*), intent(in) :: object,observer,author,instrument, &
!!!         telescope,origin,reference
!!!!    integer, dimension(:), intent(in) :: idx
!!!    real(dbl),dimension(:),intent(in) :: xcoo, ycoo, vxcoo, vycoo
!!!    real(dbl),intent(in) :: aperture,xtol, zeromag, equinox!, min0,per,long, lat, alpha, delta, jd0
!!!    logical, intent(in) :: verbose
!!!    logical, intent(in) :: mags,fluxes,instrmag,fileprint!,full,positions,header,
!!!
!!!!    integer, parameter :: DIM = 7
!!!!    integer, dimension(DIM) :: naxes
!!!    integer :: status!,blocksize,naxis,pcount,gcount,bitpix,nrows,colnum
!!!!    character(len=10) :: colname
!!!!    logical :: simple,extend,anyf
!!!!    integer :: frow = 1, felem = 1
!!!!    real(dbl) :: nullval = 0.0
!!!
!!!    character(len=80) :: ctype,filter,dateobs
!!!    character(len=666) :: fmt = ""
!!!    character(len=80), dimension(:), allocatable :: headval, cols, fkeys
!!!!    character(len=80), dimension(:), allocatable :: cols
!!!    integer :: i,j,ij,n, ndata!,icol!,y1,m1,d1,h1,min1
!!!    real(dbl) :: year,month,day,hour,min,sec,exptime,jd,jd0, r,rmin,dt,tol,dtol,scale,angle 
!!!    !,hcor,helcor, ls,&
!!!    !         phase,azimut,elev,ha,airm,
!!!!    real(dbl),dimension(:), allocatable :: sky,dsky,x,y
!!!    real(dbl),dimension(:), allocatable :: x,y
!!!    real(dbl),dimension(:,:), allocatable :: data,xdata,xmag,xflux
!!!!    real(dbl),dimension(:,:), allocatable :: flux,dflux,xflux,xdflux
!!!!    integer, dimension(:), allocatable :: id
!!!    real(dbl), dimension(:), allocatable :: a,d,u,v,mag,dmag,flux,dflux
!!!!    real(dbl), dimension(:), allocatable :: xpix,ypix,csky,cdsky,cflux,cdflux,a,d,u,v,mag,dmag
!!!    real(dbl), dimension(2) :: crval, crpix!, crder
!!!!    real(dbl), dimension(2,2) :: cd
!!!    type(TypeProjection) :: t
!!!
!!!!    real :: e,x(nstars),dx(nstars),sky(nstars),dsky(nstars)
!!!!    real :: is(nstars),dis(nstars)
!!!
!!!!    tol = xtol
!!!!    n = size(idx) + size(xcoo)
!!!
!!!!    allocate(gfitskeys(size(fitskeys))
!!!!    if( allocated(gfitskeys) ) gfitskeys = fitskeys
!!!
!!!    n = size(xcoo)
!!!    if( mags .or. fluxes ) then
!!!       allocate(cols(2))
!!!       cols(1) = 'apflux'
!!!       cols(2) = 'apflux_err'
!!!       if( allocated(gdata) ) then
!!!          deallocate(gdata)
!!!          n = size(gdata,1)
!!!          allocate(gdata(n,2))
!!!       end if
!!!    else
!!!       allocate(cols(size(selcols)))
!!!       cols = selcols
!!!    end if
!!!
!!!    call table(filename, fitskeys, headkeys, cols, aperture, verbose, &
!!!         headval,year,month,day,hour,min,sec,exptime,filter,ctype,crpix,crval,scale,angle,dtol,&
!!!         x,y,data,status)
!!!    if( status /= 0 ) then
!!!       deallocate(cols)
!!!       if( allocated(headval) ) deallocate(headval)
!!!       if( allocated(x) ) deallocate(x)
!!!       if( allocated(y) ) deallocate(y)
!!!       if( allocated(data) ) deallocate(data)
!!!       return
!!!    end if
!!!
!!!    ! Evaluate Julian date at half of exposure 
!!!    jd = datjd(year,month,day + (hour + (min + sec/60.0)/60.0)/24.0)
!!!    jd = jd + exptime/2.0/86400.0
!!!
!!!!    write(*,*) jd
!!!
!!!    ! look for coordinates
!!!    n = size(xcoo)
!!!
!!!    if( n > 0 ) then
!!!
!!!       allocate(a(n),d(n),u(n),v(n))
!!!       do j = 1, n
!!!          dt = jd - jd0
!!!          a(j) = xcoo(j) + vxcoo(j)*dt
!!!          d(j) = ycoo(j) + vycoo(j)*dt
!!!       end do
!!!
!!!       t%type = ctype    
!!!       t%acen = crval(1)
!!!       t%dcen = crval(2)
!!!       t%xcen = crpix(1)
!!!       t%ycen = crpix(2)
!!!       t%scale = scale
!!!       t%pa = angle
!!!    
!!!       call trafo(t,a,d,u,v)
!!!       !    write(*,*) a,d,u,v
!!!
!!!       if( xtol > 0.0 ) then
!!!          tol = xtol
!!!       else
!!!          ! one looks strange, but 1pix is prefered over dtol=0.0
!!!          tol = 10.0*max(dtol,1.0/scale)
!!!       end if
!!!       tol = scale*tol
!!!       
!!!       ! locate stars on base of euclidean metric
!!!       ndata = size(cols)
!!!       allocate(xdata(n,ndata))
!!!       !    tol = max(,xtol)
!!!       !    write(*,*) tol,scale
!!!       do j = 1, n
!!!
!!!          rmin = huge(rmin)
!!!          ij = 0
!!!
!!!          do i = 1, size(x)
!!!             r = sqrt((x(i) - u(j))**2 + (y(i) - v(j))**2)
!!!             !          write(*,'(5f10.3)') x(i),u(j),y(i),v(j),r
!!!             if( r < tol .and. r < rmin) then
!!!                rmin = r
!!!                ij = i
!!!             end if
!!!          end do
!!!          
!!!          if( ij > 0 ) then
!!!             xdata(j,:) = data(ij,:)
!!!          else
!!!             xdata(j,:) = 0.0
!!!             if( verbose ) write(*,'(a,2(f0.5,1x),"(",2(f0.1,1x),"[pix]) ",a,g0.5)') &
!!!                  'Object at ',a(j),d(j),u(j),v(j),' not found: r=',r
!!!          end if
!!!       end do
!!!
!!!       deallocate(u,v)
!!!
!!!    else
!!!
!!!       n = size(x)
!!!       ndata = size(cols)
!!!       allocate(a(n),d(n),xdata(n,ndata))
!!!       xdata = data
!!!
!!!       t%type = ctype
!!!       t%acen = crval(1)
!!!       t%dcen = crval(2)
!!!       t%xcen = crpix(1)
!!!       t%ycen = crpix(2)
!!!       t%scale = scale
!!!       t%pa = angle
!!!       call invtrafo(t,x,y,a,d)
!!!       
!!!
!!!    end if
!!!
!!!
!!!    if( mode == 'lc' ) then
!!!
!!!
!!!
!!!!    if( mode == 'head' ) then
!!!
!!!!    write(*,707) int(year),int(month),int(day),int(hour),int(min),int(sec),&
!!!!         jd,(trim(headval(i)),i=1,size(headval))
!!!    
!!!!707 format (1x,i4.4,tr1,5(i2.2,tr1),f13.5,2000(1x,a))
!!!
!!!       ! save LC
!!!       if( allocated(gyear) ) then
!!!          gra = a(1)
!!!          gdec = d(1)
!!!
!!!          nfile = nfile + 1
!!!          gyear(nfile) = year
!!!          gmonth(nfile) = month
!!!          gday(nfile) = day
!!!          ghour(nfile) = hour
!!!          gminute(nfile) = min
!!!          gsec(nfile) = sec
!!!          gexposure(nfile) = exptime
!!!          gfilters(nfile) = filter
!!!          gjulday(nfile) = jd
!!!!          gdata(nfile,:) = xdata(1,:)
!!!!          write(*,*) nfile,gminute(nfile)
!!!
!!!       end if
!!!
!!!
!!!    if( mags ) then
!!!
!!!       allocate(mag(n),dmag(n))
!!!       call magnitudes(zeromag,xdata(:,1),xdata(:,2),mag,dmag)
!!!       write(fmt,'(a,i0,a)') "(1x,f0.10,1x,3a,1x,",2*n,"(1x,f0.5))"
!!!       if( instrmag ) then
!!!          write(*,fmt) jd,"'",trim(filter),"'",(mag(i),dmag(i),i=1,n)
!!!       else
!!!          write(*,fmt) jd,"'",trim(filter),"'", &
!!!               (mag(i)-mag(1),sqrt(dmag(i)**2+dmag(1)**2),i=2,n)
!!!       end if
!!!       gdata(nfile,:) = (/mag,dmag/)
!!!       deallocate(mag,dmag)
!!!
!!!    else if( fluxes ) then
!!!
!!!       allocate(flux(n),dflux(n))
!!!       flux = xdata(:,1)/exptime
!!!       dflux = xdata(:,2)/sqrt(exptime)
!!!!       call magnitudes(zeromag,xdata(:,1),xdata(:,2),mag,dmag)
!!!       write(fmt,'(a,i0,a)') "(1x,f0.10,1x,3a,1x,",2*n,"(1x,f0.5))"
!!!       write(*,fmt) jd,"'",trim(filter),"'",(flux(i),dflux(i),i=1,n)
!!!       gdata(nfile,:) = (/flux,dflux/)
!!!       deallocate(flux,dflux)
!!!
!!!    else 
!!!
!!!       if( fileprint ) write(*,'(3a)',advance="no") "'",trim(filename),"'"
!!!
!!!       write(*,'(1x,i4.4,tr1,4(i2.2,tr1),f6.3,tr1,f6.1,tr1,3a)',advance="no") &
!!!            int(year),int(month),int(day),int(hour),int(min),sec,exptime,"'",trim(filter),"'"
!!!
!!!       if( size(headval) > 0 ) &
!!!            write(*,'(1000a)',advance="no") (" '"//trim(headval(i))//"'",i=1,size(headval))
!!!       
!!!       write(*,"(tr2,f20.10)",advance="no" ) jd
!!!
!!!       if( cootype == 'horizontal' ) then
!!!
!!!!          if( alpha >= 0.0 .and. abs(lat) <= 90.0 )then
!!!!             ha = hangle(lmst(jd,long)*15.0_dbl,alpha)
!!!!             call eq2hor(ha,delta,lat,azimut,elev)
!!!!             airm = airmass(90.0_dbl-elev)
!!!!             write(*,'(2f10.5,f10.5)',advance="no") azimut,elev,airm
!!!!          end if
!!!
!!!       else if( cootype == 'pixels' ) then
!!!
!!!          write(*,'(2000f10.3)',advance="no") (xcoo(i),ycoo(i),i=1,n)
!!!!          write(*,'(2000f10.3)',advance="no") (u(i),v(i),i=1,n)
!!!          
!!!       else if( cootype == 'equatorial' ) then
!!!
!!!          call invtrafo(t,xcoo,ycoo,a,d)
!!!!          call invtrafo(t,u,v,a,d)
!!!          write(*,'(2000f12.5)',advance="no") (a(i),d(i),i=1,n)
!!!
!!!       end if
!!!
!!!       write(*,*) ((xdata(i,j),j=1,ndata),i = 1,n)
!!!
!!!       ! save LC
!!!       gdata(nfile,:) = xdata(1,:)
!!!
!!!!!$       if( allocated(gyear) ) then
!!!!!$          ra = a(1)
!!!!!$          dec = d(1)
!!!!!$
!!!!!$          nfile = nfile + 1
!!!!!$          gyear(nfile) = year
!!!!!$          gmonth(nfile) = month
!!!!!$          gday(nfile) = day
!!!!!$          ghour(nfile) = hour
!!!!!$          gminute(nfile) = min
!!!!!$          gsec(nfile) = sec
!!!!!$          gexposure(nfile) = exptime
!!!!!$          gfilters(nfile) = filter
!!!!!$          gjulday(nfile) = jd
!!!!!$          gdata(nfile,:) = xdata(1,:)
!!!!!$!          write(*,*) nfile,gminute(nfile)
!!!!!$
!!!!!$       end if
!!!
!!!!call storelc(a(1),d(1),2000.0_dbl,int(year),int(month),int(day),int(hour),int(min), &
!!!!            sec,exptime,jd,filter,xdata(1,:))
!!!
!!!    end if
!!!
!!!
!!!
!!! else if( mode == 'sc' ) then
!!!
!!!    if( mags ) then
!!!       allocate(mag(n),dmag(n))
!!!       call magnitudes(zeromag,xdata(:,1),xdata(:,2),mag,dmag)
!!!    else if( fluxes ) then
!!!       allocate(flux(n),dflux(n))
!!!       flux = xdata(:,1)/exptime
!!!       dflux = xdata(:,2)/sqrt(exptime)
!!!    end if
!!!
!!!    do i = 1,n
!!!
!!!       write(*,'(2(f0.7,1x))',advance="no") a(i),d(i)
!!!
!!!       if( mags ) then
!!!          write(*,"(2(f0.5,1x))") mag(i),dmag(i)
!!!       else if( fluxes ) then
!!!          write(*,"(2(en17.7,1x))") flux(i),dflux(i)
!!!       else
!!!          write(*,*) (xdata(i,j),j=1,ndata)
!!!       end if
!!!    end do
!!!
!!!    ! save star field
!!!    if( output /= '' ) then
!!!       i = 0
!!!       call fttm2s(int(year),int(month),int(day),int(hour),int(min),sec,3,dateobs,i)
!!!       if( mags ) then
!!!          allocate(xmag(size(mag),2))
!!!          xmag(:,1) = mag
!!!          xmag(:,2) = dmag
!!!          allocate(fkeys(2))
!!!          fkeys(1) = 'MAG'
!!!          fkeys(2) = 'MAG_ERR'
!!!          call savecat(output,filename,fitskeys,object,observer,author,instrument,telescope, &
!!!               origin,reference,equinox,dateobs,filter,exptime,fkeys,a,d,xmag)
!!!          deallocate(xmag,fkeys) 
!!!       else if( fluxes ) then
!!!          allocate(xflux(size(flux),2))
!!!          xflux(:,1) = flux
!!!          xflux(:,2) = dflux
!!!          allocate(fkeys(2))
!!!          fkeys(1) = 'FLUX'
!!!          fkeys(2) = 'FLUX_ERR'
!!!          call savecat(output,filename,fitskeys,object,observer,author,instrument,telescope, &
!!!               origin,reference,equinox,dateobs,filter,exptime,fkeys,a,d,xflux)
!!!          deallocate(xflux,fkeys)
!!!       else
!!!          call savecat(output,filename,fitskeys,object,observer,author,instrument,telescope, &
!!!               origin,reference,equinox,dateobs,filter,exptime,cols,a,d,xdata)
!!!       end if
!!!    end if
!!!
!!!    if( mags ) deallocate(mag,dmag)
!!!    if( fluxes ) deallocate(flux,dflux)
!!!
!!! end if
!!!
!!!
!!!!    else if( mode == 'pos' ) then
!!!
!!!!       write(*,704) int(year),int(month),int(day),int(hour),int(min),int(sec), &
!!!!            jd, (xrect(i),yrect(i),i = 1,n)
!!!!704    format (1x,i4.4,tr1,5(i2.2,tr1),tr2,f13.5,1x, 10000f10.3)
!!!          
!!!
!!!
!!!!    else
!!!
!!!!       write(*,700) int(year),int(month),int(day),int(hour),int(min),int(sec), !&
!!!!            exptime,filter,jd, (flux(i),dflux(i),i = 1,n)
!!!!700    format (1x,i4.4,tr1,5(i2.2,tr1),f6.1,tr1,a1,tr2,f13.5,1x, 10000(es15.6,es9.2))
!!!
!!!!       write(*,*) trim(filename),int(year),int(month),int(day),int(hour),int(min),int(sec),&
!!!!            jd,(sky(i),dsky(i),flux(i),dflux(i),i = 1,n)
!!!
!!!!    end if
!!!
!!!
!!! !   if( header ) then
!!!
!!!
!!!
!!!    ! output relative quantities
!!!  !  else if( relative ) then
!!!       
!!!
!!!   ! else 
!!!       ! instrumental fluxes
!!!       
!!!!!$       if( full ) then
!!!!!$
!!!!!$          if( alpha >= 0.0 .and. abs(lat) <= 90.0 )then
!!!!!$             ha = hangle(lmst(jd,long)*15.0_dbl,alpha)
!!!!!$             call eq2hor(ha,delta,lat,azimut,elev)
!!!!!$             airm = airmass(90.0_dbl-elev)
!!!!!$             write(*,701) int(year),int(month),int(day),int(hour),int(min), &
!!!!!$                  int(sec),exptime,filter,jd,azimut,elev,airm, &
!!!!!$                  (sky(i),dsky(i),flux(i),dflux(i),i = 1,n)
!!!!!$          else
!!!!!$!             write(*,*) n,sky,flux,dsky,dflux
!!!!!$             write(*,701) int(year),int(month),int(day),int(hour),int(min), &
!!!!!$                  int(sec),exptime,filter,jd,(sky(i),dsky(i),flux(i),dflux(i),i = 1,n)
!!!!!$          endif
!!!!!$701       format (1x,i4.4,tr1,5(i2.2,tr1),f6.1,tr1,a1,tr2,f13.5,1x, 1p, 1000g12.6)
!!!!!$
!!!!!$       else if( positions .and. n > 0 ) then
!!!!!$
!!!!!$
!!!!!$       else
!!!!!$
!!!!!$
!!!!!$
!!!!!$       end if
!!!!!$
!!!
!!!
!!!!    end if
!!!
!!!    deallocate(a,d,x,y,cols,headval,xdata,data)
!!!
!!!  end subroutine munilist
!!!

!
!  Robust Flat     Average of normalised flat-fields
!  Copyright (C) 2017  Filip Hroch, Masaryk University, Brno, CZ
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

module robustflat

  use iso_fortran_env

  implicit none

  logical, private :: verb = .false.

  integer, parameter, private :: dbl = selected_real_kind(15)

  real(dbl), dimension(:), allocatable, private :: flat, dflat, cf, dcf, rat
  real(dbl), private :: reg, sigma, df, rmin, rmax

  private :: residuals, fmean, zfun, fscale

contains

  subroutine rflat(flats,dflats,factors,dfactors,fin,dfin,reliable,verbose)

    use medians

    real, dimension(:), intent(in) :: flats,dflats,factors,dfactors
    real, intent(in out) :: fin, dfin
    logical, intent(out) :: reliable
    logical, intent(in), optional :: verbose

    real(dbl) :: f,sigold,regold,sig,fold
    integer :: n,i
    logical :: freli,sreli,convergent

    if( present(verbose) ) then
       verb = verbose
    else
       verb = .false.
    end if

    n = size(flats)

    if( n == 0 ) then
       fin = 1
       dfin = 0
       reliable = .false.
       return
    end if

    if( n <= 2 ) then
       fin = sum(flats / factors) / n
       dfin = sum(abs(flats / factors - fin)) / n
       reliable = .false.
       return
    end if

    ! Now, we works with appropriate amount of data: n > 2
    allocate(flat(n),dflat(n),cf(n),dcf(n),rat(n))
    flat = flats
    dflat = dflats
    cf = factors
    dcf = dfactors
    f = fin
    df = dfin

    rat = flat / cf
    rmin = minval(rat)
    rmax = maxval(rat)

    ! initial estimate of parameters
    call finit(f,sig)
    if( verb ) &
         write(error_unit,'(a,f0.5,1x,f0.3)') 'rflat initial f,sig: ',f,sig
    fold = f

    ! avoid other computations on identical data, or
    ! low amount of data for robust estimation
    if( abs(sig) < 2*epsilon(sig) ) then
       fin = real(f)
       dfin = 0
       reliable = .true.
       goto 666
    end if

    sigold = -1
    do i = 0,666
       reg = i
       call fmean(f,sig,freli)
       call fscale(f,sig,sreli)
       if( verb ) write(error_unit,'(a,f12.7,2(1x,f0.3),2x,2l)') &
            '      zmean,sig,reg:',f,sig,reg,freli,sreli
       reliable = freli .and. sreli
       if( sig < 1 ) exit
       sigold = sig
       regold = reg
    end do
    ! solve reg. parameter by linear interpolation to the condition sig=1
    if( sigold > 0 .and. abs(sig - sigold) > epsilon(sig) ) then
       reg = regold + (1 - sigold)*(reg - regold)/(sig - sigold)
       call fmean(f,sig,reliable)
    end if
    if( verb ) write(error_unit,'(a,f12.7,2(1x,f0.3),2x,l)') &
         'final zmean,sig,reg:',f,sig,reg,reliable

    if( reliable ) then
       ! Newton's update
       call fnewton(f,df,sig,convergent)
       if( verb ) write(error_unit,'(a,2f13.7,2x,l)') 'Newton:',f,df,convergent
    else
       fin = real(fold)
    end if

    if( convergent .and. reliable ) then
       fin = real(f)
       dfin = real(df)
    end if

666 continue
    deallocate(flat,dflat,cf,dcf,rat)

  end subroutine rflat

  subroutine residuals(f,res,sig)

    real(dbl), intent(in) :: f
    real(dbl), dimension(:), intent(out) :: res,sig

    res = flat - cf*f
    sig = sqrt(dflat**2 + dcf**2 + flat*reg**2)

  end subroutine residuals


  subroutine fmean(f,sig,reli)

    use fmm
    use medians

    ! This is a robust estimation of the flat.

    real(dbl), intent(in out) :: f
    real(dbl), intent(in) :: sig
    logical, intent(out) :: reli
    real(dbl) :: htol,h,d,gmin,gmax

    sigma = sig
    h = 3.3 * median(abs(rat - f)) / 0.6745
    gmin = max(f - h, rmin)
    gmax = min(f + h, rmax)
    htol = max(1e-6,1e-5*h)
!    if( verb ) write(error_unit,*) f,gmin,gmax,h,htol,log((gmax-gmin)/htol)

    f = zeroin(gmin,gmax,zfun,htol)

    d = 2*htol
    reli = gmin + d < f .and. f < gmax - d

    ! the realiable result is inside interval rmin .. rmax
    ! and not too close to the interval endpoints

  end subroutine fmean


  function zfun(f)

    use rfun

    real(dbl), intent(in) :: f
    real(dbl) :: zfun
    real(dbl), dimension(:), allocatable :: psi,res,sig
    integer :: n

    n = size(flat)
    allocate(psi(n),res(n),sig(n))
    call residuals(f,res,sig)
    call tukeys(res/(sigma*sig),psi)

    zfun = -sum(psi*cf/sig)

    deallocate(psi,res,sig)

  end function zfun

  subroutine fscale(f,s,reli)

    use entropyscale

    real(dbl), intent(in) :: f
    real(dbl), intent(in out) :: s
    logical, intent(out) :: reli
    real(dbl), dimension(:), allocatable :: res,sig
    integer :: n

    n = size(flat)
    allocate(res(n),sig(n))
    call residuals(f,res,sig)
    call escale(res/sig,s,reli)
    deallocate(res,sig)

  end subroutine fscale

  subroutine finit(f,s)

    use medians

    real(dbl), intent(in out) :: f
    real(dbl), intent(out) :: s

    real(dbl), dimension(:), allocatable :: res,sig
    integer :: n

    n = size(flat)
    f = median(rat)
    allocate(res(n),sig(n))
    call residuals(f,res,sig)
    s = median(abs(res/sig)) / 0.6745
    deallocate(res,sig)

  end subroutine finit

  subroutine fnewton(f,df,s,convergent)

    use rfun

    real(dbl), intent(in out) :: f
    real(dbl), intent(out) :: df
    real(dbl), intent(in) :: s
    logical, intent(out) :: convergent

    real(dbl), dimension(:), allocatable :: psi,dpsi,res,sig,rs
    real(dbl) :: fun, dfun, fun2, d, xtol
    integer :: iter,n

    convergent = .false.

    if( .not. (s > 0) ) return

    n = size(flat)
    allocate(psi(n),dpsi(n),res(n),sig(n),rs(n))

    ! tolerance limit depends on number of elements in sums
    ! because every element can include its rounding error...
    ! ... proportional to absolute value ...
    xtol = 10*n*abs(f)*epsilon(f)

    do iter = 1, precision(f)

       call residuals(f,res,sig)

       rs = res / (s * sig)
       call tukeys(rs,psi)
       call dtukeys(rs,dpsi)

       fun = -sum(psi*cf/sig)
       dfun = sum(dpsi*(cf/sig)**2)

       if( abs(dfun) < epsilon(dfun) ) exit

       ! corrector for mean
       d = s * fun / dfun

       ! update location
       f = f - d

       if( verb ) write(error_unit,'(a,i2,1pg20.10,1p3g12.3)') &
            "mean, incr., f, f': ",iter,f,d,fun,dfun

       convergent = abs(d) < xtol

       ! exit of iterations: the absolute errot must be at least |d| < tol
       if( convergent ) exit

    end do

    fun2 = sum(psi**2)  ! mean of psi**2
    dfun = dfun * s**2
    if( convergent .and. dfun > 0 .and. fun2 > 0 ) then
       df = s*sqrt(fun2/dfun**2*n/(n-1)) ! df is an element of Jacobian
    else
       df = s/sqrt(real(n))
    end if

    deallocate(res,sig,psi,dpsi,rs)

  end subroutine fnewton

end module robustflat

!
!  general interpolation routines by Numerical recipes
!
!  Copyright © 1997-2011 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!  
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!  
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!


module interpol

  implicit none
  integer, parameter, private :: sp = selected_real_kind(6)
  integer, private :: errno
  logical, parameter, private :: stopme = .false.

! test for spline boundary values
  real(sp), parameter, private :: hbound = 0.9*huge(1.0_sp)

! work arrays for spline
  real(sp), dimension(:), allocatable, private :: x1a, x2a
  real(sp), dimension(:,:), allocatable, private :: y2a

contains

  function interpol_errno()

    implicit none
    integer :: interpol_errno

    interpol_errno = errno

  end function interpol_errno

  subroutine nrerror(no,string)

    implicit none
    character(len=*), intent(in) :: string
    integer, intent(in) :: no

    errno = no
    if( stopme ) then
       write(*,*) trim(string)
       stop 'Program terminated by nrerror.'
    endif

  end subroutine nrerror

  function assert_eq(name,n1,n2,n3,n4,n5,n6,n7)

    implicit none

    integer, intent(in) :: n1,n2
    character(len=*) :: name
    integer, optional,intent(in) :: n3,n4,n5,n6,n7
    integer :: assert_eq
    logical :: eq

    eq = n1 == n2
    if( present(n3) ) eq = eq .and. n1 == n3
    if( present(n4) ) eq = eq .and. n1 == n4
    if( present(n5) ) eq = eq .and. n1 == n5
    if( present(n6) ) eq = eq .and. n1 == n6
    if( present(n7) ) eq = eq .and. n1 == n7
    
    if( eq ) then
       assert_eq = n1
       errno = 0
    else
       errno = 1
       if( stopme ) then
          write(*,*) 'Dimensions non-equal in ',trim(name),'.'
          stop 'assert_eq'
       endif
    end if

  end function assert_eq


  subroutine spline(x,y,yp1,ypn,y2)

    implicit none

    real(sp), dimension(:), intent(in) :: x,y
    real(sp), intent(in) :: yp1,ypn
    real(sp), dimension(:), intent(out) :: y2
    
    integer :: n
    real(sp), dimension(size(x)) :: a,b,c,r

    n = assert_eq('spline',size(x),size(y),size(y2))

    c(1:n-1) = x(2:n) - x(1:n-1)
    r(1:n-1) = 6.0_sp*(y(2:n) - y(1:n-1))/c(1:n-1)
    r(2:n-1) = r(2:n-1) - r(1:n-2)
    a(2:n-1) = c(1:n-2)
    b(2:n-1) = 2.0_sp*(c(2:n-1) + a(2:n-1))
    b(1) = 1.0
    b(n) = 1.0
    if( yp1 > 0.99*hbound ) then
       r(1) = 0.0
       c(1) = 0.0
    else
       r(1) = (3.0_sp/(x(2) - x(1)))*((y(2) - y(1))/(x(2) - x(1)) - yp1)
       c(1) = 0.5_sp
    end if
    if( ypn > 0.99*hbound )then
       r(n) = 0.0
       a(n) = 0.0
    else
       r(n) = (-3.0_sp/(x(n) - x(n-1)))*((y(n) - y(n-1))/(x(n) - x(n-1)) - ypn)
       a(n) = 0.5
    end if
    call tridag_ser(a(2:n),b(1:n),c(1:n-1),r(1:n),y2(1:n))

  end subroutine spline

  function splint(xa,ya,y2a,x)

    implicit none
    
    real(sp), dimension(:), intent(in) :: xa,ya,y2a
    real(sp), intent(in) :: x
    real(sp) :: splint

    integer :: khi,klo,n
    real(sp) :: a,b,h

    n = assert_eq('splint',size(xa),size(ya),size(y2a))
    
    klo = max(min(locate(xa,x),n-1),1)
    khi = klo + 1
    h = xa(khi) - xa(klo)

    if( h == 0.0 ) call nrerror(4,'Bad xa input in splint.')
    a = (xa(khi) - x)/h
    b = (x - xa(klo))/h
    splint = a*ya(klo) + b*ya(khi) + ((a**3 - a)*y2a(klo) + &
         (b**3 - b)*y2a(khi))*(h**2)/6.0_sp

  end function splint


  subroutine tridag_ser(a,b,c,r,u)

    implicit none

    real(sp), dimension(:), intent(in) :: a,b,c,r
    real(sp), dimension(:), intent(out) :: u

    real(sp), dimension(size(b)) :: gam
    integer :: n,j
    real(sp) :: bet

    n = assert_eq('tridag_ser',size(a)+1,size(b),size(c)+1,size(r),size(u))

    bet = b(1)
    if( bet == 0.0 ) call nrerror(2,'tridag_ser: Error at code stage 1')
    u(1) = r(1)/bet
    do j = 2,n
       gam(j) = c(j-1)/bet
       bet = b(j) - a(j-1)*gam(j)
       if( bet == 0.0 ) call nrerror(3,'tridag_ser: Error at code stage 2')
       u(j) = (r(j) - a(j-1)*u(j-1))/bet
    enddo
    do j = n-1,1,-1
       u(j) = u(j) - gam(j+1)*u(j+1)
    enddo
    
  end subroutine tridag_ser

  function locate(xx,x)

    implicit none

    real(sp), dimension(:), intent(in) :: xx
    real(sp), intent(in) :: x
    integer :: locate

    integer :: n,jl,jm,ju
    logical :: ascnd

    n = size(xx)
    ascnd = (xx(n) >= xx(1))
    jl = 0
    ju = n + 1

    do
       if( ju - jl <= 1 ) exit
       jm = (ju + jl)/2
       if( ascnd .eqv. (x >= xx(jm)) )then
          jl = jm
       else
          ju = jm
       end if
    end do

    if( x == xx(1) )then
       locate = 1
    else if(x == xx(n) )then
       locate = n - 1
    else
       locate = jl
    end if

  end function locate

  subroutine bcucof(y,y1,y2,y12,d1,d2,c)

    implicit none

    real(sp), intent(in) :: d1,d2
    real(sp), dimension(4), intent(in) :: y,y1,y2,y12
    real(sp), dimension(4,4), intent(out) :: c

    real(sp), dimension(16) :: x

    real(sp), parameter, dimension(16,16) :: wt = reshape( (/ &
     1,0,-3,2,0,0,0,0,-3,0,9,-6,2,0,-6,4,0,0,0,0,0,0,0,0,3,0,-9,6,-2,0,6,-4, &
     0,0,0,0,0,0,0,0,0,0,9,-6,0,0,-6,4,0,0,3,-2,0,0,0,0,0,0,-9,6,0,0,6,-4, &  
     0,0,0,0,1,0,-3,2,-2,0,6,-4,1,0,-3,2,0,0,0,0,0,0,0,0,-1,0,3,-2,1,0,-3,2,& 
     0,0,0,0,0,0,0,0,0,0,-3,2,0,0,3,-2,0,0,0,0,0,0,3,-2,0,0,-6,4,0,0,3,-2,&
     0,1,-2,1,0,0,0,0,0,-3,6,-3,0,2,-4,2,0,0,0,0,0,0,0,0,0,3,-6,3,0,-2,4,-2,&
     0,0,0,0,0,0,0,0,0,0,-3,3,0,0,2,-2,0,0,-1,1,0,0,0,0,0,0,3,-3,0,0,-2,2,&
     0,0,0,0,0,1,-2,1,0,-2,4,-2,0,1,-2,1,0,0,0,0,0,0,0,0,0,-1,2,-1,0,1,-2,1, &
     0,0,0,0,0,0,0,0,0,0,1,-1,0,0,-1,1,0,0,0,0,0,0,-1,1,0,0,2,-2,0,0,-1,1 /),&
     (/16,16/) )

    x(1:4) = y
    x(5:8) = y1*d1
    x(9:12) = y2*d2
    x(13:16) = y12*d1*d2
    x = matmul(wt,x)
    c = reshape(x,(/4,4/),order=(/2,1/))
    
  end subroutine bcucof

  subroutine bcuint(y,y1,y2,y12,x1l,x1u,x2l,x2u,x1,x2,ansy,ansy1,ansy2)

    implicit none

    real(sp), dimension(4), intent(in) :: y,y1,y2,y12
    real(sp), intent(in) :: x1l,x1u,x2l,x2u,x1,x2
    real(sp), intent(out) :: ansy,ansy1,ansy2

    integer :: i
    real(sp) :: t,u
    real(sp), dimension(4,4) :: c

    call bcucof(y,y1,y2,y12,x1u-x1l,x2u-x2l,c)

    if( x1u == x1l .or. x2u == x2l ) call &
         nrerror(6,'bcuint: problem with input values - boundary pair equal?')

    t = (x1 - x1l)/(x1u - x1l)
    u = (x2 - x2l)/(x2u - x2l)
    ansy = 0.0
    ansy1 = 0.0
    ansy2 = 0.0
    do i = 4,1,-1
       ansy = t*ansy + ((c(i,4)*u + c(i,3))*u + c(i,2))*u + c(i,1)
       ansy1 = u*ansy1 + (3.0*c(4,i)*t + 2.0*c(3,i))*t + c(2,i)
       ansy2 = t*ansy2 + (3.0*c(i,4)*u + 2.0*c(i,3))*u + c(i,2)
    end do
    ansy1 = ansy1/(x1u - x1l)
    ansy2 = ansy2/(x2u - x2l)

  end subroutine bcuint

  subroutine spline2(x1a,x2a,ya,y2a)

    implicit none

    real(sp), dimension(:), intent(in) :: x1a,x2a
    real(sp), dimension(:,:), intent(in) :: ya
    real(sp), dimension(:,:), intent(out) :: y2a

    integer :: j,m,ndum
    
    m = assert_eq('spline2: m',size(x1a),size(ya,1),size(y2a,1))
    ndum = assert_eq('spline2: ndum',size(x2a),size(ya,2),size(y2a,2))
    do j = 1,m
       call spline(x2a,ya(j,:),hbound,hbound,y2a(j,:))
    end do
    
  end subroutine spline2

  function splint2(x1a,x2a,ya,y2a,x1,x2)

    implicit none
    
    real(sp), dimension(:), intent(in) :: x1a,x2a
    real(sp), dimension(:,:), intent(in) :: ya,y2a
    real(sp), intent(in) :: x1,x2
    real(sp) :: splint2

    integer :: j,m,ndum
    real(sp), dimension(size(x1a)) :: yytmp, y2tmp
    
    m = assert_eq('splint2: m',size(x1a),size(ya,1),size(y2a,1))
    ndum = assert_eq('splint2: ndum',size(x2a),size(ya,2),size(y2a,2))

    do j = 1,m
       yytmp(j) = splint(x2a,ya(j,:),y2a(j,:),x2)
    end do
    
    call spline(x1a,yytmp,hbound,hbound,y2tmp)
    splint2 = splint(x1a,yytmp,y2tmp,x1)

  end function splint2

  function bilinear(x,y,array) result(fun)

    real(sp), intent(in) :: x,y
    real(sp), dimension(:,:), intent(in) :: array
    real(sp) :: fun
    integer :: i,j
    real(sp) :: u,v

    i = int(x)
    j = int(y)

    if( (lbound(array,1) <= i .and. i < ubound(array,1)) .and. &
        (lbound(array,2) <= j .and. j < ubound(array,2)) ) then
         
       u = (x - i)/(i+1 - i)
       v = (y - j)/(j+1 - j)

       fun = (1.0 - u)*(1.0 - v)*array(i,j) + u*v*array(i+1,j+1) &
            + u*(1.0 - v)*array(i+1,j) + (1.0 - u)*v*array(i,j+1)
    
       
    else
       fun = 0.0
    end if

  end function bilinear


  function bicubic(x,y,array)

    implicit none

    real(sp), intent(in) :: x,y
    real(sp), dimension(:,:), intent(in) :: array
    real(sp) :: bicubic

    integer :: i,j,nx,ny
    real(sp) :: d, z, z1, z2, x1l, x1u, x2l, x2u
    real(sp), dimension(4) :: f, f1, f2, f12

    nx = size(array,1)
    ny = size(array,2)
    i = int(x)
    j = int(y)

    d = 1.0  ! coordinate step

    if( 1 < i .and. i < nx - 1 .and. 1 < j .and. j < ny - 1 ) then

       f(1) = array(i,j)
       f(2) = array(i+1,j)
       f(3) = array(i+1,j+1)
       f(4) = array(i,j+1)

       f1(1) = (array(i+1,j)   - array(i-1,j))  /(2.0*d)
       f1(2) = (array(i+2,j)   - array(i,j))    /(2.0*d)
       f1(3) = (array(i+2,j+1) - array(i,j+1))  /(2.0*d)
       f1(4) = (array(i+1,j+1) - array(i-1,j+1))/(2.0*d)

       f2(1) = (array(i,j+1)   - array(i,j-1))  /(2.0*d)
       f2(2) = (array(i+1,j+1) - array(i+1,j-1))/(2.0*d)
       f2(3) = (array(i+1,j+2) - array(i+1,j))  /(2.0*d)
       f2(4) = (array(i,j+2)   - array(i,j))    /(2.0*d)

       f12(1) = (array(i+1,j+1)-array(i+1,j-1)-array(i-1,j+1)+array(i-1,j-1))/(2.0*d)**2
       f12(2) = (array(i+2,j+1)-array(i+2,j-1)-array(i,j+1)+array(i,j-1))/(2.0*d)**2
       f12(3) = (array(i+2,j+2)-array(i+2,j)-array(i,j+2)+array(i,j))/(2.0*d)**2
       f12(4) = (array(i+1,j+2)-array(i+1,j)-array(i-1,j+2)+array(i-1,j))/(2.0*d)**2

       x1l = i
       x1u = x1l + d
       x2l = j
       x2u = x2l + d
       
       call bcuint(f,f1,f2,f12,x1l,x1u,x2l,x2u,x,y,z,z1,z2)
       bicubic = z

    else
       
       bicubic = 0

    end if

  end function bicubic

  function bspline(x,y,array)

    implicit none

    real(sp), intent(in) :: x,y
    real(sp), dimension(:,:), intent(in) :: array
    real(sp) :: bspline

    call bspline_init(array)

    bspline = bspline_func(x,y,array)

    call bspline_shutdown

  end function bspline

  subroutine bspline_init(array)

    implicit none

    real(sp), dimension(:,:), intent(in) :: array

    integer :: i

    allocate(x1a(size(array,1)))
    allocate(x2a(size(array,2)))
    allocate(y2a(size(array,1),size(array,2)))

    do i = 1, size(x1a)
       x1a(i) = i
    enddo
    do i = 1, size(x2a)
       x2a(i) = i
    enddo

    call spline2(x1a,x2a,array,y2a)

  end subroutine bspline_init

  subroutine bspline_shutdown

    implicit none

    deallocate(x1a)
    deallocate(x2a)
    deallocate(y2a)

  end subroutine bspline_shutdown

  function bspline_func(x,y,array)

    implicit none

    real(sp), intent(in) :: x,y
    real(sp), dimension(:,:), intent(in) :: array
    real(sp) :: bspline_func

    bspline_func = splint2(x1a,x2a,array,y2a,x,y)

  end function bspline_func

end module interpol

!
! Catalogue cross-match
!
! Copyright © 2013, 2018-20 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program cross

  use iso_fortran_env
  use titsio

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  integer, parameter :: NFILE = 2

  integer :: eq
  character(len=FLEN_VALUE), dimension(NFILE) :: col_ra, col_dec, &
       col_pmra, col_pmdec, col_mag
  character(len=FLEN_KEYWORD) :: key_epoch
  character(len=4*FLEN_FILENAME) :: record, key, val, output
  character(len=4*FLEN_FILENAME), dimension(NFILE) :: file
  logical :: verbose = .false.
  real(dbl) :: tol,ftol
  integer :: n

  key_epoch = FITS_KEY_EPOCH
  col_ra = 'RA'
  col_dec = 'DEC'
  col_pmra = ''
  col_pmdec = ''
  col_mag = ''

  file=''
  output = ''
  tol = epsilon(tol)
  ftol = 1

  do

     read(*,'(a)',end=99) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Malformed input record.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'OUTPUT' ) then

        read(val,*) output

     else if( key == 'NFILES' ) then

        read(val,*) n
        if( NFILE /= n ) stop 'Cross-match requires exactly two files.'
        n = 0

     else if( key == 'COL_RA' ) then

        read(val,*) col_ra

     else if( key == 'COL_DEC' ) then

        read(val,*) col_dec

     else if( key == 'COL_PMRA' ) then

        read(val,*) col_pmra

     else if( key == 'COL_PMDEC' ) then

        read(val,*) col_pmdec

     else if( key == 'COL_MAG' ) then

        read(val,*) col_mag

     else if( key == 'FITS_KEY_EPOCH' ) then

        read(val,*) key_epoch

     else if( key == 'TOL' ) then

        read(val,*) tol

     else if( key == 'FTOL' ) then

        read(val,*) ftol

     else if( key == 'FILE' ) then

        n = n + 1
        read(val,*) file(n)

     end if

  end do
99 continue

  call crossing

  stop 0

contains


  subroutine crossing

    use crossmatch

    real(dbl), allocatable, dimension(:) :: ra1,dec1,flux1,ra2,dec2,flux2
    integer, dimension(:,:), allocatable :: idx
    character(len=FLEN_VALUE) :: catid1,catid2
    integer :: status

    status = 0
    call tabcoo(file(1),col_ra(1),col_dec(1),col_pmra(1),col_pmdec(1),&
         col_mag(1),key_epoch,ra1,dec1,flux1,catid1,status)
    call tabcoo(file(2),col_ra(2),col_dec(2),col_pmra(2),col_pmdec(2),&
         col_mag(2),key_epoch,ra2,dec2,flux2,catid2,status)

    allocate(idx(NFILE,max(size(ra1),size(ra2))))

    call join(ra1,dec1,ra2,dec2,tol,ftol,idx)

    call savecross(output,file,idx,status)

    if( allocated(ra1) ) deallocate(ra1,dec1,flux1)
    if( allocated(ra2) ) deallocate(ra2,dec2,flux2)
    deallocate(idx)

  end subroutine crossing


  subroutine tabcoo(filename,col_ra,col_dec,col_pmra,col_pmdec,&
         col_mag,key_epoch,ra,dec,flux,catid,status)

    use trajd

    character(len=*), intent(in) :: filename, col_ra, col_dec, col_pmra, &
         col_pmdec, col_mag, key_epoch
    real(dbl), allocatable, dimension(:), intent(out) :: ra, dec, flux
    character(len=*), intent(out) :: catid
    integer, intent(in out) :: status

    real(dbl), parameter :: nullval = real(0.0,dbl)
    integer, parameter :: ncols = 5
    integer, dimension(ncols) :: col, statuses
    integer :: nrows,i,l,frow,srows
    logical :: anyf
    character(len=FLEN_VALUE), dimension(ncols) :: label,colname
    real(dbl), allocatable, dimension(:) :: alpha, delta, pmalpha, pmdelta, mag
    real(dbl) :: t0,t,dt
    type(fitsfiles) :: fits

    if( status /= 0 ) return

    ! ICRS
    t0 = yearjd(2000.00_dbl)

    label = [ character(len=FLEN_VALUE) :: col_ra, col_dec, col_pmra, col_pmdec, &
         col_mag]

    if( label(1) == '' .or. label(2) == '' ) then
       write(error_unit,*) "Coordinate columns are not fully specified (empty)."
       return
    end if

    ! open and move to a table extension
    call fits_open_table(fits,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read a table in the file `',trim(filename),"'."
       return
    end if

    call fits_get_num_rows(fits,nrows,status)
    if( .not. (nrows > 0 .and. status == 0) ) then
       write(error_unit,*) "Table `"//trim(filename)//"' looks empty."
       goto 666
    end if

    ! identification of catalogue
    call fits_read_key(fits,'EXTNAME',catid,status)
    call fits_read_key(fits,key_epoch,t,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       write(error_unit,*) "Epoch by `"//trim(key_epoch)// &
            "' keyword not found (assumed J2000.0)."
       status = 0
       t = t0
    end if

    ! find columns by labels
    statuses = 0
    col = 0
    do i = 1, ncols
       if( label(i) /= '' ) then
          call fits_get_colname(fits,.false.,label(i),colname(i),col(i),statuses(i))
       else
          col(i) = 0
       end if
    end do

    if( col(1) == 0 .or. col(2) == 0 ) then
       write(error_unit,*) "Error: coordinates column `"//trim(col_ra)//","// &
            trim(col_dec)//"' in `"//trim(filename)//"' not found."
       goto 666
    end if

    if( (label(3) /= '' .or. label(4) /= '') .and. &
         (statuses(3) /= 0 .or. statuses(4) /= 0 ) ) then
       write(error_unit,*) "Error: requested proper-motion columns `" // &
            trim(col_pmra)//"' or `"//trim(col_pmdec)//"' in `"// &
            trim(filename)//"' not found."
       goto 666
    end if

    if( label(5) /= '' .and. statuses(5) /= 0 ) then
       write(error_unit,*) "Error: a requested magnitude column `" // &
            trim(col_mag)//"' in `"//trim(filename)//"' not found."
       goto 666
    end if

    allocate(alpha(nrows),delta(nrows),pmalpha(nrows),pmdelta(nrows),mag(nrows))

    pmalpha = 0.0_dbl
    pmdelta = 0.0_dbl
    mag = 99.999

    call fits_get_rowsize(fits,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_read_col(fits,col(1),frow,nullval,alpha(i:l),anyf,status)
       call fits_read_col(fits,col(2),frow,nullval,delta(i:l),anyf,status)
       if( col(3) /= 0 .and. col(4) /= 0) then
          call fits_read_col(fits,col(3),frow,nullval,pmalpha(i:l),anyf,status)
          call fits_read_col(fits,col(4),frow,nullval,pmdelta(i:l),anyf,status)
       end if
       if( col(5) /= 0 ) then
          call fits_read_col(fits,col(5),frow,nullval,mag(i:l),anyf,status)
       end if
       if( status /= 0 ) goto 666
    end do

    pmalpha = pmalpha / 3.6e6_dbl  ! supposing mas/year
    pmdelta = pmdelta / 3.6e6_dbl

    call fits_close_file(fits,status)

    ! compute coordinates for the epoch
    allocate(ra(nrows),dec(nrows),flux(nrows))
    dt = (t - t0)/ 365.25

    ra  = alpha + dt*pmalpha
    dec = delta + dt*pmdelta
    flux = 10.0**((25.0 - mag)/2.5)

666 continue

    if( allocated(alpha) ) deallocate(alpha,delta,pmalpha,pmdelta,mag)

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

  end subroutine tabcoo

  subroutine savecross(output,filename,idx,status)

    character(len=*), intent(in) :: output
    character(len=*), dimension(:), intent(in) :: filename
    integer, dimension(:,:), intent(in) :: idx
    integer, intent(in out) :: status

    character(len=FLEN_VALUE), dimension(:), allocatable :: ttype, tform,tunit
    character(len=FLEN_KEYWORD) :: key
    integer :: nrows,i, l,frow, srows
    type(fitsfiles) :: fits

    status = 0
    if( fits_file_exist(output) ) call fits_file_delete(output)
    call fits_create_file(fits,output,status)

    allocate(ttype(NFILE),tform(NFILE),tunit(NFILE))

    tform = '1J'
    tunit = ''

    ttype = filename
    call fits_insert_btbl(fits,0,ttype,tform,tunit,'CROSSMATCH',status)

    do i = 1, NFILE
       write(key,'(a,i1)') 'FILE',i
       call fits_update_key(fits,key,filename(i),'FITS table',status)
    end do

    nrows = size(idx,2)
    call fits_get_rowsize(fits,srows,status)

    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       do n = 1, NFILE
          call fits_write_col(fits,n,frow,idx(n,i:l),status)
       end do
    end do

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    deallocate(ttype,tform,tunit)

  end subroutine savecross

end program cross

!
! mctrafo - color transformation
!
!
! Copyright © 2010-4 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!
! This code needs for color conversions auxiliary file with transformation
! matrixes. The file is in free Fortran format as follows:
!
! 'input colorspace' 'output colorspace'
! n m
! a11 a12 .. a1m
! a21 a22 .. a2m
! ...
! an1 an2 .. anm
!
! The n,m are dimensions of the matrix. The matrix contains n x m items.
! No comments are allowed.
!


program mctrafo

  use color_transformation

  implicit none

  integer, parameter :: slen = 32768
  character(len=slen) :: record,radek,line,cname,backup,cspace,ctable,fname
  integer, dimension(:), allocatable :: id
  real, dimension(:), allocatable :: black, slope
  character(len=10),dimension(5) :: key
  integer :: n,i,ic,istat,nband
  logical :: it


  key(1) = 'INFO'           ! <argument> print some information
  key(2) = 'CTABLE'         ! filename of color transformation tables
  key(3) = 'OUTPUT'         ! name of output file (default 'color.fits')
  key(4) = 'COLORSPACE'     ! data stored in the colorspace
  key(5) = 'INPUT'          ! name of input file in color FITS specification


  cname = 'color.fits'
  cspace = ''
  ctable = 'ctable.dat'
  fname = ''
  nband = 0

  ! read input data
  n = 0
  do
     read(*,'(a)',end=99,iostat=istat) record
     if( istat /= 0 ) stop 'Unexpected data on input.'

     ic = index(record,'#')
     if( ic == 0 ) then
        radek = adjustl(record)
     else
        radek = adjustl(record(1:ic-1))
     end if

     do i = 1, size(key)
        it = index(radek,trim(key(i))) == 1
        if( it ) then

           line = radek(index(radek,'=')+1:)

           if( key(i) == 'INFO' ) then
              call inform(line)
              stop 'You have been informed.'
           end if

           if( key(i) == 'CTABLE' ) then
              read(line,*,iostat=istat) ctable
              if( istat /= 0 .or. ctable == '') &
                   stop 'An error during reading of the color matrix file name.'
           end if

           if( key(i) == 'INPUT' ) then
              read(line,*,iostat=istat) fname
              if( istat /= 0 .or. fname == '') &
                   stop 'An error during reading of the input file name.'
           end if

           if( key(i) == 'OUTPUT' ) then
              read(line,*,iostat=istat) cname,backup
              if( istat /= 0 .or. cname == '') &
                   stop 'An error during reading of the output file name.'
           end if

           if( key(i) == 'COLORSPACE' ) then
              read(line,*,iostat=istat) cspace
              if( istat /= 0 .or. cspace == '' ) &
                   stop 'An error during reading of the output colorspace.'
           end if
        end if

     end do

     if( .not. it ) then

        if( index(radek,'NBAND') == 1 ) then

           read(radek(index(radek,'=')+1:),*,iostat=istat) nband
           if( istat /= 0 .or. nband <= 0 ) stop 'NBAND parameter read failed.'
           if( allocated(id) ) stop 'NBAND multiply specified ?'
           allocate(id(nband),black(nband),slope(nband))
           black = 0.0
           slope = 1.0

        else if( nband > 0 .and. n < nband .and. radek /= ' ') then

           n = n + 1
           read(radek,*,iostat=istat) id(n),black(n),slope(n)
           if( istat /= 0 ) stop 'Failed to parse an input record.'
        end if

     end if

  end do
99 continue

  if( n /= nband ) stop 'A full set of FITS files not specified.'

  if( .not. allocated(slope) ) then
     allocate(id(1),slope(1),black(1))
     slope = -1
  end if

  call ctrafo(fname,cname,backup,cspace,ctable,black,slope)
  
  deallocate(id,black,slope)

  stop 0

contains

  subroutine inform(params)
    
    character(len=*),intent(in) :: params
    character(len=80) :: ilabel,olabel
    integer ndim,mdim
    real, dimension(:,:),allocatable :: cmatrix

    if( index(params,'colorspaces') > 0 ) then

       open(1,file=ctable,status='old')
       do
          read(1,*,end=90) ilabel, olabel
          write(*,*) trim(ilabel), ' > ',trim(olabel)
          read(1,*,end=90) ndim, mdim
          allocate(cmatrix(ndim,mdim))
          read(1,*,end=90) cmatrix
          deallocate(cmatrix)
       end do
90     close(1)

    end if


  end subroutine inform

end program mctrafo

!
!  Spreaded profiles
!
!
!  Copyright © 2016-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!


module spray

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  integer, parameter, private :: zoom = 2**4

  type SprayType
     integer :: nbox, zoom
     real(dbl), dimension(:,:), allocatable :: psf
  end type SprayType

  real(dbl), dimension(:,:), allocatable, private :: psf
  integer, private :: nbox

  private :: gauss, moffat, seeing, cseeing, fseeing

contains

  subroutine spray_init(profile,spread,hwhm,airy,beta,spsf)

    character(len=*), intent(in) :: profile, spread
    real(dbl), intent(in) :: hwhm, airy, beta
    type(SprayType), intent(out) :: spsf
    integer :: n

    if( profile == 'GAUSS' ) then

       call gauss(hwhm)

    else if( profile == 'MOFFAT' ) then

       call moffat(hwhm,beta)

    else ! if( profile == 'SEEING' ) then

       if( spread == 'RANDOM' ) then

          call seeing(hwhm,airy)

       else if( spread == 'TEST' ) then

          call cseeing(hwhm,airy)

       else ! if (spread == 'FFT' ) then

          call fseeing(hwhm,airy)

       end if
    end if

    ! normalisation
    psf = psf * zoom**2 / sum(psf)

    ! keep results
    spsf%zoom = zoom
    spsf%nbox = nbox
    n = ubound(psf,1)
    allocate(spsf%psf(-n:n,-n:n))
    spsf%psf = psf
    deallocate(psf)

  end subroutine spray_init


  subroutine seeing(hwhm,airy)

    ! The seeing is simulated by summing of Airy profiles with random
    ! offsets. The distribution of offsets is Gaussian N(0,hwhm)
    ! This method is very illustrative, because simmulates the real process
    ! of an image generation. On the other side, it is slow for many iterations
    ! It gives asymetric and randomly noised images.

    use noise

    integer, parameter :: maxiter = 5555

    real(dbl), intent(in) :: hwhm, airy

    real(dbl), dimension(:,:), allocatable :: bessel
    integer :: n,m,i,j,i0,j0,iter,l1,l2,k1,k2
    real(dbl) :: x,y,r,s

    nbox = nint(13*max(hwhm,1.0)*max(airy,5.0))
    n = nbox*zoom
    s = zoom*airy
    m = n / 2
    allocate(psf(-n:n,-n:n),bessel(-m:m,-m:m))

    ! fill-up first quarter of Airy disk
    do i = 0,m
       x = i / s
       do j = 0,m
          y = j / s
          r = sqrt(x**2 + y**2)
          ! https://en.wikipedia.org/wiki/Airy_disk
          if( i == 0 .and. j == 0 ) then
             bessel(i,j) = 1
          else
             bessel(i,j) = (bessel_j1(r)/r)**2
          end if
       end do
    end do

    ! fill-up rest of the PSF
    forall( i = -m:0, j = 0:m ) bessel(i,j) = bessel(-i,j)
    forall( i = -m:m, j = -m:-1 ) bessel(i,j) = bessel(i,-j)

    ! spread the profile by random spread with N(0,s)
    s = hwhm*zoom
    psf = 0
    do iter = 1, maxiter
       x = gnoise(0.0_dbl,s)
       y = gnoise(0.0_dbl,s)
       i0 = nint(x)
       j0 = nint(y)
       k1 = i0 - m
       k2 = i0 + m
       l1 = j0 - m
       l2 = j0 + m
       psf(k1:k2,l1:l2) = psf(k1:k2,l1:l2) + bessel
    end do

    deallocate(bessel)

  end subroutine seeing


  subroutine cseeing(hwhm,airy)

    ! The seeing is simulated by convolution of Airy disk function and
    ! gaussian giving spread. The convolution is computed by direct
    ! sum and it is very slow.

    real(dbl), intent(in) :: hwhm, airy

    real(dbl), dimension(:,:), allocatable :: bessel, kernel
    integer :: n,m,i,j,k,l
    real(dbl) :: x,y,r,s,s2,x2,y2

    nbox = nint(13*max(hwhm,1.0)*max(airy,5.0))
    n = nbox*zoom
    s = zoom*airy
    m = n / 2
    allocate(psf(-n:n,-n:n),bessel(-m:m,-m:m),kernel(-n:n,-n:n))

    ! fill-up first quarter of Airy disk
    do i = 0,m
       x = i / s
       do j = 0,m
          y = j / s
          r = sqrt(x**2 + y**2)
          ! https://en.wikipedia.org/wiki/Airy_disk
          if( i == 0 .and. j == 0 ) then
             bessel(i,j) = 1
          else
             bessel(i,j) = (bessel_j1(r)/r)**2
          end if
       end do
    end do

    ! fill-up rest of the PSF
    forall( i = -m:0, j = 0:m ) bessel(i,j) = bessel(-i,j)
    forall( i = -m:m, j = -m:-1 ) bessel(i,j) = bessel(i,-j)


    ! fill-up first quarter
    s2 = 2*(zoom*hwhm)**2
    do i = 0,n
       x2 = i**2
       do j = 0,n
          y2 = j**2
          kernel(i,j) = exp(-(x2 + y2)/s2)
       end do
    end do

    ! fill-up rest of the PSF
    forall( i = -n:0, j = 0:n ) kernel(i,j) = kernel(-i,j)
    forall( i = -n:n, j = -n:-1 ) kernel(i,j) = kernel(i,-j)


    ! spread profile by direct convolution
    psf = 0
    do i = -m,m
       do j = -m,m
          s = 0
          do l = -m,m
             do k = -m,m
                s = s + bessel(k,l)*kernel(i-l,j-k)
             end do
          end do
          psf(i,j) = s
       end do
    end do

    deallocate(bessel,kernel)

  end subroutine cseeing

  subroutine fseeing(hwhm,airy)

    ! The seeing is simulated by convolution of Airy disk function and
    ! gaussian giving spread. The convolution is computed by using
    ! os Fourier transformation. It is most fast and precise method.

    use ftransform

    real(dbl), intent(in) :: hwhm, airy

    complex(dbl), dimension(:,:), allocatable :: bessel, kernel, qpsf, &
         zbessel, zkernel, zpsf
    integer :: n,m,i,j,n2
    real(dbl) :: x,y,r,s,s2,x2,y2

    n = nint(13*max(hwhm,1.0)*max(airy,5.0))
    m = int(log(real(n*zoom))/log(2.0) + 1)  ! power o 2 for FFT
    n = 2**m
    nbox = n / zoom
    n = nbox*zoom
    s = zoom*airy
    n2 = n / 2
    allocate(psf(-n2+1:n2-1,-n2+1:n2-1),bessel(n,n),zbessel(n,n), &
         kernel(n,n),zkernel(n,n),qpsf(n,n),zpsf(n,n))

    ! fill-up Airy disk
    do i = 1,n
       x = (i - n2) / s
       do j = 1,n
          y = (j - n2) / s
          r = sqrt(x**2 + y**2)
          ! https://en.wikipedia.org/wiki/Airy_disk
          if( i == n2 .and. j == n2 ) then
             bessel(i,j) = 1
          else
             bessel(i,j) = (bessel_j1(r)/r)**2
          end if
       end do
    end do

    ! fill-up Gaussian spread
    s2 = 2*(zoom*hwhm)**2
    do i = 1,n
       x2 = (i - n2)**2
       do j = 1,n
          y2 = (j - n2)**2
          kernel(i,j) = exp(-(x2 + y2)/s2)
       end do
    end do

    ! spread profile by convolution by Fourier transformation
    call ftra(bessel,zbessel,m,1)
    call ftra(kernel,zkernel,m,1)

    zpsf = zbessel * zkernel
    call ftra(zpsf,qpsf,m,-1)

    ! re-arrange quarters
    psf(0:n2-1,0:n2-1) = real(qpsf(1:n2,1:n2))
    psf(-n2+1:0,0:n2-1) = real(qpsf(n2+1:n,1:n2))
    psf(0:n2-1,-n2+1:0) = real(qpsf(1:n2,n2+1:n))
    psf(-n2+1:0,-n2+1:0) = real(qpsf(n2+1:n,n2+1:n))

    deallocate(bessel,kernel,qpsf,zbessel,zkernel,zpsf)

  end subroutine fseeing

  subroutine gauss(hwhm)

    real(dbl), intent(in) :: hwhm
    real(dbl) :: x2,y2,s2
    integer :: i,j,n

    nbox = nint(7*max(hwhm,1.0))
    n = zoom*nbox
    allocate(psf(-n:n,-n:n))

    ! fill-up first quarter
    s2 = 2*(zoom*hwhm)**2
    do i = 0,n
       x2 = i**2
       do j = 0,n
          y2 = j**2
          psf(i,j) = exp(-(x2 + y2)/s2)
       end do
    end do

    ! fill-up rest of the PSF
    forall( i = -n:0, j = 0:n ) psf(i,j) = psf(-i,j)
    forall( i = -n:n, j = -n:-1 ) psf(i,j) = psf(i,-j)

  end subroutine gauss


  subroutine moffat(hwhm, beta)

    real(dbl), intent(in) :: hwhm, beta
    real(dbl) :: x2,y2,s2
    integer :: i,j,n

    nbox = nint(30*max(hwhm,1.0))
    n = zoom*nbox

    allocate(psf(-n:n,-n:n))

    ! fill-up first quarter
    s2 = (zoom*hwhm)**2
    do i = 0,n
       x2 = i**2
       do j = 0,n
          y2 = j**2
          psf(i,j) = (1 + (x2 + y2)/s2)**(-beta)
       end do
    end do

    ! fill-up rest of the PSF
    forall( i = -n:0, j = 0:n ) psf(i,j) = psf(-i,j)
    forall( i = -n:n, j = -n:-1 ) psf(i,j) = psf(i,-j)

  end subroutine moffat


  subroutine spray_pixelize(spsf,dx,dy,xpsf,n)

    real(dbl), intent(in) :: dx, dy
    type(SprayType), intent(in) :: spsf
    real(dbl), dimension(-n:n,-n:n), intent(out) :: xpsf
    integer, intent(in) :: n
    ! The default lower dimension in subroutine is 1 (for allocatable array?),
    ! we pass the dimensions which we needs.

    integer :: x,y,k,l,i,j,k1,k2,l1,l2,m,m2,nn,kk,ll

    nbox = spsf%nbox
    nn = ubound(spsf%psf,1)
    allocate(psf(-nn:nn,-nn:nn))
    psf = spsf%psf
    x = nint(zoom*dx)
    y = nint(zoom*dy)
    m = zoom
    m2 = m / 2

    xpsf = 0
    do i = -n,n
       k = i*m + x
       k1 = max(k - m2,-nn)
       k2 = min(k + m2,nn)
       kk = k2 - k1 + 1
       do j = -n,n
          l = j*m + y
          l1 = max(l - m2,-nn)
          l2 = min(l + m2,nn)
          ll = l2 - l1 + 1
          if( kk > 0 .and. ll > 0 ) then
             xpsf(i,j) = sum(psf(k1:k2,l1:l2)) / (kk*ll)
          end if
       end do
    end do

!    do i = -n,n
!       do j = -n,n
!          xpsf(i,j) = psf(i*m,j*m)
!       end do
!    end do

    deallocate(psf)

  end subroutine spray_pixelize


  subroutine spray_clear(spsf)

    type(SprayType), intent(in out) :: spsf
    deallocate(spsf%psf)

  end subroutine spray_clear


end module spray

! gfortran -Wall -p -g -fcheck=all -I../lib  test_growmodel.f95 -L. -L../lib -ltitsio -lcfitsio -lm

program test_growmodel

  use titsio

  implicit none

  integer, parameter :: group = 1, extver = 0, frow = 1, felem = 1
  real, parameter :: nullval = 0.0
  integer, dimension(2) :: naxes, cens
  logical :: anyf
  real, dimension(:,:), allocatable :: psf
  real, dimension(12) :: raper, cts, grow
  integer :: zoom, bitpix, status, naxis, dim, i,j, m, n
  real :: f,d,b
  type(fitsfiles) :: fits

  status = 0
  call fits_open_file(fits,'art_01.fits',READONLY,status)
  if( status /= 0 ) stop 'failed to open'
  call fits_movnam_hdu(fits,IMAGE_HDU,'PSF',extver,status)
  call fits_get_img_param(fits,bitpix,naxis,naxes,status)
  call fits_get_key('ZOOM',zoom,status)
  dim = naxes(1) / 2
  allocate(psf(-dim:dim,-dim:dim))
  call fits_read_image(fits,psf,status)
  call fits_close_file(fits,status)
  call fits_report_error(error_unit,status)

  forall( i = 1:size(raper) ) raper(i) = exp(0.17338*((i-1)*1.570796327))

  cens = naxes / 2 + 1

  do m = 1, size(raper)
     n = nint(zoom * raper(m))
     f = 0
     do i = -n,n
        do j = -n,n
           if( ((i-zoom/10)**2 + j**2 <= n**2) .and. (-dim < i .and. i < dim) .and. (-dim < j .and. j < dim) ) then
              f = f + psf(i,j)
           end if
        end do
     end do
     cts(m) = f/zoom**2
     write(*,*) raper(m),real(f/zoom**2)
  end do

  deallocate(psf)

  grow(size(raper)) = 1
  b = -0.0000314*0.1
  b = 0
  do i = size(raper)-1,1,-1
     grow(i) = grow(i+1)*(cts(i)-b*raper(i)**2)/(cts(i+1)-b*raper(i+1)**2)
  end do
  do i = 1,size(raper)
     write(*,*) raper(i), cts(i), grow(i)
!     write(*,*) raper(i)/raper(size(raper)),cts(i),grow(i)
  end do

!  d = cts(1) / raper(1)
!  write(*,*) raper(1),cts(1) + 0*d*(0.1), d*0.1
!  do m = 2,size(raper)
!     write(*,*) raper(m),cts(m) + 0*d*(0.1), d
!     d = (cts(m) - cts(m-1)) / (raper(m) - raper(m-1))
!  end do


end program test_growmodel

!
!     PHOTOMETRY, aperture photometry
!     Copyright (C) 1997-9,2010,2013-19 Filip Hroch, Masaryk University
!     Copyright (C) 1991 P.B. Stetson, Dominon Astrophysical Observatory
!
!
!  This file is part of Munipack.
!
!  Credits
!
!    Almost all this source is authored by P. B. Stetson.
!    I adapted it for Fortran 90 (allocatable arrays, precision,
!    array syntax), corrected errors, improve sky estimate by
!    variance stabilising estimator, elliptic aperture.
!
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!
!===================================================================
!
! 2019: I did complete revision of the source. The various obsolete
!      parts has been removed: input by hand, output for every star
!      (but output for program to program has been added). Both
!      elliptic and testing estimators of edge fraction has been included.
!      The code has been improved by latest computer development
!      and my development of robust estimators and photometry in counts.
!      I tried to keep Stetson's programming spirit and conventions.

module daofotometr

  integer, parameter, private :: dbl = selected_real_kind(14)

  private :: circfrac, sqcover

contains

  subroutine  daophotsb (d,derr,xstar,ystar,raper,ring,ecc,incl,lobad,hibad,&
       verbose,plog,apcts,apcts_err,skystar,skystar_err)

    use iso_fortran_env
    use oakleaf

    implicit none

    real, dimension(:,:), intent(in) :: d,derr
    real, dimension(:), intent(in) :: xstar, ystar, raper,ring
    real, dimension(:,:), intent(out) :: apcts,apcts_err
    real, dimension(:), intent(out) :: skystar,skystar_err
    real, intent(in) :: lobad, hibad, ecc, incl
    logical, intent(in) :: verbose, plog

!
!=======================================================================
!
! This subroutine derives the concentric aperture photometry.  At
! present, this is the only place in all of DAOPHOT where sky values
! are derived for the individual stars.
!
!               OFFICIAL DAO VERSION:  1991 April 18
!
! Argument
!
!    WATCH (INPUT) governs whether information relating to the progress
!          of the reductions is to be typed on the terminal screen
!          during execution.
!
!=======================================================================
!

    integer, parameter  :: minsky = 7!, maxap = 12
    real, parameter :: pi = 3.141592653589793115997963
    real, parameter :: rad = 57.295779513082322865

    ! It's expected that all data are already properly scaled by the gain.
    real, parameter :: phpadu = 1.0
!
! Parameters:
!
! MINSKY is the smallest number of pixels from which the sky may be
!        determined.  If for some star the number of sky pixels
!        is less than MINSKY, an error code will result and
!        control will return to the main program.
!
! MAXSKY the maximum number of pixels allowed in the sky annulus.
!        This and the user's requested inner sky radius will later
!        determine the maximum permitted outer sky radius.
!
! MAXAP  the maximum number of star apertures allowed.
!
    real(dbl), dimension(size(raper)) :: area, apsum
    real, dimension(:), allocatable :: sky, dsky
    real, dimension(3) :: error
    real :: skymod, skysig, sigsq, skyvar, skyerr, datum, r, rsq, fractn, &
         edge, apmxsq, rout, dysq, xc, yc, e,c,s,sqrte,u,v,x,y,phi,q,rin
    integer :: i, j, k, n, naper, nstar, lx, ly, nx, ny, mx, my, &
         nsky, ncol, nrow
    logical :: reliable

    skystar = -1
    skystar_err = -1
    apcts = -1
    apcts_err = -1

    ncol = size(d,1)
    nrow = size(d,2)
    naper = size(raper)
    nstar = size(xstar)

!-----------------------------------------------------------------------
!
! SECTION 1
!
! Ascertain the name of the aperture photometry parameter table, and
! read it in.  Then set up all necessary variables for the forthcoming
! reductions. Finally, identify and open the input and output files.
!
    do i = 2, naper
       if( raper(i) < raper(i-1) ) &
            stop "Error in APHOT: some aperture radius is invalid."
    end do

    apmxsq = -1.0
    do i = 1, naper
       apmxsq = max(apmxsq, (raper(i)+0.5)**2)
    end do

!
! sky buffers allocation
!
    nsky = int(max(pi*((ring(2)+1)**2 - ring(1)**2),1.5))
    allocate(sky(nsky),dsky(nsky))

!
! NAPER   is the number of apertures, whose radii are stored in
!         elements 1 through NAPER of the array PAR.
!
! APMXSQ  is the outermost edge of the largest aperture-- if the
!         distance squared of the center of a pixel from the centroid of
!         the star is greater than APMXSQ, then we know that no part
!         of the pixel is to be included in any aperture.
!
! Now define the other variables whose values are in the table.
!

    if( ring(1) >= ring(2) ) &
         stop "Error in APHOT: invalid sky ring radius."

    rin  = ring(1)
    rout = ring(2)

! If progress is being monitored, type out column headers.
!
!  if (watch > 0.5) &
!  if( verbose ) &
!       write (*,"(/13X, 'STAR', 5X, 'X', 7X, 'Y', 9X, 'MAG.(1)', 8X, 'SKY')")
!
!-----------------------------------------------------------------------
!
! SECTION 2
!
! Derive aperture photometry object by object.
!
! Get the coordinates of next object to be measured.
!
    lx = 1
    ly = 1
    nx = ncol
    ny = nrow

    e = ecc
    c = cos(incl/rad)
    s = sin(incl/rad)
    sqrte = sqrt(1 - e**2)

    do n = 1, nstar

       xc = xstar(n)
       yc = ystar(n)
!       istar = n
!
! Compute the limits of the submatrix.
!
       lx = max(1, int(xc-rout)+1)
       mx = min(ncol, int(xc+rout))
       ly = max(1, int(yc-rout)+1)
       my = min(nrow, int(yc+rout))
       edge = min(xc-0.5, (ncol+0.5)-xc, yc-0.5, (nrow+0.5)-yc)
!
! EDGE is the distance of the star's centroid from the outermost
! extremum of the array.
!

!
! Initialize star counts and aperture area.
!
       do  i = 1, naper
          apsum(i) = real(0.0,dbl)
!
! If this star aperture extends outside the array, the magnitude
! in this aperture will be no good.
!
          if (edge < raper(i)) apsum(i) = -huge(apsum)  ! Null magnitude
          area(i) = real(0.0,dbl)
       enddo
!
! Now read through the submatrix, picking out the data we want.
!
       nsky = 0
       do  j = ly, my
          dysq = (j - yc)**2
          do i = lx,mx
             rsq = dysq + (i - xc)**2
             datum = d(i,j)

             ! elliptic apertures
             u = i - xc
             v = j - yc
             x = c*u + s*v
             y =-s*u + c*v
             if( abs(x) > 0 .or. abs(y) > 0 ) then
                r = sqrt(x**2 + y**2)
                phi = atan2(y,x*sqrte)
             else
                r = 0
                phi = 0
             end if
             q = sqrt(1 - e**2*sin(phi)**2)

!
! Is this pixel within the sky annulus?
!
!           write(*,*) r,rin,rout,datum,lobad,hibad
             if( rin <= r .and. r <= rout .and. &
                  lobad <= datum .and. datum <= hibad ) then
                nsky = nsky + 1
                sky(nsky) = datum
                dsky(nsky) = derr(i,j)
             endif
!
! The inclusion of partial pixels inside the aperture is done as
! follows:  if the distance of the center of the current pixel from the
! centroid of the star [radius vector r(i,j)] is exactly equal to the
! radius of the aperture [R(k)], then one-half of the counts in the
! pixel are included.  If r(i,j) < R(k)-0.5, then the entire pixel is
! included, while if r(i,j) > R(k)+0.5, the pixel is wholly excluded.
! In between, viz. for  R(k)-0.5 < r(i,j) < R(k)+0.5, the fraction of
! the counts included varies linearly.  Therefore a circular aperture
! is approximated by an irregular (not even convex) polygon.
!
! If this pixel falls completely outside the LARGEST aperture, go on
! to the next pixel.  Notice that APMXSQ has actually been defined
! as (R(k)+0.5)**2 for the largest value of R(k), in accordance with
! the formula used for the partial pixels.
!
             if (rsq <= apmxsq) then

                ! DAOPHOT original code adds to 0.5 to r by the commented
                ! formula; Munipack uses unmodified r value, the one-half
                ! is added in the fractn determination.
                ! r = sqrt(rsq) - 0.5
!
                do k = 1, naper
!
! if this pixel falls completely outside THIS aperture, go on to the
! next aperture.
!
                   if ( r <= raper(k)+1 ) then

                    ! determination of fraction of pixel in circular
                    ! apertures uses traditional estimator, while
                    ! the elliptic the improved one
                      if( abs(e) < epsilon(e) ) then
                         fractn = max(0.0, min(1.0,raper(k) - r + 0.5))
                      else
                         block
                           real :: a,b,xt,yt
                           a = raper(k)
                           b = a*sqrte
                           xt = a*cos(phi)
                           yt = b*sin(phi)
                           fractn = circfrac(a,b,phi,xt-x,yt-y,raper(k)*q>r)
                           ! fractn = sqcover(x,y,raper(k))
                           ! if( k == 3 .and. n == 1 ) &
                           !  write(*,*) x,y,raper(k)-r,fractn, &
                           !  max(0.0, min(1.0,raper(k) - r + 0.5)), &
                           !  sqcover(x,y,raper(k))
                         end block
                      end if

!
! fractn is the fraction of the pixel that falls inside the
! (irregular) aperture.
!
! If the pixel is bad, set the total counts in this aperture to a number
! so negative that it will never be positive again.
!                                                          ! Null magnitude
                      if (datum < lobad .or. datum > hibad ) apsum(k)=-huge(1.0)
                      apsum(k) = apsum(k) + fractn*datum
                      area(k) = area(k) + fractn
                   endif
                enddo
             endif
          enddo ! i
       enddo ! j
!
! We have accumulated the brightnesses of individual sky pixels in the
! one-dimensional array SKY.  Pixels falling above or below the BAD
! limits have already been eliminated.  Now sort SKY to place the
! pixels in order of increasing brightness.
!
       if (nsky < minsky)  then
          write(error_unit,*) "There aren't enough pixels in the sky annulus."
          write(error_unit,*) 'Object at coordinates:',xc,yc
          write(error_unit,*) ' Are you sure your bad pixel thresholds are all right?'
          write(error_unit,*) ' If so, then you need a larger outer sky radius.'
          write(error_unit,*) nsky,minsky,size(sky),lobad,hibad
          goto 3333
       end if
!
! Obtain the mode, standard deviation, and skewness of the peak in the
! sky histogram.
!
       if( all(sky(1:nsky) > 0) .and. all(dsky(1:nsky) > 0) ) then
          call rmean(sky(1:nsky),dsky(1:nsky),skymod,skyerr,skysig,&
               reliable=reliable)
       else
          reliable = .false.
       end if
       if( .not. reliable ) &
          call rmean(sky(1:nsky),skymod,skyerr,skysig,reliable=reliable)
       !write(*,*) '*',n,nsky,skymod,skyerr,skysig,reliable

       skyvar = skysig**2
       sigsq = skyerr**2    ! equivalent of: sigsq = skyvar/nsky

!
! SKYMOD has units of (ADU/pixel), and SKYSIG is the pixel-to-pixel
! scatter of SKYMOD, in units of (ADU/pixel).  SKYVAR is the
! variance (square of the standard deviation) of the sky brightness,
! (ADU/pixel)**2, and SIGSQ is the square of the standard error of the
! mean sky brightness.
!
! Subtract the sky from the integrated brightnesses in the apertures,
! convert the results to magnitudes, and compute standard errors.
!
       do i = 1, naper
!
! If the modal sky value could not be determined, set the magnitude
! to 99.999: and total count sum to -1.
!
          apsum(i) = apsum(i) - skymod*area(i)
          if( apsum(i) > 0 .and. reliable ) then
!
! If the star + sky is fainter than the sky, or if the star aperture
! extends beyond the limits of the picture, or if there is a bad pixel
! in the star aperture, set the magnitude to 99.999.
!
             error(1) = real(area(i)*skyvar)
             error(2) = real(apsum(i)/phpadu)
             error(3) = real(sigsq*area(i)**2)

! For Munipack, we needs counts. Sum in aperture is multiplied
! by phpadu, gain (=1 allways), to get detected counts instead
! of digitalized data.

             apcts(n,i) = real(apsum(i)*phpadu)
             apcts_err(n,i) = real(sqrt(sum(error)))
!             if( i == 6 ) write(*,*) area(i),apsum(i),sqrt(error)
          else
             apcts(n,i) = -1
             apcts_err(n,i) = -1
          end if


!
! These variables ERRORn are the respective variances (squares of the
! mean errors) for: (1) random noise inside the star aperture, including
! readout noise and the degree of contamination by other stars in the
! neighborhood, as estimated by the scatter in the sky values (this
! standard error increases as the square root of the area of the
! aperture); (2) the Poisson statistics of the observed star brightness;
! (3) the uncertainty of the mean sky brightness (this standard error
! increases directly with the area of the aperture).
!
       enddo
!
! Write out the answers.
!
!      if (watch > 0.5) then
!      if( verbose ) then
!         write (*,"(10X, I5, 2F8.1, F9.3, ' +-', F6.3, 3x, g0.3)") &
!              istar, xc, yc, apmag, magerr, skymod
!         write (*,"(/1X, I5, 14F9.3)") istar, xc, yc, (apmag(i), i=1,naper)
!         write (*,"(4X, F9.3, 2F6.2, F8.3, 11F9.3)") skymod, min(99.99,skysig),&
!              min(999.99, max(-99.99,skyskw)), (magerr(i), i=1,naper)
!      endif

       if( plog ) write(*,'(a,2(f0.3,1x),es15.5)') '=APHOT> ',xc,yc,apcts(n,1)

       skystar(n) = skymod*phpadu
       skystar_err(n) = skyerr*phpadu

3333 continue
    enddo ! over stars
!
!-----------------------------------------------------------------------
!
! Normal return.
!
! Estimate magnitude limit, close files, and return.
!

    if( verbose ) write(*,"(a,i0,a)") " Found ",nstar," star(s)."
    deallocate(sky,dsky)

  end subroutine daophotsb

  real function circfrac(a,b,phi,dx,dy,outer)

    ! Estimates relative fraction of pixel intesrected with aperture circle edge
    ! The pixel is approximated by circle, the edge by a line.

    real, parameter :: pi = 3.14159265358979323844
    real, parameter :: rc = 0.564 ! = 1/sqrt(pi) radius of circumcircle
    real, parameter :: Area = pi*rc**2      ! circle area, should be == 1

    real, intent(in) :: a,b,phi,dx,dy
    logical, intent(in) :: outer
    real :: k,q,D,w,s,x1,x2,y1,y2,t,alpha,dA

    ! singular points
    if( abs(a) < epsilon(a) .or. abs(phi) < epsilon(phi) ) then
       if( outer ) then
          circfrac = 1
       else
          circfrac = 0
       end if
       return
    end if

    ! the intersection
    ! https://en.wikipedia.org/wiki/Intersection_(Euclidean_geometry)

    ! tangent: y = kx + q
    k = - (b/a) / tan(phi)
    q = dy - k*dx

    ! discriminant
    w = 1 + k**2
    D = rc**2*w - q**2

    if( D > 0 ) then
       s = sqrt(D)
       x1 = (-q*k + s) / w
       x2 = (-q*k - s) / w
       y1 = (q + k*s) / w
       y2 = (q - k*s) / w
       t = sqrt((y2 - y1)**2 + (x2 - x1)**2)
       alpha = 2*asin(min(t/rc/2,1.0))
       ! https://en.wikipedia.org/wiki/Circular_segment
       dA = rc**2*(alpha - sin(alpha)) / 2
       if( outer ) then
          circfrac = (Area - dA) / Area
       else
          circfrac = dA / Area
       end if
    else
       if( outer ) then
          circfrac = 1
       else
          circfrac = 0
       end if
    end if

  end function circfrac

  real function sqcover(xpix,ypix,raper)

    ! This routine computes coveradge of pixel on the edge by numerical way.
    ! It's dumy, slow, designed for testing purposes.

    real, intent(in) :: xpix,ypix,raper

    real :: x,y
    integer :: i,j,n,k

    n = 0
    k = 0
    do i = -50, 50
       x = xpix + i / 100.0
       do j = -50, 50
          y = ypix + j / 100.0
          if( sqrt(x**2 + y**2) < raper ) k = k + 1
          n = n + 1
       end do
    end do

    sqcover = real(k) / real(n)

  end function sqcover

end module daofotometr

!
! trispace - create histogram from triangles of all possible permutations
!
! $ gfortran -Wall -g -p -fbounds-check -fimplicit-none  -I../lib match.f95  astrofits.f95 trispace.f95 -lcfitsio -lm
!
! Copyright © 2012 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program trispace

  use astrofits
  use matcher

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  integer, parameter :: uvdim = 100

  real(dbl), allocatable, dimension(:) :: x, y, x1, y1
  integer, dimension(:), allocatable :: id1
  real(dbl) :: w,h, u, v
  integer :: i,j,k,nmatch,iu,iv
  real(dbl),dimension(2) :: crpix
  integer, allocatable, dimension(:,:) :: uvhist

  call readfile('barnard_01R.fits',w,h,x,y,crpix,i)

  nmatch = size(x)
  allocate(id1(nmatch),x1(nmatch),y1(nmatch))
  x1 = x(1:nmatch)
  y1 = y(1:nmatch)

  allocate(uvhist(0:uvdim,0:uvdim))
  uvhist = 0

  do i = 1, nmatch
     do j = i+1, nmatch - 1
        do k = j+1, nmatch - 1
           call triangle(x1(i),y1(i),x1(j),y1(j),x1(k),y1(k),u,v)
!           write(*,*) i,j,k,u,v
           iu = int(uvdim*u)
           iv = int(uvdim*v)
!           write(*,*) u,v,iu,iv
           uvhist(iu,iv) = uvhist(iu,iv) + 1
        end do
     end do
  end do


  open(16,file='uvhist')
  do i = 0,uvdim
     do j = 0,uvdim
        write(16,'(2f6.3,1x,i0)') real(i)/real(uvdim),real(j)/real(uvdim),uvhist(i,j)
     end do
     write(16,*)
  end do
  close(16)

end program trispace

!
!  Robust weighted mean
!
!  Copyright © 2016-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

module weightedmean

  ! This module provides subroutines for estimation of both
  ! robust mean and its deviations.
  !
  ! rwmean should be called as:
  !
  !  call rwmean(x,dx,t,dt,sig,scale,reliable)
  !
  ! on input:
  !   x - array of data values to be estimated
  !   dx - array of statistical errors of x
  !
  ! on output are estimated:
  !   t - robust mean
  !   dt - standard error (optional)
  !   sig - standard deviation (optional)
  !   scale - scale (optional)
  !   reliable - indicates reliability of results (optional)
  !
  ! The given results  means that a true value X of the sample x can be,
  ! with 70% probability, found in interval
  !
  !         t - dt  <  X  <  t + dt
  !
  ! and the distribution can be described by Normal distribution N(t,sig).
  ! No studentizing applied.
  !
  !
  ! WARNING
  !
  ! This routine gives unexpected results when input errors in dx
  ! are incorrectly determined. In this case, scale is significantly
  ! different from number one. The reliable flag is set to .false.
  !
  !
  ! Robust estimators has been prepared on base of
  !  * Hogg in Launer, Wilkinson: Robustness in Statistics
  !  * Hubber: Robust Statistics
  !  * my experiences


  implicit none
  private

  ! print debug information ?
  logical, parameter, private :: debug = .false.
  logical, private :: verbose = .false.

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)

  ! 50% quantil of N(0,1)
  real(dbl), parameter, private :: q50 = 0.6745

  ! private working arrays
  real(dbl), dimension(:), allocatable, private :: r,rs,psi,dpsi,z,dz

  ! data limits
  real(dbl), private :: xmin, xmax

  ! implemened in both single and double precision
  interface rwmean
     module procedure rwmean2, rwmean1
  end interface rwmean

  private :: newton, zmean, zerofun, zero_graph
  public :: rwmean, rwmean2, rwmean1, rwinit

contains

  subroutine rwmean2(x,dx,t,dt,sig,scale,reliable,verb)

    use rfun
    use entropyscale

    real(dbl), dimension(:),intent(in) :: x, dx
    real(dbl), intent(out) :: t
    real(dbl), intent(out), optional :: dt,sig, scale
    logical, intent(out), optional :: reliable
    logical, intent(in), optional :: verb

    real(dbl), parameter :: machtol = epsilon(t)
    real(dbl) :: s,d,avar,s0,t0
    integer :: n
    logical :: converge, reli, treli, sreli

    if( present(verb) ) verbose = verb

    if( size(x) /= size(dx) ) stop 'rwmean: size(x) /= size(dx)'
    if( .not. ( all(dx > 0) ) ) stop 'rwmean: any dx < 0'

    converge = .false.
    if( present(scale) ) scale = 1

    n = size(x)

    if( n == 0 ) then

       t = 0
       if( present(dt)) dt = 0
       if( present(sig) ) sig = 1
       if( present(reliable) ) reliable = .false.
       return

    else if( n == 1 ) then

       t = x(1)
       if( present(dt) ) dt = dx(1)
       if( present(sig) ) sig = 1
       if( present(reliable) ) reliable = .false.
       return

    else if( n == 2 ) then

       avar = (dx(1) + dx(2)) / 2
       t = (x(1) + x(2)) / 2
       s = abs(x(1) - x(2)) / avar

       if( present(dt) ) dt = s / sqrt(2.0)
       if( present(sig) ) sig = s
       if( present(reliable) ) reliable = .true.
       return

    end if

    xmin = minval(x)
    xmax = maxval(x)

    ! initial estimate
    call rwinit(x,dx,t,s,avar)
    if( verbose ) write(*,'(a,1p3g17.7)') 'rwinit:',t,s,avar

    if( abs(s) < 2*epsilon(s)  )then

       ! The power of the robust method can be performed
       ! only on large dataset.

       ! If most of the data is identical, results can be considered
       ! as reliable.
       reli = sum(abs(x-t)) / n < 10*epsilon(s)

       if( present(dt) ) dt = avar / sqrt(real(n))
       if( present(reliable) ) reliable = reli
       if( present(sig) ) sig = s
       return

    endif
    ! we are suppose n > 2, below this point

    ! keep initial estimation
    t0 = t
    s0 = s

    ! Allocates working arrays. A memory can be allocated on the fly,
    ! but it may slow-down the computations.
    allocate(r(n),rs(n),psi(n),dpsi(n))

    if( debug ) call zero_graph(x,dx,t,s)

    ! zmean is a solver without derivatives
    call zmean(x,dx,s,t,treli)

    ! The scale parameter estimates average dispersion of residuals
    ! scaled by theirs, a priory known, statistical errors (dx).
    ! Normally, the value is expected near number one: escale ~= 1.
    call escale((x-t)/dx,s,sreli)

    reli = treli .and. sreli
    if( verbose ) &
         write(*,'(a,1p2g17.7,1x,2l1)') 'zmean, escale:',t,s,treli,sreli

    if( reli ) then

       ! keep the solution
       t0 = t
       s0 = s

       ! Newton's iterations are used mainly to get more precise result and
       ! to estimate of std.err.
       call newton(x,dx,s,t,d,converge)
       reli = converge .and. (xmin < t .and. t < xmax)

       if( verbose ) write(*,'(a,1p3g17.7,2l3)') 'Newton:',t,d,reli,converge

    end if

    if( .not. reli ) then
       ! failback alternative:
       !  * parameters are poorly estimated, all psi'(.) are zero
       !  * no convergence
       !  * final result is out of range of the zmean result
       !
       !  As the consequence, results will not realiable.

       t = t0
       s = s0
       d = avar * sqrt(s**2/n)

       if( debug ) write(*,*) 'rmean5 (not reliable):',t,t0,s,s0,d,converge

    end if

    if( verbose ) &
         write(*,'(a,3g15.5,1x,l1)') 'rwmean2:',real(t),real(d),real(s),reli
    deallocate(r,rs,psi,dpsi)

    ! fill-up optional items
    if( present(dt) ) dt = d
    if( present(sig) ) sig = s * avar
    if( present(scale) ) scale = s
    if( present(reliable) ) reliable = reli

  end subroutine rwmean2

  subroutine rwmean1(x,dx,t,dt,sig,scale,reliable,verb)

    ! single precision version

    real, dimension(:),intent(in) :: x, dx
    real, intent(out) :: t
    real, intent(out), optional :: dt,sig,scale
    logical, intent(out), optional :: reliable
    logical, intent(in), optional :: verb

    real(dbl) :: q,dq,sig2,s2
    real(dbl), dimension(:), allocatable :: y,dy
    logical :: reliable2

    if( present(verb) ) verbose = verb

    allocate(y(size(x)),dy(size(x)))
    y = x
    dy = dx

    call rwmean2(y,dy,q,dq,sig2,s2,reliable2)

    t = real(q)
    if( present(dt) ) dt = real(dq)
    if( present(sig) ) sig = real(sig2)
    if( present(scale) ) scale = real(s2)
    if( present(reliable) ) reliable = reliable2

    deallocate(y,dy)

  end subroutine rwmean1


  subroutine newton(x,dx,s,t,dt,converge)

    ! This routine implements Newton's method for solving of equation
    !
    !  f(t) = 0,  where f(t) = sum( psi( (x-t)/(s*dx) ) )
    !
    ! t   is estimation of mean,
    ! dt  is standard error of t
    ! sig is standard deviation of the sample

    use rfun

    real(dbl), dimension(:), intent(in) :: x, dx
    real(dbl), intent(in) :: s
    real(dbl), intent(in out) :: t
    real(dbl), intent(out) :: dt
    logical, intent(out) :: converge

    integer, parameter :: maxiter = precision(t)
    ! Number of iterations is limited by numerical precision.
    ! We belives in quadratic convergence of Newton's method so,
    ! two orders are reached by each iteration, at least.

    integer :: n,iter
    real(dbl) :: d,f,df,f2,tol

    converge = .false.
    dt = -1
    if( .not. (s > 0) ) return

    n = size(x)

    ! Adjusting of tolerance
    tol = 10*n*epsilon(t)*(abs(t) + 1)

    ! Newton's iterations
    do iter = 1, maxiter

       ! derivation of derivatives
       r = (x - t) / dx
       rs =  r / s
       call tukeys(rs,psi)
       call dtukeys(rs,dpsi)
       f = sum(psi/dx)
       df = sum(dpsi/dx**2)

       ! derivative (denominator) checkpoint:
       ! * If all values are out of range: |df| < epsilon
       ! * df < 0 indicates "re-descending M-estimate" function problem ...
       !   the problem usually appears when distribution strongly deviates
       !   from Normal distribution
       if( df < epsilon(df) ) exit

       ! corrector for mean
       d = s * f / df

       ! update location
       t = t + d

       if( debug ) write(*,'(a,i2,g15.5,1p3g12.3)') &
            "mean, incr., f, f': ",iter,t,d,-f/s,df/s**2

       ! exit of iterations: the absolute errot must be at least |d| < tol
       converge = abs(d) < tol
       if( converge ) exit

    enddo

    ! estimation of standard error
    if( converge ) then
       f2 = sum(psi**2/dx**2)
       if( f2 > 0 .and. df > 0 ) then
!          s = s*sqrt(n/(n-1)*f2/df)
          dt = s*sqrt(n/(n-1)*f2/df**2)
       end if
    end if

  end subroutine newton

  subroutine zmean(x,dx,s,t,reli)

    use fmm
    use medians

    real(dbl), dimension(:),intent(in) :: x, dx
    real(dbl), intent(in) :: s
    real(dbl), intent(in out) :: t
    logical, intent(out) :: reli

    real(dbl) :: tol,tmin,tmax,d
    integer :: n

    n = size(x)
    d = 3.3 * qmedian(abs(x - t)) / q50
    tol = 1e-5*d
    allocate(z(n),dz(n))

    if( n > 7 ) then
       tmin = max(t - d,xmin)
       tmax = min(t + d,xmax)
    else
       tmin = xmin
       tmax = xmax
    end if

    z = x
    dz = s*dx
    t = zeroin(tmin,tmax,zerofun,tol)
    deallocate(z,dz)

    ! d gives precision of localisation on base of std.dev.
    ! Number of calls of 0-fun will approximately ln((tmax-tmin)/tol).

    d = 2*tol
    reli = abs(t - tmin) > d .and. abs(tmax - t) > d

!    if( .not. reli ) write(*,*) tmin,tmax,d,3.3*smed/q50,xmin,xmax,'|',x

    ! if result is too close to interval endpoints, one raise suspicion ...

  end subroutine zmean


  function zerofun(t)

    use rfun

    real(dbl) :: zerofun
    real(dbl), intent(in) :: t

    rs = (t - z) / dz
    call tukeys(rs,psi)
!    psi = rs

    zerofun = sum(psi/dz)

  end function zerofun


  subroutine rwinit(x,dx,t,s,d)

    ! This routine performs an initial estimate of both mean and scale
    ! using both median and absolute value.

    use medians
    use qmeans

    real(dbl), dimension(:),intent(in) :: x, dx
    real(dbl), intent(out) :: t,s,d

    real(dbl) :: mad,med
    integer :: n

    n = size(x)

    if( n > 50 ) then

       ! This choice of the threshold used for median computation method
       ! assumes that odd and even elements in sequence are the same (within
       ! requested precision). Note that qmed is the fastest known algorithm
       ! (~2*n) while median is simpler and slower (~n*log(n)).

       d = qmedian(dx)
       med = qmedian(x)
       mad = qmedian(abs(x - med)) / d

       ! correction for Normal distribution
       s = mad / q50
       t = med

    else if( n > 13 ) then

       ! correct way to compute median (two middle values)
       d = median(dx)
       med = median(x)
       mad = median(abs(x - med)) / d

       ! correction for Normal distribution
       s = mad / q50
       t = med

    else if( n > 2 ) then

       ! compute parameters by empirical CDF quantilies
       call qmean(dx,d,s)
       call qmean(x,med,s)
       call qmean(abs(x - med),mad,s)
       mad = mad / d
       s = mad / q50
       t = med

    else if( n == 2 ) then

       d = (dx(1) + dx(2)) / 2
       t = (x(1) + x(2)) / 2
       s = abs(x(1) - x(2)) / d

    else if( n == 1 ) then

       d = dx(1)
       t = x(1)
       s = 1

    else

       d = 1
       t = 0
       s = 1

    end if

  end subroutine rwinit



 ! diagnostics routines


  subroutine zero_graph(x,dx,t0,s)

    use rfun
    use medians

    real(dbl), dimension(:),intent(in) :: x, dx
    real(dbl), intent(in) :: t0,s

    integer :: i,n
    real(dbl) :: t,d

    d = median(s*dx) / 0.6745

    n = size(x)
    allocate(z(n),dz(n))
    z = x
    dz = dx

    open(1,file='/tmp/tw')
    do i = -500,500,10
       t = t0 + d * i / 100.0
       write(1,*) t,zerofun(t)
    end do
    close(1)
    deallocate(z,dz)

  end subroutine zero_graph



end module weightedmean

!
! Astrometry related transformations
!
!
! Copyright © 2011-3, 2015 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module astrotrafo

  implicit none
  
  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl

  ! Transformation and projection:
  !
  ! type ... type of projection (GNOMONIC,..)
  !      ... mostly affine transformation ...
  ! scale... scale [deg/pixel]
  ! rot  ... rotation angle [deg]
  ! acen ... center projection in alpha [deg]
  ! dcen ... center projection in delta [deg]
  ! xcen ... horizontal center projection [pixel]
  ! ycen ... vertical center projection [pixel]
  ! refl ... -1 for reflected frame
  ! err  ... typical statistical error of acen, dcen [deg]

  type AstroTrafoProj
     character(len=80) :: type
     real(dbl) :: acen,dcen,xcen,ycen,ucen,vcen,scale,rot,err,refl
     real(dbl), dimension(2,2) :: mrot,smat,mat,mat1
     real(dbl), dimension(2) :: xy0,uv0
  end type AstroTrafoProj
  
  interface trafo
     module procedure trafo_point, trafo_array
  end interface trafo

  interface invtrafo
     module procedure invtrafo_point, invtrafo_array
  end interface invtrafo

  interface affine
     module procedure affine_point, affine_array
  end interface affine

  interface invaffine
     module procedure invaffine_point, invaffine_array
  end interface invaffine

  interface proj
     module procedure proj_point, proj_array
  end interface proj

  interface invproj
     module procedure invproj_point, invproj_array
  end interface invproj

  private :: trafo_point, trafo_array,invtrafo_point, invtrafo_array, &
       affine_point, affine_array, invaffine_point, invaffine_array, &
       proj_point, proj_array, invproj_point, invproj_array, &
       gproj, invgproj

contains

! --- init ---

  subroutine trafo_init(t,type,acen,dcen,xcen,ycen,ucen,vcen,scale,rot,refl,err)

    type(AstroTrafoProj), intent(out) :: t
    character(len=*), intent(in), optional :: type
    real(dbl), intent(in), optional :: acen,dcen,xcen,ycen,ucen,vcen,scale,rot,err,refl

    t%type = 'GNOMONIC'
    t%acen = 0.0_dbl
    t%dcen = 0.0_dbl
    t%xcen = 0.0_dbl
    t%ycen = 0.0_dbl
    t%ucen = 0.0_dbl
    t%vcen = 0.0_dbl
    t%scale= 1.0_dbl
    t%rot  = 0.0_dbl
    t%refl = 1.0_dbl
    t%err  = epsilon(t%err)

    if( present(type) ) t%type = type
    if( present(acen) ) t%acen = acen
    if( present(dcen) ) t%dcen = dcen
    if( present(xcen) ) t%xcen = xcen
    if( present(ycen) ) t%ycen = ycen
    if( present(ucen) ) t%ucen = ucen
    if( present(vcen) ) t%vcen = vcen
    if( present(scale)) t%scale= scale
    if( present(rot)  ) t%rot  = rot
    if( present(refl) ) t%refl = refl
    if( present(err)  ) t%err  = err

    call trafo_refresh(t)

  end subroutine trafo_init


  subroutine trafo_refresh(t)

    type(AstroTrafoProj), intent(inout) :: t
    real(dbl), dimension(2,2) :: m
    real(dbl) :: f,c,s,det

    ! construct affine projection matrix
    f = t%rot / rad
    c = cos(f)
    s = sin(f)

    t%smat(1,:) = (/ t%scale * t%refl, 0.0_dbl /)
    t%smat(2,:) = (/ 0.0_dbl,          t%scale /)
    t%mrot(1,:) = (/c,-s/)
    t%mrot(2,:) = (/s, c/)

    t%mat = matmul(t%mrot,t%smat)

    m = t%mat
    det = m(1,1)*m(2,2) - m(1,2)*m(2,1)
    t%mat1(1,:) = (/ m(2,2),-m(1,2) /) / det
    t%mat1(2,:) = (/-m(2,1), m(1,1) /) / det

    t%xy0 = (/t%xcen, t%ycen/)
    t%uv0 = (/t%ucen, t%vcen/)

  end subroutine trafo_refresh

! --- trafo ---

  subroutine trafo_point(t, a, d, x,y)

    type(AstroTrafoProj), intent(in) :: t
    real(dbl), intent(in) :: a,d
    real(dbl), intent(out) :: x,y
    real(dbl), dimension(1) :: xx,yy
    
    call trafo(t, (/a/), (/d/), xx,yy)
    x = xx(1)
    y = yy(1)

  end subroutine trafo_point

  subroutine trafo_array(t, a, d, x,y)


    type(AstroTrafoProj), intent(in) :: t
    real(dbl), dimension(:), intent(in) :: a,d
    real(dbl), dimension(:), intent(out) :: x,y
    real(dbl), dimension(:), allocatable :: u,v
    integer :: n

    n = size(a)
    allocate(u(n),v(n))

    call proj(t,a,d,u,v)
    call affine(t,u,v,x,y)

    deallocate(u,v)

  end subroutine trafo_array

! --- invtrafo ---

  subroutine invtrafo_point(t,x,y,a,d)

    type(AstroTrafoProj), intent(in) :: t
    real(dbl), intent(in) :: x,y
    real(dbl), intent(out) :: a,d
    real(dbl), dimension(1) :: aa,dd

    call invtrafo(t,(/x/),(/y/),aa,dd)
    a = aa(1)
    d = dd(1)

  end subroutine invtrafo_point

  subroutine invtrafo_array(t,x,y,a,d)

    use projections

    type(AstroTrafoProj), intent(in) :: t
    real(dbl), dimension(:), intent(in) :: x,y
    real(dbl), dimension(:), intent(out) :: a,d
    real(dbl), dimension(:), allocatable :: u,v
    integer :: n

    n = size(a)
    allocate(u(n),v(n))

    call invaffine(t,x,y,u,v)
    call invproj(t,u,v,a,d)

    deallocate(u,v)

  end subroutine invtrafo_array


! --- proj ---

  subroutine proj_array(t,a,d,u,v)

    use projections

    type(AstroTrafoProj), intent(in) :: t
    real(dbl), dimension(:), intent(in) :: a,d
    real(dbl), dimension(:), intent(out) :: u,v

    if( t%type == "GNOMONIC" ) then
       call gproj(gnomond,t%acen,t%dcen,a,d,u,v)
    else if( t%type == " " ) then
       call gproj(identity,t%acen,t%dcen,a,d,u,v)
    end if

  end subroutine proj_array

  subroutine proj_point(t,a,d,u,v)
    
    type(AstroTrafoProj), intent(in) :: t
    real(dbl), intent(in) :: a,d
    real(dbl), intent(out) :: u,v
    real(dbl), dimension(1) :: uu,vv

    call proj(t,(/a/),(/d/),uu,vv)
    u = uu(1)
    v = vv(1)

  end subroutine proj_point

! --- invproj ---

  subroutine invproj_array(t,u,v,a,d)

    use projections

    type(AstroTrafoProj), intent(in) :: t
    real(dbl), dimension(:), intent(in) :: u,v
    real(dbl), dimension(:), intent(out) :: a,d

    if( t%type == "GNOMONIC" ) then
       call invgproj(invgnomond,t%acen,t%dcen,u,v,a,d)
    else if( t%type == " " ) then
       call invgproj(invidentity,t%acen,t%dcen,u,v,a,d)
    end if

  end subroutine invproj_array

  subroutine invproj_point(t,u,v,a,d)

    type(AstroTrafoProj), intent(in) :: t
    real(dbl), intent(in) :: u,v
    real(dbl), intent(out) :: a,d
    real(dbl), dimension(1) :: aa,dd

    call invproj(t,(/u/),(/v/),aa,dd)
    a = aa(1)
    d = dd(1)

  end subroutine invproj_point

! --- invaffine ---


  subroutine invaffine_point(t,x,y,u,v,g,h)

    type(AstroTrafoProj), intent(in) :: t
    real(dbl), intent(in) :: x,y
    real(dbl), intent(out) :: u,v
    real(dbl), intent(out), optional :: g,h

    real(dbl), dimension(1) :: uu,vv,gg,hh

    if( present(g) .and. present(h) ) then
       call invaffine(t,(/x/),(/y/),uu,vv,gg,hh)
       u = uu(1)
       v = vv(1)
       g = gg(1)
       h = hh(1)
    else
       call invaffine(t,(/x/),(/y/),uu,vv)
       u = uu(1)
       v = vv(1)
    end if

  end subroutine invaffine_point

  subroutine invaffine_array(t,x,y,u,v,g,h)

    type(AstroTrafoProj), intent(in) :: t
    real(dbl), dimension(:), intent(in) :: x,y
    real(dbl), dimension(:), intent(out) :: u,v
    real(dbl), dimension(:), intent(out), optional :: g,h

    real(dbl), dimension(2) :: r,s
    integer :: i

    do i = 1,size(x)
       r = (/x(i),y(i)/) - t%xy0
       s = matmul(t%mat,r) + t%uv0
       u(i) = s(1)
       v(i) = s(2)

       if( present(g) .and. present(h) ) then
          s = matmul(t%mrot,r)
          g(i) = s(1)
          h(i) = s(2)
       end if

    end do

  end subroutine invaffine_array

! --- affine ---

  subroutine affine_point(t,u,v,x,y)

    type(AstroTrafoProj), intent(in) :: t
    real(dbl), intent(in) :: u,v
    real(dbl), intent(out) :: x,y

    real(dbl), dimension(1) :: xx,yy

    call affine(t,(/u/),(/v/),xx,yy)
    x = xx(1)
    y = yy(1)

  end subroutine affine_point

  subroutine affine_array(t,u,v,x,y)

    type(AstroTrafoProj), intent(in) :: t
    real(dbl), dimension(:), intent(in) :: u,v
    real(dbl), dimension(:), intent(out) :: x,y

    real(dbl), dimension(2) :: r,s
    integer :: i

    do i = 1,size(u)
       s = (/u(i),v(i)/) - t%uv0
       r = matmul(t%mat1,s) + t%xy0
       x(i) = r(1)
       y(i) = r(2)
    end do

  end subroutine affine_array


! --- projections ---

  subroutine gproj(proj, acen,dcen, a, d, u,v)

    interface
       subroutine proj(a,d,a0,d0,u,v)
         implicit none
         integer, parameter :: dp = selected_real_kind(15)
         real(dp),intent(in) :: a,d,a0,d0
         real(dp),intent(out) :: u,v
       end subroutine proj
    end interface
    
    real(dbl), intent(in) :: acen,dcen
    real(dbl), dimension(:),intent(in) :: a,d
    real(dbl), dimension(:),intent(out) :: u,v
    integer :: i

    do i = 1, size(a)
       call proj(a(i),d(i),acen,dcen,u(i),v(i))
    end do

  end subroutine gproj

  subroutine invgproj(invproj, acen,dcen, u, v, a,d)

    interface
       subroutine invproj(a,d,a0,d0,u,v)
         implicit none
         integer, parameter :: dp = selected_real_kind(15)
         real(dp),intent(in) :: a,d,a0,d0
         real(dp),intent(out) :: u,v
       end subroutine invproj
    end interface
    
    real(dbl), intent(in) :: acen,dcen
    real(dbl), dimension(:),intent(in) :: u,v
    real(dbl), dimension(:),intent(out) :: a,d
    integer :: i

    do i = 1, size(a)
       call invproj(u(i),v(i),acen,dcen,a(i),d(i))
    end do

  end subroutine invgproj


end module astrotrafo

!
!  Read catalogue
!
!
!  Copyright © 2016-20 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

!  *  proper motion is omited


module catio

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

contains

  subroutine catalogue(cat,labels,alpha,delta,mag,catid)

    use titsio

    character(len=*), intent(in) :: cat
    character(len=*), dimension(:), intent(in) :: labels
    real(dbl), dimension(:), allocatable, intent(out) :: alpha,delta,mag
    character(len=*), intent(out) :: catid

    real(dbl), parameter :: nullval = 99.99999

    integer :: nrows, srows, status, i, l, frow
    integer, dimension(size(labels)) :: cols
    logical :: anyf
    type(fitsfiles) :: fits

    status = 0

    ! open and move to a table extension
    call fits_open_table(fits,cat,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read a table in the file `',trim(cat),"'."
       stop 'CATSIO'
    end if

    call fits_get_num_rows(fits,nrows,status)
    if( status /= 0 ) goto 666
    if( nrows == 0 ) stop 'catio: no stars available.'

    ! define reference frame and identification of catalogue
    call fits_read_key(fits,'EXTNAME',catid,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       catid = ''
       status = 0
    end if

    ! find columns by labels
    do i = 1, size(labels)
       call fits_get_colnum(fits,.true.,labels(i),cols(i),status)
    end do
    if( status /= 0 ) goto 666

    allocate(alpha(nrows),delta(nrows),mag(nrows))

    call fits_get_rowsize(fits,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_read_col(fits,cols(1),frow,nullval,alpha(i:l),anyf,status)
       call fits_read_col(fits,cols(3),frow,nullval,delta(i:l),anyf,status)
       call fits_read_col(fits,cols(5),frow,nullval,mag(i:l),anyf,status)
       if( status /= 0 ) goto 666
    end do

    call fits_close_file(fits,status)
    return

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    if( allocated(mag) ) deallocate(mag,alpha,delta)

    stop 'CATSIO'

  end subroutine catalogue

end module catio

!
!  FITS tool for timeseries
!
!  Copyright © 2018 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

module fitsts

  use titsio
  use iso_fortran_env

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl

  type :: TSFits
     character(len=FLEN_FILENAME) :: filename
     character(len=FLEN_VALUE) :: dateobs = ''
     character(len=FLEN_VALUE), dimension(:), allocatable :: &
          headkeys, headvals, cols, units, keyunits
     character, dimension(:), allocatable :: keytype
     character(len=FLEN_VALUE), dimension(2) :: ctype
     real(dbl), dimension(2) :: crval, crpix, crerr, geo
     real(dbl), dimension(2,2) :: cd
     real(dbl), dimension(:,:), allocatable :: data
     logical, dimension(:), allocatable :: valid
     real :: exptime = -1
     real :: scale = 0, hwhm = 1
     integer :: year
     real(dbl) :: jd = 2451545.0_dbl   ! J2000.0
     real(dbl) :: azimuth = 0, zenitd = 0, airmass = 1
     logical :: status = .false.
     logical :: cmatch = .true.
     logical :: key_found = .true.
   contains
     procedure :: Load
     procedure, nopass, private :: FitsOpen
     procedure, private :: updatejd
     procedure :: gettime
     procedure :: gettol
     procedure, private :: updatehorizon
     procedure, private :: updateairmass
     procedure, private :: crossmatch
     procedure :: report
  end type TSFits

  private :: tits_read_key

contains

  subroutine Load(this,filename,extname,fitskeys,headkeys,coonames,cootype, &
       colnames,tolerance,cfits,verbose)

    use fitscat

    class(TSFits) :: this
    character(len=*), intent(in) :: filename, extname, cootype
    character(len=*), dimension(:), intent(in) :: fitskeys, headkeys, &
         coonames,colnames
    real(dbl) :: tolerance
    type(CatFits), intent(in) :: cfits
    logical, intent(in) :: verbose

    real(dbl), dimension(:,:), allocatable :: coo, data

    call FitsOpen(this,filename,extname,fitskeys,headkeys,coonames,cootype, &
         colnames,coo,data,verbose)
    if( .not. this%status ) return

    call this%updatejd
    call this%updatehorizon
    call this%updateairmass

    ! select stars
    block
      character(len=80) :: msg
      character(len=3) :: units
      integer, dimension(:), allocatable :: idx
      real(dbl), dimension(:), allocatable :: xref,yref
      integer :: i,j,n,stat,ncols
      real(dbl) :: tol

      n = size(cfits%coo,1)
      ncols = size(colnames)
      allocate(this%data(n,ncols),this%valid(n),xref(n),yref(n),idx(n), &
           stat=stat,errmsg=msg)
      if( stat /= 0 ) then
         write(error_unit,*) trim(msg)
         error stop 'Failed to allocate images.'
      end if

      tol = this%gettol(cootype,tolerance)
      call cfits%getcurrent(this%jd,xref,yref) ! coordinates at current time
      call this%crossmatch(cootype,tol,xref,yref,coo(:,1),coo(:,2),idx)

      if( cootype == 'RECT' ) then
         units = 'pix'
      else
         units = 'deg'
      end if

      do i = 1, size(idx)
         j = idx(i)
         if( j > 0 ) then
            this%data(i,:) = data(j,:)
            this%valid(i) = .true.
         else
            this%cmatch = .false.
            this%data(i,:) = 0 !data_undefined
            this%valid(i) = .false.
            if( verbose ) then
               write(error_unit,'(2a,2(f0.3,1x),a,es8.1,2a)') &
                    trim(filename),': * @ ',xref(i),yref(i), &
                    'not found (>',tol,units,').'
            end if
         end if
      end do
    end block

  end subroutine Load

  subroutine FitsOpen(fits,filename,extname,fitskeys,headkeys,coonames, &
       cootype,colnames,coo,data,verbose)

    type(TSFits),intent(out) :: fits
    character(len=*), intent(in) :: filename, extname, cootype
    character(len=*), dimension(:), intent(in) :: fitskeys, headkeys, &
         coonames,colnames
    real(dbl), dimension(:,:), allocatable, intent(out) :: coo, data
    logical, intent(in) :: verbose

    real(REAL64), parameter :: null = real(0.0,REAL64)
    logical, dimension(size(headkeys)) :: headkey_found
    integer, parameter :: extver = 0
    character(len=FLEN_KEYWORD) :: key
    character(len=80) :: msg
    real(dbl) :: sqscale
    integer :: i, ncols, nrows, ndata, colnum, status, stat
    type(fitsfiles) :: fitsfile
    logical :: anyf

    status = 0
    fits%filename = filename
    allocate(fits%cols, source=colnames)
    allocate(fits%units, source=colnames)
    allocate(fits%headvals, source=headkeys)
    allocate(fits%keytype, source=headkeys)
    allocate(fits%keyunits, source=headkeys)
    allocate(fits%headkeys, source=headkeys)
    fits%units = ''
    fits%headvals = ''
    fits%keytype = 'C'
    fits%keyunits = ''
    headkey_found = .true.

    call fits_open_image(fitsfile,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) 'Error: failed to read the file `',trim(filename),"'."
       fits%status = .false.
       return
    end if

    ! read date and time, dateobs
    call fits_write_errmark
    call fits_get_dateobs(fitsfile,fitskeys(1:2),fits%dateobs,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       call fits_clear_errmark
       if( verbose ) write(error_unit,*) 'Warning: Date of observation by ', &
            trim(fitskeys(1)),',',trim(fitskeys(2)),' keywords not found.'
       status = 0
       fits%dateobs = ''
    end if

    ! exposure time
    call fits_write_errmark
    call fits_read_key(fitsfile,fitskeys(3),fits%exptime,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       call fits_clear_errmark
       if( verbose ) write(error_unit,*) &
            'Warning: Exposure time by ',trim(fitskeys(3)),' keyword not found.'
       status = 0
       fits%exptime = -1
    end if

    if( cootype == 'EQT' ) then

       call fits_read_wcs(fitsfile,fits%ctype,fits%crval,fits%crpix,fits%cd,&
            fits%crerr,status)
       if( status == 0 ) then
          sqscale = fits%cd(1,1)**2 + fits%cd(1,2)**2
          if( sqscale > 0 )then
             fits%scale = real(1.0 / sqrt(sqscale))
          else
             fits%scale = 0
          end if
       end if

    else ! if( cootype == 'RECT' ) then
       fits%ctype = ''
       fits%crval = 0
       fits%crpix = 0
       fits%cd = 0
       fits%crerr = 0
    end if

    ! geographical coordinates
    call fits_write_errmark
    call fits_read_key(fitsfile,fitskeys(4),fits%geo(1),status)
    call fits_read_key(fitsfile,fitskeys(5),fits%geo(2),status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       call fits_clear_errmark
       if( verbose ) write(error_unit,*) 'Warning: Geographic coordinates by ',&
            trim(fitskeys(4)),",",trim(fitskeys(5)),' keywords not found.'
       status = 0
       fits%geo = 0
    end if

    ! user required keywords
    call fits_write_errmark
    do i = 1, size(headkeys)

       call tits_read_key(fitsfile,headkeys(i),fits%headvals(i),fits%keyunits(i),&
            fits%keytype(i),status)
       headkey_found(i) = status == 0
       if( status == FITS_KEYWORD_NOT_FOUND ) then
          fits%headvals(i) = ''
          fits%keyunits(i) = ''
          fits%keytype(i) = 'C'
          status = 0
       end if

    end do
    call fits_clear_errmark

    ! select data extension
    call fits_write_errmark
    call fits_movnam_hdu(fitsfile,FITS_BINARY_TBL,extname,extver,status)
    if( status == FITS_BAD_HDU_NUM ) then
       call fits_clear_errmark
       if( verbose .and. size(colnames) > 0 ) write(error_unit,*)  &
            "Warning: A photometry extension is unavailable: ",trim(filename)
       goto 666
    end if

    call fits_write_errmark
    call fits_read_key(fitsfile,FITS_KEY_HWHM,fits%hwhm,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       call fits_clear_errmark
       status = 0
       fits%hwhm = 1
    end if

    ! user required keywords
    call fits_write_errmark
    do i = 1, size(headkeys)

       ! if the same keyword has been already found in any previous HDU,
       ! it is omitted
       if( .not. headkey_found(i) ) then
          call tits_read_key(fitsfile,headkeys(i),fits%headvals(i),fits%keyunits(i),&
               fits%keytype(i),status)
          headkey_found(i) = status == 0
          if( status == FITS_KEYWORD_NOT_FOUND ) then
             fits%headvals(i) = ''
             fits%keyunits(i) = ''
             fits%keytype(i) = 'C'
             status = 0
          end if
       end if
    end do
    call fits_clear_errmark

    ! read table data
    ncols = size(coonames)
    ndata = size(colnames)

    call fits_get_num_rows(fitsfile,nrows,status)
    if( status /= 0 ) goto 666

    ! units
    call fits_write_errmark
    do i = 1, ndata
       call fits_get_colnum(fitsfile,.true.,colnames(i),colnum,status)
       call fits_make_keyn('TUNIT',colnum,key,status)
       call fits_read_key(fitsfile,key,fits%units(i),status)
       if( status == FITS_KEYWORD_NOT_FOUND ) then
          fits%units(i) = ''
          status = 0
       end if
    end do
    call fits_clear_errmark

    allocate(coo(nrows,ncols),data(nrows,ndata),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) trim(msg)
       error stop 'Failed to allocate volume for data.'
    end if

    do i = 1, ncols
       call fits_get_colnum(fitsfile,.true.,coonames(i),colnum,status)
       call fits_read_col(fitsfile,colnum,1,null,coo(:,i),anyf,status)
    end do

    do i = 1, ndata
       call fits_get_colnum(fitsfile,.true.,colnames(i),colnum,status)
       call fits_read_col(fitsfile,colnum,1,null,data(:,i),anyf,status)
    end do

666 continue

    call fits_close_file(fitsfile,status)
    call fits_report_error(error_unit,status)

    fits%status = status == 0
    fits%key_found = all(headkey_found .eqv. .true.)

    ! inform user when any keyword is empty
    if( verbose .and. .not. fits%key_found ) then
       write(error_unit,'(a)',advance='no') 'Warning: keys not found: '
       do i = 1, size(headkeys)
          if( .not. headkey_found(i) ) &
               write(error_unit,"(a,' ')",advance='no') trim(headkeys(i))
       end do
       write(error_unit,*)
    end if

  end subroutine FitsOpen

  subroutine updatejd(fits)

    use trajd

    class(TSFits) :: fits
    integer ::year, month, day, hour, minute
    real(dbl) :: second, d
    integer :: status

    if( fits%dateobs /= '' ) then

       ! decode date-time string
       status = 0
       call fits_str2date(fits%dateobs,year,month,day, &
            hour,minute,second,status)
       if( status /= 0 ) return

       ! Evaluate Julian date
       d = day + (hour + (minute + second/60.0_dbl) / 60.0_dbl) / 24.0_dbl
       fits%jd = datjd(real(year,dbl),real(month,dbl),d)
       fits%year = year

    end if

  end subroutine updatejd


  function gettime(fits,timetype,timestamp,min0,per) result(t)

    use trajd
    use astrosphere

    class(TSFits), intent(in) :: fits
    character(len=*), intent(in) :: timetype, timestamp
    real(dbl), intent(in) :: min0,per

    real(dbl) :: t,jd,etime,ls,d

    if( fits%dateobs /= '' ) then

       jd = fits%jd

       ! time-stamps
       if( fits%exptime >= 0) then

          etime = fits%exptime / 86400.0_dbl
          if( timestamp == 'MID' ) then
             jd = jd + etime / 2.0_dbl
          else if ( timestamp == 'END' ) then
             jd = jd + etime
          end if

       end if

       ! time (-like) determination

       if( timetype == 'JD' ) then
          t = jd
       else if( timetype == 'MJD' ) then
          t = mjd(jd)
       else if( timetype == 'HJD' ) then
          d = jd - datjd(real(fits%year,dbl),1.0_dbl,1.0_dbl)
          ls = longsun(d)
          t = hjd(jd,helcor(fits%crval(1),fits%crval(2),ls))
       else if( timetype == 'PHASE' ) then
          t = phase(jd,min0,per)
       else
          t = 0
       end if

    else
       t = 0
    end if

  end function gettime

  function gettol(fits,cootype,tolerance) result(tol)

    class(TSFits), intent(in) :: fits
    character(len=*), intent(in) :: cootype
    real(dbl), intent(in) :: tolerance

    real(dbl) :: tol

    if( cootype == 'EQT' ) then
       if( tolerance > 0 ) then
          tol = tolerance
       else if( maxval(fits%crerr) > 0 .and. fits%scale > 0 ) then
          ! If tol is not given, maximum of both astrometry error
          ! and pixel size is used. We are suppose that user
          ! specifies coordinates of objects with corresponding
          ! precision.
          tol = 5*max(maxval(fits%crerr),1/fits%scale)
       else if( fits%hwhm > 0 .and. fits%scale > 0 ) then
          tol = 5*fits%hwhm / fits%scale
       else if( fits%scale > 0 ) then !
          tol = 5/fits%scale
       else ! fail-back, 1 arcsec
          tol = 1.0 / 3600.0
       end if
    else if( cootype == 'RECT' ) then
       if( tolerance > 0 ) then
          tol = tolerance
       else
          tol = 5 ! pixels
       end if
    else
       write(error_unit,*) 'Error: tolerance is unset.'
    end if

  end function gettol

  subroutine updatehorizon(fits)

    use astrosphere

    class(TSFits) :: fits
    real(dbl) :: ra, dec, t, ha, a, h, longitude, latitude

    ra = fits%crval(1)
    dec = fits%crval(2)
    longitude = fits%geo(1)
    latitude = fits%geo(2)
    t = lmst(fits%jd,longitude)
    ha = hangle(15*t, ra)
    call eq2hor(ha, dec, latitude, a, h)
    fits%azimuth = a
    fits%zenitd = real(90.0,dbl) - h

  end subroutine updatehorizon

  subroutine updateairmass(fits)

    use astrosphere

    class(TSFits) :: fits

    fits%airmass = airmass(fits%zenitd)

  end subroutine updateairmass


  subroutine crossmatch(fits,cootype,tol,u,v,x,y,idx)

    ! Returns idx with valid elements > 0 if the given
    ! reference object (u,v) has been found at coordinates (x,y).
    ! The search is made inside a circle with tol radius.
    ! A closer object is selected when multiple objects falls
    ! into the circle.

    class(TSFits), intent(in) :: fits
    character(len=*), intent(in) :: cootype
    real(dbl), intent(in) :: tol
    real(dbl), dimension(:), intent(in) :: u,v,x,y
    integer, dimension(:), intent(out) :: idx

    real(dbl) :: g, rmin, r, dx, dy
    integer :: i, j

    idx = -1

    ! crossmatch is based on distance
    ! metrics for rectangular coordinates is
    !  dr**2 = dx**2 + dy**2
    ! while for spherical
    !  dr**2 = dalpha**2*cos(delta)**2 + ddelta**2
    ! the metric works satisfactory for small angular differences
    if( cootype == 'EQT' ) then
       g = cos(fits%crval(2)/rad)
    else
       g = 1
    end if
    do i = 1, size(u)
       rmin = tol
       do j = 1,size(x)
          dx = u(i) - x(j)
          dy = v(i) - y(j)
          r = hypot(dx*g, dy)
          if( r < rmin ) then
             rmin = r
             idx(i) = j
          end if
       end do
    end do

  end subroutine crossmatch


  subroutine report(fits,timetype,timestamp,lc_epoch,lc_period, &
       printname,printtime,printhorizon,printairmass)

    class(TSFits), intent(in) :: fits
    character(len=*), intent(in) :: timetype, timestamp
    real(dbl), intent(in) :: lc_epoch,lc_period
    logical, intent(in) :: printname, printtime, printhorizon, printairmass

    real(dbl), dimension(:,:), allocatable :: data
    character(len=666) :: fmt = "", form = ""
    integer :: i,n,m
    real(dbl) :: tm


    ! filename
    if( printname ) write(*,'(a,1x)',advance="no") trim(fits%filename)

    ! time
    if( printtime ) then
       tm = fits%gettime(timetype,timestamp,lc_epoch,lc_period)
       write(*,'(f0.10,1x)',advance="no") tm
    end if

    ! header values
    if( allocated(fits%headvals) ) then
       associate( vals => fits%headvals )
         if( size(vals) > 0 ) then
            write(fmt,'(a,i0,a)') '(',size(vals),'(a,1x))'
            write(*,fmt,advance="no") (trim(vals(i)),i=1,size(vals))
         end if
       end associate
    end if

    ! horizontal coordinates and airmass
    if( printhorizon ) &
       write(*,'(2(f0.10,1x))',advance="no") fits%azimuth,fits%zenitd
    if( printairmass ) &
       write(*,'(f0.10,1x)',advance="no") fits%airmass

    if( allocated(fits%data) ) then

       n = size(fits%data,1) ! objects
       m = size(fits%data,2) ! columns

       if( m > 0 .and. n > 0 ) then

          ! format for one object derived by columns
          fmt = ''
          do i = 1, m
             if( index(fits%cols(i),'MAG') > 0 ) then
                fmt = trim(fmt) // 'f0.5'
             else
                fmt = trim(fmt) // 'g0'
             end if
             fmt = trim(fmt) // ',1x'
             if( i < m ) fmt = trim(fmt) // ','
          end do
          write(form,'(a,i0,3a)') '(1x,',n,'(',trim(fmt),'))'

          ! temporary memoty is allocated due undefined values
          allocate(data(n,m))
          data = fits%data
          do i = 1, n
             if( .not. fits%valid(i) ) then
                where( fits%cols == 'MAG' )
                   data(i,:) = 99.999
                elsewhere( fits%cols == 'MAGERR' )
                   data(i,:) = 9.999
                elsewhere
                   data(i,:) = huge(data)*0
                end where
             end if
          end do
          write(*,form,advance="no") (data(i,:),i=1,n)

       end if
    end if
    write(*,*)

  end subroutine report

  subroutine tits_read_key(fitsfile,key,value,units,type,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: key
    character(len=*), intent(out) :: value,units,type
    integer, intent(in out) :: status

    character(len=FLEN_COMMENT) :: com
    character(len=FLEN_VALUE) :: val

    call fits_read_key(fitsfile,key,value,status)
    if( status == 0 ) then
       call fits_read_key_unit(fitsfile,key,units,status)
       call fits_read_keyword(fitsfile,key,val,com,status)
       call fits_get_keytype(val,type,status)
    else
       value = ''
       units = ''
       type = 'C'
    end if

  end subroutine tits_read_key

end module fitsts

!
!  Fortran 90+ interface for Minpack
!
!  Copyright © 2010, 2013 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!  
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!  
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

module minpack

  implicit none

  ! precision for double real
  integer, parameter, private :: dbl = selected_real_kind(15)

  interface

     subroutine chkder(m,n,x,fvec,fjac,ldfjac,xp,fvecp,mode,err)
       integer, parameter :: dbl = selected_real_kind(15)
       integer, intent(in) :: m,n,ldfjac,mode
       real(dbl) :: x(n),fvec(m),fjac(ldfjac,n),xp(n),fvecp(m),err(m)
     end subroutine chkder

     subroutine covar(n,r,ldr,ipvt,tol,wa)
       ! it should be not available in all distributions (Debian)
       integer, parameter :: dbl = selected_real_kind(15)
       integer, intent(in) ::  n,ldr
       integer::  ipvt(n)
       real(dbl) :: tol
       real(dbl) :: r(ldr,n),wa(n)
     end subroutine covar

     subroutine dmchar(ibeta,it,irnd,ngrd,machep,negep,iexp,minexp, &
          maxexp,eps,epsneg,xmin,xmax)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: i,ibeta,iexp,irnd,it,iz,j,k,machep,maxexp,minexp, &
            mx,negep,ngrd
       real(dbl) :: a,b,beta,betain,betam1,eps,epsneg,one,xmax, &
            xmin,y,z,zero
     end subroutine dmchar

     subroutine dogleg(n,r,lr,diag,qtb,delta,x,wa1,wa2)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,lr
       real(dbl) :: delta
       real(dbl) :: r(lr),diag(n),qtb(n),x(n),wa1(n),wa2(n)
     end subroutine dogleg

     function dpmpar(i)
       integer, parameter :: dbl = selected_real_kind(15)
       real(dbl) :: dpmpar
       integer, intent(in) :: i
     end function dpmpar
     
     function enorm(n,x)
       integer, parameter :: dbl = selected_real_kind(15)
       integer, intent(in) :: n
       real(dbl) :: enorm,x(n)
     end function enorm

     subroutine errjac(n,x,fjac,ldfjac,nprob)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,ldfjac,nprob
       real(dbl) :: x(n),fjac(ldfjac,n)
     end subroutine errjac

     subroutine fdjac1(fcn,n,x,fvec,fjac,ldfjac,iflag,ml,mu,epsfcn,wa1,wa2)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,ldfjac,iflag,ml,mu
       real(dbl) :: epsfcn
       real(dbl) :: x(n),fvec(n),fjac(ldfjac,n),wa1(n),wa2(n)
       interface
          subroutine fcn(n,x,fvec,iflag)
            integer, parameter :: dbl = selected_real_kind(15)
            integer, intent(in) :: n
            integer, intent(in out) :: iflag
            real(dbl), dimension(n), intent(in) :: x
            real(dbl), dimension(n), intent(out) :: fvec
          end subroutine fcn
       end interface
     end subroutine fdjac1

     subroutine fdjac2(fcn,m,n,x,fvec,fjac,ldfjac,iflag,epsfcn,wa)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,ldfjac,iflag
       real(dbl) :: epsfcn
       real(dbl) :: x(n),fvec(m),fjac(ldfjac,n),wa(m)
       interface
          subroutine fcn(m,n,x,fvec,iflag)
            integer, parameter :: dbl = selected_real_kind(15)
            integer, intent(in) :: m,n
            integer, intent(in out) :: iflag
            real(dbl), dimension(n), intent(in) :: x
            real(dbl), dimension(m), intent(out) :: fvec
          end subroutine fcn
       end interface
     end subroutine fdjac2

     subroutine grdfcn(n,x,g,nprob)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,nprob
       real(dbl) :: x(n),g(n)
     end subroutine grdfcn

     subroutine hesfcn(n,x,h,ldh,nprob)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,ldh,nprob
       real(dbl) :: x(n),h(ldh,n)
     end subroutine hesfcn

     subroutine initpt(n,x,nprob,factor)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,nprob
       real(dbl) :: factor
       real(dbl) :: x(n)
     end subroutine initpt

     subroutine hybrd(fcn,n,x,fvec,xtol,maxfev,ml,mu,epsfcn,diag, &
          mode,factor,nprint,info,nfev,fjac,ldfjac,r,lr, &
          qtf,wa1,wa2,wa3,wa4)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,maxfev,ml,mu,mode,nprint,info,nfev,ldfjac,lr
       real(dbl) :: xtol,epsfcn,factor
       real(dbl) :: x(n),fvec(n),diag(n),fjac(ldfjac,n),r(lr), &
            qtf(n),wa1(n),wa2(n),wa3(n),wa4(n)
       interface
          subroutine fcn(n,x,fvec,iflag)
            integer, parameter :: dbl = selected_real_kind(15)
            integer, intent(in) :: n
            integer, intent(in out) :: iflag
            real(dbl), dimension(n), intent(in) :: x
            real(dbl), dimension(n), intent(out) :: fvec
          end subroutine fcn
       end interface
     end subroutine hybrd

     subroutine hybrd1(fcn,n,x,fvec,tol,info,wa,lwa)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,info,lwa
       real(dbl) :: tol
       real(dbl) :: x(n),fvec(n),wa(lwa)
       interface
          subroutine fcn(n,x,fvec,iflag)
            integer, parameter :: dbl = selected_real_kind(15)
            integer, intent(in) :: n
            integer, intent(in out) :: iflag
            real(dbl), dimension(n), intent(in) :: x
            real(dbl), dimension(n), intent(out) :: fvec
          end subroutine fcn
       end interface
     end subroutine hybrd1

     subroutine hybrj(fcn,n,x,fvec,fjac,ldfjac,xtol,maxfev,diag,mode, &
          factor,nprint,info,nfev,njev,r,lr,qtf,wa1,wa2, &
          wa3,wa4)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,ldfjac,maxfev,mode,nprint,info,nfev,njev,lr
       real(dbl) :: xtol,factor
       real(dbl) :: x(n),fvec(n),fjac(ldfjac,n),diag(n),r(lr), &
            qtf(n),wa1(n),wa2(n),wa3(n),wa4(n)
       interface
          subroutine fcn(n,x,fvec,fjac,ldfjac,iflag)
            integer, parameter :: dbl = selected_real_kind(15)
            integer, intent(in) :: n, ldfjac
            integer, intent(in out) :: iflag
            real(dbl), dimension(n), intent(in) :: x
            real(dbl), dimension(n), intent(out) :: fvec
            real(dbl), dimension(ldfjac,n), intent(out) :: fjac
          end subroutine fcn
       end interface
     end subroutine hybrj

     subroutine hybrj1(fcn,n,x,fvec,fjac,ldfjac,tol,info,wa,lwa)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,ldfjac,info,lwa
       real(dbl) :: tol
       real(dbl) :: x(n),fvec(n),fjac(ldfjac,n),wa(lwa)
       interface
          subroutine fcn(n,x,fvec,fjac,ldfjac,iflag)
            integer, parameter :: dbl = selected_real_kind(15)
            integer, intent(in) :: n, ldfjac
            integer, intent(in out) :: iflag
            real(dbl), dimension(n), intent(in) :: x
            real(dbl), dimension(n), intent(out) :: fvec
            real(dbl), dimension(ldfjac,n), intent(out) :: fjac
          end subroutine fcn
       end interface
     end subroutine hybrj1
     
     subroutine lmder(fcn,m,n,x,fvec,fjac,ldfjac,ftol,xtol,gtol, &
          maxfev,diag,mode,factor,nprint,info,nfev,njev, &
          ipvt,qtf,wa1,wa2,wa3,wa4)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,ldfjac,maxfev,mode,nprint,info,nfev,njev
       integer :: ipvt(n)
       real(dbl) :: ftol,xtol,gtol,factor
       real(dbl) :: x(n),fvec(m),fjac(ldfjac,n),diag(n),qtf(n), &
            wa1(n),wa2(n),wa3(n),wa4(m)
       interface
          subroutine fcn(m,n,x,fvec,fjac,ldfjac,iflag)
            integer, parameter :: dbl = selected_real_kind(15)
            integer, intent(in) :: n, m, ldfjac
            integer, intent(in out) :: iflag
            real(dbl), dimension(n), intent(in) :: x
            real(dbl), dimension(m), intent(out) :: fvec
            real(dbl), dimension(ldfjac,n), intent(out) :: fjac
          end subroutine fcn
       end interface
     end subroutine lmder

     subroutine lmder1(fcn,m,n,x,fvec,fjac,ldfjac,tol,info,ipvt,wa,lwa)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,ldfjac,info,lwa
       integer :: ipvt(n)
       real(dbl) :: tol
       real(dbl) :: x(n),fvec(m),fjac(ldfjac,n),wa(lwa)
       interface
          subroutine fcn(m,n,x,fvec,fjac,ldfjac,iflag)
            integer, parameter :: dbl = selected_real_kind(15)
            integer, intent(in) :: n, m, ldfjac
            integer, intent(in out) :: iflag
            real(dbl), dimension(n), intent(in) :: x
            real(dbl), dimension(m), intent(out) :: fvec
            real(dbl), dimension(ldfjac,n), intent(out) :: fjac
          end subroutine fcn
       end interface
     end subroutine lmder1
 
     subroutine lmdif(fcn,m,n,x,fvec,ftol,xtol,gtol,maxfev,epsfcn, &
          diag,mode,factor,nprint,info,nfev,fjac,ldfjac, &
          ipvt,qtf,wa1,wa2,wa3,wa4)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,maxfev,mode,nprint,info,nfev,ldfjac
       integer :: ipvt(n)
       real(dbl) :: ftol,xtol,gtol,epsfcn,factor
       real(dbl) :: x(n),fvec(m),diag(n),fjac(ldfjac,n),qtf(n), &
            wa1(n),wa2(n),wa3(n),wa4(m)
       interface
          subroutine fcn(m,n,x,fvec,iflag)
            integer, parameter :: dbl = selected_real_kind(15)
            integer, intent(in) :: n, m
            integer, intent(in out) :: iflag
            real(dbl), dimension(n), intent(in) :: x
            real(dbl), dimension(m), intent(out) :: fvec
          end subroutine fcn
       end interface
     end subroutine lmdif

     subroutine lmdif1(fcn,m,n,x,fvec,tol,info,iwa,wa,lwa)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,info,lwa
       integer :: iwa(n)
       real(dbl) :: tol
       real(dbl) :: x(n),fvec(m),wa(lwa)
       interface
          subroutine fcn(m,n,x,fvec,iflag)
            integer, parameter :: dbl = selected_real_kind(15)
            integer, intent(in) :: n, m
            integer, intent(in out) :: iflag
            real(dbl), dimension(n), intent(in) :: x
            real(dbl), dimension(m), intent(out) :: fvec
          end subroutine fcn
       end interface
     end subroutine lmdif1
     
     subroutine lmpar(n,r,ldr,ipvt,diag,qtb,delta,par,x,sdiag,wa1,wa2)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,ldr
       integer :: ipvt(n)
       real(dbl) :: delta,par
       real(dbl) :: r(ldr,n),diag(n),qtb(n),x(n),sdiag(n),wa1(n),wa2(n)
     end subroutine lmpar

     subroutine lmstr(fcn,m,n,x,fvec,fjac,ldfjac,ftol,xtol,gtol, &
          maxfev,diag,mode,factor,nprint,info,nfev,njev, &
          ipvt,qtf,wa1,wa2,wa3,wa4)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,ldfjac,maxfev,mode,nprint,info,nfev,njev
       integer :: ipvt(n)
       logical :: sing
       real(dbl) :: ftol,xtol,gtol,factor
       real(dbl) :: x(n),fvec(m),fjac(ldfjac,n),diag(n),qtf(n), &
            wa1(n),wa2(n),wa3(n),wa4(m)
       interface
          subroutine fcn(m,n,x,fvec,fjrow,iflag)
            integer, parameter :: dbl = selected_real_kind(15)
            integer, intent(in) :: n, m
            integer, intent(in out) :: iflag
            real(dbl), dimension(:), intent(in) :: x
            real(dbl), dimension(:), intent(out) :: fvec, fjrow
          end subroutine fcn
       end interface
     end subroutine lmstr

     subroutine lmstr1(fcn,m,n,x,fvec,fjac,ldfjac,tol,info,ipvt,wa,lwa)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,ldfjac,info,lwa
       integer :: ipvt(n)
       real(dbl) :: tol
       real(dbl) :: x(n),fvec(m),fjac(ldfjac,n),wa(lwa)
       interface
          subroutine fcn(m,n,x,fvec,fjrow,iflag)
            integer, parameter :: dbl = selected_real_kind(15)
            integer, intent(in) :: n, m
            integer, intent(in out) :: iflag
            real(dbl), dimension(:), intent(in) :: x
            real(dbl), dimension(:), intent(out) :: fvec, fjrow
          end subroutine fcn
       end interface
     end subroutine lmstr1

     subroutine objfcn(n,x,f,nprob)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,nprob
       real(dbl) :: f
       real(dbl) :: x(n)
     end subroutine objfcn

     subroutine qform(m,n,q,ldq,wa)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,ldq
       real(dbl) :: q(ldq,m),wa(m)
     end subroutine qform

     subroutine qrfac(m,n,a,lda,pivot,ipvt,lipvt,rdiag,acnorm,wa)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,lda,lipvt
       integer :: ipvt(lipvt)
       logical :: pivot
       real(dbl) :: a(lda,n),rdiag(n),acnorm(n),wa(n)
     end subroutine qrfac

     subroutine qrsolv(n,r,ldr,ipvt,diag,qtb,x,sdiag,wa)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,ldr
       integer :: ipvt(n)
       real(dbl) :: r(ldr,n),diag(n),qtb(n),x(n),sdiag(n),wa(n)
     end subroutine qrsolv

     subroutine r1mpyq(m,n,a,lda,v,w)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,lda
       real(dbl) :: a(lda,n),v(n),w(n)
     end subroutine r1mpyq

     subroutine r1updt(m,n,s,ls,u,v,w,sing)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,ls
       logical :: sing
       real(dbl) :: s(ls),u(m),v(n),w(m)
     end subroutine r1updt

     subroutine rwupdt(n,r,ldr,w,b,alpha,cos,sin)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,ldr
       real(dbl) :: alpha
       real(dbl) :: r(ldr,n),w(n),b(n),cos(n),sin(n)
     end subroutine rwupdt

     subroutine ssqfcn(m,n,x,fvec,nprob)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,nprob
       real(dbl) :: x(n),fvec(m)
     end subroutine ssqfcn

     subroutine ssqjac(m,n,x,fjac,ldfjac,nprob)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: m,n,ldfjac,nprob
       real(dbl) :: x(n),fjac(ldfjac,n)
     end subroutine ssqjac

     subroutine vecfcn(n,x,fvec,nprob)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,nprob
       real(dbl) :: x(n),fvec(n)
     end subroutine vecfcn

     subroutine vecjac(n,x,fjac,ldfjac,nprob)
       integer, parameter :: dbl = selected_real_kind(15)
       integer :: n,ldfjac,nprob
       real(dbl) :: x(n),fjac(ldfjac,n)
     end subroutine vecjac

  end interface

end module minpack

!
!  Light curves
!
!  Copyright © 2017-9 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module lcurves

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: pi = 3.1415926535897931_dbl

  type SplineSerieType
     real(dbl), dimension(:), allocatable :: time
     real(dbl), dimension(:,:), allocatable :: taaux
   contains
     procedure :: Init, Spline
  end type SplineSerieType

contains

  function wave(phi)

    real(dbl), intent(in) :: phi
    real(dbl) :: wave

    wave = cos(2*pi*phi) + 1

  end function wave

  ! delta Cep

  function delta_cep(phi)

    use lcparams

    real(dbl), intent(in) :: phi
    real(dbl) :: delta_cep

    delta_cep = fourfun(dcep,phi)

  end function delta_cep

  function beta_per(phi)

    use lcparams

    real(dbl), intent(in) :: phi
    real(dbl) :: beta_per

    beta_per = fourfun(algol,phi)

  end function beta_per

  function fourfun(c,phi)

    complex(dbl), dimension(0:), intent(in) :: c
    real(dbl), intent(in) :: phi
    real(dbl) :: fourfun,t
    complex(dbl) :: s,u,w
    integer :: j

    t = 2*pi*phi
    w = cmplx(cos(t),-sin(t),dbl)
    u = cmplx(1.0_dbl,0.0_dbl,dbl)
    s = 0.0_dbl
    do j = 0,size(c)-1
       s = s + c(j)*u
       u = u * w
    end do
    fourfun = real(s)

  end function fourfun


  subroutine Init(this,x,y,dy,sopt)

    class(SplineSerieType) :: this
    integer, parameter :: dbl = selected_real_kind(15)
    real(dbl), dimension(:), intent(in) :: x
    real(dbl), dimension(:), intent(in) :: y,dy
    real(dbl), intent(in) :: sopt

    real(dbl), external :: smooth
    real(dbl), dimension(:,:), allocatable :: aux, aaux

    integer :: n
    real(dbl) :: w,s,dnoise

    n = size(x)
    allocate(aux(n,7),aaux(n,4))
    allocate(this%time(n),this%taaux(4,n))

    ! approximate it
    dnoise = 1e-6       ! minimal error for spline fit (and display)

    ! interpolation
    s = epsilon(x)
    ! aproximation
    s = n

    if( sopt > 0 ) s = sopt

    w = smooth(x,y,max(dy,dnoise),size(x),s,aux,aaux)
    this%taaux = transpose(aaux(:,1:4))
    this%time = x

    ! block
    ! integer :: i
    !    open(1,file='l')
    !    do i = -100,200
    !       write(1,*) i/100.0,real(lcspline(i/100.0_dbl))
    !    end do
    !    close(1)
    ! end block

    deallocate(aux,aaux)

  end subroutine Init

  function Spline(this,t) result(f)

    class(SplineSerieType) :: this
    real(dbl), intent(in) :: t
    real(dbl) :: f
    integer :: n1
    real(dbl), external :: ppvalu

    n1 = size(this%time) - 1
    f = ppvalu(this%time,this%taaux,n1,4,t,0)

  end function Spline


end module lcurves

!
!  Robust construction of a growth-curve.
!
!  Copyright © 2016-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

module grow_model

  implicit none

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: pi = 3.14159265358979312_dbl

  ! assumed error of approximation by asymptote
  real(dbl), parameter, private :: approxerr = 1e-5

  ! print debug informations ?
  logical, parameter, private :: debug = .false.

!  real(dbl), dimension(:), allocatable, private :: aper,raper,cts_, dcts_, back, &
!       grow_,dgrow_, tx, fvec, dvec, radius, phix
  real(dbl), dimension(:), allocatable, private :: aper,raper,radius,grow,dgrow, sigs
  real(dbl), dimension(:,:), allocatable, private :: cts,dcts,grows,dgrows
!  real(dbl), private :: hwhm, par_a, par_b, par_e, par_c, par_t, sig, lambda, rback
!  real(dbl), private :: hwhm, sig, lambda, rback
  real(dbl), private :: hwhm, sig, lambda
  integer, private :: nhwhm, naper, nstar, nref
!  integer, private :: type

  !private :: minall, the_constructor

contains


  subroutine growmodel(xraper,xcts,xdcts,rhwhm,mhwhm,curve,dcurve)

    use oakleaf

    real, dimension(:), intent(in) :: xraper
    real(dbl), dimension(:,:), intent(in) :: xcts,xdcts
    real, intent(in) :: rhwhm
!    real(dbl), intent(in) :: skyerr
    integer, intent(in) :: mhwhm
    real(dbl), dimension(:), intent(out) :: curve,dcurve

!    real(dbl), dimension(3) :: p
!    real(dbl), dimension(size(xraper)) :: ff,aa
!    real(dbl), dimension(:), allocatable :: back1,tx1,flux0,aas,daas,betas,qs,phi,&
!         bs
    real(dbl), dimension(:), allocatable :: flux,betas,phi
!    real(dbl) :: a,b,c,e,a1,b1,e1,t,d,s,t1,dt,db,tol,q,c1,ctsback,backmed,beta
    real(dbl) :: a,b
!    real(dbl), dimension(2,2) :: mat
!    real(dbl), dimension(2) :: vec
!    integer :: i, iter, j, n, n1, n2
    integer :: i, iter, n
!    logical :: valid

    nstar = size(xcts,1)
    naper = size(xraper)
!    allocate(raper(naper),aper(naper),back(nstar),back1(nstar),cts_(naper),dcts_(naper),&
!         cts(nstar,naper),dcts(nstar,naper),grows(nstar,naper),dgrows(nstar,naper),&
!         tx(nstar),tx1(nstar),grow_(naper),dgrow_(naper),radius(naper), &
!         flux0(nstar),aas(nstar),daas(nstar),betas(nstar),qs(nstar),phi(nstar),&
!         bs(nstar),phix(nstar))
    allocate(raper(naper),aper(naper),radius(naper),flux(nstar),betas(nstar),phi(nstar),&
         cts(nstar,naper),dcts(nstar,naper),grows(nstar,naper),dgrows(nstar,naper),&
         grow(naper),dgrow(naper),sigs(nstar))

    ! apertures radii in pixels
    raper = xraper

    ! aperture areas
    aper = pi*raper**2

    ! radius is scaled to interval 0..1, to improve numerical stability
    radius = raper / raper(naper)

    cts = xcts
    dcts = xdcts
    hwhm = rhwhm
    nhwhm = mhwhm
!    tol = sqrt(epsilon(tol))
!    tol = 10*epsilon(tol)
!    tol = 1e-8
!    nref = (nhwhm + naper)/2 ! min 5 points required?
    nref = nhwhm

    ! osetript pripad, ze nstar < 3 ?



!    if( debug ) then ! write initial grows

!!$    flux0 = cts(:,nhwhm)
!!$    do i = 1,nstar
!!$       call arc_init(cts(i,:),dcts(i,:),cts(i,nhwhm),aas(i),bs(i),betas(i))
!!$    end do
!!$
!!$! nutne:   call rwmean(aas,daas,a,s)
!!$    call rmean(aas,a,s)
!!$    write(*,*) 'aas:',real(a),real(s)
!!$    call rmean(bs,b,s)
!!$    write(*,*) 'bs:',real(b),real(s)

    a = 0
    b = 0
    betas = 0
    phi = 0
    flux = cts(:,nref)

!    call arc_inits1(flux0,b,e,betas)
!    write(*,*) b
    call arc_init(flux,b)
!    call arc_init1(flux,a,b)
    if( debug ) write(*,'(a,3f15.5)') 'Very first a,b:',a,b

    !    write(*,*) flux0(1),flux0(1)*(1 + e)
!    flux0 = flux0*(1 - e)


!    do n = 1,nstar
!       do i = nref, naper
!          write(*,*) raper(i),cts(n,i)/flux(n),-a/raper(i)-b/raper(i)**2
!       end do
!    end do
!    stop
!    call rmean(tx(1:5),t,s) ! nutne rwmean
!    write(*,*) 't:',real(t),real(s)
!    stop

    flux = flux * (1 - b/raper(naper)**2) / (1 - b/raper(nref)**2)

!    phi = 0
!    a = 0.0045
!    b = 0.13
!    call anchor_inits1(flux0,a,b,e)
!    write(*,*) 1+t

!stop
!    write(*,*) flux0(1),flux0(1)*(1 - t)
!    flux0 = flux0*(1 - t)

    ! checkpoint: first estimate of arc parameters and anchor

!    t = 1 + t
    ! t anchors grow curve at nref point

    ! update flux0
    !    flux0 = flux0 * (1 + phi*0) / t

    do iter = 1,50

       ! determine beta,phi for every star
       do n = 1,nstar
          call back_update(cts(n,:),dcts(n,:),flux(n),a,b,betas(n),phi(n))
          if( debug ) &
               write(*,'(i3,2es12.2,2f15.1)') n,betas(n),phi(n),flux(n)*(1+phi(n)),flux(n)
!                 if( n == 2 ) stop
       end do

       call arc_update(flux,phi,betas,a,b)
       !call arc_update1(flux,phi,betas,b)
       if( debug ) write(*,'(a,i5,3f15.5)') 'iter,a,b:',iter,a,b
       !stop

       flux = flux*(1 + phi)

       if( all(abs(phi) < 0.1*sqrt(flux)/flux ) ) exit

    end do

    do n = 1,nstar*0
       do i = 1,naper
          write(*,*) raper(i),cts(n,i)/flux(n),cts(n,i)/flux(n)-betas(n)*aper(i), &
               i, n, 'FF'
       end do
    end do

    ! grow curve
    do i = naper,nref,-1
       curve(i) = 1 - (a/raper(i) + b/raper(i)**2)
       do n = 1,nstar
          grows(n,i) = cts(n,i)/flux(n) - betas(n)*aper(i)
          dgrows(n,i) = grows(n,i) * (dcts(n,i) / cts(n,i))
       end do
       call rmean(grows(:,i),dgrows(:,i),grow(i),dgrow(i))
       dcurve(i) = dgrow(i)
       if( debug ) write(*,'(i3,3e15.5)') i,grow(i),dgrow(i),grow(i)-curve(i)
    end do
!    t = grow(nref)
!    grows(:,nref+1) = grow(nref+1)
    betas = betas*flux
    do i = nref,1,-1
       do n = 1,nstar
          grows(n,i) = grows(n,i+1) * &
               (cts(n,i) - betas(n)*aper(i)) / (cts(n,i+1) - betas(n)*aper(i+1))
!          grows(n,i) = (cts(n,i) - betas(n)*aper(i)) /flux(n)
          dgrows(n,i) = grows(n,i) * (dcts(n,i) / cts(n,i))
!          write(*,*) i,n,real(grows(n,i))
       end do
       call rmean(grows(:,i),dgrows(:,i),curve(i),dcurve(i))
       dcurve(i) = dcurve(i) + approxerr
    end do


!!$goto 999
!!$    stop
!!$
!!$
!!$
!!$
!!$
!!$
!!$    ! Initial estimate of individual backgrounds of stars.
!!$    ! Its estimate is on base of slope of every individual
!!$    ! growth curve close to largest aperture.
!!$    !
!!$    ! rback is radius where the slope is determined
!!$    ! ctsback is mean of counts at rback (change by slope is negligible)
!!$    rback = sum(radius(nref:naper))/(naper - nref + 1)
!!$!    write(*,*) rback,real(radius(nref:naper)),naper - nref
!!$    rback = 1
!!$
!!$    do i = 1,nstar*0
!!$!       call back_init(cts(i,:),dcts(i,:),back(i))
!!$       ctsback = sum(cts(i,nref:naper)) / (naper - nref + 1)
!!$!       write(*,*) real(cts(i,nref:naper))
!!$       back(i) = ctsback * back(i) / (2*pi*rback*raper(naper)**2)
!!$       write(*,*) real(sky(i)-1e3),real(back(i)), real(back(i)-(sky(i)-1e3)),real(ctsback)
!!$    end do
!!$    back = sky-1e3
!!$!stop
!!$!    if( debug ) then ! write grows with corrected sky
!!$
!!$
!!$    ! Initial estimate of asympotic parameters
!!$    ! There is a lot of curves with potentially false points
!!$    ! and the parameters are determined from a few points.
!!$    ! Thats is why the data are filtered by median.
!!$    !
!!$    ! The curve is anchored on number one at naper, so the
!!$    ! curve needs additional normalisation.
!!$    !
!!$    t = 1
!!$!    back = 0
!!$    do i = 1,nstar
!!$       ! starting construction from hwhm (last element > 1)
!!$       call a_constructor(cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$       if( .not. valid ) stop 'a_constructor: not valid'
!!$    end do
!!$    do i = 1,naper
!!$       call rinit(grows(:,i),grow_(i),dgrow_(i))
!!$!       write(*,'(3f15.5)') raper(i),grow_(i),dgrow_(i)
!!$    end do
!!$    dgrow_(nhwhm) = (dgrow_(nhwhm-1) + dgrow_(nhwhm+1))/2 ! reference has zero noise
!!$    grow_ = grow_ / grow_(naper)    ! normalize
!!$    t = grow_(nref) - grow_(nhwhm)
!!$    do i = 1,naper
!!$       write(*,'(3f15.5)') raper(i),grow_(i),dgrow_(i)
!!$    end do
!!$!    call asymptote_init(a,b,c,q)
!!$!    write(*,'(a,4f12.5)') 'asymptote_init (q=1?):',a,b,c,q
!!$
!!$    do i = 1,nstar
!!$       call rcal(cts(i,1:nhwhm),dcts(i,1:nhwhm),grow_(1:nhwhm),dgrow_(1:nhwhm), &
!!$            flux0(i),s,.false.)
!!$       s = sum(abs(cts(i,1:nhwhm)/grow_(1:nhwhm)-flux0(i)))/(nhwhm-1)
!!$       write(*,*) i,real(flux0(i)),real(s),real(cts(i,nhwhm))
!!$    end do
!!$
!!$    a = 0
!!$    ! inidividual grows
!!$    do i = 1,nstar
!!$       grow_ = (cts(i,:) - back(i)*pi*raper(:)**2)/ flux0(i)
!!$       dgrow_ = dcts(i,:) / flux0(i)
!!$       call asymptote_init5(a,q,beta,daas(i),b,c)
!!$       write(*,*) i,a,beta*flux0(i),q,flux0(i),daas(i),1e3-sky(i),'init5'
!!$!       flux0(i) = q*flux0(i)
!!$       qs(i) = q
!!$       aas(i) = a/q
!!$       daas(i) = daas(i)/q
!!$       betas(i) = beta/q
!!$!       stop
!!$    end do
!!$
!!$
!!$    call rwmean(aas,daas,a,s)
!!$    write(*,*) 'aas:',real(a),real(s)
!!$
!!$    call rmean(qs,q,s)
!!$    write(*,*) 'qs:',real(q),real(s)
!!$
!!$    ! update individual fluxes and backgrounds
!!$    a = 0
!!$    do i = 1,nstar
!!$       call update_backflux(a,cts(i,:),dcts(i,:),flux0(i),back(i))
!!$       write(*,*) i,real(flux0(i)),real(back(i)),real(1e3-sky(i))
!!$    end do
!!$    betas = back
!!$
!!$stop
!!$
!!$    ! update grow curve
!!$    do i = nref,naper
!!$       grow_(i) = 1 - a/raper(i)! - t
!!$       write(*,*) real(raper(i)),real(grow_(i))
!!$    end do
!!$    grows(:,nref) = grow_(nref)
!!$    do j = nref-1,1,-1
!!$       do i = 1,nstar
!!$          grows(i,j) = & !grows(i,j+1)* &
!!$               (cts(i,j) - betas(i)*raper(j)**2)/(cts(i,j+1) - betas(i)*raper(j+1)**2)
!!$       end do
!!$       call rwmean(grows(:,j),dgrows(:,j),t,dgrow_(j))
!!$       grow_(j) = t*grow_(j+1)
!!$       write(*,*) real(raper(j)),real(grow_(j)),real(dgrow_(j))
!!$    end do
!!$
!!$    grow = grow_
!!$    dgrow = dgrow_
!!$!    stop
!!$    return
!!$
!!$
!!$
!!$
!!$
!!$    do i = 1,nstar
!!$       grow_ = cts(i,:) / flux0(i)
!!$       dgrow_ = dcts(i,:) / flux0(i)
!!$       call asymptote_init5(a,q,beta,daas(i),b,c)
!!$!       write(*,*) i,a,beta*flux0(i),q,flux0(i),daas(i),1e3-sky(i),'init5'
!!$       qs(i) = q
!!$       aas(i) = a/q
!!$       daas(i) = daas(i)/q
!!$       betas(i) = beta/q
!!$    end do
!!$    call rwmean(aas,daas,a,s)
!!$    write(*,*) 'aas1:',real(a),real(s)
!!$
!!$
!!$    do i = 1,nstar
!!$       call update_backflux(a,cts(i,:),dcts(i,:),flux0(i),back(i))
!!$       write(*,*) i,real(flux0(i)),real(back(i))
!!$    end do
!!$
!!$
!!$
!!$stop
!!$
!!$
!!$
!!$    ! update fluxes
!!$    do i = 1,nstar
!!$       t = flux0(i)
!!$       call rcal(cts(i,1:nhwhm),dcts(i,1:nhwhm),grow_(1:nhwhm),dgrow_(1:nhwhm), &
!!$            flux0(i),s,.false.)
!!$       write(*,*) i,real(flux0(i)),real(t),real(s),'fff'
!!$    end do
!!$stop
!!$    ! update inidividual grows
!!$    do i = 1,nstar
!!$       grow_ = cts(i,:) / flux0(i)
!!$       dgrow_ = dcts(i,:) / flux0(i)
!!$       call asymptote_init5(a,q,beta,daas(i),b,c)
!!$       write(*,*) i,a,beta*flux0(i),q,flux0(i),daas(i),1e3-sky(i),'init7'
!!$!       flux0(i) = q*flux0(i)
!!$       qs(i) = q
!!$       aas(i) = a/q
!!$       daas(i) = daas(i)/q
!!$       betas(i) = beta/q
!!$    end do
!!$
!!$    call rwmean(aas,daas,a,s)
!!$    write(*,*) 'aas:',real(a),real(s)
!!$
!!$    ! update grow curve
!!$    do i = nref,naper
!!$       grow_(i) = 1 - a/raper(i)! - t
!!$       write(*,*) real(raper(i)),real(grow_(i))
!!$    end do
!!$    grows(:,nref) = grow_(nref)
!!$    do j = nref-1,1,-1
!!$       do i = 1,nstar
!!$          grows(i,j) = grows(i,j+1)* &
!!$               (cts(i,j) - betas(i)*raper(j)**2)/(cts(i,j+1) - betas(i)*raper(j+1)**2)
!!$       end do
!!$       call rwmean(grows(:,j),dgrows(:,j),grow_(j),dgrow_(j))
!!$       write(*,*) real(raper(j)),real(grow_(j)),real(dgrow_(j))
!!$    end do
!!$stop
!!$    grow = grow_
!!$    dgrow = dgrow_
!!$
!!$    return
!!$
!!$!    stop
!!$
!!$    do i = 1,nstar
!!$       call rmean((cts(i,nref:)-flux0(i)*grow_(nref:))/aper(nref:),back(i),s)
!!$!       call rmean((cts(i,nref:)/tx(i)-grow_(nref:))/aper(nref:),back(i),s)
!!$!       write(*,*) real((cts(i,nref:)-0*tx(i)*grow_(nref:))/aper(nref:))
!!$!       call rmean(cts(i,:)/grow_,tx(i),s)
!!$       write(*,*) i,real(back(i)/3.14),real(s),real(sky(i)-1e3)
!!$       if( i == nstar ) stop
!!$    end do
!!$    ! v teto fazi je jeste rozptyl prilis velky a pozadi urcovat nejde
!!$    ! a urceni f0 je taky zbytecne...
!!$    back = 0
!!$
!!$
!!$!    do i = 1,nstar
!!$!       grows(i,:) = cts(i,:) / tx(i)
!!$    !    end do
!!$    t = 1
!!$    back(1) = 5
!!$    do i = 1,nstar
!!$       call the_constructor(t,back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$    end do
!!$    do i = 1,naper
!!$!       call rinit(grows(:,i),grow_(i),dgrow_(i))
!!$       call rwmean(grows(:,i),dgrows(:,i),grow_(i),dgrow_(i))
!!$!       write(*,'(3f15.5)') raper(i),grow_(i),dgrow_(i)
!!$       write(*,'(3f15.5)') raper(i),cts(1,i),dgrows(1,i)
!!$    end do
!!$!        stop
!!$
!!$    grow_ = cts(1,:) / 1.603e7
!!$    dgrow_ = dcts(i,:) / 1.603e7
!!$    grow_ = cts(1,:) / 1.7e7
!!$    dgrow_ = dcts(i,:) / 1.7e7
!!$    p(2) = 1
!!$    do i = -1000,1000,100
!!$       p(1) = i/5e3
!!$       do j = -500,500,50
!!$          p(3) = j/1e3
!!$          write(*,*) p(1),p(3),fainit5(p),'qqq'
!!$       end do
!!$    end do
!!$    stop
!!$
!!$!    call asymptote_init3(a,q)
!!$
!!$
!!$    do i = 1,nstar
!!$       grow_ = grows(i,:)
!!$       dgrow_ = dgrows(i,:)
!!$       call asymptote_init3(a,q)
!!$       write(*,*) i,a,q,'aaa'
!!$       stop
!!$    end do
!!$
!!$
!!$    c = 0
!!$    stop
!!$
!!$    ! The curve's anchor point is given by q as 1-q at maximum aperture.
!!$    ! Both a,b parameters are only sligthly different against to final (true) ones.
!!$
!!$!stop
!!$
!!$    do iter = 1,13
!!$
!!$       ! Next iteration
!!$       call asymptote_init2(a,b,q)
!!$       write(*,'(a,4f12.5)') 'asymptote_init2 (q->1):',a,b,q
!!$       stop
!!$
!!$
!!$       !       t = 1 - q
!!$!       t = 1 + (1-q) !- (a + b/raper(naper))
!!$       t = 1 - (a + b/raper(naper))/raper(naper)
!!$       write(*,*) t
!!$!       stop
!!$       do i = nref,naper
!!$!          grow_(i) = asymptote(raper(i),a,b,c)
!!$          grow_(i) = t - (a + b/raper(i))/raper(i)
!!$          ! dgrow_?
!!$          write(*,'(3f15.5)') raper(i),grow_(i),dgrow_(i)
!!$       end do
!!$       grows(:,nref) = grow_(nref)
!!$       do j = nref-1,1,-1
!!$          do i = 1,nstar
!!$             grows(i,j) = grows(i,j+1)*(cts(i,j) - back(i)*aper(j))/(cts(i,j+1) - back(i)*aper(j+1))
!!$          end do
!!$       end do
!!$
!!$       do i = 1,nref-1
!!$          call rwmean(grows(:,i),dgrows(:,i),grow_(i),dgrow_(i))
!!$          write(*,'(3f15.5)') raper(i),grow_(i),dgrow_(i)
!!$       end do
!!$
!!$       do i = 1,nstar
!!$!          call rcal(cts(i,1:nref),dcts(i,1:nref),grow_(1:nref),dgrow_(1:nref),tx(i),s,.false.)
!!$          call rcal(cts(i,:),dcts(i,:),grow_,dgrow_,tx(i),s,.false.)
!!$          write(*,*) i,real(tx(i)),real(s),real(sky(i)-1e3)
!!$       end do
!!$
!!$       do i = 1,nstar
!!$          call rmean((cts(i,nref:)-tx(i)*grow_(nref:))/aper(nref:),back(i),s)
!!$!          write(*,*) real((cts(i,nref:)-tx(i)*grow_(nref:))/aper(nref:))
!!$          write(*,*) i,real(back(i)),real(s),real(sky(i)-1e3)
!!$!          if( i == 2 ) stop
!!$       end do
!!$!       stop
!!$
!!$!       t = 1 - q
!!$       do i = 1,nstar
!!$          call the_constructor(t,back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$       end do
!!$       do i = 1,naper
!!$          call rwmean(grows(:,i),dgrows(:,i),grow_(i),dgrow_(i))
!!$          write(*,'(3f15.5)') raper(i),grow_(i),dgrow_(i)
!!$       end do
!!$
!!$    !       call asymptote_update(a,b,c)
!!$!       write(*,'(a,4f12.5)') 'asymptote_update:',a,b,c
!!$
!!$    end do
!!$
!!$stop
!!$
!!$    ! Update of the initials of asymptote with anchor value as mean at naper.
!!$    ! update grow curve by the parameters (correct solution is
!!$    ! update of t as t = 1/q and repeat the procedure while q will
!!$    ! approach 1, but we are belives, that the all deviations are small...)
!!$!    t = 1/q
!!$!    t = 0.997
!!$    t = asymptote(raper(naper),a,b,c)
!!$!    write(*,*) t
!!$    do i = 1,nstar
!!$       call the_constructor(t,back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$    end do
!!$    do i = 1,naper
!!$!       call rinit(grows(:,i),grow_(i),dgrow_(i))
!!$       call rwmean(grows(:,i),dgrows(:,i),grow_(i),dgrow_(i))
!!$    end do
!!$    dgrow_(naper) = dgrow_(naper-1)
!!$!    call asymptote_init(a,b,c)
!!$    call asymptote_init(a,b,c,q)
!!$    write(*,'(a,4f12.5)') 'asymptote_init:',a,b,c,q
!!$
!!$    stop
!!$    ! choose determination of method to minimise
!!$    ! setup norm (absolute deviations)
!!$    type = 0
!!$
!!$    ! Now, its time to do more precise estimation of background..
!!$    call rinit(abs(back)/cts(:,naper),backmed,s)
!!$    do i = 1,nstar
!!$       call anchor(cts(i,:),dcts(i,:),a,b,c,t,backmed,back(i))
!!$       write(*,*) real(sky(i)-1e3),real(back(i)), real(back(i)-(sky(i)-1e3)), sqrt(cts(i,naper))
!!$    end do
!!$
!!$    ! .. anchor t
!!$!    call anchor_update(a,b,c,back,t)
!!$!    write(*,'(a,4f12.5)') 'anchor_update:',t
!!$
!!$    ! .. and asymptote
!!$    call asymptote_update(a,b,c,t)
!!$    t = asymptote(raper(naper),a,b,c)
!!$    write(*,'(a,4f12.5)') 'asymptote_update:',a,b,c,t
!!$
!!$
!!$    ! Recompute with least square meaning statistics
!!$    ! setup norm (Huber's function)
!!$    type = 1
!!$
!!$    ! determine mean sig in tail
!!$    call asymptote_sig(a,b,c,t,back,sig)
!!$
!!$    ! Now, its time to do more precise estimation of background..
!!$    call rinit(abs(back)/cts(:,naper),backmed,s)
!!$    do i = 1,nstar
!!$       call anchor(cts(i,:),dcts(i,:),a,b,c,t,backmed,back(i))
!!$       write(*,*) real(sky(i)-1e3),real(back(i)), real(back(i)-(sky(i)-1e3)), i
!!$    end do
!!$
!!$    ! .. anchor t
!!$!    call anchor_update(a,b,c,back,t)
!!$!    write(*,'(a,4f12.5)') 'anchor_update:',t
!!$
!!$    ! .. and asymptote
!!$    call asymptote_update(a,b,c,t)
!!$    t = asymptote(raper(naper),a,b,c)
!!$    write(*,'(a,4f12.5)') 'asymptote_update:',a,b,c,t
!!$
!!$
!!$
!!$
!!$    stop 0
!!$
!!$!    write(*,*) 'nref=',nref
!!$
!!$
!!$!    lambda = 1
!!$!    do j = 1,0
!!$!       call par_init(a,b,c,back)
!!$!       lambda = 2*lambda
!!$!    end do
!!$!    back =
!!$
!!$
!!$    open(1,file='/tmp/1')
!!$!    back = 0
!!$    tx = 1
!!$    t = 1 !0.9984
!!$    !    stop
!!$    t = 1
!!$    do i = 1,nstar
!!$       call the_constructor(t,back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$    end do
!!$    do i = 1,naper
!!$!       write(*,*) 'i=',i
!!$!       call rmean(grows(:,i),grow_(i),dgrow_(i))
!!$       call rinit(grows(:,i),grow_(i),dgrow_(i))
!!$!       call rmean(grows(:,i),a,b)
!!$!       call rwmean(grows(:,i),dgrows(:,i),grow_(i),dgrow_(i))
!!$       write(*,*) 'i=',i,real(raper(i)),real(grow_(i)),real(dgrow_(i))
!!$       write(1,*) raper(i),grow_(i),dgrow_(i)
!!$!       write(*,'(4g15.5,a)') a,b,grow_(i),dgrow_(i),' www'
!!$!       if( i == 11 ) then
!!$!          do j = 1,nstar
!!$!             write(*,*) grows(j,i),dgrows(j,i)**2
!!$!          end do
!!$       !       end if
!!$!       if( i == 9  ) stop 0
!!$    end do
!!$    close(1)
!!$
!!$    dgrow_(naper) = dgrow_(naper-1)
!!$    write(*,*) dgrow_(naper),dgrow_(naper-1),dgrow_(naper-2),naper
!!$
!!$
!!$    ! initial estimate of asympotic parameters
!!$    lambda = 0
!!$    do i = 1,1
!!$       call asymptote_init(a,b,c,q)
!!$       lambda = 2*lambda
!!$    end do
!!$    write(*,'(a,4f12.5)') 'asymptote_init:',a,b,c,q
!!$
!!$
!!$    ! update grow curve by the parameters (correct solution is
!!$    ! update of t as t = 1/q and repeat the procedure while q will
!!$    ! approach 1, but we are belives, that the all deviations are small...)
!!$    if( q > 1 ) grow_ = grow_ / q
!!$
!!$    ! compute asymptote
!!$    lambda = 0
!!$    do i = 1,1
!!$       call asymptote_init(a,b,c)
!!$       lambda = 2*lambda
!!$    end do
!!$
!!$    call asymptote_init(a,b,c,q)
!!$    write(*,'(a,4f12.5)') 'asymptote_init1:',a,b,c,q
!!$
!!$    stop
!!$    ! setup norm (absolute deviations)
!!$    type = 0
!!$
!!$
!!$    do j = 1,1
!!$
!!$    ! update individual t,b-parameters
!!$    tx = asymptote(raper(naper),a,b,c)
!!$    write(*,*) 'tx(1)',tx(1)
!!$    do i = nref, naper
!!$       grow_(i) = asymptote(raper(i),a,b,c)
!!$    end do
!!$    do i = 1,nstar
!!$       cts_ = cts(i,:)
!!$       dcts_ = dcts(i,:)
!!$!       call anchor(a,b,c,tx(i),back(i))
!!$!       write(*,*) i,tx(i),tx(i)-asymptote(raper(naper),a,b,c)
!!$       write(*,*) i,back(i)
!!$    end do
!!$
!!$
!!$    ! update grow curve
!!$    do i = 1,nstar
!!$       call the_constructor(tx(i),back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$    end do
!!$    do i = 1,naper
!!$       call rinit(grows(:,i),grow_(i),dgrow_(i))
!!$!       write(*,*) 'i=',i,real(raper(i)),real(grow_(i)),real(dgrow_(i))
!!$    end do
!!$    dgrow_(naper) = dgrow_(naper-1)
!!$    write(*,*) dgrow_(naper),dgrow_(naper-1),dgrow_(naper-2),naper
!!$    lambda = 0
!!$    call asymptote_init(a,b,c,q)
!!$    write(*,'(a,4f12.5)') 'asymptote_init:',a,b,c,q
!!$
!!$ enddo
!!$
!!$stop
!!$
!!$    grow_(9) = 0.99611562
!!$    grow_(10) = 0.996945143
!!$    grow_(11) = 0.997353375
!!$    grow_(12) = 0.997653544
!!$
!!$    open(1,file='/tmp/3')
!!$    back = 0
!!$    do i = 1,nstar
!!$       call the_constructor(tx(i),back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$       do j = nref,naper
!!$          write(1,*) raper(j),grows(i,j),(grows(i,j)-grow_(j))/dgrows(i,j)
!!$       end do
!!$    end do
!!$    close(1)
!!$
!!$    ! update asymptote
!!$    do i = 1,nstar
!!$       call the_constructor(tx(i),back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$    end do
!!$
!!$    lambda = 1
!!$    a1 = 100
!!$    b1 = 100
!!$    c1 = 100
!!$    do i = 1,10
!!$!       call asymptote_update(a,b,c)
!!$       write(*,'(i3,4f15.5)') i,a,b,c
!!$          if( abs(c - c1) < tol .and. abs(a - a1) < tol .and. abs(b - b1) < tol ) exit
!!$       lambda = 2*lambda
!!$       a1 = a
!!$       b1 = b
!!$       c1 = c
!!$    end do
!!$
!!$
!!$    ! setup norm (Huber's function)
!!$    type = 1
!!$
!!$    ! determine mean sig in tail
!!$!    call asymptote_sig(a,b,c,tx,sig)
!!$
!!$    ! update t-par
!!$    do i = nref, naper
!!$       grow_(i) = asymptote(raper(i),a,b,c)
!!$    end do
!!$    do i = 1,nstar
!!$       cts_ = cts(i,:)
!!$       dcts_ = dcts(i,:)
!!$!       call anchor(a,b,c,tx(i),back(i))
!!$       write(*,*) i,tx(i),tx(i)-asymptote(raper(naper),a,b,c)
!!$    end do
!!$
!!$    ! update asymptote, with Huber's help
!!$    do i = 1,nstar
!!$       call the_constructor(tx(i),back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$    end do
!!$
!!$    lambda = 1
!!$!    a1 = 100
!!$!    b1 = 100
!!$!    c1 = 100
!!$    do i = 1,10
!!$!       call asymptote_update(a,b,c)
!!$       write(*,'(i3,4f15.5)') i,a,b,c
!!$          if( abs(c - c1) < tol .and. abs(a - a1) < tol .and. abs(b - b1) < tol ) exit
!!$       lambda = 2*lambda
!!$       a1 = a
!!$       b1 = b
!!$       c1 = c
!!$    end do
!!$
!!$    goto 99
!!$    stop 0
!!$
!!$!    call rmean(dgrows(nhwhm,:),t,dt)
!!$    !    dgrow(nhwhm) = t
!!$
!!$!    call background3(back)
!!$!    write(*,*) real(back)
!!$
!!$
!!$!    stop 0
!!$    t = grow_(nref) / grow_(naper)
!!$
!!$    ! Initial value must be 0 < t < 1.
!!$    if( 0 < t .and. t < 1 ) then
!!$       continue
!!$    else
!!$       t = 0.95
!!$    end if
!!$
!!$!    t = t - 3*dgrow_(naper)
!!$    t = t - 0.002
!!$!    t = 0.9*t
!!$
!!$!    t = 0.5
!!$!    e = 1 - t
!!$!    e = e / 2
!!$!    a = ((1 - e) - t) * raper(nref)
!!$!    a = (1 - t) * raper(nref)
!!$    a = (1 - t) / 2
!!$!    c = a * raper(nref)**3
!!$    b = a * raper(nref)**2
!!$    a = a * raper(nref)
!!$    e = 0
!!$    write(*,*) t,asymptote(raper(naper),a,b,c)
!!$!    t = t * asymptote(raper(naper),e,a,b)
!!$
!!$    write(*,*) grow_(naper) - grow_(naper-1), grow_(naper-2) - grow_(naper-1)
!!$    write(*,*) 1/raper(naper) - 1/raper(naper-1)
!!$    write(*,*) 1/raper(naper-2) - 1/raper(naper-1)
!!$    write(*,*) 1/raper(naper)**2 - 1/raper(naper-1)**2
!!$    write(*,*) 1/raper(naper-2)**2 - 1/raper(naper-1)**2
!!$
!!$    mat(1,1) = 1/raper(naper) - 1/raper(naper-1)
!!$    mat(1,2) = 1/raper(naper)**2 - 1/raper(naper-1)**2
!!$    mat(2,1) = 1/raper(naper-2) - 1/raper(naper-1)
!!$    mat(2,2) = 1/raper(naper-2)**2 - 1/raper(naper-1)**2
!!$    mat = -mat
!!$    vec(1) = grow_(naper) - grow_(naper-1)
!!$    vec(2) = grow_(naper-2) - grow_(naper-1)
!!$
!!$    d = mat(1,1)*mat(2,2) - mat(1,2)*mat(2,1)
!!$
!!$    a = (vec(1)*mat(2,2) - vec(2)*mat(1,2)) / d
!!$!    a = -a / d
!!$    b = (vec(1)*mat(1,1) - vec(2)*mat(2,1)) / d
!!$!    b = b / d
!!$    e = 0
!!$    !    t =  grow_(nref) / grow_(naper) * asymptote(raper(naper),e,a,b)
!!$!    t = asymptote(raper(nref),e,a,b)
!!$    a = vec(1) / mat(1,1)
!!$    b = 0
!!$    call part(e,a,b,t)
!!$
!!$!    t = asymptote(raper(nref),a,b)
!!$!    write(*,*) a,b,t
!!$!    c = b /  !1 - t
!!$!    e = 1 - t - a/raper(nref) - b/raper(nref)**2
!!$!    a = a / 2
!!$!    e = 1 - a
!!$!    write(*,*) real(t),real(a),real(e)
!!$
!!$!    write(*,*) 1 - e - a / raper(nref) - b / raper(nref)**2
!!$    write(*,*) 'Initial estimate:',real(t),real(a),real(b),real(e)
!!$
!!$!    call tnoise(t)
!!$!    write(*,*) 'tnoise=',t
!!$
!!$!    open(11,file='/tmp/t')
!!$!    do i = 5000,10000
!!$!       t = i/1e4
!!$!       write(11,*) t,noisefun(t)
!!$!    end do
!!$!    close(11)
!!$
!!$!    stop 0
!!$
!!$!    stop 0
!!$!    back1 = 0! maxval(cts)
!!$    back = 0
!!$    back1 = back
!!$    tx1 = t
!!$    tx = t
!!$    t1 = t
!!$    dt = 1 - t
!!$
!!$    par_t = t
!!$
!!$    goto 33
!!$    open(11,file='/tmp/s')
!!$    do i = 1,1000,10
!!$       do j = 1,1000,10
!!$          b = i*1e-3
!!$          a = j*1e-3
!!$          e = j*1e-4
!!$!          s = mincom((/e,0.0_dbl,b/))
!!$!          s = mincom((/e,a,0.0_dbl/))
!!$          s = mincom((/0.0_dbl,a,b/))
!!$          write(11,*) a,b,s
!!$       end do
!!$    end do
!!$    close(11)
!!$33 continue
!!$
!!$    open(11,file='/tmp/t')
!!$    par_a = a
!!$    par_b = b
!!$    do i = 9600,10000
!!$       t = i/1e4
!!$!       write(11,*) t,tfun(t)
!!$    end do
!!$    close(11)
!!$
!!$
!!$    !    call towel(a,b,t)
!!$    call part(e,a,b,t)
!!$    write(*,*) t
!!$
!!$!    stop 0
!!$
!!$    lambda = 1
!!$    do iter = 1, precision(t)
!!$
!!$
!!$       ! estimate parameters common to all stars: a,b,e
!!$
!!$       back = 0
!!$       type = 0
!!$       lambda = 1
!!$       e1 = 100
!!$       a1 = 100
!!$       b1 = 100
!!$       do i = 1,20
!!$          call commons1(e,a,b)
!!$          !          call part(e,a,b,t)
!!$!          t = asymptote(raper(nref),e,a,b)
!!$          write(*,'(i3,4f15.5)') i,a,b,e,t
!!$!          if( abs(e - e1) < tol .and. abs(a - a1) < tol .and. abs(b - b1) < tol ) exit
!!$          lambda = 2*lambda
!!$          e1 = e
!!$          a1 = a
!!$          b1 = b
!!$       end do
!!$
!!$!       call part(e,a,b,t)
!!$       par_t = t
!!$
!!$
!!$       write(*,'(a,4f15.5)') 'abs:',a,b,c,t
!!$
!!$       exit
!!$       tx = t
!!$
!!$!       stop 0
!!$
!!$goto 45
!!$       lambda = 0.1
!!$       do i = 1,10
!!$          call commons(e,a,b)
!!$          write(*,*) real(e),real(a),real(b)
!!$          lambda = 2*lambda
!!$       end do
!!$
!!$       open(1,file='/tmp/5')
!!$       do i = nhwhm,naper
!!$          write(1,*) raper(i),(1-e-a/raper(i)-b/raper(i)**2)
!!$       end do
!!$       close(1)
!!$!stop 0
!!$45 continue
!!$
!!$       ! estimate background of individual stars
!!$       do i = 1,nstar
!!$          cts_ = cts(i,:)
!!$          dcts_ = dcts(i,:)
!!$!          call background(e,a,b,back(i),tx(i))
!!$!          call background3(e,a,b,t,back(i))
!!$!          back(i) = xbackground(e,a,b,t)
!!$!          write(*,*) i,real(back(i))
!!$!stop 0
!!$       end do
!!$!       stop 0
!!$!       call rmean(tx,t,dt)
!!$!       write(*,*) t,dt
!!$!       t = t1
!!$
!!$goto 44
!!$
!!$       call background2(e,a,b,t,back)
!!$       write(*,*) real(t),real(back)
!!$       tx = t
!!$
!!$       open(1,file='/tmp/4')
!!$       do i = 1,nstar
!!$          call the_constructor(tx(i),back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$          do j = 1,naper
!!$             write(1,*) raper(j),grows(i,j)
!!$          end do
!!$       end do
!!$       close(1)
!!$       open(1,file='/tmp/5')
!!$       do i = nhwhm,naper
!!$          call rinit(grows(:,i),grow_(i),dgrow_(i))
!!$          write(1,*) raper(i),grow_(i),dgrow_(i),grow_(i)-(1+e-a/raper(i)-b/raper(i)**2)
!!$       end do
!!$       close(1)
!!$
!!$!stop 0
!!$       tx = t
!!$
!!$       !       call part(e,a,b,t,dt)
!!$
!!$       ! estimate parameters common to all stars: a,b,e
!!$       lambda = 0.1
!!$       do i = 1,10
!!$          call commons(e,a,b)
!!$          write(*,*) real(e),real(a),real(b)
!!$          lambda = 2*lambda
!!$       end do
!!$
!!$44 continue
!!$
!!$       db = sum(abs(back - back1)/cts(:,nhwhm))/nstar
!!$!       dt = sum(abs(tx - tx1))/nstar
!!$       dt = abs(t - t1)
!!$
!!$       write(*,'(i2,3f10.5,5x,1p,2g10.2)') iter,a,b,t,db,dt
!!$
!!$       if( db < tol .and. dt < tol ) exit
!!$
!!$!       do i = 1,nstar
!!$!          do j = 8,naper
!!$!             if( abs(cts(i,j)/cts(i,naper) - (1-a/raper(j)-b/raper(j)**2)) > 0.01 ) then
!!$!                cts(i,j) = cts(i,naper)*(1-a/raper(j)-b/raper(j)**2)
!!$!             end if
!!$!          end do
!!$!       end do
!!$
!!$       lambda = 2*lambda
!!$       back1 = back
!!$       tx1 = tx
!!$       dt = abs(t1-t)
!!$       t1 = t
!!$!       stop
!!$    end do
!!$
!!$
!!$    do i = 1,nstar
!!$       call the_constructor(t,back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$    end do
!!$    allocate(fvec(naper*nstar),dvec(naper*nstar))
!!$    n = 0
!!$!    do i = (nhwhm+naper)/2,naper
!!$    do i = nref,naper
!!$       n1 = n + 1
!!$       n = n + nstar
!!$       n2 = n
!!$       d = asymptote(raper(i),a,b,c)
!!$       fvec(n1:n2) = abs(grows(:,i) - d) !/ dgrows(:,i)
!!$       dvec(n1:n2) = dgrows(:,i)
!!$!       d = (1-e-a/raper(i)-b/raper(i)**2)
!!$    end do
!!$!    write(*,*) n,nstar,real(fvec(1:n))
!!$    call rinit(fvec(1:n),d,s)
!!$    call rwmean(fvec(1:n),dvec(1:n),d,s,sig)
!!$!    sig = d / 0.6745
!!$    write(*,*) 'sig:',d, sig
!!$    deallocate(fvec,dvec)
!!$
!!$    back = 0
!!$    type = 1
!!$    lambda = 1
!!$    e1 = 100
!!$    a1 = 100
!!$    b1 = 100
!!$    do i = 1,20
!!$       call commons1(e,a,b)
!!$       !       call part(e,a,b,t)
!!$!       t = asymptote(raper(nref),e,a,b)
!!$       write(*,'(i3,4f15.5)') i,a,b,e,t
!!$!       if( abs(e - e1) < tol .and. abs(a - a1) < tol .and. abs(b - b1) < tol ) exit
!!$       lambda = 2*lambda
!!$       e1 = e
!!$       a1 = a
!!$       b1 = b
!!$    end do
!!$!       t = 1 - a/raper(nhwhm) - b/raper(nhwhm)**2
!!$
!!$!    call part(e,a,b,t)
!!$    write(*,*) 'commons1:',real(a),real(b),real(t),real(e)
!!$
!!$    ! estimate background of individual stars
!!$    do i = 1,nstar
!!$       cts_ = cts(i,:)
!!$       dcts_ = dcts(i,:)
!!$!       back(i) = ybackground(e,a,b,t)
!!$!       write(*,*) i,real(back(i))
!!$    end do
!!$
!!$99  continue
!!$
!!$    ! final curve
!!$    do i = 1,nstar
!!$!       call the_constructor(e,a,cts(i,:),dcts(i,:),back(i),grows(i,:),dgrows(i,:),valid)
!!$!       call the_constructor(tx(i),back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$       call the_constructor(tx(i),back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$!       write(*,*) i,real(grows(i,:)),real(dgrows(i,:))
!!$    end do
!!$    do i = 1,naper
!!$!       call rmean(grows(:,i),grow(i),dgrow(i))
!!$       call rwmean(grows(:,i),dgrows(:,i),grow(i),dgrow(i))
!!$!       write(*,*) i,real(grows(:,i))
!!$    end do
!!$!    do i = (nhwhm+naper)/2,naper
!!$!       grow(i) = (1-a/raper(i)-b/raper(i)**2)
!!$    !    end do
!!$
!!$999 continue

    ! check for identical curves
!    where( abs(dgrow) < epsilon(dgrow) )
!       dgrow = 1e-6
!    end where

!    open(1,file='/tmp/8')
!    do i = 1,naper
!       write(1,*) raper(i),grow(i)-(1-e-a/raper(i)-b/raper(i)**2),grow(i),dgrow(i),&
!            (1-e-a/raper(i)-b/raper(i)**2)
!    end do
!    close(1)

    if( debug ) then
       do i = 1,naper
          write(*,*) i,real(raper(i)),real(curve(i)),real(dcurve(i))
       end do
    end if

!    do i = nref+1,naper
!    t1 = (grow(naper) - grow(nref))*0.998
!    b1 = a*(1/raper(nref) -1/raper(naper)) +  2*b*(1/raper(nref)**2 - 1/raper(naper)**2)
!    write(*,'(4g15.5)') t1-b1,t1,b1
!   stop 0

!    deallocate(raper,aper,cts,dcts,back,back1,grows,dgrows,tx,tx1,grow_,dgrow_, &
!         cts_,dcts_)
    deallocate(raper,aper,radius,flux,betas,phi,cts,dcts,grows,dgrows,grow,dgrow,sigs)

  end subroutine growmodel



  subroutine back_update(cts,dcts,flux,a,b,beta,phi)

    use NelderMead
    use oakleaf
    use minpacks

    real(dbl), dimension(:), intent(in) :: cts, dcts
    real(dbl), intent(in) :: flux,a,b
    real(dbl), intent(out) :: beta, phi
    real(dbl), dimension(2) :: p,dp
    real(dbl), dimension(size(cts)) :: res
    real(dbl) :: pmin, s, g
    integer :: i,ifault,info, nprint

    do i = nref,naper
       grow(i) = cts(i)/flux - (1 - (a + b/raper(i))/raper(i))
!       write(*,'(3e15.5,a)') raper(i),grow_(i),dgrow_(i),' EE'
    end do
    s = median(dcts(nref:naper))
    sig = s / flux + approxerr

    p = 0
    dp = 1e-6

    call nelmin1(backfun,p,dp,pmin,ifault)

    if( ifault == 0 ) then
       phi = p(1)
       beta = p(2)
    else
       if( debug ) write(*,*) 'back_init:',ifault,real(p)
       phi = 0
       beta = 0
       return
    end if

    do i = nref, naper
       g = phi + beta*aper(i)
       res(i) = abs(grow(i) - g) / s
    end do
    sig = median(res(nref:naper)) / 0.6745 + approxerr

!    write(*,*) real(p),real(sig)

    nprint = 0
    call lmder2(backder,p,epsilon(p),nprint,info)

!    write(*,*) real(p),info
    if( info == 2 ) then
       phi = p(1)
       beta = p(2)
    end if

  end subroutine back_update

  function backfun(p) result(s)

    real(dbl), dimension(:), intent(in) :: p

    real(dbl) :: s,g,beta,phi
    integer :: i

    phi = p(1)
    beta = p(2)

    s = 0
    do i = nref, naper
       g = phi + beta*aper(i)
       s = s + abs(grow(i) - g) / sig
!       write(*,*) radius(i),f,x,grow_(i),dgrow_(i)
    end do

  end function backfun

  subroutine backder(m,np,p,fvec,fjac,ldfjac,iflag)

    use oakleaf

    integer, intent(in) :: m,np,ldfjac
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
    real(dbl), dimension(:), allocatable :: rs,f,df,r
    integer :: n,i,l
    real(dbl) :: phi, beta

    if( iflag == 0 ) then
       write(*,'(6g12.3)') p,fvec

       if( .true. ) then
          write(*,*) ' jac:',real(fjac(1,:))
          write(*,*) ' jac:',real(fjac(2,:))
          write(*,*) ' jac:',real(fjac(3,:))
       end if

       return
    end if

    n = naper - nref + 1
    allocate(rs(n),f(n),df(n),r(n))

    phi = p(1)
    beta = p(2)

    do i = 1,n
       l = i + nref - 1
       r(i) = raper(l)
       rs(i) = (phi + beta*aper(l) - grow(l)) / sig
       f(i) = huber(rs(i))
    end do
!    f = r

    if( iflag == 1 ) then

       fvec(1) = sum(f)
       fvec(2) = sum(f*r**2)*pi
       fvec = fvec / sig

    else if( iflag == 2 ) then

       df = dhuber(rs)
!       df = 1

       fjac(1,1) = sum(df)
       fjac(1,2) = sum(df*r**2)*pi
       fjac(2,2) = sum(df*r**4)*pi**2

       fjac(2,1) = fjac(1,2)
       fjac = fjac / sig**2

    end if

    deallocate(rs,f,df,r)

  end subroutine backder


  subroutine arc_update(flux,phi,beta,a,b)

    use oakleaf
    use neldermead
    use minpacks

    real(dbl), dimension(:), intent(in) :: flux, phi, beta
    real(dbl), intent(in out) :: a,b
    real(dbl), dimension(3) :: p,dp,p1
    real(dbl), dimension(:), allocatable :: res
    integer :: ifault,info,nprint,i,l,n
    real(dbl) :: s,g,e

    do n = 1,nstar
       do i = nref,naper
          grows(n,i) = cts(n,i) / flux(n) - phi(n) - beta(n)*aper(i)
       end do
       s = median(dcts(n,nref:naper))
       sigs(n) = s / flux(n) + approxerr
!       write(*,*) n,s,sigs(n)
    end do

    p(1) = a / raper(naper)
    p(2) = b / raper(naper)**2
    p(3) = 0

    dp = 1e-4
    lambda = 1e-4
    do i = 1,50
       call nelmin1(arcupdate,p,dp,s,ifault)
       if( debug ) &
            write(*,'(2f12.5,es12.2,i3)') p(1)*raper(naper),p(2)*raper(naper)**2,&
            p(3),ifault
       if( all(p(1:2) > 0) .and. all(abs(p(1:2)-p1(1:2)) < 1e-7) ) exit
       p1 = p
       lambda = 2*lambda
    end do
!    a = p(1)*raper(naper)
!    b = p(2)*raper(naper)**2
!    return

    if( ifault == 0 ) then
       a = p(1)
       b = p(2)
       e = p(3)
    else
       a = p(1)*raper(naper)
       b = p(2)*raper(naper)**2
       e = p(3)
       return
    end if

    l = 0
    allocate(res(naper*nstar))
    do n = 1,nstar
       do i = nref, naper
          g = 1 - e - (a + b/radius(i))/radius(i)
          l = l + 1
          res(l) = abs(grows(n,i) - g) / sigs(n)
       end do
    end do
    s = median(res(1:l))
    sig = s / 0.6745 + approxerr
    deallocate(res)
    if( debug ) write(*,*) 'sig,s:',real(sig),real(s)

    lambda = 1e-4
    do i = 1,50
       call nelmin1(archuber,p,dp,s,ifault)
       if( debug ) &
            write(*,'(2f12.5,es12.2,i3)') p(1)*raper(naper),p(2)*raper(naper)**2,&
            p(3),ifault
       if( all(p(1:2) > 0) .and. all(abs(p(1:2)-p1(1:2)) < 1e-7) ) exit
       p1 = p
       lambda = 2*lambda
    end do
    if( ifault == 0 ) then
       a = p(1)*raper(naper)
       b = p(2)*raper(naper)**2
       return
    end if

    nprint = 0
    lambda = 1e-4
    do i = 1,50*0
       call lmder2(arcder,p,epsilon(p),nprint,info)
       !    call lmdif2(backdif,p,epsilon(p),nprint,info)
       write(*,'(2f12.5,es12.2,i3)') p(1)*raper(naper),p(2)*raper(naper)**2,&
            p(3),info
       if( all(p(1:2) > 0) .and. all(abs(p(1:2)-p1(1:2)) < 1e-7) ) exit
       p1 = p
       lambda = 2*lambda
    end do

    if( info == 2 ) then
       a = p(1)*raper(naper)
       b = p(2)*raper(naper)**2
    end if

  end subroutine arc_update


 function arcupdate(p) result(s)

    real(dbl), dimension(:), intent(in) :: p

    real(dbl) :: s,g,a,b,e
    integer :: i,n

    a = p(1)
    b = p(2)
    e = p(3)

    s = 0
    do n = 1,nstar
       do i = nref, naper
          g = 1 - e - (a + b/radius(i))/radius(i)
          s = s + abs(g - grows(n,i)) / sigs(n)
       end do
    end do
    s = s / (nstar*(naper - nref + 1)) + lambda*(max(0.0,-a) + max(0.0,-b) + max(0.0,-e) + abs(e))

  end function arcupdate

  function archuber(p) result(s)

    use oakleaf

    real(dbl), dimension(:), intent(in) :: p

    real(dbl) :: s,g,a,b,e
    integer :: i,n

    a = p(1)
    b = p(2)
    e = p(3)

    s = 0
    do n = 1,nstar
       do i = nref, naper
          g = 1 - e - (a + b/radius(i))/radius(i)
          !          s = s + abs(grows(n,i) - g) / sigs(n)
          s = s + ihuber((g - grows(n,i)) / (sigs(n)*sig))
!          write(*,*) (g - grows(n,i)) / sigs(n),n,i,'666'
       end do
    end do
!    s = s / (nstar*(naper - nref + 1)) + lambda*(max(0.0,-a)**2 + max(0.0,-b)**2 + max(0.0,-e)**2 + e**2)
    s = s / (nstar*(naper - nref + 1)) &
         + lambda*(smooth_max(a)**2 + smooth_max(b)**2 + smooth_max(e)**2)
!stop
  end function archuber


  subroutine arcder(mp,np,p,fvec,fjac,ldfjac,iflag)

    use oakleaf

    integer, intent(in) :: mp,np,ldfjac
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(mp), intent(out) :: fvec
    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
    real(dbl), dimension(:,:), allocatable :: rs,f,df
    real(dbl), dimension(:), allocatable :: r,s
!    real(dbl), dimension(3,3) :: dfjac
    integer :: n,m,i,j,l
    real(dbl) :: a,b,e

    if( iflag == 0 ) then
       write(*,'(6g12.3)') p,fvec

       if( .true. ) then
          write(*,*) ' jac:',real(fjac(1,:))
          write(*,*) ' jac:',real(fjac(2,:))
          write(*,*) ' jac:',real(fjac(3,:))

!          call difjac(p(1),p(2),dfjac)
!          write(*,*) 'djac:',dfjac(1,:)
!          write(*,*) 'djac:',dfjac(2,:)

       end if

       return
    end if

    m = naper - nref + 1
    n = nstar
    allocate(rs(n,m),f(n,m),df(n,m),r(m),s(n))
    a = p(1)
    b = p(2)
    e = p(3)

    r = radius(nref:naper)

    do n = 1,nstar
       do l = 1, m
          i = l + nref - 1
          s(n) = sigs(n)*sig
          rs(n,l) = (1 - e - (a + b/r(l))/r(l) - grows(n,i)) / s(n)
          f(n,l) = huber(rs(n,l))
       end do
    end do
    f = rs

    if( iflag == 1 ) then

       fvec = 0
       do n = 1,nstar
          fvec(1) = fvec(1) + sum(f(n,:)/r) / s(n)
          fvec(2) = fvec(2) + sum(f(n,:)/r**2) / s(n)
          fvec(3) = fvec(3) + sum(f(n,:)) / s(n)
       end do
       fvec = - fvec - lambda*(/ smooth_max(a), smooth_max(b), smooth_max(e) /)

!       write(*,*) real(fvec)

    else if( iflag == 2 ) then

       do n = 1, nstar
          df(n,:) = dhuber(rs(n,:))
       end do
       df = 1

       fjac = 0
       do n = 1,nstar
          fjac(1,1) = fjac(1,1) + sum(df(n,:)/r**2) / s(n)**2
          fjac(1,2) = fjac(1,2) + sum(df(n,:)/r**3) / s(n)**2
          fjac(1,3) = fjac(1,3) + sum(df(n,:)/r) / s(n)**2
          fjac(2,2) = fjac(2,2) + sum(df(n,:)/r**4) / s(n)**2
          fjac(2,3) = fjac(2,3) + sum(df(n,:)/r**2) / s(n)**2
          fjac(3,3) = fjac(3,3) + sum(df(n,:)) / s(n)**2
       end do
       do i = 1,3
          do j = 1,i-1
             fjac(i,j) = fjac(j,i)
          end do
       end do

       fjac(1,1) = fjac(1,1) + lambda*smooth_step(a)
       fjac(2,2) = fjac(2,2) + lambda*smooth_step(b)
       fjac(3,3) = fjac(3,3) + lambda*smooth_step(e)

    end if

    deallocate(rs,f,df,r,s)

  end subroutine



    subroutine arc_update1(flux,phi,beta,b)

    use neldermead
    use minpacks
    use oakleaf

    real(dbl), dimension(:), intent(in) :: flux, phi, beta
    real(dbl), intent(in out) :: b
    real(dbl), dimension(2) :: p,dp,p1
    real(dbl), dimension(:), allocatable :: res
    integer :: ifault,info,nprint,i,l,n
    real(dbl) :: s,g,e

    do n = 1,nstar
       do i = nref,naper
          grows(n,i) = cts(n,i) / flux(n) - phi(n) - beta(n)*aper(i)
       end do
       s = median(dcts(n,nref:naper))
       sigs(n) = s / flux(n) + approxerr
!       write(*,*) n,s,sigs(n)
    end do

    p(1) = b / raper(naper)**2
    p(2) = 0

    dp = 1e-4
    lambda = 1e-4
    do i = 1,50
       call nelmin1(arcupdate1,p,dp,s,ifault)
       if( debug ) &
            write(*,'(f12.5,es12.2,i3)') p(1)*raper(naper)**2,p(2),ifault
       if( all(p(1:2) > 0) .and. all(abs(p(1:2)-p1(1:2)) < 1e-7) ) exit
       p1 = p
       lambda = 2*lambda
    end do

    if( ifault == 0 ) then
       b = p(1)
       e = p(2)
    else
       b = p(1)*raper(naper)**2
       e = p(2)
       return
    end if

    l = 0
    allocate(res(naper*nstar))
    do n = 1,nstar
       do i = nref, naper
          g = 1 - e - b/radius(i)**2
          l = l + 1
          res(l) = abs(grows(n,i) - g) / sigs(n)
       end do
    end do
    s = median(res(1:l))
    sig = s / 0.6745 + approxerr
    deallocate(res)
    if( debug ) write(*,*) 'sig,s:',real(sig),real(s)

    lambda = 1e-4
    do i = 1,50
       call nelmin1(archuber1,p,dp,s,ifault)
       if( debug ) &
            write(*,'(f12.5,es12.2,i3)') p(1)*raper(naper)**2,p(2),ifault
       if( all(p(1:2) > 0) .and. all(abs(p(1:2)-p1(1:2)) < 1e-7) ) exit
       p1 = p
       lambda = 2*lambda
    end do
    b = p(1)*raper(naper)**2
    return

!!$    nprint = 0
!!$    lambda = 1e-4
!!$    do i = 1,50*0
!!$       call lmder2(arcder,p,epsilon(p),nprint,info)
!!$       !    call lmdif2(backdif,p,epsilon(p),nprint,info)
!!$       write(*,'(2f12.5,es12.2,i3)') p(1)*raper(naper),p(2)*raper(naper)**2,&
!!$            p(3),info
!!$       if( all(p(1:2) > 0) .and. all(abs(p(1:2)-p1(1:2)) < 1e-7) ) exit
!!$       p1 = p
!!$       lambda = 2*lambda
!!$    end do
!!$
!!$    if( info == 2 ) then
!!$       a = p(1)*raper(naper)
!!$       b = p(2)*raper(naper)**2
!!$    end if

  end subroutine arc_update1


 function arcupdate1(p) result(s)

    real(dbl), dimension(:), intent(in) :: p

    real(dbl) :: s,g,b,e
    integer :: i,n

    b = p(1)
    e = p(2)

    s = 0
    do n = 1,nstar
       do i = nref, naper
          g = 1 - e - b/radius(i)**2
          s = s + abs(g - grows(n,i)) / sigs(n)
       end do
    end do
    s = s / (nstar*(naper - nref + 1)) + lambda*(max(0.0,-b) + max(0.0,-e))

  end function arcupdate1

  function archuber1(p) result(s)

    use oakleaf

    real(dbl), dimension(:), intent(in) :: p

    real(dbl) :: s,g,b,e
    integer :: i,n

    b = p(1)
    e = p(2)

    s = 0
    do n = 1,nstar
       do i = nref, naper
          g = 1 - e - b/radius(i)**2
          !          s = s + abs(grows(n,i) - g) / sigs(n)
          s = s + ihuber((g - grows(n,i)) / (sigs(n)*sig) )
!          write(*,*) (g - grows(n,i)) / sigs(n),n,i,'666'
       end do
    end do
!    s = s / (nstar*(naper - nref + 1)) + lambda*(max(0.0,-b)**2 + max(0.0,-e)**2)
    s = s / (nstar*(naper - nref + 1)) &
         + lambda*(smooth_max(b)**2 + smooth_max(e)**2)

  end function archuber1





  subroutine arc_init(flux,b)

    ! initialise arc of grow curve

    use fmm
    use oakleaf

    real(dbl), dimension(:), intent(in) :: flux
    real(dbl), intent(out) :: b

    real(dbl) :: tol,bmax,bmin,s,x
    integer :: n,i

    bmax = 0
    do n = 1,nstar
       do i = naper-1,nref,-1
          x = 1/radius(i+1)**1 - 1/radius(i)**1
          grows(n,i) = (cts(n,i+1) - cts(n,i)) / flux(n)
          s = grows(n,i) / x
          if( s > bmax ) bmax = s
       end do
       s = median(dcts(n,nref:naper)) / 0.6745
       sigs(n) = s / flux(n) + approxerr
       ! added function approximation error
    end do

    tol = 1e-7
    bmin = 0 !epsilon(b)
!    bmax = 1.0/20.**2!00
    !    bmax = maxval(grows(n,nref:naper-1)/
    bmax = max(bmax,bmin+tol)
    b = fmin(bmin,bmax,arcfun,tol)
!    write(*,*) bmin,b,bmax
    b = b*raper(naper)**2

  end subroutine arc_init

  function arcfun(b) result(s)

    real(dbl), intent(in) :: b

    real(dbl) :: s,g,x,y
    integer :: i,n

    s = 0
    do n = 1,nstar
       do i = nref, naper - 1
          x = 1/radius(i+1)**1 - 1/radius(i)**1
          y = 1/radius(i+1)**2 - 1/radius(i)**2
          g = -b*x
          s = s + abs(grows(n,i) - g) / sigs(n)
          !          write(*,*) grows(n,i) - g,(grows(n,i) - g) / sigs(n),i,n
!          write(*,*) -x,y,grows(n,i),i,n,'RR'
       end do
    end do
    s = s / (nstar*(naper - nref))

  end function arcfun


  subroutine arc_init1(flux,a,b)

    ! initialise arc of grow curve

    use neldermead
    use oakleaf

    real(dbl), dimension(:), intent(in) :: flux
    real(dbl), intent(out) :: a,b

    real(dbl) :: s,x
    real(dbl), dimension(3) :: p,dp,p1
    integer :: n,i,ifault

    do n = 1,nstar
       do i = naper-1,nref,-1
          x = 1/radius(i+1)**2 - 1/radius(i)**2
          grows(n,i) = (cts(n,i+1) - cts(n,i)) / flux(n)
       end do
       s = median(dcts(n,nref:naper)) / 0.6745
       sigs(n) = s / flux(n) + approxerr
       ! added function approximation error
    end do

    p(1) = 0
    p(2) = 0
    p(3) = 0

    dp = 1e-4
    lambda = 1e-4
    p1 = huge(p)
    do i = 1,50
       call nelmin1(arcinit1,p,dp,s,ifault)
!       write(*,*) real(p)
       if( all(p > 0) .and. all(abs(p - p1) < 1e-7) ) exit
       lambda = 2*lambda
       p1 = p
    end do

    a = p(1)*raper(naper)
    b = p(2)*raper(naper)**2

  end subroutine arc_init1

  function arcinit1(p) result(s)

    real(dbl), dimension(:), intent(in) :: p

    real(dbl) :: s,g,x,y,b,a,e
    integer :: i,n

    a = p(1)
    b = p(2)
    e = p(3)

    s = 0
    do n = 1,nstar
       do i = nref, naper - 1
          x = 1/radius(i+1)    - 1/radius(i)
          y = 1/radius(i+1)**2 - 1/radius(i)**2
          g = -b*y - a*x + e
          s = s + abs(grows(n,i) - g) / sigs(n)
          !          write(*,*) grows(n,i) - g,(grows(n,i) - g) / sigs(n),i,n
!          write(*,*) -x,grows(n,i),i,n,'RR'
       end do
    end do
    s = s / (nstar*(naper - nref)) + lambda*(max(0.0,-a) + max(0.0,-b)+max(0.0,-e))
!    stop

  end function arcinit1


  function smooth_step(x) result(f)

    ! negative logistics function: 1 - 1/(1 + exp(-x)):  _
    !         it is smooth equivalent of step function:   |_

    real(dbl), intent(in) :: x
    real(dbl), parameter :: s = epsilon(1.0) ! the same as in isigmoid
    real(dbl), parameter :: ehuge = log(huge(1.0)) / 10
    real(dbl) :: f

    if( abs(x)/s < ehuge ) then
       f = 1 / (1 + exp((x-s)/s))
    else
       if( x < 0 ) then
          f = 1
       else
          f = 0
       end if
    end if

  end function smooth_step

  function smooth_max(x) result(f)

    ! integral of negative logistics function: int(1 - 1/(1 + exp(-x))) = log(1+exp(-x))
    ! it is smooth equivalent of max(0,-x): \_

    real(dbl), intent(in) :: x
    real(dbl), parameter :: s = epsilon(1.0) ! the same as in nsigmoid
    real(dbl), parameter :: ehuge = log(huge(1.0)) / 10
    real(dbl) :: f

    if( abs(x)/s < ehuge ) then
       f = log(1 + exp(-(x-s)/s))
    else
       if( x < 0 ) then
          f = -x
       else
          f = 0
       end if
    end if

  end function smooth_max



!---------------------------------------------------------------------------


!!$  subroutine arc_inits1(flux0,b,e,beta)
!!$
!!$    ! initialise arc of grow curve
!!$
!!$    use minpacks
!!$    use robustmean
!!$    use neldermead
!!$
!!$    real(dbl), dimension(:), intent(in) :: flux0
!!$    real(dbl), intent(in out) :: b,e
!!$    real(dbl), dimension(:), intent(in out) :: beta
!!$    real(dbl), dimension(3) :: p,dp,p1
!!$    real(dbl), dimension(:), allocatable :: dd,x,y,z
!!$    real(dbl) :: c,d,s,g,fmax,fmin,a
!!$    integer :: info,nprint,i,n,ifault,m,l
!!$
!!$!    nstar = 10
!!$
!!$    fmin = minval(cts(:,nref)/flux0)
!!$    fmax = maxval(cts(:,naper)/flux0)
!!$    c = fmax - fmin
!!$!    c = 1
!!$    ! remove c
!!$
!!$    do n = 1,nstar
!!$       do i = naper-1,nref,-1
!!$          grows(n,i) = (cts(n,i+1) - cts(n,i)) / flux0(n) / c
!!$!          grows(n,i) = sqrt(cts(n,i+1)/flux0(n)) - sqrt(cts(n,i) / flux0(n))
!!$!          write(*,*) i,i+1,grows(n,i),'QQ'
!!$       end do
!!$       call rinit(dcts(n,nref:naper)/c,d,s)
!!$!       d = d / 0.6745
!!$!       write(*,*) dcts(n,nhwhm) / flux0(n),sqrt(cts(1,nhwhm))/flux0(n),d/flux0(n)
!!$       !       dgrows(n,:) = sqrt(dcts(n,nref)**2 + cts(n,nref)) / flux0(n)
!!$       dgrows(n,:) = d / flux0(n) + approxerr
!!$       ! added function approximation error
!!$!       write(*,*) real(d/flux0(n)),real(dgrows(n,1))
!!$    end do
!!$!    call rinit(pack(abs(grows(:,nref:naper-1)),.true.),sig,s)
!!$!    dgrows(:,nhwhm) = sqrt(sig**2 + dgrows(:,nhwhm)**2)
!!$
!!$!    fmin = minval(grows(:,nref:naper-1))
!!$!    fmax = maxval(grows(:,nref:naper-1))
!!$!    grows(:,nref:naper-1) = (grows(:,nref:naper-1) - fmin) / d
!!$!    dgrows(:,nref:naper-1) = dgrows(:,nref:naper-1) / d
!!$
!!$    p(1) = a / raper(naper)
!!$    p(2) = b / raper(naper)**2
!!$!    p(3) = 0
!!$!    p(4) = 0
!!$!    p(3:) = beta*(pi*raper(naper)**2)/flux0
!!$
!!$    p = 0
!!$
!!$    dp = 1e-4
!!$!    dp(3) = 1e-7
!!$!    dp(1:2) = 1e-4
!!$    lambda = 1e-4
!!$!    back = 0
!!$    do i = 1,50
!!$       call nelmin1(arcfuns2,p,dp,s,ifault)
!!$       write(*,'(2f15.5,es10.2,f15.5,f10.3)') p(1)*raper(naper)**2*c,p(2)*c!raper(naper)*c, &
!!$!            p(2)*c!,sum(abs(p(1:)))/nstar
!!$       if( all(p(1:2) > 0) .and. all(abs(p(1:2)-p1(1:2)) < 1e-7) ) exit
!!$!       if( all(p(1:2) > 0) .and. all(abs(p(1:2)-p1(1:2)) < 1e-7) .and. &
!!$!            sum(abs(back-p(3:)))/nstar < 0.001 ) exit
!!$!       back = p(3:)
!!$       p1 = p
!!$       lambda = 2*lambda
!!$    end do
!!$!    e = p(2)
!!$!    b = p(1)
!!$
!!$    m = naper - nref
!!$    allocate(dd(m),x(m),y(m),z(m))
!!$
!!$    do l = 1, m
!!$       i = l + nref - 1
!!$       x(l) = 1/radius(i) -    1/radius(i+1)
!!$       y(l) = 1/radius(i)**2 - 1/radius(i+1)**2
!!$!       z(l) = radius(i+1)**2 - radius(i)**2
!!$    end do
!!$
!!$    do n = 1,nstar
!!$       do i = 1,m
!!$          g = a*x(i) + b*y(i)
!!$          dd(i) = abs(grows(n,i+nref-1) - g)
!!$!          write(*,*) g,grows(n,i+nref-1)
!!$       end do
!!$       call rinit(dd,d,s)
!!$!       write(*,*) real(dd)
!!$!       stop
!!$       dgrows(n,:) = d / 0.6745 + approxerr
!!$    end do
!!$    deallocate(dd,x,y,z)
!!$    !stop
!!$
!!$    ! je to rozumne vzheledem k systematickym chybam?
!!$    nprint = 0
!!$    p1 = p
!!$    lambda = lambda / 10
!!$    do i = 1,50*0
!!$       !call lmder2(initfun,p,epsilon(p),nprint,info)
!!$       call lmdif2(inidfun1,p,epsilon(p),nprint,info)
!!$       write(*,'(e15.5,3f19.7)') p(1)*raper(naper)*c,p(2)*raper(naper)**2*c, &
!!$            p(2)/(pi*raper(naper)**2)*c
!!$       if( all(p(1:2) > 0) .and. all(abs(p(1:2)-p1(1:2)) < 1e-5) ) exit
!!$       lambda = 2*lambda
!!$       p1 = p
!!$!       back = p(3:)
!!$    end do
!!$
!!$    a = p(1)*raper(naper)*c
!!$    b = p(2)*raper(naper)**2*c
!!$    a = 0
!!$    b = p(1)*raper(naper)**2*c
!!$    a = p(2)*c
!!$    b = p(1)*raper(naper)**2*c
!!$
!!$
!!$  end subroutine arc_inits1
!!$
!!$  function arcfuns2(p) result(s)
!!$
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl), dimension(:), allocatable :: x,y,z,sig
!!$    real(dbl) :: s,a,b,g,t,f2,r,sbeta,q
!!$    integer :: l,i,n,m
!!$
!!$    m = naper - nref
!!$    n = nstar
!!$    allocate(x(m),y(m),z(m),sig(n))
!!$
!!$    b = p(1)
!!$    a = p(2)
!!$    q = p(3)
!!$!    sbeta = p(2)
!!$    !    sbeta = 0
!!$!    q = 0
!!$    sig = dgrows(1:nstar,nhwhm)
!!$
!!$    do l = 1, m
!!$       i = l + nref - 1
!!$       x(l) = 1/radius(i) -    1/radius(i+1)
!!$       y(l) = 1/radius(i)**2 - 1/radius(i+1)**2
!!$       z(l) = radius(i+1)**2 - radius(i)**2
!!$    end do
!!$
!!$    s = 0
!!$    do n = 1,nstar
!!$       do i = 1, m
!!$!          g = b*y(i) + sbeta*z(i) + q!*radius(i+nref-1)
!!$          g = a*x(i) + b*y(i) + q
!!$!          write(*,'(6g12.2)') x(i),y(i),grows(n,i+nref-1) - g,sig(n)
!!$          s = s + abs(grows(n,i+nref-1) - g) / sig(n)
!!$       end do
!!$    end do
!!$
!!$    s = s / (m*n) + lambda*(max(0.0,-b) + max(0.0,-a) + abs(sbeta)*0)
!!$!    s = s / (m*n) + lambda*max(0.0,-b)
!!$
!!$    deallocate(x,y,z,sig)
!!$
!!$ end function arcfuns2
!!$
!!$
!!$ function arcfuns1(p) result(s)
!!$
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl), dimension(:), allocatable :: x,y,z,sig
!!$    real(dbl) :: s,a,b,g,t,f2,r,sbeta,q
!!$    integer :: l,i,n,m
!!$
!!$    m = naper - nref
!!$    n = nstar
!!$    allocate(x(m),y(m),z(m),sig(n))
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$    sbeta = p(3)
!!$    q = p(4)
!!$!    beta = p(3:)
!!$    sig = dgrows(1:nstar,nhwhm)
!!$
!!$    do l = 1, m
!!$       i = l + nref - 1
!!$       x(l) = 1/radius(i) -    1/radius(i+1)
!!$       y(l) = 1/radius(i)**2 - 1/radius(i+1)**2
!!$       z(l) = radius(i+1)**2 - radius(i)**2
!!$    end do
!!$
!!$    s = 0
!!$    do n = 1,nstar
!!$       do i = 1, m
!!$          g = a*x(i) + b*y(i) + sbeta*z(i) + q*radius(i+nref-1)
!!$!          write(*,'(6g12.2)') x(i),y(i),grows(n,i+nref-1) - g,sig(n)
!!$          s = s + abs(grows(n,i+nref-1) - g) / sig(n)
!!$       end do
!!$    end do
!!$
!!$    f2 = 0
!!$    do i = nref+1,naper
!!$       r = (radius(i) + radius(i-1))/2
!!$       f2 = f2 + 2*(a + 3*b/r)/r**3 * (radius(i) - radius(i-1))
!!$    end do
!!$
!!$    s = s / (m*n) + lambda*(max(0.0,-a) + max(0.0,-b) + max(0.0,-q))
!!$
!!$    deallocate(x,y,z,sig)
!!$
!!$ end function arcfuns1
!!$
!!$  subroutine inidfun1(mm,np,p,fvec,iflag)
!!$
!!$    use rfun
!!$
!!$    integer, intent(in) :: mm,np
!!$    integer, intent(in out) :: iflag
!!$    real(dbl), dimension(np), intent(in) :: p
!!$    real(dbl), dimension(mm), intent(out) :: fvec
!!$    real(dbl), dimension(:), allocatable :: beta,x,y,z,s
!!$    real(dbl), dimension(:,:), allocatable :: rs,f
!!$    real(dbl) :: a,b,g
!!$    integer :: n,m,i,j,l
!!$
!!$    if( iflag == 0 ) then
!!$       write(*,'(2g13.5)') p
!!$       write(*,'(2g13.5)') fvec
!!$       return
!!$    end if
!!$
!!$    m = naper - nref
!!$    n = nstar
!!$    allocate(rs(n,m),f(n,m),x(m),y(m),z(m),beta(n),s(n))
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$    s = dgrows(1:nstar,nhwhm)
!!$
!!$    do l = 1, m
!!$       i = l + nref - 1
!!$       x(l) = 1/radius(i) -    1/radius(i+1)
!!$       y(l) = 1/radius(i)**2 - 1/radius(i+1)**2
!!$!       z(l) = radius(i+1)**2 - radius(i)**2
!!$    end do
!!$
!!$    do n = 1,nstar
!!$       do i = 1, m
!!$          g = a*x(i) + b*y(i)
!!$          rs(n,i) = (grows(n,i+nref-1) - g) / s(n)
!!$          f(n,i) = huber(rs(n,i))
!!$!          if( n == 1 ) &
!!$!          write(*,'(i2,8f15.5)') i,rs(n,i),f(n,i),g,grows(n,i+nref-1),s(n)
!!$       end do
!!$    end do
!!$    f = rs
!!$
!!$    fvec(1:2) = 0
!!$    do n = 1,nstar
!!$       fvec(1) = fvec(1) + sum(f(n,:)*x) / s(n)
!!$       fvec(2) = fvec(2) + sum(f(n,:)*y) / s(n)
!!$    end do
!!$!    forall( n = 1:nstar )
!!$!       fvec(2+n) = sum(f(n,:)*z) / s(n) - lambda*(beta(n) - back(n))
!!$!    end forall
!!$
!!$    fvec(1) = fvec(1) - lambda*isigmoid(a)
!!$    fvec(2) = fvec(2) - lambda*isigmoid(b)
!!$
!!$    fvec = - fvec
!!$
!!$    deallocate(rs,f,x,y,z,beta,s)
!!$
!!$  end subroutine inidfun1
!!$
!!$  subroutine arc_inits(flux0,beta,a,b)
!!$
!!$    ! initialise arc of grow curve
!!$
!!$    use minpacks
!!$    use robustmean
!!$    use neldermead
!!$
!!$    real(dbl), dimension(:), intent(in) :: flux0
!!$    real(dbl), dimension(:), intent(in) :: beta
!!$    real(dbl), intent(in out) :: a,b
!!$    real(dbl), dimension(2) :: p,dp,p1
!!$    real(dbl), dimension(:), allocatable :: dd,x,y,z
!!$    real(dbl) :: c,d,s,g,fmax,fmin
!!$    integer :: info,nprint,i,n,ifault,m,l
!!$
!!$!    nstar = 10
!!$
!!$    fmin = minval(cts(:,nref)/flux0)
!!$    fmax = maxval(cts(:,naper)/flux0)
!!$    c = fmax - fmin
!!$!    c = 1
!!$    ! remove c
!!$
!!$    do n = 1,nstar
!!$       do i = nref,naper
!!$          grows(n,i) = (cts(n,i) / flux0(n) - beta(n)*aper(i))  / c
!!$!          grows(n,i) = ((cts(n,i+1) - cts(n,i)) / flux0(n) - beta(n)*(aper(i+1) - aper(i)))  / c
!!$!          grows(n,i) = sqrt(cts(n,i+1)/flux0(n)) - sqrt(cts(n,i) / flux0(n))
!!$!                    write(*,*) raper(i),grows(n,i),n,'ee'
!!$       end do
!!$       call rinit(dcts(n,nref:naper)/c,d,s)
!!$!       d = d / 0.6745
!!$!       write(*,*) dcts(n,nhwhm) / flux0(n),sqrt(cts(1,nhwhm))/flux0(n),d/flux0(n)
!!$       !       dgrows(n,:) = sqrt(dcts(n,nref)**2 + cts(n,nref)) / flux0(n)
!!$       dgrows(n,:) = d / flux0(n) + approxerr
!!$       ! added function approximation error
!!$!       write(*,*) real(d/flux0(n)),real(dgrows(n,1))
!!$    end do
!!$!    call rinit(pack(abs(grows(:,nref:naper-1)),.true.),sig,s)
!!$!    dgrows(:,nhwhm) = sqrt(sig**2 + dgrows(:,nhwhm)**2)
!!$
!!$!    fmin = minval(grows(:,nref:naper-1))
!!$!    fmax = maxval(grows(:,nref:naper-1))
!!$!    grows(:,nref:naper-1) = (grows(:,nref:naper-1) - fmin) / d
!!$!    dgrows(:,nref:naper-1) = dgrows(:,nref:naper-1) / d
!!$
!!$!    p(1) = a / raper(naper) / c
!!$!    p(2) = b / raper(naper)**2 / c
!!$!    p(3) = 0
!!$!    p(4) = 0
!!$!    p(3:) = beta*(pi*raper(naper)**2)/flux0
!!$
!!$    p(1) = 0
!!$    p(2) = b / raper(naper)**2 / c
!!$!    p(3) = 0
!!$
!!$    par_t = c
!!$    dp = 1e-4
!!$!    dp(1:2) = 1e-4
!!$    lambda = 1e-4
!!$!    back = 0
!!$    do i = 1,50
!!$       call nelmin1(arcfuns,p,dp,s,ifault)
!!$       write(*,'(2f15.5,es10.2,f15.5,f10.3)') p(1)*raper(naper)*c,p(2)*raper(naper)**2*c!, &
!!$!            p(3)*c,sum(abs(back-p(3:)))/nstar,lambda
!!$!       if( all(p(1:2) > 0) .and. all(abs(p(1:2)-p1(1:2)) < 1e-7) .and. &
!!$!            sum(abs(back-p(3:)))/nstar < 0.001 ) exit
!!$       if( all(p(1:2) > 0) .and. all(abs(p(1:2)-p1(1:2)) < 1e-7) ) exit
!!$!       back = p(3:)
!!$       p1 = p
!!$       lambda = 2*lambda
!!$    end do
!!$    write(*,'(2f15.5)') p(1)*c,p(2)*raper(naper)**2*c
!!$    b = p(2)*raper(naper)**2
!!$    return
!!$    stop
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$!    beta = p(3:)
!!$
!!$    m = naper - nref
!!$    allocate(dd(m),x(m),y(m),z(m))
!!$
!!$    do l = 1, m
!!$       i = l + nref - 1
!!$       x(l) = 1/radius(i) -    1/radius(i+1)
!!$       y(l) = 1/radius(i)**2 - 1/radius(i+1)**2
!!$       z(l) = radius(i+1)**2 - radius(i)**2
!!$    end do
!!$
!!$    do n = 1,nstar
!!$       do l = 1,m
!!$          i = l + nref - 1
!!$          g = beta(n)*z(l) + a*x(l) + b*y(l)
!!$          dd(l) = abs(grows(n,i) - g)
!!$       end do
!!$       call rinit(dd,d,s)
!!$       dgrows(n,:) = d / 0.6745 + approxerr
!!$    end do
!!$    deallocate(dd,x,y,z)
!!$
!!$    nprint = 0
!!$    p1 = p
!!$    lambda = lambda / 10
!!$    do i = 1,50
!!$       !call lmder2(initfun,p,epsilon(p),nprint,info)
!!$       call lmdif2(inidfun,p,epsilon(p),nprint,info)
!!$!       write(*,'(e15.5,3f19.7)') p(1)*raper(naper)*c,p(2)*raper(naper)**2*c, &
!!$!            p(3)/(pi*raper(naper)**2)*c,sum(abs(back-p(3:)))/nstar
!!$!       if( all(p(1:2) > 0) .and. all(abs(p(1:2)-p1(1:2)) < 1e-5) .and. &
!!$!            sum(abs(back-p(3:)))/nstar < 0.001 ) exit
!!$       lambda = 2*lambda
!!$       p1 = p
!!$       back = p(3:)
!!$    end do
!!$
!!$    a = p(1)*raper(naper)*c
!!$    b = p(2)*raper(naper)**2*c
!!$!    beta = p(3:)*flux0/(pi*raper(naper)**2)*c
!!$!    beta = p(3:)/(pi*raper(naper)**2)*c
!!$
!!$!    write(*,'(2f12.5,i3,a)') a,b,info,' rrr'
!!$!    write(*,*) real(p(3)*flux0/pi/raper(naper)**2)
!!$!    write(*,'(5000f10.2)') beta(1:nstar)
!!$!    write(*,*) ifault
!!$!    stop
!!$
!!$  end subroutine arc_inits
!!$
!!$
!!$ function arcfuns(p) result(s)
!!$
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl), dimension(:), allocatable :: beta,x,y,z,sig
!!$    real(dbl) :: s,a,b,g,f2,r,sbeta,q
!!$    integer :: l,i,n,m
!!$
!!$    m = naper - nref
!!$    n = nstar
!!$    allocate(x(m),y(m),z(m),beta(n),sig(n))
!!$
!!$    a = 0
!!$    q = p(1)
!!$    b = p(2)
!!$    !    sbeta = p(3)
!!$    sbeta = 0
!!$!    q = p(4)
!!$!    beta = p(3:)
!!$    sig = dgrows(1:nstar,nhwhm)
!!$
!!$    do l = 1, m
!!$       i = l + nref - 1
!!$       x(l) = 1/radius(i) -    1/radius(i+1)
!!$       y(l) = 1/radius(i)**2 - 1/radius(i+1)**2
!!$!       z(l) = radius(i+1)**2 - radius(i)**2
!!$    end do
!!$
!!$    s = 0
!!$    do n = 1,nstar
!!$       !       do i = 1, m
!!$       do i = nref, naper
!!$          !          g = a*x(i) + b*y(i)
!!$          g = 1 - q - (a/radius(i) + b/radius(i)**2) + sbeta*radius(i)**1
!!$!          write(*,'(6g12.2)') z(i),x(i),y(i),grows(n,i+nref-1) - g,sig(n)
!!$!          s = s + abs(grows(n,i+nref-1) - g) / sig(n)
!!$          s = s + abs(grows(n,i) - g /par_t) / sig(n)
!!$       end do
!!$    end do
!!$
!!$    f2 = 0
!!$    do i = nref+1,naper
!!$       r = (radius(i) + radius(i-1))/2
!!$       f2 = f2 + 2*(a + 3*b/r)/r**3 * (radius(i) - radius(i-1))
!!$    end do
!!$
!!$    s = s / (m*n) + lambda*(max(0.0,-a)*0 + max(0.0,-b) + max(0.0,-q))
!!$
!!$!    s = s / (m*n) + lambda*(max(0.0,-a) + max(0.0,-b)) !+ sum(abs(beta-back)))
!!$
!!$    deallocate(x,y,z,beta,sig)
!!$
!!$ end function arcfuns
!!$
!!$
!!$
!!$  subroutine initfun(mm,np,p,fvec,fjac,ldfjac,iflag)
!!$
!!$    use rfun
!!$
!!$    integer, intent(in) :: mm,np,ldfjac
!!$    integer, intent(inout) :: iflag
!!$    real(dbl), dimension(np), intent(in) :: p
!!$    real(dbl), dimension(mm), intent(out) :: fvec
!!$    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
!!$    real(dbl), dimension(:), allocatable :: beta,x,y,z,s
!!$    real(dbl), dimension(:,:), allocatable :: rs,f,df
!!$    real(dbl) :: a,b,g
!!$    integer :: n,m,i,l
!!$
!!$    if( iflag == 0 ) then
!!$       write(*,'(6g12.3)') p,fvec
!!$
!!$       if( .true. ) then
!!$          write(*,*) ' jac:',real(fjac(1,:))
!!$          write(*,*) ' jac:',real(fjac(2,:))
!!$          write(*,*) ' jac:',real(fjac(3,:))
!!$
!!$       end if
!!$
!!$       return
!!$    end if
!!$
!!$    m = naper - nref
!!$    n = nstar
!!$    allocate(rs(n,m),f(n,m),df(n,m),x(m),y(m),z(m),beta(n),s(n))
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$    beta = p(3:)
!!$    s = dgrows(1:nstar,nhwhm)
!!$
!!$    do l = 1, m
!!$       i = l + nref - 1
!!$       x(l) = 1/radius(i) -    1/radius(i+1)
!!$       y(l) = 1/radius(i)**2 - 1/radius(i+1)**2
!!$       z(l) = radius(i+1)**2 - radius(i)**2
!!$    end do
!!$
!!$    do n = 1,nstar
!!$       do l = 1, m
!!$          i = l + nref - 1
!!$          g = beta(n)*z(l) + a*x(l) + b*y(l)
!!$          rs(n,l) = (grows(n,i) - g) / s(n)
!!$          f(n,l) = huber(rs(n,l))
!!$!          write(*,'(i2,4f15.5)') i,rs(n,i),f(n,i),grows(n,i+nref-1) - beta(n)*z(i) - a*x(i) - b*y(i),s(n)
!!$       end do
!!$    end do
!!$!    stop
!!$!    f = rs
!!$
!!$    if( iflag == 1 ) then
!!$
!!$       fvec(1:2) = 0
!!$       do n = 1,nstar
!!$          fvec(1) = fvec(1) + sum(f(n,:)*x) / s(n)
!!$          fvec(2) = fvec(2) + sum(f(n,:)*y) / s(n)
!!$       end do
!!$       forall( n = 1:nstar )
!!$          fvec(2+n) = sum(f(n,:)*z) / s(n) - lambda*(beta(n) - back(n))
!!$       end forall
!!$       fvec(1) = fvec(1) - lambda*isigmoid(a)
!!$       fvec(2) = fvec(2) - lambda*isigmoid(b)
!!$       fvec = - fvec
!!$
!!$    else if( iflag == 2 ) then
!!$
!!$       do n = 1, nstar
!!$          call dhubers(rs(n,:),df(n,:))
!!$       end do
!!$!       df = 1
!!$
!!$       fjac = 0
!!$       do n = 1,nstar
!!$          fjac(1,1) = fjac(1,1) + sum(df(n,:)*x**2) / s(n)**2
!!$          fjac(1,2) = fjac(1,2) + sum(df(n,:)*x*y) / s(n)**2
!!$          fjac(2,2) = fjac(2,2) + sum(df(n,:)*y**2) / s(n)**2
!!$       end do
!!$       forall( n = 1:nstar )
!!$          fjac(1,2+n) = sum(df(n,:)*z*x) / s(n)**2
!!$          fjac(2,2+n) = sum(df(n,:)*z*y) / s(n)**2
!!$          fjac(2+n,2+n) = sum(df(n,:)*z**2) / s(n)**2
!!$       end forall
!!$
!!$       fjac(2,1) = fjac(1,2)
!!$       forall( n = 1:nstar )
!!$          fjac(2+n,1) = fjac(1,2+n)
!!$          fjac(2+n,2) = fjac(2,2+n)
!!$       end forall
!!$
!!$       fjac(1,1) = fjac(1,1) - lambda*nsigmoid(a)
!!$       fjac(2,2) = fjac(2,2) - lambda*nsigmoid(b)
!!$       forall( n = 1:nstar ) fjac(2+n,2+n) = fjac(2+n,2+n) + lambda
!!$
!!$    end if
!!$
!!$    deallocate(rs,f,df,x,y,z,beta,s)
!!$
!!$  end subroutine initfun


!!$  subroutine inidfun(mm,np,p,fvec,iflag)
!!$
!!$    use rfun
!!$
!!$    integer, intent(in) :: mm,np
!!$    integer, intent(in out) :: iflag
!!$    real(dbl), dimension(np), intent(in) :: p
!!$    real(dbl), dimension(mm), intent(out) :: fvec
!!$    real(dbl), dimension(:), allocatable :: beta,x,y,z,s
!!$    real(dbl), dimension(:,:), allocatable :: rs,f
!!$    real(dbl) :: a,b,g
!!$    integer :: n,m,i,j,l
!!$
!!$    if( iflag == 0 ) then
!!$       write(*,'(2g13.5)') p
!!$       write(*,'(2g13.5)') fvec
!!$       return
!!$    end if
!!$
!!$    m = naper - nref
!!$    n = nstar
!!$    allocate(rs(n,m),f(n,m),x(m),y(m),z(m),beta(n),s(n))
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$    beta = p(3:)
!!$    s = dgrows(1:nstar,nhwhm)
!!$
!!$    do l = 1, m
!!$       i = l + nref - 1
!!$       x(l) = 1/radius(i) -    1/radius(i+1)
!!$       y(l) = 1/radius(i)**2 - 1/radius(i+1)**2
!!$       z(l) = radius(i+1)**2 - radius(i)**2
!!$    end do
!!$
!!$    do n = 1,nstar
!!$       do i = 1, m
!!$          g = beta(n)*z(i) + a*x(i) + b*y(i)
!!$          rs(n,i) = (grows(n,i+nref-1) - g) / s(n)
!!$          f(n,i) = huber(rs(n,i))
!!$!          if( n == 1 ) &
!!$!          write(*,'(i2,8f15.5)') i,rs(n,i),f(n,i),g,grows(n,i+nref-1),s(n)
!!$       end do
!!$    end do
!!$!    f = rs
!!$
!!$    fvec(1:2) = 0
!!$    do n = 1,nstar
!!$       fvec(1) = fvec(1) + sum(f(n,:)*x) / s(n)
!!$       fvec(2) = fvec(2) + sum(f(n,:)*y) / s(n)
!!$    end do
!!$    forall( n = 1:nstar )
!!$       fvec(2+n) = sum(f(n,:)*z) / s(n) - lambda*(beta(n) - back(n))
!!$    end forall
!!$
!!$    fvec(1) = fvec(1) - lambda*isigmoid(a)
!!$    fvec(2) = fvec(2) - lambda*isigmoid(b)
!!$
!!$    fvec = - fvec
!!$
!!$    deallocate(rs,f,x,y,z,beta,s)
!!$
!!$  end subroutine inidfun
!!$
!!$
!!$  subroutine anchor_inits1(flux0,beta,a,b,e)
!!$
!!$    use robustmean
!!$    use neldermead
!!$
!!$    real(dbl), dimension(:), intent(in) :: flux0, beta
!!$    real(dbl), intent(in) :: a,b
!!$    real(dbl), intent(in out) :: e
!!$    real(dbl), dimension(1) :: p,dp
!!$    integer :: ifault,i,n,m
!!$    real(dbl) :: d,s,g
!!$
!!$!    nstar = 2
!!$
!!$    do n = 1,nstar
!!$       do i = nref,naper
!!$          grows(n,i) = 1 - cts(n,i) / flux0(n) - (a/raper(i) + b/raper(i)**2) - &
!!$               beta(n)*aper(i)
!!$!          write(*,*) raper(i),grows(n,i),'LL'
!!$       end do
!!$       call rinit(dcts(n,nref:naper),d,s)
!!$       dgrows(n,:) = d / flux0(n) + approxerr
!!$!       write(*,*) n,dgrows(n,nhwhm)
!!$    end do
!!$!stop
!!$    p(1) = 0
!!$
!!$    dp = 1e-4
!!$    call nelmin1(anchorfuns1,p,dp,s,ifault)
!!$!    write(*,'(4f15.5)') p(1),p(2)*flux0(1),sum(abs(phix-p(2:)))/nstar
!!$
!!$    e = p(1) !*raper(naper)
!!$    write(*,'(f12.5,i3,a)') e,ifault,' anchor_inits1'
!!$!    write(*,*) real(p(3)*flux0/pi/raper(naper)**2)
!!$    !    write(*,'(5000f10.5)') phi(1:nstar)
!!$!    write(*,*) real(phi(1:nstar))
!!$!    write(*,*) real(p(2:))
!!$!    write(*,*) ifault
!!$!    stop
!!$
!!$  end subroutine anchor_inits1
!!$
!!$
!!$ function anchorfuns1(p) result(s)
!!$
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl), dimension(:), allocatable :: sig
!!$    real(dbl) :: s,t,g
!!$    integer :: i,n,m
!!$
!!$    m = naper - nref + 1
!!$    n = nstar
!!$    allocate(sig(n))
!!$
!!$    t = p(1)
!!$    sig = dgrows(1:nstar,nhwhm)
!!$
!!$    s = 0
!!$    do n = 1,nstar
!!$       do i = 1, m
!!$          s = s + abs(grows(n,i+nref-1) - t) / sig(n)
!!$       end do
!!$    end do
!!$    s = s / (m*n)
!!$
!!$    deallocate(sig)
!!$
!!$  end function anchorfuns1
!!$
!!$
!!$  subroutine anchor_inits(flux0,a,b,beta,t,phi)
!!$
!!$    use minpacks
!!$    use robustmean
!!$    use neldermead
!!$
!!$    real(dbl), dimension(:), intent(in) :: flux0,beta
!!$    real(dbl), intent(in) :: a,b
!!$    real(dbl), dimension(:), intent(in out) :: phi
!!$    real(dbl), intent(in out) :: t
!!$    real(dbl), dimension(size(phi)+1) :: p,dp,p1
!!$    real(dbl), dimension(:), allocatable :: dabs
!!$    integer :: ifault,info,nprint,i,n,m
!!$    real(dbl) :: d,s,g
!!$
!!$!    nstar = 2
!!$
!!$    do n = 1,nstar
!!$       do i = nref,naper
!!$          grows(n,i) = 1 - cts(n,i) / flux0(n) + 0*beta(n)*aper(i) & !/flux0(n) &
!!$               - (a/raper(i) + b/raper(i)**2)
!!$!          write(*,*) raper(i),1 - cts(n,i) / flux0(n),(a/raper(i) + b/raper(i)**2)
!!$!          grows(n,i) = sqrt(cts(n,i+1)/flux0(n)) - sqrt(cts(n,i) / flux0(n))
!!$!          write(*,*) i
!!$       end do
!!$       call rinit(dcts(n,nref:naper),d,s)
!!$       dgrows(n,:) = d / flux0(n) + approxerr
!!$!       write(*,*) n,dgrows(n,nhwhm)
!!$    end do
!!$!stop
!!$    p(1) = t
!!$    p(2:) = phi !/ flux0(1:nstar)
!!$!    p = 0*phi / flux0(1:nstar)
!!$
!!$
!!$    dp = 1e-6
!!$    dp(1) = 1e-4
!!$    lambda = 1e-4
!!$    phix = 0
!!$    do i = 1,50
!!$       call nelmin1(anchorfuns,p,dp,s,ifault)
!!$       write(*,'(4f15.5)') p(1),p(2)*flux0(1),sum(abs(phix-p(2:)))/nstar
!!$       if( abs(p(1)-p1(1)) < 1e-5 .and. sum(abs(phix-p(2:)))/nstar < 1e-7 ) exit
!!$       phix = p(2:)
!!$       p1 = p
!!$       lambda = 2*lambda
!!$    end do
!!$!stop
!!$
!!$    t = p(1)
!!$    phi = p(2:)
!!$
!!$    m = naper - nref + 1
!!$    allocate(dabs(m))
!!$    do n = 1,nstar
!!$       do i = 1,m
!!$          g = t + phi(n)
!!$          dabs(i) = abs(grows(n,i+nref-1) - g)
!!$       end do
!!$       call rinit(dabs,d,s)
!!$       dgrows(n,:) = d / 0.6745 + approxerr
!!$    end do
!!$    deallocate(dabs)
!!$
!!$!    stop
!!$    nprint = 0
!!$
!!$    p1 = p
!!$!    lambda = 1e-6
!!$    do i = 1,20
!!$       call lmder2(anchorder,p,epsilon(p),nprint,info)
!!$!       call lmdif2(anchordif,p,epsilon(p),nprint,info)
!!$       write(*,*) real(p(1:2))
!!$!       if( all(abs(p - p1) < 1e-5) ) exit
!!$       if( abs(p(1)-p1(1)) < 1e-7 .and. sum(abs(phix-p(2:)))/nstar < 1e-7 ) exit
!!$       lambda = 2*lambda
!!$       p1 = p
!!$       phix = p(2:)
!!$    end do
!!$
!!$    t = p(1) !*raper(naper)
!!$    phi = p(2:)!*flux0(1:nstar)
!!$
!!$    write(*,'(f12.5,i3,a)') t,info,' anchor_inits'
!!$!    write(*,*) real(p(3)*flux0/pi/raper(naper)**2)
!!$    !    write(*,'(5000f10.5)') phi(1:nstar)
!!$!    write(*,*) real(phi(1:nstar))
!!$!    write(*,*) real(p(2:))
!!$!    write(*,*) ifault
!!$!    stop
!!$
!!$  end subroutine anchor_inits
!!$
!!$
!!$ function anchorfuns(p) result(s)
!!$
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl), dimension(:), allocatable :: phi,sig
!!$    real(dbl) :: s,t,g
!!$    integer :: i,n,m
!!$
!!$    m = naper - nref + 1
!!$    n = nstar
!!$    allocate(phi(n),sig(n))
!!$
!!$    t = p(1)
!!$    phi = p(2:)
!!$    sig = dgrows(1:nstar,nhwhm)
!!$
!!$    s = 0
!!$    do n = 1,nstar
!!$       do i = 1, m
!!$          g = t + phi(n)
!!$          s = s + abs(grows(n,i+nref-1) - g) / sig(n)
!!$       end do
!!$    end do
!!$    s = s / (m*n) + lambda*sum(abs(phi-phix)) + lambda*sum(abs(phi))
!!$
!!$    deallocate(phi,sig)
!!$
!!$  end function anchorfuns
!!$
!!$
!!$  subroutine anchordif(mm,np,p,fvec,iflag)
!!$
!!$    use rfun
!!$
!!$    integer, intent(in) :: mm,np
!!$    integer, intent(in out) :: iflag
!!$    real(dbl), dimension(np), intent(in) :: p
!!$    real(dbl), dimension(mm), intent(out) :: fvec
!!$    real(dbl), dimension(:), allocatable :: s,phi
!!$    real(dbl), dimension(:,:), allocatable :: rs,f
!!$!    real(dbl), dimension(2,2) :: dfjac
!!$    real(dbl) :: t, g
!!$    integer :: n,m,i
!!$
!!$    if( iflag == 0 ) then
!!$       write(*,'(2g13.5)') p
!!$       write(*,'(2g13.5)') fvec
!!$       return
!!$    end if
!!$
!!$    m = naper - nref + 1
!!$    n = nstar
!!$    allocate(rs(n,m),f(n,m),phi(n),s(n))
!!$
!!$    t = p(1)
!!$    phi = p(2:)
!!$    s = dgrows(1:nstar,nhwhm)
!!$
!!$    do n = 1,nstar
!!$       do i = 1, m
!!$          g = t + phi(n)
!!$          rs(n,i) = (grows(n,i+nref-1) - g) / s(n)
!!$          f(n,i) = huber(rs(n,i))
!!$!          write(*,'(i2,8f15.5)') i,rs(n,i),f(n,i),g,grows(n,i+nref-1),s(n)
!!$       end do
!!$    end do
!!$!    stop
!!$!    f = rs !*s(1)
!!$
!!$    fvec(1) = 0
!!$    do n = 1,nstar
!!$       fvec(1) = fvec(1) + sum(f(n,:)) / s(n)
!!$!       write(*,*) real(sum(f(n,:)*x))
!!$    end do
!!$!    write(*,*) real(t)
!!$    forall( n = 1:nstar )
!!$!       fvec(1+n) = sum(f(n,:)) / s(n) + lambda*(phi(n)*(phi(n) - 1))
!!$       fvec(1+n) = sum(f(n,:)) / s(n) + lambda*(phi(n) - phix(n))
!!$    end forall
!!$    !    write(*,*) real(sum(f(1,:)*z)) / s(1)
!!$
!!$!    fvec(1) = fvec(1) + lambda*(log(t) + 1)
!!$    fvec = - fvec
!!$
!!$!    write(*,'(6g12.3)') fvec,rs!sqrt(sum(rs**2)/(m-4))
!!$
!!$    deallocate(rs,f,phi,s)
!!$
!!$  end subroutine anchordif
!!$
!!$  subroutine anchorder(mm,np,p,fvec,fjac,ldfjac,iflag)
!!$
!!$    use rfun
!!$
!!$    integer, intent(in) :: mm,np,ldfjac
!!$    integer, intent(inout) :: iflag
!!$    real(dbl), dimension(np), intent(in) :: p
!!$    real(dbl), dimension(mm), intent(out) :: fvec
!!$    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
!!$    real(dbl), dimension(:), allocatable :: phi,s
!!$    real(dbl), dimension(:,:), allocatable :: rs,f,df
!!$!    real(dbl), dimension(2,2) :: dfjac
!!$    real(dbl) :: t,g
!!$    integer :: n,m,i,j
!!$
!!$    if( iflag == 0 ) then
!!$       write(*,'(6g12.3)') p,fvec
!!$
!!$       if( .true. ) then
!!$          write(*,*) ' jac:',real(fjac(1,:))
!!$          write(*,*) ' jac:',real(fjac(2,:))
!!$          write(*,*) ' jac:',real(fjac(3,:))
!!$
!!$!          call difjac(p(1),p(2),dfjac)
!!$!          write(*,*) 'djac:',dfjac(1,:)
!!$!          write(*,*) 'djac:',dfjac(2,:)
!!$
!!$       end if
!!$
!!$       return
!!$    end if
!!$
!!$    m = naper - nref + 1
!!$    n = nstar
!!$    allocate(rs(n,m),f(n,m),df(n,m),phi(n),s(n))
!!$
!!$    t = p(1)
!!$    phi = p(2:)
!!$    s = dgrows(1:nstar,nhwhm)
!!$
!!$    do n = 1,nstar
!!$       do i = 1, m
!!$          g = t + phi(n)
!!$          rs(n,i) = (grows(n,i+nref-1) - g) / s(n)
!!$          f(n,i) = huber(rs(n,i))
!!$!          write(*,'(i2,4f15.5)') i,rs(n,i),f(n,i),grows(n,i+nref-1) - beta(n)*z(i) - a*x(i) - b*y(i),s(n)
!!$       end do
!!$    end do
!!$!    stop
!!$!    f = rs
!!$
!!$    if( iflag == 1 ) then
!!$
!!$       fvec(1) = 0
!!$       do n = 1,nstar
!!$          fvec(1) = fvec(1) + sum(f(n,:)) / s(n)
!!$       end do
!!$       forall( n = 1:nstar )
!!$!          fvec(1+n) = sum(f(n,:)) / s(n) + lambda*(phi(n)*(phi(n) - 1))
!!$          fvec(1+n) = sum(f(n,:)) / s(n) + lambda*(phi(n) - phix(n))
!!$       end forall
!!$!       forall( n = 1:nstar ) fvec(1+n) = sum(f(n,:)) / s(n)
!!$!       fvec(1) = fvec(1) + lambda*max(0.0,-a)
!!$!       fvec(2) = fvec(2) + lambda*max(0.0,-b)
!!$       fvec = - fvec
!!$
!!$    else if( iflag == 2 ) then
!!$
!!$       do n = 1, nstar
!!$          call dhubers(rs(n,:),df(n,:))
!!$       end do
!!$!       df = 1
!!$
!!$       fjac = 0
!!$       do n = 1,nstar
!!$          fjac(1,1) = fjac(1,1) + sum(df(n,:)) / s(n)**2
!!$       end do
!!$       forall( n = 1:nstar )
!!$          fjac(1,1+n) = sum(df(n,:)) / s(n)**2 + lambda
!!$          fjac(1+n,1+n) = sum(df(n,:)) / s(n)**2
!!$       end forall
!!$
!!$       forall( n = 1:nstar )
!!$          fjac(1+n,1) = fjac(1,1+n)
!!$       end forall
!!$
!!$    end if
!!$
!!$!    write(*,'(6g12.3)') p,fvec
!!$
!!$
!!$    deallocate(rs,f,df,phi,s)
!!$
!!$  end subroutine anchorder
!!$
!!$
!!$
!!$
!!$  !-----------------------------------------------------------------------
!!$
!!$
!!$
!!$
!!$  subroutine update_backflux(a,cts,dcts,flux,back)
!!$
!!$    use NelderMead
!!$    use minpacks
!!$
!!$    real(dbl), intent(in) :: a
!!$    real(dbl), dimension(:), intent(in) :: cts, dcts
!!$    real(dbl), intent(in out) :: flux, back
!!$
!!$    real(dbl), dimension(2) :: p,dp
!!$    real(dbl) :: pmin
!!$    integer :: ifault, nprint, info
!!$
!!$    p = 0
!!$    dp = 1e-6
!!$    cts_(nref:naper) = cts(nref:naper) / flux - (1 - a/raper(nref:naper))
!!$!    cts_(nref:naper) = sqrt(cts(nref:naper) / flux) - (1 - a/raper(nref:naper)/2)
!!$    dcts_(nref:naper) = dcts(nref:naper) / flux
!!$
!!$    call nelmin1(backflux,p,dp,pmin,ifault)
!!$
!!$
!!$    nprint = 0
!!$    sig = 1
!!$    call lmder2(fackblux,p,epsilon(p),nprint,info)
!!$
!!$    back = flux*p(2)/pi
!!$    flux = flux*(1 + p(1))
!!$!    back = 2*flux*p(2)/pi
!!$!    flux = flux*(1 + p(1)/2)
!!$
!!$!    write(*,*) real(flux),real(back),'ppp'
!!$!    write(*,*) real(p)
!!$
!!$  end subroutine update_backflux
!!$
!!$
!!$  function backflux(p) result(s)
!!$
!!$    use robustmean
!!$
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl), dimension(size(raper)) :: ares,stat
!!$    real(dbl) :: s,a,b,q,r,f
!!$    integer :: i
!!$
!!$    f = p(1)
!!$    b = p(2)
!!$
!!$    s = 0
!!$    do i = nref, naper
!!$       r = raper(i)
!!$       q = f + b*r**2
!!$       s = s + abs(cts_(i) - q) / dcts_(i)
!!$    end do
!!$
!!$  end function
!!$
!!$
!!$  subroutine fackblux(m,np,p,fvec,fjac,ldfjac,iflag)
!!$
!!$    use rfun
!!$
!!$    integer, intent(in) :: m,np,ldfjac
!!$    integer, intent(inout) :: iflag
!!$    real(dbl), dimension(np), intent(in) :: p
!!$    real(dbl), dimension(m), intent(out) :: fvec
!!$    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
!!$    real(dbl), dimension(:), allocatable :: rs,f,df,r
!!$    real(dbl), dimension(2,2) :: dfjac
!!$    integer :: n,i
!!$
!!$    if( iflag == 0 ) then
!!$       write(*,'(6g12.3)') p,fvec
!!$
!!$       if( .true. ) then
!!$          write(*,*) ' jac:',real(fjac(1,:))
!!$          write(*,*) ' jac:',real(fjac(2,:))
!!$          write(*,*) ' jac:',real(fjac(3,:))
!!$
!!$!          call difjac(p(1),p(2),dfjac)
!!$!          write(*,*) 'djac:',dfjac(1,:)
!!$!          write(*,*) 'djac:',dfjac(2,:)
!!$
!!$       end if
!!$
!!$       return
!!$    end if
!!$
!!$    n = naper - nref + 1
!!$    allocate(rs(n),f(n),df(n),r(n))
!!$
!!$    do i = 1,n
!!$       r(i) = raper(i+nref-1)
!!$       rs(i) = (p(1) + p(2)*r(i)**2 - cts_(i+nref-1)) / sig
!!$       f(i) = huber(rs(i))
!!$    end do
!!$!    f = r
!!$
!!$    if( iflag == 1 ) then
!!$
!!$       fvec(1) = sum(f)
!!$       fvec(2) = sum(f*r**2)
!!$       fvec = - fvec / sig
!!$
!!$    else if( iflag == 2 ) then
!!$
!!$       call dhubers(rs,df)
!!$!       df = 1
!!$
!!$       fjac(1,1) = sum(df)
!!$       fjac(1,2) = sum(df*r**2)
!!$       fjac(2,2) = sum(df*r**4)
!!$
!!$       fjac(2,1) = fjac(1,2)
!!$       fjac = fjac / sig**2
!!$
!!$    end if
!!$
!!$    deallocate(rs,f,df,r)
!!$
!!$  end subroutine fackblux
!!$
!!$
!!$
!!$
!!$
!!$
!!$  subroutine asymptote_init5(a,q,beta,da,dq,dbeta)
!!$
!!$    use NelderMead
!!$    use robustmean
!!$    use minpacks
!!$    use rfun
!!$
!!$
!!$    real(dbl), intent(out) :: a,q,beta,da,dq,dbeta
!!$    real(dbl), dimension(3) :: p,dp,p1,dp1
!!$    real(dbl), dimension(3,3) :: fjac,hess
!!$    real(dbl) :: pmin,d,r,fmin,fmax,mad,s,sum2,sum3,rs
!!$    integer :: i,j,ifault,n,info
!!$
!!$    n = naper - nref + 1
!!$    p(1) = 0
!!$    p(2) = 1
!!$    p(3) = 0
!!$    dp(1) = 0.001
!!$    dp(2) = 0.0001
!!$    dp(3) = 1e-4
!!$    n = naper - 1
!!$!    r = raper(naper)
!!$    fmin = grow_(nref)
!!$    fmax = grow_(naper)
!!$    fmin = minval(grow_(nref:naper))
!!$    fmax = maxval(grow_(nref:naper))
!!$    d = fmax - fmin
!!$    grow_ = (grow_ - fmin)  / d
!!$!    write(*,*) fmin,fmax,d
!!$!    stop
!!$
!!$    call rinit(dgrow_(nref:naper)/d,sig,s)
!!$    write(*,*) 'sig:',real(sig)
!!$    lambda = 0
!!$    do i = 1,100
!!$       call nelmin1(fainit5,p,dp,pmin,ifault)
!!$       lambda = lambda + 0.01
!!$       write(*,'(4f13.5,2g12.3,i3)') p,lambda,par_t,par_e,ifault
!!$       if( p(1) > 0 ) then
!!$!             p = p1
!!$!             dp = dp1
!!$          exit
!!$       end if
!!$       p1 = p
!!$       dp1 = dp
!!$    end do
!!$
!!$    i = 0
!!$    call lmder2(funder5,p,epsilon(p),i,info)
!!$    write(*,*) 'lmder:',real(p),info
!!$
!!$    ! osetrit pripad info /= 2
!!$
!!$    i = 2
!!$    call funder5(3,3,p,dp,fjac,3,i)
!!$    call qrinv(fjac,hess)
!!$    sum2 = 0
!!$    sum3 = 0
!!$    do i = 1,naper - nref + 1
!!$       r = radius(i+nref-1)
!!$       rs = (p(2) - p(1)/r + p(3)*r**2 - grow_(i+nref-1)) / sig
!!$       sum2 = sum2 + dhuber(rs)
!!$       sum3 = sum3 + huber(rs)**2
!!$    end do
!!$    s = sig*sqrt(sum3/sum2)
!!$    dp = s
!!$!    do i = 1,3
!!$!       write(*,*) (real(fjac(i,j)),j=1,3)
!!$!    end do
!!$!    do i = 1,3
!!$!       write(*,*) (real(hess(i,j)),j=1,3)
!!$!    end do
!!$!    write(*,*) real(fjac(1,1)),real(fjac(2,2)),real(fjac(3,3))
!!$!    write(*,*) real(hess(1,1)),real(hess(2,2)),real(hess(3,3))
!!$    do i = 1, 3
!!$       if( hess(i,i) > 0 .and. hess(i,i) < 1e3) then ! problem s 10e14
!!$          dp(i) = s *sqrt(hess(i,i))
!!$       end if
!!$    end do
!!$
!!$    if( ifault /= 0 ) write(*,*)  'asymptote_init5:',real(p),real(pmin),ifault
!!$
!!$    r = raper(naper)
!!$    a = d*p(1)*r
!!$    q = fmin + d*p(2)
!!$    beta = d*p(3)/r**2
!!$    da = a*dp(1)/p(1)
!!$    dq = d*p(2)
!!$    dbeta = beta*dp(3)/p(3)
!!$
!!$    write(*,'(5f15.5)') a,q,beta,pmin
!!$!    stop
!!$  end subroutine asymptote_init5
!!$
!!$
!!$  function fainit5(p)
!!$
!!$    use robustmean
!!$
!!$    real(dbl) :: fainit5
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl), dimension(size(raper)) :: ares,stat
!!$    real(dbl) :: s,a,q,r,x,x1,f,r1,f1,f2,h,beta
!!$    integer :: i,j,n
!!$
!!$    a = p(1)
!!$    q = p(2)
!!$    beta = p(3)
!!$
!!$    h = 0
!!$    s = 0
!!$    f1 = 0
!!$    do i = nref-1, naper
!!$       r = radius(i)
!!$       f = q - a/r + beta*r**2
!!$       f1 = a/r**2 + 2*beta*r
!!$       f2 = -2*a/r**3 + 2*beta
!!$
!!$       ! dgrow_ are not used because initial estimates have no Normal
!!$       ! distribution, errors includes systematic offsets which can
!!$       ! confuse fitting procedure
!!$       s = s + abs(grow_(i) - f)
!!$       h = h + f2 / (1 + f1**2)**1.5
!!$!       write(*,*) real(r),real((grow_(i) - f))
!!$    end do
!!$!    s = s !/ sig
!!$!    r = radius(naper)
!!$    fainit5 = (1-lambda) * s / sig + lambda*(abs(h)*0 + max(0.0,-a))
!!$    par_t = s / sig
!!$    par_e = a
!!$
!!$  end function fainit5
!!$
!!$
!!$  subroutine funder5(m,np,p,fvec,fjac,ldfjac,iflag)
!!$
!!$    use rfun
!!$
!!$    integer, intent(in) :: m,np,ldfjac
!!$    integer, intent(inout) :: iflag
!!$    real(dbl), dimension(np), intent(in) :: p
!!$    real(dbl), dimension(m), intent(out) :: fvec
!!$    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
!!$    real(dbl), dimension(:), allocatable :: rs,f,df,r
!!$    real(dbl), dimension(3,3) :: dfjac
!!$    integer :: n,i,j
!!$    real(dbl) :: q,a,beta
!!$
!!$    if( iflag == 0 ) then
!!$       write(*,'(6g12.3)') p,fvec
!!$
!!$       if( .true. ) then
!!$          write(*,*) ' jac:',real(fjac(1,:))
!!$          write(*,*) ' jac:',real(fjac(2,:))
!!$          write(*,*) ' jac:',real(fjac(3,:))
!!$
!!$!          call difjac(p(1),p(2),dfjac)
!!$!          write(*,*) 'djac:',dfjac(1,:)
!!$!          write(*,*) 'djac:',dfjac(2,:)
!!$
!!$       end if
!!$
!!$       return
!!$    end if
!!$
!!$    n = naper - nref + 1
!!$    allocate(rs(n),f(n),df(n),r(n))
!!$    q = p(2)
!!$    a = p(1)
!!$    beta = p(3)
!!$
!!$    do i = 1,n
!!$       r(i) = radius(i+nref-1)
!!$       rs(i) = (q - a/r(i) + beta*r(i)**2 - grow_(i+nref-1)) / sig
!!$       f(i) = huber(rs(i))
!!$    end do
!!$!    f = r
!!$
!!$    if( iflag == 1 ) then
!!$
!!$       fvec(1) = sum(f)
!!$       fvec(2) = -sum(f/r)
!!$       fvec(3) = sum(f*r**2)
!!$       fvec = fvec / sig
!!$
!!$    else if( iflag == 2 ) then
!!$
!!$       call dhubers(rs,df)
!!$!       df = 1
!!$
!!$       fjac(1,1) = sum(df)
!!$       fjac(1,2) = -sum(df/r)
!!$       fjac(1,3) = sum(df*r**2)
!!$       fjac(2,2) = sum(df/r**2)
!!$       fjac(2,3) = -sum(df*r)
!!$       fjac(3,3) = sum(df*r**4)
!!$
!!$       fjac(2,1) = fjac(1,2)
!!$       fjac(3,1) = fjac(1,3)
!!$       fjac(3,2) = fjac(2,3)
!!$       fjac = fjac / sig**2
!!$
!!$    end if
!!$
!!$    deallocate(rs,f,df,r)
!!$
!!$  end subroutine funder5
!!$
!!$
!!$
!!$
!!$  subroutine asymptote_init3(a,q)
!!$
!!$    use NelderMead
!!$    use robustmean
!!$    use minpacks
!!$
!!$
!!$    real(dbl), intent(out) :: a,q
!!$    real(dbl), dimension(2) :: p,dp,p1,dp1
!!$    real(dbl) :: pmin,d,r,fmin,fmax,mad,s
!!$    integer :: i,ifault,n,info
!!$
!!$    n = naper - nref + 1
!!$    p(1) = 0
!!$    p(2) = 1
!!$    dp(1) = 0.001
!!$    dp(2) = 0.0001
!!$    n = naper - 1
!!$    r = raper(naper)
!!$    fmin = grow_(nref)
!!$    fmax = grow_(naper)
!!$    fmin = minval(grow_(nref:naper))
!!$    fmax = maxval(grow_(nref:naper))
!!$    d = fmax - fmin
!!$    grow_ = (grow_ - fmin)  / d
!!$    write(*,*) fmin,fmax,d
!!$!    stop
!!$
!!$    call rinit(dgrow_(nref:naper)/d,sig,s)
!!$    write(*,*) 'sig:',real(sig)
!!$    lambda = 0
!!$    do i = 1, 6
!!$       call nelmin1(fainit32,p,dp,pmin,ifault)
!!$       lambda = lambda + 0.001
!!$       write(*,'(4f13.5,2g12.3,i3)') p,lambda,pmin,par_t,ifault
!!$       if( .not. (par_t < 1000) ) then
!!$!             p = p1
!!$!             dp = dp1
!!$          exit
!!$       end if
!!$       p1 = p
!!$       dp1 = dp
!!$    end do
!!$
!!$    i = 0
!!$    call lmder2(funder3,p,epsilon(p),i,info)
!!$    write(*,*) 'lmder:',real(p),info
!!$
!!$    if( ifault /= 0 ) write(*,*)  'asymptote_init3:',real(p),real(pmin),ifault
!!$
!!$    p = p*d
!!$    p(2) = fmin + p(2)
!!$    write(*,'(5f15.5)') p
!!$
!!$    r = raper(naper)
!!$    a = p(1)*r
!!$    q = p(2)
!!$
!!$    write(*,'(5f15.5)') a,q,pmin,9999.0
!!$!    stop
!!$  end subroutine asymptote_init3
!!$
!!$  function fainit32(p)
!!$
!!$    use robustmean
!!$
!!$    real(dbl) :: fainit32
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl), dimension(size(raper)) :: ares,stat
!!$    real(dbl) :: s,a,q,r,x,x1,f,r1,f1,f2,h
!!$    integer :: i,j,n
!!$
!!$    a = p(1)
!!$    q = p(2)
!!$
!!$    h = 0
!!$    s = 0
!!$    f1 = 0
!!$    do i = nref, naper
!!$       r = radius(i)
!!$       f = q - a/r
!!$       f1 = a/r**2
!!$       f2 = -2*a/r**3
!!$!       x = 1/r
!!$!       f =  q - (a + b*x)*x
!!$!       r1 = raper(i+1)
!!$!       f = q - (a + (b + c/r)/r)/r
!!$!       f1 = q - (a + b/r1)/r1
!!$!       x = (grow_(i)/grow_(i+1) - f/f1) !/ (dgrow_(i) / 1.4e-3) !/ raper(i)**2)!*r**2!* x**2
!!$       ! dgrow_ are not used because initial estimates have no Normal
!!$       ! distribution, errors includes systematic offsets which can
!!$       ! confuse fitting procedure
!!$       s = s + abs(grow_(i) - f) ! / 0.07
!!$!       s = s + abs(
!!$       !       if( i > nref ) h = h + abs(abs(x) / abs(x1))
!!$!       h = h + max(0.0,-x)
!!$!       h = h + abs(x)*exp(-abs(x))
!!$       !       f1 = f1 + exp(-abs(x))
!!$!       h = h + f2 / (1 + f1**2)**1.5
!!$!       write(*,*) real(r),real(2*(a + 3*b/r)/r**3),real(1+((a+2*b)/r**2)**2)**1.5
!!$!       write(*,*) i,(1 - (a + (b + c/r)/r)/r) / (1 - (a + (b + c/r1)/r1)/r1)
!!$       write(*,'(5g15.5)') r,grow_(i),f,f1,f2
!!$!       write(*,'(5f15.5)') 1/r,grow_(i),a + 3*b/r + 6*c/r**2
!!$    end do
!!$    s = s / sig
!!$!stop
!!$    r = raper(naper)
!!$    r = radius(naper)
!!$ !   fainit4 = s !+ lambda*(abs(a/r) + abs(b/r**2) + abs(c/r**3)) !(?) + abs(q-1)
!!$ !   fainit4 = s + lambda*abs(1 - (a + (b + c/r)/r)/r + q - 1)
!!$    !    fainit4 = s + lambda*(abs((a + (b + c/r)/r)/r - q) + abs(a) + abs(b) + abs(c))
!!$!    x = 1/raper(naper)
!!$!    fainit4 = s + lambda*(max(0.0,-e) + 0*abs((a + (b + c/r)/r)/r - e) - h)
!!$    fainit32 = s !+ lambda*(max(0.0,-e) + 0*abs((a + b/r)/r - e) - h)
!!$
!!$    !    fainit42 = s + lambda*max(0.0,-h)
!!$    n = (naper - nref + 1)
!!$    h = h / (radius(naper) - radius(nref)) ! rectange integration
!!$    !    fainit42 = s / n + lambda*max(0.0,-h) / n
!!$    f1 = a/r**2
!!$    f2 = - 2*a/r**3
!!$    h = f2 / (1 + f1**2)**1.5
!!$    fainit32 = (1-lambda) * s + lambda*abs(min(0.0,h)) !?-h?
!!$!    fainit42 = (1-lambda) * s + lambda*max(0.0,-h) !?-h?
!!$ !   par_t = max(0.0,-h) / n
!!$    par_t = h
!!$!    write(*,*) real(s),real(h),real(abs(min(0.0,h))),real(par_t)
!!$!    write(*,*) real(p),real(s)
!!$
!!$  end function fainit32
!!$
!!$
!!$
!!$
!!$  subroutine asymptote_init2(a,b,q)
!!$
!!$    use NelderMead
!!$    use robustmean
!!$    use minpacks
!!$
!!$
!!$    real(dbl), intent(out) :: a,b
!!$    real(dbl), intent(out), optional :: q
!!$    real(dbl), dimension(3) :: p,dp,p1,dp1
!!$    real(dbl), dimension(:), allocatable :: res
!!$    real(dbl) :: pmin,d,r,fmin,fmax,mad,s
!!$    integer :: i,ifault,n,info
!!$
!!$    n = naper - nref + 1
!!$!    p(1) = sum((1-grow_(nref:naper))/radius(nref:naper))/sum(1/radius(nref:naper)**2)
!!$!    p(1) = sum((1-grow_(nref:naper))/raper(nref:naper))/sum(1/raper(nref:naper)**2)
!!$!    p(1) = p(1) / 10
!!$!    r = radius(naper)
!!$!        write(*,*) n,p(1),p(1)/r
!!$    p(1) = 0
!!$    p(2) = 0
!!$!    p(3) = 0
!!$    dp(1) = 0.001
!!$    dp(2) = 0.001
!!$!    dp(3) = 0.001
!!$    n = naper - 1
!!$    r = raper(naper)
!!$    fmin = grow_(nref)
!!$    fmax = grow_(naper)
!!$    fmin = minval(grow_(nref:naper))
!!$    fmax = maxval(grow_(nref:naper))
!!$    d = fmax - fmin
!!$    grow_ = (grow_ - fmin)  / d
!!$    write(*,*) fmin,fmax,d
!!$!    stop
!!$
!!$    if( present(q) ) then
!!$       p(3) = 1 !-p(1)/r  !max(-p(1)/r,epsilon(p))
!!$       dp(3) = 0.0001
!!$!       p(4) = 1
!!$       !       dp(4) = 0.1*p(4)
!!$!       write(*,*) real(dgrow_(nref:naper)/d)
!!$       call rinit(dgrow_(nref:naper)/d,sig,s)
!!$       write(*,*) 'sig:',real(sig)
!!$!       stop
!!$       lambda = 0
!!$!       call nelmin1(fainit42,p,dp,pmin,ifault)
!!$!       if( par_t > 0 ) then
!!$!          lambda = 0.1*par_t
!!$       do i = 1, 6
!!$!          dp = 1e-4
!!$!          dp(3) = 1e-4
!!$          call nelmin1(fainit42,p,dp,pmin,ifault)
!!$!       end if
!!$          lambda = lambda + 0.001
!!$          write(*,'(4f13.5,2g10.3,i3)') p,lambda,pmin,par_t,ifault
!!$!          write(*,*) real(p(3) - (p(1) + p(2)/radius(nref:naper))/radius(nref:naper) - grow_(nref:naper))
!!$!          if( .not. (par_t < 0.6745) ) exit
!!$          if( .not. (par_t < 1000) ) then
!!$!             p = p1
!!$!             dp = dp1
!!$             exit
!!$          end if
!!$          p1 = p
!!$          dp1 = dp
!!$       end do
!!$
!!$       ! asi zbytecne ..
!!$       goto 33
!!$       allocate(res(naper))
!!$       do i = nref,naper
!!$          r = radius(i)
!!$          res(i) = p(3) - (p(1) + p(2)/r)/r - grow_(i)
!!$          write(*,*) real(r),real(res(i))
!!$       end do
!!$       call rinit(abs(res(nref:naper))/sig,mad,s)
!!$       sig = mad / 0.6745
!!$       write(*,*) 'mad=',real(mad),real(sig),s
!!$       deallocate(res)
!!$       ! ... az sem
!!$       33 continue
!!$       i = 0
!!$!       sig = 0.05
!!$       call lmder2(funder,p,epsilon(p),i,info)
!!$       write(*,*) 'lmder:',real(p),info
!!$
!!$
!!$!       par_t = 0.99
!!$!       lambda = 1
!!$!       do i = 1, 10
!!$!          call nelmin1(fainit4a,p(1:3),dp(1:3),pmin,ifault,kcount0=1000*nstar,reqmin0=1d-10)
!!$!          lambda = 2*lambda
!!$!          call rmean(cts(1:3,n)/cts(1:3,naper),par_t,d)
!!$!          par_t = 1 - p(1)/r - p(2)/r**2 - p(3)/r**3
!!$!          write(*,*) real(p(1:3)),real(par_t)
!!$!       end do
!!$    else
!!$       call nelmin1(fainit3,p(1:3),dp(1:3),pmin,ifault)
!!$    end if
!!$
!!$    if( ifault /= 0 ) write(*,*)  'asymptote_init:',real(p),real(pmin),ifault
!!$
!!$    p = p*d
!!$    p(3) = fmin + p(3)
!!$    write(*,'(5f15.5)') p
!!$
!!$    r = raper(naper)
!!$    a = p(1)*r
!!$    b = p(2)*r**2
!!$!    c = p(3)*r**3
!!$
!!$    if( present(q) ) q = p(3)
!!$
!!$    write(*,'(5f15.5)') a,b,q,pmin
!!$!    stop
!!$  end subroutine asymptote_init2
!!$
!!$  function fainit42(p)
!!$
!!$    use robustmean
!!$
!!$    real(dbl) :: fainit42
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl), dimension(size(raper)) :: ares,stat
!!$    real(dbl) :: s,a,b,q,r,x,x1,f,r1,f1,f2,h
!!$    integer :: i,j,n
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$    q = p(3)
!!$!    lambda = p(4)
!!$
!!$!    if( q <= 0 ) then
!!$!       fainit4 = 1e5
!!$!       return
!!$!    end if
!!$
!!$    h = 0
!!$    s = 0
!!$    f1 = 0
!!$    do i = nref, naper
!!$       r = radius(i)
!!$       f = q - (a + b/r)/r
!!$!       x = 1/r
!!$!       f =  q - (a + b*x)*x
!!$!       r1 = raper(i+1)
!!$!       f = q - (a + (b + c/r)/r)/r
!!$!       f1 = q - (a + b/r1)/r1
!!$!       x = (grow_(i)/grow_(i+1) - f/f1) !/ (dgrow_(i) / 1.4e-3) !/ raper(i)**2)!*r**2!* x**2
!!$       ! dgrow_ are not used because initial estimates have no Normal
!!$       ! distribution, errors includes systematic offsets which can
!!$       ! confuse fitting procedure
!!$       s = s + abs(grow_(i) - f) ! / 0.07
!!$!       s = s + abs(
!!$       !       if( i > nref ) h = h + abs(abs(x) / abs(x1))
!!$       ares(i) = abs(x)
!!$       x1 = x
!!$!       h = h + max(0.0,-x)
!!$!       h = h + abs(x)*exp(-abs(x))
!!$       !       f1 = f1 + exp(-abs(x))
!!$       f1 = (a + 2*b)/r**2
!!$       f2 = - 2*(a + 3*b/r)/r**3
!!$       h = h + f2 / (1 + f1**2)**1.5
!!$!       write(*,*) real(r),real(2*(a + 3*b/r)/r**3),real(1+((a+2*b)/r**2)**2)**1.5
!!$!       write(*,*) i,(1 - (a + (b + c/r)/r)/r) / (1 - (a + (b + c/r1)/r1)/r1)
!!$!       write(*,'(5g15.5)') r,grow_(i),grow_(i) - f
!!$!       write(*,'(5f15.5)') 1/r,grow_(i),a + 3*b/r + 6*c/r**2
!!$    end do
!!$    s = s / sig
!!$!stop
!!$    r = raper(naper)
!!$    r = radius(naper)
!!$ !   fainit4 = s !+ lambda*(abs(a/r) + abs(b/r**2) + abs(c/r**3)) !(?) + abs(q-1)
!!$ !   fainit4 = s + lambda*abs(1 - (a + (b + c/r)/r)/r + q - 1)
!!$    !    fainit4 = s + lambda*(abs((a + (b + c/r)/r)/r - q) + abs(a) + abs(b) + abs(c))
!!$!    x = 1/raper(naper)
!!$!    fainit4 = s + lambda*(max(0.0,-e) + 0*abs((a + (b + c/r)/r)/r - e) - h)
!!$    fainit42 = s !+ lambda*(max(0.0,-e) + 0*abs((a + b/r)/r - e) - h)
!!$
!!$    !    fainit42 = s + lambda*max(0.0,-h)
!!$    n = (naper - nref + 1)
!!$    h = h / (radius(naper) - radius(nref)) ! rectange integration
!!$    !    fainit42 = s / n + lambda*max(0.0,-h) / n
!!$    h = f2 / (1 + f1**2)**1.5
!!$    fainit42 = (1-lambda) * s + lambda*abs(min(0.0,h)) !?-h?
!!$!    fainit42 = (1-lambda) * s + lambda*max(0.0,-h) !?-h?
!!$ !   par_t = max(0.0,-h) / n
!!$    par_t = h
!!$!    write(*,*) real(s),real(h),real(abs(min(0.0,h))),real(par_t)
!!$    write(*,*) real(p),real(s)
!!$!    fainit42 = s + lambda*(sum(abs(p(1:2))) + abs(p(3)-1))
!!$!    h = maxval(ares(nref:naper))
!!$!    par_t = h / (naper - nref + 1)
!!$
!!$    do i = nref,naper
!!$       stat(i) = 0
!!$       do j = nref,naper
!!$          if( i /= j ) then
!!$             !             write(*,*) res(i),res(j)
!!$             if( ares(i) > epsilon(ares) ) then
!!$                stat(i) = stat(i) + ares(j)/ares(i)
!!$             else
!!$                stat(i) = 1e3
!!$             end if
!!$          end if
!!$       end do
!!$       stat(i) = stat(i) / (naper - nref)
!!$    end do
!!$
!!$
!!$!    call rinit(ares(nref:naper),x1,f1)
!!$!    x1 = ares(nref)
!!$    !    x1 = minval(ares(nref:naper))
!!$!    x1 = 1e-3
!!$!    h = sum(ares(nref:naper)/x1*exp(-ares(nref:naper)/x1)) / (2*x1) / (naper - nref + 1)
!!$!    h = sum(ares(nref:naper)*exp(-ares(nref:naper)))
!!$!    write(*,*) s,h
!!$!    write(*,*) s,log(maxval(stat(nref:naper)) / minval(stat(nref:naper)))
!!$!    fainit42 = s + lambda*(log(maxval(stat(nref:naper)) / minval(stat(nref:naper))))
!!$!    fainit42 = s + lambda*abs(h-0.6745)
!!$!    fainit42 = s + lambda*h
!!$
!!$    ! pridat podminku na zhruba stejne odchylky |x| ... ?
!!$    ! aby se zamezilo problemum s medianem pro malo hodnot, nebo primo odhad medianu?
!!$
!!$!    write(*,*) h/f1
!!$
!!$  end function fainit42
!!$
!!$
!!$  subroutine funder(m,np,p,fvec,fjac,ldfjac,iflag)
!!$
!!$    use rfun
!!$
!!$    integer, intent(in) :: m,np,ldfjac
!!$    integer, intent(inout) :: iflag
!!$    real(dbl), dimension(np), intent(in) :: p
!!$    real(dbl), dimension(m), intent(out) :: fvec
!!$    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
!!$    real(dbl), dimension(:), allocatable :: rs,f,df,r
!!$    real(dbl), dimension(3,3) :: dfjac
!!$    integer :: n,i
!!$    real(dbl) :: q,a,b
!!$
!!$    if( iflag == 0 ) then
!!$       write(*,'(6g12.3)') p,fvec
!!$
!!$       if( .true. ) then
!!$          write(*,*) ' jac:',real(fjac(1,:))
!!$          write(*,*) ' jac:',real(fjac(2,:))
!!$          write(*,*) ' jac:',real(fjac(3,:))
!!$
!!$!          call difjac(p(1),p(2),dfjac)
!!$!          write(*,*) 'djac:',dfjac(1,:)
!!$!          write(*,*) 'djac:',dfjac(2,:)
!!$
!!$       end if
!!$
!!$       return
!!$    end if
!!$
!!$    n = naper - nref + 1
!!$    allocate(rs(n),f(n),df(n),r(n))
!!$    q = p(3)
!!$    a = p(1)
!!$    b = p(2)
!!$
!!$    do i = 1,n
!!$       r(i) = radius(i+nref-1)
!!$       rs(i) = (q - (a + b/r(i))/r(i) - grow_(i+nref-1)) / sig
!!$       f(i) = huber(rs(i))
!!$    end do
!!$    f = r
!!$
!!$    if( iflag == 1 ) then
!!$
!!$       fvec(1) = sum(f)
!!$       fvec(2) = -sum(f/r)
!!$       fvec(3) = -sum(f/r**2)
!!$       fvec = fvec / sig
!!$
!!$    else if( iflag == 2 ) then
!!$
!!$       do i = 1,n
!!$          df(i) = dhuber(rs(i))
!!$       end do
!!$       df = 1
!!$
!!$       fjac(1,1) = sum(df)
!!$       fjac(1,2) = -sum(df/r)
!!$       fjac(1,3) = -sum(df/r**2)
!!$       fjac(2,2) = sum(df/r**2)
!!$       fjac(2,3) = sum(df/r**3)
!!$       fjac(3,3) = sum(df/r**4)
!!$
!!$       fjac(2,1) = fjac(1,2)
!!$       fjac(3,1) = fjac(1,3)
!!$       fjac(3,2) = fjac(2,3)
!!$       fjac = fjac / sig**2
!!$
!!$    end if
!!$
!!$    deallocate(rs,f,df,r)
!!$
!!$  end subroutine funder
!!$
!!$
!!$  subroutine funder3(m,np,p,fvec,fjac,ldfjac,iflag)
!!$
!!$    use rfun
!!$
!!$    integer, intent(in) :: m,np,ldfjac
!!$    integer, intent(inout) :: iflag
!!$    real(dbl), dimension(np), intent(in) :: p
!!$    real(dbl), dimension(m), intent(out) :: fvec
!!$    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
!!$    real(dbl), dimension(:), allocatable :: rs,f,df,r
!!$    real(dbl), dimension(3,3) :: dfjac
!!$    integer :: n,i
!!$    real(dbl) :: q,a,b
!!$
!!$    if( iflag == 0 ) then
!!$       write(*,'(6g12.3)') p,fvec
!!$
!!$       if( .true. ) then
!!$          write(*,*) ' jac:',real(fjac(1,:))
!!$          write(*,*) ' jac:',real(fjac(2,:))
!!$
!!$!          call difjac(p(1),p(2),dfjac)
!!$!          write(*,*) 'djac:',dfjac(1,:)
!!$!          write(*,*) 'djac:',dfjac(2,:)
!!$
!!$       end if
!!$
!!$       return
!!$    end if
!!$
!!$    n = naper - nref + 1
!!$    allocate(rs(n),f(n),df(n),r(n))
!!$    q = p(2)
!!$    a = p(1)
!!$
!!$    do i = 1,n
!!$       r(i) = radius(i+nref-1)
!!$       rs(i) = (q - a/r(i) - grow_(i+nref-1)) / sig
!!$       f(i) = huber(rs(i))
!!$    end do
!!$    f = r
!!$
!!$    if( iflag == 1 ) then
!!$
!!$       fvec(1) = sum(f)
!!$       fvec(2) = -sum(f/r)
!!$       fvec = fvec / sig
!!$
!!$    else if( iflag == 2 ) then
!!$
!!$       do i = 1,n
!!$          df(i) = dhuber(rs(i))
!!$       end do
!!$       df = 1
!!$
!!$       fjac(1,1) = sum(df)
!!$       fjac(1,2) = -sum(df/r)
!!$       fjac(2,2) = sum(df/r**2)
!!$
!!$       fjac(2,1) = fjac(1,2)
!!$       fjac = fjac / sig**2
!!$
!!$    end if
!!$
!!$    deallocate(rs,f,df,r)
!!$
!!$  end subroutine funder3
!!$
!!$
!!$  !--
!!$
!!$
!!$  subroutine asymptote_init(a,b,c,q)
!!$
!!$    use NelderMead
!!$    use robustmean
!!$
!!$    real(dbl), intent(out) :: a,b,c
!!$    real(dbl), intent(out), optional :: q
!!$    real(dbl), dimension(5) :: p,dp
!!$    real(dbl) :: pmin,d,r
!!$    integer :: i,ifault,n
!!$
!!$    n = naper - nref + 1
!!$    p(1) = sum((1-grow_(nref:naper))/radius(nref:naper))/sum(1/radius(nref:naper)**2)
!!$!    p(1) = sum((1-grow_(nref:naper))/raper(nref:naper))/sum(1/raper(nref:naper)**2)
!!$!    p(1) = p(1) / 10
!!$    r = radius(naper)
!!$        write(*,*) n,p(1),p(1)/r
!!$    p(1) = 0
!!$    p(2) = 0
!!$    p(3) = 0
!!$    dp(1) = 0.001
!!$    dp(2) = 0.001
!!$    dp(3) = 0.001
!!$    n = naper - 1
!!$    r = raper(naper)
!!$
!!$!    stop
!!$
!!$    if( present(q) ) then
!!$       p(4) = 1e-5 !-p(1)/r  !max(-p(1)/r,epsilon(p))
!!$       dp(4) = 0.00001
!!$       p(5) = 1e-5
!!$       dp(5) = 0.1*p(5)
!!$       lambda = 1
!!$       do i = 1, 1
!!$          call nelmin1(fainit4,p,dp,pmin,ifault)
!!$          lambda = lambda/10
!!$          write(*,*) real(p),ifault
!!$       end do
!!$!       par_t = 0.99
!!$!       lambda = 1
!!$!       do i = 1, 10
!!$!          call nelmin1(fainit4a,p(1:3),dp(1:3),pmin,ifault,kcount0=1000*nstar,reqmin0=1d-10)
!!$!          lambda = 2*lambda
!!$!          call rmean(cts(1:3,n)/cts(1:3,naper),par_t,d)
!!$!          par_t = 1 - p(1)/r - p(2)/r**2 - p(3)/r**3
!!$!          write(*,*) real(p(1:3)),real(par_t)
!!$!       end do
!!$    else
!!$       call nelmin1(fainit3,p(1:3),dp(1:3),pmin,ifault)
!!$    end if
!!$
!!$    if( ifault /= 0 ) write(*,*)  'asymptote_init:',real(p),real(pmin),ifault
!!$
!!$    r = raper(naper)
!!$    a = p(1)*r
!!$    b = p(2)*r**2
!!$    c = p(3)*r**3
!!$
!!$    if( present(q) ) q = p(4)
!!$
!!$    write(*,'(5f15.5)') a,b,c,p(4),pmin
!!$!    stop
!!$  end subroutine asymptote_init
!!$
!!$  function fainit4(p)
!!$
!!$    real(dbl) :: fainit4
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl) :: s,a,b,c,e,r,x,f,r1,f1,lambda,h
!!$    integer :: i
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$    c = p(3)
!!$    e = p(4)
!!$    lambda = p(5)
!!$
!!$!    if( q <= 0 ) then
!!$!       fainit4 = 1e5
!!$!       return
!!$!    end if
!!$
!!$    h = 0
!!$    s = 0
!!$    do i = nref-1, naper
!!$       r = radius(i)
!!$       f = 1 - (a + (b + c/r)/r)/r + e
!!$!       x = 1/r
!!$!       f = 1 - (a + (b + c*x)*x)*x + e
!!$!       r1 = raper(i+1)
!!$!       f = q - (a + (b + c/r)/r)/r
!!$!       f1 = q - (a + (b + c/r1)/r1)/r1
!!$       x = (grow_(i) - f) !/ (dgrow_(i) / raper(i)**2)!*r**2!* x**2
!!$       ! dgrow_ are not used because initial estimates have no Normal
!!$       ! distribution, errors includes systematic offsets which can
!!$       ! confuse fitting procedure
!!$       s = s + abs(x)
!!$       h = h + abs(a + 3*b/r + 6*c/r**2)/r**2
!!$!       write(*,*) i,(1 - (a + (b + c/r)/r)/r) / (1 - (a + (b + c/r1)/r1)/r1)
!!$       write(*,'(5f15.5)') r,f,x,grow_(i),dgrow_(i)
!!$!       write(*,'(5f15.5)') 1/r,grow_(i),a + 3*b/r + 6*c/r**2
!!$    end do
!!$!stop
!!$    r = raper(naper)
!!$    r = radius(naper)
!!$ !   fainit4 = s !+ lambda*(abs(a/r) + abs(b/r**2) + abs(c/r**3)) !(?) + abs(q-1)
!!$ !   fainit4 = s + lambda*abs(1 - (a + (b + c/r)/r)/r + q - 1)
!!$    !    fainit4 = s + lambda*(abs((a + (b + c/r)/r)/r - q) + abs(a) + abs(b) + abs(c))
!!$!    x = 1/raper(naper)
!!$    fainit4 = s + lambda*(max(0.0,-e) + 0*abs((a + (b + c/r)/r)/r - e) - h)
!!$
!!$
!!$  end function fainit4
!!$
!!$  function fainit4a(p)
!!$
!!$    real(dbl) :: fainit4a
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl) :: s,a,b,c,q,r,x,f,r1,f1,t
!!$    integer :: i,j
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$    c = p(3)
!!$    !    q = p(4)
!!$    t = par_t
!!$
!!$    s = 0
!!$    do j = 1,1
!!$    do i = nref, naper-1
!!$       r = raper(i)
!!$       r1 = raper(i+1)
!!$       f = 1 - (a + (b + c/r)/r)/r
!!$       f1 = 1 - (a + (b + c/r1)/r1)/r1
!!$!       x = (grow_(i) - f/f1) / dgrow_(i)
!!$       x = (cts(j,i)/cts(j,i+1) - f/f1) !/ dcts(j,i)
!!$       s = s + abs(x)
!!$!       write(*,*) i,f/f1,x,cts(j,i)/cts(j,i+1)
!!$    end do
!!$ end do
!!$!stop
!!$    r = raper(naper)
!!$    fainit4a = s !+ lambda*(abs(a/r) + abs(b/r**2) + abs(c/r**3)) !(?) + abs(q-1)
!!$    fainit4a = s / 3 + lambda*abs(1 - a/r - b/r**2 - c/r**3 - t)
!!$  end function fainit4a
!!$
!!$
!!$  function fainit3(p)
!!$
!!$    real(dbl) :: fainit3
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl) :: s,a,b,c,r,x,r1
!!$    integer :: i
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$    c = p(3)
!!$
!!$    s = 0
!!$    do i = nhwhm, naper-1
!!$       r = raper(i)
!!$       r1 = raper(i+1)
!!$       x = (grow_(i) - asymptote(r,a,b,c)/asymptote(r1,a,b,c)) / dgrow_(i)
!!$!       write(*,*) real(r),real(x),real(grow_(i)),real(asymptote(r,a,b,c)),real(dgrow_(i))
!!$       s = s + abs(x)
!!$    end do
!!$    r = raper(naper)
!!$    fainit3 = s !+ 0*lambda*(abs(a/r) + abs(b/r**2) + abs(c/r**3))
!!$!    write(*,*) real(s),real(p)
!!$!    stop 0
!!$
!!$  end function fainit3
!!$
!!$  subroutine anchor(cts,dcts,a,b,c,t,med,back)
!!$
!!$    use fmm
!!$
!!$    real(dbl), dimension(:), intent(in) :: cts,dcts
!!$    real(dbl), intent(in) :: a,b,c,t,med
!!$    real(dbl), intent(in out) :: back
!!$    real(dbl) :: d,tol,bmin,bmax
!!$    integer :: i
!!$
!!$!    par_a = a
!!$!    par_b = b
!!$    !    par_c = c
!!$    cts_ = cts
!!$    dcts_ = dcts
!!$    par_t = t
!!$    do i = nref, naper
!!$       grow_(i) = asymptote(raper(i),a,b,c)
!!$    end do
!!$
!!$    tol = sqrt(epsilon(cts))
!!$    tol = 1e-6
!!$
!!$    if( med > 0 ) then
!!$       d = 5*med*cts(naper)
!!$    else
!!$       d = sqrt(cts(naper))
!!$    end if
!!$    bmin = back - d
!!$    bmax = back + d
!!$!    d = back
!!$    back = fmin(bmin,bmax,ancora,tol)
!!$!    write(*,*) real(back),real(d),real(bmin),real(bmax)
!!$!stop 0
!!$  end subroutine anchor
!!$
!!$
!!$  function ancora(b)
!!$
!!$    use rfun
!!$
!!$    real(dbl), intent(in) :: b
!!$    real(dbl) :: ancora
!!$
!!$    real(dbl), dimension(size(raper)) :: grow, dgrow
!!$    real(dbl) :: s,d,f
!!$    integer :: i
!!$    logical :: valid
!!$
!!$    call the_constructor(par_t,b,cts_,dcts_,grow,dgrow,valid)
!!$    if( .not. valid ) then
!!$       ancora = 1e3*(abs(b)+1)
!!$       return
!!$    end if
!!$
!!$    s = 0
!!$    do i = nref, naper
!!$       d = (grow(i) - grow_(i)) / dgrow(i)
!!$       if( type == 0 ) then
!!$          s = s + abs(d)
!!$       else if( type == 1 ) then
!!$          s = s + ihuber(d/sig)
!!$       end if
!!$!       write(*,'(4f10.5)') raper(i),grow(i),grow_(i),dgrow(i)
!!$    end do
!!$!    write(*,*) b,s
!!$    ancora = s
!!$
!!$  end function ancora
!!$
!!$! -- odpad
!!$
!!$
!!$
!!$  subroutine asymptote_update(a,b,c,t)
!!$
!!$    use NelderMead
!!$
!!$    real(dbl), intent(in out) :: a,b,c
!!$    real(dbl), intent(in) :: t
!!$    real(dbl), dimension(3) :: p,dp
!!$    real(dbl) :: pmin
!!$    integer :: i,ifault
!!$    logical :: valid
!!$
!!$    do i = 1,nstar
!!$       call the_constructor(t,back(i),cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$    end do
!!$
!!$    ! estimate parameters
!!$    p(1) = a
!!$    p(2) = b
!!$    p(3) = c
!!$    dp(1) = 0.001
!!$    dp(2) = 0.001
!!$    dp(3) = 0.00001
!!$    call nelmin1(minas,p,dp,pmin,ifault)
!!$ !   write(*,*) ifault
!!$
!!$!    valid = ifault == 0 .and. p(2) < 0.99*maxback
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$    c = p(3)
!!$    write(*,*) real(p),real(pmin)
!!$
!!$  end subroutine asymptote_update
!!$
!!$  function minas(p)
!!$
!!$    use rfun
!!$
!!$    real(dbl) :: minas
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$!    real(dbl), dimension(size(raper)) :: grow,dgrow,f
!!$    real(dbl), dimension(size(raper)) :: f
!!$    real(dbl) :: s,d,a,b,c,x,bck,r
!!$    integer :: i,j
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$    c = p(3)
!!$    bck = 0
!!$    do i = nref,naper
!!$       f(i) = asymptote(raper(i),a,b,c)
!!$    end do
!!$
!!$    s = 0
!!$    do j = 1,nstar
!!$!       call the_constructor(tx(j),bck,cts(j,:),dcts(j,:),grow,dgrow,valid)
!!$!       if( .not. valid ) then
!!$!          s = s + 1e3
!!$!       else
!!$          do i = nref, naper
!!$             x = (grows(j,i) - f(i)) / dgrows(j,i)
!!$             if( type == 0 ) then
!!$                d = abs(x)
!!$             else if( type == 1 ) then
!!$                d = ihuber(x/sig)
!!$             else
!!$                d = 1e3
!!$             end if
!!$             s = s + d
!!$          end do
!!$!       end if
!!$    end do
!!$
!!$    ! conditions: a,b,c -> 0, a > b/r(max)
!!$    r = raper(naper)
!!$    minas = s / nstar  !+ lambda*(abs(a/r) + abs(b/r**2) + abs(c/r**3))
!!$
!!$  end function minas
!!$
!!$  subroutine asymptote_sig(a,b,c,t,back,sig)
!!$
!!$    use weightedmean
!!$
!!$    real(dbl), intent(in) :: a,b,c,t
!!$    real(dbl), dimension(:), intent(in) :: back
!!$    real(dbl), intent(out) :: sig
!!$
!!$    real(dbl), dimension(size(raper)) :: grow,dgrow,f
!!$    real(dbl), dimension(:), allocatable :: fvec,dvec
!!$    real(dbl) :: x,s
!!$    integer :: i,j,n
!!$    logical :: valid
!!$
!!$    do i = nref,naper
!!$       f(i) = asymptote(raper(i),a,b,c)
!!$    end do
!!$
!!$    n = (naper - nref + 1)*nstar
!!$    allocate(fvec(n),dvec(n))
!!$    n = 0
!!$    do j = 1, nstar
!!$       call the_constructor(t,back(j),cts(j,:),dcts(j,:),grow,dgrow,valid)
!!$       do i = nref,naper
!!$          n = n + 1
!!$          fvec(n) = grow(i) - f(i)
!!$          dvec(n) = dgrow(i)
!!$       end do
!!$    end do
!!$!    write(*,*) n,nstar,real(fvec(1:n))
!!$    !    call rinit(fvec(1:n),d,s)
!!$    call rwmean(fvec,dvec,x,s,sig)
!!$    !    sig = d / 0.6745
!!$    write(*,*) 'sig:',x, s, sig
!!$    deallocate(fvec,dvec)
!!$
!!$  end subroutine asymptote_sig
!!$
!!$
!!$
!!$
!!$  ! laters ************************
!!$
!!$
!!$
!!$
!!$
!!$  subroutine commons1(a,b,c)
!!$
!!$    use NelderMead
!!$
!!$    real(dbl), intent(in out) :: a,b,c
!!$!    integer, intent(in) :: type
!!$    real(dbl), dimension(3) :: p,dp
!!$    real(dbl) :: pmin
!!$    integer :: ifault
!!$
!!$!    par_t = t
!!$
!!$    ! estimate parameters
!!$!    p(1) = t
!!$!    p(2) = a
!!$!    p(3) = b
!!$    p(1) = a
!!$    p(2) = b
!!$    p(3) = c
!!$!    p(4:5) = 1
!!$    dp(1) = 0.001
!!$    dp(2) = 0.001
!!$!    dp(3) = 0.001
!!$    dp(3) = 0.00001
!!$!    dp(3) = 0.001
!!$!    dp(4:5) = 0.1
!!$!    if( type == 0 ) then
!!$!       call nelmin1(mincom1,p,dp,pmin,ifault)
!!$!    else if( type == 1 ) then
!!$!       call nelmin1(mincom1,p,dp,pmin,ifault)
!!$!    end if
!!$!    call nelmin1(mincom3,p,dp,pmin,ifault)
!!$ !   write(*,*) ifault
!!$
!!$!    valid = ifault == 0 .and. p(2) < 0.99*maxback
!!$
!!$!    t = p(1)
!!$!    a = p(2)
!!$!    b = p(3)
!!$!    t = p(1)
!!$    a = p(1)
!!$    b = p(2)
!!$    c = p(3)
!!$!    e = p(3)
!!$!    e = 0
!!$!    t = 1 - e - a/raper(nref) - b/raper(nref)**2
!!$!    t = asymptote(raper(nref),e,a,b)
!!$
!!$    write(*,*) real(p),real(pmin)
!!$
!!$  end subroutine commons1
!!$
!!$
!!$  function mincom0(p)
!!$
!!$!    use robustmean
!!$!    use rfun
!!$
!!$    real(dbl) :: mincom0
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl), dimension(size(raper)) :: grow,dgrow
!!$    real(dbl) :: s,e,b,d,a,r,g,t,K,q
!!$    integer :: i,j,n
!!$    logical :: valid
!!$
!!$!    t = p(1)
!!$    a = p(1)
!!$    b = p(2)
!!$    e = p(3)
!!$    t = 1 - e - a/raper(nref) - b/raper(nref)**2
!!$    n = (nhwhm + naper) / 2
!!$    n = nref
!!$
!!$    open(1,file='/tmp/7')
!!$    s = 0
!!$    q = 0
!!$    do j = 1,nstar
!!$       call the_constructor(t,back(j),cts(j,:),dcts(j,:),grow,dgrow,valid)
!!$       if( .not. valid ) then
!!$          s = s + 1
!!$       else
!!$          do i = n, naper
!!$             r = raper(i)
!!$             g = 1 - e - (a + b / r) / r
!!$             s = s + abs(grow(i) - g)
!!$             write(1,*) r,grow(i) - g,g,grow(i)
!!$          end do
!!$          do i = nhwhm, naper
!!$             e = sqrt(dgrow(i)**2 + dgrow(i-1)**2)
!!$             q = q + max(-(grow(i) - grow(i-1) - e),0.0)**2
!!$          end do
!!$       end if
!!$    end do
!!$    close(1)
!!$
!!$    d = a - b / raper(naper)
!!$    K = a*(1/raper(naper)**2 - 1/raper(n)**2) + 2*b*(1/raper(naper)**3 - 1/raper(n)**3)
!!$    K = -K
!!$!    d = a + 2*b/raper(n)
!!$!    d = 0
!!$!    do i = n,naper
!!$!       d = d + max(0.0,-(a + 2*b/raper(i)))
!!$!    end do
!!$    ! conditions: e,a,b > 0, a > b/r(max)
!!$!    mincom0 = s + 0*lambda*max(1-t,0.0) + max(0.0,-a) + max(0.0,-b) + max(0.0,-d)
!!$!    mincom0 = s + lambda*(max(1-t,0.0)**2 + max(0.0,-a)**2 + max(0.0,-b)**2 + max(0.0,-d)**2)
!!$!    mincom0 = s + lambda*(a**2 + b**2 + max(0.0,-a)**2 + max(0.0,-b)**2 + max(0.0,-d)**2)
!!$    mincom0 = s + lambda*(max(0.0,-a)**2 + max(0.0,-b)**2 + max(0.0,-e)**2 + 0*max(0.0,-d)**2   &
!!$         + 0*max(0.0,-K)**2 + 0*max(1-t,0.0)**2 + 0*q/nstar)
!!$
!!$  end function mincom0
!!$
!!$  function mincom(p)
!!$
!!$    use rfun
!!$
!!$    real(dbl) :: mincom
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl), dimension(size(raper)) :: grow,dgrow,f
!!$    real(dbl) :: s,b,d,a,c,t,x,bck,w,e
!!$    integer :: i,j
!!$    logical :: valid
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$    c = p(3)
!!$!    e = p(3)
!!$!    e = 0
!!$    bck = 0
!!$!    t = asymptote(raper(nref),e,a,b)
!!$    do i = nref,naper
!!$       f(i) = asymptote(raper(i),a,b,c)
!!$    end do
!!$    !    t = f(nref)
!!$    t = par_t
!!$
!!$!    open(1,file='/tmp/9')
!!$    s = 0
!!$    !    w = e
!!$    w = 0
!!$    do j = 1,nstar
!!$       call the_constructor(t,bck,cts(j,:),dcts(j,:),grow,dgrow,valid)
!!$       if( .not. valid ) then
!!$          s = s + 1e3
!!$       else
!!$          do i = nref, naper
!!$             x = (grow(i) - f(i)) / dgrow(i)
!!$             if( type == 0 ) then
!!$                d = abs(x)
!!$             else if( type == 1 ) then
!!$                d = ihuber(x/sig)
!!$             else
!!$                d = 1e3
!!$             end if
!!$             s = s + d
!!$!             w = w + sqrt(dgrow(i)**2 + dgrow(i-1)**2)
!!$!             write(1,*) raper(i),d,f(i),grow(i)
!!$          end do
!!$       end if
!!$    end do
!!$!    close(1)
!!$
!!$
!!$
!!$
!!$    !        write(*,*) real(e),real(a),real(t),real(s)
!!$    ! conditions: e,a,b > 0, a > b/r(max)
!!$!    write(*,*) sum(abs(t-grow(:,nref)))
!!$!    d = (a + 2*b/raper(naper))/raper(naper)**2
!!$    mincom = s / nstar  &
!!$         + lambda*(max(0.0,-a)**2 + max(0.0,-b)**2 + max(0.0,-e)**2)
!!$    !+ max(0.0,-(a+2*b/raper(naper)))**2) !&
!!$!         + a**2 + b**2 + e**2)
!!$!         + max(0.0,-w)**2*0 + a**2 + b**2 + e**2)
!!$
!!$  end function mincom
!!$
!!$  function asymptote(r,a,b,c)
!!$
!!$    real(dbl), intent(in) :: r,a,b,c
!!$    real(dbl) :: asymptote
!!$
!!$    asymptote = 1 - (a + (b + c/r)/r)/r
!!$
!!$  end function asymptote
!!$


!!$  subroutine arc_init(cts,dcts,flux0,a,b,beta)
!!$
!!$    use NelderMead
!!$
!!$    real(dbl), dimension(:), intent(in) :: cts,dcts
!!$    real(dbl), intent(in) :: flux0
!!$    real(dbl), intent(out) :: a,b
!!$    real(dbl), intent(out) :: beta
!!$    real(dbl), dimension(3) :: p,dp
!!$    real(dbl) :: pmin
!!$    integer :: ifault,i
!!$
!!$    ! here, all dgrows are defined and leaved to no change during computations
!!$    do i = naper-1,nref,-1
!!$       grow_(i) = (cts(i+1) - cts(i)) / flux0
!!$    end do
!!$    dgrow_ = dcts(nhwhm) / flux0
!!$
!!$    p = 0
!!$    dp = 1e-3
!!$    call nelmin1(arcfun,p,dp,pmin,ifault)
!!$
!!$    a = p(1)*raper(naper)
!!$    b = p(2)*raper(naper)**2
!!$    beta = p(3)*flux0/(pi*raper(naper)**2)
!!$
!!$!    write(*,'(3f12.5,2g16.5,i3,a)') a,b,beta,pmin,dgrow_(1),ifault,' ppp'
!!$!    write(*,*) real(p(3)*flux0/pi/raper(naper)**2)
!!$!    write(*,'(5000f10.2)') p(3:)*flux0/pi
!!$!    write(*,*) ifault
!!$!    stop
!!$
!!$  end subroutine arc_init
!!$
!!$
!!$  function arcfun(p) result(s)
!!$
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl) :: s,f,f2,a,b,r,r1,beta
!!$    integer :: i,n
!!$    logical :: valid
!!$
!!$    if( p(1) < 0 .or. p(2) < 0 ) then
!!$       s = 1000*nstar
!!$      return
!!$    end if
!!$
!!$    a = p(1)
!!$    b = p(2)
!!$    beta = p(3)
!!$
!!$    s = 0
!!$    f2 = 0
!!$    do i = nref, naper-1
!!$       r = radius(i)
!!$       r1 = radius(i+1)
!!$       f = beta*(r1**2 - r**2) + a*(1/r - 1/r1) + b*(1/r**2 - 1/r1**2)
!!$       f2 = f2 - 2*(a + 3*b/r)/r**3
!!$       s = s + abs(grow_(i) - f) / dgrow_(i)
!!$       !write(*,'(6f12.5)') real(grows(n,i) - f), real(f),real(grows(n,i)),a,b,beta(n)
!!$    end do
!!$   s = s / (naper - nref - 1)
!!$
!!$ end function arcfun
!!$
!!$
!!$
!!$
!!$
!!$  subroutine anchor_init(cts,dcts,flux0,a,b,beta,t,phi)
!!$
!!$    use fmm
!!$
!!$    real(dbl), dimension(:), intent(in) :: cts,dcts
!!$    real(dbl), intent(in) :: flux0,a,b,beta
!!$    real(dbl), intent(out) :: t,phi
!!$    real(dbl) :: tol, tmin, tmax
!!$    integer :: ifault,i
!!$
!!$    ! here, all dgrows are defined and leaved to no change during computations
!!$    do i = nref,naper
!!$       grow_(i) = 1 - cts(i) / flux0 - beta*aper(i)/flux0 + a/raper(i) + b/raper(i)**2
!!$!       write(*,*) real(grow_(i)),real(cts(i) / flux0),real(beta*aper(i)/flux0), &
!!$!            real(a/raper(i)),real(b/raper(i)**2)
!!$    end do
!!$    dgrow_ = dcts(nhwhm) / flux0
!!$
!!$    tol = sqrt(epsilon(cts))
!!$    tol = 1e-6
!!$    tmin = minval(grow_(nref:naper))
!!$    tmax = maxval(grow_(nref:naper))
!!$!    write(*,*) real(tmin), real(tmax)
!!$    phi = fmin(tmin,tmax,anchorfun,tol)
!!$
!!$!    write(*,*) real(t),' anchor_init'
!!$
!!$  end subroutine anchor_init
!!$
!!$
!!$  function anchorfun(t) result(s)
!!$
!!$    real(dbl), intent(in) :: t
!!$
!!$    real(dbl) :: s,f
!!$    integer :: i
!!$
!!$    s = 0
!!$    do i = nref, naper
!!$       s = s + abs(grow_(i) - t) / dgrow_(i)
!!$       !write(*,'(6f12.5)') real(grows(n,i) - f), real(f),real(grows(n,i)),a,b,beta(n)
!!$    end do
!!$   s = s / (naper - nref - 1)
!!$
!!$ end function anchorfun
!!$
!!$



!!$  function ancora(t)
!!$
!!$    use rfun
!!$
!!$    real(dbl), intent(in) :: t
!!$    real(dbl) :: ancora
!!$
!!$    real(dbl), dimension(size(raper)) :: grow, dgrow
!!$    real(dbl) :: s,d,b,f
!!$    integer :: i
!!$    logical :: valid
!!$
!!$    b = 0
!!$    call the_constructor(t,b,cts_,dcts_,grow,dgrow,valid)
!!$
!!$    s = 0
!!$    do i = nref, naper
!!$       d = (grow(i) - grow_(i)) / dgrow(i)
!!$       if( type == 0 ) then
!!$          s = s + abs(d)
!!$       else if( type == 1 ) then
!!$          s = s + ihuber(d/sig)
!!$       end if
!!$    end do
!!$
!!$    ancora = s
!!$
!!$  end function ancora


!!$  function asymptote1(r,a,b,c)
!!$
!!$    real(dbl), intent(in) :: r,a,b,c
!!$    real(dbl) :: asymptote1
!!$
!!$    asymptote1 = 1 - (a + (b + c/r)/r)/r
!!$
!!$  end function asymptote1
!!$
!!$  subroutine the_constructor(t,b,cts,dcts,grow,dgrow,valid)
!!$
!!$    real(dbl), intent(in) :: t,b
!!$    real(dbl), dimension(:), intent(in) :: cts, dcts
!!$    real(dbl), dimension(:), intent(out) :: grow,dgrow
!!$    logical, intent(out) :: valid
!!$
!!$    real(dbl), dimension(size(raper)) :: flux,dflux
!!$    integer :: i,n
!!$
!!$    valid = .false.
!!$    n = size(grow)
!!$
!!$    flux = cts - b*aper
!!$    dflux = dcts
!!$
!!$    if( any(flux < epsilon(flux)) ) return
!!$
!!$    ! set up initial point of grow curve
!!$!    grow(nhwhm) = t
!!$!    grow(nref) = t
!!$    grow(naper) = t
!!$
!!$    do i = naper-1,1,-1
!!$       grow(i) = grow(i+1) * (flux(i) / flux(i+1))
!!$    end do
!!$
!!$
!!$    ! compute grow curve
!!$    goto 33
!!$!    do i = nhwhm-1,1,-1
!!$    do i = nref-1,1,-1
!!$       grow(i) = grow(i+1) * (flux(i) / flux(i+1))
!!$    end do
!!$!    do i = nhwhm+1,n
!!$    do i = nref+1,n
!!$       grow(i) = grow(i-1) * (flux(i) / flux(i-1))
!!$    end do
!!$
!!$33 continue
!!$
!!$!    forall( i = 1:n ) dgrow(i) = grow(i)*(dflux(i)/flux(i))
!!$!    dgrow = max(grow * (dflux / flux), 1e-7)
!!$    dgrow = grow * (dflux / flux)
!!$
!!$    valid = .true.
!!$
!!$  end subroutine the_constructor
!!$
!!$  subroutine a_constructor(flux,dflux,grow,dgrow,valid)
!!$
!!$    real(dbl), dimension(:), intent(in) :: flux, dflux
!!$    real(dbl), dimension(:), intent(out) :: grow,dgrow
!!$    logical, intent(out) :: valid
!!$
!!$    integer :: i
!!$
!!$    valid = .false.
!!$
!!$    if( any(flux < epsilon(flux)) ) return
!!$
!!$    ! set up initial point of grow curve
!!$    grow(nhwhm) = 1
!!$
!!$    ! compute grow curve
!!$    do i = nhwhm-1,1,-1
!!$       grow(i) = grow(i+1) * (flux(i) / flux(i+1))
!!$    end do
!!$    do i = nhwhm+1, size(grow)
!!$       grow(i) = grow(i-1) * (flux(i) / flux(i-1))
!!$    end do
!!$
!!$    dgrow = grow * (dflux / flux)
!!$
!!$    valid = .true.
!!$
!!$  end subroutine a_constructor
!!$
!!$
!!$  subroutine part(e,a,b,t)
!!$
!!$    use fmm
!!$
!!$    real(dbl), intent(in) :: e,a,b
!!$    real(dbl), intent(in out) :: t
!!$    real(dbl) :: dt,tol,tmin,tmax
!!$
!!$    par_e = e
!!$    par_a = a
!!$    par_b = b
!!$!    par_c = c
!!$    dt = 1e-2
!!$!    write(*,*) bmax,cts_(nhwhm),par_e,par_a,par_b
!!$!    tol = sqrt(epsilon(cts))*maxval(cts)
!!$    tol = sqrt(epsilon(cts))
!!$    tol = 1e-6
!!$    tmin = 0.5
!!$    tmax = min(1 - tol,asymptote(raper(naper),e,a,b))
!!$!    t = fmin(t-dt,max(t+dt,1.0),tfun,tol)
!!$    t = fmin(tmin,tmax,tfun,tol)
!!$!    if( back > 100 ) then
!!$!       valid = .false.
!!$!    end if
!!$
!!$  end subroutine part
!!$
!!$
!!$  function tfun(t)
!!$
!!$    use rfun
!!$
!!$    real(dbl), intent(in) :: t
!!$    real(dbl) :: tfun
!!$
!!$    real(dbl), dimension(size(raper)) :: grow, dgrow, f
!!$    real(dbl) :: s,g,d,x
!!$    integer :: i,j
!!$    logical :: valid
!!$
!!$
!!$!    if( .not. valid ) then
!!$!       tfun = 666
!!$!       return
!!$!    end if
!!$
!!$!    do i = 1,naper
!!$!       write(*,*) raper(i),grow(i)
!!$!    end do
!!$    !    stop 0
!!$
!!$    do i = nref,naper
!!$       f(i) = asymptote(raper(i),par_e,par_a,par_b)
!!$    end do
!!$
!!$    s = 0
!!$    do j = 1,nstar
!!$       call the_constructor(t,back(j),cts(j,:),dcts(j,:),grow,dgrow,valid)
!!$!       if( .not. valid ) s = s + 100
!!$!       d = grow(naper) - f(naper)
!!$!       if( d ) s = s + 1000*()
!!$       do i = nref,naper
!!$!          r = raper(i) !/ hwhm
!!$!          g = 1 - par_e - par_a / r - par_b / r**2
!!$          !          s = s + abs(grow(i) - f(i)) ! / sqrt(dcts**2 + ..?
!!$          x = (grow(i) - f(i)) / dgrow(i)
!!$          if( type == 0 ) then
!!$             d = abs(x)
!!$          else if( type == 1 ) then
!!$             d = ihuber(x/sig)
!!$          else
!!$             d = 1e3
!!$          end if
!!$          s = s + d
!!$!          if( x > 3 ) s = s + 10
!!$       end do
!!$    end do
!!$    tfun = s / nstar
!!$
!!$!    write(*,*) real(t),real(s),t
!!$!    stop 0
!!$
!!$  end function tfun


!!$  subroutine tnoise(t)
!!$
!!$    use fmm
!!$
!!$    real(dbl), intent(out) :: t
!!$    real(dbl) :: tmin,tmax,tol
!!$
!!$    tmin = 0.5
!!$    tmax = 1 - epsilon(tmax)
!!$    tol = 1e-6
!!$    t = fmin(tmin,tmax,noisefun,tol)
!!$!    if( back > 100 ) then
!!$!       valid = .false.
!!$!    end if
!!$
!!$  end subroutine tnoise
!!$
!!$  function noisefun(t)
!!$
!!$    use robustmean
!!$
!!$    real(dbl), intent(in) :: t
!!$    real(dbl) :: noisefun
!!$
!!$    real(dbl), dimension(size(raper)) :: grow, dgrow
!!$    real(dbl) :: s,back
!!$    integer :: n,i,j
!!$    logical :: valid
!!$
!!$    back = 0
!!$    n = (nhwhm + naper) / 2
!!$!    t = 1
!!$    do i = 1, nstar
!!$       call the_constructor(t,back,cts(i,:),dcts(i,:),grows(i,:),dgrows(i,:),valid)
!!$    end do
!!$    do i = nref, naper
!!$       call rinit(grows(:,i),grow(i),dgrow(i))
!!$    end do
!!$    s = 0
!!$    do i = nref+1, naper
!!$       !       s = s + abs(dgrow(i) - dgrow(i-1))/(grow(i) + grow(i-1)) !/(raper(i) - raper(i-1))
!!$       s = s + dgrow(i)
!!$    end do
!!$!    write(*,*) s,n
!!$    noisefun = s / (naper - nref)
!!$
!!$  end function noisefun


! ----




!!$  subroutine growmodel1(grows,dgrows,grow,dgrow)
!!$
!!$    use robustmean
!!$
!!$    real(dbl), dimension(:,:), intent(in) :: grows,dgrows
!!$    real(dbl), dimension(:), intent(out) :: grow,dgrow
!!$    real(dbl), dimension(:), allocatable :: f
!!$    integer :: n,i,j,l,naper,nstars
!!$
!!$    nstars = size(grows,1)
!!$    naper = size(grows,2)
!!$
!!$    ! initial estimate of growth curve as mean of all grow-curves
!!$    do i = 1, naper
!!$       call rmean(grows(:,i),grow(i),dgrow(i))
!!$!       write(*,*) i,real(grow(i)),real(dgrow(i))
!!$    end do
!!$
!!$
!!$    allocate(f(naper*nstars))
!!$
!!$    do i = 1,naper
!!$
!!$       n = 0
!!$       do l = 1, nstars
!!$          do j = 1,naper
!!$             n = n + 1
!!$             f(n) = grows(l,i)/grows(l,j) * grow(j)
!!$          end do
!!$       end do
!!$       if( n /= nstars*naper ) stop 'n /= nstars*naper'
!!$
!!$       call rmean(f,grow(i),dgrow(i))
!!$
!!$    end do
!!$
!!$    deallocate(f)
!!$
!!$    ! check for identical curves
!!$    where( abs(dgrow) < epsilon(dgrow) )
!!$       dgrow = 1e-5
!!$    end where
!!$
!!$  end subroutine growmodel1


!!$  function background1(e,a,d)
!!$
!!$    use fmm
!!$
!!$    real(dbl), intent(in) :: e,a,d
!!$    real(dbl) :: b, bmax, tol, background1
!!$
!!$    par_e = e
!!$    par_a = a
!!$    par_b = d
!!$    bmax = 0.1*cts_(nhwhm)
!!$    write(*,*) bmax,cts_(nhwhm),par_e,par_a,par_b
!!$!    tol = sqrt(epsilon(cts))*maxval(cts)
!!$    tol = sqrt(epsilon(cts))
!!$    b = fmin(-bmax,bmax,backfun1,tol)
!!$!    if( b > 100 ) then
!!$!       valid = .false.
!!$!    end if
!!$
!!$    background1 = b
!!$
!!$  end function background1
!!$
!!$  function backfun1(b)
!!$
!!$    real(dbl), intent(in) :: b
!!$    real(dbl) :: backfun1
!!$
!!$    real(dbl), dimension(size(raper)) :: grow, dgrow
!!$    real(dbl) :: s,d,x
!!$    integer :: i
!!$    logical :: valid
!!$
!!$    call the_constructor1(par_e,par_a,cts_,dcts_,b,grow,dgrow,valid)
!!$
!!$    if( .not. valid ) then
!!$       backfun1 = 666
!!$       return
!!$    end if
!!$
!!$!    do i = 1,naper
!!$!       write(*,*) raper(i),grow(i)
!!$!    end do
!!$!    stop 0
!!$    s = 0
!!$    do i = (nhwhm+naper)/2,naper
!!$       x = raper(i) !/ hwhm
!!$       d = 1 - par_e - par_a / x - par_b / x**2
!!$       s = s + abs(grow(i) - d) ! / sqrt(dcts**2 + ..?
!!$    end do
!!$    backfun1 = s
!!$
!!$    write(*,*) real(b),real(s)
!!$
!!$  end function backfun1
!!$
!!$    subroutine the_constructor1(e,a,cts,dcts,b,grow,dgrow,valid)
!!$
!!$    real(dbl), intent(in) :: a,e,b
!!$    real(dbl), dimension(:), intent(in) :: cts, dcts
!!$    real(dbl), dimension(:), intent(out) :: grow,dgrow
!!$    logical, intent(out) :: valid
!!$
!!$    real(dbl), dimension(size(raper)) :: flux,dflux
!!$    integer :: i
!!$    real(dbl) :: t
!!$
!!$    valid = .false.
!!$
!!$    flux = cts - b*aper
!!$    dflux = dcts
!!$
!!$    if( any(flux < epsilon(flux)) ) return
!!$
!!$    ! set up initial point of grow curve
!!$    t = 1 - e - a / raper(nhwhm) - 0.13/ raper(nhwhm)**2
!!$    grow(nhwhm) = t
!!$    dgrow(nhwhm) = t * dcts(nhwhm)/cts(nhwhm)
!!$
!!$    ! compute grow curve
!!$    do i = nhwhm-1,1,-1
!!$       grow(i) = grow(i+1)*(flux(i) / flux(i+1))
!!$       dgrow(i) = grow(i)*sqrt((dcts(i)/cts(i))**2 + (dcts(i+1)/cts(i+1))**2)/1.41
!!$    end do
!!$
!!$    do i = nhwhm+1,size(grow)
!!$       grow(i) = grow(i-1)*(flux(i) / flux(i-1))
!!$       dgrow(i) = grow(i-1)*sqrt((dcts(i)/cts(i))**2 + (dcts(i-1)/cts(i-1))**2)/1.41
!!$    end do
!!$
!!$    valid = .true.
!!$
!!$  end subroutine the_constructor1
!!$
!!$
!!$
!!$  function xbackground(e,a,b,t)
!!$
!!$    use fmm
!!$
!!$    real(dbl), intent(in) :: e,a,b,t
!!$    real(dbl) :: back, bmax, tol, xbackground
!!$
!!$!    par_e = e
!!$    par_a = a
!!$    par_b = b
!!$    par_t = 1 - a / raper(nhwhm) - b / raper(nhwhm)**2
!!$    bmax = 0.1*cts_(nhwhm)
!!$!    bmax = 10
!!$!    write(*,*) bmax,cts_(nhwhm),par_e,par_a,par_b
!!$!    tol = sqrt(epsilon(cts))*maxval(cts)
!!$    tol = sqrt(epsilon(cts))
!!$    back = fmin(-bmax,bmax,xbackfun,tol)
!!$!    if( back > 100 ) then
!!$!       valid = .false.
!!$!    end if
!!$
!!$    xbackground = back
!!$
!!$  end function xbackground
!!$
!!$  function xbackfun(b)
!!$
!!$    real(dbl), intent(in) :: b
!!$    real(dbl) :: xbackfun
!!$
!!$    real(dbl), dimension(size(raper)) :: grow, dgrow
!!$    real(dbl) :: s,g,r
!!$    integer :: i
!!$    logical :: valid
!!$
!!$    call the_constructor(par_t,b,cts_,dcts_,grow,dgrow,valid)
!!$
!!$    if( .not. valid ) then
!!$       xbackfun = 666
!!$       return
!!$    end if
!!$
!!$!    do i = 1,naper
!!$!       write(*,*) raper(i),grow(i)
!!$!    end do
!!$!    stop 0
!!$    s = 0
!!$    do i = (nhwhm+naper)/2,naper
!!$       r = raper(i) !/ hwhm
!!$!       g = 1 - par_e - par_a / r - par_b / r**2
!!$       g = 1 - par_a / r - par_b / r**2
!!$       s = s + abs(grow(i) - g) ! / sqrt(dcts**2 + ..?
!!$    end do
!!$    xbackfun = s
!!$
!!$!    write(*,*) real(b),real(s)
!!$
!!$  end function xbackfun
!!$
!!$
!!$  function ybackground(e,a,b,t)
!!$
!!$    use fmm
!!$
!!$    real(dbl), intent(in) :: e,a,b,t
!!$    real(dbl) :: back, bmax, tol, ybackground
!!$
!!$    par_a = a
!!$    par_b = b
!!$    par_t = t
!!$    par_t = 1 - a / raper(nhwhm) - b / raper(nhwhm)**2
!!$    bmax = 0.1*cts_(nhwhm)
!!$    bmax = 50
!!$    tol = sqrt(epsilon(cts))
!!$    back = fmin(-bmax,bmax,ybackfun,tol)
!!$!    if( back > 100 ) then
!!$!       valid = .false.
!!$!    end if
!!$
!!$    ybackground = back
!!$
!!$  end function ybackground
!!$
!!$  function ybackfun(b)
!!$
!!$    use rfun
!!$
!!$    real(dbl), intent(in) :: b
!!$    real(dbl) :: ybackfun
!!$
!!$    real(dbl), dimension(size(raper)) :: grow, dgrow
!!$    real(dbl) :: s,g,r,x
!!$    integer :: i
!!$    logical :: valid
!!$
!!$    call the_constructor(par_t,b,cts_,dcts_,grow,dgrow,valid)
!!$
!!$    if( .not. valid ) then
!!$       ybackfun = 666
!!$       return
!!$    end if
!!$
!!$    s = 0
!!$    do i = (nhwhm+naper)/2,naper
!!$       r = raper(i) !/ hwhm
!!$!       g = 1 - par_e - par_a / r - par_b / r**2
!!$       g = 1 - par_a / r - par_b / r**2
!!$       x = (grow(i) - g) / (sig*dgrow(i))
!!$       s = s + ihuber(x) ! / sqrt(dcts**2 + ..?
!!$    end do
!!$    ybackfun = s
!!$
!!$!    write(*,*) real(b),real(s)
!!$
!!$  end function ybackfun



!!$  subroutine background2(e,a,b,tx,backs)
!!$
!!$    use NelderMead
!!$    use robustmean
!!$
!!$    real(dbl), intent(in) :: e,a,b
!!$    real(dbl), intent(in out) :: tx
!!$    real(dbl), dimension(:), intent(in out) :: backs
!!$    real(dbl), dimension(:), allocatable :: p,dp
!!$    real(dbl), dimension(size(raper)) :: grow, dgrow, f, r
!!$    real(dbl) :: pmin, d, s
!!$    integer :: n, i, npar, ifault
!!$    logical :: valid
!!$
!!$    par_e = e
!!$    par_a = a
!!$    par_b = b
!!$
!!$    npar = nstar + 1
!!$    allocate(p(npar),dp(npar))
!!$
!!$    p(1) = tx
!!$    p(2:) = backs
!!$    dp(1) = 0.01
!!$    dp(2:) = 0.1
!!$    lambda = 1
!!$    do i = 1, 1
!!$       call nelmin1(backfun2,p,dp,pmin,ifault)
!!$       write(*,*) real(pmin),ifault,real(lambda)
!!$       lambda = 2*lambda
!!$    end do
!!$    tx = p(1)
!!$    backs = p(2:)
!!$!    stop 0
!!$    deallocate(p,dp)
!!$
!!$  end subroutine background2
!!$
!!$  function backfun2(p)
!!$
!!$    real(dbl), dimension(:), intent(in) :: p
!!$    real(dbl) :: backfun2
!!$
!!$    real(dbl), dimension(size(raper)) :: grow, dgrow, f
!!$    real(dbl) :: s,g,r
!!$    integer :: n,i,j
!!$    logical :: valid
!!$
!!$    n = (nhwhm + naper) / 2
!!$    call asymptote(n,par_e,par_a,par_b,f)
!!$
!!$    s = 0
!!$    open(1,file='/tmp/c')
!!$    do i = 1, nstar
!!$       call the_constructor(p(1),p(i+1),cts(i,:),dcts(i,:),grow,dgrow,valid)
!!$       if( valid ) then
!!$          s = s + sum(abs(grow(n:) - f(n:)))
!!$          do j = n,naper
!!$             write(1,*) raper(j),abs(grow(j) - f(j)),grow(j),f(j)
!!$          end do
!!$       else
!!$          s = s + naper
!!$       end if
!!$    end do
!!$    close(1)
!!$
!!$    backfun2 = s / (nstar*(naper - n)) !+ lambda*(max(0.0,1-p(1))) !+ sum(abs(p(2:))))
!!$
!!$  end function backfun2
!!$
!!$
!!$
!!$  subroutine background(e,a,b,back,tx)
!!$
!!$    use NelderMead
!!$    use robustmean
!!$
!!$    real(dbl), intent(in) :: e,a,b
!!$    real(dbl), intent(in out) :: back,tx
!!$    real(dbl), dimension(2) :: p,dp
!!$    real(dbl), dimension(size(raper)) :: grow, dgrow, f, r
!!$    real(dbl) :: pmin, d, s
!!$    integer :: n, ifault
!!$    logical :: valid
!!$
!!$    par_e = e
!!$    par_a = a
!!$    par_b = b
!!$
!!$    p(1) = tx
!!$    p(2) = back
!!$    dp(1) = 0.01
!!$    dp(2) = 1
!!$    call nelmin1(backfun,p,dp,pmin,ifault)
!!$    tx = p(1)
!!$    back = p(2)
!!$
!!$    n = (nhwhm + naper) / 2
!!$    call the_constructor(tx,back,cts_,dcts_,grow,dgrow,valid)
!!$    call asymptote(n,e,a,b,f)
!!$    r(n:) = abs(grow(n:) - f(n:)) / dgrow(n:)
!!$    call rinit(r(n:),d,s)
!!$    sig = d
!!$
!!$    call nelmin1(backas,p,dp,pmin,ifault)
!!$    write(*,*) real(p), real(sig)
!!$    tx = p(1)
!!$    back = p(2)
!!$
!!$  end subroutine background
!!$
!!$  function backfun(p)
!!$
!!$    real(dbl), dimension(:), intent(in) :: p
!!$    real(dbl) :: backfun
!!$
!!$    real(dbl), dimension(size(raper)) :: grow, dgrow, f
!!$    real(dbl) :: s,g,r
!!$    integer :: n
!!$    logical :: valid
!!$
!!$    call the_constructor(p(1),p(2),cts_,dcts_,grow,dgrow,valid)
!!$
!!$    if( .not. valid ) then
!!$       backfun = 666
!!$       return
!!$    end if
!!$
!!$!    do i = 1,naper
!!$!       write(*,*) raper(i),grow(i)
!!$!    end do
!!$    !    stop 0
!!$
!!$    n = (nhwhm + naper) / 2
!!$    call asymptote(n,par_e,par_a,par_b,f)
!!$    backfun = sum(abs(grow(n:) - f(n:))) / (naper - n)
!!$
!!$    s = 0
!!$    do i = (nhwhm+naper)/2,naper
!!$       r = raper(i) !/ hwhm
!!$       g = 1 - (par_e + (par_a + par_b / r ) / r)
!!$       s = s + abs(grow(i) - g) !/ dgrow(i) ! / sqrt(dcts**2 + ..?
!!$!       write(*,*) real(x),real(d),real(grow(i))
!!$    end do
!!$    backfun = s
!!$
!!$!    write(*,*) real(p),real(s)
!!$
!!$  end function backfun
!!$
!!$  function backas(p)
!!$
!!$    use rfun
!!$
!!$    real(dbl), dimension(:), intent(in) :: p
!!$    real(dbl) :: backas
!!$
!!$    real(dbl), dimension(size(raper)) :: grow, dgrow, f, r, rs, rho
!!$!    real(dbl) :: s,g,r
!!$    integer :: n
!!$    logical :: valid
!!$
!!$    call the_constructor(p(1),p(2),cts_,dcts_,grow,dgrow,valid)
!!$
!!$    if( .not. valid ) then
!!$       backas = 666*naper
!!$       return
!!$    end if
!!$
!!$!    do i = 1,naper
!!$!       write(*,*) raper(i),grow(i)
!!$!    end do
!!$    !    stop 0
!!$
!!$    n = (nhwhm + naper) / 2
!!$    call asymptote(n,par_e,par_a,par_b,f)
!!$    r = (grow - f) / dgrow
!!$    rs = r / sig
!!$    call ihubers(rs,rho)
!!$    backas = sum(rho(n:)) / (naper - n)
!!$
!!$  end function backas
!!$
!!$
!!$  subroutine commons(e,a,b)
!!$
!!$    use NelderMead
!!$
!!$    real(dbl), intent(in out) :: e,a,b
!!$    real(dbl), dimension(3) :: p,dp
!!$    real(dbl) :: pmin
!!$    integer :: ifault
!!$
!!$    ! estimate parameters
!!$    p(1) = e
!!$    p(2) = a
!!$    p(3) = b
!!$    dp(1) = 0.0001
!!$    dp(2) = 0.001
!!$    dp(3) = 0.01
!!$    call nelmin1(mincom,p,dp,pmin,ifault)
!!$!    valid = ifault == 0 .and. p(2) < 0.99*maxback
!!$
!!$    e = p(1)
!!$    a = p(2)
!!$    b = p(3)
!!$
!!$!    write(*,*) real(p),real(pmin)
!!$
!!$  end subroutine commons


!!$  function mincom(p)
!!$
!!$    use robustmean
!!$    use rfun
!!$
!!$    real(dbl) :: mincom
!!$    real(dbl), dimension(:), intent(in) :: p
!!$
!!$    real(dbl), dimension(size(raper)) :: grow,dgrow
!!$    real(dbl) :: s,e,b,d,a,r,g
!!$    integer :: i,j,n
!!$    logical :: valid
!!$
!!$    e = p(1)
!!$    a = p(2)
!!$    b = p(3)
!!$    n = (nhwhm + naper) / 2
!!$
!!$    s = 0
!!$    do j = 1,nstar
!!$       call the_constructor(tx(j),back(j),cts(j,:),dcts(j,:),grow,dgrow,valid)
!!$       if( .not. valid ) s = s + 1
!!$       do i = n, naper
!!$          r = raper(i)
!!$          g = 1 - (e + (a + b / r) / r)
!!$          s = s + abs(grow(i) - g)
!!$!          write(*,*) real(grow(i)),real(dgrow(i)),real((grow(i)-g)/dgrow(i))
!!$!          write(*,*) real(grow(i)),real(dgrow(i)),real((grow(i)-g)/dgrow(i))
!!$!          s = s + huber((grow(i) - g)/dgrow(i))
!!$       end do
!!$    end do
!!$
!!$    d = a - b / raper(naper)
!!$    ! conditions: e,a,b > 0, a > b/r(max)
!!$    mincom = s + lambda*max(0.0,-e) + max(0.0,-a) + max(0.0,-b) + max(0.0,-d)
!!$
!!$
!!$!    if( e < 0 .or. a < 0 .or. b < 0 .or. x < 0 ) mincom = sum(grow_(n:naper))
!!$!    if( a < 0 .or. b < 0 .or. a < b / raper(naper) ) mincom = sum(grow_(n:naper))
!!$

!!$    return
!!$
!!$    n = (nhwhm + naper) / 2
!!$    s = 0
!!$    do k = 1, nstar
!!$
!!$       call the_constructor(e,a,cts(k,:),dcts(k,:),back(k),grow,dgrow,valid)
!!$       if( .not. valid ) s = s + 1e3
!!$       grows(k,:) = grow
!!$       dgrows(k,:) = dgrow
!!$
!!$
!!$       do i = n, naper
!!$!       do i = nhwhm, naper
!!$          x = raper(i) !/ hwhm
!!$          d = 1 + e - a / x
!!$!          d = 1  - a / x
!!$          !d = 1
!!$          s = s + abs(grow(i) - d) !/ dgrow(i)
!!$!          if( grow(i) <= 1 ) then
!!$!             s = s + 1-grow(i)
!!$!          else
!!$!             s = s + 1
!!$          !          end if
!!$          !          s = s + abs(grow(i) - 1) !* raper(i)/raper(naper)
!!$!          if( d < grow(i) .and. grow(i) <= 1 ) then
!!$!             s = s + (1 - grow(i))
!!$!          else if( grow(i) > 1 ) then
!!$!             s = s + 100*(grow(i) - 1)
!!$!          else if( grow(i) <= d ) then
!!$!             s = s + 100*(d - grow(i))
!!$!          end if
!!$       end do
!!$    end do
!!$!    s = s / nstar
!!$
!!$!    mincom = s + lambda(1)*max(0.0,t) + lambda(2)*max(0.0,a)
!!$    mincom = s + abs(e) + a
!!$!    mincom = s !+ 0.01*abs(e)
!!$
!!$!    write(*,*) real(s),real(e),real(a)
!!$
!!$    if( a < 0 ) mincom = 1e3
!!$
!!$    s = 0
!!$    do i = 1,naper
!!$       call rinit(grows(:,i),x,d)
!!$       write(*,*) i,real(x),real(d)
!!$       s = s + d
!!$    end do
!!$    mincom = s + abs(e) + a
!stop 0
!  end function mincom

end module grow_model

!
!  Photometric systems table
!
!  Copyright © 2013 - 2015, 2018-21 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module phsysfits

  use titsio
  use iso_fortran_env

  implicit none

  integer, parameter, private :: dbl = REAL64

  type type_phsys
     character(len=FLEN_VALUE) :: name = '', filter_ref = ''
     character(len=FLEN_VALUE), dimension(:), allocatable :: filter
     real(dbl), dimension(:), allocatable :: lam_eff,lam_fwhm,nu_eff,nu_fwhm, &
          fnu_ref,flam_ref
  end type type_phsys

  interface deallocate_phsyscal
     module procedure deallocate_phsyscal_single,deallocate_phsyscal_multiple
  end interface deallocate_phsyscal

contains


  subroutine phsysread(filename,phsys,status)

    character(len=*), intent(in) :: filename
    type(type_phsys), dimension(:), allocatable, intent(out) :: phsys
    integer, intent(out) :: status

    integer, parameter :: frow = 1
    real(dbl), parameter :: nullval = real(0.0,dbl)

    integer :: nrows, ncols, hdutype, nhdu, i, n
    integer, parameter :: maxcols = 7
    integer, dimension(maxcols) :: col
    character(len=FLEN_VALUE), dimension(maxcols) :: cols
    character(len=FLEN_VALUE) :: photosys
    logical :: anyf
    type(fitsfiles) :: fits

    cols(1) = FITS_COL_FILTER
    cols(2) = FITS_COL_LAMEFF
    cols(3) = FITS_COL_LAMFWHM
    cols(4) = FITS_COL_NUEFF
    cols(5) = FITS_COL_NUFWHM
    cols(6) = FITS_COL_FLAMREF
    cols(7) = FITS_COL_FNUREF

    status = 0

    ! open, and get number of HDU
    call fits_open_file(fits,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) 'Error: failed to read the file `',trim(filename),"'."
       return
    end if

    call fits_get_num_hdus(fits,nhdu,status)
    if( status /= 0 ) goto 666

    ! checkpoint
    call fits_read_key(fits,'HDUNAME',photosys,status)
    if( status == FITS_KEYWORD_NOT_FOUND .or. photosys /= FHDUNAME ) then
       status = 0
       write(error_unit,*) "Warning: Photometry system file `",trim(filename), &
            "' has wrong identificator."
    end if
    if( status /= 0 ) goto 666

    allocate(phsys(nhdu-1))

    do n = 1, nhdu-1

       call fits_movabs_hdu(fits,n+1,hdutype,status)
       if( hdutype /= FITS_BINARY_TBL .or. status /= 0 ) goto 666

       call fits_read_key(fits,'EXTNAME',phsys(n)%name,status)
       call fits_read_key(fits,FITS_KEY_FILTREF,phsys(n)%filter_ref,status)
       if( status == FITS_KEYWORD_NOT_FOUND .or. status /= 0 ) goto 666

       call fits_get_num_cols(fits,ncols,status)
       call fits_get_num_rows(fits,nrows,status)

       ! find columns by cols
       do i = 1, size(cols)
          call fits_get_colnum(fits,.true.,cols(i),col(i),status)
       end do
       if( status /= 0 ) goto 666
       if( ncols /= size(cols) ) stop 'ncols /= size(cols)'

       allocate(phsys(n)%filter(nrows),phsys(n)%lam_eff(nrows), &
            phsys(n)%lam_fwhm(nrows),phsys(n)%nu_eff(nrows), &
            phsys(n)%nu_fwhm(nrows),phsys(n)%flam_ref(nrows), &
            phsys(n)%fnu_ref(nrows))

       phsys(n)%filter = ''
       call fits_read_col(fits,col(1),frow,'',phsys(n)%filter,anyf,status)
       call fits_read_col(fits,col(2),frow,nullval,phsys(n)%lam_eff,anyf,status)
       call fits_read_col(fits,col(3),frow,nullval,phsys(n)%lam_fwhm,anyf,status)
       call fits_read_col(fits,col(4),frow,nullval,phsys(n)%nu_eff,anyf,status)
       call fits_read_col(fits,col(5),frow,nullval,phsys(n)%nu_fwhm,anyf,status)
       call fits_read_col(fits,col(6),frow,nullval,phsys(n)%fnu_ref,anyf,status)
       call fits_read_col(fits,col(6),frow,nullval,phsys(n)%flam_ref,anyf,status)

       if( status /= 0 ) goto 666
    end do

    call fits_close_file(fits,status)
    return

666 continue

    if( allocated(phsys) ) then
       do i = 1, size(phsys)
          if( allocated(phsys(i)%filter) ) deallocate(phsys(i)%filter)
          if( allocated(phsys(i)%lam_eff) ) deallocate(phsys(i)%lam_eff)
          if( allocated(phsys(i)%lam_fwhm) ) deallocate(phsys(i)%lam_fwhm)
          if( allocated(phsys(i)%nu_eff) ) deallocate(phsys(i)%nu_eff)
          if( allocated(phsys(i)%nu_fwhm) ) deallocate(phsys(i)%nu_fwhm)
          if( allocated(phsys(i)%fnu_ref) ) deallocate(phsys(i)%fnu_ref)
          if( allocated(phsys(i)%flam_ref) ) deallocate(phsys(i)%flam_ref)
       end do
    end if

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

  end subroutine phsysread

  subroutine listphsys(phsystable)

    character(len=*), intent(in) :: phsystable
    type(type_phsys), dimension(:), allocatable :: phsyscal
    integer :: status,i,j

    call phsysread(phsystable,phsyscal,status)
    if( status /= 0 ) stop 'Failed to read photometry system table.'

    write(*,*)
    do i = 1,size(phsyscal)
       write(*,'(2a)',advance="no") trim(phsyscal(i)%name),": "
       do j = 1, size(phsyscal(i)%filter)
          write(*,'(a)',advance="no") trim(phsyscal(i)%filter(j))
          if( j == size(phsyscal(i)%filter) ) then
             write(*,*)
          else
             write(*,'(a)',advance="no") ","
          end if
       end do
    end do

    call deallocate_phsyscal(phsyscal)

  end subroutine listphsys

  subroutine deallocate_phsyscal_multiple(phsyscal)

    type(type_phsys), dimension(:), allocatable :: phsyscal
    integer :: i

    if( allocated(phsyscal) ) then
       do i = 1,size(phsyscal)
          call deallocate_phsyscal_single(phsyscal(i))
       end do
       deallocate(phsyscal)
    end if

  end subroutine deallocate_phsyscal_multiple

  subroutine deallocate_phsyscal_single(phsyscal)

    type(type_phsys) :: phsyscal

    if( allocated(phsyscal%filter) ) then
       deallocate(phsyscal%filter,phsyscal%lam_eff,phsyscal%lam_fwhm, &
            phsyscal%nu_eff,phsyscal%nu_fwhm,phsyscal%fnu_ref,phsyscal%flam_ref)
    end if

  end subroutine deallocate_phsyscal_single

  subroutine phselect(phsystable,phsystem,phsys)

    character(len=*), intent(in) :: phsystable,phsystem
    type(type_phsys), intent(out) :: phsys
    type(type_phsys), dimension(:), allocatable :: phsyscal

    integer :: i,n,status
    logical :: found

    if( phsystem == '' ) stop 'Photometry system undefined.'

    call phsysread(phsystable,phsyscal,status)
    if( status /= 0 ) stop 'Failed to read photometry system table.'

    found = .false.
    do i = 1,size(phsyscal)
       if( phsyscal(i)%name == phsystem ) then
          n = size(phsyscal(i)%filter)
          phsys%name = phsyscal(i)%name
          phsys%filter_ref = phsyscal(i)%filter_ref
          allocate(phsys%filter(n),phsys%lam_eff(n),phsys%lam_fwhm(n),&
            phsys%nu_eff(n),phsys%nu_fwhm(n),phsys%flam_ref(n),phsys%fnu_ref(n))
          phsys%filter = phsyscal(i)%filter
          phsys%lam_eff = phsyscal(i)%lam_eff
          phsys%lam_fwhm = phsyscal(i)%lam_fwhm
          phsys%nu_eff = phsyscal(i)%nu_eff
          phsys%nu_fwhm = phsyscal(i)%nu_fwhm
          phsys%flam_ref = phsyscal(i)%flam_ref
          phsys%fnu_ref = phsyscal(i)%fnu_ref
          found = .true.
       end if
    end do

    call deallocate_phsyscal(phsyscal)

    if( .not. found ) stop 'Specified photometry system not found.'

  end subroutine phselect


  subroutine selphsystem(phsyscal,phsystem,filter,leff,lfwhm,feff,ffwhm,flam_ref, &
       fnu_ref,status)

    type(type_phsys), dimension(:), intent(in) :: phsyscal
    character(len=*), intent(in) :: phsystem,filter
    real(dbl), intent(out) :: leff,lfwhm,feff,ffwhm,flam_ref,fnu_ref
    integer, intent(out) :: status

    integer :: i,j

    status = -1

    do i = 1,size(phsyscal)
!       write(*,*) trim(phsyscal(i)%name)
       if( phsyscal(i)%name == phsystem ) then
          do j = 1, size(phsyscal(i)%filter)
!             write(*,*) trim(phsyscal(i)%filter(j)), trim(filter)
             if( phsyscal(i)%filter(j) == filter ) then
                status = 0
                feff = phsyscal(i)%nu_eff(j)
                ffwhm = phsyscal(i)%nu_fwhm(j)
                leff = phsyscal(i)%lam_eff(j)
                lfwhm = phsyscal(i)%lam_fwhm(j)
                flam_ref = phsyscal(i)%flam_ref(j)
                fnu_ref = phsyscal(i)%fnu_ref(j)
                return
             end if
          end do
       end if
    end do

  end subroutine selphsystem


  subroutine phsysmagph(phsys,filter,pairs,mag,dmag,ph,dph)

    use photoconv

    type(type_phsys), intent(in) :: phsys
    character(len=*), dimension(:), intent(in) :: filter
    integer, dimension(:,:), intent(in) :: pairs
    real(dbl), dimension(:,:), intent(in) :: mag,dmag
    real(dbl), dimension(:,:), intent(out) :: ph,dph

    real(dbl), parameter :: eps = epsilon(ph)
    real(dbl), dimension(size(filter)) :: feff,ffwhm,leff,lfwhm,flamref,fnuref
    integer :: n,i,j,k,status
!    real(dbl), dimension(:,:), allocatable :: ph0,dph0,ph3,dph3,mag0,dmag0, &
!         magx,dmagx,mag3,dmag3,flux,dflux
    real(dbl), dimension(:,:), allocatable :: flux,dflux
    real(dbl) :: w

    if( size(mag,2) /= size(filter) ) stop 'Counts of filters and magnitudes different.'

    j = 1
    do n = 1, size(mag,2)
       call selphsystem((/phsys/),phsys%name,filter(n), &
            leff(n),lfwhm(n),feff(n),ffwhm(n),flamref(n),fnuref(n),status)

       if( status /= 0 ) then
          write(error_unit,*) 'Filter `',trim(filter(n)),"' not found in system `",&
               trim(phsys%name),"'."
          stop 'Filter not found.'
       end if
    end do

!    allocate(ph0(size(ph,1),size(ph,2)),dph0(size(ph,1),size(ph,2)))

!    write(*,*) leff(2),lfwhm(2),flamref(2)
!    do j = 1,size(mag,2)
!       call mag2ph0(leff(j),lfwhm(j),flamref(j),mag(:,j),dmag(:,j),ph(:,j),dph(:,j))
!    end do
!    write(*,'(5e10.3)') ph(1,:)
!    call mag2ph(leff(j),lfwhm(j),flamref(j),mag(:,j),dmag(:,j),ph(:,j),dph(:,j))


!    do n = 1,size(mag,1)
!       call mag2ph3(leff,lfwhm,flamref,mag(n,:),dmag(n,:),ph(n,:),dph(n,:))
!    end do

!    do j = 1,size(mag,1)
!       write(*,*) j,mag(j,3),dmag(j,3),ph(j,3),dph(j,3)
!    end do

!    allocate(mag0(size(ph,1),size(ph,2)),dmag0(size(ph,1),size(ph,2)))

!    call ph2mag0(leff(1),lfwhm(1),flamref(1),ph(:,1),dph(:,1),mag0(:,1),dmag0(:,1))
!    do j = 1,size(mag,1)
!       write(*,'(5g15.5)') real(mag(j,3)),real(ph(j,3)),real(ph0(j,3)),real(ph0(j,2)/ph0(j,3)),&
!            real(ph0(j,3)/ph(j,3))
!    end do

    allocate(flux(size(ph,1),size(ph,2)),dflux(size(ph,1),size(ph,2)))
    call phsysmagflux(phsys,filter,pairs,mag,dmag,flux,dflux)

    k = pairs(1,1)
    call mag2ph0(leff(k),lfwhm(k),flamref(k),mag(:,k),dmag(:,k),ph(:,k),dph(:,k))

    do n = 2, size(pairs,1)
       i = pairs(n,1)
       j = pairs(n,2)
       if( pairs(n,1) < k ) then
          i = pairs(n,1)
          j = pairs(n,2)
          w = leff(i) / leff(j)
          where( flux(:,i) > 0 .and. flux(:,j) > 0 .and. ph(:,j) > 0 )
             ph(:,i) = ph(:,j)*(flux(:,i)/flux(:,j))*w
          elsewhere
             ph(:,i) = -1
          end where
          where( dflux(:,i) > 0 .and. ph(:,i) > 0 .and. flux(:,i) > 0)
             dph(:,i) = dflux(:,i) * ph(:,i) / flux(:,i)
          elsewhere
             dph(:,i) = 0
          end where
       else if( pairs(n,2) > k ) then
          i = pairs(n,1)
          j = pairs(n,2)
          w = leff(j) / leff(i)
          where( flux(:,i) > 0 .and. flux(:,j) > 0 .and. ph(:,i) > 0 )
             ph(:,j) = ph(:,i)*(flux(:,j)/flux(:,i))*w
          elsewhere
             ph(:,j) = -1
          end where
          where( dflux(:,j) > 0 .and. ph(:,j) > 0 .and. flux(:,j) > 0)
             dph(:,j) = dflux(:,j) * ph(:,j) / flux(:,j)
          elsewhere
             dph(:,j) = 0
          end where
       end if
    end do
    deallocate(flux,dflux)



!    allocate(ph0(size(ph,1),size(ph,2)),dph0(size(ph,1),size(ph,2)), &
!         ph3(size(ph,1),size(ph,2)),dph3(size(ph,1),size(ph,2)), &
!         mag3(size(ph,1),size(ph,2)),dmag3(size(ph,1),size(ph,2)),&
!         mag0(size(ph,1),size(ph,2)),dmag0(size(ph,1),size(ph,2)),&
!         magx(size(ph,1),size(ph,2)),dmagx(size(ph,1),size(ph,2)),&
!         )



!!$    goto 666
!!$
!!$
!!$!    do n = 1,size(mag,1)
!!$!       call mag2ph(leff,lfwhm,flamref,mag(n,:),dmag(n,:),ph(n,:),dph(n,:))
!!$!       call mag2ph0(leff,flamref,mag(n,:),dmag(n,:),ph0(n,:),dph0(n,:))
!!$!       write(*,*) real(mag(n,:)),real(ph(n,:))
!!$!    end do
!!$
!!$    do n = 1,size(mag,1)
!!$!       call mag2ph(leff,lfwhm,flamref,mag(n,:),dmag(n,:),ph(n,:),dph(n,:))
!!$!       call mag2ph3(leff,lfwhm,flamref,mag(n,:),dmag(n,:),ph3(n,:),dph3(n,:))
!!$!       write(*,*) real(mag(n,:)),real(ph(n,:))
!!$    end do
!!$
!!$!    do n = 1,size(mag,1)
!!$!       call mag2ph(leff,lfwhm,flamref,mag(n,:),dmag(n,:),ph(n,:),dph(n,:))
!!$!       call mag2ph(leff,lfwhm,flamref,mag(n,:),dmag(n,:),ph(n,:),dph(n,:))
!!$!       write(*,*) real(mag(n,:)),real(ph(n,:))
!!$!    end do
!!$
!!$!    do n = 1,size(mag,1)
!!$!       write(*,'(2f10.3,3g15.5)') mag(n,3),mag(n,2)-mag(n,3),ph0(n,3),ph(n,3),ph3(n,3)
!!$!    end do
!!$
!!$    do j = 1,size(mag,2)
!!$!       call mag2ph0(leff(j),flamref(j),mag(:,j),dmag(:,j),ph0(:,j),dph0(:,j))
!!$!       call ph2mag0(leff(j),flamref(j),ph0(:,j),dph0(:,j),mag0(:,j),dmag0(:,j))
!!$    end do
!!$    do n = 1,size(mag,1)
!!$       call mag2ph3(leff,lfwhm,flamref,mag(n,:),dmag(n,:),ph3(n,:),dph3(n,:))
!!$!       call ph2mag3(leff,lfwhm,flamref,ph3(n,:),dph3(n,:),mag3(n,:),dmag3(n,:))
!!$    end do
!!$
!!$    do j = 1,size(mag,2)-2
!!$!       write(*,*) trim(filter(j))
!!$       do n = 1,size(mag,1)
!!$          write(*,'(2f10.3,3g15.5)') mag(n,j),mag(n,j)-mag(n,j+1),ph0(n,j),ph3(n,j)
!!$       end do
!!$       do n = 1,size(mag,1)
!!$          write(*,'(5f10.3)') mag(n,j),mag(n,j)-mag(n,j+1),mag0(n,j),mag3(n,j)
!!$       end do
!!$    end do
!!$    do j = size(mag,2)-1,size(mag,2)
!!$       write(*,*) trim(filter(j))
!!$!       do n = 1,size(mag,1)
!!$!          call mag2ph3(leff,lfwhm,flamref,mag(j,:),dmag(j,:),ph3(j,:),dph3(j,:))
!!$!          call ph2mag3(leff,lfwhm,flamref,ph3(j,:),dph3(j,:),mag3(j,:),dmag3(j,:))
!!$!       end do
!!$       do n = 1,size(mag,1)
!!$          write(*,'(2f10.3,3g15.5)') mag(n,j),mag(n,j-1)-mag(n,j),ph0(n,j),ph3(n,j)
!!$       end do
!!$       do n = 1,size(mag,1)
!!$          write(*,'(5f10.3)') mag(n,j),mag(n,j-1)-mag(n,j),mag0(n,j),mag3(n,j)
!!$       end do
!!$    end do
!!$
!!$    do n = 1,size(mag,1)
!!$!       call ph2mag3(leff,lfwhm,flamref,ph(n,:),dph(n,:),magx(n,:),dmagx(n,:))
!!$!       call ph2mag0(lfwhm(3),flamref(3),ph0(:,3),dph0(:,3),mag0(:,3),dmag0(:,3))
!!$!       call ph2mag0(leff(3),lfwhm(3),flamref(3),ph(:,3),dph(:,3),mag0(:,3),dmag0(:,3))
!!$!       call ph2mag3(leff,lfwhm,flamref,ph3(n,:),dph3(n,:),mag3(n,:),dmag3(n,:))
!!$    end do
!!$
!!$
!!$    do j = 1,size(mag,2)-2
!!$       write(*,*) trim(filter(j))
!!$       do n = 1,size(mag,1)
!!$          write(*,'(5f10.3)') mag(n,j),mag(n,j)-mag(n,j+1),mag0(n,j),mag3(n,j)
!!$       end do
!!$    end do
!!$    do j = size(mag,2)-1,size(mag,2)
!!$       write(*,*) trim(filter(j))
!!$       do n = 1,size(mag,1)
!!$          write(*,'(5f10.3)') mag(n,j),mag(n,j-1)-mag(n,j),mag0(n,j),mag3(n,j)
!!$       end do
!!$    end do
!!$
!!$!    stop
!!$
!!$!    do n = 1,size(mag,1)
!!$!       call mag2ph(leff,lfwhm,flamref,mag(n,:),dmag(n,:),ph(n,:),dph(n,:))
!!$!       call mag2ph3(leff,lfwhm,flamref,mag(n,:),dmag(n,:),ph(n,:),dph(n,:))
!!$!       call mag2ph3(leff,lfwhm,flamref,mag(n,:),dmag(n,:),ph(n,:),dph(n,:))
!!$!       write(*,*) real(mag(n,:)),real(ph(n,:))
!!$!    end do
!!$
!!$    ph = ph0
!!$    dph = dph0
!!$
!!$
!!$    666 continue

    ! when magnitude error is unavailable, we are use the most optimistics
    ! variant with non-photon noise neglecting
!    where( dmag > 9 .or. dmag < epsilon(dmag) )
!       dph = sqrt(ph)
!    end where

!    deallocate(ph0,dph0,ph3,dph3,mag0,dmag0,magx,dmagx,mag3,dmag3)

  end subroutine phsysmagph


  subroutine phsysphmag1(phsys,filter,ph,dph,mag,dmag)

    use photoconv

    type(type_phsys), intent(in) :: phsys
    character(len=*), intent(in) :: filter
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: mag,dmag

    real(dbl) :: feff,ffwhm,leff,lfwhm,flamref,fnuref
    integer :: status

    call selphsystem((/phsys/),phsys%name,filter, &
         leff,lfwhm,feff,ffwhm,flamref,fnuref,status)

    call ph2mag0(leff,lfwhm,flamref,ph,dph,mag,dmag)

  end subroutine phsysphmag1

  subroutine phsysmagph1(phsys,filter,mag,dmag,ph,dph)

    use photoconv

    type(type_phsys), intent(in) :: phsys
    character(len=*), intent(in) :: filter
    real(dbl), dimension(:), intent(in) :: mag,dmag
    real(dbl), dimension(:), intent(out) :: ph,dph

    real(dbl) :: feff,ffwhm,leff,lfwhm,flamref,fnuref
    integer :: status

    call selphsystem((/phsys/),phsys%name,filter, &
         leff,lfwhm,feff,ffwhm,flamref,fnuref,status)

    call mag2ph0(leff,lfwhm,flamref,mag,dmag,ph,dph)

  end subroutine phsysmagph1

  subroutine phsysphmag(phsys,filters,pairs,ph,dph,mag,dmag)

    use photoconv

    type(type_phsys), intent(in) :: phsys
    character(len=*), dimension(:), intent(in) :: filters
    integer, dimension(:,:), intent(in) :: pairs
    real(dbl), dimension(:,:), intent(in) :: ph,dph
    real(dbl), dimension(:,:), intent(out) :: mag,dmag

    real(dbl), dimension(:,:), allocatable :: flux,dflux
    integer, dimension(size(filters)) :: idx
    integer :: n,i,j,k
    real(dbl) :: w,f

    idx = 0
    do i = 1, size(filters)
       do j = 1, size(phsys%filter)
          if( phsys%filter(j) == filters(i) ) then
             n = n + 1
             idx(i) = j
          end if
       end do
    end do
    if( any(idx == 0 ) ) stop 'Any filter not found (in phsysphmag).'

    allocate(flux(size(ph,1),size(ph,2)),dflux(size(ph,1),size(ph,2)))

    k = pairs(1,1)
    n = idx(k)
    call ph2flux0(phsys%lam_eff(n),ph(:,k),dph(:,k),flux(:,k),dflux(:,k))
    call flux2mag0(phsys%lam_fwhm(n),phsys%flam_ref(n),flux(:,k),dflux(:,k), &
         mag(:,k),dmag(:,k))

    do n = 2, size(pairs,1)

       if( pairs(n,1) < k ) then
          i = pairs(n,1)
          j = pairs(n,2)
          w = phsys%lam_eff(idx(j)) / phsys%lam_eff(idx(i))
          f = (phsys%lam_fwhm(idx(i))*phsys%flam_ref(idx(i)))/ &
               (phsys%lam_fwhm(idx(j))*phsys%flam_ref(idx(j)))
          where( ph(:,i) > 0 .and. ph(:,j) > 0 .and. flux(:,j) > 0 )
             flux(:,i) = flux(:,j)*(ph(:,i)/ph(:,j))*w/f
             mag(:,i) = mag(:,j) - 2.5*log10(flux(:,i) / flux(:,j))
          elsewhere
             flux(:,i) = -1
             mag(:,i) = 99.99999
          end where
          where( dph(:,i) > 0 .and. ph(:,i) > 0 .and. flux(:,i) > 0)
             dflux(:,i) = flux(:,i) * dph(:,i) / ph(:,i)
             dmag(:,i) = 1.086 * dflux(:,i) / flux(:,i)
          elsewhere
             dflux(:,i) = 0
             dmag(:,i) = 9.99999
          end where
       else if( pairs(n,2) > k ) then
          i = pairs(n,1)
          j = pairs(n,2)
          w = phsys%lam_eff(idx(i)) / phsys%lam_eff(idx(j))
          f = (phsys%lam_fwhm(idx(j))*phsys%flam_ref(idx(j)))/ &
               (phsys%lam_fwhm(idx(i))*phsys%flam_ref(idx(i)))
          where( ph(:,i) > 0 .and. ph(:,j) > 0 .and. flux(:,i) > 0 )
             flux(:,j) = flux(:,i)*(ph(:,j)/ph(:,i))*w / f
             mag(:,j) = mag(:,i) - 2.5*log10(flux(:,j) / flux(:,i))
          elsewhere
             flux(:,j) = -1
             mag(:,j) = 99.99999
          end where
          where( dph(:,j) > 0 .and. flux(:,j) > 0 .and. ph(:,j) > 0)
             dflux(:,j) = dph(:,j) * flux(:,j) / ph(:,j)
             dmag(:,j) = 1.086 * dflux(:,j) / flux(:,j)
          elsewhere
             dflux(:,j) = 0
             dmag(:,j) = 9.99999
          end where
       end if
    end do

    deallocate(flux,dflux)

  end subroutine phsysphmag

  subroutine phsysmagflux(phsys,filter,pairs,mag,dmag,flux,dflux)

    use photoconv

    type(type_phsys), intent(in) :: phsys
    character(len=*), dimension(:), intent(in) :: filter
    integer, dimension(:,:), intent(in) :: pairs
    real(dbl), dimension(:,:), intent(in) :: mag,dmag
    real(dbl), dimension(:,:), intent(out) :: flux,dflux

    real(dbl), dimension(size(filter)) :: feff,ffwhm,leff,lfwhm,flamref,fnuref
    integer :: n,i,j,k,status
    real(dbl) :: w

    if( size(mag,2) /= size(filter) ) stop 'Counts of filters and magnitudes different.'

    j = 1
    do n = 1, size(mag,2)
       call selphsystem((/phsys/),phsys%name,filter(n), &
            leff(n),lfwhm(n),feff(n),ffwhm(n),flamref(n),fnuref(n),status)

       if( status /= 0 ) then
          write(error_unit,*) 'Filter `',trim(filter(n)),"' not found in system `",&
               trim(phsys%name),"'."
          stop 'Filter not found.'
       end if
    end do

    do n = 1,size(mag,1)
       call mag2flux0(lfwhm,flamref,mag(n,:),dmag(n,:),flux(n,:),dflux(n,:))
    end do

    k = pairs(1,1)
    do n = 2,size(pairs,1)
       i = pairs(n,1)
       j = pairs(n,2)
       if( pairs(n,1) < k ) then
          w = (lfwhm(i)*flamref(i)) / (lfwhm(j)*flamref(j))
          where( mag(:,i) < 99 .and. mag(:,j) < 99 )
             flux(:,i) = w*flux(:,j)*10.0_dbl**(-0.4_dbl*(mag(:,i) - mag(:,j)))
          elsewhere
             flux(:,i) = -1
          end where
          where( dmag(:,i) < 9 )
             dflux(:,i) = flux(:,i) * dmag(:,i) / 1.0857
          elsewhere
             dflux(:,i) = -1
          end where
       else if( pairs(n,2) > k ) then
          w = (lfwhm(j)*flamref(j)) / (lfwhm(i)*flamref(i))
          where( mag(:,i) < 99 .and. mag(:,j) < 99 )
             flux(:,j) = w*flux(:,i)*10.0_dbl**( 0.4_dbl*(mag(:,i) - mag(:,j)))
          elsewhere
             flux(:,j) = -1
          end where
          where( dmag(:,j) < 9 )
             dflux(:,j) = flux(:,j) * dmag(:,i) / 1.0857
          elsewhere
             dflux(:,j) = -1
          end where
       end if
    end do

  end subroutine phsysmagflux


  subroutine phsysconv(key,filter,phsyscal,area,exptime,arcscale,ph,dph,q,dq)

    use photoconv

    character(len=*), intent(in) :: key, filter
    type(type_phsys), intent(in) :: phsyscal
    real(dbl), intent(in) :: exptime,area,arcscale
    real(dbl), dimension(:), intent(in) :: ph,dph
    real(dbl), dimension(:), intent(out) :: q,dq
    real(dbl), dimension(:), allocatable :: r,dr
    real(dbl) :: feff,ffwhm,leff,lfwhm,fnuref,flamref
    integer :: i
    logical :: defined

    defined = .false.
    do i = 1,size(phsyscal%filter)
       if( filter == phsyscal%filter(i) ) then
          feff = phsyscal%nu_eff(i)
          ffwhm = phsyscal%nu_fwhm(i)
          leff = phsyscal%lam_eff(i)
          lfwhm = phsyscal%lam_fwhm(i)
          fnuref = phsyscal%fnu_ref(i)
          flamref = phsyscal%flam_ref(i)
          defined = .true.
       end if
    end do

    if( .not. defined ) then
       write(error_unit,*) "Filter `",trim(filter),"' not defined."
       stop 'Undefined filter of photometry system.'
    end if

    allocate(r(size(q)),dr(size(dq)))

    call phrate(area,exptime,arcscale,ph,dph,r,dr)

    if( key == 'FNU' ) then
       call ph2fnu(feff,ffwhm,r,dr,q,dq)
    else if( key == 'FLAM' ) then
       call ph2flam0(leff,lfwhm,r,dr,q,dq)
    else if( key == 'PHOTNU' ) then
       call ph2photnu(ffwhm,r,dr,q,dq)
    else if( key == 'PHOTLAM' ) then
       call ph2photlam(lfwhm,r,dr,q,dq)
    else if( key == 'ABMAG' ) then
       call ph2abmag(feff,ffwhm,r,dr,q,dq)
    else if( key == 'STMAG' ) then
       call ph2stmag(leff,lfwhm,r,dr,q,dq)
    else if( key == 'MAG' ) then
       call ph2mag0(leff,lfwhm,flamref,r,dr,q,dq)
    else if( key == 'FLUX' ) then
       call ph2flux(feff,r,dr,q,dq)
    else if( key == 'PHRATE' ) then
       q = r
       dq = dr
    else if( key(1:6) == 'PHOTON' ) then
       q = ph
       dq = dph
    else
       stop 'An unknown quantity for calibrated data requested.'
    end if

    deallocate(r,dr)

  end subroutine phsysconv

  subroutine phstkeys(phsyscal,filter,photflam,photzpt,photplam,photbw)

    use photoconv

    character(len=*), intent(in) :: filter
    type(type_phsys), intent(in) :: phsyscal
    real(dbl), intent(out) :: photflam,photzpt,photplam,photbw
    integer :: i

    do i = 1,size(phsyscal%filter)
       if( filter == phsyscal%filter(i) ) then
          call hstparam(phsyscal%lam_eff(i),phsyscal%lam_fwhm(i), &
               photflam,photzpt,photplam,photbw)
       end if
    end do

  end subroutine phstkeys

  subroutine phsyspairs(phsys,filters,pairs)

    ! arrange filters for photometry transformation

    type(type_phsys), intent(in) :: phsys
    character(len=*), dimension(:), intent(in) :: filters
    integer, dimension(:,:), allocatable :: pairs

    integer :: i,j,l,m,n,npairs

    if( size(filters) == 1 ) then
       allocate(pairs(1,2))
       pairs = 1
       return
    end if

    n = 0
    do j = 1,size(filters)
       if( filters(j) == phsys%filter_ref ) n = j
    end do
    if( n == 0 ) stop 'Reference filter not included in filter set.'

    m = 0
    do j = 1, size(phsys%filter)
       if( phsys%filter(j) == phsys%filter_ref ) m = j
    end do
    if( m == 0 ) stop 'Reference filter not found in standard set.'

    allocate(pairs(size(filters),2))
    npairs = 1
    pairs(1,:) = n

    ! we are supposes that the filters are sorted by wavelength order
    n = pairs(1,1)
    do j = m-1,1,-1
       l = 0
       do i = 1,size(filters)
          if( phsys%filter(j) == filters(i) ) l = i
       end do
       if( l /= 0 ) then
          npairs = npairs + 1
          pairs(npairs,:) = (/l,n/)
          n = l
       end if
    end do
    n = pairs(1,1)
    do j = m+1, size(phsys%filter)
       l = 0
       do i = 1,size(filters)
          if( phsys%filter(j) == filters(i) ) l = i
       end do
       if( l /= 0 ) then
          npairs = npairs + 1
          pairs(npairs,:) = (/n,l/)
          n = l
       end if
    end do

  end subroutine phsyspairs

end module phsysfits

!
! Kombine     Combine a set of frames.
!
! Copyright © 1998-2006, 2011-7 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

! Needs a lot of work:
!  * implement local convertion in FITS keywords


program skombine

!
! Experimental version, subpixel transformation
!
! Sum (combine) the frames.
!
!

  use interpol
  use means
  use robustmean
  use fitsio
  use astrotrafo
  use phio
  use iso_fortran_env

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  real(dbl), parameter :: rad = 57.295779513082322865_dbl

  Character(len=*), parameter :: version = &
       'KOMBINE 0.6.x, (C)1998-2006,2011-7 F.Hroch, Masaryk University,Brno,CZ '

  ! Minimum of values
  real :: minvalue = 0.0

  ! FITS
  logical :: simple,extend,anyf,xrange
  integer :: n, i, j, status, bpix, maxvalue, bitpix = -32, naxis, naxes(2)
  integer :: pcount,gcount,eq,nfiles
  character(len=FLEN_KEYWORD) :: FILTER='FILTER',DATE_OBS='DATE-OBS', &
       EXPTIME='EXPTIME',OBJECT='OBJECT',KEY_GAIN = FITS_KEY_GAIN

  real, dimension(:,:), allocatable :: KOMBINE, IMAGE, EXPMASK
  real, dimension(:,:,:), allocatable :: frames
  real, dimension(:), allocatable :: skies, exptimes
  real :: oneexp, etime, gain, ctph, skymean
  real :: f,fs,sky,dsky
  real(dbl) :: ff,x,y,a,d
  character(len=FLEN_VALUE) :: onedate, obj, filtr, ctype1, ctype2
  character(len=2*FLEN_FILENAME), dimension(:), allocatable :: alldate
  character(len=2*FLEN_FILENAME) :: sb,record
  character(len=4*FLEN_FILENAME) :: key,val
  character(len=3*FLEN_FILENAME) :: buf
  character(len=FLEN_COMMENT) :: comgain
  logical :: init = .false., init_proj = .false., init_crval = .false., &
       init_crpix = .false., init_scale=.false., init_angle=.false., &
       reflex = .false., init_reflex = .false., sky_determine = .true.
  type(AstroTrafoProj) :: tp,tpi
  character(len=FLEN_VALUE) :: ptype = "GNOMONIC"
  real(dbl) :: xcen,ycen
  real(dbl) :: scale = 3600.0 ! pixels per deg
  real(dbl) :: angle = 0.0
  real(dbl), dimension(2) :: xcrval, xcrpix
  real(dbl), dimension(2,2) :: mat,rmat
  integer, dimension(2) :: xnaxes = (/0,0/)
  character(len=*), parameter :: un = '[deg]'

  ! selection of method of interpolation
  ! 0=no interpolation, 1=bilinear, 2=bicubic, 3=bspline
  !   fast                slow        slower     hang up
  !   pixelized           good        perfect    little bit over perfect
  integer :: sint = 2

  ! set dimensions of output image
  integer ::  nx = -1, ny = -1

  ! Output image name:
  character(len=FLEN_FILENAME) :: backup, namekombi='kombine.fits'

  ! adjust output sky
  logical :: adjustsky = .false.

  ! use exposure mask
  logical :: expomask = .false.

  ! output image is computed by robust mean, by default
  logical :: average = .false.

  ! Time start of first exposure
  character(len=FLEN_VALUE) :: first = ''

  ! verbose output
  logical :: verbose = .false.
  logical :: pipelog = .false.

! init variables
  status = 0
  obj = ''
  etime = 0.0
  f = 1.0
  fs = 0.0
  sky = 0.0

  n = 0
  status = 0
  do
     read(*,'(a)',end=20) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Improper input.'

     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'OUTPUT' ) then

        read(val,*) namekombi, backup

     else if( key == 'FITS_KEY_FILTER' ) then

        read(val,*) FILTER

     else if( key == 'FITS_KEY_OBJECT' ) then

        read(val,*) OBJECT

     else if( key == 'FITS_KEY_EXPTIME' ) then

        read(val,*) EXPTIME

     else if( key == 'FITS_KEY_DATEOBS' ) then

        read(val,*) DATE_OBS

     else if( key == 'FITS_KEY_GAIN' ) then

        read(val,*) KEY_GAIN

     else if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'PIPELOG' ) then

        read(val,*) pipelog

     else if( key == 'BITPIX' ) then

        read(val,*) bitpix

     else if( key == 'SCALE' ) then

        read(val,*) scale
        init_scale = .true.

     else if( key == 'ANGLE' ) then

        read(val,*) angle
        init_angle = .true.

     else if( key == 'REFLEX' ) then

        read(val,*) reflex
        init_reflex = .true.

     else if( key == 'CRVAL' ) then

        read(val,*) xcrval
        init_crval = .true.

     else if( key == 'CRPIX' ) then

        read(val,*) xcrpix
        init_crpix = .true.

     else if( key == 'NAXES' ) then

        read(val,*) xnaxes

     else if( key == 'PROJECTION' ) then

        read(val,*) ptype
        init_proj = .true.

     else if( key == 'INTERPOL' ) then

        if( val == 'none' ) sint = 0
        if( val == 'bilinear' ) sint = 1
        if( val == 'bicubic' ) sint = 2
!        if( val == 'bspline' ) sint = 3

     else if( key == 'ADJUSTSKY' ) then

        read(val,*) adjustsky

     else if( key == 'EXPOMASK' ) then

        read(val,*) expomask

     else if( key == 'AVERAGE' ) then

        read(val,*) average

     else if( key == 'NFILES' ) then

        read(val,*) nfiles
        allocate(alldate(nfiles),skies(nfiles),exptimes(nfiles))

     else if( key == 'FILE' ) then

        ! input initialisation of the current file

        read(val,*) sb

        sky_determine = .true.
        status = 0
        Call ftdopn(25,sb,0,status)
        Call ftghpr(25,2,simple,bpix,naxis,naxes,pcount,gcount,extend,status)
        if( status /= 0 ) goto 666
        call ftgkye(25,EXPTIME,oneexp, buf, status)
        if( status /= 0 ) then
           oneexp = -1.0
           status = 0
        endif
        call ftgkys(25,DATE_OBS,onedate, buf, status)
        if( status /= 0 ) then
           onedate = ''
           status = 0
        endif
        call ftgkys(25,OBJECT,obj, buf, status)
        if( status /= 0 ) then
           obj = ''
           status = 0
        endif
        call ftgkys(25,FILTER,filtr, buf, status)
        if( status /= 0 ) then
           filtr = ''
           status = 0
        endif
        call ftgkye(25,KEY_GAIN,gain, comgain, status)
        if( status /= 0 ) then
           gain = -1.0
           status = 0
        endif

        call wcsget(25,tpi,status)
        if( status == KEYWORD_NOT_FOUND ) then
           write(*,'(a)') &
                "Skipped `"//trim(sb)//"': astrometry calibration not found."
           status = 0
           goto 665
        end if

        ! image - data input
        allocate(IMAGE(naxes(1),naxes(2)))
        call FTG2DE(25,1,minvalue,naxes(1),naxes(1),naxes(2),IMAGE,anyf,status)
        if( status /= 0 ) goto 666

        !
        if( average ) then
           ! move to photometry table
           call ftmnhd(25,BINARY_TBL,PHOTOEXTNAME,0,status)
           if( status == BAD_HDU_NUM ) then
              write(*,'(a)') "Skipped `"//trim(sb)// &
                   "': Failed to find a photometry extension."
              status = 0
              goto 665
           end if
           call ftgkye(25,FITS_KEY_CTPH,ctph,buf,status)
           if( status /= 0 ) then
              write(*,'(a)') "Skipped `"//trim(sb)// &
                   "': Failed to find CTPH in the photometry extension."
              status = 0
           endif
           call ftgkye(25,FITS_KEY_SKYMEAN,skymean,buf,status)
           if( status /= 0 ) then
              write(*,'(a)') "Skipped `"//trim(sb)// &
                   "': Failed to find SKYMEAN in the photometry extension."
              status = 0
           else
              ! per pixel (arcsec originally)
              sky = skymean * (3600*real(tpi%scale))**2
              sky_determine = .false.
           endif

        end if

        if( sky_determine ) then
           call rmean(pack(IMAGE(1:size(IMAGE,1):10,1:size(IMAGE,2):10),&
                .true.),sky,dsky)
!        else
!           sky = skymean
        end if

        if( adjustsky ) IMAGE = IMAGE - sky

        ! first image - initialisation
        if( .not. init ) then
           init = .true.
           call trafo_init(tp)

           if( xnaxes(1) /= 0 .and. xnaxes(2) /= 0 ) then
              nx = xnaxes(1)
              ny = xnaxes(2)
           else if( nx < 0 .and. ny < 0 )then
              nx = naxes(1)
              ny = naxes(2)
           endif

           if( average ) then
              allocate(frames(nx,ny,nfiles),stat=status,errmsg=buf)
              if( status /= 0 ) then
                 if( verbose ) write(error_unit,*) 'kombine:',trim(buf)
                 stop 'Failed to allocate memmory.'
              end if
           end if

           allocate(KOMBINE(nx,ny),EXPMASK(nx,ny))
           KOMBINE = 0.0
           EXPMASK = 0.0

           xcen = nx/2.0
           ycen = ny/2.0
           if( init_proj ) then
              tp%type = ptype
           else
              tp%type = tpi%type
           end if
           if( init_crval ) then
              tp%acen = xcrval(1)
              tp%dcen = xcrval(2)
           else
              tp%acen = tpi%acen
              tp%dcen = tpi%dcen
           end if
           if( init_crpix ) then
              tp%xcen = xcrpix(1)
              tp%ycen = xcrpix(2)
           else
              tp%xcen = xcen
              tp%ycen = ycen
           end if
           if( init_scale ) then
              tp%scale = scale
           else
              tp%scale = tpi%scale
           end if
           if( init_angle )then
              tp%rot = angle
           else
              tp%rot = tpi%rot
           end if
           if( init_reflex )then
              if( reflex ) then
                 tp%refl = -1.0_dbl
              else
                 tp%refl = 1.0_dbl
              end if
           else
              tp%refl = tpi%refl
           end if
           tp%err = tpi%err

           call trafo_refresh(tp)

        end if

        if( sint == 3 ) then
           ! init bspline
           call bspline_init(IMAGE)
        endif

        n = n + 1
        write(alldate(n),*) "'",trim(sb),"' ",sky
        skies(n) = sky
        exptimes(n) = oneexp

        ! compute sumation
        do i = 1, nx
           do j = 1, ny

              x = i
              y = j
              call invtrafo(tp,x,y,a,d)
              ff = skyinterpol(sint,a,d,IMAGE,tpi,xrange)

              if( average ) then
                 frames(i,j,n) = real(ff) - sky
              else
                 KOMBINE(i,j) = KOMBINE(i,j) + real(ff)
              end if

              if( oneexp > 0.0 .and. xrange ) &
                   EXPMASK(i,j) = EXPMASK(i,j) + oneexp
           enddo
        enddo
        if( sint == 3 ) then
           call bspline_shutdown
        endif

        if( first == '' ) first = onedate
        if( oneexp > 0.0 ) etime = etime + oneexp

665     continue

        call ftclos(25,status)
        if( status /= 0 ) then
           goto 666
        end if

        if( allocated(IMAGE) ) deallocate(IMAGE)

     end if

  enddo
20 continue

  if( n == 0 ) stop 'No input images.'
  nfiles = n

  if( average ) then
     call rmean(skies(1:nfiles),skymean,dsky)
     do i = 1, nx
        do j = 1, ny
           call rmean(frames(i,j,1:n),f,fs)
           kombine(i,j) = f*n + skymean
        end do
     end do
     deallocate(frames)
  end if


  if( expomask ) then
     where( EXPMASK /= 0.0 )
        KOMBINE = KOMBINE / EXPMASK
     end where
  end if

  ! range checking
  if( bitpix > 0 )then
     maxvalue = int(2.0**bitpix - 1)
     where( KOMBINE < minvalue )
        KOMBINE = minvalue
     endwhere
     where( KOMBINE > maxvalue )
        KOMBINE = maxvalue
     endwhere
  end if

! form an output image
  call fitsbackup(namekombi,backup,status)
  call ftinit(26,namekombi,1,status)
  naxis = 2
  naxes = (/nx, ny/)
  Call ftphps(26,bitpix,naxis,naxes,status)
  if( bitpix > 0 ) then
     call ftpkye(26,'BSCALE',1.0,10,'',status)
     call ftpkye(26,'BZERO',2.0**(bitpix-1),10,'',status)
  endif
  Call ftukys(26,OBJECT,obj,'',status)
  Call ftukys(26,FILTER,filtr,'',status)
  if( average ) then
     call rmean(exptimes(1:nfiles),etime,oneexp)
     call ftukye(26,EXPTIME,etime,10,'Average exposure time',status)
  else
     call ftukye(26,EXPTIME,etime,10,'Sum of all exposure times',status)
  end if
  if( first /= '' ) call ftukys(26,DATE_OBS,first,'UTC of series exposure start',status)
  if( gain > 0.0 ) call ftukye(26,FITS_KEY_GAIN,gain,7,comgain,status)

  rmat(1,:) = (/-1.0_dbl,0.0_dbl/)
  rmat(2,:) = (/ 0.0_dbl,1.0_dbl/)
  mat = matmul(rmat,tp%mat)

  if( tp%type == 'GNOMONIC' ) then
     ctype1 = 'RA---TAN'
     ctype2 = 'DEC--TAN'
  end if
  if( tp%type /= 'IDENTITY' ) then
     call ftukys(26,'CTYPE1',ctype1,'the coordinate type for the first axis',status)
     call ftukys(26,'CTYPE2',ctype2,'the coordinate type for the second axis',status)
  else
     call ftdkey(26,'CTYPE1',status)
     if( status == KEYWORD_NOT_FOUND ) status = 0
     call ftdkey(26,'CTYPE2',status)
     if( status == KEYWORD_NOT_FOUND ) status = 0
  end if
  call ftukyd(26,'CRVAL1',tp%acen,16,un//' first axis value at reference pixel',status)
  call ftukyd(26,'CRVAL2',tp%dcen,16,un//' second axis value at reference pixel',status)
  call ftukyd(26,'CRDER1',tp%err,2,un//' random error in first axis',status)
  call ftukyd(26,'CRDER2',tp%err,2,un//' random error in second axis',status)
  call ftukys(26,'CUNIT1','deg','units of first axis',status)
  call ftukys(26,'CUNIT2','deg','units of second axis',status)
  call ftukyd(26,'CRPIX1',tp%xcen,16,'x-coordinate of reference pixel',status)
  call ftukyd(26,'CRPIX2',tp%ycen,16,'y-coordinate of reference pixel',status)
  call ftukyd(26,'CD1_1',mat(1,1),16,'partial of first axis coordinate w.r.t. x',status)
  call ftukyd(26,'CD1_2',mat(1,2),16,'partial of first axis coordinate w.r.t. y',status)
  call ftukyd(26,'CD2_1',mat(2,1),16,'partial of second axis coordinate w.r.t. x',status)
  call ftukyd(26,'CD2_2',mat(2,2),16,'partial of second axis coordinate w.r.t. y',status)

  if( nfiles > 0 ) then
     write(buf,'(a,i0,a)',iostat=i) &
          'The image is a result of composition of ',nfiles,' exposure(s).'
     if( i== 0 ) call ftpcom(26,buf,status)
     call ftpcom(26,'The time of start, the exposure time, the filter,',status)
     call ftpcom(26,'the intensity multiplier and relative sky value for each image used:',status)
     do i = 1, nfiles
        call ftpcom(26,alldate(i),status)
     enddo
     call ftpcom(26,'All times are derived from DATE-OBS and EXPTIME keywords.',status)
  endif
  if( expomask ) call ftpcom(26,'Fluxes are normalized by exposure times.',status)
  if( adjustsky ) call ftpcom(26,'All sky levels are adjusted to zero.',status)
  select case (sint)
  case(0)
     buf = 'No interpolation has been used.'
  case(1)
     buf = 'Bilinear interpolation has been used.'
  case(2)
     buf = 'Bicubic interpolation has been used.'
  case(3)
     buf = 'Bspline interpolation has been used.'
  end select
  if( average ) then
     call ftpcom(26,'Frames has been averaged by robust mean.',status)
  else
     call ftpcom(26,'Frames has been summed.',status)
  end if
  call ftpcom(26,buf,status)
  call ftpcom(26,version,status)
  if( status /= 0 ) goto 666

  call ftp2de(26,1,nx,nx,ny,KOMBINE,status)

  ! exposure mask
  if( expomask ) then
     call ftiimg(26,bitpix,naxis,naxes,status)
     call ftukys(26,'EXTNAME','EXPOMASK','',status)
     call ftpcom(26,'The exposure mask as an *experimental* feature.',status)
     call ftp2de(26,1,naxes(1),naxes(1),naxes(2),EXPMASK,status)
     if( status == NUMERICAL_OVERFLOW ) status = 0
  end if

  CALL ftclos(26,status)
  if( status /= 0 ) goto 666

  ! print output info
  if( verbose ) then
     write(*,*) 'Output image: ',trim(namekombi)
     write(*,*) 'Dimension: ',nx,'x',ny
  end if

666 continue
  if( allocated(KOMBINE) ) deallocate(KOMBINE)
  if( allocated(EXPMASK) ) deallocate(EXPMASK)
  if( allocated(alldate) ) deallocate(alldate,skies)

  if( status == 0 )then
     stop 0
  else
     call ftrprt ('STDERR',status)
  end if


contains

  function skyinterpol(sint,a,d,array,t,range)

    use astrotrafo

    implicit none

    real(dbl) :: skyinterpol
    real(dbl), intent(in) :: a,d
    integer, intent(in) :: sint
    real, dimension(:,:), intent(in) :: array
    type(AstroTrafoProj),intent(in) :: t
    logical, intent(out) :: range
    real(dbl) :: x,y
    integer :: i,j

    call trafo(t,a,d,x,y)
    i = nint(x)
    j = nint(y)
!    write(*,*) a,d,x,y

    if(  1 <= i .and. i <= size(array,1) .and. &
         1 <= j .and. j <= size(array,2) ) then

       select case (sint)
       case(0)
          ! nearest neighborhood
          skyinterpol = array(i,j)
       case(1)
          ! bilinear interpolation
          skyinterpol = bilinear(real(x),real(y),array)
       case(2)
          ! bicubic interpolation
          skyinterpol = bicubic(real(x),real(y),array)
       end select

       range = .true.
    else
       skyinterpol = 0.0_dbl
       range = .false.
    end if

  end function skyinterpol

end program skombine

!
!  Light Curve Approximations by Fourier series
!
!  gfortran -I../lib -Wall -g -p -fcheck=all -fimplicit-none -fbacktrace \
!            lcapprox.f08 -L../lib -lminpacks -lminpack
!
!  Copyright © 2017 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!


program lcapprox

  use iso_fortran_env

  implicit none
  integer, parameter :: db = selected_real_kind(15)
  real(db), parameter :: pi = 3.14159265358979323844_db

  real(db), dimension(:), allocatable :: x,y
  character(len=10) :: modname, tail

  write(*,*)
  write(*,*) '!  Copyright © 2017 F.Hroch (hroch@physics.muni.cz)'
  write(*,*) '!'
  write(*,*) '!  This file is part of Munipack.'
  write(*,*) '!  All source code is generated by lcapprox.f08.'
  write(*,*) '!'
  write(*,*) '!  Munipack is free software: you can redistribute it and/or modify'
  write(*,*) '!  it under the terms of the GNU General Public License as published by'
  write(*,*) '!  the Free Software Foundation, either version 3 of the License, or'
  write(*,*) '!  (at your option) any later version.'
  write(*,*) '!'
  write(*,*) '!  Munipack is distributed in the hope that it will be useful,'
  write(*,*) '!  but WITHOUT ANY WARRANTY; without even the implied warranty of'
  write(*,*) '!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the'
  write(*,*) '!  GNU General Public License for more details.'
  write(*,*) '!'
  write(*,*) '!  You should have received a copy of the GNU General Public License'
  write(*,*) '!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.'
  write(*,*)

  modname = 'lcparams'
  write(*,'(a)') 'module '//modname
  write(*,*)
  write(*,'(a)') '   implicit none'
  write(*,'(a)') '   integer, parameter, private :: db = selected_real_kind(15)'
  write(*,*)

  ! delta Cep (simulated) by http://adsabs.harvard.edu/abs/2015A%26A...584A..80M
  call delta_cep

  write(*,*)

  ! Algol by http://adsabs.harvard.edu/abs/1989ApJ...342.1061K
  call algol

  write(*,*)
  write(*,'(a)') 'end module '//modname

  ! testing framework
  call testfour


contains

  subroutine delta_cep

    ! Dataset is simulated (without noise). Coeficients of polynomial
    ! are esimated by direct projection.

    complex(db), dimension(0:7) :: dcep
    real(db) :: s
    real :: tmp(4)
    integer :: i

    open(1,file='delta_Cep.dat',status='old')
    allocate(x(999),y(999))   ! dim by `wc delta_Cep.dat'
    do i = 1,size(x)
       read(1,*) x(i),tmp,y(i)
    end do
    close(1)

    ! normalise
    y = y / maxval(y)

    ! Fourier approximation of delta Cep
    write(*,'(a,i0,a)') '   complex(db), dimension(0:',size(dcep)-1, &
         '), parameter :: dcep = (/ &'
    do i = 0,size(dcep)-1
       dcep(i) =  fourproj(i,x,y)
       if( i /= size(dcep)-1 ) then
          tail = ', &'
       else
          tail = ' /)'
       end if
       write(*,'(2(a,es22.15),2a)') '     cmplx(',real(dcep(i)),',',&
            aimag(dcep(i)),')',tail
    end do

    open(9,file='/tmp/dcep')
    dcep(0) = dcep(0) / 2
    do i = 1,size(x)
       s = fourfun(dcep,x(i))
       write(9,*) x(i),y(i),s,y(i)-s
    end do
    close(9)

    deallocate(x,y)

  end subroutine delta_cep


  subroutine algol

    ! The real (measured) data are approximated by least squares.
    ! Some (one) original data-point (commented out with #) has been removed.
    ! The values has been transcribed by me by hand and can contain
    ! mistakes (but much less than any OCR reader which I checked).

    complex(db), dimension(0:13) :: c
    real(db) :: jd0, per, s
    integer :: i

    allocate(x(516),y(516)) ! dim by `wc algol.dat'
    open(1,file='algol.dat',status='old')
    read(1,*)
    read(1,*)
    do i = 1, size(x)
       read(1,*) x(i),y(i)
    end do
    close(1)

    ! to JD without 2.4e6
    x = x + 45000
    ! elements by Kim's paper
    jd0 = 41773.4894
    per = 2.8673285
    x = mod(x - jd0,per) / per
    y = 10**(0.4*y)
    y =  y / maxval(y)

    ! sort by phase
    block
      real(db) :: xx, yy
      integer :: j,k

      do i = 1, size(x) - 1
         k = i
         xx = x(i)
         yy = y(i)
         do j = i + 1, size(x)
            if( x(j) <= xx ) then
               k = j
               xx = x(j)
               yy = y(j)
            endif
         end do
         x(k) = x(i)
         y(k) = y(i)
         x(i) = xx
         y(i) = yy
      end do
    end block

    block
      use minpacks
      real(db), dimension(:), allocatable :: cab
      integer :: info

      allocate(cab(2*size(c)))
      cab = 0
      call lmdif3(fourmin,cab,info=info)
!      write(*,*) cab,info
      c = [(cmplx(cab(1+i),cab(1+i+size(c)),kind=db),i=0,size(c)-1)]

    end block

    write(*,'(a,i0,a)') '   complex(db), dimension(0:',size(c)-1, &
         '), parameter :: algol = (/ &'
    do i = 0,size(c)-1
       if( i /= size(c)-1 ) then
          tail = ', &'
       else
          tail = ' /)'
       end if
       write(*,'(2(a,es22.15),2a)') '     cmplx(',real(c(i)),',', &
            aimag(c(i)),')',tail
    end do

    open(9,file='/tmp/algol')
    do i = 1,size(x)
       s = fourfun(c,x(i))
       write(9,*) x(i),y(i),s,y(i)-s
    end do
    close(9)

    deallocate(x,y)

  end subroutine algol


  function fourproj(n,x,y) result(s)

    real(db), dimension(:), intent(in) :: x,y
    real(db), dimension(size(y)) :: f,t
    integer, intent(in) :: n
    complex(db) :: s
    real(db) :: a,b

    t = n*2*pi*x
    f = y*cos(t)
    call lich(x,f,a)

    f = y*sin(t)
    call lich(x,f,b)

    s = 2*cmplx(a,b,kind=db)

  end function fourproj

  subroutine fourmin(m,n,p,fvec,iflag)

    integer, parameter :: dbl = selected_real_kind(15)
    integer, intent(in) :: n, m
    integer, intent(in out) :: iflag
    real(dbl), dimension(m), intent(in) :: p
    real(dbl), dimension(n), intent(out) :: fvec

    complex(dbl), dimension(0:m/2-1) :: c
    real(dbl), dimension(:), allocatable :: res
    complex(dbl), dimension(:,:), allocatable :: cvec
    complex(dbl), dimension(:), allocatable :: w
    integer :: i,m2

    m2 = m / 2
    c = [(cmplx(p(i),p(i+m2),kind=db),i=1,m2)]

    allocate(cvec(size(x),0:m2-1),res(size(x)),w(size(x)))

    w = cmplx(cos(2*pi*x),-sin(2*pi*x),dbl)
    cvec(:,0) = cmplx(1.0_dbl,0.0_dbl,dbl)
    do i = 1, m2-1
       cvec(:,i) = cvec(:,i-1)*w
    end do
    do i = 1,size(x)
       res(i) = y(i) - real(sum(c*cvec(i,:)))
    end do
    do i = 0,m2-1
       fvec(1+i) = -2*sum(res*real(cvec(:,i)))
       fvec(1+i+m2) = -2*sum(res*aimag(cvec(:,i))) ! +- ?
!       write(*,*) i,real(fvec(1+i)),real(fvec(1+i+m2))
    end do
!    write(*,*) real(fvec)
!        stop

  end subroutine fourmin

  function fourfun(c,phi)

    complex(db), dimension(0:), intent(in) :: c
    real(db), intent(in) :: phi
    real(db) :: fourfun,t
    complex(db) :: s,u,w
    integer :: j

    t = 2*pi*phi
    w = cmplx(cos(t),-sin(t),db)
    u = cmplx(1.0_db,0.0_db,db)
    s = 0.0_db
    do j = 0,size(c)-1
       s = s + c(j)*u
       u = u * w
    end do
    fourfun = real(s)

  end function fourfun


  subroutine lich(x,y,s)

    ! trapezoidal rule on equidistant grid

    real(db), dimension(0:), intent(in) :: x,y
    real(db) :: s, h
    integer :: n

    n = size(y)-1
    h = (x(n) - x(0)) / n
    s = (y(0) + y(n)) / 2 + sum(y(1:n-1))
    s = h*s

  end subroutine lich

  subroutine testfour

    use minpacks

    real(db), dimension(:), allocatable :: cab
    complex(db), dimension(0:1) :: c
    integer :: i,info
    logical :: random = .true.

    allocate(cab(2*size(c)))

    if( random ) then
       allocate(x(8),y(8))

       x = [ 0.0, 0.0, 1.0471975512, 1.0471975512, 1.570796326775, &
            3.14159265355, 3.14159265355, 4.712388980325]
       y = [ 1.1, 0.8, 1.4, 1.6, 2.1, 2.8, 3.1, 2.1 ]
       cab = [ 2, -1,0,0]
       ! check: f(x) = 2 - cos(x)
    else
       allocate(x(5),y(5))

       x = [ 0.0, 1.25663706,2.513274122,3.76991118,5.0265482456]
       y = [ 3,1,-1,0,2]
       cab = [1.0,1.89443,0.0,-0.61554]
       ! check: f(x) = 1 + 1.89443*cos(x) - 0.61554*sin(x)
    end if

    x = x / 6.2831853071

    !cab = 0
    call lmdif3(fourmin,cab,info=info)
    write(error_unit,*) '!',cab,info

    c = [(cmplx(cab(1+i),cab(1+i+size(c)),kind=db),i=0,size(c)-1)]
    do i = 0,size(c)-1
       write(error_unit,*) '!',i,c(i)
    end do

    deallocate(x,y)

  end subroutine testfour

end program lcapprox

!
!  fitspphot
!
!  Copyright © 2013 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module psfengine

  use titsio
  use iso_fortran_env

  implicit none

  integer, parameter, private :: rp = selected_real_kind(15)

contains

  subroutine psfmodel(xcens,ycens,asky,acts,frame,ring,lobad,hibad,phpadu, &
       verbose,plog,cts,cts_err,sky,sky_err,rframe,status)

    real(rp), dimension(:), intent(in) :: xcens,ycens,asky,acts
    real(rp), dimension(:,:), intent(in) :: frame
    real(rp), intent(in) :: ring,lobad,hibad,phpadu
    logical, intent(in) :: verbose,plog
    real(rp), dimension(:), intent(out) :: cts,cts_err,sky,sky_err
    real(rp), dimension(:,:), intent(out) :: rframe
    integer, intent(in out) :: status

    logical, dimension(:,:), allocatable :: psfmask
    real(rp), dimension(:,:), allocatable :: psf,tpsf,convol
    real(rp), dimension(:), allocatable :: r
    integer, dimension(:), allocatable :: icen,jcen
    integer :: npsf,nring,nstars,nx,ny,i,j,n,k,l
    real(rp) :: s,x,y
    type(fitsfiles) :: fits


    nring = nint(ring)
    npsf = 2*nring + 1
    nstars = size(xcens)
    allocate(psf(npsf,npsf),tpsf(npsf,npsf),convol(npsf,npsf), &
         r(nstars),icen(nstars),jcen(nstars))

    ! central pixels
    icen = nint(xcens)
    jcen = nint(ycens)
!    do i = 1,size(xcens)
!       icen(i) = nint(xcens(i))
!       jcen(i) = nint(ycens(i))
!    end do

    do n = 1,nstars
       if( abs(icen(n) - 840) < ring .and. abs(jcen(n) - 866) < ring ) then

          tpsf = frame(icen(n)-nring:icen(n)+nring,jcen(n)-nring:jcen(n)+nring)-asky(n)
          do i = 1,npsf
             do j = 1,npsf

                x = i + (xcens(n) - icen(n))
                y = j + (ycens(n) - jcen(n))
!                psf(i,j) =  bicubic(x,y,tpsf)
                psf(i,j) =  bilinear(x,y,tpsf)

             end do
          end do

!          psf = frame(icen(n)-nring:icen(n)+nring,jcen(n)-nring:jcen(n)+nring) - asky(n)
          psf = psf / acts(n)
       end if
    end do

!    s = 0
!    do i = 1,npsf
!       do j = 1,npsf
!          s = s + max(psf(i,j),0.0_rp)
!       end do
!    end do
!    psf = psf / s
!    psf /



    ! save PSF
    call fits_create_file(fits,'!psf.fits',status)
    call fits_insert_img(fits,-32,2,[npsf,npsf],status)
    call fits_write_image(fits,0,psf,status)
    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)



    ! synthetic stars
    nx = size(frame,1)
    ny = size(frame,2)
    allocate(psfmask(nx,ny))
    psfmask = .false.
    rframe = 1
    do n = 1,nstars

       do i = 1, npsf
          do j = 1,npsf

             l = icen(n)-nring -1 + i
             k = jcen(n)-nring -1 + j
             if( 1 <= l .and. l <= nx .and. 1 <= k .and. k <= ny ) then
                x = i + (xcens(n) - icen(n))
                y = j + (ycens(n) - jcen(n))
!                tpsf(,j) = acts(n)*bicubic(x,y,psf)
                tpsf(i,j) = acts(n)*bilinear(x,y,psf)

!                tpsf(i,j) = bicubic(x,y,psf)
!                rframe(l,k) = acts(n)*s + rframe(l,k)
!                rframe(l,k) = (acts(n)*psf(i,j) + 0*asky(n)) + rframe(l,k)
!                rframe(l,k) = acts(n)*psf(i,j) * rframe(l,k)
!                psfmask(l,k) = .true.
             end if
          end do
       end do

       do i = 1, npsf
          do j = 1,npsf

             !rframe(i,j) = sum(tpsf(i,:)*rframe(:,j))

             l = icen(n)-nring -1 + i
             k = jcen(n)-nring -1 + j
             if( npsf < l .and. l < nx-npsf .and. npsf < k .and. k < ny-npsf ) then
                !write(*,*) n,l,k,i,j
                convol(i,j) = tpsf(i,j) + rframe(l,k)
!                convol(i,j) = sum(tpsf(i,:)*rframe(l:l+npsf-1,k))
!                call convolution(tpsf,rframe(l:l+npsf-1,k),convol)
!                rframe(l,k) = sum(tpsf(i,:)*rframe(l:l+npsf-1,k))
             end if
          end do
       end do


       l = icen(n)-nring -1
       k = jcen(n)-nring -1
       if( npsf < l .and. l < nx-npsf .and. npsf < k .and. k < ny-npsf ) then
!          call convolution(tpsf,rframe(l:l+npsf-1,k:k+npsf-1),convol)
          rframe(l:l+npsf-1,k:k+npsf-1) = convol
       end if
    end do

!    return

!    where( psfmask )
       rframe = frame - rframe
!    elsewhere
!       rframe = frame
!    end where

    deallocate(psf)

  end subroutine psfmodel

  subroutine convolution(a,b,c)

    real(rp), dimension(:,:), intent(in) :: a,b
    real(rp), dimension(:,:), intent(out) :: c

    integer :: i,j,k,l,m,n,sn
    real(rp) :: s

    n = size(a,1)
    m = size(a,2)

    do i = 1,n
      do j = 1,m
!    do i = -n/2,n/2
!       do j = -m/2,m/2

          s = 0
          sn = 0

          do l = -n/2+1,n/2
             do k = -m/2+1,m/2
!               write(*,*)  n/2+i-l-1,m/2+j-k-1,l,k,i,j,m,n
 !               s = s + a(n/2+i-l,m+j-k)*b(l,k)
               if( 0 < i-l .and. i-l < n .and. 0 < j-k .and. j-k < m .and. 0 < l &
                    .and. l < n .and. 0 < k .and. k < m ) then
                s = s + a(i-l,j-k)*b(l,k)
                sn = sn + 1
             end if
             end do
          end do


!!$          do l = 1,0*i
!!$             do k = 1,0*j
!!$!                write(*,*) (i-l)+1,(j-k)+1,l,k,i,j,m,n
!!$                s = s + a((i-l)+1,(j-k)+1)*b(l,k)
!!$                sn = sn + 1
!!$             end do
!!$          end do
!!$          do l = i+1,n
!!$
!!$             do k = j+1,n
!!$!                write(*,*) n+(i-l),m+(j-k),l,k,i,j,m,n
!!$                s = s + a(n+(i-l),m+(j-k))*b(l,k)
!!$                sn = sn + 1
!!$             end do
!!$
!!$          end do
          c(i,j) = s/sn

       end do
    end do

  end subroutine convolution


  function bilinear(x,y,array) result(fun)

    real(rp), intent(in) :: x,y
    real(rp), dimension(:,:), intent(in) :: array
    real(rp) :: fun
    integer :: i,j
    real(rp) :: u,v

    i = int(x)
    j = int(y)

    if( (lbound(array,1) <= i .and. i < ubound(array,1)) .and. &
        (lbound(array,2) <= j .and. j < ubound(array,2)) ) then

       u = (x - i)/(i+1 - i)
       v = (y - j)/(j+1 - j)

       fun = (1.0 - u)*(1.0 - v)*array(i,j) + u*v*array(i+1,j+1) &
            + u*(1.0 - v)*array(i+1,j) + (1.0 - u)*v*array(i,j+1)


    else
       fun = 0.0
    end if

  end function bilinear

  function bicubic(x,y,array)

    implicit none

    real(rp), intent(in) :: x,y
    real(rp), dimension(:,:), intent(in) :: array
    real(rp) :: bicubic

    integer :: i,j,nx,ny
    real(rp) :: d, z, z1, z2, x1l, x1u, x2l, x2u
    real(rp), dimension(4) :: f, f1, f2, f12

    nx = size(array,1)
    ny = size(array,2)
    i = int(x)
    j = int(y)

    d = 1.0  ! coordinate step

    if( 1 < i .and. i < nx - 1 .and. 1 < j .and. j < ny - 1 ) then

       f(1) = array(i,j)
       f(2) = array(i+1,j)
       f(3) = array(i+1,j+1)
       f(4) = array(i,j+1)

       f1(1) = (array(i+1,j)   - array(i-1,j))  /(2.0*d)
       f1(2) = (array(i+2,j)   - array(i,j))    /(2.0*d)
       f1(3) = (array(i+2,j+1) - array(i,j+1))  /(2.0*d)
       f1(4) = (array(i+1,j+1) - array(i-1,j+1))/(2.0*d)

       f2(1) = (array(i,j+1)   - array(i,j-1))  /(2.0*d)
       f2(2) = (array(i+1,j+1) - array(i+1,j-1))/(2.0*d)
       f2(3) = (array(i+1,j+2) - array(i+1,j))  /(2.0*d)
       f2(4) = (array(i,j+2)   - array(i,j))    /(2.0*d)

       f12(1) = (array(i+1,j+1)-array(i+1,j-1)-array(i-1,j+1)+array(i-1,j-1))/(2.0*d)**2
       f12(2) = (array(i+2,j+1)-array(i+2,j-1)-array(i,j+1)+array(i,j-1))/(2.0*d)**2
       f12(3) = (array(i+2,j+2)-array(i+2,j)-array(i,j+2)+array(i,j))/(2.0*d)**2
       f12(4) = (array(i+1,j+2)-array(i+1,j)-array(i-1,j+2)+array(i-1,j))/(2.0*d)**2

       x1l = i
       x1u = x1l + d
       x2l = j
       x2u = x2l + d

       call bcuint(f,f1,f2,f12,x1l,x1u,x2l,x2u,x,y,z,z1,z2)
       bicubic = z

    else

       bicubic = 0

    end if

  end function bicubic

  subroutine bcucof(y,y1,y2,y12,d1,d2,c)

    implicit none

    real(rp), intent(in) :: d1,d2
    real(rp), dimension(4), intent(in) :: y,y1,y2,y12
    real(rp), dimension(4,4), intent(out) :: c

    real(rp), dimension(16) :: x

    real(rp), parameter, dimension(16,16) :: wt = reshape( (/ &
     1,0,-3,2,0,0,0,0,-3,0,9,-6,2,0,-6,4,0,0,0,0,0,0,0,0,3,0,-9,6,-2,0,6,-4, &
     0,0,0,0,0,0,0,0,0,0,9,-6,0,0,-6,4,0,0,3,-2,0,0,0,0,0,0,-9,6,0,0,6,-4, &
     0,0,0,0,1,0,-3,2,-2,0,6,-4,1,0,-3,2,0,0,0,0,0,0,0,0,-1,0,3,-2,1,0,-3,2,&
     0,0,0,0,0,0,0,0,0,0,-3,2,0,0,3,-2,0,0,0,0,0,0,3,-2,0,0,-6,4,0,0,3,-2,&
     0,1,-2,1,0,0,0,0,0,-3,6,-3,0,2,-4,2,0,0,0,0,0,0,0,0,0,3,-6,3,0,-2,4,-2,&
     0,0,0,0,0,0,0,0,0,0,-3,3,0,0,2,-2,0,0,-1,1,0,0,0,0,0,0,3,-3,0,0,-2,2,&
     0,0,0,0,0,1,-2,1,0,-2,4,-2,0,1,-2,1,0,0,0,0,0,0,0,0,0,-1,2,-1,0,1,-2,1, &
     0,0,0,0,0,0,0,0,0,0,1,-1,0,0,-1,1,0,0,0,0,0,0,-1,1,0,0,2,-2,0,0,-1,1 /),&
     (/16,16/) )

    x(1:4) = y
    x(5:8) = y1*d1
    x(9:12) = y2*d2
    x(13:16) = y12*d1*d2
    x = matmul(wt,x)
    c = reshape(x,(/4,4/),order=(/2,1/))

  end subroutine bcucof

  subroutine bcuint(y,y1,y2,y12,x1l,x1u,x2l,x2u,x1,x2,ansy,ansy1,ansy2)

    implicit none

    real(rp), dimension(4), intent(in) :: y,y1,y2,y12
    real(rp), intent(in) :: x1l,x1u,x2l,x2u,x1,x2
    real(rp), intent(out) :: ansy,ansy1,ansy2

    integer :: i
    real(rp) :: t,u
    real(rp), dimension(4,4) :: c

    call bcucof(y,y1,y2,y12,x1u-x1l,x2u-x2l,c)

    if( x1u == x1l .or. x2u == x2l ) &
         stop 'bcuint: problem with input values - boundary pair equal?'

    t = (x1 - x1l)/(x1u - x1l)
    u = (x2 - x2l)/(x2u - x2l)
    ansy = 0.0
    ansy1 = 0.0
    ansy2 = 0.0
    do i = 4,1,-1
       ansy = t*ansy + ((c(i,4)*u + c(i,3))*u + c(i,2))*u + c(i,1)
       ansy1 = u*ansy1 + (3.0*c(4,i)*t + 2.0*c(3,i))*t + c(2,i)
       ansy2 = t*ansy2 + (3.0*c(i,4)*u + 2.0*c(i,3))*u + c(i,2)
    end do
    ansy1 = ansy1/(x1u - x1l)
    ansy2 = ansy2/(x2u - x2l)

  end subroutine bcuint

end module psfengine

!
!  match    finding of cross identification between two lists
!           the core of the matching algorithm
!
!  Copyright © 2010 - 2015, 2017-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!
!  http://en.wikipedia.org/wiki/Backtracking
!
!  Key ideas of matching by backtracking has origin in book:
!    N.Wirth: Data Structures + Algorithms = Programs
!

module matcher

  implicit none

  integer, parameter, private :: rp = selected_real_kind(15)
  integer, private, dimension(:), allocatable :: id1, id2, seq1, seq2
  logical, private, dimension(:), allocatable :: idx1, idx2
  real(rp), private, dimension(:), pointer :: x1,y1,x2,y2,f1,f2
  real, private, dimension(:,:,:,:), allocatable :: tris1,tris2
  real(rp), private :: amin, dmin, fmin, tflux, sflux, scale
  real(rp), private :: sig1 = 1.0/3600.0 ! spherical coordinate limit [deg]
  real(rp), private :: sig2 = 1.0        ! on chip coordinate limit [pix]
  real(rp), private :: xsig = 2.0     ! Normal distribution limit at 95%
  real(rp), private :: rsig = 3.8     ! Rayleigh distribution limit at 95%
  real(rp), private :: fuse = 1       ! =1 .. use flux, =0.. don't use flux
  real(rp), private :: fsig = 1       ! flux limit in sigmas
  real(rp), private :: dtol1, dtol2, rtol1, rtol2
  integer, private :: nseq, nid
  integer, private :: minmatch = 5
  integer, private :: maxmatch = 30
  logical, private :: stopping = .false.
  logical, private :: progres2 = .false.

  integer, private :: counter ! debuging purposes

  private :: disp, angels, angles, escale, distances, seq, in_idx, qchi2, &
       elen, dsq, fsq, mflux

contains

subroutine match(x_1,y_1,f_1,x_2,y_2,f_2,nm,mm,sigma1,sigma2,fsigma, &
     fluxtest,id_1,id_2,fullmatch,luckymatch,matchprint,progress2,status)

  implicit none

  interface
     subroutine matchprint(id1,id2,c,t,p,d,r,q)
       integer, parameter :: dbl = selected_real_kind(15)
       integer, dimension(:), intent(in) :: id1,id2
       real(dbl), intent(in) :: c,t,p,d,r,q
     end subroutine matchprint

     subroutine progress2(ns,ntot,amin,dmin,fmin,id1,id2)
       integer, parameter :: dbl = selected_real_kind(15)
       integer, intent(in) :: ns,ntot
       integer, dimension(:), intent(in), optional :: id1,id2
       real(dbl), intent(in), optional :: amin,dmin,fmin
     end subroutine progress2

  end interface

  real(rp), dimension(:), intent(in), target :: x_1,y_1,x_2,y_2,f_1,f_2
  integer, dimension(:), allocatable, intent(out) :: id_1, id_2
  logical, intent(in) :: fullmatch, fluxtest
  integer, intent(in) :: nm, mm, luckymatch
  real(rp), intent(in) :: sigma1, sigma2, fsigma
  logical, intent(out) :: status
  integer :: i1,i2,j1,j2,ns,ntot
  real(rp) :: d1,d2,xlim

  status = .false.

  x1 => x_1
  y1 => y_1
  x2 => x_2
  y2 => y_2
  f1 => f_1
  f2 => f_2

  if( size(x1) /= size(y1) .or. size(x2) /= size(y2) ) &
       stop 'Match: Array dimensions does not matches.'

  if( (.not. all(f1 > 0)) .or. (.not. all(f2 > 0)) ) &
       stop 'Match: All fluxes must be > 0.'

  if( nm > 0 ) minmatch = nm
  if( mm > 0 ) maxmatch = mm
  if( sigma1 > 0.0 ) sig1 = sigma1
  if( sigma2 > 0.0 ) sig2 = sigma2
  if( fsigma > 0 ) fsig = fsigma

  if( .not. fluxtest ) fuse = 0

  allocate(id1(maxmatch),id2(maxmatch),seq1(0),seq2(0), &
       idx1(maxmatch),idx2(maxmatch), &
       tris1(maxmatch,maxmatch,maxmatch,3),tris2(maxmatch,maxmatch,maxmatch,3))

  tris1 = -1
  tris2 = -1

  nseq = 0
  amin = huge(amin)
  dmin = huge(dmin)
  fmin = huge(fmin)

  ns = 0
  ntot = (size(x1) - 1)*(size(x1)/2)

  dtol2 = xsig*sig2
  dtol1 = xsig*sig1
  rtol1 = rsig*sig1
  rtol2 = rsig*sig2
  xlim = qchi2(2)

  counter = 0

  do i1 = 1, size(x1) - 1
     do i2 = i1 + 1, size(x1)

        id1(1:2) = [ i1, i2 ]
        ns = ns + 1
        call progress2(ns,ntot)

        d1 = elen(x1(i1),y1(i1),x1(i2),y1(i2))
        if( .not. in_idx(seq1,id1(1:2)) .and. d1 > dtol1 ) then

           idx1 = .true.
           idx1(id1(1:2)) = .false.

           do j1 = 1, size(x2) - 1
              do j2 = j1+1, size(x2)

                 id2(1:2) = [ j1, j2 ]

                 nid = 2
                 d2 = elen(x2(j1),y2(j1),x2(j2),y2(j2))
                 idx2 = .true.
                 idx2(id2(1:2)) = .false.

                 ! Before launching of a long-duration search,
                 ! we step over the stars already presented
                 ! in previously formed sequences and those which
                 ! distances are under coordinate uncertainities.

                 if( .not. in_idx(seq2,id2(1:2)) .and. d2 > dtol2 ) then

                    ! check fluxes, optionaly
                    if( fuse > 0 ) then
                       call mflux(f1(id1(1:nid)),f2(id2(1:nid)),tflux,sflux)
                    else
                       tflux = 1
                       sflux = 0
                    end if

                    if( fuse*sflux / tflux < fsig*xlim ) then

                       ! setup of coordinate scale and the mean flux ratio
                       scale = escale(x1,y1,id1(1:nid),x2,y2,id2(1:nid))

                       ! start of recursive search
                       stopping = .false.
                       progres2 = .false.
                       call seq(matchprint)

                       ! show the longest sequence
                       if( progres2 ) &
                            call progress2(ns,ntot,amin,dmin,fmin,seq1,seq2)

                       ! finish on first success attempt (luckymatch == 0),
                       ! or finish when results looks reliable (>0)
                       if(  .not. fullmatch &
                            .and. nseq >= minmatch + luckymatch ) goto 666

                    end if
                 end if
              end do
           end do
        end if
     end do
  end do

666 continue

!  write(*,*) counter

  if( nseq > 0 ) then

     allocate(id_1(nseq),id_2(nseq))
     id_1 = seq1
     id_2 = seq2
     status = .true.

  end if

  deallocate(id1,id2,idx1,idx2,seq1,seq2,tris1,tris2)

end subroutine match


! the core
recursive subroutine seq(matchprint)

  interface
     subroutine matchprint(id1,id2,c,t,a,d,r,q)
       integer, parameter :: dbl = selected_real_kind(15)
       integer, dimension(:), intent(in) :: id1,id2
       real(dbl), intent(in) :: c,t,a,d,r,q
     end subroutine matchprint
  end interface

  real(rp), parameter :: sq2 = sqrt(2.0)

  integer :: i,j,i1,i2,j1,j2,i0,j0,n1
  real(rp) :: u1, v1, u2, v2, d1, d2, tol, &
       tol1, tol2, au, av, fres, sres, a, d, f, t, s, xlim, xlin
  logical :: launch

  if( stopping ) return

  n1 = nid - 1
  i1 = id1(n1)
  i2 = id1(nid)
  j1 = id2(n1)
  j2 = id2(nid)

  xlin = qchi2(nid)
  xlim = qchi2(2)

  launch = .false.
  do i = 1, size(x1)

     if( idx1(i) ) then

        if( tris1(i1,i2,i,1) < 0.0 ) then

           call triangle(x1(i1),y1(i1),x1(i2),y1(i2),x1(i),y1(i),d1,u1,v1)
           tris1(i1,i2,i,:) = real([u1,v1,d1])
!           counter = counter + 1

        else
           u1 = tris1(i1,i2,i,1)
           v1 = tris1(i1,i2,i,2)
           d1 = tris1(i1,i2,i,3)
        end if

        tol1 = sq2 * rtol1 / d1

        ! v1 > (1 + tol1 - u1) rejects triangles with too short side
        if( d1 > dtol1 .and. v1 > (1 + tol1 - u1) ) then

           ! counter = counter + 1

           do j = 1, size(x2)

              if( fuse > 0 ) then
                 fres = fsq(tflux,sflux,[f1(i)],[f2(j)])
              else
                 fres = 0
              end if

              if( idx2(j) .and. fres*fuse < fsig*xlim ) then

                 if( tris2(j1,j2,j,1) < 0.0 ) then

                    call triangle(x2(j1),y2(j1),x2(j2),y2(j2),x2(j),y2(j), &
                         d2,u2,v2)
                    tris2(j1,j2,j,:) = real([u2,v2,d2])

                 else
                    u2 = tris2(j1,j2,j,1)
                    v2 = tris2(j1,j2,j,2)
                    d2 = tris2(j1,j2,j,3)
                 end if

                 tol2 = sq2 * rtol2 / d2

                 if( d2 > dtol2 .and. v2 > (1 + tol2 - u2)  ) then

                    tol = tol1 + tol2

                    au = abs(u1 - u2)
                    av = abs(v1 - v2)
                    sres = dsq(scale,[d1],[d2],sig1,sig2)

                    if( au < tol .and. av < tol .and. sres < xlim ) then

                       nid = nid + 1
                       id1(nid) = i
                       id2(nid) = j
                       idx1(i) = .false.
                       idx2(j) = .false.

                       if( .not. stopping ) then
                          launch = .true.
                          call seq(matchprint)
                       end if

                       if( nid >= max(minmatch,nseq) ) then

                          ! final checks for realiable match:

                          ! dispersions of distances and angles
                          scale = escale(x1,y1,id1(1:nid),x2,y2,id2(1:nid))
                          d = disp(scale,x1,y1,id1(1:nid),x2,y2,id2(1:nid))
                          a = angels(x1,y1,id1(1:nid),x2,y2,id2(1:nid))

                          ! dispersion of fluxes (optional)
                          if( fuse > 0 ) then
                             call mflux(f1(id1(1:nid)),f2(id2(1:nid)),t,s)
                             f = fsq(t,s,f1(id1(1:nid)),f2(id2(1:nid)))
                          else
                             f = 0
                          end if

                          ! head and tail of sequence on similarity of triangles
                          i0 = id1(1)
                          j0 = id2(1)
                          call triangle(x1(i0),y1(i0),x1(i2),y1(i2), &
                               x1(i),y1(i),d1,u1,v1)
                          call triangle(x2(j0),y2(j0),x2(j2),y2(j2), &
                               x2(j),y2(j),d2,u2,v2)
                          tol = sq2*(rtol1/d1 + rtol2/d2)

                          if( a < xlin &
                               .and. d < xlin &
                               .and. f*fuse < fsig*xlin &
                               .and. abs(u1 - u2) < tol &
                               .and. abs(v1 - v2) < tol ) then

                             progres2 = .true.
                             call matchprint(id1(1:nid),id2(1:nid),scale,tflux,&
                                  a,d,f,xlin)
                             if( nid >= nseq ) then
                                nseq = nid
                                amin = a
                                dmin = d
                                fmin = f
                                deallocate(seq1,seq2)
                                allocate(seq1(nseq),seq2(nseq))
                                seq1 = id1(1:nid)
                                seq2 = id2(1:nid)
                             end if
                          end if
                       end if

                       nid = nid - 1
                       idx1(i) = .true.
                       idx2(j) = .true.

                    end if
                 end if
              end if
           end do ! j
        end if
     end if
  end do ! i

  ! none matching stars has been found,
  ! =>  next subroutine invocation will be stopped
  if( .not. launch ) stopping = .true.

end subroutine seq


function elen(x1,y1,x2,y2)

  ! lenght of an edge by Pythagorean theorem

  real(rp) :: elen
  real(rp), intent(in) :: x1,y1,x2,y2

  elen = sqrt((x1 - x2)**2 + (y1 - y2)**2)

end function elen


subroutine triangle(x1,y1,x2,y2,x3,y3,d3,u,v)

  ! computes coordinates in uv space

  real(rp), parameter :: eps = epsilon(0.0_rp)

  real(rp), intent(in) :: x1,y1,x2,y2,x3,y3
  real(rp), intent(out) :: d3,u,v

  real(rp), dimension(0:3) :: d
  real(rp) :: x
  integer :: i,j

  ! compute lengths of triangle's sides
  d(1) = sqrt((x1 - x2)**2 + (y1 - y2)**2)
  d(2) = sqrt((x1 - x3)**2 + (y1 - y3)**2)
  d(3) = sqrt((x2 - x3)**2 + (y2 - y3)**2)

  ! sorting, an implementation of the insert sort algorithm by N.Wirth
  do i = 2, 3
     x = d(i)
     d(0) = x
     j = i - 1
     do while ( x < d(j) )
        d(j+1) = d(j)
        j = j - 1
     end do
     d(j+1) = x
  end do

  if( d(3) > eps ) then
     ! compute triangle coordinates
     u = d(1)/d(3)
     v = d(2)/d(3)
     ! the longest side
     d3 = d(3)
  else
     ! triangle is collapsing to a point
     u = 0.0
     v = 0.0
     d3 = 0.0
  end if

end subroutine triangle



subroutine distances(x,y,id,d)

  real(rp), dimension(:), intent(in) :: x,y
  integer, dimension(:), intent(in) :: id
  real(rp), dimension(:), intent(out) :: d
  integer :: i,j,k,l,n

  n = size(id)
  l = n  ! connecting head and tail
  do k = 1, n
     i = id(k)
     j = id(l)
     d(k) = elen(x(i),y(i),x(j),y(j))
     l = k
  end do

end subroutine distances

function escale(x1,y1,id1,x2,y2,id2)

  ! estimate scale from ratio of edge lenghts

  real(rp) :: escale
  integer, dimension(:), intent(in) :: id1, id2
  real(rp), dimension(:), intent(in) :: x1,y1,x2,y2
  real(rp), dimension(size(id1)) :: d1,d2

  call distances(x1,y1,id1,d1)
  call distances(x2,y2,id2,d2)

  escale  = sum(d2/d1)/size(id1)

end function escale


function dsq(s,d1,d2,sig1,sig2)

  real(rp) :: dsq
  real(rp), parameter :: sq2 = sqrt(2.0_rp)
  real(rp), intent(in) :: s
  real(rp), dimension(:), intent(in) :: d1,d2
  real(rp), intent(in) :: sig1,sig2
  real(rp), dimension(size(d1)) :: r2,dr2

  dr2 = (s*sig1)**2 + sig2**2
  where( dr2 > 0 )
     r2 = (d2 - s*d1)**2 / (2*dr2)
  elsewhere
     r2 = 1
  end where
  dsq = sum(r2)

end function dsq

function disp(s,x1,y1,id1,x2,y2,id2)

  ! Approximated standard residuals of edge lenghts
  ! on frame and catalogue in pixels (lenghts in degrees
  ! are scaled):
  !            (d2 - s*d1)**2
  !            --------------
  !                sig**2
  ! where sig = 1.41*sqrt((s*sig1)**2 + sig2**2).

  real(rp) :: disp
  real(rp), intent(in) :: s
  integer, dimension(:), intent(in) :: id1, id2
  real(rp), dimension(:), intent(in) :: x1,y1,x2,y2
  real(rp), dimension(size(id1)) :: d1,d2

  call distances(x1,y1,id1,d1)
  call distances(x2,y2,id2,d2)

  disp = dsq(s,d1,d2,sig1,sig2)

end function disp


subroutine angles(x,y,id,sig,a,da)

  ! computes angles in polygon given by the sequence
  ! the angles and theirs errors are in radians

  real(rp), dimension(:), intent(in) :: x,y
  integer, dimension(:), intent(in) :: id
  real(rp), intent(in) :: sig
  real(rp), dimension(:), intent(out) :: a,da
  real(rp), dimension(2) :: u,v
  real(rp) :: uu,vv,t
  integer :: i,l,k,n

  n = size(id)

  l = n
  do i = 1, n
     k = mod(i,n) + 1
     u = [ x(id(i)) - x(id(l)), y(id(i)) - y(id(l)) ]
     v = [ x(id(k)) - x(id(i)), y(id(k)) - y(id(i)) ]
     uu = sqrt(sum(u**2))
     vv = sqrt(sum(v**2))
     t = sum(u*v)/(uu*vv)
     a(i) = acos(t)
     da(i) = t*sig*sqrt(1/uu**2 + 1/vv**2)
     l = i
  end do

end subroutine angles


function angels(x1,y1,id1,x2,y2,id2)

  ! returns sum of squares suitable for test by Xi2 distribution
  ! of residuals of angles:
  !
  !            |a1 - a2|
  !            ---------
  !              sig
  !
  ! where sig=sqrt(da1**2 + da2**2)

  real(rp) :: angels
  integer, dimension(:), intent(in) :: id1, id2
  real(rp), dimension(:), intent(in) :: x1,y1,x2,y2
  real(rp), dimension(size(id1)) :: a1,a2,da1,da2,r

  call angles(x1,y1,id1,sig1,a1,da1)
  call angles(x2,y2,id2,sig2,a2,da2)

  r = (a1 - a2)/sqrt(da1**2 + da2**2)
  angels = sum(r**2)

end function angels


subroutine mflux(f1,f2,t,s)

  ! determines estimation of ratio and its standard deviation
  ! by arithmetical mean (intentionally non-robust)

  real(rp), dimension(:), intent(in) :: f1,f2
  real(rp), intent(out) :: t,s

  real(rp), dimension(size(f1)) :: r
  integer :: n

  n = size(r)
  r = f1 / f2
  t = sum(r)/n
  s = sqrt(sum((r-t)**2)/(n-1))

  ! s == 0 for twices with the same magnitudes (very low probability)
  if( s < 10*epsilon(s) ) then
     s = (sum(sqrt(f1)/f1) / n + sum(sqrt(f2)/f2) / n) / 2
  end if

end subroutine mflux


function fsq(t,s,f1,f2)

  ! returns squares of residuals of
  !   (f1 - t* f2)**2 / sqrt(f1 + t**2*f2 + f2**s**2)**2
  !  or simplified form
  !   (f1/f2 - t)**2 / s**2
  ! suitable for test by chi2 statistics
  !
  ! the last term of errors describes t noise and
  ! generaly is due effects not directly connected
  ! on photon statistics (clouds, background, ..)
  ! Fluxes (normal distribution) are considered.

  real(rp) :: fsq
  real(rp),intent(in) :: t,s
  real(rp), dimension(:), intent(in) :: f1,f2

  fsq = sum((f1/f2 - t)**2 / s**2)

end function fsq


function in_idx(seq,id)

  logical :: in_idx
  integer, dimension(:), intent(in) :: seq,id
  logical, dimension(size(id)) :: n
  integer :: i,j,l

  n = .false.
  l = 1
  do j = 1,size(id)
     do i = l,size(seq)
        if( seq(i) == id(j) ) then
           n(j) = .true.
           l = i
        end if
     end do
  end do
  in_idx = all(n)

end function in_idx

function qchi2(n)

  ! approximation of quantiles of chi2 distribution for choosed probability
  ! accuracy for n < 30 is poor (few thents only)
  ! u are quantiles of N(0,1):
  !    P     u
  !   0.9   1.282
  !   0.95  1.645
  !   0.99  2.326
  !   0.999 3.090
  !

  real :: qchi2
  real, parameter :: u = 1.645
  integer, intent(in) :: n

  qchi2 = (sqrt(2.0*n - 1.0) + u)**2 / 2.0

end function qchi2

end module matcher

!
! astrometry
!
!
! Copyright © 2011-20 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

! TODO:
!
!   * add all WCS related projections
!   * add catalogue/reference matching identifier
!   * add correlation matching by FFT with help of artificial
!
!  testing:
!   * improve high-precision algorithm to fit all parameters simulatenously
!   * rewrite to use Penalty function to non-fitting parameters (centre)

! TODO for 0.5.7
!   * add mirror projection (done)
!   * add FITS extension with astrometry results
!   * filtering input for double stars (on photography or digital camera) (done)
!   * try to select better triangles firstly (abandoned)
!   * crossmatching by backtracking
!   * provide manual sequences as a reference parameter (done)
!   * estimate dispersion simultaneously
!   * use Rayleigh statistics (done)
!   * selection stars by magnitude limits (upper and lower)

program astrometry

  use titsio
  use astrofits
  use astrofitting
  use astromatcher
  use iso_fortran_env

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  real(dbl), parameter :: rad = 57.295779513082322865_dbl

  character(len=4*FLEN_FILENAME) :: record, key, val, seq1, seq2
  character(len=FLEN_FILENAME) :: ref = '', cat = '', rel = '', &
       output = '', filename = ''
  character(len=FLEN_VALUE) :: col_ra = 'RAJ2000', col_dec = 'DEJ2000', &
       col_pmra = '', col_pmdec = '', col_mag = ''

  character(len=FLEN_VALUE) :: type = 'GNOMONIC', fit = 'ROBUST', aunits = '', &
       mode = 'MATCH'
  character(len=FLEN_VALUE) :: rframe = '', idcat = '', key_epoch = 'EPOCH', &
       key_dateobs = 'DATE-OBS'
  real(dbl), allocatable, dimension(:) :: alpha,delta,pmalpha,pmdelta,x,y, &
       ares,dres,flux, rflux
  integer,  allocatable, dimension(:) :: id1,id2
  integer,  allocatable, dimension(:) :: i1,i2
  character(len=FLEN_COMMENT), allocatable, dimension(:) :: com
  real(dbl), dimension(2) :: crpix = 0.0_dbl, crval = 0.0_dbl, &
       dcrval, xcrpix, xcrval
  real(dbl) :: tepoch,jd,scale = 1.0_dbl,dscale = epsilon(1.0_dbl), &
       angle = 0.0_dbl, dangle=epsilon(1.0_dbl), rms=0.0_dbl,a,da,b,db,s,ds,&
       w,h,density,sm,refl=1.0_dbl
  real(dbl) :: sig2 = 1.0, sig1= 1.0/3600.0, xsig = 3.0, fsig = -1
  integer :: eq,n,status,nseq,ncom
  integer :: minmatch = 5, maxmatch = 33
  integer :: luckymatch = 3
  logical :: fcrpix = .false., fcrval = .false., reflex = .false. ,&
       initpar = .true., matched = .false., rmscheck = .true., &
       fluxtest = .true., verbose = .false., wcssave = .true., &
       plog = .false., fullmatch = .false., init_match = .false., &
       ex, exitus = .true., reliable

  n = 0
  ncom = 0
  allocate(com(0))

  ! read input parameters
  do
     read(*,'(a)',end=99) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Malformed input record.'
     key = record(:eq-1)
     val = record(eq+1:)


     if( key == 'MODE' ) then

        read(val,*) mode  ! mode is expected as first parameter
        if( mode == 'DEFAULTS' ) call show_defaults

     elseif( key == 'PROJECTION' ) then

        read(val,*) type ! the projection must by defined before CAT,REF

     else if( key == 'FIT' ) then

        read(val,*) fit

     else if( key == 'AUNITS' ) then

        read(val,*) aunits

     else if( key == 'WCSSAVE' ) then

        read(val,*) wcssave

     else if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'PIPELOG' ) then

        read(val,*) plog

     else if( key == 'CRPIX' ) then

        read(val,*) crpix
        fcrpix = .true.

     else if( key == 'CRVAL' ) then

        read(val,*) crval
        fcrval = .true.

     else if( key == 'SCALE' ) then

        read(val,*) scale

     else if( key == 'ANGLE' ) then

        read(val,*) angle

     else if( key == 'REFLEX' ) then

        read(val,*) reflex
        if( reflex ) refl = -1.0_dbl

     else if( key == 'SIG' ) then

        read(val,*) sig2

     else if( key == 'SIGCAT' ) then

        read(val,*) sig1

     else if( key == 'FSIG' ) then

        read(val,*) fsig

     else if( key == 'FLUXCHECK' ) then

        read(val,*) fluxtest

     else if( key == 'INITPAR' ) then

        read(val,*) initpar


     ! match parameters

     else if( key == 'MINMATCH' ) then

        read(val,*) minmatch
        init_match = .true.

     else if( key == 'MAXMATCH' ) then

        read(val,*) maxmatch
        init_match = .true.

     else if( key == 'FULLMATCH' ) then

        read(val,*) fullmatch

     else if( key == 'LUCKYMATCH' ) then

        read(val,*) luckymatch

        if( luckymatch < 0 ) stop 'Lucky match requires one or more stars.'

     else if( key == 'RMSCHECK' ) then

        read(val,*) rmscheck

     else if( key == 'COL_RA' ) then

        read(val,*) col_ra

     else if( key == 'COL_DEC' ) then

        read(val,*) col_dec

     else if( key == 'COL_PMRA' ) then

        read(val,*) col_pmra

     else if( key == 'COL_PMDEC' ) then

        read(val,*) col_pmdec

     else if( key == 'COL_MAG' ) then

        read(val,*) col_mag

     else if( key == 'FITS_KEY_EPOCH' ) then

        read(val,*) key_epoch

     else if( key == 'FITS_KEY_DATEOBS' ) then

        read(val,*) key_dateobs

     else if( key == 'NSEQ' ) then

        read(val,*) nseq

     else if( key == 'SEQ1' ) then

        read(val,*) seq1

     else if( key == 'SEQ2' ) then

        read(val,*) seq2

     else if( key == 'NCOM' ) then

        read(val,*) ncom
        deallocate(com)
        allocate(com(ncom))

     else if( key == 'COM' ) then

        if( size(com) > 0 ) then
           n = n + 1
           if( n < size(com) ) read(val,*) com(n)
        end if

     else if( key == 'REL' ) then

        read(val,*) rel
        call read_rel(rel)

     else if( key == 'REF' ) then

        read(val,*) ref
        call read_ref(ref)

     else if( key == 'CAT' ) then

        read(val,*) cat
        call read_cat(cat)

     else if( key == 'FILE' ) then

        read(val,*) filename, output

        if( mode == 'MATCH' .or. mode == 'SEQUENCE' ) then

           call calibrate(filename, output, ex)

        elseif( mode == 'MANUAL' ) then

           call mancal(filename, output, ex)

        elseif( mode == 'REMOVE' ) then

           call remove(filename, output, ex)

        elseif( mode == 'DEFAULTS' ) then

           call show_defaults

        end if

        exitus = exitus .and. ex

     end if


  end do
99 continue

  if( allocated(alpha) ) deallocate(alpha,delta,pmdelta,pmalpha,rflux)
  if( allocated(com) ) deallocate(com)

  if( exitus ) then
     stop 0
  else
     stop 'Some errors occurred during the astrometry calibration.'
  end if

contains

  subroutine calibrate(filename, output, exitus)

    character(len=*), intent(in) :: filename, output
    logical, intent(out) :: exitus

    type(fitsfiles) :: fits
    character(len=FLEN_COMMENT), allocatable, dimension(:) :: com
    real(dbl), dimension(2) :: zcrval

    exitus = .false.

    if( cat == '' .and. ref == '' .and. rel == '' ) &
         stop 'A reference file (catalogue, frame) unspecified.'

    if( verbose ) &
       write(error_unit,*) "Astrometry calibration of `"//trim(filename)//"'."

    if( plog ) write(*,'(a)') "=ASTROMETRY> Start `"//trim(filename)//"'."

    status = 0
    call readfile(filename,key_dateobs,w,h,x,y,flux,crpix,jd,zcrval,scale, &
         angle,refl,status)
    if( status /= 0 ) then
       write(error_unit,*) "Error: Failed to open  `" //trim(filename)//"'"
       goto 77
    end if

    if( .not. fcrval ) crval = xcrval

    if( mode == 'MATCH' ) then

       if( plog ) then
          write(*,'(a)') "=ASTROMATCH> Start"
          call uvhist(x,y)
       end if

       ! crowded field check, update parameters
       if( .not. init_match ) then
          density = size(x) / (w*h)  ! stars per sq. pixel
          if( density > 5e-4 ) then
             minmatch = 6
             maxmatch = 36
          else
             minmatch = 5
             maxmatch = 33
          end if
          if(verbose) &
               write(error_unit,'(2(a,i0),a)') &
               ' Match parameters updated: minmatch=', &
               minmatch,', maxmatch=',maxmatch,'.'
       end if

       call astromatch(minmatch,maxmatch,type,alpha,delta,pmalpha,pmdelta, &
            rflux,x,y,flux,crval(1),crval(2),crpix(1),crpix(2),id1,id2, &
            sig1,sig2,fsig,fluxtest,tepoch,jd,fullmatch,luckymatch,&
            verbose,plog,matched)
!           write(*,'(a,f10.7)') "=MATCH> End "

    else if( mode == 'SEQUENCE' ) then

       allocate(id1(nseq),id2(nseq))
       read(seq1,*) id1
       read(seq2,*) id2
       matched = .true.

!       call listmatch(type,alpha,delta,pmalpha,pmdelta,x,y,tepoch,jd, &
!            crval(1),crval(2),crpix(1),crpix(2),scale,angle,refl,xsig*sig2/scale,id1,id2,matched)

!           write(*,*) size(id1)
    end if

    if( .not. matched ) then
       if(plog) write(*,'(a)') "=ASTROMATCH> Finish Fail"

       write(error_unit,'(7a)') "Warning: Mutual match for files `", &
            trim(filename),"' and `",trim(cat),trim(ref),trim(rel), &
            "' failed. No common stars found."
    else
       if( plog ) write(*,'(a)') "=ASTROMATCH> Finish Success"

       if( plog ) write(*,'(a)') "=ASTROFIT> Start"
 !          if( verbose ) write(*,'(a)') "=> Fitting ..."
       call astrofit(fit,type,alpha,delta,pmalpha,pmdelta,x,y,sig2,xsig,&
            tepoch,jd,crpix(1),crpix(2),crval(1),dcrval(1),crval(2),dcrval(2),&
            scale,dscale,refl,rms,angle,dangle,ares,dres,id1,id2,i1,i2, &
            rmscheck,verbose,plog,reliable)

       if( .not. reliable ) write(error_unit,*) &
            'Warning: Reliability test failed for `',trim(filename),"'"

       ! use a return flag instead ?
       if( size(i1) > 0 ) then

          if( plog ) then
             write(*,'(a,e15.7)') "=ASTROFIT> Final ",rms
             write(*,'(a)') "=ASTROFIT> Finish Success"
          end if

          allocate(com(15+size(i1)))

          a = cos(angle/rad)
          da = abs((dangle/rad)*sin(angle/rad))
          b = sin(angle/rad)
          db = abs((dangle/rad)*cos(angle/rad))
          s = 3600.0_dbl*scale
          ds = s*dscale/scale

          if( aunits == '' ) then
             if( rel /= '' ) then
                aunits = 'pix'
             else if( log10(3600.0e6*rms) < 0.5 ) then
                aunits = 'uas'
             else if( log10(3600.0e3*rms) < 0.5 ) then
                aunits = 'mas'
             else if( log10(3600.0*rms) < 0.5 ) then
                aunits = 'arcsec'
             else if( log10(60.0*rms) < 0.5 ) then
                aunits = 'arcmin'
             else
                aunits = 'deg'
             end if
          end if

          if( rel /= '' ) then
             write(com(1),'(a)') "Type: relative"
             write(com(2),'(a)') "Reference frame: "//trim(rel)
          else
             write(com(1),'(a)') "Type: absolute"
             !                 write(com(2),'(a)') "Coordinate reference frame: ",trim(rframe)
             if( ref /= '' ) then
                write(com(2),'(a)') "Reference frame: "//trim(ref)
             else
                write(com(2),'(a)') "Reference catalogue: "//trim(idcat)
             end if
          end if
          write(com(3),'(a)') "Projection: "//trim(type)
          write(com(4),'(a,i0)') "Objects used = ",size(i1)
          if( aunits == 'arcsec' .or. aunits == 'arcmin' .or. &
               aunits == 'deg' .or. aunits == 'mas' .or. aunits == 'uas') then
             if( aunits == 'uas' ) then
                sm = 3600.0e6_dbl
             else if( aunits == 'mas' ) then
                sm = 3600.0e3_dbl
             else if( aunits == 'arcsec' ) then
                sm = 3600.0_dbl
             else if( aunits == 'arcmin' ) then
                sm = 60.0_dbl
             else if( aunits == 'deg' ) then
                sm = 1.0_dbl
             end if

             s = sm/scale
             ds = s*dscale/scale
             write(com(5),'(a,en11.1,3a)') "RMS = ",sm*rms,' [',trim(aunits),']'
             write(com(6),'(a,g15.7,a,es7.1,3a)') "Scale = ",s," +- ",ds, &
                  ' [',trim(aunits),'/pix]'
          else if( aunits == "pix" ) then
             write(com(5),'(a,g15.7,a)') "RMS = ",rms,' [pix]'
             write(com(6),'(a,g15.7,a,es7.1)') "Scale = ",scale," +- ",dscale
          end if
          write(com(7),'(a,f12.7,a,es7.1)') "cos(angle) = ",a," +- ",da
          write(com(8),'(a,f12.7,a,es7.1)') "sin(angle) = ",b," +- ",db
          write(com(9),'(a,l5)') "Reflexion = ", refl < 0
          write(com(10),'(a,f11.5,a,es7.1,a)') "Angle of rotation(angle) = ", &
               angle," +- ",dangle," [deg]"
          if( aunits == 'pix' ) then
             write(com(11), '(a,f12.7,a,es7.1)') &
                 "Alpha center projection (CRVAL1) = ",crval(1)," +- ",dcrval(1)
             write(com(12),'(a,f12.7,a,es7.1)') &
                 "Delta center projection (CRVAL2) = ",crval(2)," +- ",dcrval(2)
          else
             write(com(11),'(a,f12.7,a,es7.1,a)') &
                "Alpha center projection (CRVAL1) = ",crval(1)," +- ",dcrval(1)," [deg]"
             write(com(12),'(a,f12.7,a,es7.1,a)') "Delta center projection (CRVAL2) = ",&
                  crval(2)," +- ",dcrval(2)," [deg]"
          end if
          write(com(13),'(a,f9.3,a)') "Horizontal center (CRPIX1) = ",crpix(1),' [pix]'
          write(com(14),'(a,f9.3,a)') "Vertical   center (CRPIX2) = ",crpix(2),' [pix]'

          if( aunits == 'uas' .or. aunits == 'mas' .or. aunits == 'arcsec' .or. &
               aunits == 'arcmin' .or. aunits == 'deg' ) then
             write(com(15),'(3a)') 'Catalogue RA,DEC [deg]        Data X,Y [pix]     Residuals [',trim(aunits),']'
          else if( aunits == 'pix' ) then
             write(com(15),'(a)') 'Reference X,Y [pix]       Data X,Y [pix]       Residuals [pix]'
          end if

          if( rel /= '' ) then
             do n = 1, size(ares)
                write(com(15+n),'(2f9.3,6x,2f9.3,1x,2f9.3)') &
                     alpha(i1(n))+xcrpix(1),delta(i1(n))+xcrpix(2),x(i2(n)),y(i2(n)),ares(n),dres(n)
             end do
          else
             do n = 1, size(ares)
                write(com(15+n),'(2f13.7,2f9.3,2en12.1)') &
                     alpha(i1(n)),delta(i1(n)),x(i2(n)),y(i2(n)),sm*ares(n),sm*dres(n)
             end do
          end if

!              if( plog ) write(*,'("=C> ",a)') (trim(com(n)),n=1,size(com))
          if( verbose ) write(error_unit,'(a)') (trim(com(n)),n=1,size(com))

          if( wcssave ) then
             if( plog ) write(*,'(a)') "=WCSSAVE> Start"

             status = 0

             if( output == '' ) then
                call fits_open_file(fits,filename,FITS_READWRITE,status)
             else
                call fits_precopy_file(fits,filename,output,FITS_READWRITE, &
                     .true.,status)
             end if

              call wcsupdate(fits,type,crval,1/scale,angle,dangle, &
                  fcrpix,crpix,refl,rms,com,status)

             if( status == 0 ) then
                if( plog ) write(*,'(a)') "=WCSSAVE> Finish Success"
             else
                if( plog ) write(*,'(a)') "=WCSSAVE> Finish Fail"
                write(error_unit,*) &
                     "Warning: WCS save failed for `"//trim(filename)//"'."
             end if
             call fits_close_file(fits,status)
             call fits_report_error(error_unit,status)
             exitus = status == 0

          else
             exitus = .true.
          end if

          deallocate(com)


       else
          write(error_unit,'(a)') "Warning: Astrometry of `" // &
               trim(filename)//"' failed."
          if( plog ) write(*,'(a)') "=ASTROFIT> Finish Fail"
       end if

       if( allocated(ares)  ) deallocate(ares,dres,i1,i2)

    end if

77  continue
    if( allocated(x) ) deallocate(x,y,flux)
    if( allocated(id1) ) deallocate(id1,id2)

    if( plog ) write(*,'(a)') "=ASTROMETRY> Finish"

  end subroutine calibrate


  subroutine mancal(filename, output, exitus)

    use astrofits

    character(len=*), intent(in) :: filename, output
    logical, intent(out) :: exitus

    type(fitsfiles) :: fits
    integer :: status

    if( verbose ) write(error_unit,*) &
         "Manual astrometry calibration of `"//trim(filename)//"'."

    status = 0
    if( output == '' ) then
       call fits_open_file(fits,filename,FITS_READWRITE,status)
    else
       call fits_precopy_file(fits,filename,output,FITS_READWRITE,.true.,status)
    end if
    call wcsupdate(fits,type,crval,scale,angle,dangle,fcrpix,crpix,refl,rms,&
         com,status)
    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    exitus = status == 0

  end subroutine mancal


  subroutine remove(filename, output, exitus)

    use astrofits

    character(len=*), intent(in) :: filename, output
    logical, intent(out) :: exitus

    type(fitsfiles) :: fits
    integer :: status

    if( verbose ) write(error_unit,*) &
         "Removing astrometry calibration of `"//trim(filename)//"'."

    status = 0
    if( output == '' ) then
       call fits_open_file(fits,filename,FITS_READWRITE,status)
    else
       call fits_precopy_file(fits,filename,output,FITS_READWRITE,.true.,status)
    end if
    call wcsremove(fits,status)
    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)
    exitus = status == 0

  end subroutine remove


  subroutine read_rel(rel)

    character(len=*), intent(in) :: rel

    call readfile(rel,key_dateobs,w,h,x,y,rflux,xcrpix,tepoch,xcrval, &
         scale,angle,refl,status)
    if( status /= 0 ) stop 'Error: Opening of reference frame failed.'

    type = ' '
    xcrval = 0.0_dbl
    scale = 1.0_dbl
    angle = 0.0_dbl
    n = min(size(x),maxmatch)
    allocate(alpha(n),delta(n),pmalpha(n),pmdelta(n))
    alpha = x(1:n) - xcrpix(1)
    delta = y(1:n) - xcrpix(2)
    pmalpha = 0.0_dbl
    pmdelta = 0.0_dbl
    deallocate(x,y)

  end subroutine read_rel

  subroutine read_ref(ref)

    character(len=*), intent(in) :: ref

    call reffile(ref,key_dateobs,alpha,delta,rflux,tepoch,status)
    if( status /= 0 ) stop 'Error: Opening of reference frame failed.'

    if( initpar ) call init(alpha,delta,xcrval(1),xcrval(2))
    allocate(pmalpha(size(alpha)),pmdelta(size(delta)))
    pmalpha = 0.0_dbl
    pmdelta = 0.0_dbl

  end subroutine read_ref

  subroutine read_cat(cat)

    character(len=*), intent(in) :: cat

    call readtable(cat,col_ra,col_dec,col_pmra,col_pmdec,col_mag,&
         key_epoch,alpha,delta,pmalpha,pmdelta,rflux,rframe,idcat,tepoch,status)
    if( status /= 0 ) stop "Failed to open the catalogue file."
    if( initpar ) call init(alpha,delta,xcrval(1),xcrval(2))

  end subroutine read_cat


  subroutine init(a,d,acen,dcen)

    use oakleaf

    real(dbl), dimension(:), intent(in) :: a,d
    real(dbl), intent(out) :: acen,dcen
    real(dbl) :: x

    call rmean(a,acen,x)
    call rmean(d,dcen,x)

  end subroutine init


  subroutine show_defaults

    write(*,*) 'Default values for astrometry parameters :'
    write(*,*) '  Spherical Projection: ',trim(type)
    write(*,*) '  Right Ascension column label: ',trim(col_ra)
    write(*,*) '  Declination column label: ',trim(col_dec)
    write(*,*) '  Method for fitting: ',trim(fit)
    write(*,*) '  Minimum stars for matching: ',minmatch
    write(*,*) '  Maximum stars for matching: ',maxmatch
    write(*,*) '  Number stars for lucky matching: ',luckymatch

    write(*,*) '  Full match:   ',fullmatch
    write(*,*) '  Check fluxes: ',fluxtest
    write(*,*) '  Check RMS:    ',rmscheck
    write(*,*) '  Save results: ',wcssave
    write(*,'(a,f0.1,a)') &
         '   Mean uncertainty of centers stars on frame: ',sig2,' pix'
    write(*,'(a,f0.1,a)') &
         '   Mean uncertainty of stars in catalogue: ',sig1*3600.0,' arcsec'
    write(*,'(a,g0.1,a)') '   Mean uncertainty of fluxes: ',1.0

  end subroutine show_defaults


end program astrometry

!
!  Save timeserie to FITS table
!
!  Copyright © 2018-20 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module savelcfits

  use fitsts
  use fitscat
  use titsio
  use iso_fortran_env

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

  private :: maxlen, tits_write_col_logical, tits_write_col_integer, &
       tits_write_col_double

contains

  subroutine savelc(output,fitses,timetype,timestamp,cat,cols, &
       lc_epoch,lc_period,printname,printtime,printhorizon,printairmass,status)

    character(len=*), intent(in) :: output, timetype, timestamp
    type(TSFits), dimension(:), intent(in) :: fitses
    type(CatFits), intent(in) :: cat
    character(len=*), dimension(:), intent(in) :: cols
    real(dbl), intent(in) :: lc_epoch,lc_period
    logical, intent(in) :: printname, printtime, printhorizon, printairmass
    logical, intent(out) :: status

    character(len=FLEN_VALUE), dimension(:), allocatable :: labels, units
    character(len=FLEN_VALUE), dimension(:,:), allocatable :: headvals
    character(len=FLEN_FILENAME), dimension(size(fitses)) :: filenames
    real(dbl), dimension(size(fitses)) :: timelike,azimuth,zenitd,airmass
    real(dbl), dimension(:,:), allocatable :: data
    character(len=80) :: msg, fmt

    integer :: i,j,n,m,ncols,nrows,nkeys,nvalid,nstars,ndata,stat

    ! investigating valid fitses
    nrows = 0
    nvalid = 0 ! the first valid fits
    do i = 1, size(fitses)
       if( fitses(i)%status ) nrows = nrows + 1
       if( nvalid == 0 ) nvalid = i
    end do

    nstars = size(cat%coo,1) ! also size(fitses(nvalid)%data,1)
    ncols = size(cols)
    nkeys = size(fitses(nvalid)%keyunits)
    ndata = size(fitses(nvalid)%data)
    n = nstars*ncols
    allocate(labels(n),units(n),headvals(nrows,nkeys),data(nrows,ndata), &
         stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) trim(msg)
       error stop 'Failed to allocate temporary arrays.'
    end if

    units = [ (fitses(nvalid)%units,i=1,nstars) ]
    do n = 1,nstars
       m = ncols*(n-1)
       write(fmt,'(i0)' ) n
       do i = 1,ncols
          labels(m+i) = trim(cols(i)) // "_" // fmt
       end do
    end do

    n = 0
    do i = 1, size(fitses)
       if( fitses(i)%status ) then
          n = n + 1
          filenames(n) = fitses(i)%filename
          timelike(n) = fitses(i)%gettime(timetype,timestamp,lc_epoch,lc_period)
          headvals(n,:) = fitses(i)%headvals
          azimuth(n) = fitses(i)%azimuth
          zenitd(n) = fitses(i)%zenitd
          airmass(n) = fitses(i)%airmass
          data(n,:) = [ (fitses(i)%data(j,:),j=1,nstars) ]
          ! pack() stores data in unprefered column-order (Fortran way)
       end if
    end do

    call savefits(output,filenames(:n),printtime,printname,printhorizon, &
         printairmass,timetype,timelike(:n),labels,units, &
         fitses(nvalid)%keyunits,fitses(nvalid)%headkeys, &
         fitses(nvalid)%keytype,headvals(:n,:),cat%jd, &
         azimuth(:n),zenitd(:n),airmass(:n),cat%coo(:,1),cat%coo(:,2), &
         data(:n,:),stat)

    status = stat == 0

  end subroutine savelc


  subroutine savefits(output,filenames,printtime,printname,printhorizon, &
       printairmass,timetype,timelike,labels,units,hunits,headkeys,keytype,&
       headvals,epoch,azimuth,zenitd,airmass,xcoo,ycoo,data,status)

    character(len=*), intent(in) :: output,timetype
    character(len=*), dimension(:), intent(in) :: filenames
    logical, intent(in) :: printtime, printname, printhorizon, printairmass
    character(len=*), dimension(:), intent(in) :: headkeys, labels,units, &
         hunits, keytype
    character(len=*), dimension(:,:), intent(in) :: headvals
    real(dbl), dimension(:), intent(in) :: timelike,xcoo,ycoo,azimuth,zenitd,&
         airmass
    real(dbl), dimension(:,:), intent(in) :: data
    real(dbl), intent(in) :: epoch
    integer, intent(out) :: status

    character(len=FLEN_VALUE), dimension(:), allocatable :: ttype, tform, tunit
    character(len=FLEN_VALUE), dimension(size(keytype)) :: hform
    integer :: i,l,n,m,num,nadd,nrows,srows,ntypes,nkeys,frow
    type(fitsfiles) :: fitsfile

    nadd = 0
    if( printtime ) nadd = nadd + 1
    if( printname ) nadd = nadd + 1
    if( printhorizon ) nadd = nadd + 2
    if( printairmass ) nadd = nadd + 1

    nkeys = size(headkeys)
    ntypes = nadd + nkeys + size(labels)
    allocate(ttype(ntypes),tform(ntypes),tunit(ntypes))
    tform = '1D'
    tunit = ''

    num = 0
    if( printname ) then
       num = num + 1
       ttype(1) = FITS_COL_FILENAME
       write(tform(1),"(i0,'A')") max(maxlen(filenames),1)
       tunit(1) = ''
    end if

    if( printtime ) then
       num = num + 1
       ttype(num) = FITS_COL_TIME
       tform(num) = '1D'
       tunit(num) = 'day'   ! jd
       if( timetype == 'PHASE' ) tunit(num) = ''
    end if

    if( nkeys > 0 ) then
       do i = 1, nkeys
          select case(keytype(i))
          case('L')
             hform(i) = '1L'
          case('I')
             hform(i) = '1J'
          case('F')
             hform(i) = '1D'
          case default
             write(hform(i),"(i0,'A')") max(maxlen(headvals(:,i)),1)
          end select
       end do
       n = num + 1
       m = num + nkeys
       num = num + nkeys
       ttype(n:m) = headkeys
       tform(n:m) = hform
       tunit(n:m) = hunits
    end if

    if( printhorizon ) then
       num = num + 2
       ttype(num-1:num) = [ FITS_COL_AZIMUTH, FITS_COL_ZENITD ]
       tform(num-1:num) = '1D'
       tunit(num-1:num) = 'deg'
    end if

    if( printairmass ) then
       num = num + 1
       ttype(num) = FITS_COL_AIRMASS
       tform(num) = '1D'
       tunit(num) = ''
    end if

    ! all other columns
    ttype(num+1:) = labels
    tform(num+1:) = '1D'
    tunit(num+1:) = units

    status = 0
    nrows = size(filenames)
    if( fits_file_exist(output) ) call fits_file_delete(output)
    call fits_create_file(fitsfile,output,status)
    call fits_insert_img(fitsfile,8,0,[0],status)
    call fits_write_key(fitsfile,'HDUNAME',MEXTNAMETS,'time series table',status)
    call fits_write_key(fitsfile,FITS_KEY_CREATOR,FITS_VALUE_CREATOR, &
         FITS_COM_CREATOR,status)
    call fits_write_comment(fitsfile,MUNIPACK_VERSION,status)
    call fits_write_comment(fitsfile,&
         'Description: http://munipack.physics.muni.cz/dataform_tmserie.html',&
         status)

    if( status /= 0  ) goto 666

    ! LC extension
    call fits_insert_btbl(fitsfile,nrows,ttype,tform,tunit,MEXTNAMETS,status)

    ! time info: http://dotastro.org/simpletimeseries/
    call fits_write_key(fitsfile,'TIMETYPE',timetype,'JD,MJD,HJD,phase',status)
    call fits_write_key(fitsfile,'TIMESYS','UTC','',status)
    call fits_write_key(fitsfile,'TIMEREF','GEOCENTER','',status)
    call fits_write_key(fitsfile,'TIMESTMP','MIDPOINT', &
         'time stamp = MIDPOINT,BEGIN,END',status)

    call fits_write_comment(fitsfile,'File names (by input order):',status)
    do i = 1, size(filenames)
       call fits_write_comment(fitsfile,filenames(i),status)
    end do

    ! data vomit
    call fits_get_rowsize(fitsfile,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       num = 0
       if( printname ) then
          num = num + 1
          call fits_write_col(fitsfile,num,frow,filenames(i:l),status)
       end if

       if( printtime ) then
          num = num + 1
          call fits_write_col(fitsfile,num,frow,timelike(i:l),status)
       end if

       ! keys
       do n = 1, nkeys
          select case(keytype(n))
          case('L')
             call tits_write_col_logical(fitsfile,num+n,frow,headvals(i:l,n),status)
          case('I')
             call tits_write_col_integer(fitsfile,num+n,frow,headvals(i:l,n),status)
          case('F')
             call tits_write_col_double(fitsfile,num+n,frow,headvals(i:l,n),status)
          case default
             call fits_write_col(fitsfile,num+n,frow,headvals(i:l,n),status)
          end select
       end do
       num = num + nkeys

       ! horizon
       if( printhorizon ) then
          call fits_write_col(fitsfile,num+1,frow,azimuth(i:l),status)
          call fits_write_col(fitsfile,num+2,frow,zenitd(i:l),status)
          num = num + 2
       end if

       ! airmass
       if( printairmass ) then
          num = num + 1
          call fits_write_col(fitsfile,num,frow,airmass(i:l),status)
       end if

       ! data
       do n = 1,size(labels)
          call fits_write_col(fitsfile,num+n,frow,data(i:l,n),status)
       end do

       if( status /= 0 ) goto 666
    end do
    deallocate(ttype,tform,tunit)

    ! OBJECT extension
    nrows = size(xcoo)
    ntypes = 2
    allocate(ttype(ntypes),tform(ntypes),tunit(ntypes))
    tform = '1D'
    tunit = 'deg'
    ttype(1) = FITS_COL_RA
    ttype(2) = FITS_COL_DEC

    call fits_insert_btbl(fitsfile,nrows,ttype,tform,tunit,MEXTNAMETSC,status)
    call fits_write_key(fitsfile,"REFRAME",'ICRS', &
         'reference celestial coordinate system',status)
    call fits_write_key(fitsfile,"EPOCH",epoch,15,'catalogue reference epoch',status)

    call fits_get_rowsize(fitsfile,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_write_col(fitsfile,1,frow,xcoo(i:l),status)
       call fits_write_col(fitsfile,2,frow,ycoo(i:l),status)
       if( status /= 0 ) goto 666
    end do

    deallocate(ttype,tform,tunit)

666 continue

    call fits_close_file(fitsfile,status)
    call fits_report_error(error_unit,status)

  end subroutine savefits


  integer function maxlen(a)

    ! returns maximum lenght of an element of the passed character array
    ! minimal possible lenght is 1 due FITS table format

    character(len=*), dimension(:) :: a
    integer :: i,n,m

    m = 0
    do i = 1, size(a)
       n = len_trim(a(i))
       if( n > m ) m = n
    end do
    maxlen = m

  end function maxlen

  subroutine tits_write_col_logical(fitsfile,colnum,frow,values,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, frow
    character(len=*), dimension(:), intent(in) :: values
    integer, intent(in out) :: status

    logical, dimension(size(values)) :: vals
    integer :: i

    do i = 1, size(values)
       read(values(i),*) vals(i)
    end do
    call fits_write_col(fitsfile,colnum,frow,vals,status)

  end subroutine tits_write_col_logical

  subroutine tits_write_col_integer(fitsfile,colnum,frow,values,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, frow
    character(len=*), dimension(:), intent(in) :: values
    integer, intent(in out) :: status

    integer, dimension(size(values)) :: vals
    integer :: i

    do i = 1, size(values)
       read(values(i),*) vals(i)
    end do
    call fits_write_col(fitsfile,colnum,frow,vals,status)

  end subroutine tits_write_col_integer

  subroutine tits_write_col_double(fitsfile,colnum,frow,values,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, frow
    character(len=*), dimension(:), intent(in) :: values
    integer, intent(in out) :: status

    real(dbl), dimension(size(values)) :: vals
    integer :: i

    do i = 1, size(values)
       read(values(i),*) vals(i)
    end do
    call fits_write_col(fitsfile,colnum,frow,vals,status)

  end subroutine tits_write_col_double

end module savelcfits

!
! color transformation
!
!
! Copyright © 2010-3 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module color_transformation

  implicit none

contains

  subroutine ctrafo(fname,cname,backup,cspace,ctable,black,slope)

    use fitsio

    integer, parameter :: naxis = 3
    integer, parameter :: bitpix = -32
    real, parameter :: minvalue = -huge(1.0)

    character(len=*),intent(in) :: fname,cname,backup,ctable,cspace
    real, dimension(:), intent(in) :: black,slope

    integer,dimension(naxis) :: naxes
    real,dimension(:,:,:),allocatable :: cube,xcube
    real, dimension(:,:),allocatable :: cmatrix
    character(len=80),dimension(:),allocatable :: head

    integer :: i,j,n,ndim,mstat, mdim, nbands, ncolors, width, height, &
         nhead, status, bpix, pcount,gcount, keylen
    logical :: simple,extend,anyf
    character(len=80) :: buf,com,ilabel,olabel,icspace,keyname

    nbands = 0
    ncolors = 0
    width = 0
    height = 0
    status = 0

    call ftnopn(25,fname,0,status)
    if( status /= 0 ) goto 666

    call ftghpr(25,naxis,simple,bpix,n,naxes,pcount,gcount,extend,status)
    if( status /= 0 ) goto 666
    if( n /= naxis ) stop 'Only two dimensional color images (NAXIS=3) are supported.'

    width = naxes(1)
    height = naxes(2)
    nbands = naxes(3)

    if( nbands /= size(black) .or. nbands /= size(slope) ) &
         stop 'Color layers count does not corresponds to black,slope switches.'

    call ftghps(25,nhead,n,status)
    allocate(head(nhead),stat=mstat)
    if( mstat /= 0 ) stop 'Not enough memory for your head.'
    do n = 1, nhead
       call ftgrec(25,n,head(n),status)
    enddo

    call ftgkys(25,FITS_KEY_CSPACE,icspace,buf,status)
    if( status /= 0 ) stop 'Colorspace of input not specified.'

    allocate(cube(width,height,nbands),stat=mstat)
    if( mstat /= 0 ) stop 'Not enough memory.'

    call ftg3de(25,1,minvalue,width,height,width,height,nbands,cube,anyf,status)

    if( status /= 0 ) goto 666

    call ftclos(25,status)


    ! grep color transformation table
    open(1,file=ctable,status='old',iostat=status)
    if( status /= 0 ) stop 'A color table file not found.'

    do
       read(1,*,err=99,end=90) ilabel, olabel
       read(1,*,err=99,end=90) ndim, mdim
       allocate(cmatrix(ndim,mdim))
       read(1,*,err=99,end=90) cmatrix

       if( ilabel == icspace .and. cspace == olabel ) goto 90
       deallocate(cmatrix)
    end do

99  stop 'A color table file read error.'
90  continue
    close(1)

    if( .not. allocated(cmatrix) ) stop 'Required colospaces not found in the table.'
    ncolors = ndim


    ! scale data (only for XYZ)
    if( minval(slope) > 0.0 ) then
       forall(i=1:3)
          cube(:,:,i) = (cube(:,:,i) - black(i))*slope(i)
       end forall
    end if

    ! ???
    where( cube < 0.0 )
       cube = 0.0
    end where


    allocate(xcube(width,height,ncolors))

    ! the transformation
    forall(i=1:width,j=1:height)
       xcube(i,j,:) = matmul(cmatrix,cube(i,j,:))
    end forall

    ! cutoff negative values ??
    where( xcube < 0.0 )
       xcube = 0.0
    end where


    ! write out FITS color
    call fitsbackup(cname,backup,status)
    call ftinit(26,cname,1,status)

    call ftiimg(26,bitpix,naxis,naxes,status)
    call ftukys(26,FITS_KEY_CSPACE,cspace,'the color space for the stored data',status)

    call ftpcom(26,'The matrix of color transformation:',status)
    do i = 1,ncolors
       write(buf,*) cmatrix(i,:)
       call ftpcom(26,buf,status)
    end do

    call ftpcom(26,'Original filename: '//trim(fname),status)

    do n = 1, nhead
       call ftgknm(head(n),keyname,keylen,status)
       call ftgkys(26,keyname,buf,com,status)
       if( buf == '' ) then
          call ftprec(26,head(n),status)
       end if
       status = 0
    end do

    call ftukys(26,'CREATOR','Munipack','Created by color transform utility of Munipack',status)

    call ftp3de(26,1,width,height,width,height,nbands,xcube,status)

    if( status == 412 ) status = 0 ! numerical overflow during implicit datatype conversion

    call ftclos(26,status)


666 continue

    if( allocated(cube) ) deallocate(cube)
    if( allocated(xcube) ) deallocate(xcube)

    call ftrprt('STDERR',status)

  end subroutine ctrafo

end module color_transformation

!
! compute 2-D distribution of gaussian distributions with offset
!
! fortran -Wall -g -p -fbounds-check -fimplicit-none ddistrib.f95
!
!
! Copyright © 2012 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!



program ddistrib

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  real(dbl), dimension(-200:600) :: y,f,g
  real(dbl), dimension(-500:500,-500:500) :: ff,gg,yy
  real(dbl), dimension(-500:500) :: ww
  integer :: i,j
  real(dbl) :: u,v,s

  g = 0.0
  g(0:300) = 2.0
  f = 0.0
  do i = -200,400
     f(i) = 0.5*exp(i/100.0-4.0)
  end do
  
  do i = -200,600
     y(i) = dconv1d(400-i,f,g)
!     write(*,*) i/100.0,g(i),f(i),y(i)/50
  end do
  
  do i = -500,500
     do j = -500,500
        u = i/100.0
        v = j/100.0
        ff(i,j) = exp(-(u**2 + v**2)/2.0)
        gg(i,j) = exp(-((u-1.0)**2 + (v-0.0)**2)/2.0)
!        gg(i,j) = 1.0
     end do
  end do

  do i = -500,500,10
     do j = -500,500,10
        yy(i,j) = dconv2d(i,j,ff,gg)
!        write(*,*) i/100.0,j/100.0,ff(i,j),gg(i,j),yy(i,j)
     end do
  end do

  do i = -500,500,10
     s = 0.0
     do j = -500,500,10
        s = s + yy(i,j)
     end do
     ww(i) = s
     write(*,*) i,s
  end do
        


!  do i = 1,100    
!     d = i/10.0
!     write(*,*) d,dconv1d(d)
!  end do
  
contains

  function dconv1d(j,f,g) result(s)

    real(dbl) :: s
    real(dbl), dimension(:), intent(in) :: f,g
    integer, intent(in) :: j
    integer :: i,l,nmin,nmax
    integer, dimension(1) :: ub,lb

    lb = lbound(f)
    ub = ubound(f)
    nmin = lb(1)
    nmax = ub(1)

    s = 0.0
    do i = nmin,nmax
       l = i - j
       if( nmin < l .and. l < nmax ) &
            s = s + f(i)*g(l)
    end do


  end function dconv1d

  function dconv2d(k,l,f,g) result(s)

    real(dbl) :: s
    real(dbl), dimension(:,:), intent(in) :: f,g
    integer, intent(in) :: k,l
    integer :: i,j,u,v,nxmin,nxmax,nymin,nymax
    integer, dimension(2) :: ub,lb

    lb = lbound(f)
    ub = ubound(f)
    nxmin = lb(1)
    nxmax = ub(1)
    nymin = lb(2)
    nymax = ub(2)

    s = 0.0
    do i = nxmin,nxmax
       u = i - k
       do j = nymin, nymax
          v = j - l
          if( (nxmin < u .and. u < nxmax) .and. (nymin < v .and. v < nymax) ) &
               s = s + f(i,j)*g(u,v)
       end do
    end do


  end function dconv2d

end program ddistrib

!
!  Robust minimization functions
!
!  Copyright © 2011 - 2017 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module rfun

  implicit none

  ! M-estimator functions
  ! Hogg in Launer, Wilkinson: Robustness in Statistics

  ! precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)

  ! parameters of robust functions
  real(dbl),parameter,private :: huber_a = 1.349_dbl, huber_a2 = huber_a**2/2.0_dbl
  real(dbl),parameter :: huber_sigcorr = 1.15
  real(dbl),parameter,private :: hampel_a=1.7_dbl,hampel_b=3.4_dbl,hampel_c=8.5_dbl
  real(dbl),parameter,private :: Andrews_a = 2.1_dbl
  real(dbl),parameter,private :: Tukey_a = 6.0_dbl, Tukey_a2 = 36.0_dbl / 2.0_dbl
  real(dbl),parameter,private :: pi = 3.141592653589793115997963468544185161590576171875_dbl
  real(dbl),parameter :: winscut = 1.618
  real(dbl),parameter,private :: Andrews_pi = Andrews_a*pi

contains

  !--------------------------------------------------------------
  !
  ! Robust functions
  !

  ! Huber

  function huber(x)

    real(dbl) :: huber
    real(dbl),intent(in) :: x

    if( abs(x) < huber_a )then
       huber = x
    else
       huber = sign(huber_a,x)
    endif

  end function huber


  function dhuber(x)

    real(dbl) :: dhuber
    real(dbl),intent(in) :: x

    if( abs(x) < huber_a )then
       dhuber = 1.0_dbl
    else
       dhuber = 0.0_dbl
    endif

  end function dhuber

  function ihuber(x)

    real(dbl) :: ihuber
    real(dbl), intent(in) :: x

    if( abs(x) < huber_a ) then
       ihuber = x**2/2.0_dbl
    else
       ihuber = huber_a*abs(x) - huber_a2
    end if

  end function ihuber


  subroutine hubers(x,y)

    real(dbl),dimension(:),intent(in) :: x
    real(dbl),dimension(:),intent(out) :: y

    where( abs(x) < huber_a )
       y = x
    elsewhere
       y = sign(huber_a,x)
    end where

  end subroutine hubers

  subroutine dhubers(x,y)

    real(dbl),dimension(:),intent(in) :: x
    real(dbl),dimension(:),intent(out) :: y

    where( abs(x) < huber_a )
       y = 1.0_dbl
    elsewhere
       y = 0.0_dbl
    end where

  end subroutine dhubers

  subroutine ihubers(x,y)

    real(dbl), dimension(:), intent(in) :: x
    real(dbl), dimension(:), intent(out) :: y

    where( abs(x) < huber_a )
       y = x**2/2.0_dbl
    elsewhere
       y = huber_a*abs(x) - huber_a2
    end where

  end subroutine ihubers


  ! Hampell

  function hampel(x)

    real(dbl) :: hampel
    real(dbl),intent(in) :: x

    if( abs(x) < hampel_a )then
       hampel = x
    elseif( hampel_a <= abs(x) .and. abs(x) < hampel_b )then
       hampel = sign(hampel_a,x)
    elseif( hampel_b <= abs(x) .and. abs(x) < hampel_c )then
       hampel = hampel_a*(x - sign(hampel_c,x))/(hampel_b - hampel_c)
    elseif(  abs(x) >= hampel_c )then
       hampel = 0.0_dbl
    else
       hampel = 0.0_dbl
    endif

  end function hampel

  function dhampel(x)

    real(dbl) :: dhampel
    real(dbl),intent(in) :: x

    if( abs(x) < hampel_a )then
       dhampel = 1.0_dbl
    elseif( hampel_b <= abs(x) .and. abs(x) < hampel_c )then
       dhampel = hampel_a/(hampel_b - hampel_c)
    else
       dhampel = 0.0_dbl
    endif

  end function dhampel

  subroutine hampels(x,y)

    real(dbl),dimension(:),intent(in) :: x
    real(dbl),dimension(:),intent(out) :: y

    where( abs(x) < hampel_a )
       y = x
    elsewhere( hampel_a <= abs(x) .and. abs(x) < hampel_b )
       y = sign(hampel_a,x)
    elsewhere( hampel_b <= abs(x) .and. abs(x) < hampel_c )
       y = hampel_a*(x - sign(hampel_c,x))/(hampel_b - hampel_c)
    elsewhere(  abs(x) >= hampel_c )
       y = 0.0_dbl
    elsewhere
       y = 0.0_dbl
    endwhere

  end subroutine hampels


  subroutine dhampels(x,y)

    real(dbl),dimension(:),intent(in) :: x
    real(dbl),dimension(:),intent(out) :: y

    where( abs(x) < hampel_a )
       y = 1.0_dbl
    elsewhere( hampel_b <= abs(x) .and. abs(x) < hampel_c )
       y = hampel_a/(hampel_b - hampel_c)
    elsewhere
       y = 0.0_dbl
    endwhere

  end subroutine dhampels

  ! Andrews

  function andrews(x)

    real(dbl) :: andrews
    real(dbl),intent(in) :: x

    if( abs(x) < andrews_a*pi )then
       andrews = sin(x/andrews_a)
    else
       Andrews = 0.0_dbl
    endif

  end function andrews

  function dandrews(x)

    real(dbl) :: dandrews
    real(dbl),intent(in) :: x

    if( abs(x) < andrews_a*pi )then
       dandrews = cos(x/andrews_a)/andrews_a
    else
       dandrews = 0.0_dbl
    endif

  end function dandrews

  subroutine iAndrews(x,y)

    real(dbl),dimension(:),intent(in) :: x
    real(dbl),dimension(:),intent(out) :: y

    where( abs(x) < Andrews_pi )
       y = Andrews_a*(1 - cos(x/Andrews_a))
    elsewhere
       y = 2*Andrews_a
    end where

  end subroutine iAndrews


  ! Tukey

  function tukey(x)

    real(dbl) :: tukey
    real(dbl),intent(in) :: x
    real(dbl) :: t

    if( abs(x) < tukey_a )then
       t = (x/tukey_a)**2
       tukey = x*(1.0_dbl - t)**2
    else
       tukey = 0.0_dbl
    endif

  end function tukey

  function dtukey(x)

    real(dbl) :: dTukey
    real(dbl),intent(in) :: x
    real(dbl) :: t

    if( abs(x) < tukey_a )then
       t = (x/tukey_a)**2
       dtukey = (1.0_dbl - t)*(1.0_dbl - 5.0_dbl*t)
    else
       dtukey = 0.0_dbl
    endif

  end function dTukey

  function iTukey(x)

    real(dbl) :: itukey
    real(dbl),intent(in) :: x
    real(dbl) :: t

    if( abs(x) < tukey_a )then
       t = (x/tukey_a)**2
       iTukey = (x**2/2.0_dbl)*(1.0_dbl + t*(t/3.0_dbl - 1.0_dbl))
    else
       iTukey = tukey_a
    endif

  end function iTukey


  subroutine tukeys(x,y)

    real(dbl),dimension(:),intent(in) :: x
    real(dbl),dimension(:),intent(out) :: y

!    integer :: i

!    do i = 1, size(x)
!       if( abs(x(i)) < tukey_a ) then
!          y(i) = x(i)*(1.0_dbl - (x(i)/tukey_a)**2)**2
!       else
!          y(i) = 0.0_dbl
!       end if
!    end do

    where( abs(x) < tukey_a )
       y = x*(1.0_dbl - (x/tukey_a)**2)**2
    elsewhere
       y = 0.0_dbl
    end where

  end subroutine tukeys

  subroutine dtukeys(x,y)

    real(dbl),dimension(:),intent(in) :: x
    real(dbl),dimension(:),intent(out) :: y

    integer :: i
    real(dbl) :: t

    do i = 1, size(x)
       if( abs(x(i)) < tukey_a ) then
          t = (x(i) / tukey_a)**2
          y(i) = (1.0_dbl - t)*(1.0_dbl - 5.0_dbl*t)
       else
          y(i) = 0.0_dbl
       end if
    end do

!    where( abs(x) < tukey_a )
!       y = (x / tukey_a)**2
!       y = (1.0_dbl - y)*(1.0_dbl - 5.0_dbl*y)
!    elsewhere
!       y = 0
!    end where

  end subroutine dtukeys


  subroutine d2tukeys(x,y)

    real(dbl),dimension(:),intent(in) :: x
    real(dbl),dimension(:),intent(out) :: y

    where( abs(x) < tukey_a )
       y = (x / tukey_a)**2
       y = 4*x/tukey_a**2 * (5*y - 3)
    elsewhere
       y = 0.0_dbl
    end where

  end subroutine d2tukeys


  subroutine iTukeys(x,y)

    real(dbl),dimension(:),intent(in) :: x
    real(dbl),dimension(:),intent(out) :: y

    integer :: i
    real(dbl) :: t

    do i = 1, size(x)
       if( abs(x(i)) < tukey_a ) then
          t = (x(i) / tukey_a)**2
          y(i) = tukey_a2*t*(1.0_dbl + t*(t/3.0_dbl - 1.0_dbl))
       else
          y(i) = tukey_a
       end if
    end do

    !    where( abs(x) < tukey_a )
!       y = (x / tukey_a)**2
!       y = tukey_a2*y*(1.0_dbl + y*(y/3.0_dbl - 1.0_dbl))
!    elsewhere
!       y = tukey_a
!    end where


  end subroutine iTukeys



end module rfun

!
!  Generate artifical sky frame
!
!
!  Copyright © 2016-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!


module marker

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

contains

  subroutine watermark(sky,gray)

    use artpicture

    real(dbl), dimension(:,:), intent(in out) :: sky
    real(dbl), intent(in) :: gray
    real, dimension(:,:), allocatable :: mask
    integer :: i,j,x,y

    allocate(mask(xdimask,ydimask))
    call genmask(mask)

    x = size(sky,1) - xdimask - 10
    y = size(sky,2) - ydimask - 10
    do i = 1, xdimask
       do j = 1, ydimask
          sky(i+x,j+y) = sky(i+x,j+y) + gray*mask(i,ydimask-j+1)
       end do
    end do

    deallocate(mask)

  end subroutine watermark


end module marker

!
!  Robust estimate of parameters of line
!
!  Copyright © 2014-5, 2017 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!


module robustline

  ! This module provides subroutines for estimation
  ! of parameters (a,b) for a line in the form
  !
  !     y = a + b*x                        (without errors of x,y)
  !
  ! or
  !                a + b*x
  !     y = ------------------------       (with errors)
  !         sqrt(dy**2 + b**2*dx**2)
  !
  !
  ! with optional estimate of theirs statistical errors (da, db).
  !
  ! rline should be called as:
  !
  !  call rline(x,y,a,b,da,db,dx,dy,sigma,reliable,verbose)
  !
  ! on input:
  !   x,y - array of data values to be estimated
  !   dx,dy - array of statistical errors of x,y (optional), dx can be omitted,
  !           if dy is presented.
  !   verbose - verbose output (optional)
  !
  ! on output are estimated:
  !   a,b - parameters of the line
  !   da,db - standard error of the parameters (optional)
  !   sigma - standard deviation (optional)
  !   reliable - indicates reliability of results (optional)

  use rfun

  implicit none

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)

  ! verbose print?
  logical, private :: xverbose = .false.

  ! print debug messages
  logical, parameter, private :: debug = .false.

  ! estimate jacobian by differences or derivations ?
  logical, parameter, private :: analytic = .true.

  ! weights?
  logical, private :: weights

  integer, private :: ndat
  real(dbl), dimension(:), allocatable, private :: xdata, ydata, xsig, ysig, &
       res, rho, psi, dpsi
  real(dbl), private :: rsig

  private :: absline, absfun, nscale, funder, fundif, difjac, loglikely, residuals, &
       newline, logline


contains

  subroutine rline(x,y,a,b,da,db,dx,dy,sigma,reliable,verbose)

    use medians

    real(dbl), dimension(:), intent(in) :: x,y
    real(dbl), intent(out) :: a,b
    real(dbl), dimension(:), intent(in), optional :: dx,dy
    real(dbl), intent(out), optional :: da,db
    real(dbl), intent(out), optional :: sigma
    logical, intent(out), optional :: reliable
    logical, intent(in), optional :: verbose

    real(dbl) :: s,d,sig,xcen,ycen,d1,d2

    logical :: abreli, sreli, reli
    integer :: n

    weights = present(dx) .or. present(dy)

    if( present(verbose) ) then
       xverbose = verbose
    else
       xverbose = .false.
    end if

    if( weights .and. .not. present(dy) ) stop 'rline(): dy must be present.'

    if( size(x) /= size(y) ) stop 'rline(): Size of x,y data sets are different.'

    if( present(dx) ) then
       if( size(dx) /= size(x) ) stop 'rline(): Size of x and dx are different.'
       if( .not. all(dx >= 0) ) stop 'rline(): all dx >= 0, it is required.'
    end if

    if( present(dy) ) then
       if( size(dy) /= size(x) ) stop 'rline(): Size of y and dy are different.'
       if( .not. all(dy > 0) ) stop 'rline(): all dy > 0, it is required.'
    end if

    n = size(x)

    if( n < 2 ) then
       a = 0
       b = 0
       if( present(da) ) da = 0
       if( present(db) ) db = 0
       if( present(sigma) ) sigma = 1
       if( present(reliable) ) reliable = .false.
       return

    else if( n == 2 ) then
       d = x(2) - x(1)
       if( abs(d) > 0 ) then
          b = (y(2) - y(1)) / (x(2) - x(1))
          a = (y(1) + y(1)) / 2 + b*(x(1) + x(2)) / 2
       else
          a = 0
          b = 0
       end if
       if( present(da) ) da = 0
       if( present(db) ) db = 0
       if( present(sigma) ) sigma = 1
       if( present(reliable) ) reliable = .false.
       return

    end if

    allocate(xdata(n),ydata(n),xsig(n),ysig(n),res(n),rho(n),psi(n),dpsi(n))
    ndat = n
    xdata = x
    ydata = y

    if( present(dx) ) then
       xsig = dx
    else
       xsig = 0.0_dbl
    end if

    if( present(dy) ) then
       ysig = dy
    else
       ysig = 1.0_dbl
    end if

    ! compute data centroids
    xcen = median(x)
    ycen = median(y)
    if( xverbose ) write(*,*) "Centroids:",real(xcen),real(ycen)

    ! inital estimate by absolute deviations
    call absline(a,b,s,abreli)
    rsig = s
    call nscale(a,b,s,sreli)
    if( xverbose ) write(*,'(a,1p,2g15.5,0pf8.2,1x,2l1)') &
         'Robust line by abs.dev., sig by entropy:',a,b,s,abreli,sreli

    if( sreli ) rsig = s
    reli = abreli .and. sreli
    if( reli ) then

       call logline(a,b,abreli)
       call nscale(a,b,s,sreli)
       if( xverbose ) write(*,'(a,1p,2g15.5,0pf8.2,1x,2l1)') &
            'Robust line by likelihood, sig by entropy:',a,b,s,abreli,sreli

       if( sreli ) rsig = s
       reli = abreli .and. sreli
       if( reli ) then

          ! hight precise solution and statistical errors
          call newline(a,b,d1,d2,sig,reli)

       end if

    end if

    if( .not. reli ) then
       d2 = rsig/sqrt(real(n))
       if( b > 0 ) then
          d1 = d2 / b
       else
          d1 = huge(d1)
       end if
    end if

    if( present(da) ) da = d1
    if( present(db) ) db = d2
    if( present(reliable) ) reliable = reli
    if( present(sigma) ) sigma = sig

    deallocate(xdata,ydata,xsig,ysig,res,rho,psi,dpsi)

  end subroutine rline

  subroutine absline(a,b,s,reli)

    use NelderMead
    use medians

    real(dbl), intent(out) :: a,b,s
    real(dbl), dimension(2) :: t, dt
    logical, intent(out) :: reli
    real(dbl) :: ams, mad
    integer :: ifault

    t = 0
    dt = 1
    call nelmin1(absfun,t,dt,ams,ifault)
    reli = ifault == 0

    if( xverbose .and. ifault > 0 ) write(*,*) "No konvergence in rline: absline()."

    call residuals(t(1),t(2),res)

    if( ndat < 50 ) then
       mad = median(abs(res))
    else
       mad = qmedian(abs(res))
    end if

    a = t(1)
    b = t(2)
    s = mad / 0.6745

  end subroutine absline

  function absfun(t) result(s)

    real(dbl), dimension(:), intent(in) :: t
    real(dbl) :: s

    call residuals(t(1),t(2),res)
    s = sum(abs(res))

  end function absfun


  subroutine logline(a,b,reli)

    use NelderMead

    real(dbl), intent(in out) :: a,b
    real(dbl), dimension(2) :: t, dt
    logical, intent(out) :: reli
    real(dbl) :: ams
    integer :: ifault

    t = (/ a, b /)
    dt = rsig
    call nelmin1(loglikely,t,dt,ams,ifault)
    reli = ifault == 0

    if( xverbose .and. ifault > 0 ) write(*,*) "No konvergence in rline / logline."

    a = t(1)
    b = t(2)

  end subroutine logline


  subroutine newline(a,b,da,db,sig,reli)

    use minpacks

    real(dbl), intent(in out) :: a,b
    real(dbl), intent(out) :: da,db,sig
    real(dbl), dimension(2) :: t
    logical, intent(out) :: reli
    real(dbl), dimension(2,2) :: cov
    real(dbl) :: df, f2
    integer :: nprint,info, i

    if( debug ) then
       nprint = 1
    else
       nprint = 0
    end if

    t = (/ a, b /)

    ! Try to find the best solution. Our initial estimate is very neary
    ! to the right one.
    if( analytic ) then
       call lmder3(funder,t,cov,nprint=nprint,info=info)
    else
       call lmdif3(fundif,t,cov,nprint=nprint,info=info)
    end if

    reli = info /= 5
    if( reli ) then
       ! the minimum localised successfully, update estimates
       a = t(1)
       b = t(2)

       ! estimate uncerainities
       call residuals(a,b,res)
       call tukeys(res/rsig,psi)
       call dtukeys(res/rsig,dpsi)
!       dpsi = 1
!       psi = res
       df = sum(dpsi)
       f2 = sum(psi**2)

       if( df > 0 .and. f2 > 0 ) then

          cov = cov / rsig**2
          sig = rsig * sqrt(f2/df*ndat/(ndat-2))
          if( cov(1,1) > 0 ) da = sig * sqrt(cov(1,1))
          if( cov(2,2) > 0 ) db = sig * sqrt(cov(2,2))

       else
          reli = .false.
       end if

       if( xverbose ) then
          write(*,*) 'cov:',real(cov(1,:))
          write(*,*) 'cov:',real(cov(2,:))
       end if

    end if

  end subroutine newline


  subroutine residuals(a,b,r)

    real(dbl), intent(in) :: a,b
    real(dbl), dimension(:), intent(out) :: r

    if( weights ) then
       r = (ydata - (a + b*xdata)) / sqrt(ysig**2 + b**2*xsig**2)
    else
       r = ydata - (a + b*xdata)
    end if

  end subroutine residuals

  function loglikely(t)

    use rfun

    real(dbl), dimension(:), intent(in) :: t
    real(dbl) :: loglikely

    call residuals(t(1),t(2),res)
    call itukeys(res/rsig,rho)

    loglikely = sum(rho)

  end function loglikely

  subroutine funder(m,np,p,fvec,fjac,ldfjac,iflag)

    use rfun

    integer, intent(in) :: m,np,ldfjac
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
    real(dbl), dimension(:), allocatable :: r,ds,dra,drb
    real(dbl), dimension(2) :: fv
    real(dbl), dimension(2,2) :: dfjac
    real(dbl) :: a,b,s
    integer :: n

    if( iflag == 0 ) then

       write(*,'(4g15.5)') p,fvec

       if( debug ) then
          write(*,*) 'djac:',fjac(1,:)
          write(*,*) 'djac:',fjac(2,:)

          call difjac(p(1),p(2),dfjac)
          write(*,*) 'djac:',dfjac(1,:)
          write(*,*) 'djac:',dfjac(2,:)
       end if

       return
    end if

    n = size(xdata)
    allocate(r(n),ds(n))

    a = p(1)
    b = p(2)
    s = rsig

    if( weights ) then

       ds = sqrt(ysig**2 + b**2*xsig**2)
       r = (ydata - (a + b*xdata)) / ds
       call tukeys(r/s,psi)
!       psi = r/s
       fv(1) = sum(psi/ds)
       fv(2) = sum(psi*(xdata/ds + r*b*xsig**2/ds**2))

    else

       r = ydata - a - b*xdata
       call tukeys(r/s,psi)
!       psi = r / s
       fv(1) = sum(psi)
       fv(2) = sum(psi*xdata)

    end if

    if( iflag == 1 ) then

       fvec = - fv / s
!       write(*,*) fvec

    else if( iflag == 2 ) then

       allocate(dra(n),drb(n))
       call dtukeys(r/s,dpsi)
!       dpsi = 1

       if( weights ) then

          dra = - 1 / ds
          drb = - (xdata*ds + r*b*xsig**2) / ds**2

          fjac(1,1) = sum(dpsi/ds**2)
          fjac(1,2) = sum(dpsi*dra*drb) - s*sum(psi*b*xsig**2/ds**3)
          fjac(2,1) = fjac(1,2)
          fjac(2,2) = sum(dpsi*drb**2) - &
               s*sum(psi*(r*(1-3*b**2**xsig**2/ds**2)-2*xdata/ds)*xsig**2/ds**2)

       else

          fjac(1,1) = sum(dpsi)
          fjac(1,2) = sum(dpsi*xdata)
          fjac(2,1) = fjac(1,2)
          fjac(2,2) = sum(dpsi*xdata**2)

       end if

       fjac = fjac / s**2

       deallocate(dra,drb)

    end if

    deallocate(r,ds)

  end subroutine funder

  subroutine difjac(t,s,jac)

    real(dbl), intent(in) :: t,s
    real(dbl), dimension(:,:), intent(out) :: jac
    real(dbl), parameter :: d = 1e-4
    real(dbl), dimension(2) :: fv1,fv2
    integer :: iflag

    iflag = 1

    call fundif(2,2,(/t+d,s/),fv1,iflag)
    call fundif(2,2,(/t-d,s/),fv2,iflag)
    jac(1,:) = (fv1 - fv2)/(2*d)

    call fundif(2,2,(/t,s+d/),fv1,iflag)
    call fundif(2,2,(/t,s-d/),fv2,iflag)
    jac(2,:) = (fv1 - fv2)/(2*d)

  end subroutine difjac

  subroutine fundif(m,np,p,fvec,iflag)

    use rfun

    integer, intent(in) :: m,np
    integer, intent(in out) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(:), allocatable :: r,f,ds
    real(dbl), dimension(2,2) :: jac
    real(dbl), dimension(2) :: fv
    integer :: n
    real(dbl) :: a,b,s

    if( iflag == 0 ) then

       write(*,'(6g13.5)') p,fvec

       if( debug ) then
          n = 2
          call funder(2,2,p,fv,jac,2,n)
          write(*,*) ' jac:',jac(1,:)
          write(*,*) ' jac:',jac(2,:)
       end if

       return
    end if

    n = size(xdata)
    allocate(r(n),f(n),ds(n))

    a = p(1)
    b = p(2)
    s = rsig

    if( weights ) then

       ds = sqrt(ysig**2 + b**2*xsig**2)
       r = (ydata - (a + b*xdata)) / ds
       call tukeys(r/s,psi)
!       psi = r/s

       fvec(1) = sum(psi/ds)
       fvec(2) = sum(psi*(xdata*ds + r*b*xsig**2)/ds**2)

    else

       r = ydata - (a + b*xdata)
       call tukeys(r/s,psi)
!       psi = r / s
       fvec(1) = sum(psi)
       fvec(2) = sum(psi*xdata)

    end if

    fvec = - fvec / s

    deallocate(r,f,ds)

  end subroutine fundif

  subroutine nscale(a,b,s,reli)

    use entropyscale

    real(dbl), intent(in) :: a,b
    real(dbl), intent(in out) :: s
    logical, intent(out) :: reli

    call residuals(a,b,res)
    call escale(res,s,reli)

  end subroutine nscale


end module robustline

!
!  fitsgphot
!
!  Copyright © 2018 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


module fitsgphot

  use titsio
  use iso_fortran_env

  implicit none

  integer, parameter, private :: rp = selected_real_kind(15)

contains

  subroutine fits_gphot_read(filename,hwhm,sep,raper,xcens,ycens, &
    sky,skyerr,skycorr,skyerrcorr,apcts,apcts_err,status)

    character(len=*), intent(in) :: filename
    real, intent(out) :: hwhm, sep
    real, dimension(:), allocatable, intent(out) :: raper, xcens,ycens, &
         sky,skyerr,skycorr,skyerrcorr
    real, dimension(:,:), allocatable, intent(out) :: apcts,apcts_err
    integer, intent(in out) :: status

    integer :: nrows,xcol,ycol,ecol,scol,i,n,naper
    integer, parameter :: extver = 0, frow = 1
    real, parameter :: nullval = 0.0
    logical :: anyf
    character(len=FLEN_VALUE) :: key, label
    type(fitsfiles) :: fits

    status = 0
    call fits_open_file(fits,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: failed to read the file `',trim(filename),"'."
       return
    end if

    call fits_movnam_hdu(fits,FITS_BINARY_TBL,APEREXTNAME,extver,status)
    if( status == FITS_BAD_HDU_NUM ) then
       write(error_unit,*) "Error: ",trim(APEREXTNAME)// &
            " extension not found. Has been aperture photometry by " // &
            "`munipack aphot "//trim(filename)//"' performed?"
       goto 666
    end if

    call fits_get_num_rows(fits,nrows,status)
    call fits_read_key(fits,FITS_KEY_NAPER,naper,status)
    call fits_read_key(fits,FITS_KEY_HWHM,hwhm,status)
    call fits_read_key(fits,trim(FITS_KEY_ANNULUS)//'2',sep,status)

    allocate(xcens(nrows),ycens(nrows),sky(nrows),skyerr(nrows), &
         skycorr(nrows),skyerrcorr(nrows),apcts(nrows,naper), &
         apcts_err(nrows,naper),raper(naper))

    do i = 1, naper
       call fits_make_keyn(FITS_KEY_APER,i,key,status)
       call fits_read_key(fits,key,raper(i),status)
    end do

    call fits_get_colnum(fits,.true.,FITS_COL_X,xcol,status)
    call fits_get_colnum(fits,.true.,FITS_COL_Y,ycol,status)
    call fits_get_colnum(fits,.true.,FITS_COL_SKY,scol,status)
    call fits_get_colnum(fits,.true.,FITS_COL_SKYERR,ecol,status)
    call fits_read_col(fits,xcol,frow,nullval,xcens,anyf,status)
    call fits_read_col(fits,ycol,frow,nullval,ycens,anyf,status)
    call fits_read_col(fits,scol,frow,nullval,sky,anyf,status)
    call fits_read_col(fits,ecol,frow,nullval,skyerr,anyf,status)

    do i = 1, naper
       write(label,'(a,i0)') FITS_COL_APCOUNT,i
       call fits_get_colnum(fits,.true.,label,n,status)
       call fits_read_col(fits,n,frow,nullval,apcts(:,i),anyf,status)
       write(label,'(a,i0)') FITS_COL_APCOUNTERR,i
       call fits_get_colnum(fits,.true.,label,n,status)
       call fits_read_col(fits,n,frow,nullval,apcts_err(:,i),anyf,status)
    end do

    ! all the commands must be finished without eny error for
    ! correct head, any error indicates internal inconsistency

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    if( status /= 0 ) then
       if( allocated(xcens) ) deallocate(xcens,ycens,sky,skyerr, &
            skycorr,skyerrcorr,apcts,apcts_err,raper)
    end if


  end subroutine fits_gphot_read


  subroutine fits_find_save(filename,output,ghwhm,rflux90, &
       raper, xcens, ycens, sky,skyerr, gcount,gcount_err, growflag, &
       curve, curve_err, prof, status)

    character(len=*), intent(in) :: filename, output
    real, intent(in) :: ghwhm,rflux90
    real, dimension(:), intent(in) :: raper, xcens, ycens, sky,skyerr
    real(rp), dimension(:), intent(in) :: gcount,gcount_err
    integer, dimension(:), intent(in) :: growflag
    real(rp), dimension(:), intent(in) :: curve, curve_err, prof
    integer, intent(in out) :: status

    integer :: hdutype,n
    integer, parameter :: extver = 0, frow = 1, nbegin = 4
    real, parameter :: nullval = 0.0
    character(len=FLEN_VALUE), dimension(:), allocatable :: ttype, tform, tunit
    character(len=FLEN_COMMENT) :: com
    type(fitsfiles) :: fits


    if( status /= 0 ) return

    if( output == '' ) then
       call fits_open_file(fits,filename,FITS_READWRITE,status)
       if( status /= 0 ) then
          write(error_unit,*) &
            'Error: failed to open the file `',trim(filename),"' for a table update."
          return
       end if
    else
       call fits_precopy_file(fits,filename,output,FITS_READWRITE,.true.,status)
       if( status /= 0 ) then
          write(error_unit,*) &
            'Error: failed to create the file `',trim(output),"'."
          return
       end if
    end if

    ! grow photometry table
    call fits_movnam_hdu(fits,FITS_BINARY_TBL,GROWEXTNAME,extver,status)
    if( status == FITS_BAD_HDU_NUM ) then
       status = 0
    else
       ! already presented ? remove it !
       call fits_delete_hdu(fits,hdutype,status)
       if( status /= 0 ) goto 666
    end if

    n = 7
    allocate(ttype(n), tform(n), tunit(n))

    tform = '1D'
    tform(7) = '1B'
    tunit = ''
    ttype(1) = FITS_COL_X
    ttype(2) = FITS_COL_Y
    ttype(3) = FITS_COL_SKY
    ttype(4) = FITS_COL_SKYERR
    ttype(5) = FITS_COL_GCOUNT
    ttype(6) = FITS_COL_GCOUNTERR
    ttype(7) = FITS_COL_GROWFLAG

    call fits_insert_btbl(fits,0,ttype,tform,tunit,GROWEXTNAME,status)
    call fits_write_key(fits,FITS_KEY_HWHM,ghwhm,-4, &
         '[pix] half width at half of maximum',status)
    call fits_write_key(fits,FITS_KEY_RF90,rflux90,-4, &
         '[pix] radius contains 90% of flux',status)

    write(com,'(a,i0)') 'Count of stars used for curve construction: ', &
         count(growflag == 1)
    call fits_write_comment(fits,com,status)
    call fits_write_comment(fits,'GROWFLAG: 0 - star, not used,',status)
    call fits_write_comment(fits, &
         '          1 - star, used for growth curve construction,',status)
    call fits_write_comment(fits,'          2 - non-stellar object',status)

    call fits_write_col(fits,1,frow,xcens,status)
    call fits_write_col(fits,2,frow,ycens,status)
    call fits_write_col(fits,3,frow,sky,status)
    call fits_write_col(fits,4,frow,skyerr,status)
    call fits_write_col(fits,5,frow,gcount,status)
    call fits_write_col(fits,6,frow,gcount_err,status)
    call fits_write_col(fits,7,frow,growflag,status)
    deallocate(ttype,tform,tunit)

    ! store growth-curve
    call fits_movnam_hdu(fits,FITS_BINARY_TBL,GROWCURVEXTNAME,extver,status)
    if( status == FITS_BAD_HDU_NUM ) then
       status = 0
    else
       ! already presented ? remove it !
       call fits_delete_hdu(fits,hdutype,status)
       if( status /= 0 ) goto 666
    end if

    n = 4
    allocate(ttype(n), tform(n), tunit(n))

    tform = '1D'
    tunit = ''
    ttype(1) = FITS_COL_R
    ttype(2) = FITS_COL_GROW
    ttype(3) = FITS_COL_GROWERR
    ttype(4) = FITS_COL_RPROF

    call fits_insert_btbl(fits,0,ttype,tform,tunit,GROWCURVEXTNAME,status)
    call fits_write_col(fits,1,frow,raper,status)
    call fits_write_col(fits,2,frow,curve,status)
    call fits_write_col(fits,3,frow,curve_err,status)
    call fits_write_col(fits,4,frow,prof,status)
    deallocate(ttype,tform,tunit)

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

  end subroutine fits_find_save

end module fitsgphot

!
!  Julian date conversion module
!
!  Copyright © 1996 - 2012 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

!
! 1996-12-23 F.Hroch
! 1996 to f90
! 2000 some change according to Numerical Recipes
!
! --------------------------------------------------------------------

module trajd

  integer, parameter, private :: dbl = selected_real_kind(15)

contains

  !----------------------------------------------------------------------

  function datjd (year,month,day)

    ! Compute Julian date from input citizen year, month and day.
    ! Tested for all year

    real(dbl), parameter :: break = 15 + 31*(10 + 12*1582)

    real(dbl), intent(in) :: year,month,day
    real(dbl) ::  datjd,y,m,d,a

    if( abs(year) < epsilon(year) ) stop "datjd: There is no Year Zero."

    y = year
    if( y < 0.0_dbl ) y = y + 1.0_dbl

    if( month > 2.0_dbl )then
       m = month + 1.0_dbl
       d = day
    else
       y = y - 1.0_dbl
       m = month + 13.0_dbl
       d = day
    endif
    datjd = int(365.25_dbl*y) + int(30.6001_dbl*m) + d + 1720994.5_dbl
    if( d + 31.0_dbl*(m + 12.0_dbl*y) >= break )then
       a = int(y/100.0_dbl)
       datjd = datjd + 2.0_dbl - a + int(a/4.0_dbl)
    endif

  end function datjd

  !----------------------------------------------------------------------

  function yearjd (year)

    ! Compute Julian date from input year with fraction

    real(dbl), parameter :: break = 15 + 31*(10 + 12*1582)

    real(dbl), intent(in) :: year
    real(dbl) ::  yearjd,month,day,y

    y = year - aint(year)
    month = aint(12.0_dbl*y)
    day = 365.25_dbl*(y - month/12.0_dbl) + 1.0_dbl
    month = month + 1.0

    yearjd = datjd(aint(year),month,day)

  end function yearjd


  !----------------------------------------------------------------------

  function mjd (jd)

    real(dbl), intent(in) ::  jd
    real(dbl) :: mjd

    mjd = jd - 2400000.5_dbl

  end function mjd

  !----------------------------------------------------------------------

  function hjd (jd,helcor)

    real(dbl), intent(in) ::  jd,helcor
    real(dbl) :: hjd

    hjd = jd + helcor

  end function hjd

  !----------------------------------------------------------------------

  subroutine jdat(jd,year,month,day)

    ! compute citizen date: year, month and day from input julian date.
    ! only for jd>0! tested for all year except 1582-10-07..15.
    !
    ! WARNING! possibly work incorrectly for a negative year

    real(dbl), parameter :: break = 2299163.0_dbl

    real(dbl), intent( in ) ::  jd
    real(dbl), intent( out ) ::  year,month,day
    real(dbl) :: alpha,a,b,c,d,e

    if( jd >= break ) then
       alpha = int( ((jd - 1867216.0_dbl) - 0.25_dbl) / 36524.25_dbl)
       a = jd + 1.0_dbl + alpha - int( alpha / 4.0_dbl )
    else
       a = jd
    endif
    b = a + 1524.0_dbl
    c = int(6680.0_dbl+((b - 2439870.0_dbl) - 122.1_dbl)/365.25_dbl)
    d = 365.0_dbl*c + int(c/4.0_dbl)
    e = int((b - d)/30.6001_dbl)

    day = b - d - int(30.6001_dbl*e)
    month = e - 1.0_dbl
    if( month > 12.0_dbl ) month = month - 12.0_dbl
    year = c - 4715.0_dbl
    if( month > 2.0_dbl ) year = year - 1.0_dbl
    if( year <= 0.0_dbl ) year = year - 1.0_dbl
    if( year < 0.0_dbl )then
       day = day - 0.5_dbl
    else
       day = day + 0.5_dbl
    endif

  end subroutine jdat


  subroutine jdatetime(jd,year,month,day,hour,min,sec,ms)

    real(dbl), intent(in) ::  jd
    integer, intent(out) ::  year,month,day,hour,min,sec
    real(dbl), intent(out) ::  ms

    real(dbl) ::  y,m,d

    call jdat(jd,y,m,d)
    year = nint(y)
    month = nint(m)
    day = int(d)
    hour = int(24*(d - day))
    min = int(1440*(d - (day + hour / 24.0_dbl)))
    sec = int(86400*(d - (day + (hour + min/60.0_dbl)/24.0_dbl)))
    ms = nint(1000*86400*(d - (day + (hour + (min + sec/60.0_dbl)/60.0_dbl)/24.0_dbl)))
    if( ms > 999 ) then
       sec = sec + 1
       ms = ms - 1000
    end if
    if( sec > 59 ) then
       min = min + 1
       sec = sec - 60
    end if
    if( min > 59 ) then
       hour = hour + 1
       min = min - 60
    end if
    if( hour > 23 ) then
       day = day + 1
       hour = hour - 24
    end if

  end subroutine jdatetime



  ! computes the epoch

  function epoch(y,m,d)

    real(dbl), intent(in) :: y,m,d
    real(dbl) :: jd0,jd,x,epoch

    jd0 = datjd(y,1.0_dbl,1.0_dbl)
    jd  = datjd(y,m,d)

    x = (jd - jd0)/365.25_dbl
    epoch = y + x

  end function epoch

end module trajd

!
!  FITS catalogue for timeseries
!
!  Copyright © 2018-20 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

module fitscat

  use titsio
  use iso_fortran_env

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: J2000 = 2451545.0_dbl   ! J2000.0

  type :: CatFits
     character(len=FLEN_FILENAME) :: filename = ''
     real(dbl) :: jd = 0
     real(dbl), dimension(:,:), allocatable :: coo, pm
     logical :: status = .false.
   contains
     procedure :: Catalogue,Coords,ZeroInit,getcurrent
  end type CatFits

contains

  subroutine ZeroInit(this)

    class(CatFits) :: this

    this%filename = ''
    this%jd = J2000
    allocate(this%coo(0,0),this%pm(0,0))
    this%status = .false.

  end subroutine ZeroInit

  subroutine Coords(this,x,y)

    class(CatFits) :: this
    real(dbl), dimension(:), intent(in) :: x,y

    integer :: n, stat
    character(len=80) :: msg

    n = size(x)

    allocate(this%coo(n,2),this%pm(n,2),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) trim(msg)
       error stop 'Failed to allocate arrays.'
    end if

    this%coo(:,1) = x
    this%coo(:,2) = y
    this%pm = 0
    this%jd = J2000
    this%status = .true.

  end subroutine Coords


  subroutine Catalogue(fits,cat)

    class(CatFits) :: fits
    character(len=*), intent(in) :: cat

    real(dbl), parameter :: xpm = 365.25_dbl * 3600.0_dbl
    integer, parameter :: nlabels = 4
    character(len=FLEN_VALUE), dimension(nlabels), parameter :: &
         labels = [ FITS_COL_RA, FITS_COL_DEC, FITS_COL_PMRA, FITS_COL_PMDEC ]

    real(REAL64), parameter :: null = real(0.0,REAL64)
    integer :: nrows, ncols, i, l, status, stat, srows, frow
    integer, dimension(nlabels) :: col
    character(len=FLEN_CARD) :: runits,dunits,buf
    character(len=80) :: msg
    type(fitsfiles) :: fitsfile
    logical :: anyf

    fits%filename = cat

    status = 0

    call fits_open_table(fitsfile,cat,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) 'Error: failed to read the file `',trim(cat),"'."
       fits%status = .false.
       return
    end if

    call fits_write_errmark
    call fits_read_key(fitsfile,FITS_KEY_EPOCH,fits%jd,buf,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       call fits_clear_errmark
       status = 0
       fits%jd = J2000
    end if

    call fits_get_num_cols(fitsfile,ncols,status)
    call fits_get_num_rows(fitsfile,nrows,status)
    if( ncols /= size(labels) ) stop 'ncols /= size(labels)'

    ! find columns by labels
    do i = 1, size(labels)
       call fits_get_colnum(fitsfile,.true.,labels(i),col(i),status)
    end do
    if( status /= 0 ) goto 666

    ! get units of PM_*
    call fits_read_key(fitsfile,'TUNIT3',runits,status)
    call fits_read_key(fitsfile,'TUNIT4',dunits,status)

    allocate(fits%coo(nrows,2),fits%pm(nrows,2),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) 'Error: ',trim(msg)
       error stop 'Failed to allocate data memory'
    end if

    call fits_get_rowsize(fitsfile,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_read_col(fitsfile,col(1),frow,null,fits%coo(i:l,1),anyf,status)
       call fits_read_col(fitsfile,col(2),frow,null,fits%coo(i:l,2),anyf,status)
       call fits_read_col(fitsfile,col(3),frow,null,fits%pm(i:l,1),anyf,status)
       call fits_read_col(fitsfile,col(4),frow,null,fits%pm(i:l,2),anyf,status)
       if( status /= 0 ) goto 666
    end do

    if( runits == 'arcsec/year' .and. dunits == 'arcsec/year')  then
       fits%pm = fits%pm  / xpm
    else if( runits == 'deg/day' .and. dunits == 'deg/day')  then
       fits%pm = fits%pm
    else
       stop 'Error: unrecognised proper motion units (allowed: arcsec/year, deg/day).'
    end if

666 continue

    call fits_close_file(fitsfile,status)
    call fits_report_error(error_unit,status)

    fits%status = status == 0

  end subroutine Catalogue

  subroutine getcurrent(this,jd,x,y)

    class(CatFits) :: this
    real(dbl), intent(in) :: jd
    real(dbl), dimension(:), intent(out) :: x,y

    real(dbl) :: dt

    if( this%status ) then

       dt = (jd - this%jd)!/365.25_dbl
       x = this%coo(:,1) + dt * this%pm(:,1)
       y = this%coo(:,2) + dt * this%pm(:,2)

    end if

  end subroutine getcurrent

end module fitscat

!
!  Robust mean
!
!  Copyright © 2001 - 2017 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

module robustmean

  ! This module provides rmean subroutine for estimation of robust mean.
  !
  ! rmean should be called as:
  !
  !  call rmean(x,t,dt,sig,reliable)
  !
  ! on input:
  !   x - array of data values to be estimated
  !
  ! on output are estimated:
  !   t - robust mean
  !   dt - standard error
  !   sig (optional) - standard deviation
  !   reliable (optional) - indicates reliability of result
  !
  ! The given results  means that a true value X of the sample x can be,
  ! with 70% probability, found in interval
  !
  !         t - dt  <  X  <  t + dt
  !
  ! and the distribution can be described by Normal distribution N(t,sig),
  ! but studentising is not applied.
  !
  !
  ! Robust estimators has been prepared on base of
  !  * Hogg in Launer, Wilkinson: Robustness in Statistics
  !  * Hubber: Robust Statistics
  !  * my experiences

  implicit none

  ! print debug information ?
  logical, parameter, private :: verbose = .false.
  logical, parameter, private :: debug = .false.

  ! estimate jacobian by differences or derivations ?
  logical, parameter, private :: analytic = .true.

  ! which method will be used?
  integer, parameter, private :: method = 5

  ! winsorize data?
  logical, parameter, private :: winsorize = .true.

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)

  ! 50% quantil of N(0,1)
  real(dbl), parameter, private :: q50 = 0.6745

  ! dispersion of Hubber distribution
  real(dbl), parameter, private :: beta = 0.8200

  ! data buffers
  real(dbl), dimension(:), allocatable, private :: xdata,r,psi,dpsi
  real(dbl), private :: zsig

  integer, private :: nprint = 0

  ! this definition provides the interface described above
  interface rmean
     module procedure rmean_double, rmean_single
  end interface rmean

  private :: funder, fundif, difjac, loglikely, rmean_double, rmean_single, &
       funds, funis, difjac3, graph, zero_graph, zmean, zfun, rhalley, rnewton

contains

  subroutine rmean_double(x,t,dt,sig,reliable)

    ! simple interface for rmean

    real(dbl), dimension(:),intent(in) :: x
    real(dbl), intent(out) :: t,dt
    real(dbl), intent(out), optional :: sig
    logical, intent(out), optional :: reliable

    real(dbl), parameter :: macheps = epsilon(t)
    real(dbl) :: s, eps
    integer :: n,istat
    logical :: reli

    n = size(x)

    if( n == 0 ) then

       ! results are undefined
       t = 0
       s = 0
       dt = 0
       reli = .false.
       goto 666

    else if( n == 1 ) then

       ! dispersion and std.err. are undefined
       t = x(1)
       s = 0
       dt = 0
       reli = .false.
       goto 666

    else if( n == 2 ) then

       t = (x(1) + x(2))/2
       s = abs(x(1) - x(2))/2
       reli = .true.
       dt = s
       goto 666

    end if
    ! we are suppose that  n > 2  below...

    ! initial values
    call rinit(x,t,s)
    if( verbose ) write(*,*) "rinit: t, s= ",t, s

    if( abs(s) <= 2*macheps ) then
       ! If important part of data has identical values, within machine precision,
       ! their median is zero. The application of robust methods is uselles
       ! (and problematic while s == 0).
       !
       ! If all the data are identical, result can be considered as reliable.
       s = sum(abs(x-t)) / n
       reli = s < 10*macheps

       dt = s / sqrt(real(n))
       goto 666
    end if

    ! no-/print debug informations, parameter of lmder, lmdif subroutines
    if( verbose ) then
       nprint = 1
    else
       nprint = 0
    end if

    ! set-up required precision
    eps = 10*macheps*n*max(abs(t),1.0)

    ! allocate working arrays
    allocate(r(n),psi(n),dpsi(n))

    ! Robust solvers
    !
    ! Both the parameters t,s are initiated by rinit and the estimates
    ! are used by all the solvers. See also longer description
    ! given within comments of the routines.
    !
    ! Generally, only rmean5 (reliable, precise) is recommended
    ! for regular use. Please consider rmean[1-4], rnewton and rhalley
    ! as dead way alternatives.

    select case(method)

    case(0)
       ! Location is estimated by robust function, scale by MAD
       call rnewton(x,t,dt,s,eps,reli)

    case(1)
       ! Both location and scale is estimated by robust function
       call rmean1(x,t,dt,s,eps,istat)

    case(2)
       ! Both location and scale are estimated by maximum likelihood.
       call rmean2(x,t,dt,s,eps,istat)

    case(3)
       ! Location is estimated by maximum likelihood, scale by entropy.
       call rmean3(x,t,dt,s,eps,istat)

    case(4)
       ! Location is estimated by maximum likelihood, scale by entropy.
       call rmean4(x,t,dt,s,eps,istat)

    case(5)
       ! Reliable version of rmean4
       call rmean5(x,t,dt,s,eps,reli)

    case default
       ! No default is here, initial estimates will be used
       continue
       dt = s / sqrt(real(n))
       reli = .false.

    end select

    deallocate(r,psi,dpsi)

666 continue

    ! fill-up required items
    if( present(sig) ) sig = s
    if( present(reliable) ) reliable = reli

  end subroutine rmean_double

  subroutine rmean_single(x,t,dt,sig,reliable)

    ! this single precision integrace via double precision is a little bit slower,
    ! than genuine single one, although no code is doubled.

    real, dimension(:),intent(in) :: x
    real, intent(out) :: t,dt
    real, intent(out), optional :: sig
    logical, intent(out), optional :: reliable

    real(dbl), dimension(:), allocatable :: y
    real(dbl) :: d,dd,s
    logical :: reli

    allocate(y(size(x)))
    y = x
    call rmean_double(y,d,dd,s,reli)
    deallocate(y)
    t = real(d)
    dt = real(dd)
    if( present(sig) ) sig = real(s)
    if( present(reliable) ) reliable = reli

  end subroutine rmean_single


  !-------------------------------------------------------------------

  subroutine rinit(x,t,s)

    ! initial estimate of parameters

    use medians
    use qmeans

    real(dbl), dimension(:),intent(in) :: x
    real(dbl), intent(out) :: t,s

    real(dbl) :: mad,med
    integer :: n

    n = size(x)

    if( n > 50 ) then

       ! This choice of the threshold, used for median computation method,
       ! assumes that odd and even elements in sequence are the same (within
       ! requested precision). Note that qmed is the fastest known algorithm
       ! (~ 2*n) while median is simpler and slower (~ n*log(n)).

       med = qmedian(x)
       mad = qmedian(abs(x - med))

       ! correction for Normal distribution
       s = mad / q50
       t = med

    else if( n > 13 ) then

       ! correct way to compute median (two middle values)
       med = median(x)
       mad = median(abs(x - med))

       ! correction for Normal distribution
       s = mad / q50
       t = med

    else if( n > 2 ) then

       ! compute parameters by empirical CDF quantilies
       call qmean(x,t,s)

    else if( n == 2 ) then

       t = (x(1) + x(2))/2
       s = abs(x(1) - x(2))/2

    else if( n == 1 ) then

       t = x(1)
       s = 0

    else

       t = 0
       s = 0

    end if

  end subroutine rinit

  !-----------------------------------------------------------------------

  subroutine rnewton(x,t,dt,sig,tol,converge)

    ! One has been the default robust estimator for a long time.
    ! The main difference from other rmeans is that only the location
    ! parameter (t) is estimated (by Newton's iterations).
    ! The scale has its unchanged estimated value during all computations.
    ! This estimator may give less precise results (up to 10%), but one is
    ! significantly faster than all others rmedians (up to 10x to rmean5).
    !
    ! The reliability of result randomly depends on an initial estimate of t.
    ! There is no reliability if the estimate is out of convergence region
    ! of Newtons method or the scale sig is far from its right value. The region
    ! of convergence depends on robust function in use. Two most frequent
    ! cases are Huber's function which is monotone and converges in full range
    ! and Tukey's (or Hampel's) function which converges only between extremes
    ! of the function.
    !
    ! rmean5 is much more reliable and much more slower.

    use rfun

    real(dbl), dimension(:), intent(in) :: x
    real(dbl), intent(in out) :: t, sig
    real(dbl), intent(out) :: dt
    real(dbl), intent(in) :: tol
    logical, intent(out) :: converge

    integer, parameter :: maxit = precision(t)
    ! Number of iterations is given by numerical precision.
    ! We belives, that one order is reached by each iteration.

    integer :: n,it
    real(dbl) :: d,s,f,f2,df

    converge = .false.
    dt = -1
    if( .not. (sig > 0) ) return

    n = size(x)
    s = sig

    ! iterations
    do it = 1, maxit

       r = (x - t)/s
       call tukeys(r,psi)
       call dtukeys(r,dpsi)
       f = sum(psi)
       df = sum(dpsi)

       ! df can be nearly zero when the important part of data has large
       ! deviations (above 3.4 for Hampel's piecewise or 1.6 for Tukey's
       ! bi-weight), this si "re-descending M-estimate" function problem.
       ! In this case, the computation is immediatelly interrupted and
       ! result should by considered as unreliable.
       if( df <= epsilon(df) ) exit

       ! corrector for mean
       d = s * f / df

       ! update location
       t = t + d

       if( debug ) &
            write(*,'(a,i2,1pg20.10,1p3g10.2)') "mean, inc., f, f': ",it,t,d,-f/s,df/s**2

       ! exit of iterations: the absolute errot must be at least |d| < tol
       converge = abs(d) < tol
       if( converge ) exit

    enddo

    ! estimation of standard deviation, K-factor is omited
    if( converge ) then
       f2 = sum(psi**2)
       if( df > 0 .and. f2 > 0 ) then
          sig = s !*
          dt = sig * sqrt(f2/df**2*n/(n-1))
       end if
    end if

  end subroutine rnewton


  subroutine rhalley(x,t,dt,sig,tol,converge)

    ! This is a faster version of Newton's method with cubicall
    ! convergention. It has simillar properties as rnewton().
    ! One is reccomended to be used only for fast determination
    ! of precise root.

    use rfun

    real(dbl), dimension(:), intent(in) :: x
    real(dbl), intent(in out) :: t, sig
    real(dbl), intent(out) :: dt
    real(dbl), intent(in) :: tol
    logical, intent(out) :: converge

    integer, parameter :: maxit = precision(t)
    ! Number of iterations is given by numerical precision.
    ! We belives, that one order is reached by each iteration.

    integer :: n,it
    real(dbl) :: d,s,f,f2,df,d2f
    real(dbl), dimension(:), allocatable :: d2psi

    converge = .false.
    dt = -1
    if( .not. (sig > 0) ) return

    n = size(x)
    s = sig

    ! iterations
    allocate(d2psi(n))
    do it = 1, maxit

       r = (x - t)/s
       call tukeys(r,psi)
       call dtukeys(r,dpsi)
       call d2tukeys(r,d2psi)
       f = - sum(psi) / s
       df = sum(dpsi) / s**2
       d2f = - sum(d2psi) / s**3

       if( df <= epsilon(df) ) exit

       ! corrector for mean
       d = f / (df * (1 - (f*d2f)/(2*df)))

       ! update location
       t = t - d

       if( debug ) write(*,'(a,1pg15.5,1p3g12.3)') "mean,incr,f,df,d2f: ",t,d,df,d2f

       ! exit of iterations: the absolute errot must be at least |d| < tol
       converge = abs(d) < tol
       if( converge ) exit

    enddo

    ! estimation of standard deviation, K-factor is omited
    if( converge ) then
       f2 = sum(psi**2)
       if( df > 0 .and. f2 > 0 ) then
          df = df * s**2
          sig = s*sqrt(f2/df*n/(n-1))
          dt = sig / sqrt(df)
       end if
    end if

    deallocate(d2psi)

  end subroutine rhalley


! ----------------------------------------------------------------------------


  subroutine rmean1(x,t,dt,sig,tol,istat)

    ! One estimates mean and standard deviation by minimizing
    ! both mean and scale together, the equations are solved
    ! by combination of the iteractions and Newton's method
    ! as reccomends Huber (1980), p. 147 (6.7 the computation
    ! of M-estimates)
    !
    ! t   is solution on output
    ! dt  is standard error of t
    !
    !
    ! IMPORTANT
    !
    ! The procedure works well when covariance matrix is nearly
    ! diagonal because minimizes scale and mean separately in
    ! theirs directions. By another words, the eigenvectors are
    ! orthogonal. The condition is sometimes violated when (perhaps)
    ! data has a distribution unlike the Normal. In this case,
    ! the solution can converge to a false point. This is reason
    ! for use rmean3 in any case! Second reason is the non-convergence
    ! when initial estimate is behind horizon of convergence.
    !
    ! Consider the implementation for study purposes only.
    ! It is unmaintained for long time.

    use rfun

    real(dbl), dimension(:), intent(in) :: x
    real(dbl), intent(in out) :: t,sig
    real(dbl), intent(out) :: dt
    real(dbl), intent(in) :: tol
    integer, intent(out) :: istat

    integer, parameter :: maxit = 2*precision(t)
    integer :: n,i,it
    real(dbl) :: d,t0,s,s0,sum1,sum2,sum3,absd,xm,var,kcorr
    real(dbl), dimension(:), allocatable :: r,p,dp

    istat = 0
    n = size(x)
    s = sig

    ! 99% Winsorisation
    allocate(xdata(n),r(n),p(n),dp(n))
    if( winsorize ) then
       r = (x - t)/s
       where( abs(r) < 3.0 )
          xdata = x
       elsewhere
          xdata = t + sign(3.0*s,r)
       end where
    else
       xdata = x
    end if

    ! save intial estimate
    t0 = t
    s0 = s

    ! iterations
    it = 0
    do i = 1,maxit

       r = (x - t)/s
       call hubers(r,p)
       call dhubers(r,dp)
       sum1 = sum(p)
       sum2 = sum(dp)
       sum3 = sum(p**2)

       ! sum2 can be nearly zero or negative when the important part of data
       ! has large deviations (above 3.4 for Hampel's piecewise or 1.6 for Tukey's
       ! bi-weight), this si "re-descending M-estimate" function problem.
       ! In this case, and also when s*sum1 is smaller (which will indicate
       ! no convergence, perhaps), the computation is stoped and initial estimate
       ! of t,s is used.
       if( sum2 < tol .or. sum2 > s*sum1 ) then
          istat = 3
          exit
       end if

       ! corrector for mean
       d = s*sum1/sum2
       t = t + d

       ! corrector for scale
       s = sqrt(sum3*s**2/(n-1)/beta)

       if( verbose ) write(*,'(a,3g15.5)') "mean, increment, scale: ",t,d,s

       ! exit of iterations:
       absd = abs(d)
       if( absd/abs(t) < tol .or. absd < tol ) exit
       ! the relative error must be at least |d|/|t| < xrel
       ! the absolute errot must be at least |d| < xabs

       it = it + 1
    enddo

    if( istat == 3 ) then
       ! fail of convergence
       t = t0
       s = s0
    end if

    ! estimation of standard deviation, K-factor is included (~1 + 1/n*var/dmean)
    if( sum2 > tol ) then

       xm = sum2/n
       var = sum((dp - xm)**2)/n
       kcorr = (1 + var/xm**2/n)

       sig = s*sqrt(kcorr*sum3/sum2*n/(n-1))
       dt = sig / sqrt(sum2)

    else
       sig = s
       dt = sig/sqrt(real(n))
    end if

    deallocate(xdata,r,p,dp)

  end subroutine rmean1

! ----------------------------------------------------------------------------

  subroutine rmean2(x,t,dt,sig,tol,istat)

    ! minimizes parameters of a robust function with joint estimate of mean and scale
    ! the parameters maximises likelihood getting the most probable solution
    ! This is givest the best solution for outliers free data. The winsorizing
    ! is used for correcting the outliers.
    !
    ! t   is estimation of mean
    ! dt  is standard error of t
    ! sig is standard deviation of sample
    !
    ! rmean3 works faster, more robust and no winsorizing is required!

    use rfun
    use minpacks
    use neldermead

    real(dbl), dimension(:), intent(in) :: x
    real(dbl), intent(inout) :: t,sig
    real(dbl), intent(out) :: dt
    real(dbl), intent(in) :: tol
    integer, intent(out) :: istat

    ! limit to detect non-convergent series, reccomended values: >100
    real(dbl), parameter :: siglim = 1000.0

    integer :: n,m,info,nprint,icount,numres,ifault,i
    real(dbl) :: s,c,sum2,sum3,bcorr,smin,reqmin
    real(dbl), dimension(:), allocatable :: r,p,dp
    real(dbl), dimension(2) :: u,u0,du

    istat = 0
    n = size(x)
    s = sig

    allocate(xdata(n),r(n))

    ! winsorizing, outliers are replaced by x-sigma values
    if( winsorize ) then
       r = (x - t)/s
       c = winscut*s
       where( abs(r) < winscut )
          xdata = x
       elsewhere
          xdata = t + sign(c,r)
       end where
       if( verbose ) then
          write(*,'(a,f0.2)') "Winsorising at cut: ",winscut
          write(*,*) " #, original,  replacement, sig"
          m = 0
          do i = 1,n
             if( abs(xdata(i) - x(i)) > 10*epsilon(x) ) then
                m = m + 1
                !             write(*,'(i4,2g15.4,g10.3)') i,x(i),xdata(i),r(i)
             end if
          end do
          write(*,'(a,i0,a,f0.1,a)') 'Replacements: ',m,'x (',100*float(m)/float(n),'%)'
       end if
    else
       xdata = x
    end if

    ! Location of proper minimum. The parameters are initiated by a non-M-estimate
    ! method and we are expecting a deviated estimate. The M-estimation
    ! is derived in two steps:
    !  1. approximate location of minimum of negative log(likelihood) function
    !     without use of derivates
    !  2. precise estimate by a gradient method
    !
    ! The gradient method can't be used directly because the estimation of scale
    ! frequently lies near (or above) horizon of convergence.

    ! Approximate location of -log(L), the function has one global minimum
    reqmin = s**2
    u = (/t,s/)
    u0 = u
    du = (/ s, s /)
    call nelmin(loglikely,size(u),u0,u,smin,reqmin,du,10,10000,icount,numres,ifault)
    if( verbose ) write(*,'(a,2i3,3g15.5)') 'Approximate solution: ',ifault,icount,u

    if( ifault /= 0 ) then
       ! no global convergence occured

       if( verbose ) &
            write(*,*) "Warning: Finished prematurely without likelihood convergence."

       t = u0(1)
       sig = huber_sigcorr*u0(2)
       dt = sig/sqrt(real(n))
       goto 666

    end if
    u0 = u

    ! Precise solution, a gradient method leads to two minimums: the right, in infinity.
    ! We are suppose, that the previous estimation of u is very nearly to the right.
    if( analytic ) then
       call lmder2(funder,u,tol,nprint,info)
    else
       call lmdif2(fundif,u,tol,nprint,info)
    end if

    if( abs(u(2))/s < siglim .and. info /= 5 ) then
       ! the minimum localised successfully, update estimates
       t = u(1)
       s = u(2)

    else
       ! No convergence detected, so the initial values are used.
       ! The approach is less precise but works better for any unexpected data:
       !  * many same values and one outlier, we are in doubts what is the right result

       if( verbose ) &
            write(*,*) "Warning: Finished prematurely without convergence in gradient."
       t = u0(1)
       sig = huber_sigcorr*u0(2)
       dt = sig/sqrt(real(n))
       goto 666

    end if


    ! Estimation of dispersion (variance) and uncertainty of mean
    ! With the extimations, two notes are related:
    !
    !  * the variance estimated by scale parameter of robust function is
    !    usually smaller than standard deviations because the second
    !    moments of the functions are smaller. For Huber's function,
    !    the second moment is 1.18945 (computed as int(p(normal)*x**2))
    !    To get asymptotical estimation of dispersion from scale, we are
    !    appling the factor.
    !
    !  * The estimation of uncertainity is by Hubber(1981), formula (8.8)
    !    The sum2 has meaning: "which fraction of values lies inside -1.345...
    !    .. 1.345 interval" (in Huber's function). The sum3 is robust equivalent
    !    of mean of square deviations.


    allocate(p(n),dp(n))
    r = (x - t)/s
    call hubers(r,p)
    call dhubers(r,dp)
    bcorr = real(n)/real(n-1) ! Bessel's correction, real() to prevent numerical overflow
    sum2 = sum(dp)
    sum3 = sum(p**2)
    deallocate(p,dp)

    sig = s

    if( sum2 > tol ) then
       ! Huber(1981), Section 7.6 - Asymptotic convariances ....
       dt = sig*sqrt(bcorr*sum3/sum2**2)
    else
       ! the alternative for the scale nearly to machine epsilon
       dt = sig/sqrt(real(n))
    end if

666 continue

    deallocate(xdata,r)

  end subroutine rmean2


  function loglikely(p)

    use rfun

    real(dbl), dimension(:), intent(in) :: p
    real(dbl) :: loglikely
    real(dbl), dimension(:), allocatable :: r,f
    real(dbl) ::t,s
    integer :: n

    t = p(1)
    s = p(2)

    if( s < epsilon(s) ) then
        loglikely = 1e-3*huge(loglikely)
       return
    end if

    n = size(xdata)
    allocate(r(n),f(n))

    r = (xdata - t)/s
    call ihubers(r,f)
!    f = r**2/2
    loglikely = sum(f) + n*log(s)*beta

    deallocate(r,f)

  end function loglikely


  subroutine funder(m,np,p,fvec,fjac,ldfjac,iflag)

    use rfun

    integer, intent(in) :: m,np,ldfjac
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
    real(dbl), dimension(:), allocatable :: r,f,df,rd
    real(dbl), dimension(2) :: fv
    real(dbl), dimension(2,2) :: dfjac
    real(dbl) :: s
    integer :: n

    if( iflag == 0 ) then

       write(*,'(4g15.5)') p,fvec

       if( debug ) then
          write(*,*) 'fjac:',fjac(1,:)
          write(*,*) 'fjac:',fjac(2,:)

          call difjac(p(1),p(2),dfjac)
!          write(*,*) 'djac:',dfjac(1,:)
!          write(*,*) 'djac:',dfjac(2,:)
       end if

       return
    end if

    n = size(xdata)
    allocate(r(n),f(n))

    s = p(2)
    r = (xdata - p(1))/s
    call hubers(r,f)
!    f = r

    fv(1) = sum(f)
    fv(2) = sum(f*r) - n*beta

    if( iflag == 1 ) then

       fvec = fv / s

    else if( iflag == 2 ) then

       allocate(df(n),rd(n))
       call dhubers(r,df)
!       df = 1

       rd = df*r

       fjac(1,1) = sum(df)
       fjac(1,2) = fv(1) + sum(rd)
       fjac(2,1) = fjac(1,2)
       rd = rd*r
       fjac(2,2) = 2*fv(2) + sum(rd) + n*beta

       fjac = - fjac / s**2

       deallocate(rd,df)

    end if


    deallocate(r,f)

  end subroutine funder


  subroutine fundif(m,np,p,fvec,iflag)

    use rfun

    integer, intent(in) :: m,np
    integer, intent(in out) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(:), allocatable :: r,f
    real(dbl), dimension(2,2) :: jac
    real(dbl), dimension(2) :: fv
    integer :: n
    real(dbl) :: s

    if( iflag == 0 ) then

       write(*,'(4g15.5)') p,fvec

       if( debug ) then
          n = 2
          call funder(2,2,p,fv,jac,2,n)
          write(*,*) ' jac:',jac(1,:)
          write(*,*) ' jac:',jac(2,:)
       end if

       return
    end if

    n = size(xdata)
    allocate(r(n),f(n))

    s = p(2)
    r = (xdata - p(1))/s
    call hubers(r,f)

    fvec(1) = sum(f)
    fvec(2) = sum(f*r) - n*beta

    fvec = fvec / s

    deallocate(r,f)

  end subroutine fundif

  subroutine difjac(t,s,jac)

    ! numerical approximation of jacobian

    real(dbl), intent(in) :: t,s
    real(dbl), dimension(:,:), intent(out) :: jac
    real(dbl), dimension(2) :: fv1,fv2
    real(dbl) :: d = 1e-4
    integer :: iflag

    iflag = 1

    if( abs(t) > epsilon(t) ) then
       d = sqrt(epsilon(d))*abs(t)
    else
       d = sqrt(epsilon(d))
    end if
    call fundif(2,2,(/t+d,s/),fv1,iflag)
    call fundif(2,2,(/t-d,s/),fv2,iflag)
    jac(1,:) = (fv1 - fv2)/(2*d)

    d = sqrt(epsilon(d))
    call fundif(2,2,(/t,s+d/),fv1,iflag)
    call fundif(2,2,(/t,s-d/),fv2,iflag)
    jac(2,:) = (fv1 - fv2)/(2*d)

  end subroutine difjac

! ----------------------------------------------------------------------------

  subroutine rmean3(x,t,dt,sig,tol,istat)

    ! minimizes parameters of a robust function with joint estimate of mean and scale
    ! The location estimate maximises likelihood while scale is estimated
    ! from maximum of entropy (free energy). The subroutine gives the best
    ! estimation of scale. No winsorising is applied.
    !
    ! t   is estimation of mean,
    ! dt  is standard error of t
    ! sig is standard deviation of sample
    !
    ! rnewton is significantly faster.

    use rfun
    use minpacks

    real(dbl), dimension(:), intent(in) :: x
    real(dbl), intent(in out) :: t,sig
    real(dbl), intent(out) :: dt
    real(dbl), intent(in) :: tol
    integer, intent(out) :: istat

    integer :: n,info
    real(dbl) :: s,sum2,sum3
    real(dbl), dimension(:), allocatable :: r,f,df
    real(dbl), dimension(2) :: u

    istat = 0
    n = size(x)
    s = sig

    allocate(xdata(n))
    xdata = x

    u = (/ t,s /)
    if( analytic ) then
       call lmder2(funds,u,tol,nprint,info)
    else
       call lmdif2(funis,u,tol,nprint,info)
    end if

    if( info /= 5 ) then
       ! the minimum localised successfully, update estimates
       t = u(1)
       s = u(2)

    else
       ! No convergence occured, so the initial values are used.

       if( verbose ) &
            write(*,*) "Warning: Finished prematurely without convergence in gradient."

       dt = sig/sqrt(real(n))
       goto 666

    end if

    ! Estimation of dispersion (variance) and uncertainty of mean
    !
    !  * The estimation of uncertainity is by Hubber(1981), formula (8.8)
    !    The sum2 has meaning: "which fraction of values lies inside -1.349...
    !    .. 1.349 interval" (in Huber's function). The sum3 is robust equivalent
    !    of mean of square deviations.


    allocate(r(n),f(n),df(n))
    r = (x - t)/s
    call hubers(r,f)
    call dhubers(r,df)
    sum2 = sum(df)
    sum3 = sum(f**2)

    sig = s

    if( sum2 > tol ) then
       dt = sig*sqrt(sum3/sum2**2)
    else
       ! the alternative for the scale nearly to machine epsilon
       dt = sig/sqrt(real(n))
    end if
    deallocate(r,f,df)

666 continue

    deallocate(xdata)

  end subroutine rmean3


  subroutine funds(m,np,p,fvec,fjac,ldfjac,iflag)

    use rfun

    integer, intent(in) :: m,np,ldfjac
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
    real(dbl), dimension(:), allocatable :: rs,f,df,rho,tmp
    real(dbl), dimension(2) :: fv
    real(dbl), dimension(2,2) :: dfjac
    real(dbl) :: s
    integer :: n

    if( iflag == 0 ) then

       write(*,'(4g15.5)') p,fvec

       if( debug ) then
          call difjac3(p(1),p(2),dfjac)
          write(*,*) 'djac:',dfjac(1,:)*p(2)
          write(*,*) 'djac:',dfjac(2,:)*p(2)
       end if

       return
    end if

    n = size(xdata)
    allocate(rs(n),f(n),rho(n))

    s = p(2)
    rs = (xdata - p(1))/s   ! r = xdata - p(1)
    call hubers(rs,f)
    call ihubers(rs,rho)

    ! f = rs
    ! rho = rs**2/2

    ! maximum likelihood
    fv(1) = sum(f)

    ! update for entropy
    f = 2*f
    rho = 2*rho

    fv(2) = sum(f*rs*exp(-rho)*(1-rho))/s

    if( iflag == 1 ) then

       fvec = fv

    else if( iflag == 2 ) then

       allocate(df(n),tmp(n))
       call dhubers(rs,df)
       !       df = 1

       ! maximum likelihood
       fjac(1,1) = sum(df)
       fjac(1,2) = sum(df*rs)

       ! the update for entropy
       df = 2*df
       tmp = exp(-rho)*((f+df*rs)*(1-rho) + rs*f**2*(rho-2))

       ! rho
       fjac(2,1) = sum(tmp)/s
       fjac(2,2) = sum(tmp*rs)/s + fv(2)/s

       if( debug ) then
          write(*,*) fjac(1,:)
          write(*,*) fjac(2,:)
       end if

       fjac = - fjac / s

       deallocate(df,tmp)

    end if

    deallocate(rs,f,rho)

  end subroutine funds

  subroutine funis(m,np,p,fvec,iflag)

    use rfun

    integer, intent(in) :: m,np
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(:), allocatable :: rs,f
    real(dbl), dimension(:), allocatable :: rho
    real(dbl), dimension(2,2) :: dfjac
    real(dbl) :: s
    integer :: n

    if( iflag == 0 ) then

       write(*,'(4g15.5)') p,fvec

       if( debug ) then
          call difjac3(p(1),p(2),dfjac)
          write(*,*) 'djac:',dfjac(1,:)*p(2)
          write(*,*) 'djac:',dfjac(2,:)*p(2)
       end if

       return
    end if

    n = size(xdata)
    allocate(rs(n),f(n),rho(n))

    s = p(2)
    rs = (xdata - p(1))/s
    call hubers(rs,f)
    call ihubers(rs,rho)
!    f = 2*rs
!    rho = rs**2

    ! maximum likelihood
    fvec(1) = sum(f)

    ! the update for entropy
    f = 2*f
    rho = 2*rho

    fvec(2) = sum(f*rs*exp(-rho)*(1-rho))/s

    deallocate(rs,f,rho)

  end subroutine funis


  subroutine difjac3(t,s,jac)

    ! numerical approximation of jacobian of rmean3

    real(dbl), intent(in) :: t,s
    real(dbl), dimension(:,:), intent(out) :: jac
    real(dbl), dimension(2) :: fv1,fv2
    real(dbl) :: d = 1e-4
    integer :: iflag

    iflag = 1

    if( abs(t) > epsilon(t) ) then
       d = sqrt(epsilon(d))*abs(t)
    else
       d = sqrt(epsilon(d))
    end if
    call funis(2,2,(/t+d,s/),fv1,iflag)
    call funis(2,2,(/t-d,s/),fv2,iflag)
    jac(:,1) = (fv1 - fv2)/(2*d)

    d = sqrt(epsilon(d))
    call funis(2,2,(/t,s+d/),fv1,iflag)
    call funis(2,2,(/t,s-d/),fv2,iflag)
    jac(:,2) = (fv1 - fv2)/(2*d)

  end subroutine difjac3


  ! --------------------------------------------------------


  subroutine rmean4(x,t,dt,sig,tol,istat)

    ! One minimizes mean by Huber function with scale estimated by entropy.
    ! The location is estimated by maximum of likelihood while scale is
    ! estimated from extreme of entropy. The subroutine gives the best
    ! estimation of scale. No winsorising is applied.
    !
    ! t   is estimation of mean,
    ! dt  is standard error of t
    ! sig is standard deviation of sample
    !
    ! rnewton is significantly faster.

    use rfun

    real(dbl), dimension(:), intent(in) :: x
    real(dbl), intent(in out) :: t,sig
    real(dbl), intent(out) :: dt
    real(dbl), intent(in) :: tol
    integer, intent(out) :: istat

    integer, parameter :: maxiter = precision(t)
    ! Number of iterations is limited by numerical precision.
    ! We belives in properties of Newton's method so,
    ! one order is reached by each iteration, at least.

    logical :: convergent
    integer :: n,iter
    real(dbl) :: s,sum3,sum2,sum1,d,fs,dfs
    real(dbl), dimension(:), allocatable :: r,rs,f,df,rho,erho

    ! allocate working arrays
    n = size(x)
    allocate(r(n),rs(n),f(n),df(n),rho(n),erho(n))

    ! try to improve estimation of scale by entropy extreme
    s = sig
    convergent = .false.
    do iter = 1, maxiter

       ! check of scale on positiveness
       if( .not. (s > 0) ) exit

       ! solution of f(s) = 0, with f(s) = d [sum(rho*exp(-2*rho))] / ds
       r = x - t
       rs = r / s
       call ihubers(rs,rho)
       call hubers(rs,f)
       call dhubers(rs,df)
!       rho = rs**2/2
!       f = rs
!       df = 1

       erho = exp(-2*rho)
       sum1 = sum(f*r*(1-2*rho)*erho)
       sum2 = sum(((1-2*rho)*(2*f**2-df) + 2*f**2)*r**2*erho)

       fs = -sum1 / s**2
       dfs = 2*sum1 / s**3 - sum2 / s**4

       ! Note. If we have good initial estimate, than sum1 (=fs) is near to zero
       ! and sum1 / sum2 * s**2 is numerically equivalent, but little bit
       ! faster, than fs/dfs. Theirs numerical differences are negligible.

       if( .not. (abs(dfs) > 0) ) exit

       ! Newton's step for scale
       d = fs / dfs
       s = s - d

       !if( debug ) write(*,'(a,i3,4g15.5)') "scale,f,f',incr.",iter,s,sum1,sum2,d

       convergent = abs(d) < tol

       ! exit immediately when required precision is reached
       if( convergent ) exit
    end do

    ! no convergence detected, fall-back to initials
    if( .not. convergent ) s = sig

    ! precision of mean improved with the updated scale
    convergent = .false.
    do iter = 1, maxiter

       ! solution of f(t) = 0, where f(t) = sum(phi((x-t)/s)
       rs = (x - t)/s
       call hubers(rs,f)
       call dhubers(rs,df)
       sum1 = sum(f)
       sum2 = sum(df)

       if( sum2 < tol ) exit

       ! corrector for mean
       d = s*sum1/sum2

       ! update location
       t = t + d

       convergent = abs(d) < tol

       ! exit of iterations: the absolute errot must be at least |d| < tol
       if( convergent ) exit

       if( debug ) write(*,'(a,3g15.5)') "mean, increment, scale: ",t,d,s
    enddo

    ! estimation of standard deviation
    if( convergent ) then

       sum3 = sum(f**2)
       dt = s*sqrt(sum3/sum2**2*n/(n-1))
       sig = s
       istat = 0

    else
       ! this alternative branch is for:
       !  * parameters are poorly estimated, all phi' are zeros
       !  * no convergence
       !
       !  As the consequence, results should be incorrect!
       sig = s
       dt = sig/sqrt(real(n))
       istat = 5
    end if

    deallocate(r,rs,f,df,rho,erho)

  end subroutine rmean4


  subroutine rmean5(x,t,dt,s,tol,reli)

    ! One minimizes mean by Huber function with scale estimated by entropy.
    ! The location is estimated by minimum of likelihood while scale is
    ! estimated from maximum of entropy.
    !
    ! t   is estimation of mean,
    ! dt  is standard error of t
    ! sig is standard deviation of sample
    !
    ! rnewton is significantly faster but less reliable

    use rfun
    use entropyscale

    real(dbl), dimension(:), intent(in) :: x
    real(dbl), intent(in out) :: t,s
    real(dbl), intent(out) :: dt
    real(dbl), intent(in) :: tol
    logical, intent(out) :: reli

    integer :: n
    real(dbl) :: s0,t0
    logical :: converge, treli, sreli

    converge = .false.
    dt = -1

    n = size(x)
    allocate(xdata(n))

    ! keep initial estimation
    t0 = t
    s0 = s

    if( debug ) call zero_graph(x,t,s)

    call zmean(x,t,s,treli)
    call escale(x-t,s,sreli)
    reli = treli .and. sreli

    if( debug ) write(*,'(a,1pg20.10,1pg12.3,1x,2l1)') 'zmean, escale:',t,s,treli,sreli

    if( reli ) then

       ! keep the solution
       t0 = t
       s0 = s

       ! Newton's iterations are only used to get more precise result and
       ! to estimate of std.err. by  derivative.
       call rnewton(x,t,dt,s,tol,converge)
!       call rhalley(x,t,dt,s,tol,converge)
       reli = converge .and. (minval(x) <= t .and. t <= maxval(x))

       if( debug ) write(*,'(a,1pg20.10,1p2g17.7,l3)') 'Newton:',t,dt,reli

    end if

    if( .not. reli ) then
       ! Failback for:
       !  * parameters are poorly estimated, all psi'(.) are zero
       !  * no convergence
       !  * final result is out of range of the zmean result
       !
       !  As the consequence, results are unreliable.

       t = t0
       s = s0
       if( dt < 0 ) dt = s/sqrt(real(n))

       if( debug ) write(*,*) 'rmean5 (not reliable):',t,t0,s,s0,dt,converge

    end if

    if( verbose ) write(*,'(a,1g20.10,2g12.3,l2)') 'rmean5:',t,dt,s,reli
    deallocate(xdata)

  end subroutine rmean5

  subroutine zmean(x,t,s,reli)

    ! Zero mean estimates mean of robust function by Brent's method
    ! which is combination of bisection and inverse quadratic interpolation.
    ! It is important that it works without derivatives so there is
    ! no potential risk of divergence due to "re-descending" property
    ! of Tukey's function as in rnewton() with an imprecise initial.

    use fmm

    real(dbl), dimension(:),intent(in) :: x
    real(dbl), intent(in) :: s
    real(dbl), intent(in out) :: t
    logical, intent(out) :: reli

    real(dbl) :: tol, tmin, tmax, d
    integer :: n

    n = size(x)
    tol = 0.001 * s / sqrt(real(n))

    tmin = t - s
    tmax = t + s

    xdata = x
    zsig = s
    t = zeroin(tmin,tmax,zfun,tol)

    ! d gives precision of localisation on base of std.dev.
    ! Number of calls of fhuber will approximately ln((tmax-tmin)/d).

    d = 2*tol
    reli = abs(t - tmin) > d .and. abs(tmax - t) > d

    ! results lying too close to endpoints looks very bad...

  end subroutine zmean

  function zfun(t)

    use rfun

    real(dbl) :: zfun
    real(dbl), intent(in) :: t

    call tukeys((xdata -t)/zsig,psi)
    !    psi = r/zsig

    zfun = sum(psi) / size(psi)

  end function zfun



  !-------------------------------------
  !
  ! diagnostics routines
  !

  subroutine zero_graph(x,t0,s)

    use rfun

    real(dbl), dimension(:),intent(in) :: x
    real(dbl), intent(in) :: t0,s

    integer :: i
    real(dbl) :: t

    xdata = x
    zsig = s

    open(1,file='/tmp/t')
    do i = -500,500,10
       t = t0 + s * i / 100.0
       write(1,*) t,zfun(t)
    end do
    close(1)

  end subroutine zero_graph



  ! an interface for plotting of functions in minimum (not used for computations)
  subroutine graph(x,t,sig,type,fvec)

    real(dbl), dimension(:), target, intent(in) :: x
    real(dbl), intent(in) :: t,sig
    character(len=*), intent(in) :: type
    real(dbl), dimension(:) :: fvec
    integer :: iflag, n

    n = size(x)
    allocate(xdata(n))
    xdata = x

    if( type == "grad" ) then
       iflag = 1
       call fundif(2,2,(/t,sig/),fvec,iflag)
    else if( type == "like" ) then
       fvec(1) = loglikely((/t,sig/))
    end if

    deallocate(xdata)

  end subroutine graph


end module robustmean

!
!  find stars
!
!  Copyright © 2013-4, 2016 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!  
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!  
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


program find

  use fitsio
  use fitsfind

  implicit none

  character(len=4*FLEN_FILENAME) :: line,key,val
  character(len=FLEN_FILENAME) :: outname, file,backup, output = ''
  character(len=FLEN_KEYWORD), dimension(2) :: fkeys
  real :: lothresh = 7.0
  real :: threshold = 7.0
  real :: fwhm = 3.0
  real :: readns = -1
  real :: satur = -1
  real :: shrplo = 0.2, shrphi = 1.0
  real :: rndlo = -1.0, rndhi = 1.0
  integer :: maxsky = 10000
  logical :: verbose = .false., plog = .false.
  integer :: eq,istat

  fkeys(1) = FITS_KEY_SATURATE
  fkeys(2) = FITS_KEY_READNS

  do
     read(*,'(a)',end=20) line

     eq = index(line,'=')
     if( eq == 0 ) stop 'Improper input.'
     key = line(:eq-1)
     val = line(eq+1:)

     if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'PIPELOG' ) then

        read(val,*) plog

     else if( key == 'FWHM' ) then

        read(val,*) fwhm

     else if( key == 'READNOISE' ) then

        read(val,*) readns

     else if( key == 'SATURATE' ) then

        read(val,*) satur

     else if( key == 'THRESHOLD' ) then

        read(val,*) threshold

     else if( key == 'LOWER_THRESHOLD' ) then

        read(val,*) lothresh

     else if( key == 'ROUND_LOWER' ) then

        read(val,*) rndlo

     else if( key == 'ROUND_HIGHER' ) then

        read(val,*) rndhi

     else if( key == 'SHARP_LOWER' ) then

        read(val,*) shrplo

     else if( key == 'SHARP_HIGHER' ) then

        read(val,*) shrphi

     else if( key == 'FITS_KEY_SATURATE' ) then

           read(val,*) fkeys(1)

     else if( key == 'FITS_KEY_READNOISE' ) then

           read(val,*) fkeys(2)

     else if( key == 'FILE' ) then

        read(val,*) file, backup, output

        istat = 0
        call fitsback(file,backup,output,.false.,outname,istat)

        if( verbose ) then
           write(*,*)
           write(*,'(a)') "========  Processing file: "//trim(outname)
           write(*,*)
        end if
           
        call ffind(outname,maxsky,verbose,plog,fkeys,fwhm,readns, &
             satur,lothresh,threshold,shrplo,shrphi,rndlo,rndhi)

     end if

  end do

20 continue

  stop 0

end program find

!
!  Robust estimate of both scale and background from already known growth-curve.
!
!  Copyright © 2015-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

module grow_fit

  implicit none

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: pi = 3.14159265358979312_dbl

  ! use analytical Jacobian ?
  logical, parameter, private :: analytic = .true.

  ! verbose (prints intermediate results)
  logical, parameter, private :: verbose = .false.

  ! In minpacks routines, prints intermediate results every nprint-call or be quite (0)
  integer, private :: nprint = 0 ! 0 or >= 1

  integer, parameter :: maxit = 3*precision(0.0_dbl)
  ! Number of iterations is limited by numerical precision.
  ! We belives, that one order is reached by each iteration.

  ! tolerances in numerical precision of iterations
  real(dbl), parameter, private :: tol = 10*epsilon(0.0_dbl)

  real(dbl), dimension(:), allocatable, private :: aper,cts,dcts,curve,curve_err,acts,ects
  real(dbl), private :: rsig, fmin, ctsref

  private :: growfun, growdif, growder, difjac, res, varpar, &
       snoise, snoise_graph

contains

  subroutine growfit(raper,xcts,xdcts,xcurve,xcurve_err,bmax,f,df,b,db,sig,info)

    use NelderMead
    use minpacks
    use oakleaf

    real, dimension(:), intent(in) :: raper
    real(dbl), dimension(:), intent(in) :: xcts,xdcts,xcurve,xcurve_err
    real, intent(in) :: bmax
    real(dbl), intent(in out) :: f,df,b,db
    real(dbl), intent(out) :: sig
    integer, intent(out) :: info
    integer :: ifault
    real(dbl), dimension(2) :: p,p1,dp
    real(dbl), dimension(size(raper)) :: r
    real(dbl) :: mad, dsig
    integer :: n, iter, i
    logical :: converge

    info = 3 ! no initialisation

    n = size(raper)
    allocate(aper(n),cts(n),dcts(n),curve(n),curve_err(n),acts(n),ects(n))
    aper = pi*raper**2
    cts = xcts
    dcts = xdcts
    curve = xcurve
    curve_err = xcurve_err
    ctsref = f
    acts = cts / ctsref
    ects = dcts / ctsref

    if( verbose ) then
       do i = 1,n
          write(*,*) i,real(curve(i)),real(curve_err(i)),real(cts(i)/curve(i))
       end do
    end if

!    write(*,*) real(p(1)),real(dp(1))
!    write(*,*) real(cts - p(1)*curve)/aper

    ! setup init values
    p(1) = f
    p(2) = 0
    dp(1) = 1e-4*df + f*curve_err(6)
    dp(2) = 1!0.01*bmax

    p(1) = 1
    p(2) = 0
    dp = 1e-4

    ! minimal value of p(1) for init
    fmin = max(0.1*median(cts),1.0)
    fmin = minval(acts)

    ! initial estimate of parameters by absolute deviations
    call nelmin1(growfun,p,dp,mad,ifault)
    if( verbose ) &
         write(*,'(a,3g15.5,f8.3,i5)') 'growfit init: ',p*ctsref,mad,mad/p(1),ifault
    if( ifault /= 0 .or. p(1) < 1.01*fmin ) then
       info = 2 ! no convergence
       if( verbose ) write(*,*) &
            "Warning: growfit finished prematurely without nelmin convergence."
       goto 666
    end if
    p = ctsref*p

!    p(2) = 0
!    dp(2)

    ! initial estimate of mean deviation
    r = abs(p(1)*curve + p(2)*aper - cts) / sqrt(dcts**2 + p(1)**2*curve_err**2)
    sig = median(r) / 0.6745
    dsig = median(sqrt(dcts**2 + p(1)**2*curve_err**2)) / 0.6745
    if( verbose ) write(*,'(a,g0.3,5x,2f0.5,a)') 'sig = ',sig,dsig
    rsig = sig

    converge = .false.
    p1 = p
    do iter = 1, maxit

       ! robust estimate
       if( analytic ) then
          call lmder2(growder,p,tol,nprint,info)
       else
          call lmdif2(growdif,p,sqrt(tol),nprint,info)
       end if
       if( verbose ) write(*,'(a,es12.5,f10.5,i5)') 'robust:',p,info
       if( info == 5 ) then
          info = 2 ! no convergence
          if( verbose ) write(*,*) &
               "Warning: growfit finished prematurely without lmdif/lmder convergence."
          if( analytic ) goto 666
       end if

       converge = all(abs(p - p1) < tol)

       if( converge ) exit

       p1 = p

       ! update noise scale
       call snoise(p,sig)
!       rsig = sig

    end do

    if( .not. converge .and. verbose ) &
         write(*,*) "Warning: Grow-curve fitting shows no convergence!"

    if( converge ) then

       ! estimation of uncertainties (sigma is omited)
       call varpar(p,dp,sig)

       info = 0
       f = p(1)
       b = p(2)
       df = dsig*dp(1)
       df = sqrt(f)
       db = dp(2)
    end if

666 continue

    deallocate(aper,cts,dcts,curve,curve_err,acts,ects)

  end subroutine growfit

  function growfun(p) result(s)

    real(dbl), dimension(:), intent(in) :: p
    real(dbl) :: s,f,b,f2ref

    f = p(1)
    b = p(2)
!    f2ref = cts(6)**2

    if( f < fmin ) then
       s = 100 * size(cts) !* maxval(cts)
    else
       s = sum(abs(f*curve + b*aper - acts)/sqrt(ects**2 + curve_err**2))
!       s = sum(abs(curve + b*aper - cts/f)/sqrt(dcts**2/f2ref + curve_err**2))
!       s = sum(abs(curve + b*aper - cts/f))
    end if
!    write(*,*) real(p),real(s)

  end function growfun


  subroutine res(f,b,r,ds)

    real(dbl), intent(in) :: f,b
    real(dbl), dimension(:), intent(out) :: r,ds

    r = cts - (f*curve + b*aper)
    ds = sqrt(dcts**2 + f**2*curve_err**2 + rsig**2*f**2*0)

  end subroutine res

  subroutine growdif(m,np,p,fvec,iflag)

    use oakleaf

    integer, intent(in) :: m,np
    integer, intent(in out) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(:), allocatable :: r,f,ds
    integer :: n
    real(dbl) :: f0,b,s

    if( iflag == 0 ) then
       write(*,'(2g13.5)') p
       write(*,'(2g13.5)') fvec
       return
    end if

    n = size(aper)
    allocate(r(n),f(n),ds(n))

    f0 = p(1)
    b = p(2)
    s = rsig

    call res(f0,b,r,ds)
    f = huber(r/ds/s)

    fvec(1) = sum(f*(curve - f0*r*curve_err**2/ds**2)/ds - f0*curve_err**2/ds**2*s)
    fvec(2) = sum(f*aper/ds)

    fvec = - fvec / s

    deallocate(r,f,ds)

  end subroutine growdif

  subroutine growder(m,np,p,fvec,fjac,ldfjac,iflag)

    use oakleaf

    integer, intent(in) :: m,np,ldfjac
    integer, intent(in out) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
    real(dbl), dimension(size(p),size(p)) :: dfjac
    real(dbl), dimension(:), allocatable :: r,f,df,ds,dd
    integer :: i,j,n
    real(dbl) :: f0,b,s

    if( iflag == 0 ) then

       write(*,'(6g13.5)') p,fvec

       do i = 1,2
          write(*,'(a,2g15.5)') ' jac:',fjac(i,:)
       end do

       call difjac(p,dfjac)
       do i = 1,2
          write(*,'(a,2g15.5)') 'djac:',dfjac(i,:)
       end do

       return
    end if

    n = size(aper)
    allocate(r(n),f(n),df(n),ds(n),dd(n))

    f0 = p(1)
    b = p(2)
    s = rsig

    call res(f0,b,r,ds)
    f = huber(r/ds/s)
    dd = curve - r*f0*curve_err**2/ds**2

    if( iflag == 1 ) then

       fvec(1) = sum(f*dd/ds - f0*curve_err**2/ds**2*s)
       fvec(2) = sum(f*aper/ds)

    else if( iflag == 2 ) then

       fjac = 0
       df = dhuber(r/ds/s)

       fjac(1,1) = sum(df*(dd/ds)**2 &
            - f*(curve*f0*curve_err**2 + &
            r*curve_err**2*(ds**2-3.0_dbl*f0**2*curve_err**2)/ds**2)/ds**3 &
            - curve_err**2*(ds**2-2.0_dbl*f0**2*curve_err**2)/ds**4)
       fjac(1,2) = sum(df*dd*aper/ds**2 - f*aper*f0*curve_err**2/ds**3)
       fjac(2,2) = sum(df*(aper/ds)**2)

       do j = 1,size(fvec)
          do i = 1,j-1
             fjac(j,i) = fjac(i,j)
          end do
       end do

    end if

    fvec = - fvec / s
    fjac = fjac / s**2

    deallocate(r,f,df,ds,dd)

  end subroutine growder

  subroutine difjac(p,jac)

    ! It has failure near the minimum

    real(dbl), dimension(:), intent(in) :: p
    real(dbl), dimension(:,:), intent(out) :: jac
    real(dbl), parameter :: d = 1e-4
    real(dbl), dimension(size(p)) :: fv1,fv2,q
    integer :: n,i,iflag

    iflag = 1
    n = size(p)

    do i = 1,size(p)
       q = p
       q(i) = p(i) + d
       call growdif(n,n,q,fv1,iflag)

       q = p
       q(i) = p(i) - d
       call growdif(n,n,q,fv2,iflag)

       jac(i,:) = (fv1 - fv2)/(2*d)
    end do

  end subroutine difjac



  subroutine varpar(p,dp,sig)
    ! estimate variability of parameters

    use minpacks
    use oakleaf

    real(dbl), dimension(:), intent(in) :: p
    real(dbl), dimension(:), intent(out) :: dp
    real(dbl), intent(out) :: sig

    real(dbl), dimension(size(p),size(p)) :: jac,hess
    real(dbl),dimension(:), allocatable :: f,df,r,ds
    real(dbl) :: sum2,sum3
    integer :: i,n

    n = size(aper)
    allocate(r(n),f(n),df(n),ds(n))
    dp = -1

    call res(p(1),p(2),r,ds)
    f = huber(r/(ds*rsig))
    df = dhuber(r/(ds*rsig))
    sum2 = sum(df)
    sum3 = sum(f**2)

    if( sum2 > 0 .and. sum3 > 0 .and. n > 2 ) then

       ! The matrix is computed from second derivatives.
       ! The variability scales - ds (converting sum of square roots
       ! to chi2) - are ignored to provide a proper scale of errors.
       jac(1,1) = sum(df*curve**2)
       jac(1,2) = sum(df*curve*aper)
       jac(2,1) = jac(1,2)
       jac(2,2) = sum(df*(aper)**2)
       call qrinv(jac,hess)

       ! Huber (6.6)
       sig = rsig*sqrt(sum3/sum2*n/(n-1.0))

       do i = 1, 2
          if( hess(i,i) > 0 ) then
             dp(i) = sig * sqrt(hess(i,i))
          end if
       end do

       if( verbose ) then
          do i = 1,n
             write(*,'(i3,g15.5,3f12.3)') i,r(i),r(i)/(ds(i)*rsig),f(i),df(i)
          end do
          write(*,*) 'jac:',real(jac(1,:))
          write(*,*) 'jac:',real(jac(2,:))
          write(*,*) 'hess:',real(hess(1,:))
          write(*,*) 'hess:',real(hess(2,:))
       end if

    end if

    deallocate(r,f,df,ds)

  end subroutine varpar

  subroutine snoise(p,sig)

    use oakleaf

    real(dbl), dimension(:), intent(in) :: p
    real(dbl), intent(in out) :: sig

    integer :: n,iter
    real(dbl) :: s,sum1,sum2,fs,dfs,d
    real(dbl), dimension(:), allocatable :: r,rs,ds,f,df,rho,erho
    logical :: convergent

    n = size(aper)
    allocate(r(n),rs(n),ds(n),rho(n),df(n),f(n),erho(n))

    s = sig
    convergent = .false.

    do iter = 1, maxit

       if( .not. (s > 0) ) exit

       call res(p(1),p(2),r,ds)
       r = r / ds
       rs = r / s
       rho = ihuber(rs)
       f   =  huber(rs)
       df  = dhuber(rs)

!       rho = rs**2/2
!       f = rs
!       df = 1

       erho = exp(-2*rho)
       sum1 = sum(f*r*(1-2*rho)*erho)
       sum2 = sum(((1-2*rho)*(2*f**2-df) + 2*f**2)*r**2*erho)

       fs = -sum1 / s**2
       dfs = 2*sum1 / s**3 - sum2 / s**4

       ! Note. If we have good initial estimate, than sum1 (=fs) is near to zero
       ! and sum1 / sum2 * s**2 is numerically equivalent, but little bit
       ! faster, than fs/dfs. Theirs numerical differences are negligible.

       if( .not. (abs(dfs) > 0) ) exit

       ! Newton's step for scale
       d = fs / dfs
       s = s - d

       !       if( debug )
!       write(*,'(a,i3,4g15.5)') "scale,f,f',incr.",iter,s,fs,dfs,d

       ! exit immediately when required precision is reached
       convergent = abs(d) < 10*epsilon(sig)
       if( convergent ) exit

    end do

    deallocate(r,rs,ds,f,df,rho,erho)

    if( convergent ) sig = s

  end subroutine snoise

  subroutine snoise_graph(p)

    use oakleaf

    real(dbl), dimension(:), intent(in) :: p

    integer :: n,i
    real(dbl) :: s
    real(dbl), dimension(:), allocatable :: r,rho,ds,rs

    n = size(aper)
    allocate(r(n),rho(n),ds(n),rs(n))

    open(1,file='/tmp/e')
    do i = 2,1000
       s = i / 100.0

       call res(p(1),p(2),r,ds)
       rho = ihuber(r/(s*ds))
       write(1,*) s,sum(rho*exp(-2*rho))
    end do
    close(1)

    deallocate(r,rho,ds,rs)

  end subroutine snoise_graph

end module grow_fit

!
!  find stars
!
!  Copyright © 2013-4, 2016-20 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


program find

  use titsio
  use iso_fortran_env

  implicit none

  logical, parameter :: debug = .false.
  integer, parameter :: maxsky = 4e6

  character(len=4*FLEN_FILENAME) :: record,key,val
  character(len=FLEN_FILENAME) :: filename, output
  character(len=FLEN_KEYWORD), dimension(2) :: fkeys
  character(len=80) :: msg
  real :: lothresh = 3.0
  real :: threshold = 7.0
  real :: fwhm = 3.0
  real :: readns_init = -1
  real :: saturation = -1
  real :: shrplo = 0.2, shrphi = 1.0
  real :: rndlo = -1.0, rndhi = 1.0
  logical :: verbose = .false., plog = .false.
  logical :: ex, exitus = .true.
  integer :: eq, stat

  fkeys(1) = FITS_KEY_SATURATE
  fkeys(2) = FITS_KEY_READNS

  do
     read(*,'(a)',iostat=stat,iomsg=msg) record
     if( stat == IOSTAT_END ) exit
     if( stat > 0 ) then
        write(error_unit,*) trim(msg)
        error stop 'An input error.'
     end if

     eq = index(record,'=')
     if( eq == 0 ) stop 'Malformed input record.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then

        read(val,*) verbose
        if( verbose ) &
             write(error_unit,*) 'Filename, sky value [cts], No. of stars:'

     else if( key == 'PIPELOG' ) then

        read(val,*) plog

     else if( key == 'FWHM' ) then

        read(val,*) fwhm

     else if( key == 'READNOISE' ) then

        read(val,*) readns_init

     else if( key == 'SATURATE' ) then

        read(val,*) saturation

     else if( key == 'THRESHOLD' ) then

        read(val,*) threshold

     else if( key == 'LOWER_THRESHOLD' ) then

        read(val,*) lothresh

     else if( key == 'ROUND_LOWER' ) then

        read(val,*) rndlo

     else if( key == 'ROUND_HIGHER' ) then

        read(val,*) rndhi

     else if( key == 'SHARP_LOWER' ) then

        read(val,*) shrplo

     else if( key == 'SHARP_HIGHER' ) then

        read(val,*) shrphi

     else if( key == 'FITS_KEY_SATURATE' ) then

           read(val,*) fkeys(1)

     else if( key == 'FITS_KEY_READNOISE' ) then

           read(val,*) fkeys(2)

     else if( key == 'FILE' ) then

        read(val,*) filename, output

        if( verbose ) &
             write(error_unit,'(a)',advance="no") trim(filename)//": "

        call the_finder(ex)
        exitus = exitus .and. ex

     end if

  end do

  if( exitus ) then
     stop 0
  else
     stop 'Some error(s) occurred during this star FIND.'
  end if

contains

  subroutine the_finder(exitus)

    use mdaosky
    use mdaofind
    use fitsfind

    logical, intent(out) :: exitus

    real, dimension(:,:), allocatable :: data
    real :: lobad, hibad, hmin, readns,skymod, skyerr, skysig, satur
    integer :: nstep,nstar,status

    if( fwhm <= 0.0 ) stop 'Error in find: Assumption FWHM > 0 unsatisfied.'

    status = 0
    call fits_find_read(filename,fkeys,data,readns,satur,status)
    if( status /= 0 ) goto 666

    ! by default, saturation is assigned:
    !  * if presented in the file and not specified by user: by the file
    !  * if specified: by user
    if( saturation > 0 ) then
       hibad = saturation
    else
       hibad = satur
    end if
    if( readns_init > 0.0 ) readns = readns_init

    ! Sky estimate
    nstep = max(int(log(float(size(data))/maxsky) / log(2.0)),1)
    call daosky(data,nstep,verbose,hibad,skymod,skyerr,skysig)
    if( debug ) write(*,*) 'Sky:',skymod,'+-',skyerr,' sig=',skysig

    if( skymod < 0 ) &
         stop 'Error in FIND: skymod >= 0 assumption failed.'

    ! Detected stars are temporary stored in a scratch file under unit 3.
    ! The file is written by daofind and re-read by fits_find_save().
    open(3,status='scratch',form='unformatted')

    call daofind(data,debug,plog,hibad,skymod,skysig,fwhm,lothresh,threshold,&
         shrplo,shrphi,rndlo,rndhi,readns,nstar,lobad, hmin)

    rewind(3)
    call fits_find_save(filename,output,fkeys,nstar,fwhm,threshold,&
         shrplo,shrphi,rndlo,rndhi,readns,lothresh, lobad, hibad, hmin, &
         skymod, skyerr, skysig, maxsky,status)

    if( verbose ) write(error_unit,*) skymod, nstar
    close(3)

666 continue

    exitus = status == 0

    if( allocated(data) ) deallocate(data)

  end subroutine the_finder

end program find

!
!  FITSIO definitions - directly derived from f77.inc
!
!  Copyright © 2010-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.



module fitsio

  ! version identification

  character(len=*), parameter :: MUNIPACK_VERSION = &
       "Munipack 0.5.10, (C)1997-2018 F. Hroch <hroch@physics.muni.cz>"

  character(len=*), parameter :: FITS_VALUE_CREATOR = "Munipack 0.5.10"
  character(len=*), parameter :: FITS_COM_CREATOR = "http://munipack.physics.muni.cz"

  ! basic constants (fitsio.h)
  integer, parameter :: FLEN_FILENAME = 1025 ! max length of a filename
  integer, parameter :: FLEN_KEYWORD = 72    ! max length of a keyword (include HIERARCH)
  integer, parameter :: FLEN_CARD = 81       ! length of a FITS header card
  integer, parameter :: FLEN_VALUE = 71      ! max length of a keyword value string
  integer, parameter :: FLEN_COMMENT = 73    ! max length of a keyword comment string
  integer, parameter :: FLEN_ERRMSG = 81     ! max length of a FITSIO error message
  integer, parameter :: FLEN_STATUS = 31     ! max length of a FITSIO status text string


  ! Merged from f77.inc (cfitsio distribution)

  ! Codes for FITS extension types
  integer, parameter :: &
       IMAGE_HDU = 0, &
       ASCII_TBL = 1, &
       BINARY_TBL = 2, &
       ANY_HDU = 2

  integer, parameter :: &
       READONLY = 0, &
       READWRITE = 1

  ! Codes for FITS table data types
  integer, parameter :: &
       TBIT        =   1, &
       TBYTE       =  11, &
       TLOGICAL    =  14, &
       TSTRING     =  16, &
       TSHORT      =  21, &
       TINT        =  31, &
       TFLOAT      =  42, &
       TDOUBLE     =  82, &
       TCOMPLEX    =  83, &
       TDBLCOMPLEX = 163

  ! Codes for iterator column types
  integer, parameter :: &
       InputCol       = 0, &
       InputOutputCol = 1, &
       OutputCol      = 2

  ! codes for header record class
  integer, parameter :: &
       TYP_STRUC_KEY = 10, &
       TYP_CMPRS_KEY = 20, &
       TYP_SCAL_KEY  = 30, &
       TYP_NULL_KEY  = 40, &
       TYP_DIM_KEY   = 50, &
       TYP_RANG_KEY  = 60, &
       TYP_UNIT_KEY  = 70, &
       TYP_DISP_KEY  = 80, &
       TYP_HDUID_KEY = 90, &
       TYP_CKSUM_KEY = 100,&
       TYP_WCS_KEY   = 110,&
       TYP_REFSYS_KEY= 120,&
       TYP_COMM_KEY  = 130,&
       TYP_CONT_KEY  = 140,&
       TYP_USER_KEY  = 150


  integer, parameter :: FILE_NOT_OPENED = 104
  integer, parameter :: BAD_HDU_NUM = 301 ! HDU number < 1 or > MAXHDU
  integer, parameter :: KEYWORD_NOT_FOUND = 202
  integer, parameter :: COLUMN_NOT_FOUND = 219
  integer, parameter :: NUMERICAL_OVERFLOW = 412
  integer, parameter :: MULTIPLE_MATCH = 237

  character(len=*), parameter :: FINDEXTNAME = 'FIND'
  character(len=*), parameter :: APEREXTNAME = 'APERPHOT'
  character(len=*), parameter :: GROWEXTNAME = 'GROWPHOT'
  character(len=*), parameter :: GROWCURVEXTNAME = 'GROWCURVE'
  character(len=*), parameter :: GROWFUNCEXTNAME = 'GROWFUNC'
  character(len=*), parameter :: GROWDATEXTNAME = 'GROWDATA'
  character(len=*), parameter :: PSFEXTNAME  = 'PSFPHOT'
  character(len=*), parameter :: PHOTOEXTNAME= 'PHOTOMETRY'
  character(len=*), parameter :: MEXTNAMETS =  'TIMESERIES'
  character(len=*), parameter :: MEXTNAMETSC = 'CATALOGUE'
  character(len=*), parameter :: FHDUNAME =    'PHOTOSYS'
  character(len=*), parameter :: FTHDUNAME =   'FOTRAN'
  character(len=*), parameter :: EXT_STDERR =  'STDERR'
  character(len=*), parameter :: EXT_PHRES =   'PHRES'

  character(len=*), parameter :: BEGIN_ASTROMETRY = &
       '=== Astrometric Solution by Munipack ==='
  character(len=*), parameter :: END_ASTROMETRY = &
       '=== End of Astrometric Solution by Munipack ==='
  character(len=*), parameter :: BEGIN_PHOTOCAL = &
       '=== Photometric Calibration by Munipack ==='
  character(len=*), parameter :: END_PHOTOCAL = &
       '=== End of Photometric Calibration by Munipack ==='

  character(len=*), parameter :: FITS_KEY_NAPER = 'NAPER'
  character(len=*), parameter :: FITS_KEY_APER = 'APER'
  character(len=*), parameter :: FITS_KEY_SAPER = 'SAPER'
  character(len=*), parameter :: FITS_KEY_ANNULUS = 'ANNULUS'
  character(len=*), parameter :: FITS_KEY_FWHM = 'FWHM'
  character(len=*), parameter :: FITS_KEY_HWHM = 'HWHM'
  character(len=*), parameter :: FITS_KEY_RF90 = 'RADFLX90'
  character(len=*), parameter :: FITS_KEY_EXTINK0 = 'EXTIN_K0'
  character(len=*), parameter :: FITS_KEY_EXTINR = 'EXTIN_R'
  character(len=*), parameter :: FITS_KEY_EXTINREF = 'EXTINREF'
  character(len=*), parameter :: FITS_KEY_THRESHOLD = 'THRESH'
  character(len=*), parameter :: FITS_KEY_LOWBAD = 'LOWBAD'
  character(len=*), parameter :: FITS_KEY_HIGHBAD = 'HIGHBAD'
  character(len=*), parameter :: FITS_KEY_RNDLO = 'RNDLO'
  character(len=*), parameter :: FITS_KEY_RNDHI = 'RNDHI'
  character(len=*), parameter :: FITS_KEY_SHRPLO = 'SHRPLO'
  character(len=*), parameter :: FITS_KEY_SHRPHI = 'SHRPHI'
  character(len=*), parameter :: FITS_KEY_PHOTPLAM = 'PHOTPLAM'
  character(len=*), parameter :: FITS_KEY_PHOTZPT = 'PHOTZPT'
  character(len=*), parameter :: FITS_KEY_PHOTFLAM = 'PHOTFLAM'
  character(len=*), parameter :: FITS_KEY_PHOTBW = 'PHOTBW'
  character(len=*), parameter :: FITS_KEY_CTPH = 'CTPH'
  character(len=*), parameter :: FITS_KEY_CTPHERR = 'CTPHERR'
  character(len=*), parameter :: FITS_KEY_CSPACE = 'CSPACE'
  character(len=*), parameter :: FITS_KEY_REFRAME = 'REFRAME'
  character(len=*), parameter :: FITS_KEY_SATURATE = 'SATURATE'
  character(len=*), parameter :: FITS_KEY_GAIN = 'GAIN'
  character(len=*), parameter :: FITS_KEY_READNS = 'READNS'
  character(len=*), parameter :: FITS_KEY_AREA = 'AREA'
  character(len=*), parameter :: FITS_KEY_EXPTIME = 'EXPTIME'
  character(len=*), parameter :: FITS_KEY_PHOTSYS = 'PHOTSYS'
  character(len=*), parameter :: FITS_KEY_FILTER = 'FILTER'
  character(len=*), parameter :: FITS_KEY_FILTREF = 'FILTREF'
  character(len=*), parameter :: FITS_KEY_OBJECT = 'OBJECT'
  character(len=*), parameter :: FITS_KEY_OBSERVER = 'OBSERVER'
  character(len=*), parameter :: FITS_KEY_ORIGIN = 'ORIGIN'
  character(len=*), parameter :: FITS_KEY_AUTHOR = 'AUTHOR'
  character(len=*), parameter :: FITS_KEY_INSTRUME = 'INSTRUME'
  character(len=*), parameter :: FITS_KEY_TELESCOP = 'TELESCOP'
  character(len=*), parameter :: FITS_KEY_BIBREF = 'BIBREF'
  character(len=*), parameter :: FITS_KEY_LONGITUDE = 'LONGITUD'
  character(len=*), parameter :: FITS_KEY_LATITUDE =  'LATITUDE'
  character(len=*), parameter :: FITS_KEY_EPOCH = 'EPOCH'
  character(len=*), parameter :: FITS_KEY_CREATOR = 'CREATOR'
  character(len=*), parameter :: FITS_KEY_ORIGHDU = 'ORIGHDU'
  character(len=*), parameter :: FITS_KEY_BUNIT = 'BUNIT'
  character(len=*), parameter :: FITS_KEY_SKYMAG = 'SKYMAG'
  character(len=*), parameter :: FITS_KEY_SKYMEAN = 'SKYMEAN'
  character(len=*), parameter :: FITS_KEY_SKYSIG = 'SKYSIG'
  character(len=*), parameter :: FITS_KEY_SKYSTD = 'SKYSTD'
  character(len=*), parameter :: FITS_KEY_IMAGETYP = 'IMAGETYP'
  character(len=*), parameter :: FITS_KEY_DATEOBS = 'DATE-OBS'
  character(len=*), parameter :: FITS_KEY_TIME = 'TIME'
  character(len=*), parameter :: FITS_KEY_TEMPERATURE = 'TEMPERAT'
  character(len=*), parameter :: FITS_KEY_AIRMASS = 'AIRMASS'
  character(len=*), parameter :: FITS_KEY_JD = 'JD'
  character(len=*), parameter :: FITS_KEY_HJD = 'HJD'
  character(len=*), parameter :: FITS_KEY_FILENAME = 'FILENAME'
  character(len=*), parameter :: FITS_KEY_PHOTOTYP = 'PHOTOTYP'

  ! definitions of column labels, common
  character(len=*), parameter :: FITS_COL_TIME = 'TIME'
  character(len=*), parameter :: FITS_COL_X = 'X'
  character(len=*), parameter :: FITS_COL_Y = 'Y'
  character(len=*), parameter :: FITS_COL_RA = 'RAJ2000'
  character(len=*), parameter :: FITS_COL_DEC = 'DEJ2000'
  character(len=*), parameter :: FITS_COL_PMRA = 'pmRA'
  character(len=*), parameter :: FITS_COL_PMDEC = 'pmDE'
  character(len=*), parameter :: FITS_COL_SKY = 'SKY'
  character(len=*), parameter :: FITS_COL_SKYERR = 'SKYERR'
  character(len=*), parameter :: FITS_COL_R = 'R'
  character(len=*), parameter :: FITS_COL_GROW = 'GROWCURVE'
  character(len=*), parameter :: FITS_COL_GROWERR = 'GROWCURVEERR'
  character(len=*), parameter :: FITS_COL_RPROF = 'RADIALPROFILE'
  character(len=*), parameter :: FITS_COL_RESGROW = 'RESGROW'
  character(len=*), parameter :: FITS_COL_GROWFLAG = 'GROWFLAG'

  ! definitions of column labels, find
  character(len=*), parameter :: FITS_COL_PEAKRATIO = 'PEAKRATIO'
  character(len=*), parameter :: FITS_COL_SHARP = 'SHARP'
  character(len=*), parameter :: FITS_COL_ROUND = 'ROUND'

  ! definitions of column labels, general photometry
  character(len=*), parameter :: FITS_COL_COUNT =     'COUNT'
  character(len=*), parameter :: FITS_COL_COUNTERR =  'COUNTERR'
  character(len=*), parameter :: FITS_COL_PHOTON =    'PHOTON'
  character(len=*), parameter :: FITS_COL_PHOTONERR = 'PHOTONERR'
  character(len=*), parameter :: FITS_COL_PHOTRATE =    'PHOTRATE'
  character(len=*), parameter :: FITS_COL_PHOTRATEERR = 'PHOTRATEERR'

  ! definitions of column labels, aperture photometry
  character(len=*), parameter :: FITS_COL_APCOUNT =    'APCOUNT'
  character(len=*), parameter :: FITS_COL_APCOUNTERR = 'APCOUNTERR'

  ! definitions of column labels, growth-curve photometry
  character(len=*), parameter :: FITS_COL_GCOUNT =    'GCOUNT'
  character(len=*), parameter :: FITS_COL_GCOUNTERR = 'GCOUNTERR'

  ! definitions of column labels, L-photometry
  character(len=*), parameter :: FITS_COL_LBCOUNT =    'LBCOUNT'
  character(len=*), parameter :: FITS_COL_LBCOUNTERR = 'LBCOUNTERR'

  ! definitions of column labels, PSF photometry
  character(len=*), parameter :: FITS_COL_PSFCOUNT =   'PSFCOUNT'
  character(len=*), parameter :: FITS_COL_PSFCOUNTERR ='PSFCOUNTERR'
  character(len=*), parameter :: FITS_COL_PSFPEAK =    'PSFPEAK'
  character(len=*), parameter :: FITS_COL_PSFPEAKERR = 'PSFPEAKERR'

  ! definitions of column labels, output photometry quantities
  character(len=*), parameter :: FITS_COL_PHOTNU =     'PHOTNU'
  character(len=*), parameter :: FITS_COL_PHOTNUERR =  'PHOTNUERR'
  character(len=*), parameter :: FITS_COL_PHOTLAM =    'PHOTLAM'
  character(len=*), parameter :: FITS_COL_PHOTLAMERR = 'PHOTLAMERR'
  character(len=*), parameter :: FITS_COL_FLUX =       'FLUX'
  character(len=*), parameter :: FITS_COL_FLUXERR =    'FLUXERR'
  character(len=*), parameter :: FITS_COL_FNU =        'FNU'
  character(len=*), parameter :: FITS_COL_FNUERR =     'FNUERR'
  character(len=*), parameter :: FITS_COL_FLAM =       'FLAM'
  character(len=*), parameter :: FITS_COL_FLAMERR=     'FLAMERR'
  character(len=*), parameter :: FITS_COL_MAG =        'MAG'
  character(len=*), parameter :: FITS_COL_MAGERR =     'MAGERR'
  character(len=*), parameter :: FITS_COL_ABMAG =      'ABMAG'
  character(len=*), parameter :: FITS_COL_ABMAGERR =   'ABMAGERR'
  character(len=*), parameter :: FITS_COL_STMAG =      'STMAG'
  character(len=*), parameter :: FITS_COL_STMAGERR =   'STMAGERR'
  character(len=*), parameter :: FITS_COL_RATE =       'RATE'
  character(len=*), parameter :: FITS_COL_RATEERR =    'RATEERR'

  character(len=*), parameter :: FITS_COL_FILTER =     'FILTER'

  character(len=*), parameter :: FITS_COL_LAMEFF =     'LAM_EFF'
  character(len=*), parameter :: FITS_COL_LAMFWHM =    'LAM_FWHM'
  character(len=*), parameter :: FITS_COL_NUEFF =      'NU_EFF'
  character(len=*), parameter :: FITS_COL_NUFWHM =     'NU_FWHM'
  character(len=*), parameter :: FITS_COL_FNUREF =     'FNU_REF'
  character(len=*), parameter :: FITS_COL_FLAMREF =    'FLAM_REF'

!  character(len=*), parameter :: FITS_COL__ERR = '_ERR'


!!$  interface
!!$
!!$     subroutine ftpcle(unit,colnum,frow,felem,nelements,values,status)
!!$       integer, intent(in) :: unit, colnum, frow,felem,nelements
!!$       real, dimension(:), intent(in) :: values
!!$       integer, intent(out) :: status
!!$     end subroutine ftpcle
!!$
!!$  end interface

  interface
     function ftgkcl(buf)
       integer :: ftgkcl
       character(len=*) :: buf
     end function ftgkcl
  end interface

  private :: fremove

contains

    subroutine fitscopy(from,to,status)

    character(len=*), intent(in) :: from,to
    integer, intent(out) :: status
    integer :: blocksize = 0

    status = 0
    call ftopen(15,from,0,blocksize,status)
    call ftinit(16,to,blocksize,status)
    call ftcpfl(15,16,1,1,1,status)
    call ftclos(16,status)
    call ftclos(15,status)
    call ftrprt('STDERR',status)

  end subroutine fitscopy

  subroutine fitsbackup(file,backup,status,rem)

    character(len=*), intent(in) :: file,backup
    integer, intent(out) :: status
    logical, intent(in), optional :: rem
    logical :: rm = .true.

    if( present(rem) ) rm = rem

    ! remove backup when exist
    if( backup /= '' ) then
       call fremove(backup)

       ! copy the file to backup
       call fitscopy(file,backup,status)

    end if

    ! optionally remove the old file
    if( rm ) call fremove(file)

  end subroutine fitsbackup

  subroutine fitsback(file,backup,output,rem,outname,status)

    character(len=*), intent(in) :: file,backup,output
    character(len=*), intent(out) :: outname
    logical, intent(in) :: rem
    integer, intent(inout) :: status

    if( status /= 0 ) return

    if( output /= '' ) then
       if( backup /= '' ) then
          call fitsbackup(output,backup,status,rem)
!  !!! removed when storing to a different directory failed with
!      "failed to create new file (already exists?):"
!       else
!          call fitscopy(file,output,status)
       end if
       outname = output
    else
       if( backup /= '' ) then
          call fitsbackup(file,backup,status,rem)
       end if
       outname = file
    end if

  end subroutine fitsback

  subroutine fremove(file)

    character(len=*), intent(in) :: file
    logical :: ex

    inquire(file=file,exist=ex)
    if( ex ) then
       open(26,file=file)
       close(26,status='DELETE')
    end if

  end subroutine fremove


  ! DESIGN FOR FUTURE:
  ! subroutine fitsio_init(unit,file,newfile,status)
  !  if( newfile /= '' ) then
  !    default = 'fitsio_XXXX.fits'
  !  else
  !     default = newfile
  !   endif
  !   call fremove(default)
  !   call ftinit(unit,default,...,status)
  !
  ! subroutine fitsio_close(unit,backup,status)
  !   if( backup /= '' ) call fitscopy(file,backup)
  !   if( newfile == '' ) call fitscopy(default,file)
  !
  ! subroutine fitsio_ftp2d(unit,obr,status)
  !   n(i) = size(obr,i)
  !   call ftp2de(unit,1,n(1),n(1),n(2),obr,status)


  subroutine fitsio_unlink(file)

    character(len=*), intent(in) :: file
    logical :: ex

    inquire(file=file,exist=ex)
    if( ex ) then
       open(26,file=file)
       close(26,status='DELETE')
    end if

  end subroutine fitsio_unlink


end module fitsio

!
!  Phcorr - photometric corrections
!  Copyright (C) 2012-4, 2016-20  Filip Hroch, Masaryk University, Brno, CZ
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program phcorr

  use fitscorr
  use oakleaf
  use titsio
  use iso_fortran_env

  implicit none

  character(len=FLEN_FILENAME) :: sciname, output
  character(len=FLEN_FILENAME) :: flatname = ''
  character(len=FLEN_FILENAME) :: biasname=''
  character(len=FLEN_FILENAME) :: darkname=''
  character(len=FLEN_FILENAME) :: maskname=''

  character(len=4*FLEN_FILENAME) :: key, val, record
  character(len=80) :: msg

  integer :: eq, stat
  logical :: verbose = .false.       ! vebosity
  logical :: normalise = .false.     ! normalise flat prior to use
  real    :: gain_user = 0           ! gain
  logical :: gain_set = .false.
  real    :: tol_exptime = 1e-6      ! tolerances
  real    :: tol_temperat = 1.0
  real    :: xdark = -1.0            ! dark time factor
  real    :: flat_mean = 1.0, flat_err = 0.0 ! flat parameters
  integer :: bitpix = -32            ! bitpix
  integer :: box = 5                 ! box size for median mask
  logical :: ex, exitus = .true.
  logical :: overwrite = .false.     ! do not overwrite files
  logical :: gain_warning = .false.  ! reports unset gain on finish

  character(len=FLEN_KEYWORD) :: tmask = 'MEAN'
  character(len=FLEN_KEYWORD), dimension(6) :: keys = [ &
       FITS_KEY_DATEOBS, &
       FITS_KEY_EXPTIME, &
       FITS_KEY_FILTER, &
       FITS_KEY_SATURATE, &
       FITS_KEY_TEMPERATURE, &
       FITS_KEY_GAIN ]

  ! FITS wrappers
  type(CorrFits), allocatable :: flatfits, darkfits, biasfits, maskfits

  do
     read(*,'(a)',iostat=stat,iomsg=msg) record
     if( stat == IOSTAT_END ) exit
     if( stat > 0 ) then
        write(error_unit,*) trim(msg)
        error stop 'An input error.'
     end if

     eq = index(record,'=')
     if( eq == 0 ) error stop 'Malformed input record.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then
        read(val,*) verbose
     endif

     if( key == 'OVERWRITE' ) then
        read(val,*) overwrite
     endif

     if( key == 'BITPIX' ) then
        read(val,*) bitpix
     endif

     if( key == 'FITS_KEY_DATEOBS' ) then
        read(val,*) keys(1)
     endif

     if( key == 'FITS_KEY_EXPTIME' ) then
        read(val,*) keys(2)
     endif

     if( key == 'FITS_KEY_FILTER' ) then
        read(val,*) keys(3)
     endif

     if( key == 'FITS_KEY_SATURATE' ) then
        read(val,*) keys(4)
     endif

     if( key == 'FITS_KEY_TEMPERATURE' ) then
        read(val,*) keys(5)
     endif

     if( key == 'FITS_KEY_GAIN' ) then
        read(val,*) keys(6)
     endif

     if( key == 'GAIN' ) then
        read(val,*) gain_user
        if( .not. (gain_user > 0) ) stop 'Assertion: gain > 0 unsatisfied.'
        gain_set = .true.
     endif

     if( key == 'MUNIPACK_TEMPERATURE_TOLERANCE' ) then
        read(val,*) tol_temperat
     endif

     if( key == 'MUNIPACK_EXPTIME_TOLERANCE' ) then
        read(val,*) tol_exptime
     endif

     if( key == 'NORMALISE' ) then
        read(val,*) normalise
     endif

     if( key == 'FLAT' ) then

        read(val,*) flatname

        if( verbose ) write(error_unit,'(a)',advance="no") &
             "Flat-field frame: "//trim(flatname)//", "

        allocate(flatfits)
        call flatfits%Load(flatname,keys)
        if( .not. flatfits%status ) stop 'Failed to load flat-field frame.'

        if( verbose ) &
             write(error_unit,'(2a)') ' filter = ',trim(flatfits%filter)

        if( flatfits%filter == '' ) &
             write(error_unit,*) &
             "Warning: a photometric filter of flat-field unknown."

        if( normalise .or. flatfits%bitpix > 0 ) then

           ! average of flat
           if( any(flatfits%imgerr > 0) ) then
              call rmean(pack(flatfits%image, flatfits%imgerr > 0),&
                   pack(flatfits%imgerr,flatfits%imgerr > 0),&
                   flat_mean,flat_err)
           else
              call rmean(pack(flatfits%image, flatfits%image > 0),&
                   pack(sqrt(flatfits%image),flatfits%image > 0),&
                   flat_mean,flat_err)
           end if

           if( verbose ) &
                write(error_unit,*) 'Flat-frame statistics: mean=', &
                flat_mean,'+-',flat_err

           if( flat_mean < epsilon(flat_mean) ) &
                stop 'Suspicious value of mean of flat-field.'
        end if

     end if

     if( key == 'BIAS' ) then

        read(val,*) biasname
        if( verbose ) write(error_unit,'(a)',advance="no") &
             "Bias frame: "//trim(biasname)//", "

        allocate(biasfits)
        call biasfits%Load(biasname,keys)
        if( .not. biasfits%status ) stop 'Failed to load bias frame.'

        if( verbose ) write(error_unit,'(a,1pg0.3,a,0pf0.1)') &
             ' exp.time[s] = ',biasfits%exptime,', T[degC] = ',biasfits%temper
     end if

     if( key == 'DARK' ) then

        read(val,*) darkname

        if( verbose ) write(error_unit,'(a)',advance="no") &
             "Dark frame: "//trim(darkname)//", "

        allocate(darkfits)
        call darkfits%Load(darkname,keys)
        if( .not. darkfits%status ) stop 'Failed to load dark frame.'

        if( verbose ) write(error_unit,'(a,1pg0.3,a,0pf0.1)') &
             ' exp.time[s] = ',darkfits%exptime,', T[degC] = ',darkfits%temper

        if( .not. darkfits%exptime_set .and. verbose ) &
             write(error_unit,*) "Warning: Exposure time for dark is undefined."

        if( darkfits%temper < -273 .and. verbose ) &
             write(error_unit,*) "Warning: Temperature of dark is undefined."

     end if

     if( key == 'XDARK' ) then
        read(val,*) xdark
     end if

     if( key == 'MASK' ) then

        read(val,*) maskname
        if( verbose ) write(error_unit,*) "Mask frame: ",trim(maskname)

        allocate(maskfits)
        call maskfits%Load(maskname)
        if( .not. maskfits%status ) stop 'Failed to load the mask frame.'

     end if

     if( key == 'XMASK' ) then
        read(val,*) tmask
     end if

     if( key == 'BOX' ) then
        read(val,*) box
     end if

     if( key == 'FILE' ) then

        read(val,*) sciname,output
        ex = corrector(sciname,output)
        exitus = exitus .and. ex

     end if

  end do

  if( gain_warning ) write(error_unit,*) &
       "Warning: Gain is unset for one or more frames (use -gain)."

  if( exitus ) then
     stop 0
  else
     stop 'An error occurred during phcorr session.'
  end if

contains

  logical function corrector(sciname,output)

    character(len=*), parameter :: phid = 'PHCORR'

    character(len=*), intent(in) :: sciname, output
    character(len=FLEN_CARD) :: buf
    character(len=4*FLEN_FILENAME) :: flattext, darktext, biastext
    real, dimension(:,:), allocatable :: FLAT, BIAS, DARK, MASK, OUT, &
         DFLAT, DBIAS, DDARK, DOUT
    type(CorrFits) :: scifits
    type(fitsfiles) :: fits, cfits
    character(len=80) :: msg
    integer :: stat,status,hdutype,hdunum,chdu
    real :: t, xerr, xmask, saturate, gain, maxout
    integer :: n, m

    corrector = .false.
    call scifits%Load(sciname,keys)
    if( .not. scifits%status ) then
       write(error_unit,*) &
            "Warning: Failed to read `",trim(sciname),"'. Skippy."
       return
    end if

    if( gain_set ) then
       gain = gain_user
    else
       if( scifits%gain_set ) then
          gain = scifits%gain
       else
          gain_warning = .true.
          gain = 1
       end if
    end if

    if( verbose ) &
         write(error_unit,'(1x,f0.2,a)',advance="no") gain,' * ('//trim(sciname)

    if( .not. (gain > 0) ) then
       write(error_unit,*) "Warning: assertion gain > 0 unsatisfied. Skip."
       return
    end if

    n = scifits%naxes(1)
    m = scifits%naxes(2)
    allocate(OUT(n,m),DOUT(n,m),FLAT(n,m),DFLAT(n,m),BIAS(n,m),DBIAS(n,m), &
         DARK(n,m),DDARK(n,m),MASK(n,m),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) trim(msg)
       error stop 'Insufficient memory.'
    end if

    FLAT = 1.0
    DFLAT = 0.0
    BIAS = 0.0
    DBIAS = 0.0
    DARK = 0.0
    DDARK = 0.0

    if( allocated(flatfits) ) then
       if( .not. all(flatfits%naxes == scifits%naxes) )then
          write(error_unit,*) &
               "Warning: Flat-field size does not match corrected frame."
          return
       end if

       if( verbose .and. flatfits%filter /= '' .and. scifits%filter /= '' )then
          if( flatfits%filter /= scifits%filter ) &
               write(error_unit,*) "Warning: filters does not match."
       end if

       FLAT =  flatfits%image / flat_mean
       DFLAT = flatfits%imgerr / flat_mean

    endif

    if( allocated(biasfits) ) then
       if( .not. all(biasfits%naxes == scifits%naxes) )then
          write(error_unit,*) &
               "Warning: Frame and bias sizes does not match. Skipping."
          return
       end if
       BIAS = biasfits%image
       DBIAS = biasfits%imgerr

    endif

    if( allocated(maskfits) ) then
       if( .not. all(maskfits%naxes == scifits%naxes) )then
          write(error_unit,*) &
               "Warning: Frame and mask sizes does not match. Skipping."
          return
       end if
    endif

    if( allocated(darkfits) ) then
       if( .not. all(darkfits%naxes == scifits%naxes) )then
          write(error_unit,*) &
               "Warning: Frame and dark sizes does not match. Skipping."
          return
       end if

       if( verbose .and. darkfits%temper > -273.0 .and. &
            scifits%temper > -273.0 )then
          if( abs(darkfits%temper - scifits%temper) > tol_temperat ) &
               write(error_unit,*) &
               "Warning: Temperature difference limit reached."
       end if

       if( xdark > 0.0 ) then
          t = xdark
       else if( darkfits%exptime_set .and. scifits%exptime_set .and. &
            darkfits%exptime > 0 .and. scifits%exptime > 0 ) then
          t = scifits%exptime / darkfits%exptime
       else
          t = 1
       end if

       DARK = darkfits%image
       DDARK = darkfits%imgerr

    endif

    if( verbose ) then

       flattext = ''
       biastext = ''
       darktext = ''

       if( flatname /= '' ) write(flattext,'(3a,1pg0.6,a)') &
            '/ (',trim(flatname),'/',flat_mean,')'

       if( biasname /= '' ) &
            biastext = " - "//trim(biasname)

       if( darkname /= '' ) &
            write(darktext,'(a,f0.3,2a)') ' - ',t,'*',trim(darkname)

       write(error_unit,'(a)',advance="no") &
            trim(darktext)//trim(biastext)//') '//trim(flattext)//' ='
    end if

    ! the corrections, we are sure that FLAT > 0
    where( FLAT > 0 )
       OUT = gain*(scifits%image - (t*DARK + BIAS)) / FLAT
    elsewhere
       OUT = gain*(scifits%image - (t*DARK + BIAS))
    end where
    where( FLAT > 0 .and. OUT > 0 )
       DOUT = sqrt(OUT + gain**2*(t**2*DDARK**2 + DBIAS**2))
       DOUT = abs(OUT)*sqrt(DOUT**2/OUT**2 + DFLAT**2/FLAT**2)
    elsewhere
       ! defective pixels
       OUT = 0
       DOUT = 1
    end where
    ! YES, this small piece of code is the full correction!!!
    ! All everything is just a practise in reading and writing
    ! of FITS files.

    ! masking
    if( allocated(maskfits) ) then

       MASK = maskfits%image

       if( tmask == "MEAN" .or. tmask == "MEDIAN" ) then
          ! median of the image
          call rmean(pack(OUT,OUT>0),xmask,xerr)
          if( verbose ) write(error_unit,*) 'Mask frame statistics: mean=',&
               xmask,'+-',xerr
       else ! if( tmask == "ZERO" ) then
          xmask = 0
          xerr = 0
       end if

       where( MASK < epsilon(MASK) )
          OUT = xmask
          DOUT = xerr
       end where

       if( tmask == 'MEDIAN' ) then

          block
            integer :: i,j,h,i1,i2,j1,j2
            h = min(box / 2, 1)

            do i = 1, size(MASK,1)
               do j = 1, size(MASK,2)
                  if( MASK(i,j) < epsilon(MASK) ) then
                     i1 = max(1,i-h)
                     i2 = min(i+h,size(MASK,1))
                     j1 = max(1,j-h)
                     j2 = min(j+h,size(MASK,2))
                     if( count(MASK(i1:i2,j1:j2) > 0) > 0 ) then
                        call rmean(pack(OUT(i1:i2,j1:j2), &
                             MASK(i1:i2,j1:j2) > 0),OUT(i,j),DOUT(i,j))
                     end if
                  end if
               end do
            end do
          end block
       end if

    end if

    ! cut-off negative values
!    where( OUT < 0 )
!       OUT = 0
!    end where

    ! write out corrected image
    status = 0
    call fits_open_image(fits,sciname,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) 'Error: failed to read the file `',trim(sciname),"'."
       corrector = .false.
       return
    end if

    call fits_create_scratch(cfits,status)
    call fits_get_num_hdus(fits,hdunum,status)
    if( status /= 0 ) goto 666

    block
      character(len=FLEN_VALUE) :: extname
      logical :: found
      found = .false.

      do chdu = 1, hdunum
         call fits_movabs_hdu(fits,chdu,hdutype,status)

         call fits_write_errmark
         call fits_read_key(fits,'EXTNAME',extname,status)
         if( status == FITS_KEYWORD_NOT_FOUND ) then
            call fits_clear_errmark
            status = 0
            extname = ''
         end if

         ! we are looking for the very first IMAGE HDU to apply the corrections
         if( .not. found .and. hdutype == FITS_IMAGE_HDU ) then
            found = .true.

            call fits_copy_header(fits,cfits,status)

            call fits_update_key(cfits,'BITPIX',bitpix,'',status)
            if( bitpix > 0 ) then
               maxout = 2.0**bitpix - 1
               OUT = max(0.0,min(OUT,maxout))
               DOUT = max(0.0,min(DOUT,maxout))
            else
               call fits_write_errmark
               call fits_delete_key(cfits,'BSCALE',status)
               call fits_delete_key(cfits,'BZERO',status)
               if( status == FITS_KEYWORD_NOT_FOUND ) then
                  call fits_clear_errmark
                  status = 0
               end if
            end if

            if( scifits%saturate_set ) then
               saturate = scifits%get_saturate(gain)
               call fits_update_key(cfits,keys(4),saturate,-5, &
                    '[counts] saturation level',status)
            end if

            ! set units of images
            if( gain_set .or. scifits%gain_set ) then
               call fits_update_key(cfits,FITS_KEY_BUNIT,'COUNTS', &
                    'captured electrons',status)
               call fits_update_key(cfits,keys(6),gain,5, &
                    '[e-/ADU] amplifier gain used for conversion',status)
               write(buf,'(g0.3)') gain
               call fits_write_history(cfits,phid//" gain: "//trim(buf),status)
            else
               call fits_update_key(cfits,FITS_KEY_BUNIT,'ADU', &
                    'values directly provided by camera',status)
            end if

            if( flatname /= '' ) then
               write(buf,'(1pg0.6)') flat_mean
               call fits_write_history(cfits,phid//" flat-field: '" //  &
                    trim(flatname)//"' / "//trim(buf),status)
            end if

            if( darkname /= '' ) then
               write(buf,'(f0.5)') t
               call fits_write_history(cfits,phid//" dark: '"//trim(darkname) &
                    //"' * "//trim(buf),status)
            end if

            if( biasname /= '' ) then
               call fits_write_history(cfits,phid//" bias: '"//trim(biasname)//"'",&
                    status)
            end if

            if( maskname /= '' ) then
               call fits_write_history(cfits,phid//" mask: '"//trim(maskname)//"'",&
                    status)
            end if

            call fits_update_key(cfits,FITS_KEY_CREATOR,FITS_VALUE_CREATOR, &
                 FITS_COM_CREATOR,status)
            call fits_write_comment(cfits,MUNIPACK_VERSION,status)

            ! corrected data
            call fits_write_image(cfits,0,OUT,status)

         else if( extname == EXT_STDERR ) then
            ! skip all previous std. error images
            continue

         else
            ! other HDUs are just copied
            call fits_copy_hdu(fits,cfits,0,status)
         end if

         if( status /= 0 ) goto 666
      end do
    end block

    ! stderr
    call fits_insert_img(cfits,bitpix,scifits%naxis,scifits%naxes,status)
    call fits_update_key(cfits,'EXTNAME',EXT_STDERR,'',status)
    call fits_write_comment(cfits,'The estimation of standard error.',status)
    call fits_write_image(cfits,0,DOUT,status)

    if( verbose ) write(error_unit,*) trim(output)

666 continue

    if( status == 0 ) then
       if( fits_file_exist(output) .and. overwrite ) &
            call fits_file_delete(output)
       call fits_file_duplicate(cfits,output,status)
    end if

    call fits_close_file(fits,status)
    call fits_delete_file(cfits,status)
    call fits_report_error(error_unit,status)

    corrector = status == 0

  end function corrector

end program phcorr

!
! Cross-match
!
! Copyright © 2013 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module crossmatch

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

contains

  subroutine join(ra1,dec1,ra2,dec2,tol,ftol,idx)

    real(dbl), dimension(:), intent(in) :: ra1, dec1, ra2, dec2
    real(dbl), intent(in) :: tol, ftol
    integer, dimension(:,:), intent(out) :: idx
    integer :: i,j,jmin
    real(dbl) :: r,rmin

    idx = 0
    
    do i = 1,size(ra2)
       rmin = tol
       jmin = 0
       do j = 1,size(ra1)
          r = spmetr(ra1(j),dec1(j),ra2(i),dec2(i))
          if( r < rmin )then
             rmin = r
             jmin = j
          end if
       end do

       if( jmin > 0 ) then
          idx(1,i) = jmin
          idx(2,jmin) = i
       end if

    end do

  end subroutine join

  function spmetr(a1,d1,a2,d2)

    ! angular distance in degrees

    real(dbl), parameter :: rad = 57.295779513082322865_dbl
    real(dbl) :: spmetr
    real(dbl), intent(in) :: a1,d1,a2,d2
    real(dbl) :: da,dd,sind
    
    da = a1 - a2
    dd = d1 - d2
    if( abs(da) > 10.0 .and. abs(dd) > 10.0 ) then

       sind = sin(d1/rad)*sin(d2/rad) + cos(d1/rad)*cos(d2/rad)*cos((a1 - a2)/rad)
       spmetr = rad*acos(min(sind,1.0_dbl))

    else
       ! for small angles, haversine formula is used
       ! http://en.wikipedia.org/wiki/Great-circle_distance
       da = da / rad
       dd = dd / rad
       sind = sqrt(sin(dd/2)**2 + cos(d1/rad)*cos(d2/rad)*sin(da/2)**2)
       spmetr = 2*rad*asin(min(sind,1.0_dbl))

    end if

  end function spmetr



end module crossmatch

!
!  Galaxies
!
!  Copyright © 2021-2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!


module artgalaxy

  use iso_fortran_env

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

  type galtype
     character(len=80) :: type
     real(dbl) :: alpha,delta,Reff,mueff,PA,e,sersic
     ! mueff .. effective surface magnitude at Reff in [mag/arcsec2],
     !          determine effective ieff in counts
     ! Reff .. effective radius [deg]
     ! PA ... position angle [deg, o'clock orientation]
     ! e .. eccentricity
     ! sersic .. Sersic exponent in R**(1/n)
  end type galtype

contains

  subroutine galaxy(galcat,crval,crpix,scale,angle,exptime,area,qe, &
       phsystable,phsystem,filter,sky)

    use phsysfits
    use photoconv
    use astrotrafo

    character(len=*), intent(in) :: galcat,filter, phsystable, phsystem
    real(dbl), dimension(:), intent(in) :: crval,crpix
    real(dbl), intent(in) :: scale,angle,exptime,area,qe
    real(dbl), dimension(:,:), intent(in out) :: sky

    type(AstroTrafoProj) :: t
    type(type_phsys) :: phsys
    type(galtype), dimension(:), allocatable :: gs
    integer :: i

    call phselect(phsystable,phsystem,phsys)
    call trafo_init(t,'GNOMONIC',crval(1),crval(2),crpix(1),crpix(2),&
         scale=scale,rot=angle)

    call load_galaxy(galcat,gs)

    do i = 1, size(gs)

       if( gs(i)%type == 'ELLIPTICAL' ) then
          call elliptical(gs(i),t,phsys,scale,exptime,area,qe,filter,sky)
       else
          write(error_unit,*) 'Warning: Unsupported galaxy type.'
       end if
    end do


  end subroutine galaxy

  subroutine elliptical(g,t,phsys,scale,exptime,area,qe,filter,sky)

    use phsysfits
    use photoconv
    use astrotrafo

    type(galtype), intent(in) :: g
    type(AstroTrafoProj), intent(in) :: t
    type(type_phsys), intent(in) :: phsys
    character(len=*), intent(in) :: filter
    real(dbl), intent(in) :: scale,exptime,area,qe
    real(dbl), dimension(:,:), intent(in out) :: sky

    real(dbl), parameter :: rad = 57.2958
    real(dbl) :: x,y,xc,yc,c,s,u,v,a,b,reff,n,beff,r,q,ceff, dmag
    real(dbl), dimension(1) :: ct, dct
    integer :: i,j

    call trafo(t,g%alpha,g%delta,xc,yc)
    reff = g%reff / scale
    c = cos(g%PA / rad)
    s = sin(g%PA / rad)
    a = 1
    b = a*sqrt(1 - g%E**2)

    dmag = 9.999
    call phsysmagph1(phsys,filter,[g%mueff],[dmag],ct,dct)
    ceff = ct(1)
    ceff = ceff * exptime * area * qe * (scale*3600)**2

    n = g%sersic
    beff = 2*n - 1.0/3.0 + (9.8765e-3 + (1.8e-3 + (1.14e-4 - 7e-5/n)/n)/n)/n

    do i = 1, size(sky,1)
       do j = 1, size(sky,2)
          x = i - xc
          y = j - yc
          u = a*(c*x - s*y)
          v = b*(s*x + c*y)
          r = hypot(u,v)
          q = ceff * exp(-beff*((r/reff)**(1.0/n) - 1))
          sky(i,j) = sky(i,j) + q
       end do
    end do

  end subroutine elliptical

  subroutine load_galaxy(filename,gs)

    use titsio

    character(len=*), intent(in) :: filename
    type(galtype), dimension(:), allocatable, intent(out) :: gs

    real(dbl), parameter :: nullval = 99.99999

    character(len=FLEN_VALUE) :: extname
    character(len=FLEN_KEYWORD), dimension(7) :: labels
    real(dbl), dimension(:), allocatable :: alpha,delta,mueff,reff,pa,e,sersic
    integer :: nrows, srows, status, i, l, frow
    integer, dimension(size(labels)) :: cols
    logical :: anyf
    type(fitsfiles) :: fits

    labels = [ character(len=FLEN_KEYWORD) :: &
         'RAJ2000', 'DEJ2000', 'MUEFF', 'REFF', 'PA', 'E', 'SERSIC' ]
    status = 0

    ! open and move to a table extension
    call fits_open_table(fits,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) &
            'Error: unable to read a table in the file `',trim(filename),"'."
       stop 'load_galaxy'
    end if

    call fits_get_num_rows(fits,nrows,status)
    if( status /= 0 ) goto 666
    if( nrows == 0 ) stop 'load_galaxy: empty table.'

    ! define reference frame and identification of catalogue
    call fits_read_key(fits,'EXTNAME',extname,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       extname = ''
       status = 0
    end if

    if( extname /= 'ELLIPTICAL' ) stop 'load_galaxy: unknown type galaxy requested.'

    ! find columns by labels
    do i = 1, size(labels)
       call fits_get_colnum(fits,.true.,labels(i),cols(i),status)
    end do
    if( status /= 0 ) goto 666

    allocate(alpha(nrows),delta(nrows),mueff(nrows),reff(nrows),pa(nrows),&
         e(nrows),sersic(nrows))

    call fits_get_rowsize(fits,srows,status)
    do i = 1, nrows, srows
       frow = i
       l = min(i+srows,nrows)

       call fits_read_col(fits,cols(1),frow,nullval,alpha(i:l),anyf,status)
       call fits_read_col(fits,cols(2),frow,nullval,delta(i:l),anyf,status)
       call fits_read_col(fits,cols(3),frow,nullval,mueff(i:l),anyf,status)
       call fits_read_col(fits,cols(4),frow,nullval,reff(i:l),anyf,status)
       call fits_read_col(fits,cols(5),frow,nullval,pa(i:l),anyf,status)
       call fits_read_col(fits,cols(6),frow,nullval,e(i:l),anyf,status)
       call fits_read_col(fits,cols(7),frow,nullval,sersic(i:l),anyf,status)
       if( status /= 0 ) goto 666
    end do

    call fits_close_file(fits,status)

    allocate(gs(nrows))
    do i = 1, nrows
       gs(i)%type = extname
       gs(i)%alpha = alpha(i)
       gs(i)%delta = delta(i)
       gs(i)%mueff = mueff(i)
       gs(i)%reff = reff(i)
       gs(i)%pa = pa(i)
       gs(i)%e = e(i)
       gs(i)%sersic = sersic(i)
    end do
    return

666 continue

    call fits_close_file(fits,status)
    call fits_report_error(error_unit,status)

    stop 'load_galaxy'

  end subroutine load_galaxy

end module artgalaxy

!
!     Find  - Search stars on image
!     Copyright (C) 1999, 2010, 2012, 2016, 2018-9 Filip Hroch,
!                   Masaryk University
!     Copyright (C) 1991 P.B. Stetson, Dominon Astrophysical Observatory
!
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!
! 1999, september ..  to F90, no a disk scratch file+other many changes
! 1999, november  ..  rewriting completed
!
!====================================================================
!
!  The original code of DAOPHOT is absolutelly impressive.
!  I just try to improve it.
!

! TODO:
!  * to double precision


module mdaofind

  logical, parameter, private :: debug = .false.

  private :: centres, moments

contains

  subroutine daofind (d, verbose, plog, hibad, skymod, skysig,  &
       fwhm, lothresh, threshold, shrplo, shrphi, rndlo, rndhi, readns, &
       nstar, lobad, hmin )

  implicit none

  real, dimension(:,:), intent(in) :: d
  logical, intent(in) :: verbose, plog
  real, intent(in) :: hibad, fwhm, shrplo, shrphi, rndlo, rndhi, &
       readns, lothresh, threshold, skymod, skysig
  integer, intent(out) :: nstar
  real, intent(out) :: lobad, hmin

  ! Gain: DAOPHOT scales data on-the-fly by the parameter,
  ! while Munipack assumes that the data has already gain correction done.
  real, parameter :: phpadu = 1.0

!
!=======================================================================
!
! This subroutine is supposed to find small, positive brightness
! perturbations in a two-dimensional image.
!
!                OFFICIAL DAO VERSION:  1991 April 18
!
! First, FIND reads in several rows' worth of image data.  For each
! pixel it computes a least-squares fit of an analytic Gaussian function
! to a roughly circular array of pixels surrounding the pixel in
! question.  The overall bias level (sky brightness in that vicinity)
! is removed by the calculation and, since the function is
! symmetric about the central pixel, a smooth gradient in the sky
! brightness cancels out exactly.  This means that the user does
! not have to specify an absolute brightness threshold for star
! detection, and if the mean background brightness varies over the
! frame, to the extent that the variations are smooth and large-scale,
! to first order they will have no effect on the detection limit.
!    The derived peak heights of the Gaussian functions are stored in a
! scratch disk image file.  Later they will be read back in, and local
! maxima in the peak values will be sought.  After undergoing a few
! tests designed to select against bad pixels and bad columns, these
! local maxima will be considered to be astronomical objects, better
! image centroids will be computed, and the objects will be assigned
! sequential ID numbers and will be written to a disk data file.
!    The user is asked to specify a "lowest good data-value"-- any pixel
! whose value is found to fall below this level or above the HIBAD
! value which is passed as an argument is presumed bad, and
! is ignored during all computations in this routine.  The numerical
! value of this bad pixel ceiling will be written out in the header
! of the output data file, and will be used in other DAOPHOT routines
! as well.
!
! Arguments
!
!     FWHM (INPUT) is the estimated full width at half-maximum of the
!          objects for which the algorithm is to be optimized.  It will
!          be used (a) to determine the size of the roughly circular
!          array which will be used to compute the brightness
!          enhancements and to define local maxima, and (b) to define
!          the coefficient assigned to each pixel in the computation
!          of the brightness enhancements.
!
!    WATCH (INPUT) governs whether information relating to the progress
!          of the star-finding is to be typed on the terminal screen
!          during execution.
!
! SHRPLO, SHRPHI (INPUT) are numerical cutoffs on the image-sharpness
!          statistic, designed to eliminate brightness maxima which
!          appear to be due to bad pixels, rather than to astronomical
!          objects.
!
! RNDLO, RNDHI (INPUT) are numerical cutoffs on the image-roundness
!          statistic, designed to eliminate brightness maxima which
!          appear to be due to bad rows or columns, rather than to
!          astronomical objects.
!
! HIBAD  is the highest valid data-value-- the level above which the
!          CCD chip is presumed to be non-linear.
!
! All of the above arguments are user-definable optional parameters,
! whose numerical values may be changed by a DEFAULT.OPT file, or by
! the OPTION command.  (WATCH may also the set by the MONITOR and
! NOMONITOR commands.)
!
!=======================================================================
!
! Parameters:
!
!!!!!  integer :: maxsky, nopt
!
! MAXBOX is the length of the side of the largest subarray that you plan
!        to need for computing the brightness enhancement in each pixel.
! Warning: maxbox is no more need, replaced by dynamic allocation of arrays
!
! MAX/MAXBOX is the length in the x-direction of the largest picture
!        you can try to reduce.
!
!-----------------------------------------------------------------------
!
! DIMENSIONS
!
! Arrays
!

!  real, dimension(size(d,1),size(d,2)) :: h
  real, dimension(:,:), allocatable :: h, g
!  real, dimension(:), allocatable :: sh
! data(2), opt(nopt)
!  real, dimension(:,:), allocatable :: g
  logical, dimension(:,:), allocatable :: skip
!
! Variables
!
!!!!  character(len=*) :: coofil
!!!!!  character(len=5) :: line
!!!!  real pixels, radius, fwhm, sigsq, rsq, relerr, skylvl, temp
!!!!  real hmin, lobad, hibad, watch, p, datum, height, denom, sgop
  real :: pixels, radius, sigsq, rsq, relerr, skylvl, temp
  real :: p, datum, height, denom, sgop
!!!  real :: lobad, hmin, p, datum, height, denom, sgop
  real :: sharp, round!, shrplo, shrphi, rndlo, rndhi
  real :: sumg, sumgsq, sumgd, sumd, sg, sgsq, sgd, sd, wt, hx, hy
  real :: dgdx, sdgdx, sdgdxs, sddgdx, sgdgdx
  real :: xcen, ycen, dx, dy, shape, ecc, incl
!!!!  real xcen, ycen, dx, dy, phpadu, readns, skymod, skymn, skymed
  integer :: nhalf, nbox, middle, lastcl, lastro, ncol, nrow, jsq
!!!  integer :: istat, nstar
  integer :: i, j, n, ix, iy, jx, jy, kx, ky
  logical :: inside, inrange

!!!!!!  hibad = opt(4)
!!!!!!  fwhm = opt(5)
!!!!!!  shrplo = opt(7)
!!!!!!  shrphi = opt(8)
!!!!!!  rndlo = opt(9)
!!!!!!  rndhi = opt(10)
!!!!!!  watch = opt(11)
!!!!!!

!write(*,*) hibad,fwhm,shrplo,shrphi,rndlo,rndhi

!-----------------------------------------------------------------------
!
! section 1
!
! Setup the necessary variables and arrays, particularly the constants
! to be used in the convolutions.
!
! The brightness enhancement will be computed on the basis only of those
! pixels within 1.5 sigma = 0.637*FWHM of the central pixel.  However,
! in the limit of infinitely small FWHM the brightness enhancement will
! be based on no fewer than the following subarray of pixels:
!
!                                .
!                                .
!                                .
!
!                          -  -  +  -  -
!                          -  +  +  +  -
!                 .  .  .  +  +  X  +  +  .  .  .
!                          -  +  +  +  -
!                          -  -  +  -  -
!                                .
!                                .
!                                .
!
! This represents a 5 x 5 subarray taken out of the original picture.
! The X represents the pixel for which the brightness enhancement is
! currently being computed and the +'s represent other pixels included
! in the calculation; the -'s and all pixels lying outside this 5 x 5
! subarray will not be used in computing the brightness enhancement in
! the central pixel.  In the limit of infinitely large FWHM, only those
! pixels lying within a MAXBOX x MAXBOX square subarray centered on the
! pixel in question will be used in computing its brightness
! enhancement.
!
! Compute the size of the subarray needed.  The radius of the circular
! area desired is MAX (2.0, 0.637*FWHM), so the distance from the
! central pixel to the center of an edge pixel is the integer smaller
! than this.
!
  radius = max(2.001, 0.637*fwhm)
  nhalf = int(radius)
  nbox = 2*nhalf + 1                ! length of the side of the subarray
  middle = nhalf + 1

  allocate(g(nbox,nbox),skip(nbox,nbox))

  ncol = size(d,1)
  nrow = size(d,2)

!
! Just for future reference--
!
! MIDDLE is the index of the central pixel of the box in both x and y,
!        where the corner of the box is considered to be at (1,1).
!
!  NHALF is the number of pixels between the central pixel (exclusive)
!        and the edge of the box (inclusive).  For example, if NBOX = 7,
!        MIDDLE = 4 and NHALF = 3.  Note that all the way around the
!        picture being reduced there will be a border NHALF pixels wide
!        where define brightness enhancements can't be defined, because
!        the box would extend beyond the boundaries of the frame.  We
!        will thus be able to compute brightness enhancements only for
!        MIDDLE <= x <= LASTCL,   MIDDLE <= y <= LASTRO, where...
!
  lastro = nrow - nhalf
  lastcl = ncol - nhalf
!
!-----------------------------------------------------------------------
!
! Compute the values of a bivariate circular Gaussian function with
! unit height and the specified value of the FWHM.
!
  sigsq = (fwhm/2.35482)**2
  radius = radius**2
!
! RADIUS is now the square of the radius of the circle to be used.
!
!-----------------------------------------------------------------------
!
! EXPLANATION:
!
! The approach taken by this star-finding algorithm is defined by this
! question:  "Assuming for the moment that there is a star with a
! Gaussian light distribution centered in the central pixel of this
! subarray, then how bright is it?"  Having answered that question for
! every pixel MIDDLE <= x <= LASTCL, MIDDLE <= y <= LASTRO, we will
! then go through the picture looking for places where the numerical
! answer to the question achieves local maxima.  For the region around
! each pixel, then, we want to solve this equation via least squares:
!
!                     D(i,j) = h * G(i,j) + s
!
! where D is the observed brightness in some pixel of the subarray, G
! is the value of the Gaussian function of unit central height in the
! in that pixel
!
! G(i,j) = exp{[(i-MIDDLE)**2 + (j-MIDDLE)**2]/(2 * sigma**2)}, for
!
!                      (i-MIDDLE)**2 + (j-MIDDLE)**2 < (1.5 * sigma)**2
!
! (the center of the subarray has relative coordinates i = j = MIDDLE).
!
!      The parameters  h  (= central brightness of the hypothetical
! star centered in the central pixel of the subarray), and s (= the
! local sky background) are unknowns.  The least-squares solution
! for this system of equations is given by
!
!         [G*D] - [G] [D]/n
!    h =  ----------------- ,         s = {[D] - h [G]}/n
!         [G**2] - [G]**2/n
!
! where the square brackets denote summation (Gauss's notation).
!
! For use in solving for the many values of  h, we will save the
! array G(i,j) (= G(I,J)) and the constants [G] (= SUMG, meaning
! "sum of the Gaussian"), [G**2] (= SUMGSQ), n (= PIXELS); also the
! denominator of the fraction for  h (= DENOM), and [G]/n (= SGOP).
! [G*D] and [D] will have to be computed each time.
!
! It is possible to show that each of these least-squares problems can
! be reduced to a linear function of the image data D(i,j), and that the
! entire ensemble of least-squares problems is arithmetically identical
! with a convolution of the original image data with a truncated,
! lowered Gaussian function.  Hence, I will occasionally refer to the
! generation of the array of values h(i,j) as a "convolution."
!
!-----------------------------------------------------------------------
!
! Loop over the pixels in the subarray, computing the value of the
! Gaussian function G(i,j) at each point.  Also, accumulate the sum of
! the values of the Gaussian and the sum of the squares of the values
! of the Gaussian.  These will be held for later use in the convolution.
!
  sumg = 0.0
  sumgsq = 0.0
  pixels = 0.0
  do j = 1, nbox
     jsq = (j - middle)**2
     do i = 1, nbox
        rsq = (i - middle)**2 + jsq
        g(i,j) = exp(-0.5*rsq/sigsq)
        if (rsq <= radius) then
           skip(i,j) = .false.
           sumg = sumg + g(i,j)
           sumgsq = sumgsq + g(i,j)**2
           pixels = pixels + 1.0
        else
           skip(i,j)= .true.
        end if
     end do
  end do
  denom = sumgsq - (sumg**2)/pixels
  sgop = sumg/pixels
!
! At this point the two-dimensional array G(I,J) contains the values of
! a unit Gaussian function, with the input value of FWHM, at each point
! in the SQUARE subarray.
!
! SUMG   contains the sum of the values of the Gaussian function over
!        the CIRCULAR area which will be used in the convolution.
!
! SUMGSQ contains the sum of the squares of the values of the Gaussian
!        function over the CIRCULAR area which will be used in the
!        convolution.
!
! PIXELS contains the number of pixels in the CIRCULAR area which will
!        be used in the convolution.
!
! DENOM  contains the denominator of the fraction defining  h.
!
! SGOP   contains [G]/n
!
! Using our knowledge of least squares, we can compute the standard
! error of the coefficient  h  in terms of the standard error of the
! brightness in a single pixel:
!
!      sigma**2(h) = sigma**2(1 pixel) / ([G**2] - [G]**2/n)
!
  relerr = 1.0/denom
  relerr = sqrt(relerr)
  !  call daosky(ncol, nrow, d, min(maxsky, (ncol*nrow)/3), opt(4), skymn, skymed, skymod, ix)
  !  call daosky(d,min(maxsky,(ncol*nrow)/3),verbose,hibad,skymod,skyerr,skysig)

!  if( ncol*nrow > maxsky ) then
!     n = 2
!  else
!     n = 1
!  end if
!  call daosky(d,n,verbose,hibad,skymod,skyerr,skysig)
!  write(*,*) skymod,skyerr,skysig,relerr

  if( verbose ) write (*,"(23X, 'Relative error = ', F5.2/)") relerr

!  if( abs(skymod) < epsilon(skymod) ) then
!     write(*,*) 'Zero sky standard deviations: defective frame(?).'
!     nstar = 0
!     return
!  end if

!
! Now ask the user for a star-detection threshold and a bad pixel
! ceiling.
!
!      call getdat ('Number of frames averaged, summed:', DATA, 2)
!!!!!  if (data(1) < 0.5 .or. data(2) < 0.5) return
!!!!!  readns = opt(1)**2*data(2)/data(1)
!!!!!  phpadu = opt(2)*data(1)

  if( threshold < epsilon(threshold) ) &
       stop 'Error in FIND: threshold > 0 assumption failed.'

  hmin = (phpadu*readns)**2 + skysig**2
  if( hmin > 0 ) then
     hmin = sqrt(hmin)
  else if( skymod > 0 ) then
     ! suitable for a test data without included Poisson noise
     hmin = sqrt(readns**2 + max(0.0,skymod)/phpadu) ! assuming: var(d)==mean(d)
  else
     hmin = sqrt(epsilon(hmin))
  end if
!  lobad = 0.1*nint(10.*(skymod - lothresh*hmin))
  lobad = max(0.0,skymod - lothresh*hmin)
!  write(*,*) 0.1*nint(10.*(skymod - lothresh*hmin)),max(0.0,skymod - lothresh*hmin)
!  hmin = 0.01*nint(100.*threshold*relerr*hmin)
!  write(*,*) skymod,lobad,hmin
  hmin = threshold*relerr*hmin
!  write(*,*) lobad,hmin

  ! simplified code:
!  hmin = sqrt(readns**2 + skysig**2) ! replacing skymod->skysig**2 is realiable
!  lobad = max(0.0,skymod - lothresh*hmin)
!  hmin = threshold*relerr*hmin
!  write(*,*) lobad,hmin,relerr
!!!!!  lobad = 0.1*nint(10.*(skymod - opt(3)*hmin))
!!!!!  hmin = 0.01*nint(100.*opt(6)*relerr*hmin)
!!!!!  readns = sqrt(readns)
!
! Later on, the threshold HMIN will be the minimum value of the local
! brightness enhancement that will be considered when searching for
! local maxima, and any pixel whose brightness value is less than LOBAD
! or greater than HIBAD will be ignored in the computations.
!
! Open the input and scratch disk files.
!
! Open output data file for newly-discovered stars.
!
!!!!!!  call outfil (3, coofil, istat)
!!!!!!  if (istat /= 0) then
!!!!!!     call stupid ('Error opening output file '//trim(coofil))
!!!!!!     return
!!!!!!  end if
!!!!!!  if (watch > 0.5) then
!!!!!!     call tblank
!!!!!!!     call ovrwrt('  Row', 1)
!!!!!!  end if
!!!!!!!
!-----------------------------------------------------------------------
!
! SECTION 2
!
! Read the raw image data in, holding only a few rows' worth of data in
! memory at any one time.  Convolve the data with the appropriate
! Gaussian function, and write the resulting numbers into the scratch
! disk picture.
!
! .... (censored :-)
!
! The cylinder buffer D now contains the actual image data for the
! first NHALF rows of the picture.  We will soon create the file
! containing the derived values of  h  (see above) one row at a time.
!
! Now we will step through the picture row by row. JY remembers which
! row in the big picture we are working on.  For each row JY, the
! convolved data will be accumulated in the vector H(i,2), and then
! written into the JY-th row of the scratch picture.
!
!      jy = 0
! 2020 jy = jy + 1                              ! Increment image-row pointer
!      if (jy > nrow) go to 2100         ! Have we reached the bottom?
!
! ... (censored :-)
! Note that at any given time we have only NBOX rows of the original
! image in memory, contained in the cylinder buffer D(i,j),
! j = 1, ..., NBOX, but not necessarily in that order.  For instance,
! if NBOX = 5, when JY = 1,
!
!      row:     1    2    3    4    5     of G is to be fitted to
!
!      row:     *    *    1    2    3     of the original picture which
!                                         is contained in
!      row:     1    2    3    4    5     of D.
!
! When row 1 of the picture is done, JY is set to 2, and row 4
! of the original picture is read into row 1 of the cylinder buffer,
! D, overwriting the null values which we put there before.
! Hence, when JY = 2,
!
!      row:     1    2    3    4    5     of G is to be fitted to
!
!      row:     *    1    2    3    4     of the original picture which
!                                         is contained in
!      row:     2    3    4    5    1     of D.
!
! As a final example, consider the situation for JY = 7:
!
!      row:     1    2    3    4    5     of G is to be fitted to
!
!      row:     5    6    7    8    9     of the original picture which
!                                         is contained in
!      row:     2    3    4    5    1     of D.
!
! In other words:
!
!      row:     1    2    3    4    5     variable J
!
!      row:     5    6    7    8    9     variable JY
!
!      row:     2    3    4    5    1     vector JCYLN(J)
!
! The cylinder buffer, D, just rolls down through the picture like a
! caterpillar tread, dropping off rows of data when they are no longer
! necessary and picking up new ones in their place.  The data are
! handled in this way (a) to minimize the amount of memory required,
! by storing only those rows that are immediately wanted, consistent
! with (b) minimizing the number of data transfers.  Now, for the
! CURRENT value of JY, which row of the cylinder buffer is to be fitted
! to each row of G?  The answers will be contained in the vector
! JCYLN.
!
! JCYLN(MIDDLE) is the row in the cylinder buffer where we will find
! the data for row JY of the big picture, which is to be fitted to row
! MIDDLE of G.  Similarly, JCYLN returns the position in the cylinder
! buffer of the row to be fitted to the J-th row of G
! (J = 1, ..., NBOX).
!
! Now that this is all straight, read in the data for row JY+NHALF
! (overwriting the data for row JY-NHALF-1, which is no longer needed).
!
!      do j = 1, nbox
!         iy = jy + (j - middle)
!
! iy is that row of the big picture which is to be matched up against
! row J of the Gaussian function, during the convolution of this
! row JY of the big picture.
!
! Which row of the cylinder buffer contains row IY of the big picture?
!
!         i = iy + nhalf
!
! i now represents the position that row IY of the big picture would
! have had in the cylinder buffer if the cylinder buffer were
! arbitrarily long, i.e. row 1 of the image in row 3 of D, row 2
! in row 4, row 3 in row 5, row 4 in row 6, ... in the examples
! above.  Now we wrap this around.
!
!         jcyln(j) = mod(i-1,nbox) + 1
!      end do
!
!      ly = jy+nhalf
!      if (ly >= nrow) then
!         call rdaray ('DATA', lx, ly, ncol, nrows, maxcol, d(1,jcyln(nbox)), istat)
!      else
!         k = jcyln(nbox)
!         do ix=1,ncol
!            d(ix,k) = -1.1e38
!         end do
!      end if
!
!      if (istat /= 0) then
!         call stupid ('Error reading image data from disk file.')
!         return
!      end if
!
! Compute the local brightness enhancement for each pixel in the row,
! The enhancement is computed from a circular region contained
! within an NBOX x NBOX array centered on the current pixel, using the
! array, G(I,J), and the constants SUMG, SUMGSQ, and PIXELS computed
! above.  (These constants will need to be modified if the circular
! region used in the calculation contains any bad pixels; we will use
! the variables SG, SGSQ, and P for temporary storage of these
! constants, and SGD and SD for the accumulation of [G*D] and [D] which
! are also needed.)
!

!  if( plog ) write(*,'(a)') "=FIND> Convolution ..."
  allocate(h(ncol,nrow))

  do jy = 1, nrow

     do jx = 1, ncol

        sgd = 0.0
        sd = 0.0
        sgsq = sumgsq
        sg = sumg
        p = pixels

        do  ix = jx - nhalf, jx + nhalf
           i = middle + (ix - jx)
           do  iy = jy - nhalf, jy + nhalf
              j = middle + (iy - jy)
              if ( .not. skip(i,j)) then
                 inside = (1 <= ix  .and. ix <= ncol ) .and. &
                      ( 1 <= iy  .and. iy <= nrow )
                 inrange = .false.
                 if( inside ) &
                      inrange = (lobad <= d(ix,iy) .and. d(ix,iy) <= hibad )
!                 if( ( 1 <= ix  .and. ix <= ncol ) .and. &
!                     ( 1 <= iy  .and. iy <= nrow ) ) then
                 !                    if( (lobad <= d(ix,iy) .and. d(ix,iy) <= hibad ) )then
!                 inrange = .true.
                 if( inside .and. inrange ) then
                       datum = d(ix,iy)
                       sgd = sgd + g(i,j)*datum
                       sd = sd + datum
!                    end if
                 else
                    sgsq = sgsq - g(i,j)**2
                    sg = sg - g(i,j)
                    p = p - 1.0
                 endif
              endif
           enddo
        enddo
!
! compute the central height of the best fitting Gaussian function,
! temporarily storing it in the variable, then putting it into array
! element H(JX, 2).
!
        if (p > 1.5) then
           if (p < pixels) then
              sgsq = sgsq - (sg**2)/p
              if (sgsq /= 0.0) then
                 sgd = (sgd - sg*sd/p)/sgsq
              else
                 sgd = 0.0
              end if
           else
              sgd = (sgd - sgop*sd)/denom
           end if
        else
           sgd = 0.0
        end if
        h(jx,jy) = sgd
     enddo !jx
!
! Write this newly-computed row of brightness enhancements to the
! scratch output picture.
!
!!!!!!      if (watch > 0.5) then
!!!!!!         write (line,"(I5)") jy
!!!!!!!         call ovrwrt (line(1:5), 2)
!!!!!!      end if
  enddo ! jy

!  write(*,*) h(50,136),lobad,hibad

  ! save convoluted image
!  if( debug ) then
!     i = 0
!     Call ftinit(26,'!/tmp/h.fits',1,i)
!     Call ftphps(26,-32,2,(/ncol,nrow/),i)
!     Call ftp2de(26,1,ncol,ncol,nrow,h,i)
!     call ftclos(26,i)
!  end if


!!!!!!  call ovrwrt (' ', 4)
!!!!!!!
! Later on, when we try to decide whether a local maximum represents
! a stellar profile or a delta function ( = bright bad pixel), we will
! compare the brightness of the central pixel to the average of the
! surrounding pixels.  To be ready for that, we here modify SKIP to
! skip over the central pixel, and set PIXELS equal to the number of
! pixels in the circular area not counting the central pixel.
!
  skip(middle,middle) = .true.
  pixels = pixels - 1.0

!  do i = 1,nbox
!     write(*,*) skip(i,:)
!  end do
!  stop 0
!
!-----------------------------------------------------------------------
!
! SECTION 3
!
! Read in both the convolved data from the scratch disk file and the raw
! data from the original picture.  Search for local maxima in the
! convolved brightness data.  When these are found, compute image-shape
! statistics from the raw data to eliminate non-stellar brightness
! enhancements (as well as possible) and estimate the position of the
! centroid of the brightness enhancement.
!
! 3000 continue
!
! Now the star search may begin.  The original image data will be read
! into the cylinder buffer D again, just as before.  At the same time,
! the brightness enhancements will be read from the scratch disk file
! into another cylinder buffer, H.  The brightness enhancements will
! then be searched for local maxima.  When these are found, functions
! of the original image data will be used to derive shape parameters
! designed to identify bad pixels and bad columns or rows.
!
!!!!!!  call wrhead (3, 1, ncol, nrow, 6, lobad, hibad, hmin, 0., phpadu, readns, 0.)
!!!!!!  if (watch > 0.5) then
!     call ovrwrt (' ', 4)
  if( verbose ) then
!     write (*,"(6X, '                              MAGS')" )
!     write (*,"(6X, '                              FROM ')")
     write (*,"(6X, '                             PEAK')")
     write (*,"(6X, '       STAR     X      Y     RATIO      SHARP    ROUND')")
  end if
!!!!!!!
! .... (censored :-)
!
! Now step through the picture row by row.  Again JY is the image-row
! counter.
!
  nstar = 0

  do jy = 1, nrow

!
! .... (censored :-)
!
!
! Now step across the row, pixel by pixel.
!
     jx = 1
     do
        height = h(jx,jy)
!
! sieve to locate a local maximum in the brightness enhancement.  To
! be a local maximum, the brightness enhancement in a given pixel must
! be above the threshold, and it must also be greater than the
! brightness enhancement of any pixel within a radius equal to
! 1.5 sigma.
!
        if (height < hmin) go to 3200
        do ix = jx - nhalf, jx + nhalf
           if ((1 <= ix) .and. (ix <= ncol)) then
              i = middle + (ix - jx)
              do iy = jy - nhalf, jy + nhalf
                 j = middle + (iy - jy)
!                 inside = 1 <= ix .and. ix <= ncol .and. &
!                      1 <= iy .and. iy <= nrow
                 if( 1 <= iy .and. iy <= nrow ) then
!                    if ( .not. skip(i,j) .and. ) then
                    if ( .not. skip(i,j) ) then
                       if (height < h(ix,iy)) go to 3200
                    endif
                 end if
              enddo
           endif
        enddo
!
! The brightness enhancement of this pixel is now confirmed to be above
! the threshold, and to be larger than in any other pixel within a
! radius of 1.5 sigma.
!
! Now we derive the shape indices.  First, is the object much more
! sharply peaked than the input FWHM?  Compare the central pixel to
! the mean of the surrounding (non-bad) pixels.  If this difference is
! greater than the originally estimated height of the Gaussian or less
! than two-tenths the height of the Gaussian, reject the star
! (assuming SHRPLO and SHRPHI have the default values of 0.2 and
! 1.0; otherwise, muta mutandis.)
!
!
! ********** IF THE CENTRAL PIXEL IS BAD SKIP THIS TEST. **********
!
!
!D     TYPE *, JX, JY
!D     DO 1666 J=1,NBOX
!D1666 TYPE 6661, (JNINT(D(I,JCYLN(J))),
!D    .     I=MAX0(1,JX-NHALF),MIN0(NCOL,IX+NHALF)),
!D    .     (JNINT(H(I,JCYLN(J))), I=IX-NHALF,IX+NHALF)
!D6661 FORMAT(1X, <NBOX>I6, 1X, <NBOX>I6)
!
! As one final nuance, for this and subsequent calculations I propose
! to subtract off the modal sky level.  Otherwise, for faint stars on
! bright backgrounds in large boxes, it is barely possible that
! truncation error could affect the numerical results of the analysis.
!
!        allocate(sh(nbox*nbox))
!        n = 0
        sharp = 0.0
        datum = d(jx,jy)
        if( lobad <= datum .and. datum <= hibad ) then
           p = 0.0
           do ix = jx - nhalf, jx + nhalf
              if( 1 <= ix .and. ix <= ncol ) then
                 i = middle + (ix - jx)
                 temp = 0.0
                 do iy = jy - nhalf, jy + nhalf
                    j = middle + (iy - jy)
                    if( 1 <= iy .and. iy <= nrow ) then
                       !                    if( 1 <= i .and. i <= ncol .and. 1 <= j .and. j <= nrow)then
                       if ( .not. skip(i,j) )then
                          datum = d(ix,iy)
                          if ((datum >= lobad) .and. (datum <= hibad)) then
                             temp = temp + (datum - skymod)
                             p = p + 1.0
!                             n = n + 1
!                             sh(n) = datum - skymod
                          end if
                       endif
                    end if
                 enddo
                 sharp = sharp + temp
              endif
           enddo

           ! original estimator
           if( height > 0 .and. p > 0 ) then
              sharp = (d(jx,jy) - skymod - sharp/p)/height
           else
              sharp = 0
           end if

           ! new experimental method for estimate of local background
           ! with outliers, looks more reliable
!           call rmean(sh(1:n),temp)
!           write(*,*) jx,jy,skymod,(temp/(sharp/p))
!           sharp = (d(jx,jy) - skymod - temp) / height

        endif
!        deallocate(sh)
        if ( sharp < shrplo .or. sharp > shrphi ) go to 3200
!           write(*,*) sharp,skysig,datum

!
! Now check to see whether the object is strongly elongated either
! along the row or along the column.  Compute the height of a Gaussian
! function of x and a Gaussian function of y by least-squares fits to
! the marginal distributions of the image data.  That is, fit the
! sum over y of the actual brightness values to the sum over y of the
! values of the array G, as functions of x.  If a bad pixel is found
! omit both the picture datum and the value of G for that pixel from
! their respective sums.  If the computed height of either the
! x-marginal or the y-marginal is non-positive, or if the central
! heights of the two marginals differ by more than their average
! (assuming that RNDLO and RNDHI have their default values
! of -1.0 and 1.0; otherwise, etc.), reject the star.
!
! We will now compute the height of the one-dimensional Gaussian
! distribution which best fits the x-marginal distribution of the
! brightness.  The equation which will be used will be the same as
! in the comments above ( h = ...) except that the symbol D in the
! equation now represents stands for the brightness data in the NBOX by
! NBOX square array summed over the y spatial direction, and the
! symbol G now stands for a one-dimensional Gaussian function (= the
! two-dimensional function G(i,j) also summed over the y spatial
! direction.  This sum is actually carried out numerically, rather
! than being done analytically, in order to permit the omission of
! "bad" pixels.)  At the same time, we will set up the necessary sums
! to permit the computation of a first-order correction to the centroid
! of the Gaussian profile in x:
!
!                -[G'*(D-G)]          [G*G']-[D*G']
! Delta x = -------------------- = -------------------,
!            [G'**2] - [G']**2/n   [G'**2] - [G']**2/n
!
! where G is the one-dimensional Gaussian profile, G' = (dG/dx), and
! D = the summed actual image data.  (There would normally be a
! [G']*[(D-G)]/n term in the numerator, but because G is already the
! "best fitting" Gaussian, [(D-G)] = 0.)  We will use
!
! SD      for the marginal sum of the actual image data
!                    (mnemonic:  "temporary sum of the data")
! SG      for the marginal sum of the 2-D Gaussian function
!                               ("temporary sum of the Gaussian")
! SUMGD   for [G*D]             ("sum of the Gaussian times the data")
! SUMG    for [G]               ("sum of the Gaussian")
! SUMD    for [D]               ("sum of the data")
! SUMGSQ  for [G**2]            ("sum of the Gaussian squared")
! SDGDX   for [G']              ("sum of d(Gaussian)/dx")
! SDGDXS  for [G'**2]           ("sum of {d(Gaussian)/dx}**2")
! SDDGDX  for [D*G']            ("sum of data times d(Gaussian)/dx")
! SGDGDX  for [G*G']            ("sum of Gaussian times d(Gaussian)/dx")
!
! In addition, for these calculations, pixels will arbitrarily be
! assigned weights ranging from unity at the corners of the box to
! MIDDLE**2 at the center (e.g. if NBOX = 5 or 7, the weights will be
!
!                                 1   2   3   4   3   2   1
!      1   2   3   2   1          2   4   6   8   6   4   2
!      2   4   6   4   2          3   6   9  12   9   6   3
!      3   6   9   6   3          4   8  12  16  12   8   4
!      2   4   6   4   2          3   6   9  12   9   6   3
!      1   2   3   2   1          2   4   6   8   6   4   2
!                                 1   2   3   4   3   2   1
!
! respectively).  This is done to desensitize the derived parameters to
! possible neighboring, brighter stars.
!
! The temporary variable P will be used to accumulate the sum of the
! weights, and N will count the number of points in the marginal
! distribution that actually get used.
!
! SKIP ALL THIS IF THE STAR IS TOO NEAR THE EDGE OF THE FRAME!
!
        if ((jx < middle) .or. (jx > lastcl) .or.    &
             (jy < middle) .or. (jy > lastro)) then
           xcen = jx
           ycen = jy
           round = 0
           ecc = 0
           incl = 0

           go to 3190
!           goto 3200
        end if

        ix = jx - middle
        iy = jy - middle

        sumgd = 0.0
        sumgsq = 0.0
        sumg = 0.0
        sumd = 0.0
        sdgdx = 0.0
        sdgdxs = 0.0
        sddgdx = 0.0
        sgdgdx = 0.0
        p = 0.0
        n = 0
        do i = 1,nbox
           sg = 0.0
           sd = 0.0
           kx = ix + i
           do j = 1,nbox
              wt = middle - abs(j - middle)
              ky = iy + j
              if( 1 <= kx .and. kx <= ncol .and. 1 <= ky .and. ky <= nrow ) then
                 datum = d(kx,ky)
                 if ((datum >= lobad) .and. (datum <= hibad)) then
                    sd = sd + (datum - skymod)*wt
                    sg = sg + g(i,j)*wt
                 end if
              end if
           enddo
           if (sg > 0.0) then
              wt = middle - abs(i - middle)
              sumgd = sumgd + wt*sg*sd
              sumgsq = sumgsq + wt*sg**2
              sumg = sumg + wt*sg
              sumd = sumd + wt*sd
              p = p + wt
              n = n + 1
              dgdx = sg*(middle - i)
              sdgdxs = sdgdxs + wt*dgdx**2
              sdgdx = sdgdx + wt*dgdx
              sddgdx = sddgdx + wt*sd*dgdx
              sgdgdx = sgdgdx + wt*sg*dgdx
           end if
        enddo
!
! we need at least three points to estimate the height and position
! of the star, and the local sky brightness.
!
        if (n <= 2) go to 3200
        hx = (sumgd - sumg*sumd/p)/(sumgsq - (sumg**2)/p)
!
! dx is the height of the best-fitting marginal Gaussian.  If this is
! non-positive, this is not an acceptable star.
!
        if (hx <= 0.0) go to 3200
!
! compute the first-order correction to the x-centroid of the star.
! Note that a factor of HX/SIGSQ is missing from SDGDX, SDDGDX, and
! SGDGDX, and a factor of (HX/SIGSQ)**2 is missing from SDGDXS.
!
        skylvl = (sumd - hx*sumg)/p
        dx = (sgdgdx - (sddgdx - sdgdx*(hx*sumg + skylvl*p)))/(hx*sdgdxs/sigsq)
        xcen = jx + dx/(1.0 + abs(dx))
!
! if the best estimate of the star's center falls outside the image,
! reject it.
!
        if( xcen < 0.5 .or. xcen > ncol - 0.5 ) go to 3200
!
! Compute the height of the y-marginal Gaussian distribution.
!
        sumgd = 0.0
        sumgsq = 0.0
        sumg = 0.0
        sumd = 0.0
        sdgdx = 0.0
        sdgdxs = 0.0
        sddgdx = 0.0
        sgdgdx = 0.0
        p = 0.0
        n = 0
        do j = 1,nbox
           ky = iy + j
           sg = 0.0
           sd = 0.0
           do i = 1, nbox
              wt = middle - abs(i - middle)
              kx = ix + i
              if( 1 <= kx .and. kx <= ncol .and. 1 <= ky .and. ky <= nrow ) then
                 datum = d(kx,ky)
                 if ( lobad <= datum .and. datum <= hibad ) then
                    sd = sd + (datum - skymod)*wt
                    sg = sg + g(i,j)*wt
                 end if
              end if
           enddo

           if (sg > 0.0) then
              wt = middle - abs(j - middle)
              sumgd = sumgd + wt*sg*sd
              sumgsq = sumgsq + wt*sg**2
              sumg = sumg + wt*sg
              sumd = sumd + wt*sd
              p = p + wt
              dgdx = sg*(middle - j)
              sdgdx = sdgdx + wt*dgdx
              sdgdxs = sdgdxs + wt*dgdx**2
              sddgdx = sddgdx + wt*sd*dgdx
              sgdgdx = sgdgdx + wt*sg*dgdx
              n = n + 1
           end if
        enddo

        if (n <= 2) go to 3200
        hy = (sumgd - sumg*sumd/p)/(sumgsq - (sumg**2)/p)
        if (hy <= 0.0) go to 3200
        skylvl = (sumd - hy*sumg)/p
        dy = (sgdgdx - (sddgdx - sdgdx*(hy*sumg + skylvl*p)))/(hy*sdgdxs/sigsq)
        ycen = jy + dy/(1.0 + abs(dy))
        if ((ycen < 0.5) .or. (ycen > nrow-0.5)) go to 3200

        round = 2.0*(hx - hy)/(hx + hy)
        if( round < rndlo .or. round > rndhi ) go to 3200

        ! estimates star centroids
        call centres(d,jx,jy,nbox,middle,skymod,lobad,hibad,xcen,ycen)

        ! estimates shape parameters
        call moments(d,jx,jy,nbox,middle,skymod,lobad,hibad,xcen,ycen,shape,ecc,incl)


!
! the fully verified and located star may now be dignified with its own
! ID number.
!
3190    nstar = nstar + 1

!        height = -2.5*log10(height/hmin)
        height = height / max(hmin,1.0)

!!!!!!        if (watch > 0.5) then
        if( verbose ) then
           write (*,"(12X, I5, 2F7.1, 2x,1pg9.3, 0p2F9.2)") &
                nstar, xcen, ycen, height, sharp, round
        endif
!!!!!!
!        write (3,"(I6, 14F9.3)") nstar, xcen, ycen, height, sharp, round
!!!!!!

        ! the data are saved to the scratch file and re-read later
        write(3) xcen, ycen, height, sharp, round, ecc, incl

        if( plog ) write(*,'(a,i0,1x,2(f0.3,1x))') '=FIND> ',nstar,xcen,ycen
!        if( verbose ) write(*,*) nstar,xcen,ycen

3200    continue
!
! If the sieve above (between statements 3040 and 3050) has detected a
! local maximum in the brightness enhancement, whether this enhancement
! was subsequently confirmed to be a star or not, then there is no need
! to check the other pixels in this row between JX+1 and JX+NHALF,
! inclusive, since we know there can't be a local maximum there.
!
!        jx = jx + nhalf
       jx = jx + 1
!
! Have we passed the last pixel in the row?  If not, work on this
! pixel.  If so, go to next row.
!
        if( jx > ncol ) exit

        enddo !jx

      enddo !jy
!
!-----------------------------------------------------------------------
!
! SECTION 4
!
! Find out whether the user is happy.  If so, delete the scratch picture
! and close up shop.  If not, return to the beginning of Section 3.
!
!!!!!!      if (watch <= 0.5) write (*,"(//1X, I5, ' stars.')") nstar
      if ( verbose ) write (*,"(//1X, I5, ' stars.')") nstar
!      if( plog ) write(*,'(a,i0,a)') "=FIND> Found ",nstar," stars."
!!!!!!
!!!!!!      call clfile (3)
!!!!!!      call tblank                                    ! type a blank line
!!!!!!      call tblank                                    ! type a blank line
!!!!!!
!-----------------------------------------------------------------------
!
! Normal return.
!

      deallocate(h,g,skip)

    end subroutine daofind


    subroutine centres(d,jx,jy,nbox,middle,skymod,lobad,hibad,xcen,ycen)

      use oakleaf

      real, dimension(:,:), intent(in) :: d
      integer, intent(in) :: jx,jy,nbox,middle
      real, intent(in) :: skymod,lobad,hibad
      real, intent(inout) :: xcen,ycen

      real, dimension(:), allocatable :: w,t
      integer :: i,j,ix,iy,ky,kx,nw,ncol,nrow
      real :: wt

      allocate(w(nbox**2),t(nbox**2))
      ix = jx - middle
      iy = jy - middle
      ncol = size(d,1)
      nrow = size(d,2)

      nw = 0
      do j = 1,nbox
         ky = iy + j
         do i = 1, nbox
            kx = ix + i
            wt = d(kx,ky) - skymod
            if ( lobad < d(kx,ky) .and. d(kx,ky) < hibad .and. wt > 0) then
               nw = nw + 1
               w(nw) = wt
               t(nw) = kx
            end if
         enddo
      end do

      ! the statistical errors are determined as sigma = sum(w)/w
      if( nw > 1 ) then
         call rmean(t(1:nw),sum(w(1:nw))/w(1:nw),xcen)
      end if

      nw = 0
      do j = 1,nbox
         ky = iy + j
         do i = 1, nbox
            kx = ix + i
            wt = d(kx,ky) - skymod
            if ( lobad < d(kx,ky) .and. d(kx,ky) < hibad .and. wt > 0) then
               nw = nw + 1
               w(nw) = wt
               t(nw) = ky
            end if
         enddo
      end do
      if( nw > 1 ) then
         call rmean(t(1:nw),sum(w(1:nw))/w(1:nw),ycen)
      end if

      if( abs(xcen - jx) > 3 .or. abs(ycen - jy) > 3 ) &
           write(*,*) 'Warning in FIND: ',jx,jy,xcen,ycen

      deallocate(w,t)

!!$      goto 667
!!$      p = 0
!!$        xcen = 0
!!$        do j = 1,nbox
!!$           ky = iy + j
!!$           do i = 1, nbox
!!$              wt = middle - abs(i - middle)
!!$              wt = 1
!!$              kx = ix + i
!!$              datum = d(kx,ky)
!!$              if ( lobad <= datum .and. datum <= hibad ) then
!!$                 xcen = xcen + (datum - skymod)*wt*kx
!!$                 p = p + (datum - skymod)*wt
!!$              end if
!!$           enddo
!!$        end do
!!$        xcen = xcen / p
!!$
!!$        p = 0
!!$        ycen = 0
!!$        do j = 1,nbox
!!$           ky = iy + j
!!$           do i = 1, nbox
!!$              wt = middle - abs(j - middle)
!!$              wt = 1
!!$              kx = ix + i
!!$              datum = d(kx,ky)
!!$              if ( lobad <= datum .and. datum <= hibad  ) then
!!$                 ycen = ycen + (datum - skymod)*wt*ky
!!$                 p = p + (datum - skymod)*wt
!!$              end if
!!$           enddo
!!$        end do
!!$        ycen = ycen / p
!!$        667 continue


    end subroutine centres

    subroutine moments(d,jx,jy,nbox,middle,skymod,lobad,hibad,xcen,ycen,shape,ecc,incl)

      use oakleaf

      real, dimension(:,:), intent(in) :: d
      integer, intent(in) :: jx,jy,nbox,middle
      real, intent(in) :: skymod,lobad,hibad,xcen,ycen
      real, intent(out) :: shape,ecc,incl

      real, dimension(:), allocatable :: w,r
      integer :: i,j,ix,iy,ky,kx,nw,ncol,nrow
      real :: wt,a,b,h,hmean,hx,hy,hxy

      allocate(w(nbox**2),r(nbox**2))
      ix = jx - middle
      iy = jy - middle
      ncol = size(d,1)
      nrow = size(d,2)

      hx = 0
      nw = 0
      do j = 1,nbox
         ky = iy + j
         do i = 1, nbox
            kx = ix + i
            if( (1 <= kx .and. kx <= ncol) .and. (1 <= ky .and. ky <= nrow))then
               wt = d(kx,ky) - skymod
               if ( lobad < d(kx,ky) .and. d(kx,ky) < hibad .and. wt > 0 ) then
                  nw = nw + 1
                  r(nw) = (kx - xcen)**2
                  w(nw) = wt
               end if
            end if
         enddo
      end do
      if( nw > 1 ) then
         call rmean(r(1:nw),sum(w(1:nw))/w(1:nw),hx)
         if( hx > 0 ) hx = sqrt(hx)
      end if

      hy = 0
      nw = 0
      do j = 1,nbox
         ky = iy + j
         do i = 1, nbox
            kx = ix + i
            if( (1 <= kx .and. kx <= ncol) .and. (1 <= ky .and. ky <= nrow))then
               wt = d(kx,ky) - skymod
               if ( lobad < d(kx,ky) .and. d(kx,ky) < hibad .and. wt > 0 ) then
                  nw = nw + 1
                  r(nw) = (ky - ycen)**2
                  w(nw) = wt
               end if
            end if
         enddo
      end do
      if( nw > 1 ) then
         call rmean(r(1:nw),sum(w(1:nw))/w(1:nw),hy)
         if( hy > 0 ) hy = sqrt(hy)
      end if

      nw = 0
      do j = 1,nbox
         ky = iy + j
         do i = 1, nbox
            kx = ix + i
            if( (1 <= kx .and. kx <= ncol) .and. (1 <= ky .and. ky <= nrow))then
               wt = d(kx,ky) - skymod
               if ( lobad < d(kx,ky) .and. d(kx,ky) < hibad .and. wt > 0 ) then
                  nw = nw + 1
                  r(nw) = (kx - xcen)*(ky - ycen)
                  w(nw) = wt
               end if
            end if
         enddo
      end do
      if( nw > 1 ) then
         call rmean(r(1:nw),sum(w(1:nw))/w(1:nw),hxy)
      else
         hxy = 0
      end if

      hmean = (hx + hy) / 2
      if( hmean > 0 ) then
         if( hx > 0 .or. hy > 0 ) then
            h = sqrt((hx - hy)**2 + 4*hxy**2)
         else
            h = 0
         end if
         shape = h / hmean
         a = hmean + h/2
         b = hmean - h/2
         if( a > b .and. a > 0 ) then
            ecc = sqrt(a**2 - b**2) / a
         else
            ecc = 0
         end if
         if( h > 0 ) then
            if( hmean > abs(hxy) .and. 2*abs(hxy) < h ) then
               incl = 57.3*asin(2*hxy / h) / 2
            else if( hmean <= abs(hxy) .and. abs(hx - hy) < h ) then
               incl = sign(57.3,hxy)*acos((hx - hy) / h) / 2
            else
               incl = 0
            end if
         else
            incl = 0
         end if
      else
         shape = 0
         ecc = 0
         incl = 0
      end if
!     write(*,*) 'shape:',shape,hx,hy,hxy,ecc,incl

      deallocate(w,r)

    end subroutine moments


end module mdaofind

!
!  Generate noises with various statistical distributions
!
!
!  Copyright © 2016 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!


module noise

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

contains

  function gnoise(mean,sig)

    ! Gets noise from N(mean,sig), eg. Normal distribution.

    real(dbl), parameter :: sqrt2 = 1.4142135623730951_dbl

    real(dbl) :: gnoise,x
    real(dbl), intent(in) :: mean, sig

    call random_number(x)
    gnoise = mean + sqrt2*sig*inverf(2*x-1)

  end function gnoise

  function pnoise(lambda)

    ! Gets noise from Poisson(lambda) distribution.

    real(dbl) :: pnoise
    real(dbl), intent(in) :: lambda

    ! The approximation for low lambda uses Knuth's algorithm
    ! which is valid only for exp(-lambda) > epsilon(1.0_dbl),
    ! eg. lambda < 740. Normal distribution is used for larger
    ! values. Approximation of N(lambda,sqrt(lambda)) will also
    ! valid with appropriate precision.

    if( lambda  < 500 ) then
       pnoise = pnoise_knuth(lambda)
    else
       pnoise = gnoise(lambda,sqrt(lambda))
    end if

  end function pnoise

  function pnoise_knuth(lam) result(k)

    ! Knuth's algorithm by http://en.wikipedia.org/wiki/Poisson_distribution
    ! This function is valid only for L=exp(-lam) > epsilon(L).

    real(dbl), intent(in) :: lam
    real(dbl) :: L,p,u
    integer :: k

    L = exp(-lam)
    k = 0
    p = 1
    do
       k = k + 1
       call random_number(u)
       p = p*u
       if( .not. (p > L) ) exit
    enddo
    k = k - 1

  end function pnoise_knuth


  ! The function inverf is adapted Numerical Recipes subroutine
  ! by chapter 6. Error functions. Its precision is better
  ! then 1e-6 on  -5 < x < 5.
  !
  ! Unfortunately, the erf(.) should be supported by compiler.
  ! It requires at least Fortran 2008.

    function inverf(p)

    real(dbl), intent(in) :: p
    real(dbl) :: inverf, pp,x,t,err
    integer :: j

    if( abs(p) < 1 ) then

       pp = 1 - abs(p)
       t = sqrt(-2.0_dbl*log(pp/2))
       x = - 0.70711*((2.30753 + t*0.27061)/(1 + t*(0.99229 + t*0.04481)) - t)
       do j = 1,2
          err = 1 - erf(x) - pp
          x = x + err/(1.128379167099551257*exp(-x**2) - x*err)
       end do
       inverf = -sign(x,-p)

    else
       inverf = sign(huge(p),p)
    end if

  end function inverf


  function ierf(x)

    ! http://en.wikipedia.org/wiki/Error_function
    ! Unfortunatelly, this function has large numerical
    ! error (about 0.2!).

    real(dbl), parameter :: pi = 3.1415926535897931

    real(dbl), intent(in) :: x
    real(dbl) :: ierf, u, v, a, y, w

    a = 0.140012288686666
    u = log(1 - x**2)
    v = 2/(pi*a)
    y = v + u/2

    w = sqrt(y**2 - u/a)
    ierf = sign(1.0d0,x)*sqrt(w - y)

  end function ierf


end module noise

!
!  An initial construction of an individual growth-curve of a star.
!
!  Copyright © 2016 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

module grow_init

  implicit none

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: pi = 3.14159265358979312_dbl

  ! print debug informations ?
  logical, parameter, private :: verbose = .false.

  real(dbl), dimension(:), allocatable, private :: cts,dcts,aper,raper
  real(dbl), private :: maxback, hwhm, par_a, par_b
  integer, private :: nhwhm, naper
  logical, private :: second

  private :: minall, the_constructor

contains




  subroutine growinit(xraper,xcts,xdcts,skyerr,rhwhm,mhwhm,grow,dgrow,valid,a,b)

    use NelderMead

    real, dimension(:), intent(in) :: xraper
    real(dbl), dimension(:), intent(in) :: xcts,xdcts
    real, intent(in) :: rhwhm
    real(dbl), intent(in) :: skyerr
    integer, intent(in) :: mhwhm
    real(dbl), dimension(:), intent(out) :: grow,dgrow
    logical, intent(out) :: valid
    real(dbl), intent(in), optional :: a,b
    real(dbl), dimension(2) :: p,dp
    real(dbl) :: pmin
    integer :: ifault

    if( present(a) .and. present(b) ) then
       second = .true.
       par_a = a
       par_b = b
!       write(*,*) a,b
    else
       second = .false.
       par_a = 0
       par_b = 0
    end if

    naper = size(xraper)
    allocate(raper(naper),aper(naper),cts(naper),dcts(naper))

    raper = xraper
    aper = pi*raper**2
    cts = xcts
    dcts = xdcts
    hwhm = rhwhm
    nhwhm = mhwhm

    ! estimate parameters
    p(1) = 1
    p(2) = 0
    dp(1) = 0.01
    dp(2) = 0.1*skyerr
    maxback = 10*skyerr
    call nelmin1(minall,p,dp,pmin,ifault)
    valid = ifault == 0 .and. p(2) < 0.99*maxback

    ! update grow curve
    if( valid ) call the_constructor(p(1),p(2),grow,dgrow,valid)

    deallocate(raper,aper,cts,dcts)

  end subroutine growinit


  function minall(p)

    real(dbl) :: minall
    real(dbl), dimension(:), intent(in) :: p

    real(dbl), dimension(:), allocatable :: grow,dgrow
    real(dbl) :: s,t,b,d,a,x,g,x1,x2,gx
    integer :: i,n
    logical :: valid

    t = p(1)
    b = p(2)

    ! range check of parameters
    if( .not. (0.5 < t .and. t < 1.0 ) .or.  abs(b) > maxback) then
       minall = 1e5
       return
    end if

    ! determine grow curve with actual parameters
    allocate(grow(naper),dgrow(naper))
    call the_constructor(t,b,grow,dgrow,valid)
    if( .not. valid ) then
       minall = 1e6
       return
    end if

    ! asymptotic parameter, 1-order
    n = (naper + nhwhm) / 2
    a = (raper(nhwhm) / hwhm) * (1 - grow(nhwhm))
    a = (raper(n) / hwhm) * (1 - grow(n))
!    a = (raper(nhwhm) / hwhm)**2 * (1 - grow(nhwhm))
!    write(*,*) a


!    g = (grow(naper)*raper(naper) - grow(n)*raper(n)) / (raper(naper) - raper(n))
!    a = (grow(naper) - grow(n)) / (1/raper(n) - 1/raper(naper))

!    x1 = raper(naper) / hwhm
!    x2 = raper(n) / hwhm
!    g = (grow(naper)*x2 - grow(n)*x1) / (x2 - x1)
!    a = (grow(naper) - grow(n)) / (1/x1 - 1/x2)

!    write(*,*) a,g

    if( second ) then
       gx = 1 - 1/ (par_a*raper(naper) - par_b)
    else
       gx = 1
    end if

    ! asympotic estimate for larger apertures
    s = 0
    do i = (nhwhm+naper)/2,naper
       d = 1-0.00177*0 - a / (raper(i) / hwhm)
       d = 1 - a / (raper(i) / hwhm)**2
       x = raper(i) / hwhm
!       d = 1 - exp(-x**2)/1.77245*(1/x-0.5/x**2)
       !       d = 1-exp(-x)/(x)
       if( second ) then
          d = (1 - 1/ (par_a*raper(i) - par_b))/gx
       else
          d = 1 - a / x
       end if
       s = s + abs(grow(i) - d)
    end do

    minall = s

    deallocate(grow,dgrow)

  end function minall

  subroutine the_constructor(t,b,grow,dgrow,valid)

    real(dbl), intent(in) :: b,t
    real(dbl), dimension(:), intent(out) :: grow,dgrow
    logical, intent(out) :: valid

    real(dbl), dimension(size(grow)) :: flux,dflux
    integer :: i

    valid = .false.

    flux = cts - b*aper
    dflux = dcts

    if( any(flux < epsilon(flux)) ) return

    ! set up initial point of grow curve
    grow(nhwhm) = t
    dgrow(nhwhm) = t * dcts(nhwhm)/cts(nhwhm)

    ! compute grow curve
    do i = nhwhm-1,1,-1
       grow(i) = grow(i+1)*(flux(i) / flux(i+1))
       dgrow(i) = grow(i)*sqrt((dcts(i)/cts(i))**2 + (dcts(i+1)/cts(i+1))**2)/1.41
    end do

    do i = nhwhm+1,size(grow)
       grow(i) = grow(i-1)*(flux(i) / flux(i-1))
       dgrow(i) = grow(i-1)*sqrt((dcts(i)/cts(i))**2 + (dcts(i-1)/cts(i-1))**2)/1.41
    end do

    valid = .true.

  end subroutine the_constructor

end module grow_init

subroutine banfac ( w, nroww, nrow, nbandl, nbandu, iflag )

!*****************************************************************************80
!
!! BANFAC factors a banded matrix without pivoting.
!
!  Discussion:
!
!    BANFAC returns in W the LU-factorization, without pivoting, of 
!    the banded matrix A of order NROW with (NBANDL+1+NBANDU) bands 
!    or diagonals in the work array W.
! 
!    Gauss elimination without pivoting is used.  The routine is 
!    intended for use with matrices A which do not require row 
!    interchanges during factorization, especially for the totally 
!    positive matrices which occur in spline calculations.
!
!    The matrix storage mode used is the same one used by LINPACK 
!    and LAPACK, and results in efficient innermost loops.
! 
!    Explicitly, A has 
! 
!      NBANDL bands below the diagonal
!      1     main diagonal
!      NBANDU bands above the diagonal
!
!    and thus, with MIDDLE=NBANDU+1,
!    A(I+J,J) is in W(I+MIDDLE,J) for I=-NBANDU,...,NBANDL, J=1,...,NROW.
!
!    For example, the interesting entries of a banded matrix
!    matrix of order 9, with NBANDL=1, NBANDU=2:
!
!      11 12 13  0  0  0  0  0  0
!      21 22 23 24  0  0  0  0  0
!       0 32 33 34 35  0  0  0  0
!       0  0 43 44 45 46  0  0  0
!       0  0  0 54 55 56 57  0  0
!       0  0  0  0 65 66 67 68  0
!       0  0  0  0  0 76 77 78 79
!       0  0  0  0  0  0 87 88 89
!       0  0  0  0  0  0  0 98 99
!
!    would appear in the first 1+1+2=4 rows of W as follows:
!
!       0  0 13 24 35 46 57 68 79
!       0 12 23 34 45 56 67 78 89
!      11 22 33 44 55 66 77 88 99
!      21 32 43 54 65 76 87 98  0
! 
!    All other entries of W not identified in this way with an
!    entry of A are never referenced.
! 
!    This routine makes it possible to solve any particular linear system 
!    A*X=B for X by the call
!
!      call banslv ( w, nroww, nrow, nbandl, nbandu, b )
!
!    with the solution X contained in B on return.
! 
!    If IFLAG=2, then one of NROW-1, NBANDL, NBANDU failed to be nonnegative, 
!    or else one of the potential pivots was found to be zero 
!    indicating that A does not have an LU-factorization.  This 
!    implies that A is singular in case it is totally positive.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
! 
!    Input/output, real ( kind = 8 ) W(NROWW,NROW).
!    On input, W contains the "interesting" part of a banded 
!    matrix A, with the diagonals or bands of A stored in the
!    rows of W, while columns of A correspond to columns of W. 
!    On output, W contains the LU-factorization of A into a unit 
!    lower triangular matrix L and an upper triangular matrix U 
!    (both banded) and stored in customary fashion over the 
!    corresponding entries of A.  
!
!    Input, integer ( kind = 4 ) NROWW, the row dimension of the work array W.
!    NROWW must be at least NBANDL+1 + NBANDU.
! 
!    Input, integer ( kind = 4 ) NROW, the number of rows in A.
!
!    Input, integer ( kind = 4 ) NBANDL, the number of bands of A below 
!    the main diagonal.
! 
!    Input, integer ( kind = 4 ) NBANDU, the number of bands of A above 
!    the main diagonal.
! 
!    Output, integer ( kind = 4 ) IFLAG, error flag.
!    1, success.
!    2, failure, the matrix was not factored.
!
  implicit none

  integer ( kind = 4 ) nrow
  integer ( kind = 4 ) nroww

  real ( kind = 8 ) factor
  integer ( kind = 4 ) i
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) j
  integer ( kind = 4 ) k
  integer ( kind = 4 ) middle
  integer ( kind = 4 ) nbandl
  integer ( kind = 4 ) nbandu
  real ( kind = 8 ) pivot
  real ( kind = 8 ) w(nroww,nrow)

  iflag = 1

  if ( nrow < 1 ) then
    iflag = 2
    return
  end if
!
!  W(MIDDLE,*) contains the main diagonal of A.
!
  middle = nbandu + 1
  
  if ( nrow == 1 ) then
    if ( w(middle,nrow) == 0.0D+00 ) then
      iflag = 2
    end if
    return
  end if
!
!  A is upper triangular.  Check that the diagonal is nonzero.
!
  if ( nbandl <= 0 ) then

    do i = 1, nrow-1
      if ( w(middle,i) == 0.0D+00 ) then
        iflag = 2
        return
      end if
    end do

    if ( w(middle,nrow) == 0.0D+00 ) then
      iflag = 2
    end if

    return
!
!  A is lower triangular.  Check that the diagonal is nonzero and
!  divide each column by its diagonal.
!
  else if ( nbandu <= 0 ) then

    do i = 1, nrow - 1

      pivot = w(middle,i)

      if ( pivot == 0.0D+00 ) then
        iflag = 2
        return
      end if

      do j = 1, min ( nbandl, nrow-i )
        w(middle+j,i) = w(middle+j,i) / pivot
      end do

    end do

    return

  end if
!
!  A is not just a triangular matrix.  
!  Construct the LU factorization.
!
  do i = 1, nrow - 1
!
!  W(MIDDLE,I) is the pivot for the I-th step.
!
    if ( w(middle,i) == 0.0D+00 ) then
      iflag = 2
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'BANFAC - Fatal error!'
      write ( *, '(a,i8)' ) '  Zero pivot encountered in column ', i
      stop 1
    end if
!
!  Divide each entry in column I below the diagonal by PIVOT.
!
    do j = 1, min ( nbandl, nrow-i )
      w(middle+j,i) = w(middle+j,i) / w(middle,i)
    end do
!
!  Subtract A(I,I+K)*(I-th column) from (I+K)-th column (below row I).
!
    do k = 1, min ( nbandu, nrow-i )
      factor = w(middle-k,i+k)
      do j = 1, min ( nbandl, nrow-i )
        w(middle-k+j,i+k) = w(middle-k+j,i+k) - w(middle+j,i) * factor
      end do
    end do
 
  end do
!
!  Check the last diagonal entry.
!
  if ( w(middle,nrow) == 0.0D+00 ) then
    iflag = 2
  end if

  return
end
subroutine banslv ( w, nroww, nrow, nbandl, nbandu, b )

!*****************************************************************************80
!
!! BANSLV solves a banded linear system A * X = B factored by BANFAC.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) W(NROWW,NROW).  W contains the banded matrix,
!    after it has been factored by BANFAC.
!
!    Input, integer ( kind = 4 ) NROWW, the row dimension of the work array W.
!    NROWW must be at least NBANDL+1 + NBANDU.
! 
!    Input, integer ( kind = 4 ) NROW, the number of rows in A.
!
!    Input, integer ( kind = 4 ) NBANDL, the number of bands of A below the 
!    main diagonal.
! 
!    Input, integer ( kind = 4 ) NBANDU, the number of bands of A above the 
!    main diagonal.
! 
!    Input/output, real ( kind = 8 ) B(NROW).
!    On input, B contains the right hand side of the system to be solved.
!    On output, B contains the solution, X.
!
  implicit none

  integer ( kind = 4 ) nrow
  integer ( kind = 4 ) nroww

  real ( kind = 8 ) b(nrow)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jmax
  integer ( kind = 4 ) middle
  integer ( kind = 4 ) nbandl
  integer ( kind = 4 ) nbandu
  real ( kind = 8 ) w(nroww,nrow)

  middle = nbandu + 1

  if ( nrow == 1 ) then
    b(1) = b(1) / w(middle,1)
    return
  end if
!
!  Forward pass:
!
!  For I = 1, 2, ..., NROW-1, subtract RHS(I)*(I-th column of L) 
!  from the right hand side, below the I-th row.
!
  if ( 0 < nbandl ) then
    do i = 1, nrow - 1
      jmax = min ( nbandl, nrow-i )
      do j = 1, jmax
        b(i+j) = b(i+j) - b(i) * w(middle+j,i)
      end do
    end do
  end if
!
!  Backward pass:
!
!  For I=NROW, NROW-1,...,1, divide RHS(I) by 
!  the I-th diagonal entry of U, then subtract 
!  RHS(I)*(I-th column of U) from right hand side, above the I-th row.
!
  do i = nrow, 2, -1
   
    b(i) = b(i) / w(middle,i)

    do j = 1, min ( nbandu, i - 1 )
      b(i-j) = b(i-j) - b(i) * w(middle-j,i)
    end do

  end do

  b(1) = b(1) / w(middle,1)

  return
end
subroutine bchfac ( w, nbands, nrow, diag )

!*****************************************************************************80
!
!! BCHFAC constructs a Cholesky factorization of a matrix.
!
!  Discussion:
!
!    The factorization has the form
!
!      C = L * D * L'
!  
!    with L unit lower triangular and D diagonal, for a given matrix C of 
!    order NROW, where C is symmetric positive semidefinite and banded, 
!    having NBANDS diagonals at and below the main diagonal.
! 
!    Gauss elimination is used, adapted to the symmetry and bandedness of C.
! 
!    Near-zero pivots are handled in a special way.  The diagonal 
!    element C(N,N) = W(1,N) is saved initially in DIAG(N), all N. 
! 
!    At the N-th elimination step, the current pivot element, W(1,N), 
!    is compared with its original value, DIAG(N).  If, as the result 
!    of prior elimination steps, this element has been reduced by about 
!    a word length, that is, if W(1,N) + DIAG(N) <= DIAG(N), then the pivot 
!    is declared to be zero, and the entire N-th row is declared to
!    be linearly dependent on the preceding rows.  This has the effect 
!    of producing X(N) = 0 when solving C * X = B for X, regardless of B.
! 
!    Justification for this is as follows.  In contemplated applications 
!    of this program, the given equations are the normal equations for 
!    some least-squares approximation problem, DIAG(N) = C(N,N) gives 
!    the norm-square of the N-th basis function, and, at this point, 
!    W(1,N) contains the norm-square of the error in the least-squares 
!    approximation to the N-th basis function by linear combinations 
!    of the first N-1.  
!
!    Having W(1,N)+DIAG(N) <= DIAG(N) signifies that the N-th function 
!    is linearly dependent to machine accuracy on the first N-1 
!    functions, therefore can safely be left out from the basis of 
!    approximating functions.
!
!    The solution of a linear system C * X = B is effected by the 
!    succession of the following two calls:
! 
!      call bchfac ( w, nbands, nrow, diag )
!
!      call bchslv ( w, nbands, nrow, b, x )
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input/output, real ( kind = 8 ) W(NBANDS,NROW).
!    On input, W contains the NBANDS diagonals in its rows, 
!    with the main diagonal in row 1.  Precisely, W(I,J) 
!    contains C(I+J-1,J), I=1,...,NBANDS, J=1,...,NROW.
!    For example, the interesting entries of a seven diagonal
!    symmetric matrix C of order 9 would be stored in W as
!      11 22 33 44 55 66 77 88 99
!      21 32 43 54 65 76 87 98  *
!      31 42 53 64 75 86 97  *  *
!      41 52 63 74 85 96  *  *  *
!    Entries of the array not associated with an
!    entry of C are never referenced.
!    On output, W contains the Cholesky factorization 
!    C = L*D*L', with W(1,I) containing 1/D(I,I) and W(I,J) 
!    containing L(I-1+J,J), I=2,...,NBANDS.
!
!    Input, integer ( kind = 4 ) NBANDS, indicates the bandwidth of the
!    matrix C, that is, C(I,J) = 0 for NBANDS < abs(I-J).
! 
!    Input, integer ( kind = 4 ) NROW, is the order of the matrix C.
! 
!    Work array, real ( kind = 8 ) DIAG(NROW).
!
  implicit none

  integer ( kind = 4 ) nbands
  integer ( kind = 4 ) nrow

  real ( kind = 8 ) diag(nrow)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) imax
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jmax
  integer ( kind = 4 ) n
  real ( kind = 8 ) ratio
  real ( kind = 8 ) w(nbands,nrow)

  if ( nrow <= 1 ) then
    if ( 0.0D+00 < w(1,1) ) then
      w(1,1) = 1.0D+00 / w(1,1)
    end if
    return
  end if
!
!  Store the diagonal.
!
  diag(1:nrow) = w(1,1:nrow)
!
!  Factorization.
!
  do n = 1, nrow
 
    if ( w(1,n) + diag(n) <= diag(n) ) then
      w(1:nbands,n) = 0.0D+00
    else
 
      w(1,n) = 1.0D+00 / w(1,n)
 
      imax = min ( nbands - 1, nrow - n )
 
      jmax = imax
 
      do i = 1, imax
 
        ratio = w(i+1,n) * w(1,n)
 
        do j = 1, jmax
          w(j,n+i) = w(j,n+i) - w(j+i,n) * ratio
        end do
 
        jmax = jmax - 1
        w(i+1,n) = ratio
 
      end do
 
    end if
 
  end do
 
  return
end
subroutine bchslv ( w, nbands, nrow, b )

!*****************************************************************************80
!
!! BCHSLV solves a banded symmetric positive definite system.
!
!  Discussion:
!
!    The system is of the form:
!
!      C * X = B 
!  
!    and the Cholesky factorization of C has been constructed 
!    by BCHFAC.
! 
!    With the factorization 
!
!      C = L * D * L'
!
!    available, where L is unit lower triangular and D is diagonal, 
!    the triangular system 
!
!      L * Y = B 
!
!    is solved for Y (forward substitution), Y is stored in B, the 
!    vector D^(-1)*Y is computed and stored in B, then the 
!    triangular system L'*X = D^(-1)*Y is solved for X 
!    (back substitution).
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) W(NBANDS,NROW), the Cholesky factorization for C, 
!    as computed by BCHFAC.
! 
!    Input, integer ( kind = 4 ) NBANDS, the bandwidth of C.
!
!    Input, integer ( kind = 4 ) NROW, the order of the matrix C.
! 
!    Input/output, real ( kind = 8 ) B(NROW).
!    On input, the right hand side.
!    On output, the solution.
!
  implicit none

  integer ( kind = 4 ) nbands
  integer ( kind = 4 ) nrow

  real ( kind = 8 ) b(nrow)
  integer ( kind = 4 ) j
  integer ( kind = 4 ) n
  real ( kind = 8 ) w(nbands,nrow)

  if ( nrow <= 1 ) then
    b(1) = b(1) * w(1,1)
    return
  end if
!
!  Forward substitution. 
!  Solve L*Y = B.
!
  do n = 1, nrow

    do j = 1, min ( nbands - 1, nrow - n )
      b(j+n) = b(j+n) - w(j+1,n) * b(n)
    end do

  end do
!
!  Back substitution. 
!  Solve L'*X = D^(-1)*Y.
!
  do n = nrow, 1, -1

    b(n) = b(n) * w(1,n)

    do j = 1, min ( nbands - 1, nrow - n )
      b(n) = b(n) - w(j+1,n) * b(j+n)
    end do

  end do

  return
end
subroutine bsplpp ( t, bcoef, n, k, scrtch, break, coef, l )

!*****************************************************************************80
!
!! BSPLPP converts from B-spline to piecewise polynomial form.
!
!  Discussion:
!
!    The B-spline representation of a spline is 
!      ( T, BCOEF, N, K ),
!    while the piecewise polynomial representation is 
!      ( BREAK, COEF, L, K ).
!
!    For each breakpoint interval, the K relevant B-spline coefficients 
!    of the spline are found and then differenced repeatedly to get the 
!    B-spline coefficients of all the derivatives of the spline on that 
!    interval. 
!
!    The spline and its first K-1 derivatives are then evaluated at the 
!    left end point of that interval, using BSPLVB repeatedly to obtain 
!    the values of all B-splines of the appropriate order at that point.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) T(N+K), the knot sequence.
! 
!    Input, real ( kind = 8 ) BCOEF(N), the B spline coefficient sequence.
! 
!    Input, integer ( kind = 4 ) N, the number of B spline coefficients.
! 
!    Input, integer ( kind = 4 ) K, the order of the spline.
! 
!    Work array, real ( kind = 8 ) SCRTCH(K,K).
! 
!    Output, real ( kind = 8 ) BREAK(L+1), the piecewise polynomial breakpoint 
!    sequence.  BREAK contains the distinct points in the sequence T(K:N+1)
! 
!    Output, real ( kind = 8 ) COEF(K,N), with COEF(I,J) = (I-1)st derivative 
!    of the spline at BREAK(J) from the right.
! 
!    Output, integer ( kind = 4 ) L, the number of polynomial pieces which 
!    make up the spline in the interval ( T(K), T(N+1) ).
!
  implicit none

  integer ( kind = 4 ) k
  integer ( kind = 4 ) l
  integer ( kind = 4 ) n

  real ( kind = 8 ) bcoef(n)
  real ( kind = 8 ) biatx(k)
  real ( kind = 8 ) break(*)
  real ( kind = 8 ) coef(k,n)
  real ( kind = 8 ) diff
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jp1
  integer ( kind = 4 ) left
  integer ( kind = 4 ) lsofar
  real ( kind = 8 ) scrtch(k,k)      
  real ( kind = 8 ) sum1
  real ( kind = 8 ) t(n+k)

  lsofar = 0
  break(1) = t(k)
  
  do left = k, n
!
!  Find the next nontrivial knot interval.
!
    if ( t(left+1) == t(left) ) then
      cycle
    end if

    lsofar = lsofar + 1
    break(lsofar+1) = t(left+1)

    if ( k <= 1 ) then
      coef(1,lsofar) = bcoef(left)
      cycle
    end if
!
!  Store the K B-spline coefficients relevant to current knot 
!  interval in SCRTCH(*,1).
!
    do i = 1, k
      scrtch(i,1) = bcoef(left-k+i)
    end do
!
!  For J=1,...,K-1, compute the  K-J  B-spline coefficients relevant to
!  the current knot interval for the J-th derivative by differencing
!  those for the (J-1)st derivative, and store in SCRTCH(.,J+1).
!
    do jp1 = 2, k
      j = jp1 - 1
      do i = 1, k - j
        diff = t(left+i) - t(left+i-(k-j))
        if ( 0.0D+00 < diff ) then
          scrtch(i,jp1) = ( ( scrtch(i+1,j) - scrtch(i,j) ) / diff ) &
            * real ( k - j, kind = 8 )
        end if
      end do
    end do
!
!  For J=0, ..., K-1, find the values at T(left) of the J+1
!  B-splines of order J+1 whose support contains the current
!  knot interval from those of order J (in  BIATX ), then combine
!  with the B-spline coefficients (in SCRTCH(.,K-J) ) found earlier
!  to compute the (K-J-1)st derivative at  T(LEFT) of the given
!  spline.
!
    call bsplvb ( t, 1, 1, t(left), left, biatx )

    coef(k,lsofar) = scrtch(1,k)
    
    do jp1 = 2, k
    
      call bsplvb ( t, jp1, 2, t(left), left, biatx )

      coef(k+1-jp1,lsofar) = dot_product ( biatx(1:jp1), scrtch(1:jp1,k+1-jp1) )
      
    end do

  end do
   
  l = lsofar

  return
end
subroutine bsplvb ( t, jhigh, index, x, left, biatx )

!*****************************************************************************80
!
!! BSPLVB evaluates B-splines at a point X with a given knot sequence.
!
!  Discusion:
!
!    BSPLVB evaluates all possibly nonzero B-splines at X of order
!
!      JOUT = MAX ( JHIGH, (J+1)*(INDEX-1) ) 
!  
!    with knot sequence T.
! 
!    The recurrence relation
! 
!                     X - T(I)               T(I+J+1) - X
!    B(I,J+1)(X) = ----------- * B(I,J)(X) + --------------- * B(I+1,J)(X)
!                  T(I+J)-T(I)               T(I+J+1)-T(I+1)
! 
!    is used to generate B(LEFT-J:LEFT,J+1)(X) from B(LEFT-J+1:LEFT,J)(X)
!    storing the new values in BIATX over the old. 
!
!    The facts that 
!
!      B(I,1)(X) = 1  if  T(I) <= X < T(I+1)
!
!    and that 
!
!      B(I,J)(X) = 0  unless  T(I) <= X < T(I+J)
!
!    are used. 
!
!    The particular organization of the calculations follows 
!    algorithm 8 in chapter X of the text.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) T(LEFT+JOUT), the knot sequence.  T is assumed to 
!    be nondecreasing, and also, T(LEFT) must be strictly less than 
!    T(LEFT+1).
! 
!    Input, integer ( kind = 4 ) JHIGH, INDEX, determine the order 
!    JOUT = max ( JHIGH, (J+1)*(INDEX-1) )  
!    of the B-splines whose values at X are to be returned.  
!    INDEX is used to avoid recalculations when several 
!    columns of the triangular array of B-spline values are
!    needed, for example, in BVALUE or in BSPLVD.
!    If INDEX = 1, the calculation starts from scratch and the entire 
!    triangular array of B-spline values of orders
!    1, 2, ...,JHIGH is generated order by order, that is, 
!    column by column.
!    If INDEX = 2, only the B-spline values of order J+1, J+2, ..., JOUT  
!    are generated, the assumption being that BIATX, J, 
!    DELTAL, DELTAR are, on entry, as they were on exit 
!    at the previous call.  In particular, if JHIGH = 0, 
!    then JOUT = J+1, that is, just the next column of B-spline 
!    values is generated.
!    Warning: the restriction  JOUT <= JMAX (= 20) is
!    imposed arbitrarily by the dimension statement for DELTAL
!    and DELTAR, but is nowhere checked for.
! 
!    Input, real ( kind = 8 ) X, the point at which the B-splines 
!    are to be evaluated.
! 
!    Input, integer ( kind = 4 ) LEFT, an integer chosen so that 
!    T(LEFT) <= X <= T(LEFT+1).
! 
!    Output, real ( kind = 8 ) BIATX(JOUT), with BIATX(I) containing the
!    value at X of the polynomial of order JOUT which agrees 
!    with the B-spline B(LEFT-JOUT+I,JOUT,T) on the interval 
!    (T(LEFT),T(LEFT+1)).
!
  implicit none

  integer ( kind = 4 ), parameter :: jmax = 20

  integer ( kind = 4 ) jhigh

  real ( kind = 8 ) biatx(jhigh)
  real ( kind = 8 ), save, dimension ( jmax ) :: deltal
  real ( kind = 8 ), save, dimension ( jmax ) :: deltar
  integer ( kind = 4 ) i
  integer ( kind = 4 ) index
  integer ( kind = 4 ), save :: j = 1
  integer ( kind = 4 ) left
  real ( kind = 8 ) saved
  real ( kind = 8 ) t(left+jhigh)
  real ( kind = 8 ) term
  real ( kind = 8 ) x

  if ( index == 1 ) then 
    j = 1
    biatx(1) = 1.0D+00
    if ( jhigh <= j ) then
      return
    end if
  end if

  if ( t(left+1) <= t(left) ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'BSPLVB - Fatal error!'
    write ( *, '(a)' ) '  It is required that T(LEFT) < T(LEFT+1).'
    write ( *, '(a,i8)' ) '  But LEFT = ', left
    write ( *, '(a,g14.6)' ) '  T(LEFT) =   ', t(left)
    write ( *, '(a,g14.6)' ) '  T(LEFT+1) = ', t(left+1)
    stop 1
  end if

  do
   
    deltar(j) = t(left+j) - x
    deltal(j) = x - t(left+1-j)

    saved = 0.0D+00
    do i = 1, j
      term = biatx(i) / ( deltar(i) + deltal(j+1-i) )
      biatx(i) = saved + deltar(i) * term
      saved = deltal(j+1-i) * term
    end do

    biatx(j+1) = saved
    j = j + 1

    if ( jhigh <= j ) then
      exit
    end if

  end do

  return
end
subroutine bsplvd ( t, k, x, left, a, dbiatx, nderiv )

!*****************************************************************************80
!
!! BSPLVD calculates the nonvanishing B-splines and derivatives at X.
!
!  Discussion:
!
!    Values at X of all the relevant B-splines of order K:K+1-NDERIV 
!    are generated via BSPLVB and stored temporarily in DBIATX.  
!
!    Then the B-spline coefficients of the required derivatives 
!    of the B-splines of interest are generated by differencing, 
!    each from the preceding one of lower order, and combined with 
!    the values of B-splines of corresponding order in DBIATX 
!    to produce the desired values.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) T(LEFT+K), the knot sequence.  It is assumed that 
!    T(LEFT) < T(LEFT+1).  Also, the output is correct only if 
!    T(LEFT) <= X <= T(LEFT+1).
!
!    Input, integer ( kind = 4 ) K, the order of the B-splines to be evaluated.
! 
!    Input, real ( kind = 8 ) X, the point at which these values are sought.
! 
!    Input, integer ( kind = 4 ) LEFT, indicates the left endpoint of the 
!    interval of interest.  The K B-splines whose support contains the interval 
!    ( T(LEFT), T(LEFT+1) ) are to be considered.
! 
!    Workspace, real ( kind = 8 ) A(K,K).
! 
!    Output, real ( kind = 8 ) DBIATX(K,NDERIV).  DBIATX(I,M) contains 
!    the value of the (M-1)st derivative of the (LEFT-K+I)-th B-spline 
!    of order K for knot sequence T, I=M,...,K, M=1,...,NDERIV.
!
!    Input, integer ( kind = 4 ) NDERIV, indicates that values of B-splines and 
!    their derivatives up to but not including the NDERIV-th are asked for. 
!
  implicit none

  integer ( kind = 4 ) k
  integer ( kind = 4 ) left
  integer ( kind = 4 ) nderiv

  real ( kind = 8 ) a(k,k)
  real ( kind = 8 ) dbiatx(k,nderiv)
  real ( kind = 8 ) factor
  real ( kind = 8 ) fkp1mm
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ideriv
  integer ( kind = 4 ) il
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jlow
  integer ( kind = 4 ) jp1mid
  integer ( kind = 4 ) ldummy
  integer ( kind = 4 ) m
  integer ( kind = 4 ) mhigh
  real ( kind = 8 ) sum1
  real ( kind = 8 ) t(left+k)
  real ( kind = 8 ) x

  mhigh = max ( min ( nderiv, k ), 1 )
!
!  MHIGH is usually equal to NDERIV.
!
  call bsplvb ( t, k+1-mhigh, 1, x, left, dbiatx )
  
  if ( mhigh == 1 ) then
    return
  end if
!
!  The first column of DBIATX always contains the B-spline values
!  for the current order.  These are stored in column K+1-current
!  order before BSPLVB is called to put values for the next
!  higher order on top of it.
!
  ideriv = mhigh
  do m = 2, mhigh
    jp1mid = 1
    do j = ideriv, k
      dbiatx(j,ideriv) = dbiatx(jp1mid,1)
      jp1mid = jp1mid + 1
    end do
    ideriv = ideriv - 1
    call bsplvb ( t, k+1-ideriv, 2, x, left, dbiatx )
  end do
!
!  At this point, B(LEFT-K+I, K+1-J)(X) is in DBIATX(I,J) for
!  I=J,...,K and J=1,...,MHIGH ('=' NDERIV). 
!
!  In particular, the first column of DBIATX is already in final form. 
!
!  To obtain corresponding derivatives of B-splines in subsequent columns, 
!  generate their B-representation by differencing, then evaluate at X.
!
  jlow = 1
  do i = 1, k
    a(jlow:k,i) = 0.0D+00
    jlow = i
    a(i,i) = 1.0D+00
  end do
!
!  At this point, A(.,J) contains the B-coefficients for the J-th of the
!  K B-splines of interest here.
!
  do m = 2, mhigh
  
    fkp1mm = real ( k + 1 - m, kind = 8 )
    il = left
    i = k
!
!  For J = 1,...,K, construct B-coefficients of (M-1)st derivative of
!  B-splines from those for preceding derivative by differencing
!  and store again in  A(.,J).  The fact that  A(I,J) = 0 for
!  I < J is used.
!
    do ldummy = 1, k + 1 - m
    
      factor = fkp1mm / ( t(il+k+1-m) - t(il) )
!
!  The assumption that T(LEFT) < T(LEFT+1) makes denominator
!  in FACTOR nonzero.
!
      a(i,1:i) = ( a(i,1:i) - a(i-1,1:i) ) * factor

      il = il - 1
      i = i - 1
      
    end do
!
!  For I = 1,...,K, combine B-coefficients A(.,I) with B-spline values
!  stored in DBIATX(.,M) to get value of (M-1)st derivative of
!  I-th B-spline (of interest here) at X, and store in DBIATX(I,M).
!
!  Storage of this value over the value of a B-spline
!  of order M there is safe since the remaining B-spline derivatives
!  of the same order do not use this value due to the fact
!  that  A(J,I) = 0  for J < I.
!
    do i = 1, k
 
      jlow = max ( i, m )
 
      dbiatx(i,m) = dot_product ( a(jlow:k,i), dbiatx(jlow:k,m) )

    end do
    
  end do
 
  return
end
subroutine bspp2d ( t, bcoef, n, k, m, scrtch, break, coef, l )

!*****************************************************************************80
!
!! BSPP2D converts from B-spline to piecewise polynomial representation.
!
!  Discussion:
!
!    The B-spline representation
! 
!      T, BCOEF(.,J), N, K 
!
!    is converted to its piecewise polynomial representation 
!
!      BREAK, COEF(J,.,.), L, K, J=1, ..., M.
!
!    This is an extended version of BSPLPP for use with tensor products.
!
!    For each breakpoint interval, the K relevant B-spline 
!    coefficients of the spline are found and then differenced 
!    repeatedly to get the B-spline coefficients of all the 
!    derivatives of the spline on that interval. 
!
!    The spline and its first K-1 derivatives are then evaluated 
!    at the left endpoint of that interval, using BSPLVB 
!    repeatedly to obtain the values of all B-splines of the 
!    appropriate order at that point.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) T(N+K), the knot sequence.
! 
!    Input, real ( kind = 8 ) BCOEF(N,M).  For each J, B(*,J) is the 
!    B-spline coefficient sequence, of length N.
! 
!    Input, integer ( kind = 4 ) N, the length of BCOEF.
! 
!    Input, integer ( kind = 4 ) K, the order of the spline.
! 
!    Input, integer ( kind = 4 ) M, the number of data sets.
! 
!    Work array, real ( kind = 8 ) SCRTCH(K,K,M).
! 
!    Output, real ( kind = 8 ) BREAK(L+1), the breakpoint sequence
!    containing the distinct points in the sequence T(K),...,T(N+1)
! 
!    Output, real ( kind = 8 ) COEF(M,K,N), with COEF(MM,I,J) = the (I-1)st
!    derivative of the MM-th spline at BREAK(J) from the right, MM=1, ..., M.
! 
!    Output, integer ( kind = 4 ) L, the number of polynomial pieces which 
!    make up the spline in the interval (T(K), T(N+1)).
!
  implicit none

  integer ( kind = 4 ) k
  integer ( kind = 4 ) m
  integer ( kind = 4 ) n

  real ( kind = 8 ) bcoef(n,m)
  real ( kind = 8 ) biatx(k)
  real ( kind = 8 ) break(*)
  real ( kind = 8 ) coef(m,k,*)
  real ( kind = 8 ) diff
  real ( kind = 8 ) fkmj
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jp1
  integer ( kind = 4 ) kmj
  integer ( kind = 4 ) l
  integer ( kind = 4 ) left
  integer ( kind = 4 ) lsofar
  integer ( kind = 4 ) mm
  real ( kind = 8 ) scrtch(k,k,m)
  real ( kind = 8 ) sum1
  real ( kind = 8 ) t(n+k)

  lsofar = 0
  break(1) = t(k)
  
  do left = k, n
!
!  Find the next nontrivial knot interval.
!
    if ( t(left+1) == t(left) ) then
      cycle
    end if

    lsofar = lsofar + 1
    break(lsofar+1) = t(left+1)

    if ( k <= 1 ) then
    
      coef(1:m,1,lsofar) = bcoef(left,1:m)

      cycle

    end if
!
!  Store the K B-spline coefficients relevant to current knot interval
!  in SCRTCH(.,1).
!
    do i = 1, k
      scrtch(i,1,1:m) = bcoef(left-k+i,1:m)
    end do
!
!  For J = 1,...,K-1, compute the ( K - J ) B-spline coefficients relevant to
!  current knot interval for the J-th derivative by differencing
!  those for the (J-1)st derivative, and store in SCRTCH(.,J+1).
!
    do jp1 = 2, k
    
      j = jp1 - 1
      kmj = k - j
      fkmj = real ( k - j, kind = 8 )
      
      do i = 1, k - j
      
        diff = ( t(left+i) - t(left+i-kmj) ) / fkmj
        
        if ( 0.0D+00 < diff ) then
        
          scrtch(i,jp1,1:m) = ( scrtch(i+1,j,1:m) - scrtch(i,j,1:m) ) / diff
          
        end if
        
      end do
        
    end do
!
!  For  J = 0, ..., K-1, find the values at T(LEFT) of the J+1
!  B-splines of order J+1 whose support contains the current
!  knot interval from those of order J (in  BIATX ), then combine
!  with the B-spline coefficients (in SCRTCH(.,K-J) ) found earlier
!  to compute the (K-J-1)st derivative at T(LEFT) of the given spline.
!
    call bsplvb ( t, 1, 1, t(left), left, biatx )
    
    coef(1:m,k,lsofar) = scrtch(1,k,1:m)
    
    do jp1 = 2, k
    
      call bsplvb ( t, jp1, 2, t(left), left, biatx )
      kmj = k + 1 - jp1
      
      do mm = 1, m
      
        sum1 = 0.0D+00
        do i = 1, jp1
          sum1 = sum1 + biatx(i) * scrtch(i,kmj,mm)
        end do
        
        coef(mm,kmj,lsofar) = sum1
        
      end do
      
    end do
   
  end do
   
  l = lsofar
  
  return
end
function bvalue ( t, bcoef, n, k, x, jderiv )

!*****************************************************************************80
!
!! BVALUE evaluates a derivative of a spline from its B-spline representation.  
!
!  Discussion:
!
!    The spline is taken to be continuous from the right.
! 
!    The nontrivial knot interval (T(I),T(I+1)) containing X is 
!    located with the aid of INTERV.  The K B-spline coefficients 
!    of F relevant for this interval are then obtained from BCOEF, 
!    or are taken to be zero if not explicitly available, and are 
!    then differenced JDERIV times to obtain the B-spline 
!    coefficients of (D^JDERIV)F relevant for that interval.  
!
!    Precisely, with J = JDERIV, we have from X.(12) of the text that:
! 
!      (D^J)F = sum ( BCOEF(.,J)*B(.,K-J,T) )
! 
!    where
!                      / BCOEF(.),                    if J == 0
!                     /
!       BCOEF(.,J) = / BCOEF(.,J-1) - BCOEF(.-1,J-1)
!                   / -----------------------------,  if 0 < J
!                  /    (T(.+K-J) - T(.))/(K-J)
! 
!    Then, we use repeatedly the fact that
! 
!      sum ( A(.) * B(.,M,T)(X) ) = sum ( A(.,X) * B(.,M-1,T)(X) )
! 
!    with
!                   (X - T(.))*A(.) + (T(.+M-1) - X)*A(.-1)
!      A(.,X) =   ---------------------------------------
!                   (X - T(.))      + (T(.+M-1) - X)
! 
!    to write (D^J)F(X) eventually as a linear combination of 
!    B-splines of order 1, and the coefficient for B(I,1,T)(X) 
!    must then be the desired number (D^J)F(X).
!    See Chapter X, (17)-(19) of text.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) T(N+K), the knot sequence.  T is assumed 
!    to be nondecreasing.
!
!    Input, real ( kind = 8 ) BCOEF(N), B-spline coefficient sequence.
! 
!    Input, integer ( kind = 4 ) N, the length of BCOEF.
! 
!    Input, integer ( kind = 4 ) K, the order of the spline.
!
!    Input, real ( kind = 8 ) X, the point at which to evaluate.
! 
!    Input, integer ( kind = 4 ) JDERIV, the order of the derivative to 
!    be evaluated.  JDERIV is assumed to be zero or positive.
! 
!    Output, real ( kind = 8 ) BVALUE, the value of the (JDERIV)-th 
!    derivative of the spline at X.
!
  implicit none

  integer ( kind = 4 ) k
  integer ( kind = 4 ) n

  real ( kind = 8 ) aj(k)
  real ( kind = 8 ) bcoef(n)
  real ( kind = 8 ) bvalue
  real ( kind = 8 ) dl(k)
  real ( kind = 8 ) dr(k)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ilo
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jc
  integer ( kind = 4 ) jcmax
  integer ( kind = 4 ) jcmin
  integer ( kind = 4 ) jderiv
  integer ( kind = 4 ) jj
  integer ( kind = 4 ) mflag
  real ( kind = 8 ) t(n+k)
  real ( kind = 8 ) x

  bvalue = 0.0D+00
  
  if ( k <= jderiv ) then
    return
  end if
!
!  Find I so that 1 <= I < N+K and T(I) < T(I+1) and T(I) <= X < T(I+1). 
!
!  If no such I can be found, X lies outside the support of the 
!  spline F and  BVALUE = 0.  The asymmetry in this choice of I makes F 
!  right continuous, except at T(N+K) where it is leftcontinuous.
!
  call interv ( t, n+k, x, i, mflag )
  
  if ( mflag /= 0 ) then
    return
  end if
!
!  If K = 1 (and JDERIV = 0), BVALUE = BCOEF(I).
!
  if ( k <= 1 ) then
    bvalue = bcoef(i)
    return
  end if
!
!  Store the K B-spline coefficients relevant for the knot interval
!  ( T(I),T(I+1) ) in AJ(1),...,AJ(K) and compute DL(J) = X - T(I+1-J),
!  DR(J) = T(I+J)-X, J=1,...,K-1.  Set any of the AJ not obtainable
!  from input to zero.  
!
!  Set any T's not obtainable equal to T(1) or to T(N+K) appropriately.
!
  jcmin = 1
  
  if ( k <= i ) then
  
    do j = 1, k-1
      dl(j) = x - t(i+1-j)
    end do
    
  else
  
    jcmin = 1 - ( i - k )
 
    do j = 1, i
      dl(j) = x - t(i+1-j)
    end do
 
    do j = i, k-1
      aj(k-j) = 0.0D+00
      dl(j) = dl(i)
    end do
  
  end if
 
  jcmax = k

  if ( n < i ) then
 
    jcmax = k + n - i
    do j = 1, k + n - i
      dr(j) = t(i+j) - x
    end do
 
    do j = k+n-i, k-1
      aj(j+1) = 0.0D+00
      dr(j) = dr(k+n-i)
    end do
 
  else
 
    do j = 1, k-1
      dr(j) = t(i+j) - x
    end do
 
  end if
 
  do jc = jcmin, jcmax
    aj(jc) = bcoef(i-k+jc)
  end do
!
!  Difference the coefficients JDERIV times.
!
  do j = 1, jderiv
 
    ilo = k - j
    do jj = 1, k - j
      aj(jj) = ( ( aj(jj+1) - aj(jj) ) / ( dl(ilo) + dr(jj) ) ) &
        * real ( k - j, kind = 8 )
      ilo = ilo - 1
    end do
 
  end do
!
!  Compute value at X in (T(I),T(I+1)) of JDERIV-th derivative,
!  given its relevant B-spline coefficients in AJ(1),...,AJ(K-JDERIV).
!
  do j = jderiv+1, k-1
    ilo = k-j
    do jj = 1, k-j
      aj(jj) = ( aj(jj+1) * dl(ilo) + aj(jj) * dr(jj) ) &
        / ( dl(ilo) + dr(jj) )
      ilo = ilo - 1
    end do
  end do
  
  bvalue = aj(1)
 
  return
end
subroutine chol1d ( p, v, qty, npoint, ncol, u, qu )

!*****************************************************************************80
!
!! CHOL1D sets up and solves linear systems needed by SMOOTH.
!
!  Discussion:
!
!    This routine constructs the upper three diagonals of
!
!      V(I,J), I = 2 to NPOINT-1, J=1,3, 
!
!    of the matrix 
!
!      6 * (1-P) * Q' * (D^2) * Q + P * R.
! 
!    It then computes its L*L' decomposition and stores it also
!    in V, then applies forward and back substitution to the right hand side 
!
!      Q'*Y 
!
!    in QTY to obtain the solution in U.
!
!  Modified:
!
!    16 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) P, the smoothing parameter that defines 
!    the linear system.
!
!    Input/output, real ( kind = 8 ) V(NPOINT,7), contains data used
!    to define the linear system, some of which is determined by
!    routine SETUPQ.
!
!    Input, real ( kind = 8 ) QTY(NPOINT), the value of Q' * Y.
!
!    Input, integer ( kind = 4 ) NPOINT, the number of equations.
!
!    Input, integer ( kind = 4 ) NCOL, an unused parameter, which may be 
!    set to 1.
!
!    Output, real ( kind = 8 ) U(NPOINT), the solution.
!
!    Output, real ( kind = 8 ) QU(NPOINT), the value of Q * U.
!
  implicit none

  integer ( kind = 4 ) npoint

  integer ( kind = 4 ) i
  integer ( kind = 4 ) ncol
  real ( kind = 8 ) p
  real ( kind = 8 ) qty(npoint)
  real ( kind = 8 ) qu(npoint)
  real ( kind = 8 ) u(npoint)
  real ( kind = 8 ) v(npoint,7)
  real ( kind = 8 ) prev
  real ( kind = 8 ) ratio
  real ( kind = 8 ) six1mp
  real ( kind = 8 ) twop
!
!  Construct 6*(1-P)*Q'*(D^2)*Q + P*R.
!
  six1mp = 6.0D+00 * ( 1.0D+00 - p )
  twop = 2.0D+00 * p

  v(2:npoint-1,1) = six1mp * v(2:npoint-1,5) &
    + twop * ( v(1:npoint-2,4) + v(2:npoint-1,4) )
  v(2:npoint-1,2) = six1mp * v(2:npoint-1,6) + p * v(2:npoint-1,4)
  v(2:npoint-1,3) = six1mp * v(2:npoint-1,7)
 
  if ( npoint < 4 ) then

    u(1) = 0.0D+00
    u(2) = qty(2) / v(2,1)
    u(3) = 0.0D+00
!
!  Factorization.
!
  else

    do i = 2, npoint-2
      ratio = v(i,2) / v(i,1)
      v(i+1,1) = v(i+1,1) - ratio * v(i,2)
      v(i+1,2) = v(i+1,2) - ratio * v(i,3)
      v(i,2) = ratio
      ratio = v(i,3) / v(i,1)
      v(i+2,1) = v(i+2,1) - ratio * v(i,3)
      v(i,3) = ratio
    end do
!
!  Forward substitution
!
    u(1) = 0.0D+00
    v(1,3) = 0.0D+00
    u(2) = qty(2)
    do i = 2, npoint-2
      u(i+1) = qty(i+1) - v(i,2) * u(i) - v(i-1,3) * u(i-1)
    end do
!
!  Back substitution.
!
    u(npoint) = 0.0D+00
    u(npoint-1) = u(npoint-1) / v(npoint-1,1)

    do i = npoint-2, 2, -1
      u(i) = u(i) / v(i,1) - u(i+1) * v(i,2) - u(i+2) * v(i,3)
    end do

  end if
!
!  Construct Q * U.
!
  prev = 0.0D+00
  do i = 2, npoint
    qu(i) = ( u(i) - u(i-1) ) / v(i-1,4)
    qu(i-1) = qu(i) - prev
    prev = qu(i)
  end do

  qu(npoint) = -qu(npoint)
    
  return
end
subroutine colloc ( aleft, aright, lbegin, iorder, ntimes, addbrk, relerr )

!*****************************************************************************80
!
!! COLLOC solves an ordinary differential equation by collocation.
!
!  Method:
!
!    The M-th order ordinary differential equation with M side 
!    conditions, to be specified in subroutine DIFEQU, is solved 
!    approximately by collocation.
!
!    The approximation F to the solution G is piecewise polynomial of order 
!    K+M with L pieces and M-1 continuous derivatives.   F is determined by 
!    the requirement that it satisfy the differential equation at K points 
!    per interval (to be specified in COLPNT ) and the M side conditions.
!
!    This usually nonlinear system of equations for F is solved by
!    Newton's method. the resulting linear system for the B-coefficients of an
!    iterate is constructed appropriately in EQBLOK and then solved
!    in SLVBLK, a program designed to solve almost block
!    diagonal linear systems efficiently.
!
!    There is an opportunity to attempt improvement of the breakpoint
!    sequence, both in number and location, through the use of NEWNOT.
!
!    Printed output consists of the piecewise polynomial representation 
!    of the approximate solution, and of the error at selected points.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters: 
!
!    Input, real ( kind = 8 ) ALEFT, ARIGHT, the endpoints of the interval.
!
!    Input, integer ( kind = 4 ) LBEGIN, the initial number of polynomial 
!    pieces in the approximation.  A uniform breakpoint sequence will be chosen.
!
!    Input, integer ( kind = 4 ) IORDER, the order of the polynomial pieces 
!    to be used in the approximation
!
!    Input, integer ( kind = 4 ) NTIMES, the number of passes to be made 
!    through NEWNOT.
!
!    Input, real ( kind = 8 ) ADDBRK, the number, possibly fractional, of 
!    breaks to be added per pass through NEWNOT.  For instance, if 
!    ADDBRK = 0.33334, then a breakpoint will be added at every third pass 
!    through NEWNOT.
!
!    Input, real ( kind = 8 ) RELERR, a tolerance.  Newton iteration is 
!    stopped if the difference between the B-coefficients of two successive 
!    iterates is no more than RELERR*(absolute largest B-coefficient).
!
  implicit none

  integer ( kind = 4 ), parameter :: npiece = 100
  integer ( kind = 4 ), parameter :: ndim = 200
  integer ( kind = 4 ), parameter :: ncoef = 2000
  integer ( kind = 4 ), parameter :: lenblk = 2000

  real ( kind = 8 ) a(ndim)
  real ( kind = 8 ) addbrk
  real ( kind = 8 ) aleft
  real ( kind = 8 ) amax
  real ( kind = 8 ) aright
  real ( kind = 8 ) asave(ndim)
  real ( kind = 8 ) b(ndim)
  real ( kind = 8 ) bloks(lenblk)
  real ( kind = 8 ) break
  real ( kind = 8 ) coef
  real ( kind = 8 ) dx
  real ( kind = 8 ) err
  integer ( kind = 4 ) i
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) ii
  integer ( kind = 4 ) integs(3,npiece)
  integer ( kind = 4 ) iorder
  integer ( kind = 4 ) iside
  integer ( kind = 4 ) itemps(ndim)
  integer ( kind = 4 ) iter
  integer ( kind = 4 ) itermx
  integer ( kind = 4 ) j
  integer ( kind = 4 ) k
  integer ( kind = 4 ) kpm
  integer ( kind = 4 ) l
  integer ( kind = 4 ) lbegin
  integer ( kind = 4 ) lnew
  integer ( kind = 4 ) m
  integer ( kind = 4 ) n
  integer ( kind = 4 ) nbloks
  integer ( kind = 4 ) nt
  integer ( kind = 4 ) ntimes
  real ( kind = 8 ) relerr
  real ( kind = 8 ) rho
  real ( kind = 8 ) t(ndim)
  real ( kind = 8 ) templ(lenblk)
  real ( kind = 8 ) temps(ndim)
  real ( kind = 8 ) xside

  equivalence ( bloks, templ )

  save / approx /
  save / other /
  save / side /

  common / approx / break(npiece), coef(ncoef), l, kpm
  common / other / itermx, k, rho(19)
  common / side / m, iside, xside(10)

  kpm = iorder

  if ( ncoef < lbegin * kpm ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'COLLOC - Fatal error!'
    write ( *, '(a)' ) '  The assigned dimension for COEF is too small.'
    stop 1
  end if
!
!  Set the various parameters concerning the particular differential
!  equation, including a first approximation in case the differential
!  equation is to be solved by iteration ( 0 < ITERMX ).
!
  call difequ ( 1, temps(1), temps )
!
!  Obtain the K collocation points for the standard interval.
!
  k = kpm - m
  call colpnt ( k, rho )
!
!  The following five statements could be replaced by a read in
!  order to obtain a nonuniform spacing of the breakpoints.
!
  dx = ( aright - aleft ) / real ( lbegin, kind = 8 )
 
  temps(1) = aleft
  do i = 2, lbegin
    temps(i) = temps(i-1) + dx
  end do
  temps(lbegin+1) = aright
!
!  Generate the required knots T(1:N+KPM).
!
  call knots ( temps, lbegin, kpm, m, t, n )
  nt = 1
!
!  Generate the almost block diagonal coefficient matrix BLOKS and
!  right hand side B from collocation equations and side conditions.
!
!  Then solve via SLVBLK, obtaining the B-representation of the 
!  approximation in T, A, N, KPM.
!
  do

    call eqblok ( t, n, kpm, temps, a, bloks, lenblk, integs, nbloks, b )

    call slvblk ( bloks, integs, nbloks, b, itemps, a, iflag )
!
!  Save B-spline coefficients of current approximation in ASAVE, then 
!  get new approximation and compare with old. 
!
!  If coefficients are more than RELERR apart (relatively) or if number 
!  of iterations is less than ITERMX, continue iterating.
!
    do iter = 1, itermx

      call bsplpp ( t, a, n, kpm, templ, break, coef, l )
 
      asave(1:n) = a(1:n)
 
      call eqblok ( t, n, kpm, temps, a, bloks, lenblk, integs, nbloks, b )

      call slvblk ( bloks, integs, nbloks, b, itemps, a, iflag )

      amax = maxval ( abs ( a(1:n) ) )
      err = maxval ( abs ( a(1:n) - asave(1:n) ) )
 
      if ( err <= relerr * amax ) then
        exit
      end if

    end do
!
!  Iteration (if any) completed.  Print out approximation based on current
!  breakpoint sequence, then try to improve the sequence.
!
    write ( *, '(a)' ) ' '
    write ( *,'(a,i3,a,i3,a)' ) &
    '  Approximation from a space of splines of order ', kpm, &
    ' on ', l, ' intervals'
    write ( *, '(a,i4)' ) '  of dimension ', n
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '  Breakpoints:'
    write ( *, '(a)' ) ' '
    write ( *, '(5g14.6)' ) break(2:l)

    if ( 0 < itermx ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a,i8)' ) '  Results on interation ', iter
    end if

    call bsplpp ( t, a, n, kpm, templ, break, coef, l )
  
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) &
      '  The piecewise polynomial representation of the approximation:'
    write ( *, '(a)' ) ' '
   
    do i = 1, l
      ii = ( i - 1 ) * kpm
      write ( *, '(f9.3,2x,e12.4,10e11.3)' ) break(i), coef(ii+1:ii+kpm)
    end do
!
!  The following call is provided here for possible further analysis
!  of the approximation specific to the problem being solved.
!  It is, of course, easily omitted.
!
    call difequ ( 4, temps(1), temps )
 
    if ( ntimes < nt ) then
      exit
    end if
!
!  From the piecewise polynomial representation of the current approximation, 
!  obtain in NEWNOT a new, and possibly better, sequence of breakpoints, 
!  adding, on average, ADDBRK breakpoints per pass through NEWNOT.
!
    lnew = lbegin + int ( real ( nt, kind = 8 ) * addbrk )

    if ( ncoef < lnew * kpm ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'COLLOC - Fatal error!'
      write ( *, '(a)' ) '  The assigned dimension for COEF is too small.'
      stop 1
    end if

    call newnot ( break, coef, l, kpm, temps, lnew, templ )

    call knots ( temps, lnew, kpm, m, t, n )
    nt = nt + 1

  end do

  return  
end
subroutine colpnt ( k, rho )

!*****************************************************************************80
!
!! COLPNT supplies collocation points.
!
!  Discussion:
!
!    The collocation points are for the standard interval (-1,1) as the 
!    zeros of the Legendre polynomial of degree K, provided K <= 8.  
!
!    Otherwise, uniformly spaced points are given.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) K, the number of collocation points desired.
!
!    Output, real ( kind = 8 ) RHO(K), the collocation points.
!
  implicit none

  integer ( kind = 4 ) k

  integer ( kind = 4 ) j
  real ( kind = 8 ) rho(k)

  if ( k == 1 ) then

    rho(1) = 0.0D+00

  else if ( k == 2 ) then

    rho(1) = -0.577350269189626D+00
    rho(2) =  0.577350269189626D+00

  else if ( k == 3 ) then

    rho(1) = -0.774596669241483D+00
    rho(2) =  0.0D+00
    rho(3) =  0.774596669241483D+00

  else if ( k == 4 ) then

    rho(1) = -0.861136311594053D+00
    rho(2) = -0.339981043584856D+00
    rho(3) =  0.339981043584856D+00
    rho(4) =  0.861136311594053D+00

  else if ( k == 5 ) then

    rho(1) = -0.906179845938664D+00
    rho(2) = -0.538469310105683D+00
    rho(3) =  0.0D+00
    rho(4) =  0.538469310105683D+00
    rho(5) =  0.906179845938664D+00

  else if ( k == 6 ) then

    rho(1) = -0.932469514203152D+00
    rho(2) = -0.661209386466265D+00
    rho(3) = -0.238619186083197D+00
    rho(4) =  0.238619186083197D+00
    rho(5) =  0.661209386466265D+00
    rho(6) =  0.932469514203152D+00

  else if ( k == 7 ) then

    rho(1) = -0.949107912342759D+00
    rho(2) = -0.741531185599394D+00
    rho(3) = -0.405845151377397D+00
    rho(4) =  0.0D+00
    rho(5) =  0.405845151377397D+00
    rho(6) =  0.741531185599394D+00
    rho(7) =  0.949107912342759D+00

  else if ( k == 8 ) then

    rho(1) = -0.960289856497536D+00
    rho(2) = -0.796666477413627D+00
    rho(3) = -0.525532409916329D+00
    rho(4) = -0.183434642495650D+00
    rho(5) =  0.183434642495650D+00
    rho(6) =  0.525532409916329D+00
    rho(7) =  0.796666477413627D+00
    rho(8) =  0.960289856497536D+00

  else

    write ( *, '(a)' ) ' '
    write ( *, '(a)' )'COLPNT - Warning!'
    write ( *, '(a)' )'  Equispaced collocation points will be used,'
    write ( *, '(a,i8)' ) '  because K = ', k
 
    do j = 1, k
      rho(j) = ( real ( k - j,     kind = 8 ) * ( -1.0D+00 )   &
               + real (     j - 1, kind = 8 ) * ( +1.0D+00 ) ) &
               / real ( k     - 1, kind = 8 )
    end do
    
  end if
 
  return
end
subroutine cubspl ( tau, c, n, ibcbeg, ibcend )

!*****************************************************************************80
!
!! CUBSPL defines an interpolatory cubic spline.
!
!  Discussion:
!
!    A tridiagonal linear system for the unknown slopes S(I) of
!    F at TAU(I), I=1,..., N, is generated and then solved by Gauss
!    elimination, with S(I) ending up in C(2,I), for all I.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) TAU(N), the abscissas or X values of
!    the data points.  The entries of TAU are assumed to be
!    strictly increasing.
!
!    Input, integer ( kind = 4 ) N, the number of data points.  N is
!    assumed to be at least 2.
!
!    Input/output, real ( kind = 8 ) C(4,N).
!    On input, if IBCBEG or IBCBEG is 1 or 2, then C(2,1)
!    or C(2,N) should have been set to the desired derivative
!    values, as described further under IBCBEG and IBCEND.
!    On output, C contains the polynomial coefficients of
!    the cubic interpolating spline with interior knots
!    TAU(2) through TAU(N-1).
!    In the interval interval (TAU(I), TAU(I+1)), the spline
!    F is given by
!      F(X) = 
!        C(1,I) + 
!        C(2,I) * H +
!        C(3,I) * H^2 / 2 + 
!        C(4,I) * H^3 / 6.
!    where H=X-TAU(I).  The routine PPVALU may be used to
!    evaluate F or its derivatives from TAU, C, L=N-1,
!    and K=4.
!
!    Input, integer ( kind = 4 ) IBCBEG, IBCEND, boundary condition indicators.
!    IBCBEG = 0 means no boundary condition at TAU(1) is given.
!    In this case, the "not-a-knot condition" is used.  That
!    is, the jump in the third derivative across TAU(2) is
!    forced to zero.  Thus the first and the second cubic
!    polynomial pieces are made to coincide.
!    IBCBEG = 1 means the slope at TAU(1) is to equal the
!    input value C(2,1).
!    IBCBEG = 2 means the second derivative at TAU(1) is
!    to equal C(2,1).
!    IBCEND = 0, 1, or 2 has analogous meaning concerning the
!    boundary condition at TAU(N), with the additional
!    information taken from C(2,N).
!
  implicit none

  integer ( kind = 4 ) n

  real ( kind = 8 ) c(4,n)
  real ( kind = 8 ) divdf1
  real ( kind = 8 ) divdf3
  real ( kind = 8 ) dtau
  real ( kind = 8 ) g
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ibcbeg
  integer ( kind = 4 ) ibcend
  real ( kind = 8 ) tau(n)
!
!  C(3,*) and C(4,*) are used initially for temporary storage.
!
!  Store first differences of the TAU sequence in C(3,*).
!
!  Store first divided difference of data in C(4,*).
!
  do i = 2, n
    c(3,i) = tau(i) - tau(i-1)
  end do

  do i = 2, n 
    c(4,i) = ( c(1,i) - c(1,i-1) ) / ( tau(i) - tau(i-1) )
  end do
!
!  Construct the first equation from the boundary condition
!  at the left endpoint, of the form:
!
!    C(4,1) * S(1) + C(3,1) * S(2) = C(2,1)
!
!  IBCBEG = 0: Not-a-knot
!
  if ( ibcbeg == 0 ) then

    if ( n <= 2 ) then
      c(4,1) = 1.0D+00
      c(3,1) = 1.0D+00
      c(2,1) = 2.0D+00 * c(4,2)
      go to 120
    end if

    c(4,1) = c(3,3)
    c(3,1) = c(3,2) + c(3,3)
    c(2,1) = ( ( c(3,2) + 2.0D+00 * c(3,1) ) * c(4,2) * c(3,3) &
      + c(3,2)**2 * c(4,3) ) / c(3,1)
!
!  IBCBEG = 1: derivative specified.
!
  else if ( ibcbeg == 1 ) then

    c(4,1) = 1.0D+00
    c(3,1) = 0.0D+00

    if ( n == 2 ) then
      go to 120
    end if
!
!  Second derivative prescribed at left end.
!
  else

    c(4,1) = 2.0D+00
    c(3,1) = 1.0D+00
    c(2,1) = 3.0D+00 * c(4,2) - c(3,2) / 2.0D+00 * c(2,1)

    if ( n == 2 ) then
      go to 120
    end if

  end if
!
!  If there are interior knots, generate the corresponding
!  equations and carry out the forward pass of Gauss elimination,
!  after which the I-th equation reads:
!
!    C(4,I) * S(I) + C(3,I) * S(I+1) = C(2,I).
!
  do i = 2, n-1
    g = -c(3,i+1) / c(4,i-1)
    c(2,i) = g * c(2,i-1) + 3.0D+00 * ( c(3,i) * c(4,i+1) + c(3,i+1) * c(4,i) )
    c(4,i) = g * c(3,i-1) + 2.0D+00 * ( c(3,i) + c(3,i+1))
  end do
!
!  Construct the last equation from the second boundary condition, of
!  the form
!
!    -G * C(4,N-1) * S(N-1) + C(4,N) * S(N) = C(2,N)
!
!  If slope is prescribed at right end, one can go directly to
!  back-substitution, since the C array happens to be set up just
!  right for it at this point.
!
  if ( ibcend == 1 ) then
    go to 160
  end if

  if ( 1 < ibcend ) then
    go to 110
  end if
 
90    continue
!
!  Not-a-knot and 3 <= N, and either 3 < N or also not-a-knot
!  at left end point.
!
  if ( n /= 3 .or. ibcbeg /= 0 ) then
    g = c(3,n-1) + c(3,n)
    c(2,n) = ( ( c(3,n) + 2.0D+00 * g ) * c(4,n) * c(3,n-1) + c(3,n)**2 &
      * ( c(1,n-1) - c(1,n-2) ) / c(3,n-1) ) / g
    g = - g / c(4,n-1)
    c(4,n) = c(3,n-1)
    c(4,n) = c(4,n) + g * c(3,n-1)
    c(2,n) = ( g * c(2,n-1) + c(2,n) ) / c(4,n)
    go to 160
  end if
!
!  N = 3 and not-a-knot also at left.
!
100   continue
 
  c(2,n) = 2.0D+00 * c(4,n)
  c(4,n) = 1.0D+00
  g = -1.0D+00 / c(4,n-1)
  c(4,n) = c(4,n) - c(3,n-1) / c(4,n-1)
  c(2,n) = ( g * c(2,n-1) + c(2,n) ) / c(4,n)
  go to 160
!
!  IBCEND = 2: Second derivative prescribed at right endpoint.
!
110   continue
 
  c(2,n) = 3.0D+00 * c(4,n) + c(3,n) / 2.0D+00 * c(2,n)
  c(4,n) = 2.0D+00
  g = -1.0D+00 / c(4,n-1)
  c(4,n) = c(4,n) - c(3,n-1) / c(4,n-1)
  c(2,n) = ( g * c(2,n-1) + c(2,n) ) / c(4,n)
  go to 160
!
!  N = 2.
!
120   continue
  
  if ( ibcend == 2  ) then

    c(2,n) = 3.0D+00 * c(4,n) + c(3,n) / 2.0D+00 * c(2,n)
    c(4,n) = 2.0D+00
    g = -1.0D+00 / c(4,n-1)
    c(4,n) = c(4,n) - c(3,n-1) / c(4,n-1)
    c(2,n) = ( g * c(2,n-1) + c(2,n) ) / c(4,n)
 
  else if ( ibcend == 0 .and. ibcbeg /= 0 ) then

    c(2,n) = 2.0D+00 * c(4,n)
    c(4,n) = 1.0D+00
    g = -1.0D+00 / c(4,n-1)
    c(4,n) = c(4,n) - c(3,n-1) / c(4,n-1)
    c(2,n) = ( g * c(2,n-1) + c(2,n) ) / c(4,n)

  else if ( ibcend == 0 .and. ibcbeg == 0 ) then

    c(2,n) = c(4,n)

  end if
!
!  Back solve the upper triangular system 
!
!    C(4,I) * S(I) + C(3,I) * S(I+1) = B(I)
!
!  for the slopes C(2,I), given that S(N) is already known.
!
160   continue
 
  do i = n-1, 1, -1
    c(2,i) = ( c(2,i) - c(3,i) * c(2,i+1) ) / c(4,i)
  end do
!
!  Generate cubic coefficients in each interval, that is, the
!  derivatives at its left endpoint, from value and slope at its
!  endpoints.
!
  do i = 2, n
    dtau = c(3,i)
    divdf1 = ( c(1,i) - c(1,i-1) ) / dtau
    divdf3 = c(2,i-1) + c(2,i) - 2.0D+00 * divdf1
    c(3,i-1) = 2.0D+00 * ( divdf1 - c(2,i-1) - divdf3 ) / dtau
    c(4,i-1) = 6.0D+00 * divdf3 / dtau**2
  end do
 
  return
end
subroutine cwidth ( w, b, nequ, ncols, integs, nbloks, d, x, iflag )

!*****************************************************************************80
!
!! CWIDTH solves an almost block diagonal linear system.
!
!  Discussion:
!
!    This routine is a variation of the theme in the algorithm
!    by Martin and Wilkinson.  It solves the linear system
!      A * X = B
!    of NEQU equations in case A is almost block diagonal with all
!    blocks having NCOLS columns using no more storage than it takes to
!    store the interesting part of A.  Such systems occur in the determination
!    of the B-spline coefficients of a spline approximation.
!
!    The block structure of A:  
!
!    The interesting part of A is taken to consist of NBLOKS
!    consecutive blocks, with the I-th block made up of NROWI = INTEGS(1,I)
!    consecutive rows and NCOLS consecutive columns of A, and with
!    the first LASTI = INTEGS(2,I) columns to the left of the next block.
!    These blocks are stored consecutively in the work array W.
!
!    For example, here is an 11th order matrix and its arrangement in
!    the work array W.  (The interesting entries of A are indicated by
!    their row and column index modulo 10.)
!
!                   ---   A   ---                          ---   W   ---
! 
!                      NROW1=3
!           11 12 13 14                                     11 12 13 14
!           21 22 23 24                                     21 22 23 24
!           31 32 33 34      NROW2=2                        31 32 33 34
!    LAST1=2      43 44 45 46                               43 44 45 46
!                 53 54 55 56         NROW3=3               53 54 55 56
!          LAST2=3         66 67 68 69                      66 67 68 69
!                          76 77 78 79                      76 77 78 79
!                          86 87 88 89   NROW4=1            86 87 88 89
!                   LAST3=1   97 98 99 90   NROW5=2         97 98 99 90
!                      LAST4=1   08 09 00 01                08 09 00 01
!                                18 19 10 11                18 19 10 11
!                         LAST5=4
!
!    For this interpretation of A as an almost block diagonal matrix,
!    we have NBLOKS = 5, and the INTEGS array is
!
!                          I = 1   2   3   4   5
!                    K =
!    INTEGS(K,I) =      1      3   2   3   1   2
!                       2      2   3   1   1   4
!
!
!  Method:
!
!    Gauss elimination with scaled partial pivoting is used, but
!    multipliers are not saved in order to save storage.  Rather, the
!    right hand side is operated on during elimination.  The two parameters
!    IPVTEQ and LASTEQ are used to keep track of the action.  IPVTEQ 
!    is the index of the variable to be eliminated next, from equations 
!    IPVTEQ+1,...,LASTEQ, using equation IPVTEQ, possibly after an 
!    interchange, as the pivot equation.  
!
!    The entries in the pivot column are always in column
!    1 of W.  This is accomplished by putting the entries in rows
!    IPVTEQ+1,...,LASTEQ revised by the elimination of the IPVTEQ-th
!    variable one to the left in W.  In this way, the columns of the
!    equations in a given block, as stored in W, will be aligned with
!    those of the next block at the moment when these next equations 
!    become involved in the elimination process.
!
!    Thus, for the above example, the first elimination steps proceed
!    as follows.
!
!    *11 12 13 14    11 12 13 14    11 12 13 14    11 12 13 14
!    *21 22 23 24   *22 23 24       22 23 24       22 23 24
!    *31 32 33 34   *32 33 34      *33 34          33 34
!     43 44 45 46    43 44 45 46   *43 44 45 46   *44 45 46        
!     53 54 55 56    53 54 55 56   *53 54 55 56   *54 55 56
!     66 67 68 69    66 67 68 69    66 67 68 69    66 67 68 69
!
!    In all other respects, the procedure is standard, including the
!    scaled partial pivoting.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!    Roger Martin, James Wilkinson,
!    Solution of Symmetric and Unsymmetric Band Equations and
!    the Calculation of Eigenvectors of Band Matrices,
!    Numerische Mathematik,
!    Volume 9, Number 4, December 1976, pages 279-301.
!
!  Parameters:
!
!    Input/output, real ( kind = 8 ) W(NEQU,NCOLS), on input, contains
!    the interesting part of the almost block diagonal coefficient matrix 
!    A.  The array INTEGS describes the storage scheme.  On output, W 
!    contains the upper triangular factor U of the LU factorization of a 
!    possibly permuted version of A.  In particular, the determinant of 
!    A could now be found as
!      IFLAG * W(1,1) * W(2,1) * ... * W(NEQU,1).
!
!    Input/output, real ( kind = 8 ) B(NEQU); on input, the right hand
!    side of the linear system.  On output, B has been overwritten by
!    other information.
!
!    Input, integer ( kind = 4 ) NEQU, the number of equations.
!
!    Input, integer ( kind = 4 ) NCOLS, the block width, that is, the number of 
!    columns in each block.
!
!    Input, integer ( kind = 4 ) INTEGS(2,NEQU), describes the block structure 
!    of A.
!    INTEGS(1,I) = number of rows in block I = NROW.
!    INTEGS(2,I) = number of elimination steps in block I = overhang over 
!    next block = LAST.
!
!    Input, integer ( kind = 4 ) NBOKS, the number of blocks.
!
!    Workspace, real D(NEQU), used to contain row sizes.  If storage is 
!    scarce, the array X could be used in the calling sequence for D.
!
!    Output, real ( kind = 8 ) X(NEQU), the computed solution, if 
!    IFLAG is nonzero.
!
!    Output, integer ( kind = 4 ) IFLAG, error flag.
!    = (-1)^(number of interchanges during elimination) if A is invertible;
!    = 0 if A is singular.
!
  implicit none

  integer ( kind = 4 ) nbloks
  integer ( kind = 4 ) ncols
  integer ( kind = 4 ) nequ

  real ( kind = 8 ) awi1od
  real ( kind = 8 ) b(nequ)
  real ( kind = 8 ) colmax
  real ( kind = 8 ) d(nequ)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) icount
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) ii
  integer ( kind = 4 ) integs(2,nbloks)
  integer ( kind = 4 ) ipvteq
  integer ( kind = 4 ) ipvtp1
  integer ( kind = 4 ) istar
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jmax
  integer ( kind = 4 ) lastcl
  integer ( kind = 4 ) lasteq
  integer ( kind = 4 ) lasti
  integer ( kind = 4 ) nexteq
  integer ( kind = 4 ) nrowad
  real ( kind = 8 ) ratio
  real ( kind = 8 ) rowmax
  real ( kind = 8 ) sum1
  real ( kind = 8 ) temp
  real ( kind = 8 ) w(nequ,ncols)
  real ( kind = 8 ) x(nequ)

  iflag = 1
  ipvteq = 0
  lasteq = 0
!
!  The I loop runs over the blocks.
!
  do i = 1, nbloks
!
!  The equations for the current block are added to those currently
!  involved in the elimination process, by increasing LASTEQ
!  by INTEGS(1,I) after the row size of these equations has been
!  recorded in the array D.
!
    nrowad = integs(1,i)
    
    do icount = 1, nrowad

      nexteq = lasteq + icount
      rowmax = maxval ( abs ( w(nexteq,1:ncols) ) )
      
      if ( rowmax == 0.0D+00 ) then
        iflag = 0
        return
      end if

      d(nexteq) = rowmax

    end do
   
    lasteq = lasteq + nrowad
!
!  There will be LASTI = INTEGS(2,I) elimination steps before
!  the equations in the next block become involved.
!
!  Further, LASTCL records the number of columns involved in the current
!  elimination step.  It starts equal to NCOLS when a block
!  first becomes involved and then drops by one after each elimination
!  step.
!
    lastcl = ncols
    lasti = integs(2,i)
    
    do icount = 1, lasti
    
      ipvteq = ipvteq + 1

      if ( lasteq <= ipvteq ) then

        if ( d(ipvteq) < abs ( w(ipvteq,1) ) + d(ipvteq) ) then
          exit
        end if

        iflag = 0
        return

      end if
!
!  Determine the smallest ISTAR in (IPVTEQ,LASTEQ) for
!  which abs ( W(ISTAR,1) ) / D(ISTAR) is as large as possible, and
!  interchange equations IPVTEQ and ISTAR in case  IPVTEQ < ISTAR.
!
      colmax = abs ( w(ipvteq,1) ) / d(ipvteq)
      istar = ipvteq
      ipvtp1 = ipvteq + 1
      
      do ii = ipvtp1, lasteq
        awi1od = abs ( w(ii,1) ) / d(ii)
        if ( colmax < awi1od ) then
          colmax = awi1od
          istar = ii
        end if
      end do
      
      if ( abs ( w(istar,1) ) + d(istar) == d(istar) ) then
        iflag = 0
        return
      end if
!
!  Rearrange data because of pivoting.
!
      if ( istar /= ipvteq ) then

        iflag = -iflag

        temp = d(istar)
        d(istar) = d(ipvteq)
        d(ipvteq) = temp
  
        temp = b(istar)
        b(istar) = b(ipvteq)
        b(ipvteq) = temp
      
        do j = 1, lastcl
          temp = w(istar,j)
          w(istar,j) = w(ipvteq,j)
          w(ipvteq,j) = temp
        end do

      end if
!
!  Subtract the appropriate multiple of equation IPVTEQ from
!  equations IPVTEQ+1,...,LASTEQ to make the coefficient of the
!  IPVTEQ-th unknown (presently in column 1 of W) zero, but
!  store the new coefficients in W one to the left from the old.
!  
      do ii = ipvtp1, lasteq
      
        ratio = w(ii,1) / w(ipvteq,1)
        do j = 2, lastcl
          w(ii,j-1) = w(ii,j) - ratio * w(ipvteq,j)
        end do
        w(ii,lastcl) = 0.0D+00
        b(ii) = b(ii) - ratio * b(ipvteq)
        
      end do
   
      lastcl = lastcl - 1
      
    end do

  end do
!
!  At this point, W and B contain an upper triangular linear system
!  equivalent to the original one, with W(I,J) containing entry
!  (I, I-1+J) of the coefficient matrix.  Solve this system by 
!  back substitution, taking into account its block structure.
!
!  I-loop over the blocks, in reverse order.
!
  i = nbloks

  do while ( 0 < i )

    lasti = integs(2,i)
    jmax = ncols - lasti
  
    do icount = 1, lasti
  
      sum1 = dot_product ( x(ipvteq+1:ipvteq+jmax), w(ipvteq,2:jmax+1) )
  
      x(ipvteq) = ( b(ipvteq) - sum1 ) / w(ipvteq,1)
      jmax = jmax + 1
      ipvteq = ipvteq - 1
    
    end do
  
    i = i - 1

  end do

  return
end
subroutine difequ ( mode, xx, v )

!*****************************************************************************80
!
!! DIFEQU returns information about a differential equation.
!
!  Discussion:
!
!    This sample version of DIFEQU is for the example in chapter XV.  It is a
!    nonlinear second order two point boundary value problem.
!
!  Modified:
!
!    16 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) MODE, an integer indicating the task to 
!    be performed.
!    1, initialization
!    2, evaluate the differential equation at point XX.
!    3, specify the next side condition
!    4, analyze the approximation
!
!    Input, real ( kind = 8 ) XX, a point at which information is wanted
!
!    Output, real ( kind = 8 ) V, depends on the MODE.
!
  implicit none

  integer ( kind = 4 ), parameter :: npiece = 100
  integer ( kind = 4 ), parameter :: ncoef = 2000

  real ( kind = 8 ) break
  real ( kind = 8 ) coef
  real ( kind = 8 ), save :: eps
  real ( kind = 8 ) ep1
  real ( kind = 8 ) ep2
  real ( kind = 8 ) error
  real ( kind = 8 ), save :: factor
  integer ( kind = 4 ) i
  integer ( kind = 4 ) iside
  integer ( kind = 4 ) itermx
  integer ( kind = 4 ) k
  integer ( kind = 4 ) kpm
  integer ( kind = 4 ) l
  integer ( kind = 4 ) m
  integer ( kind = 4 ) mode
  real ( kind = 8 ) ppvalu
  real ( kind = 8 ) rho
  real ( kind = 8 ), save :: s2ovep
  real ( kind = 8 ) solutn
  real ( kind = 8 ) un
  real ( kind = 8 ) v(20)
  real ( kind = 8 ) value
  real ( kind = 8 ) x
  real ( kind = 8 ) xside
  real ( kind = 8 ) xx

  save / approx /
  save / other /
  save / side /

  common / approx / break(npiece), coef(ncoef), l, kpm
  common / other / itermx, k, rho(19)
  common / side / m, iside, xside(10)
!
!  Initialize everything,  Set the order M of the differential equation, 
!  the nondecreasing sequence XSIDE(1:M), of points at which side 
!  conditions are given and anything else necessary.
!
  if ( mode == 1 ) then

    m = 2
    xside(1) = 0.0D+00
    xside(2) = 1.0D+00
!
!  Print out heading.
!
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '  Carrier''s nonlinear perturbation problem'
    write ( *, '(a)' ) ' '
  
    eps = 0.005D+00
    write ( *, '(a,g14.6)' ) '  EPS = ', eps
!
!  Set constants used in formula for solution below.
!
    factor = ( sqrt ( 2.0D+00 ) + sqrt ( 3.0D+00 ) )**2
    s2ovep = sqrt ( 2.0D+00 / eps )
!
!  Initial guess for Newton iteration: UN(X) = X*X-1.
!
    l = 1
    break(1) = 0.0D+00
    coef(1:kpm) = 0.0D+00
    coef(1) = -1.0D+00
    coef(3) = 2.0D+00
    itermx = 10
!
!  Provide value of left side coefficients and right hand side at XX.
!  Specifically, at XX the differential equation reads:
!
!    V(M+1) D^M + V(M) D^(M-1) + ... + V(1) D^0 = V(M+2)
!
!  in terms of the quantities V(1:M+2), to be computed here.
!
  else if ( mode == 2 ) then

    v(3) = eps
    v(2) = 0.0D+00

    un = ppvalu ( break, coef, l, kpm, xx, 0 )

    v(1) = 2.0D+00 * un
    v(4) = un**2 + 1.0D+00
!
!  Provide the M side conditions. these conditions are of the form
!
!    V(M+1) D^M + V(M) D^(M-1) + ... + V(1) D^0 = V(M+2)
!
!  in terms of the quantities V(1:M+2), to be specified here.
!  Note that V(M+1) = 0 for customary side conditions.
!
  else if ( mode == 3 ) then

    v(m+1) = 0.0D+00

    if ( iside == 1 ) then
      v(2) = 1.0D+00
      v(1) = 0.0D+00
      v(4) = 0.0D+00
      iside = iside + 1
    else if ( iside == 2 ) then
      v(2) = 0.0D+00
      v(1) = 1.0D+00
      v(4) = 0.0D+00
      iside = iside + 1
    end if
!
!  Calculate the error near the boundary layer at 1.
!
  else if ( mode == 4 ) then

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '      X             G(X)          G(X)-F(X):'
    write ( *, '(a)' ) ' '

    x = 0.75D+00
  
    do i = 1, 9

      ep1 = exp ( s2ovep * ( 1.0D+00 - x ) ) * factor
      ep2 = exp ( s2ovep * ( 1.0D+00 + x ) ) * factor

      solutn = 12.0D+00 / ( 1.0D+00 + ep1 )**2 * ep1 &
             + 12.0D+00 / ( 1.0D+00 + ep2 )**2 * ep2 - 1.0D+00

      value = ppvalu ( break, coef, l, kpm, x, 0 )

      error = solutn - value
      write ( *, '(2x,3g14.6)' ) x, solutn, error
      x = x + 0.03125D+00

    end do

  else

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'DIFEQU - Fatal error!'
    write ( *, '(a)' ) '  Illegal value of MODE:'
    write ( *, '(a,i8)' ) mode
    stop 1

  end if
  
  return
end
subroutine dtblok ( bloks, integs, nbloks, ipivot, iflag, detsgn, detlog )

!*****************************************************************************80
!
!! DTBLOK gets the determinant of an almost block diagonal matrix.
!
!  Discussion:
!
!    The matrix's PLU factorization must have been obtained 
!    previously by FCBLOK.
!
!    The logarithm of the determinant is computed instead of the
!    determinant itself to avoid the danger of overflow or underflow
!    inherent in this calculation.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) BLOKS(*), the factorization of A computed
!    by FCBLOK.
!
!    Input, integer ( kind = 4 ) INTEGS(3,NBLOKS), describes the block 
!    structure of A.
!
!    Input, integer ( kind = 4 ) NBLOKS, the number of blocks in A.
!
!    Input, integer ( kind = 4 ) IPIVOT(*), pivoting information.
!    The dimension of IPIVOT is the sum ( INTEGS(1,1:NBLOKS) ).
!
!    Input, integer ( kind = 4 ) IFLAG, = (-1)^(number of interchanges during
!    factorization) if successful, otherwise IFLAG = 0.
!
!    Output, real ( kind = 8 ) DETSGN, the sign of the determinant.
!
!    Output, real ( kind = 8 ) DETLOG, the natural logarithm of the 
!    determinant, if the determinant is not zero.  If the determinant
!    is 0, then DETLOG is returned as 0.
!
  implicit none

  integer ( kind = 4 ) nbloks

  real ( kind = 8 ) bloks(*)
  real ( kind = 8 ) detlog
  real ( kind = 8 ) detsgn
  integer ( kind = 4 ) i
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) index
  integer ( kind = 4 ) indexp
  integer ( kind = 4 ) integs(3,nbloks)
  integer ( kind = 4 ) ip
  integer ( kind = 4 ) ipivot(1)
  integer ( kind = 4 ) k
  integer ( kind = 4 ) last
  integer ( kind = 4 ) nrow

  detsgn = iflag
  detlog = 0.0D+00

  if ( iflag == 0 ) then
    return
  end if

  index = 0
  indexp = 0
  
  do i = 1, nbloks
  
    nrow = integs(1,i)
    last = integs(3,i)
    
    do k = 1, last
      ip = index + nrow * ( k - 1 ) + ipivot(indexp+k)
      detlog = detlog + log ( abs ( bloks(ip) ) )
      detsgn = detsgn * sign ( 1.0D+00, bloks(ip) )
    end do
   
    index = nrow * integs(2,i) + index
    indexp = indexp + nrow
    
  end do
   
  return
end
subroutine eqblok ( t, n, kpm, work1, work2, bloks, lenblk, integs, nbloks, b )

!*****************************************************************************80
!
!! EQBLOK is to be called in COLLOC.
!
!  Method:
!
!    Each breakpoint interval gives rise to a block in the linear system.
!    This block is determined by the K collocation equations in the interval
!    with the side conditions, if any, in the interval interspersed
!    appropriately, and involves the KPM B-splines having the interval in
!    their support.  Correspondingly, such a block has NROW = K + ISIDEL
!    rows, with ISIDEL = number of side conditions in this and the 
!    previous intervals, and NCOL = KPM columns.
!
!    Further, because the interior knots have multiplicity K, we can
!    carry out in SLVBLK K elimination steps in a block before pivoting
!    might involve an equation from the next block.  In the last block,
!    of course, all KPM elimination steps will be carried out in SLVBLK.
!
!    See the detailed comments in SLVBLK for further
!    information about the almost block diagonal form used here.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) T(N+KPM), the knot sequence.
!
!    Input, integer ( kind = 4 ) N, the dimension of the approximating spline 
!    space, that is, the order of the linear system to be constructed.
!
!    Input, integer ( kind = 4 ) KPM, = K + M, the order of the approximating 
!    spline.
!
!    Input, integer ( kind = 4 ) LENBLK, the maximum length of the array BLOKS,
!    as allowed by the dimension statement in COLLOC.
!
!    Workspace, real ( kind = 8 ) WORK1(KPM,KPM), used in PUTIT.
!
!    Workspace, real ( kind = 8 ) WORK2(KPM,M+1), used in PUTIT.
!
!    Output, real ( kind = 8 ) BLOKS(*), the coefficient matrix of the
!    linear system, stored in almost block diagonal form, of size
!    KPM * sum ( INTEGS(1,1:NBLOKS) ).
!
!    Output, integer ( kind = 4 ) INTEGS(3,NBLOKS), describing the block 
!    structure.
!    INTEGS(1,I) = number of rows in block I;
!    INTEGS(2,I) = number of columns in block I;
!    INTEGS(3,I) = number of elimination steps which can be carried out in 
!    block I before pivoting might bring in an equation from the next block.
!
!    Output, integer ( kind = 4 ) NBLOKS, the number of blocks, equals number
!    of polynomial pieces.
!
!    Output, real ( kind = 8 ) B(*), the right hand side of the linear 
!    system, stored corresponding to the almost block diagonal form, 
!    of size sum ( INTEGS(1,1:NBLOKS) ).
!
  implicit none

  integer ( kind = 4 ) kpm
  integer ( kind = 4 ) n

  real ( kind = 8 ) b(*)
  real ( kind = 8 ) bloks(*)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) index
  integer ( kind = 4 ) indexb
  integer ( kind = 4 ) integs(3,*)
  integer ( kind = 4 ) iside
  integer ( kind = 4 ) isidel
  integer ( kind = 4 ) itermx
  integer ( kind = 4 ) k
  integer ( kind = 4 ) left
  integer ( kind = 4 ) lenblk
  integer ( kind = 4 ) m
  integer ( kind = 4 ) nbloks
  integer ( kind = 4 ) nrow
  real ( kind = 8 ) rho
  real ( kind = 8 ) t(n+kpm)
  real ( kind = 8 ) work1(kpm,kpm)
  real ( kind = 8 ) work2(kpm,*)
  real ( kind = 8 ) xside

  save / other /
  save / side /

  common / other / itermx, k, rho(19)
  common / side / m, iside, xside(10)

  index = 1
  indexb = 1
  i = 0
  iside = 1
  
  do left = kpm, n, k
  
    i = i + 1
!
!  Determine INTEGS(:,I).
!
    integs(2,i) = kpm
    
    if ( n <= left ) then

      integs(3,i) = kpm
      isidel = m
!
!  At this point, ISIDE - 1 gives the number of side conditions
!  incorporated so far.  Adding to this the side conditions in the
!  current interval gives the number ISIDEL.
!
    else

      integs(3,i) = k

      isidel = iside - 1

      do

        if ( isidel == m ) then
          exit
        end if

        if ( t(left+1) <= xside(isidel+1) ) then
          exit
        end if

        isidel = isidel + 1

      end do

    end if

    nrow = k + isidel
    integs(1,i) = nrow
!
!  The detailed equations for this block are generated and put
!  together in PUTIT.
!
    if ( lenblk < index + nrow * kpm - 1 ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'EQBLOK - Fatal error!'
      write ( *, '(a)' ) '  The dimension of BLOKS is too small.'
      write ( *, '(a,i8)' ) '  LENBLK = ', lenblk
      stop 1
    end if

    call putit ( t, kpm, left, work1, work2, bloks(index), nrow, b(indexb) )

    index = index + nrow * kpm
    indexb = indexb + nrow
    
  end do
 
  nbloks = i

  return
end
subroutine evnnot ( break, coef, l, k, brknew, lnew, coefg )

!*****************************************************************************80
!
!! EVNNOT is a version of NEWNOT returning uniform knots.
!
!  Discussion:
!
!    EVNNOT returns LNEW+1 knots in BRKNEW which are evenly spaced between 
!    BREAK(1) and BREAK(L+1).
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) BREAK(L+1), real ( kind = 8 ) COEF(K,L), 
!    integer ( kind = 4 ) L, integer K, the piecewise polynomial representation 
!    of a certain function F of order K.  Specifically,
!      d^(K-1) F(X) = COEF(K,I) for BREAK(I) <= X < BREAK(I+1).
!
!    Input, integer ( kind = 4 ) LNEW, the number of subintervals into which 
!    the interval (A,B) is to be sectioned by the new breakpoint
!    sequence BRKNEW.
!
!    Output, real ( kind = 8 ) BRKNEW(LNEW+1), the new breakpoints.
!
!    Output, real (kind = 8 ) COEFG(2,L), the coefficient part of the 
!    piecewise polynomial representation BREAK, COEFG, L, 2 for the monotone 
!    piecewise linear function G with respect to which BRKNEW will
!    be equidistributed.
!
  implicit none

  integer ( kind = 4 ) k
  integer ( kind = 4 ) l
  integer ( kind = 4 ) lnew

  real ( kind = 8 ) break(l+1)
  real ( kind = 8 ) brknew(lnew+1)
  real ( kind = 8 ) coef(k,l)
  real ( kind = 8 ) coefg(2,l)
  integer ( kind = 4 ) i

  coefg(2,l) = 0.0D+00

  if ( lnew == 0 ) then

    brknew(1) = 0.5D+00 * ( break(1) + break(l+1) )

  else

    do i = 1, lnew + 1
      brknew(i) = ( real ( lnew - i + 1, kind = 8 ) * break(1) &
                  + real (        i - 1, kind = 8 ) * break(l+1) ) &
                  / real ( lnew,         kind = 8 )
    end do

  end if
 
  return
end
subroutine factrb ( w, ipivot, d, nrow, ncol, last, iflag )

!*****************************************************************************80
!
!! FACTRB constructs a partial PLU factorization.
!
!  Discussion:
!
!    This factorization corresponds to steps 1 through LAST in Gauss 
!    elimination for the matrix W of order ( NROW, NCOL ), using 
!    pivoting of scaled rows.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input/output, real ( kind = 8 ) W(NROW,NCOL); on input, contains the
!    matrix to be partially factored; on output, the partial factorization.
!
!    Output, integer ( kind = 4 ) IPIVOT(NROW), contains a record of the 
!    pivoting strategy used; row IPIVOT(I) is used during the I-th elimination
!    step, for I = 1, ..., LAST.
!
!    Workspace, real ( kind = 8 ) D(NROW), used to store the maximum entry
!    in each row.
!
!    Input, integer ( kind = 4 ) NROW, the number of rows of W.
!
!    Input, integer ( kind = 4 ) NCOL, the number of columns of W.
!
!    Input, integer ( kind = 4 ) LAST, the number of elimination steps to 
!    be carried out.
!
!    Input/output, integer ( kind = 4 ) IFLAG.  On output, equals the input 
!    value times (-1)^(number of row interchanges during the factorization 
!    process), in case no zero pivot was encountered.
!    Otherwise, IFLAG = 0 on output.
!
  implicit none

  integer ( kind = 4 ) ncol
  integer ( kind = 4 ) nrow

  real ( kind = 8 ) awikdi
  real ( kind = 8 ) colmax
  real ( kind = 8 ) d(nrow)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) ipivi
  integer ( kind = 4 ) ipivk
  integer ( kind = 4 ) ipivot(nrow)
  integer ( kind = 4 ) j
  integer ( kind = 4 ) k
  integer ( kind = 4 ) kp1
  integer ( kind = 4 ) last
  real ( kind = 8 ) ratio
  real ( kind = 8 ) rowmax
  real ( kind = 8 ) w(nrow,ncol)
!
!  Initialize IPIVOT and D.
!
  do i = 1, nrow
    ipivot(i) = i
  end do

  do i = 1, nrow
    
    rowmax = maxval ( abs ( w(i,1:ncol) ) )
    
    if ( rowmax == 0.0D+00 ) then
      iflag = 0
      return
    end if

    d(i) = rowmax
    
  end do
!
!  Gauss elimination with pivoting of scaled rows, loop over K = 1,..., LAST.
!
  k = 1
!
!  As pivot row for K-th step, pick among the rows not yet used,
!  that is, from rows IPIVOT(K:NROW), the one whose K-th entry, compared 
!  to the row size, is largest. 
!
!  If this row does not turn out to be row IPIVOT(K), redefine IPIVOT(K)
!  appropriately and record this interchange by changing the sign
!  of IFLAG.
!
  do while ( k <= last )

    ipivk = ipivot(k)

    if ( k == nrow ) then
      if ( abs ( w(ipivk,nrow) ) + d(ipivk) <= d(ipivk) ) then
        iflag = 0
      end if
      return
    end if

    j = k
    kp1 = k + 1
    colmax = abs ( w(ipivk,k) ) / d(ipivk)
!
!  Find the largest pivot.
!
    do i = kp1, nrow
      ipivi = ipivot(i)
      awikdi = abs ( w(ipivi,k) ) / d(ipivi)
      if ( colmax < awikdi ) then
        colmax = awikdi
        j = i
      end if
    end do
  
    if ( j /= k ) then
      ipivk = ipivot(j)
      ipivot(j) = ipivot(k)
      ipivot(k) = ipivk
      iflag = - iflag
    end if
!
!  If the pivot element is too small in absolute value, declare
!  the matrix to be noninvertible and quit.
!
    if ( abs ( w(ipivk,k) ) + d(ipivk) <= d(ipivk) ) then
      iflag = 0
      return
    end if
!
!  Otherwise, subtract the appropriate multiple of the pivot
!  row from the remaining rows, that is, the rows IPIVOT(K+1:NROW),
!  to make the K-th entry zero.
!
!  Save the multiplier in its place.
!
    do i = kp1, nrow
  
      ipivi = ipivot(i)
      w(ipivi,k) = w(ipivi,k) / w(ipivk,k)
    
      ratio = - w(ipivi,k)
      w(ipivi,kp1:ncol) = ratio * w(ipivk,kp1:ncol) + w(ipivi,kp1:ncol)
    
    end do
    
    k = kp1

  end do

  return
end
subroutine fcblok ( bloks, integs, nbloks, ipivot, scrtch, iflag )

!*****************************************************************************80
!
!! FCBLOK supervises the PLU factorization of an almost block diagonal matrix.
!
!  Discussion:
!
!    The routine supervises the PLU factorization with pivoting of
!    the scaled rows of an almost block diagonal matrix.
!
!    The almost block diagonal matrix is stored in the arrays
!    BLOKS and INTEGS.
!
!    The FACTRB routine carries out steps 1,..., LAST of Gauss
!    elimination, with pivoting, for an individual block.
!
!    The SHIFTB routine shifts the remaining rows to the top of
!    the next block.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input/output, real ( kind = 8 ) BLOKS(*).  On input, the almost 
!    block diagonal matrix A to be factored.  On output, the
!    factorization of A.
!
!    Input, integer ( kind = 4 ) INTEGS(3,NBLOKS), describes the block 
!    structure of A.
!
!    Input, integer ( kind = 4 ) NBLOKS, the number of blocks in A.
!
!    Output, integer ( kind = 4 ) IPIVOT(*), which will contain pivoting 
!    information.  The dimension of IPIVOT is the sum ( INTEGS(1,1:NBLOKS) ).
!
!    Workspace, real SCRTCH(*), of length maxval ( integs(1,1:NBLOKS) ).
!
!    Output, integer ( kind = 4 ) IFLAG, error flag.
!    = 0,  in case matrix was found to be singular;
!    = (-1)^(number of row interchanges during factorization), otherwise.
!
  implicit none

  integer ( kind = 4 ) nbloks

  real ( kind = 8 ) bloks(*)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) index
  integer ( kind = 4 ) indexb
  integer ( kind = 4 ) indexn
  integer ( kind = 4 ) integs(3,nbloks)
  integer ( kind = 4 ) ipivot(*)
  integer ( kind = 4 ) last
  integer ( kind = 4 ) ncol
  integer ( kind = 4 ) nrow
  real ( kind = 8 ) scrtch(*)

  iflag = 1
  indexb = 1
  indexn = 1
  i = 1 
!
!  Loop over the blocks.  I is the loop index.
!
  do

    index = indexn
    nrow = integs(1,i)
    ncol = integs(2,i)
    last = integs(3,i)
!
!  Carry out elimination on the I-th block until next block
!  enters, for columns 1 through LAST of I-th block.
!
    call factrb ( bloks(index), ipivot(indexb), scrtch, nrow, ncol, &
      last, iflag )
!
!  Check for having reached a singular block or the last block.
!
    if ( iflag == 0 .or. i == nbloks ) then
      exit
    end if

    i = i + 1
    indexn = nrow * ncol + index
!
!  Put the rest of the I-th block onto the next block.
!
    call shiftb ( bloks(index), ipivot(indexb), nrow, ncol, last, &
      bloks(indexn), integs(1,i), integs(2,i) )

    indexb = indexb + nrow

  end do

  return
end
subroutine interv ( xt, lxt, x, left, mflag )

!*****************************************************************************80
!
!! INTERV brackets a real value in an ascending vector of values.
!
!  Discussion:
!
!    The XT array is a set of increasing values.  The goal of the routine
!    is to determine the largest index I so that 
!
!      XT(I) < XT(LXT)  and  XT(I) <= X.
!
!    The routine is designed to be efficient in the common situation
!    that it is called repeatedly, with X taken from an increasing
!    or decreasing sequence.
!
!    This will happen when a piecewise polynomial is to be graphed.
!    The first guess for LEFT is therefore taken to be the value
!    returned at the previous call and stored in the local variable ILO.
!
!    A first check ascertains that ILO < LXT.  This is necessary
!    since the present call may have nothing to do with the previous
!    call.  Then, if 
!      XT(ILO) <= X < XT(ILO+1), 
!    we set LEFT = ILO and are done after just three comparisons.
!
!    Otherwise, we repeatedly double the difference ISTEP = IHI - ILO
!    while also moving ILO and IHI in the direction of X, until
!      XT(ILO) <= X < XT(IHI)
!    after which we use bisection to get, in addition, ILO + 1 = IHI.
!    The value LEFT = ILO is then returned.
!
!    Thanks to Daniel Gloger for pointing out an important modification
!    to the routine, so that the piecewise polynomial in B-form is
!    left-continuous at the right endpoint of the basic interval,
!    17 April 2014.
!
!  Modified:
!
!    17 April 2014
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) XT(LXT), a nondecreasing sequence of values.
!
!    Input, integer ( kind = 4 ) LXT, the dimension of XT.
!
!    Input, real ( kind = 8 ) X, the point whose location with 
!    respect to the sequence XT is to be determined.
!
!    Output, integer ( kind = 4 ) LEFT, the index of the bracketing value:
!      1     if             X  <  XT(1)
!      I     if   XT(I)  <= X  < XT(I+1)
!      I     if   XT(I)  <  X == XT(I+1) == XT(LXT)
!
!    Output, integer ( kind = 4 ) MFLAG, indicates whether X lies within the
!    range of the data.
!    -1:            X  <  XT(1)
!     0: XT(I)   <= X  < XT(I+1)
!    +1: XT(LXT) <  X
!
  implicit none

  integer ( kind = 4 ) lxt

  integer ( kind = 4 ) left
  integer ( kind = 4 ) mflag
  integer ( kind = 4 ) ihi
  integer ( kind = 4 ), save :: ilo = 1
  integer ( kind = 4 ) istep
  integer ( kind = 4 ) middle
  real ( kind = 8 ) x
  real ( kind = 8 ) xt(lxt)

  ihi = ilo + 1

  if ( lxt <= ihi ) then

    if ( xt(lxt) <= x ) then
      go to 110
    end if

    if ( lxt <= 1 ) then
      mflag = -1
      left = 1
      return
    end if

    ilo = lxt - 1
    ihi = lxt

  end if

  if ( xt(ihi) <= x ) then
    go to 20
  end if

  if ( xt(ilo) <= x ) then
    mflag = 0
    left = ilo
    return
  end if
!
!  Now X < XT(ILO).  Decrease ILO to capture X.
!
  istep = 1

10 continue

  ihi = ilo
  ilo = ihi - istep

  if ( 1 < ilo ) then
    if ( xt(ilo) <= x ) then
      go to 50
    end if
    istep = istep * 2
    go to 10
  end if

  ilo = 1

  if ( x < xt(1) ) then
    mflag = -1
    left = 1
    return
  end if

  go to 50
!
!  Now XT(IHI) <= X.  Increase IHI to capture X.
!
20 continue

  istep = 1

30 continue

  ilo = ihi
  ihi = ilo + istep

  if ( ihi < lxt ) then

    if ( x < xt(ihi) ) then
      go to 50
    end if

    istep = istep * 2
    go to 30

  end if

  if ( xt(lxt) <= x ) then
    go to 110
  end if
!
!  Now XT(ILO) < = X < XT(IHI).  Narrow the interval.
!
  ihi = lxt

50 continue

  do

    middle = ( ilo + ihi ) / 2

    if ( middle == ilo ) then
      mflag = 0
      left = ilo
      return
    end if
!
!  It is assumed that MIDDLE = ILO in case IHI = ILO+1.
!
    if ( xt(middle) <= x ) then
      ilo = middle
    else
      ihi = middle
    end if

  end do
!
!  Set output and return.
!
110 continue

  mflag = 1

  if ( x == xt(lxt) ) then
    mflag = 0
  end if

  do left = lxt - 1, 1, -1
    if ( xt(left) < xt(lxt) ) then
      return
    end if
  end do

  return
end
subroutine knots ( break, l, kpm, m, t, n )

!*****************************************************************************80
!
!! KNOTS is to be called in COLLOC.
!
!  Discussion:
!
!    Note that the FORTRAN77 calling sequence has been modified, by
!    adding the variable M.
!
!    From the given breakpoint sequence BREAK, this routine constructs the 
!    knot sequence T so that
!      SPLINE(K+M,T) = PP(K+M,BREAK) 
!    with M-1 continuous derivatives.
!
!    This means that T(1:N+KPM) is equal to BREAK(1) KPM times, then 
!    BREAK(2) through BREAK(L) each K times, then, finally, BREAK(L+1) 
!    KPM times.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) BREAK(L+1), the breakpoint sequence.
!
!    Input, integer ( kind = 4 ) L, the number of intervals or pieces.
!
!    Input, integer ( kind = 4 ) KPM, = K+M, the order of the piecewise
!    polynomial function or spline.
!
!    Input, integer ( kind = 4 ) M, the order of the differential equation.
!
!    Output, real ( kind = 8 ) T(N+KPM), the knot sequence.
!
!    Output, integer ( kind = 4 ) N, = L*K+M = the dimension of SPLINE(K+M,T).
!
  implicit none

  integer ( kind = 4 ) kpm
  integer ( kind = 4 ) l
  integer ( kind = 4 ) n

  real ( kind = 8 ) break(l+1)
  integer ( kind = 4 ) iside
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jj
  integer ( kind = 4 ) jjj
  integer ( kind = 4 ) k
  integer ( kind = 4 ) ll
  integer ( kind = 4 ) m
  real ( kind = 8 ) t(n+kpm)
  real ( kind = 8 ) xside

  k = kpm - m
  n = l * k + m
  jj = n + kpm
  jjj = l + 1
  
  do ll = 1, kpm
    t(jj) = break(jjj)
    jj = jj - 1
  end do
  
  do j = 1, l
    jjj = jjj - 1
    do ll = 1, k
      t(jj) = break(jjj)
      jj = jj - 1
    end do
  end do
   
  t(1:kpm) = break(1)

  return
end
subroutine l2appr ( t, n, k, q, diag, bcoef )

!*****************************************************************************80
!
!! L2APPR constructs a weighted L2 spline approximation to given data.
!
!  Discussion:
!
!    The routine constructs the weighted discrete L2-approximation by 
!    splines of order K with knot sequence T(1:N+K) to 
!    given data points ( TAU(1:NTAU), GTAU(1:NTAU) ).  
!
!    The B-spline coefficients BCOEF of the approximating spline are 
!    determined from the normal equations using Cholesky's method.
!
!  Method:
!
!    The B-spline coefficients of the L2-approximation are determined as the 
!    solution of the normal equations, for 1 <= I <= N:
!      sum ( 1 <= J <= N ) ( B(I), B(J) ) * BCOEF(J) = ( B(I), G ).
!
!    Here, B(I) denotes the I-th B-spline, G denotes the function to
!    be approximated, and the inner product of two functions F and G 
!    is given by
!      ( F, G ) = sum ( 1 <= I <= NTAU ) WEIGHT(I) * F(TAU(I)) * G(TAU(I)).
!
!    The arrays TAU and WEIGHT are given in common block DATA, as is the 
!    array GTAU(1:NTAU) = G(TAU(1:NTAU)).
!
!    The values of the B-splines B(1:N) are supplied by BSPLVB.
!
!    The coefficient matrix C, with
!       C(I,J) = ( B(I), B(J) )
!    of the normal equations is symmetric and (2*K-1)-banded, therefore
!    can be specified by giving its K bands at or below the diagonal. 
!
!    For I = 1:N and J = I:min(I+K-1,N), we store
!      ( B(I), B(J) ) = C(I,J) 
!    in
!      Q(I-J+1,J), 
!    and the right hand side
!      ( B(I), G )  
!    in
!      BCOEF(I).
!
!    Since B-spline values are most efficiently generated by finding
!    simultaneously the value of every nonzero B-spline at one point,
!    the entries of C (that is, of Q), are generated by computing, for
!    each LL, all the terms involving TAU(LL) simultaneously and adding
!    them to all relevant entries.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) T(N+K), the knot sequence.
!
!    Input, integer ( kind = 4 ) N, the dimension of the space of splines 
!    of order K with knots T.
!
!    Input, integer ( kind = 4 ) K, the order of the splines.
!
!    Workspace, real ( kind = 8 ) Q(K,N), used to store the K lower 
!    diagonals of the Gramian matrix C.
!
!    Workspace, real ( kind = 8 ) DIAG(N), used in BCHFAC.
!
!    Output, real ( kind = 8 ) BCOEF(N), the B-spline coefficients of
!    the L2 approximation to the data.
!
  implicit none

  integer ( kind = 4 ) k
  integer ( kind = 4 ) n
  integer ( kind = 4 ), parameter :: ntmax = 200

  real ( kind = 8 ) bcoef(n)
  real ( kind = 8 ) biatx(k)
  real ( kind = 8 ) diag(n)
  real ( kind = 8 ) dw
  real ( kind = 8 ) gtau
  integer ( kind = 4 ) i
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jj
  integer ( kind = 4 ) left
  integer ( kind = 4 ) leftmk
  integer ( kind = 4 ) ll
  integer ( kind = 4 ) mm
  integer ( kind = 4 ) ntau
  real ( kind = 8 ) q(k,n)
  real ( kind = 8 ) t(n+k)
  real ( kind = 8 ) tau
  real ( kind = 8 ) totalw
  real ( kind = 8 ) weight

  save / i4data /
  save / r8data /

  common / i4data / ntau
  common / r8data / tau(ntmax), gtau(ntmax), weight(ntmax), totalw

  bcoef(1:n) = 0.0D+00
  q(1:k,1:n) = 0.0D+00

  left = k
  leftmk = 0
  
  do ll = 1, ntau
!
!  Locate LEFT such that TAU(LL) is in ( T(LEFT), T(LEFT+1) ).
!
    do

      if ( left == n ) then
        exit
      end if

      if ( tau(ll) < t(left+1) ) then
        exit
      end if

      left = left + 1
      leftmk = leftmk + 1

    end do

    call bsplvb ( t, k, 1, tau(ll), left, biatx )
!
!  BIATX(MM) contains the value of B(LEFT-K+MM) at TAU(LL).
!
!  Hence, with DW = BIATX(MM) * WEIGHT(LL), the number DW * GTAU(LL)
!  is a summand in the inner product
!    ( B(LEFT-K+MM), G)
!  which goes into  BCOEF(LEFT-K+MM)
!  and the number BIATX(JJ)*DW is a summand in the inner product
!    (B(LEFT-K+JJ), B(LEFT-K+MM)), into  Q(JJ-MM+1,LEFT-K+MM)
!  since  (LEFT-K+JJ)-(LEFT-K+MM)+1 = JJ - MM + 1.
!
    do mm = 1, k
    
      dw = biatx(mm) * weight(ll)
      j = leftmk + mm
      bcoef(j) = dw * gtau(ll) + bcoef(j)
      i = 1
      
      do jj = mm, k
        q(i,j) = biatx(jj) * dw + q(i,j)
        i = i + 1
      end do
      
    end do
    
  end do
!
!  Construct the Cholesky factorization for C in Q, then 
!  use it to solve the normal equations
!
!    C * X = BCOEF
!
!  for X, and store X in BCOEF.
!
  call bchfac ( q, k, n, diag )
  
  call bchslv ( q, k, n, bcoef )
  
  return
end
subroutine l2err ( iprfun, ftau, error )

!*****************************************************************************80
!
!! L2ERR computes the errors of an L2 approximation.
!
!  Discussion:
!
!    This routine computes various errors of the current L2 approximation, 
!    whose piecewise polynomial representation is contained in common 
!    block APPROX, to the given data contained in common block DATA.  
!
!    It prints out the average error ERRL1, the L2 error ERRL2, and the
!    maximum error ERRMAX.
!
!  Modified:
!
!    16 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters: 
!
!    Input, integer ( kind = 4 ) IPRFUN.  If IPRFUN = 1, the routine prints out
!    the value of the approximation as well as its error at
!    every data point.
!
!    Output, real ( kind = 8 ) FTAU(NTAU), contains the value of the computed
!    approximation at each value TAU(1:NTAU).
!
!    Output, real ( kind = 8 ) ERROR(NTAU), with 
!      ERROR(I) = SCALE * ( G - F )(TAU(I)).  Here, SCALE equals 1
!    in case IPRFUN /= 1, or the absolute error is greater than 100 
!    somewhere.  Otherwise, SCALE is such that the maximum of the
!    absolute value of ERROR(1:NTAU) lies between 10 and 100.  This
!    makes the printed output more illustrative.
!
  implicit none

  integer ( kind = 4 ), parameter :: lpkmax = 100
  integer ( kind = 4 ), parameter :: ntmax = 200
  integer ( kind = 4 ), parameter :: ltkmax = 2000

  integer ( kind = 4 ) ntau

  real ( kind = 8 ) break
  real ( kind = 8 ) coef
  real ( kind = 8 ) err
  real ( kind = 8 ) errl1
  real ( kind = 8 ) errl2
  real ( kind = 8 ) errmax
  real ( kind = 8 ) error(ntau)
  real ( kind = 8 ) ftau(ntau)
  real ( kind = 8 ) gtau
  integer ( kind = 4 ) ie
  integer ( kind = 4 ) iprfun
  integer ( kind = 4 ) k
  integer ( kind = 4 ) l
  integer ( kind = 4 ) ll
  real ( kind = 8 ) ppvalu
  real ( kind = 8 ) scale
  real ( kind = 8 ) tau
  real ( kind = 8 ) totalw
  real ( kind = 8 ) weight

  save / approx /
  save / i4data /
  save / r8data /

  common / approx / break(lpkmax), coef(ltkmax), l, k
  common / i4data / ntau
  common / r8data / tau(ntmax), gtau(ntmax), weight(ntmax), totalw

  errl1 = 0.0D+00
  errl2 = 0.0D+00
  errmax = 0.0D+00

  do ll = 1, ntau

    ftau(ll) = ppvalu ( break, coef, l, k, tau(ll), 0 )

    error(ll) = gtau(ll) - ftau(ll)
    err = abs(error(ll))

    if ( errmax < err ) then
      errmax = err
    end if

    errl1 = errl1 + err * weight(ll)
    errl2 = errl2 + err**2 * weight(ll)

  end do

  errl1 = errl1 / totalw
  errl2 = sqrt ( errl2 / totalw )

  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  Least square error = ', errl2
  write ( *, '(a,g14.6)' ) '  Average error      = ', errl1
  write ( *, '(a,g14.6)' ) '  Maximum error      = ', errmax
  write ( *, '(a)' ) ' '
  
  if ( iprfun /= 1 ) then
    return
  end if
!
!  Scale error curve and print.
!
  ie = 0
  scale = 1.0D+00

  if ( errmax < 10.0D+00 ) then
  
    do ie = 1, 9
      scale = scale * 10.0D+00
      if ( 10.0D+00 <= errmax * scale ) then
        exit
      end if
    end do

  end if  

  error(1:ntau) = error(1:ntau) * scale
  
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Approximation and scaled error curve'
  write ( *, '(a)' ) ' '
  write ( *, '(a,i1)' ) &
    '       Data point       Approximation   Deviation x 10**', ie
  write ( *, '(a)' ) ' '
  write ( *, '(i4,f16.8,f16.8,f17.6)' ) &
    ( ll, tau(ll), ftau(ll), error(ll), ll = 1, ntau )

  return
end
subroutine l2knts ( break, l, k, t, n )

!*****************************************************************************80
!
!! L2KNTS converts breakpoints to knots.
!
!  Discussion:
!
!    The breakpoint sequence BREAK is converted into a corresponding 
!    knot sequence T to allow the representation of a piecewise
!    polynomial function of order K with K-2 continuous derivatives 
!    as a spline of order K with knot sequence T. 
!
!    This means that T(1:N+K) = BREAK(1) K times, then BREAK(2:L), 
!    then BREAK(L+1) K times.  
!
!    Therefore, N = K - 1 + L.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) K, the order.
!
!    Input, integer ( kind = 4 ) L, the number of polynomial pieces.
!
!    Input, real ( kind = 8 ) BREAK(L+1), the breakpoint sequence.
!
!    Output, real ( kind = 8 ) T(N+K), the knot sequence.
!
!    Output, integer ( kind = 4 ) N, the dimension of the corresponding spline 
!    space of order K.
!
  implicit none

  integer ( kind = 4 ) k
  integer ( kind = 4 ) l
  integer ( kind = 4 ) n

  real ( kind = 8 ) break(l+1)
  real ( kind = 8 ) t(k-1+l+k)

  n = k - 1 + l

  t(1:k-1) = break(1)
  t(k:n) = break(1:l) 
  t(n+1:n+k) = break(l+1)
 
  return
end
subroutine newnot ( break, coef, l, k, brknew, lnew, coefg )

!*****************************************************************************80
!
!! NEWNOT returns LNEW+1 knots which are equidistributed on (A,B).
!
!  Discussion:
!
!    The knots are equidistributed on (A,B) = ( BREAK(1), BREAK(L+1) ) 
!    with respect to a certain monotone function G related to the K-th root of 
!    the K-th derivative of the piecewise polynomial function F whose 
!    piecewise polynomial representation is contained in BREAK, COEF, L, K.
!
!  Method:
!
!    The K-th derivative of the given piecewise polynomial function F does 
!    not exist, except perhaps as a linear combination of delta functions. 
!
!    Nevertheless, we construct a piecewise constant function H with 
!    breakpoint sequence BREAK which is approximately proportional 
!    to abs ( d^K(F) ).
!
!    Specifically, on (BREAK(I), BREAK(I+1)),
!
!          abs(jump at BREAK(I) of PC)     abs(jump at BREAK(I+1) of PC)
!      H = ---------------------------  +  ----------------------------
!          BREAK(I+1) - BREAK(I-1)         BREAK(I+2) - BREAK(I)
!
!    with PC the piecewise constant (K-1)st derivative of F.
!
!    Then, the piecewise linear function G is constructed as
!      G(X) = integral ( A <= Y <= X )  H(Y)^(1/K) dY,
!    and its piecewise polynomial coefficients are stored in COEFG.
!
!    Then BRKNEW is determined by
!      BRKNEW(I) = A + G^(-1)((I-1)*STEP), for I = 1:LNEW+1,
!    where STEP = G(B) / LNEW and (A,B) = ( BREAK(1), BREAK(L+1) ).
!
!    In the event that PC = d^(K-1)(F) is constant in ( A, B ) and
!    therefore H = 0 identically, BRKNEW is chosen uniformly spaced.
!
!    If IPRINT is set positive, then the piecewise polynomial coefficients
!    of G will be printed out.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) BREAK(L+1), real ( kind = 8 ) COEF(K,L), 
!    integer ( kind = 4 ) L, integer K, the piecewise polynomial representation
!    of a certain function F of order K.  Specifically,
!      d^(k-1) F(X) = COEF(K,I) for BREAK(I) <= X < BREAK(I+1).
!
!    Input, integer ( kind = 4 ) LNEW, the number of intervals into which the 
!    interval (A,B) is to be divided by the new breakpoint sequence BRKNEW. 
!
!    Output, real ( kind = 8 ) BRKNEW(LNEW+1), the new breakpoint sequence.
!
!    Output, real ( kind = 8 ) COEFG(2,L), the coefficient part of the piecewise
!    polynomial representation BREAK, COEFG, L, 2 for the monotone piecewise 
!    linear function G with respect to which BRKNEW will be equidistributed.
!
  implicit none

  integer ( kind = 4 ) k
  integer ( kind = 4 ) l
  integer ( kind = 4 ) lnew

  real ( kind = 8 ) break(l+1)
  real ( kind = 8 ) brknew(lnew+1)
  real ( kind = 8 ) coef(k,l)
  real ( kind = 8 ) coefg(2,l)
  real ( kind = 8 ) dif
  real ( kind = 8 ) difprv
  integer ( kind = 4 ) i
  integer ( kind = 4 ), save :: iprint = 0
  integer ( kind = 4 ) j
  real ( kind = 8 ) oneovk
  real ( kind = 8 ) step
  real ( kind = 8 ) stepi
!
!  If G is constant, BRKNEW is uniform.
!
  if ( l <= 1 ) then
    call evnnot ( break, coef, l, k, brknew, lnew, coefg )
    return
  end if

  brknew(1) = break(1)
  brknew(lnew+1) = break(l+1)
!
!  Construct the continuous piecewise linear function G.
!
  oneovk = 1.0D+00 / real ( k, kind = 8 )
  coefg(1,1) = 0.0D+00
  difprv = abs ( coef(k,2) - coef(k,1) ) / ( break(3) - break(1) )
  
  do i = 2, l
    dif = abs ( coef(k,i) - coef(k,i-1) ) / ( break(i+1) - break(i-1) )
    coefg(2,i-1) = ( dif + difprv )**oneovk
    coefg(1,i) = coefg(1,i-1) + coefg(2,i-1) * ( break(i) - break(i-1) )
    difprv = dif
  end do
   
  coefg(2,l) = ( 2.0D+00 * difprv )**oneovk
!
!  STEP = G(B) / LNEW.
!
  step = ( coefg(1,l) + coefg(2,l) * ( break(l+1) - break(l) ) ) &
    / real ( lnew, kind = 8 )

  if ( 0 < iprint ) then
    write ( *, '(2x,e16.7)' ) step
    do i = 1, l
      write ( *, '(i5,2e16.5)' ) i, coefg(1:2,i)
    end do
  end if
!
!  If G is constant, BRKNEW is uniform.
!
  if ( step <= 0.0D+00 ) then
    call evnnot ( break, coef, l, k, brknew, lnew, coefg )
    return
  end if
!
!  For I = 2,..., LNEW, construct  BRKNEW(I) = A + G^(-1)(STEPI),
!  with STEPI = ( I - 1 ) * STEP.  
!
!  This requires inversion of the piecewise linear function G.  
!
!  For this, J is found so that
!
!    G(BREAK(J)) <= STEPI <= G(BREAK(J+1))
!
!  and then
!
!    BRKNEW(I) = BREAK(J) + ( STEPI - G(BREAK(J)) ) / DG(BREAK(J) ).
!
!  The midpoint is chosen if DG(BREAK(J)) = 0.
!
  j = 1
  
  do i = 2, lnew
  
    stepi = real ( i - 1, kind = 8 ) * step

    do

      if ( j == l ) then
        exit
      end if

      if ( stepi <= coefg(1,j+1) ) then
        exit
      end if

      j = j + 1

    end do
       
    if ( coefg(2,j) /= 0.0D+00 ) then
      brknew(i) = break(j) + ( stepi - coefg(1,j) ) / coefg(2,j)
    else
      brknew(i) = ( break(j) + break(j+1) ) / 2.0D+00
    end if
    
  end do
  
  return
end
function ppvalu ( break, coef, l, k, x, jderiv )

!*****************************************************************************80
!
!! PPVALU evaluates a piecewise polynomial function or its derivative.
!
!  Discussion:
!
!    PPVALU calculates the value at X of the JDERIV-th derivative of
!    the piecewise polynomial function F from its piecewise
!    polynomial representation.
!
!    The interval index I, appropriate for X, is found through a
!    call to INTERV.  The formula for the JDERIV-th derivative
!    of F is then evaluated by nested multiplication.
!
!    The J-th derivative of F is given by:
!      (d^J) F(X) = 
!        COEF(J+1,I) + H * (
!        COEF(J+2,I) + H * (
!        ...
!        COEF(K-1,I) + H * (
!        COEF(K,  I) / (K-J-1) ) / (K-J-2) ... ) / 2 ) / 1
!    with
!      H = X - BREAK(I)
!    and
!      I = max ( 1, max ( J, BREAK(J) <= X, 1 <= J <= L ) ).
!
!  Modified:
!
!    16 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) BREAK(L+1), real COEF(*), integer L, the
!    piecewise polynomial representation of the function F to be evaluated.
!
!    Input, integer ( kind = 4 ) K, the order of the polynomial pieces that 
!    make up the function F.  The usual value for K is 4, signifying a 
!    piecewise cubic polynomial.
!
!    Input, real ( kind = 8 ) X, the point at which to evaluate F or
!    of its derivatives.
!
!    Input, integer ( kind = 4 ) JDERIV, the order of the derivative to be
!    evaluated.  If JDERIV is 0, then F itself is evaluated,
!    which is actually the most common case.  It is assumed
!    that JDERIV is zero or positive.
!
!    Output, real ( kind = 8 ) PPVALU, the value of the JDERIV-th
!    derivative of F at X.
!
  implicit none

  integer ( kind = 4 ) k
  integer ( kind = 4 ) l

  real ( kind = 8 ) break(l+1)
  real ( kind = 8 ) coef(k,l)
  real ( kind = 8 ) fmmjdr
  real ( kind = 8 ) h
  integer ( kind = 4 ) i
  integer ( kind = 4 ) jderiv
  integer ( kind = 4 ) m
  integer ( kind = 4 ) ndummy
  real ( kind = 8 ) ppvalu
  real ( kind = 8 ) value
  real ( kind = 8 ) x

  value = 0.0D+00

  fmmjdr = k - jderiv
!
!  Derivatives of order K or higher are identically zero.
!
  if ( k <= jderiv ) then
    return
  end if
!
!  Find the index I of the largest breakpoint to the left of X.
!
  call interv ( break, l+1, x, i, ndummy )
!
!  Evaluate the JDERIV-th derivative of the I-th polynomial piece at X.
!
  h = x - break(i)
  m = k
 
  do

    value = ( value / fmmjdr ) * h + coef(m,i)
    m = m - 1
    fmmjdr = fmmjdr - 1.0D+00

    if ( fmmjdr <= 0.0D+00 ) then
      exit
    end if

  end do

  ppvalu = value
 
  return
end
subroutine putit ( t, kpm, left, scrtch, dbiatx, q, nrow, b )

!*****************************************************************************80
!
!! PUTIT puts together one block of the collocation equation system.
!
!  Method:
!
!    The K collocation equations for the interval ( T(LEFT), T(LEFT+1) )
!    are constructed with the aid of the subroutine DIFEQU( 2, ., . ) 
!    and interspersed (in order) with the side conditions, if any, in
!    this interval, using DIFEQU ( 3, ., . )  for the information.
!
!    The block Q has KPM columns, corresponding to the KPM B-splines of order 
!    KPM which have the interval ( T(LEFT), T(LEFT+1) ) in their support. 
!
!    The block's diagonal is part of the diagonal of the total system.
!
!    The first equation in this block not overlapped by the preceding block 
!    is therefore equation LOWROW, with LOWROW = number of side conditions 
!    in preceding intervals (or blocks).
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) T(LEFT+KPM), the knot sequence.
!
!    Input, integer ( kind = 4 ) KPM, the order of the spline.
!
!    Input, integer ( kind = 4 ) LEFT, indicates the interval of interest, 
!    that is, the interval ( T(LEFT), T(LEFT+1) ).
!
!    Workspace, real ( kind = 8 ) SCRTCH(KPM,KPM).
!
!    Workspace, real ( kind = 8 ) DBIATX(KPM,M+1), derivatives of B-splines, 
!    with DBIATX(J,I+1) containing the I-th derivative of the J-th B-spline 
!    of interest.
!
!    Output, real ( kind = 8 ) Q(NROW,KPM), the block.
!
!    Input, integer ( kind = 4 ) NROW, number of rows in block to be 
!!   put together.
!
!    Output, real ( kind = 8 ) B(NROW), the corresponding piece of 
!    the right hand side.
!
  implicit none

  integer ( kind = 4 ) kpm
  integer ( kind = 4 ) left
  integer ( kind = 4 ) nrow

  real ( kind = 8 ) b(nrow)
  real ( kind = 8 ) dbiatx(kpm,*)
  real ( kind = 8 ) dx
  integer ( kind = 4 ) i
  integer ( kind = 4 ) irow
  integer ( kind = 4 ) iside
  integer ( kind = 4 ) itermx
  integer ( kind = 4 ) j
  integer ( kind = 4 ) k
  integer ( kind = 4 ) ll
  integer ( kind = 4 ) lowrow
  integer ( kind = 4 ) m
  integer ( kind = 4 ) mode
  integer ( kind = 4 ) mp1
  real ( kind = 8 ) q(nrow,kpm)
  real ( kind = 8 ) rho
  real ( kind = 8 ) scrtch(kpm,kpm)
  real ( kind = 8 ) sum1
  real ( kind = 8 ) t(left+kpm)
  real ( kind = 8 ) v(20)
  real ( kind = 8 ) xm
  real ( kind = 8 ) xside
  real ( kind = 8 ) xx

  save / other /
  save / side /

  common / other / itermx, k, rho(19)
  common / side / m, iside, xside(10)

  mp1 = m + 1
  
  q(1:nrow,1:kpm) = 0.0D+00
  
  xm = ( t(left+1) + t(left) ) / 2.0D+00
  dx = ( t(left+1) - t(left) ) / 2.0D+00

  ll = 1
  lowrow = iside

  do irow = lowrow, nrow

    if ( k < ll ) then
      go to 20
    end if

    mode = 2
!
!  Next collocation point:
!
    xx = xm + dx * rho(ll)
    ll = ll + 1
!
!  The corresponding collocation equation is next unless the next side
!  condition occurs at a point at, or to the left of, the next
!  collocation point.
!
    if ( m < iside ) then
      go to 30
    end if

    if ( xx < xside(iside) ) then
      go to 30
    end if

    ll = ll - 1

   20   continue

    mode = 3
    xx = xside(iside)

   30   continue

    call difequ ( mode, xx, v )
!
!  The next equation, a collocation equation (MODE=2) or a side
!  condition (MODE=3), reads
!
!    (*)   (V(M+1)*D^M+V(M)*D^(M-1) +...+ V(1)*D^0)F(XX) = V(M+2)
!
!  in terms of the information supplied by DIFEQU. 
!
!  The corresponding equation for the B-spline coefficients of F therefore
!  has the left side of (*), evaluated at each of the KPM B-splines having
!  XX in their support, as its KPM possibly nonzero coefficients.
!
    call bsplvd ( t, kpm, xx, left, scrtch, dbiatx, mp1 )
    
    do j = 1, kpm
    
      q(irow,j) = dot_product ( dbiatx(j,1:mp1), v(1:mp1) )
            
    end do
   
    b(irow) = v(m+2)
    
  end do
   
  return
end
subroutine r8vec_print ( n, a, title )

!*****************************************************************************80
!
!! R8VEC_PRINT prints an R8VEC.
!
!  Discussion:
!
!    An R8VEC is an array of double precision real values.
!
!  Modified:
!
!    22 August 2000
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of components of the vector.
!
!    Input, real ( kind = 8 ) A(N), the vector to be printed.
!
!    Input, character ( len = * ) TITLE, an optional title.
!
  implicit none

  integer ( kind = 4 ) n

  real ( kind = 8 ) a(n)
  integer ( kind = 4 ) i
  character ( len = * ) title

  if ( 0 < len_trim ( title ) ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) trim ( title )
  end if

  write ( *, '(a)' ) ' '
  do i = 1, n
    write ( *, '(2x,i8,2x,g16.8)' ) i, a(i)
  end do

  return
end
function round ( x, size )

!*****************************************************************************80
!
!! ROUND is called to add some noise to data.
!
!  Discussion:
!
!    This function simply adds plus or minus a perturbation value
!    to the input data.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input. real ( kind = 8 ) X, the value to be perturbed.
!
!    Input, real ( kind = 8 ) SIZE, the size of the perturbation.
!
!    Output, real ( kind = 8 ) ROUND, the perturbed value.
!
  implicit none

  real ( kind = 8 ), save :: flip = -1.0D+00
  real ( kind = 8 ) round
  real ( kind = 8 ) size
  real ( kind = 8 ) x

  flip = -flip
  round = x + flip * size

  return
end
subroutine sbblok ( bloks, integs, nbloks, ipivot, b, x )

!*****************************************************************************80
!
!! SBBLOK solves a linear system that was factored by FCBLOK.
!
!  Discussion:
!
!    The routine supervises the solution, by forward and backward 
!    substitution, of the linear system 
!      A * x = b
!    for X, with the PLU factorization of A already generated in FCBLOK.
!    Individual blocks of equations are solved via SUBFOR and SUBBAK.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) BLOKS(*), integer INTEGS(3,NBLOKS), integer
!    NBLOKS, integer IPIVOT(*), are as on return from FCBLOK.
!
!    Input, real ( kind = 8 ) B(*), the right hand side, stored corresponding 
!    to the storage of the equations.  See comments in SLVBLK for details.
!
!    Output, real ( kind = 8 ) X(*), the solution vector.
!
  implicit none

  integer ( kind = 4 ) nbloks

  real ( kind = 8 ) b(*)
  real ( kind = 8 ) bloks(*)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) index
  integer ( kind = 4 ) indexb
  integer ( kind = 4 ) indexx
  integer ( kind = 4 ) integs(3,nbloks)
  integer ( kind = 4 ) ipivot(*)
  integer ( kind = 4 ) j
  integer ( kind = 4 ) last
  integer ( kind = 4 ) nbp1
  integer ( kind = 4 ) ncol
  integer ( kind = 4 ) nrow
  real ( kind = 8 ) x(*)
!
!  Forward substitution:
!
  index = 1
  indexb = 1
  indexx = 1

  do i = 1, nbloks

    nrow = integs(1,i)
    last = integs(3,i)

    call subfor ( bloks(index), ipivot(indexb), nrow, last, b(indexb), &
      x(indexx) )

    index = nrow * integs(2,i) + index
    indexb = indexb + nrow
    indexx = indexx + last

  end do
!
!  Back substitution.
!
  nbp1 = nbloks + 1

  do j = 1, nbloks

    i = nbp1 - j
    nrow = integs(1,i)
    ncol = integs(2,i)
    last = integs(3,i)
    index = index - nrow * ncol
    indexb = indexb - nrow
    indexx = indexx - last

    call subbak ( bloks(index), ipivot(indexb), nrow, ncol, last, x(indexx) )

  end do
   
  return
end
subroutine setupq ( x, dx, y, npoint, v, qty )

!*****************************************************************************80
!
!! SETUPQ is to be called in SMOOTH.
!
!  Discussion:
!
!    Put DELX = X(*+1) - X(*) into V(*,4).
!
!    Put the three bands of Q' * D into V(*,1:3).
!
!    Put the three bands of ( D * Q )' * ( D * Q ) at and above the diagonal
!    into V(*,5:7).
!
!    Here, Q is the tridiagonal matrix of order ( NPOINT-2, NPOINT )
!    with general row 
!      1/DELX(I), -1/DELX(I)-1/DELX(I+1), 1/DELX(I+1)
!    and D is the diagonal matrix with general row DX(I).
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) X(NPOINT), the abscissas, assumed to be 
!    strictly increasing.
!
!    Input, real ( kind = 8 ) DX(NPOINT), the data uncertainty estimates,
!    which are assumed to be positive.
!
!    Input, real ( kind = 8 ) Y(NPOINT), the corresponding ordinates.
!
!    Input, integer ( kind = 4 ) NPOINT, the number of data points.
!
!    Output, real ( kind = 8 ) V(NPOINT,7), contains data needed for
!    the smoothing computation.
!
!    Output, real ( kind = 8 ) QTY(NPOINT), the value of Q' * Y.
!
  implicit none

  integer ( kind = 4 ) npoint

  real ( kind = 8 ) diff
  real ( kind = 8 ) dx(npoint)
  integer ( kind = 4 ) i
  real ( kind = 8 ) prev
  real ( kind = 8 ) qty(npoint)
  real ( kind = 8 ) v(npoint,7)
  real ( kind = 8 ) x(npoint)
  real ( kind = 8 ) y(npoint)

  v(1:npoint-1,4) = x(2:npoint) - x(1:npoint-1)

  v(2:npoint-1,1) = dx(1:npoint-2) / v(1:npoint-2,4)  
  v(npoint,1) = 0.0D+00

  v(2:npoint-1,2) = - dx(2:npoint-1) / v(2:npoint-1,4) &
                    - dx(2:npoint-1) / v(1:npoint-2,4)

  v(2:npoint-1,3) = dx(3:npoint) / v(2:npoint-1,4)
   
  v(2:npoint-1,5) = v(2:npoint-1,1)**2 &
                  + v(2:npoint-1,2)**2 &
                  + v(2:npoint-1,3)**2
   
  v(2:npoint-2,6) = v(2:npoint-2,2) * v(3:npoint-1,1) &
                  + v(2:npoint-2,3) * v(3:npoint-1,2)
  v(npoint-1,6) = 0.0D+00

  v(2:npoint-3,7) = v(2:npoint-3,3) * v(4:npoint-1,1)   
  v(npoint-2,7) = 0.0D+00
  v(npoint-1,7) = 0.0D+00
!
!  Construct Q' * Y in QTY.
!
  prev = ( y(2) - y(1) ) / v(1,4)
  do i = 2, npoint - 1
    diff = ( y(i+1) - y(i) ) / v(i,4)
    qty(i) = diff - prev
    prev = diff
  end do
  
  return
end
subroutine shiftb ( ai, ipivot, nrowi, ncoli, last, ai1, nrowi1, ncoli1 )

!*****************************************************************************80
!
!! SHIFTB shifts the rows in the current block.
!
!  Discussion:
!
!    This routine shifts rows in the current block, AI, which are not used 
!    as pivot rows, if any, that is, rows IPIVOT(LAST+1) through IPIVOT(NROWI), 
!    onto the first MMAX = NROW - LAST rows of the next block, AI1, 
!    with column LAST + J of AI going to column J, 
!    for J = 1,..., JMAX = NCOLI - LAST.
!
!    The remaining columns of these rows of AI1 are zeroed out.
!
!  Diagram:
!
!       Original situation after         Results in a new block I+1
!       LAST = 2 columns have been       created and ready to be
!       done in FACTRB, assuming no      factored by next FACTRB call.
!       interchanges of rows.
!
!                   1
!              X  X 1X  X  X           X  X  X  X  X
!                   1
!              0  X 1X  X  X           0  X  X  X  X
!  BLOCK I          1                       ---------------
!  NROWI=4     0  0 1X  X  X           0  0 1X  X  X  0  01
!  NCOLI=5          1                       1             1
!  LAST=2      0  0 1X  X  X           0  0 1X  X  X  0  01
!              -------------------          1             1   NEW
!                   1X  X  X  X  X          1X  X  X  X  X1  BLOCK
!                   1                       1             1   I+1
!  BLOCK I+1        1X  X  X  X  X          1X  X  X  X  X1
!  NROWI1= 5        1                       1             1
!  NCOLI1= 5        1X  X  X  X  X          1X  X  X  X  X1
!              -------------------          1-------------1
!                   1
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) AI(NROWI,NCOLI), the current block.
!
!    Input, integer ( kind = 4 ) IPIVOT(NROWI), the pivot vector.
!
!    Input, integer ( kind = 4 ) NROWI, NCOLI, the number of rows and columns
!    in block AI.
!
!    Input, integer ( kind = 4 ) LAST, indicates the last row on which pivoting
!    has been carried out.
!
!    Input/output, real ( kind = 8 ) AI1(NROWI1,NCOLI1), the next block.
!
!    Input, integer ( kind = 4 ) NROWI1, NCOLI1, the number of rows and columns
!    in block AI1.
!
  implicit none

  integer ( kind = 4 ) ncoli
  integer ( kind = 4 ) ncoli1
  integer ( kind = 4 ) nrowi1
  integer ( kind = 4 ) nrowi

  real ( kind = 8 ) ai(nrowi,ncoli)
  real ( kind = 8 ) ai1(nrowi1,ncoli1)
  integer ( kind = 4 ) ip
  integer ( kind = 4 ) ipivot(nrowi)
  integer ( kind = 4 ) j
  integer ( kind = 4 ) last
  integer ( kind = 4 ) m

  if ( nrowi - last < 1 ) then
    return
  end if

  if ( ncoli - last < 1 ) then
    return
  end if
!
!  Put the remainder of block I into AI1.
!
  do m = 1, nrowi - last
    ip = ipivot(last+m)
    do j = 1, ncoli - last
      ai1(m,j) = ai(ip,last+j)
    end do
  end do
!
!  Zero out the upper right corner of AI1.
!
  do j = ncoli + 1 - last, ncoli1
    do m = 1, nrowi - last
      ai1(m,j) = 0.0D+00
    end do
  end do
  
  return
end
subroutine slvblk ( bloks, integs, nbloks, b, ipivot, x, iflag )

!*****************************************************************************80
!
!! SLVBLK solves the almost block diagonal linear system A * x = b.  
!
!  Discussion:
!
!    Such almost block diagonal matrices arise naturally in piecewise 
!    polynomial interpolation or approximation and in finite element 
!    methods for two-point boundary value problems.  The PLU factorization 
!    method is implemented here to take advantage of the special structure 
!    of such systems for savings in computing time and storage requirements.
!
!    SLVBLK relies on several auxiliary programs:
!
!    FCBLOK (BLOKS,INTEGS,NBLOKS,IPIVOT,SCRTCH,IFLAG)  
!    factors the matrix A.
!
!    SBBLOK (BLOKS,INTEGS,NBLOKS,IPIVOT,B,X)
!    solves the system A*X=B once A is factored.
!
!    DTBLOK (BLOKS,INTEGS,NBLOKS,IPIVOT,IFLAG,DETSGN,DETLOG) 
!    computes the determinant of A once it has been factored.
!
!  Block structure of A:
!
!    The NBLOKS blocks are stored consecutively in the array BLOKS.
!
!    The first block has its (1,1)-entry at BLOKS(1), and, if the I-th
!    block has its (1,1)-entry at BLOKS(INDEX(I)), then
!
!      INDEX(I+1) = INDEX(I) + NROW(I) * NCOL(I).
!
!    The blocks are pieced together to give the interesting part of A
!    as follows.  For I=1,2,..., NBLOKS-1, the (1,1)-entry of the next
!    block (the (I+1)st block) corresponds to the (LAST+1,LAST+1)-entry
!    of the current I-th block.  Recall LAST = INTEGS(3,I) and note that
!    this means that
!
!    A: every block starts on the diagonal of A.
!
!    B: the blocks overlap (usually). the rows of the (I+1)st block
!       which are overlapped by the I-th block may be arbitrarily 
!       defined initially.  They are overwritten during elimination.
!
!    The right hand side for the equations in the I-th block are stored
!    correspondingly as the last entries of a piece of B of length NROW
!    (= INTEGS(1,I)) and following immediately in B the corresponding
!    piece for the right hand side of the preceding block, with the right 
!    hand side for the first block starting at B(1).  In this, the right 
!    hand side for an equation need only be specified once on input, 
!    in the first block in which the equation appears.
!
!  Example:
!
!    The test driver for this package contains an example, a linear
!    system of order 11, whose nonzero entries are indicated in the
!    following diagram by their row and column index modulo 10.  Next to it
!    are the contents of the INTEGS arrray when the matrix is taken to
!    be almost block diagonal with NBLOKS = 5, and below it are the five
!    blocks.
!
!                        NROW1 = 3, NCOL1 = 4
!             11 12 13 14
!             21 22 23 24   NROW2 = 3, NCOL2 = 3
!             31 32 33 34
!    LAST1 = 2      43 44 45
!                   53 54 55            NROW3 = 3, NCOL3 = 4
!          LAST2 = 3         66 67 68 69   NROW4 = 3, NCOL4 = 4
!                            76 77 78 79      NROW5 = 4, NCOL5 = 4
!                            86 87 88 89
!                   LAST3 = 1   97 98 99 90
!                      LAST4 = 1   08 09 00 01
!                                  18 19 10 11
!                         LAST5 = 4
!
!    Actual input to BLOKS shown by rows of blocks of A.
!    The ** items are arbitrary.
!
!    11 12 13 14  / ** ** **  / 66 67 68 69  / ** ** ** **  / ** ** ** **
!    21 22 23 24 /  43 44 45 /  76 77 78 79 /  ** ** ** ** /  ** ** ** **
!    31 32 33 34/   53 54 55/   86 87 88 89/   97 98 99 90/   08 09 00 01
!                                                             18 19 10 11
!
!    INDEX = 1      INDEX = 13  INDEX = 22     INDEX = 34     INDEX = 46
!
!    Actual right hand side values with ** for arbitrary values:
!
!      B1 B2 B3 ** B4 B5 B6 B7 B8 ** ** B9 ** ** B10 B11
!
!    It would have been more efficient to combine block 3 with block 4.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input/output, real ( kind = 8 ) BLOKS(*), a one-dimenional array, 
!    of length sum ( INTEGS(1,1:NBLOKS) * INTEGS(2,1:NBLOKS) ).
!    On input, contains the blocks of the almost block diagonal matrix A.  
!    The array INTEGS describes the block structure.
!    On output, contains correspondingly the PLU factorization
!    of A, if IFLAG /= 0.  Certain entries in BLOKS are arbitrary, 
!    where the blocks overlap.
!
!    Input, integer ( kind = 4 ) INTEGS(3,NBLOKS), description of the block 
!    structure of A.
!    integs(1,I) = number of rows of block I = nrow;
!    integs(2,I) = number of colums of block I = ncol;
!    integs(3,I) = number of elimination steps in block I = last.
!    The linear system is of order n = sum ( integs(3,i), i=1,...,nbloks ),
!    but the total number of rows in the blocks is
!    nbrows=sum( integs(1,i) ; i = 1,...,nbloks)
!
!    Input, integer ( kind = 4 ) NBLOKS, the number of blocks.
!
!    Input, real ( kind = 8 ) B(NBROWS), the right hand side.  Certain entries 
!    are arbitrary, corresponding to rows of the blocks which overlap.  See 
!    the block structure in the example.
!
!    Output, integer ( kind = 4 ) IPIVOT(NBROWS), the pivoting sequence used.
!
!    Output, real ( kind = 8 ) X(N), the computed solution, if iflag /= 0.
!
!    Output, integer ( kind = 4 ) IFLAG.
!    = (-1)^(number of interchanges during factorization) if A is invertible;
!    = 0 if A is singular.
!
  implicit none

  integer ( kind = 4 ) nbloks

  real ( kind = 8 ) b(*)
  real ( kind = 8 ) bloks(*)
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) integs(3,nbloks)
  integer ( kind = 4 ) ipivot(*)
  real ( kind = 8 ) x(*)
!
!  In the call to FCBLOK, X is used for temporary storage.
!
  call fcblok ( bloks, integs, nbloks, ipivot, x, iflag )
  
  if ( iflag == 0 ) then
    return
  end if
  
  call sbblok ( bloks, integs, nbloks, ipivot, b, x )
  
  return
end
function smooth ( x, y, dy, npoint, s, v, a )

!*****************************************************************************80
!
!! SMOOTH constructs the cubic smoothing spline to given data.
!
!  Discussion:
!
!    The data is of the form
!      ( X(1:NPOINT), Y(1:NPOINT) )
!
!    The cubic smoothing spline has as small a second derivative as
!    possible, while
!      S(F) <= S,
!    where
!      S(F) = sum ( 1 <= I <= NPOINT ) ( ( ( Y(I) - F(X(I)) ) / DY(I) )^2.
!
!  Method:
!
!    The matrices Q' * D and Q' * D^2 * Q are constructed in SETUPQ from
!    X and DY, as is the vector QTY = Q' * Y.
!
!    Then, for given P, the vector U is determined in CHOL1D as
!    the solution of the linear system
!      ( 6 * (1-P) * Q' * D^2 * Q + P * R ) * U = QTY.
!
!    From U and this choice of smoothing parameter P, the smoothing spline F
!    is obtained in the sense that:
!            F(X(.)) = Y - 6 (1-P) D^2 * Q * U,
!      (d^2) F(X(.)) = 6 * P * U.
!
!    The smoothing parameter P is found, if possible, so that
!      SF(P) = S,
!    with SF(P) = S(F), where F is the smoothing spline as it depends
!    on P.  If S = 0, then P = 1.  If SF(0) <= S, then P = 0.
!    Otherwise, the secant method is used to locate an appropriate P in
!    the open interval (0,1).
!
!    Specifically,
!      P(0) = 0,  P(1) = ( S - SF(0) ) / DSF
!    with
!      DSF = -24 * U' * R * U
!    a good approximation to
!      D(SF(0)) = DSF + 60 * (D*Q*U)' * (D*Q*U),
!    and U as obtained for P = 0.
!
!    After that, for N = 1, 2,...  until SF(P(N)) <= 1.01 * S, do:
!    determine P(N+1) as the point at which the secant to SF at the
!    points P(N) and P(N-1) takes on the value S.
!
!    If 1 <= P(N+1), choose instead P(N+1) as the point at which
!    the parabola SF(P(N))*((1-.)/(1-P(N)))^2 takes on the value S.
!
!    Note that, in exact arithmetic, it is always the case that
!      P(N+1) < P(N),
!    hence
!      SF(P(N+1)) < SF(P(N)).
!
!    Therefore, also stop the iteration, with final P = 1, in case
!      SF(P(N)) <= SF(P(N+1)).
!
!  Modified:
!
!    16 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) X(NPOINT), the abscissas, assumed to be
!    strictly increasing.
!
!    Input, real ( kind = 8 ) Y(NPOINT), the corresponding ordinates.
!
!    Input, real ( kind = 8 ) DY(NPOINT), the data uncertainty estimates,
!    which are assumed to be positive.
!
!    Input, integer ( kind = 4 ) NPOINT, the number of data points.
!
!    Input, real ( kind = 8 ) S, an upper bound on the discrete weighted mean
!    square distance of the approximation F from the data.
!
!    Workspace, real ( kind = 8 ) V(NPOINT,7).
!
!    Workspace, real ( kind = 8 ) A(NPOINT,4).
!
!    Output, real ( kind = 8 ) A(NPOINT,4).
!    A(*,1).....contains the sequence of smoothed ordinates.
!    A(I,J) = d^(J-1) F(X(I)), for J = 2:4, I = 1:NPOINT-1.
!    That is, the first three derivatives of the smoothing spline F at the
!    left end of each of the data intervals.  Note that A would have to
!    be transposed before it could be used in PPVALU.
!
!    Output, real ( kind = 8 ) SMOOTH, the value of the smoothing parameter.
!
  implicit none

  integer ( kind = 4 ) npoint

  real ( kind = 8 ) a(npoint,4)
  real ( kind = 8 ) change
  real ( kind = 8 ) dy(npoint)
  integer ( kind = 4 ) i
  real ( kind = 8 ) oosf
  real ( kind = 8 ) ooss
  real ( kind = 8 ) p
  real ( kind = 8 ) prevq
  real ( kind = 8 ) prevsf
  real ( kind = 8 ) q
  real ( kind = 8 ) s
  real ( kind = 8 ) sfq
  real ( kind = 8 ) smooth
  real ( kind = 8 ) utru
  real ( kind = 8 ) v(npoint,7)
  real ( kind = 8 ) x(npoint)
  real ( kind = 8 ) y(npoint)

  call setupq ( x, dy, y, npoint, v, a(1,4) )

  if ( s <= 0.0D+00 ) then

    p = 1.0D+00
    call chol1d ( p, v, a(1,4), npoint, 1, a(1,3), a(1,1) )
    sfq = 0.0D+00

  else

    p = 0.0D+00
    call chol1d ( p, v, a(1,4), npoint, 1, a(1,3), a(1,1) )

    sfq = 36.0D+00 * dot_product ( a(1:npoint,1)**2, dy(1:npoint)**2 )

    if ( s < sfq ) then

      utru = 0.0D+00
      do i = 2, npoint
        utru = utru + v(i-1,4) * ( a(i-1,3) * ( a(i-1,3) + a(i,3) ) &
          + a(i,3)**2 )
      end do

      ooss = 1.0D+00 / sqrt ( s )
      oosf = 1.0D+00 / sqrt ( sfq )
      q = - ( oosf - ooss ) * sfq / ( 6.0D+00 * utru * oosf )
!
!  Secant iteration for the determination of P starts here.
!
      prevq = 0.0D+00
      prevsf = oosf

      do

        call chol1d ( q / ( 1.0D+00 + q ), v, a(1,4), npoint, 1, &
          a(1,3), a(1,1) )

        sfq = 36.0D+00 * dot_product ( a(1:npoint,1)**2, dy(1:npoint)**2 ) &
          / ( 1.0D+00 + q )**2

        if ( abs ( sfq - s ) <= 0.01D+00 * s ) then
          exit
        end if

        oosf = 1.0D+00 / sqrt ( sfq )
        change = ( q - prevq ) / ( oosf - prevsf ) * ( oosf - ooss )
        prevq = q
        q = q - change
        prevsf = oosf

      end do

      p = q / ( 1.0D+00 + q )

    end if

  end if
!
!  Correct value of P has been found.
!  Compute polynomial coefficients from Q * U in A(.,1).
!
  smooth = sfq

  a(1:npoint,1) = y(1:npoint) - 6.0D+00 * ( 1.0D+00 - p ) &
    * dy(1:npoint)**2 * a(1:npoint,1)

  a(1:npoint,3) = a(1:npoint,3) * 6.0D+00 * p

  do i = 1, npoint - 1
    a(i,4) = ( a(i+1,3) - a(i,3) ) / v(i,4)
    a(i,2) = ( a(i+1,1) - a(i,1) ) / v(i,4) &
      - ( a(i,3) + a(i,4) / 3.0D+00 * v(i,4) ) / 2.0D+00 * v(i,4)
  end do

  return
end
subroutine spli2d ( tau, gtau, t, n, k, m, work, q, bcoef, iflag )

!*****************************************************************************80
!
!! SPLI2D produces a interpolatory tensor product spline.
!
!  Discussion:
!
!    SPLI2D is an extended version of SPLINT.
!
!    SPLI2D produces the B-spline coefficients BCOEF(J,.) of the 
!    spline of order K with knots T(1:N+K), which takes on 
!    the value GTAU(I,J) at TAU(I), I=1,..., N, J=1,...,M.
! 
!    The I-th equation of the linear system 
!      A * BCOEF = B  
!    for the B-spline coefficients of the interpolant enforces 
!    interpolation at TAU(I), I=1,...,N.  Hence,  B(I) = GTAU(I), 
!    for all I, and A is a band matrix with 2*K-1 bands, if it is 
!    invertible.
! 
!    The matrix A is generated row by row and stored, diagonal by
!    diagonal, in the rows of the array Q, with the main diagonal
!    going into row K.
! 
!    The banded system is then solved by a call to BANFAC, which 
!    constructs the triangular factorization for A and stores it 
!    again in Q, followed by a call to BANSLV, which then obtains 
!    the solution BCOEF by substitution.
!
!     The linear system to be solved is theoretically invertible if
!     and only if 
!       T(I) < TAU(I) < TAU(I+K), for all I.
!     Violation of this condition is certain to lead to IFLAG = 2.
! 
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) TAU(N), contains the data point abscissas.
!    TAU must be strictly increasing
! 
!    Input, real ( kind = 8 ) GTAU(N,M), contains the data point ordinates.
! 
!    Input, real ( kind = 8 ) T(N+K), the knot sequence.
! 
!    Input, integer ( kind = 4 ) N, the number of data points and the 
!    dimension of the spline space SPLINE(K,T)
! 
!    Input, integer ( kind = 4 ) K, the order of the spline.
! 
!    Input, integer ( kind = 4 ) M, the number of data sets.
!
!    Work space, real ( kind = 8 ) WORK(N).
! 
!    Output, real ( kind = 8 ) Q(2*K-1)*N, the triangular 
!    factorization of the coefficient matrix of the linear 
!    system for the B-spline coefficients of the spline interpolant.
!    The B-spline coefficients for the interpolant of an additional 
!    data set ( TAU(I), HTAU(I) ), I=1,...,N  with the same data 
!    abscissae can be obtained without going through all the 
!    calculations in this routine, simply by loading HTAU into 
!    BCOEF and then using the statement
!      CALL BANSLV ( Q, 2*K-1, N, K-1, K-1, BCOEF )
! 
!    Output, real ( kind = 8 ) BCOEF(N), the B-spline coefficients of
!    the interpolant.
! 
!    Output, integer ( kind = 4 ) IFLAG, error indicator.
!    1, no error.   
!    2, an error occurred, which may have been caused by 
!       singularity of the linear system.
!
  implicit none

  integer ( kind = 4 ) m
  integer ( kind = 4 ) n

  real ( kind = 8 ) bcoef(m,n)
  real ( kind = 8 ) gtau(n,m)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) ilp1mx
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jj
  integer ( kind = 4 ) k
  integer ( kind = 4 ) left
  real ( kind = 8 ) q((2*k-1)*n)
  real ( kind = 8 ) t(n+k)
  real ( kind = 8 ) tau(n)
  real ( kind = 8 ) taui
  real ( kind = 8 ) work(n)

  left = k
  
  q(1:(2*k-1)*n) = 0.0D+00
!
!  Construct the N interpolation equations.
!
  do i = 1, n
  
    taui = tau(i)
    ilp1mx = min ( i + k, n + 1 )
!
!  Find the index LEFT in the closed interval (I,I+K-1) such that:
!
!    T(LEFT) < = TAU(I) < T(LEFT+1)
!
!  The matrix will be singular if this is not possible.
!
    left = max ( left, i )
    
    if ( taui < t(left) ) then
      iflag = 2
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'SPLI2D - Fatal error!'
      write ( *, '(a)' ) '  The TAU array is not strictly increasing.'
      stop 1
    end if
   
    do while ( t(left+1) <= taui )
   
      left = left + 1

      if ( left < ilp1mx ) then
        cycle
      end if
    
      left = left - 1
    
      if ( t(left+1) < taui ) then
        iflag = 2
        write ( *, '(a)' ) ' '
        write ( *, '(a)' ) 'SPLI2D - Fatal error!'
        write ( *, '(a)' ) '  The TAU array is not strictly increasing.'
        stop 1
      end if
 
      exit

    end do
!
!  The I-th equation enforces interpolation at TAUI, hence
!
!    A(I,J) = B(J,K,T)(TAUI), for all J. 
!
!  Only the K entries with J = LEFT-K+1, ..., LEFT actually might be 
!  nonzero.  These K numbers are returned, in WORK (used for 
!  temporary storage here), by the following call:
!
    call bsplvb ( t, k, 1, taui, left, work )
!
!  We therefore want  
!    WORK(J) = B(LEFT-K+J)(TAUI) 
!  to go into
!    A(I,LEFT-K+J),
!
!  that is, into  Q(I-(LEFT+J)+2*K,(LEFT+J)-K) since
!  A(I+J,J) is to go into Q(I+K,J), for all I, J, if we consider Q
!  as a two-dimensional array, with  2*K-1 rows.  See comments in
!  BANFAC.
!
!  In the present program, we treat Q as an equivalent one-dimensional 
!  array, because of fortran restrictions on dimension statements.  
!
!  We therefore want WORK(J) to go into the entry of Q with index:
!    I -(LEFT+J)+2*K + ((LEFT+J)-K-1)*(2*K-1)
!    = I-LEFT+1+(LEFT -K)*(2*K-1) + (2*K-2)*J
!
    jj = i - left + 1 + ( left - k ) * ( k + k - 1 )
    
    do j = 1, k
      jj = jj + k + k - 2
      q(jj) = work(j)
    end do
    
  end do
!
!  Factor A, stored again in Q.
!
  call banfac ( q, k+k-1, n, k-1, k-1, iflag )
  
  if ( iflag == 2 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLI2D - Fatal error!'
    write ( *, '(a)' ) '  BANFAC reports that the matrix is singular.'
    stop 1
  end if
!
!  Solve 
!    A * BCOEF = GTAU 
!  by back substitution.
!
  do j = 1, m
   
    work(1:n) = gtau(1:n,j)
   
    call banslv ( q, k+k-1, n, k-1, k-1, work )
    
    bcoef(j,1:n) = work(1:n)
    
  end do
   
  return
end
subroutine splint ( tau, gtau, t, n, k, q, bcoef, iflag )

!*****************************************************************************80
!
!! SPLINT produces the B-spline coefficients BCOEF of an interpolating spline.
!
!  Discussion:
!
!    The spline is of order K with knots T(1:N+K), and takes on the 
!    value GTAU(I) at TAU(I), for I = 1 to N.
!
!    The I-th equation of the linear system 
!      A * BCOEF = B 
!    for the B-spline coefficients of the interpolant enforces interpolation
!    at TAU(1:N).
!
!    Hence, B(I) = GTAU(I), for all I, and A is a band matrix with 2*K-1
!    bands, if it is invertible.
!
!    The matrix A is generated row by row and stored, diagonal by diagonal,
!    in the rows of the array Q, with the main diagonal going
!    into row K.  See comments in the program.
!
!    The banded system is then solved by a call to BANFAC, which 
!    constructs the triangular factorization for A and stores it again in
!    Q, followed by a call to BANSLV, which then obtains the solution
!    BCOEF by substitution.
!
!    BANFAC does no pivoting, since the total positivity of the matrix
!    A makes this unnecessary.
!
!    The linear system to be solved is (theoretically) invertible if
!    and only if
!      T(I) < TAU(I) < TAU(I+K), for all I.
!    Violation of this condition is certain to lead to IFLAG = 2.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) TAU(N), the data point abscissas.  The entries in
!    TAU should be strictly increasing.
!
!    Input, real ( kind = 8 ) GTAU(N), the data ordinates.
!
!    Input, real ( kind = 8 ) T(N+K), the knot sequence.
!
!    Input, integer ( kind = 4 ) N, the number of data points.
!
!    Input, integer ( kind = 4 ) K, the order of the spline.
!
!    Output, real ( kind = 8 ) Q((2*K-1)*N), the triangular factorization
!    of the coefficient matrix of the linear system for the B-coefficients 
!    of the spline interpolant.  The B-coefficients for the interpolant 
!    of an additional data set can be obtained without going through all 
!    the calculations in this routine, simply by loading HTAU into BCOEF 
!    and then executing the call:
!      call banslv ( q, 2*k-1, n, k-1, k-1, bcoef )
!
!    Output, real ( kind = 8 ) BCOEF(N), the B-spline coefficients of 
!    the interpolant.
!
!    Output, integer ( kind = 4 ) IFLAG, error flag.
!    1, = success.
!    2, = failure.
!
  implicit none

  integer ( kind = 4 ) n

  real ( kind = 8 ) bcoef(n)
  real ( kind = 8 ) gtau(n)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) ilp1mx
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jj
  integer ( kind = 4 ) k
  integer ( kind = 4 ) kpkm2
  integer ( kind = 4 ) left
  real ( kind = 8 ) q((2*k-1)*n)
  real ( kind = 8 ) t(n+k)
  real ( kind = 8 ) tau(n)
  real ( kind = 8 ) taui

  kpkm2 = 2 * ( k - 1 )
  left = k
  q(1:(2*k-1)*n) = 0.0D+00
!
!  Loop over I to construct the N interpolation equations.
!
  do i = 1, n
  
    taui = tau(i)
    ilp1mx = min ( i + k, n + 1 )
!
!  Find LEFT in the closed interval (I,I+K-1) such that
!
!    T(LEFT) <= TAU(I) < T(LEFT+1)
!
!  The matrix is singular if this is not possible.
!
    left = max ( left, i )

    if ( taui < t(left) ) then
      iflag = 2
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'SPLINT - Fatal Error!'
      write ( *, '(a)' ) '  The linear system is not invertible!'
      return
    end if

    do while ( t(left+1) <= taui )

      left = left + 1

      if ( left < ilp1mx ) then
        cycle
      end if

      left = left - 1

      if ( t(left+1) < taui ) then
        iflag = 2
        write ( *, '(a)' ) ' '
        write ( *, '(a)' ) 'SPLINT - Fatal Error!'
        write ( *, '(a)' ) '  The linear system is not invertible!'
        return
      end if

      exit

    end do
!
!  The I-th equation enforces interpolation at TAUI, hence for all J,
!    A(I,J) = B(J,K,T)(TAUI).
!
!  Only the K entries with J = LEFT-K+1,...,LEFT actually might be nonzero.
!
!  These K numbers are returned, in BCOEF (used for temporary storage here),
!  by the following.
!
    call bsplvb ( t, k, 1, taui, left, bcoef )
!
!  We therefore want BCOEF(J) = B(LEFT-K+J)(TAUI) to go into
!  A(I,LEFT-K+J), that is, into Q(I-(LEFT+J)+2*K,(LEFT+J)-K) since
!  A(I+J,J) is to go into Q(I+K,J), for all I, J, if we consider Q
!  as a two-dimensional array, with  2*K-1 rows.  See comments in
!  BANFAC.
!
!  In the present program, we treat Q as an equivalent
!  one-dimensional array, because of fortran restrictions on
!  dimension statements.
!
!  We therefore want  BCOEF(J) to go into the entry of Q with index:
!
!    I -(LEFT+J)+2*K + ((LEFT+J)-K-1)*(2*K-1)
!   = I-LEFT+1+(LEFT -K)*(2*K-1) + (2*K-2)*J
!
    jj = i - left + 1 + ( left - k ) * ( k + k - 1 )

    do j = 1, k
      jj = jj + kpkm2
      q(jj) = bcoef(j)
    end do
    
  end do
!
!  Obtain factorization of A, stored again in Q.
!
  call banfac ( q, k+k-1, n, k-1, k-1, iflag )
  
  if ( iflag == 2 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINT - Fatal Error!'
    write ( *, '(a)' ) '  The linear system is not invertible!'
    return
  end if
!
!  Solve 
!
!    A * BCOEF = GTAU
!
!  by back substitution.
!
  bcoef(1:n) = gtau(1:n)

  call banslv ( q, k+k-1, n, k-1, k-1, bcoef )

  return
end
subroutine splopt ( tau, n, k, scrtch, t, iflag )

!*****************************************************************************80
!
!! SPLOPT computes the knots for an optimal recovery scheme. 
!
!  Discussion:
!
!    The optimal recovery scheme is of order K for data at TAU(1:N).
!
!    The interior knots T(K+1:N) are determined by Newton's method in 
!    such a way that the signum function which changes sign at
!      T(K+1:N)  and nowhere else in ( TAU(1), TAU(N) ) is 
!    orthogonal to the spline space SPLINE ( K, TAU ) on that interval.
!
!    Let XI(J) be the current guess for T(K+J), J=1,...,N-K.  Then
!    the next Newton iterate is of the form
!      XI(J) + (-1)^(N-K-J)*X(J),  J=1,...,N-K,
!    with X the solution of the linear system
!      C * X = D.
!
!    Here, for all J,
!      C(I,J) = B(I)(XI(J)), 
!    with B(I) the I-th B-spline of order K for the knot sequence TAU, 
!    for all I, and D is the vector given, for each I, by
!      D(I) = sum ( -A(J), J=I,...,N ) * ( TAU(I+K) - TAU(I) ) / K,
!    with, for I = 1 to N-1:  
!      A(I) = sum ( (-1)^(N-K-J)*B(I,K+1,TAU)(XI(J)), J=1,...,N-K )
!    and  
!      A(N) = -0.5.
!
!    See Chapter XIII of text and references there for a derivation.
!
!    The first guess for T(K+J) is sum ( TAU(J+1:J+K-1) ) / ( K - 1 ).
!
!    The iteration terminates if max ( abs ( X(J) ) ) < TOL, with
!      TOL = TOLRTE * ( TAU(N) - TAU(1) ) / ( N - K ),
!    or else after NEWTMX iterations.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) TAU(N), the interpolation points.
!    assumed to be nondecreasing, with TAU(I) < TAU(I+K), for all I.
!
!    Input, integer ( kind = 4 ) N, the number of data points.
!
!    Input, integer ( kind = 4 ) K, the order of the optimal recovery scheme 
!    to be used.
!
!    Workspace, real ( kind = 8 ) SCRTCH((N-K)*(2*K+3)+5*K+3).  The various
!    contents are specified in the text below.
!
!    Output, real ( kind = 8 ) T(N+K), the optimal knots ready for
!    use in optimal recovery.  Specifically, T(1:K) = TAU(1), 
!    T(N+1:N+K) = TAU(N), while the N - K interior knots T(K+1:N) 
!    are calculated.
!
!    Output, integer ( kind = 4 ) IFLAG, error indicator.
!    = 1, success.  T contains the optimal knots.
!    = 2, failure.  K < 3 or N < K or the linear system was singular.
!
  implicit none

  integer ( kind = 4 ) k
  integer ( kind = 4 ) n

  real ( kind = 8 ) del
  real ( kind = 8 ) delmax
  real ( kind = 8 ) floatk
  integer ( kind = 4 ) i
  integer ( kind = 4 ) id
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) index
  integer ( kind = 4 ) j
  integer ( kind = 4 ) kp1
  integer ( kind = 4 ) kpkm1
  integer ( kind = 4 ) kpn
  integer ( kind = 4 ) l
  integer ( kind = 4 ) left
  integer ( kind = 4 ) leftmk
  integer ( kind = 4 ) lenw
  integer ( kind = 4 ) ll
  integer ( kind = 4 ) llmax
  integer ( kind = 4 ) llmin
  integer ( kind = 4 ) na
  integer ( kind = 4 ) nb
  integer ( kind = 4 ) nc
  integer ( kind = 4 ) nd
  integer ( kind = 4 ), parameter :: newtmx = 10
  integer ( kind = 4 ) newton
  integer ( kind = 4 ) nmk
  integer ( kind = 4 ) nx
  real ( kind = 8 ) scrtch((n-k)*(2*k+3)+5*k+3)
  real ( kind = 8 ) t(n+k)
  real ( kind = 8 ) tau(n)
  real ( kind = 8 ) sign
  real ( kind = 8 ) signst
  real ( kind = 8 ) sum1
  real ( kind = 8 ) tol
  real ( kind = 8 ), parameter :: tolrte = 0.000001D+00
  real ( kind = 8 ) xij

  nmk = n - k
  
  if ( n < k ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLOPT - Fatal error!'
    write ( *, '(a)' ) '  N < K.'
    iflag = 2
    return
  end if
  
  if ( n == k ) then
    t(1:k) = tau(1)
    t(n+1:n+k) = tau(n)
    return
  end if
  
  if ( k <= 2 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLOPT - Fatal error!'
    write ( *, '(a)' ) '  K < 2.'
    iflag = 2
    stop 1
  end if
 
  floatk = k
  kp1 = k + 1
  kpkm1 = k + k - 1
  kpn = k + n

  signst = -1.0D+00
  if ( ( nmk / 2 ) * 2 < nmk ) then
    signst = 1.0D+00
  end if
!
!  SCRTCH(I) = TAU-EXTENDED(I), I=1,...,N+K+K
!
  nx = n + k + k + 1
!
!  SCRTCH(I+NX) = XI(I), I=0,...,N-K+1
!
  na = nx + nmk + 1
!
!  SCRTCH(I+NA) = - A(I), I=1,...,N
!
  nd = na + n
!
!  SCRTCH(I+ND) = X(I) or D(I), I=1,...,N-K
!
  nb = nd + nmk
!
!  SCRTCH(I+NB) = BIATX(I), I=1,...,K+1
!
  nc = nb + kp1
!
!  SCRTCH(I+(J-1)*(2K-1)+NC) = W(I,J) = C(I-K+J,J), I=J-K,...,J+K,
!                                                     J=1,...,N-K.
!
  lenw = kpkm1 * nmk
!
!  Extend TAU to a knot sequence and store in SCRTCH.
!
  scrtch(1:k) = tau(1)
  scrtch(k+1:k+n) = tau(1:n)
  scrtch(kpn+1:kpn+k) = tau(n)
!
!  First guess for SCRTCH (.+NX) = XI.
!
  scrtch(nx) = tau(1)
  scrtch(nmk+1+nx) = tau(n)
 
  do j = 1, nmk 
    scrtch(j+nx) = sum ( tau(j+1:j+k-1) ) / real ( k - 1, kind = 8 )
  end do
!
!  Last entry of SCRTCH (.+NA) = -A  is always ...
!
  scrtch(n+na) = 0.5D+00
!
!  Start the Newton iteration.
!
  newton = 1
  tol = tolrte * ( tau(n) - tau(1) ) / real ( nmk, kind = 8 )
!
!  Start the Newton step.
!  Compute the 2*K-1 bands of the matrix C and store in SCRTCH(.+NC),
!  and compute the vector SCRTCH(.+NA) = -A.
!
  do newton = 1, newtmx

    scrtch(nc+1:nc+lenw) = 0.0D+00
    scrtch(na+1:na+n-1) = 0.0D+00
  
    sign = signst
    left = kp1
  
    do j = 1, nmk
  
      xij = scrtch(j+nx)

      do

        if ( xij < scrtch(left+1) ) then
          exit
        end if

        left = left + 1

        if ( kpn <= left ) then
          left = left - 1
          exit
        end if

      end do

      call bsplvb ( scrtch, k, 1, xij, left, scrtch(1+nb) )
!
!  The TAU sequence in SCRTCH is preceded by K additional knots.
!
!  Therefore, SCRTCH(LL+NB) now contains B(LEFT-2K+LL)(XIJ)
!  which is destined for C(LEFT-2K+LL,J), and therefore for
!
!    W(LEFT-K-J+LL,J)= SCRTCH(LEFT-K-J+LL+(J-1)*KPKM1 + NC)
!
!  since we store the 2*K-1 bands of C in the 2*K-1 rows of
!  the work array W, and W in turn is stored in SCRTCH,
!  with W(1,1) = SCRTCH(1+NC).
!
!  Also, C being of order N - K, we would want  
!    1 <= LEFT-2K+LL <= N - K or
!    LLMIN=2K-LEFT  <=  LL <= N-LEFT+K = LLMAX.
!
      leftmk = left - k
      index = leftmk - j + ( j - 1 ) * kpkm1 + nc
      llmin = max ( 1, k - leftmk )
      llmax = min ( k, n - leftmk )
      do ll = llmin, llmax
        scrtch(ll+index) = scrtch(ll+nb)
      end do
    
      call bsplvb ( scrtch, kp1, 2, xij, left, scrtch(1+nb) )

      id = max ( 0, leftmk - kp1 )
      llmin = 1 - min ( 0, leftmk - kp1 )
      do ll = llmin, kp1
        id = id + 1
        scrtch(id+na) = scrtch(id+na) - sign * scrtch(ll+nb)
      end do
    
      sign = - sign
    
    end do
  
    call banfac ( scrtch(1+nc), kpkm1, nmk, k-1, k-1, iflag )
  
    if ( iflag == 2 ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'SPLOPT - Fatal error!'
      write ( *, '(a)' ) '  Matrix C is not invertible.'
      stop 1
    end if
!
!  Compute SCRTCH(.+ND) = D from SCRTCH(.+NA) = -A.
!
    do i = n, 2, -1
      scrtch(i-1+na) = scrtch(i-1+na) + scrtch(i+na)
    end do
  
    do i = 1, nmk
      scrtch(i+nd) = scrtch(i+na) * ( tau(i+k) - tau(i) ) / floatk
    end do
!
!  Compute SCRTCH(.+ND)= X.
!
    call banslv ( scrtch(1+nc), kpkm1, nmk, k-1, k-1, scrtch(1+nd) )
!
!  Compute SCRTCH(.+ND) = change in XI.  Modify, if necessary, to
!  prevent new XI from moving more than 1/3 of the way to its
!  neighbors.  Then add to XI to obtain new XI in SCRTCH(.+NX).
!
    delmax = 0.0D+00
    sign = signst

    do i = 1, nmk

      del = sign * scrtch(i+nd)
      delmax = max ( delmax, abs ( del ) )

      if ( 0.0D+00 < del ) then
        del = min ( del, ( scrtch(i+1+nx) - scrtch(i+nx) ) / 3.0D+00 )
      else
        del = max ( del, ( scrtch(i-1+nx) - scrtch(i+nx) ) / 3.0D+00 )
      end if

      sign = - sign
      scrtch(i+nx) = scrtch(i+nx) + del

    end do
!
!  Call it a day in case change in XI was small enough or too many
!  steps were taken.
!
    if ( delmax < tol ) then
      exit
    end if

  end do

  if ( tol <= delmax ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLOPT - Warning!'
    write ( *, '(a)' ) '  The Newton iteration did not converge.'
  end if

  t(1:k) = tau(1)
  t(k+1:n) = scrtch(nx+1:nx+n-k)  
  t(n+1:n+k) = tau(n)
  
  return
end
subroutine subbak ( w, ipivot, nrow, ncol, last, x )

!*****************************************************************************80
!
!! SUBBAK carries out back substitution for the current block.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) W(NROW,NCOL), integer IPIVOT(NROW), integer
!    NROW, integer NCOL, integer LAST, are as on return from FACTRB.
!
!    Input/output, real ( kind = 8 ) X(NCOL).
!    On input, the right hand side for the equations in this block after 
!    back substitution has been carried out up to, but not including,
!    equation IPIVOT(LAST).  This means that X(1:LAST) contains the right hand
!    sides of equation IPIVOT(1:LAST) as modified during elimination,
!    while X(LAST+1:NCOL) is already a component of the solution vector.
!    On output, the components of the solution corresponding to the present
!    block.
!
  implicit none

  integer ( kind = 4 ) ncol
  integer ( kind = 4 ) nrow

  integer ( kind = 4 ) ip
  integer ( kind = 4 ) ipivot(nrow)
  integer ( kind = 4 ) k
  integer ( kind = 4 ) last
  real ( kind = 8 ) w(nrow,ncol)
  real ( kind = 8 ) x(ncol)

  do k = last, 1, -1

    ip = ipivot(k)
   
    x(k) = ( x(k) - dot_product ( w(ip,k+1:ncol), x(k+1:ncol) ) ) / w(ip,k)

  end do

  return
end
subroutine subfor ( w, ipivot, nrow, last, b, x )

!*****************************************************************************80
!
!! SUBFOR carries out the forward pass of substitution for the current block.
!
!  Discussion:
!
!    The forward pass is the action on the right hand side corresponding to the 
!    elimination carried out in FACTRB for this block.
!
!    At the end, X(1:NROW) contains the right hand side of the transformed
!    IPIVOT(1:NROW)-th equation in this block.  
!
!    Then, since for I=1,...,NROW-LAST, B(NROW+I) is going to be used as 
!    the right hand side of equation I in the next block (shifted over there 
!    from this block during factorization), it is set equal to X(LAST+I) here.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) W(NROW,LAST), integer IPIVOT(NROW), 
!    integer ( kind = 4 ) NROW, integer LAST, are as on return from FACTRB.
!
!    Output, real ( kind = 8 ) B(2*NROW-LAST).  On input, B(1:NROW)
!    contains the right hand sides for this block.  On output,
!    B(NROW+1:2*NROW-LAST) contains the appropriately modified right
!    hand sides for the next block.
!
!    Output, real X(NROW), contains, on output, the appropriately modified
!    right hand sides of equations IPIVOT(1:NROW).
!
  implicit none

  integer ( kind = 4 ) last
  integer ( kind = 4 ) nrow

  real ( kind = 8 ) b(nrow+nrow-last)
  integer ( kind = 4 ) ip
  integer ( kind = 4 ) ipivot(nrow)
  integer ( kind = 4 ) jhi
  integer ( kind = 4 ) k
  real ( kind = 8 ) w(nrow,last)
  real ( kind = 8 ) x(nrow)

  ip = ipivot(1)
  x(1) = b(ip)
  
  do k = 2, nrow
  
    ip = ipivot(k)

    jhi = min ( k - 1, last )
    
    x(k) = b(ip) - dot_product ( w(ip,1:jhi), x(1:jhi) )

  end do
!
!  Transfer modified right hand sides of equations IPIVOT(LAST+1:NROW) 
!  to next block.
!
  b(nrow+1:2*nrow-last) = x(last+1:nrow)
  
  return
end
subroutine tautsp ( tau, gtau, ntau, gamma, s, break, coef, l, k, iflag )

!*****************************************************************************80
!
!! TAUTSP constructs a cubic spline interpolant to given data.
!
!  Discussion:
!
!    If 0 < GAMMA, additional knots are introduced where needed to
!    make the interpolant more flexible locally.  This avoids extraneous
!    inflection points typical of cubic spline interpolation at knots to
!    rapidly changing data.
!
!  Method:  
!
!    On the I-th interval, (TAU(I), TAU(I+1)), the interpolant is of the
!    form:
!      (*)  F(U(X)) = A + B * U + C * H(U,Z) + D * H(1-U,1-Z),
!    with  
!      U = U(X) = ( X - TAU(I) ) / DTAU(I). 
!
!    Here,
!      Z(I) = ADDG(I+1) / ( ADDG(I) + ADDG(I+1) )
!    but if the denominator vanishes, we set Z(I) = 0.5
!
!    Also, we have
!      ADDG(J) = abs ( DDG(J) ), 
!      DDG(J) = DG(J+1) - DG(J),
!      DG(J) = DIVDIF(J) = ( GTAU(J+1) - GTAU(J) ) / DTAU(J)
!    and
!      H(U,Z) = ALPHA * U^3 
!           + ( 1 - ALPHA ) * ( max ( ( ( U - ZETA ) / ( 1 - ZETA ) ), 0 )^3
!    with
!      ALPHA(Z) = ( 1 - GAMMA / 3 ) / ZETA
!      ZETA(Z) = 1 - GAMMA * min ( ( 1 - Z ), 1/3 )
!
!    Thus, for 1/3 <= Z <= 2/3, F is just a cubic polynomial on
!    the interval I.  Otherwise, it has one additional knot, at
!      TAU(I) + ZETA * DTAU(I).
!
!    As Z approaches 1, H(.,Z) has an increasingly sharp bend near 1,
!    thus allowing F to turn rapidly near the additional knot.
!
!    In terms of F(J) = GTAU(J) and FSECND(J) = second derivative of F 
!    at TAU(J), the coefficients for (*) are given as:
!      A = F(I) - D
!      B = ( F(I+1) - F(I) ) - ( C - D )
!      C = FSECND(I+1) * DTAU(I)^2 / HSECND(1,Z)
!      D = FSECND(I) * DTAU(I)^2 / HSECND(1,1-Z)
!
!    Hence these can be computed once FSECND(1:NTAU) is fixed.
!
!    F is automatically continuous and has a continuous second derivative
!    except when Z=0 or 1 for some I.  We determine FSECND from
!    the requirement that the first derivative of F be continuous.
!
!    In addition, we require that the third derivative be continuous
!    across TAU(2) and across TAU(NTAU-1).  This leads to a strictly
!    diagonally dominant tridiagonal linear system for the FSECND(I)
!    which we solve by Gauss elimination without pivoting.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) TAU(NTAU), the sequence of data points.  
!    TAU must be strictly increasing.
!
!    Input, real ( kind = 8 ) GTAU(NTAU), the corresponding sequence of
!    function values.
!
!    Input, integer ( kind = 4 ) NTAU, the number of data points.  
!    NTAU must be at least 4.
!
!    Input, real ( kind = 8 ) GAMMA, indicates whether additional flexibility
!    is desired.
!    GAMMA = 0.0, no additional knots;
!    GAMMA in (0.0,3.0), under certain conditions on the given data at
!    points I-1, I, I+1, and I+2, a knot is added in the I-th interval, 
!    for I = 2,...,NTAU-2.  See description of method.  The interpolant 
!    gets rounded with increasing gamma.  A value of 2.5 for GAMMA is typical.
!    GAMMA in (3.0,6.0), same, except that knots might also be added in
!    intervals in which an inflection point would be permitted.  A value 
!    of 5.5 for GAMMA is typical.
!
!    Output, real ( kind = 8 ) BREAK(L), real ( kind = 8 ) COEF(K,L), 
!    integer ( kind = 4 ) L, integer K, give the piecewise polynomial 
!    representation of the interpolant.  Specifically, 
!    for BREAK(i) <= X <= BREAK(I+1), the interpolant has the form:
!      F(X) = COEF(1,I) +  DX    * ( 
!             COEF(2,I) + (DX/2) * (
!             COEF(3,I) + (DX/3) *
!             COEF(4,I) ) )
!    with  DX = X - BREAK(I) for I = 1,..., L.
!
!    Output, integer ( kind = 4 ) IFLAG, error flag.
!    1, no error.
!    2, input was incorrect.
!
!    Output, real ( kind = 8 ) S(NTAU,6).  The individual columns of this
!    array contain the following quantities mentioned in the write up
!    and below.
!    S(.,1) = DTAU = TAU(.+1)-TAU;
!    S(.,2) = DIAG = diagonal in linear system;
!    S(.,3) = U = upper diagonal in linear system;
!    S(.,4) = R = right hand side for linear system (initially)
!           = FSECND = solution of linear system, namely the second
!             derivatives of interpolant at TAU;
!    S(.,5) = Z = indicator of additional knots;
!    S(.,6) = 1/HSECND(1,X) with X = Z or 1-Z.
!
  implicit none

  integer ( kind = 4 ) ntau

  real ( kind = 8 ) alph
  real ( kind = 8 ) alpha
  real ( kind = 8 ) break(*)
  real ( kind = 8 ) c
  real ( kind = 8 ) coef(4,*)
  real ( kind = 8 ) d
  real ( kind = 8 ) del
  real ( kind = 8 ) denom
  real ( kind = 8 ) divdif
  real ( kind = 8 ) entry
  real ( kind = 8 ) entry3
  real ( kind = 8 ) factor
  real ( kind = 8 ) factr2
  real ( kind = 8 ) gam
  real ( kind = 8 ) gamma
  real ( kind = 8 ) gtau(ntau)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) iflag
  integer ( kind = 4 ) k
  integer ( kind = 4 ) l
  integer ( kind = 4 ) method
  real ( kind = 8 ) onemg3
  real ( kind = 8 ) onemzt
  real ( kind = 8 ) ratio
  real ( kind = 8 ) s(ntau,6)
  real ( kind = 8 ) sixth
  real ( kind = 8 ) tau(ntau)
  real ( kind = 8 ) temp
  real ( kind = 8 ) x
  real ( kind = 8 ) z
  real ( kind = 8 ) zeta
  real ( kind = 8 ) zt2

  alph(x) = min ( 1.0D+00, onemg3 / x )
!
!  There must be at least 4 interpolation points.
!
  if ( ntau < 4 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'TAUTSP - Fatal error!'
    write ( *, '(a)' ) '  Input NTAU must be at least 4.'
    write ( *, '(a,i8)' ) '  NTAU = ', ntau
    iflag = 2
    stop 1
  end if
!
!  Construct delta TAU and first and second (divided) differences of data.
!
  do i = 1, ntau - 1

    s(i,1) = tau(i+1) - tau(i)
    
    if ( s(i,1) <= 0.0D+00 ) then
      write ( *, '(a,i3,a,2e15.6,a)' ) &
        '  Point ', i, ' and the next ', tau(i), tau(i+1), ' are disordered.'
      iflag = 2
      return
    end if
    
    s(i+1,4) = ( gtau(i+1) - gtau(i) ) / s(i,1)

  end do
   
  do i = 2, ntau - 1
    s(i,4) = s(i+1,4) - s(i,4)
  end do
!
!  Construct system of equations for second derivatives at TAU.
!
!  At each interior data point, there is one continuity equation.
!  At the first and last interior data point there is an additional 
!  equation for a total of NTAU equations in NTAU unknowns.
!
  i = 2
  s(2,2) = s(1,1) / 3.0D+00
  sixth = 1.0D+00 / 6.0D+00
  method = 2
  gam = gamma

  if ( gam <= 0.0D+00 ) then
    method = 1
  end if

  if ( 3.0D+00 < gam ) then
    method = 3
    gam = gam - 3.0D+00
  end if

  onemg3 = 1.0D+00 - gam / 3.0D+00
!
!  Loop over I.
!
   70 continue
!
!  Construct Z(I) and ZETA(I).
!
  z = 0.5D+00

  if ( method == 1 ) then
    go to 100
  end if

  if ( method == 3 ) then
    go to 90
  end if

  if ( s(i,4) * s(i+1,4) < 0.0D+00 ) then
    go to 100
  end if

   90 continue

  temp = abs ( s(i+1,4) )
  denom = abs ( s(i,4) ) + temp
  
  if ( denom /= 0.0D+00 ) then
    z = temp / denom
    if ( abs ( z - 0.5D+00 ) <= sixth ) then
      z = 0.5D+00
    end if
  end if
  
  100 continue

  s(i,5) = z
!
!  Set up part of the I-th equation which depends on the I-th interval.
!
  if ( z < 0.5D+00 ) then

    zeta = gam * z
    onemzt = 1.0D+00 - zeta
    zt2 = zeta**2
    alpha = alph(onemzt)
    factor = zeta / ( alpha * ( zt2 - 1.0D+00 ) + 1.0D+00 )
    s(i,6) = zeta * factor / 6.0D+00
    s(i,2) = s(i,2) + s(i,1) &
      * ( ( 1.0D+00 - alpha * onemzt ) * factor / 2.0D+00 - s(i,6) )
!
!  If Z = 0 and the previous Z = 1, then D(I) = 0.  
!  Since then also U(I-1) = L(I+1) = 0, its value does not matter.  
!  Reset D(I) = 1 to insure nonzero pivot in elimination.
!
    if ( s(i,2) <= 0.0D+00 ) then
      s(i,2) = 1.0D+00
    end if

    s(i,3) = s(i,1) / 6.0D+00

  else if ( z == 0.5D+00 ) then

    s(i,2) = s(i,2) + s(i,1) / 3.0D+00
    s(i,3) = s(i,1) / 6.0D+00

  else if ( 0.5D+00 < z ) then

    onemzt = gam * ( 1.0D+00 - z )
    zeta = 1.0D+00 - onemzt
    alpha = alph(zeta)
    factor = onemzt / ( 1.0D+00 - alpha * zeta * ( 1.0D+00 + onemzt ) )
    s(i,6) = onemzt * factor / 6.0D+00
    s(i,2) = s(i,2) + s(i,1) / 3.0D+00
    s(i,3) = s(i,6) * s(i,1)

  end if

  if ( 2 < i ) then
    go to 190
  end if

  s(1,5) = 0.5D+00
!
!  The first two equations enforce continuity of the first and of
!  the third derivative across TAU(2).
!
  s(1,2) = s(1,1) / 6.0D+00
  s(1,3) = s(2,2)
  entry3 = s(2,3)

  if ( z < 0.5D+00 ) then

    factr2 = zeta * ( alpha * ( zt2 - 1.0D+00 ) + 1.0D+00 ) &
      / ( alpha * ( zeta * zt2 - 1.0D+00 ) + 1.0D+00 )

    ratio = factr2 * s(2,1) / s(1,2)
    s(2,2) = factr2 * s(2,1) + s(1,1)
    s(2,3) = - factr2 * s(1,1)
  
  else if ( z == 0.5D+00 ) then

    ratio = s(2,1) / s(1,2)
    s(2,2) = s(2,1) + s(1,1)
    s(2,3) = - s(1,1)
  
  else if ( 0.5D+00 < z ) then

    ratio = s(2,1) / s(1,2)
    s(2,2) = s(2,1) + s(1,1)
    s(2,3) = - s(1,1) * 6.0D+00 * alpha * s(2,6)

  end if
!
!  At this point, the first two equations read:
!              DIAG(1)*X1+U(1)*X2 + ENTRY3*X3 = R(2)
!       -RATIO*DIAG(1)*X1+DIAG(2)*X2 + U(2)*X3 = 0.0
!  Eliminate first unknown from second equation.
!
  s(2,2) = ratio * s(1,3) + s(2,2)
  s(2,3) = ratio * entry3 + s(2,3)
  s(1,4) = s(2,4)
  s(2,4) = ratio * s(1,4)

  go to 200
  
  190 continue
!
!  The I-th equation enforces continuity of the first derivative
!  across TAU(I).  It now reads:
!    - RATIO * DIAG(I-1) * X(I-1) + DIAG(I) * X(I) + U(I) * X(I+1) = R(I).
!  Eliminate (I-1)st unknown from this equation
!
  s(i,2) = ratio * s(i-1,3) + s(i,2)
  s(i,4) = ratio * s(i-1,4) + s(i,4)
!
!  Set up the part of the next equation which depends on the I-th interval.
!
  200 continue

  if ( z < 0.5D+00 ) then

    ratio = - s(i,6) * s(i,1) / s(i,2)
    s(i+1,2) = s(i,1) / 3.0D+00

  else if ( z == 0.5D+00 ) then

    ratio = - ( s(i,1) / 6.0D+00 ) / s(i,2)
    s(i+1,2) = s(i,1) / 3.0D+00

  else if ( 0.5D+00 < z ) then

    ratio = - ( s(i,1) / 6.0D+00 ) / s(i,2)
    s(i+1,2) = s(i,1) &
      * ( ( 1.0D+00 - zeta * alpha ) * factor / 2.0D+00 - s(i,6) )

  end if
!
!  End of I loop.
!
  i = i + 1

  if ( i < ntau - 1 ) then
    go to 70
  end if

  s(i,5) = 0.5D+00
!
!  The last two equations enforce continuity of third derivative and
!  of first derivative across TAU(NTAU-1).
!
  entry = ratio * s(i-1,3) + s(i,2) + s(i,1) / 3.0D+00
  s(i+1,2) = s(i,1) / 6.0D+00
  s(i+1,4) = ratio * s(i-1,4) + s(i,4)

  if ( z < 0.5D+00 ) then

    ratio = s(i,1) * 6.0D+00 * s(i-1,6) * alpha / s(i-1,2)
    s(i,2) = ratio * s(i-1,3) + s(i,1) + s(i-1,1)
    s(i,3) = - s(i-1,1)
  
  else if ( z == 0.5D+00 ) then

    ratio = s(i,1) / s(i-1,2)
    s(i,2) = ratio * s(i-1,3) + s(i,1) + s(i-1,1)
    s(i,3) = - s(i-1,1)
  
  else if ( 0.5D+00 < z ) then

    factr2 = onemzt * ( alpha * ( onemzt**2 - 1.0D+00 ) + 1.0D+00 ) &
      / ( alpha * ( onemzt**3 - 1.0D+00 ) + 1.0D+00 )

    ratio = factr2 * s(i,1) / s(i-1,2)
    s(i,2) = ratio * s(i-1,3) + factr2 * s(i-1,1) + s(i,1)
    s(i,3) = - factr2 * s(i-1,1)

  end if
!
!  At this point, the last two equations read:
!           DIAG(I)*XI+     U(I)*XI+1 = R(I)
!    -RATIO*DIAG(I)*XI+DIAG(I+1)*XI+1 = R(I+1)
!
!  Eliminate XI from the last equation.
!
  s(i,4) = ratio * s(i-1,4)
  ratio = - entry / s(i,2)
  s(i+1,2) = ratio * s(i,3) + s(i+1,2)
  s(i+1,4) = ratio * s(i,4) + s(i+1,4)
!
!  Back substitution.
!
  s(ntau,4) = s(ntau,4) / s(ntau,2)

  do while ( 1 < i )

    s(i,4) = ( s(i,4) - s(i,3) * s(i+1,4) ) / s(i,2)
    i = i - 1

  end do

  s(1,4) = ( s(1,4) - s(1,3) * s(2,4) - entry3 * s(3,4) ) / s(1,2)
!
!  Construct polynomial pieces. 
!
  break(1) = tau(1)
  l = 1

  do i = 1, ntau - 1

    coef(1,l) = gtau(i)
    coef(3,l) = s(i,4)
    divdif = ( gtau(i+1) - gtau(i) ) / s(i,1)
    z = s(i,5)

    if ( z == 0.0D+00 ) then

      coef(2,l) = divdif
      coef(3,l) = 0D+00
      coef(4,l) = 0.0D+00

    else if ( z < 0.5D+00 ) then

      zeta = gam * z
      onemzt = 1.0D+00 - zeta
      c = s(i+1,4) / 6.0D+00
      d = s(i,4) * s(i,6)
      l = l + 1
      del = zeta * s(i,1)
      break(l) = tau(i) + del
      zt2 = zeta**2
      alpha = alph(onemzt)
      factor = onemzt**2 * alpha
      coef(1,l) = gtau(i) + divdif * del &
        + s(i,1)**2 * ( d * onemzt * ( factor - 1.0D+00 ) &
        + c * zeta * ( zt2 - 1.0D+00 ) )
      coef(2,l) = divdif + s(i,1) * ( d * ( 1.0D+00 - 3.0D+00 * factor ) &
        + c * ( 3.0D+00 * zt2 - 1.0D+00 ) )
      coef(3,l) = 6.0D+00 * ( d * alpha * onemzt + c * zeta )
      coef(4,l) = 6.0D+00 * ( c - d * alpha ) / s(i,1)
      coef(4,l-1) = coef(4,l) &
        - 6.0D+00 * d * ( 1.0D+00 - alpha ) / ( del * zt2 )
      coef(2,l-1) = coef(2,l) - del * ( coef(3,l) &
        - ( del / 2.0D+00 ) * coef(4,l-1))
 
    else if ( z == 0.5D+00 ) then

      coef(2,l) = divdif &
        - s(i,1) * ( 2.0D+00 * s(i,4) + s(i+1,4) ) / 6.0D+00
      coef(4,l) = ( s(i+1,4) - s(i,4) ) / s(i,1)

    else if ( 0.5D+00 <= z ) then

      onemzt = gam * ( 1.0D+00 - z )

      if ( onemzt == 0.0D+00 ) then

        coef(2,l) = divdif
        coef(3,l) = 0D+00
        coef(4,l) = 0.0D+00

      else

        zeta = 1.0D+00 - onemzt
        alpha = alph(zeta)
        c = s(i+1,4) * s(i,6)
        d = s(i,4) / 6.0D+00
        del = zeta * s(i,1)
        break(l+1) = tau(i) + del
        coef(2,l) = divdif - s(i,1) * ( 2.0D+00 * d + c )
        coef(4,l) = 6.0D+00 * ( c * alpha - d ) / s(i,1)
        l = l + 1
        coef(4,l) = coef(4,l-1) + 6.0D+00 * ( 1.0D+00 - alpha ) * c &
          / ( s(i,1) * onemzt**3 )
        coef(3,l) = coef(3,l-1) + del * coef(4,l-1)
        coef(2,l) = coef(2,l-1) + del * ( coef(3,l-1) &
          + ( del / 2.0D+00 ) * coef(4,l-1) )
        coef(1,l) = coef(1,l-1) + del * ( coef(2,l-1) &
          + ( del / 2.0D+00 ) * ( coef(3,l-1) &
          + ( del / 3.0D+00 ) * coef(4,l-1) ) )

      end if

    end if

    l = l + 1
    break(l) = tau(i+1)
    
  end do
  
  l = l - 1
  k = 4
  iflag = 1

  return
end
subroutine titand ( t, g, n )

!*****************************************************************************80
!
!! TITAND represents a temperature-dependent property of titanium.
!
!  Discussion:
!
!    The data has been used extensively as an example in spline
!    approximation with variable knots.
!
!  Modified:
!
!    14 February 2007
!
!  Author:
!
!    Carl de Boor
!
!  Reference:
!
!    Carl de Boor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663,
!    LC: QA1.A647.v27.
!
!  Parameters:
!
!    Output, real ( kind = 8 ) T(N), the location of the data points.
!
!    Output, real ( kind = 8 ) G(N), the value associated with the data points.
!
!    Output, integer ( kind = 4 ) N, the number of data points, which is 49.
!
  implicit none

  real ( kind = 8 ) g(*)
  integer ( kind = 4 ) n
  real ( kind = 8 ) t(*)

  n = 49

  t(1:49) = (/ &
     595.0D+00,  605.0D+00,  615.0D+00,  625.0D+00,  635.0D+00, &
     645.0D+00,  655.0D+00,  665.0D+00,  675.0D+00,  685.0D+00, &
     695.0D+00,  705.0D+00,  715.0D+00,  725.0D+00,  735.0D+00, &
     745.0D+00,  755.0D+00,  765.0D+00,  775.0D+00,  785.0D+00, &
     795.0D+00,  805.0D+00,  815.0D+00,  825.0D+00,  835.0D+00, &
     845.0D+00,  855.0D+00,  865.0D+00,  875.0D+00,  885.0D+00, &
     895.0D+00,  905.0D+00,  915.0D+00,  925.0D+00,  935.0D+00, &
     945.0D+00,  955.0D+00,  965.0D+00,  975.0D+00,  985.0D+00, &
     995.0D+00, 1005.0D+00, 1015.0D+00, 1025.0D+00, 1035.0D+00, &
    1045.0D+00, 1055.0D+00, 1065.0D+00, 1075.0D+00 /)

  g(1:49) = (/ &
    0.644D+00, 0.622D+00, 0.638D+00, 0.649D+00, 0.652D+00, &
    0.639D+00, 0.646D+00, 0.657D+00, 0.652D+00, 0.655D+00, &
    0.644D+00, 0.663D+00, 0.663D+00, 0.668D+00, 0.676D+00, &
    0.676D+00, 0.686D+00, 0.679D+00, 0.678D+00, 0.683D+00, &
    0.694D+00, 0.699D+00, 0.710D+00, 0.730D+00, 0.763D+00, &
    0.812D+00, 0.907D+00, 1.044D+00, 1.336D+00, 1.881D+00, &
    2.169D+00, 2.075D+00, 1.598D+00, 1.211D+00, 0.916D+00, &
    0.746D+00, 0.672D+00, 0.627D+00, 0.615D+00, 0.607D+00, &
    0.606D+00, 0.609D+00, 0.603D+00, 0.601D+00, 0.603D+00, &
    0.601D+00, 0.611D+00, 0.601D+00, 0.608D+00 /)

  return
end

! gfortran -fcheck=all -g -p  -Wall testrline.f95 -L. -L../minpack -lnoise -lrstat -lsort -llmin -lminpacks -lminpack -lfmm -lm

program testrline

  use robustline
  use noise

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  integer, parameter :: nmax = 100
  real(dbl), dimension(:),allocatable :: x,y,dx,dy
  real(dbl) :: a,b,da,db,sig,t
  integer :: i,n
  logical :: reliable

  call rektoris
!  stop

  allocate(x(nmax),y(nmax),dx(nmax),dy(nmax))
  do i = 1,size(x)

     call random_number(t)
     x(i) = t
     if( mod(i,10) > 0 ) then
        y(i) = 1 + 1*x(i) + gnoise(0.0_dbl,0.01_dbl)
     else
        y(i) = 1 + 1*x(i) + gnoise(0.0_dbl,0.1_dbl)
     end if

  end do
  i = size(x)/3
!  y(i) = 1 + 1*x(i) + gnoise(0.0_dbl,0.1_dbl)
  i = size(x)/2
!  y(i) = 1 + 1*x(i) + gnoise(0.0_dbl,0.1_dbl)
  i = size(x)/4
!  y(i) = 1 + 1*x(i) + gnoise(0.0_dbl,0.1_dbl)

  dx = 0.01 !* 0.707
  dy = 0.01 !* 0.707
  dx = 0
  dy = 1

!  deallocate(x,y,dx,dy)
!  read(*,*) n
!  allocate(x(n),y(n),dx(n),dy(n))
!  do n = 1,size(x)
!     read(*,*) x(n),y(n),dx(n),dy(n)
!  enddo

  call rline(x,y,a,b,da,db,dx,dy,sig,reliable,verbose=.true.)

  write(*,*) 'a=',a,'+-',da
  write(*,*) 'b=',b,'+-',db
  write(*,*) 'sig=',sig,' reliable:',reliable

  open(1,file='/tmp/rline2')
  do i = 1, size(x)
     write(1,*) x(i),y(i),y(i) - (a + b*x(i))
  end do
  close(1)

  deallocate(x,y,dx,dy)


contains

  subroutine rektoris

    integer, parameter :: ndat = 14
    real(dbl), dimension(ndat) :: x,y
    real(dbl) :: a,b,da,db,sig
    logical :: reliable

    x = (/3,4,6,6,6,7,8,9,11,11,12,12,14,16 /)
    y = (/24.82, 23.26, 14.77, 19.06, 14.79, 17.66, 11.83, &
         14.82, 5.16, 11.12, 8.04, 2.72, 0.74, 1.21/)

    call rline(x,y,a,b,da,db,sigma=sig,reliable=reliable,verbose=.true.)

    write(*,*) "rline:", reliable
    write(*,*) "sig:",sig
    write(*,*) "a:",a,"+-",da
    write(*,*) "b:",b,"+-",db

  end subroutine rektoris

end program testrline

!
! projections
!
!
! Copyright © 2011 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module projections

  implicit none
  integer, private, parameter :: dp = selected_real_kind(15)
  real(dp), private, parameter :: rad = 180.0_dp/3.1415926535897931160_dp

contains

  subroutine identity(alpha, delta, alpha0, delta0, x,y)

    real(dp),intent(in) :: alpha, delta, alpha0, delta0
    real(dp),intent(out) :: x,y

    x = alpha - alpha0
    y = delta - delta0

  end subroutine identity

  subroutine invidentity(x,y,alpha0,delta0,alpha,delta)

    implicit none
    real(dp),intent(in) :: alpha0, delta0, x, y
    real(dp),intent(out) :: alpha, delta

    alpha = x + alpha0
    delta = y + delta0

  end subroutine invidentity


  subroutine gnomon(alpha, delta, alpha0, delta0, x,y)

    implicit none
    real(dp),intent(in) :: alpha, delta, alpha0, delta0
    real(dp),intent(out) :: x,y
    real(dp) :: c,p,q,r,v,w,s

    c = cos(delta)
    p = sin(delta)
    q = c*sin(alpha - alpha0)
    r = c*cos(alpha - alpha0)
    v = sin(delta0)
    w = cos(delta0)
    s = p*v + r*w

    x = -q/s
    y = (w*p - v*r)/s

  end subroutine gnomon

  subroutine invgnomon(x,y,alpha0,delta0,alpha,delta)

    implicit none
    real(dp),intent(in) :: alpha0, delta0, x, y
    real(dp),intent(out) :: alpha, delta
    real(dp) :: p,q,r,v,w,t

    v = sin(delta0)
    w = cos(delta0) 
    t = sqrt(1.0_dp + x**2 + y**2)
    p = (v + w*y)/t
    q = -x/t
    r = (w - v*y)/t

    delta = asin(p)
    alpha = atan2(q,r) + alpha0

  end subroutine invgnomon

  subroutine gnomond(alpha, delta, alpha0, delta0, x,y)

    implicit none
    real(dp),intent(in) :: alpha, delta, alpha0, delta0
    real(dp),intent(out) :: x,y

    call gnomon(alpha/rad, delta/rad,alpha0/rad,delta0/rad,x,y)
    x = rad*x
    y = rad*y

  end subroutine gnomond

  subroutine invgnomond(x,y,alpha0,delta0,alpha,delta)

    implicit none
    real(dp),intent(in) :: alpha0, delta0, x, y
    real(dp),intent(out) :: alpha, delta

    call invgnomon(x/rad,y/rad,alpha0/rad,delta0/rad,alpha,delta)
    alpha = rad*alpha
    delta = rad*delta

  end subroutine invgnomond

end module projections

!
! absfit - fitting absolute deviations
!
!
! Copyright © 2015, 2017-8 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module estimator

  use iso_fortran_env

  implicit none

  logical, private :: debug = .true.
  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl

  private :: escaler,erot,angle,ereflex,eoff

contains

  subroutine inestim(type,a,d,xc,yc,xx,yy,acen,dcen,sc,dsc,rot,drot,refl, &
       xoff,dxoff,yoff,dyoff,verbose)

    use astrotrafo

    character(len=*),intent(in) :: type
    real(dbl),intent(in) :: xc,yc
    real(dbl),dimension(:),intent(in) :: a,d,xx,yy
    real(dbl),intent(inout) :: acen,dcen,sc,rot,dsc,drot,xoff,yoff,dxoff,dyoff
    real(dbl),intent(out) :: refl
    logical, intent(in) :: verbose
    real(dbl), dimension(:), allocatable :: x,y,u,v
    integer :: ndat
    type(AstroTrafoProj) :: t

    if( size(a) < 1 ) stop 'InEstim: no points available.'

    if(verbose) write(error_unit,*) "=== Parameters estimation ==="

    debug = verbose

    ndat = size(a)
    allocate(x(ndat),y(ndat),u(ndat),v(ndat))

    ! projection of spherical coordinates to a tangent plane
    call trafo_init(t,type,acen,dcen)
    call proj(t,a,d,u,v)

    call escaler(u,v,xx,yy,sc,dsc)
    call ereflex(u,v,xx,yy,refl)

    ! time to estimate an angle of rotation
    call trafo_init(t,xcen=xc,ycen=yc,scale=sc,refl=refl)
    call invaffine(t,xx,yy,x,y)
    call erot(u,v,x,y,rot,drot)

    ! offset
    ! origin of rectangular coordinates is moved to center of frame
    ! because that's point the frame is rotated around
    call trafo_init(t,xcen=xc,ycen=xc,scale=sc,rot=rot,refl=refl)
    call invaffine(t,xx,yy,x,y)
    call eoff(u,v,x,y,xoff,dxoff,yoff,dyoff)

  end subroutine inestim


  subroutine escaler(u,v,x,y,c,dc)

    use oakleaf

    real(dbl), dimension(:),intent(in) :: x,y,u,v
    real(dbl), intent(out) :: c,dc

    integer :: i,j,n
    real(dbl),dimension(:),allocatable :: cc
    real(dbl) :: d1,d2,e

    allocate(cc(size(x)**2))

    n = 0
    do i = 2, size(x)
       do j = 1,i-1
          d1 = sqrt((x(j) - x(i))**2 + (y(j) - y(i))**2)
          d2 = sqrt((u(j) - u(i))**2 + (v(j) - v(i))**2)
          n = n + 1
          cc(n) = d2/d1
!         if(debug) write(*,'(a,2es15.8,3f15.5)') '#',x(i),y(i),u(i),v(i),d2/d1
       end do
    enddo

    if( n > 1 ) then
       call rmean(cc(1:n),c,e,dc)
    else
       c = 0.0_dbl
       dc = 0.0_dbl
    end if

    if( debug ) write(error_unit,'(a,f10.1,g10.2)') &
         '# estim init scale [pix/deg]: ',1/c,dc/c**2

  end subroutine escaler

  subroutine erot(u,v,x,y,f,df)

    use oakleaf

    real(dbl), dimension(:),intent(in) :: x,y,u,v
    real(dbl), intent(out) :: f,df

    integer :: i,j,n
    real(dbl),dimension(:),allocatable :: cc,cs
    real(dbl) :: d1,d2,x1,y1,x2,y2,c,s,dc,ds,e

    n = size(x) - 1
    allocate(cc(n),cs(n))

    do i = 1, n
       j = i + 1
       x1 = x(j) - x(i)
       y1 = y(j) - y(i)
       d1 = sqrt(x1**2 + y1**2)
       x2 = u(j) - u(i)
       y2 = v(j) - v(i)
       d2 = sqrt(x2**2 + y2**2)
       ! cos
       cc(i) = (x1*x2 + y1*y2)/(d1*d2)
       ! sin
       cs(i) = (x1*y2 - x2*y1)/(d1*d2)
!       if(debug)write(*,'(a,6f12.5)') '# erot ',x(i),y(i),u(i),v(i),cc(i),cs(i)
    enddo

    if( n > 1 ) then
       call rmean(cc,c,e,dc)
       call rmean(cs,s,e,ds)
       f = rad * sign(atan2(abs(s),c),s)
       if( abs(s) > 0 ) then
          df = rad*sqrt(ds**2 + (c/s)**2*dc**2)
       else
          df = max(ds,dc)
       end if
    else
       f = 0.0_dbl
       df = 0.0_dbl
    end if

    if( debug ) write(error_unit,'(a,f8.3,g10.2)') &
         '# estim init angle [deg]: ',f,df

  end subroutine erot


  function angle(x1,y1,x2,y2,x3,y3)

    real(dbl), intent(in) :: x1,y1,x2,y2,x3,y3
    real(dbl) :: angle,u1,u2,v1,v2,c,s,r1,r2

    u1 = x1 - x2
    u2 = x3 - x2
    v1 = y1 - y2
    v2 = y3 - y2
    r1 = sqrt(u1**2 + v1**2)
    r2 = sqrt(u2**2 + v2**2)
    c = (u1*u2 + v1*v2)/(r1*r2)
    s = (u1*v2 - u2*v1)/(r1*r2)
    angle = sign(atan2(abs(s),c),s)

  end function angle


  subroutine ereflex(u,v,x,y,refl)

    use oakleaf

    real(dbl), dimension(:),intent(in) :: x,y,u,v
    real(dbl), intent(out) :: refl

    integer :: i,j,k
    integer, dimension(:), allocatable :: r
    real(dbl) :: f1,f2

    allocate(r(size(x)-2))

    refl = 1.0_dbl
    do i = 1, size(x)-2
       j = i + 1
       k = i + 2
       f1 = angle(x(i),y(i),x(j),y(j),x(k),y(k))
       f2 = angle(u(i),v(i),u(j),v(j),u(k),v(k))

       if( f1*f2 >= 0 ) then
          r(i) = 1
       else
          r(i) = -1
       end if
!       if( debug ) write(*,'(a,3f7.2)') '# ereflex ',f1,f2,f1/f2
    enddo

    if( count(r > 0) > count(r < 0) ) then
       refl = 1.0_dbl
    else
       refl = -1.0_dbl
    end if

    if( debug ) write(error_unit,'(a,f5.0)') '# estim init reflexion: ',refl

  end subroutine ereflex

  subroutine eoff(u,v,x,y,xoff,dxoff,yoff,dyoff)

    use oakleaf

    real(dbl), dimension(:), intent(in) :: x,y,u,v
    real(dbl), intent(out) :: xoff,dxoff,yoff,dyoff

    integer :: i,n
    real(dbl),dimension(:),allocatable :: du,dv
    real(dbl) :: e

    n = size(x)
    allocate(du(n),dv(n))

    do i = 1, n
       du(i) = u(i) - x(i)
       dv(i) = v(i) - y(i)
!       if( debug ) write(*,'(6f11.5)') x(i),y(i),u(i),v(i),du(i),dv(i)
    end do

    if( n > 1 ) then
       call rmean(du,xoff,e,dxoff)
       call rmean(dv,yoff,e,dyoff)
    else
       xoff = 0.0_dbl
       yoff = 0.0_dbl
       dxoff = 0.0_dbl
       dyoff = 0.0_dbl
    end if

    if( debug ) write(error_unit,'(a,2f12.5,2g10.2)') &
         '# estim init offset [deg]: ',xoff,yoff,dxoff,dyoff

  end subroutine eoff

end module estimator

!
! colouring
!
! Copyright © 2010-2, 2018-9 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program colouring

  use colouring_book
  use fitscolour
  use ctables
  use titsio
  use iso_fortran_env

  implicit none

  character(len=4*FLEN_FILENAME) :: record, key, val
  character(len=FLEN_FILENAME) :: filename
  type(ColourFits), dimension(:), allocatable :: bands
  character(len=FLEN_KEYWORD), dimension(4) :: fitskeys
  real, dimension(:,:), allocatable :: cmatrix
  real, dimension(:), allocatable :: weights, ctphs, backs
  character(len=80) :: msg
  integer :: eq,stat,status
  real :: x, y, r = 7  ! for white spot, star
  integer :: bitpix = -32
  integer :: nbands = 0
  integer :: nweights = 0
  integer :: nctphs = 0
  integer :: nbacks = 0
  logical :: verbose = .false.   ! verbose output
  logical :: estimbacks = .true. ! estimate backgrounds
  integer :: white = 0           ! zero means undefined
  logical :: list
  character(len=FLEN_FILENAME) :: output = 'colour.fits'
  character(len=FLEN_FILENAME) :: ctable = 'ctable.dat'
  character(len=FLEN_FILENAME) :: phsystable = 'photosystems.fits'
  character(len=FLEN_VALUE) :: cspace = ''
  character(len=FLEN_VALUE) :: outspace = 'CIE 1931 XYZ'

  ! mandatory keys
  fitskeys(1) = FITS_KEY_FILTER
  fitskeys(2) = FITS_KEY_EXPTIME
  fitskeys(3) = FITS_KEY_AREA
  fitskeys(4) = FITS_KEY_OBJECT

  do
     read(*,'(a)',iostat=stat,iomsg=msg) record
     if( stat == IOSTAT_END ) exit
     if( stat > 0 ) then
        write(error_unit,*) trim(msg)
        error stop 'An input error.'
     end if

     eq = index(record,'=')
     if( eq == 0 ) stop 'Malformed input record.'

     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'OUTPUT' ) then

        read(val,*) output

     else if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'FITS_KEY_FILTER' ) then

        read(val,*) fitskeys(1)

     else if( key == 'FITS_KEY_EXPTIME' ) then

        read(val,*) fitskeys(2)

     else if( key == 'FITS_KEY_AREA' ) then

        read(val,*) fitskeys(3)

     else if( key == 'FITS_KEY_OBJECT' ) then

        read(val,*) fitskeys(4)

     else if( key == 'BITPIX' ) then

        read(val,*) bitpix

    else if( key == 'PHSYSTABLE' ) then

        read(val,*) phsystable

     else if( key == 'CTABLE' ) then

        read(val,*) ctable

     else if( key == 'COLOURSPACE' ) then

        read(val,*) cspace

     else if( key == 'OUTERSPACE' ) then

        read(val,*) outspace

     else if( key == 'ESTIMBACKS' ) then

        read(val,*) estimbacks

     else if( key == 'WRADIUS' ) then

        read(val,*) r

     else if( key == 'WSPOT' ) then

        read(val,*) x,y
        white = WHITE_SPOT

     else if( key == 'WSTAR' ) then

        read(val,*) x,y
        white = WHITE_STAR

     else if( key == 'NWEIGHTS' ) then

        read(val,*) nweights
        allocate(weights(nweights))
        white = WHITE_WEIGHTS

     else if( key == 'WEIGHTS' ) then

        read(val,*) weights

     else if( key == 'NCTPHS' ) then

        read(val,*) nctphs
        allocate(ctphs(nctphs))
        white = WHITE_CTPH

     else if( key == 'CTPHS' ) then

        read(val,*) ctphs

     else if( key == 'NBACKS' ) then

        read(val,*) nbacks
        allocate(backs(nbacks))

     else if( key == 'BACKS' ) then

        read(val,*) backs

     else if( key == 'NBANDS' ) then

        read(val,*) nbands
        allocate(bands(nbands))
        nbands = 0

     else if( key == 'BAND' ) then

        read(val,*) filename

        nbands = nbands + 1
        call bands(nbands)%Load(filename,fitskeys)
        if( .not. bands(nbands)%status ) then
           write(error_unit,*) "Error: file `",trim(filename),"' read failed."
           stop 'FITS read fail.'
        end if

        if( nbands > 1 ) then
           if( .not. all(bands(nbands-1)%naxes == bands(nbands)%naxes) ) then
              if( verbose ) write(error_unit,*) "Current file: `",filename,"'."
              stop "Dimensions of images does not corresponds each other."
           end if
        endif

     end if

     if( key == 'LIST' ) then
        read(val,*) list
        if( list ) then
           call ctable_list(ctable)
           stop 0
        end if
     end if

  end do

  if( size(bands) == 0 ) stop 'No bands, no love.'
  if( .not. (size(bands) == nbands) ) stop 'A full set of FITS files required.'

  ! input colour space guess
  if( cspace == '' ) then
     call colour_oracle(bands,cspace)
     if( cspace == '' ) &
          stop 'Please, specify input colour space. Try, the list option.'
  end if

  ! check calibration
  if( white == 0 .and. all(bands(:)%calibrated) ) white = WHITE_CAL

  ! load transformation table
  call ctable_load(ctable,cspace,outspace,cmatrix,verbose)

  ! load wavelengths
  call colour_waves(bands,cspace,phsystable)

  ! backs
  if( nbacks > 0 ) estimbacks = .false.

  call colour(cspace,outspace,bands,bitpix,cmatrix,x,y,r,white,estimbacks,&
       weights,ctphs,backs,output,verbose,status)

  deallocate(bands,cmatrix)

  if( status == 0 )then
     stop 0
  else
     stop 'An error during colouring occurred.'
  end if

contains

  subroutine colour_oracle(bands,cspace)

    type(ColourFits), dimension(:), intent(in) :: bands
    character(len=*), intent(in out) :: cspace

    integer :: k

    if( size(bands) == 3 ) then

       if( all(bands(:)%filter == ['B', 'V', 'R']) ) then
          cspace = 'Johnson BVR'
       else if ( all(bands(:)%filter == ['Z', 'Y', 'X']) ) then
          cspace = 'CIE 1931 XYZ'
       end if

    end if

    if( verbose ) then
       if( cspace /= '' ) then
          write(error_unit,*) "Info: Colour space of inputs: '", &
               trim(cspace),"'"
       else
          write(error_unit,*) 'Warning: Failed to guess a colour space',&
               ' for filters: ',("'", &
               trim(bands(k)%filter),"' ",k=1,size(bands)),&
               '(in this order).'
       end if
    end if

  end subroutine colour_oracle

  subroutine colour_waves(bands,cspace,phsystable)

    use phsysfits

    type(ColourFits), dimension(:), intent(in out) :: bands
    character(len=*), intent(in) :: cspace, phsystable

    type(type_phsys) :: phsys
    character(len=*), parameter :: Johnson = 'Johnson'
    integer :: l,k
    logical :: found

    if( index(cspace,Johnson) > 0 ) then

       call phselect(phsystable,Johnson,phsys)
       do l = 1, size(bands)
          found = .false.
          do k = 1, size(phsys%filter)
             if( bands(l)%filter == phsys%filter(k) ) then
                found = .true.
                bands(l)%leff = real(phsys%lam_eff(k))
                bands(l)%fref = &
                 real(2.50663 * phsys%flam_ref(k) * 1e9*phsys%lam_fwhm(k) / 2.0)
             end if
          end do
          if( .not. found ) then
             write(error_unit,*) 'Error: For filter `',trim(bands(l)%filter),"'"
             stop 'Error: filter not found.'
          end if
       end do

       call deallocate_phsyscal(phsys)

       if( verbose ) then
          write(error_unit,*) "Info: Effective wavelengts [nm] of filters: '"
          do k = 1, size(bands)
             write(error_unit,'(3a,f7.1)') &
                  " Info: ",trim(bands(k)%filter),'   ',1e9*bands(k)%leff
          end do
       end if

    end if

  end subroutine colour_waves

end program colouring

!
!  Scale by entropy
!
!  Copyright © 2017 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

module entropyscale

  ! This module provides escale subroutine for estimation of scale.
  !
  ! escale should be called as:
  !
  !  call escale(r,s,reliable)
  !
  ! on input:
  !   r - array of residuals
  !   s - initial estimate of scale
  !
  ! on output are estimated:
  !   s - estimation of scale
  !   reliable (optional) - indicates reliability of result

  implicit none

  ! print debug information ?
  logical, parameter, private :: debug = .false.

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)

  ! relative precision of result
  real(dbl), parameter :: etol = 1e-3

  ! data buffers
  real(dbl), dimension(:), allocatable, private :: res, rho

  private :: negentropy, graph

contains

  subroutine escale(r,s,reliable)

    ! An estimator of scale parameter as maximum of entropy
    ! (implemented as minimum of negative entropy).
    ! The routine fmin is very reliable for this purpose.
    ! The extrem can be localised with relative small precision
    ! (3-digits guarantees everything). The scale parameter corrects
    ! oddly estimated statistical errors of passed data (dx).
    ! Normally, the value is expected near number one: escale ~= 1.

    use fmm
    use medians

    real(dbl), dimension(:), intent(in) :: r
    real(dbl), intent(in out) :: s
    logical, intent(out), optional :: reliable

    ! golden ratio
    real(dbl), parameter :: gold = 1.618 !=(1 + sqrt(5))/2

    real(dbl) :: stol, smin, smax, e, valmin, valmax
    integer :: n, iter
    logical :: abovemin, undermax

    if( s <= 0 ) then
       reliable = .false.
       return
    end if

    n = size(r)
    allocate(res(n),rho(n))

    res = r
    valmin = max(minval(abs(res)),epsilon(res))
    valmax = maxval(abs(res))

    if( n > 13 ) then

       ! we belives that the initial estimate of s is very good,
       ! and it falls inside the interval gived by golden ratio.
       smin = max(s / gold, valmin)
       smax = min(s * gold, valmax)
       stol = max(etol*s,100*epsilon(s))
       ! The maximum will be located with the precision
       ! giving approx ln((smax - smin)/stol) calls to negentropy.

       abovemin = abs(valmin - smin) > epsilon(smin)
       undermax = abs(valmax - smax) > epsilon(smax)

    else
       ! A case of a few elements only .. there is many local extremes...
       ! we are selecting one from those, randomly...
       smin = valmin
       smax = valmax
       stol = max(etol*valmin,100*epsilon(s))
       abovemin = .false.
       undermax = .false.

    end if

    do iter = 1, 3

       if( smax > smin ) then
          s = fmin(smin,smax,negentropy,stol)
       else ! if( smin == smax) then
          s = smin

          ! yes, it is possible for two sets of identical values
       end if

!       write(*,*) smin, smax, abovemin, undermax, iter

       ! update initial range if needed, or accept result
       e = 2*stol
       if( abs(s - smin) < e .and. abovemin ) then
          smin = max(smin / gold, valmin)
          abovemin = abs(valmin - smin) > epsilon(smin)
!          write(*,*) 'smin=',smin,smax,iter,abovemin, undermax
       else if( abs(smax - s) < e .and. undermax ) then
          smax = min(smax * gold, valmax)
          undermax = abs(valmax - smax) > epsilon(smax)
!          write(*,*) 'smax=',smax,smin,iter,abovemin, undermax
       else
          exit
       end if

    end do

    if( present(reliable) ) then
       e = 2*stol
       reliable = abs(s - smin) > e .and. abs(smax - s) > e
    end if

    if( debug ) call graph(s/10,5*s)

    deallocate(res,rho)

  end subroutine escale

  function negentropy(s)

    use rfun

    real(dbl) :: negentropy
    real(dbl), intent(in) :: s
    real(dbl), parameter :: rhomax = log(huge(1.0_dbl)/2.1)

    call itukeys(res/s,rho)
!    call iandrews(res/s,rho)
!    rho = (res/s)**2/2

    negentropy = - sum(rho*exp(-2.12*rho), rho < rhomax) / count(rho < rhomax)
!    negentropy = - sum(rho*exp(-2*rho)) / size(rho)

    ! The sum includes only values inside range acceptable for exp() function.
    ! Otherwise, FPE flag due to an underflow will be raised, although
    ! validity of results is untouched.

  end function negentropy


  subroutine graph(smin,smax)

    use rfun

    real(dbl), intent(in) :: smin, smax

    integer, parameter :: n = 66
    integer :: i
    real(dbl) :: s,ds

    ds = (smax - smin) / n

    open(1,file='/tmp/e')
    do i = 0,n
       s = smin + i * ds
       call ihubers(res/s,rho)
       write(1,*) s,negentropy(s) !,sum(rho**2)/size(rho)-0.8
    end do
    close(1)

  end subroutine graph


end module entropyscale

!
!  Robust estimate of a rational function
!
!  Copyright © 2015 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

module robustrational

  implicit none

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)

  ! print debug informations ?
  logical, parameter, private :: verbose = .false.

  ! estimate jacobian by differences or derivations ?
  !logical, parameter, private :: analytic = .false.
  ! currently, only differences are implemented

  ! limit to detect non-convergent series, reccomended values: >100
  real(dbl), parameter, private :: siglim = 1000.0

  real(dbl), dimension(:), allocatable, private :: xdata, ydata
  real(dbl), private :: par1

  private :: ratfun

contains

  subroutine robrat(x,y,p,dp,ab)

    use NelderMead

    real(dbl), dimension(:), intent(in) :: x,y
    real(dbl), intent(in) :: ab
    real(dbl), dimension(:), intent(in out) :: p,dp
    integer :: icount, numres, ifault, ndata
    real(dbl),dimension(size(p)) :: p0
    real(dbl) :: reqmin,rms

    ndata = size(x)
    p0 = p
    par1 = ab
    reqmin = epsilon(reqmin)
    allocate(xdata(ndata),ydata(ndata))
    xdata = x
    ydata = y
    call nelmin(ratfun,2,p0,p,rms,reqmin,dp,1,1000000,icount,numres,ifault)

    deallocate(xdata,ydata)

  end subroutine robrat

  function ratfun(p) result(s)

    real(dbl), dimension(:), intent(in) :: p
    real(dbl) :: s

!    s = sum(abs(p(1)*(xdata + p(2))/(1.0_dbl + p(3)*xdata) - ydata))
    s = sum(abs(p(1)*(xdata + p(2))/(1.0_dbl + par1*xdata) - ydata))

  end function ratfun


end module robustrational

! plot of likelihood and realted functions

! make install && gfortran -Wall -o horizon_graph horizon_graph.f95 -L../lib -L../minpack -lrstat -lsort -llmin -lminpacks -lminpack -llmin -lm && ./horizon_graph

program horizon_graph

  use robustmean

  integer, parameter :: dbl = selected_real_kind(15)
  real(dbl), dimension(666) :: x
  real(dbl), dimension(2) :: fv
  real(dbl) :: t,sig
  integer :: i,j,n


  do i = 1, int(0.95*size(x))
     x(i) = gdis(0.0_dbl,1.0_dbl)
     n = i
  end do
  do i = n+1, size(x)
     x(i) = gdis(0.0_dbl,5.0_dbl)
  end do
  
  
  do i = -100,100,10
     t = 0.0 + i/100.0
     do j = 1,20
        sig = j/10.0
        call graph(x,t,sig,"grad",fv)
        write(*,*) t,sig,sum(fv**2)
     end do
     write(*,*)
  end do


contains

  function gdis(mean, sig)

    ! generate random data with gauss distribution

    real(dbl), intent(in) :: mean, sig
    real(dbl) :: gdis, x
    
    call random_number(x)
    gdis = invnorm(x)*sig + mean

  end function gdis


    ! excelent overwiew of algorithms !
    ! http://home.online.no/~pjacklam/notes/invnorm/

    function invnorm(p)

      !ren-raw chen, rutgers business school
      ! normal inverse
      ! translate from
      ! http://home.online.no/~pjacklam/notes/invnorm
      ! a routine written by john herrero
      real*8 invnorm
      real*8 p,p_low,p_high
      real*8 a1,a2,a3,a4,a5,a6
      real*8 b1,b2,b3,b4,b5
      real*8 c1,c2,c3,c4,c5,c6
      real*8 d1,d2,d3,d4
      real*8 z,q,r
      a1=-39.6968302866538
      a2=220.946098424521
      a3=-275.928510446969
      a4=138.357751867269
      a5=-30.6647980661472
      a6=2.50662827745924
      b1=-54.4760987982241
      b2=161.585836858041
      b3=-155.698979859887
      b4=66.8013118877197
      b5=-13.2806815528857
      c1=-0.00778489400243029
      c2=-0.322396458041136
      c3=-2.40075827716184
      c4=-2.54973253934373
      c5=4.37466414146497
      c6=2.93816398269878
      d1=0.00778469570904146
      d2=0.32246712907004
      d3=2.445134137143
      d4=3.75440866190742
      p_low=0.02425
      p_high=1-p_low
      if(p.lt.p_low) goto 201
      if(p.ge.p_low) goto 301
201   q=dsqrt(-2*dlog(p))
      z=(((((c1*q+c2)*q+c3)*q+c4)*q+c5)*q+c6)/((((d1*q+d2)*q+d3)*q+d4)*q+1)
      goto 204
301   if((p.ge.p_low).and.(p.le.p_high)) goto 202
      if(p.gt.p_high) goto 302
202   q=p-0.5
      r=q*q
      z=(((((a1*r+a2)*r+a3)*r+a4)*r+a5)*r+a6)*q/(((((b1*r+b2)*r+b3)*r+b4)*r+b5)*r+1)
      goto 204
302   if((p.gt.p_high).and.(p.lt.1)) goto 203
203   q=dsqrt(-2*dlog(1-p))
      z=-(((((c1*q+c2)*q+c3)*q+c4)*q+c5)*q+c6)/((((d1*q+d2)*q+d3)*q+d4)*q+1)
204   invnorm=z
      return

    end function invnorm


end program horizon_graph

!
! triangle statistics
!
! fortran -Wall -g -p -fbounds-check -fimplicit-none -I../lib astrofits.f95 tristat.f95 -L../lib -lastrometry -lcfitsio -lm
!
!
! Copyright © 2012 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program tristat

  use astrotrafo
  use astrofits

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  logical , parameter :: monte = .false.
  integer, parameter :: nr = 100
  real(dbl), parameter :: qe = 0.1

  real(dbl), dimension(:), allocatable :: x,y,xe,ye,a,d,xhist
  integer, dimension(-nr:nr) :: hist
  real(dbl), dimension(2) :: crpix
  character(len=80) :: idcat,rframe

  integer :: ns,i,j,k,t,status,ihist
  real(dbl) :: u,v,ue,ve,q,w,h,s

  type(TypeProjection) :: at

  
  hist = 0

  if( monte ) then
     ns = 333
     allocate(x(ns),y(ns),xe(ns),ye(ns),xhist(ns*ns*ns))

     do i = 1, ns
        call random_number(q)
        x(i) = q - 0.5
        call random_number(q)
        y(i) = q - 0.5
     end do

     do i = 1, ns
        xe(i) = x(i) + gnoise(qe)
        ye(i) = y(i) + gnoise(qe)
!        x(i) = x(i) + gnoise(qe)
!        y(i) = y(i) + gnoise(qe)
     end do

  else
     
     status = 0
     call readfile('barnard_01R.fits',w,h,x,y,crpix,status)
     ns = size(x)

     call readtable("bcat.fits","RAJ2000","DEJ2000",a,d,rframe,idcat,status)
     at%type = "GNOMONIC"
     at%acen = 269.44
     at%dcen = 4.74
     at%xcen = 0.0
     at%ycen = 0.0
     at%scale = 1.0
     at%pa = 0.0

     allocate(xe(ns),ye(ns),xhist(ns*ns*ns))
     call trafo(at,a(1:ns),d(1:ns),xe,ye)

  end if


  xhist = 0.0
  ihist = 0

  do i = 1, ns
     do j = i+1, ns - 1
        do k = j+1, ns - 1
           call triangle(x(i),y(i),x(j),y(j),x(k),y(k),u,v)
           call triangle(xe(i),ye(i),xe(j),ye(j),xe(k),ye(k),ue,ve)
!           t = nr*(u - ue)
!           write(*,*) (u-ue)**2+(v-ve)**2
!           write(*,*) abs(u-ue)+abs(v-ve)
!           t = nr*((x(i) - x(j))-(xe(i) - xe(j)))**2 + ((y(i) - y(j))-(ye(i) - ye(j)))**2
!           write(*,*) i,j,t
!           t = nr*t
           t = nr*sqrt((u-ue)**2+(v-ve)**2)
!           t = nr*(u-ue)
!           t = nr*(abs(u-ue)+abs(v-ve))
!           t = nr*(u-ue)
           if( -nr < t .and. t < nr ) hist(t) = hist(t) + 1
           ihist = ihist + 1
!           xhist(ihist) = sqrt((u-ue)**2)
           xhist(ihist) = sqrt((u-ue)**2+(v-ve)**2)
!           xhist(ihist) = abs(u-ue) + abs(v-ve)
!           xhist(ihist) = v-ve
           write(*,*) xhist(ihist)
        end do
     end do
  end do


!  s = sum(hist)
!  do i = -nr,nr
!     if( i /= 0 ) write(*,*) i/100.0,hist(i)/s
!  end do

  call histogram(xhist(1:ihist),'uveuclid')

  deallocate(x,y,xe,ye,xhist)

contains

subroutine triangle(x1,y1,x2,y2,x3,y3,u,v)

  integer, parameter :: rp = selected_real_kind(15)
  real(rp), parameter :: eps = epsilon(1.0_rp)

  real(rp), intent(in) :: x1,y1,x2,y2,x3,y3
  real(rp), intent(out) :: u,v

  real(rp), dimension(3) :: d
  real(rp) :: x
  integer :: i,j,jj

  ! compute sides of triangle
  d(1) = (x1 - x2)**2 + (y1 - y2)**2
  d(2) = (x1 - x3)**2 + (y1 - y3)**2
  d(3) = (x2 - x3)**2 + (y2 - y3)**2

  ! sorting
  do i = 2, 3
     do j = 3, i, -1

        jj = j - 1
        if( d(jj) > d(j) )then

           x = d(jj)
           d(jj) = d(j)
           d(j) = x

        endif
     enddo
  enddo

  ! compute transformed coordinates
  if( d(3) > eps )then
     u = sqrt(d(1)/d(3))
     v = sqrt(d(2)/d(3))
  else
     ! it would be better put u,v to the definition domain
     u = 0.0
     v = 0.0
  endif

end subroutine triangle

   function gnoise(noise)

    real(dbl) :: gnoise, noise
    real(dbl) :: x

    call random_number(x)
    gnoise = noise*invdist(x)
    

  end function gnoise


  function invdist(xx)

    real(dbl) :: invdist,xx

    ! rational approximation of an inverse to a cumulative function
    ! of Gaussian distribution  with precision better than 0.00045
    ! J.Andel: Statistical methods, Matfyz Press, Prague 1991
    
    real(dbl) :: w,f,x
    logical :: interval

    x = xx
    if( x < 0.0 ) then
       invdist = 0.0
    elseif( x > 1.0 )then
       invdist = 1.0
    else
       interval = x < 0.5
       if( .not. interval ) x = 1.0 - x + epsilon(1.0)
       w = sqrt(-2.0*log(x));
       f = -w + (2.515517 + w*(0.802853 + w*0.010328))/ &
            (1.0 + w*(1.432788 + w*(0.189269 + w*0.001308)));
       if( interval ) then
          invdist = f
       else
          invdist = -f
       endif
    endif
    
  end function invdist

  subroutine histogram(x,name)

    character(len=*) :: name
    real(dbl), dimension(:) :: x

    integer, parameter :: nhist = 99
    integer, dimension(nhist) :: hist
    real(dbl), dimension(nhist) :: bins
    real(dbl), parameter :: h = 0.02
    integer :: i,j
    real(dbl) :: ss

    do i = 1, nhist
       bins(i) = h*(i - nhist/2)
!       write(*,*) i,bins(i)
    end do

  
    hist = 0
    do i = 1,size(x)
       do j = 2,nhist
          if( bins(j-1) < x(i) .and. x(i) <= bins(j)) hist(j) = hist(j) + 1
       end do
    end do

    open(1,file=name)
    ss = sum(hist)*h
    do i = 1,nhist
       write(1,*) bins(i)-h/2.0,hist(i)/ss
    end do
    close(1)

  end subroutine histogram

end program tristat

! tester - matching
!
! $ gfortran -Wall -g -p -fbounds-check -fimplicit-none match.f95 matches.f95
!
! Copyright © 2012 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

! dummy
module match_print

contains

  subroutine matchprint(id1,id2,p,d)
    integer, parameter :: dbl = selected_real_kind(15)
    integer, dimension(:), intent(in) :: id1,id2
    real(dbl), intent(in) :: p,d
    integer :: n
    character(len=80) :: fmt

    if( size(id1) /= size(id2) ) stop 'astromatch size(id1) /= size(id2)'

    n = size(id2)

    write(fmt,"(a,i0,a,i0,a)") "(",n,"i3,a,",n,"i3,a,f5.3,f8.5)"
!    write(*,fmt) id1,' -> ',id2,' : ',p,d

!    write(fmt,"(a,i0,a)") "(a,i0,",2*n,"(1x,f0.3),f6.3,f8.5)"
!    write(*,fmt) "=M> ",n,(xstar(id2(i)),ystar(id2(i)),i=1,n),p,d
    
  end subroutine matchprint

end module match_print



program matches

  use matcher
  use match_print

  implicit none

  integer, parameter :: dp = selected_real_kind(15)
  integer :: n, np, nmatch, i, j
  integer, parameter :: npmax = 10000
  integer, allocatable, dimension(:)  :: p,pn,id1,id2
  real(dp), allocatable, dimension(:) :: x1,y1,x2,y2
  real(dp) :: q, pmax


  np = 1
  n = 20
  nmatch = 7

  ! random stars
  allocate(x1(n),y1(n),x2(n),y2(n))!,id1(n),id2(n))
  do i = 1, n
     call random_number(q)
     x1(i) = 100.0*q
     call random_number(q)
     y1(i) = 100.0*q
!     id1(i) = i
  end do

  ! permutations
  write(*,*) 'number of permutations (factorial) = ',fact(n)
  allocate(p(n),pn(n))
  do i = 1, n
     p(i) = i
  enddo
!  pn = p
  call per(n)
  
  write(*,*) pn


  ! random transformation
  do i = 1, n
     j = pn(i)
!     id2(i) = i
     x2(i) = x1(j) + gnoise(0.01)
     y2(i) = y1(j) + gnoise(0.01)
     write(*,*) i,j
  end do

  
  call match(x1,y1,x2,y2,nmatch,id1,id2,pmax,matchprint)

  write(*,*) pmax
  write(*,*) id1
  write(*,*) id2

  ! residuals
  do i = 1,size(id1)
!     j = id2(i)
!     write(*,'(4f10.3)') x1(id1(i)),y1(id1(i)),x2(id2(i)),y2(id2(i))
!     write(*,'(4f10.3)') x1(i),y1(i),x2(i),y2(i)
  end do


  deallocate(p,pn)
  deallocate(x1,y1,x2,y2,id1,id2)

contains

   function gnoise(noise)

    real :: gnoise, noise
    real :: x

    call random_number(x)
    gnoise = noise*invdist(x)
    

  end function gnoise


  function invdist(xx)

    real :: invdist,xx

    ! rational approximation of an inverse to a cumulative function
    ! of Gaussian distribution  with precision better than 0.00045
    ! J.Andel: Statistical methods, Matfyz Press, Prague 1991
    
    real :: w,f,x
    logical :: interval

    x = xx
    if( x < 0.0 ) then
       invdist = 0.0
    elseif( x > 1.0 )then
       invdist = 1.0
    else
       interval = x < 0.5
       if( .not. interval ) x = 1.0 - x + epsilon(1.0)
       w = sqrt(-2.0*log(x));
       f = -w + (2.515517 + w*(0.802853 + w*0.010328))/ &
            (1.0 + w*(1.432788 + w*(0.189269 + w*0.001308)));
       if( interval ) then
          invdist = f
       else
          invdist = -f
       endif
    endif
    
  end function invdist



  ! factorial
  recursive function fact(n)  result(ff)

     implicit none

     integer :: ff
     integer, intent(in) :: n

     if( n > 0 ) then
        ff = n*fact(n-1)
     else
        ff = 1
     endif
!     write(*,*) n,ff

   end function fact


   ! all permutations
   recursive subroutine per(level)

     implicit none

     integer, intent(in) :: level
     integer :: i,pp

     if( np > npmax ) return

     if( level > 1 )then
        do i = 1,n
!           if( i /= n ) then
           pp = p(i)
           p(i) = p(1)
           p(1) = pp
           call per(level-1)
           pp = p(i)
           p(i) = p(1)
           p(1) = pp
!        end if
        enddo
     else
!        write(*,'(a,100I3)') 'p:',p
        continue

        np = np + 1
!        if( np == n ) then
        if( np == npmax ) then
           pn = p
!           write(*,'(a,100I3)') 'pn:',pn
        end if
           
     end if

!     write(*,*) 'p:',p
   end subroutine per


end program matches

!
!  An implementation of growth-curves in aperture photometry
!  of point-like objects.
!
!     This piece of software is dedicated to my colleague
!     Vladimír Štefl. because the growth-curve method is his
!     favourite method for spectral line analysis. :)
!
!  Copyright © 2015-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

! grow curve construction:
!   * localy (en every point), the variartion principle
!     must be satisfied, base funtions be linear?


module grow_curve

  use grow_report

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: pi = 3.14159265358979312_dbl

  type(grow_reporter), pointer, private :: reporter
  logical, private :: report

!  private :: growcurve, select_valid_isolated, curve_init, grow_deepest, &
  private :: growcurve, select_valid_isolated, curve_init, model_curve, &
       curve_spline, grow_phot, estim_rflux90, estim_hwhm

contains


  subroutine growphot(xcens,ycens,apcts,apcts_err,sky,sky_sig,raper,hwhm,sep,threshold, &
       gcount,gcount_err,skycorr,skyerrcorr,curve,curve_err,growflag,prof, &
       rflux90,ghwhm,make_report,xreport)

    real, dimension(:), intent(in) :: xcens,ycens
    real, dimension(:,:), intent(in) :: apcts,apcts_err
    real, dimension(:),intent(in) :: sky,sky_sig,raper
    real, intent(in) :: hwhm, sep, threshold
    real(dbl), dimension(:), intent(out) :: gcount,gcount_err,curve,curve_err,prof
    real, dimension(:), intent(out) :: skycorr,skyerrcorr
    integer, dimension(:), intent(out) :: growflag
    real, intent(out) :: rflux90, ghwhm
    logical, intent(in) :: make_report
    type(grow_reporter), target, intent(in out) :: xreport

    integer :: i,j,n

    report = make_report
    reporter => xreport

    n = size(gcount)

    ! construct growth-curve
    call growcurve(xcens,ycens,apcts,apcts_err,sky,sky_sig,raper,hwhm,sep,threshold, &
         curve,curve_err,growflag,prof,rflux90,ghwhm)

    ! photometry by using of the curve
    call grow_phot(raper,apcts,apcts_err,curve,curve_err,sky_sig,hwhm, &
         gcount,gcount_err,skycorr,skyerrcorr)

    if( report ) then

       call curve_spline(raper,curve,curve_err)

       n = 0
       do i = 1, size(apcts,1)
          do j = 1, size(apcts,2)
             n = n + 1
             if( apcts(i,j) > 0 .and. curve(j) > 0 .and. gcount(i) > 0 ) then
                reporter%grow(i,j) = (apcts(i,j) - skycorr(i)*pi*raper(j)**2)/ gcount(i)
                reporter%resgrow(i,j) =  reporter%grow(i,j) - curve(j)
                reporter%grow_err(i,j) = reporter%grow(i,j)* &
                     sqrt((apcts_err(i,j)/apcts(i,j))**2 + (curve_err(j)/curve(j))**2)
             else
                reporter%resgrow(i,j) = -1
                reporter%grow(i,j) = -1
                reporter%grow_err(i,j) = -1
             end if
          end do
       end do
    end if

  end subroutine growphot


  subroutine growcurve(xcens,ycens,apcts,apcts_err,sky,sky_err,raper,hwhm,sep, &
       threshold,curve,curve_err,growflag,prof,rflux90,ghwhm)

    use grow_model
    use grow_fit

    real, dimension(:), intent(in) :: xcens,ycens
    real, dimension(:,:), intent(in) :: apcts,apcts_err
    real, dimension(:),intent(in) :: sky,sky_err,raper
    real, intent(in) :: hwhm, sep, threshold
    real(dbl), dimension(:), intent(out) :: curve,curve_err, prof
    integer, dimension(:), intent(out) :: growflag
    real, intent(out) :: rflux90, ghwhm

    real(dbl), dimension(:,:), allocatable :: grow,grow_err!,grows,grows_err
    integer, dimension(:), allocatable :: id, idn
    integer :: nid,nrows,naper,i,nhwhm,maper
!    real(dbl) :: y1,y2,x2,x1,a,b,gx

    nrows = size(apcts,1)
    naper = size(apcts,2)
    growflag = 0
    nhwhm = optimal_index(raper,hwhm)

    allocate(id(nrows),idn(nrows),grow(nrows,naper),grow_err(nrows,naper))

    ! generate initial growth-curve estimate on base of Gaussian
    ! the estimate of HWHM is important (especialy when
    ! there are no valid stars to determine the accurate one).
    call curve_init(raper,hwhm,curve,curve_err,prof)

!    do i = 1,12
!       write(*,*) raper(i),curve(i)
!    end do
!    stop 0

    ! select aperture optimal for star selection procedure
    maper = 0
    do i = 1,naper
       if( raper(i) >= 2*hwhm ) then
          maper = i
          exit
       end if
    end do
    if( maper == 0 ) goto 666

    ! select isolated stars with all aperture measurements valid
    call select_valid_isolated(xcens,ycens,sep,threshold,apcts,apcts_err,sky, &
         raper(maper),maper,nid,id)
!    write(*,*) nid,maper
    if( nid == 0 ) goto 666

    ! ** WARNING **
    ! The order in apcts,apcts_err field is unchanged.
    ! All valid grow(_err) are spreaded over all the field keeping their ranks.
    ! It makes possibility to identify any object at any time of processing.

    ! flags for stars with an accepted profile and objects with non-stellar ones
    forall( i = 1:nid  ) growflag(id(i))  = 1

    ! construct the principial growth curve
    call model_curve(nid,id,hwhm,nhwhm,raper,apcts,apcts_err,sky,curve,curve_err)

!!$    ! construct growth-curves of individual (selected) stars
!!$    call grow_deepest(nid,id,hwhm,nhwhm,raper,apcts,apcts_err,sky_err,grow,grow_err)
!!$!    write(*,*) nid
!!$    if( nid == 0 ) goto 666
!!$
!!$    ! ** WARNING **
!!$    ! The order in apcts,apcts_err field is unchanged.
!!$    ! All valid grow(_err) are spreaded over all the field keeping their ranks.
!!$    ! It makes possibility to identify any object at any time of processing.
!!$
!!$    ! flags for stars with an accepted profile and objects with non-stellar ones
!!$    forall( i = 1:nid  ) growflag(id(i))  = 1
!!$
!!$    allocate(grows(nid,naper),grows_err(nid,naper))
!!$    do i = 1,nid
!!$       k = id(i)
!!$       grows(i,:) = grow(k,:)
!!$       grows_err(i,:) = grow_err(k,:)
!!$    end do
!!$
!!$    call growmodel1(grows,grows_err,curve,curve_err)
!!$    goto 33
!!$
!!$    ! correct for finite radius
!!$    y1 = 1/(1 - curve(naper))
!!$    y2 = 1/(1 - curve((nhwhm+naper)/2))
!!$    x1 = raper(naper)
!!$    x2 = raper((nhwhm+naper)/2)
!!$    a = (y2 - y1)/(x2 - x1)
!!$    b = (y1 + y2 - a*(x1 + x2)) / 2
!!$    gx = 1 - 1/(a*raper(naper) + b)
!!$    write(*,*) a,b,gx
!!$
!!$    call grow_deepest(nid,id,hwhm,nhwhm,raper,apcts,apcts_err,sky_err,grow,grow_err,a,b)
!!$    call growmodel1(grows,grows_err,curve,curve_err)
!!$
!!$    do i = 1,size(curve)
!!$       write(*,*) raper(i),curve(i) - 1,1/(1-curve(i))
!!$    end do
!!$!    curve = curve / gx
!!$33  continue
!!$
!!$    call grow_deepest1(nid,id,hwhm,nhwhm,raper,apcts,apcts_err,curve,curve_err)

!    deallocate(grows,grows_err)

666 continue

    ! estimate HWHM and energy within a radius as an indicator of actual spread
    rflux90 = estim_rflux90(raper,curve)

    ! profile is derived from rectangle rule
    prof(1) = curve(1)/raper(1)**2/(2*pi)
    do i = 2,naper
       prof(i) = (curve(i) - curve(i-1)) / (2*pi * raper(i) * (raper(i) - raper(i-1)))
       prof(i) = max(prof(i),0.0)
    end do
    ghwhm = estim_hwhm(raper,prof)

!    do i = 1,naper
!       write(*,'(f5.1,3f10.4)') raper(i),curve(i),curve_err(i),prof(i)
!    end do

    deallocate(id,idn,grow,grow_err)

  end subroutine growcurve


  subroutine select_valid_isolated(xcens,ycens,sep,threshold,apcts,apcts_err,&
       sky,raper,maper,nid,id)

    ! select isolated stars suitable for estimate of growth-curve
    !
    ! the selection is on base of rules:
    !   * isolated star by 'sep' parameters
    !   * all measurements are valid
    !   * bright stars

    real, dimension(:), intent(in) :: xcens,ycens,sky
    real, intent(in) :: sep, threshold, raper
    real, dimension(:,:), intent(in) :: apcts, apcts_err
    integer, intent(in) :: maper
    integer, intent(out) :: nid
    integer, dimension(:), intent(out) :: id

    integer :: n,i,j,naper
    logical :: found
    real :: r,aper

    n = size(xcens)
    naper = size(apcts,2)
    aper = 3.14*raper**2

    ! selection of isolated stars
    nid = 0
    do i = 1, n
       found = .false.
       do j = 1, n
          if( i /= j ) then
             r = sqrt((xcens(i) - xcens(j))**2 + (ycens(i) - ycens(j))**2)
             if( r < sep ) then
                found = .true.
                goto 90
             end if
          end if
       end do
90     continue

       ! accept only valid bright stars highly above sky limit
!       write(*,*) apcts(i,maper)/(aper*sky(i)),threshold,found
       if( .not. found .and. &
            all(apcts(i,:) > 0) .and. all(apcts_err(i,:) > 0) .and. &
            apcts(i,maper) / (aper*sky(i))  > threshold ) then

          nid = nid + 1
          id(nid) = i

       end if
    end do

  end subroutine select_valid_isolated

  subroutine curve_init(r,hwhm,curve,curve_err,prof)

    real, dimension(:), intent(in) :: r
    real, intent(in) :: hwhm
    real(dbl), dimension(:), intent(out) :: curve, curve_err, prof

    prof = exp(-(r/hwhm)**2/2.0_dbl)
    curve = 1.0_dbl - prof
    curve_err = 1e-5

    if( report ) then
       reporter%prof = exp(-(reporter%radius/hwhm)**2/2.0_dbl)
       reporter%curve = 1.0_dbl - reporter%prof
    end if

  end subroutine curve_init


  subroutine model_curve(nid,id,hwhm,nhwhm,raper,apcts,apcts_err,sky,grow,grow_err)

    use grow_model
    use grow_fit

    integer, intent(in out) :: nid
    integer, dimension(:), allocatable, intent(in out) :: id
    real, intent(in) :: hwhm
    integer, intent(in) :: nhwhm
    real, dimension(:), intent(in) :: raper, sky
    real, dimension(:,:), intent(in) :: apcts,apcts_err
    real(dbl), dimension(:), intent(out) :: grow,grow_err

    real(dbl), dimension(:,:), allocatable :: cts, dcts
    real, dimension(:), allocatable :: sky1
    real(dbl) :: a,aerr,b,berr,sig
    integer :: i,k,n,info

    n = size(raper)
    allocate(cts(nid,n),dcts(nid,n),sky1(nid))

    n = 0
    do i = 1,nid
       k = id(i)
       n = n + 1
       cts(n,:) = apcts(k,:)
       dcts(n,:) = apcts_err(k,:)
       sky1(n) = sky(k)
    end do

    call growmodel(raper,cts,dcts,hwhm,nhwhm,grow,grow_err)

!stop 0
    goto 55
    grow(1) = 0.378608555
    grow(2) = 0.556426227
    grow(3) = 0.760242879
    grow(4) = 0.897968650
    grow(5) = 0.972795010
    grow(6) = 0.988545179
    grow(7) = 0.992449760
    grow(8) = 0.994584739
    grow(9) = 0.996115625
    grow(10) = 0.996945143
    grow(11) = 0.997353375
    grow(12) = 0.997653544

    55 continue

    do i = 1,nid*0
       k = id(i)
       a = apcts(k,6)
       b = 0
       call growfit(raper,1d0*apcts(k,:),1d0*apcts_err(k,:),grow,grow_err,real(30), &
            a,aerr,b,berr,sig,info)
!       write(*,*) k,real(a),real(b),sky(k),'ccc'
!       stop
    end do

!stop
    deallocate(cts,dcts)

  end subroutine model_curve



!!$  subroutine grow_deepest(nid,id,hwhm,nhwhm,raper,apcts,apcts_err,sky_err,grow,grow_err,a,b)
!!$
!!$    ! The First Cut Is the Deepest
!!$
!!$    use grow_init
!!$
!!$    integer, intent(in out) :: nid
!!$    integer, dimension(:), allocatable, intent(in out) :: id
!!$    real, intent(in) :: hwhm
!!$    real(dbl), intent(in), optional :: a,b
!!$    integer, intent(in) :: nhwhm
!!$    real, dimension(:), intent(in) :: raper,sky_err
!!$    real, dimension(:,:), intent(in) :: apcts,apcts_err
!!$    real(dbl), dimension(:,:), intent(out) :: grow,grow_err
!!$
!!$    integer, dimension(:), allocatable :: mid
!!$    real(dbl), dimension(size(apcts,2)) :: cts, dcts
!!$    real(dbl) :: skyerr
!!$    integer :: i,k,j,n
!!$    logical :: valid
!!$
!!$    n = 0
!!$    allocate(mid(nid))
!!$
!!$    do i = 1,nid
!!$       k = id(i)
!!$       cts = apcts(k,:)
!!$       dcts = apcts_err(k,:)
!!$       skyerr = sky_err(k)
!!$       if( present(a) .and. present(b) ) then
!!$          call growinit(raper,cts,dcts,skyerr,hwhm,nhwhm,grow(k,:),grow_err(k,:),valid,a,b)
!!$       else
!!$          call growinit(raper,cts,dcts,skyerr,hwhm,nhwhm,grow(k,:),grow_err(k,:),valid)
!!$       end if
!!$       if( valid ) then
!!$          do j = 1,12
!!$!             write(*,'(i4,f5.1,2g20.5)') k,raper(j),grow(k,j)
!!$          end do
!!$
!!$          n = n + 1
!!$          mid(n) = k
!!$!          stop 0
!!$
!!$       end if
!!$    end do
!!$
!!$    deallocate(id)
!!$    allocate(id(n))
!!$    id = mid(1:n)
!!$    nid = n
!!$
!!$    deallocate(mid)
!!$
!!$!stop 0
!!$  end subroutine grow_deepest



  subroutine curve_spline(raper,curve,curve_err)

    real, dimension(:), intent(in) :: raper
    real(dbl), dimension(:), intent(in) :: curve,curve_err

    real(dbl), external :: smooth, ppvalu
    real(dbl), dimension(size(raper)+1) :: x,y,d
    real(dbl), dimension(size(raper)+1,7) :: aux
    real(dbl), dimension(size(raper)+1,4) :: aaux
    real(dbl), dimension(4,size(raper)+1) :: taaux

    integer :: i,n1,naper
    real(dbl) :: t,s,dnoise

    naper = size(raper)
    n1 = size(x) - 1

    ! approximate it
    dnoise = 1e-5       ! minimal error for spline fit (and display)
    x(1) = 0.0_dbl
    x(2:naper+1) = raper
    y(1) = 0.0_dbl
    y(2:naper+1) = curve
    d(1) = dnoise
    d(2:naper+1) = max(curve_err,dnoise)

    ! interpolation
    s = epsilon(x)
    ! aproximation
    s = naper
!    do i = 1,naper+1
!       write(*,*) i,real(x(i)),real(y(i)),real(d(i))
!    end do
    t = smooth(x,y,d,size(x),s,aux,aaux)
    taaux = transpose(aaux(:,1:4))

    if( report ) then
       do i = 1,size(reporter%radius)
          t = reporter%radius(i)
          reporter%curve(i) = ppvalu(x,taaux,n1,4,t,0)
          reporter%prof(i) = ppvalu(x,taaux,n1,4,t,1)
       end do
    end if

  end subroutine curve_spline

  subroutine grow_phot(raper,apcts,apcts_err,curve,curve_err,sky_sig, hwhm, &
       apcount,apcount_err, back, back_err)

    use grow_fit
    use oakleaf

    real, dimension(:), intent(in) :: raper,sky_sig
    real, dimension(:,:), intent(in) :: apcts,apcts_err
    real(dbl), dimension(:), intent(in) :: curve,curve_err
    real, intent(in) :: hwhm
    real(dbl), dimension(:), intent(out) :: apcount,apcount_err
    real, dimension(:), intent(out) :: back, back_err

    real(dbl), dimension(size(apcts,2)) :: cts, dcts, c,dc
    real, dimension(size(apcts,2)) :: r
    integer :: i,j,n,info,nhwhm,m
    real(dbl) :: sig,b,berr,a,aerr, rbest

    nhwhm = optimal_index(raper,hwhm)

    do i = 1, size(apcts,1)
       n = 0
       m = 0
       rbest = raper(size(raper)) - raper(1)
       do j = 1, size(apcts,2)
          if( apcts(i,j) > 0 ) then
             n = n + 1
             cts(n) = apcts(i,j)
             dcts(n) = apcts_err(i,j)
             c(n) = curve(j)
             dc(n) = curve_err(j)
             r(n) = raper(j)
             if( abs(r(n) - hwhm) < rbest ) then
                m = n
                rbest = r(n)
             end if
          end if
       end do
       back(i) = 0
       back_err(i) = -1
       apcount(i) = -1
       apcount_err(i) = -1
       if( n > 0 .and. m > 0) then

          ! The values are initialized on values near HWHM (having optimal
          ! noise) and corrected for aperture correction. When fitting
          ! procedure will unsuccessfull, the values are considered as results.

          apcount(i) = cts(m)/c(m)
          apcount_err(i) = dcts(m)/c(m)

          if( n > nhwhm + 1 ) then
!             a = apcount(i)
             !             aerr = apcount_err(i)
             call fmean(cts(:n),dcts(:n),curve(:n),curve_err(:n),a,aerr)
             ! only 1:nhwhm ?
             call growfit(r(1:n),cts(1:n),dcts(1:n),c(1:n),dc(1:n),sky_sig(i), &
                  a,aerr,b,berr,sig,info)
             if( info == 0 ) then
                apcount(i) = a
                apcount_err(i) = aerr
                back(i) = real(b)
                back_err(i) = real(berr)
             else
                back(i) = 0
                back_err(i) = 0
             end if
          end if

       end if
    end do

  end subroutine grow_phot


  function estim_rflux90(raper,curve)

    ! estimate a radius with 90% energy within

    real :: estim_rflux90
    real, parameter :: q90 = 0.9
    real, dimension(:), intent(in) :: raper
    real(dbl), dimension(:), intent(in) :: curve
    real(dbl) :: d
    integer :: i

    if( curve(1) > q90 ) then
       estim_rflux90 = real(q90*raper(1)/curve(1))
       return
    end if

    do i = 2,size(raper)
       if( curve(i-1) <= q90 .and. q90 < curve(i) ) then
          d = (raper(i) - raper(i-1)) / (curve(i) - curve(i-1))
          estim_rflux90 = real(raper(i-1) + d*(q90 - curve(i-1)))
          return
       end if
    end do

    estim_rflux90 = -1

  end function estim_rflux90


  function estim_hwhm(raper,prof)

    ! estimate a half of width in hight maximum

    real :: estim_hwhm
    real, parameter :: q = 0.5
    real, dimension(:), intent(in) :: raper
    real(dbl), dimension(:), intent(in) :: prof
    real, dimension(size(prof)) :: p
    real :: d
    real(dbl) :: prof0
    integer :: i

    ! extrapolate to raper == 0 with first and second point
    ! and the profile  prof(r) = a*r**2 + c
    prof0 = (prof(1)*raper(2)**2 - prof(2)*raper(1)**2) / (raper(2)**2 - raper(1)**2)

    p = real(prof / prof0)

    if( p(1) < q ) then
       estim_hwhm = real(q*raper(1)/p(1))
       return
    end if

    do i = 2,size(raper)
       if( p(i-1) >= q .and. q > p(i) ) then
          d = (raper(i) - raper(i-1)) / (p(i) - p(i-1))
          estim_hwhm = raper(i-1) + d*(q - p(i-1))
          return
       end if
    end do

    estim_hwhm = -1

  end function estim_hwhm


  function optimal_index(raper,hwhm) result(nhwhm)

    real, dimension(:), intent(in) :: raper
    real, intent(in) :: hwhm

    integer :: nhwhm,naper,i

    naper = size(raper)

    ! the optimal aperture for starting point, see section
    ! Optimal Aperture Choice in On Calibration ...
    nhwhm = naper / 2
    do i = 1, naper
       ! the factor 3 is for bright stars with gaussian profile
       if( raper(i) > 3*hwhm ) then
          nhwhm = i
          exit
       end if
    end do

  end function optimal_index


end module grow_curve

!
! robfit - robust fitting
!
! Copyright © 2011-8 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module robfit

  use iso_fortran_env

  implicit none

  logical, private :: debug = .false.
  logical, private :: analytic = .true.
  logical, private :: rnewton = .true.
  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl
  real(dbl), dimension(:), allocatable, private :: uref,vref
  real(dbl), dimension(:), pointer, private :: xstar,ystar
  real(dbl), private :: refl, xcen, ycen, scale
  integer, private :: ndat

  private :: dres, minfun, fundif, funder, difjac, difvec, hessian_min

contains

  subroutine robmin(type,a,d,xc,yc,rf,xx,yy,mad,acen,dacen,dcen,ddcen, &
       sc,dsc,pa,dpa,stdsig,verbose,reliable)

    ! find proper transformation by robust method

    use oakleaf
    use astrotrafo
    use minpacks
    use neldermead

    ! parameters
    character(len=*),intent(in) :: type
    real(dbl),dimension(:), intent(in) :: a, d
    real(dbl),dimension(:), target, intent(in) :: xx,yy
    real(dbl),intent(in) :: mad,xc,yc,rf
    real(dbl),intent(inout) :: acen,dcen,sc,pa
    real(dbl),intent(out) :: dacen,ddcen,dsc,dpa,stdsig
    logical, intent(in) :: verbose
    logical, intent(out) :: reliable

    real(dbl), parameter :: eps = 10*epsilon(1.0_dbl)
    integer, parameter :: npar = 4

    real(dbl),dimension(npar) :: p,dp,p0
    real(dbl),dimension(npar,npar) :: fjac,cov
    real(dbl),dimension(:), allocatable :: du,dv,res
    integer :: iter,i,j,info,nprint,ifault,nra,ndec
    real(dbl) :: s,smin
    type(AstroTrafoProj) :: t,ti
    character(len=20) :: fmt
    character :: areli
    logical :: sreli, treli

    debug = verbose
    reliable = .false.

    if(debug) write(error_unit,*) '=== Robust fitting ==='

    stdsig = huge(stdsig)
    refl = rf
    xcen = xc
    ycen = yc
    ndat = size(a)
    xstar => xx
    ystar => yy

    if( .not. (ndat > npar) ) stop 'Robust fitting requires five stars > 5.'
    if( mad < epsilon(mad) ) stop 'Robust fit needs mad > 0.'

    allocate(uref(ndat),vref(ndat),du(ndat),dv(ndat),res(2*ndat))

    call trafo_init(t,type,acen,dcen)
    call proj(t,a,d,uref,vref)

    ! setup
    scale = mad / 0.6745
    p = [ 0.0_dbl, 0.0_dbl, 1.0_dbl / sc, pa / rad ]
    dp = [ 0.1*p(3), 0.1*p(3), 0.001*p(3), 0.1 / rad ]

    do iter = 1, precision(p)

       p0 = p

       if( rnewton ) then
          ! This piece of code has origin in the gold good times, when
          ! no divengence could had occured and the robust function
          ! has been on base Huber's minimax(). Tukey's functions
          ! needs more carefull approach and some plan B as fail-back.
          nprint = 0 ! or 1
          if( analytic ) then
             call lmder2(funder,p,eps,nprint,info)
          else
             call lmdif2(fundif,p,eps,nprint,info)
          end if
          if( info == 0 ) &
               write(error_unit,*) 'Error in robfit: Improper input parameters.'

          treli = info == 2 .or. info == 3
          ifault = info

       else
          treli = .false.
       end if

       if( .not. treli ) then

          p = p0
          ! Plan B
          ! Update estimate of parameters by method without derivation
          ! Because there are no methods reliable for finding of roots
          ! in multidimensional case, we replaced root finding by minimizing.
          call nelmin1(minfun,p,dp,smin,ifault)
          treli = ifault == 0
          if( .not. treli ) p = p0

       end if

       areli = ' '
       if( treli .and. iter > 1 ) then

          ! update estimate of dispersion by entropy,
          ! applied only on the already iterated center of projection
          call dres(p,res(1:ndat),res(ndat+1:2*ndat))
          call iscale(res,s,sreli)

          ! accept only reliable estimates
          if( sreli ) then
             scale = s
             areli = 'T'
          else
             areli = 'F'
          end if
       end if

       if( debug ) &
            write(error_unit,'(2i2,es10.2,2f11.5,2g12.3,f10.1,f7.1,1x,l1,a1)') &
            iter,ifault,scale,acen,dcen,p(1:2)/p(3),1/p(3),rad*p(4),treli,areli

       ! finish when parameters are appropriate small
       ! and iterations couldn't made further progress
       ! the precision is set to be better than 1/1000 of a pixel
       ! and reached usually within two iterations
       if( iter > 1 .and. all(abs(p(1:2)/p(3)) < 0.001) .and. treli ) then
          reliable = .true.
          exit
       end if

       ! update center of projection and projected coordinates
       call trafo_init(ti,type,acen=acen,dcen=dcen, &
            xcen=xcen,ycen=ycen,scale=p(3),rot=rad*p(4),refl=refl)
       call invproj(ti,p(1),p(2),acen,dcen)
       call trafo_init(t,type,acen,dcen)
       call proj(t,a,d,uref,vref)
       p(1:2) = 0.0_dbl

    end do

    ! statistical errors of parameters
    ! Hessian is recomputed analyticaly in view of the fact that
    ! we needs errors of acen, dcen (but p(1:2) are X0,Y0) and
    ! Jacobian by lmdif2 is scaled by errors (multiplication of s**2
    ! is satisfactory only for p(3:4).
    call hessian_min(p,fjac)
    call qrinv(fjac,cov)

    if( debug ) then
       write(fmt,'(a,i0,a)') '(a,',npar,'g15.5)'
       write(error_unit,'(a)') '# Hessian at minimum:'
       write(error_unit,fmt) ('#',fjac(i,:),i=1,npar)
       write(error_unit,'(a)') '# Covariance matrix (no regularisation):'
       write(error_unit,fmt) ('#',cov(i,:),i=1,npar)
       write(error_unit,'(a)') '# Correlation matrix:'
       do i = 1,npar
          write(error_unit,'(a)',advance="no")  '#'
          do j = 1,npar
             if( cov(i,i) > 0 .and. cov(j,j) > 0 ) then
                write(error_unit,'(f9.3)',advance="no") &
                     cov(i,j)/sqrt(cov(i,i)*cov(j,j))
             else
                ! Hessian is not regularised and Tukey's function has been used.
                write(error_unit,'(a9)',advance="no") ' *?* '
             end if
          end do
          write(error_unit,*)
       end do

    end if

    dp = -1
    do i = 1,npar
       if( scale > 0 .and. cov(i,i) > 0 ) &
            dp(i) = scale * sqrt(cov(i,i)/(ndat - npar))
    end do

    sc = 1.0_dbl/p(3)
    pa = rad*p(4)

    ! deviations of output parameters
    dacen = dp(1) / cos(dcen / rad) ! cos() sqeezes metric (distance) on sphere
    ddcen = dp(2)
    dsc = sc*(dp(3)/p(3))
    dpa = rad*dp(4)

    ! stdsig
    call dres(p,du,dv)
    stdsig = sum(tukey(du/scale)**2 + tukey(dv/scale)**2) / &
             sum(dtukey(du/scale) + dtukey(dv/scale))**2 * ndat / 2
    stdsig = scale * sqrt(stdsig)

    if( debug ) then
       call dres(p,du,dv)
       nra = count(du > 0)
       ndec = count(dv > 0)

       write(error_unit,'(a,4es13.3)') '# solution:  ',p(1:npar)
       write(error_unit,'(a,4es13.2)') '# deviations:',dp(1:npar)
       write(error_unit,'(a,es10.2,a,g0.3,a)') '# stdsig: ',stdsig, &
            ' [deg]    ',3600*stdsig,' [arcsec]'
       write(error_unit,'(a,i7,"/",f0.1,2(i5,"+-",f0.1))') &
            '# sign test (total/expected, RA+, Dec+): ',&
            ndat,ndat/2.0,nra,sqrt(nra*0.25),ndec,sqrt(ndec*0.25)
       ! simple version of sign test, var = n*p*(1-p), where p = 0.5
    end if

    deallocate(uref,vref,du,dv,res)

  end subroutine robmin


  subroutine dres(p,du,dv,u,v)

    use astrotrafo

    real(dbl), dimension(:), intent(in) :: p
    real(dbl), dimension(:), intent(out) :: du,dv
    real(dbl), dimension(:), intent(out), optional :: u,v

    real(dbl) :: uu,vv,x,y
    integer :: i
    type(AstroTrafoProj) :: t

    call trafo_init(t,xcen=xcen,ycen=ycen, &
         ucen=p(1),vcen=p(2),scale=p(3),rot=rad*p(4),refl=refl)

    do i = 1, ndat
       call invaffine(t,xstar(i),ystar(i),uu,vv,x,y)
       du(i) = uref(i) - uu
       dv(i) = vref(i) - vv

       ! u,v - projected coordinates of refence stars, refreshed in main loop
       ! x,y - coordinates of stars on CCD
       ! xx,yy - rotated (and reflexed), but not scaled, x,y coordinates
       ! du,dv - residuals
       ! uu,vv - rotated, sometimes reflexed, and scaled x,y coordinates

       if( present(u) .and. present(v) ) then
          u(i) = x
          v(i) = y
       end if
    end do

  end subroutine dres


  subroutine fundif(m,np,p,fvec,iflag)

    use oakleaf

    integer, intent(in) :: m,np
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(:), allocatable :: dx,dy,xx,yy
    real(dbl), dimension(4) :: dfvec
    real(dbl) :: sf,sc,sx,sy,fx,fy
    integer :: i

    if( iflag == 0 .and. debug ) &
         write(error_unit,*) '#robfit t:',real(p)

    sf = 0.0_dbl
    sc = 0.0_dbl
    sx = 0.0_dbl
    sy = 0.0_dbl

    allocate(dx(ndat),dy(ndat),xx(ndat),yy(ndat))
    call dres(p,dx,dy,xx,yy)
    do i = 1, ndat
       fx = tukey(dx(i)/scale)
       fy = tukey(dy(i)/scale)
!       fx = huber(dx(i)/scale)
!       fy = huber(dy(i)/scale)
!       fx = dx(i)/scale
!       fy = dy(i)/scale
       sx = sx + fx
       sy = sy + fy
       sc = sc + (fx*xx(i) + fy*yy(i))
       sf = sf + (fx*yy(i) - fy*xx(i))
    end do
    fvec = [ -sx,-sy,-sc,sf*p(3) ] /scale
    deallocate(dx,dy,xx,yy)

    if( debug .and. .false. ) then
       write(error_unit,'(a,4g15.5)') '    ',fvec * scale
       call difvec(p,dfvec)
       write(error_unit,'(a,4g15.5)') 'dif:',dfvec * scale
    end if

  end subroutine fundif


  subroutine funder(m,np,p,fvec,fjac,ldfjac,iflag)

    use oakleaf

    integer, intent(in) :: m,np,ldfjac
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
    real(dbl), dimension(:), allocatable :: fu,fv,dfu,dfv,du,dv,u,v,ru,rv
    real(dbl), dimension(m) :: fc
    real(dbl), dimension(4,4) :: dfjac
    real(dbl), dimension(4) :: dfvec
    real(dbl) :: r
    integer :: i,j

    if( iflag == 0 ) then
       write(error_unit,'(4f15.5)') p
       return
    end if

    allocate(fu(ndat),fv(ndat),du(ndat),dv(ndat),u(ndat),v(ndat), &
         ru(ndat),rv(ndat))
    call dres(p,du,dv,u,v)

    r = p(3)
    ru = du / scale
    rv = dv / scale
    fu = tukey(ru)
    fv = tukey(rv)
!    fu = huber(ru)
!    fv = huber(rv)
!    fu = ru
!    fv = rv

    fc(1) =-sum(fu)
    fc(2) =-sum(fv)
    fc(3) =-sum(fu*u + fv*v)
    fc(4) = sum(fu*v - fv*u) * r

    if( iflag == 1 ) then

       fvec = fc / scale

       if( debug .and. .false. ) then
          write(error_unit,'(a,4g15.5)') '    ',fvec * scale
          call difvec(p,dfvec)
          write(error_unit,'(a,4g15.5)') 'dif:',dfvec * scale
       end if

    else if( iflag == 2 ) then

       allocate(dfu(ndat),dfv(ndat))

       dfu = dtukey(ru)
       dfv = dtukey(rv)
!       dfu = dhuber(ru)
!       dfv = dhuber(rv)
!       dfu = 1
!       dfv = 1

       fjac = 0.0_dbl
       fjac(1,1) = sum(dfu)
       fjac(1,3) = sum(dfu*u)
       fjac(1,4) =-sum(dfu*v)*r
       fjac(2,2) = sum(dfv)
       fjac(2,3) = sum(dfv*v)
       fjac(2,4) = sum(dfv*u)*r
       fjac(3,3) = sum(dfu*u**2 + dfv*v**2)
       fjac(3,4) = sum((dfv - dfu)*u*v)*r
       fjac(4,4) = sum(dfu*v**2 + dfv*u**2)*r**2
       fjac = fjac / scale**2

       fjac(3,4) = fjac(3,4) + fc(4) / r / scale
       fjac(4,4) = fjac(4,4) - fc(3) * r / scale

       do i = 1,np
          do j = 1,i-1
             fjac(i,j) = fjac(j,i)
          end do
       end do

       if( debug .and. .false. ) then
          do i = 1,np
             write(error_unit,'(4g15.5)') fjac(i,:) * scale**2
          end do
          call difjac(p,dfjac)
          do i = 1,np
             write(error_unit,'(a,4g15.5)') 'dif: ',dfjac(i,:) * scale**2
          end do
       end if

       deallocate(dfu,dfv)

    end if

    deallocate(fu,fv,du,dv,u,v,ru,rv)

  end subroutine funder

  subroutine hessian_min(p,hess)

    real(dbl), dimension(:), intent(in) :: p
    real(dbl), dimension(:,:), intent(out) :: hess
    real(dbl), dimension(size(p),size(p)) :: fjac
    real(dbl), dimension(size(p)) :: fvec
    integer :: iflag,m

    iflag = 2
    m = size(p)
    call funder(m,m,p,fvec,fjac,m,iflag)
    hess = fjac*scale**2

  end subroutine hessian_min


  subroutine difjac(p,jac)

    ! numerical approximation of jacobian
    ! https://en.wikipedia.org/wiki/Finite_difference

    real(dbl), dimension(:), intent(in) :: p
    real(dbl), dimension(:,:), intent(out) :: jac
    real(dbl), dimension(size(p)) :: d,fv1,fv2
    integer :: i,n,iflag
    real(dbl) :: h

    n = size(p)
    h = sqrt(epsilon(h))
    d = 0.0_dbl

    jac = 0
    do i = 1, n
       if( abs(p(i)) > epsilon(p) ) then
          h = sqrt(epsilon(h))*abs(p(i))
       else
          h = sqrt(epsilon(h))
       end if
       d(i) = h
       call fundif(n,n,p+d,fv1,iflag)
       call fundif(n,n,p-d,fv2,iflag)
       jac(i,i:n) = (fv1(i:n) - fv2(i:n))/(2*h)
       d(i) = 0.0_dbl
    end do


  end subroutine difjac

  subroutine difvec(p,vec)

    ! numerical approximation of jacobian
    ! https://en.wikipedia.org/wiki/Finite_difference

    real(dbl), dimension(:), intent(in) :: p
    real(dbl), dimension(:), intent(out) :: vec
    real(dbl), dimension(size(p)) :: d
    integer :: i,n
    real(dbl) :: h,f1,f2

    n = size(p)
    h = sqrt(epsilon(h))
    d = 0.0_dbl

    do i = 1,n
       d(i) = h
       f1 = minfun(p+d)
       f2 = minfun(p-d)
       vec(i) = (f1 - f2)/(2*h)
       d(i) = 0.0_dbl
    end do

  end subroutine difvec


  function minfun(p)

    use oakleaf

    real(dbl) :: minfun
    real(dbl), dimension(:), intent(in) :: p
    real(dbl), dimension(:), allocatable :: du,dv

    allocate(du(ndat),dv(ndat))
    call dres(p,du,dv)
    minfun = sum(itukey(du/scale)) / ndat + sum(itukey(dv/scale)) / ndat
!    minfun = (sum(ihuber(du/scale)) + sum(ihuber(dv/scale))) / (2*ndat)
!    minfun = (sum((du/scale)**2 / 2) + sum((dv/scale)**2 / 2)) / (2*ndat)

  end function minfun

end module robfit

!
!  Generate artifical sky frame
!
!
!  Copyright © 2016-9 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!


module generator

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)

  private :: stardist

contains

  subroutine spreadstars(spsf,xcoo,ycoo,flux,jitter,sky)

    use noise
    use spray

    type(SprayType), intent(in) :: spsf
    real(dbl), dimension(:), intent(in) :: xcoo,ycoo,flux
    logical, intent(in) :: jitter
    real(dbl), dimension(:,:), intent(in out) :: sky
    integer, dimension(2) :: naxes
    real(dbl), dimension(:,:), allocatable :: psf
    real(dbl) :: f,dx,dy
    integer :: nw,i,j,n,x,y,k,l

    naxes = shape(sky)

    nw = spsf%nbox
    allocate(psf(-nw:nw,-nw:nw))

    do n = 1, size(xcoo)
       x = nint(xcoo(n))
       y = nint(ycoo(n))
       dx = x - xcoo(n)
       dy = y - ycoo(n)

       call spsf%Pixelize(dx,dy,psf,nw)
       psf = flux(n)*psf

       do i = x - nw, x + nw
          k = i - x
          do j = y - nw, y + nw
             l = j - y
             if(  1 <= i .and. i <= naxes(1) .and. &
                  1 <= j .and. j <= naxes(2) ) then
                f = psf(k,l)
                if( f > 0 ) then
                   if( jitter ) then
                      sky(i,j) = sky(i,j) + pnoise(f)
                   else
                      sky(i,j) = sky(i,j) + f
                   end if
                end if
             end if
          end do
       end do

    end do

    deallocate(psf)

  end subroutine spreadstars

  subroutine rain(alpha,delta,mag,scale,angle,crval,crpix,phsystable, &
       phsystem,filter,xcoo,ycoo,flux)

    use astrotrafo
    use phsysfits
    use photoconv

    real(dbl), dimension(:), intent(in) :: alpha,delta,mag
    character(len=*), intent(in) :: filter, phsystable, phsystem
    real(dbl), dimension(:), intent(in) :: crpix, crval
    real(dbl), intent(in) :: scale,angle
    real(dbl), dimension(:), allocatable, intent(out) :: xcoo,ycoo,flux
    type(AstroTrafoProj) :: t
    type(type_phsys) :: phsys
    real(dbl), dimension(:), allocatable :: dmag, dflux
    integer :: n

    call trafo_init(t,'GNOMONIC',crval(1),crval(2),crpix(1),crpix(2),&
         scale=scale,rot=angle)

    n = size(alpha)
    allocate(xcoo(n),ycoo(n),flux(n),dmag(n),dflux(n))
    call trafo(t,alpha,delta,xcoo,ycoo)

    call phselect(phsystable,phsystem,phsys)
    dmag = 0
    call phsysmagph1(phsys,filter,mag,dmag,flux,dflux)

    deallocate(dmag, dflux)

  end subroutine rain


  subroutine catstars(cat,labels,scale,angle,crval,crpix,phsystable, &
       phsystem,filter,xcoo,ycoo,flux)

    use catio

    character(len=*), intent(in) :: cat, filter, phsystable, phsystem
    character(len=*), dimension(:), intent(in) :: labels
    real(dbl), dimension(:), intent(in) :: crpix, crval
    real(dbl), intent(in) :: scale,angle
    real(dbl), dimension(:), allocatable, intent(out) :: xcoo,ycoo,flux
    real(dbl), dimension(:), allocatable :: alpha,delta,mag
    character(len=80) :: catid

    call catalogue(cat,labels,alpha,delta,mag,catid)

    call rain(alpha,delta,mag,scale,angle,crval,crpix,phsystable, &
         phsystem,filter,xcoo,ycoo,flux)

    deallocate(alpha,delta,mag)

  end subroutine catstars


  subroutine genstars(maglim,naxes,xcoo,ycoo,flux)

    integer, intent(in) :: maglim
    integer, dimension(:), intent(in) :: naxes
    real(dbl), dimension(:), allocatable, intent(out) :: xcoo,ycoo,flux
    integer, dimension(0:maglim) :: nsq
    real :: x,y
    integer :: mag,n,i

    call stardist(maglim,nsq)

    n = sum(nsq)
    allocate(xcoo(n),ycoo(n),flux(n))

    n = 0

    do mag = 0, maglim

       do i = 1,nsq(mag)

          n = n + 1

          ! coordinates
          call random_number(x)
          call random_number(y)
          xcoo(n) = naxes(1) * x
          ycoo(n) = naxes(2) * y

          ! flux
          call random_number(x)
          flux(n) = 5e4*10**(-0.4*(mag + x - maglim + 1))

       end do

    end do

  end subroutine genstars


  subroutine stardist(maglim,nsq)

    integer, intent(in) :: maglim
    integer, dimension(0:), intent(out) :: nsq
    integer :: mag

    ! mean magnitude distribution by Gaia DR1:
    ! https://www.cosmos.esa.int/web/gaia/dr1
    ! approximated as sigma(m) = 1e-4*exp(1.1*mag)

    do mag = 0, maglim
       nsq(mag) = int(1e-4*exp(1.1*mag)) ! per square degree
    end do

  end subroutine stardist


  subroutine background(b,bgrad,jitter,sky)

    use noise

    real(dbl), intent(in) :: b
    real(dbl), dimension(:), intent(in) :: bgrad
    logical, intent(in) :: jitter
    real(dbl), dimension(:,:), intent(out) :: sky
    integer :: i,j,ic,jc
    real(dbl) :: db,dx,dy

    db = sqrt(b)
    ic = size(sky,1) / 2
    jc = size(sky,2) / 2
    do i = 1,size(sky,1)
       dx = (i - ic)*bgrad(1)
       do j = 1,size(sky,2)
          dy = (j - jc)*bgrad(2)
          if( jitter ) then
             sky(i,j) = gnoise(b + dx + dy,db)
          else
             sky(i,j) = b + dx + dy
          end if
       end do
    end do

  end subroutine background

end module generator

!
! Catalogue cross-match
!
! Copyright © 2013 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program cross

  use iso_fortran_env
  use fitsio

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  integer, parameter :: nfile = 2

  integer :: eq
  character(len=FLEN_VALUE), dimension(nfile) :: col_ra, col_dec, &
       col_pmra, col_pmdec, col_mag
  character(len=FLEN_KEYWORD) :: key_epoch
  character(len=4*FLEN_FILENAME) :: record, key, val, output, backup
  character(len=4*FLEN_FILENAME), dimension(nfile) :: file
  logical :: verbose = .false.
  real(dbl) :: tol,ftol
  integer :: n

  key_epoch = FITS_KEY_EPOCH
  col_ra = 'RA'
  col_dec = 'DEC'
  col_pmra = ''
  col_pmdec = ''
  col_mag = ''

  file=''
  output = ''
  backup = ''
  tol = epsilon(tol)
  ftol = 1

  do
     
     read(*,'(a)',end=99) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Improper input.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'OUTPUT' ) then

        read(val,*) output, backup

     else if( key == 'NFILE' ) then

        read(val,*) n
        if( nfile /= n ) stop 'Cross-match requires exactly two files.'
        n = 0

     else if( key == 'COL_RA' ) then

        read(val,*) col_ra

     else if( key == 'COL_DEC' ) then

        read(val,*) col_dec

     else if( key == 'COL_PMRA' ) then

        read(val,*) col_pmra

     else if( key == 'COL_PMDEC' ) then

        read(val,*) col_pmdec

     else if( key == 'COL_MAG' ) then

        read(val,*) col_mag

     else if( key == 'FITS_KEY_EPOCH' ) then
        
        read(val,*) key_epoch

     else if( key == 'TOL' ) then

        read(val,*) tol

     else if( key == 'FTOL' ) then

        read(val,*) ftol

     else if( key == 'FILE' ) then

        n = n + 1
        read(val,*) file(n)

     end if

  end do
99 continue

  call crossing

  stop 0

contains


  subroutine crossing

    use crossmatch

    real(dbl), allocatable, dimension(:) :: ra1,dec1,flux1,ra2,dec2,flux2
    integer, dimension(:,:), allocatable :: idx
    character(len=FLEN_VALUE) :: catid1,catid2
    integer :: status
!    integer :: i

    status = 0
    call tabcoo(file(1),col_ra(1),col_dec(1),col_pmra(1),col_pmdec(1),&
         col_mag(1),key_epoch,ra1,dec1,flux1,catid1,status)
    call tabcoo(file(2),col_ra(2),col_dec(2),col_pmra(2),col_pmdec(2),&
         col_mag(2),key_epoch,ra2,dec2,flux2,catid2,status)

    allocate(idx(nfile,max(size(ra1),size(ra2))))

    call join(ra1,dec1,ra2,dec2,tol,ftol,idx)

    ! check point
!    do i = 1,size(idx,2)
!       if( idx(2,i) > 0 ) then
!          write(*,*) i,idx(:,i),ra2(idx(2,i)),dec2(idx(2,i)),ra1(i),dec1(i)
!       end if
!    end do
    
    call savecross(output,file,idx,status)

    deallocate(ra1,dec1,ra2,dec2,flux1,flux2,idx)

  end subroutine crossing

  
  subroutine tabcoo(filename,col_ra,col_dec,col_pmra,col_pmdec,&
         col_mag,key_epoch,ra,dec,flux,catid,status)

    use trajd

    character(len=*), intent(in) :: filename, col_ra, col_dec, col_pmra, &
         col_pmdec, col_mag, key_epoch
    real(dbl), allocatable, dimension(:), intent(out) :: ra, dec, flux
    character(len=*), intent(out) :: catid
    integer, intent(in out) :: status

    real(dbl), parameter :: nullval = 0.0_dbl
    integer, parameter :: ncols = 5, frow = 1, felem = 1
    integer, dimension(ncols) :: col, statuses
    integer :: nrows,i
    logical :: anyf
    character(len=FLEN_CARD) :: buf
    character(len=FLEN_VALUE), dimension(ncols) :: label,colname
    real(dbl), allocatable, dimension(:) :: alpha, delta, pmalpha, pmdelta
    real(dbl) :: t0,t,dt

    if( status /= 0 ) return

    ! ICRS
    t0 = yearjd(2000.00_dbl)

    label(1) = col_ra
    label(2) = col_dec
    label(3) = col_pmra
    label(4) = col_pmdec
    label(5) = col_mag

    if( label(1) == '' .or. label(2) == '' ) then
       write(error_unit,*) "Coordinate columns are not fully specified (empty)."
       return
    end if

    ! open and move to a table extension
    call fttopn(15,filename,0,status)
    call ftgnrw(15,nrows,status)
    if( status /= 0 ) then
       write(error_unit,*) "Failed to open table in `"//trim(filename)//"'."
       goto 666
    end if

    if( .not. (nrows > 0) ) then
       write(error_unit,*) "Table `"//trim(filename)//"' looks empty."
       goto 666
    end if

    ! identification of catalogue
    call ftgkys(15,'EXTNAME',catid,buf,status)
    call ftgkyd(15,key_epoch,t,buf,status)
    if( status == KEYWORD_NOT_FOUND ) then
       write(error_unit,*) "Epoch by `"//trim(key_epoch)// &
            "' keyword not found (assumed J2000.0)."
       status = 0
       t = t0
    end if

    ! find columns by labels
    statuses = 0
    col = 0
    do i = 1, ncols
       if( label(i) /= '' ) then
          call ftgcnn(15,.false.,label(i),colname(i),col(i),statuses(i))
       else
          col(i) = 0
       end if
    end do
    
    if( col(1) == 0 .or. col(2) == 0 ) then
       write(error_unit,*) "Coordinates column `"//trim(col_ra)//","// &
            trim(col_dec)//"' in `"//trim(filename)//"' not found."
       goto 666
    end if



    allocate(alpha(nrows),delta(nrows))
    call ftgcvd(15,col(1),frow,felem,nrows,nullval,alpha,anyf,status)
    call ftgcvd(15,col(2),frow,felem,nrows,nullval,delta,anyf,status)
    if( status /= 0 ) goto 666

    allocate(pmalpha(nrows),pmdelta(nrows))
    pmalpha = 0.0_dbl
    pmdelta = 0.0_dbl
    if( col(3) /= 0 .and. col(4) /= 0) then
       call ftgcvd(15,col(3),frow,felem,nrows,nullval,pmalpha,anyf,status)
       call ftgcvd(15,col(4),frow,felem,nrows,nullval,pmdelta,anyf,status)
    end if
    if( status == 0 ) then
       pmalpha = pmalpha / 3.6e6_dbl  ! supposing mas/year
       pmdelta = pmdelta / 3.6e6_dbl
    else 
       write(error_unit,*) "Requested proper-motion columns `"//trim(col_ra)//","// &
            trim(col_dec)//"' in `"//trim(filename)//"' not found."
       goto 666
    end if

    allocate(flux(nrows))
    if( col(5) /= 0 ) then
       call ftgcvd(15,col(5),frow,felem,nrows,nullval,flux,anyf,status)

       if( status == 0 ) then
          flux = 10.0**((25.0 - flux)/2.5)
       else
          write(error_unit,*) "Requested proper-motion columns `"//trim(col_ra)//","// &
               trim(col_dec)//"' in `"//trim(filename)//"' not found."
          flux = 0.0
       end if
    end if

    if( status /= 0 ) goto 666

    call ftclos(15,status)


    ! compute coordinates for the epoch
    allocate(ra(nrows),dec(nrows))
    dt = (t - t0)/ 365.25


    ra  = alpha + dt*pmalpha
    dec = delta + dt*pmdelta

!    return

666 continue

    if( allocated(alpha) ) deallocate(alpha,delta)
    if( allocated(pmalpha) ) deallocate(pmalpha,pmdelta)
!    if( allocated(flux) ) deallocate(flux)

    call ftclos(15,status)
    call ftrprt('STDERR',status)


  end subroutine tabcoo

  subroutine savecross(output,filename,idx,status)

    character(len=*), intent(in) :: output
    character(len=*), dimension(:), intent(in) :: filename
    integer, dimension(:,:), intent(in) :: idx
    integer, intent(in out) :: status

    integer, parameter :: frow = 1, felem = 1
    character(len=FLEN_VALUE), dimension(:), allocatable :: ttype, tform,tunit
    character(len=FLEN_KEYWORD) :: key
    integer, dimension(:), allocatable :: iq
    integer :: nrows,i

    status = 0
    call ftinit(26,output,0,status)

    allocate(ttype(nfile),tform(nfile),tunit(nfile))

    tform = '1J'
    tunit = ''

    ttype = filename
    call ftibin(26,0,size(ttype),ttype,tform,tunit,'CROSSMATCH',0,status)

    do i = 1,nfile
       write(key,'(a,i1)') 'FILE',i
       call ftukys(26,key,filename(i),'FITS table',status)
    end do

    nrows = size(idx,2)
    allocate(iq(nrows))
    do i = 1,nfile
       iq = idx(i,:)
       call ftpclj(26,i,frow,felem,nrows,iq,status)
    end do
    deallocate(iq)
    call ftclos(26,status)

    call ftrprt('STDERR',status)

    deallocate(ttype,tform,tunit)

  end subroutine savecross
  

end program cross

!
!  Fortran 2008+ interface for (c)FITSIO library
!
!  Purpose of this module is to provide the interface to cFITSIO
!  in native Fortran data types. The long-names provides generic
!  names (selected by actual passed arguments).
!
!  Copyright © 2020-2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module fitsio

  use cfitsio
  use iso_fortran_env
  use, intrinsic :: iso_c_binding
  implicit none

  ! basic constants (fitsio.h)
  integer, parameter :: FLEN_FILENAME = 1025 ! max length of a filename
  integer, parameter :: FLEN_KEYWORD = 75    ! max length of a keyword
  integer, parameter :: FLEN_CARD = 81       ! length of a FITS header card
  integer, parameter :: FLEN_VALUE = 71      ! max length of a keyword value string
  integer, parameter :: FLEN_COMMENT = 73    ! max length of a keyword comment string
  integer, parameter :: FLEN_ERRMSG = 81     ! max length of a FITSIO error message
  integer, parameter :: FLEN_STATUS = 31     ! max length of a FITSIO status text


  ! Codes for FITS extension types
  integer, parameter :: &
       FITS_IMAGE_HDU = 0, &
       FITS_ASCII_TBL = 1, &
       FITS_BINARY_TBL = 2, &
       FITS_ANY_HDU = 2

  integer, parameter :: &
       FITS_READONLY = 0, &
       FITS_READWRITE = 1

  ! table labels sensitivity
  integer, parameter :: &
       FITS_CASEINSEN = 0, &
       FITS_CASESEN = 1

  ! error codes
  integer, parameter :: FITS_FILE_NOT_OPENED = 104
  integer, parameter :: FITS_FILE_NOT_CREATED = 105
  integer, parameter :: FITS_READ_ERROR = 108
  integer, parameter :: FITS_BAD_HDU_NUM = 301
  integer, parameter :: FITS_KEYWORD_NOT_FOUND = 202
  integer, parameter :: FITS_COLUMN_NOT_FOUND = 219
  integer, parameter :: FITS_NUMERICAL_OVERFLOW = 412
  integer, parameter :: FITS_MULTIPLE_MATCH = 237


  type :: fitsfiles
     type(c_ptr) :: fptr
     character(len=FLEN_FILENAME) :: filename
  end type fitsfiles


  interface fits_read_key
     module procedure fits_read_key_str, fits_read_key_str_null, &
          fits_read_key_lng, fits_read_key_lng_null, &
          fits_read_key_flt, fits_read_key_flt_null, &
          fits_read_key_dbl, fits_read_key_dbl_null
  end interface fits_read_key

  interface fits_write_key
     module procedure fits_write_key_str, fits_write_key_lng, &
          fits_write_key_flt, fits_write_key_dbl
  end interface fits_write_key

  interface fits_update_key
     module procedure fits_update_key_str, fits_update_key_lng, &
          fits_update_key_flt, fits_update_key_dbl
  end interface fits_update_key

  interface fits_read_col
     module procedure fits_read_col_str, fits_read_col_log, &
          fits_read_col_lng, fits_read_col_flt, fits_read_col_dbl
  end interface fits_read_col

  interface fits_write_col
     module procedure fits_write_col_str, fits_write_col_log, &
          fits_write_col_lng, fits_write_col_flt, fits_write_col_dbl
  end interface fits_write_col

  interface fits_read_img
     module procedure fits_read_img_chr, fits_read_img_int, &
          fits_read_img_flt, fits_read_img_dbl
  end interface fits_read_img

  interface fits_write_img
     module procedure fits_write_img_chr, fits_write_img_int, &
          fits_write_img_flt, fits_write_img_dbl
  end interface fits_write_img

  interface fits_read_2d
     module procedure fits_read_2d_chr, fits_read_2d_int, &
          fits_read_2d_flt, fits_read_2d_dbl
  end interface fits_read_2d

  interface fits_read_3d
     module procedure fits_read_3d_chr, fits_read_3d_int, &
          fits_read_3d_flt, fits_read_3d_dbl
  end interface fits_read_3d

  interface fits_write_2d
     module procedure fits_write_2d_chr, fits_write_2d_int, &
          fits_write_2d_flt, fits_write_2d_dbl
  end interface fits_write_2d

  interface fits_write_3d
     module procedure fits_write_3d_chr, fits_write_3d_int, &
          fits_write_3d_flt, fits_write_3d_dbl
  end interface fits_write_3d

  private :: fchar, cchar

contains


  ! File Access Routines

  subroutine fits_open_file(fitsfile,filename,iomode,status)

    type(fitsfiles), intent(out) :: fitsfile
    character(len=*), intent(in) :: filename
    integer, intent(in) :: iomode
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(len_trim(filename)+1) :: name
    integer(kind=C_INT) :: rwmode, stat

    fitsfile%filename = filename
    call cchar(filename,name)
    stat = status
    rwmode = iomode
    status = ffopen(fitsfile%fptr,name,rwmode,stat)

  end subroutine fits_open_file

  subroutine fits_open_table(fitsfile,filename,iomode,status)

    type(fitsfiles), intent(out) :: fitsfile
    character(len=*), intent(in) :: filename
    integer, intent(in) :: iomode
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(len_trim(filename)+1) :: name
    integer(kind=C_INT) :: rwmode, stat

    fitsfile%filename = filename
    call cchar(filename,name)
    stat = status
    rwmode = iomode
    status = fftopn(fitsfile%fptr,name,rwmode,stat)

  end subroutine fits_open_table

  subroutine fits_open_image(fitsfile,filename,iomode,status)

    type(fitsfiles), intent(out) :: fitsfile
    character(len=*), intent(in) :: filename
    integer, intent(in) :: iomode
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(len_trim(filename)+1) :: name
    integer(kind=C_INT) :: rwmode, stat

    fitsfile%filename = filename
    call cchar(filename,name)
    stat = status
    rwmode = iomode
    status = ffiopn(fitsfile%fptr,name,rwmode,stat)

  end subroutine fits_open_image


  subroutine fits_create_file(fitsfile,filename,status)

    type(fitsfiles), intent(out) :: fitsfile
    character(len=*), intent(in) :: filename
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(len_trim(filename)+1) :: name
    integer(kind=C_INT) :: stat

    fitsfile%filename = filename
    call cchar(filename,name)
    stat = status
    status = ffinit(fitsfile%fptr,name,stat)

  end subroutine fits_create_file


  subroutine fits_close_file(fitsfile,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in out) :: status

    integer(kind=C_INT) :: stat

    stat = status
    status = ffclos(fitsfile%fptr,stat)

  end subroutine fits_close_file

  subroutine fits_delete_file(fitsfile,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in out) :: status

    integer(kind=C_INT) :: stat

    stat = status
    status = ffdelt(fitsfile%fptr,stat)

  end subroutine fits_delete_file


  ! HDU Access Routines

  subroutine fits_movabs_hdu(fitsfile,hdunum,hdutype,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: hdunum
    integer, intent(out) :: hdutype
    integer, intent(in out) :: status

    integer(kind=C_INT) :: n,m,stat

    stat = status
    n = hdunum
    status = ffmahd(fitsfile%fptr,n,m,stat)
    hdutype = m

  end subroutine fits_movabs_hdu

  subroutine fits_movnam_hdu(fitsfile,hdutype,extname,extver,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: hdutype, extver
    character(len=*), intent(in) :: extname
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(len_trim(extname)+1) :: name
    integer(kind=C_INT) :: n,m,stat

    call cchar(extname,name)
    stat = status
    n = hdutype
    m = extver
    status = ffmnhd(fitsfile%fptr,n,name,m,stat)

  end subroutine fits_movnam_hdu

  subroutine fits_get_num_hdus(fitsfile,hdunum,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(out) :: hdunum
    integer, intent(in out) :: status

    integer(kind=C_INT) :: n,stat

    stat = status
    status = ffthdu(fitsfile%fptr,n,stat)
    hdunum = n

  end subroutine fits_get_num_hdus

  subroutine fits_get_hdu_num(fitsfile,hdunum)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(out) :: hdunum

    integer(kind=C_INT) :: n

    hdunum = ffghdn(fitsfile%fptr,n)

  end subroutine fits_get_hdu_num

  subroutine fits_copy_file(infits,outfits,previous,current,following,status)

    type(fitsfiles), intent(in) :: infits, outfits
    integer, intent(in) :: previous,current,following
    integer, intent(in out) :: status

    integer(kind=C_INT) :: stat,n,m,k

    stat = status
    n = previous
    m = current
    k = following
    status = ffcpfl(infits%fptr,outfits%fptr,n,m,k,stat)

  end subroutine fits_copy_file

  subroutine fits_copy_hdu(infits,outfits,morekeys,status)

    type(fitsfiles), intent(in) :: infits, outfits
    integer, intent(in) :: morekeys
    integer, intent(in out) :: status

    integer(kind=C_INT) :: stat,m

    stat = status
    m = morekeys
    status = ffcopy(infits%fptr,outfits%fptr,m,stat)

  end subroutine fits_copy_hdu

  subroutine fits_copy_header(infits,outfits,status)

    type(fitsfiles), intent(in) :: infits, outfits
    integer, intent(in out) :: status

    integer(kind=C_INT) :: stat

    stat = status
    status = ffcphd(infits%fptr,outfits%fptr,stat)

  end subroutine fits_copy_header

  subroutine fits_delete_hdu(fitsfile,hdutype,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(out) :: hdutype
    integer, intent(in out) :: status

    integer(kind=C_INT) :: stat, type

    stat = status
    status = ffdhdu(fitsfile%fptr,type,stat)
    hdutype = type

  end subroutine fits_delete_hdu

  subroutine fits_insert_img(fitsfile,bitpix,naxis,naxes,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: bitpix, naxis
    integer, dimension(:), intent(in) :: naxes
    integer, intent(in out) :: status

    integer(kind=C_INT) :: bpix, maxis, stat
    integer(kind=C_LONG), dimension(size(naxes)) :: maxes

    stat = status
    bpix = bitpix
    maxis = naxis
    maxes = naxes
    status = ffiimg(fitsfile%fptr,bpix,maxis,maxes,stat)

  end subroutine fits_insert_img

  subroutine fits_insert_btbl(fitsfile,nrows,ttype,tform,tunit,extname,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: nrows
    character(len=*), dimension(:), intent(in) :: ttype,tform,tunit
    character(len=*) :: extname
    integer, intent(in out) :: status

    integer :: i
    character(kind=C_CHAR), dimension(len_trim(extname)+1) :: name
    integer(kind=C_LONG_LONG) :: mrows, pcount
    integer(kind=C_INT) :: tfields, stat
    character(kind=C_CHAR), dimension(len(ttype)+1,size(ttype)), target :: mtype
    character(kind=C_CHAR), dimension(len(tform)+1,size(ttype)), target :: mform
    character(kind=C_CHAR), dimension(len(tunit)+1,size(ttype)), target :: munit
    type(c_ptr), dimension(size(ttype)) :: type_ptr, form_ptr, unit_ptr

    stat = status
    mrows = nrows
    tfields = size(ttype)
    pcount = 0

    do i = 1, tfields
       call cchar(ttype(i),mtype(:,i))
       type_ptr(i) = C_LOC(mtype(:,i))
       call cchar(tform(i),mform(:,i))
       form_ptr(i) = C_LOC(mform(:,i))
       call cchar(tunit(i),munit(:,i))
       unit_ptr(i) = C_LOC(munit(:,i))
    end do

    call cchar(extname,name)

    status = ffibin(fitsfile%fptr,mrows,tfields,type_ptr,form_ptr,unit_ptr, &
         name,pcount,stat)

  end subroutine fits_insert_btbl


  ! Header Keyword Read/Write Routines

  subroutine fits_read_keyword(fitsfile,keyname,val,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    character(len=*), intent(out) :: val, com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k,v
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    status = ffgkey(fitsfile%fptr,k,v,c,stat)
    call fchar(v,val)
    call fchar(c,com)

  end subroutine fits_read_keyword

  subroutine fits_read_key_str(fitsfile,keyname,val,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    character(len=*), intent(out) :: val, com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k,v
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    status = ffgkys(fitsfile%fptr,k,v,c,stat)
    call fchar(v,val)
    call fchar(c,com)

  end subroutine fits_read_key_str

  subroutine fits_read_key_str_null(fitsfile,keyname,val,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    character(len=*), intent(out) :: val
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k,v
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    status = ffgkys(fitsfile%fptr,k,v,c,stat)
    call fchar(v,val)

  end subroutine fits_read_key_str_null


  subroutine fits_read_key_lng(fitsfile,keyname,val,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    integer, intent(out) :: val
    character(len=*), intent(out) :: com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k
    integer(kind=C_LONG) :: n
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    status = ffgkyj(fitsfile%fptr,k,n,c,stat)
    call fchar(c,com)
    val = int(n)

  end subroutine fits_read_key_lng

  subroutine fits_read_key_lng_null(fitsfile,keyname,val,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    integer, intent(out) :: val
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k
    integer(kind=C_LONG) :: n
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    status = ffgkyj(fitsfile%fptr,k,n,c,stat)
    val = int(n)

  end subroutine fits_read_key_lng_null


  subroutine fits_read_key_flt(fitsfile,keyname,val,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    real(REAL32), intent(out) :: val
    character(len=*), intent(out) :: com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k
    real(kind=C_FLOAT) :: x
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    status = ffgkye(fitsfile%fptr,k,x,c,stat)
    call fchar(c,com)
    val = x

  end subroutine fits_read_key_flt

  subroutine fits_read_key_flt_null(fitsfile,keyname,val,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    real(REAL32), intent(out) :: val
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k
    real(kind=C_FLOAT) :: x
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    status = ffgkye(fitsfile%fptr,k,x,c,stat)
    val = x

  end subroutine fits_read_key_flt_null

  subroutine fits_read_key_dbl(fitsfile,keyname,val,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    real(REAL64), intent(out) :: val
    character(len=*), intent(out) :: com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k
    real(kind=C_DOUBLE) :: x
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    status = ffgkyd(fitsfile%fptr,k,x,c,stat)
    call fchar(c,com)
    val = x

  end subroutine fits_read_key_dbl

  subroutine fits_read_key_dbl_null(fitsfile,keyname,val,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    real(REAL64), intent(out) :: val
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k
    real(kind=C_DOUBLE) :: x
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    status = ffgkyd(fitsfile%fptr,k,x,c,stat)
    val = x

  end subroutine fits_read_key_dbl_null

  subroutine fits_write_key_str(fitsfile,keyname,val,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname, val, com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k,v
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    call cchar(val,v)
    call cchar(com,c)
    status = ffpkys(fitsfile%fptr,k,v,c,stat)

  end subroutine fits_write_key_str

  subroutine fits_write_key_lng(fitsfile,keyname,val,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    integer, intent(in) :: val
    character(len=*), intent(in) :: com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k
    integer(kind=C_LONG_LONG) :: n
    integer(kind=C_INT) :: stat

    stat = status
    n = val
    call cchar(keyname,k)
    call cchar(com,c)
    status = ffpkyj(fitsfile%fptr,k,n,c,stat)

  end subroutine fits_write_key_lng

  subroutine fits_write_key_flt(fitsfile,keyname,val,decimals,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    real(REAL32), intent(in) :: val
    integer, intent(in) :: decimals
    character(len=*), intent(in) :: com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k
    real(kind=C_FLOAT) :: x
    integer(kind=C_INT) :: stat, d

    x = val
    d = decimals
    stat = status
    call cchar(keyname,k)
    call cchar(com,c)
    status = ffpkye(fitsfile%fptr,k,x,d,c,stat)

  end subroutine fits_write_key_flt

  subroutine fits_write_key_dbl(fitsfile,keyname,val,decimals,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    real(REAL64), intent(in) :: val
    integer, intent(in) :: decimals
    character(len=*), intent(in) :: com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k
    real(kind=C_DOUBLE) :: x
    integer(kind=C_INT) :: stat, d

    x = val
    d = decimals
    stat = status
    call cchar(keyname,k)
    call cchar(com,c)
    status = ffpkyd(fitsfile%fptr,k,x,d,c,stat)

  end subroutine fits_write_key_dbl

  subroutine fits_update_key_str(fitsfile,keyname,val,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname, val, com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k,v
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    call cchar(val,v)
    call cchar(com,c)
    status = ffukys(fitsfile%fptr,k,v,c,stat)

  end subroutine fits_update_key_str

  subroutine fits_update_key_lng(fitsfile,keyname,val,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    integer, intent(in) :: val
    character(len=*), intent(in) :: com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k
    integer(kind=C_LONG_LONG) :: n
    integer(kind=C_INT) :: stat

    stat = status
    n = val
    call cchar(keyname,k)
    call cchar(com,c)
    status = ffukyj(fitsfile%fptr,k,n,c,stat)

  end subroutine fits_update_key_lng

  subroutine fits_update_key_flt(fitsfile,keyname,val,decimals,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    real(REAL32), intent(in) :: val
    integer, intent(in) :: decimals
    character(len=*), intent(in) :: com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k
    real(kind=C_FLOAT) :: x
    integer(kind=C_INT) :: stat, d

    x = val
    d = decimals
    stat = status
    call cchar(keyname,k)
    call cchar(com,c)
    status = ffukye(fitsfile%fptr,k,x,d,c,stat)

  end subroutine fits_update_key_flt

  subroutine fits_update_key_dbl(fitsfile,keyname,val,decimals,com,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    real(REAL64), intent(in) :: val
    integer, intent(in) :: decimals
    character(len=*), intent(in) :: com
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: c,k
    real(kind=C_DOUBLE) :: x
    integer(kind=C_INT) :: stat, d

    x = val
    d = decimals
    stat = status
    call cchar(keyname,k)
    call cchar(com,c)
    status = ffukyd(fitsfile%fptr,k,x,d,c,stat)

  end subroutine fits_update_key_dbl

  subroutine fits_read_key_unit(fitsfile,keyname,unit,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    character(len=*), intent(out) :: unit
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: k,u
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    status = ffgunt(fitsfile%fptr,k,u,stat)
    call fchar(u,unit)

  end subroutine fits_read_key_unit

  subroutine fits_delete_key(fitsfile,keyname,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: keyname
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: k
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(keyname,k)
    status = ffdkey(fitsfile%fptr,k,stat)

  end subroutine fits_delete_key

  subroutine fits_write_comment(fitsfile,comment,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: comment
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: com
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(comment,com)
    status = ffpcom(fitsfile%fptr,com,stat)

  end subroutine fits_write_comment

  subroutine fits_write_history(fitsfile,history,status)

    type(fitsfiles), intent(in) :: fitsfile
    character(len=*), intent(in) :: history
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: hist
    integer(kind=C_INT) :: stat

    stat = status
    call cchar(history,hist)
    status = ffpcom(fitsfile%fptr,hist,stat)

  end subroutine fits_write_history

  subroutine fits_read_record(fitsfile,keynum,card,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: keynum
    character(len=*), intent(out) :: card
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(FLEN_CARD) :: line
    integer(kind=C_INT) :: stat, n

    stat = status
    n = keynum
    status = ffgrec(fitsfile%fptr,n,line,stat)
    call fchar(line,card)

  end subroutine fits_read_record

  subroutine fits_delete_record(fitsfile,keynum,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: keynum
    integer, intent(in out) :: status

    integer(kind=C_INT) :: stat, n

    stat = status
    n = keynum
    status = ffdrec(fitsfile%fptr,n,stat)

  end subroutine fits_delete_record



  ! Primary Array or IMAGE Extension I/O Routines

  subroutine fits_get_img_type(fitsfile,bitpix,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(out) :: bitpix
    integer, intent(in out) :: status

    integer(kind=C_INT) :: bpix, stat

    stat = status
    status = ffgidt(fitsfile%fptr,bpix,stat)
    status = stat
    bitpix = bpix

  end subroutine fits_get_img_type

  subroutine fits_get_img_dim(fitsfile,naxis,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(out) :: naxis
    integer, intent(in out) :: status

    integer(kind=C_INT) :: maxis, stat

    stat = status
    status = ffgidm(fitsfile%fptr,maxis,stat)
    naxis = maxis

  end subroutine fits_get_img_dim

  subroutine fits_get_img_size(fitsfile,naxis,naxes,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: naxis
    integer, dimension(:), intent(out) :: naxes
    integer, intent(in out) :: status

    integer(kind=C_INT) :: maxdim, stat
    integer(kind=C_LONG), dimension(naxis) :: maxes

    stat = status
    maxdim = naxis
    status = ffgisz(fitsfile%fptr,maxdim,maxes,stat)
    naxes = int(maxes)

  end subroutine fits_get_img_size

  subroutine fits_get_img_param(fitsfile,bitpix,naxis,naxes,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(out) :: bitpix, naxis
    integer, dimension(:), intent(out) :: naxes
    integer, intent(in out) :: status

    integer(kind=C_INT) :: maxdim, bpix, maxis, stat
    integer(kind=C_LONG), dimension(size(naxes)) :: maxes

    stat = status
    maxdim = size(maxes)
    status = ffgipr(fitsfile%fptr,maxdim,bpix,maxis,maxes,stat)
    bitpix = bpix
    naxis = maxis
    naxes = int(maxes)

  end subroutine fits_get_img_param

  subroutine fits_read_img_chr(fitsfile,group,firstelem,nelements,nullval, &
       array,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, firstelem, nelements
    character, intent(in) :: nullval
    character, dimension(:), intent(out) :: array
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: fpixel, npixels
    integer(kind=C_INT) :: stat, anynull
    character(kind=C_CHAR) :: nval
    character(kind=C_CHAR), dimension(size(array)) :: col

    fpixel = firstelem
    npixels = nelements
    nval = nullval
    grp = group
    stat = status
    status = ffgpvb(fitsfile%fptr,grp,fpixel,npixels,nval,col,anynull,stat)
    array = col
    anyf = anynull == 1

  end subroutine fits_read_img_chr

  subroutine fits_read_img_int(fitsfile,group,firstelem,nelements,nullval, &
       array,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, firstelem, nelements
    integer, intent(in) :: nullval
    integer, dimension(:), intent(out) :: array
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: fpixel, npixels
    integer(kind=C_INT) :: stat, anynull
    integer(kind=C_INT) :: nval
    integer(kind=C_INT), dimension(size(array)) :: col

    fpixel = firstelem
    npixels = nelements
    nval = nullval
    grp = group
    stat = status
    status = ffgpvk(fitsfile%fptr,grp,fpixel,npixels,nval,col,anynull,stat)
    array = col
    anyf = anynull == 1

  end subroutine fits_read_img_int

  subroutine fits_read_img_flt(fitsfile,group,firstelem,nelements,nullval, &
       array,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, firstelem, nelements
    real(REAL32), intent(in) :: nullval
    real(REAL32), dimension(:), intent(out) :: array
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: fpixel, npixels
    integer(kind=C_INT) :: stat, anynull
    real(kind=C_FLOAT) :: nval
    real(kind=C_FLOAT), dimension(size(array)) :: col

    fpixel = firstelem
    npixels = nelements
    nval = nullval
    grp = group
    stat = status
    status = ffgpve(fitsfile%fptr,grp,fpixel,npixels,nval,col,anynull,stat)
    array = col
    anyf = anynull == 1

  end subroutine fits_read_img_flt

  subroutine fits_read_img_dbl(fitsfile,group,firstelem,nelements,nullval, &
       array,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, firstelem, nelements
    real(REAL64), intent(in) :: nullval
    real(REAL64), dimension(:), intent(out) :: array
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: fpixel, npixels
    integer(kind=C_INT) :: stat, anynull
    real(kind=C_DOUBLE) :: nval
    real(kind=C_DOUBLE), dimension(size(array)) :: col

    fpixel = firstelem
    npixels = nelements
    nval = nullval
    grp = group
    stat = status
    status = ffgpvd(fitsfile%fptr,grp,fpixel,npixels,nval,col,anynull,stat)
    array = col
    anyf = anynull == 1

  end subroutine fits_read_img_dbl


  subroutine fits_write_img_chr(fitsfile,group,firstelem,nelements,array,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, firstelem, nelements
    character, dimension(:), intent(in) :: array
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: fpixel, npixels
    integer(kind=C_INT) :: stat
    character(kind=C_CHAR), dimension(size(array)) :: col

    fpixel = firstelem
    npixels = nelements
    grp = group
    stat = status
    col = array
    status = ffpprb(fitsfile%fptr,grp,fpixel,npixels,col,stat)

  end subroutine fits_write_img_chr

  subroutine fits_write_img_int(fitsfile,group,firstelem,nelements,array,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, firstelem, nelements
    integer, dimension(:), intent(in) :: array
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: fpixel, npixels
    integer(kind=C_INT) :: stat
    integer(kind=C_INT), dimension(size(array)) :: col

    fpixel = firstelem
    npixels = nelements
    grp = group
    stat = status
    col = array
    status = ffpprk(fitsfile%fptr,grp,fpixel,npixels,col,stat)

  end subroutine fits_write_img_int

  subroutine fits_write_img_flt(fitsfile,group,firstelem,nelements,array,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, firstelem, nelements
    real(REAL32), dimension(:), intent(in) :: array
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: fpixel, npixels
    integer(kind=C_INT) :: stat
    real(kind=C_FLOAT), dimension(size(array)) :: col

    fpixel = firstelem
    npixels = nelements
    grp = group
    stat = status
    col = array
    status = ffppre(fitsfile%fptr,grp,fpixel,npixels,col,stat)

  end subroutine fits_write_img_flt

  subroutine fits_write_img_dbl(fitsfile,group,firstelem,nelements,array,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, firstelem, nelements
    real(REAL64), dimension(:), intent(in) :: array
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: fpixel, npixels
    integer(kind=C_INT) :: stat
    real(kind=C_DOUBLE), dimension(size(array)) :: col

    fpixel = firstelem
    npixels = nelements
    grp = group
    stat = status
    col = array
    status = ffpprd(fitsfile%fptr,grp,fpixel,npixels,col,stat)

  end subroutine fits_write_img_dbl


  subroutine fits_read_2d_chr(fitsfile,group,nullval,dim1,naxis1,naxis2, &
       image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, dim1,naxis1,naxis2
    character, intent(in) :: nullval
    character, dimension(:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,n1,n2
    integer(kind=C_INT) :: stat, anynull
    character(kind=C_CHAR) :: nval
    character(kind=C_CHAR), dimension(size(image)) :: array

    d1 = dim1
    n1 = naxis1
    n2 = naxis2
    nval = nullval
    grp = group
    stat = status
    status = ffg2db(fitsfile%fptr,grp,nval,d1,n1,n2,array,anynull,stat)
    image = reshape(array,[size(image,1),size(image,2)])
    anyf = anynull == 1

  end subroutine fits_read_2d_chr

  subroutine fits_read_2d_int(fitsfile,group,nullval,dim1,naxis1,naxis2, &
       image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, dim1,naxis1,naxis2
    integer, intent(in) :: nullval
    integer, dimension(:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,n1,n2
    integer(kind=C_INT) :: stat, anynull
    integer(kind=C_INT) :: nval
    integer(kind=C_INT), dimension(size(image)) :: array

    d1 = dim1
    n1 = naxis1
    n2 = naxis2
    nval = nullval
    grp = group
    stat = status
    status = ffg2dk(fitsfile%fptr,grp,nval,d1,n1,n2,array,anynull,stat)
    image = reshape(array,[size(image,1),size(image,2)])
    anyf = anynull == 1

  end subroutine fits_read_2d_int

  subroutine fits_read_2d_flt(fitsfile,group,nullval,dim1,naxis1,naxis2, &
       image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, dim1,naxis1,naxis2
    real(REAL32), intent(in) :: nullval
    real(REAL32), dimension(:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,n1,n2
    integer(kind=C_INT) :: stat, anynull
    real(kind=C_FLOAT) :: nval
    real(kind=C_FLOAT), dimension(size(image)) :: array

    d1 = dim1
    n1 = naxis1
    n2 = naxis2
    nval = nullval
    grp = group
    stat = status
    status = ffg2de(fitsfile%fptr,grp,nval,d1,n1,n2,array,anynull,stat)
    image = reshape(array,[size(image,1),size(image,2)])
    anyf = anynull == 1

  end subroutine fits_read_2d_flt

  subroutine fits_read_2d_dbl(fitsfile,group,nullval,dim1,naxis1,naxis2, &
       image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, dim1,naxis1,naxis2
    real(REAL64), intent(in) :: nullval
    real(REAL64), dimension(:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,n1,n2
    integer(kind=C_INT) :: stat, anynull
    real(kind=C_DOUBLE) :: nval
    real(kind=C_DOUBLE), dimension(size(image)) :: array

    d1 = dim1
    n1 = naxis1
    n2 = naxis2
    nval = nullval
    grp = group
    stat = status
    status = ffg2dd(fitsfile%fptr,grp,nval,d1,n1,n2,array,anynull,stat)
    image = reshape(array,[size(image,1),size(image,2)])
    anyf = anynull == 1

  end subroutine fits_read_2d_dbl

  subroutine fits_write_2d_chr(fitsfile,group,dim1,naxis1,naxis2,image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group,dim1,naxis1,naxis2
    character, dimension(:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,n1,n2
    integer(kind=C_INT) :: stat
    character(kind=C_CHAR), dimension(size(image)) :: array

    d1 = dim1
    n1 = naxis1
    n2 = naxis2
    grp = group
    stat = status
    array = pack(image,.true.)
    status = ffp2db(fitsfile%fptr,grp,d1,n1,n2,array,stat)

  end subroutine fits_write_2d_chr

  subroutine fits_write_2d_int(fitsfile,group,dim1,naxis1,naxis2,image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group,dim1,naxis1,naxis2
    integer, dimension(:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,n1,n2
    integer(kind=C_INT) :: stat
    integer(kind=C_INT), dimension(size(image)) :: array

    d1 = dim1
    n1 = naxis1
    n2 = naxis2
    grp = group
    stat = status
    array = pack(image,.true.)
    status = ffp2dk(fitsfile%fptr,grp,d1,n1,n2,array,stat)

  end subroutine fits_write_2d_int

  subroutine fits_write_2d_flt(fitsfile,group,dim1,naxis1,naxis2,image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group,dim1,naxis1,naxis2
    real(REAL32), dimension(:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,n1,n2
    integer(kind=C_INT) :: stat
    real(kind=C_FLOAT), dimension(size(image)) :: array

    d1 = dim1
    n1 = naxis1
    n2 = naxis2
    grp = group
    stat = status
    array = pack(image,.true.)
    status = ffp2de(fitsfile%fptr,grp,d1,n1,n2,array,stat)

  end subroutine fits_write_2d_flt

  subroutine fits_write_2d_dbl(fitsfile,group,dim1,naxis1,naxis2,image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group,dim1,naxis1,naxis2
    real(REAL64), dimension(:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,n1,n2
    integer(kind=C_INT) :: stat
    real(kind=C_DOUBLE), dimension(size(image)) :: array

    d1 = dim1
    n1 = naxis1
    n2 = naxis2
    grp = group
    stat = status
    array = pack(image,.true.)
    status = ffp2dd(fitsfile%fptr,grp,d1,n1,n2,array,stat)

  end subroutine fits_write_2d_dbl

  subroutine fits_read_3d_chr(fitsfile,group,nullval,dim1,dim2,naxis1,naxis2,naxis3,&
       image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, dim1,dim2,naxis1,naxis2,naxis3
    character, intent(in) :: nullval
    character, dimension(:,:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,d2,n1,n2,n3
    integer(kind=C_INT) :: stat, anynull
    character(kind=C_CHAR) :: nval
    character(kind=C_CHAR), dimension(size(image)) :: array

    d1 = dim1
    d2 = dim2
    n1 = naxis1
    n2 = naxis2
    n3 = naxis3
    nval = nullval
    grp = group
    stat = status
    status = ffg3db(fitsfile%fptr,grp,nval,d1,d2,n1,n2,n3,array,anynull,stat)
    image = reshape(array,[size(image,1),size(image,2),size(image,3)])
    anyf = anynull == 1

  end subroutine fits_read_3d_chr

  subroutine fits_read_3d_int(fitsfile,group,nullval,dim1,dim2,naxis1,naxis2,naxis3,&
       image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, dim1,dim2,naxis1,naxis2,naxis3
    integer, intent(in) :: nullval
    integer, dimension(:,:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,d2,n1,n2,n3
    integer(kind=C_INT) :: stat, anynull
    integer(kind=C_INT) :: nval
    integer(kind=C_INT), dimension(size(image)) :: array

    d1 = dim1
    d2 = dim2
    n1 = naxis1
    n2 = naxis2
    n3 = naxis3
    nval = nullval
    grp = group
    stat = status
    status = ffg3dk(fitsfile%fptr,grp,nval,d1,d2,n1,n2,n3,array,anynull,stat)
    image = reshape(array,[size(image,1),size(image,2),size(image,3)])
    anyf = anynull == 1

  end subroutine fits_read_3d_int

  subroutine fits_read_3d_flt(fitsfile,group,nullval,dim1,dim2,naxis1,naxis2,naxis3,&
       image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, dim1,dim2,naxis1,naxis2,naxis3
    real(REAL32), intent(in) :: nullval
    real(REAL32), dimension(:,:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,d2,n1,n2,n3
    integer(kind=C_INT) :: stat, anynull
    real(kind=C_FLOAT) :: nval
    real(kind=C_FLOAT), dimension(size(image)) :: array

    d1 = dim1
    d2 = dim2
    n1 = naxis1
    n2 = naxis2
    n3 = naxis3
    nval = nullval
    grp = group
    stat = status
    status = ffg3de(fitsfile%fptr,grp,nval,d1,d2,n1,n2,n3,array,anynull,stat)
    image = reshape(array,[size(image,1),size(image,2),size(image,3)])
    anyf = anynull == 1

  end subroutine fits_read_3d_flt

  subroutine fits_read_3d_dbl(fitsfile,group,nullval,dim1,dim2,naxis1,naxis2,naxis3,&
       image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group, dim1,dim2,naxis1,naxis2,naxis3
    real(REAL64), intent(in) :: nullval
    real(REAL64), dimension(:,:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,d2,n1,n2,n3
    integer(kind=C_INT) :: stat, anynull
    real(kind=C_DOUBLE) :: nval
    real(kind=C_DOUBLE), dimension(size(image)) :: array

    d1 = dim1
    d2 = dim2
    n1 = naxis1
    n2 = naxis2
    n3 = naxis3
    nval = nullval
    grp = group
    stat = status
    status = ffg3dd(fitsfile%fptr,grp,nval,d1,d2,n1,n2,n3,array,anynull,stat)
    image = reshape(array,[size(image,1),size(image,2),size(image,3)])
    anyf = anynull == 1

  end subroutine fits_read_3d_dbl

  subroutine fits_write_3d_chr(fitsfile,group,dim1,dim2,naxis1,naxis2,naxis3, &
       image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group,dim1,dim2,naxis1,naxis2,naxis3
    character, dimension(:,:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,d2,n1,n2,n3
    integer(kind=C_INT) :: stat
    character(kind=C_CHAR), dimension(size(image)) :: array

    d1 = dim1
    d2 = dim2
    n1 = naxis1
    n2 = naxis2
    n3 = naxis3
    grp = group
    stat = status
    array = pack(image,.true.)
    status = ffp3db(fitsfile%fptr,grp,d1,d2,n1,n2,n3,array,stat)

  end subroutine fits_write_3d_chr

  subroutine fits_write_3d_int(fitsfile,group,dim1,dim2,naxis1,naxis2,naxis3, &
       image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group,dim1,dim2,naxis1,naxis2,naxis3
    integer, dimension(:,:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,d2,n1,n2,n3
    integer(kind=C_INT) :: stat
    integer(kind=C_INT), dimension(size(image)) :: array

    d1 = dim1
    d2 = dim2
    n1 = naxis1
    n2 = naxis2
    n3 = naxis3
    grp = group
    stat = status
    array = pack(image,.true.)
    status = ffp3dk(fitsfile%fptr,grp,d1,d2,n1,n2,n3,array,stat)

  end subroutine fits_write_3d_int

  subroutine fits_write_3d_flt(fitsfile,group,dim1,dim2,naxis1,naxis2,naxis3, &
       image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group,dim1,dim2,naxis1,naxis2,naxis3
    real(REAL32), dimension(:,:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,d2,n1,n2,n3
    integer(kind=C_INT) :: stat
    real(kind=C_FLOAT), dimension(size(image)) :: array

    d1 = dim1
    d2 = dim2
    n1 = naxis1
    n2 = naxis2
    n3 = naxis3
    grp = group
    stat = status
    array = pack(image,.true.)
    status = ffp3de(fitsfile%fptr,grp,d1,d2,n1,n2,n3,array,stat)

  end subroutine fits_write_3d_flt

  subroutine fits_write_3d_dbl(fitsfile,group,dim1,dim2,naxis1,naxis2,naxis3, &
       image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group,dim1,dim2,naxis1,naxis2,naxis3
    real(REAL64), dimension(:,:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: grp
    integer(kind=C_LONG_LONG) :: d1,d2,n1,n2,n3
    integer(kind=C_INT) :: stat
    real(kind=C_DOUBLE), dimension(size(image)) :: array

    d1 = dim1
    d2 = dim2
    n1 = naxis1
    n2 = naxis2
    n3 = naxis3
    grp = group
    stat = status
    array = pack(image,.true.)
    status = ffp3dd(fitsfile%fptr,grp,d1,d2,n1,n2,n3,array,stat)

  end subroutine fits_write_3d_dbl



  ! ASCII and Binary Table Routines

  subroutine fits_get_num_rows(fitsfile,nrows,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(out) :: nrows
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: mrows
    integer(kind=C_INT) :: stat

    stat = status
    status = ffgnrw(fitsfile%fptr,mrows,stat)
    nrows = int(mrows)

  end subroutine fits_get_num_rows

  subroutine fits_get_num_cols(fitsfile,ncols,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(out) :: ncols
    integer, intent(in out) :: status

    integer(kind=C_INT) :: mcols, stat

    stat = status
    status = ffgncl(fitsfile%fptr,mcols,stat)
    ncols = mcols

  end subroutine fits_get_num_cols

  subroutine fits_get_rowsize(fitsfile,nrows,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(out) :: nrows
    integer, intent(in out) :: status

    integer(kind=C_LONG) :: mrows
    integer(kind=C_INT) :: stat

    stat = status
    status = ffgrsz(fitsfile%fptr,mrows,stat)
    nrows = int(mrows)

  end subroutine fits_get_rowsize

  subroutine fits_get_colnum(fitsfile,casesens,templt,colnum,status)

    type(fitsfiles), intent(in) :: fitsfile
    logical, intent(in) :: casesens
    character(len=*), intent(in) :: templt
    integer, intent(out) :: colnum
    integer, intent(in out) :: status

    integer(kind=C_INT) :: mcase, mcolnum, stat
    character(kind=C_CHAR), dimension(len(templt)+1) :: templ

    stat = status
    if( casesens ) then
       mcase = FITS_CASESEN
    else
       mcase = FITS_CASEINSEN
    end if
    call cchar(templt,templ)

    status = ffgcno(fitsfile%fptr,mcase,templ,mcolnum,stat)
    colnum = mcolnum

  end subroutine fits_get_colnum


  subroutine fits_get_colname(fitsfile,casesens,templt,colname,colnum,status)

    type(fitsfiles), intent(in) :: fitsfile
    logical, intent(in) :: casesens
    character(len=*), intent(in) :: templt
    character(len=*), intent(out) :: colname
    integer, intent(out) :: colnum
    integer, intent(in out) :: status

    integer(kind=C_INT) :: mcase, mcolnum, stat
    character(kind=C_CHAR), dimension(len(templt)+1) :: templ
    character(kind=C_CHAR), dimension(len(colname)+1) :: name

    stat = status
    if( casesens ) then
       mcase = FITS_CASESEN
    else
       mcase = FITS_CASEINSEN
    end if
    call cchar(templt,templ)

    status = ffgcnn(fitsfile%fptr,mcase,templ,name,mcolnum,stat)
    call fchar(name,colname)
    colnum = mcolnum

  end subroutine fits_get_colname

  subroutine fits_insert_col(fitsfile,colnum,ttype,tform,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum
    character(len=*), intent(in) :: ttype,tform
    integer, intent(in out) :: status

    integer(kind=C_INT) :: icol, stat
    character(kind=C_CHAR), dimension(len(ttype)+1) :: mtype
    character(kind=C_CHAR), dimension(len(tform)+1) :: mform

    stat = status
    icol = colnum

    call cchar(ttype,mtype)
    call cchar(tform,mform)

    status = fficol(fitsfile%fptr,icol,mtype,mform,stat)

  end subroutine fits_insert_col

  subroutine fits_insert_cols(fitsfile,colnum,ncols,ttype,tform,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, ncols
    character(len=*), dimension(:), intent(in) :: ttype,tform
    integer, intent(in out) :: status

    integer :: i
    integer(kind=C_INT) :: icol, tfields, stat
    character(kind=C_CHAR), dimension(len(ttype)+1,size(ttype)), target :: mtype
    character(kind=C_CHAR), dimension(len(tform)+1,size(tform)), target :: mform
    type(c_ptr), dimension(size(ttype)) :: type_ptr
    type(c_ptr), dimension(size(tform)) :: form_ptr

    stat = status
    icol = colnum
    tfields = ncols

    do i = 1, ncols
       call cchar(ttype(i),mtype(:,i))
       type_ptr(i) = C_LOC(mtype(:,i))
       call cchar(tform(i),mform(:,i))
       form_ptr(i) = C_LOC(mform(:,i))
    end do

    status = fficls(fitsfile%fptr,icol,tfields,type_ptr,form_ptr,stat)

  end subroutine fits_insert_cols

  subroutine fits_delete_col(fitsfile,colnum,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum
    integer, intent(in out) :: status

    integer(kind=C_INT) :: icol, stat

    stat = status
    icol = colnum

    status = ffdcol(fitsfile%fptr,icol,stat)

  end subroutine fits_delete_col

  subroutine fits_read_col_str(fitsfile,colnum,firstrow,nullstr,array,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, firstrow
    character(len=*), intent(in) :: nullstr
    character(len=*), dimension(:), intent(out) :: array
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer :: i
    integer(kind=C_LONG_LONG), parameter :: felement = 1
    integer(kind=C_INT) :: icol, anynull,  stat
    integer(kind=C_LONG_LONG) :: frow, nelements
    character(kind=C_CHAR), dimension(len(nullstr)+1) :: nulls
    character(kind=C_CHAR), dimension(len(array)+1,size(array)), target :: col
    type(c_ptr), dimension(size(array)) :: ptrs

    stat = status
    icol = colnum
    frow = firstrow
    nelements = size(array)

    call cchar(nullstr,nulls)
    do i = 1, size(array)
       ptrs(i) = C_LOC(col(:,i))
    end do
    status = ffgcvs(fitsfile%fptr,icol,frow,felement,nelements,nulls, &
         ptrs,anynull,stat)

    if( status == 0 ) then
       do i = 1, size(array)
          call fchar(col(:,i),array(i))
       end do
    end if
    anyf = anynull == 1

  end subroutine fits_read_col_str

  subroutine fits_read_col_log(fitsfile,colnum,firstrow,nullval,array,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, firstrow
    logical, intent(in) :: nullval
    logical, dimension(:), intent(out) :: array
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG_LONG), parameter :: felement = 1
    integer(kind=C_INT) :: icol, anynull,  stat
    integer(kind=C_LONG_LONG) :: frow, nelements
    character(kind=C_CHAR) :: nulls
    character(kind=C_CHAR), dimension(size(array)) :: bools

    stat = status
    icol = colnum
    frow = firstrow
    nelements = size(array)
    if( nullval ) then
       nulls = char(1)
    else
       nulls = char(0)
    end if
    status = ffgcvl(fitsfile%fptr,icol,frow,felement,nelements,nulls, &
         bools,anynull,stat)
    array = ichar(bools) == 1
    anyf = anynull == 1

  end subroutine fits_read_col_log

  subroutine fits_read_col_lng(fitsfile,colnum,firstrow,nullval,array,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, firstrow
    integer, intent(in) :: nullval
    integer, dimension(:), intent(out) :: array
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG_LONG), parameter :: felement = 1
    integer(kind=C_INT) :: icol, anynull,  stat
    integer(kind=C_LONG_LONG) :: frow, nelements
    integer(kind=C_LONG) :: nulls
    integer(kind=C_LONG), dimension(size(array)) :: col

    stat = status
    icol = colnum
    frow = firstrow
    nelements = size(array)
    nulls = nullval
    status = ffgcvj(fitsfile%fptr,icol,frow,felement,nelements,nulls, &
         col,anynull,stat)
    array = int(col)
    anyf = anynull == 1

  end subroutine fits_read_col_lng

  subroutine fits_read_col_flt(fitsfile,colnum,firstrow,nullval,array,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, firstrow
    real(REAL32), intent(in) :: nullval
    real(REAL32), dimension(:), intent(out) :: array
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG_LONG), parameter :: felement = 1
    integer(kind=C_INT) :: icol, anynull,  stat
    integer(kind=C_LONG_LONG) :: frow, nelements
    real(kind=C_FLOAT) :: nulls
    real(kind=C_FLOAT), dimension(size(array)) :: col

    stat = status
    icol = colnum
    frow = firstrow
    nelements = size(array)
    nulls = nullval
    status = ffgcve(fitsfile%fptr,icol,frow,felement,nelements,nulls, &
         col,anynull,stat)
    array = col
    anyf = anynull == 1

  end subroutine fits_read_col_flt

  subroutine fits_read_col_dbl(fitsfile,colnum,firstrow,nullval,array,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, firstrow
    real(kind=REAL64), intent(in) :: nullval
    real(kind=REAL64), dimension(:), intent(out) :: array
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer(kind=C_LONG_LONG), parameter :: felement = 1
    integer(kind=C_INT) :: icol, anynull,  stat
    integer(kind=C_LONG_LONG) :: frow, nelements
    real(kind=C_DOUBLE) :: nulls
    real(kind=C_DOUBLE), dimension(size(array)) :: col

    stat = status
    icol = colnum
    frow = firstrow
    nelements = size(array)
    nulls = nullval
    status = ffgcvd(fitsfile%fptr,icol,frow,felement,nelements,nulls, &
         col,anynull,stat)
    array = col
    anyf = anynull == 1

  end subroutine fits_read_col_dbl


  subroutine fits_write_col_str(fitsfile,colnum,firstrow,array,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, firstrow
    character(len=*), dimension(:), intent(in) :: array
    integer, intent(in out) :: status

    integer(kind=C_LONG_LONG), parameter :: felement = 1
    integer :: i
    integer(kind=C_INT) :: icol, stat
    integer(kind=C_LONG_LONG) :: frow, nelements
    character(kind=C_CHAR), dimension(len(array)+1,size(array)), target :: strings
    type(c_ptr), dimension(size(array)) :: ptrs

    stat = status
    icol = colnum
    frow = firstrow
    nelements = size(array)

    do i = 1, size(array)
       call cchar(array(i),strings(:,i))
       ptrs(i) = C_LOC(strings(:,i))
    end do

    status = ffpcls(fitsfile%fptr,icol,frow,felement,nelements,ptrs,stat)

  end subroutine fits_write_col_str

  subroutine fits_write_col_log(fitsfile,colnum,firstrow,array,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, firstrow
    logical, dimension(:), intent(in) :: array
    integer, intent(in out) :: status

    integer(kind=C_LONG_LONG), parameter :: felement = 1
    integer(kind=C_INT) :: icol, stat
    integer(kind=C_LONG_LONG) :: frow, nelements
    character(kind=C_CHAR), dimension(size(array)) :: col

    stat = status
    icol = colnum
    frow = firstrow
    nelements = size(array)
    where( array )
       col = char(1)
    elsewhere
       col = char(0)
    end where

    status = ffpcll(fitsfile%fptr,icol,frow,felement,nelements,col,stat)

  end subroutine fits_write_col_log

  subroutine fits_write_col_lng(fitsfile,colnum,firstrow,array,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, firstrow
    integer, dimension(:), intent(in) :: array
    integer, intent(in out) :: status

    integer(kind=C_LONG_LONG), parameter :: felement = 1
    integer(kind=C_INT) :: icol, stat
    integer(kind=C_LONG_LONG) :: frow, nelements
    integer(kind=C_LONG), dimension(size(array)) :: col

    stat = status
    icol = colnum
    frow = firstrow
    nelements = size(array)
    col = array

    status = ffpclj(fitsfile%fptr,icol,frow,felement,nelements,col,stat)

  end subroutine fits_write_col_lng

  subroutine fits_write_col_flt(fitsfile,colnum,firstrow,array,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, firstrow
    real(kind=REAL32), dimension(:), intent(in) :: array
    integer, intent(in out) :: status

    integer(kind=C_LONG_LONG), parameter :: felement = 1
    integer(kind=C_INT) :: icol, stat
    integer(kind=C_LONG_LONG) :: frow, nelements
    real(kind=C_FLOAT), dimension(size(array)) :: col

    stat = status
    icol = colnum
    frow = firstrow
    nelements = size(array)
    col = array

    status = ffpcle(fitsfile%fptr,icol,frow,felement,nelements,col,stat)

  end subroutine fits_write_col_flt

  subroutine fits_write_col_dbl(fitsfile,colnum,firstrow,array,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: colnum, firstrow
    real(kind=REAL64), dimension(:), intent(in) :: array
    integer, intent(in out) :: status

    integer(kind=C_LONG_LONG), parameter :: felement = 1
    integer(kind=C_INT) :: icol, stat
    integer(kind=C_LONG_LONG) :: frow, nelements
    real(kind=C_DOUBLE), dimension(size(array)) :: col

    stat = status
    icol = colnum
    frow = firstrow
    nelements = size(array)
    col = array

    status = ffpcld(fitsfile%fptr,icol,frow,felement,nelements,col,stat)

  end subroutine fits_write_col_dbl

  subroutine fits_delete_rows(fitsfile,firstrow,nrows,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: firstrow, nrows
    integer, intent(in out) :: status

    integer(kind=C_INT) :: stat
    integer(kind=C_LONG_LONG) :: frow, nelements

    stat = status
    frow = firstrow
    nelements = nrows

    status = ffdrow(fitsfile%fptr,frow,nelements,stat)

  end subroutine fits_delete_rows


  !  Error Status Routines

  subroutine fits_report_error(unit,status)

    integer, intent(in) :: unit, status

    integer(kind=C_INT) :: stat
    character(len=FLEN_ERRMSG) :: errmsg
    character(len=FLEN_STATUS) :: status_str
    character(kind=C_CHAR), dimension(0:FLEN_STATUS) :: err_text
    character(kind=C_CHAR), dimension(0:FLEN_ERRMSG) :: err_msg

    if( status == 0 ) return

    stat = status
    call ffgerr(stat,err_text)
    call fchar(err_text,status_str)
    write(unit,'(3a,i0,a)') 'FITSIO error: "',trim(status_str), &
         '" (status = ',status,')'

    do
       if( ffgmsg(err_msg) == 0 ) exit
       call fchar(err_msg,errmsg)
       write(unit,'(2a)') 'FITSIO: ',trim(errmsg)
    end do

  end subroutine fits_report_error

  subroutine fits_write_errmark
    call ffpmrk
  end subroutine fits_write_errmark

  subroutine fits_clear_errmark
    call ffcmrk
  end subroutine fits_clear_errmark

  subroutine fits_clear_errmsg
    call ffcmsg
  end subroutine fits_clear_errmsg


  ! Utility Routines

  subroutine fits_get_keytype(val,dtype,status)

    character(len=*), intent(in) :: val
    character, intent(out) :: dtype
    integer, intent(in out) :: status

    integer(kind=C_INT) :: stat
    character(kind=C_CHAR), dimension(len(val)+1) :: string
    character(kind=C_CHAR) :: type

    stat = status
    call cchar(val,string)
    status = ffdtyp(string,type,stat)
    dtype = type

  end subroutine fits_get_keytype

  subroutine fits_make_keyn(keyroot,val,keyname,status)

    character(len=*), intent(in) :: keyroot
    integer, intent(in) :: val
    character(len=*), intent(out) :: keyname
    integer, intent(in out) :: status

    integer(kind=C_INT) :: n, stat
    character(kind=C_CHAR), dimension(len(keyroot)+1) :: root
    character(kind=C_CHAR), dimension(len(keyname)+1) :: name

    stat = status
    n = val
    call cchar(keyroot,root)
    status = ffkeyn(root,n,name,stat)
    call fchar(name,keyname)

  end subroutine fits_make_keyn

  subroutine fits_str2date(datestr,year,month,day,hour,minute,second,status)

    character(len=*), intent(in) :: datestr
    integer, intent(out) :: year,month,day,hour,minute
    real(REAL64), intent(out) :: second
    integer, intent(in out) :: status

    character(kind=C_CHAR), dimension(len_trim(datestr)+1) :: str
    integer(kind=C_INT) :: y,m,d,h,mnt,stat
    real(kind=C_DOUBLE) :: s

    stat = status
    call cchar(datestr,str)
    status = ffs2tm(str,y,m,d,h,mnt,s,stat)
    year = y
    month = m
    day = d
    hour = h
    minute = mnt
    second = s

  end subroutine fits_str2date


  ! Auxiliary utilities for string conversion: Fortran <-> C .

  subroutine fchar(cstring,fstring)

    character(kind=C_CHAR), dimension(*), intent(in) :: cstring
    character(len=*), intent(out) :: fstring

    integer :: i,n

    n = 1
    do i = 1, len(fstring)
       n = i
       if( cstring(n) == C_NULL_CHAR ) exit
       fstring(n:n) = cstring(n)
    end do
    fstring(n:) = ' '

  end subroutine fchar

  subroutine cchar(fstring,cstring)

    character(len=*), intent(in) :: fstring
    character(kind=C_CHAR), dimension(*), intent(out) :: cstring
    integer :: i, n

    n = len_trim(fstring)
    do i = 1, n
       cstring(i) = fstring(i:i)
    end do
    cstring(n+1) = C_NULL_CHAR

  end subroutine cchar


end module fitsio

!
!  Dark     Average of a set of dark or bias frames.
!
!  Copyright © 1998-2020 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

program dark

  use fitscorr
  use titsio
  use iso_fortran_env

  implicit none

  character(len=FLEN_FILENAME) :: darkname = 'dark.fits'   ! output
  character(len=FLEN_FILENAME) :: biasname = '' ! bias
  character(len=FLEN_FILENAME) :: maskname = '' ! mask

  character(len=80) :: msg
  character(len=4*FLEN_FILENAME) :: key, val, record
  character(len=FLEN_VALUE) :: dateobs, imagetyp
  character(len=FLEN_FILENAME), dimension(:), allocatable :: darknames
  character(len=FLEN_KEYWORD), dimension(6) :: keys = [ &
       FITS_KEY_DATEOBS, &
       FITS_KEY_EXPTIME, &
       FITS_KEY_FILTER, &
       FITS_KEY_SATURATE, &
       FITS_KEY_TEMPERATURE, &
       FITS_KEY_GAIN ]

  integer :: ndark = 0           ! total count of darks
  integer :: bitpix = -32        ! default output dark bitpix
  integer :: status = 0          ! FITS status
  logical :: verbose = .false.
  integer :: eq, stat, naxis
  integer, dimension(2) :: naxes ! code is restricted on 2D frames

  ! check limits
  real :: tol_exptime = 1e-6
  real :: tol_temper = 1.0

  ! lower and upper limits
  real :: saturate = -1
  real :: threshold = 1
  logical :: threshold_set = .false.

  ! dark image and its statistical error
  real, dimension(:,:), allocatable :: image, imgerr
  real :: exptime_mean = 0,  exptime_err = 0  ! exposure time
  real :: temper_mean = -666, temper_err  = 0  ! temperature
  real :: dark_mean = 0,      dark_err = 0     ! mean level

  ! FITS wrappers
  type(CorrFits), allocatable :: biasfits, maskfits
  type(CorrFits), dimension(:), allocatable :: darks


  ! Section: Input  ---------------------------------------
  do
     read(*,'(a)',iostat=stat,iomsg=msg) record
     if( stat == IOSTAT_END ) exit
     if( stat > 0 ) then
        write(error_unit,*) trim(msg)
        error stop 'An input error.'
     end if

     eq = index(record,'=')
     if( eq == 0 ) error stop 'Malformed input record.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'OUTPUT' ) then
        read(val,*) darkname
     endif

     if( key == 'VERBOSE' ) then
        read(val,*) verbose
     endif

     if( key == 'BITPIX' ) then
        read(val,*) bitpix
     endif

     if( key == 'SATURATE' ) then
        read(val,*) saturate
        if( .not. (saturate > 0) ) stop 'Saturation > 0 is required.'
     endif

     if( key == 'THRESHOLD' ) then
        read(val,*) threshold
        if( .not. (threshold > 0) ) stop 'Threshold > 0 is required.'
        threshold_set = .true.
     endif

     if( key == 'FITS_KEY_DATEOBS' ) then
        read(val,*) keys(1)
     endif

     if( key == 'FITS_KEY_EXPTIME' ) then
        read(val,*) keys(2)
     endif

     if( key == 'FITS_KEY_SATURATE' ) then
        read(val,*) keys(4)
     endif

     if( key == 'FITS_KEY_TEMPERATURE' ) then
        read(val,*) keys(5)
     endif

     if( key == 'MUNIPACK_TEMPERATURE_TOLERANCE' ) then
        read(val,*) tol_temper
     endif

     if( key == 'MUNIPACK_EXPTIME_TOLERANCE' ) then
        read(val,*) tol_exptime
     endif

     if( key == 'BIAS' ) then
        read(val,*) biasname
     end if

     if( key == 'MASK' ) then
        read(val,*) maskname
     end if

     if( key == 'NFILES' ) then

        read(val,*) ndark
        allocate(darknames(ndark),stat=stat,errmsg=msg)
        if( stat /= 0 ) then
           write(error_unit,*) trim(msg)
           error stop 'Insufficient memory.'
        end if
        ndark = 0

     end if

     if( key == 'FILE' ) then

        ndark = ndark + 1
        if( ndark > size(darknames) ) stop 'NFILES unspecified?'
        read(val,*) darknames(ndark)

     end if

  enddo

  if( ndark == 0 ) stop 'Missing data'
  if( ndark /= size(darknames) ) error stop 'n /= size(darknames)'

  ! Section: FITS files read ------------------------------------------
  block

    integer :: n

    ! bias
    if( biasname /= '' ) then
       if( verbose ) write(error_unit,'(a)',advance="no") &
            "Bias frame: "//trim(biasname)//", "

       allocate(biasfits)
       call biasfits%Load(biasname,keys)
       if( .not. biasfits%status ) stop 'Failed to load bias frame.'

       if( verbose ) write(error_unit,'(a,1pg0.3,a,0pf0.1)') &
            ' exp.time[s] = ',biasfits%exptime, &
            ', T[degC] = ',biasfits%temper
    end if

    ! mask
    if( maskname /= '' ) then
       if( verbose ) write(error_unit,*) "Mask frame: ",trim(maskname)

       allocate(maskfits)
       call maskfits%Load(maskname)
       if( .not. maskfits%status ) stop 'Failed to load the mask frame.'
    end if

    if( verbose ) &
         write(error_unit,*) "Filename, exposure time[s], temperature [degC]:"

    ! darks
    allocate(darks(ndark),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) trim(msg)
       error stop 'Insufficient memory.'
    end if

    do n = 1, size(darknames)

       if( verbose ) write(error_unit,'(a)',advance="no") &
            trim(darknames(n))//":"

       call darks(n)%Load(darknames(n),keys)
       if( .not. darks(n)%status ) stop 'Frame read failed.'

       if( verbose ) write(error_unit,'(2x,1pg12.3,1x,0pf7.1)') &
            darks(n)%exptime,darks(n)%temper

       if( n == 1 .and. allocated(biasfits) ) then
          if( .not. all(biasfits%naxes == darks(n)%naxes) ) then
             stop "Dimensions of bias and the frame does not corresponds."
          end if
       end if

       if( n == 1 .and. allocated(maskfits) ) then
          if( .not. all(maskfits%naxes == darks(n)%naxes) ) then
             stop "Dimensions of bitmask and the frame does not corresponds."
          end if
       end if

       if( n > 1 ) then
          if( .not. all(darks(n-1)%naxes == darks(n)%naxes) ) then
             stop "Dimensions of images mutually does not corresponds."
          end if
       endif

       ! setup saturation
       if( saturate > 0 ) darks(n)%saturate = saturate
    end do

  end block

  ! setup common parameters
  naxis = darks(1)%naxis
  naxes = darks(1)%naxes
  dateobs = darks(1)%dateobs
  imagetyp = darks(1)%imagetyp

  if( verbose ) then
     write(error_unit,*)
     write(error_unit,*) 'Total count of frame(s):',ndark
     write(error_unit,*) 'Frame dimensions:',naxes(1),'x',naxes(2)
     write(error_unit,*) 'Some bias or a dark frame is being prepared ...'
  end if

  ! Section: mean dark determination --------------------------------
  block

    use oakleaf

    real, dimension(:,:), allocatable :: bias
    logical, dimension(:,:), allocatable :: mask, bitmask
    real, dimension(:), allocatable :: x
    integer :: i,j,n,m
    real :: f

    allocate(bitmask(naxes(1),naxes(2)),mask(naxes(1),naxes(2)),x(ndark), &
         image(naxes(1),naxes(2)),imgerr(naxes(1),naxes(2)), &
         bias(naxes(1),naxes(2)),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) trim(msg)
       error stop 'Insufficient memory.'
    end if

    image = 0.0
    imgerr = 0.0

    if( allocated(biasfits) ) then
       bias = biasfits%image
       deallocate(biasfits)
    else
       bias = 0.0
    end if

    if( allocated(maskfits) ) then
       bitmask = maskfits%image > 0.5
       deallocate(maskfits)
    else
       bitmask = .true.
    end if

    if( ndark > 1 ) then

       do j = 1, naxes(2)
          do i = 1, naxes(1)

             if( bitmask(i,j) ) then

                n = 0
                do m = 1, ndark
                   f = darks(m)%image(i,j)
                   if( threshold < f .and. f < darks(m)%saturate ) then
                      n = n + 1
                      x(n) = f - bias(i,j)
                   end if
                end do

                if( n > 1 ) then
                   call rmean(x(1:n),image(i,j),imgerr(i,j))
                else
                   bitmask(i,j) = .false.
                end if
             end if
          enddo
       enddo

       ! mean exposure time
       n = 0
       do m = 1, ndark
          if( darks(m)%exptime_set ) then
             n = n + 1
             x(n) = darks(m)%exptime
          end if
       end do
       if( n > 0 ) then
          call rmean(x(1:n),exptime_mean,exptime_err)
       else
          exptime_mean = 0
          exptime_err = 0
       end if

       ! mean temperature
       n = 0
       do m = 1, ndark
          if( darks(m)%temper > -273 ) then
             n = n + 1
             x(n) = darks(m)%temper
          end if
       end do
       if( n > 0 ) then
          call rmean(x(1:n),temper_mean,temper_err)
       else
          temper_mean = -666
          temper_err = 0
       end if

       ! mean dark value
       mask = imgerr > 0
       call rmean(pack(image,mask),pack(imgerr,mask),dark_mean,dark_err)

    else if( ndark == 1 ) then

       image = darks(1)%image
       temper_mean = darks(1)%temper
       temper_err = 0.0
       exptime_mean = darks(1)%exptime
       exptime_err = 0.0
       mask = threshold < image .and. image < darks(1)%saturate .and. bitmask
       call rmean(pack(image,mask),dark_mean,dark_err)

    end if

    ! replace undefined pixels by the mean
    where( .not. bitmask )
       image = dark_mean
       imgerr = dark_err
    end where

    deallocate(bias,mask,bitmask,x)
  end block

  ! checks
  block

    real :: t, e, maximg
    integer :: n

    ! check exptimes
    do n = 1, ndark
       e = darks(n)%exptime
       if( darks(n)%exptime_set .and. abs(e - exptime_mean) > tol_exptime ) &
            write(error_unit,*) "Warning: Exposure time out of limit for `",&
            trim(darks(n)%filename),"': ",e
    end do

    ! check temperatures
    do n = 1, ndark
       t = darks(n)%temper
       if( t > -273 .and. abs(t-temper_mean) > tol_temper ) &
            write(error_unit,*) "Warning: Temperature out of limit for `", &
            trim(darks(n)%filename),"': ",t
    enddo

    ! cut-off
    if( bitpix > 0 ) then
       maximg = 2.0**bitpix - 1
       image = max(0.0,min(image,maximg))
       imgerr = max(0.0,min(imgerr,maximg))
    end if

  end block

  if( verbose ) then
     write(error_unit,*) 'Average level: ',dark_mean,'+-',dark_err
     write(error_unit,*) 'Average exposure time: ',exptime_mean,'+-',exptime_err
     write(error_unit,*) 'Average temperature: ',temper_mean,'+-',temper_err
     write(error_unit,*) 'Saving to output file: ',trim(darkname)
  end if

  ! Section: FITS save -----------------------------------------------
  block

    integer, parameter :: group = 1
    character(len=FLEN_CARD) :: buf
    integer :: n
    type(fitsfiles) :: fits

    call fits_create_scratch(fits,status)
    call fits_insert_img(fits,bitpix,naxis,naxes,status)

    if( dateobs /= '' ) &
       call fits_write_key(fits,keys(1),dateobs,'UTC of the first on input',status)
    call fits_write_key(fits,keys(2),exptime_mean,6, &
         'The average of exposure times',status)
    call fits_write_key(fits,keys(5),temper_mean,4, &
         'The average of camera temperatures',status)
    if( imagetyp /= '' ) &
         call fits_write_key(fits,FITS_KEY_IMAGETYP,imagetyp,'The image type',status)
    write(buf,'(a,1pg0.6,a,1pg0.2)') &
         ' Average exposure time = ',exptime_mean,' +- ',exptime_err
    call fits_write_comment(fits,buf(2:),status)
    write(buf,'(a,f0.2,a,f0.2,a)') &
         ' Average temperature = ',temper_mean,' +- ',temper_err
    call fits_write_comment(fits,buf(2:),status)
    write(buf,'(a,1pg0.5,a,1pg0.1)') ' Average level = ',dark_mean,' +- ',&
         dark_err
    call fits_write_comment(fits,buf(2:),status)

    if( allocated(biasfits) ) &
         call fits_write_comment(fits,'BIAS: '//trim(biasfits%filename),status)

    if( allocated(maskfits) ) &
         call fits_write_comment(fits,'MASK: '//trim(maskfits%filename),status)

    if( ndark > 0 ) then
       write(buf,'(a,i0,a)') 'Result of average of ',ndark,'  exposure(s):'
       call fits_write_comment(fits,buf,status)
       do n = 1, ndark
          call fits_write_comment(fits,"'"//trim(darknames(n))//"'",status)
       end do
    endif

    if( biasname /= '' ) then
       call fits_write_history(fits,"DARK bias: '"//trim(biasname)//"'",status)
    end if

    if( maskname /= '' ) &
         call fits_write_history(fits,"DARK bitmask: '"//trim(maskname)//"'", &
         status)

    if( threshold_set ) then
       write(buf,*) threshold
       call fits_write_history(fits,"DARK threshold: "//trim(buf),status)
    end if

    if( saturate > 0 ) then
       write(buf,*) saturate
       call fits_write_history(fits,"DARK saturation: "//trim(buf),status)
    end if

    call fits_update_key(fits,FITS_KEY_CREATOR,FITS_VALUE_CREATOR, &
         FITS_COM_CREATOR,status)
    call fits_write_comment(fits,MUNIPACK_VERSION,status)

    ! dark frame data
    call fits_write_image(fits,group,image,status)

    ! stderr
    call fits_insert_img(fits,bitpix,naxis,naxes,status)
    call fits_update_key(fits,'EXTNAME',EXT_STDERR,'',status)
    call fits_write_comment(fits, &
         'An estimation of standard error of mean of pixels of dark frame.',&
         status)
    call fits_write_image(fits,group,imgerr,status)

    if( status == 0 ) then
       if( fits_file_exist(darkname) ) call fits_file_delete(darkname)
       call fits_file_duplicate(fits,darkname,status)
    end if
    call fits_delete_file(fits,status)
    call fits_report_error(error_unit,status)

  end block

  deallocate(darks,darknames,image,imgerr)

  if( status == 0 ) then
     stop 0
  else
     stop 'An error occurred during some dark or bias frames determination.'
  end if

end program dark

!
!  fitsaphot
!
!  Copyright © 2013-6 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

! Parameters by:
! http://stsdas.stsci.edu/cgi-bin/gethelp.cgi?psfmeasure.hlp


module fitsaphot

  use fitsio
  use iso_fortran_env

  implicit none

contains

subroutine faphot(filename,raper,ring,verbose,plog)

  use mdaofotometr

  integer, parameter :: DIM = 2

  character(len=*),intent(in) :: filename
  real, dimension(:),intent(in) :: raper,ring
  logical, intent(in) :: verbose,plog

  integer :: status,naxis,bitpix,nrows,xcol,ycol,hcol,hdutype,i,j,n,naper
  integer, parameter :: group = 1, extver = 0, frow = 1, felem = 1, nbegin = 4
  real, parameter :: nullval = 0.0
  integer, dimension(DIM) :: naxes
  logical :: anyf
  real, dimension(:,:), allocatable :: data, stderr
  real, dimension(:), allocatable :: xcens,ycens,hstar,sky,sky_err
  real, dimension(:,:), allocatable :: apcts,apcts_err
  character(len=FLEN_VALUE), dimension(:), allocatable :: ttype, tform, tunit
  real :: lobad, hibad, fwhm, hwhm
  character(len=FLEN_COMMENT) :: com
  character(len=FLEN_VALUE) :: key

  status = 0
  call ftiopn(15,filename,1,status)
  call ftgipr(15,DIM,bitpix,naxis,naxes,status)
  if( status /= 0 ) goto 666

  allocate(data(naxes(1),naxes(2)),stderr(naxes(1),naxes(2)))
  call ftg2de(15,group,nullval,size(data,1),naxes(1),naxes(2),data,anyf,status)

  call ftmnhd(15,IMAGE_HDU,EXT_STDERR,extver,status)
  if( status == 0 ) then
     call ftg2de(15,1,nullval,naxes(1),naxes(1),naxes(2),stderr,anyf,status)
  else if ( status == BAD_HDU_NUM ) then
     ! if the information about standard error is not available,
     ! we are continuing with epsilons
     ! if( verbose ) write(error_unit,*) "Standard errors of frame are not available."
     !     stderr = epsilon(stderr)
     ! we are continuing with only Poisson component
     where( data > 0 )
        stderr = sqrt(data)
     elsewhere
        stderr = -1
     end where
     status = 0
  end if

  if( status /= 0 ) then
     write(error_unit,*) trim(filename),": Failed to read data."
     goto 666
  end if

  call ftmnhd(15,BINARY_TBL,FINDEXTNAME,extver,status)
  if( status == BAD_HDU_NUM ) then
     write(error_unit,*) "Error: ",trim(FINDEXTNAME)//" extension not found."
     write(error_unit,*) "       Has been stars detected by `munipack find "// &
          trim(filename)//"'?"
     goto 666
  end if

  call ftgnrw(15,nrows,status)

  call ftgkye(15,FITS_KEY_LOWBAD,lobad,com,status)
  call ftgkye(15,FITS_KEY_HIGHBAD,hibad,com,status)
  call ftgkye(15,FITS_KEY_FWHM,fwhm,com,status)
  if( status /= 0 ) then
     write(error_unit,*) trim(filename),": Required keywords ",trim(FITS_KEY_LOWBAD),&
          ",",trim(FITS_KEY_HIGHBAD)," or ",trim(FITS_KEY_FWHM)," not found."
     goto 666
  end if

  naper = size(raper)
  allocate(xcens(nrows),ycens(nrows),hstar(nrows),sky(nrows),sky_err(nrows), &
       apcts(nrows,naper),apcts_err(nrows,naper))

  apcts = -1.0
  apcts_err = -1.0

  call ftgcno(15,.true.,FITS_COL_X,xcol,status)
  call ftgcno(15,.true.,FITS_COL_Y,ycol,status)
  call ftgcno(15,.true.,FITS_COL_PEAKRATIO,hcol,status)
  call ftgcve(15,xcol,frow,felem,size(xcens),nullval,xcens,anyf,status)
  call ftgcve(15,ycol,frow,felem,size(ycens),nullval,ycens,anyf,status)
  call ftgcve(15,hcol,frow,felem,size(hstar),nullval,hstar,anyf,status)
  if( status /= 0 ) goto 666

  ! aperture photometry
  call daophotsb(data,stderr,xcens,ycens,hstar,raper,ring,lobad,hibad,1.0, &
       verbose,plog,apcts,apcts_err,sky,sky_err,status)
  if( status /= 0 ) goto 666

  ! estimate of width parameter for Gaussian
  call estim_hwhm(data,xcens,ycens,sky,fwhm,lobad,hibad,hwhm)
  if( hwhm < 0 ) hwhm = fwhm / (2*sqrt(2*log(2.0)))

  ! store results to next extension
  call ftmnhd(15,BINARY_TBL,APEREXTNAME,extver,status)
  if( status == BAD_HDU_NUM ) then
     status = 0
  else
     ! already presented ? remove it !
     call ftdhdu(15,hdutype,status)
     if( status /= 0 ) goto 666
  end if

  n = nbegin + 2*size(raper)
  allocate(ttype(n), tform(n), tunit(n))

  tform = '1D'
  tunit = ''
  ttype(1) = FITS_COL_X
  ttype(2) = FITS_COL_Y
  ttype(3) = FITS_COL_SKY
  ttype(4) = FITS_COL_SKYERR

  do i = 1, size(raper)
     j = nbegin - 1 + 2*i
     write(ttype(j),'(a,i0)') trim(FITS_COL_APCOUNT),i
     write(ttype(j+1),'(a,i0)') trim(FITS_COL_APCOUNTERR),i
  end do

  ! aperture photometry table
  call ftibin(15,0,size(ttype),ttype,tform,tunit,APEREXTNAME,0,status)

  call ftpkye(15,FITS_KEY_HWHM,hwhm,-4,'[pix] half width at half of maximum',status)
  call ftpkyj(15,FITS_KEY_NAPER,size(raper),'Count of apertures',status)
  do i = 1, size(raper)
     call ftkeyn(FITS_KEY_APER,i,key,status)
     call ftpkye(15,key,raper(i),-5,'[pix] aperture radius',status)
  end do

  call ftpkye(15,trim(FITS_KEY_ANNULUS)//'1',ring(1),-5,'[pix] inner sky annulus radius',status)
  call ftpkye(15,trim(FITS_KEY_ANNULUS)//'2',ring(2),-5,'[pix] outer sky annulus radius',status)

  call ftpcle(15,1,frow,felem,size(xcens),xcens,status)
  call ftpcle(15,2,frow,felem,size(ycens),ycens,status)
  call ftpcle(15,3,frow,felem,size(sky),sky,status)
  call ftpcle(15,4,frow,felem,size(sky_err),sky_err,status)

  do i = 1,size(apcts,2)
     j = nbegin-1+2*i
     call ftpcle(15,j,frow,felem,size(apcts(:,i)),apcts(:,i),status)
     call ftpcle(15,j+1,frow,felem,size(apcts_err(:,i)),apcts_err(:,i),status)
  end do
  deallocate(ttype,tform,tunit)


666 continue

  if( allocated(data) ) deallocate(data,stderr)
  if( allocated(apcts) ) deallocate(xcens,ycens,hstar,apcts,apcts_err, &
       sky,sky_err)


  call ftclos(15,status)
  call ftrprt('STDERR',status)

end subroutine faphot


subroutine estim_hwhm(data,xcens,ycens,sky,fwhm,lobad,hibad,hwhm)

  use robustmean

  real, dimension(:,:), intent(in) :: data
  real, dimension(:), intent(in) :: xcens,ycens,sky
  real, intent(in) :: fwhm,lobad,hibad
  real, intent(out) :: hwhm

  real, dimension(:), allocatable :: xhwhm
  real :: sx,sy,w,sw,w0
  integer :: nx,ny,i,j,l,m,n,i0,j0

  allocate(xhwhm(size(xcens)))

  nx = size(data,1)
  ny = size(data,2)

  n = 0
  m = nint(1.5*fwhm)
  m = nint(fwhm / 2) * 3
  ! neighborhood is 3*hwhm of expected which prefers important
  ! parts of profile

  do l = 1, size(xcens)

     sx = 0
     sy = 0
     sw = 0
     i0 = nint(xcens(l))
     j0 = nint(ycens(l))
     w0 = max(data(i0,j0) - sky(l),0.0)
     do i = i0-m,i0+m
        do j = j0-m,j0+m
           if( 0 < i .and. i <= nx .and. 0 < j .and. j <= ny ) then
              if( lobad < data(i,j) .and. data(i,j) < hibad ) then
                 w = max(data(i,j) - sky(l),0.0)
                 sx = sx + w*(i - xcens(l))**2
                 sy = sy + w*(j - ycens(l))**2
                 sw = sw + w
              end if
           end if
        end do
     end do
     if( sw > 0 .and. w0 > 0 .and. sqrt(w0) / w0 < 0.01) then
        ! estimation of fwhm is very sensitive on noise in data (w),
        ! therefore we're selecting only bright stars
        n = n + 1
        xhwhm(n) = (sqrt(sx/sw) + sqrt(sy/sw)) / 2
     end if
  end do

  if( n > 1 ) then
     call rmean(xhwhm(1:n),hwhm,w)
  else
     hwhm = -1
  end if

  deallocate(xhwhm)

end subroutine estim_hwhm


end module fitsaphot

!
!  FITS tool for kombine
!
!  Copyright © 2018-21 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module fitskombi

  use astrotrafo
  use phio
  use titsio
  use iso_fortran_env

  implicit none

  integer, private, parameter :: dbl = selected_real_kind(15)

  type :: KombiFits
     character(len=FLEN_FILENAME) :: filename = ''
     character(len=FLEN_VALUE) :: dateobs = '', filter = '', object = ''
     character(len=FLEN_VALUE), dimension(2) :: ctype
     real(dbl), dimension(2) :: crval, crpix, crerr
     real(dbl), dimension(2,2) :: cd
     real(dbl) :: longitude, latitude
     real, dimension(:,:), allocatable :: image
     integer, dimension(2) :: naxes = [ 0, 0 ]
     integer :: bitpix = -32
     integer :: naxis = 0
     real :: exptime = 1
     logical :: background = .true.
     logical :: geo = .false.
     logical :: status = .false.
   contains
     procedure :: Load,loadimg,reproject,jd
     procedure, private :: bestim
  end type KombiFits

contains

  subroutine Load(fits,filename,fitskeys,background,verbose)

    ! opens a FITS file, only metadata are probed,
    ! %image components remains undefined

    class(KombiFits) :: fits
    character(len=*), intent(in) :: filename
    character(len=*), dimension(:), intent(in) :: fitskeys
    logical, intent(in) :: background, verbose

    type(fitsfiles) :: fitsfile
    integer :: status

    fits%filename = filename
    fits%background = background

    status = 0
    call fits_open_image(fitsfile,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) 'Error: failed to read the file `',trim(filename),"'."
       fits%status = .false.
       return
    end if

    call fits_get_img_type(fitsfile,fits%bitpix,status)
    call fits_get_img_dim(fitsfile,fits%naxis,status)
    if( status /= 0 ) goto 666

    if( fits%naxis /= 2 ) then
       write(error_unit,*) &
            'Error: the assertion NAXIS /= 2 failed: `',trim(filename),"."
       goto 666
    end if

    call fits_get_img_size(fitsfile,2,fits%naxes,status)
    if( status /= 0 ) goto 666

    ! read date and time, dateobs
    call fits_write_errmark
    call fits_get_dateobs(fitsfile,fitskeys(1:2),fits%dateobs,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       call fits_clear_errmark
       if( verbose ) write(error_unit,*) 'Warning: Date of observation by ', &
            trim(fitskeys(1)),',',trim(fitskeys(2)),' keywords not found.'
       status = 0
       fits%dateobs = ''
    end if

    ! exposure time
    call fits_write_errmark
    call fits_read_key(fitsfile,fitskeys(3),fits%exptime,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       call fits_clear_errmark
       if( verbose ) write(error_unit,*) &
            'Warning: Exposure time by ',trim(fitskeys(3)),' keyword not found.'
       status = 0
       fits%exptime = 1
    end if

    ! filter
    call fits_write_errmark
    call fits_read_key(fitsfile,fitskeys(4),fits%filter,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       call fits_clear_errmark
       if( verbose ) write(error_unit,*) &
            'Warning: Filter by ',trim(fitskeys(4)),' keyword not found.'
       status = 0
       fits%filter = ''
    end if

    ! object
    call fits_write_errmark
    call fits_read_key(fitsfile,fitskeys(5),fits%object,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       call fits_clear_errmark
       if( verbose ) write(error_unit,*) &
            'Warning: Object name by ',trim(fitskeys(5)),' keyword not found.'
       status = 0
       fits%object = ''
    end if

    ! Geographic coordinates
    call fits_write_errmark
    call fits_read_key(fitsfile,fitskeys(6),fits%longitude,status)
    call fits_read_key(fitsfile,fitskeys(7),fits%latitude,status)
    fits%geo = status == 0
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       call fits_clear_errmark
       if( verbose ) write(error_unit,*) &
            'Warning: Geographics coordinates by ',trim(fitskeys(6)),&
            ' and ',trim(fitskeys(7)),' keyword not found.'
       status = 0
    end if

    ! astrometry
    call fits_read_wcs(fitsfile,fits%ctype,fits%crval,fits%crpix,fits%cd,fits%crerr,&
         status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       if( verbose ) write(error_unit,'(a)') &
            "Error: `"//trim(filename)//"': astrometry calibration not found."
       goto 666
    end if

666 continue

    call fits_close_file(fitsfile,status)
    call fits_report_error(error_unit,status)

    fits%status = status == 0

  end subroutine Load

  logical function loadimg(this)

    ! fills %image structure item

    class(KombiFits) :: this
    character(len=80) :: msg
    integer :: status
    logical :: anyf
    type(fitsfiles) :: fitsfile

    allocate(this%image(this%naxes(1),this%naxes(2)),stat=status,errmsg=msg)
    if( status /= 0 ) then
       write(error_unit,*) "Error: ",trim(this%filename),": ",trim(msg)
       loadimg = .false.
       return
    end if

    status = 0
    call fits_open_image(fitsfile,this%filename,FITS_READONLY,status)
    if( status == 0 ) then
       call fits_read_image(fitsfile,0,0.0,this%image,anyf,status)
       call fits_close_file(fitsfile,status)
       call fits_report_error(error_unit,status)
    end if

    loadimg = allocated(this%image) .and. status == 0

  end function loadimg

  subroutine reproject(this,method,jdref,crmov,alpha,delta,img,mask)

    use interpol

    class(KombiFits) :: this
    character(len=*), intent(in) :: method
    real(dbl), intent(in) :: jdref
    real(dbl), dimension(:), intent(in) :: crmov
    real(dbl), dimension(:,:), intent(in) :: alpha, delta
    real, dimension(:,:), intent(out) :: img
    logical, dimension(:,:), intent(out) :: mask

    real, dimension(:,:), allocatable :: fx,fy,fxy
    integer :: i,j,n,m,i1,i2,j1,j2,nx,ny
    real :: x,y,back
    real(dbl) :: xx,yy,dt
    type(AstroTrafoProj) :: t

    nx = size(this%image,1)
    ny = size(this%image,2)

    mask = .false.
    call trafo_fromwcs(t,this%ctype,this%crval,this%crpix,this%cd,this%crerr)

    ! proper motion
    dt = this%jd() - jdref
    t%acen = t%acen - dt * crmov(1)
    t%dcen = t%dcen - dt * crmov(2)

    ! background
    if( this%background ) then
       back = this%bestim()
    else
       back = 0.0
    end if

    if( method == 'BICUBIC' ) then
       allocate(fx(nx,ny),fy(nx,ny),fxy(nx,ny))
       call diff(this%image,fx,1,0)
       call diff(this%image,fy,0,1)
       call diff2(this%image,fxy)
    end if

    do i = 2, size(alpha,1)-1
       do j = 2, size(delta,2)-1

          call trafo(t,alpha(i,j),delta(i,j),xx,yy)
          x = real(xx)
          y = real(yy)
          i1 = int(x)
          i2 = i1 + 1
          j1 = int(y)
          j2 = j1 + 1

          if( method == 'BI3CONV' ) then
             i2 = i2 + 2
             j2 = j2 + 2
          end if

          if(  1 <= i1 .and. i2 <= nx .and. 1 <= j1 .and. j2 <= ny ) then

             if( method == 'NEAR' ) then

                n = nint(x)
                m = nint(y)
                img(i,j) = this%image(n,m) -  back

             else if( method == 'BILINEAR' ) then

                img(i,j) = bilinear(x-i1,y-j1,this%image(i1:i2,j1:j2)) - back

             else if( method == 'BICUBIC' ) then

                img(i,j) = bicubic(x-i1,y-j1,this%image(i1:i2,j1:j2), &
                     fx(i1:i2,j1:j2),fy(i1:i2,j1:j2),fxy(i1:i2,j1:j2)) - back

             else if( method == 'BI3CONV' ) then

                img(i,j) = bi3conv(x-i1,y-j1,this%image(i1:i2,j1:j2)) -  back

             else

                call random_number(img(i,j)) ! noise

             end if

             mask(i,j) = .true.
          end if
       end do
    end do

  end subroutine reproject

  real(dbl) function jd(this)

    ! returns JD at middle of this exposure

    use phio

    class(KombiFits) :: this
    integer :: status

    status = 0
    jd = fits_jd(this%dateobs,status)
    if( status /= 0 ) write(error_unit,'(a)') &
         "Error: Failed to convert `"//trim(this%dateobs)//"' to JD."

    jd = jd + this%exptime / (2*86400)

  end function jd

  real function bestim(this)

    use oakleaf

    class(KombiFits), intent(in) :: this
    integer :: n,m

    if( .not. this%status ) then
       bestim = 0.0
       return
    end if

    do n = 0, 10
       m = 2**n
       if( (this%naxes(1)/m) * (this%naxes(2)/m) < 2**20 ) exit
    end do

    call rmean(pack(this%image(::m,::m),.true.),bestim)

  end function bestim

end module fitskombi

!
!  Dark     Average of a set of dark or bias frames.
!
!  Copyright © 1998-2017 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!
!  TODO:
!
!   * Is there a benefit from arithmetic mean at 21. century?
!

program adark

!
! Computes average of darks or biases by the arithmetical mean
! of all images (non-robust but fast) or by the robust mean (remove
! defects on single frame but slower and more memory consuming).
!

  use LibList
  use robustmean
  use weightedmean
  use means
  use fitsio
  use xfitsio
  use iso_fortran_env

  implicit none

  character(len=*), parameter :: adid = 'DARK'

  ! Output image name:
  Character(len=FLEN_FILENAME) :: namedark='dark.fits', backup, biasname=''

  ! No. of image dimensions
  integer, parameter :: DIM = 2

  Character(len=4*FLEN_FILENAME) :: sb,key,val,record,buf
  Character(len=FLEN_CARD) :: dateobs,dateobs1,imagetyp1,imagetyp
  character(len=FLEN_KEYWORD) :: TEMPERAT=FITS_KEY_TEMPERATURE, &
       EXPTIME=FITS_KEY_EXPTIME,DATE_OBS=FITS_KEY_DATEOBS,KEY_IMAGETYP=FITS_KEY_IMAGETYP

  Integer :: i,j,n, eq, nobs, istat, naxis
  Integer, dimension(DIM) :: naxes
  integer :: bitpix = -32
  logical :: robust = .true.
  logical :: verbose = .false.

! image
  real, dimension(:,:), allocatable :: DARK, DDARK, SIG
  real, dimension(:,:), pointer :: ccd
  real, dimension(:), allocatable :: fbuf
  real :: t, temp, stemp, e, etime,setime,aval, sval
  real :: tol_exptime = 1e-6
  real :: tol_temperat = 1.0
  type(Imagetype), pointer :: list,curr
  type(xFITS) :: fits, bias

  call xfits_init(bias)

  call InitList(list)
  curr => list

  do
     read(*,'(a)',end=20) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Improper input.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'OUTPUT' ) then
        read(val,*) namedark, backup
     endif

     if( key == 'MEAN' ) then
        read(val,*) buf
        robust = buf /= 'A';
     endif

     if( key == 'BITPIX' ) then
        read(val,*) bitpix
     endif

     if( key == 'VERBOSE' ) then
        read(val,*) verbose
     endif

     if( key == 'FITS_KEY_TEMPERATURE' ) then
        read(val,*) TEMPERAT
     endif

     if( key == 'FITS_KEY_DATEOBS' ) then
        read(val,*) DATE_OBS
     endif

     if( key == 'FITS_KEY_EXPTIME' ) then
        read(val,*) EXPTIME
     endif

     if( key == 'TOL_TEMPERATURE' ) then
        read(val,*) tol_temperat
     endif

     if( key == 'TOL_EXPOSURE' ) then
        read(val,*) tol_exptime
     endif

     if( key == 'BIAS' ) then

        read(val,*) biasname
        if( verbose ) write(error_unit,*) "BIAS=",trim(biasname)
        call xfits_read(biasname,bias)
        if( .not. bias%status ) stop 'Failed to load bias frame.'

     end if

     if( key == 'FILE' ) then

        if( verbose .and. getno(curr) == 0 ) &
             write(error_unit,*) "Filename, exposure time [s], temperature [degC]:"


        read(val,*) sb
        if( verbose ) write(error_unit,'(a)',advance="no") trim(sb)//":"

        call xfits_init(fits)
        call xfits_read(sb,fits)
        if( .not. fits%status ) then
           call xfits_deallocate(fits)
           goto 665
        end if

        if( getno(curr) > 0 .and. .not. all(naxes == fits%naxes) ) then
           write(error_unit,*) &
                "Dimensions of images mutually does not corresponds. Skipping."
           goto 665
        endif

        istat = 0
        call xfits_kye(fits,TEMPERAT,t,istat)
        if( istat /= 0 ) then
           istat = 0
           t = -999
        end if

        call xfits_kye(fits,EXPTIME,e,istat)
        if( istat /= 0 ) then
           istat = 0
           e = -1
        end if

        call xfits_kys(fits,DATE_OBS,dateobs,istat)
        if( istat /= 0 ) then
           istat = 0
           dateobs = ''
        end if

        call xfits_kys(fits,KEY_IMAGETYP,imagetyp,istat)
        if( istat /= 0 ) then
           istat = 0
           imagetyp = ''
        end if

        if( verbose ) write(error_unit,'(2x,1pg12.3,1x,0pf7.1)') e,t

        ! first image => initialisation
        if( getno(curr) == 0 )then

           naxis = fits%naxis
           naxes = fits%naxes

           allocate(DARK(naxes(1),naxes(2)),DDARK(naxes(1),naxes(2)), &
                SIG(naxes(1),naxes(2)))
           DARK = 0.0
           SIG = 0.0
           DDARK = 0.0
           dateobs1 = dateobs
           imagetyp1 = imagetyp

           if( bias%status ) then
              if( .not. all(bias%naxes == naxes) ) &
                   stop "Biases has different axes sizes."
           end if

        end if

        if( bias%status ) fits%image = fits%image - bias%image
        ! bias error is neglected

        if( robust ) then
           allocate(ccd(naxes(1),naxes(2)))
           ccd = fits%image
           Call AddItem (curr,image=ccd,filename=sb,dateobs=dateobs,exptime=e,temp=t)
        else

           ! compute sumation
           DARK = DARK + fits%image
           SIG  = SIG  + fits%image**2

           ! add image
           Call AddItem (curr,filename=sb,dateobs=dateobs,exptime=e,temp=t)
        endif

665     continue
        call xfits_deallocate(fits)

     end if

  enddo

20 continue
  nobs = getno(curr)

  if( nobs == 0 ) stop 'None input image(s) are available to open.'

  if( nobs > 1 ) then

     if( verbose ) then
        write(error_unit,*)
        write(error_unit,*) 'Mean of frame(s):',nobs
        write(error_unit,*) 'Computed by mean: ',robust,' (T=robust, F=arithmetical)'
        write(error_unit,*) 'Dimensions:',naxes(1),'x',naxes(2)
        write(error_unit,*) 'Preparing a bias or dark frame ...'
     end if

     ! computation of mean
     if( robust ) then

        allocate(fbuf(nobs))
        do j = 1, naxes(2)
           do i = 1, naxes(1)

              curr => list
              do
                 curr => GetNext(curr)
                 if( .not. associated(curr) ) exit
                 call GetItem(curr,image=ccd)
                 n = getno(curr)
                 fbuf(n) = ccd(i,j)
              enddo
              call rmean(fbuf,DARK(i,j),DDARK(i,j),SIG(i,j))

           enddo
        enddo
        deallocate(fbuf)

        call rwmean(pack(DARK,DDARK > 0),pack(DDARK,DDARK > 0),aval,sval)

     else

        DARK = DARK / nobs
        SIG = sqrt((max(SIG - nobs*DARK**2,0.0)/(nobs - 1)))
        DDARK = SIG / sqrt(real(nobs))

        aval = sum(DARK)/size(DARK)
        sval = sum(SIG,mask=SIG>0) / count(SIG>0)

     end if

     allocate(fbuf(nobs))
     ! mean exposure time
     curr => list
     do
        curr => GetNext(curr)
        if( .not. associated(curr) ) exit
        n = getno(curr)
        call GetItem(curr,exptime=fbuf(n))
     enddo
     if( robust ) then
        call rmean(fbuf,etime,setime)
     else
        call mean(fbuf,etime,setime)
     end if
     setime = setime / sqrt(real(nobs))

     ! check exptimes
     if( etime > 0 )then
        curr => list
        do
           curr => GetNext(curr)
           if( .not. associated(curr) ) exit
           n = getno(curr)
           call GetItem(curr,filename=sb,exptime=e)
           if( e > 0 .and. abs(e-etime) > tol_exptime ) write(error_unit,*) &
                "Warning: Exposure time out of limit for `",trim(sb),"': ",e
        enddo
     end if

     ! computation of mean temperature
     curr => list
     do
        curr => GetNext(curr)
        if( .not. associated(curr) ) exit
        n = getno(curr)
        call GetItem(curr,temp=fbuf(n))
     enddo
     if( robust ) then
        call rmean(fbuf,temp,stemp)
     else
        call mean(fbuf,temp,stemp)
     end if
     stemp = stemp / sqrt(real(nobs))

     ! check temperatures
     if( temp > -273.0 ) then
        curr => list
        do
           curr => GetNext(curr)
           if( .not. associated(curr) ) exit
           n = getno(curr)
           call GetItem(curr,filename=sb,temp=t)
           if( t > -273 .and. abs(t-temp) > tol_temperat ) write(error_unit,*) &
                "Warning: Temperature out of limit for `",trim(sb),"': ",t
        enddo
     end if

     deallocate(fbuf)

  else

     ! nobs == 1
     DARK = ccd
     temp = t
     stemp = 0.0
     etime = e
     setime = 0.0
     aval = sum(DARK)/size(DARK)
     sval = 0.0

  end if

  if( verbose ) then
     write(error_unit,*) 'Output image: ',trim(namedark)
     write(error_unit,*) 'Average level: ',aval,'+-',sval
     write(error_unit,*) 'Average exposure time: ',etime,'+-',setime
     write(error_unit,*) 'Average temperature: ',temp,'+-',stemp
  end if

  ! save output image
  istat = 0
  call fitsbackup(namedark,backup,istat)
  Call ftinit(26,namedark,1,istat)
  Call ftphps(26,bitpix,naxis,naxes,istat)
  if( etime > 0.0 )then
     call ftpkye(26,EXPTIME,etime,6,'Average of exposure times',istat)
  end if
  if( temp > -273.0 )then
     call ftpkye(26,TEMPERAT,temp,4,'Average of camera temperatures',istat)
  end if
  call ftpkys(26,DATE_OBS,dateobs1,'UTC of the first on input',istat)
  if( bitpix > 0 ) then
     call ftpkyj(26,'BSCALE',1,'',istat)
     call ftpkyj(26,'BZERO',2**(bitpix-1),'',istat)
  endif
  if( imagetyp1 /= '' ) &
     call ftpkys(26,KEY_IMAGETYP,imagetyp,'image type',istat)
  if( temp > -273.0 )then
     write(buf,'(a,f0.2,a,f0.2,a)') ' Average temperature = ',temp,' +- ',stemp
     call ftpcom(26,buf(2:),istat)
  end if
  if( etime > 0.0 )then
     write(buf,'(a,1pg0.6,a,1pg0.2)') ' Average exposure time = ',etime,' +- ',setime
     call ftpcom(26,buf(2:),istat)
  end if
  write(buf,'(a,1pg0.5,a,1pg0.1)') ' Average level = ',aval,' +- ',sval
  call ftpcom(26,buf(2:),istat)

  if( bias%status ) call ftpcom(26,'BIAS: '//trim(bias%filename),istat)

  if( nobs > 0 ) then
     write(buf,'(a,i0,a)') 'Result of average of ',nobs,'  exposure(s).'
     call ftpcom(26,buf,istat)
     call ftpcom(26,'File name, time of start and temperature for each frame:',istat)
     curr => list
     do
        curr => GetNext(curr)
        if( .not. associated(curr) ) exit
        call GetItem(curr,filename=sb,dateobs=dateobs,temp=t)
        write(buf,'(f0.2)') t
        call ftpcom(26,"'"//trim(sb)//"' '"//trim(dateobs)//"' "//trim(buf),istat)
        ! just part of the comment will visible for very long filenames
     enddo
  endif
  if( robust ) then
     call FTPCOM(26,'The robust mean has been used.',istat)
  else
     call FTPCOM(26,'The arithmetical mean has been used.',istat)
  end if

  if( biasname /= '' ) then
     call ftphis(26,adid//" bias: '"//trim(biasname)//"'",istat)
  end if

  call ftukys(26,FITS_KEY_CREATOR,FITS_VALUE_CREATOR,FITS_COM_CREATOR,istat)
  call ftpcom(26,MUNIPACK_VERSION,istat)

  if( istat /= 0 ) goto 666

  ! data
  call ftp2de(26,1,naxes(1),naxes(1),naxes(2),DARK,istat)
  if( istat == NUMERICAL_OVERFLOW ) then
     write(error_unit,*) 'Warning: Numerical overflow occurred while writing dark.'
     istat = 0
  end if

  ! stderr
  call ftiimg(26,bitpix,naxis,naxes,istat)
  call ftukys(26,'EXTNAME',EXT_STDERR,'',istat)
  call ftpcom(26,'An estimation of standard error of every pixel.',istat)
  call ftp2de(26,1,naxes(1),naxes(1),naxes(2),DDARK,istat)
  if( istat == NUMERICAL_OVERFLOW ) then
     write(error_unit,*) 'Warning: Numerical overflow occurred while writing std.err.'
     istat = 0
  end if

  call ftclos(26,istat)
  if( istat /= 0 ) goto 666

  call DestroyList(list)
  deallocate(DARK,DDARK,SIG)

  call xfits_deallocate(bias)

  stop 0

666 continue

  call xfits_deallocate(bias)

  call ftrprt('STDERR',istat)

end program adark

!
!  aperture photometry
!
!  Copyright © 2010-19 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!  Ideas:
!    * The aperture radii distribution by [1 + erf(x/FWHM)]/2.
!

program aphot

  use titsio
  use fitsaphot
  use daofotometr

  implicit none

  real, parameter :: pi = 3.141592653

  character(len=4*FLEN_FILENAME) :: record,key,val
  character(len=FLEN_FILENAME) :: filename,output
  character(len=FLEN_KEYWORD), dimension(1) :: fkeys
  character(len=80) :: msg
  real, dimension(:), allocatable :: raper, xstar, ystar
  real, dimension(2) :: ring
  real ::  ecc_par = 0           ! eccentricity: 0 (circle) .. 1 (line)
  real :: incl_par = 0           ! inclination of major semiaxis, degs
  logical :: ellipticity = .false. ! enable elliptic apertures
  logical :: snap = .false.      ! locate a local maximum brightness (by hand)
  logical :: ecc_defined = .false., incl_defined = .false.
  logical :: verbose = .false., plog = .false.
  logical :: ex, exitus = .true.
  integer :: i,eq,stat,naper,nstars
  real :: theta, pitch

  ! Aperture radii are defined by the logarithmic spiral
  ! (https://en.wikipedia.org/wiki/Logarithmic_spiral); the angles
  ! are in the interval 0 .. pi with step pi / (naper - 1). The pitch
  ! parameter is ln(20)/pi; it is computed from the inner ring radius.
  ! pitch 9.84 deg, raper(1) = 1, .. raper(12) = 20
  naper = 12
  allocate(raper(naper))
  pitch = log(20.0) / pi
  do i = 1, naper
     theta = (i - 1.0) / (naper - 1.0) * pi
     raper(i) = exp(pitch*theta)
  end do
  ring = [20.0, 30.0]

  nstars = 0
  allocate(xstar(0),ystar(0))

  fkeys(1) = FITS_KEY_SATURATE

  do
     read(*,'(a)',iostat=stat,iomsg=msg) record
     if( stat == IOSTAT_END ) exit
     if( stat > 0 ) then
        write(error_unit,*) trim(msg)
        error stop 'Some input error.'
     end if

     eq = index(record,'=')
     if( eq == 0 ) stop 'Malformed input record.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'PIPELOG' ) then

        read(val,*) plog

     else if( key == 'FITS_KEY_SATURATE' ) then

        read(val,*) fkeys(1)

     else if( key == 'NAPER' ) then

        read(val,*) naper
        deallocate(raper)
        allocate(raper(naper))

     else if( key == 'APER' ) then

        read(val,*) raper

     else if( key == 'RING' ) then

        read(val,*) ring

     else if( key == 'ELLIPTICITY' ) then

        read(val,*) ellipticity

     else if( key == 'ECCENTRICITY' ) then

        read(val,*) ecc_par
        ecc_defined = .true.
        if( .not. abs(ecc_par) < 1 ) stop 'Eccentricity >= 1.'

     else if( key == 'INCLINATION' ) then

        read(val,*) incl_par
        incl_defined = .true.

     else if( key == 'NSTARS' ) then

        read(val,*) nstars
        deallocate(xstar,ystar)
        allocate(xstar(nstars),ystar(nstars))
        nstars = 0

     else if( key == 'STAR' ) then

        nstars = nstars + 1
        read(val,*) xstar(nstars),ystar(nstars)

     else if( key == 'SNAP' ) then

        read(val,*) snap

     else if( key == 'FILE' ) then

        read(val,*) filename, output

        if( verbose ) write(*,*) trim(filename)//": "

        if( nstars > 0 ) then
           call byhand(exitus)
        else
           call the_aphot(ex)
           exitus = exitus .and. ex
        end if

     end if

  end do

  deallocate(raper,xstar,ystar)

  if( exitus ) then
     stop 0
  else
     stop 'Some error(s) occurred during this APHOT run.'
  end if

contains

  subroutine the_aphot(exitus)

    logical, intent(out) :: exitus

    real, dimension(:,:), allocatable :: data,stderr
    real, dimension(:), allocatable :: xcens,ycens,sky,sky_err
    real, dimension(:,:), allocatable :: apcts,apcts_err
    real :: lobad,hibad,fwhm,hwhm,ecc,incl
    integer :: nrows, status

    status = 0
    call fits_aphot_read(filename,data,stderr,xcens,ycens, &
         lobad,hibad,fwhm,ecc,incl,status)
    if( status /= 0 ) goto 666

    if(  ecc_defined )  ecc =  ecc_par
    if( incl_defined ) incl = incl_par

    if( .not. ellipticity ) then
       ecc = 0
       incl = 0
    end if

    nrows = size(xcens)
    allocate(apcts(nrows,naper),apcts_err(nrows,naper), &
         sky(nrows),sky_err(nrows))

    call daophotsb(data,stderr,xcens,ycens,raper,ring,ecc,incl,lobad,hibad, &
         verbose,plog,apcts,apcts_err,sky,sky_err)

    ! estimate of width parameter for Gaussian
    call estim_hwhm(data,xcens,ycens,sky,fwhm,lobad,hibad,hwhm)
    if( hwhm < 0 ) hwhm = fwhm / (2*sqrt(2*log(2.0)))

    call fits_aphot_save(filename, output, hwhm, ecc, incl, raper, ring, &
         xcens, ycens, apcts,apcts_err,sky,sky_err, status)

666 continue

    exitus = status == 0

    if( allocated(data) ) deallocate(data,stderr)
    if( allocated(apcts) ) deallocate(xcens,ycens,apcts,apcts_err,sky,sky_err)

  end subroutine the_aphot

  subroutine byhand(exitus)

    use mdaosky

    logical, intent(out) :: exitus

    real, dimension(:,:), allocatable :: data, stderr
    real, dimension(:), allocatable :: sky, sky_err
    real, dimension(:,:), allocatable :: apcts,apcts_err
    real :: lobad, hibad, saturate, skyavg,skyerr,skysig
    integer :: i, nrow, nstep, status

    status = 0
    call fits_aphot_image(filename,fkeys,data,stderr,saturate,status)
    if( status /= 0 ) goto 666

    hibad = saturate
    nstep = max(int(log(float(size(data))/4e4) / log(2.0)),1)
    call daosky(data,nstep,verbose,hibad,skyavg,skyerr,skysig)
    lobad = max(0.0,skyavg - 3*skysig)

    nrow = size(xstar)
    allocate(apcts(nrow,naper),apcts_err(nrow,naper),sky(nrow),sky_err(nrow))

    if( snap ) then
       block
         integer :: i,j,n,i0,j0,imin,imax,jmin,jmax
         real :: fmax
         logical :: found

         do n = 1, nrow

            imin = max(int(xstar(n)-raper(1)-1),1)
            jmin = max(int(ystar(n)-raper(1)-1),1)
            imax = min(int(xstar(n)+raper(1)+1),size(data,1))
            jmax = min(int(ystar(n)+raper(1)+1),size(data,2))
            found = .false.
            fmax = lobad
            do i = imin, imax
               do j = jmin, jmax
                  if( data(i,j) > fmax ) then
                     fmax = data(i,j)
                     i0 = i
                     j0 = j
                     found = .true.
                  end if
               end do
            end do

            if( found ) then
               xstar(n) = i0
               ystar(n) = j0
            end if

         end do
       end block
    end if

    call daophotsb(data,stderr,xstar,ystar,raper,ring,ecc_par,incl_par, &
         lobad,hibad,verbose,plog,apcts,apcts_err,sky,sky_err)

    do i = 1, nrow
       write(*,*) '=BYHAND> ',i,xstar(i),ystar(i),sky(i),sky_err(i), &
            apcts(i,:),apcts_err(i,:)
    end do

666 continue

    exitus = status == 0

    if( allocated(data) ) deallocate(data,stderr)
    if( allocated(apcts) ) deallocate(apcts,apcts_err,sky,sky_err)

  end subroutine byhand


end program aphot

!
!  Robust estimate of a plane
!
!  Copyright © 2015 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

module robustplane

  implicit none

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)

  ! print debug informations ?
  logical, parameter, private :: verbose = .false.

  real(dbl), dimension(:), allocatable, private :: xdata, ydata, zdata, &
       xsig, ysig, zsig
  real(dbl), private :: rsig

  private :: planefun,planedif,planelog,res

contains

  subroutine rplane(x,dx,y,dy,z,dz,q,dq,sig,info)

    use minpacks
    use NelderMead
    use oakleaf

    real(dbl), parameter :: macheps = epsilon(1.0_dbl)
    integer, parameter :: maxeval = 1000000
    real(dbl), dimension(:), intent(in) :: x,y,z,dx,dy,dz
    real(dbl), dimension(:), intent(in out) :: q,dq
    real(dbl), intent(out) :: sig
    integer, intent(out) :: info
    integer :: icount, numres, ifault, ndata, nprint
    real(dbl), dimension(size(q)+1) :: p,dp,p0
    real(dbl), dimension(size(p),size(p)) :: jac,hess
    real(dbl),dimension(:), allocatable :: f,df,r
    real(dbl) :: s,d,mad,sum2,sum3
    integer :: i

    if( size(q) /= 3 ) stop 'Plane needs to have tree parameters.'

    if( verbose ) then
       nprint = 1
    else
       nprint = 0
    end if

    info = 3 ! no initialisation
    ndata = size(x)
    allocate(xdata(ndata),ydata(ndata),zdata(ndata),xsig(ndata),ysig(ndata),zsig(ndata),&
         f(ndata),df(ndata),r(ndata))
    xdata = x
    ydata = y
    zdata = z
    xsig = dx
    ysig = dy
    zsig = dz

    ! init by absolute deviations
    p(1:3) = q
    dp(1:3) = dq
    p0 = p
    call nelmin(planefun,3,p0(1:3),p(1:3),mad,macheps,dp(1:3),1,maxeval,icount,numres,ifault)
    if( verbose ) write(*,'(a,3f15.3,i5)') 'rplane init:',p(1:3),ifault
    if( ifault /= 0 ) then
       info = 2 ! no convergence
       if( verbose ) &
            write(*,*) "rplane init finished prematurely without convergence."
       goto 666
    end if
    q = p(1:3)

    r = abs(zdata - (p(1) + p(2)*xdata + p(3)*ydata))
    sig = median(r) / 0.6745
    if( verbose ) write(*,'(a,f0.5)') 'sig0 = ',sig
    rsig = sig

    if( verbose ) write(*,*) 'Winsorisation:'
    do i = 1,size(zdata)
       r(i) = (zdata(i) - (p(1) + p(2)*xdata(i) + p(3)*ydata(i))) / sig
       if( abs(r(i)) > 3 ) then
          d = p(1) + p(2)*xdata(i) + p(3)*ydata(i) + sign(3*sig,r(i))
          if( verbose ) write(*,'(4g15.5)') i,d,zdata(i),r(i)
          zdata(i) = d
       end if
    end do

    ! locate proper minimum
    p(4) = 1
    p0 = p
    dp = abs(0.1*p + 0.01*sig + 1e-3)
    dp(4) = 0.1
    dp = 0.1*dp
    call nelmin(planelog,size(p),p0,p,s,macheps,dp,1,maxeval,icount,numres,ifault)
    if( verbose ) write(*,'(a,i3,4g13.5)') 'Approximate solution: ',ifault,p
    if( ifault /= 0 ) then
       info = 2 ! no convergence
       if( verbose ) &
            write(*,*) "rplane finished prematurely without likelihood convergence."
       goto 666
    end if
    q = p(1:3)

    ! robust estimate
    call lmdif2(planedif,p,epsilon(p),nprint,info)
    if( verbose ) write(*,'(a,4f10.5,i5)') 'robust:',p,info
    if( info == 5 ) then
       info = 2 ! no convergence
       if( verbose ) &
            write(*,*) "rplane finished prematurely without lmdif convergence."
       goto 666
    end if
    q = p(1:3)

    ! estimation of uncertainties
    call res(p(1),p(2),p(3),r)
    f = huber(r)
    df = dhuber(r)
    sum2 = sum(df)
    sum3 = sum(f**2)

    if( sum2 > epsilon(sum2) ) then

       ! Huber (6.6)
       ! compute jac!!
       call qrinv(jac,hess)
       sig = sig*sqrt(sum3/sum2*ndata/(ndata-1.0))
       do i = 1, size(q)
          if( abs(hess(i,i)) > 0 ) then
             dq(i) = sig * sqrt(abs(hess(i,i)))
          else
             dq(i) = sig / sqrt(ndata - 1.0)
          end if
       end do

       if( verbose ) then
          write(*,*) 'jac:',real(jac(1,:))
          write(*,*) 'jac:',real(jac(2,:))
          write(*,*) 'jac:',real(jac(3,:))
          write(*,*) 'jac:',real(jac(4,:))
          write(*,*) 'hess:',real(hess(1,:))
          write(*,*) 'hess:',real(hess(2,:))
          write(*,*) 'hess:',real(hess(3,:))
          write(*,*) 'hess:',real(hess(4,:))
       end if

    else
       dq = 0
    end if
    info = 0

666 continue

    deallocate(xdata,ydata,zdata,xsig,ysig,zsig,f,df,r)

  end subroutine rplane


  function planefun(p) result(s)

    real(dbl), dimension(:), intent(in) :: p
    real(dbl) :: s

    s = sum(abs(p(1) + p(2)*xdata + p(3)*ydata - zdata)) / size(xdata)

  end function planefun


  subroutine res(a,b,c,r)

    real(dbl), intent(in) :: a,b,c
    real(dbl), dimension(:), intent(out) :: r

    r = (zdata - (a + b*xdata + c*ydata)) / &
         sqrt(zsig**2 + b**2*xsig**2 + c**2*ysig**2 + rsig**2)

  end subroutine res


  function planelog(p)

    use oakleaf

    real(dbl), dimension(:), intent(in) :: p
    real(dbl) :: planelog
    real(dbl), dimension(:), allocatable :: r,f,ds
    real(dbl) :: a,b,c,s
    integer :: n

    n = size(xdata)
    a = p(1)
    b = p(2)
    c = p(3)
    s = p(4)

    if( s < epsilon(s) ) then
       planelog = 100*n
       return
    end if

    allocate(r(n),f(n),ds(n))

    call res(a,b,c,r)
    r = r / s
    f = ihuber(r)

    planelog = sum(f) + n*log(s)
!    write(*,'(7f10.5)') p,planelog,sum(f),n*log(s)

    deallocate(r,f,ds)

  end function planelog



  subroutine planedif(m,np,p,fvec,iflag)

    use oakleaf

    integer, intent(in) :: m,np
    integer, intent(in out) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(:), allocatable :: r,f,ds
    integer :: n
    real(dbl) :: a,b,c,s

    if( iflag == 0 ) then
!       write(*,'(6g13.5)') p
!       write(*,'(6g13.5)') fvec
       return
    end if

    n = size(xdata)
    allocate(r(n),f(n),ds(n))

    a = p(1)
    b = p(2)
    c = p(3)
    s = p(4)

    ds = sqrt(zsig**2 + b**2*xsig**2 + c**2*ysig**2 + rsig**2)
    call res(a,b,c,r)
    r = r / s
    f = huber(r)

    fvec(1) = sum(f/ds)
    fvec(2) = sum(f*(xdata + r*b*xsig**2/ds)/ds)
    fvec(3) = sum(f*(ydata + r*c*ysig**2/ds)/ds)
    fvec(4) = sum(f*r)/s - n

    fvec = - fvec / s

    deallocate(r,f,ds)

  end subroutine planedif


end module robustplane

!
!  Sky - average sky value
!
!  Copyright © 1999, 2010, 2013, 2016, 2018-9 F.Hroch (hroch@physics.muni.cz)
!  Copyright (C) 1991 P.B. Stetson, Dominon Astrophysical Observatory
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

!
!====================================================================
!
!  This source is on base of DAOPHOT II package by P.B.Stetson
!
!=======================================================================
!
! This subroutine estimates an average sky value for a picture by taking
! individual pixels scattered over the picture.  The brightness values
! are sorted, and the modal value is estimated using the MMM subroutine.
!
!               OFFICIAL DAO VERSION:  1991 April 18
!
!=======================================================================
!

module mdaosky

contains

subroutine  daosky (d, nstep, verbose, hibad, sky, skyerr, skysig)

  use oakleaf

  implicit none

  integer, intent(in) :: nstep
  logical, intent(in) :: verbose
  real, intent(in) :: hibad
  real, intent(in), dimension(:,:) :: d
  real, intent(out) :: sky, skyerr, skysig

!
! NMAX    is the maximum number of sky pixels we can deal with,
!         given the limited amount of working space.
!

  integer :: ncol, nrow, n
  real, dimension(:), allocatable :: s

  ncol = size(d,1)
  nrow = size(d,2)
!
!-----------------------------------------------------------------------
!
! The spacing between pixels that will be included in the sample is
! estimated by the ratio of the total number of pixels in the picture to
! the maximum number of pixels that can be accomodated in the vector S.
!
!  istep = max((ncol*nrow)/nmax, 1)
!
! Go through the disk file reading a row at a time and extracting every
! ISTEP-th pixel.  If ISTEP is not equal to 1, make sure that the
! starting pixel for each row is staggered.
!

  allocate(s(size(d)))
  s = pack(d(1:ncol:nstep,1:nrow:nstep), d < hibad)
  n = count(d(1:ncol:nstep,1:nrow:nstep) < hibad)

!
! Sort these values, then estimate the mode.
!

  call rmean(s(1:n),sky,skyerr,skysig)

  if( verbose ) &
       write (*,"(A,F9.1,A,F10.2)") &
       ' Approximate sky value for this frame =', sky,' +- ',skyerr

  deallocate(s)

end subroutine daosky

end module mdaosky

!
!  aperture photometry
!
!  Copyright © 2010-17 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


program aphot

  use fitsio
  use fitsaphot
  use mdaofotometr

  implicit none

  character(len=4*FLEN_FILENAME) :: record,key,val
  character(len=FLEN_FILENAME) :: outname, file,backup, output = ''
  real, dimension(:), allocatable :: apertures
  real, dimension(2) :: ring
  logical :: verbose = .false., plog = .false.
  integer :: i,eq,status,naper

  ! we predefine radii of apertures as the logarithmic spiral,
  ! pitch 9.84 deg, apertures(1) = 1, .. apertures(12) = 20
  allocate(apertures(12))
  forall( i = 1:size(apertures) )
     apertures(i) = exp(0.17338*((i-1)*1.570796327))
  end forall
  ring = (/20.0, 30.0/)

  do
     read(*,'(a)',end=20) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Improper input.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'PIPELOG' ) then

        read(val,*) plog

     else if( key == 'NAPERTURES' ) then

        read(val,*) naper
        deallocate(apertures)
        allocate(apertures(naper))

     else if( key == 'APERTURES' ) then

        read(val,*) apertures

     else if( key == 'RING' ) then

        read(val,*) ring

     else if( key == 'FILE' ) then

        read(val,*) file, backup, output

        status = 0
        call fitsback(file,backup,output,.false.,outname,status)
        call faphot(outname,apertures,ring,verbose,plog)

     end if

  end do

20 continue

  deallocate(apertures)

  stop 0

end program aphot

!
!  support for save of listing
!
!  Copyright © 2012 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!  
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!  
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.

module savetables

  use fitsio

  implicit none

  integer, parameter, private :: dbl = selected_real_kind(15)


contains

! ----

  subroutine savelc(file,backup,extname,cols,fitskeys,fitsval,aperture,equinox,&
       exposure,julday,filter,xcoo,ycoo,data)
!       year,month,day,hour,minute,sec,exposure,julday,filter,xcoo,ycoo,data)

    integer, parameter :: ntime = 2
    character(len=*), intent(in) :: file,backup,extname
    character(len=*), dimension(:), intent(in) :: fitskeys,fitsval,cols,filter
!    integer, dimension(:), intent(in) :: year,month,day,hour,minute
!    real(dbl), dimension(:), intent(in) :: sec,exposure,julday,xcoo,ycoo
    real(dbl), dimension(:), intent(in) :: exposure,julday,xcoo,ycoo
    real(dbl), dimension(:,:), intent(in) :: data
    real(dbl), intent(in) :: equinox,aperture

    character(len=80), dimension(:), allocatable :: ttype, tform, tunit
    integer :: i,nd,nrows,ntypes
    integer :: status, blocksize, frow, felem
!    character(len=80) :: tmp

    frow = 1
    felem = 1
    ntypes = ntime + size(data,2)
    allocate(ttype(ntypes),tform(ntypes),tunit(ntypes))

!    ttype(1) = 'YEAR';                tform(1) = '1J';  tunit(1) = ''
!    ttype(2) = 'MONTH';               tform(2) = '1J';  tunit(2) = ''
!    ttype(3) = 'DAY';                 tform(3) = '1J';  tunit(3) = ''
!    ttype(4) = 'HOUR';                tform(4) = '1J';  tunit(4) = ''
!    ttype(5) = 'MINUTE';              tform(5) = '1J';  tunit(5) = ''
!    ttype(6) = 'SECOND';              tform(6) = '1D';  tunit(6) = ''
!    ttype(7) = fitskeys(3);           tform(7) = '1D';  tunit(7) = 's'   ! exptime
!    ttype(8) = 'JULDAY';              tform(8) = '1D';  tunit(8) = ''   ! jd
!    ttype(9) = fitskeys(4);           tform(9) = '10A';   tunit(9) = ''   ! filter

    ttype(1) = 'TIME';              tform(1) = '1D';  tunit(1) = 'day'   ! jd
    ttype(2) = fitskeys(3);         tform(2) = '1D';  tunit(2) = 's'      ! exptime
    

    do i = 1,size(cols)
       ttype(ntime+i) = cols(i);  tform(ntime+i) = '1D';  tunit(ntime+i) = ''
    end do

    status = 0
    blocksize = 0
    nrows = size(julday)
    call fitsbackup(file,backup,status)
    call ftinit(15,file,blocksize,status)

    ! LC extension
    call ftibin(15,nrows,ntypes,ttype,tform,tunit,extname,0,status)
    
    call ftpkys(15,fitskeys(6),fitsval(6),'observed object',status)
    call ftpkys(15,fitskeys(7),fitsval(7),'observer who acquired the data',status)
    call ftpkys(15,fitskeys(8),fitsval(8),'author of the data',status)
    call ftpkys(15,fitskeys(9),fitsval(9),'name of instrument',status)
    call ftpkys(15,fitskeys(10),fitsval(10),'name of telescope',status)
    call ftpkys(15,fitskeys(11),fitsval(11),'organization responsible for the data',status)
    call ftpkys(15,fitskeys(12),fitsval(12),'bibliographic reference',status)
    call ftpkyd(15,"APAPER",aperture,5,'[deg] radius of aperture ',status)
    

    ! time info: http://dotastro.org/simpletimeseries/
    call ftpkys(15,'TIMETYPE','JD','JD,MJD,HJD,phase',status)
    call ftpkys(15,'TIMESYS','UTC','',status)
    call ftpkys(15,'TIMEREF','GEOCENTER','',status)
    call ftpkys(15,'TIMESTMP','MIDPOINT','time stamp = MIDPOINT,BEGIN,END',status)
    ! implement via parameters ?
!    call ftpkyd(15,'TIMEERR',epsilon(1.0_dbl),16,'Uncertainty in the time measurement',status)
!    call ftpkyd(15,'TIMERES',epsilon(1.0_dbl),16,'Resolution in the time measurement',status)
    

    ! band
    call ftpkys(15,fitskeys(4),filter,'spectral band',status)
    
    call ftpcom(15,'Munipack VERSION, (C)1997-2012 F. Hroch <hroch@physics.muni.cz>',status)
    


!    call ftpclj(15,1,frow,felem,nrows,year,status)
!    call ftpclj(15,2,frow,felem,nrows,month,status)
!    call ftpclj(15,3,frow,felem,nrows,day,status)
!    call ftpclj(15,4,frow,felem,nrows,hour,status)
!    call ftpclj(15,5,frow,felem,nrows,minute,status)
!    call ftpcld(15,6,frow,felem,nrows,sec,status)
!    call ftpcld(15,7,frow,felem,nrows,exposure,status)
!    call ftpcld(15,8,frow,felem,nrows,julday,status)
!    call ftpcls(15,9,frow,felem,nrows,filter,status)

    call ftpcld(15,1,frow,felem,nrows,julday,status)
    call ftpcld(15,2,frow,felem,nrows,exposure,status)

    nd = size(data,2)
    do i = 1,nd
       call ftpcld(15,ntime+i,frow,felem,nrows,data(:,i),status)
    end do
    deallocate(ttype,tform,tunit)


    ! OBJECT extension
    nrows = size(xcoo)
    ntypes = 2
    allocate(ttype(ntypes),tform(ntypes),tunit(ntypes))
    tform = '1D'
    tunit = 'deg'
    ttype(1) = FITS_COL_RA
    ttype(2) = FITS_COL_DEC
    
    call ftibin(15,nrows,ntypes,ttype,tform,tunit,trim(extname)//'CAT',0,status)
    call ftpkys(15,FITS_KEY_REFRAME,'ICRS','reference celestial coordinate system',status)
!    call ftpkyd(15,"EQUINOX",equinox,5,'equinox of celestial coordinate system',status)
    call ftpcld(15,1,frow,felem,nrows,xcoo,status)
    call ftpcld(15,2,frow,felem,nrows,ycoo,status)

    deallocate(ttype,tform,tunit)

    call ftclos(15,status)
    call ftrprt('STDERR',status)


  end subroutine savelc

! ----

  subroutine savecat(file,backup,extname,dtext,fitskeys,fitsval,&
       dateobs,filter,exptime,aperture,equinox,a,d,data)

    character(len=*), intent(in) :: file,backup,extname,dateobs,filter
    character(len=*), dimension(:), intent(in) :: fitskeys,fitsval,dtext
    real(dbl), dimension(:), intent(in) :: a,d
    real(dbl), dimension(:,:), intent(in) :: data
    real(dbl), intent(in) :: exptime, equinox, aperture

    character(len=80), dimension(:), allocatable :: ttype, tform, tunit
    integer :: i,nd,ntypes,nrows
    integer :: status, blocksize, frow, felem

    frow = 1
    felem = 1
    ntypes = 2 + size(dtext)
    allocate(ttype(ntypes),tform(ntypes),tunit(ntypes))
    tform = '1D'
    tunit = 'deg'
    ttype = (/ FITS_COL_RA, FITS_COL_DEC /)
    do i = 1,size(dtext)
       ttype(2+i) = dtext(i);       tform(2+i) = '1D';  tunit(2+i) = ''
    end do

    status = 0
    blocksize = 0
    nrows = size(a)
    call fitsbackup(file,backup,status)
    call ftinit(15,file,blocksize,status)
    call ftibin(15,nrows,ntypes,ttype,tform,tunit,extname,0,status)
    
    call ftpkyd(15,"APAPER",aperture,5,'[deg] radius of aperture photometry',status)
!    call ftpkyd(15,"EQUINOX",equinox,5,'equinox of celestial coordinate system',status)
    call ftpkys(15,fitskeys(1),dateobs,'exposure start',status)
    call ftpkyd(15,fitskeys(3),exptime,-3,'[sec] exposure time',status)
    call ftpkys(15,fitskeys(4),filter,'filter',status)
    call ftpkys(15,fitskeys(6),fitsval(6),'observed object',status)
    call ftpkys(15,fitskeys(7),fitsval(7),'observer who acquired the data',status)
    call ftpkys(15,fitskeys(8),fitsval(8),'author of the data',status)
    call ftpkys(15,fitskeys(9),fitsval(9),'name of instrument',status)
    call ftpkys(15,fitskeys(10),fitsval(10),'name of telescope',status)
    call ftpkys(15,fitskeys(11),fitsval(11),'organization responsible for the data',status)
    call ftpkys(15,fitskeys(12),fitsval(12),'bibliographic reference',status)

    call ftpcld(15,1,frow,felem,nrows,a,status)
    call ftpcld(15,2,frow,felem,nrows,d,status)
    nd = size(data,2)
    do i = 1,nd
       call ftpcld(15,2+i,frow,felem,nrows,data(:,i),status)
    end do

    call ftclos(15,status)
    call ftrprt('STDERR',status)

    deallocate(ttype,tform,tunit)

  end subroutine savecat


end module savetables

!
!  Fortran 2008+ interface for (c)FITSIO library
!  This module provides some high-level convenience functions.
!
!  Copyright © 2020-2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!


module fitsio_mmviii

  use fitsio
  use iso_fortran_env
  implicit none


  interface fits_read_image
     module procedure fits_read_image_chr, fits_read_image_int, &
          fits_read_image_flt, fits_read_image_dbl
  end interface fits_read_image

  interface fits_write_image
     module procedure fits_write_image_chr, fits_write_image_int, &
          fits_write_image_flt, fits_write_image_dbl
  end interface fits_write_image

  interface fits_read_cube
     module procedure fits_read_cube_chr, fits_read_cube_int, &
          fits_read_cube_flt, fits_read_cube_dbl
  end interface fits_read_cube

  interface fits_write_cube
     module procedure fits_write_cube_chr, fits_write_cube_int, &
          fits_write_cube_flt, fits_write_cube_dbl
  end interface fits_write_cube


  private :: init_seed

contains


  ! Convenience functions

  subroutine fits_insert_image(fitsfile,bitpix,naxis,naxes,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: bitpix, naxis
    integer, dimension(:), intent(in) :: naxes
    integer, intent(in out) :: status

    call fits_insert_img(fitsfile,bitpix,naxis,naxes,status)

    ! the image is scaled to the appropriate numerical range by default
    if( bitpix > 0 ) then
       call fits_write_key(fitsfile,'BSCALE',1,'',status)

       if( bitpix == 32 ) then
          call fits_write_key(fitsfile,'BZERO',huge(bitpix),'',status)
       else
          call fits_write_key(fitsfile,'BZERO',2**(bitpix-1),'',status)
       end if
    endif

  end subroutine fits_insert_image

  subroutine fits_get_image_size(fitsfile,naxes,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, dimension(:), intent(out) :: naxes
    integer, intent(in out) :: status

    call fits_get_img_size(fitsfile,size(naxes),naxes,status)

  end subroutine fits_get_image_size

  subroutine fits_read_image_int(fitsfile,group,nullval,image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    integer, intent(in) :: nullval
    integer, dimension(:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer :: dim1, naxis1, naxis2

    dim1 = size(image,1)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    call fits_read_2d_int(fitsfile,group,nullval,dim1,naxis1,naxis2, &
         image,anyf,status)

  end subroutine fits_read_image_int

  subroutine fits_read_image_chr(fitsfile,group,nullval,image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    character, intent(in) :: nullval
    character, dimension(:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer :: dim1, naxis1, naxis2

    dim1 = size(image,1)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    call fits_read_2d_chr(fitsfile,group,nullval,dim1,naxis1,naxis2, &
         image,anyf,status)

  end subroutine fits_read_image_chr

  subroutine fits_read_image_flt(fitsfile,group,nullval,image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    real(REAL32), intent(in) :: nullval
    real(REAL32), dimension(:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer :: dim1, naxis1, naxis2

    dim1 = size(image,1)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    call fits_read_2d_flt(fitsfile,group,nullval,dim1,naxis1,naxis2, &
         image,anyf,status)

  end subroutine fits_read_image_flt

  subroutine fits_read_image_dbl(fitsfile,group,nullval,image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    real(REAL64), intent(in) :: nullval
    real(REAL64), dimension(:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer :: dim1, naxis1, naxis2

    dim1 = size(image,1)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    call fits_read_2d_dbl(fitsfile,group,nullval,dim1,naxis1,naxis2, &
         image,anyf,status)

  end subroutine fits_read_image_dbl

  subroutine fits_write_image_chr(fitsfile,group,image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    character, dimension(:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer :: dim1, naxis1, naxis2

    dim1 = size(image,1)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    call fits_write_2d_chr(fitsfile,group,dim1,naxis1,naxis2,image,status)

  end subroutine fits_write_image_chr

  subroutine fits_write_image_int(fitsfile,group,image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    integer, dimension(:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer :: dim1, naxis1, naxis2

    dim1 = size(image,1)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    call fits_write_2d_int(fitsfile,group,dim1,naxis1,naxis2,image,status)

  end subroutine fits_write_image_int

  subroutine fits_write_image_flt(fitsfile,group,image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    real(REAL32), dimension(:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer :: dim1, naxis1, naxis2

    dim1 = size(image,1)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    call fits_write_2d_flt(fitsfile,group,dim1,naxis1,naxis2,image,status)

  end subroutine fits_write_image_flt

  subroutine fits_write_image_dbl(fitsfile,group,image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    real(REAL64), dimension(:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer :: dim1, naxis1, naxis2

    dim1 = size(image,1)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    call fits_write_2d_dbl(fitsfile,group,dim1,naxis1,naxis2,image,status)

  end subroutine fits_write_image_dbl


  subroutine fits_read_cube_chr(fitsfile,group,nullval,image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    character, intent(in) :: nullval
    character, dimension(:,:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer :: dim1, dim2, naxis1, naxis2, naxis3

    dim1 = size(image,1)
    dim2 = size(image,2)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    naxis3 = size(image,3)
    call fits_read_3d_chr(fitsfile,group,nullval,dim1,dim2,naxis1,naxis2,naxis3,&
         image,anyf,status)

  end subroutine fits_read_cube_chr

  subroutine fits_read_cube_int(fitsfile,group,nullval,image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    integer, intent(in) :: nullval
    integer, dimension(:,:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer :: dim1, dim2, naxis1, naxis2, naxis3

    dim1 = size(image,1)
    dim2 = size(image,2)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    naxis3 = size(image,3)
    call fits_read_3d_int(fitsfile,group,nullval,dim1,dim2,naxis1,naxis2,naxis3,&
         image,anyf,status)

  end subroutine fits_read_cube_int

  subroutine fits_read_cube_flt(fitsfile,group,nullval,image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    real(REAL32), intent(in) :: nullval
    real(REAL32), dimension(:,:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer :: dim1, dim2, naxis1, naxis2, naxis3

    dim1 = size(image,1)
    dim2 = size(image,2)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    naxis3 = size(image,3)
    call fits_read_3d_flt(fitsfile,group,nullval,dim1,dim2,naxis1,naxis2,naxis3,&
         image,anyf,status)

  end subroutine fits_read_cube_flt

  subroutine fits_read_cube_dbl(fitsfile,group,nullval,image,anyf,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    real(REAL64), intent(in) :: nullval
    real(REAL64), dimension(:,:,:), intent(out) :: image
    logical, intent(out) :: anyf
    integer, intent(in out) :: status

    integer :: dim1, dim2, naxis1, naxis2, naxis3

    dim1 = size(image,1)
    dim2 = size(image,2)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    naxis3 = size(image,3)
    call fits_read_3d_dbl(fitsfile,group,nullval,dim1,dim2,naxis1,naxis2,naxis3,&
         image,anyf,status)

  end subroutine fits_read_cube_dbl

  subroutine fits_write_cube_chr(fitsfile,group,image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    character, dimension(:,:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer :: dim1, dim2, naxis1, naxis2, naxis3

    dim1 = size(image,1)
    dim2 = size(image,2)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    naxis3 = size(image,3)
    call fits_write_3d_chr(fitsfile,group,dim1,dim2,naxis1,naxis2,naxis3, &
         image,status)

  end subroutine fits_write_cube_chr

  subroutine fits_write_cube_int(fitsfile,group,image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    integer, dimension(:,:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer :: dim1, dim2, naxis1, naxis2, naxis3

    dim1 = size(image,1)
    dim2 = size(image,2)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    naxis3 = size(image,3)
    call fits_write_3d_int(fitsfile,group,dim1,dim2,naxis1,naxis2,naxis3, &
         image,status)

  end subroutine fits_write_cube_int

  subroutine fits_write_cube_flt(fitsfile,group,image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    real(REAL32), dimension(:,:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer :: dim1, dim2, naxis1, naxis2, naxis3

    dim1 = size(image,1)
    dim2 = size(image,2)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    naxis3 = size(image,3)
    call fits_write_3d_flt(fitsfile,group,dim1,dim2,naxis1,naxis2,naxis3, &
         image,status)

  end subroutine fits_write_cube_flt

  subroutine fits_write_cube_dbl(fitsfile,group,image,status)

    type(fitsfiles), intent(in) :: fitsfile
    integer, intent(in) :: group
    real(REAL64), dimension(:,:,:), intent(in) :: image
    integer, intent(in out) :: status

    integer :: dim1, dim2, naxis1, naxis2, naxis3

    dim1 = size(image,1)
    dim2 = size(image,2)
    naxis1 = size(image,1)
    naxis2 = size(image,2)
    naxis3 = size(image,3)
    call fits_write_3d_dbl(fitsfile,group,dim1,dim2,naxis1,naxis2,naxis3, &
         image,status)

  end subroutine fits_write_cube_dbl


  ! FITS file handling routines

  function fits_file_exist(filename) result(exist)

    character(len=*), intent(in) :: filename
    logical :: exist

    integer :: status
    type(fitsfiles) :: fitsfile

    status = 0
    call ftpmrk
    call fits_open_file(fitsfile,filename,FITS_READONLY,status)
    exist = status == 0
    call fits_close_file(fitsfile,status)
    call ftcmrk

  end function fits_file_exist

  subroutine fits_file_copy(source,destination,status)

    character(len=*), intent(in) :: source,destination
    integer, intent(in out) :: status

    type(fitsfiles) :: src,dst

    call fits_open_file(src,source,FITS_READONLY,status)
    call fits_create_file(dst,destination,status)
    call fits_copy_file(src,dst,1,1,1,status)
    call fits_close_file(src,status)
    if( status == 0 ) then
       call fits_close_file(dst,status)
    else
       call fits_delete_file(dst,status)
    end if
!    call fits_report_error(error_unit,status)

  end subroutine fits_file_copy

  subroutine fits_file_duplicate(fitsfile,destination,status)

    type(fitsfiles), intent(out) :: fitsfile
    character(len=*), intent(in) :: destination
    integer, intent(in out) :: status

    type(fitsfiles) :: dst

    call fits_create_file(dst,destination,status)
    call fits_copy_file(fitsfile,dst,1,1,1,status)
    if( status == 0 ) then
       call fits_close_file(dst,status)
    else
       call fits_delete_file(dst,status)
    end if

  end subroutine fits_file_duplicate

  subroutine fits_precopy_file(fitsfile,source,destination,rwmode,overwrite,status)

    type(fitsfiles), intent(out) :: fitsfile
    character(len=*), intent(in) :: source,destination
    integer, intent(in) :: rwmode
    logical, intent(in) :: overwrite
    integer, intent(in out) :: status

    type(fitsfiles) :: fits

    call fits_open_file(fits,source,FITS_READONLY,status)
    if( fits_file_exist(destination) .and. overwrite ) &
         call fits_file_delete(destination)
    call fits_file_duplicate(fits,destination,status)
    call fits_close_file(fits,status)
    call fits_open_file(fitsfile,destination,rwmode,status)

  end subroutine fits_precopy_file

  subroutine fits_file_delete(filename)

    character(len=*), intent(in) :: filename
    integer :: unit, iostat
    character(len=80) :: msg

    open(newunit=unit,file=filename,status='old',iostat=iostat,iomsg=msg)
    if( iostat == 0 ) then
       close(unit,status='DELETE')
    else
       write(error_unit,*) 'fits_file_delete: ',trim(msg)
    end if

  end subroutine fits_file_delete

  subroutine fits_create_scratch(fitsfile,status)

    type(fitsfiles), intent(out) :: fitsfile
    integer, intent(in out) :: status

    real :: x
    character(len=33) :: scratch

    call init_seed
    do
       call random_number(x)
       write(scratch,'(a,i0,a)') 'fits_scratch_',int(1e9*x),'.fits'

       status = 0
       call fits_create_file(fitsfile,scratch,status)
       if( status == 0 ) return
       if( status == FITS_FILE_NOT_CREATED ) status = 0
       if( status /= 0 ) return
    end do

  end subroutine fits_create_scratch

  subroutine init_seed

    integer, dimension(:), allocatable :: seed
    integer, dimension(8) :: values
    integer :: n

    call date_and_time(values=values)
    call random_seed(size=n)
    allocate(seed(n))
    seed = 6 ! the devil's seed
    n = min(size(seed),size(values))
    seed(1:n) = values(1:n)
    call random_seed(put=seed)
    deallocate(seed)

  end subroutine init_seed


end module fitsio_mmviii

!
! absfit - fitting absolute deviations
!
!
! Copyright © 2011-2, 2015-8 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module absfit

  use astrotrafo
  use iso_fortran_env

  implicit none

  logical, private :: debug = .true.
  integer, parameter, private :: dbl = selected_real_kind(15)
  real(dbl), parameter, private :: rad = 57.295779513082322865_dbl
  real(dbl), dimension(:), allocatable, private :: x,y,u,v
  real(dbl), private :: refl, xcen, ycen
  integer, private :: ndat

  private :: medfun

contains


  function medfun(p)

    ! This function computes mean Manhattan metrics (sum of absolute values)
    ! per point: http://en.wikipedia.org/wiki/Taxicab_geometry

    real(dbl) :: medfun
    real(dbl), dimension(:), intent(in) :: p
    type(AstroTrafoProj) :: t
    real(dbl) :: uu,vv
    integer :: i

    call trafo_init(t,xcen=xcen,ycen=ycen, &
         ucen=p(1),vcen=p(2),scale=p(3),rot=p(4),refl=refl)

    medfun = 0.0_dbl
    do i = 1, ndat
       call invaffine(t,x(i),y(i),uu,vv)
       medfun = medfun + abs(u(i) - uu) + abs(v(i) - vv)
    end do
    medfun = medfun / (2*ndat)

  end function medfun


  subroutine  absmin(type,a,d,xc,yc,xx,yy,acen,dcen,sc,dsc,rot,drot,xrefl, &
       xoff,dxoff,yoff,dyoff,mad,verbose)

    use NelderMead

    character(len=*),intent(in) :: type
    real(dbl),intent(in) :: xc,yc
    real(dbl),dimension(:),intent(in) :: a,d,xx,yy
    real(dbl),intent(inout) :: acen,dcen,sc,dsc,rot,drot
    real(dbl),intent(out) :: mad
    real(dbl),intent(in) :: xrefl,xoff,dxoff,yoff,dyoff
    logical, intent(in) :: verbose

    real(dbl), parameter :: sqreps = sqrt(epsilon(mad))
    real(dbl), parameter :: reqmin = epsilon(mad)
    integer, parameter :: npar = 4

    real(dbl),dimension(npar) :: p,p0,dp ! = [x0, y0, sc, rot]
    real(dbl) :: uu,vv,dd
    integer :: iter,icount, numres, ifault, i, nra, ndec
    type(AstroTrafoProj) :: t,ti

    if( size(a) < 1 ) stop 'Absfit: no star available.'

    if(verbose) write(error_unit,*) "=== Absolute deviations fitting ==="

    debug = verbose
    xcen = xc
    ycen = yc

    ! x,y,u,v arrays are a common working arrays for both absmin and medfun !!
    ndat = size(a)
    allocate(x(ndat),y(ndat),u(ndat),v(ndat))

    ! origin of rectangular coordinates is moved to the center of frame
    ! because that's point the frame is rotated around
    x = xx
    y = yy

    call trafo_init(t,type,acen,dcen)
    call proj(t,a,d,u,v)

    p = [ xoff, yoff, sc, rot ]
    dd = 0.1*sc ! star centroids are usually located with the precision 0.1 pix
    dp = [ max(dxoff,dd), max(dyoff,dd), dsc, drot ]
    refl = xrefl

    if( debug ) write(error_unit,'(a)') &
         '# ifault   mad     acen         dcen       offset[pix]    s[pix/deg] rot[deg]'

    do iter = 1, precision(p)

       ! estimate transformation by minimizing of absolute deviations
       p0 = p
       dp = max(dp,sqreps)

       call nelmin(medfun,npar,p0,p,mad,reqmin,dp,1,9999,icount,numres,ifault)
       ! a typical run needs about one thousand of medfun calls
       ! ifault=0 means convergence, 2 means slow convergence

       if( debug ) write(error_unit,'(2i2,es10.2,2f11.5,2g11.2,f10.1,f7.1)') &
            iter,ifault,mad,acen,dcen,p(1:2)/p(3),1/p(3),p(4)

       ! iterations couldn't make further progress, with precision 1/10 [pix]
       if( iter > 1 .and. all(abs(p(1:2)/p(3)) < 0.1) ) exit

       ! update center of projection and projected coordinates
       call trafo_init(ti,type,acen=acen,dcen=dcen, &
            xcen=xcen,ycen=ycen,scale=p(3),rot=p(4),refl=refl)
       call invproj(ti,p(1),p(2),acen,dcen)
       call trafo_init(t,type,acen,dcen)
       call proj(t,a,d,u,v)
       p(1:2) = 0.0_dbl

    end do

    rot = p(4)
    sc = 1.0_dbl / p(3)

    if( debug ) then
       nra = 0
       ndec = 0
       call trafo_init(t,xcen=xcen,ycen=ycen,scale=p(3),rot=p(4),refl=refl)
       do i = 1, ndat
          call invaffine(t,x(i),y(i),uu,vv)
          if( uu - u(i) > 0 ) nra  = nra + 1
          if( vv - v(i) > 0 ) ndec = ndec + 1
       end do
       write(error_unit,'(a,i7,"/",f0.1,2(i5,"+-",f0.1))') &
            '# absfit sign test (total/expected, RA+, Dec+): ',&
            ndat,ndat/2.0,nra,sqrt(nra*0.25),ndec,sqrt(ndec*0.25)
       write(error_unit,'(a,en12.2,en13.3,f8.1,2f11.5,f5.1)') &
            "# absfit final:",mad,sc,rot,acen,dcen,refl
    end if

    deallocate(x,y,u,v)

  end subroutine absmin

end module absfit

!
!  Medians - common methods
!
!  Copyright © 2016-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

! Medians:
! * qmed - quick-median
! * xmed - median of sorted array on base of select sort (slow ~n**2)
! * median -  general median on base of quicksort (fast ~n*log(n))

module medians

  implicit none

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)

  interface median
     module procedure median_double, median_single
  end interface median

contains

  function qmedian(b)

    real(dbl) :: qmedian
    real(dbl),dimension(:),intent(in) :: b
    integer :: n, nmed

    n = size(b)
    nmed = min(n/2+1,n)

    ! this is right just only for odd-th elements of the sequence,
    ! we're ignore the right way, having huge dataset, n > 50

    qmedian = qmed(b,nmed)

  end function qmedian


  ! Quick median by Wirth: Algorith + data structures = programs
  ! fastest known median algorithm ~2*n

  function qmed(b,k) result(x)

    integer, intent(in) :: k
    real(dbl),dimension(:),intent(in) :: b
    real(dbl),dimension(:),allocatable :: a
    real(dbl) :: w,x
    integer :: n,l,r,i,j

    n = size(b)
    allocate(a(n))
    a = b

    l = 1
    r = n
    do while( l < r )
       x = a(k)
       i = l
       j = r
       do
          do while( a(i) < x )
             i = i + 1
          enddo
          do while( x < a(j) )
             j = j - 1
          enddo
          if( i <= j ) then
             w = a(i)
             a(i) = a(j)
             a(j) = w
             i = i + 1
             j = j - 1
          endif
          if( i > j ) exit
       enddo
       if( j < k ) l = i
       if( k < i ) r = j
    enddo
    deallocate(a)

  end function qmed


  ! computes median from pre-sorted array
  ! prefered for a few elements ~n*log(n)

  function xmed(b)

    use selectsort

    real(dbl),dimension(:),intent(in) :: b
    real(dbl) :: xmed
    real(dbl),dimension(:),allocatable :: a
    integer :: n

    n = size(b)

    if( n == 0 ) then
       xmed = 0.0_dbl
       return
    end if

    if( n == 1 ) then
       xmed = b(1)
       return
    end if

    allocate(a(n))
    a = b
    call ssort(a)

    xmed = (a((n+1)/2) + a(n/2)) / 2.0_dbl

    deallocate(a)

  end function xmed


  ! General medians on base of quicksort

  function median_double(x) result(median)

    use quicksort

    real(dbl), dimension(:), intent(in) :: x
    real(dbl) :: median
    integer :: n, n2
    real(dbl), dimension(:), allocatable :: y

    n = size(x)
    allocate(y(n))
    y = x
    call qsort(y)

    n2 = n / 2
    if( mod(n,2) == 0 ) then
       ! even
       median = (y(n2+1) + y(n2))/2.0_dbl
    else
       ! odd
       median = y(n2)
    end if

    deallocate(y)

  end function median_double


  function median_single(x) result(median)

    use quicksort

    real, dimension(:), intent(in) :: x
    real :: median
    integer :: n, n2
    real(dbl), dimension(:), allocatable :: y

    n = size(x)
    allocate(y(n))
    y = x
    call qsort(y)

    n2 = n / 2
    if( mod(n,2) == 0 ) then
       ! even
       median = real((y(n2+1) + y(n2))/2.0)
    else
       ! odd
       median = real(y(n2))
    end if

    deallocate(y)

  end function median_single


end module medians

!
!     PHOTOMETRY, aperture photometry
!     Copyright (C) 1997-9,2010,2013-17 Filip Hroch, Masaryk University
!     Copyright (C) 1991 P.B. Stetson, Dominon Astrophysical Observatory
!
!
!  This file is part of Munipack.
!
!  Credits
!
!    Almost all this source is authored by P. B. Stetson.
!    I adapted it for Fortran 90 (allocatable arrays, precision,
!    array syntax), corrected errors, improve sky estimate by
!    variance stabilising estimator.
!
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!
!===================================================================
!

module mdaofotometr

contains

subroutine  daophotsb (d, stderr,xstar,ystar,hstar,raper,ring,lobad,hibad,phpadu, &
     verbose,plog,apcts,apcts_err,xsky,xsky_err,status)

!watch, coofil, magfil)
  use iso_fortran_env
  use robustmean
  use weightedmean
  use medians

  implicit none

  real, dimension(:,:), intent(in) :: d,stderr
  real, dimension(:), intent(in) :: xstar, ystar, hstar, raper,ring
  real, dimension(:,:), intent(out) :: apcts,apcts_err
  real, dimension(:), intent(out) :: xsky,xsky_err
  real, intent(in) :: lobad, hibad, phpadu
  logical, intent(in) :: verbose, plog
  integer, intent(out) :: status

!
!=======================================================================
!
! This subroutine derives the concentric aperture photometry.  At
! present, this is the only place in all of DAOPHOT where sky values
! are derived for the individual stars.
!
!               OFFICIAL DAO VERSION:  1991 April 18
!
! Argument
!
!    WATCH (INPUT) governs whether information relating to the progress
!          of the reductions is to be typed on the terminal screen
!          during execution.
!
!=======================================================================
!
!!!  implicit none
!!!  integer :: ncol, nrow
!!!  real :: d(ncol, nrow)
  integer, parameter :: precision = selected_real_kind(14)

  integer, parameter  :: minsky = 20!, maxap = 12
  real, parameter :: pi = 3.141592653589793115997963

!!!  character(len=*) :: coofil, magfil
!
! Parameters:
!
! MINSKY is the smallest number of pixels from which the sky may be
!        determined.  If for some star the number of sky pixels
!        is less than MINSKY, an error code will result and
!        control will return to the main program.
!
! MAXSKY the maximum number of pixels allowed in the sky annulus.
!        This and the user's requested inner sky radius will later
!        determine the maximum permitted outer sky radius.
!
! MAXAP  the maximum number of star apertures allowed.
!
  real(precision) :: maglim, magsq, wt, sumwt
  real(precision) :: apmag(size(raper)), area(size(raper)), sdev(size(raper))
!!!  real(precision) :: apmag(maxap), area(maxap)
  real, dimension(:), allocatable :: sky, dsky
  real :: error(3), magerr(size(raper)) !magerr(maxap)
!!!  real :: par(maxap+2) = 0.0
!!!  real :: pmin(maxap+2) = tiny(0.0)
!!!  real :: pmax(maxap+2) = huge(1.0)
!!!  real :: lobad, skymod, skysig, skyskw, sigsq, skyvar, skymn, skymed
  real :: skymod, skysig, skyskw, sigsq, skyvar, skyerr!, skymn, skymed
  real :: datum, r, rsq, fractn, edge!, thresh!, dum
!!!  real :: datum, r, rsq, fractn, edge, hibad, thresh, dum
  real :: readns, xc, yc, dmag, apmxsq
!!!  real :: phpadu, readns, xc, yc, dmag, watch, apmxsq
  real :: rinsq, rout, routsq, dysq
!  integer :: i, j, k, l, n, naper, idum, nmag, lx, ly, nx, ny
  integer :: i, j, k, n, naper, nmag, lx, ly, nx, ny
!  integer :: istar, mx, my, nsky, nl, maxsky, ncol, nrow
  integer :: istar, mx, my, nsky, maxsky, ncol, nrow
  logical :: reliable

  status = 0

!!!  character(len=10) :: table = 'mphoto.opt'
!!!  character(len=26) :: lbl(maxap+2) = (/ &
!!!              ' A1  RADIUS OF APERTURE  1',  &
!!!              ' A2  RADIUS OF APERTURE  2',   &
!!!              ' A3  RADIUS OF APERTURE  3',   &
!!!              ' A4  RADIUS OF APERTURE  4',   &
!!!              ' A5  RADIUS OF APERTURE  5',   &
!!!              ' A6  RADIUS OF APERTURE  6',   &
!!!              ' A7  RADIUS OF APERTURE  7',   &
!!!              ' A8  RADIUS OF APERTURE  8',   &
!!!              ' A9  RADIUS OF APERTURE  9',   &
!!!              ' AA  RADIUS OF APERTURE 10',   &
!!!              ' AB  RADIUS OF APERTURE 11',   &
!!!              ' AC  RADIUS OF APERTURE 12',   &
!!!              ' IS       INNER SKY RADIUS',   &
!!!              ' OS       OUTER SKY RADIUS'/)
!!!!

  ncol = size(d,1)
  nrow = size(d,2)
!  watch = 0.0
  skyskw = 0.0

!-----------------------------------------------------------------------
!
! SECTION 1
!
! Ascertain the name of the aperture photometry parameter table, and
! read it in.  Then set up all necessary variables for the forthcoming
! reductions. Finally, identify and open the input and output files.
!
!!!  l = maxap + 1
!!!  pmin(l) = 1.0
!!!
!!!  call getopt(table, maxap+2, par, pmin, pmax, istat)
!!!  if( istat /= 0 )then
!!!     write(*,*) 'Error during read apertures radii. Using following values: '
!!!     do i = 1, maxap + 2
!!!        write(*,"(a,f10.2)") lbl(i),par(i)
!!!     enddo
!!!  endif
!!!
!!!! check apertures?

!
! Count up the number of apertures that will be used.  The first zero or
! negative number encountered terminates the list.
!
!!!  naper = maxap
!!!  apmxsq = -1.0
!!!  do  i = 1, maxap
!!!     if (par(i) <= 0.0 ) then
!!!        naper = i - 1
!!!        exit
!!!     endif
!!!     apmxsq = max(apmxsq, (par(i)+0.5)**2)
!!!  enddo
!!!
  naper = size(raper)
  apmxsq = -1.0
  do i = 1, naper
     apmxsq = max(apmxsq, (raper(i)+0.5)**2)
  end do

!
! sky buffer allocation
!
!!!  maxsky = int(max(Pi*((par(maxap+2)+1)**2 - par(maxap+1)**2),1.5))
!!!  allocate(sky(maxsky))

  maxsky = int(max(pi*((ring(2)+1)**2 - ring(1)**2),1.5))
  allocate(sky(maxsky),dsky(maxsky))

!
! NAPER   is the number of apertures, whose radii are stored in
!         elements 1 through NAPER of the array PAR.
!
! APMXSQ  is the outermost edge of the largest aperture-- if the
!         distance squared of the center of a pixel from the centroid of
!         the star is greater than APMXSQ, then we know that no part
!         of the pixel is to be included in any aperture.
!
! Now define the other variables whose values are in the table.
!
!!!  rinsq = max(par(maxap + 1), 0.0)**2      ! Inner sky radius squared
  rinsq = max(ring(1), 0.0)**2      ! Inner sky radius squared
!!$  routsq = maxsky/pi + rinsq
!!$!!!  dum = par(maxap + 2)**2
!!$  dum = ring(2)**2
!!$  if (dum > routsq) then
!!$!!!    call stupid('   *** You have specified too big a sky annulus. ***')
!!$     write (error_unit,"(F10.2,A)") sqrt(routsq), &
!!$          ' pixels is the largest outer sky radius currently permitted.'
!!$     write (error_unit,*) '   *** You have specified too big a sky annulus. ***'
!!$     goto 666
!!$  else if (dum <= rinsq) then
!!$!!!     call stupid ('Your outer sky radius is no bigger than the inner radius.')
!!$!     write (error_unit,*) ' Please try again.'
!!$     write (error_unit,*) 'Your outer sky radius is no bigger than the inner radius.'
!!$     goto 666
!!$!     return
!!$  else
!!$  !!!   rout = par(maxap + 2)
!!$     rout = ring(2)
!!$     routsq = dum
!!$  end if
  rout = ring(2)
  routsq = ring(2)**2

!
! Inquire the name of the input data file with the stellar positions,
! and open it.
!
!!!  call infile (2, coofil, istat)
!!!  if (istat /= 0) then
!!!     call stupid ('Error opening input file '//coofil)
!!!     return
!!!  end if
!!!  call rdhead(2, nl, idum, idum, lobad, hibad, thresh, dum, phpadu, readns, dum)
!!!  if (nl < 1) nl = 1
!!!!
! Inquire file name for output aperture photometry results, and open
! the new file.
!
!!!  call outfil (3, magfil, istat)
!!!  if (istat /= 0) then
!!!     call stupid ('Error opening output file '//magfil)
!!!     return
!!!  end if
!!!  call wrhead (3, 2, ncol, nrow, 6, lobad, hibad, thresh, par(1), phpadu, readns, 0.)
!!!  readns = readns**2

! readns is unused ?????


!!!!
! If progress is being monitored, type out column headers.
!
!  if (watch > 0.5) &
  if( verbose ) &
       write (*,"(/13X, 'STAR', 5X, 'X', 7X, 'Y', 9X, 'MAG.(1)', 8X, 'SKY')")
!
! Initialize variables for the computation of the magnitude limit.
!
  maglim = 0.0
  magsq = 0.0
  sumwt = 0.0
  nmag = 0
!
!-----------------------------------------------------------------------
!
! SECTION 2
!
! Derive aperture photometry object by object.
!
! Get the coordinates of next object to be measured.
!
  lx = 1
  ly = 1
  nx = ncol
  ny = nrow

  do n = 1, size(xstar)

     xc = xstar(n)
     yc = ystar(n)
     dmag = -2.5*log10(hstar(n))
     istar = n

!!!!     call rdstar (2, nl, istar, xc, yc, dmag, dum)
!!!!     if (istar < 0) exit
!      if (istar == 0) go to 2000
!
! Compute the limits of the submatrix.
!
     lx = max(1, int(xc-rout)+1)
     mx = min(ncol, int(xc+rout))
     ly = max(1, int(yc-rout)+1)
     my = min(nrow, int(yc+rout))
     edge = min(xc-0.5, (ncol+0.5)-xc, yc-0.5, (nrow+0.5)-yc)
!     write(*,*) lx,mx,ly,my,edge,xc,rout,lobad,hibad
!
! EDGE is the distance of the star's centroid from the outermost
! extremum of the array.
!
! Initialize star counts and aperture area.
!
     do  i = 1, naper
        apmag(i) = 0.0
!
! If this star aperture extends outside the array, the magnitude
! in this aperture will be no good.
!
!!!!        if (edge < par(i)) apmag(i) = - huge(1.0)! Null magnitude
        if (edge < raper(i)) apmag(i) = - huge(1.0)  ! Null magnitude
        area(i) = 0.0
     enddo
     sdev = 0
!
! Now read through the submatrix, picking out the data we want.
!
     nsky = 0
!
     do  j = ly, my
        dysq = (j - yc)**2
!
        do i = lx,mx
           rsq = dysq + (i - xc)**2
           datum = d(i,j)
!
! Is this pixel within the sky annulus?
!
!           write(*,*) rsq,rinsq,routsq,datum,lobad,hibad
           if ( .not.((rsq < rinsq) .or. (rsq > routsq) .or. &
                (nsky > maxsky) .or. (datum < lobad) .or. &
                (datum > hibad))) then
              nsky = nsky + 1
              sky(nsky) = datum
              dsky(nsky) = stderr(i,j)
           endif
!
! The inclusion of partial pixels inside the aperture is done as
! follows:  if the distance of the center of the current pixel from the
! centroid of the star [radius vector r(i,j)] is exactly equal to the
! radius of the aperture [R(k)], then one-half of the counts in the
! pixel are included.  If r(i,j) < R(k)-0.5, then the entire pixel is
! included, while if r(i,j) > R(k)+0.5, the pixel is wholly excluded.
! In between, viz. for  R(k)-0.5 < r(i,j) < R(k)+0.5, the fraction of
! the counts included varies linearly.  Therefore a circular aperture
! is approximated by an irregular (not even convex) polygon.
!
! If this pixel falls completely outside the LARGEST aperture, go on
! to the next pixel.  Notice that APMXSQ has actually been defined
! as (R(k)+0.5)**2 for the largest value of R(k), in accordance with
! the formula used for the partial pixels.
!
           if (rsq <= apmxsq) then
              r = sqrt(rsq) - 0.5
!
              do k = 1, naper
!
! if this pixel falls completely outside THIS aperture, go on to the
! next aperture.
!
!!!!                 if (r <= par(k)) then
!!!!                    fractn = max(0.0, min(1.0,par(k) - r))
                 if (r <= raper(k)) then
                    fractn = max(0.0, min(1.0,raper(k) - r))
!
! fractn is the fraction of the pixel that falls inside the
! (irregular) aperture.
!
! If the pixel is bad, set the total counts in this aperture to a number
! so negative that it will never be positive again.
!                                                          ! Null magnitude
                    if (datum < lobad .or. datum > hibad ) apmag(k) = - huge(1.0)
                    apmag(k) = apmag(k) + fractn*datum
                    area(k) = area(k) + fractn
                    sdev(k) = sdev(k) + fractn * stderr(i,j)**2
                 endif
              enddo
           endif
        enddo ! i
!
   enddo ! j
!
! We have accumulated the brightnesses of individual sky pixels in the
! one-dimensional array SKY.  Pixels falling above or below the BAD
! limits have already been eliminated.  Now sort SKY to place the
! pixels in order of increasing brightness.
!
!   write(*,*) nsky,minsky,lobad,hibad

   if (nsky < minsky)  then
!      write(*,*) nsky,n,xc,yc
!!!      call stupid ('There aren''t enough pixels in the sky annulus.')
      write(error_unit,*) 'Object at coordinates:',xc,yc
      write(error_unit,*) ' Are you sure your bad pixel thresholds are all right?'
      write(error_unit,*) ' If so, then you need a larger outer sky radius.'
      write(error_unit,*) nsky,minsky,maxsky,lobad,hibad
      write(error_unit,*) 'There aren''t enough pixels in the sky annulus.'
!      stop
!      call tblank
!      call clfile (2)
!      call clfile (3)
!      return
      goto 3333
   end if
!      call quick (sky, nsky, index)
!
! Obtain the mode, standard deviation, and skewness of the peak in the
! sky histogram.
!
!      call mmm (sky, nsky, hibad, dum, datum, skymod, skysig, skyskw)
!!!   call robustmean1(sky, nsky, skymn, skymed, skymod, skysig, skyskw)

   if( all(sky(1:nsky) > 0) .and. all(dsky(1:nsky) > 0) ) then
      call rwmean(sky(1:nsky),dsky(1:nsky),skymod,skyerr,skysig,&
           reliable=reliable)
      !   write(*,*) nsky,skymod,skyerr,skysig
   else
      reliable = .false.
   end if
   if( .not. reliable ) then
      call rmean(sky(1:nsky),skymod,skyerr,skysig)
!      write(*,*) skymod,skysig
   end if

   skyvar=skysig**2
   sigsq=skyvar/nsky

!
! SKYMOD has units of (ADU/pixel), and SKYSIG is the pixel-to-pixel
! scatter of SKYMOD, in units of (ADU/pixel).  SKYVAR is the
! variance (square of the standard deviation) of the sky brightness,
! (ADU/pixel)**2, and SIGSQ is the square of the standard error of the
! mean sky brightness.
!
! Subtract the sky from the integrated brightnesses in the apertures,
! convert the results to magnitudes, and compute standard errors.
!
   do i = 1, naper
!
! If the modal sky value could not be determined, set the magnitude
! to 99.999.
!

      if (skysig < -0.5) go to 2210
      apmag(i) = apmag(i) - skymod*area(i)
!
! If the star + sky is fainter than the sky, or if the star aperture
! extends beyond the limits of the picture, or if there is a bad pixel
! in the star aperture, set the magnitude to 99.999.
!
      if (apmag(i) <= 0.0) go to 2210
!      error(1) = real(area(i)*skyvar)
      error(1) = real(area(i)*skyerr**2)
      error(2) = real(apmag(i))!*phpadu!/phpadu
      error(3) = real(sigsq*area(i)**2)

!      error(1) = real(sdev(i) + error(1)) / 2
!      error(3) = epsilon(error)

!      write(*,'(5g15.3)') apmag(i),area(i),area(i)*skyvar,sdev(i),sigsq*area(i)**2

      ! readns ?????

! For Munipack, we needs counts. Sum in aperture is multiplied
! by phpadu (gain) to get detected counts instead of digitalized
! data.

      apcts(n,i) = real(apmag(i)*phpadu)
      ! in Munipack, the noise of flat-field (and others) is also included:
      apcts_err(n,i) = real(sqrt(error(1) + error(2) + error(3)))
      !      apcts_err(n,i) = sqrt(phpadu*(error(1) + error(2) + error(3) + sdev(i)**2))
!      write(*,*) sqrt(error(1)), sqrt(error(2)),  sqrt(error(3)),stderr(int(xc),int(yc))!sqrt(sdev(i))
!      apcts_err(n,i) = sqrt(apmag(i))

!
! These variables ERRORn are the respective variances (squares of the
! mean errors) for: (1) random noise inside the star aperture, including
! readout noise and the degree of contamination by other stars in the
! neighborhood, as estimated by the scatter in the sky values (this
! standard error increases as the square root of the area of the
! aperture); (2) the Poisson statistics of the observed star brightness;
! (3) the uncertainty of the mean sky brightness (this standard error
! increases directly with the area of the aperture).
!
      magerr(i) = real(min(9.999d0, 1.0857*sqrt(error(1) + error(2) + error(3))/apmag(i)))
      apmag(i) = 25.0 - 2.5*log10(apmag(i)*phpadu)
      if (apmag(i) > 99.999) go to 2210
      go to 2220
2210  continue
      apmag(i) = 99.999
      magerr(i) = 9.999
      apcts(n,i) = -1
      apcts_err(n,i) = -1
2220  continue
      enddo
!
!  NOTICE: a nice example of goto's
!
! Write out the answers.
!
!      if (watch > 0.5) then
      if( verbose ) then
         write (*,"(10X, I5, 2F8.1, F9.3, ' +-', F6.3, 3x, g0.3)") &
              istar, xc, yc, apmag(1), magerr(1), skymod
!         write (*,"(/1X, I5, 14F9.3)") istar, xc, yc, (apmag(i), i=1,naper)
!         write (*,"(4X, F9.3, 2F6.2, F8.3, 11F9.3)") skymod, min(99.99,skysig),&
!              min(999.99, max(-99.99,skyskw)), (magerr(i), i=1,naper)
      endif

      if( plog ) then
         write(*,'(a,2(f0.3,1x),es15.5)') '=APHOT> ',xc,yc,apcts(n,1)
      end if

      xsky(n) = skymod*phpadu
!      xsky_err(n) = sqrt(sigsq*phpadu**2)
      xsky_err(n) = skyerr*phpadu

      if (apmag(1) < 99.0) then
         wt = (2.0/(2.0 - dmag))*(100.0/magerr(1))**2
         maglim = maglim + wt*(apmag(1) - dmag)
         magsq = magsq + wt*(apmag(1) - dmag)**2
         sumwt = sumwt + wt
         nmag = nmag + 1
      endif

3333  continue
   enddo ! n
!
!-----------------------------------------------------------------------
!
! Normal return.
!
! Estimate magnitude limit, close files, and return.
!

deallocate(sky)

!call clfile (3)
!call clfile (2)
if (sumwt <= 0.0) return
maglim = maglim/sumwt
magsq = magsq/sumwt - maglim**2
magsq = sqrt(max(0.0d0, magsq))

if( verbose ) &
     write (*,"('    Estimated magnitude limit (Aperture 1): ', F4.1,' +-', F4.1, ' per star.')") maglim, magsq

if( verbose ) write(*,"(a,i0,a)") " Found ",size(xstar)," star(s)."

!      call stupid (line)
return
!
!-----------------------------------------------------------------------
!
!666 continue
if ( allocated(sky) ) deallocate(sky,dsky)
status = 1

end subroutine daophotsb

end module mdaofotometr

!
!  profile photometry
!
!  Copyright © 2013, 2016 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.


program pphot

  use titsio
  use fitspphot

  implicit none

  character(len=4*FLEN_FILENAME) :: record,key,val
  character(len=FLEN_FILENAME) :: outname, file,backup, output = ''
  character(len=FLEN_KEYWORD), dimension(1) :: fkeys
  logical :: verbose = .false., plog = .false.
  integer :: eq,status

  fkeys(1) = FITS_KEY_GAIN

  do
     read(*,'(a)',end=20) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Malformed input record.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'PIPELOG' ) then

        read(val,*) plog

     else if( key == 'FITS_KEY_GAIN' ) then

           read(val,*) fkeys(1)

     else if( key == 'FILE' ) then

        read(val,*) file, backup, output

        status = 0
!        call fitsback(file,backup,output,.false.,outname,status)

        if( verbose ) then
           write(*,*)
           write(*,'(a)') "========  Processing file: "//trim(outname)
           write(*,*)
        end if

     end if

  end do

20 continue

  stop 0

end program pphot

!
!  Flat     Average of a set of flat-fields.
!  Copyright (C) 1997 - 2017  Filip Hroch, Masaryk University, Brno, CZ
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!

program aflat

  use LibList
  use robustmean
  use weightedmean
  use robratio
  use robustflat
  use medians
  use fitsio
  use xfitsio
  use iso_fortran_env

  implicit none

  ! debuging
  logical, parameter :: debug = .false.

  logical :: verbose = .false.

  integer, parameter :: dbl = selected_real_kind(15)

  character(len=*), parameter :: afid = 'FLAT'

  ! Default Output image name:
  character(len=FLEN_FILENAME) :: nameflat='flat.fits', backup

  ! No. of image dimensions
  integer, parameter :: DIM = 2

  ! lower and upper limits
  real :: saturate_set =  -1
  real :: threshold_set = 0

  integer :: i,j,eq,nobs, istat, naxis,n,l, iter
  integer, dimension(DIM) :: naxes
  integer :: bitpix = -32
  integer :: maxiter = 7
  character(len=8) :: approximation = 'STANDARD'

  real :: avg, sig, t, savg, dt, g, d, egain, sgain, fmean, time, saturate, &
       eflat, waterline, thresh
  real :: darketime = -1
  real :: etime = -1
  real :: xdark = -1.0
  real :: gain = 1
  logical :: gain_set = .false.
  logical :: gain_estimate = .false.
  real, allocatable, dimension(:,:) :: flat,dflat,res,des,bias,dark,ebias,edark
  real, allocatable, dimension(:) :: fbuf, dbuf, abuf, sbuf, egains
  real, dimension(:,:), pointer :: ccd, err
  logical, allocatable, dimension(:,:) :: mask, bitmask
  character(len=FLEN_FILENAME) :: sb,record,buf,key,val, &
       biasname='', darkname='', maskname=''
  character(len=FLEN_VALUE) :: dateobs,dateobs1,filter,filter1, &
       imagetyp1, imagetyp
  character(len=FLEN_KEYWORD) :: KEY_FILTER=FITS_KEY_FILTER, &
       DATE_OBS=FITS_KEY_DATEOBS, KEY_EXPTIME=FITS_KEY_EXPTIME, &
       KEY_IMAGETYP=FITS_KEY_IMAGETYP, KEY_GAIN=FITS_KEY_GAIN,&
       KEY_SATURATE=FITS_KEY_SATURATE
  type(Imagetype), pointer :: list,curr
  type(xFITS) :: fits, biasfits, darkfits, maskfits
  logical :: reliable, terminate

  buf = ''
  filter1 = ''
  imagetyp1 = ''

  call xfits_init(biasfits)
  call xfits_init(darkfits)
  call xfits_init(maskfits)

  call InitList(list)
  curr => list

  do
     read(*,'(a)',end=20) record

     eq = index(record,'=')
     if( eq == 0 ) stop 'Improper input.'
     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'OUTPUT' ) then
        read(val,*) nameflat, backup
     endif

     if( key == 'BITPIX' ) then
        read(val,*) bitpix
     endif

     if( key == 'SATURATE' ) then
        read(val,*) saturate_set
        if( saturate_set <= 0 ) stop 'Only positive saturations are allowed.'
     endif

     if( key == 'THRESHOLD' ) then
        read(val,*) threshold_set
        if( threshold_set <= 0 ) stop 'Only positive thresholds are allowed.'
     endif

     if( key == 'GAIN' ) then
        read(val,*) gain
        gain_set = .true.
     endif

     if( key == 'VERBOSE' ) then
        read(val,*) verbose
     endif

     if( key == 'APPROXIMATION' ) then
        read(val,*) approximation
        if( approximation == 'BASIC' ) then
           maxiter = 0
        else !if( approximation == 'STANDARD' ) then
           maxiter = 3
        end if
     endif

     if( key == 'GAIN_ESTIMATE' ) then
        read(val,*) gain_estimate
     endif

     if( key == 'FITS_KEY_FILTER' ) then
        read(val,*) KEY_FILTER
     endif

     if( key == 'FITS_KEY_DATEOBS' ) then
        read(val,*) DATE_OBS
     endif

     if( key == 'FITS_KEY_EXPTIME' ) then
        read(val,*) KEY_EXPTIME
     endif

     if( key == 'FITS_KEY_IMAGETYP' ) then
        read(val,*) KEY_IMAGETYP
     endif

     if( key == 'FITS_KEY_GAIN' ) then
        read(val,*) KEY_GAIN
     endif

     if( key == 'FITS_KEY_SATURATE' ) then
        read(val,*) KEY_SATURATE
     endif

     if( key == 'BIAS' ) then

        read(val,*) biasname
        if( verbose ) write(error_unit,*) "BIAS=",trim(biasname)
        call xfits_read(biasname,biasfits)
        if( .not. biasfits%status ) stop 'Failed to load the bias frame.'

     end if

     if( key == 'XDARK' ) then
        read(val,*) xdark
     end if

     if( key == 'DARK' ) then

        read(val,*) darkname
        if( verbose ) write(error_unit,*) "DARK=",trim(darkname)
        call xfits_read(darkname,darkfits)
        if( .not. darkfits%status ) stop 'Failed to load the dark frame.'

        istat = 0
        call xfits_kye(darkfits,KEY_EXPTIME,darketime,istat)
        if( istat /= 0 ) then
           istat = 0
           darketime = -1
           if( verbose ) &
                write(error_unit,*) "An exposure time for dark frame unknown."
        end if

     end if

     if( key == 'MASK' ) then

        read(val,*) maskname
        if( verbose ) write(error_unit,*) "MASK=",trim(maskname)
        call xfits_read(maskname,maskfits)
        if( .not. maskfits%status ) stop 'Failed to load the mask frame.'

     end if

     if( key == 'FILE' ) then

        if( verbose .and. getno(curr) == 0 ) &
             write(error_unit,*) &
             "Filename, exptime[s], gain[ct/adu], saturation[ct], threshold[ct], mean[ct], std.err., reliable:"

        read(val,*) sb
        if( verbose ) write(error_unit,'(a)',advance="no") trim(sb)//":"

        call xfits_init(fits)
        call xfits_read(sb,fits)
        if( .not. fits%status ) then
           call xfits_deallocate(fits)
           write(error_unit,*) "Filed to read `",trim(sb),"'. Skipping."
           goto 665
        end if

        istat = 0
        call xfits_kys(fits,DATE_OBS,dateobs,istat)
        if( istat /= 0 ) then
           istat = 0
           dateobs = ''
        end if

        call xfits_kys(fits,KEY_FILTER,filter,istat)
        if( istat /= 0 ) then
           istat = 0
           filter = ''
        end if
        if( filter == '' .and. verbose ) &
             write(error_unit,'(a)',advance="no") "Warning: empty filter .. "

        call xfits_kys(fits,KEY_IMAGETYP,imagetyp,istat)
        if( istat /= 0 ) then
           istat = 0
           imagetyp = ''
        end if

        call xfits_kye(fits,KEY_EXPTIME,etime,istat)
        if( istat /= 0 ) then
           istat = 0
           etime = -1
        end if

        if( .not. gain_set ) then
           call xfits_kye(fits,KEY_GAIN,gain,istat)
           if( istat /= 0 ) then
              write(error_unit,*) &
                   "Warning: Gain keyword not found in FITS header of `", &
                   trim(sb),"' (default is 1)."
              istat = 0
              gain = 1
           end if
        end if

        ! first image => initialisation
        if( getno(curr) == 0 )then

           naxis = fits%naxis
           naxes = fits%naxes

           dateobs1 = dateobs
           filter1 = filter
           imagetyp1 = imagetyp

           if( biasfits%status ) then
              if( .not. all(biasfits%naxes == naxes) ) then
                 write(error_unit,*) 'bias:',biasfits%naxes(1),&
                      'x',biasfits%naxes(2), &
                      '     current frame:',naxes(1),'x',naxes(2)
                 stop "Bias has incompatible dimensions."
              end if
           end if

           if( darkfits%status ) then
              if( .not. all(darkfits%naxes == naxes) ) then
                 write(error_unit,*) 'dark:',darkfits%naxes(1), &
                      'x',darkfits%naxes(2), &
                      '     current frame:',naxes(1),'x',naxes(2)
                 stop "Dark has incompatible dimensions."
              end if
           end if

           if( maskfits%status ) then
              if( .not. all(maskfits%naxes == naxes) )then
                 write(error_unit,*) 'bitmask:',maskfits%naxes(1), &
                      'x',maskfits%naxes(2), &
                      '     current frame:',naxes(1),'x',naxes(2)
                 stop "Mask has incompatible dimensions."
              end if
           endif

        else

           if( .not. all(naxes == fits%naxes) ) then
              write(error_unit,*) &
                   "Dimensions of images are mutually incompatible. Skipping."
              goto 665
           endif

           if( imagetyp1 /= imagetyp ) &
              write(error_unit,'(a)',advance="no") &
                   "Warning: Image-types does not corresponds. .. current `",&
                   trim(imagetyp),"'(?)"

           if( filter /= filter1 ) write(error_unit,'(a)',advance="no") &
                "Warning: incompatible filters .. current `",trim(filter),"'(?)"

        endif

        ! dark frame multiplicator
        if( xdark > 0 )then
           time = xdark
        else if( etime > 0 .and. darketime > 0 )then
           time = etime / darketime
        else
           time = 1
        end if

        ! saturation
        if( saturate_set > 0 ) then
           saturate = saturate_set
        else
           call xfits_kye(fits,KEY_SATURATE,saturate,istat)
           if( istat /= 0 ) then
              istat = 0
              if( fits%bitpix > 0 ) then
                 saturate = 2.0**fits%bitpix - 1
              else
                 saturate = maxval(fits%image)*(1 + epsilon(saturate))
              end if
           end if
        end if

        ! threshold
        if( threshold_set > 0 ) then
           thresh = threshold_set
        else
           thresh = 0
        end if

        allocate(ccd(naxes(1),naxes(2)),err(naxes(1),naxes(2)), &
             mask(naxes(1),naxes(2)),bias(naxes(1),naxes(2)), &
             dark(naxes(1),naxes(2)),ebias(naxes(1),naxes(2)), &
             edark(naxes(1),naxes(2)),bitmask(naxes(1),naxes(2)))

        if( biasfits%status ) then
           bias = biasfits%image
           ebias = biasfits%stderr
        else
           bias = 0
           ebias = 0
        end if
        if( darkfits%status ) then
           dark = darkfits%image
           edark = darkfits%stderr
        else
           dark = 0
           edark = 0
        end if
        if( maskfits%status ) then
           bitmask = maskfits%image > 0.5
        else
           bitmask = .true.
        end if

        ! Preparatory correct the input flat.
        ! Standard deviation is set with assumption of Poisson distribution
        ! of data. It requires large light fluxes, around half of a full range.
        mask =  thresh < fits%image .and. fits%image < saturate .and. bitmask
        where( mask )
           ccd = gain*(fits%image - (bias + time*dark))
        elsewhere
           ccd = -1
        end where
        saturate = gain * saturate
        thresh = gain * thresh
        mask =  thresh < ccd .and. ccd < saturate .and. mask
        where( mask )
           err = sqrt(ccd + gain**2*(ebias**2 + time**2*edark**2))
        elsewhere
           err = -1
        end where
        ! Important. Pixels out of the mask has negative values.

        ! the average is computed by one million elements or less
        n = (naxes(1)*naxes(2)) / 1000000
        if( n > 0 ) then
           l = 0
           do i = 1,naxes(1)
              do j = 1,naxes(2)
                 l = l + 1
                 if( mod(l,n) /= 0 ) mask(i,j) = .false.
              end do
           end do
        end if

        ! determine mean level of current frame
        call rwmean(pack(ccd,mask),pack(err,mask),avg,savg,sig, &
             reliable=reliable)

        if( verbose ) &
             write(error_unit, &
             '(2x,1pg0.3,2x,0pf0.2,2x,1p,2(g0.2,1x),2x,1pg0.5,3x,1pg0.3,l2)') &
             etime,gain,saturate,thresh,avg,sig,reliable

        if( .not. (avg > 0) ) then
           write(error_unit,*) &
                'This frame has zero or negative mean level. Skipping.'
           deallocate(ccd,err)
        else
           ! add image to the list
           Call AddItem (curr,image=ccd,noise=err,filename=sb,mean=avg, &
                stderr=savg,stdsig=sig,dateobs=dateobs,filter=filter, &
                satur=saturate)
        end if

        deallocate(mask,bias,dark,ebias,edark,bitmask)
665     continue
        call xfits_deallocate(fits)

     end if

  enddo

20 continue
  nobs = getno(curr)

  if( nobs == 0 ) stop 'No input image(s).'

  if( verbose ) then
     write(error_unit,*)
     write(error_unit,*) 'Number of input images:',nobs
     write(error_unit,*) 'Dimensions:',naxes(1),'x',naxes(2)
     write(error_unit,*) 'Filter: ',trim(filter1)
     write(error_unit,*) 'Precision of appoximation: ',trim(approximation)
  end if

  ! Section: flat-field computation by flux calibration
  allocate(flat(naxes(1),naxes(2)),dflat(naxes(1),naxes(2)),&
       res(naxes(1),naxes(2)),des(naxes(1),naxes(2)),mask(naxes(1),naxes(2)), &
       fbuf(nobs),dbuf(nobs),abuf(nobs),sbuf(nobs),bitmask(naxes(1),naxes(2)),&
       egains(nobs))

  if( maskfits%status ) then
     bitmask = maskfits%image > 0.5
  else
     bitmask = .true.
  end if

  ! Initial mean flat
  if( verbose ) write(error_unit,'(a)') &
       'Calculating the initial flat-field frame (iter. #0) ...'
  do j = 1,naxes(2)
     do i = 1,naxes(1)

        ! this is initial estimate only
        ! lighter frames has smaller influence due Poisson statistics
        curr => list
        n = 0
        do
           curr => GetNext(curr)
           if( .not. associated(curr) ) exit
           call GetItem(curr,image=ccd,noise=err,mean=avg,stdsig=sig, &
                satur=saturate)
           if( thresh < ccd(i,j) .and. ccd(i,j) < saturate .and. &
                err(i,j) > 0 .and. bitmask(i,j) .and. avg > 0 ) then
              n = n + 1
              fbuf(n) = ccd(i,j) / avg
              dbuf(n) = sqrt(err(i,j)**2 / avg**2 + sig**2)
           end if
        enddo
        if( n > 0 ) then
           call rwmean(fbuf(1:n),dbuf(1:n),flat(i,j),dflat(i,j), &
                reliable=reliable)
           if( .not. reliable ) &
                call rmean(fbuf(1:n),flat(i,j),dflat(i,j))
        else
           flat(i,j) = 1
           dflat(i,j) = 0
        end if

     enddo
  enddo

  if( debug ) then
     ! write out the first estimate

     mask = bitmask
     where( mask )
        des = sqrt(err**2 + dflat**2)
        res = (flat - 1) / des
     end where

     open(1,file='/tmp/flatdebug_zero.dat')
     do i = 1,size(flat,1),2
        do j = 1,size(flat,2),2
           if( mask(i,j) .and. abs(res(i,j)) < 5 ) then
              write(1,*) flat(i,j)-1,res(i,j), flat(i,j)
           end if
        end do
     end do
     close(1)

  end if

  terminate = .false.
  do iter = 1, maxiter

     ! Now, we're Improving precision of approximation. The number of
     ! iterations is controled by `terminate' variable which tests
     ! convergence of subsequent estimates of the created flat.

     if( terminate ) exit

     if( verbose ) then
        write(error_unit,'(a)') 'Scaling individual frames by the flat ...'
        write(error_unit,'(a)',advance="no") &
             "Filename,      mean level[ct],  std.err., reliable"
        if( gain_estimate ) then
           write(error_unit,'(a)') ",  std.dev.,  gain:"
        else
           write(error_unit,'(a)') ":"
        end if
     end if

     ! Update means for individual frames
     curr => list
     do ! over frames
        curr => GetNext(curr)
        if( .not. associated(curr) ) exit
        call GetItem(curr,filename=sb,image=ccd,noise=err,mean=avg, &
             satur=saturate)

        mask = thresh < ccd .and. ccd < saturate .and. err > 0 &
             .and. flat > 0 .and. dflat > 0 .and. bitmask
        call rcal(pack(ccd,mask),pack(err,mask),pack(flat,mask), &
             pack(dflat,mask),t,dt,xreliable=reliable,xverb=.false.)
        ! We assumes Poisson distribution of flat pixels, their dispersion
        ! is bound to the mean value. Data with strong fluence of
        ! non-Poisson noise component should be avoided already.

        if( verbose ) then

           write(error_unit, &
                '(a,2x,1pg0.5,2x,1pg0.3,2x,l1)',advance="no") &
                trim(sb)//": ",t,dt,reliable

           ! gain estimate
           if( gain_estimate ) then
              call rmean(pack(ccd/flat, mask),fmean,savg,sig)
              g = fmean / sig**2
              write(error_unit,'(1x,1pg0.5,2x,0pf0.3)') sig,g
              egains(curr%i) = g

              ! The value of fmean is principally identical to t by rcal.
              ! The rmean is convenience way how to determine variance
              ! (rcal uses regularisation which gives var ~ 1 in any case).
           else
              write(error_unit,*)
           end if

        end if

        ! update only when our estimate is realiable
        if( reliable ) &
           call SetItem(curr,mean=t)

     enddo ! over all frames

     ! update flat
     if( verbose ) write(error_unit,'(a,i0,a)') &
          'Calculating a flat-field frame (iter. #',iter,') ...'
     res = -1
     do j = 1,naxes(2)
        do i = 1,naxes(1)

           curr => list
           n = 0
           do
              curr => GetNext(curr)
              if( .not. associated(curr) ) exit
              call GetItem(curr,image=ccd,noise=err,mean=avg,stdsig=sig,&
                   satur=saturate)
              if( thresh < ccd(i,j) .and. ccd(i,j) < saturate .and. &
                   err(i,j) > 0 .and. bitmask(i,j) .and. &
                   avg > 0 .and. sig > 0 ) then
                 n = n + 1
                 fbuf(n) = ccd(i,j)
                 dbuf(n) = err(i,j)
                 abuf(n) = avg
                 sbuf(n) = sig
              end if
           enddo
           if( n > 0 ) then

              avg = flat(i,j)

              if( debug .and. i == naxes(1)/2 .and. j == naxes(2)/2 ) &
                   call rflat(fbuf(1:n),dbuf(1:n),abuf(1:n),sbuf(1:n), &
                   flat(i,j),dflat(i,j),reliable,verbose=.true.)

              call rflat(fbuf(1:n),dbuf(1:n),abuf(1:n),sbuf(1:n), &
                   flat(i,j),dflat(i,j),reliable,verbose=.false.)

              ! Non reliable pixels are silently ignored. The data
              ! has strongly non-gaussian distribution: the case of
              ! bad columns and pixels, an overscan data and etc.
              ! if( .not. reliable .and. verbose ) write(*,*) i,j

              ! the absolute difference between the result of previous
              ! computation and the current one controls termination
              if( reliable ) res(i,j) = abs(avg - flat(i,j))

           else
              flat(i,j) = 1
              dflat(i,j) = 0
           end if

        enddo
     enddo

     ! terminate condition: the mean difference between two latest
     ! subsequent iterations is under the mean std.err. limit
     d = median(pack(res,res>0))
     eflat = median(pack(dflat,dflat>0))
     terminate = d < eflat
     if( verbose ) &
          write(error_unit,'(a,3x,1p,2(g0.1,2x),l1)') &
          'Mean residual and std.dev., terminate:',d,eflat,terminate

  end do ! iter

  if( debug ) then
     ! (**)
     ! Diagnostics. The second column of the files
     ! are residuals intended for Normality testing.
     !
     ! https://stackoverflow.com/questions/2471884/
     ! or:
     ! gnuplot> binwidth=0.05
     ! gnuplot> bin(x,width)=width*floor(x/width)
     ! gnuplot> plot '/tmp/flatdebug_666.fits.dat' \
     !          using (bin($2,binwidth)):(1.0) smooth freq with boxes

     curr => list
     do ! over frames
        curr => GetNext(curr)
        if( .not. associated(curr) ) exit
        call GetItem(curr,filename=sb,image=ccd,noise=err,mean=avg, &
             satur=saturate)

        mask = thresh < ccd .and. ccd < saturate .and. &
             flat > 0 .and. dflat > 0 .and. bitmask
        where( mask )
           des = sqrt(err**2 + avg**2*dflat**2)
           res = (ccd - avg*flat) / des
        end where

        write(buf,'(a,i0,a)') '/tmp/flatdebug_',GetNo(curr),'.dat'
        open(1,file=buf)
        write(1,'(2a)') '# ',trim(sb)
        do i = 1,size(ccd,1),2
           do j = 1,size(ccd,2),2
              if( mask(i,j) .and. abs(res(i,j)) < 5 ) then
                 write(1,*) ccd(i,j)-avg,res(i,j), flat(i,j)
              end if
           end do
        end do
        close(1)
     end do

  end if ! debug

  ! final mean over the whole area
  call rmean(pack(flat,bitmask),avg,savg,sig)

  if( gain_estimate ) then
     call rmean(egains,egain,sgain,t)
  end if

  ! integer representation of flat is not recommended in any case,
  ! but it can be useful for a compatibility
  if( bitpix > 0 ) then
     waterline = nint(10.0**(int(log10(2.0**(bitpix-1)))))
     ! waterline updates mean levels on 1e2,1e4 and 1e9
     avg = waterline * avg
     flat = waterline * flat
     dflat = waterline * dflat
     if( verbose ) write(error_unit,*) &
          'Warning: Numerical precision degraded by conversion to integers.'
  end if

  if( verbose ) then
     eflat = median(pack(dflat,dflat>0))
     write(error_unit,'(2a)') ' Output image: ',trim(nameflat)
     write(error_unit,'(a,3x,1pg0.7)') ' Final mean:',avg
     write(error_unit,'(a,3x,1pg0.1)') &
          ' Expected photometry standard error per pixel:',eflat
     if( gain_estimate ) then
        write(error_unit,'(a,2(2x,f0.3),a,f0.3,a)') &
             ' Estimated relative gain, std.err:',egain,sgain, &
             ' (original gain was ',gain,').'
     end if
  end if

  ! Output image
  istat = 0
  call fitsbackup(nameflat,backup,istat)
  call ftinit(26,nameflat,1,istat)
  call ftphps(26,bitpix,naxis,naxes,istat)
  if( gain_estimate ) then
     call ftpkye(26,'GAIN_AVG',egain,6,'[ct/ADU] estimated gain',istat)
     call ftpkye(26,'GAIN_STD',sgain,2,'[ct/ADU] std.dev of estimated gain',&
          istat)
  end if
  if( filter1 /= '' ) &
       call ftpkys(26,KEY_FILTER,filter1,'filter',istat)
  if( imagetyp1 /= '' ) &
     call ftpkys(26,KEY_IMAGETYP,imagetyp,'image type',istat)
  call ftpkys(26,DATE_OBS,dateobs1,'UTC of the first on input',istat)
  if( bitpix > 0 ) then
     call ftpkye(26,'BSCALE',1.0,10,'',istat)
     call ftpkye(26,'BZERO',2.0**(bitpix-1),10,'',istat)
  endif

  if( nobs > 0 ) then
     write(buf,'(a,i0,a)') 'Result of robust flat-fielding of ',nobs,&
          ' exposure(s).'
     call ftpcom(26,buf,istat)
     call ftpcom(26,&
          'Filename, time of start, mean level[ct] for each image used:',&
          istat)
     curr => list
     do
        curr => GetNext(curr)
        if( .not. associated(curr) ) exit
        call GetItem(curr,filename=sb,dateobs=dateobs,mean=t)
        write(buf,'(1pg0.5)') t
        call ftpcom(26,"'"//trim(sb)//"' '"//trim(dateobs)//"' "//trim(buf), &
             istat)
     enddo
  endif

  write(buf,'(f0.3)') gain
  call ftphis(26,afid//" gain: "//trim(buf),istat)

  if( darkname /= '' ) then
     write(buf,'(f0.5)') time
     call ftphis(26,afid//" dark: '"//trim(darkname)//"' *"//trim(buf),istat)
  end if

  if( biasname /= '' ) &
     call ftphis(26,afid//" bias: '"//trim(biasname)//"'",istat)

  if( maskname /= '' ) &
     call ftphis(26,afid//" bitmask: '"//trim(maskname)//"'",istat)

  write(buf,*) thresh
  call ftphis(26,afid//" threshold: "//trim(buf)//" [ct] (gain applied)",istat)

  write(buf,*) saturate
  call ftphis(26,afid//" saturation: "//trim(buf)//" [ct] (gain applied)",istat)

  write(buf,*) avg
  call ftphis(26,afid//" mean level: "//trim(buf)//" [ct]",istat)

  call ftukys(26,FITS_KEY_CREATOR,FITS_VALUE_CREATOR,FITS_COM_CREATOR,istat)
  call ftpcom(26,MUNIPACK_VERSION,istat)

  ! flat-field generated
  call ftp2de(26,1,naxes(1),naxes(1),naxes(2),flat,istat)

  ! standard error of mean
  call ftiimg(26,bitpix,naxis,naxes,istat)
  call ftukys(26,'EXTNAME',EXT_STDERR,'',istat)
  call ftpcom(26,&
       'The estimation of standard error of mean of pixels of flat-field.',&
       istat)
  call ftp2de(26,1,naxes(1),naxes(1),naxes(2),dflat,istat)

  call ftclos(26,istat)
  call ftrprt('STDERR',istat)

  if( allocated(flat) ) &
       deallocate(flat,dflat,res,des,mask,fbuf,dbuf,abuf,sbuf,egains,bitmask)
  call DestroyList(list)
  call xfits_deallocate(maskfits)
  call xfits_deallocate(biasfits)
  call xfits_deallocate(darkfits)

  if( istat == 0 ) then
     stop 0
  else
     stop 'Failed on FITS I/O error.'
  end if

end program aflat

!
! Kombine     Combine a set of frames.
!
! Copyright © 1998-2006, 2011-21 F.Hroch (hroch@physics.muni.cz)
!
! This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

program kombine

  use fitskombi
  use oakleaf
  use astrotrafo
  use phio
  use titsio
  use iso_fortran_env

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)

  character(len=FLEN_FILENAME) :: filename
  character(len=4*FLEN_FILENAME) :: key,val, record
  character(len=80) :: msg

  character(len=FLEN_KEYWORD), dimension(7) :: fitskeys
  character(len=FLEN_FILENAME) :: output = 'kombine.fits'

  ! spherical sprojection
  logical :: init_sproj = .false.  ! initialised by user
  logical :: init_crval = .false.  ! initialised by user
  logical :: init_crpix = .false.
  logical :: init_scale=.false.
  logical :: init_angle=.false.
  logical :: init_reflex = .false.
  logical :: init_jdref = .false.
  character(len=FLEN_VALUE) :: ptype = "GNOMONIC"
  real(dbl) :: scale = 1.0/3600.0! deg per pixel
  real(dbl) :: angle = 0         ! rotation in degrees
  logical :: reflex = .false.
  real(dbl) :: jdref = 0         ! proper motion reference JD
  real(dbl), dimension(2) :: crval, crpix
  real(dbl), dimension(2) :: crmov = [ real(0.0,dbl), real(0.0,dbl) ]
  real(dbl) :: longitude, latitude
  logical :: geodefined = .false.

  ! information keywords
  character(len=FLEN_VALUE) :: object = ''
  character(len=FLEN_VALUE) :: filter = ''
  character(len=FLEN_VALUE) :: dateobs = ''
  integer :: bitpix = -32        ! default output bitpix
  integer, dimension(2) :: naxes = -1 ! the code is restricted on 2D frames
  integer :: nfiles = 0          ! input files count
  real :: exptime = 1            ! mean exposure time
  logical :: robust = .true.     ! output image is computed by robust mean
  logical :: background = .true. ! subtract background
  logical :: verbose = .false.   ! verbose output
  logical :: pipelog = .false.

  ! selection of method of interpolation:
  !
  !  NEAR(default)  BILINEAR    BICUBIC   BI3CONV
  !  fast           slow        slower    the slowest
  !  pixelized      good        perfect   for undersampled
  !
  ! warning: all BI-* methods can give an undesired fringing patterns
  ! on the background
  character(len=10) :: method = 'NEAR'

  integer :: eq, stat, status
  type(KombiFits) :: fits
  type(KombiFits), dimension(:), allocatable :: files
  type(AstroTrafoProj) :: sproj     ! spherical projection
  real, dimension(:,:), allocatable :: IMAGE, EXPMASK

  ! mandatory keys
  fitskeys = [ FITS_KEY_DATEOBS, FITS_KEY_TIMEOBS, FITS_KEY_EXPTIME, &
       FITS_KEY_FILTER, FITS_KEY_OBJECT, FITS_KEY_LONGITUDE, &
       FITS_KEY_LATITUDE ]

  do
     read(*,'(a)',iostat=stat,iomsg=msg) record
     if( stat == IOSTAT_END ) exit
     if( stat > 0 ) then
        write(error_unit,*) trim(msg)
        error stop 'An input error.'
     end if

     eq = index(record,'=')
     if( eq == 0 ) stop 'Malformed input record.'

     key = record(:eq-1)
     val = record(eq+1:)

     if( key == 'OUTPUT' ) then

        read(val,*) output

     else if( key == 'FITS_KEY_OBJECT' ) then

        read(val,*) fitskeys(5)

     else if( key == 'FITS_KEY_FILTER' ) then

        read(val,*) fitskeys(4)

     else if( key == 'FITS_KEY_EXPTIME' ) then

        read(val,*) fitskeys(3)

     else if( key == 'FITS_KEY_DATEOBS' ) then

        read(val,*) fitskeys(1)

     else if( key == 'FITS_KEY_TIMEOBS' ) then

        read(val,*) fitskeys(2)

     else if( key == 'FITS_KEY_LONGITUDE' ) then

        read(val,*) fitskeys(6)

     else if( key == 'FITS_KEY_LATITUDE' ) then

        read(val,*) fitskeys(7)

     else if( key == 'VERBOSE' ) then

        read(val,*) verbose

     else if( key == 'PIPELOG' ) then

        read(val,*) pipelog

     else if( key == 'BITPIX' ) then

        read(val,*) bitpix

     else if( key == 'SCALE' ) then

        read(val,*) scale
        init_scale = .true.

     else if( key == 'ANGLE' ) then

        read(val,*) angle
        init_angle = .true.

     else if( key == 'REFLEX' ) then

        read(val,*) reflex
        init_reflex = .true.

     else if( key == 'CRVAL' ) then

        read(val,*) crval
        init_crval = .true.

     else if( key == 'CRMOV' ) then

        read(val,*) crmov

     else if( key == 'JDREF' ) then

        read(val,*) jdref
        init_jdref = .true.

     else if( key == 'CRPIX' ) then

        read(val,*) crpix
        init_crpix = .true.

     else if( key == 'NAXES' ) then

        read(val,*) naxes

     else if( key == 'SPROJECTION' ) then

        read(val,*) ptype
        init_sproj = .true.

     else if( key == 'INTERPOL' ) then

        read(val,*) method
        if( .not. (method == 'NEAR' .or. method == 'BILINEAR' .or. &
             method == 'BICUBIC' .or. method == 'BI3CONV') ) &
             stop 'Specified interpolation method is not implemented yet.'

     else if( key == 'ROBUST' ) then

        read(val,*) robust

     else if( key == 'BACKGROUND' ) then

        read(val,*) background

     else if( key == 'NFILES' ) then

        read(val,*) nfiles
        allocate(files(nfiles))
        nfiles = 0

     else if( key == 'FILE' ) then

        read(val,*) filename

        call fits%Load(filename,fitskeys,background,verbose)
        if( fits%status ) then
           nfiles = nfiles + 1
           files(nfiles) = fits
        else
           write(error_unit,*) &
                "Error: file `",trim(filename),"' read failed. Ignored."
        end if

     end if

  end do ! read

  if( nfiles == 0 ) stop 'No input images.'

  ! Section: initialisation -----------------------------------
  ! Unspecified parameters are derived from the first frame
  block

    exptime = 1

    if( dateobs == '' ) &
         dateobs = files(1)%dateobs

    if( filter == '' ) &
         filter = files(1)%filter

    if( object == '' ) &
         object = files(1)%object

    if( files(1)%geo ) then
       geodefined = .true.
       longitude = files(1)%longitude
       latitude = files(1)%latitude
    end if

    call trafo_fromwcs(sproj,files(1)%ctype,files(1)%crval,files(1)%crpix, &
         files(1)%cd,files(1)%crerr)

    if( any(naxes <= 0) ) &
       naxes = files(1)%naxes

    if( init_sproj ) sproj%type = ptype
    if( init_crval ) then
       sproj%acen = crval(1)
       sproj%dcen = crval(2)
    end if
    if( init_crpix ) then
       sproj%xcen = crpix(1)
       sproj%ycen = crpix(2)
    else
       sproj%xcen = naxes(1) / 2
       sproj%ycen = naxes(2) / 2
    end if
    if( init_scale ) sproj%scale = scale
    if( init_angle ) sproj%rot = angle
    if( init_reflex )then
       if( reflex ) then
          sproj%refl = -1.0_dbl
       else
          sproj%refl = 1.0_dbl
       end if
    end if

    call trafo_refresh(sproj)

    ! reference time for proper motion
    if( .not. init_jdref ) jdref = files(1)%jd()

  end block ! init

  ! time to create the output image
  allocate(IMAGE(naxes(1),naxes(2)),EXPMASK(naxes(1),naxes(2)), &
       stat=stat,errmsg=msg)
  if( stat /= 0 ) then
     write(error_unit,*) "Error: ",trim(msg)
     stop 'Failed to allocate memory.'
  end if
  IMAGE = 0
  EXPMASK = 0


  ! Section: processing ---------------------------------------------
  block

    real, dimension(:,:,:), allocatable :: bigimg
    logical, dimension(:,:), allocatable :: mask, fill
    real(dbl), dimension(:,:), allocatable :: alpha, delta
    real, dimension(:,:), allocatable :: img
    real, dimension(:), allocatable :: fbuf
    real :: amean
    integer :: i,j,n

    allocate(alpha(naxes(1),naxes(2)),delta(naxes(1),naxes(2)),fbuf(nfiles), &
         img(naxes(1),naxes(2)),mask(naxes(1),naxes(2)), &
         fill(naxes(1),naxes(2)),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) trim(msg)
       error stop 'Failed to allocate an image.'
    end if

    ! determine nodes of sky coordinate grid
    do i = 1, naxes(1)
       do j = 1, naxes(2)
          call invtrafo(sproj,real(i,dbl),real(j,dbl),alpha(i,j),delta(i,j))
       end do
    end do

    ! compute mean exposure time
    do n = 1, nfiles
       fbuf(n) = files(n)%exptime
    end do
    call rmean(fbuf,exptime)

    ! mask of touched pixels, value .true. is for pixels which needs to be
    ! additionaly set with image mean
    fill = .true.

    if( robust ) then
       ! compute the average by robust mean

       ! allocate memory
       allocate(bigimg(naxes(1),naxes(2),nfiles),stat=stat,errmsg=msg)
       if( stat /= 0 ) then
          write(error_unit,*) trim(msg)
          error stop 'Failed to allocate so big image.'
       end if

       do n = 1, nfiles
          if( files(n)%loadimg() ) then
             call files(n)%reproject(method,jdref,crmov,alpha,delta,img,mask)
             where( mask )
                bigimg(:,:,n) = img / (files(n)%exptime / exptime) ! area?
             elsewhere
                bigimg(:,:,n) = -1
             end where
             fill = fill .and. .not. mask
             deallocate(files(n)%image)
          end if
       end do

       do i = 1, naxes(1)
          do j = 1, naxes(2)
             if( .not. fill(i,j) ) then
                call rmean(pack(bigimg(i,j,:),bigimg(i,j,:)>0),IMAGE(i,j))
             end if
          end do
       end do

    else
       ! compute the average by arithmetic mean
       do n = 1, nfiles
          if( files(n)%loadimg() ) then
             call files(n)%reproject(method,jdref,crmov,alpha,delta,img,mask)
             where( mask )
                IMAGE = IMAGE + img
                EXPMASK = EXPMASK + (files(n)%exptime / exptime)
             end where
             fill = fill .and. .not. mask
             deallocate(files(n)%image)
          end if
       end do

       where( EXPMASK > 0 )
          IMAGE = IMAGE / EXPMASK
       end where
    end if

    ! fill untouched pixels by mean
    amean = imean(.not.fill,IMAGE)
    do i = 1, naxes(1)
       do j = 1, naxes(2)
          if( fill(i,j) ) IMAGE(i,j) = amean
       end do
    end do

    ! scale on proper values
    IMAGE = nfiles * IMAGE

  end block

  ! Section: FITS save ----------------------------------------------
  block
    integer :: n,naxis
    character(len=FLEN_COMMENT) :: buf
    character(len=FLEN_VALUE), dimension(2) :: ctype
    real(dbl), dimension(2) :: crval,crpix,crder
    real(dbl), dimension(2,2) :: cd,rmat
    real, parameter :: minvalue = 0
    real :: maxvalue
    type(fitsfiles) :: fits

    status = 0
    call fits_create_scratch(fits,status)
    naxis = size(naxes)
    call fits_insert_img(fits,bitpix,naxis,naxes,status)
    if( object /= '' ) then
       call fits_update_key(fits,fitskeys(5),object,'',status)
    end if
    if( filter /= '' ) then
       call fits_update_key(fits,fitskeys(4),filter,'',status)
    end if
    call fits_update_key(fits,fitskeys(3),nfiles*exptime,-3,'Total exposure time',status)
    if( dateobs /= '' ) then
       call fits_update_key(fits,fitskeys(1),dateobs,'',status)
    end if

    if( geodefined ) then
       call fits_update_key(fits,fitskeys(6),longitude,-5, &
            '[deg] geographic longitude (-east)',status)
       call fits_update_key(fits,fitskeys(7),latitude,-5, &
            '[deg] geographic latitude (+north)',status)
    end if

    rmat(1,:) = real([-1,0],dbl)
    rmat(2,:) = real([ 0,1],dbl)
    cd = matmul(rmat,sproj%mat)

    ctype = [ 'RA---TAN', 'DEC--TAN' ]
    crval = [ sproj%acen, sproj%dcen ]
    crpix = [ sproj%xcen, sproj%ycen ]
    crder = sproj%err
    call fits_update_wcs(fits,ctype,crval,crpix,cd,crder,status)

    if( sproj%type == '' ) then
       call fits_write_errmark
       call fits_delete_key(fits,'CTYPE1',status)
       call fits_delete_key(fits,'CTYPE2',status)
       if( status == FITS_KEYWORD_NOT_FOUND ) then
          call fits_clear_errmark
          status = 0
       end if
    end if

    write(buf,'(a,i0,a)') &
         'The image is a collection of ',nfiles,' exposure(s):'
    call fits_write_comment(fits,buf,status)
    do n = 1, nfiles
       call fits_write_comment(fits,"'"//trim(files(n)%filename)//"'",status)
    enddo

    if( robust ) then
       buf = 'robust'
    else
       buf = 'arithmetic'
    end if
    call fits_write_comment(fits, &
         'The averadge by '//trim(buf)//' mean.',status)

    if( method == 'NEAR' ) then
       buf = 'Nearest-neighbour'
    else if( method == 'BILINEAR' ) then
       buf = 'Bi-linear'
    else if( method == 'BICUBIC' ) then
       buf = 'Bicubic'
    else if( method == 'BI3CONV' ) then
       buf = 'Bicubic convolution '
    else
       buf = 'Unspecified'
    end if
    call fits_write_comment(fits,trim(buf) // &
         ' method of interpolation has been used.',status)

    ! range cut-off
    if( bitpix > 0 )then
       maxvalue = 2.0**bitpix - 1.0
       IMAGE = max(minvalue,min(maxvalue,IMAGE))
    end if

    call fits_write_image(fits,0,IMAGE,status)

    if( status == 0 ) then
       if( fits_file_exist(output) ) call fits_file_delete(output)
       call fits_file_duplicate(fits,output,status)
    end if
    call fits_delete_file(fits,status)
    call fits_report_error(error_unit,status)

  end block

  deallocate(files,IMAGE,EXPMASK)

  ! print output info
  if( verbose .and. status == 0 ) then
     write(*,*) 'Output image: ',trim(output)
     write(*,*) 'Dimension: ',naxes(1),'x',naxes(2)
  end if

  if( status == 0 )then
     stop 0
  else
     stop 'An error during kombine run occurred.'
  end if

contains

  real function imean(fill,IMAGE)

    ! estimates mean of te IMAGE by using computed pixels

    logical, dimension(:,:), intent(in) :: fill
    real, dimension(:,:), intent(in) :: IMAGE
    real, dimension(:), allocatable :: fbuf
    integer :: i, j, n, nstep
    real :: x, y

    n = minval(naxes) / 77
    nstep = minval(naxes) / n
    allocate(fbuf(nstep**2))

    ! very sparse grid
    n = 0
    do i = 1, naxes(1), nstep
       do j = 1, naxes(2), nstep
          if( fill(i,j) .and. n < size(fbuf) ) then
             n = n + 1
             fbuf(n) = IMAGE(i,j)
          end if
       end do
    end do

    if( n > 0 ) then
       call rmean(fbuf(1:n),imean)
    else
       ! random selection is also very fine
       do n = 1, 10
          call random_number(x)
          i = int(naxes(1)*x)
          call random_number(y)
          j = int(naxes(2)*y)
          if( 0 < i .and. i < naxes(1) .and. 0 < j .and. j < naxes(2) ) then
             imean = IMAGE(i,j)
             if( fill(i,j) ) return
          end if
       end do
    end if

  end function imean

end program kombine

!
!  Colour FITS tool
!
!  Copyright © 2018-2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
! Munipack is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! Munipack is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module fitscolour

  use titsio
  use iso_fortran_env

  implicit none

  integer, private, parameter :: dbl = selected_real_kind(15)

  type :: ColourFits
     character(len=FLEN_FILENAME) :: filename = ''
     real, dimension(:,:), allocatable :: image
     character(len=FLEN_VALUE) :: filter = ''
     character(len=FLEN_VALUE) :: dateobs = ''
     character(len=FLEN_VALUE) :: object = ''
     character(len=FLEN_VALUE), dimension(2) :: ctype
     real(REAL64), dimension(2) :: crval, crpix
     real(REAL64), dimension(2,2) :: cd
     integer, dimension(2) :: naxes = [ 0, 0 ]
     integer :: naxis = 0
     integer :: bitpix = 0
     real :: exptime = 1   ! [s]
     real :: area = 1      ! [m2]
     real :: leff = 1239.8e-9 ! [m] == 1eV
     real :: fref = 3.6e-9  ! [W/m2] reference flux
     real :: ctph = 1
     real :: scale = 1     ! degs per pixel
     real :: saturate = huge(1.0)
     logical :: astrometry = .false.
     logical :: calibrated = .false.
     logical :: status = .false.
   contains
     procedure :: Load, sky, aperture, apmean, apsum
  end type ColourFits

contains

  subroutine Load(fits,filename,fitskeys)

    ! opens a FITS file

    class(ColourFits) :: fits
    character(len=*), intent(in) :: filename
    character(len=*), dimension(:), intent(in) :: fitskeys

    integer, parameter :: extver = 0
    character(len=80) :: msg
    real(REAL64), dimension(2) :: crder
    integer :: stat,status
    type(fitsfiles) :: fitsfile
    logical :: anyf

    fits%filename = filename
    fits%exptime = 1
    fits%area = 1

    status = 0
    call fits_open_image(fitsfile,filename,FITS_READONLY,status)
    if( status /= 0 ) then
       write(error_unit,*) 'Error: failed to read the file `',trim(filename),"'."
       fits%status = .false.
       return
    end if

    call fits_get_img_dim(fitsfile,fits%naxis,status)
    if( status /= 0 ) goto 666

    if( fits%naxis /= 2 .and. status == 0 ) then
       write(error_unit,*) "Error: `",trim(filename), &
            "': only 2D images are supported for colouring."
       goto 666
    end if

    call fits_get_img_type(fitsfile,fits%bitpix,status)
    call fits_get_img_size(fitsfile,2,fits%naxes,status)
    if( status /= 0 ) goto 666

    call fits_read_key(fitsfile,fitskeys(1),fits%filter,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       status = 0
       fits%filter = ''
    end if

    call fits_read_key(fitsfile,fitskeys(2),fits%exptime,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       status = 0
       fits%exptime = 1
    end if

    call fits_read_key(fitsfile,fitskeys(3),fits%area,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       status = 0
       fits%area = 1
    end if

    call fits_read_key(fitsfile,fitskeys(4),fits%object,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       status = 0
       fits%object = ''
    end if

    call fits_read_key(fitsfile,FITS_KEY_DATEOBS,fits%dateobs,status)
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       status = 0
       fits%dateobs = ''
    end if

    ! add astrometry parameters
    call fits_read_wcs(fitsfile,fits%ctype,fits%crval,fits%crpix,fits%cd,crder,status)
    fits%astrometry = status == 0
    if( status == FITS_KEYWORD_NOT_FOUND ) then
       status = 0
    else
       ! determine scale, degrees per pixel
       fits%scale = real(sqrt(fits%cd(1,1)**2 + fits%cd(1,2)**2))
    end if

    if( status /= 0 ) goto 666

    allocate(fits%image(fits%naxes(1),fits%naxes(2)),stat=stat,errmsg=msg)
    if( stat /= 0 ) then
       write(error_unit,*) "Error: ",trim(msg)
       error stop 'ColourFits failed during memory allocation.'
    end if
    call fits_read_image(fitsfile,0,0.0,fits%image,anyf,status)

    ! photometry calibration
    call fits_write_errmark
    call fits_movnam_hdu(fitsfile,FITS_BINARY_TBL,PHOTOEXTNAME,extver,status)
    if( status == 0 ) then
       call fits_read_key(fitsfile,FITS_KEY_CTPH,fits%ctph,status)
       fits%calibrated = .true.
    else if( status == FITS_BAD_HDU_NUM ) then
       call fits_clear_errmark
       status = 0
    end if

    ! estimate saturate
    if( fits%bitpix > 0 ) then
       fits%saturate = 2.0**fits%bitpix - 1
    end if

666 continue

    if( status /= 0 .and. allocated(fits%image) ) deallocate(fits%image)

    call fits_close_file(fitsfile,status)
    call fits_report_error(error_unit,status)

    fits%status = status == 0

  end subroutine Load

  function sky(this)

    ! estimates background

    use oakleaf

    real :: sky
    class(ColourFits), intent(in) :: this
    integer :: dx,dy,n

    if( .not. this%status ) then
       sky = 0
       return
    end if

    n = int(sqrt(real(this%naxes(1)*this%naxes(2)) / 32768.0))
    dx = max(this%naxes(1)/n,1)
    dy = max(this%naxes(2)/n,1)
    call rmean(pack(this%image(::dx,::dy),.true.),sky)

  end function sky

  subroutine aperture(this,i0,j0,r0,back,data)

    class(ColourFits), intent(in) :: this
    integer, intent(in) :: i0, j0, r0
    real, intent(in) :: back
    real, dimension(:), allocatable, intent(out) :: data

    integer :: n,i,j,dx,dy,r2,width,height
    real, dimension(:), allocatable :: pixels

    ! init
    width = size(this%image,1)
    height = size(this%image,2)

    ! photometry in the aperture
    n = (2*r0 + 1)**2
    allocate(pixels(n))
    r2 = r0**2
    n = 0
    do j = max(j0-r0, 1), min(j0+r0, height)
       dy = (j - j0)**2
       do i = max(i0-r0, 1), min(i0+r0, width)
          dx = (i - i0)**2
          if( dx + dy <= r2 ) then
             n = n + 1
             pixels(n) = this%image(i,j) - back
          end if
       end do
    end do

    allocate(data(n))
    data = pixels(1:n)
    deallocate(pixels)

  end subroutine aperture

  function apmean(this,x,y,r,back)

    ! estimates mean flux in the aperture

    use oakleaf

    real :: apmean
    class(ColourFits), intent(in) :: this
    real, intent(in) :: x, y, r, back

    real, dimension(:), allocatable :: data

    call aperture(this,nint(x),nint(y),nint(r),back,data)
    call rmean(data,apmean)
    deallocate(data)

  end function apmean

  function apsum(this,x,y,r,back)

    ! estimates total flux in the aperture

    real :: apsum
    class(ColourFits), intent(in) :: this
    real, intent(in) :: x, y, r, back

    integer :: i0, j0, r0
    real, dimension(:), allocatable :: data

    r0 = nint(r)
    call locpeak(this,nint(x),nint(y),r0,i0,j0)
    call aperture(this,i0,j0,r0,back,data)
    apsum = sum(data)
    deallocate(data)

  end function apsum

  subroutine locpeak(this,x,y,r0,i0,j0)

    class(ColourFits), intent(in) :: this
    integer, intent(in) :: x, y, r0
    integer, intent(out) :: i0,j0

    integer :: i,j,width,height
    real :: qmax

    ! init
    width = size(this%image,1)
    height = size(this%image,2)
    i0 = x
    j0 = y

    ! locate the local maximum
    qmax = this%image(i0,j0)
    do j = max(y - r0, 1), min(y + r0, height)
       do i = max(x - r0, 1), min(x + r0, width)
          if( this%image(i,j) > qmax ) then
             qmax = this%image(i,j)
             i0 = i
             j0 = j
          end if
       end do
    end do

  end subroutine locpeak

end module fitscolour

!
!  Purpose of this module is to provide API interfaces to C routines.
!  The short name versions of C routines are included only.
!
!  Copyright © 2020-2022 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!

module cfitsio

  use, intrinsic :: iso_c_binding
  implicit none

  interface

     ! File Access Routines

     integer(kind=C_INT) function ffopen(fptr,filename,iomode,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), intent(out) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: filename
       integer(kind=C_INT), value, intent(in) :: iomode
       integer(kind=C_INT), intent(in out) :: status
     end function ffopen

     integer(kind=C_INT) function fftopn(fptr,filename,iomode,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), intent(out) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: filename
       integer(kind=C_INT), value, intent(in) :: iomode
       integer(kind=C_INT), intent(in out) :: status
     end function fftopn

     integer(kind=C_INT) function ffiopn(fptr,filename,iomode,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), intent(out) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: filename
       integer(kind=C_INT), value, intent(in) :: iomode
       integer(kind=C_INT), intent(in out) :: status
     end function ffiopn

     integer(kind=C_INT) function ffinit(fptr,filename,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), intent(out) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: filename
       integer(kind=C_INT), intent(in out) :: status
     end function ffinit

     integer(kind=C_INT) function ffclos(fptr,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), intent(in out) :: status
     end function ffclos

     integer(kind=C_INT) function ffdelt(fptr,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), intent(in out) :: status
     end function ffdelt

     ! HDU Access Routines

     integer(kind=C_INT) function ffmahd(fptr,hdunum,hdutype,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: hdunum
       integer(kind=C_INT), intent(out) :: hdutype
       integer(kind=C_INT), intent(in out) :: status
     end function ffmahd

     integer(kind=C_INT) function ffmnhd(fptr,hdutype,extname,extver,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: hdutype, extver
       character(kind=C_CHAR), dimension(*), intent(in) :: extname
       integer(kind=C_INT), intent(in out) :: status
     end function ffmnhd

     integer(kind=C_INT) function ffthdu(fptr,hdunum,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), intent(out) :: hdunum
       integer(kind=C_INT), intent(in out) :: status
     end function ffthdu

     integer(kind=C_INT) function ffghdn(fptr,hdunum) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), intent(out) :: hdunum
     end function ffghdn

     integer(kind=C_INT) function ffcpfl(infptr,outfptr,previous,current,following,&
          status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: infptr,outfptr
       integer(kind=C_INT), value, intent(in) :: previous,current,following
       integer(kind=C_INT), intent(in out) :: status
     end function ffcpfl

     integer(kind=C_INT) function ffcopy(infptr,outfptr,morekeys,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: infptr,outfptr
       integer(kind=C_INT), value, intent(in) :: morekeys
       integer(kind=C_INT), intent(in out) :: status
     end function ffcopy

     integer(kind=C_INT) function ffcphd(infptr,outfptr,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: infptr,outfptr
       integer(kind=C_INT), intent(in out) :: status
     end function ffcphd

     integer(kind=C_INT) function ffdhdu(fptr,hdutype,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), intent(out) :: hdutype
       integer(kind=C_INT), intent(in out) :: status
     end function ffdhdu

     integer(kind=C_INT) function ffiimg(fptr,bitpix,naxis,naxes,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: bitpix, naxis
       integer(kind=C_LONG), dimension(*), intent(in) :: naxes
       integer(kind=C_INT), intent(in out) :: status
     end function ffiimg

     integer(kind=C_INT) function ffibin(fptr,nrows,tfields,ttype,tform,tunit,&
          extname,pcount,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG_LONG), value, intent(in) :: nrows
       integer(kind=C_INT), value, intent(in) :: tfields
       type(c_ptr), dimension(*), intent(in) :: ttype, tform, tunit
       character(kind=C_CHAR), dimension(*), intent(in) :: extname
       integer(kind=C_LONG_LONG), value, intent(in) :: pcount
       integer(kind=C_INT), intent(in out) :: status
     end function ffibin


     ! Header Keyword Read/Write Routines

     integer(kind=C_INT) function ffgkey(fptr,keyname,val,com,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname
       character(kind=C_CHAR), dimension(*), intent(out) :: val,com
       integer(kind=C_INT), intent(in out) :: status
     end function ffgkey

     integer(kind=C_INT) function ffgkys(fptr,keyname,val,com,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname
       character(kind=C_CHAR), dimension(*), intent(out) :: val,com
       integer(kind=C_INT), intent(in out) :: status
     end function ffgkys

     integer(kind=C_INT) function ffgkyj(fptr,keyname,numval,com,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname
       integer(kind=C_LONG), intent(out) :: numval
       character(kind=C_CHAR), dimension(*), intent(out) :: com
       integer(kind=C_INT), intent(in out) :: status
     end function ffgkyj

     integer(kind=C_INT) function ffgkye(fptr,keyname,numval,com,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname
       real(kind=C_FLOAT), intent(out) :: numval
       character(kind=C_CHAR), dimension(*), intent(out) :: com
       integer(kind=C_INT), intent(in out) :: status
     end function ffgkye

     integer(kind=C_INT) function ffgkyd(fptr,keyname,numval,com,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname
       real(kind=C_DOUBLE), intent(out) :: numval
       character(kind=C_CHAR), dimension(*), intent(out) :: com
       integer(kind=C_INT), intent(in out) :: status
     end function ffgkyd

     integer(kind=C_INT) function ffpkys(fptr,keyname,val,com,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname,val,com
       integer(kind=C_INT), intent(in out) :: status
     end function ffpkys

     integer(kind=C_INT) function ffpkyj(fptr,keyname,numval,com,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname, com
       integer(kind=C_LONG_LONG), value, intent(in) :: numval
       integer(kind=C_INT), intent(in out) :: status
     end function ffpkyj

     integer(kind=C_INT) function ffpkye(fptr,keyname,numval,decimals,com,status) &
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname, com
       real(kind=C_FLOAT), value, intent(in) :: numval
       integer(kind=C_INT), value, intent(in) :: decimals
       integer(kind=C_INT), intent(in out) :: status
     end function ffpkye

     integer(kind=C_INT) function ffpkyd(fptr,keyname,numval,decimals,com,status) &
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname, com
       real(kind=C_DOUBLE), value, intent(in) :: numval
       integer(kind=C_INT), value, intent(in) :: decimals
       integer(kind=C_INT), intent(in out) :: status
     end function ffpkyd

     integer(kind=C_INT) function ffukys(fptr,keyname,val,com,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname,val,com
       integer(kind=C_INT), intent(in out) :: status
     end function ffukys

     integer(kind=C_INT) function ffukyj(fptr,keyname,numval,com,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname, com
       integer(kind=C_LONG_LONG), value, intent(in) :: numval
       integer(kind=C_INT), intent(in out) :: status
     end function ffukyj

     integer(kind=C_INT) function ffukye(fptr,keyname,numval,decimals,com,status) &
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname, com
       real(kind=C_FLOAT), value, intent(in) :: numval
       integer(kind=C_INT), value, intent(in) :: decimals
       integer(kind=C_INT), intent(in out) :: status
     end function ffukye

     integer(kind=C_INT) function ffukyd(fptr,keyname,numval,decimals,com,status) &
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname, com
       real(kind=C_DOUBLE), value, intent(in) :: numval
       integer(kind=C_INT), value, intent(in) :: decimals
       integer(kind=C_INT), intent(in out) :: status
     end function ffukyd

     integer(kind=C_INT) function ffgunt(fptr,keyname,unit,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname
       character(kind=C_CHAR), dimension(*), intent(out) :: unit
       integer(kind=C_INT), intent(in out) :: status
     end function ffgunt

     integer(kind=C_INT) function ffdkey(fptr,keyname,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: keyname
       integer(kind=C_INT), intent(in out) :: status
     end function ffdkey

     integer(kind=C_INT) function ffpcom(fptr,comment,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: comment
       integer(kind=C_INT), intent(in out) :: status
     end function ffpcom

     integer(kind=C_INT) function ffphis(fptr,history,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       character(kind=C_CHAR), dimension(*), intent(in) :: history
       integer(kind=C_INT), intent(in out) :: status
     end function ffphis

     integer(kind=C_INT) function ffgrec(fptr,keynum,card,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(C_INT), value, intent(in) :: keynum
       character(kind=C_CHAR), dimension(*), intent(out) :: card
       integer(kind=C_INT), intent(in out) :: status
     end function ffgrec

     integer(kind=C_INT) function ffdrec(fptr,keynum,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(C_INT), value, intent(in) :: keynum
       integer(kind=C_INT), intent(in out) :: status
     end function ffdrec


     ! Primary Array or IMAGE Extension I/O Routines

     integer(kind=C_INT) function ffgidt(fptr,bitpix,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), intent(out) :: bitpix
       integer(kind=C_INT), intent(in out) :: status
     end function ffgidt

     integer(kind=C_INT) function ffgidm(fptr,naxis,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), intent(out) :: naxis
       integer(kind=C_INT), intent(in out) :: status
     end function ffgidm

     integer(kind=C_INT) function ffgisz(fptr,maxdim,naxes,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: maxdim
       integer(kind=C_LONG), dimension(*), intent(out) :: naxes
       integer(kind=C_INT), intent(in out) :: status
     end function ffgisz

     integer(kind=C_INT) function ffgipr(fptr,maxdim,bitpix,naxis,naxes,status) &
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: maxdim
       integer(kind=C_INT), intent(out) :: bitpix, naxis
       integer(kind=C_LONG), dimension(*), intent(out) :: naxes
       integer(kind=C_INT), intent(in out) :: status
     end function ffgipr

     integer(kind=C_INT) function ffgpvb(fptr,group,fpixel,nelements,nulval,&
          array,anynul,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: fpixel, nelements
       character(kind=C_CHAR), value, intent(in) :: nulval
       character(kind=C_CHAR), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynul
       integer(kind=C_INT), intent(in out) :: status
     end function ffgpvb

     integer(kind=C_INT) function ffgpvk(fptr,group,fpixel,nelements,nulval,&
          array,anynul,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: fpixel, nelements
       integer(kind=C_INT), value, intent(in) :: nulval
       integer(kind=C_INT), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynul
       integer(kind=C_INT), intent(in out) :: status
     end function ffgpvk

     integer(kind=C_INT) function ffgpve(fptr,group,fpixel,nelements,nulval,&
          array,anynul,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: fpixel, nelements
       real(kind=C_FLOAT), value, intent(in) :: nulval
       real(kind=C_FLOAT), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynul
       integer(kind=C_INT), intent(in out) :: status
     end function ffgpve

     integer(kind=C_INT) function ffgpvd(fptr,group,fpixel,nelements,nulval,&
          array,anynul,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: fpixel, nelements
       real(kind=C_DOUBLE), value, intent(in) :: nulval
       real(kind=C_DOUBLE), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynul
       integer(kind=C_INT), intent(in out) :: status
     end function ffgpvd

     integer(kind=C_INT) function ffpprb(fptr,group,fpixel,nelements,array,status) &
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: fpixel, nelements
       character(kind=C_CHAR), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffpprb

     integer(kind=C_INT) function ffpprk(fptr,group,fpixel,nelements,array,status) &
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: fpixel, nelements
       integer(kind=C_INT), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffpprk

     integer(kind=C_INT) function ffppre(fptr,group,fpixel,nelements,array,status) &
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: fpixel, nelements
       real(kind=C_FLOAT), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffppre

     integer(kind=C_INT) function ffpprd(fptr,group,fpixel,nelements,array,status) &
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: fpixel, nelements
       real(kind=C_DOUBLE), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffpprd

     integer(kind=C_INT) function ffg2db(fptr,group,nullval,dim1, &
          naxis1,naxis2,array,anynul,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,naxis1,naxis2
       character(kind=C_CHAR), value, intent(in) :: nullval
       character(kind=C_CHAR), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynul
       integer(kind=C_INT), intent(in out) :: status
     end function ffg2db

     integer(kind=C_INT) function ffg2dk(fptr,group,nullval, &
          dim1,naxis1,naxis2,array,anynul,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,naxis1,naxis2
       integer(kind=C_INT), value, intent(in) :: nullval
       integer(kind=C_INT), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynul
       integer(kind=C_INT), intent(in out) :: status
     end function ffg2dk

     integer(kind=C_INT) function ffg2de(fptr,group,nullval, &
          dim1,naxis1,naxis2,array,anynul,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,naxis1,naxis2
       real(kind=C_FLOAT), value, intent(in) :: nullval
       real(kind=C_FLOAT), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynul
       integer(kind=C_INT), intent(in out) :: status
     end function ffg2de

     integer(kind=C_INT) function ffg2dd(fptr,group,nullval, &
          dim1,naxis1,naxis2,array,anynul,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,naxis1,naxis2
       real(kind=C_DOUBLE), value, intent(in) :: nullval
       real(kind=C_DOUBLE), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynul
       integer(kind=C_INT), intent(in out) :: status
     end function ffg2dd

     integer(kind=C_INT) function ffp2db(fptr,group,dim1,naxis1,naxis2,array,status)&
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,naxis1,naxis2
       character(kind=C_CHAR), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffp2db

     integer(kind=C_INT) function ffp2dk(fptr,group,dim1,naxis1,naxis2,array,status)&
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,naxis1,naxis2
       integer(kind=C_INT), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffp2dk

     integer(kind=C_INT) function ffp2de(fptr,group,dim1,naxis1,naxis2,array,status)&
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,naxis1,naxis2
       real(kind=C_FLOAT), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffp2de

     integer(kind=C_INT) function ffp2dd(fptr,group,dim1,naxis1,naxis2,array,status)&
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,naxis1,naxis2
       real(kind=C_DOUBLE), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffp2dd

     integer(kind=C_INT) function ffg3db(fptr,group,nullval,dim1,dim2, &
          naxis1,naxis2,naxis3,array,anynul,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,dim2,naxis1,naxis2,naxis3
       character(kind=C_CHAR), value, intent(in) :: nullval
       character(kind=C_CHAR), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynul
       integer(kind=C_INT), intent(in out) :: status
     end function ffg3db

     integer(kind=C_INT) function ffg3dk(fptr,group,nullval, &
          dim1,dim2,naxis1,naxis2,naxis3,array,anynul,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,dim2,naxis1,naxis2,naxis3
       integer(kind=C_INT), value, intent(in) :: nullval
       integer(kind=C_INT), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynul
       integer(kind=C_INT), intent(in out) :: status
     end function ffg3dk

     integer(kind=C_INT) function ffg3de(fptr,group,nullval, &
          dim1,dim2,naxis1,naxis2,naxis3,array,anynul,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,dim2,naxis1,naxis2,naxis3
       real(kind=C_FLOAT), value, intent(in) :: nullval
       real(kind=C_FLOAT), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynul
       integer(kind=C_INT), intent(in out) :: status
     end function ffg3de

     integer(kind=C_INT) function ffg3dd(fptr,group,nullval, &
          dim1,dim2,naxis1,naxis2,naxis3,array,anynul,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,dim2,naxis1,naxis2,naxis3
       real(kind=C_DOUBLE), value, intent(in) :: nullval
       real(kind=C_DOUBLE), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynul
       integer(kind=C_INT), intent(in out) :: status
     end function ffg3dd

     integer(kind=C_INT) function ffp3db(fptr,group,dim1,dim2,naxis1,naxis2,naxis3,&
          array,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,dim2,naxis1,naxis2,naxis3
       character(kind=C_CHAR), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffp3db

     integer(kind=C_INT) function ffp3dk(fptr,group,dim1,dim2,naxis1,naxis2,naxis3,&
          array,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,dim2,naxis1,naxis2,naxis3
       integer(kind=C_INT), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffp3dk

     integer(kind=C_INT) function ffp3de(fptr,group,dim1,dim2,naxis1,naxis2,naxis3,&
          array,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,dim2,naxis1,naxis2,naxis3
       real(kind=C_FLOAT), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffp3de

     integer(kind=C_INT) function ffp3dd(fptr,group,dim1,dim2,naxis1,naxis2,naxis3,&
          array,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), value, intent(in) :: group
       integer(kind=C_LONG_LONG), value, intent(in) :: dim1,dim2,naxis1,naxis2,naxis3
       real(kind=C_DOUBLE), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffp3dd

     ! ASCII and Binary Table Routines

     integer(kind=C_INT) function ffgnrw(fptr,nrows,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), intent(out) :: nrows
       integer(kind=C_INT), intent(in out) :: status
     end function ffgnrw

     integer(kind=C_INT) function ffgncl(fptr,ncols,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), intent(out) :: ncols
       integer(kind=C_INT), intent(in out) :: status
     end function ffgncl

     integer(kind=C_INT) function ffgrsz(fptr,nrows,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG), intent(out) :: nrows
       integer(kind=C_INT), intent(in out) :: status
     end function ffgrsz

     integer(kind=C_INT) function ffgcno(fptr,casesen,templt,colnum,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: casesen
       character(kind=C_CHAR), dimension(*), intent(out) :: templt
       integer(kind=C_INT), intent(out) :: colnum
       integer(kind=C_INT), intent(in out) :: status
     end function ffgcno

     integer(kind=C_INT) function ffgcnn(fptr,casesen,templt,colname,colnum,status)&
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: casesen
       character(kind=C_CHAR), dimension(*), intent(in) :: templt
       character(kind=C_CHAR), dimension(*), intent(out) :: colname
       integer(kind=C_INT), intent(out) :: colnum
       integer(kind=C_INT), intent(in out) :: status
     end function ffgcnn

     integer(kind=C_INT) function fficol(fptr,colnum,ttype,tform,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum
       character(kind=C_CHAR), dimension(*), intent(in) :: ttype, tform
       integer(kind=C_INT), intent(in out) :: status
     end function fficol

     integer(kind=C_INT) function fficls(fptr,colnum,ncols,ttype,tform,status) &
          bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum, ncols
       type(c_ptr), dimension(*), intent(in) :: ttype, tform
       integer(kind=C_INT), intent(in out) :: status
     end function fficls

     integer(kind=C_INT) function ffdcol(fptr,colnum,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum
       integer(kind=C_INT), intent(in out) :: status
     end function ffdcol

     integer(kind=C_INT) function ffgcvs(fptr,colnum,firstrow,firstelem,nelements,&
          nullstr,array,anynull,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum
       integer(kind=C_LONG_LONG), value, intent(in) :: firstrow, firstelem, nelements
       character(kind=C_CHAR), dimension(*), intent(in) :: nullstr
       type(c_ptr), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynull
       integer(kind=C_INT), intent(in out) :: status
     end function ffgcvs

     integer(kind=C_INT) function ffgcvl(fptr,colnum,firstrow,firstelem,nelements,&
          nullval,array,anynull,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum
       integer(kind=C_LONG_LONG), value, intent(in) :: firstrow, firstelem, nelements
       character(kind=C_CHAR), value, intent(in) :: nullval
       character(kind=C_CHAR), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynull
       integer(kind=C_INT), intent(in out) :: status
     end function ffgcvl

     integer(kind=C_INT) function ffgcvj(fptr,colnum,firstrow,firstelem,nelements,&
          nullval,array,anynull,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum
       integer(kind=C_LONG_LONG), value, intent(in) :: firstrow, firstelem, nelements
       integer(kind=C_LONG), value, intent(in) :: nullval
       integer(kind=C_LONG), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynull
       integer(kind=C_INT), intent(in out) :: status
     end function ffgcvj

     integer(kind=C_INT) function ffgcve(fptr,colnum,firstrow,firstelem,nelements,&
          nullval,array,anynull,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum
       integer(kind=C_LONG_LONG), value, intent(in) :: firstrow, firstelem, nelements
       real(kind=C_FLOAT), value, intent(in) :: nullval
       real(kind=C_FLOAT), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynull
       integer(kind=C_INT), intent(in out) :: status
     end function ffgcve

     integer(kind=C_INT) function ffgcvd(fptr,colnum,firstrow,firstelem,nelements,&
          nullval,array,anynull,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum
       integer(kind=C_LONG_LONG), value, intent(in) :: firstrow, firstelem, nelements
       real(kind=C_DOUBLE), value, intent(in) :: nullval
       real(kind=C_DOUBLE), dimension(*), intent(out) :: array
       integer(kind=C_INT), intent(out) :: anynull
       integer(kind=C_INT), intent(in out) :: status
     end function ffgcvd

     integer(kind=C_INT) function ffpcls(fptr,colnum,firstrow,firstelem,nelements,&
          array,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum
       integer(kind=C_LONG_LONG), value, intent(in) :: firstrow, firstelem, nelements
       type(c_ptr), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffpcls

     integer(kind=C_INT) function ffpcll(fptr,colnum,firstrow,firstelem,nelements,&
          array,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum
       integer(kind=C_LONG_LONG), value, intent(in) :: firstrow, firstelem, nelements
       character(kind=C_CHAR), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffpcll

     integer(kind=C_INT) function ffpclj(fptr,colnum,firstrow,firstelem,nelements,&
          array,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum
       integer(kind=C_LONG_LONG), value, intent(in) :: firstrow, firstelem, nelements
       integer(kind=C_LONG), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffpclj

     integer(kind=C_INT) function ffpcle(fptr,colnum,firstrow,firstelem,nelements,&
          array,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum
       integer(kind=C_LONG_LONG), value, intent(in) :: firstrow, firstelem, nelements
       real(kind=C_FLOAT), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffpcle

     integer(kind=C_INT) function ffpcld(fptr,colnum,firstrow,firstelem,nelements,&
          array,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_INT), value, intent(in) :: colnum
       integer(kind=C_LONG_LONG), value, intent(in) :: firstrow, firstelem, nelements
       real(kind=C_DOUBLE), dimension(*), intent(in) :: array
       integer(kind=C_INT), intent(in out) :: status
     end function ffpcld

     integer(kind=C_INT) function ffdrow(fptr,firstrow,nelements,status) bind(c)
       use, intrinsic :: iso_c_binding
       type(c_ptr), value, intent(in) :: fptr
       integer(kind=C_LONG_LONG), value, intent(in) :: firstrow, nelements
       integer(kind=C_INT), intent(in out) :: status
     end function ffdrow

     !  Error Status Routines

     subroutine ffgerr(status,err_text) bind(c)
       use, intrinsic :: iso_c_binding
       integer(kind=C_INT), value, intent(in) :: status
       character(kind=C_CHAR), dimension(*), intent(out) :: err_text
     end subroutine ffgerr

     integer(kind=C_INT) function ffgmsg(err_msg) bind(c)
       use, intrinsic :: iso_c_binding
       character(kind=C_CHAR), dimension(*), intent(out) :: err_msg
     end function ffgmsg

     subroutine ffpmrk() bind(c)
     end subroutine ffpmrk

     subroutine ffcmrk() bind(c)
     end subroutine ffcmrk

     subroutine ffcmsg() bind(c)
     end subroutine ffcmsg

     ! Utility Routines

     integer(kind=C_INT) function ffdtyp(val,dtype,status) bind(c)
       use, intrinsic :: iso_c_binding
       character(kind=C_CHAR), dimension(*), intent(in) :: val
       character(kind=C_CHAR), intent(out) :: dtype
       integer(kind=C_INT), intent(in out) :: status
     end function ffdtyp

     integer(kind=C_INT) function ffkeyn(keyroot,val,keyname,status) bind(c)
       use, intrinsic :: iso_c_binding
       character(kind=C_CHAR), dimension(*), intent(in) :: keyroot
       integer(kind=C_INT), value, intent(in) :: val
       character(kind=C_CHAR), dimension(*), intent(out) :: keyname
       integer(kind=C_INT), intent(in out) :: status
     end function ffkeyn

     integer(kind=C_INT) function ffs2tm(datestr,year,month,day,hour,minute,second,&
          status) bind(c)
       use, intrinsic :: iso_c_binding
       character(kind=C_CHAR), dimension(*), intent(in) :: datestr
       integer(kind=C_INT), intent(out) :: year,month,day,hour,minute
       real(kind=C_DOUBLE), intent(out) :: second
       integer(kind=C_INT), intent(in out) :: status
     end function ffs2tm

  end interface

end module cfitsio

FILE=barnard-calibrated.fits
CONE=cone_barnard.fits

cp astrometry/${FILE} ${AUTOPKGTEST_TMP}
cp astrometry/${CONE} ${AUTOPKGTEST_TMP}
cd ${AUTOPKGTEST_TMP}

munipack find -f 5 $FILE
munipack aphot $FILE
# munipack cone -r 0.1 --par 'Vmag=<15' -o cone_barnard.fits -- 269.44 4.69
munipack astrometry -c $CONE $FILE
munipack phcal --photsys-ref Johnson --area 0.3 \
	 --col-ra RAJ2000 --col-dec DEJ2000 \
	 -f V --col-mag Vmag --col-magerr e_Vmag -c $CONE \
	 -O --mask '\!\1_phcal.\2' $FILE

FILE=barnard-calibrated.fits

cp astrometry/${FILE} ${AUTOPKGTEST_TMP}
cd ${AUTOPKGTEST_TMP}

munipack find -f 5 $FILE
munipack aphot $FILE
munipack cone -r 0.1 --par 'Vmag=<15' -- 269.44 4.69
munipack astrometry $FILE
munipack phcal --photsys-ref Johnson --area 0.3 \
	 --col-ra RAJ2000 --col-dec DEJ2000 \
	 -f V --col-mag Vmag --col-magerr e_Vmag -c cone.fits \
	 -O --mask '\!\1_phcal.\2' $FILE

# exit imediatelly, when any command fails
set -e

FILE=barnard-calibrated.fits
CONE=cone_barnard.fits
# value of CTPH should be near 12 for $FILE
good=12

cp astrometry/${FILE} ${AUTOPKGTEST_TMP}
cp astrometry/${CONE} ${AUTOPKGTEST_TMP}
cd ${AUTOPKGTEST_TMP}

munipack find -f 5 $FILE
munipack aphot $FILE
# munipack cone -r 0.1 --par 'Vmag=<15' -o cone_barnard.fits -- 269.44 4.69
munipack astrometry -c $CONE $FILE
munipack phcal --photsys-ref Johnson --area 0.3 \
	 --col-ra RAJ2000 --col-dec DEJ2000 \
	 -f V --col-mag Vmag --col-magerr e_Vmag -c $CONE \
	 -O --mask phcal.fits $FILE

CTPH=$(munipack fits -K CTPH --value phcal.fits\[PHOTOMETRY\])

# log
echo $CTPH | awk -v good=$good '{ d=$1-good; if(d<0)d=-d; if(d<1) {print "OK",d;} else {print "FAIL",d;}}'

STATUS=$(echo $CTPH | awk -v good=$good '{ d=$1-good; if(d<0)d=-d; if(d<1) {print "OK";}}')

if [ "$STATUS" = "OK" ]; then
    exit 0
fi

exit 1

#!/bin/bash

NATIVE=FALSE
DEBUG=FALSE
PKGNAME=wxMathPlot

function create_source_tgz {
    VERSION=`cat ./distrib/VERSION`
    echo "Building packet $PKGNAME Versione $VERSION"
    PKGBASE=$PKGNAME-$VERSION
    PKGDIR=$PKGNAME-$VERSION
    CMAKEDIR=""
    if [[ -d /usr/share/cmake ]] ; then
        CMAKEDIR=/usr/share/cmake ;
    fi
    if [[ -d /usr/share/cmake-2.4 ]] ; then
        CMAKEDIR=/usr/share/cmake-2.4 ;
    fi
    if [[ -d /usr/share/cmake-2.6 ]] ; then
        CMAKEDIR=/usr/share/cmake-2.6 ;
    fi
    if [[ -z $CMAKEDIR ]] ; then
        echo "CMake modules path not found. Aborting."
        exit 0 ;
    fi
	
    if [[ -e ./distrib/$PKGBASE.tar.gz ]] ; then
        echo "$PKGBASE already exists: to avoid confusion, please change version"
        exit 1 ;
    else
        mkdir ./distrib/$PKGDIR ;
        mkdir ./distrib/$PKGDIR/{www,distrib,build,samples,samples/sample{1,2,3}}
        # Copy all sources
        for SRC in `find . -name '*.h' -o -name '*.cpp' -o -name 'CMakeLists.txt' -o -name '*.in' | grep -v 'distrib'` ; do
            cp $SRC ./distrib/$PKGDIR/`dirname $SRC`/
        done
        # Copy other useful files
        for SRC2 in {clear_project,README,Doxyfile,Dox_footer.html,Changelog,packages.sh,samples/sample3/gridmap.png} ; do
            cp $SRC2 ./distrib/$PKGDIR/`dirname $SRC2`/
        done
        # Finally create tar.gz of source package
        cd ./distrib
        tar czf $PKGBASE.tar.gz $PKGDIR
        rm -rf $PKGDIR
        cd ..
    fi
}

function create_rpm {
    RPMPATH=~/rpmbuild/
    VERSION=`cat ./distrib/VERSION`
    echo "Building RPM $PKGNAME Versione $VERSION"
    PKGBASE=$PKGNAME-$VERSION
    if ! [[ -e ./distrib/$PKGBASE.tar.gz ]] ; then
        create_source_tgz
    fi
# Create the right SPEC file
    cat ./distrib/Base.spec | sed s/"Version:"/"Version: $VERSION"/ > ./distrib/$PKGBASE.spec
    cp ./distrib/$PKGBASE.spec $RPMPATH/SPECS
    cp ./distrib/$PKGBASE.tar.gz $RPMPATH/SOURCES
}

function create_deb {
    VERSION=`cat ./distrib/VERSION`
    TMPCL=distrib/deb_tmp_cl
    unlink debian/control
    DEBVERSION=`cat /etc/debian_version`
    case $DEBVERSION in
    	"4.0")
    		echo "using Debian Etch!"
    		OSVER="etch1"
    		cd debian && ln -s control-debian control && cd ..
    	;;
    	"5.0")
    		echo "using Debian Lenny!"
    		OSVER="lenny1"
    		cd debian && ln -s control-ubuntu control && cd ..
    	;;
    	"lenny/sid")
    		echo "This is Ubuntu, not Debian!"
    		OSVER="ubuntu1"
    		cd debian && ln -s control-ubuntu control && cd ..
    	;;
    esac
    COMPLETE_VERSION=$VERSION-$OSVER
    echo "$PKGNAME ($COMPLETE_VERSION) unstable; urgency=low" > $TMPCL
    echo >> $TMPCL
    echo "  * " >> $TMPCL
    echo >> $TMPCL 
    echo -n " -- Davide Rondini <davide.rondini@samplesw.com>  " >> $TMPCL
    # LC_TIME="en_US.UTF-8"
    date -R >> $TMPCL
    echo >> $TMPCL
    joe $TMPCL
    cat debian/changelog >> $TMPCL
    mv $TMPCL debian/changelog
    debuild -us -uc
}


if [[ $# -eq 0 ]] ; then
    echo "usage: packages.sh [tgz][rpm][deb]"
    exit 0 ;
fi

for PARAM in $* ; do
    if [[ $PARAM = "tgz" ]] ; then
        ./clear_project
        create_source_tgz
        exit 0 ;
    fi
    if [[ $PARAM = "rpm" ]] ; then
        ./clear_project
        create_rpm
#echo "Not yet implemented"
        exit 0 ;
    fi
    if [[ $PARAM = "deb" ]] ; then
        ./clear_project
        create_deb
        exit 0 ;
    fi

done

exit 0

# A variable star
RA=150
DEC=50
JD0=2457948.5
LCID="--lc-fourier fourier.fits"
LCID="--lc-table Kepler-21b.fits"
LCID="--lc-model Cepheid"
munipack artificial --verbose --mask 'art_??.fits' --fov 0.3 --count 48 \
	 --rcen $RA --dcen $DEC \
	 --lc-ra $RA --lc-dec $DEC \
 	 $LCID --lc-mag 12 --lc-amp 1 --lc-jd0 $JD0 --lc-per 0.1 \
	 --date 2017-07-14 --time 00:00:00  --timestep 180 --exptime 90
LS="art_??.fits"
munipack find $LS
munipack aphot $LS
cp art_01.fits art_01_grow.fits
munipack gphot art_01_grow.fits

# aperture correction
R90=$(munipack fits --shell -K RADFLX90 art_01_grow.fits\[GROWPHOT\] | \
	     awk -F '=' '{print $2;}')
BEGIN='BEGIN { q = -1; }'
BODY='{if($0~/^APER/ && $2 >= r && q < 0) {q=$2;gsub("APER","",$1);print $1;}}'
SAPER=$(munipack fits -lh art_01_grow.fits\[APERPHOT\] | \
	       awk -F '[=/]' -v r=$R90 "$BEGIN $BODY")
APCORR=$(munipack fits -lt art_01_grow.fits\[GROWCURVE\] | \
	       awk -v saper=$SAPER  '{if( NR == saper ) print 1/$2;}')

munipack phcal -C 1 --saper $SAPER --photsys-ref Johnson -f V \
	 art_01_grow.fits,man_01.fits
for A in $LS; do
    munipack phcal --photsys-ref Johnson -f V -r man_01.fits \
	     --apcorr $APCORR --saper $SAPER $A;
done
echo "# JD MAG " > lc
munipack timeseries -c MAG,MAGERR --stdout ${RA},${DEC} art_*_cal.fits >> lc

echo "# JD MAG " > lcmodel
BEGIN='BEGIN { JD=0; MAG=99.999; }'
BODY='{ if($0~/^JD/) JD=$2; if($0~/current magnitude/) MAG=$2; }'
END='END {print JD MAG;}'
for A in $LS; do
    munipack fits -lh $A | awk -F '[=/]' "$BEGIN $BODY $END" >> lcmodel
done

paste lc lcmodel > lcd

gnuplot <<EOF
set key right bottom
set xlabel "Julian Day - $JD0"
set ylabel "magnitude"
set title "Model $LCID"
#set yrange[13.7:11.7]
set size ratio 0.618
set term svg dynamic
set output 'lc.svg'
plot 'lc' u (\$1-$JD0):2 t "data art" ls 3 lc rgb '#8AB8E6', \
     'lcmodel' u (\$1-$JD0):2 t "model" w l lc rgb '#000000'
EOF

gnuplot <<EOF
set key right bottom
set xlabel "Julian Day - $JD0"
set ylabel "difference magnitude"
set title "Verification $LCID"
#set yrange[13.7:11.7]
set size ratio 0.618
set term svg dynamic
set output 'lcd.svg'
plot 'lcd' u (\$1-$JD0):(\$2-\$5) t "diff." ls 3 lc rgb '#8AB8E6'
EOF

echo "Result kept in 'lc.svg' and 'lcd.svg'."

exit 0


# BL Lac
#RA=330.68
#DEC=42.27
#munipack cone -r 0.2 -- $RA $DEC
#munipack artificial --verbose --fov 0.3 -c cone.fits --rcen $RA --dcen $DEC \
#	 --mask 'art_??.fits' --lat 50 --long -15 --date 2016-08-29 \
#	 --time 00:27:03.123 --count 50 --extk 0.1 --timestep 600 --exptime 10 \
#	 --atmosphere

# sparse in UMa
HWHM=0.5
RA=140
DEC=40
COUNT=55
TIMESTEP=600
#COUNT=5
#TIMESTEP=6600
munipack cone -r 0.2 -- $RA $DEC
munipack artificial --verbose --fov 0.3 -c cone.fits --rcen $RA --dcen $DEC \
         --mask 'art_??.fits' --lat 50 --long -15 --date 2016-11-29 \
         --time 04:47:03.123 --count $COUNT --timestep $TIMESTEP --exptime 60 \
         --hwhm $HWHM --extk 0.1 --atmosphere

SCALE=$(echo 0.3*3600/666 | bc -l) # update for FOV, size changes
LS="art_??.fits"

munipack find -f 2 $LS
munipack aphot $LS

# construction of growth-curve as product of calibration in various apertures
for A in $LS; do
    B=${A%fits}dat
    CAL=${A%.fits}_catcal.fits
    rm -f $B
    for I in `seq 1 12`; do
	munipack phcal --photsys-ref Johnson -f V --col-mag f.mag \
		 --col-magerr e_Vmag -c cone.fits -O --mask '\!\1_catcal.\2' \
		 --verbose --saper $I $A;
	M=$(munipack fits -K AIRMASS --shell ${CAL} | awk -F= '{print $2;}')
	E=$(munipack fits -lh ${CAL} | \
		   awk -v a=$M '{if( /Extinction/ ) print exp($5*(a-1));}')
	C=$(munipack fits -K CTPH --shell ${CAL}\[PHOTOMETRY\] | \
		   awk -F= -v e=$E '{print 1/$2*e;}')
	R=$(munipack fits -K APER --shell ${CAL}\[PHOTOMETRY\] | \
		   awk -F= -v s=$SCALE '{print $2*3600/s;}')
	echo $R $C >> $B
    done
done

# aperture photometry
for A in $LS; do
    munipack phcal --photsys-ref Johnson -f V --col-mag f.mag --col-magerr e_Vmag \
	     -c cone.fits -O --mask '\!\1_catcal.\2' --verbose $A;
done
rm -f ext_A
for A in art_*_catcal.fits; do
    X=$(munipack fits -K AIRMASS --shell $A | awk -F= '{print $2;}')
    C=$(munipack fits -K CTPH --shell ${A}\[PHOTOMETRY\] | awk -F= '{print $2;}')
    echo $X $C >> ext_A
done

# growth-curve photometry
munipack gphot --verbose $LS
for A in $LS; do
    munipack phcal --photsys-ref Johnson -f V --col-mag f.mag --col-magerr e_Vmag \
	     -c cone.fits -O --mask '\!\1_catcal.\2' --verbose $A;
done
rm -f ext_G
for A in art_*_catcal.fits; do
    D=${A%fits}dat
    E=${A%_catcal.fits}.dat
    X=$(munipack fits -K AIRMASS --shell $A | awk -F= '{print $2;}')
    C=$(munipack fits -K CTPH --shell ${A}\[PHOTOMETRY\] | \
	       awk -F= '{print $2;}')
    echo $X $C >> ext_G
    munipack fits -lt ${A%_catcal.fits}.fits\[GROWCURVE\] > $D

    paste $D $E > F
    PNG=${A%fits}png
    gnuplot <<EOF
    set output '$PNG'
    set term png
    set multiplot title 'Grows'
    set lmargin 6
    set rmargin 2
    set origin 0,0.3
    set size 1,0.7
    set tmargin 2
    set bmargin 0
    unset xtics
    set key bottom
    set yrange[0:1.2]
    set xrange[0:21]
    #set ylabel "attenuation"
    plot '$D' u 1:2 t "curve", '$E' t "by cal"
    set origin 0,0
    set size 1,0.3
    set tmargin 0
    set bmargin 3
    unset key
    set grid
    set xlabel "aperture [pix]"
    set xtics 0,5,20 format '%0.0f' nomirror
    set ytics -0.005,0.005,0.005 format '%0.3f'
    set yrange[-0.008:0.008]
    plot 'F' u 1:(\$2-\$6)
EOF
done


gnuplot <<EOF
set output 'att.png'
set term png
set multiplot title 'Extinction'
set lmargin 6
set rmargin 2
set origin 0,0.3
set size 1,0.7
set tmargin 2
set bmargin 0
unset xtics
set key bottom
set ytics 1,0.1,1.5 format '%0.1f'
set yrange[0.9:1.5]
set xrange[0.9:4.5]
set ylabel "attenuation"
plot 'ext_A' t "aperture", 'ext_G' t "grow", exp(0.1*(x-1))
set origin 0,0
set size 1,0.3
set tmargin 0
set bmargin 3
unset key
set xtics 1,1,5 format '%0.0f' nomirror
set grid
set ytics -0.01,0.01,0.1 format '%0.2f'
set yrange[-0.011:0.011]
set xlabel "airmass"
plot 'ext_A' u 1:(exp(0.1*(\$1-1))-\$2), 'ext_G' u 1:(exp(0.1*(\$1-1))-\$2)
EOF

# prepare data
wget ftp://integral.physics.muni.cz/pub/munipack/munipack-data-m51.tar.gz
tar zxf munipack-data-m51.tar.gz
cd munipack-data-m51/

# photometric corrections
export FITS_KEY_TEMPERATURE="CCD-TEMP"
munipack dark -o dark120.fits dark_005?.fits dark_008?.fits
munipack dark -o dark10.fits dark_003?.fits dark_004?.fits
munipack phcorr -dark dark10.fits flat_Green_*.fits
munipack flat -o flat_Green.fits flat_Green_*.fits
munipack phcorr -dark dark120.fits -flat flat_Green.fits m51_Green_*.fits

# find stars, aperture photometry
munipack find -f 7 -th 7  m51_Green_*_proc.fits
munipack aphot m51_Green_*_proc.fits

# astrometry
munipack cone -r 0.2 -- 202.47 +47.2
munipack astrometry m51_Green_00*_proc.fits

# kombine
munipack kombine --rcen 202.47 --dcen +47.2 --width 1000 --height 1000 \
	 -o m51.fits m51_Green_00??_proc.fits

# update filters, photometric calibration
for A in m51_Green_00??_proc.fits; do
    munipack fits --update --key FILTER --val "'V'" $A
    munipack phcal --photsys-ref Johnson --area 0.3 -c cone.fits \
           --col-ra RAJ2000 --col-dec DEJ2000 -f V --col-mag Vmag $A
done

# kombine of calibrated frames
munipack kombine --rcen 202.47 --dcen +47.2 --width 1000 --height 1000 \
	 -o m51_cal.fits m51_Green_00??_proc_cal.fits

# run flat with debug on (recompile required):
#     logical, parameter :: debug = .true.
#

gnuplot <<EOF
bin(x,width)=width*floor(x/width)
set style line 1 lt rgb "#8AB8E6" lw 1
set style line 2 lt rgb "black" lw 1
set size 0.618,1

set term svg dynamic
set output 'flatdebug_zero.svg'
set xrange[-10:10]
unset key
set xlabel "residual"
set ylabel "number of values"
binwidth=0.1
plot 'flatdebug_zero.dat' using (bin(\$2,binwidth)):(1.0) smooth freq with boxes ls 1, 18.5e3*exp(-x**2/2) ls 2

set output 'flatdebug_3.svg'
set autoscale
binwidth=0.05
unset key
set xlabel "residual from N(0,1)"
set ylabel "number of values"
plot 'flatdebug_3.dat' using (bin(\$2,binwidth)):(1.0) smooth freq with boxes ls 1,\
     21e3*exp(-x**2/2) ls 2
EOF

if [ -f aphottester.f08 ]; then
    echo "Use another working place."
    exit 0
fi

PATH=$PATH:${0%aphot_test.sh}

if [ ! -f cone.fits ]; then
    munipack cone -r 0.1 -- 110.473 71.343
fi

HWHM=2
ECC=0.9
INCL=60

munipack artificial --psf gauss --hwhm $HWHM --disable-noise \
	 --eccentricity $ECC --inclination $INCL  --sky-mag 18 \
	 -c cone.fits --rcen 110.473 --dcen 71.343 --fov 0.1 \
	 --width 512 --height 384 --col-mag Vmag --mask art.fits

munipack find art.fits
munipack aphot --verbose --eccentricity $ECC --inclination $INCL  art.fits

aphottester $HWHM $ECC

#!/bin/sh
# generates include file for Make providing all images

#set -x

MFILE=image_list.mk

echo -n "image_list = " > $MFILE
for S in "icons/*.png" "icons/*.gif"; do
    for A in $S; do 
	echo "\\" >> $MFILE
	echo -n " $A " >> $MFILE
    done
done
echo >> $MFILE

#!/bin/sh
# generates RSS

#set -x

which python
if [ $? -ne 0 ]; then
    echo "Python not found. If you want generate RSS, please install it." > /dev/stderr
    exit 1
fi

# generate it
python munipack-atom.py > news_feed.xml

# important when previous command fails
exit 0

# compile, run
gfortran -I../lib -Wall -g -p -fcheck=all -fimplicit-none -fbacktrace lcapprox.f08 -L../lib -lminpacks -lminpack && ./a.out

# create graphs
cd /tmp/
gnuplot <<EOF
set term svg dynamic
set output 'lcapprox.svg'
set ylabel "rel. flux"
set ytics 0.3,0.1,1.0 format "%0.1f"
set yrange[0.2:1.1]
set key left bottom
set multiplot
set xtics format ""
set size 1,0.45
set origin 0,0.55
set tmargin 0.5
set bmargin 0
plot 'dcep' t "δ Cep theoretical data" lc rgb '#8AB8E6', 'dcep' u 1:3 t "the approximation" w l lc rgb '#000000' lw 2
set size 1,0.55
set origin 0,0
set tmargin 0
set bmargin 3
set xtics format "%0.1f"
set xlabel "phase"
plot 'algol' t "Algol observed data" lc rgb '#8AB8E6', 'algol' u 1:3 t "the approximation" w l lc rgb '#000000' lw 2
EOF

#!/bin/sh
# generates include file for Make providing all images

#set -x

MFILE=image_list.mk

echo -n "image_list = " > $MFILE
for S in "*.png" "*.jp*g" "*.svg"; do
    for A in $S; do
	echo "\\" >> $MFILE
	echo -n " $A " >> $MFILE
    done
done
echo >> $MFILE

#!/bin/sh -f

# converts ST-x files to FITSes
# suffixes are:  .st? -> .fits 
# needs konve external

#echo $@

echo "CONVE Version 0.1, Copyright (C) 2000 F.Hroch, Masaryk University, Brno, CZ"

for A in "$@" ; do
    if [ `head -1 $A | awk '{ print index($1,"ST-?")+index($1,"Image") }'` > "2" ]; then
       B=`echo $A | awk '{ gsub(".st[4-8]",".fits"); print; }'`
       if [ "$B" = "$A" ]; then
         B="$A.fits"
       fi
       if [ -x "$B" ]; then
          echo "File $B exist. Creating _$B"
	  B="_$B"
       fi 
      echo $A "->" $B
      konve $A "mask=$B"
    else
       if [ "$A" = "-h" -or "$A" = "--help" ]; then
           echo "Usage: conve [file]"
       fi
       echo "File $A is not ST[4-8]."
       echo "Try -h for help"
    fi
done

# Examples for both artificial tutorial and manual page

# Cover Image -- Blazar 0716+71
munipack cone -r 0.3 -- 110.5 71.35
munipack artificial --qeff 0.02 -c cone.fits --exptime 120 \
	 --hwhm 0.6 --diameter 0.6 --sky-grad-x 0.003 \
         --rcen 110.476 --dcen 71.346 --scale 5.658e-4 --width 510 --height 360 \
	 --verbose
fitspng -o 0716+71.png artificial.fits

# merged by hand with 0716_035R.fits

#  This script does visualisation of growth-curve reports.
#
#  Copyright © 2016 F.Hroch (hroch@physics.muni.cz)
#
#  This file is part of Munipack.
#
#  Munipack is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  
#  Munipack is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.



#
#  Usage:
#
#  * Run this script in a directory where reports are generated.
#    Use the calling sequence:
#       $ bash grow_report.sh
#
#  * The reports are created by passing --report option to aphot:
#    ($ munipack aphot --report [fits-files])
#
#  * Gnuplot and python with matplotlib are required.
#
#  * Default graphical format is PNG. It can be changed with FRM
#    variable (the format must be supported by gnuplot).
#
#  * The results will stored in grow_report/ subdirectory.
#
#

# uncomment for tracking
# set -x

# graphical format
FRM=png

# default subdirectory
SDIR=grow_report/

# default directory
DIR=$PWD/$SDIR

#
# ---- code for processing of a single report file -----
#

report()
{
    F=$1
    B=${F%.fits}
    O=${DIR}/${B}_curve.png
    Q=${DIR}/${B}.png
    CURVE=$(mktemp grow_curve.XXXXXXXXX)
    DATA=$(mktemp grow_data.XXXXXXXXX)
    DATA1=$(mktemp grow_data_1.XXXXXXXXX)
    DATA2=$(mktemp grow_data_2.XXXXXXXXX)

    python grow_report.py display $F $Q

    munipack fits -lt $F\[GROWCURVE\] > $CURVE
    python grow_report.py curve $F > $DATA
    grep "1$" < $DATA > $DATA1
    grep -v "1$" < $DATA > $DATA2

    gnuplot <<EOF
set term '$FRM'
set output '$O'
set style line 99 lt 2 lc rgb "gold" lw 2
unset key
set lmargin 5
set rmargin 2
set multiplot title "Growth-curve ($A)"
set origin 0,0.3
set size 1,0.7
set key right bottom
set tmargin 2
set bmargin 0
unset xtics
set xrange[0:21]
set yrange[0:1.618]
set ytics 0,0.5,1.5 format "%0.1f"
set grid
plot '$CURVE' t "growth-curve" with lines ls 99, '$DATA2' t "all stars" with points pt 6 lc rgb "#87CEFA", '$DATA1' t "designed by" with points pt 13 lc rgb "blue"
set origin 0,0
set size 1,0.3
unset key
set bmargin 3
set tmargin 0
set xtics nomirror
set xrange[0:21]
set yrange[-0.21:0.21]
set ytics -0.1,0.1,0.1 format "%0.1f"
set xlabel "distance from a star center in pixels"
set grid
plot '$DATA2' u 1:3 with points pt 6 lc rgb "#87CEFA", '$DATA1' u 1:3 with points pt 13 lc rgb "blue"
EOF
    

    rm -f "$CURVE" "$DATA" "$DATA1" "$DATA2"
}

report_svg()
{
    F=$1
    B=${F%.fits}
    O="${DIR}/${B}_curve.png"
    TITLE=$3
    CURVE=$(mktemp grow_curve.XXXXXXXXX)
    DATA=$(mktemp grow_data.XXXXXXXXX)

    if [ "$TITLE" ]; then
	TTT=" title \"Growth-Curve\""
	LABEL="set xlabel \"distance from a star center in pixels\""
	FILENAME="grow_curve_anotated.svg"
    else
	FILENAME="grow_curve.svg"
    fi
    
    munipack fits -lt $F\[GROWCURVE\] > $CURVE
    python grow_report.py report $F > $DATA
    grep "1$" < $DATA > $DATA1
    grep -v "1$" < $DATA > $DATA2

    gnuplot <<EOF
set term 'svg' size 500,400 dynamic fsize 11 rounded solid
set output '$FILENAME' 
set style line 99 lt 2 lc rgb "gold" lw 2
set lmargin 5
set rmargin 2
set multiplot $TTT
set origin 0,0.3
set size 1,0.7
set key right bottom
set tmargin 2
set bmargin 0
unset xtics
set xrange[0:21]
set yrange[0:1.618]
set ytics 0,0.5,1.5 format "%0.1f"
plot '$CURVE' t "growth-curve" with lines ls 99, '$DATA2' t "all stars" with dots ls 3 lc rgb "#B0C4DE", '$DATA1' t "designed by" with dots ls 13 lc rgb "blue"
set origin 0,0
set size 1,0.3
unset key
set bmargin 3
set tmargin 0
set xtics nomirror
set xrange[0:21]
set yrange[-0.21:0.21]
set ytics -0.1,0.1,0.1 format "%0.1f"
$LABEL
set grid
plot '$DATA2' u 1:3 with dots ls 3 lc rgb "#87CEFA", '$DATA1' u 1:3 with dots ls 3 lc rgb "blue"
EOF
    

    rm -f "$CURVE" "$DATA" "$DATA1" "$DATA2"
}


# ----  processing starts here  -----

mkdir -p $DIR

# if filenames contains spaces, firstly replace its with underscores:
#find . -maxdepth 1 -name '*.fits' -print0 | xargs -0 rename 's/ /_/g'

if [ "$1" ]; then
    
   for A in $*; do
      report $A
   done

else
    
   for A in $(ls *.fits); do
      report $A
   done
fi

# animate gif (?)

echo "Processing data of M27 to get colour frame..."

wget ftp://integral.physics.muni.cz/pub/munipack/munipack-data-m27.tar.gz
tar zxf munipack-data-m27.tar.gz
cd munipack-data-m27/
munipack dark -o d60.fits d60_*.fits
munipack phcorr -dark d60.fits m27_*B.fits
munipack dark -o d40.fits d40_*.fits
munipack phcorr -dark d40.fits m27_*[VR].fits

munipack find -f 5 m27_*.fits
munipack aphot m27_*.fits

munipack cone --Johnson-patch -r 0.1 --magmin 10 --magmax 13 -- 299.87 22.71
munipack astrometry --verbose  m27_*_proc.fits

munipack kombine -o m27_B.fits --rcen 299.9 --dcen 22.72 m27_*B_proc.fits
munipack kombine -o m27_V.fits --rcen 299.9 --dcen 22.72 m27_*V_proc.fits
munipack kombine -o m27_R.fits --rcen 299.9 --dcen 22.72 m27_*R_proc.fits

munipack find -f 5 m27_?.fits
munipack aphot m27_?.fits

for F in B V R; do
    munipack phcal --photsys-ref Johnson --area 0.2 -c cone.fits \
	     -f $F --col-mag ${F}mag --col-magerr e_${F}mag m27_${F}.fits
done

munipack colouring -o m27.fits m27_B_cal.fits m27_V_cal.fits m27_R_cal.fits

# Test determination of centroids

set -e

ECC=0
INCL=0

munipack artificial --psf seeing --verbose --hwhm 1 --exptime 10 --maglim 14 \
	 --eccentricity $ECC --inclination $INCL
munipack fits -lt artificial.fits\[CATALOGUE\] > art.txt

munipack find -f 4 artificial.fits
munipack fits -lt artificial.fits\[FIND\] > find.txt

R --vanilla <<EOF
art <- read.table("art.txt",header=FALSE)
find <- read.table("find.txt",header=FALSE)
x0 = art[,1]
y0 = art[,2]
x = find[,1]
y = find[,2]

# cross-match
cross <- matrix(0,nrow=length(x),ncol=2)
n = 0
for (i in 1:length(x)) {
  rmin = 10 # max. uncertainity
  m = 0
  for (j in 1:length(x0)) {
    r = sqrt((x[i]-x0[j])**2 + (y[i]-y0[j])**2)
    if( r < rmin ) {
      rmin = r
      m = j
    }
  }
  if( m > 0 ) {
    n = n + 1
    cross[n,1] = i
    cross[n,2] = m
  }
}
#print(cross)


dx <- vector("numeric",n)
dy <- vector("numeric",n)
for (i in 1:n) {
  if( cross[i,1] > 0 & cross[i,2] > 0 ) {
     k = cross[i,1]
     l = cross[i,2]
     dx[i] = x[k] - x0[l]
     dy[i] = y[k] - y0[l]
  }
}

png('dx.png')
hist(dx,60,main="dx: Ecc $ECC, Incl $INCL")
dev.off()
png('dy.png')
hist(dy,60,main="dy: Ecc $ECC, Incl $INCL")
#dev.off()


EOF

#!/bin/bash

# solution by mss:
# http://stackoverflow.com/questions/6489995/can-you-use-heredocuments-to-embed-awk-in-a-bash-script

cat m67ids.txt | awk -f <(sed -e '0,/^#!.*awk/d' $0)
exit $PIPESTATUS

#!/usr/bin/awk -f
BEGIN {

    OUT="m67ids.lst";

print "# BEGIN HDU 0" > OUT;
print "SIMPLE  =                    T / file does conform to FITS standard" > OUT;
print "BITPIX  =                    8 / number of bits per data pixel" > OUT;
print "NAXIS   =                    0 / number of data axes" > OUT;
print "EXTEND  =                    T / FITS dataset may contain extensions" > OUT;
print "COMMENT   FITS (Flexible Image Transport System) format is defined in 'Astronomy" > OUT;
print "COMMENT   and Astrophysics', volume 376, page 359; bibcode: 2001A&A...376..359H" > OUT;
print "END" > OUT;
print "# END HDU 0" > OUT;
print "# BEGIN HDU 1" > OUT;
print "XTENSION= 'BINTABLE'           / binary table extension" > OUT;
print "BITPIX  =                    8 / 8-bit bytes" > OUT;
print "NAXIS   =                    2 / 2-dimensional binary table" > OUT;
print "NAXIS1  =                   56 / 2*8 + 10*4 = width of table in bytes" > OUT;
print "NAXIS2  =                   64 / number of rows in table" > OUT;
print "PCOUNT  =                    0 / size of special data area" > OUT;
print "GCOUNT  =                    1 / one data group (required keyword)" > OUT;
print "TFIELDS =                   12 / number of fields in each row" > OUT;
print "TTYPE1  = 'RAJ2000 '           / label for field   2" > OUT;
print "TFORM1  = 'D       '           / data format of field: 8-byte DOUBLE" > OUT;
print "TUNIT1  = 'deg     '           / physical unit of field" > OUT;
print "TTYPE2  = 'DEJ2000 '           / label for field   3" > OUT;
print "TFORM2  = 'D       '           / data format of field: 8-byte DOUBLE" > OUT;
print "TUNIT2  = 'deg     '           / physical unit of field" > OUT;
print "TTYPE3  = 'U       '" > OUT;
print "TFORM3  = 'E       '" > OUT;
print "TUNIT3  = 'mag     '" > OUT;
print "TTYPE4  = 'B       '" > OUT;
print "TFORM4  = 'E       '" > OUT;
print "TUNIT4  = 'mag     '" > OUT;
print "TTYPE5  = 'V       '" > OUT;
print "TFORM5  = 'E       '" > OUT;
print "TUNIT5  = 'mag     '" > OUT;
print "TTYPE6  = 'R       '" > OUT;
print "TFORM6  = 'E       '" > OUT;
print "TUNIT6  = 'mag     '" > OUT;
print "TTYPE7  = 'I       '" > OUT;
print "TFORM7  = 'E       '" > OUT;
print "TUNIT7  = 'mag     '" > OUT;
print "TTYPE8  = 'Uerr    '" > OUT;
print "TFORM8  = 'E       '" > OUT;
print "TUNIT8  = 'mag     '" > OUT;
print "TTYPE9  = 'Berr    '" > OUT;
print "TFORM9  = 'E       '" > OUT;
print "TUNIT9  = 'mag     '" > OUT;
print "TTYPE10 = 'Verr    '" > OUT;
print "TFORM10 = 'E       '" > OUT;
print "TUNIT10 = 'mag     '" > OUT;
print "TTYPE11 = 'Rerr    '" > OUT;
print "TFORM11 = 'E       '" > OUT;
print "TUNIT11 = 'mag     '" > OUT;
print "TTYPE12 = 'Ierr    '" > OUT;
print "TFORM12 = 'E       '" > OUT;
print "TUNIT12 = 'mag     '" > OUT;
print "EXTNAME = 'M67 by Henden'      / name of this binary table extension" > OUT;
print "COMMENT http://binaries.boulder.swri.edu/fields/m67.html" > OUT;
print "END" > OUT;

}
#
{
    ra=$2;
    dec = $4;
    v = $7;
    b = $8 + v;
    u = $9 + b;
    r = v - $10;
    i = r - $11;
    verr = $12;
    uerr = sqrt($14*$14 + verr*verr);
    berr = sqrt($13*$13 + verr*verr);
    rerr = sqrt($15*$15 + verr*verr);
    ierr = sqrt($16*$16 + verr*verr);

    if( FNR > 1 ) {
	    print ra,dec,u,b,v,r,i,uerr,berr,verr,rerr,ierr > OUT;
	}
}
#
END {
    print "# END HDU 1" > OUT;
    system("munipack fits --restore " OUT);
}

#!/bin/sh

# This script creates light curves and other related
# products by using Munipack data for 0716+71
#
# See detailed description in lctut.html

set -x

# data
wget -nv ftp://munipack.physics.muni.cz/pub/munipack/munipack-data-0716.tar.gz
tar zxf munipack-data-0716.tar.gz
DATA=${PWD}/munipack-data-0716/
mkdir workdir-0716/
cd workdir-0716/

# preprocessing
munipack dark -o d30.fits $DATA/d30_*.fits
munipack dark -o d120.fits $DATA/d120_*.fits
munipack flat -o f_V.fits -dark d30.fits $DATA/f30_*V.fits
munipack flat -o f_R.fits -dark d30.fits $DATA/f30_*R.fits
munipack phcorr -dark d120.fits -flat f_V.fits -t . $DATA/0716_*V.fits
munipack phcorr -dark d120.fits -flat f_R.fits -t . $DATA/0716_*R.fits

# aperture photometry and star detection
munipack find -f 3 0716_*.fits
munipack aphot 0716_*.fits

# astrometry calibration
munipack cone --Johnson-patch --magmin 11 --magmax 15 -r 0.2 -- 110.5 71.3
munipack astrometry 0716_*.fits

# photometry calibration
wget -nv http://munipack.physics.muni.cz/0716+71.lst
munipack fits --restore 0716+71.lst

# SAPER=5 minimises dispersion of A comparison star
# SAPER=3 minimises dispersion of the blasar: PSF is actually need.
SAPER="--saper 5"
#THRESH="-th 0.1 -e 0.01"
for FILTER in V R; do
    munipack kombine --disable-back -o 0716.${FILTER}.fits \
	     0716_04[0-7]${FILTER}.fits
  #cp 0716_042${FILTER}.fits 0716.${FILTER}.fits
  munipack find -f 3 0716.${FILTER}.fits
  munipack aphot 0716.${FILTER}.fits
  munipack astrometry 0716.${FILTER}.fits
  munipack phcal --photsys-ref Johnson -f ${FILTER} --area 0.3 \
	   -c 0716+71.fits --col-mag ${FILTER}mag --col-magerr e_${FILTER}mag \
	   $THRESH $SAPER 0716.${FILTER}.fits
done


for FILTER in V R; do

  # catalogue
  for A in 0716_*${FILTER}.fits; do
      munipack phcal \
        --photsys-ref Johnson --area 0.3 \
        -f ${FILTER} --col-mag ${FILTER}mag --col-magerr e_${FILTER}mag  \
        -c 0716+71.fits \
        $THRESH $SAPER  \
	-O --mask '\!\1_catcal.\2' $A;
  done

  # reference frame
  for A in 0716_*${FILTER}.fits; do
      munipack phcal \
        --photsys-ref Johnson -f ${FILTER} --area 0.3 \
	$THRESH $SAPER -r 0716.${FILTER}_cal.fits \
        -O --mask '\!\1_refcal.\2' $A;
  done

  # ucac
  for A in 0716_*${FILTER}.fits; do
      munipack phcal \
        --photsys-ref Johnson --area 0.3 --col-ra RAJ2000 --col-dec DEJ2000 \
        -f ${FILTER} --col-mag ${FILTER}mag --col-magerr e_${FILTER}mag  \
	-c cone.fits $THRESH $SAPER \
        -O --mask '\!\1_ucacal.\2' $A;
  done

  # manual
  for A in 0716_*${FILTER}.fits; do
    munipack phcal -C 1 --photsys-ref Johnson -f ${FILTER} \
        $SAPER -O --mask '\!\1_mancal.\2' $A;
  done

done

# light curves
for FILTER in V R; do
   for TYPE in man cat ref uca; do
      munipack timeseries -c "110.473,71.343 110.389,71.322 110.468,71.305" \
               -l MAG,MAGERR --stdout  0716_*${FILTER}_${TYPE}cal.fits | \
	  sort -n > ${TYPE}cal_${FILTER}
   done
done


# plots, V filter
gnuplot <<EOF
set key bottom left
set title "0716+71"
set ylabel "magnitude in V"
set xlabel "JD - 2453409"
set yrange[14.8:13.5]
set term svg dynamic
set output 'lc0716_V.svg'
plot 'mancal_V' u (\$1-2453409):(\$2-\$4+11.8) t "diff(0716+71 - A) + 11.8", \
     'catcal_V' u (\$1-2453409):(\$2-0.2) t "std.field - 0.2" ls 1 lc 2, \
     'refcal_V' u (\$1-2453409):2 t "frame" ls 1 lc 3, \
     'ucacal_V' u (\$1-2453409):(\$2+0.2) t "UCAC4 + 0.2" ls 1 lc 4
EOF


gnuplot <<EOF
set key top left
set title "Calibration star A"
set ylabel "magnitude in V"
set xlabel "JD - 2453409"
set yrange[12:11]
set ytics 0.1
set term svg dynamic
set output 'comp0716_V.svg'
plot 'mancal_V' u (\$1-2453409):(\$4-\$6+12.65) t "diff(A-B)+12.65", \
     'catcal_V' u (\$1-2453409):(\$4-0.1) t "std.field - 0.1" ls 1 lc 2, \
     'refcal_V' u (\$1-2453409):4 t "frame" ls 1 lc 3, \
     'ucacal_V' u (\$1-2453409):(\$4+0.2) t "UCAC4 + 0.2" ls 1 lc 4
EOF

# plots, R filter
gnuplot <<EOF
set key bottom left
set title "0716+71"
set ylabel "magnitude in R"
set xlabel "JD - 2453409"
set yrange[14.5:13.0]
set term svg dynamic
set output 'lc0716_R.svg'
plot 'mancal_R' u (\$1-2453409):(\$2-\$4+11.7) t "diff(0716+71 - A) + 11.7", \
     'catcal_R' u (\$1-2453409):(\$2-0.2) t "std.field - 0.2" ls 1 lc 2, \
     'refcal_R' u (\$1-2453409):2 t "frame" ls 1 lc 3, \
     'ucacal_R' u (\$1-2453409):(\$2+0.1) t "UCAC4 + 0.1" ls 1 lc 4
EOF


gnuplot <<EOF
set key top left
set title "Calibration star A"
set ylabel "magnitude in R"
set xlabel "JD - 2453409"
set yrange[11.7:10.7]
set ytics 0.1
set term svg dynamic
set output 'comp0716_R.svg'
plot 'mancal_R' u (\$1-2453409):(\$4-\$6+12.5) t "diff(A-B+12.5)", \
     'catcal_R' u (\$1-2453409):(\$4-0.1) t "std.field - 0.1" ls 1 lc 2, \
     'refcal_R' u (\$1-2453409):4 t "frame" ls 1 lc 3, \
     'ucacal_R' u (\$1-2453409):(\$4+0.1) t "UCAC4 + 0.1" ls 1 lc 4
EOF

LS="art_??.fits"
LS="0716_*V.fits"


# construction of growth-curve as the product of calibration in various apertures
for A in $LS; do
    B=${A%fits}dat
    CAL=${A%.fits}_catcal.fits
    rm -f $B
    for I in `seq 1 12`; do
	munipack phcal --photsys-ref Johnson -f V --col-mag f.mag --col-magerr e_Vmag \
		 -c cone.fits -O --mask '\!\1_catcal.\2' --verbose --saper $I $A;
#	M=$(munipack fits -K AIRMASS --shell ${CAL} | awk -F= '{print $2;}')
#	E=$(munipack fits -lh ${CAL} | \
#		   awk -v a=$M '{if( /Extinction/ ) print exp($5*(a-1));}')
	C=$(munipack fits -K CTPH --shell ${CAL}\[PHOTOMETRY\] | \
		   awk -F= -v e=$E '{print 1/$2;}')
#	R=$(munipack fits -K APER --shell ${CAL}\[PHOTOMETRY\] | \
#		   awk -F= -v s=$SCALE '{print $2*3600/s;}')
	R=$(munipack fits -lh ${A}\[APERPHOT\] | \
		   awk -v i=$I '{if($1 ~ "^APER" i "$") print $3;}')
	echo $R $C >> $B
    done
    X=$(awk '{} END {print $2;}' < $B)
    awk -v X=$X '{print $1,$2/X;}' < $B > /tmp/x
    mv /tmp/x $B
done


# growth-curve photometry
munipack gphot --verbose $LS
for A in $LS; do
    munipack phcal --photsys-ref Johnson -f V --col-mag f.mag --col-magerr e_Vmag \
	     -c cone.fits -O --mask '\!\1_catcal.\2' --verbose $A;
done

rm -f ext_G
for L in $LS; do
    A=${L%.fits}_catcal.fits
    D=${A%fits}dat
    E=${A%_catcal.fits}.dat
    X=$(munipack fits -K AIRMASS --shell $A | awk -F= '{print $2;}')
    C=$(munipack fits -K CTPH --shell ${A}\[PHOTOMETRY\] | awk -F= '{print $2;}')
    echo $X $C >> ext_G
    munipack fits -lt ${A%_catcal.fits}.fits\[GROWCURVE\] > $D

    paste $D $E > F
    PNG=${A%fits}png
    gnuplot <<EOF
    set output '$PNG'
    set term png
    set multiplot title 'Grows'
    set lmargin 6
    set rmargin 2
    set origin 0,0.3
    set size 1,0.7
    set tmargin 2
    set bmargin 0
    unset xtics
    set key bottom
    set yrange[0:1.2]
    set xrange[0:21]
    #set ylabel "attenuation"
    plot '$D' u 1:2 t "curve", '$E' t "by cal"
    set origin 0,0
    set size 1,0.3
    set tmargin 0
    set bmargin 3
    unset key
    set grid
    set xlabel "aperture [pix]"
    set xtics 0,5,20 format '%0.0f' nomirror
    set ytics -0.05,0.05,0.05 format '%0.2f'
#    set yrange[-0.008:0.008]
    set yrange[-0.06:0.06]
    plot 'F' u 1:(\$2-\$6)
EOF
done

wget https://integral.physics.muni.cz/ftp/munipack/munipack-data-m67.tar.gz
tar zxf munipack-data-m67.tar.gz
cd munipack-data-m67/

# darks
munipack dark -o d7.fits d7_*.fits &
munipack dark -o d30.fits d30_*.fits &
wait

# flats
munipack flat -o fB.fits -dark d7.fits flat_*B.fits &
munipack flat -o fV.fits -dark d7.fits flat_*V.fits &
munipack flat -o fR.fits -dark d7.fits flat_*R.fits &
wait

# precorr
munipack phcorr -dark d30.fits -flat fB.fits m67_*B.fits &
munipack phcorr -dark d30.fits -flat fV.fits m67_*V.fits &
munipack phcorr -dark d30.fits -flat fR.fits m67_*R.fits &
wait

# find, aperture photometry
munipack find -th 10 -f 6 m67_*_proc.fits
munipack aphot m67_*_proc.fits

# astrometry
munipack cone -r 0.2 --magmax 14 --  132.8 11.8
munipack astrometry -c cone.fits m67_*_proc.fits

# collect
munipack kombine --rcen 132.8304 --dcen 11.7771 -o m67_B.fits m67_*B_proc.fits
munipack kombine --rcen 132.8304 --dcen 11.7771 -o m67_V.fits m67_*V_proc.fits
munipack kombine --rcen 132.8304 --dcen 11.7771 -o m67_R.fits m67_*R_proc.fits

# find, aperture photometry
munipack find -th 10 -f 6 m67_?.fits
munipack aphot m67_?.fits

# photometry calibration by UCAC4
munipack cone -r 0.2 --magmax 14 --Johnson-patch -o phcal_cone.fits -- 132.8 11.8
munipack phcal --photsys-ref Johnson -f B --area 0.3 --col-mag Bmag \
	 --col-magerr e_Bmag -c phcal_cone.fits m67_B.fits
munipack phcal --photsys-ref Johnson -f V --area 0.3 --col-mag Vmag \
	 --col-magerr e_Vmag -c phcal_cone.fits m67_V.fits
munipack phcal --photsys-ref Johnson -f R --area 0.3 --col-mag Rmag \
	 --col-magerr e_Rmag -c phcal_cone.fits m67_R.fits

# prepare data
wget ftp://munipack.physics.muni.cz/pub/munipack/munipack-data-bubble.tar.gz
tar zxf munipack-data-bubble.tar.gz
cd munipack-data-bubble/

# precorrections
munipack dark d120_*.fits
munipack phcorr -gain 2.3 -dark dark.fits ngc7635_*.fits

# find stars, aperture photometry
munipack find ngc7635_*_proc.fits
munipack aphot ngc7635_*_proc.fits

# astrometry
munipack cone -r 0.1 350.20 61.20
munipack astrometry ngc7635_*_proc.fits

# kombine
munipack kombine -o bubble.fits ngc7635_*_proc.fits

#!/bin/sh
#
# Creation of debian binary linux package
#
# Usage:
#
# $ dbuilder.sh distdir
#
#  *  the output will be placed in curent dir as munipack-*.deb
#
# 
# Description of detailed usage:
#
#     http://integral.physics.muni.cz/debbuilder.html
#
# 
# Please, check these utilities before:
#  * g++ and gfortran compilers
#  * autoconf, automake
#  * gtk2-dev
#  * imagemagick
#  * debhelper
#
# Content of distdir:
#  munipack-*.tar.gz
#  cfitsio*.tar.gz     	 rawtran-*.tar.gz
#  wxWidgets-*.tar.bz2   fitspng-*.tar.gz
#  libpng-*.tar.gz
#
# optionaly:
#
#  konve-*.tar.gz
#  picko-*.tar.gz
#
#
# http://tldp.org/HOWTO/html_single/Debian-Binary-Package-Building-HOWTO/

set -x
set -e


# functions

tarname ()
{
  find $1 -name "$2" -type f | sort | tail -1
}

tdirname ()
{
  XC=$(echo $1 | awk '{if(/\.tar\.gz$/){print "z"} else if(/\.tar\.bz2$/){print "j"};}')
  tar tf${XC} $1 | awk '{FS="/"; if(FNR==2) print $1;}'
}

makeinstall ()
{
  cd $1
  make install
  cd $TOPDIR
}

makeexternal()
{
    TARBALL=$1

    if [ "$TARBALL" ]; then
	DIR=$(tar ztf ${TARBALL} | awk '{FS="/"; if(FNR==2) print $1;}')
    fi

    if [ "$TARBALL" -a "$DIR" ]; then
	rm -rf $DIR
	tar zxf $TARBALL
	cd $DIR
	./configure --prefix=$PREFIX
	make install
	cd $TOPDIR
        BINARIES="$BINARIES ${DIR%-*}"
    fi
}

# end of functions


DISTDIR=$1

if [ -z "$DISTDIR" ]; then
    echo "$0 distdir"
    exit 0
fi 

TOPDIR=$PWD
BUNDLEDIR=/opt/munipack
PREFIX=$TOPDIR/install
DEBDIR=$TOPDIR/debian
DEBOPT=$DEBDIR/$BUNDLEDIR

BINARIES="xmunipack munipack"

MUNIPACK_TAR=$(tarname $DISTDIR munipack-*.tar.gz)
FITSPNG_TAR=$(tarname $DISTDIR fitspng-*.tar.gz)
RAWTRAN_TAR=$(tarname $DISTDIR rawtran-*.tar.gz)
KONVE_TAR=$(tarname $DISTDIR konve-*.tar.gz)
PICKO_TAR=$(tarname $DISTDIR picko-*.tar.gz)
CFITSIO_TAR=$(tarname $DISTDIR cfitsio*.tar.gz)
WXWIDGETS_TAR=$(tarname $DISTDIR wxWidgets*.tar.bz2)
LIBPNG_TAR=$(tarname $DISTDIR libpng*.tar.gz)

MUNIPACK_DIR=$(tar ztf ${MUNIPACK_TAR} | awk '{FS="/"; if(FNR==2) print $1;}')

if [ "$FITSPNG_TAR" ]; then
  FITSPNG_DIR=$(tar ztf ${FITSPNG_TAR} | awk '{FS="/"; if(FNR==2) print $1;}')
fi
if [ "$RAWTRAN_TAR" ]; then
  RAWTRAN_DIR=$(tar ztf ${RAWTRAN_TAR} | awk '{FS="/"; if(FNR==2) print $1;}')
fi
if [ "$KONVE_TAR" ]; then
  KONVE_DIR=$(tar ztf ${KONVE_TAR} | awk '{FS="/"; if(FNR==2) print $1;}')
fi
if [ "$PICKO_TAR" ]; then
  PICKO_DIR=$(tar ztf ${PICKO_TAR} | awk '{FS="/"; if(FNR==2) print $1;}')
fi
CFITSIO_DIR=$(tdirname $CFITSIO_TAR)
WXWIDGETS_DIR=$(tdirname $WXWIDGETS_TAR)
LIBPNG_DIR=$(tdirname $LIBPNG_TAR)

# environment setup
KERNEL=$(uname -s)
#CPPFLAGS="-DNDEBUG -I$PREFIX/include"
CPPFLAGS="-I$PREFIX/include"
CFLAGS=-O2
CXXFLAGS=-O2
FCFLAGS=-O2
STATIC_LDFLAGS="-static-libgfortran -static-libgcc -static-libstdc++"
LDFLAGS="-L$PREFIX/lib -Wl,-rpath,$BUNDLEDIR/lib "
PKG_CONFIG_PATH=$PREFIX/lib/pkgconfig
LD_LIBRARY_PATH=$PREFIX/lib
export CPPFLAGS CFLAGS CXXFLAGS FCFLAGS LDFLAGS PKG_CONFIG_PATH LD_LIBRARY_PATH

# be sure to prevent crash while paralle make
unset MAKEFLAGS

# remove older builds
rm -rf $TOPDIR/setup/
rm -rf $TOPDIR/install/
rm -rf $MUNIPACK_DIR
rm -rf $FITSPNG_DIR
rm -rf $RAWTRAN_DIR
rm -rf $FITSPNG_DIR
rm -rf $KONVE_DIR
rm -rf $PICKO_DIR

mkdir -p $DEBDIR
mkdir -p $DEBOPT

# cFITSIO, http://heasarc.gsfc.nasa.gov/fitsio/
if [ ! -d "$CFITSIO_DIR" ]; then
  tar zxf $CFITSIO_TAR
  cd $CFITSIO_DIR
  ./configure --prefix=$PREFIX --enable-reentrant
  make shared
  cd $TOPDIR
fi
makeinstall $CFITSIO_DIR

# wxWidgets, http://www.wxwidgets.org/downloads/
if [ ! -d "$WXWIDGETS_DIR" ]; then
  tar jxf $WXWIDGETS_TAR
  cd $WXWIDGETS_DIR
  ./configure --with-zlib=builtin \
    --with-libpng=builtin --with-libjpeg=builtin --with-libtiff=builtin \
    --with-regex=builtin --with-expat=builtin  \
    --enable-graphics_ctx  --enable-stl --enable-baseevtloop \
    --disable-compat28 \
    --without-odbc --without-opengl --without-libmspack --without-hildon \
    --without-gnomeprint --disable-xrc --disable-aui --disable-richtext  \
    --disable-ribbon --disable-stc --disable-propgrid --disable-gl \
    --prefix=$PREFIX
  make
  cd $TOPDIR
fi
makeinstall $WXWIDGETS_DIR

# pre-set PATH to use wx-config created by us (prevent to use system wide ones)
PATH=$PREFIX/bin:$PATH

# libpng, http://www.libpng.org/pub/png/libpng.html
if [ ! -d "$LIBPNG_DIR" ]; then
   tar zxf $LIBPNG_TAR
   cd $LIBPNG_DIR
   ./configure --prefix=$PREFIX
   make
   cd $TOPDIR
fi
makeinstall $LIBPNG_DIR

# Munipack
LDFLAGS="$STATIC_LDFLAGS $LDFLAGS "
export LDFLAGS
tar zxf $MUNIPACK_TAR
cd $MUNIPACK_DIR
./bootstrap $PREFIX/share/aclocal
#autoreconf -i -f -I $PREFIX/share/aclocal
./configure --prefix=$PREFIX --enable-bundle
make install
cd $TOPDIR

MVERSION=$(cat $MUNIPACK_DIR/configure.ac | awk '{if(/AC_INIT/) {gsub("[\\[\\]\\,]"," ");  print $3;}}')

# fitspng
makeexternal $FITSPNG_TAR

# rawtran 
makeexternal $RAWTRAN_TAR

# konve
makeexternal $KONVE_TAR

# picko
makeexternal $PICKO_TAR

# doc
DOC=$PREFIX/share/doc/munipack/html
cd $MUNIPACK_DIR/doc && make mini && make install && \
    tar cf - . | (mkdir -p $DOC && cd $DOC && tar xf - )

cd $PREFIX
tar cf - . \
    --exclude '*include*' \
    --exclude '*locale*' --exclude '*aclocal*' --exclude '*bakefile*' \
    --exclude '*pkgconfig*' --exclude 'lib/libcfitsio.a' \
    --exclude 'lib/libpng*.a' --exclude 'lib/libpng*.la' \
    --exclude 'bin/*-config' --exclude 'share/man/man3/libpng*' \
    --exclude 'share/man/man5/png*' --exclude 'lib/wx*' \
    --exclude 'lib/fortran' \
| (cd $DEBOPT && tar xf - )

# add necessary libraries, Has one an appropriate licence/permissions?
# this step is just for safety, when the --enable-static-lib* are ignored.
#for A in libgfortran libgcc libstdc++ libquadmath; do
#    P=$(/sbin/ldconfig -p | awk -v a=$A  '{ FS="=> "; if(/a/) print $2; }')
#    cp $P $DEBOPT/lib/
#done

#cp /usr/lib/libstdc++.so* $DEBOPT/lib/
#cp /lib/libgcc_s.so* $DEBOPT/lib/

#cp $TOPDIR/$MUNIPACK_DIR/dist/muni-pack.desktop $DEBOPT/share/munipack/

rmdir $DEBOPT/share/man/man3/ $DEBOPT/share/man/man5/

cd $DEBDIR
mkdir -p $DEBDIR/DEBIAN
cp $TOPDIR/$MUNIPACK_DIR/dist/debian/postinst $DEBDIR/DEBIAN/
cp $TOPDIR/$MUNIPACK_DIR/dist/debian/prerm $DEBDIR/DEBIAN/
awk -v v=$MVERSION -v a=$(dpkg-architecture -qDEB_BUILD_ARCH) '{ if( /^Version:/ ) { print $1,v; print "Architecture: ",a; } else print; }' < $TOPDIR/$MUNIPACK_DIR/dist/debian/control.template > $DEBDIR/DEBIAN/control

DDOC=/usr/share/doc/munipack
mkdir -p $DEBDIR/$DDOC
cp $TOPDIR/$MUNIPACK_DIR/debian/copyright $DEBDIR/$DDOC
cp $TOPDIR/$MUNIPACK_DIR/ChangeLog $DEBDIR/$DDOC

mkdir -p $DEBDIR/usr/bin
cd $DEBDIR/usr/bin
for B in $BINARIES; do
    fakeroot -- ln -sf $BUNDLEDIR/bin/$B
done

mkdir -p $DEBDIR/usr/share/man/man1
cd $DEBDIR/usr/share/man/man1
for B in $BINARIES; do
    fakeroot -- ln -sf $BUNDLEDIR/share/man/man1/${B}.1
done

cd $TOPDIR
fakeroot dpkg-deb --build debian $TOPDIR
